/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","electron","vs/base/common/errors","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/extpath","vs/base/common/map","vs/base/common/uuid","vs/platform/state/node/state","vs/base/common/objects","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","vs/base/common/errorMessage","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/decorators","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/files/common/watcher","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/normalization","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","string_decoder","vs/code/electron-main/main"],ae=function(K){for(var e=[],n=0,j=K.length;n<j;n++)e[n]=oe[K[n]];return e};define(oe[136],ae([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=n,e.$gb=j,e.$hb=P,e.$ib=M,e.$jb=S,e.$kb=E,e.$lb=h,e.$nb=p,e.$ob=y,e.$pb=k,e.$qb=g,e.$rb=m;function n(v,w,$){const f=j(v,w);if(f!==-1)return v[f]}function j(v,w,$=v.length-1){for(let f=$;f>=0;f--){const l=v[f];if(w(l))return f}return-1}function P(v,w){const $=M(v,w);return $===-1?void 0:v[$]}function M(v,w,$=0,f=v.length){let l=$,d=f;for(;l<d;){const a=Math.floor((l+d)/2);w(v[a])?l=a+1:d=a}return l-1}function S(v,w){const $=E(v,w);return $===v.length?void 0:v[$]}function E(v,w,$=0,f=v.length){let l=$,d=f;for(;l<d;){const a=Math.floor((l+d)/2);w(v[a])?d=a:l=a+1}return l}function h(v,w,$=0,f=v.length){const l=E(v,w,$,f);return l===v.length?-1:l}class c{static{this.assertInvariants=!1}constructor(w){this.e=w,this.c=0}findLastMonotonous(w){if(c.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!w(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=w}const $=M(this.e,w,this.c);return this.c=$+1,$===-1?void 0:this.e[$]}}e.$mb=c;function p(v,w){if(v.length===0)return;let $=v[0];for(let f=1;f<v.length;f++){const l=v[f];w(l,$)>0&&($=l)}return $}function y(v,w){if(v.length===0)return;let $=v[0];for(let f=1;f<v.length;f++){const l=v[f];w(l,$)>=0&&($=l)}return $}function k(v,w){return p(v,($,f)=>-w($,f))}function g(v,w){if(v.length===0)return-1;let $=0;for(let f=1;f<v.length;f++){const l=v[f];w(l,v[$])>0&&($=f)}return $}function m(v,w){for(const $ of v){const f=w($);if(f!==void 0)return f}}}),define(oe[137],ae([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=n,e.$L=j,e.$M=P,e.$N=M;function n(S,E){const h=Object.create(null);for(const c of S){const p=E(c);let y=h[p];y||(y=h[p]=[]),y.push(c)}return h}function j(S,E){const h=[],c=[];for(const p of S)E.has(p)||h.push(p);for(const p of E)S.has(p)||c.push(p);return{removed:h,added:c}}function P(S,E){const h=[],c=[];for(const[p,y]of S)E.has(p)||h.push(y);for(const[p,y]of E)S.has(p)||c.push(y);return{removed:h,added:c}}function M(S,E){const h=new Set;for(const c of E)S.has(c)&&h.add(c);return h}}),define(oe[138],ae([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gt=e.$Ft=e.$Et=e.$Dt=void 0;function n(E,h){const c=Math.pow(10,h);return Math.round(E*c)/c}class j{constructor(h,c,p,y=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,c))|0,this.b=Math.min(255,Math.max(0,p))|0,this.a=n(Math.max(Math.min(1,y),0),3)}static equals(h,c){return h.r===c.r&&h.g===c.g&&h.b===c.b&&h.a===c.a}}e.$Dt=j;class P{constructor(h,c,p,y){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=n(Math.max(Math.min(1,c),0),3),this.l=n(Math.max(Math.min(1,p),0),3),this.a=n(Math.max(Math.min(1,y),0),3)}static equals(h,c){return h.h===c.h&&h.s===c.s&&h.l===c.l&&h.a===c.a}static fromRGBA(h){const c=h.r/255,p=h.g/255,y=h.b/255,k=h.a,g=Math.max(c,p,y),m=Math.min(c,p,y);let v=0,w=0;const $=(m+g)/2,f=g-m;if(f>0){switch(w=Math.min($<=.5?f/(2*$):f/(2-2*$),1),g){case c:v=(p-y)/f+(p<y?6:0);break;case p:v=(y-c)/f+2;break;case y:v=(c-p)/f+4;break}v*=60,v=Math.round(v)}return new P(v,w,$,k)}static i(h,c,p){return p<0&&(p+=1),p>1&&(p-=1),p<1/6?h+(c-h)*6*p:p<1/2?c:p<2/3?h+(c-h)*(2/3-p)*6:h}static toRGBA(h){const c=h.h/360,{s:p,l:y,a:k}=h;let g,m,v;if(p===0)g=m=v=y;else{const w=y<.5?y*(1+p):y+p-y*p,$=2*y-w;g=P.i($,w,c+1/3),m=P.i($,w,c),v=P.i($,w,c-1/3)}return new j(Math.round(g*255),Math.round(m*255),Math.round(v*255),k)}}e.$Et=P;class M{constructor(h,c,p,y){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=n(Math.max(Math.min(1,c),0),3),this.v=n(Math.max(Math.min(1,p),0),3),this.a=n(Math.max(Math.min(1,y),0),3)}static equals(h,c){return h.h===c.h&&h.s===c.s&&h.v===c.v&&h.a===c.a}static fromRGBA(h){const c=h.r/255,p=h.g/255,y=h.b/255,k=Math.max(c,p,y),g=Math.min(c,p,y),m=k-g,v=k===0?0:m/k;let w;return m===0?w=0:k===c?w=((p-y)/m%6+6)%6:k===p?w=(y-c)/m+2:w=(c-p)/m+4,new M(Math.round(w*60),v,k,h.a)}static toRGBA(h){const{h:c,s:p,v:y,a:k}=h,g=y*p,m=g*(1-Math.abs(c/60%2-1)),v=y-g;let[w,$,f]=[0,0,0];return c<60?(w=g,$=m):c<120?(w=m,$=g):c<180?($=g,f=m):c<240?($=m,f=g):c<300?(w=m,f=g):c<=360&&(w=g,f=m),w=Math.round((w+v)*255),$=Math.round(($+v)*255),f=Math.round((f+v)*255),new j(w,$,f,k)}}e.$Ft=M;class S{static fromHex(h){return S.Format.CSS.parseHex(h)||S.red}static equals(h,c){return!h&&!c?!0:!h||!c?!1:h.equals(c)}get hsla(){return this.i?this.i:P.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:M.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof j)this.rgba=h;else if(h instanceof P)this.i=h,this.rgba=P.toRGBA(h);else if(h instanceof M)this.j=h,this.rgba=M.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&j.equals(this.rgba,h.rgba)&&P.equals(this.hsla,h.hsla)&&M.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=S.k(this.rgba.r),c=S.k(this.rgba.g),p=S.k(this.rgba.b),y=.2126*h+.7152*c+.0722*p;return n(y,4)}static k(h){const c=h/255;return c<=.03928?c/12.92:Math.pow((c+.055)/1.055,2.4)}getContrastRatio(h){const c=this.getRelativeLuminance(),p=h.getRelativeLuminance();return c>p?(c+.05)/(p+.05):(p+.05)/(c+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const c=this.getRelativeLuminance(),p=h.getRelativeLuminance();return c>p}isDarkerThan(h){const c=this.getRelativeLuminance(),p=h.getRelativeLuminance();return c<p}lighten(h){return new S(new P(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new S(new P(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:c,g:p,b:y,a:k}=this.rgba;return new S(new j(c,p,y,k*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new S(new j(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const c=h.rgba,p=this.rgba.a,y=c.a,k=p+y*(1-p);if(k<1e-6)return S.transparent;const g=this.rgba.r*p/k+c.r*y*(1-p)/k,m=this.rgba.g*p/k+c.g*y*(1-p)/k,v=this.rgba.b*p/k+c.b*y*(1-p)/k;return new S(new j(g,m,v,k))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:c,g:p,b:y,a:k}=this.rgba;return new S(new j(h.rgba.r-k*(h.rgba.r-c),h.rgba.g-k*(h.rgba.g-p),h.rgba.b-k*(h.rgba.b-y),1))}flatten(...h){const c=h.reduceRight((p,y)=>S.o(y,p));return S.o(this,c)}static o(h,c){const p=1-h.rgba.a;return new S(new j(p*c.rgba.r+h.rgba.a*h.rgba.r,p*c.rgba.g+h.rgba.a*h.rgba.g,p*c.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this.u||(this.u=S.Format.CSS.format(this)),this.u}static getLighterColor(h,c,p){if(h.isLighterThan(c))return h;p=p||.5;const y=h.getRelativeLuminance(),k=c.getRelativeLuminance();return p=p*(k-y)/k,h.lighten(p)}static getDarkerColor(h,c,p){if(h.isDarkerThan(c))return h;p=p||.5;const y=h.getRelativeLuminance(),k=c.getRelativeLuminance();return p=p*(y-k)/y,h.darken(p)}static{this.white=new S(new j(255,255,255,1))}static{this.black=new S(new j(0,0,0,1))}static{this.red=new S(new j(255,0,0,1))}static{this.blue=new S(new j(0,0,255,1))}static{this.green=new S(new j(0,255,0,1))}static{this.cyan=new S(new j(0,255,255,1))}static{this.lightgrey=new S(new j(211,211,211,1))}static{this.transparent=new S(new j(0,0,0,0))}}e.$Gt=S,function(E){let h;(function(c){let p;(function(y){function k(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:E.Format.CSS.formatRGBA(t)}y.formatRGB=k;function g(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}y.formatRGBA=g;function m(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:E.Format.CSS.formatHSLA(t)}y.formatHSL=m;function v(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}y.formatHSLA=v;function w(t){const o=t.toString(16);return o.length!==2?"0"+o:o}function $(t){return`#${w(t.rgba.r)}${w(t.rgba.g)}${w(t.rgba.b)}`}y.formatHex=$;function f(t,o=!1){return o&&t.rgba.a===1?E.Format.CSS.formatHex(t):`#${w(t.rgba.r)}${w(t.rgba.g)}${w(t.rgba.b)}${w(Math.round(t.rgba.a*255))}`}y.formatHexA=f;function l(t){return t.isOpaque()?E.Format.CSS.formatHex(t):E.Format.CSS.formatRGBA(t)}y.format=l;function d(t){const o=t.length;if(o===0||t.charCodeAt(0)!==35)return null;if(o===7){const r=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),s=16*a(t.charCodeAt(5))+a(t.charCodeAt(6));return new E(new j(r,i,s,1))}if(o===9){const r=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),s=16*a(t.charCodeAt(5))+a(t.charCodeAt(6)),u=16*a(t.charCodeAt(7))+a(t.charCodeAt(8));return new E(new j(r,i,s,u/255))}if(o===4){const r=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),s=a(t.charCodeAt(3));return new E(new j(16*r+r,16*i+i,16*s+s))}if(o===5){const r=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),s=a(t.charCodeAt(3)),u=a(t.charCodeAt(4));return new E(new j(16*r+r,16*i+i,16*s+s,(16*u+u)/255))}return null}y.parseHex=d;function a(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(p=c.CSS||(c.CSS={}))})(h=E.Format||(E.Format={}))}(S||(e.$Gt=S={}))}),define(oe[51],ae([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=j,e.$Nh=P,e.$Oh=M;function n(S){return(E,h,c)=>{let p=null,y=null;if(typeof c.value=="function"?(p="value",y=c.value):typeof c.get=="function"&&(p="get",y=c.get),!y)throw new Error("not supported");c[p]=S(y,h)}}function j(S,E,h){let c=null,p=null;if(typeof h.value=="function"?(c="value",p=h.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(c="get",p=h.get),!p)throw new Error("not supported");const y=`$memoize$${E}`;h[c]=function(...k){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:p.apply(this,k)}),this[y]}}function P(S,E,h){return n((c,p)=>{const y=`$debounce$${p}`,k=`$debounce$result$${p}`;return function(...g){this[k]||(this[k]=h?h():void 0),clearTimeout(this[y]),E&&(this[k]=E(this[k],...g),g=[this[k]]),this[y]=setTimeout(()=>{c.apply(this,g),this[k]=h?h():void 0},S)}})}function M(S,E,h){return n((c,p)=>{const y=`$throttle$timer$${p}`,k=`$throttle$result$${p}`,g=`$throttle$lastRun$${p}`,m=`$throttle$pending$${p}`;return function(...v){if(this[k]||(this[k]=h?h():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),E&&(this[k]=E(this[k],...v)),this[m])return;const w=this[g]+S;w<=Date.now()?(this[g]=Date.now(),c.apply(this,[this[k]]),this[k]=h?h():void 0):(this[m]=!0,this[y]=setTimeout(()=>{this[m]=!1,this[g]=Date.now(),c.apply(this,[this[k]]),this[k]=h?h():void 0},w-Date.now()))}})}}),define(oe[15],ae([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=j,e.$Z=P,e.$1=M,e.$2=S,e.$3=E,e.$4=c,e.$6=y,e.$7=k,e.$8=g,e.$0=v;class n{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?l.isErrorNoTelemetry(t)?new l(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(o=>{o(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=n,e.$X=new n;function j(a){e.$X.setUnexpectedErrorHandler(a)}function P(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function M(a){c(a)||e.$X.onUnexpectedError(a)}function S(a){c(a)||e.$X.onUnexpectedExternalError(a)}function E(a){if(a instanceof Error){const{name:t,message:o}=a,r=a.stacktrace||a.stack;return{$isError:!0,name:t,message:o,stack:r,noTelemetry:l.isErrorNoTelemetry(a)}}return a}const h="Canceled";function c(a){return a instanceof p?!0:a instanceof Error&&a.name===h&&a.message===h}class p extends Error{constructor(){super(h),this.name=this.message}}e.$5=p;function y(){const a=new Error(h);return a.name=a.message,a}function k(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}function g(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}class m extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=m;function v(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}class w extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=w;class $ extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=$;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=f;class l extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof l)return t;const o=new l;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=l;class d extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,d.prototype)}}e.$cb=d}),define(oe[22],ae([0,1,15,136]),function(K,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=P,e.$tb=M,e.$ub=S,e.$vb=E,e.$wb=h,e.$xb=c,e.$yb=p,e.$zb=y,e.$Ab=k,e.$Bb=g,e.$Cb=m,e.$Db=v,e.$Eb=w,e.top=$,e.$Gb=f,e.$Hb=d,e.$Ib=a,e.$Jb=t,e.$Kb=o,e.$Lb=r,e.$Mb=i,e.$Nb=s,e.$Ob=u,e.$Pb=b,e.$Qb=C,e.$Rb=I,e.$Sb=D,e.$Tb=O,e.$Ub=R,e.$Vb=W,e.$Wb=F,e.$Xb=q,e.$Yb=x,e.$Zb=le,e.$1b=te,e.$2b=ue,e.$3b=Y,e.$4b=Z,e.$5b=B,e.$6b=L,e.$7b=z,e.$8b=ce,e.$$b=A;function P(J,V=0){return J[J.length-(1+V)]}function M(J){if(J.length===0)throw new Error("Invalid tail call");return[J.slice(0,J.length-1),J[J.length-1]]}function S(J,V,H=(U,re)=>U===re){if(J===V)return!0;if(!J||!V||J.length!==V.length)return!1;for(let U=0,re=J.length;U<re;U++)if(!H(J[U],V[U]))return!1;return!0}function E(J,V){const H=J.length-1;V<H&&(J[V]=J[H]),J.pop()}function h(J,V,H){return c(J.length,U=>H(J[U],V))}function c(J,V){let H=0,U=J-1;for(;H<=U;){const re=(H+U)/2|0,ee=V(re);if(ee<0)H=re+1;else if(ee>0)U=re-1;else return re}return-(H+1)}function p(J,V,H){if(J=J|0,J>=V.length)throw new TypeError("invalid index");const U=V[Math.floor(V.length*Math.random())],re=[],ee=[],fe=[];for(const me of V){const ve=H(me,U);ve<0?re.push(me):ve>0?ee.push(me):fe.push(me)}return J<re.length?p(J,re,H):J<re.length+fe.length?fe[0]:p(J-(re.length+fe.length),ee,H)}function y(J,V){const H=[];let U;for(const re of J.slice(0).sort(V))!U||V(U[0],re)!==0?(U=[re],H.push(U)):U.push(re);return H}function*k(J,V){let H,U;for(const re of J)U!==void 0&&V(U,re)?H.push(re):(H&&(yield H),H=[re]),U=re;H&&(yield H)}function g(J,V){for(let H=0;H<=J.length;H++)V(H===0?void 0:J[H-1],H===J.length?void 0:J[H])}function m(J,V){for(let H=0;H<J.length;H++)V(H===0?void 0:J[H-1],J[H],H+1===J.length?void 0:J[H+1])}function v(J,V,H){const U=[];function re(me,ve,ke){if(ve===0&&ke.length===0)return;const je=U[U.length-1];je&&je.start+je.deleteCount===me?(je.deleteCount+=ve,je.toInsert.push(...ke)):U.push({start:me,deleteCount:ve,toInsert:ke})}let ee=0,fe=0;for(;;){if(ee===J.length){re(ee,0,V.slice(fe));break}if(fe===V.length){re(ee,J.length-ee,[]);break}const me=J[ee],ve=V[fe],ke=H(me,ve);ke===0?(ee+=1,fe+=1):ke<0?(re(ee,1,[]),ee+=1):ke>0&&(re(ee,0,[ve]),fe+=1)}return U}function w(J,V,H){const U=v(J,V,H),re=[],ee=[];for(const fe of U)re.push(...J.slice(fe.start,fe.start+fe.deleteCount)),ee.push(...fe.toInsert);return{removed:re,added:ee}}function $(J,V,H){if(H===0)return[];const U=J.slice(0,H).sort(V);return l(J,V,U,H,J.length),U}function f(J,V,H,U,re){return H===0?Promise.resolve([]):new Promise((ee,fe)=>{(async()=>{const me=J.length,ve=J.slice(0,H).sort(V);for(let ke=H,je=Math.min(H+U,me);ke<me;ke=je,je=Math.min(je+U,me)){if(ke>H&&await new Promise(Fe=>setTimeout(Fe)),re&&re.isCancellationRequested)throw new n.$5;l(J,V,ve,ke,je)}return ve})().then(ee,fe)})}function l(J,V,H,U,re){for(const ee=H.length;U<re;U++){const fe=J[U];if(V(fe,H[ee-1])<0){H.pop();const me=(0,j.$kb)(H,ve=>V(fe,ve)<0);H.splice(me,0,fe)}}}function d(J){return J.filter(V=>!!V)}function a(J){let V=0;for(let H=0;H<J.length;H++)J[H]&&(J[V]=J[H],V+=1);J.length=V}function t(J,V,H){J.splice(H,0,J.splice(V,1)[0])}function o(J){return!Array.isArray(J)||J.length===0}function r(J){return Array.isArray(J)&&J.length>0}function i(J,V=H=>H){const H=new Set;return J.filter(U=>{const re=V(U);return H.has(re)?!1:(H.add(re),!0)})}function s(J){const V=new Set;return H=>{const U=J(H);return V.has(U)?!1:(V.add(U),!0)}}function u(J,V){return J.length>0?J[0]:V}function b(J,V){return J.length>0?J[J.length-1]:V}function C(J,V,H=(U,re)=>U===re){let U=0;for(let re=0,ee=Math.min(J.length,V.length);re<ee&&H(J[re],V[re]);re++)U++;return U}function I(J){return[].concat(...J)}function D(J,V){let H=typeof V=="number"?J:0;typeof V=="number"?H=J:(H=0,V=J);const U=[];if(H<=V)for(let re=H;re<V;re++)U.push(re);else for(let re=H;re>V;re--)U.push(re);return U}function O(J,V,H){return J.reduce((U,re)=>(U[V(re)]=H?H(re):re,U),Object.create(null))}function R(J,V){return J.push(V),()=>W(J,V)}function W(J,V){const H=J.indexOf(V);if(H>-1)return J.splice(H,1),V}function F(J,V,H){const U=J.slice(0,V),re=J.slice(V);return U.concat(H,re)}function q(J,V){let H;if(typeof V=="number"){let U=V;H=()=>{const re=Math.sin(U++)*179426549;return re-Math.floor(re)}}else H=Math.random;for(let U=J.length-1;U>0;U-=1){const re=Math.floor(H()*(U+1)),ee=J[U];J[U]=J[re],J[re]=ee}}function x(J,V){const H=J.indexOf(V);H>-1&&(J.splice(H,1),J.unshift(V))}function le(J,V){const H=J.indexOf(V);H>-1&&(J.splice(H,1),J.push(V))}function te(J,V){for(const H of V)J.push(H)}function ue(J,V){return Array.isArray(J)?J.map(V):V(J)}function Y(J){return Array.isArray(J)?J:[J]}function Z(J){return J[Math.floor(Math.random()*J.length)]}function B(J,V,H){const U=T(J,V),re=J.length,ee=H.length;J.length=re+ee;for(let fe=re-1;fe>=U;fe--)J[fe+ee]=J[fe];for(let fe=0;fe<ee;fe++)J[fe+U]=H[fe]}function L(J,V,H,U){const re=T(J,V);let ee=J.splice(re,H);return ee===void 0&&(ee=[]),B(J,re,U),ee}function T(J,V){return V<0?Math.max(V+J.length,0):Math.min(V,J.length)}var G;(function(J){function V(ee){return ee<0}J.isLessThan=V;function H(ee){return ee<=0}J.isLessThanOrEqual=H;function U(ee){return ee>0}J.isGreaterThan=U;function re(ee){return ee===0}J.isNeitherLessOrGreaterThan=re,J.greaterThan=1,J.lessThan=-1,J.neitherLessOrGreaterThan=0})(G||(e.CompareResult=G={}));function z(J,V){return(H,U)=>V(J(H),J(U))}function ce(...J){return(V,H)=>{for(const U of J){const re=U(V,H);if(!G.isNeitherLessOrGreaterThan(re))return re}return G.neitherLessOrGreaterThan}}const he=(J,V)=>J-V;e.$9b=he;const X=(J,V)=>(0,e.$9b)(J?1:0,V?1:0);e.$0b=X;function A(J){return(V,H)=>-J(V,H)}class N{constructor(V){this.g=V,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(V){let H=this.c;for(;H<this.g.length&&V(this.g[H]);)H++;const U=H===this.c?null:this.g.slice(this.c,H);return this.c=H,U}takeFromEndWhile(V){let H=this.d;for(;H>=0&&V(this.g[H]);)H--;const U=H===this.d?null:this.g.slice(H+1,this.d+1);return this.d=H,U}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const V=this.g[this.c];return this.c++,V}removeLast(){const V=this.g[this.d];return this.d--,V}takeCount(V){const H=this.g.slice(this.c,this.c+V);return this.c+=V,H}}e.$_b=N;class _{static{this.empty=new _(V=>{})}constructor(V){this.iterate=V}forEach(V){this.iterate(H=>(V(H),!0))}toArray(){const V=[];return this.iterate(H=>(V.push(H),!0)),V}filter(V){return new _(H=>this.iterate(U=>V(U)?H(U):!0))}map(V){return new _(H=>this.iterate(U=>H(V(U))))}some(V){let H=!1;return this.iterate(U=>(H=V(U),!H)),H}findFirst(V){let H;return this.iterate(U=>V(U)?(H=U,!1):!0),H}findLast(V){let H;return this.iterate(U=>(V(U)&&(H=U),!0)),H}findLastMaxBy(V){let H,U=!0;return this.iterate(re=>((U||G.isGreaterThan(V(re,H)))&&(U=!1,H=re),!0)),H}}e.$ac=_;class se{constructor(V){this.c=V}static createSortPermutation(V,H){const U=Array.from(V.keys()).sort((re,ee)=>H(V[re],V[ee]));return new se(U)}apply(V){return V.map((H,U)=>V[this.c[U]])}inverse(){const V=this.c.slice();for(let H=0;H<this.c.length;H++)V[this.c[H]]=H;return new se(V)}}e.$bc=se}),define(oe[139],ae([0,1,15]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=j,e.$0c=P,e.$$c=M,e.$_c=S,e.$ad=E,e.$bd=h;function j(c,p){if(!c)throw new Error(p?`Assertion failed (${p})`:"Assertion Failed")}function P(c,p="Unreachable"){throw new Error(p)}function M(c){if(!c)throw new n.$cb("Assertion Failed")}function S(c){c||(0,n.$1)(new n.$cb("Soft Assertion Failed"))}function E(c){if(!c()){debugger;c(),(0,n.$1)(new n.$cb("Assertion Failed"))}}function h(c,p){let y=0;for(;y<c.length-1;){const k=c[y],g=c[y+1];if(!p(k,g))return!1;y++}return!0}}),define(oe[85],ae([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=n;function n(j,P){const M=this;let S=!1,E;return function(){if(S)return E;if(S=!0,P)try{E=j.apply(M,arguments)}finally{P()}else E=j.apply(M,arguments);return E}}}),define(oe[71],ae([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var n;(function(j){function P(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}j.is=P;const M=Object.freeze([]);function S(){return M}j.empty=S;function*E(t){yield t}j.single=E;function h(t){return P(t)?t:E(t)}j.wrap=h;function c(t){return t||M}j.from=c;function*p(t){for(let o=t.length-1;o>=0;o--)yield t[o]}j.reverse=p;function y(t){return!t||t[Symbol.iterator]().next().done===!0}j.isEmpty=y;function k(t){return t[Symbol.iterator]().next().value}j.first=k;function g(t,o){for(const r of t)if(o(r))return!0;return!1}j.some=g;function m(t,o){for(const r of t)if(o(r))return r}j.find=m;function*v(t,o){for(const r of t)o(r)&&(yield r)}j.filter=v;function*w(t,o){let r=0;for(const i of t)yield o(i,r++)}j.map=w;function*$(...t){for(const o of t)yield*o}j.concat=$;function f(t,o,r){let i=r;for(const s of t)i=o(i,s);return i}j.reduce=f;function*l(t,o,r=t.length){for(o<0&&(o+=t.length),r<0?r+=t.length:r>t.length&&(r=t.length);o<r;o++)yield t[o]}j.slice=l;function d(t,o=Number.POSITIVE_INFINITY){const r=[];if(o===0)return[r,t];const i=t[Symbol.iterator]();for(let s=0;s<o;s++){const u=i.next();if(u.done)return[r,j.empty()];r.push(u.value)}return[r,{[Symbol.iterator](){return i}}]}j.consume=d;async function a(t){const o=[];for await(const r of t)o.push(r);return Promise.resolve(o)}j.asyncToArray=a})(n||(e.Iterable=n={}))}),define(oe[42],ae([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$tn=S,e.$un=y,e.$vn=k,e.$wn=g,e.$xn=m,e.$yn=v,e.$zn=w,e.$An=$,e.$Bn=f,e.$Cn=l,e.$Dn=d,e.$En=a;var n;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(n||(e.ScanError=n={}));var j;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(j||(e.SyntaxKind=j={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function S(t,o=!1){let r=0;const i=t.length;let s="",u=0,b=16,C=0;function I(x){let le=0,te=0;for(;le<x;){const ue=t.charCodeAt(r);if(ue>=48&&ue<=57)te=te*16+ue-48;else if(ue>=65&&ue<=70)te=te*16+ue-65+10;else if(ue>=97&&ue<=102)te=te*16+ue-97+10;else break;r++,le++}return le<x&&(te=-1),te}function D(x){r=x,s="",u=0,b=16,C=0}function O(){const x=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&c(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&c(t.charCodeAt(r)))for(r++;r<t.length&&c(t.charCodeAt(r));)r++;else return C=3,t.substring(x,r);let le=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&c(t.charCodeAt(r))){for(r++;r<t.length&&c(t.charCodeAt(r));)r++;le=r}else C=3;return t.substring(x,le)}function R(){let x="",le=r;for(;;){if(r>=i){x+=t.substring(le,r),C=2;break}const te=t.charCodeAt(r);if(te===34){x+=t.substring(le,r),r++;break}if(te===92){if(x+=t.substring(le,r),r++,r>=i){C=2;break}switch(t.charCodeAt(r++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:{const Y=I(4);Y>=0?x+=String.fromCharCode(Y):C=4;break}default:C=5}le=r;continue}if(te>=0&&te<=31)if(h(te)){x+=t.substring(le,r),C=2;break}else C=6;r++}return x}function W(){if(s="",C=0,u=r,r>=i)return u=i,b=17;let x=t.charCodeAt(r);if(E(x)){do r++,s+=String.fromCharCode(x),x=t.charCodeAt(r);while(E(x));return b=15}if(h(x))return r++,s+=String.fromCharCode(x),x===13&&t.charCodeAt(r)===10&&(r++,s+=`
`),b=14;switch(x){case 123:return r++,b=1;case 125:return r++,b=2;case 91:return r++,b=3;case 93:return r++,b=4;case 58:return r++,b=6;case 44:return r++,b=5;case 34:return r++,s=R(),b=10;case 47:{const le=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!h(t.charCodeAt(r));)r++;return s=t.substring(le,r),b=12}if(t.charCodeAt(r+1)===42){r+=2;const te=i-1;let ue=!1;for(;r<te;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,ue=!0;break}r++}return ue||(r++,C=1),s=t.substring(le,r),b=13}return s+=String.fromCharCode(x),r++,b=16}case 45:if(s+=String.fromCharCode(x),r++,r===i||!c(t.charCodeAt(r)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=O(),b=11;default:for(;r<i&&F(x);)r++,x=t.charCodeAt(r);if(u!==r){switch(s=t.substring(u,r),s){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return s+=String.fromCharCode(x),r++,b=16}}function F(x){if(E(x)||h(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function q(){let x;do x=W();while(x>=12&&x<=15);return x}return{setPosition:D,getPosition:()=>r,scan:o?q:W,getToken:()=>b,getTokenValue:()=>s,getTokenOffset:()=>u,getTokenLength:()=>r-u,getTokenError:()=>C}}function E(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function h(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var p;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(p||(p={}));function y(t,o){const r=[],i=new Object;let s;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function C(I,D,O,R){u.value=I,u.offset=D,u.length=O,u.type=R,u.colonOffset=void 0,s=u}try{l(t,{onObjectBegin:(I,D)=>{if(o<=I)throw i;s=void 0,b=o>I,r.push("")},onObjectProperty:(I,D,O)=>{if(o<D||(C(I,D,O,"property"),r[r.length-1]=I,o<=D+O))throw i},onObjectEnd:(I,D)=>{if(o<=I)throw i;s=void 0,r.pop()},onArrayBegin:(I,D)=>{if(o<=I)throw i;s=void 0,r.push(0)},onArrayEnd:(I,D)=>{if(o<=I)throw i;s=void 0,r.pop()},onLiteralValue:(I,D,O)=>{if(o<D||(C(I,D,O,a(I)),o<=D+O))throw i},onSeparator:(I,D,O)=>{if(o<=D)throw i;if(I===":"&&s&&s.type==="property")s.colonOffset=D,b=!1,s=void 0;else if(I===","){const R=r[r.length-1];typeof R=="number"?r[r.length-1]=R+1:(b=!0,r[r.length-1]=""),s=void 0}}})}catch(I){if(I!==i)throw I}return{path:r,previousNode:s,isAtPropertyKey:b,matches:I=>{let D=0;for(let O=0;D<I.length&&O<r.length;O++)if(I[D]===r[O]||I[D]==="*")D++;else if(I[D]!=="**")return!1;return D===I.length}}}function k(t,o=[],r=M.DEFAULT){let i=null,s=[];const u=[];function b(I){Array.isArray(s)?s.push(I):i!==null&&(s[i]=I)}return l(t,{onObjectBegin:()=>{const I={};b(I),u.push(s),s=I,i=null},onObjectProperty:I=>{i=I},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{const I=[];b(I),u.push(s),s=I,i=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:b,onError:(I,D,O)=>{o.push({error:I,offset:D,length:O})}},r),s[0]}function g(t,o=[],r=M.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(I){i.type==="property"&&(i.length=I-i.offset,i=i.parent)}function u(I){return i.children.push(I),I}l(t,{onObjectBegin:I=>{i=u({type:"object",offset:I,length:-1,parent:i,children:[]})},onObjectProperty:(I,D,O)=>{i=u({type:"property",offset:D,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:I,offset:D,length:O,parent:i})},onObjectEnd:(I,D)=>{i.length=I+D-i.offset,i=i.parent,s(I+D)},onArrayBegin:(I,D)=>{i=u({type:"array",offset:I,length:-1,parent:i,children:[]})},onArrayEnd:(I,D)=>{i.length=I+D-i.offset,i=i.parent,s(I+D)},onLiteralValue:(I,D,O)=>{u({type:a(I),offset:D,length:O,parent:i,value:I}),s(D+O)},onSeparator:(I,D,O)=>{i.type==="property"&&(I===":"?i.colonOffset=D:I===","&&s(D))},onError:(I,D,O)=>{o.push({error:I,offset:D,length:O})}},r);const C=i.children[0];return C&&delete C.parent,C}function m(t,o){if(!t)return;let r=t;for(const i of o)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let s=!1;for(const u of r.children)if(Array.isArray(u.children)&&u.children[0].value===i){r=u.children[1],s=!0;break}if(!s)return}else{const s=i;if(r.type!=="array"||s<0||!Array.isArray(r.children)||s>=r.children.length)return;r=r.children[s]}return r}function v(t){if(!t.parent||!t.parent.children)return[];const o=v(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;o.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&o.push(r)}return o}function w(t){switch(t.type){case"array":return t.children.map(w);case"object":{const o=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(o[r.children[0].value]=w(i))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function $(t,o,r=!1){return o>=t.offset&&o<t.offset+t.length||r&&o===t.offset+t.length}function f(t,o,r=!1){if($(t,o,r)){const i=t.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=o;s++){const u=f(i[s],o,r);if(u)return u}return t}}function l(t,o,r=M.DEFAULT){const i=S(t,!1);function s(z){return z?()=>z(i.getTokenOffset(),i.getTokenLength()):()=>!0}function u(z){return z?ce=>z(ce,i.getTokenOffset(),i.getTokenLength()):()=>!0}const b=s(o.onObjectBegin),C=u(o.onObjectProperty),I=s(o.onObjectEnd),D=s(o.onArrayBegin),O=s(o.onArrayEnd),R=u(o.onLiteralValue),W=u(o.onSeparator),F=s(o.onComment),q=u(o.onError),x=r&&r.disallowComments,le=r&&r.allowTrailingComma;function te(){for(;;){const z=i.scan();switch(i.getTokenError()){case 4:ue(14);break;case 5:ue(15);break;case 3:ue(13);break;case 1:x||ue(11);break;case 2:ue(12);break;case 6:ue(16);break}switch(z){case 12:case 13:x?ue(10):F();break;case 16:ue(1);break;case 15:case 14:break;default:return z}}}function ue(z,ce=[],he=[]){if(q(z),ce.length+he.length>0){let X=i.getToken();for(;X!==17;){if(ce.indexOf(X)!==-1){te();break}else if(he.indexOf(X)!==-1)break;X=te()}}}function Y(z){const ce=i.getTokenValue();return z?R(ce):C(ce),te(),!0}function Z(){switch(i.getToken()){case 11:{let z=0;try{z=JSON.parse(i.getTokenValue()),typeof z!="number"&&(ue(2),z=0)}catch{ue(2)}R(z);break}case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return te(),!0}function B(){return i.getToken()!==10?(ue(3,[],[2,5]),!1):(Y(!1),i.getToken()===6?(W(":"),te(),G()||ue(4,[],[2,5])):ue(5,[],[2,5]),!0)}function L(){b(),te();let z=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(z||ue(4,[],[]),W(","),te(),i.getToken()===2&&le)break}else z&&ue(6,[],[]);B()||ue(4,[],[2,5]),z=!0}return I(),i.getToken()!==2?ue(7,[2],[]):te(),!0}function T(){D(),te();let z=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(z||ue(4,[],[]),W(","),te(),i.getToken()===4&&le)break}else z&&ue(6,[],[]);G()||ue(4,[],[4,5]),z=!0}return O(),i.getToken()!==4?ue(8,[4],[]):te(),!0}function G(){switch(i.getToken()){case 3:return T();case 1:return L();case 10:return Y(!0);default:return Z()}}return te(),i.getToken()===17?r.allowEmptyContent?!0:(ue(4,[],[]),!1):G()?(i.getToken()!==17&&ue(9,[],[]),!0):(ue(4,[],[]),!1)}function d(t,o){const r=S(t),i=[];let s,u=0,b;do switch(b=r.getPosition(),s=r.scan(),s){case 12:case 13:case 17:u!==b&&i.push(t.substring(u,b)),o!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,o)),u=r.getPosition();break}while(s!==17);return i.join("")}function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(oe[140],ae([0,1,42]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=j,e.$Gn=P,e.$Hn=E,e.$In=h;function j(c,p,y){let k,g,m,v,w;if(p){for(v=p.offset,w=v+p.length,m=v;m>0&&!h(c,m-1);)m--;let b=w;for(;b<c.length&&!h(c,b);)b++;g=c.substring(m,b),k=S(g,y)}else g=c,k=0,m=0,v=0,w=c.length;const $=E(y,c);let f=!1,l=0,d;y.insertSpaces?d=M(" ",y.tabSize||4):d="	";const a=(0,n.$tn)(g,!1);let t=!1;function o(){return $+M(d,k+l)}function r(){let b=a.scan();for(f=!1;b===15||b===14;)f=f||b===14,b=a.scan();return t=b===16||a.getTokenError()!==0,b}const i=[];function s(b,C,I){!t&&C<w&&I>v&&c.substring(C,I)!==b&&i.push({offset:C,length:I-C,content:b})}let u=r();if(u!==17){const b=a.getTokenOffset()+m,C=M(d,k);s(C,m,b)}for(;u!==17;){let b=a.getTokenOffset()+a.getTokenLength()+m,C=r(),I="";for(;!f&&(C===12||C===13);){const O=a.getTokenOffset()+m;s(" ",b,O),b=a.getTokenOffset()+a.getTokenLength()+m,I=C===12?o():"",C=r()}if(C===2)u!==1&&(l--,I=o());else if(C===4)u!==3&&(l--,I=o());else{switch(u){case 3:case 1:l++,I=o();break;case 5:case 12:I=o();break;case 13:f?I=o():I=" ";break;case 6:I=" ";break;case 10:if(C===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:C===12||C===13?I=" ":C!==5&&C!==17&&(t=!0);break;case 16:t=!0;break}f&&(C===12||C===13)&&(I=o())}const D=a.getTokenOffset()+m;s(I,b,D),u=C}return i}function P(c,p){const y=JSON.stringify(c,void 0,p.insertSpaces?p.tabSize||4:"	");return p.eol!==void 0?y.replace(/\r\n|\r|\n/g,p.eol):y}function M(c,p){let y="";for(let k=0;k<p;k++)y+=c;return y}function S(c,p){let y=0,k=0;const g=p.tabSize||4;for(;y<c.length;){const m=c.charAt(y);if(m===" ")k++;else if(m==="	")k+=g;else break;y++}return Math.floor(k/g)}function E(c,p){for(let y=0;y<p.length;y++){const k=p.charAt(y);if(k==="\r")return y+1<p.length&&p.charAt(y+1)===`
`?`\r
`:"\r";if(k===`
`)return`
`}return c&&c.eol||`
`}function h(c,p){return`\r
`.indexOf(c.charAt(p))!==-1}}),define(oe[103],ae([0,1,42,140]),function(K,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=P,e.$Kn=M,e.$Ln=S,e.$Mn=E,e.$Nn=h;function P(c,p,y){return M(c,p,void 0,y)}function M(c,p,y,k,g){const m=p.slice(),v=[],w=(0,n.$wn)(c,v);let $,f;for(;m.length>0&&(f=m.pop(),$=(0,n.$xn)(w,m),$===void 0&&y!==void 0);)typeof f=="string"?y={[f]:y}:y=[y];if($)if($.type==="object"&&typeof f=="string"&&Array.isArray($.children)){const l=(0,n.$xn)($,[f]);if(l!==void 0)if(y===void 0){if(!l.parent)throw new Error("Malformed AST");const d=$.children.indexOf(l.parent);let a,t=l.parent.offset+l.parent.length;if(d>0){const o=$.children[d-1];a=o.offset+o.length}else a=$.offset+1,$.children.length>1&&(t=$.children[1].offset);return S(c,{offset:a,length:t-a,content:""},k)}else return S(c,{offset:l.offset,length:l.length,content:JSON.stringify(y)},k);else{if(y===void 0)return[];const d=`${JSON.stringify(f)}: ${JSON.stringify(y)}`,a=g?g($.children.map(o=>o.children[0].value)):$.children.length;let t;if(a>0){const o=$.children[a-1];t={offset:o.offset+o.length,length:0,content:","+d}}else $.children.length===0?t={offset:$.offset+1,length:0,content:d}:t={offset:$.offset+1,length:0,content:d+","};return S(c,t,k)}}else if($.type==="array"&&typeof f=="number"&&Array.isArray($.children))if(y!==void 0){const l=`${JSON.stringify(y)}`;let d;if($.children.length===0||f===0)d={offset:$.offset+1,length:0,content:$.children.length===0?l:l+","};else{const a=f===-1||f>$.children.length?$.children.length:f,t=$.children[a-1];d={offset:t.offset+t.length,length:0,content:","+l}}return S(c,d,k)}else{const l=f,d=$.children[l];let a;if($.children.length===1)a={offset:$.offset+1,length:$.length-2,content:""};else if($.children.length-1===l){const t=$.children[l-1],o=t.offset+t.length,r=$.offset+$.length;a={offset:o,length:r-2-o,content:""}}else a={offset:d.offset,length:$.children[l+1].offset-d.offset,content:""};return S(c,a,k)}else throw new Error(`Can not add ${typeof f!="number"?"index":"property"} to parent of type ${$.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return S(c,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(y)},k)}}function S(c,p,y){let k=E(c,p),g=p.offset,m=p.offset+p.content.length;if(p.length===0||p.content.length===0){for(;g>0&&!(0,j.$In)(k,g-1);)g--;for(;m<k.length&&!(0,j.$In)(k,m);)m++}const v=(0,j.$Fn)(k,{offset:g,length:m-g},y);for(let $=v.length-1;$>=0;$--){const f=v[$];k=E(k,f),g=Math.min(g,f.offset),m=Math.max(m,f.offset+f.length),m+=f.content.length-f.length}const w=c.length-(k.length-m)-g;return[{offset:g,length:w,content:k.substring(g,m)}]}function E(c,p){return c.substring(0,p.offset)+p.content+c.substring(p.offset+p.length)}function h(c,p){const y=p.slice(0).sort((g,m)=>{const v=g.offset-m.offset;return v===0?g.length-m.length:v});let k=c.length;for(let g=y.length-1;g>=0;g--){const m=y[g];if(m.offset+m.length<=k)c=E(c,m);else throw new Error("Overlapping edit");k=m.offset}return c}}),define(oe[62],ae([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class n{constructor(P){this.d=P,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(P){this.c=P}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=n}),define(oe[104],ae([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class n{static{this.Undefined=new n(void 0)}constructor(M){this.element=M,this.next=n.Undefined,this.prev=n.Undefined}}class j{constructor(){this.a=n.Undefined,this.b=n.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===n.Undefined}clear(){let M=this.a;for(;M!==n.Undefined;){const S=M.next;M.prev=n.Undefined,M.next=n.Undefined,M=S}this.a=n.Undefined,this.b=n.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,S){const E=new n(M);if(this.a===n.Undefined)this.a=E,this.b=E;else if(S){const c=this.b;this.b=E,E.prev=c,c.next=E}else{const c=this.a;this.a=E,E.next=c,c.prev=E}this.c+=1;let h=!1;return()=>{h||(h=!0,this.e(E))}}shift(){if(this.a!==n.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==n.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==n.Undefined&&M.next!==n.Undefined){const S=M.prev;S.next=M.next,M.next.prev=S}else M.prev===n.Undefined&&M.next===n.Undefined?(this.a=n.Undefined,this.b=n.Undefined):M.next===n.Undefined?(this.b=this.b.prev,this.b.next=n.Undefined):M.prev===n.Undefined&&(this.a=this.a.next,this.a.prev=n.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==n.Undefined;)yield M.element,M=M.next}}e.$5c=j}),define(oe[32],ae([0,1]),function(K,e){"use strict";var n,j,P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=M,e.$zc=S,e.$Ac=E,e.$Ic=f;function M(l,d,a){let t=l.get(d);return t===void 0&&(t=a,l.set(d,t)),t}function S(l){const d=[];return l.forEach((a,t)=>{d.push(`${t} => ${a}`)}),`Map(${l.size}) {${d.join(", ")}}`}function E(l){const d=[];return l.forEach(a=>{d.push(a)}),`Set(${l.size}) {${d.join(", ")}}`}class h{constructor(d,a){this.uri=d,this.value=a}}function c(l){return Array.isArray(l)}class p{static{this.c=d=>d.toString()}constructor(d,a){if(this[n]="ResourceMap",d instanceof p)this.d=new Map(d.d),this.e=a??p.c;else if(c(d)){this.d=new Map,this.e=a??p.c;for(const[t,o]of d)this.set(t,o)}else this.d=new Map,this.e=d??p.c}set(d,a){return this.d.set(this.e(d),new h(d,a)),this}get(d){return this.d.get(this.e(d))?.value}has(d){return this.d.has(this.e(d))}get size(){return this.d.size}clear(){this.d.clear()}delete(d){return this.d.delete(this.e(d))}forEach(d,a){typeof a<"u"&&(d=d.bind(a));for(const[t,o]of this.d)d(o.value,o.uri,this)}*values(){for(const d of this.d.values())yield d.value}*keys(){for(const d of this.d.values())yield d.uri}*entries(){for(const d of this.d.values())yield[d.uri,d.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,d]of this.d)yield[d.uri,d.value]}}e.$Bc=p;class y{constructor(d,a){this[j]="ResourceSet",!d||typeof d=="function"?this.c=new p(d):(this.c=new p(a),d.forEach(this.add,this))}get size(){return this.c.size}add(d){return this.c.set(d,d),this}clear(){this.c.clear()}delete(d){return this.c.delete(d)}forEach(d,a){this.c.forEach((t,o)=>d.call(a,o,o,this))}has(d){return this.c.has(d)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(j=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=y;var k;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(k||(e.Touch=k={}));class g{constructor(){this[P]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(d){return this.c.has(d)}get(d,a=0){const t=this.c.get(d);if(t)return a!==0&&this.l(t,a),t.value}set(d,a,t=0){let o=this.c.get(d);if(o)o.value=a,t!==0&&this.l(o,t);else{switch(o={key:d,value:a,next:void 0,previous:void 0},t){case 0:this.j(o);break;case 1:this.i(o);break;case 2:this.j(o);break;default:this.j(o);break}this.c.set(d,o),this.f++}return this}delete(d){return!!this.remove(d)}remove(d){const a=this.c.get(d);if(a)return this.c.delete(d),this.k(a),this.f--,a.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const d=this.d;return this.c.delete(d.key),this.k(d),this.f--,d.value}forEach(d,a){const t=this.g;let o=this.d;for(;o;){if(a?d.bind(a)(o.value,o.key,this):d(o.value,o.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const d=this,a=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(d.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:t.key,done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}values(){const d=this,a=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(d.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:t.value,done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}entries(){const d=this,a=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(d.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:[t.key,t.value],done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(d){if(d>=this.size)return;if(d===0){this.clear();return}let a=this.d,t=this.size;for(;a&&t>d;)this.c.delete(a.key),a=a.next,t--;this.d=a,this.f=t,a&&(a.previous=void 0),this.g++}i(d){if(!this.d&&!this.e)this.e=d;else if(this.d)d.next=this.d,this.d.previous=d;else throw new Error("Invalid list");this.d=d,this.g++}j(d){if(!this.d&&!this.e)this.d=d;else if(this.e)d.previous=this.e,this.e.next=d;else throw new Error("Invalid list");this.e=d,this.g++}k(d){if(d===this.d&&d===this.e)this.d=void 0,this.e=void 0;else if(d===this.d){if(!d.next)throw new Error("Invalid list");d.next.previous=void 0,this.d=d.next}else if(d===this.e){if(!d.previous)throw new Error("Invalid list");d.previous.next=void 0,this.e=d.previous}else{const a=d.next,t=d.previous;if(!a||!t)throw new Error("Invalid list");a.previous=t,t.next=a}d.next=void 0,d.previous=void 0,this.g++}l(d,a){if(!this.d||!this.e)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(d===this.d)return;const t=d.next,o=d.previous;d===this.e?(o.next=void 0,this.e=o):(t.previous=o,o.next=t),d.previous=void 0,d.next=this.d,this.d.previous=d,this.d=d,this.g++}else if(a===2){if(d===this.e)return;const t=d.next,o=d.previous;d===this.d?(t.previous=void 0,this.d=t):(t.previous=o,o.next=t),d.next=void 0,d.previous=this.e,this.e.next=d,this.e=d,this.g++}}}toJSON(){const d=[];return this.forEach((a,t)=>{d.push([t,a])}),d}fromJSON(d){this.clear();for(const[a,t]of d)this.set(a,t)}}e.$Dc=g;class m extends g{constructor(d,a=1){super(),this.m=d,this.n=Math.min(Math.max(0,a),1)}get limit(){return this.m}set limit(d){this.m=d,this.o()}get ratio(){return this.n}set ratio(d){this.n=Math.min(Math.max(0,d),1),this.o()}get(d,a=2){return super.get(d,a)}peek(d){return super.get(d,0)}set(d,a){return super.set(d,a,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Ec=m;class v{constructor(){this.c=new Map}add(d){return this.c.set(d,(this.c.get(d)||0)+1),this}delete(d){let a=this.c.get(d)||0;return a===0?!1:(a--,a===0?this.c.delete(d):this.c.set(d,a),!0)}has(d){return this.c.has(d)}}e.$Fc=v;class w{constructor(d){if(this.c=new Map,this.d=new Map,d)for(const[a,t]of d)this.set(a,t)}clear(){this.c.clear(),this.d.clear()}set(d,a){this.c.set(d,a),this.d.set(a,d)}get(d){return this.c.get(d)}getKey(d){return this.d.get(d)}delete(d){const a=this.c.get(d);return a===void 0?!1:(this.c.delete(d),this.d.delete(a),!0)}forEach(d,a){this.c.forEach((t,o)=>{d.call(a,t,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=w;class ${constructor(){this.c=new Map}add(d,a){let t=this.c.get(d);t||(t=new Set,this.c.set(d,t)),t.add(a)}delete(d,a){const t=this.c.get(d);t&&(t.delete(a),t.size===0&&this.c.delete(d))}forEach(d,a){const t=this.c.get(d);t&&t.forEach(a)}get(d){const a=this.c.get(d);return a||new Set}}e.$Hc=$;function f(l,d){if(l===d)return!0;if(l.size!==d.size)return!1;for(const[a,t]of l)if(!d.has(a)||d.get(a)!==t)return!1;for(const[a]of d)if(!l.has(a))return!1;return!0}}),define(oe[2],ae([0,1,22,137,32,85,71]),function(K,e,n,j,P,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=p,e.$Lc=y,e.$Mc=k,e.$Nc=v,e.$Oc=w,e.$Pc=$,e.$Qc=f,e.$Rc=l,e.$Sc=d,e.$3c=I;const E=!1;let h=null;class c{constructor(){this.b=new Map}static{this.a=0}c(R){let W=this.b.get(R);return W||(W={parent:null,source:null,isSingleton:!1,value:R,idx:c.a++},this.b.set(R,W)),W}trackDisposable(R){const W=this.c(R);W.source||(W.source=new Error().stack)}setParent(R,W){const F=this.c(R);F.parent=W}markAsDisposed(R){this.b.delete(R)}markAsSingleton(R){this.c(R).isSingleton=!0}f(R,W){const F=W.get(R);if(F)return F;const q=R.parent?this.f(this.c(R.parent),W):R;return W.set(R,q),q}getTrackedDisposables(){const R=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,R).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(R=10,W){let F;if(W)F=W;else{const ue=new Map,Y=[...this.b.values()].filter(B=>B.source!==null&&!this.f(B,ue).isSingleton);if(Y.length===0)return;const Z=new Set(Y.map(B=>B.value));if(F=Y.filter(B=>!(B.parent&&Z.has(B.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function q(ue){function Y(B,L){for(;B.length>0&&L.some(T=>typeof T=="string"?T===B[0]:B[0].match(T));)B.shift()}const Z=ue.source.split(`
`).map(B=>B.trim().replace("at ","")).filter(B=>B!=="");return Y(Z,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Z.reverse()}const x=new P.$Hc;for(const ue of F){const Y=q(ue);for(let Z=0;Z<=Y.length;Z++)x.add(Y.slice(0,Z).join(`
`),ue)}F.sort((0,n.$7b)(ue=>ue.idx,n.$9b));let le="",te=0;for(const ue of F.slice(0,R)){te++;const Y=q(ue),Z=[];for(let B=0;B<Y.length;B++){let L=Y[B];L=`(shared with ${x.get(Y.slice(0,B+1).join(`
`)).size}/${F.length} leaks) at ${L}`;const G=x.get(Y.slice(0,B).join(`
`)),z=(0,j.$K)([...G].map(ce=>q(ce)[B]),ce=>ce);delete z[Y[B]];for(const[ce,he]of Object.entries(z))Z.unshift(`    - stacktraces of ${he.length} other leaks continue with ${ce}`);Z.unshift(L)}le+=`


==================== Leaking disposable ${te}/${F.length}: ${ue.value.constructor.name} ====================
${Z.join(`
`)}
============================================================

`}return F.length>R&&(le+=`


... and ${F.length-R} more leaking disposables

`),{leaks:F,details:le}}}e.$Jc=c;function p(O){h=O}if(E){const O="__is_disposable_tracked__";p(new class{trackDisposable(R){const W=new Error("Potentially leaked disposable").stack;setTimeout(()=>{R[O]||console.log(W)},3e3)}setParent(R,W){if(R&&R!==t.None)try{R[O]=!0}catch{}}markAsDisposed(R){if(R&&R!==t.None)try{R[O]=!0}catch{}}markAsSingleton(R){}})}function y(O){return h?.trackDisposable(O),O}function k(O){h?.markAsDisposed(O)}function g(O,R){h?.setParent(O,R)}function m(O,R){if(h)for(const W of O)h.setParent(W,R)}function v(O){return h?.markAsSingleton(O),O}function w(O){return typeof O.dispose=="function"&&O.dispose.length===0}function $(O){if(S.Iterable.is(O)){const R=[];for(const W of O)if(W)try{W.dispose()}catch(F){R.push(F)}if(R.length===1)throw R[0];if(R.length>1)throw new AggregateError(R,"Encountered errors while disposing of store");return Array.isArray(O)?[]:O}else if(O)return O.dispose(),O}function f(O){for(const R of O)w(R)&&R.dispose();return[]}function l(...O){const R=d(()=>$(O));return m(O,R),R}function d(O){const R=y({dispose:(0,M.$db)(()=>{k(R),O()})});return R}class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,y(this)}dispose(){this.g||(k(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{$(this.f)}finally{this.f.clear()}}add(R){if(!R)return R;if(R===this)throw new Error("Cannot register a disposable on itself!");return g(R,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(R),R}delete(R){if(R){if(R===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(R),R.dispose()}}deleteAndLeak(R){R&&this.f.has(R)&&(this.f.delete(R),g(R,null))}}e.$Tc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,y(this),g(this.q,this)}dispose(){k(this),this.q.dispose()}B(R){if(R===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(R)}}e.$Uc=t;class o{constructor(){this.b=!1,y(this)}get value(){return this.b?void 0:this.a}set value(R){this.b||R===this.a||(this.a?.dispose(),R&&g(R,this),this.a=R)}clear(){this.value=void 0}dispose(){this.b=!0,k(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const R=this.a;return this.a=void 0,R&&g(R,null),R}}e.$Vc=o;class r{constructor(R){this.a=new o,this.b=!1,this.a.value=R}get value(){return this.a.value}set value(R){this.b||R===this.a.value||(this.a.value=R)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=r;class i{constructor(R){this.b=R,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=i;class s{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(R){let W=R;return this.unset=()=>W=void 0,this.isset=()=>W!==void 0,this.dispose=()=>{W&&(W(),W=void 0,k(this))},this}}e.$Yc=s;class u{constructor(){this.a=new Map}acquire(R,...W){let F=this.a.get(R);F||(F={counter:0,object:this.b(R,...W)},this.a.set(R,F));const{object:q}=F,x=(0,M.$db)(()=>{--F.counter===0&&(this.c(R,F.object),this.a.delete(R))});return F.counter++,{object:q,dispose:x}}}e.$Zc=u;class b{constructor(R){this.a=R}async acquire(R,...W){const F=this.a.acquire(R,...W);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(q){throw F.dispose(),q}}}e.$1c=b;class C{constructor(R){this.object=R}dispose(){}}e.$2c=C;function I(O){const R=new a;try{O(R)}finally{R.dispose()}}class D{constructor(){this.a=new Map,this.b=!1,y(this)}dispose(){k(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{$(this.a.values())}finally{this.a.clear()}}has(R){return this.a.has(R)}get size(){return this.a.size}get(R){return this.a.get(R)}set(R,W,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(R)?.dispose(),this.a.set(R,W)}deleteAndDispose(R){this.a.get(R)?.dispose(),this.a.delete(R)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=D}),define(oe[86],ae([0,1,32]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2l=void 0,e.$Zl=P,e.$1l=S;const j=new n.$Ec(1e4);function P(c){return h(c,"NFC",j)}const M=new n.$Ec(1e4);function S(c){return h(c,"NFD",M)}const E=/[^\u0000-\u0080]/;function h(c,p,y){if(!c)return c;const k=y.get(c);if(k)return k;let g;return E.test(c)?g=c.normalize(p):g=c,y.set(c,g),g}e.$2l=function(){const c=/[\u0300-\u036f]/g;return function(p){return S(p).replace(c,"")}}()}),define(oe[141],ae([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=e.$qm=e.$pm=void 0,e.$nm=n,e.rot=j;function n(E,h,c){return Math.min(Math.max(E,h),c)}function j(E,h){return(h+E%h)%h}class P{constructor(){this.a=0}getNext(){return this.a++}}e.$pm=P;class M{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$qm=M;class S{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const c=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$rm=S}),function(){function K(P){const M=[];typeof P=="number"&&M.push("code/timeOrigin",P);function S(h){M.push(h,Date.now())}function E(){const h=[];for(let c=0;c<M.length;c+=2)h.push({name:M[c],startTime:M[c+1]});return h}return{mark:S,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const S of performance.getEntriesByType("mark"))M.push({name:S.name,startTime:Math.round(P+S.startTime)});return M}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function n(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var j;typeof global=="object"?j=global:typeof self=="object"?j=self:j={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(j)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(j):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),j.perf=n(j))}(),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var j in n)(typeof exports=="object"?exports:K)[j]=n[j]}}(typeof self<"u"?self:this,function(){return function(K){var e={};function n(j){if(e[j])return e[j].exports;var P=e[j]={i:j,l:!1,exports:{}};return K[j].call(P.exports,P,P.exports,n),P.l=!0,P.exports}return n.m=K,n.c=e,n.d=function(j,P,M){n.o(j,P)||Object.defineProperty(j,P,{enumerable:!0,get:M})},n.r=function(j){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(j,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(j,"__esModule",{value:!0})},n.t=function(j,P){if(1&P&&(j=n(j)),8&P||4&P&&typeof j=="object"&&j&&j.__esModule)return j;var M=Object.create(null);if(n.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:j}),2&P&&typeof j!="string")for(var S in j)n.d(M,S,function(E){return j[E]}.bind(null,S));return M},n.n=function(j){var P=j&&j.__esModule?function(){return j.default}:function(){return j};return n.d(P,"a",P),P},n.o=function(j,P){return Object.prototype.hasOwnProperty.call(j,P)},n.p="",n(n.s=0)}([function(K,e,n){(function(j){var P;e=K.exports=he,P=typeof j=="object"&&j.env&&j.env.NODE_DEBUG&&/\bsemver\b/i.test(j.env.NODE_DEBUG)?function(){var Q=Array.prototype.slice.call(arguments,0);Q.unshift("SEMVER"),console.log.apply(console,Q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,S=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],h=e.src=[],c=0,p=c++;h[p]="0|[1-9]\\d*";var y=c++;h[y]="[0-9]+";var k=c++;h[k]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var g=c++;h[g]="("+h[p]+")\\.("+h[p]+")\\.("+h[p]+")";var m=c++;h[m]="("+h[y]+")\\.("+h[y]+")\\.("+h[y]+")";var v=c++;h[v]="(?:"+h[p]+"|"+h[k]+")";var w=c++;h[w]="(?:"+h[y]+"|"+h[k]+")";var $=c++;h[$]="(?:-("+h[v]+"(?:\\."+h[v]+")*))";var f=c++;h[f]="(?:-?("+h[w]+"(?:\\."+h[w]+")*))";var l=c++;h[l]="[0-9A-Za-z-]+";var d=c++;h[d]="(?:\\+("+h[l]+"(?:\\."+h[l]+")*))";var a=c++,t="v?"+h[g]+h[$]+"?"+h[d]+"?";h[a]="^"+t+"$";var o="[v=\\s]*"+h[m]+h[f]+"?"+h[d]+"?",r=c++;h[r]="^"+o+"$";var i=c++;h[i]="((?:<|>)?=?)";var s=c++;h[s]=h[y]+"|x|X|\\*";var u=c++;h[u]=h[p]+"|x|X|\\*";var b=c++;h[b]="[v=\\s]*("+h[u]+")(?:\\.("+h[u]+")(?:\\.("+h[u]+")(?:"+h[$]+")?"+h[d]+"?)?)?";var C=c++;h[C]="[v=\\s]*("+h[s]+")(?:\\.("+h[s]+")(?:\\.("+h[s]+")(?:"+h[f]+")?"+h[d]+"?)?)?";var I=c++;h[I]="^"+h[i]+"\\s*"+h[b]+"$";var D=c++;h[D]="^"+h[i]+"\\s*"+h[C]+"$";var O=c++;h[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var R=c++;h[R]="(?:~>?)";var W=c++;h[W]="(\\s*)"+h[R]+"\\s+",E[W]=new RegExp(h[W],"g");var F=c++;h[F]="^"+h[R]+h[b]+"$";var q=c++;h[q]="^"+h[R]+h[C]+"$";var x=c++;h[x]="(?:\\^)";var le=c++;h[le]="(\\s*)"+h[x]+"\\s+",E[le]=new RegExp(h[le],"g");var te=c++;h[te]="^"+h[x]+h[b]+"$";var ue=c++;h[ue]="^"+h[x]+h[C]+"$";var Y=c++;h[Y]="^"+h[i]+"\\s*("+o+")$|^$";var Z=c++;h[Z]="^"+h[i]+"\\s*("+t+")$|^$";var B=c++;h[B]="(\\s*)"+h[i]+"\\s*("+o+"|"+h[b]+")",E[B]=new RegExp(h[B],"g");var L=c++;h[L]="^\\s*("+h[b]+")\\s+-\\s+("+h[b]+")\\s*$";var T=c++;h[T]="^\\s*("+h[C]+")\\s+-\\s+("+h[C]+")\\s*$";var G=c++;h[G]="(<|>)?=?\\s*\\*";for(var z=0;z<35;z++)P(z,h[z]),E[z]||(E[z]=new RegExp(h[z]));function ce(Q,de){if(Q instanceof he)return Q;if(typeof Q!="string"||Q.length>M||!(de?E[r]:E[a]).test(Q))return null;try{return new he(Q,de)}catch{return null}}function he(Q,de){if(Q instanceof he){if(Q.loose===de)return Q;Q=Q.version}else if(typeof Q!="string")throw new TypeError("Invalid Version: "+Q);if(Q.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof he))return new he(Q,de);P("SemVer",Q,de),this.loose=de;var $e=Q.trim().match(de?E[r]:E[a]);if(!$e)throw new TypeError("Invalid Version: "+Q);if(this.raw=Q,this.major=+$e[1],this.minor=+$e[2],this.patch=+$e[3],this.major>S||this.major<0)throw new TypeError("Invalid major version");if(this.minor>S||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>S||this.patch<0)throw new TypeError("Invalid patch version");$e[4]?this.prerelease=$e[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Re=+Se;if(Re>=0&&Re<S)return Re}return Se}):this.prerelease=[],this.build=$e[5]?$e[5].split("."):[],this.format()}e.parse=ce,e.valid=function(Q,de){var $e=ce(Q,de);return $e?$e.version:null},e.clean=function(Q,de){var $e=ce(Q.trim().replace(/^[=v]+/,""),de);return $e?$e.version:null},e.SemVer=he,he.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},he.prototype.toString=function(){return this.version},he.prototype.compare=function(Q){return P("SemVer.compare",this.version,this.loose,Q),Q instanceof he||(Q=new he(Q,this.loose)),this.compareMain(Q)||this.comparePre(Q)},he.prototype.compareMain=function(Q){return Q instanceof he||(Q=new he(Q,this.loose)),A(this.major,Q.major)||A(this.minor,Q.minor)||A(this.patch,Q.patch)},he.prototype.comparePre=function(Q){if(Q instanceof he||(Q=new he(Q,this.loose)),this.prerelease.length&&!Q.prerelease.length)return-1;if(!this.prerelease.length&&Q.prerelease.length)return 1;if(!this.prerelease.length&&!Q.prerelease.length)return 0;var de=0;do{var $e=this.prerelease[de],Se=Q.prerelease[de];if(P("prerelease compare",de,$e,Se),$e===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if($e===void 0)return-1;if($e!==Se)return A($e,Se)}while(++de)},he.prototype.inc=function(Q,de){switch(Q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var $e=this.prerelease.length;--$e>=0;)typeof this.prerelease[$e]=="number"&&(this.prerelease[$e]++,$e=-2);$e===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+Q)}return this.format(),this.raw=this.version,this},e.inc=function(Q,de,$e,Se){typeof $e=="string"&&(Se=$e,$e=void 0);try{return new he(Q,$e).inc(de,Se).version}catch{return null}},e.diff=function(Q,de){if(J(Q,de))return null;var $e=ce(Q),Se=ce(de);if($e.prerelease.length||Se.prerelease.length){for(var Re in $e)if((Re==="major"||Re==="minor"||Re==="patch")&&$e[Re]!==Se[Re])return"pre"+Re;return"prerelease"}for(var Re in $e)if((Re==="major"||Re==="minor"||Re==="patch")&&$e[Re]!==Se[Re])return Re},e.compareIdentifiers=A;var X=/^[0-9]+$/;function A(Q,de){var $e=X.test(Q),Se=X.test(de);return $e&&Se&&(Q=+Q,de=+de),$e&&!Se?-1:Se&&!$e?1:Q<de?-1:Q>de?1:0}function N(Q,de,$e){return new he(Q,$e).compare(new he(de,$e))}function _(Q,de,$e){return N(Q,de,$e)>0}function se(Q,de,$e){return N(Q,de,$e)<0}function J(Q,de,$e){return N(Q,de,$e)===0}function V(Q,de,$e){return N(Q,de,$e)!==0}function H(Q,de,$e){return N(Q,de,$e)>=0}function U(Q,de,$e){return N(Q,de,$e)<=0}function re(Q,de,$e,Se){var Re;switch(de){case"===":typeof Q=="object"&&(Q=Q.version),typeof $e=="object"&&($e=$e.version),Re=Q===$e;break;case"!==":typeof Q=="object"&&(Q=Q.version),typeof $e=="object"&&($e=$e.version),Re=Q!==$e;break;case"":case"=":case"==":Re=J(Q,$e,Se);break;case"!=":Re=V(Q,$e,Se);break;case">":Re=_(Q,$e,Se);break;case">=":Re=H(Q,$e,Se);break;case"<":Re=se(Q,$e,Se);break;case"<=":Re=U(Q,$e,Se);break;default:throw new TypeError("Invalid operator: "+de)}return Re}function ee(Q,de){if(Q instanceof ee){if(Q.loose===de)return Q;Q=Q.value}if(!(this instanceof ee))return new ee(Q,de);P("comparator",Q,de),this.loose=de,this.parse(Q),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(Q,de){return A(de,Q)},e.major=function(Q,de){return new he(Q,de).major},e.minor=function(Q,de){return new he(Q,de).minor},e.patch=function(Q,de){return new he(Q,de).patch},e.compare=N,e.compareLoose=function(Q,de){return N(Q,de,!0)},e.rcompare=function(Q,de,$e){return N(de,Q,$e)},e.sort=function(Q,de){return Q.sort(function($e,Se){return e.compare($e,Se,de)})},e.rsort=function(Q,de){return Q.sort(function($e,Se){return e.rcompare($e,Se,de)})},e.gt=_,e.lt=se,e.eq=J,e.neq=V,e.gte=H,e.lte=U,e.cmp=re,e.Comparator=ee;var fe={};function me(Q,de){if(Q instanceof me)return Q.loose===de?Q:new me(Q.raw,de);if(Q instanceof ee)return new me(Q.value,de);if(!(this instanceof me))return new me(Q,de);if(this.loose=de,this.raw=Q,this.set=Q.split(/\s*\|\|\s*/).map(function($e){return this.parseRange($e.trim())},this).filter(function($e){return $e.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Q);this.format()}function ve(Q){return!Q||Q.toLowerCase()==="x"||Q==="*"}function ke(Q,de,$e,Se,Re,qe,Me,Le,Ve,xe,Xe,Te,ie){return((de=ve($e)?"":ve(Se)?">="+$e+".0.0":ve(Re)?">="+$e+"."+Se+".0":">="+de)+" "+(Le=ve(Ve)?"":ve(xe)?"<"+(+Ve+1)+".0.0":ve(Xe)?"<"+Ve+"."+(+xe+1)+".0":Te?"<="+Ve+"."+xe+"."+Xe+"-"+Te:"<="+Le)).trim()}function je(Q,de){for(var $e=0;$e<Q.length;$e++)if(!Q[$e].test(de))return!1;if(de.prerelease.length){for($e=0;$e<Q.length;$e++)if(P(Q[$e].semver),Q[$e].semver!==fe&&Q[$e].semver.prerelease.length>0){var Se=Q[$e].semver;if(Se.major===de.major&&Se.minor===de.minor&&Se.patch===de.patch)return!0}return!1}return!0}function Fe(Q,de,$e){try{de=new me(de,$e)}catch{return!1}return de.test(Q)}function ye(Q,de,$e,Se){var Re,qe,Me,Le,Ve;switch(Q=new he(Q,Se),de=new me(de,Se),$e){case">":Re=_,qe=U,Me=se,Le=">",Ve=">=";break;case"<":Re=se,qe=H,Me=_,Le="<",Ve="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Fe(Q,de,Se))return!1;for(var xe=0;xe<de.set.length;++xe){var Xe=de.set[xe],Te=null,ie=null;if(Xe.forEach(function(ge){ge.semver===fe&&(ge=new ee(">=0.0.0")),Te=Te||ge,ie=ie||ge,Re(ge.semver,Te.semver,Se)?Te=ge:Me(ge.semver,ie.semver,Se)&&(ie=ge)}),Te.operator===Le||Te.operator===Ve||(!ie.operator||ie.operator===Le)&&qe(Q,ie.semver)||ie.operator===Ve&&Me(Q,ie.semver))return!1}return!0}ee.prototype.parse=function(Q){var de=this.loose?E[Y]:E[Z],$e=Q.match(de);if(!$e)throw new TypeError("Invalid comparator: "+Q);this.operator=$e[1],this.operator==="="&&(this.operator=""),$e[2]?this.semver=new he($e[2],this.loose):this.semver=fe},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(Q){return P("Comparator.test",Q,this.loose),this.semver===fe||(typeof Q=="string"&&(Q=new he(Q,this.loose)),re(Q,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(Q,de){if(!(Q instanceof ee))throw new TypeError("a Comparator is required");var $e;if(this.operator==="")return $e=new me(Q.value,de),Fe(this.value,$e,de);if(Q.operator==="")return $e=new me(this.value,de),Fe(Q.semver,$e,de);var Se=!(this.operator!==">="&&this.operator!==">"||Q.operator!==">="&&Q.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||Q.operator!=="<="&&Q.operator!=="<"),qe=this.semver.version===Q.semver.version,Me=!(this.operator!==">="&&this.operator!=="<="||Q.operator!==">="&&Q.operator!=="<="),Le=re(this.semver,"<",Q.semver,de)&&(this.operator===">="||this.operator===">")&&(Q.operator==="<="||Q.operator==="<"),Ve=re(this.semver,">",Q.semver,de)&&(this.operator==="<="||this.operator==="<")&&(Q.operator===">="||Q.operator===">");return Se||Re||qe&&Me||Le||Ve},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(Q){return Q.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(Q){var de=this.loose;Q=Q.trim(),P("range",Q,de);var $e=de?E[T]:E[L];Q=Q.replace($e,ke),P("hyphen replace",Q),Q=Q.replace(E[B],"$1$2$3"),P("comparator trim",Q,E[B]),Q=(Q=(Q=Q.replace(E[W],"$1~")).replace(E[le],"$1^")).split(/\s+/).join(" ");var Se=de?E[Y]:E[Z],Re=Q.split(" ").map(function(qe){return function(Me,Le){return P("comp",Me),Me=function(Ve,xe){return Ve.trim().split(/\s+/).map(function(Xe){return function(Te,ie){P("caret",Te,ie);var ge=ie?E[ue]:E[te];return Te.replace(ge,function(we,be,Pe,Ae,ze){var Je;return P("caret",Te,we,be,Pe,Ae,ze),ve(be)?Je="":ve(Pe)?Je=">="+be+".0.0 <"+(+be+1)+".0.0":ve(Ae)?Je=be==="0"?">="+be+"."+Pe+".0 <"+be+"."+(+Pe+1)+".0":">="+be+"."+Pe+".0 <"+(+be+1)+".0.0":ze?(P("replaceCaret pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Je=be==="0"?Pe==="0"?">="+be+"."+Pe+"."+Ae+ze+" <"+be+"."+Pe+"."+(+Ae+1):">="+be+"."+Pe+"."+Ae+ze+" <"+be+"."+(+Pe+1)+".0":">="+be+"."+Pe+"."+Ae+ze+" <"+(+be+1)+".0.0"):(P("no pr"),Je=be==="0"?Pe==="0"?">="+be+"."+Pe+"."+Ae+" <"+be+"."+Pe+"."+(+Ae+1):">="+be+"."+Pe+"."+Ae+" <"+be+"."+(+Pe+1)+".0":">="+be+"."+Pe+"."+Ae+" <"+(+be+1)+".0.0"),P("caret return",Je),Je})}(Xe,xe)}).join(" ")}(Me,Le),P("caret",Me),Me=function(Ve,xe){return Ve.trim().split(/\s+/).map(function(Xe){return function(Te,ie){var ge=ie?E[q]:E[F];return Te.replace(ge,function(we,be,Pe,Ae,ze){var Je;return P("tilde",Te,we,be,Pe,Ae,ze),ve(be)?Je="":ve(Pe)?Je=">="+be+".0.0 <"+(+be+1)+".0.0":ve(Ae)?Je=">="+be+"."+Pe+".0 <"+be+"."+(+Pe+1)+".0":ze?(P("replaceTilde pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Je=">="+be+"."+Pe+"."+Ae+ze+" <"+be+"."+(+Pe+1)+".0"):Je=">="+be+"."+Pe+"."+Ae+" <"+be+"."+(+Pe+1)+".0",P("tilde return",Je),Je})}(Xe,xe)}).join(" ")}(Me,Le),P("tildes",Me),Me=function(Ve,xe){return P("replaceXRanges",Ve,xe),Ve.split(/\s+/).map(function(Xe){return function(Te,ie){Te=Te.trim();var ge=ie?E[D]:E[I];return Te.replace(ge,function(we,be,Pe,Ae,ze,Je){P("xRange",Te,we,be,Pe,Ae,ze,Je);var Qe=ve(Pe),Ye=Qe||ve(Ae),Ze=Ye||ve(ze);return be==="="&&Ze&&(be=""),Qe?we=be===">"||be==="<"?"<0.0.0":"*":be&&Ze?(Ye&&(Ae=0),Ze&&(ze=0),be===">"?(be=">=",Ye?(Pe=+Pe+1,Ae=0,ze=0):Ze&&(Ae=+Ae+1,ze=0)):be==="<="&&(be="<",Ye?Pe=+Pe+1:Ae=+Ae+1),we=be+Pe+"."+Ae+"."+ze):Ye?we=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":Ze&&(we=">="+Pe+"."+Ae+".0 <"+Pe+"."+(+Ae+1)+".0"),P("xRange return",we),we})}(Xe,xe)}).join(" ")}(Me,Le),P("xrange",Me),Me=function(Ve,xe){return P("replaceStars",Ve,xe),Ve.trim().replace(E[G],"")}(Me,Le),P("stars",Me),Me}(qe,de)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(qe){return!!qe.match(Se)})),Re=Re.map(function(qe){return new ee(qe,de)})},me.prototype.intersects=function(Q,de){if(!(Q instanceof me))throw new TypeError("a Range is required");return this.set.some(function($e){return $e.every(function(Se){return Q.set.some(function(Re){return Re.every(function(qe){return Se.intersects(qe,de)})})})})},e.toComparators=function(Q,de){return new me(Q,de).set.map(function($e){return $e.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},me.prototype.test=function(Q){if(!Q)return!1;typeof Q=="string"&&(Q=new he(Q,this.loose));for(var de=0;de<this.set.length;de++)if(je(this.set[de],Q))return!0;return!1},e.satisfies=Fe,e.maxSatisfying=function(Q,de,$e){var Se=null,Re=null;try{var qe=new me(de,$e)}catch{return null}return Q.forEach(function(Me){qe.test(Me)&&(Se&&Re.compare(Me)!==-1||(Re=new he(Se=Me,$e)))}),Se},e.minSatisfying=function(Q,de,$e){var Se=null,Re=null;try{var qe=new me(de,$e)}catch{return null}return Q.forEach(function(Me){qe.test(Me)&&(Se&&Re.compare(Me)!==1||(Re=new he(Se=Me,$e)))}),Se},e.validRange=function(Q,de){try{return new me(Q,de).range||"*"}catch{return null}},e.ltr=function(Q,de,$e){return ye(Q,de,"<",$e)},e.gtr=function(Q,de,$e){return ye(Q,de,">",$e)},e.outside=ye,e.prerelease=function(Q,de){var $e=ce(Q,de);return $e&&$e.prerelease.length?$e.prerelease:null},e.intersects=function(Q,de,$e){return Q=new me(Q,$e),de=new me(de,$e),Q.intersects(de)},e.coerce=function(Q){if(Q instanceof he)return Q;if(typeof Q!="string")return null;var de=Q.match(E[O]);return de==null?null:ce((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,n(1))},function(K,e){var n,j,P=K.exports={};function M(){throw new Error("setTimeout has not been defined")}function S(){throw new Error("clearTimeout has not been defined")}function E(w){if(n===setTimeout)return setTimeout(w,0);if((n===M||!n)&&setTimeout)return n=setTimeout,setTimeout(w,0);try{return n(w,0)}catch{try{return n.call(null,w,0)}catch{return n.call(this,w,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:M}catch{n=M}try{j=typeof clearTimeout=="function"?clearTimeout:S}catch{j=S}})();var h,c=[],p=!1,y=-1;function k(){p&&h&&(p=!1,h.length?c=h.concat(c):y=-1,c.length&&g())}function g(){if(!p){var w=E(k);p=!0;for(var $=c.length;$;){for(h=c,c=[];++y<$;)h&&h[y].run();y=-1,$=c.length}h=null,p=!1,function(f){if(j===clearTimeout)return clearTimeout(f);if((j===S||!j)&&clearTimeout)return j=clearTimeout,clearTimeout(f);try{j(f)}catch{try{return j.call(null,f)}catch{return j.call(this,f)}}}(w)}}function m(w,$){this.fun=w,this.array=$}function v(){}P.nextTick=function(w){var $=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)$[f-1]=arguments[f];c.push(new m(w,$)),c.length!==1||p||E(g)},m.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=v,P.addListener=v,P.once=v,P.off=v,P.removeListener=v,P.removeAllListeners=v,P.emit=v,P.prependListener=v,P.prependOnceListener=v,P.listeners=function(w){return[]},P.binding=function(w){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(w){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(oe[142],ae([0,1]),function(K,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$is=void 0;class j{constructor(E,h,c){this.level=E,this.key=h,this.value=c,this.forward=[]}}const P=void 0;class M{constructor(E,h=2**16){this.comparator=E,this[n]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(h)|0),this.e=new j(this.c,P,P)}get size(){return this.f}clear(){this.e=new j(this.c,P,P),this.f=0}has(E){return!!M.g(this,E,this.comparator)}get(E){return M.g(this,E,this.comparator)?.value}set(E,h){return M.h(this,E,h,this.comparator)&&(this.f+=1),this}delete(E){const h=M.k(this,E,this.comparator);return h&&(this.f-=1),h}forEach(E,h){let c=this.e.forward[0];for(;c;)E.call(h,c.value,c.key,this),c=c.forward[0]}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this.e.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this.e.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this.e.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",h=this.e.forward[0];for(;h;)E+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return E}static g(E,h,c){let p=E.e;for(let y=E.d-1;y>=0;y--)for(;p.forward[y]&&c(p.forward[y].key,h)<0;)p=p.forward[y];if(p=p.forward[0],p&&c(p.key,h)===0)return p}static h(E,h,c,p){const y=[];let k=E.e;for(let g=E.d-1;g>=0;g--){for(;k.forward[g]&&p(k.forward[g].key,h)<0;)k=k.forward[g];y[g]=k}if(k=k.forward[0],k&&p(k.key,h)===0)return k.value=c,!1;{const g=M.j(E);if(g>E.d){for(let m=E.d;m<g;m++)y[m]=E.e;E.d=g}k=new j(g,h,c);for(let m=0;m<g;m++)k.forward[m]=y[m].forward[m],y[m].forward[m]=k;return!0}}static j(E,h=.5){let c=1;for(;Math.random()<h&&c<E.c;)c+=1;return c}static k(E,h,c){const p=[];let y=E.e;for(let k=E.d-1;k>=0;k--){for(;y.forward[k]&&c(y.forward[k].key,h)<0;)y=y.forward[k];p[k]=y}if(y=y.forward[0],!y||c(y.key,h)!==0)return!1;for(let k=0;k<E.d&&p[k].forward[k]===y;k++)p[k].forward[k]=y.forward[k];for(;E.d>0&&E.e.forward[E.d-1]===P;)E.d-=1;return!0}}e.$is=M}),define(oe[72],ae([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class j{static create(M){return new j(M)}constructor(M){this.c=n&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$3d=j}),define(oe[3],ae([0,1,15,85,2,104,72]),function(K,e,n,j,P,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$5d=e.Event=void 0,e.$6d=g;const E=!1,h=!1,c=!1;var p;(function(O){O.None=()=>P.$Uc.None;function R(ee){if(c){const{onDidAddListener:fe}=ee,me=v.create();let ve=0;ee.onDidAddListener=()=>{++ve===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),me.print()),fe?.()}}}function W(ee,fe){return L(ee,()=>{},0,void 0,!0,void 0,fe)}O.defer=W;function F(ee){return(fe,me=null,ve)=>{let ke=!1,je;return je=ee(Fe=>{if(!ke)return je?je.dispose():ke=!0,fe.call(me,Fe)},null,ve),ke&&je.dispose(),je}}O.once=F;function q(ee,fe,me){return Z((ve,ke=null,je)=>ee(Fe=>ve.call(ke,fe(Fe)),null,je),me)}O.map=q;function x(ee,fe,me){return Z((ve,ke=null,je)=>ee(Fe=>{fe(Fe),ve.call(ke,Fe)},null,je),me)}O.forEach=x;function le(ee,fe,me){return Z((ve,ke=null,je)=>ee(Fe=>fe(Fe)&&ve.call(ke,Fe),null,je),me)}O.filter=le;function te(ee){return ee}O.signal=te;function ue(...ee){return(fe,me=null,ve)=>{const ke=(0,P.$Rc)(...ee.map(je=>je(Fe=>fe.call(me,Fe))));return B(ke,ve)}}O.any=ue;function Y(ee,fe,me,ve){let ke=me;return q(ee,je=>(ke=fe(ke,je),ke),ve)}O.reduce=Y;function Z(ee,fe){let me;const ve={onWillAddFirstListener(){me=ee(ke.fire,ke)},onDidRemoveLastListener(){me?.dispose()}};fe||R(ve);const ke=new a(ve);return fe?.add(ke),ke.event}function B(ee,fe){return fe instanceof Array?fe.push(ee):fe&&fe.add(ee),ee}function L(ee,fe,me=100,ve=!1,ke=!1,je,Fe){let ye,Q,de,$e=0,Se;const Re={leakWarningThreshold:je,onWillAddFirstListener(){ye=ee(Me=>{$e++,Q=fe(Q,Me),ve&&!de&&(qe.fire(Q),Q=void 0),Se=()=>{const Le=Q;Q=void 0,de=void 0,(!ve||$e>1)&&qe.fire(Le),$e=0},typeof me=="number"?(clearTimeout(de),de=setTimeout(Se,me)):de===void 0&&(de=0,queueMicrotask(Se))})},onWillRemoveListener(){ke&&$e>0&&Se?.()},onDidRemoveLastListener(){Se=void 0,ye.dispose()}};Fe||R(Re);const qe=new a(Re);return Fe?.add(qe),qe.event}O.debounce=L;function T(ee,fe=0,me){return O.debounce(ee,(ve,ke)=>ve?(ve.push(ke),ve):[ke],fe,void 0,!0,void 0,me)}O.accumulate=T;function G(ee,fe=(ve,ke)=>ve===ke,me){let ve=!0,ke;return le(ee,je=>{const Fe=ve||!fe(je,ke);return ve=!1,ke=je,Fe},me)}O.latch=G;function z(ee,fe,me){return[O.filter(ee,fe,me),O.filter(ee,ve=>!fe(ve),me)]}O.split=z;function ce(ee,fe=!1,me=[],ve){let ke=me.slice(),je=ee(Q=>{ke?ke.push(Q):ye.fire(Q)});ve&&ve.add(je);const Fe=()=>{ke?.forEach(Q=>ye.fire(Q)),ke=null},ye=new a({onWillAddFirstListener(){je||(je=ee(Q=>ye.fire(Q)),ve&&ve.add(je))},onDidAddFirstListener(){ke&&(fe?setTimeout(Fe):Fe())},onDidRemoveLastListener(){je&&je.dispose(),je=null}});return ve&&ve.add(ye),ye.event}O.buffer=ce;function he(ee,fe){return(ve,ke,je)=>{const Fe=fe(new A);return ee(function(ye){const Q=Fe.evaluate(ye);Q!==X&&ve.call(ke,Q)},void 0,je)}}O.chain=he;const X=Symbol("HaltChainable");class A{constructor(){this.f=[]}map(fe){return this.f.push(fe),this}forEach(fe){return this.f.push(me=>(fe(me),me)),this}filter(fe){return this.f.push(me=>fe(me)?me:X),this}reduce(fe,me){let ve=me;return this.f.push(ke=>(ve=fe(ve,ke),ve)),this}latch(fe=(me,ve)=>me===ve){let me=!0,ve;return this.f.push(ke=>{const je=me||!fe(ke,ve);return me=!1,ve=ke,je?ke:X}),this}evaluate(fe){for(const me of this.f)if(fe=me(fe),fe===X)break;return fe}}function N(ee,fe,me=ve=>ve){const ve=(...ye)=>Fe.fire(me(...ye)),ke=()=>ee.on(fe,ve),je=()=>ee.removeListener(fe,ve),Fe=new a({onWillAddFirstListener:ke,onDidRemoveLastListener:je});return Fe.event}O.fromNodeEventEmitter=N;function _(ee,fe,me=ve=>ve){const ve=(...ye)=>Fe.fire(me(...ye)),ke=()=>ee.addEventListener(fe,ve),je=()=>ee.removeEventListener(fe,ve),Fe=new a({onWillAddFirstListener:ke,onDidRemoveLastListener:je});return Fe.event}O.fromDOMEventEmitter=_;function se(ee){return new Promise(fe=>F(ee)(fe))}O.toPromise=se;function J(ee){const fe=new a;return ee.then(me=>{fe.fire(me)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}O.fromPromise=J;function V(ee,fe,me){return fe(me),ee(ve=>fe(ve))}O.runAndSubscribe=V;class H{constructor(fe,me){this._observable=fe,this.f=0,this.g=!1;const ve={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};me||R(ve),this.emitter=new a(ve),me&&me.add(this.emitter)}beginUpdate(fe){this.f++}handlePossibleChange(fe){}handleChange(fe,me){this.g=!0}endUpdate(fe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function U(ee,fe){return new H(ee,fe).emitter.event}O.fromObservable=U;function re(ee){return(fe,me,ve)=>{let ke=0,je=!1;const Fe={beginUpdate(){ke++},endUpdate(){ke--,ke===0&&(ee.reportChanges(),je&&(je=!1,fe.call(me)))},handlePossibleChange(){},handleChange(){je=!0}};ee.addObserver(Fe),ee.reportChanges();const ye={dispose(){ee.removeObserver(Fe)}};return ve instanceof P.$Tc?ve.add(ye):Array.isArray(ve)&&ve.push(ye),ye}}O.fromObservableLight=re})(p||(e.Event=p={}));class y{static{this.all=new Set}static{this.f=0}constructor(R){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${R}_${y.f++}`,y.all.add(this)}start(R){this.g=new S.$3d,this.listenerCount=R}stop(){if(this.g){const R=this.g.elapsed();this.durations.push(R),this.elapsedOverall+=R,this.invocationCount+=1,this.g=void 0}}}e.$5d=y;let k=-1;function g(O){const R=k;return k=O,{dispose(){k=R}}}class m{constructor(R,W=Math.random().toString(18).slice(2,5)){this.threshold=R,this.name=W,this.g=0}dispose(){this.f?.clear()}check(R,W){const F=this.threshold;if(F<=0||W<F)return;this.f||(this.f=new Map);const q=this.f.get(R.value)||0;if(this.f.set(R.value,q+1),this.g-=1,this.g<=0){this.g=F*.5;let x,le=0;for(const[te,ue]of this.f)(!x||le<ue)&&(x=te,le=ue);console.warn(`[${this.name}] potential listener LEAK detected, having ${W} listeners already. MOST frequent listener (${le}):`),console.warn(x)}return()=>{const x=this.f.get(R.value)||0;this.f.set(R.value,x-1)}}}class v{static create(){return new v(new Error().stack??"")}constructor(R){this.value=R}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class ${constructor(R){this.value=R,this.id=w++}}const f=2,l=(O,R)=>{if(O instanceof $)R(O);else for(let W=0;W<O.length;W++){const F=O[W];F&&R(F)}},d=E?new FinalizationRegistry(O=>{typeof O=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(O))}):void 0;class a{constructor(R){this.w=0,this.f=R,this.g=k>0||this.f?.leakWarningThreshold?new m(this.f?.leakWarningThreshold??k):void 0,this.j=this.f?._profName?new y(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(h){const R=this.t;queueMicrotask(()=>{l(R,W=>W.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(R,W,F)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),P.$Uc.None;if(this.m)return P.$Uc.None;W&&(R=R.bind(W));const q=new $(R);let x,le;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(q.stack=v.create(),x=this.g.check(q.stack,this.w+1)),h&&(q.stack=le??v.create()),this.t?this.t instanceof $?(this.u??=new o,this.t=[this.t,q]):this.t.push(q):(this.f?.onWillAddFirstListener?.(this),this.t=q,this.f?.onDidAddFirstListener?.(this)),this.w++;const te=(0,P.$Sc)(()=>{d?.unregister(te),x?.(),this.x(q)});if(F instanceof P.$Tc?F.add(te):Array.isArray(F)&&F.push(te),d){const ue=new Error().stack.split(`
`).slice(2).join(`
`).trim();d.register(te,ue,te)}return te},this.q}x(R){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const W=this.t,F=W.indexOf(R);if(F===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,W[F]=void 0;const q=this.u.current===this;if(this.w*f<=W.length){let x=0;for(let le=0;le<W.length;le++)W[le]?W[x++]=W[le]:q&&(this.u.end--,x<this.u.i&&this.u.i--);W.length=x}}y(R,W){if(!R)return;const F=this.f?.onListenerError||n.$1;if(!F){R.value(W);return}try{R.value(W)}catch(q){F(q)}}z(R){const W=R.current.t;for(;R.i<R.end;)this.y(W[R.i++],R.value);R.reset()}fire(R){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof $)this.y(this.t,R);else{const W=this.u;W.enqueue(this,R,this.t.length),this.z(W)}this.j?.stop()}hasListeners(){return this.w>0}}e.$7d=a;const t=()=>new o;e.$8d=t;class o{constructor(){this.i=-1,this.end=0}enqueue(R,W,F){this.i=0,this.end=F,this.current=R,this.value=W}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class r extends a{async fireAsync(R,W,F){if(this.t)for(this.h||(this.h=new M.$5c),l(this.t,q=>this.h.push([q.value,R]));this.h.size>0&&!W.isCancellationRequested;){const[q,x]=this.h.shift(),le=[],te={...x,token:W,waitUntil:ue=>{if(Object.isFrozen(le))throw new Error("waitUntil can NOT be called asynchronous");F&&(ue=F(ue,q)),le.push(ue)}};try{q(te)}catch(ue){(0,n.$1)(ue);continue}Object.freeze(le),await Promise.allSettled(le).then(ue=>{for(const Y of ue)Y.status==="rejected"&&(0,n.$1)(Y.reason)})}}}e.$9d=r;class i extends a{get isPaused(){return this.h!==0}constructor(R){super(R),this.h=0,this.s=new M.$5c,this.A=R?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const R=Array.from(this.s);this.s.clear(),super.fire(this.A(R))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(R){this.w&&(this.h!==0?this.s.push(R):super.fire(R))}}e.$0d=i;class s extends i{constructor(R){super(R),this.k=R.delay??100}fire(R){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(R)}}e.$$d=s;class u extends a{constructor(R){super(R),this.h=[],this.k=R?.merge}fire(R){this.hasListeners()&&(this.h.push(R),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(W=>super.fire(W)),this.h=[]}))}}e.$_d=u;class b{constructor(){this.g=!1,this.h=[],this.f=new a({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(R){const W={event:R,listener:null};this.h.push(W),this.g&&this.m(W);const F=()=>{this.g&&this.o(W);const q=this.h.indexOf(W);this.h.splice(q,1)};return(0,P.$Sc)((0,j.$db)(F))}j(){this.g=!0,this.h.forEach(R=>this.m(R))}k(){this.g=!1,this.h.forEach(R=>this.o(R))}m(R){R.listener=R.event(W=>this.f.fire(W))}o(R){R.listener?.dispose(),R.listener=null}dispose(){this.f.dispose();for(const R of this.h)R.listener?.dispose();this.h=[]}}e.$ae=b;class C{constructor(R,W,F,q){this.f=new P.$Tc;const x=this.f.add(new b),le=this.f.add(new P.$4c);function te(ue){le.set(ue,x.add(q(ue)))}for(const ue of R)te(ue);this.f.add(W(ue=>{te(ue)})),this.f.add(F(ue=>{le.deleteAndDispose(ue)})),this.event=x.event}dispose(){this.f.dispose()}}e.$be=C;class I{constructor(){this.f=[]}wrapEvent(R){return(W,F,q)=>R(x=>{const le=this.f[this.f.length-1];le?le.push(()=>W.call(F,x)):W.call(F,x)},void 0,q)}bufferEvents(R){const W=[];this.f.push(W);const F=R();return this.f.pop(),W.forEach(q=>q()),F}}e.$ce=I;class D{constructor(){this.f=!1,this.g=p.None,this.h=P.$Uc.None,this.j=new a({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(R){this.g=R,this.f&&(this.h.dispose(),this.h=R(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$de=D}),define(oe[23],ae([0,1,3]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.CancellationToken=void 0;const j=Object.freeze(function(E,h){const c=setTimeout(E.bind(h),0);return{dispose(){clearTimeout(c)}}});var P;(function(E){function h(c){return c===E.None||c===E.Cancelled||c instanceof M?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}E.isCancellationToken=h,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:j})})(P||(e.CancellationToken=P={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?j:(this.b||(this.b=new n.$7d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class S{constructor(h){this.f=void 0,this.g=void 0,this.g=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=P.Cancelled}dispose(h=!1){h&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=P.None}}e.$ee=S}),define(oe[143],ae([0,1,23]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Re=e.$Qe=e.$Pe=void 0;class j{constructor(E){this.b=E,this.a=null}get(){if(this.a)return this.a;const E=new n.$ee,h=this.b(E.token);return this.a={promise:h,dispose:()=>{this.a=null,E.cancel(),E.dispose()}},this.a}}e.$Pe=j;class P{constructor(E){this.c=E,this.a=void 0,this.b=void 0}get(E){const h=JSON.stringify(E);return this.b!==h&&(this.b=h,this.a=this.c(E)),this.a}}e.$Qe=P;class M{get cachedValues(){return this.a}constructor(E){this.b=E,this.a=new Map}get(E){if(this.a.has(E))return this.a.get(E);const h=this.b(E);return this.a.set(E,h),h}}e.$Re=M}),define(oe[63],ae([0,1,15,2]),function(K,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=P,e.$ge=M,e.$he=S,e.$ie=E,e.$je=c,e.$ke=p,e.$le=y,e.$me=k,e.$ne=g,e.$oe=m,e.$pe=v,e.$qe=w,e.$re=$,e.$se=f,e.$te=l;function P(d){const a=d;return a?typeof a.read=="function":!1}function M(d){const a=d;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}function S(d){const a=d;return a?M(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}function E(d,a){return new h(d,a)}class h{constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,n.$1)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let o;switch(a){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const r=o.indexOf(t);r>=0&&o.splice(r,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(d,a){const t=[];let o;for(;(o=d.read())!==null;)t.push(o);return a(t)}function p(d,a,t){const o=[];let r;for(;(r=d.read())!==null&&o.length<t;)o.push(r);return r===null&&o.length>0?a(o):{read:()=>{if(o.length>0)return o.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return d.read()}}}function y(d,a){return new Promise((t,o)=>{const r=[];k(d,{onData:i=>{a&&r.push(i)},onError:i=>{a?o(i):t(void 0)},onEnd:()=>{t(a?a(r):void 0)}})})}function k(d,a,t){d.on("error",o=>{t?.isCancellationRequested||a.onError(o)}),d.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),d.on("data",o=>{t?.isCancellationRequested||a.onData(o)})}function g(d,a){return new Promise((t,o)=>{const r=new j.$Tc,i=[],s=C=>{if(i.push(C),i.length>a)return r.dispose(),d.pause(),t({stream:d,buffer:i,ended:!1})},u=C=>(r.dispose(),o(C)),b=()=>(r.dispose(),t({stream:d,buffer:i,ended:!0}));r.add((0,j.$Sc)(()=>d.removeListener("error",u))),d.on("error",u),r.add((0,j.$Sc)(()=>d.removeListener("end",b))),d.on("end",b),r.add((0,j.$Sc)(()=>d.removeListener("data",s))),d.on("data",s)})}function m(d,a){const t=E(a);return t.end(d),t}function v(){const d=E(()=>{throw new Error("not supported")});return d.end(),d}function w(d){let a=!1;return{read:()=>a?null:(a=!0,d)}}function $(d,a,t){const o=E(t);return k(d,{onData:r=>o.write(a.data(r)),onError:r=>o.error(a.error?a.error(r):r),onEnd:()=>o.end()}),o}function f(d,a,t){let o=!1;return{read:()=>{const r=a.read();return o?r:(o=!0,r!==null?t([d,r]):d)}}}function l(d,a,t){let o=!1;const r=E(t);return k(a,{onData:i=>o?r.write(i):(o=!0,r.write(t([d,i]))),onError:i=>r.error(i),onEnd:()=>{o||(o=!0,r.write(d)),r.end()}}),r}}),define(oe[17],ae([0,1,62,63]),function(K,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=void 0,e.$ve=c,e.$we=p,e.$xe=y,e.$ye=k,e.$ze=g,e.$Ae=m,e.$Be=v,e.$Ce=w,e.$De=$,e.$Ee=f,e.$Fe=l,e.$Ge=d,e.$He=a,e.$Ie=t,e.$Je=o,e.$Ke=r,e.$Le=i,e.$Me=s,e.$Ne=u,e.$Oe=I;const P=typeof Buffer<"u",M=new n.$V(()=>new Uint8Array(256));let S,E;class h{static alloc(O){return P?new h(Buffer.allocUnsafe(O)):new h(new Uint8Array(O))}static wrap(O){return P&&!Buffer.isBuffer(O)&&(O=Buffer.from(O.buffer,O.byteOffset,O.byteLength)),new h(O)}static fromString(O,R){return!(R?.dontUseNodeBuffer||!1)&&P?new h(Buffer.from(O)):(S||(S=new TextEncoder),new h(S.encode(O)))}static fromByteArray(O){const R=h.alloc(O.length);for(let W=0,F=O.length;W<F;W++)R.buffer[W]=O[W];return R}static concat(O,R){if(typeof R>"u"){R=0;for(let q=0,x=O.length;q<x;q++)R+=O[q].byteLength}const W=h.alloc(R);let F=0;for(let q=0,x=O.length;q<x;q++){const le=O[q];W.set(le,F),F+=le.byteLength}return W}constructor(O){this.buffer=O,this.byteLength=this.buffer.byteLength}clone(){const O=h.alloc(this.byteLength);return O.set(this),O}toString(){return P?this.buffer.toString():(E||(E=new TextDecoder),E.decode(this.buffer))}slice(O,R){return new h(this.buffer.subarray(O,R))}set(O,R){if(O instanceof h)this.buffer.set(O.buffer,R);else if(O instanceof Uint8Array)this.buffer.set(O,R);else if(O instanceof ArrayBuffer)this.buffer.set(new Uint8Array(O),R);else if(ArrayBuffer.isView(O))this.buffer.set(new Uint8Array(O.buffer,O.byteOffset,O.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(O){return k(this.buffer,O)}writeUInt32BE(O,R){g(this.buffer,O,R)}readUInt32LE(O){return m(this.buffer,O)}writeUInt32LE(O,R){v(this.buffer,O,R)}readUInt8(O){return w(this.buffer,O)}writeUInt8(O,R){$(this.buffer,O,R)}indexOf(O,R=0){return c(this.buffer,O instanceof h?O.buffer:O,R)}}e.$ue=h;function c(D,O,R=0){const W=O.byteLength,F=D.byteLength;if(W===0)return 0;if(W===1)return D.indexOf(O[0]);if(W>F-R)return-1;const q=M.value;q.fill(O.length);for(let ue=0;ue<O.length;ue++)q[O[ue]]=O.length-ue-1;let x=R+O.length-1,le=x,te=-1;for(;x<F;)if(D[x]===O[le]){if(le===0){te=x;break}x--,le--}else x+=Math.max(O.length-le,q[D[x]]),le=O.length-1;return te}function p(D,O){return D[O+0]<<0>>>0|D[O+1]<<8>>>0}function y(D,O,R){D[R+0]=O&255,O=O>>>8,D[R+1]=O&255}function k(D,O){return D[O]*2**24+D[O+1]*2**16+D[O+2]*2**8+D[O+3]}function g(D,O,R){D[R+3]=O,O=O>>>8,D[R+2]=O,O=O>>>8,D[R+1]=O,O=O>>>8,D[R]=O}function m(D,O){return D[O+0]<<0>>>0|D[O+1]<<8>>>0|D[O+2]<<16>>>0|D[O+3]<<24>>>0}function v(D,O,R){D[R+0]=O&255,O=O>>>8,D[R+1]=O&255,O=O>>>8,D[R+2]=O&255,O=O>>>8,D[R+3]=O&255}function w(D,O){return D[O]}function $(D,O,R){D[R]=O}function f(D){return j.$je(D,O=>h.concat(O))}function l(D){return j.$qe(D)}function d(D){return j.$le(D,O=>h.concat(O))}async function a(D){return D.ended?h.concat(D.buffer):h.concat([...D.buffer,await d(D.stream)])}function t(D){return j.$oe(D,O=>h.concat(O))}function o(D){return j.$re(D,{data:O=>typeof O=="string"?h.fromString(O):h.wrap(O)},O=>h.concat(O))}function r(D){return j.$ie(O=>h.concat(O),D)}function i(D,O){return j.$se(D,O,R=>h.concat(R))}function s(D,O){return j.$te(D,O,R=>h.concat(R))}function u(D){let O=0,R=0,W=0;const F=new Uint8Array(Math.floor(D.length/4*3)),q=le=>{switch(R){case 3:F[W++]=O|le,R=0;break;case 2:F[W++]=O|le>>>2,O=le<<6,R=3;break;case 1:F[W++]=O|le>>>4,O=le<<4,R=2;break;default:O=le<<2,R=1}};for(let le=0;le<D.length;le++){const te=D.charCodeAt(le);if(te>=65&&te<=90)q(te-65);else if(te>=97&&te<=122)q(te-97+26);else if(te>=48&&te<=57)q(te-48+52);else if(te===43||te===45)q(62);else if(te===47||te===95)q(63);else{if(te===61)break;throw new SyntaxError(`Unexpected base64 character ${D[le]}`)}}const x=W;for(;R>0;)q(0);return h.wrap(F).slice(0,x)}const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:D},O=!0,R=!1){const W=R?C:b;let F="";const q=D.byteLength%3;let x=0;for(;x<D.byteLength-q;x+=3){const le=D[x+0],te=D[x+1],ue=D[x+2];F+=W[le>>>2],F+=W[(le<<4|te>>>4)&63],F+=W[(te<<2|ue>>>6)&63],F+=W[ue&63]}if(q===1){const le=D[x+0];F+=W[le>>>2],F+=W[le<<4&63],O&&(F+="==")}else if(q===2){const le=D[x+0],te=D[x+1];F+=W[le>>>2],F+=W[(le<<4|te>>>4)&63],F+=W[te<<2&63],O&&(F+="=")}return F}}),define(oe[25],ae([0,1,143,62]),function(K,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uf=e.$Tf=e.$Sf=e.GraphemeBreakType=e.$If=e.$Bf=e.$uf=e.$tf=void 0,e.$Ue=P,e.$Ve=S,e.$We=h,e.$Xe=c,e.$Ye=p,e.$Ze=y,e.$1e=k,e.$2e=g,e.$3e=m,e.$4e=v,e.$5e=w,e.$6e=$,e.$7e=f,e.$8e=l,e.$9e=d,e.$0e=a,e.$$e=t,e.$_e=o,e.$af=r,e.$bf=i,e.$cf=s,e.$df=u,e.$ef=b,e.$ff=C,e.$gf=I,e.$hf=D,e.$if=O,e.$jf=R,e.$kf=W,e.$lf=F,e.$mf=q,e.$nf=x,e.$of=le,e.$pf=te,e.$qf=ue,e.$rf=Y,e.$sf=Z,e.$vf=G,e.$wf=z,e.$xf=ce,e.$yf=he,e.$zf=N,e.$Af=se,e.$Cf=J,e.$Df=V,e.$Ef=H,e.$Ff=U,e.$Gf=ee,e.$Hf=fe,e.$Jf=me,e.$Kf=ve,e.$Lf=ke,e.$Mf=je,e.$Nf=Fe,e.$Of=ye,e.$Pf=Q,e.$Qf=de,e.$Rf=Me;function P(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}const M=/{(\d+)}/g;function S(ie,...ge){return ge.length===0?ie:ie.replace(M,function(we,be){const Pe=parseInt(be,10);return isNaN(Pe)||Pe<0||Pe>=ge.length?we:ge[Pe]})}const E=/{([^}]+)}/g;function h(ie,ge){return Object.keys(ge).length===0?ie:ie.replace(E,(we,be)=>ge[be]??we)}function c(ie){return ie.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function p(ie){return ie.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function y(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function k(ie,ge){let we=0;const be=ge.charCodeAt(0);for(let Pe=ie.length-1;Pe>=0;Pe--)ie.charCodeAt(Pe)===be&&we++;return we}function g(ie,ge,we="\u2026"){return ie.length<=ge?ie:`${ie.substr(0,ge)}${we}`}function m(ie,ge,we="\u2026"){if(ie.length<=ge)return ie;const be=Math.ceil(ge/2)-we.length/2,Pe=Math.floor(ge/2)-we.length/2;return`${ie.substr(0,be)}${we}${ie.substr(ie.length-Pe)}`}function v(ie,ge=" "){const we=w(ie,ge);return $(we,ge)}function w(ie,ge){if(!ie||!ge)return ie;const we=ge.length;if(we===0||ie.length===0)return ie;let be=0;for(;ie.indexOf(ge,be)===be;)be=be+we;return ie.substring(be)}function $(ie,ge){if(!ie||!ge)return ie;const we=ge.length,be=ie.length;if(we===0||be===0)return ie;let Pe=be,Ae=-1;for(;Ae=ie.lastIndexOf(ge,Pe-1),!(Ae===-1||Ae+we!==Pe);){if(Ae===0)return"";Pe=Ae}return ie.substring(0,Pe)}function f(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function l(ie){return ie.replace(/\*/g,"")}function d(ie,ge,we={}){if(!ie)throw new Error("Cannot create regex from empty string");ge||(ie=y(ie)),we.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let be="";return we.global&&(be+="g"),we.matchCase||(be+="i"),we.multiline&&(be+="m"),we.unicode&&(be+="u"),new RegExp(ie,be)}function a(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}function t(ie){return ie.split(/\r\n|\r|\n/)}function o(ie){const ge=[],we=ie.split(/(\r\n|\r|\n)/);for(let be=0;be<Math.ceil(we.length/2);be++)ge.push(we[2*be]+(we[2*be+1]??""));return ge}function r(ie){for(let ge=0,we=ie.length;ge<we;ge++){const be=ie.charCodeAt(ge);if(be!==32&&be!==9)return ge}return-1}function i(ie,ge=0,we=ie.length){for(let be=ge;be<we;be++){const Pe=ie.charCodeAt(be);if(Pe!==32&&Pe!==9)return ie.substring(ge,be)}return ie.substring(ge,we)}function s(ie,ge=ie.length-1){for(let we=ge;we>=0;we--){const be=ie.charCodeAt(we);if(be!==32&&be!==9)return we}return-1}function u(ie,ge,we){const be=[];let Pe=0;for(const Ae of ie.matchAll(ge)){if(be.push(ie.slice(Pe,Ae.index)),Ae.index===void 0)throw new Error("match.index should be defined");Pe=Ae.index+Ae[0].length,be.push(we(Ae[0],...Ae.slice(1),Ae.index,ie,Ae.groups))}return be.push(ie.slice(Pe)),Promise.all(be).then(Ae=>Ae.join(""))}function b(ie,ge){return ie<ge?-1:ie>ge?1:0}function C(ie,ge,we=0,be=ie.length,Pe=0,Ae=ge.length){for(;we<be&&Pe<Ae;we++,Pe++){const Qe=ie.charCodeAt(we),Ye=ge.charCodeAt(Pe);if(Qe<Ye)return-1;if(Qe>Ye)return 1}const ze=be-we,Je=Ae-Pe;return ze<Je?-1:ze>Je?1:0}function I(ie,ge){return D(ie,ge,0,ie.length,0,ge.length)}function D(ie,ge,we=0,be=ie.length,Pe=0,Ae=ge.length){for(;we<be&&Pe<Ae;we++,Pe++){let Qe=ie.charCodeAt(we),Ye=ge.charCodeAt(Pe);if(Qe===Ye)continue;if(Qe>=128||Ye>=128)return C(ie.toLowerCase(),ge.toLowerCase(),we,be,Pe,Ae);R(Qe)&&(Qe-=32),R(Ye)&&(Ye-=32);const Ze=Qe-Ye;if(Ze!==0)return Ze}const ze=be-we,Je=Ae-Pe;return ze<Je?-1:ze>Je?1:0}function O(ie){return ie>=48&&ie<=57}function R(ie){return ie>=97&&ie<=122}function W(ie){return ie>=65&&ie<=90}function F(ie,ge){return ie.length===ge.length&&D(ie,ge)===0}function q(ie,ge){const we=ge.length;return ge.length>ie.length?!1:D(ie,ge,0,we)===0}function x(ie,ge){const we=Math.min(ie.length,ge.length);let be;for(be=0;be<we;be++)if(ie.charCodeAt(be)!==ge.charCodeAt(be))return be;return we}function le(ie,ge){const we=Math.min(ie.length,ge.length);let be;const Pe=ie.length-1,Ae=ge.length-1;for(be=0;be<we;be++)if(ie.charCodeAt(Pe-be)!==ge.charCodeAt(Ae-be))return be;return we}function te(ie){return 55296<=ie&&ie<=56319}function ue(ie){return 56320<=ie&&ie<=57343}function Y(ie,ge){return(ie-55296<<10)+(ge-56320)+65536}function Z(ie,ge,we){const be=ie.charCodeAt(we);if(te(be)&&we+1<ge){const Pe=ie.charCodeAt(we+1);if(ue(Pe))return Y(be,Pe)}return be}function B(ie,ge){const we=ie.charCodeAt(ge-1);if(ue(we)&&ge>1){const be=ie.charCodeAt(ge-2);if(te(be))return Y(be,we)}return we}class L{get offset(){return this.e}constructor(ge,we=0){this.c=ge,this.d=ge.length,this.e=we}setOffset(ge){this.e=ge}prevCodePoint(){const ge=B(this.c,this.e);return this.e-=ge>=65536?2:1,ge}nextCodePoint(){const ge=Z(this.c,this.d,this.e);return this.e+=ge>=65536?2:1,ge}eol(){return this.e>=this.d}}e.$tf=L;class T{get offset(){return this.c.offset}constructor(ge,we=0){this.c=new L(ge,we)}nextGraphemeLength(){const ge=Re.getInstance(),we=this.c,be=we.offset;let Pe=ge.getGraphemeBreakType(we.nextCodePoint());for(;!we.eol();){const Ae=we.offset,ze=ge.getGraphemeBreakType(we.nextCodePoint());if($e(Pe,ze)){we.setOffset(Ae);break}Pe=ze}return we.offset-be}prevGraphemeLength(){const ge=Re.getInstance(),we=this.c,be=we.offset;let Pe=ge.getGraphemeBreakType(we.prevCodePoint());for(;we.offset>0;){const Ae=we.offset,ze=ge.getGraphemeBreakType(we.prevCodePoint());if($e(ze,Pe)){we.setOffset(Ae);break}Pe=ze}return be-we.offset}eol(){return this.c.eol()}}e.$uf=T;function G(ie,ge){return new T(ie,ge).nextGraphemeLength()}function z(ie,ge){return new T(ie,ge).prevGraphemeLength()}function ce(ie,ge){ge>0&&ue(ie.charCodeAt(ge))&&ge--;const we=ge+G(ie,ge);return[we-z(ie,we),we]}function he(ie){const ge=new T(ie);let we=0;for(;!ge.eol();)we++,ge.nextGraphemeLength();return we}let X;function A(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function N(ie){return X||(X=A()),X.test(ie)}const _=/^[\t\n\r\x20-\x7E]*$/;function se(ie){return _.test(ie)}e.$Bf=/[\u2028\u2029]/;function J(ie){return e.$Bf.test(ie)}function V(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}function H(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}function U(ie,ge,we=""){const be=ie.trimStart();if(be.length<ge)return be;const Pe=/\b/g;let Ae=0;for(;Pe.test(be)&&!(be.length-Pe.lastIndex<ge);)Ae=Pe.lastIndex,Pe.lastIndex+=1;return Ae===0?be:we+be.substring(Ae).trimStart()}const re=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*ee(ie){let ge=0;for(const we of ie.matchAll(re))ge!==we.index&&(yield{isCode:!1,str:ie.substring(ge,we.index)}),yield{isCode:!0,str:we[0]},ge=we.index+we[0].length;ge!==ie.length&&(yield{isCode:!1,str:ie.substring(ge)})}function fe(ie){return ie&&(ie=ie.replace(re,"")),ie}e.$If="\uFEFF";function me(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}function ve(ie){return me(ie)?ie.substr(1):ie}function ke(ie,ge){if(!ie||!ge||ie.length<ge.length)return!1;const we=ge.length,be=ie.toLowerCase();let Pe=0,Ae=-1;for(;Pe<we;){const ze=be.indexOf(ge[Pe],Ae+1);if(ze<0)return!1;Ae=ze,Pe++}return!0}function je(ie,ge=!1){return ie?(ge&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}function Fe(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}function ye(ie,ge=1){if(ge===0)return"";let we=-1;do we=ie.indexOf(`
`,we+1),ge--;while(ge>0&&we>=0);return we===-1?ie:(ie[we-1]==="\r"&&we--,ie.substr(0,we))}function Q(ie){return ie=ie%(2*26),ie<26?String.fromCharCode(97+ie):String.fromCharCode(65+ie-26)}function de(ie){return Re.getInstance().getGraphemeBreakType(ie)}function $e(ie,ge){return ie===0?ge!==5&&ge!==7:ie===2&&ge===3?!1:ie===4||ie===2||ie===3||ge===4||ge===2||ge===3?!0:!(ie===8&&(ge===8||ge===9||ge===11||ge===12)||(ie===11||ie===9)&&(ge===9||ge===10)||(ie===12||ie===10)&&ge===10||ge===5||ge===13||ge===7||ie===1||ie===13&&ge===14||ie===6&&ge===6)}var Se;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(Se||(e.GraphemeBreakType=Se={}));class Re{static{this.c=null}static getInstance(){return Re.c||(Re.c=new Re),Re.c}constructor(){this.d=qe()}getGraphemeBreakType(ge){if(ge<32)return ge===10?3:ge===13?2:4;if(ge<127)return 0;const we=this.d,be=we.length/3;let Pe=1;for(;Pe<=be;)if(ge<we[3*Pe])Pe=2*Pe;else if(ge>we[3*Pe+1])Pe=2*Pe+1;else return we[3*Pe+2];return 0}}function qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Me(ie,ge){if(ie===0)return 0;const we=Le(ie,ge);if(we!==void 0)return we;const be=new L(ge,ie);return be.prevCodePoint(),be.offset}function Le(ie,ge){const we=new L(ge,ie);let be=we.prevCodePoint();for(;Ve(be)||be===65039||be===8419;){if(we.offset===0)return;be=we.prevCodePoint()}if(!H(be))return;let Pe=we.offset;return Pe>0&&we.prevCodePoint()===8205&&(Pe=we.offset),Pe}function Ve(ie){return 127995<=ie&&ie<=127999}var xe;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(xe||(xe={})),e.$Sf="\xA0";class Xe{static{this.c=new j.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new n.$Qe(ge=>{function we(Ze){const st=new Map;for(let tt=0;tt<Ze.length;tt+=2)st.set(Ze[tt],Ze[tt+1]);return st}function be(Ze,st){const tt=new Map(Ze);for(const[ot,at]of st)tt.set(ot,at);return tt}function Pe(Ze,st){if(!Ze)return st;const tt=new Map;for(const[ot,at]of Ze)st.has(ot)&&tt.set(ot,at);return tt}const Ae=this.c.value;let ze=ge.filter(Ze=>!Ze.startsWith("_")&&Ze in Ae);ze.length===0&&(ze=["_default"]);let Je;for(const Ze of ze){const st=we(Ae[Ze]);Je=Pe(Je,st)}const Qe=we(Ae._common),Ye=be(Qe,Je);return new Xe(Ye)})}static getInstance(ge){return Xe.d.get(Array.from(ge))}static{this.e=new j.$V(()=>Object.keys(Xe.c.value).filter(ge=>!ge.startsWith("_")))}static getLocales(){return Xe.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Tf=Xe;class Te{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Te.c())),this.d}static isInvisibleCharacter(ge){return Te.e().has(ge)}static get codePoints(){return Te.e()}}e.$Uf=Te}),define(oe[46],ae([0,1,25]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.$aj=void 0,e.$9i=j,e.$0i=P,e.$$i=M,e.$_i=E,e.$bj=v;function j($){return P($,0)}function P($,f){switch(typeof $){case"object":return $===null?M(349,f):Array.isArray($)?h($,f):c($,f);case"string":return E($,f);case"boolean":return S($,f);case"number":return M($,f);case"undefined":return M(937,f);default:return M(617,f)}}function M($,f){return(f<<5)-f+$|0}function S($,f){return M($?433:863,f)}function E($,f){f=M(149417,f);for(let l=0,d=$.length;l<d;l++)f=M($.charCodeAt(l),f);return f}function h($,f){return f=M(104579,f),$.reduce((l,d)=>P(d,l),f)}function c($,f){return f=M(181387,f),Object.keys($).sort().reduce((l,d)=>(l=E(d,l),P($[d],l)),f)}class p{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=P(f,this.g),this.g}}e.$aj=p;var y;(function($){$[$.BLOCK_SIZE=64]="BLOCK_SIZE",$[$.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function k($,f,l=32){const d=l-f,a=~((1<<d)-1);return($<<f|(a&$)>>>d)>>>0}function g($,f=0,l=$.byteLength,d=0){for(let a=0;a<l;a++)$[f+a]=d}function m($,f,l="0"){for(;$.length<f;)$=l+$;return $}function v($,f=32){return $ instanceof ArrayBuffer?Array.from(new Uint8Array($)).map(l=>l.toString(16).padStart(2,"0")).join(""):m(($>>>0).toString(16),f/4)}class w{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const l=f.length;if(l===0)return;const d=this.p;let a=this.r,t=this.u,o,r;for(t!==0?(o=t,r=-1,t=0):(o=f.charCodeAt(0),r=0);;){let i=o;if(n.$pf(o))if(r+1<l){const s=f.charCodeAt(r+1);n.$qf(s)?(r++,i=n.$rf(o,s)):i=65533}else{t=o;break}else n.$qf(o)&&(i=65533);if(a=this.w(d,a,i),r++,r<l)o=f.charCodeAt(r);else break}this.r=a,this.u=t}w(f,l,d){return d<128?f[l++]=d:d<2048?(f[l++]=192|(d&1984)>>>6,f[l++]=128|(d&63)>>>0):d<65536?(f[l++]=224|(d&61440)>>>12,f[l++]=128|(d&4032)>>>6,f[l++]=128|(d&63)>>>0):(f[l++]=240|(d&1835008)>>>18,f[l++]=128|(d&258048)>>>12,f[l++]=128|(d&4032)>>>6,f[l++]=128|(d&63)>>>0),l>=64&&(this.y(),l-=64,this.t+=64,f[0]=f[64],f[1]=f[65],f[2]=f[66]),l}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,g(this.p,this.r),this.r>56&&(this.y(),g(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=w.g,l=this.q;for(let b=0;b<64;b+=4)f.setUint32(b,l.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)f.setUint32(b,k(f.getUint32(b-12,!1)^f.getUint32(b-32,!1)^f.getUint32(b-56,!1)^f.getUint32(b-64,!1),1),!1);let d=this.h,a=this.l,t=this.m,o=this.n,r=this.o,i,s,u;for(let b=0;b<80;b++)b<20?(i=a&t|~a&o,s=1518500249):b<40?(i=a^t^o,s=1859775393):b<60?(i=a&t|a&o|t&o,s=2400959708):(i=a^t^o,s=3395469782),u=k(d,5)+i+r+s+f.getUint32(b*4,!1)&4294967295,r=o,o=t,t=k(a,30),a=d,d=u;this.h=this.h+d&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+r&4294967295}}e.$cj=w}),define(oe[73],ae([0,1,25]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var j;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(j||(j={})),function(P){const M="error",S="warning",E="warn",h="info",c="ignore";function p(k){return k?n.$lf(M,k)?P.Error:n.$lf(S,k)||n.$lf(E,k)?P.Warning:n.$lf(h,k)?P.Info:P.Ignore:P.Ignore}P.fromValue=p;function y(k){switch(k){case P.Error:return M;case P.Warning:return S;case P.Info:return h;default:return c}}P.toString=y}(j||(j={})),e.default=j}),define(oe[144],ae([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=void 0,e.$4d=Symbol("MicrotaskDelay")}),define(oe[59],ae([0,1,22,25]),function(K,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.$ki=void 0;class P{constructor(){this.b="",this.c=0}reset(g){return this.b=g,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(g){const m=g.charCodeAt(0),v=this.b.charCodeAt(this.c);return m-v}value(){return this.b[this.c]}}e.$ki=P;class M{constructor(g=!0){this.e=g}reset(g){return this.b=g,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let g=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(g)this.c++;else break;else g=!1;return this}cmp(g){return this.e?(0,j.$ff)(g,this.b,0,g.length,this.c,this.d):(0,j.$hf)(g,this.b,0,g.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$li=M;class S{constructor(g=!0,m=!0){this.f=g,this.g=m}reset(g){this.d=0,this.e=0,this.b=g,this.c=g.length;for(let m=g.length-1;m>=0;m--,this.c--){const v=this.b.charCodeAt(m);if(!(v===47||this.f&&v===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let g=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(g)this.d++;else break;else g=!1}return this}cmp(g){return this.g?(0,j.$ff)(g,this.b,0,g.length,this.d,this.e):(0,j.$hf)(g,this.b,0,g.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$mi=S;var E;(function(k){k[k.Scheme=1]="Scheme",k[k.Authority=2]="Authority",k[k.Path=3]="Path",k[k.Query=4]="Query",k[k.Fragment=5]="Fragment"})(E||(E={}));class h{constructor(g,m){this.f=g,this.g=m,this.d=[],this.e=0}reset(g){return this.c=g,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new S(!1,!this.f(g)),this.b.reset(g.path),this.b.value()&&this.d.push(3)),this.g(g)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(g){if(this.d[this.e]===1)return(0,j.$gf)(g,this.c.scheme);if(this.d[this.e]===2)return(0,j.$gf)(g,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(g);if(this.d[this.e]===4)return(0,j.$ef)(g,this.c.query);if(this.d[this.e]===5)return(0,j.$ef)(g,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ni=h;class c{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const g=this.right;return this.right=g.left,g.left=this,this.updateHeight(),g.updateHeight(),g}rotateRight(){const g=this.left;return this.left=g.right,g.right=this,this.updateHeight(),g.updateHeight(),g}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(k){k[k.Left=-1]="Left",k[k.Mid=0]="Mid",k[k.Right=1]="Right"})(p||(p={}));class y{static forUris(g=()=>!1,m=()=>!1){return new y(new h(g,m))}static forPaths(g=!1){return new y(new S(void 0,!g))}static forStrings(){return new y(new P)}static forConfigKeys(){return new y(new M)}constructor(g){this.b=g}clear(){this.c=void 0}fill(g,m){if(m){const v=m.slice(0);(0,n.$Xb)(v);for(const w of v)this.set(w,g)}else{const v=g.slice(0);(0,n.$Xb)(v);for(const w of v)this.set(w[0],w[1])}}set(g,m){const v=this.b.reset(g);let w;this.c||(this.c=new c,this.c.segment=v.value());const $=[];for(w=this.c;;){const l=v.cmp(w.segment);if(l>0)w.left||(w.left=new c,w.left.segment=v.value()),$.push([-1,w]),w=w.left;else if(l<0)w.right||(w.right=new c,w.right.segment=v.value()),$.push([1,w]),w=w.right;else if(v.hasNext())v.next(),w.mid||(w.mid=new c,w.mid.segment=v.value()),$.push([0,w]),w=w.mid;else break}const f=w.value;w.value=m,w.key=g;for(let l=$.length-1;l>=0;l--){const d=$[l][1];d.updateHeight();const a=d.balanceFactor();if(a<-1||a>1){const t=$[l][0],o=$[l+1][0];if(t===1&&o===1)$[l][1]=d.rotateLeft();else if(t===-1&&o===-1)$[l][1]=d.rotateRight();else if(t===1&&o===-1)d.right=$[l+1][1]=$[l+1][1].rotateRight(),$[l][1]=d.rotateLeft();else if(t===-1&&o===1)d.left=$[l+1][1]=$[l+1][1].rotateLeft(),$[l][1]=d.rotateRight();else throw new Error;if(l>0)switch($[l-1][0]){case-1:$[l-1][1].left=$[l][1];break;case 1:$[l-1][1].right=$[l][1];break;case 0:$[l-1][1].mid=$[l][1];break}else this.c=$[0][1]}}return f}get(g){return this.d(g)?.value}d(g){const m=this.b.reset(g);let v=this.c;for(;v;){const w=m.cmp(v.segment);if(w>0)v=v.left;else if(w<0)v=v.right;else if(m.hasNext())m.next(),v=v.mid;else break}return v}has(g){const m=this.d(g);return!(m?.value===void 0&&m?.mid===void 0)}delete(g){return this.e(g,!1)}deleteSuperstr(g){return this.e(g,!0)}e(g,m){const v=this.b.reset(g),w=[];let $=this.c;for(;$;){const f=v.cmp($.segment);if(f>0)w.push([-1,$]),$=$.left;else if(f<0)w.push([1,$]),$=$.right;else if(v.hasNext())v.next(),w.push([0,$]),$=$.mid;else break}if($){if(m?($.left=void 0,$.mid=void 0,$.right=void 0,$.height=1):($.key=void 0,$.value=void 0),!$.mid&&!$.value)if($.left&&$.right){const f=this.f($.right);if(f.key){const{key:l,value:d,segment:a}=f;this.e(f.key,!1),$.key=l,$.value=d,$.segment=a}}else{const f=$.left??$.right;if(w.length>0){const[l,d]=w[w.length-1];switch(l){case-1:d.left=f;break;case 0:d.mid=f;break;case 1:d.right=f;break}}else this.c=f}for(let f=w.length-1;f>=0;f--){const l=w[f][1];l.updateHeight();const d=l.balanceFactor();if(d>1?(l.right.balanceFactor()>=0||(l.right=l.right.rotateRight()),w[f][1]=l.rotateLeft()):d<-1&&(l.left.balanceFactor()<=0||(l.left=l.left.rotateLeft()),w[f][1]=l.rotateRight()),f>0)switch(w[f-1][0]){case-1:w[f-1][1].left=w[f][1];break;case 1:w[f-1][1].right=w[f][1];break;case 0:w[f-1][1].mid=w[f][1];break}else this.c=w[0][1]}}}f(g){for(;g.left;)g=g.left;return g}findSubstr(g){const m=this.b.reset(g);let v=this.c,w;for(;v;){const $=m.cmp(v.segment);if($>0)v=v.left;else if($<0)v=v.right;else if(m.hasNext())m.next(),w=v.value||w,v=v.mid;else break}return v&&v.value||w}findSuperstr(g){return this.g(g,!1)}g(g,m){const v=this.b.reset(g);let w=this.c;for(;w;){const $=v.cmp(w.segment);if($>0)w=w.left;else if($<0)w=w.right;else if(v.hasNext())v.next(),w=w.mid;else return w.mid?this.h(w.mid):m?w.value:void 0}}hasElementOrSubtree(g){return this.g(g,!0)!==void 0}forEach(g){for(const[m,v]of this)g(v,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(g){const m=[];return this.j(g,m),m[Symbol.iterator]()}j(g,m){g&&(g.left&&this.j(g.left,m),g.value&&m.push([g.key,g.value]),g.mid&&this.j(g.mid,m),g.right&&this.j(g.right,m))}_isBalanced(){const g=m=>{if(!m)return!0;const v=m.balanceFactor();return v<-1||v>1?!1:g(m.left)&&g(m.right)};return g(this.c)}}e.$oi=y}),define(oe[12],ae([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vf=n,e.$Wf=j,e.$Xf=P,e.$Yf=M,e.$Zf=S,e.$1f=E,e.$2f=h,e.$3f=c,e.$4f=p,e.$5f=y,e.$6f=k,e.$7f=g,e.$8f=m,e.$9f=w,e.$0f=$,e.$$f=f,e.$_f=l,e.$ag=d;function n(a){return typeof a=="string"}function j(a){return Array.isArray(a)&&a.every(t=>n(t))}function P(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}function M(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}function S(a){return typeof a=="number"&&!isNaN(a)}function E(a){return!!a&&typeof a[Symbol.iterator]=="function"}function h(a){return a===!0||a===!1}function c(a){return typeof a>"u"}function p(a){return!y(a)}function y(a){return c(a)||a===null}function k(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function g(a){if(y(a))throw new Error("Assertion Failed: argument is undefined or null");return a}function m(...a){const t=[];for(let o=0;o<a.length;o++){const r=a[o];if(y(r))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(r)}return t}const v=Object.prototype.hasOwnProperty;function w(a){if(!P(a))return!1;for(const t in a)if(v.call(a,t))return!1;return!0}function $(a){return typeof a=="function"}function f(...a){return a.length>0&&a.every($)}function l(a,t){const o=Math.min(a.length,t.length);for(let r=0;r<o;r++)d(a[r],t[r])}function d(a,t){if(n(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if($(t)){try{if(a instanceof t)return}catch{}if(!y(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(oe[105],ae([0,1,12]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=P,e.$Dj=M;const j=Object.create(null);function P(S,E){if((0,n.$Vf)(E)){const h=j[E];if(h===void 0)throw new Error(`${S} references an unknown codicon: ${E}`);E=h}return j[S]=E,{id:S}}function M(){return j}}),define(oe[145],ae([0,1,105]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=void 0,e.$Ej={add:(0,n.$Cj)("add",6e4),plus:(0,n.$Cj)("plus",6e4),gistNew:(0,n.$Cj)("gist-new",6e4),repoCreate:(0,n.$Cj)("repo-create",6e4),lightbulb:(0,n.$Cj)("lightbulb",60001),lightBulb:(0,n.$Cj)("light-bulb",60001),repo:(0,n.$Cj)("repo",60002),repoDelete:(0,n.$Cj)("repo-delete",60002),gistFork:(0,n.$Cj)("gist-fork",60003),repoForked:(0,n.$Cj)("repo-forked",60003),gitPullRequest:(0,n.$Cj)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.$Cj)("git-pull-request-abandoned",60004),recordKeys:(0,n.$Cj)("record-keys",60005),keyboard:(0,n.$Cj)("keyboard",60005),tag:(0,n.$Cj)("tag",60006),gitPullRequestLabel:(0,n.$Cj)("git-pull-request-label",60006),tagAdd:(0,n.$Cj)("tag-add",60006),tagRemove:(0,n.$Cj)("tag-remove",60006),person:(0,n.$Cj)("person",60007),personFollow:(0,n.$Cj)("person-follow",60007),personOutline:(0,n.$Cj)("person-outline",60007),personFilled:(0,n.$Cj)("person-filled",60007),gitBranch:(0,n.$Cj)("git-branch",60008),gitBranchCreate:(0,n.$Cj)("git-branch-create",60008),gitBranchDelete:(0,n.$Cj)("git-branch-delete",60008),sourceControl:(0,n.$Cj)("source-control",60008),mirror:(0,n.$Cj)("mirror",60009),mirrorPublic:(0,n.$Cj)("mirror-public",60009),star:(0,n.$Cj)("star",60010),starAdd:(0,n.$Cj)("star-add",60010),starDelete:(0,n.$Cj)("star-delete",60010),starEmpty:(0,n.$Cj)("star-empty",60010),comment:(0,n.$Cj)("comment",60011),commentAdd:(0,n.$Cj)("comment-add",60011),alert:(0,n.$Cj)("alert",60012),warning:(0,n.$Cj)("warning",60012),search:(0,n.$Cj)("search",60013),searchSave:(0,n.$Cj)("search-save",60013),logOut:(0,n.$Cj)("log-out",60014),signOut:(0,n.$Cj)("sign-out",60014),logIn:(0,n.$Cj)("log-in",60015),signIn:(0,n.$Cj)("sign-in",60015),eye:(0,n.$Cj)("eye",60016),eyeUnwatch:(0,n.$Cj)("eye-unwatch",60016),eyeWatch:(0,n.$Cj)("eye-watch",60016),circleFilled:(0,n.$Cj)("circle-filled",60017),primitiveDot:(0,n.$Cj)("primitive-dot",60017),closeDirty:(0,n.$Cj)("close-dirty",60017),debugBreakpoint:(0,n.$Cj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.$Cj)("debug-breakpoint-disabled",60017),debugHint:(0,n.$Cj)("debug-hint",60017),terminalDecorationSuccess:(0,n.$Cj)("terminal-decoration-success",60017),primitiveSquare:(0,n.$Cj)("primitive-square",60018),edit:(0,n.$Cj)("edit",60019),pencil:(0,n.$Cj)("pencil",60019),info:(0,n.$Cj)("info",60020),issueOpened:(0,n.$Cj)("issue-opened",60020),gistPrivate:(0,n.$Cj)("gist-private",60021),gitForkPrivate:(0,n.$Cj)("git-fork-private",60021),lock:(0,n.$Cj)("lock",60021),mirrorPrivate:(0,n.$Cj)("mirror-private",60021),close:(0,n.$Cj)("close",60022),removeClose:(0,n.$Cj)("remove-close",60022),x:(0,n.$Cj)("x",60022),repoSync:(0,n.$Cj)("repo-sync",60023),sync:(0,n.$Cj)("sync",60023),clone:(0,n.$Cj)("clone",60024),desktopDownload:(0,n.$Cj)("desktop-download",60024),beaker:(0,n.$Cj)("beaker",60025),microscope:(0,n.$Cj)("microscope",60025),vm:(0,n.$Cj)("vm",60026),deviceDesktop:(0,n.$Cj)("device-desktop",60026),file:(0,n.$Cj)("file",60027),fileText:(0,n.$Cj)("file-text",60027),more:(0,n.$Cj)("more",60028),ellipsis:(0,n.$Cj)("ellipsis",60028),kebabHorizontal:(0,n.$Cj)("kebab-horizontal",60028),mailReply:(0,n.$Cj)("mail-reply",60029),reply:(0,n.$Cj)("reply",60029),organization:(0,n.$Cj)("organization",60030),organizationFilled:(0,n.$Cj)("organization-filled",60030),organizationOutline:(0,n.$Cj)("organization-outline",60030),newFile:(0,n.$Cj)("new-file",60031),fileAdd:(0,n.$Cj)("file-add",60031),newFolder:(0,n.$Cj)("new-folder",60032),fileDirectoryCreate:(0,n.$Cj)("file-directory-create",60032),trash:(0,n.$Cj)("trash",60033),trashcan:(0,n.$Cj)("trashcan",60033),history:(0,n.$Cj)("history",60034),clock:(0,n.$Cj)("clock",60034),folder:(0,n.$Cj)("folder",60035),fileDirectory:(0,n.$Cj)("file-directory",60035),symbolFolder:(0,n.$Cj)("symbol-folder",60035),logoGithub:(0,n.$Cj)("logo-github",60036),markGithub:(0,n.$Cj)("mark-github",60036),github:(0,n.$Cj)("github",60036),terminal:(0,n.$Cj)("terminal",60037),console:(0,n.$Cj)("console",60037),repl:(0,n.$Cj)("repl",60037),zap:(0,n.$Cj)("zap",60038),symbolEvent:(0,n.$Cj)("symbol-event",60038),error:(0,n.$Cj)("error",60039),stop:(0,n.$Cj)("stop",60039),variable:(0,n.$Cj)("variable",60040),symbolVariable:(0,n.$Cj)("symbol-variable",60040),array:(0,n.$Cj)("array",60042),symbolArray:(0,n.$Cj)("symbol-array",60042),symbolModule:(0,n.$Cj)("symbol-module",60043),symbolPackage:(0,n.$Cj)("symbol-package",60043),symbolNamespace:(0,n.$Cj)("symbol-namespace",60043),symbolObject:(0,n.$Cj)("symbol-object",60043),symbolMethod:(0,n.$Cj)("symbol-method",60044),symbolFunction:(0,n.$Cj)("symbol-function",60044),symbolConstructor:(0,n.$Cj)("symbol-constructor",60044),symbolBoolean:(0,n.$Cj)("symbol-boolean",60047),symbolNull:(0,n.$Cj)("symbol-null",60047),symbolNumeric:(0,n.$Cj)("symbol-numeric",60048),symbolNumber:(0,n.$Cj)("symbol-number",60048),symbolStructure:(0,n.$Cj)("symbol-structure",60049),symbolStruct:(0,n.$Cj)("symbol-struct",60049),symbolParameter:(0,n.$Cj)("symbol-parameter",60050),symbolTypeParameter:(0,n.$Cj)("symbol-type-parameter",60050),symbolKey:(0,n.$Cj)("symbol-key",60051),symbolText:(0,n.$Cj)("symbol-text",60051),symbolReference:(0,n.$Cj)("symbol-reference",60052),goToFile:(0,n.$Cj)("go-to-file",60052),symbolEnum:(0,n.$Cj)("symbol-enum",60053),symbolValue:(0,n.$Cj)("symbol-value",60053),symbolRuler:(0,n.$Cj)("symbol-ruler",60054),symbolUnit:(0,n.$Cj)("symbol-unit",60054),activateBreakpoints:(0,n.$Cj)("activate-breakpoints",60055),archive:(0,n.$Cj)("archive",60056),arrowBoth:(0,n.$Cj)("arrow-both",60057),arrowDown:(0,n.$Cj)("arrow-down",60058),arrowLeft:(0,n.$Cj)("arrow-left",60059),arrowRight:(0,n.$Cj)("arrow-right",60060),arrowSmallDown:(0,n.$Cj)("arrow-small-down",60061),arrowSmallLeft:(0,n.$Cj)("arrow-small-left",60062),arrowSmallRight:(0,n.$Cj)("arrow-small-right",60063),arrowSmallUp:(0,n.$Cj)("arrow-small-up",60064),arrowUp:(0,n.$Cj)("arrow-up",60065),bell:(0,n.$Cj)("bell",60066),bold:(0,n.$Cj)("bold",60067),book:(0,n.$Cj)("book",60068),bookmark:(0,n.$Cj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.$Cj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.$Cj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.$Cj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.$Cj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.$Cj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.$Cj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.$Cj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.$Cj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.$Cj)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.$Cj)("briefcase",60076),broadcast:(0,n.$Cj)("broadcast",60077),browser:(0,n.$Cj)("browser",60078),bug:(0,n.$Cj)("bug",60079),calendar:(0,n.$Cj)("calendar",60080),caseSensitive:(0,n.$Cj)("case-sensitive",60081),check:(0,n.$Cj)("check",60082),checklist:(0,n.$Cj)("checklist",60083),chevronDown:(0,n.$Cj)("chevron-down",60084),chevronLeft:(0,n.$Cj)("chevron-left",60085),chevronRight:(0,n.$Cj)("chevron-right",60086),chevronUp:(0,n.$Cj)("chevron-up",60087),chromeClose:(0,n.$Cj)("chrome-close",60088),chromeMaximize:(0,n.$Cj)("chrome-maximize",60089),chromeMinimize:(0,n.$Cj)("chrome-minimize",60090),chromeRestore:(0,n.$Cj)("chrome-restore",60091),circleOutline:(0,n.$Cj)("circle-outline",60092),circle:(0,n.$Cj)("circle",60092),debugBreakpointUnverified:(0,n.$Cj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.$Cj)("terminal-decoration-incomplete",60092),circleSlash:(0,n.$Cj)("circle-slash",60093),circuitBoard:(0,n.$Cj)("circuit-board",60094),clearAll:(0,n.$Cj)("clear-all",60095),clippy:(0,n.$Cj)("clippy",60096),closeAll:(0,n.$Cj)("close-all",60097),cloudDownload:(0,n.$Cj)("cloud-download",60098),cloudUpload:(0,n.$Cj)("cloud-upload",60099),code:(0,n.$Cj)("code",60100),collapseAll:(0,n.$Cj)("collapse-all",60101),colorMode:(0,n.$Cj)("color-mode",60102),commentDiscussion:(0,n.$Cj)("comment-discussion",60103),creditCard:(0,n.$Cj)("credit-card",60105),dash:(0,n.$Cj)("dash",60108),dashboard:(0,n.$Cj)("dashboard",60109),database:(0,n.$Cj)("database",60110),debugContinue:(0,n.$Cj)("debug-continue",60111),debugDisconnect:(0,n.$Cj)("debug-disconnect",60112),debugPause:(0,n.$Cj)("debug-pause",60113),debugRestart:(0,n.$Cj)("debug-restart",60114),debugStart:(0,n.$Cj)("debug-start",60115),debugStepInto:(0,n.$Cj)("debug-step-into",60116),debugStepOut:(0,n.$Cj)("debug-step-out",60117),debugStepOver:(0,n.$Cj)("debug-step-over",60118),debugStop:(0,n.$Cj)("debug-stop",60119),debug:(0,n.$Cj)("debug",60120),deviceCameraVideo:(0,n.$Cj)("device-camera-video",60121),deviceCamera:(0,n.$Cj)("device-camera",60122),deviceMobile:(0,n.$Cj)("device-mobile",60123),diffAdded:(0,n.$Cj)("diff-added",60124),diffIgnored:(0,n.$Cj)("diff-ignored",60125),diffModified:(0,n.$Cj)("diff-modified",60126),diffRemoved:(0,n.$Cj)("diff-removed",60127),diffRenamed:(0,n.$Cj)("diff-renamed",60128),diff:(0,n.$Cj)("diff",60129),diffSidebyside:(0,n.$Cj)("diff-sidebyside",60129),discard:(0,n.$Cj)("discard",60130),editorLayout:(0,n.$Cj)("editor-layout",60131),emptyWindow:(0,n.$Cj)("empty-window",60132),exclude:(0,n.$Cj)("exclude",60133),extensions:(0,n.$Cj)("extensions",60134),eyeClosed:(0,n.$Cj)("eye-closed",60135),fileBinary:(0,n.$Cj)("file-binary",60136),fileCode:(0,n.$Cj)("file-code",60137),fileMedia:(0,n.$Cj)("file-media",60138),filePdf:(0,n.$Cj)("file-pdf",60139),fileSubmodule:(0,n.$Cj)("file-submodule",60140),fileSymlinkDirectory:(0,n.$Cj)("file-symlink-directory",60141),fileSymlinkFile:(0,n.$Cj)("file-symlink-file",60142),fileZip:(0,n.$Cj)("file-zip",60143),files:(0,n.$Cj)("files",60144),filter:(0,n.$Cj)("filter",60145),flame:(0,n.$Cj)("flame",60146),foldDown:(0,n.$Cj)("fold-down",60147),foldUp:(0,n.$Cj)("fold-up",60148),fold:(0,n.$Cj)("fold",60149),folderActive:(0,n.$Cj)("folder-active",60150),folderOpened:(0,n.$Cj)("folder-opened",60151),gear:(0,n.$Cj)("gear",60152),gift:(0,n.$Cj)("gift",60153),gistSecret:(0,n.$Cj)("gist-secret",60154),gist:(0,n.$Cj)("gist",60155),gitCommit:(0,n.$Cj)("git-commit",60156),gitCompare:(0,n.$Cj)("git-compare",60157),compareChanges:(0,n.$Cj)("compare-changes",60157),gitMerge:(0,n.$Cj)("git-merge",60158),githubAction:(0,n.$Cj)("github-action",60159),githubAlt:(0,n.$Cj)("github-alt",60160),globe:(0,n.$Cj)("globe",60161),grabber:(0,n.$Cj)("grabber",60162),graph:(0,n.$Cj)("graph",60163),gripper:(0,n.$Cj)("gripper",60164),heart:(0,n.$Cj)("heart",60165),home:(0,n.$Cj)("home",60166),horizontalRule:(0,n.$Cj)("horizontal-rule",60167),hubot:(0,n.$Cj)("hubot",60168),inbox:(0,n.$Cj)("inbox",60169),issueReopened:(0,n.$Cj)("issue-reopened",60171),issues:(0,n.$Cj)("issues",60172),italic:(0,n.$Cj)("italic",60173),jersey:(0,n.$Cj)("jersey",60174),json:(0,n.$Cj)("json",60175),kebabVertical:(0,n.$Cj)("kebab-vertical",60176),key:(0,n.$Cj)("key",60177),law:(0,n.$Cj)("law",60178),lightbulbAutofix:(0,n.$Cj)("lightbulb-autofix",60179),linkExternal:(0,n.$Cj)("link-external",60180),link:(0,n.$Cj)("link",60181),listOrdered:(0,n.$Cj)("list-ordered",60182),listUnordered:(0,n.$Cj)("list-unordered",60183),liveShare:(0,n.$Cj)("live-share",60184),loading:(0,n.$Cj)("loading",60185),location:(0,n.$Cj)("location",60186),mailRead:(0,n.$Cj)("mail-read",60187),mail:(0,n.$Cj)("mail",60188),markdown:(0,n.$Cj)("markdown",60189),megaphone:(0,n.$Cj)("megaphone",60190),mention:(0,n.$Cj)("mention",60191),milestone:(0,n.$Cj)("milestone",60192),gitPullRequestMilestone:(0,n.$Cj)("git-pull-request-milestone",60192),mortarBoard:(0,n.$Cj)("mortar-board",60193),move:(0,n.$Cj)("move",60194),multipleWindows:(0,n.$Cj)("multiple-windows",60195),mute:(0,n.$Cj)("mute",60196),noNewline:(0,n.$Cj)("no-newline",60197),note:(0,n.$Cj)("note",60198),octoface:(0,n.$Cj)("octoface",60199),openPreview:(0,n.$Cj)("open-preview",60200),package:(0,n.$Cj)("package",60201),paintcan:(0,n.$Cj)("paintcan",60202),pin:(0,n.$Cj)("pin",60203),play:(0,n.$Cj)("play",60204),run:(0,n.$Cj)("run",60204),plug:(0,n.$Cj)("plug",60205),preserveCase:(0,n.$Cj)("preserve-case",60206),preview:(0,n.$Cj)("preview",60207),project:(0,n.$Cj)("project",60208),pulse:(0,n.$Cj)("pulse",60209),question:(0,n.$Cj)("question",60210),quote:(0,n.$Cj)("quote",60211),radioTower:(0,n.$Cj)("radio-tower",60212),reactions:(0,n.$Cj)("reactions",60213),references:(0,n.$Cj)("references",60214),refresh:(0,n.$Cj)("refresh",60215),regex:(0,n.$Cj)("regex",60216),remoteExplorer:(0,n.$Cj)("remote-explorer",60217),remote:(0,n.$Cj)("remote",60218),remove:(0,n.$Cj)("remove",60219),replaceAll:(0,n.$Cj)("replace-all",60220),replace:(0,n.$Cj)("replace",60221),repoClone:(0,n.$Cj)("repo-clone",60222),repoForcePush:(0,n.$Cj)("repo-force-push",60223),repoPull:(0,n.$Cj)("repo-pull",60224),repoPush:(0,n.$Cj)("repo-push",60225),report:(0,n.$Cj)("report",60226),requestChanges:(0,n.$Cj)("request-changes",60227),rocket:(0,n.$Cj)("rocket",60228),rootFolderOpened:(0,n.$Cj)("root-folder-opened",60229),rootFolder:(0,n.$Cj)("root-folder",60230),rss:(0,n.$Cj)("rss",60231),ruby:(0,n.$Cj)("ruby",60232),saveAll:(0,n.$Cj)("save-all",60233),saveAs:(0,n.$Cj)("save-as",60234),save:(0,n.$Cj)("save",60235),screenFull:(0,n.$Cj)("screen-full",60236),screenNormal:(0,n.$Cj)("screen-normal",60237),searchStop:(0,n.$Cj)("search-stop",60238),server:(0,n.$Cj)("server",60240),settingsGear:(0,n.$Cj)("settings-gear",60241),settings:(0,n.$Cj)("settings",60242),shield:(0,n.$Cj)("shield",60243),smiley:(0,n.$Cj)("smiley",60244),sortPrecedence:(0,n.$Cj)("sort-precedence",60245),splitHorizontal:(0,n.$Cj)("split-horizontal",60246),splitVertical:(0,n.$Cj)("split-vertical",60247),squirrel:(0,n.$Cj)("squirrel",60248),starFull:(0,n.$Cj)("star-full",60249),starHalf:(0,n.$Cj)("star-half",60250),symbolClass:(0,n.$Cj)("symbol-class",60251),symbolColor:(0,n.$Cj)("symbol-color",60252),symbolConstant:(0,n.$Cj)("symbol-constant",60253),symbolEnumMember:(0,n.$Cj)("symbol-enum-member",60254),symbolField:(0,n.$Cj)("symbol-field",60255),symbolFile:(0,n.$Cj)("symbol-file",60256),symbolInterface:(0,n.$Cj)("symbol-interface",60257),symbolKeyword:(0,n.$Cj)("symbol-keyword",60258),symbolMisc:(0,n.$Cj)("symbol-misc",60259),symbolOperator:(0,n.$Cj)("symbol-operator",60260),symbolProperty:(0,n.$Cj)("symbol-property",60261),wrench:(0,n.$Cj)("wrench",60261),wrenchSubaction:(0,n.$Cj)("wrench-subaction",60261),symbolSnippet:(0,n.$Cj)("symbol-snippet",60262),tasklist:(0,n.$Cj)("tasklist",60263),telescope:(0,n.$Cj)("telescope",60264),textSize:(0,n.$Cj)("text-size",60265),threeBars:(0,n.$Cj)("three-bars",60266),thumbsdown:(0,n.$Cj)("thumbsdown",60267),thumbsup:(0,n.$Cj)("thumbsup",60268),tools:(0,n.$Cj)("tools",60269),triangleDown:(0,n.$Cj)("triangle-down",60270),triangleLeft:(0,n.$Cj)("triangle-left",60271),triangleRight:(0,n.$Cj)("triangle-right",60272),triangleUp:(0,n.$Cj)("triangle-up",60273),twitter:(0,n.$Cj)("twitter",60274),unfold:(0,n.$Cj)("unfold",60275),unlock:(0,n.$Cj)("unlock",60276),unmute:(0,n.$Cj)("unmute",60277),unverified:(0,n.$Cj)("unverified",60278),verified:(0,n.$Cj)("verified",60279),versions:(0,n.$Cj)("versions",60280),vmActive:(0,n.$Cj)("vm-active",60281),vmOutline:(0,n.$Cj)("vm-outline",60282),vmRunning:(0,n.$Cj)("vm-running",60283),watch:(0,n.$Cj)("watch",60284),whitespace:(0,n.$Cj)("whitespace",60285),wholeWord:(0,n.$Cj)("whole-word",60286),window:(0,n.$Cj)("window",60287),wordWrap:(0,n.$Cj)("word-wrap",60288),zoomIn:(0,n.$Cj)("zoom-in",60289),zoomOut:(0,n.$Cj)("zoom-out",60290),listFilter:(0,n.$Cj)("list-filter",60291),listFlat:(0,n.$Cj)("list-flat",60292),listSelection:(0,n.$Cj)("list-selection",60293),selection:(0,n.$Cj)("selection",60293),listTree:(0,n.$Cj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.$Cj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.$Cj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.$Cj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.$Cj)("debug-stackframe-active",60297),circleSmallFilled:(0,n.$Cj)("circle-small-filled",60298),debugStackframeDot:(0,n.$Cj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.$Cj)("terminal-decoration-mark",60298),debugStackframe:(0,n.$Cj)("debug-stackframe",60299),debugStackframeFocused:(0,n.$Cj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.$Cj)("debug-breakpoint-unsupported",60300),symbolString:(0,n.$Cj)("symbol-string",60301),debugReverseContinue:(0,n.$Cj)("debug-reverse-continue",60302),debugStepBack:(0,n.$Cj)("debug-step-back",60303),debugRestartFrame:(0,n.$Cj)("debug-restart-frame",60304),debugAlt:(0,n.$Cj)("debug-alt",60305),callIncoming:(0,n.$Cj)("call-incoming",60306),callOutgoing:(0,n.$Cj)("call-outgoing",60307),menu:(0,n.$Cj)("menu",60308),expandAll:(0,n.$Cj)("expand-all",60309),feedback:(0,n.$Cj)("feedback",60310),gitPullRequestReviewer:(0,n.$Cj)("git-pull-request-reviewer",60310),groupByRefType:(0,n.$Cj)("group-by-ref-type",60311),ungroupByRefType:(0,n.$Cj)("ungroup-by-ref-type",60312),account:(0,n.$Cj)("account",60313),gitPullRequestAssignee:(0,n.$Cj)("git-pull-request-assignee",60313),bellDot:(0,n.$Cj)("bell-dot",60314),debugConsole:(0,n.$Cj)("debug-console",60315),library:(0,n.$Cj)("library",60316),output:(0,n.$Cj)("output",60317),runAll:(0,n.$Cj)("run-all",60318),syncIgnored:(0,n.$Cj)("sync-ignored",60319),pinned:(0,n.$Cj)("pinned",60320),githubInverted:(0,n.$Cj)("github-inverted",60321),serverProcess:(0,n.$Cj)("server-process",60322),serverEnvironment:(0,n.$Cj)("server-environment",60323),pass:(0,n.$Cj)("pass",60324),issueClosed:(0,n.$Cj)("issue-closed",60324),stopCircle:(0,n.$Cj)("stop-circle",60325),playCircle:(0,n.$Cj)("play-circle",60326),record:(0,n.$Cj)("record",60327),debugAltSmall:(0,n.$Cj)("debug-alt-small",60328),vmConnect:(0,n.$Cj)("vm-connect",60329),cloud:(0,n.$Cj)("cloud",60330),merge:(0,n.$Cj)("merge",60331),export:(0,n.$Cj)("export",60332),graphLeft:(0,n.$Cj)("graph-left",60333),magnet:(0,n.$Cj)("magnet",60334),notebook:(0,n.$Cj)("notebook",60335),redo:(0,n.$Cj)("redo",60336),checkAll:(0,n.$Cj)("check-all",60337),pinnedDirty:(0,n.$Cj)("pinned-dirty",60338),passFilled:(0,n.$Cj)("pass-filled",60339),circleLargeFilled:(0,n.$Cj)("circle-large-filled",60340),circleLarge:(0,n.$Cj)("circle-large",60341),circleLargeOutline:(0,n.$Cj)("circle-large-outline",60341),combine:(0,n.$Cj)("combine",60342),gather:(0,n.$Cj)("gather",60342),table:(0,n.$Cj)("table",60343),variableGroup:(0,n.$Cj)("variable-group",60344),typeHierarchy:(0,n.$Cj)("type-hierarchy",60345),typeHierarchySub:(0,n.$Cj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.$Cj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.$Cj)("git-pull-request-create",60348),runAbove:(0,n.$Cj)("run-above",60349),runBelow:(0,n.$Cj)("run-below",60350),notebookTemplate:(0,n.$Cj)("notebook-template",60351),debugRerun:(0,n.$Cj)("debug-rerun",60352),workspaceTrusted:(0,n.$Cj)("workspace-trusted",60353),workspaceUntrusted:(0,n.$Cj)("workspace-untrusted",60354),workspaceUnknown:(0,n.$Cj)("workspace-unknown",60355),terminalCmd:(0,n.$Cj)("terminal-cmd",60356),terminalDebian:(0,n.$Cj)("terminal-debian",60357),terminalLinux:(0,n.$Cj)("terminal-linux",60358),terminalPowershell:(0,n.$Cj)("terminal-powershell",60359),terminalTmux:(0,n.$Cj)("terminal-tmux",60360),terminalUbuntu:(0,n.$Cj)("terminal-ubuntu",60361),terminalBash:(0,n.$Cj)("terminal-bash",60362),arrowSwap:(0,n.$Cj)("arrow-swap",60363),copy:(0,n.$Cj)("copy",60364),personAdd:(0,n.$Cj)("person-add",60365),filterFilled:(0,n.$Cj)("filter-filled",60366),wand:(0,n.$Cj)("wand",60367),debugLineByLine:(0,n.$Cj)("debug-line-by-line",60368),inspect:(0,n.$Cj)("inspect",60369),layers:(0,n.$Cj)("layers",60370),layersDot:(0,n.$Cj)("layers-dot",60371),layersActive:(0,n.$Cj)("layers-active",60372),compass:(0,n.$Cj)("compass",60373),compassDot:(0,n.$Cj)("compass-dot",60374),compassActive:(0,n.$Cj)("compass-active",60375),azure:(0,n.$Cj)("azure",60376),issueDraft:(0,n.$Cj)("issue-draft",60377),gitPullRequestClosed:(0,n.$Cj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.$Cj)("git-pull-request-draft",60379),debugAll:(0,n.$Cj)("debug-all",60380),debugCoverage:(0,n.$Cj)("debug-coverage",60381),runErrors:(0,n.$Cj)("run-errors",60382),folderLibrary:(0,n.$Cj)("folder-library",60383),debugContinueSmall:(0,n.$Cj)("debug-continue-small",60384),beakerStop:(0,n.$Cj)("beaker-stop",60385),graphLine:(0,n.$Cj)("graph-line",60386),graphScatter:(0,n.$Cj)("graph-scatter",60387),pieChart:(0,n.$Cj)("pie-chart",60388),bracket:(0,n.$Cj)("bracket",60175),bracketDot:(0,n.$Cj)("bracket-dot",60389),bracketError:(0,n.$Cj)("bracket-error",60390),lockSmall:(0,n.$Cj)("lock-small",60391),azureDevops:(0,n.$Cj)("azure-devops",60392),verifiedFilled:(0,n.$Cj)("verified-filled",60393),newline:(0,n.$Cj)("newline",60394),layout:(0,n.$Cj)("layout",60395),layoutActivitybarLeft:(0,n.$Cj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.$Cj)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.$Cj)("layout-panel-left",60398),layoutPanelCenter:(0,n.$Cj)("layout-panel-center",60399),layoutPanelJustify:(0,n.$Cj)("layout-panel-justify",60400),layoutPanelRight:(0,n.$Cj)("layout-panel-right",60401),layoutPanel:(0,n.$Cj)("layout-panel",60402),layoutSidebarLeft:(0,n.$Cj)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.$Cj)("layout-sidebar-right",60404),layoutStatusbar:(0,n.$Cj)("layout-statusbar",60405),layoutMenubar:(0,n.$Cj)("layout-menubar",60406),layoutCentered:(0,n.$Cj)("layout-centered",60407),target:(0,n.$Cj)("target",60408),indent:(0,n.$Cj)("indent",60409),recordSmall:(0,n.$Cj)("record-small",60410),errorSmall:(0,n.$Cj)("error-small",60411),terminalDecorationError:(0,n.$Cj)("terminal-decoration-error",60411),arrowCircleDown:(0,n.$Cj)("arrow-circle-down",60412),arrowCircleLeft:(0,n.$Cj)("arrow-circle-left",60413),arrowCircleRight:(0,n.$Cj)("arrow-circle-right",60414),arrowCircleUp:(0,n.$Cj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.$Cj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.$Cj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.$Cj)("layout-sidebar-left-off",60418),blank:(0,n.$Cj)("blank",60419),heartFilled:(0,n.$Cj)("heart-filled",60420),map:(0,n.$Cj)("map",60421),mapFilled:(0,n.$Cj)("map-filled",60422),circleSmall:(0,n.$Cj)("circle-small",60423),bellSlash:(0,n.$Cj)("bell-slash",60424),bellSlashDot:(0,n.$Cj)("bell-slash-dot",60425),commentUnresolved:(0,n.$Cj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.$Cj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.$Cj)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.$Cj)("search-fuzzy",60429),commentDraft:(0,n.$Cj)("comment-draft",60430),send:(0,n.$Cj)("send",60431),sparkle:(0,n.$Cj)("sparkle",60432),insert:(0,n.$Cj)("insert",60433),mic:(0,n.$Cj)("mic",60434),thumbsdownFilled:(0,n.$Cj)("thumbsdown-filled",60435),thumbsupFilled:(0,n.$Cj)("thumbsup-filled",60436),coffee:(0,n.$Cj)("coffee",60437),snake:(0,n.$Cj)("snake",60438),game:(0,n.$Cj)("game",60439),vr:(0,n.$Cj)("vr",60440),chip:(0,n.$Cj)("chip",60441),piano:(0,n.$Cj)("piano",60442),music:(0,n.$Cj)("music",60443),micFilled:(0,n.$Cj)("mic-filled",60444),repoFetch:(0,n.$Cj)("repo-fetch",60445),copilot:(0,n.$Cj)("copilot",60446),lightbulbSparkle:(0,n.$Cj)("lightbulb-sparkle",60447),robot:(0,n.$Cj)("robot",60448),sparkleFilled:(0,n.$Cj)("sparkle-filled",60449),diffSingle:(0,n.$Cj)("diff-single",60450),diffMultiple:(0,n.$Cj)("diff-multiple",60451),surroundWith:(0,n.$Cj)("surround-with",60452),share:(0,n.$Cj)("share",60453),gitStash:(0,n.$Cj)("git-stash",60454),gitStashApply:(0,n.$Cj)("git-stash-apply",60455),gitStashPop:(0,n.$Cj)("git-stash-pop",60456),vscode:(0,n.$Cj)("vscode",60457),vscodeInsiders:(0,n.$Cj)("vscode-insiders",60458),codeOss:(0,n.$Cj)("code-oss",60459),runCoverage:(0,n.$Cj)("run-coverage",60460),runAllCoverage:(0,n.$Cj)("run-all-coverage",60461),coverage:(0,n.$Cj)("coverage",60462),githubProject:(0,n.$Cj)("github-project",60463)}}),define(oe[74],ae([0,1,105,145]),function(K,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hj=e.$Gj=void 0,e.$Fj=P;function P(){return Object.values(e.$Hj)}e.$Gj={dialogError:(0,n.$Cj)("dialog-error","error"),dialogWarning:(0,n.$Cj)("dialog-warning","warning"),dialogInfo:(0,n.$Cj)("dialog-info","info"),dialogClose:(0,n.$Cj)("dialog-close","close"),treeItemExpanded:(0,n.$Cj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.$Cj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.$Cj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.$Cj)("tree-filter-clear","close"),treeItemLoading:(0,n.$Cj)("tree-item-loading","loading"),menuSelection:(0,n.$Cj)("menu-selection","check"),menuSubmenu:(0,n.$Cj)("menu-submenu","chevron-right"),menuBarMore:(0,n.$Cj)("menubar-more","more"),scrollbarButtonLeft:(0,n.$Cj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.$Cj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.$Cj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.$Cj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.$Cj)("toolbar-more","more"),quickInputBack:(0,n.$Cj)("quick-input-back","arrow-left"),dropDownButton:(0,n.$Cj)("drop-down-button",60084),symbolCustomColor:(0,n.$Cj)("symbol-customcolor",60252),exportIcon:(0,n.$Cj)("export",60332),workspaceUnspecified:(0,n.$Cj)("workspace-unspecified",60355),newLine:(0,n.$Cj)("newline",60394),thumbsDownFilled:(0,n.$Cj)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.$Cj)("thumbsup-filled",60436),gitFetch:(0,n.$Cj)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.$Cj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.$Cj)("debug-breakpoint-pending",60377)},e.$Hj={...j.$Ej,...e.$Gj}}),define(oe[35],ae([0,1,12]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=j,e.$Pn=P,e.$Qn=S,e.$Rn=h,e.$Sn=c,e.$Tn=p,e.$Un=y,e.$Vn=k,e.$Wn=g,e.$Xn=m,e.$Yn=v,e.$Zn=w;function j($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const f=Array.isArray($)?[]:{};return Object.entries($).forEach(([l,d])=>{f[l]=d&&typeof d=="object"?j(d):d}),f}function P($){if(!$||typeof $!="object")return $;const f=[$];for(;f.length>0;){const l=f.shift();Object.freeze(l);for(const d in l)if(M.call(l,d)){const a=l[d];typeof a=="object"&&!Object.isFrozen(a)&&!(0,n.$Yf)(a)&&f.push(a)}}return $}const M=Object.prototype.hasOwnProperty;function S($,f){return E($,f,new Set)}function E($,f,l){if((0,n.$5f)($))return $;const d=f($);if(typeof d<"u")return d;if(Array.isArray($)){const a=[];for(const t of $)a.push(E(t,f,l));return a}if((0,n.$Xf)($)){if(l.has($))throw new Error("Cannot clone recursive data-structure");l.add($);const a={};for(const t in $)M.call($,t)&&(a[t]=E($[t],f,l));return l.delete($),a}return $}function h($,f,l=!0){return(0,n.$Xf)($)?((0,n.$Xf)(f)&&Object.keys(f).forEach(d=>{d in $?l&&((0,n.$Xf)($[d])&&(0,n.$Xf)(f[d])?h($[d],f[d],l):$[d]=f[d]):$[d]=f[d]}),$):f}function c($,f){if($===f)return!0;if($==null||f===null||f===void 0||typeof $!=typeof f||typeof $!="object"||Array.isArray($)!==Array.isArray(f))return!1;let l,d;if(Array.isArray($)){if($.length!==f.length)return!1;for(l=0;l<$.length;l++)if(!c($[l],f[l]))return!1}else{const a=[];for(d in $)a.push(d);a.sort();const t=[];for(d in f)t.push(d);if(t.sort(),!c(a,t))return!1;for(l=0;l<a.length;l++)if(!c($[a[l]],f[a[l]]))return!1}return!0}function p($){const f=new Set;return JSON.stringify($,(l,d)=>{if((0,n.$Xf)(d)||Array.isArray(d)){if(f.has(d))return"[Circular]";f.add(d)}return d})}function y($,f){const l=Object.create(null);return!$||!f||Object.keys(f).forEach(a=>{const t=$[a],o=f[a];c(t,o)||(l[a]=o)}),l}function k($,f){const l=f.toLowerCase(),d=Object.keys($).find(a=>a.toLowerCase()===l);return d?$[d]:$[f]}function g($,f){const l=Object.create(null);for(const[d,a]of Object.entries($))f(d,a)&&(l[d]=a);return l}function m($){let f=[];for(;Object.prototype!==$;)f=f.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return f}function v($){const f=[];for(const l of m($))typeof $[l]=="function"&&f.push(l);return f}function w($,f){const l=a=>function(){const t=Array.prototype.slice.call(arguments,0);return f(a,t)},d={};for(const a of $)d[a]=l(a);return d}}),define(oe[106],ae([0,1,74]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Ij=P;var j;(function(S){function E(h){return h&&typeof h=="object"&&typeof h.id=="string"}S.isThemeColor=E})(j||(e.ThemeColor=j={}));function P(S){return{id:S}}var M;(function(S){S.iconNameSegment="[A-Za-z0-9]+",S.iconNameExpression="[A-Za-z0-9-]+",S.iconModifierExpression="~[A-Za-z]+",S.iconNameCharacter="[A-Za-z0-9~-]";const E=new RegExp(`^(${S.iconNameExpression})(${S.iconModifierExpression})?$`);function h(f){const l=E.exec(f.id);if(!l)return h(n.$Hj.error);const[,d,a]=l,t=["codicon","codicon-"+d];return a&&t.push("codicon-modifier-"+a.substring(1)),t}S.asClassNameArray=h;function c(f){return h(f).join(" ")}S.asClassName=c;function p(f){return"."+h(f).join(".")}S.asCSSSelector=p;function y(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color>"u"||j.isThemeColor(f.color))}S.isThemeIcon=y;const k=new RegExp(`^\\$\\((${S.iconNameExpression}(?:${S.iconModifierExpression})?)\\)$`);function g(f){const l=k.exec(f);if(!l)return;const[,d]=l;return{id:d}}S.fromString=g;function m(f){return{id:f}}S.fromId=m;function v(f,l){let d=f.id;const a=d.lastIndexOf("~");return a!==-1&&(d=d.substring(0,a)),l&&(d=`${d}~${l}`),{id:d}}S.modify=v;function w(f){const l=f.id.lastIndexOf("~");if(l!==-1)return f.id.substring(l+1)}S.getModifier=w;function $(f,l){return f.id===l.id&&f.color?.id===l.color?.id}S.isEqual=$})(M||(e.ThemeIcon=M={}))}),define(oe[33],ae([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=void 0,e.$Dg=j;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function j(P){return n.test(P)}e.$Eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(E){for(let h=0;h<E.length;h++)E[h]=Math.floor(Math.random()*256);return E};const M=new Uint8Array(16),S=[];for(let E=0;E<256;E++)S.push(E.toString(16).padStart(2,"0"));return function(){P(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let h=0,c="";return c+=S[M[h++]],c+=S[M[h++]],c+=S[M[h++]],c+=S[M[h++]],c+="-",c+=S[M[h++]],c+=S[M[h++]],c+="-",c+=S[M[h++]],c+=S[M[h++]],c+="-",c+=S[M[h++]],c+=S[M[h++]],c+="-",c+=S[M[h++]],c+=S[M[h++]],c+=S[M[h++]],c+=S[M[h++]],c+=S[M[h++]],c+=S[M[h++]],c}}()}),define(oe[146],ae([0,1,87,43,85]),function(K,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZV=M;async function M(S,E){if(await new Promise((p,y)=>{const k=j.createReadStream(S),g=n.createHash("sha256");k.pipe(g);const m=(0,P.$db)((v,w)=>{k.removeAllListeners(),g.removeAllListeners(),v?y(v):p(w)});k.once("error",m),k.once("end",m),g.once("error",m),g.once("data",v=>m(void 0,v.toString("hex")))})!==E)throw new Error("Hash mismatch")}}),define(oe[147],ae([0,1,26]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=M;const j=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function P(S){const E=S.replace(/\-/g,":").toLowerCase();return!j.has(E)}function M(){const S=(0,n.networkInterfaces)();for(const E in S){const h=S[E];if(h){for(const{mac:c}of h)if(P(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(oe[107],ae([0,1,88]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hg=void 0,e.$Gg=j,e.$Ig=M;function j(E,h,c,p=1){let y=!1;return new Promise(k=>{const g=setTimeout(()=>{if(!y)return y=!0,k(0)},c);P(E,h,p,m=>{if(!y)return y=!0,clearTimeout(g),k(m)})})}function P(E,h,c,p){if(h===0)return p(0);const y=new n.Socket;y.once("connect",()=>(S(y),P(E+c,h-1,c,p))),y.once("data",()=>{}),y.once("error",k=>(S(y),k.code!=="ECONNREFUSED"?P(E+c,h-1,c,p):p(E))),y.connect(E,"127.0.0.1")}e.$Hg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(E,h,c,p="127.0.0.1"){let y=!1,k,g=1;const m=n.createServer({pauseOnConnect:!0});function v(w,$){y||(y=!0,m.removeAllListeners(),m.close(),k&&clearTimeout(k),$(w))}return new Promise(w=>{k=setTimeout(()=>{v(0,w)},c),m.on("listening",()=>{v(E,w)}),m.on("error",$=>{$&&($.code==="EADDRINUSE"||$.code==="EACCES")&&g<h?(E++,g++,m.listen(E,p)):v(0,w)}),m.on("close",()=>{v(0,w)}),m.listen(E,p)})}function S(E){try{E.removeAllListeners("connect"),E.removeAllListeners("error"),E.end(),E.destroy(),E.unref()}catch(h){console.error(h)}}}),function(){function K(){function e(){return process.uncHostAllowlist}function n(h){const c=new Set;if(Array.isArray(h))for(const p of h)typeof p=="string"&&c.add(p);return Array.from(c)}function j(){const h=e();return h?Array.from(h):[]}function P(h){if(process.platform!=="win32")return;const c=e();if(c)if(typeof h=="string")c.add(h.toLowerCase());else for(const p of n(h))P(p)}function M(h){if(typeof h!="string")return;const c=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let p;for(const y of c){if(h.indexOf(y)!==0)continue;const g=h.indexOf("\\",y.length);if(g===-1)continue;const m=h.substring(y.length,g);if(m){p=m;break}}return p}function S(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function E(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:j,addUNCHostToAllowlist:P,getUNCHost:M,disableUNCAccessRestrictions:S,isUNCAccessRestrictionsDisabled:E}}typeof define=="function"?define("vs/base/node/unc",[],function(){return K()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=K():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(oe[148],ae([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4V=e.$3V=void 0,e.$3V="vscode:contextmenu",e.$4V="vscode:onCloseContextMenu"}),define(oe[149],ae([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$V=void 0;class n{constructor(P,M){this.a=P,this.onMessage=M}send(P){try{this.a.send("vscode:message",P.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$$V=n}),define(oe[150],ae([11,10]),function(K,e){return K.create("vs/base/common/date",e)}),define(oe[151],ae([0,1,150]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=c,e.$Om=p,e.$Pm=y;const j=60,P=j*60,M=P*24,S=M*7,E=M*30,h=M*365;function c(k,g,m,v){typeof k!="number"&&(k=k.getTime());const w=Math.round((new Date().getTime()-k)/1e3);if(w<-30)return(0,n.localize)(0,null,c(new Date().getTime()+w*1e3,!1));if(!v&&w<30)return(0,n.localize)(1,null);let $;return w<j?($=w,g?$===1?m?(0,n.localize)(2,null,$):(0,n.localize)(3,null,$):m?(0,n.localize)(4,null,$):(0,n.localize)(5,null,$):$===1?m?(0,n.localize)(6,null,$):(0,n.localize)(7,null,$):m?(0,n.localize)(8,null,$):(0,n.localize)(9,null,$)):w<P?($=Math.floor(w/j),g?$===1?m?(0,n.localize)(10,null,$):(0,n.localize)(11,null,$):m?(0,n.localize)(12,null,$):(0,n.localize)(13,null,$):$===1?m?(0,n.localize)(14,null,$):(0,n.localize)(15,null,$):m?(0,n.localize)(16,null,$):(0,n.localize)(17,null,$)):w<M?($=Math.floor(w/P),g?$===1?m?(0,n.localize)(18,null,$):(0,n.localize)(19,null,$):m?(0,n.localize)(20,null,$):(0,n.localize)(21,null,$):$===1?m?(0,n.localize)(22,null,$):(0,n.localize)(23,null,$):m?(0,n.localize)(24,null,$):(0,n.localize)(25,null,$)):w<S?($=Math.floor(w/M),g?$===1?(0,n.localize)(26,null,$):(0,n.localize)(27,null,$):$===1?(0,n.localize)(28,null,$):(0,n.localize)(29,null,$)):w<E?($=Math.floor(w/S),g?$===1?m?(0,n.localize)(30,null,$):(0,n.localize)(31,null,$):m?(0,n.localize)(32,null,$):(0,n.localize)(33,null,$):$===1?m?(0,n.localize)(34,null,$):(0,n.localize)(35,null,$):m?(0,n.localize)(36,null,$):(0,n.localize)(37,null,$)):w<h?($=Math.floor(w/E),g?$===1?m?(0,n.localize)(38,null,$):(0,n.localize)(39,null,$):m?(0,n.localize)(40,null,$):(0,n.localize)(41,null,$):$===1?m?(0,n.localize)(42,null,$):(0,n.localize)(43,null,$):m?(0,n.localize)(44,null,$):(0,n.localize)(45,null,$)):($=Math.floor(w/h),g?$===1?m?(0,n.localize)(46,null,$):(0,n.localize)(47,null,$):m?(0,n.localize)(48,null,$):(0,n.localize)(49,null,$):$===1?m?(0,n.localize)(50,null,$):(0,n.localize)(51,null,$):m?(0,n.localize)(52,null,$):(0,n.localize)(53,null,$))}function p(k,g){const m=Math.abs(k/1e3);return m<1?g?(0,n.localize)(54,null,k):(0,n.localize)(55,null,k):m<j?g?(0,n.localize)(56,null,Math.round(k)/1e3):(0,n.localize)(57,null,Math.round(k)/1e3):m<P?g?(0,n.localize)(58,null,Math.round(k/(1e3*j))):(0,n.localize)(59,null,Math.round(k/(1e3*j))):m<M?g?(0,n.localize)(60,null,Math.round(k/(1e3*P))):(0,n.localize)(61,null,Math.round(k/(1e3*P))):(0,n.localize)(62,null,Math.round(k/(1e3*M)))}function y(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(oe[152],ae([11,10]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(oe[47],ae([0,1,22,12,152]),function(K,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6i=h,e.$7i=c,e.$8i=p;function M(y,k){return k&&(y.stack||y.stacktrace)?P.localize(0,null,E(y),S(y.stack)||S(y.stacktrace)):E(y)}function S(y){return Array.isArray(y)?y.join(`
`):y}function E(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?P.localize(1,null,y.message):y.message||P.localize(2,null)}function h(y=null,k=!1){if(!y)return P.localize(3,null);if(Array.isArray(y)){const g=n.$Hb(y),m=h(g[0],k);return g.length>1?P.localize(4,null,m,g.length):m}if(j.$Vf(y))return y;if(y.detail){const g=y.detail;if(g.error)return M(g.error,k);if(g.exception)return M(g.exception,k)}return y.stack?M(y,k):y.message?y.message:P.localize(5,null)}function c(y){const k=y;return k instanceof Error&&Array.isArray(k.actions)}function p(y,k){let g;return typeof y=="string"?g=new Error(y):g=y,g.actions=k,g}}),define(oe[153],ae([11,10]),function(K,e){return K.create("vs/base/common/jsonErrorMessages",e)}),define(oe[154],ae([0,1,153]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=j;function j(P){switch(P){case 1:return(0,n.localize)(0,null);case 2:return(0,n.localize)(1,null);case 3:return(0,n.localize)(2,null);case 4:return(0,n.localize)(3,null);case 5:return(0,n.localize)(4,null);case 6:return(0,n.localize)(5,null);case 7:return(0,n.localize)(6,null);case 8:return(0,n.localize)(7,null);case 9:return(0,n.localize)(8,null);default:return""}}}),define(oe[155],ae([11,10]),function(K,e){return K.create("vs/base/common/platform",e)}),define(oe[4],ae([0,1,155]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=o,e.$D=C,e.$J=I,e.$g="en";let j=!1,P=!1,M=!1,S=!1,E=!1,h=!1,c=!1,p=!1,y=!1,k=!1,g,m=e.$g,v=e.$g,w,$;const f=globalThis;let l;typeof f.vscode<"u"&&typeof f.vscode.process<"u"?l=f.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(l=process);const d=typeof l?.versions?.electron=="string",a=d&&l?.type==="renderer";if(typeof l=="object"){j=l.platform==="win32",P=l.platform==="darwin",M=l.platform==="linux",S=M&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,c=d,y=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=e.$g,m=e.$g;const D=l.env.VSCODE_NLS_CONFIG;if(D)try{const O=JSON.parse(D),R=O.availableLanguages["*"];g=O.locale,v=O.osLocale,m=R||e.$g,w=O._translationsConfigFile}catch{}E=!0}else typeof navigator=="object"&&!a?($=navigator.userAgent,j=$.indexOf("Windows")>=0,P=$.indexOf("Macintosh")>=0,p=($.indexOf("Macintosh")>=0||$.indexOf("iPad")>=0||$.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=$.indexOf("Linux")>=0,k=$?.indexOf("Mobi")>=0,h=!0,g=n.getConfiguredDefaultLocale(n.localize(0,null))||e.$g,m=g,v=navigator.language):console.error("Unable to resolve platform.");var t;(function(D){D[D.Web=0]="Web",D[D.Mac=1]="Mac",D[D.Linux=2]="Linux",D[D.Windows=3]="Windows"})(t||(e.Platform=t={}));function o(D){switch(D){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let r=0;P?r=1:j?r=3:M&&(r=2),e.$i=j,e.$j=P,e.$k=M,e.$l=S,e.$m=E,e.$n=c,e.$o=h,e.$p=h&&typeof f.importScripts=="function",e.$q=e.$p?f.origin:void 0,e.$r=p,e.$s=k,e.$t=y,e.$u=r,e.$v=$,e.$w=m;var i;(function(D){function O(){return e.$w}D.value=O;function R(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}D.isDefaultVariant=R;function W(){return e.$w==="en"}D.isDefault=W})(i||(e.Language=i={})),e.$x=g,e.$y=v,e.$z=w,e.$A=typeof f.postMessage=="function"&&!f.importScripts,e.$B=(()=>{if(e.$A){const D=[];f.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let W=0,F=D.length;W<F;W++){const q=D[W];if(q.id===R.data.vscodeScheduleAsyncWork){D.splice(W,1),q.callback();return}}});let O=0;return R=>{const W=++O;D.push({id:W,callback:R}),f.postMessage({vscodeScheduleAsyncWork:W},"*")}}return D=>setTimeout(D)})();var s;(function(D){D[D.Windows=1]="Windows",D[D.Macintosh=2]="Macintosh",D[D.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=P||p?2:j?1:3;let u=!0,b=!1;function C(){if(!b){b=!0;const D=new Uint8Array(2);D[0]=1,D[1]=2,u=new Uint16Array(D.buffer)[0]===513}return u}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function I(D){return parseFloat(D)>=20}}),define(oe[36],ae([0,1,4]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let j;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.process<"u"){const M=P.process;j={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()}}}else typeof process<"u"?j={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:j={get platform(){return n.$i?"win32":n.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=j.cwd,e.env=j.env,e.$ec=j.platform,e.$fc=j.arch}),define(oe[9],ae([0,1,36]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const j=65,P=97,M=90,S=122,E=46,h=47,c=92,p=58,y=63;class k extends Error{constructor(o,r,i){let s;typeof r=="string"&&r.indexOf("not ")===0?(s="must not be",r=r.replace(/^not /,"")):s="must be";const u=o.indexOf(".")!==-1?"property":"argument";let b=`The "${o}" ${u} ${s} of type ${r}`;b+=`. Received type ${typeof i}`,super(b),this.code="ERR_INVALID_ARG_TYPE"}}function g(t,o){if(t===null||typeof t!="object")throw new k(o,"Object",t)}function m(t,o){if(typeof t!="string")throw new k(o,"string",t)}const v=n.$ec==="win32";function w(t){return t===h||t===c}function $(t){return t===h}function f(t){return t>=j&&t<=M||t>=P&&t<=S}function l(t,o,r,i){let s="",u=0,b=-1,C=0,I=0;for(let D=0;D<=t.length;++D){if(D<t.length)I=t.charCodeAt(D);else{if(i(I))break;I=h}if(i(I)){if(!(b===D-1||C===1))if(C===2){if(s.length<2||u!==2||s.charCodeAt(s.length-1)!==E||s.charCodeAt(s.length-2)!==E){if(s.length>2){const O=s.lastIndexOf(r);O===-1?(s="",u=0):(s=s.slice(0,O),u=s.length-1-s.lastIndexOf(r)),b=D,C=0;continue}else if(s.length!==0){s="",u=0,b=D,C=0;continue}}o&&(s+=s.length>0?`${r}..`:"..",u=2)}else s.length>0?s+=`${r}${t.slice(b+1,D)}`:s=t.slice(b+1,D),u=D-b-1;b=D,C=0}else I===E&&C!==-1?++C:C=-1}return s}function d(t,o){g(o,"pathObject");const r=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return r?r===o.root?`${r}${i}`:`${r}${t}${i}`:i}e.$gc={resolve(...t){let o="",r="",i=!1;for(let s=t.length-1;s>=-1;s--){let u;if(s>=0){if(u=t[s],m(u,"path"),u.length===0)continue}else o.length===0?u=n.cwd():(u=n.env[`=${o}`]||n.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==o.toLowerCase()&&u.charCodeAt(2)===c)&&(u=`${o}\\`));const b=u.length;let C=0,I="",D=!1;const O=u.charCodeAt(0);if(b===1)w(O)&&(C=1,D=!0);else if(w(O))if(D=!0,w(u.charCodeAt(1))){let R=2,W=R;for(;R<b&&!w(u.charCodeAt(R));)R++;if(R<b&&R!==W){const F=u.slice(W,R);for(W=R;R<b&&w(u.charCodeAt(R));)R++;if(R<b&&R!==W){for(W=R;R<b&&!w(u.charCodeAt(R));)R++;(R===b||R!==W)&&(I=`\\\\${F}\\${u.slice(W,R)}`,C=R)}}}else C=1;else f(O)&&u.charCodeAt(1)===p&&(I=u.slice(0,2),C=2,b>2&&w(u.charCodeAt(2))&&(D=!0,C=3));if(I.length>0)if(o.length>0){if(I.toLowerCase()!==o.toLowerCase())continue}else o=I;if(i){if(o.length>0)break}else if(r=`${u.slice(C)}\\${r}`,i=D,D&&o.length>0)break}return r=l(r,!i,"\\",w),i?`${o}\\${r}`:`${o}${r}`||"."},normalize(t){m(t,"path");const o=t.length;if(o===0)return".";let r=0,i,s=!1;const u=t.charCodeAt(0);if(o===1)return $(u)?"\\":t;if(w(u))if(s=!0,w(t.charCodeAt(1))){let C=2,I=C;for(;C<o&&!w(t.charCodeAt(C));)C++;if(C<o&&C!==I){const D=t.slice(I,C);for(I=C;C<o&&w(t.charCodeAt(C));)C++;if(C<o&&C!==I){for(I=C;C<o&&!w(t.charCodeAt(C));)C++;if(C===o)return`\\\\${D}\\${t.slice(I)}\\`;C!==I&&(i=`\\\\${D}\\${t.slice(I,C)}`,r=C)}}}else r=1;else f(u)&&t.charCodeAt(1)===p&&(i=t.slice(0,2),r=2,o>2&&w(t.charCodeAt(2))&&(s=!0,r=3));let b=r<o?l(t.slice(r),!s,"\\",w):"";return b.length===0&&!s&&(b="."),b.length>0&&w(t.charCodeAt(o-1))&&(b+="\\"),i===void 0?s?`\\${b}`:b:s?`${i}\\${b}`:`${i}${b}`},isAbsolute(t){m(t,"path");const o=t.length;if(o===0)return!1;const r=t.charCodeAt(0);return w(r)||o>2&&f(r)&&t.charCodeAt(1)===p&&w(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,r;for(let u=0;u<t.length;++u){const b=t[u];m(b,"path"),b.length>0&&(o===void 0?o=r=b:o+=`\\${b}`)}if(o===void 0)return".";let i=!0,s=0;if(typeof r=="string"&&w(r.charCodeAt(0))){++s;const u=r.length;u>1&&w(r.charCodeAt(1))&&(++s,u>2&&(w(r.charCodeAt(2))?++s:i=!1))}if(i){for(;s<o.length&&w(o.charCodeAt(s));)s++;s>=2&&(o=`\\${o.slice(s)}`)}return e.$gc.normalize(o)},relative(t,o){if(m(t,"from"),m(o,"to"),t===o)return"";const r=e.$gc.resolve(t),i=e.$gc.resolve(o);if(r===i||(t=r.toLowerCase(),o=i.toLowerCase(),t===o))return"";let s=0;for(;s<t.length&&t.charCodeAt(s)===c;)s++;let u=t.length;for(;u-1>s&&t.charCodeAt(u-1)===c;)u--;const b=u-s;let C=0;for(;C<o.length&&o.charCodeAt(C)===c;)C++;let I=o.length;for(;I-1>C&&o.charCodeAt(I-1)===c;)I--;const D=I-C,O=b<D?b:D;let R=-1,W=0;for(;W<O;W++){const q=t.charCodeAt(s+W);if(q!==o.charCodeAt(C+W))break;q===c&&(R=W)}if(W!==O){if(R===-1)return i}else{if(D>O){if(o.charCodeAt(C+W)===c)return i.slice(C+W+1);if(W===2)return i.slice(C+W)}b>O&&(t.charCodeAt(s+W)===c?R=W:W===2&&(R=3)),R===-1&&(R=0)}let F="";for(W=s+R+1;W<=u;++W)(W===u||t.charCodeAt(W)===c)&&(F+=F.length===0?"..":"\\..");return C+=R,F.length>0?`${F}${i.slice(C,I)}`:(i.charCodeAt(C)===c&&++C,i.slice(C,I))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$gc.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===c){if(o.charCodeAt(1)===c){const r=o.charCodeAt(2);if(r!==y&&r!==E)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(f(o.charCodeAt(0))&&o.charCodeAt(1)===p&&o.charCodeAt(2)===c)return`\\\\?\\${o}`;return t},dirname(t){m(t,"path");const o=t.length;if(o===0)return".";let r=-1,i=0;const s=t.charCodeAt(0);if(o===1)return w(s)?t:".";if(w(s)){if(r=i=1,w(t.charCodeAt(1))){let C=2,I=C;for(;C<o&&!w(t.charCodeAt(C));)C++;if(C<o&&C!==I){for(I=C;C<o&&w(t.charCodeAt(C));)C++;if(C<o&&C!==I){for(I=C;C<o&&!w(t.charCodeAt(C));)C++;if(C===o)return t;C!==I&&(r=i=C+1)}}}}else f(s)&&t.charCodeAt(1)===p&&(r=o>2&&w(t.charCodeAt(2))?3:2,i=r);let u=-1,b=!0;for(let C=o-1;C>=i;--C)if(w(t.charCodeAt(C))){if(!b){u=C;break}}else b=!1;if(u===-1){if(r===-1)return".";u=r}return t.slice(0,u)},basename(t,o){o!==void 0&&m(o,"ext"),m(t,"path");let r=0,i=-1,s=!0,u;if(t.length>=2&&f(t.charCodeAt(0))&&t.charCodeAt(1)===p&&(r=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let b=o.length-1,C=-1;for(u=t.length-1;u>=r;--u){const I=t.charCodeAt(u);if(w(I)){if(!s){r=u+1;break}}else C===-1&&(s=!1,C=u+1),b>=0&&(I===o.charCodeAt(b)?--b===-1&&(i=u):(b=-1,i=C))}return r===i?i=C:i===-1&&(i=t.length),t.slice(r,i)}for(u=t.length-1;u>=r;--u)if(w(t.charCodeAt(u))){if(!s){r=u+1;break}}else i===-1&&(s=!1,i=u+1);return i===-1?"":t.slice(r,i)},extname(t){m(t,"path");let o=0,r=-1,i=0,s=-1,u=!0,b=0;t.length>=2&&t.charCodeAt(1)===p&&f(t.charCodeAt(0))&&(o=i=2);for(let C=t.length-1;C>=o;--C){const I=t.charCodeAt(C);if(w(I)){if(!u){i=C+1;break}continue}s===-1&&(u=!1,s=C+1),I===E?r===-1?r=C:b!==1&&(b=1):r!==-1&&(b=-1)}return r===-1||s===-1||b===0||b===1&&r===s-1&&r===i+1?"":t.slice(r,s)},format:d.bind(null,"\\"),parse(t){m(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.length;let i=0,s=t.charCodeAt(0);if(r===1)return w(s)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(w(s)){if(i=1,w(t.charCodeAt(1))){let R=2,W=R;for(;R<r&&!w(t.charCodeAt(R));)R++;if(R<r&&R!==W){for(W=R;R<r&&w(t.charCodeAt(R));)R++;if(R<r&&R!==W){for(W=R;R<r&&!w(t.charCodeAt(R));)R++;R===r?i=R:R!==W&&(i=R+1)}}}}else if(f(s)&&t.charCodeAt(1)===p){if(r<=2)return o.root=o.dir=t,o;if(i=2,w(t.charCodeAt(2))){if(r===3)return o.root=o.dir=t,o;i=3}}i>0&&(o.root=t.slice(0,i));let u=-1,b=i,C=-1,I=!0,D=t.length-1,O=0;for(;D>=i;--D){if(s=t.charCodeAt(D),w(s)){if(!I){b=D+1;break}continue}C===-1&&(I=!1,C=D+1),s===E?u===-1?u=D:O!==1&&(O=1):u!==-1&&(O=-1)}return C!==-1&&(u===-1||O===0||O===1&&u===C-1&&u===b+1?o.base=o.name=t.slice(b,C):(o.name=t.slice(b,u),o.base=t.slice(b,C),o.ext=t.slice(u,C))),b>0&&b!==i?o.dir=t.slice(0,b-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(v){const t=/\\/g;return()=>{const o=n.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>n.cwd()})();e.$hc={resolve(...t){let o="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const s=i>=0?t[i]:a();m(s,"path"),s.length!==0&&(o=`${s}/${o}`,r=s.charCodeAt(0)===h)}return o=l(o,!r,"/",$),r?`/${o}`:o.length>0?o:"."},normalize(t){if(m(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===h,r=t.charCodeAt(t.length-1)===h;return t=l(t,!o,"/",$),t.length===0?o?"/":r?"./":".":(r&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return m(t,"path"),t.length>0&&t.charCodeAt(0)===h},join(...t){if(t.length===0)return".";let o;for(let r=0;r<t.length;++r){const i=t[r];m(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.$hc.normalize(o)},relative(t,o){if(m(t,"from"),m(o,"to"),t===o||(t=e.$hc.resolve(t),o=e.$hc.resolve(o),t===o))return"";const r=1,i=t.length,s=i-r,u=1,b=o.length-u,C=s<b?s:b;let I=-1,D=0;for(;D<C;D++){const R=t.charCodeAt(r+D);if(R!==o.charCodeAt(u+D))break;R===h&&(I=D)}if(D===C)if(b>C){if(o.charCodeAt(u+D)===h)return o.slice(u+D+1);if(D===0)return o.slice(u+D)}else s>C&&(t.charCodeAt(r+D)===h?I=D:D===0&&(I=0));let O="";for(D=r+I+1;D<=i;++D)(D===i||t.charCodeAt(D)===h)&&(O+=O.length===0?"..":"/..");return`${O}${o.slice(u+I)}`},toNamespacedPath(t){return t},dirname(t){if(m(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===h;let r=-1,i=!0;for(let s=t.length-1;s>=1;--s)if(t.charCodeAt(s)===h){if(!i){r=s;break}}else i=!1;return r===-1?o?"/":".":o&&r===1?"//":t.slice(0,r)},basename(t,o){o!==void 0&&m(o,"ext"),m(t,"path");let r=0,i=-1,s=!0,u;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let b=o.length-1,C=-1;for(u=t.length-1;u>=0;--u){const I=t.charCodeAt(u);if(I===h){if(!s){r=u+1;break}}else C===-1&&(s=!1,C=u+1),b>=0&&(I===o.charCodeAt(b)?--b===-1&&(i=u):(b=-1,i=C))}return r===i?i=C:i===-1&&(i=t.length),t.slice(r,i)}for(u=t.length-1;u>=0;--u)if(t.charCodeAt(u)===h){if(!s){r=u+1;break}}else i===-1&&(s=!1,i=u+1);return i===-1?"":t.slice(r,i)},extname(t){m(t,"path");let o=-1,r=0,i=-1,s=!0,u=0;for(let b=t.length-1;b>=0;--b){const C=t.charCodeAt(b);if(C===h){if(!s){r=b+1;break}continue}i===-1&&(s=!1,i=b+1),C===E?o===-1?o=b:u!==1&&(u=1):o!==-1&&(u=-1)}return o===-1||i===-1||u===0||u===1&&o===i-1&&o===r+1?"":t.slice(o,i)},format:d.bind(null,"/"),parse(t){m(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.charCodeAt(0)===h;let i;r?(o.root="/",i=1):i=0;let s=-1,u=0,b=-1,C=!0,I=t.length-1,D=0;for(;I>=i;--I){const O=t.charCodeAt(I);if(O===h){if(!C){u=I+1;break}continue}b===-1&&(C=!1,b=I+1),O===E?s===-1?s=I:D!==1&&(D=1):s!==-1&&(D=-1)}if(b!==-1){const O=u===0&&r?1:u;s===-1||D===0||D===1&&s===b-1&&s===u+1?o.base=o.name=t.slice(O,b):(o.name=t.slice(O,s),o.base=t.slice(O,b),o.ext=t.slice(s,b))}return u>0?o.dir=t.slice(0,u-1):r&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=v?e.$gc.normalize:e.$hc.normalize,e.$jc=v?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=v?e.$gc.join:e.$hc.join,e.$lc=v?e.$gc.resolve:e.$hc.resolve,e.$mc=v?e.$gc.relative:e.$hc.relative,e.$nc=v?e.$gc.dirname:e.$hc.dirname,e.$oc=v?e.$gc.basename:e.$hc.basename,e.$pc=v?e.$gc.extname:e.$hc.extname,e.$qc=v?e.$gc.format:e.$hc.format,e.$rc=v?e.$gc.parse:e.$hc.parse,e.$sc=v?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=v?e.$gc.sep:e.$hc.sep,e.$uc=v?e.$gc.delimiter:e.$hc.delimiter}),define(oe[31],ae([0,1,9,4,25,12]),function(K,e,n,j,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=S,e.$cg=E,e.$dg=h,e.$eg=c,e.$fg=p,e.$gg=m,e.$hg=v,e.$ig=w,e.$jg=$,e.$kg=f,e.$lg=l,e.$mg=d,e.$ng=a,e.$og=t,e.$pg=o,e.$qg=s;function S(u){return u===47||u===92}function E(u){return u.replace(/[\\/]/g,n.$hc.sep)}function h(u){return u.indexOf("/")===-1&&(u=E(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}function c(u,b=n.$hc.sep){if(!u)return"";const C=u.length,I=u.charCodeAt(0);if(S(I)){if(S(u.charCodeAt(1))&&!S(u.charCodeAt(2))){let O=3;const R=O;for(;O<C&&!S(u.charCodeAt(O));O++);if(R!==O&&!S(u.charCodeAt(O+1))){for(O+=1;O<C;O++)if(S(u.charCodeAt(O)))return u.slice(0,O+1).replace(/[\\/]/g,b)}}return b}else if($(I)&&u.charCodeAt(1)===58)return S(u.charCodeAt(2))?u.slice(0,2)+b:u.slice(0,2);let D=u.indexOf("://");if(D!==-1){for(D+=3;D<C;D++)if(S(u.charCodeAt(D)))return u.slice(0,D+1)}return""}function p(u){if(!j.$i||!u||u.length<5)return!1;let b=u.charCodeAt(0);if(b!==92||(b=u.charCodeAt(1),b!==92))return!1;let C=2;const I=C;for(;C<u.length&&(b=u.charCodeAt(C),b!==92);C++);return!(I===C||(b=u.charCodeAt(C+1),isNaN(b)||b===92))}const y=/[\\/:\*\?"<>\|]/g,k=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(u,b=j.$i){const C=b?y:k;return!(!u||u.length===0||/^\s+$/.test(u)||(C.lastIndex=0,C.test(u))||b&&g.test(u)||u==="."||u===".."||b&&u[u.length-1]==="."||b&&u.length!==u.trim().length||u.length>255)}function v(u,b,C){const I=u===b;return!C||I?I:!u||!b?!1:(0,P.$lf)(u,b)}function w(u,b,C,I=n.sep){if(u===b)return!0;if(!u||!b||b.length>u.length)return!1;if(C){if(!(0,P.$mf)(u,b))return!1;if(b.length===u.length)return!0;let O=b.length;return b.charAt(b.length-1)===I&&O--,u.charAt(O)===I}return b.charAt(b.length-1)!==I&&(b+=I),u.indexOf(b)===0}function $(u){return u>=65&&u<=90||u>=97&&u<=122}function f(u,b){return j.$i&&u.endsWith(":")&&(u+=n.sep),(0,n.$jc)(u)||(u=(0,n.$kc)(b,u)),u=(0,n.$ic)(u),j.$i?(u=(0,P.$6e)(u,n.sep),u.endsWith(":")&&(u+=n.sep)):(u=(0,P.$6e)(u,n.sep),u||(u=n.sep)),u}function l(u){const b=(0,n.$ic)(u);return j.$i?u.length>3?!1:d(b)&&(u.length===2||b.charCodeAt(2)===92):b===n.$hc.sep}function d(u,b=j.$i){return b?$(u.charCodeAt(0))&&u.charCodeAt(1)===58:!1}function a(u,b=j.$i){return d(u,b)?u[0]:void 0}function t(u,b,C){return b.length>u.length?-1:u===b?0:(C&&(u=u.toLowerCase(),b=b.toLowerCase()),u.indexOf(b))}function o(u){const b=u.split(":");let C,I,D;for(const O of b){const R=Number(O);(0,M.$Zf)(R)?I===void 0?I=R:D===void 0&&(D=R):C=C?[C,O].join(":"):O}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:I!==void 0?I:void 0,column:D!==void 0?D:I!==void 0?1:void 0}}const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function s(u,b,C=8){let I="";for(let O=0;O<C;O++){let R;O===0&&j.$i&&!b&&(C===3||C===4)?R=i:R=r,I+=R.charAt(Math.floor(Math.random()*R.length))}let D;return b?D=`${b}-${I}`:D=I,u?(0,n.$kc)(u,D):D}}),define(oe[75],ae([0,1,4]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$$l=M,e.$_l=S;var j;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(j||(e.Source=j={}));var P;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(P||(e.TerminateResponseCode=P={}));function M(E,...h){const c=h.reduce((k,g)=>(k[g]=!0,k),{}),p=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(k=>!c[k]).forEach(k=>{for(let g=0;g<p.length;g++)if(k.search(p[g])!==-1){delete E[k];break}})}function S(E){E&&(delete E.DEBUG,n.$j&&delete E.DYLD_LIBRARY_PATH,n.$k&&delete E.LD_PRELOAD)}}),define(oe[7],ae([0,1,9,4]),function(K,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=m,e.$xc=d;const P=/^\w[\w\d+.-]*$/,M=/^\//,S=/^\/\//;function E(i,s){if(!i.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!P.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!M.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(S.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(i,s){return!i&&!s?"file":i}function c(i,s){switch(i){case"https":case"http":case"file":s?s[0]!==y&&(s=y+s):s=y;break}return s}const p="",y="/",k=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{static isUri(s){return s instanceof g?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}constructor(s,u,b,C,I,D=!1){typeof s=="object"?(this.scheme=s.scheme||p,this.authority=s.authority||p,this.path=s.path||p,this.query=s.query||p,this.fragment=s.fragment||p):(this.scheme=h(s,D),this.authority=u||p,this.path=c(this.scheme,b||p),this.query=C||p,this.fragment=I||p,E(this,D))}get fsPath(){return d(this,!1)}with(s){if(!s)return this;let{scheme:u,authority:b,path:C,query:I,fragment:D}=s;return u===void 0?u=this.scheme:u===null&&(u=p),b===void 0?b=this.authority:b===null&&(b=p),C===void 0?C=this.path:C===null&&(C=p),I===void 0?I=this.query:I===null&&(I=p),D===void 0?D=this.fragment:D===null&&(D=p),u===this.scheme&&b===this.authority&&C===this.path&&I===this.query&&D===this.fragment?this:new w(u,b,C,I,D)}static parse(s,u=!1){const b=k.exec(s);return b?new w(b[2]||p,r(b[4]||p),r(b[5]||p),r(b[7]||p),r(b[9]||p),u):new w(p,p,p,p,p)}static file(s){let u=p;if(j.$i&&(s=s.replace(/\\/g,y)),s[0]===y&&s[1]===y){const b=s.indexOf(y,2);b===-1?(u=s.substring(2),s=y):(u=s.substring(2,b),s=s.substring(b)||y)}return new w("file",u,s,p,p)}static from(s,u){return new w(s.scheme,s.authority,s.path,s.query,s.fragment,u)}static joinPath(s,...u){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return j.$i&&s.scheme==="file"?b=g.file(n.$gc.join(d(s,!0),...u)).path:b=n.$hc.join(s.path,...u),s.with({path:b})}toString(s=!1){return a(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof g)return s;{const u=new w(s);return u._formatted=s.external??null,u._fsPath=s._sep===v?s.fsPath??null:null,u}}else return s}}e.URI=g;function m(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}const v=j.$i?1:void 0;class w extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(s=!1){return s?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=v),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const $={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function f(i,s,u){let b,C=-1;for(let I=0;I<i.length;I++){const D=i.charCodeAt(I);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||s&&D===47||u&&D===91||u&&D===93||u&&D===58)C!==-1&&(b+=encodeURIComponent(i.substring(C,I)),C=-1),b!==void 0&&(b+=i.charAt(I));else{b===void 0&&(b=i.substr(0,I));const O=$[D];O!==void 0?(C!==-1&&(b+=encodeURIComponent(i.substring(C,I)),C=-1),b+=O):C===-1&&(C=I)}}return C!==-1&&(b+=encodeURIComponent(i.substring(C))),b!==void 0?b:i}function l(i){let s;for(let u=0;u<i.length;u++){const b=i.charCodeAt(u);b===35||b===63?(s===void 0&&(s=i.substr(0,u)),s+=$[b]):s!==void 0&&(s+=i[u])}return s!==void 0?s:i}function d(i,s){let u;return i.authority&&i.path.length>1&&i.scheme==="file"?u=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?s?u=i.path.substr(1):u=i.path[1].toLowerCase()+i.path.substr(2):u=i.path,j.$i&&(u=u.replace(/\//g,"\\")),u}function a(i,s){const u=s?l:f;let b="",{scheme:C,authority:I,path:D,query:O,fragment:R}=i;if(C&&(b+=C,b+=":"),(I||C==="file")&&(b+=y,b+=y),I){let W=I.indexOf("@");if(W!==-1){const F=I.substr(0,W);I=I.substr(W+1),W=F.lastIndexOf(":"),W===-1?b+=u(F,!1,!1):(b+=u(F.substr(0,W),!1,!1),b+=":",b+=u(F.substr(W+1),!1,!0)),b+="@"}I=I.toLowerCase(),W=I.lastIndexOf(":"),W===-1?b+=u(I,!1,!0):(b+=u(I.substr(0,W),!1,!0),b+=I.substr(W))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const W=D.charCodeAt(1);W>=65&&W<=90&&(D=`/${String.fromCharCode(W+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const W=D.charCodeAt(0);W>=65&&W<=90&&(D=`${String.fromCharCode(W+32)}:${D.substr(2)}`)}b+=u(D,!0,!1)}return O&&(b+="?",b+=u(O,!1,!1)),R&&(b+="#",b+=s?R:f(R,!1,!1)),b}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(o)?i.replace(o,s=>t(s)):i}}),define(oe[156],ae([0,1,7]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=j,e.$Gq=P,e.$Hq=M,e.log=E;function j(c){const p=c;return p&&typeof p.type=="string"&&typeof p.severity=="string"}function P(c){const p=[];let y;try{const k=JSON.parse(c.arguments),g=k[k.length-1];g&&g.__$stack&&(k.pop(),y=g.__$stack),p.push(...k)}catch{p.push("Unable to log remote console arguments",c.arguments)}return{args:p,stack:y}}function M(c){if(typeof c!="string")return M(P(c).stack);const p=c;if(p){const y=S(p),k=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(k&&k.length===4)return{uri:n.URI.file(k[1]),line:Number(k[2]),column:Number(k[3])}}}function S(c){if(!c)return c;const p=c.indexOf(`
`);return p===-1?c:c.substring(0,p)}function E(c,p){const{args:y,stack:k}=P(c),g=typeof y[0]=="string"&&y.length===1;let m=S(k);m&&(m=`(${m.trim()})`);let v=[];if(typeof y[0]=="string"?m&&g?v=[`%c[${p}] %c${y[0]} %c${m}`,h("blue"),h(""),h("grey")]:v=[`%c[${p}] %c${y[0]}`,h("blue"),h(""),...y.slice(1)]:v=[`%c[${p}]%`,h("blue"),...y],m&&!g&&v.push(m),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,v)}function h(c){return`color: ${c}`}}),define(oe[76],ae([0,1,17,7]),function(K,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=P,e.$Qh=M,e.$Rh=E;function P(h){return JSON.stringify(h,S)}function M(h){let c=JSON.parse(h);return c=E(c),c}function S(h,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function E(h,c=0){if(!h||c>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return j.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof n.$ue||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let p=0;p<h.length;++p)h[p]=E(h[p],c+1);else for(const p in h)Object.hasOwnProperty.call(h,p)&&(h[p]=E(h[p],c+1))}return h}}),define(oe[13],ae([0,1,15,4,25,7,9]),function(K,e,n,j,P,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$vg=e.$ug=e.$tg=e.Schemas=void 0,e.$rg=h,e.$sg=c,e.$wg=y;var E;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatCodeBlock="vscode-chat-code-block",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm",m.codeSetting="code-setting"})(E||(e.Schemas=E={}));function h(m,v){return M.URI.isUri(m)?(0,P.$lf)(m.scheme,v):(0,P.$mf)(m,v+":")}function c(m,...v){return v.some(w=>h(m,w))}e.$tg="vscode-tkn",e.$ug="tkn";class p{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(v){this.d=v}setDelegate(v){this.e=v}setServerRootPath(v,w){this.f=y(v,w)}getServerRootPath(){return this.f}get g(){return S.$hc.join(this.f,E.vscodeRemoteResource)}set(v,w,$){this.a[v]=w,this.b[v]=$}setConnectionToken(v,w){this.c[v]=w}getPreferredWebSchema(){return this.d}rewrite(v){if(this.e)try{return this.e(v)}catch(a){return n.$1(a),v}const w=v.authority;let $=this.a[w];$&&$.indexOf(":")!==-1&&$.indexOf("[")===-1&&($=`[${$}]`);const f=this.b[w],l=this.c[w];let d=`path=${encodeURIComponent(v.path)}`;return typeof l=="string"&&(d+=`&${e.$ug}=${encodeURIComponent(l)}`),M.URI.from({scheme:j.$o?this.d:E.vscodeRemoteResource,authority:`${$}:${f}`,path:this.g,query:d})}}e.$vg=new p;function y(m,v){return S.$hc.join(v??"/",`${m.quality??"oss"}-${m.commit??"dev"}`)}e.$xg="vs/../../extensions",e.$yg="vs/../../node_modules",e.$zg="vs/../../node_modules.asar",e.$Ag="vs/../../node_modules.asar.unpacked",e.$Bg="vscode-app";class k{static{this.a=e.$Bg}asBrowserUri(v){const w=this.b(v,K);return this.uriToBrowserUri(w)}uriToBrowserUri(v){return v.scheme===E.vscodeRemote?e.$vg.rewrite(v):v.scheme===E.file&&(j.$m||j.$q===`${E.vscodeFileResource}://${k.a}`)?v.with({scheme:E.vscodeFileResource,authority:v.authority||k.a,query:null,fragment:null}):v}asFileUri(v){const w=this.b(v,K);return this.uriToFileUri(w)}uriToFileUri(v){return v.scheme===E.vscodeFileResource?v.with({scheme:E.file,authority:v.authority!==k.a?v.authority:null,query:null,fragment:null}):v}b(v,w){return M.URI.isUri(v)?v:M.URI.parse(w.toUrl(v))}}e.$Cg=new k;var g;(function(m){const v=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(v.get("3"));const w="vscode-coi";function $(l){let d;typeof l=="string"?d=new URL(l).searchParams:l instanceof URL?d=l.searchParams:M.URI.isUri(l)&&(d=new URL(l.toString(!0)).searchParams);const a=d?.get(w);if(a)return v.get(a)}m.getHeadersFromQuery=$;function f(l,d,a){if(!globalThis.crossOriginIsolated)return;const t=d&&a?"3":a?"2":"1";l instanceof URLSearchParams?l.set(w,t):l[w]=t}m.addSearchParam=f})(g||(e.COI=g={}))}),define(oe[19],ae([0,1,31,13,9,4,25,7]),function(K,e,n,j,P,M,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=void 0,e.$Jg=h,e.$5g=p,e.$6g=k;function h(g){return(0,E.$xc)(g,!0)}class c{constructor(m){this.a=m}compare(m,v,w=!1){return m===v?0:(0,S.$ef)(this.getComparisonKey(m,w),this.getComparisonKey(v,w))}isEqual(m,v,w=!1){return m===v?!0:!m||!v?!1:this.getComparisonKey(m,w)===this.getComparisonKey(v,w)}getComparisonKey(m,v=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,v,w=!1){if(m.scheme===v.scheme){if(m.scheme===j.Schemas.file)return n.$ig(h(m),h(v),this.a(m))&&m.query===v.query&&(w||m.fragment===v.fragment);if((0,e.$1g)(m.authority,v.authority))return n.$ig(m.path,v.path,this.a(m),"/")&&m.query===v.query&&(w||m.fragment===v.fragment)}return!1}joinPath(m,...v){return E.URI.joinPath(m,...v)}basenameOrAuthority(m){return(0,e.$Sg)(m)||m.authority}basename(m){return P.$hc.basename(m.path)}extname(m){return P.$hc.extname(m.path)}dirname(m){if(m.path.length===0)return m;let v;return m.scheme===j.Schemas.file?v=E.URI.file(P.$nc(h(m))).path:(v=P.$hc.dirname(m.path),m.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),v="/")),m.with({path:v})}normalizePath(m){if(!m.path.length)return m;let v;return m.scheme===j.Schemas.file?v=E.URI.file(P.$ic(h(m))).path:v=P.$hc.normalize(m.path),m.with({path:v})}relativePath(m,v){if(m.scheme!==v.scheme||!(0,e.$1g)(m.authority,v.authority))return;if(m.scheme===j.Schemas.file){const f=P.$mc(h(m),h(v));return M.$i?n.$cg(f):f}let w=m.path||"/";const $=v.path||"/";if(this.a(m)){let f=0;for(const l=Math.min(w.length,$.length);f<l&&!(w.charCodeAt(f)!==$.charCodeAt(f)&&w.charAt(f).toLowerCase()!==$.charAt(f).toLowerCase());f++);w=$.substr(0,f)+w.substr(f)}return P.$hc.relative(w,$)}resolvePath(m,v){if(m.scheme===j.Schemas.file){const w=E.URI.file(P.$lc(h(m),v));return m.with({authority:w.authority,path:w.path})}return v=n.$dg(v),m.with({path:P.$hc.resolve(m.path,v)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,v){return m===v||m!==void 0&&v!==void 0&&(0,S.$lf)(m,v)}hasTrailingPathSeparator(m,v=P.sep){if(m.scheme===j.Schemas.file){const w=h(m);return w.length>n.$eg(w).length&&w[w.length-1]===v}else{const w=m.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,v=P.sep){return(0,e.$2g)(m,v)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,v=P.sep){let w=!1;if(m.scheme===j.Schemas.file){const $=h(m);w=$!==void 0&&$.length===n.$eg($).length&&$[$.length-1]===v}else{v="/";const $=m.path;w=$.length===1&&$.charCodeAt($.length-1)===47}return!w&&!(0,e.$2g)(m,v)?m.with({path:m.path+"/"}):m}}e.$Kg=c,e.$Lg=new c(()=>!1),e.$Mg=new c(g=>g.scheme===j.Schemas.file?!M.$k:!0),e.$Ng=new c(g=>!0),e.$Og=e.$Lg.isEqual.bind(e.$Lg),e.$Pg=e.$Lg.isEqualOrParent.bind(e.$Lg),e.$Qg=e.$Lg.getComparisonKey.bind(e.$Lg),e.$Rg=e.$Lg.basenameOrAuthority.bind(e.$Lg),e.$Sg=e.$Lg.basename.bind(e.$Lg),e.$Tg=e.$Lg.extname.bind(e.$Lg),e.$Ug=e.$Lg.dirname.bind(e.$Lg),e.$Vg=e.$Lg.joinPath.bind(e.$Lg),e.$Wg=e.$Lg.normalizePath.bind(e.$Lg),e.$Xg=e.$Lg.relativePath.bind(e.$Lg),e.$Yg=e.$Lg.resolvePath.bind(e.$Lg),e.$Zg=e.$Lg.isAbsolutePath.bind(e.$Lg),e.$1g=e.$Lg.isEqualAuthority.bind(e.$Lg),e.$2g=e.$Lg.hasTrailingPathSeparator.bind(e.$Lg),e.$3g=e.$Lg.removeTrailingPathSeparator.bind(e.$Lg),e.$4g=e.$Lg.addTrailingPathSeparator.bind(e.$Lg);function p(g,m){const v=[];for(let w=0;w<g.length;w++){const $=m(g[w]);g.some((f,l)=>l===w?!1:(0,e.$Pg)($,m(f)))||v.push(g[w])}return v}var y;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function m(v){const w=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(l=>{const[d,a]=l.split(":");d&&a&&w.set(d,a)});const f=v.path.substring(0,v.path.indexOf(";"));return f&&w.set(g.META_DATA_MIME,f),w}g.parseMetaData=m})(y||(e.DataUri=y={}));function k(g,m,v){if(m){let w=g.path;return w&&w[0]!==P.$hc.sep&&(w=P.$hc.sep+w),g.with({scheme:v,authority:m,path:w})}return g.with({scheme:v})}}),define(oe[8],ae([0,1,23,15,3,2,19,4,144,62]),function(K,e,n,j,P,M,S,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.Promises=e.$Fh=e.$Eh=e.$Dh=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=void 0,e.$7g=p,e.$8g=y,e.$9g=k,e.$0g=g,e.$$g=m,e.$_g=v,e.$ah=w,e.$bh=$,e.$jh=u,e.$kh=b,e.$lh=C,e.$mh=I,e.$nh=D,e.$Ch=L,e.$Kh=J;function p(H){return!!H&&typeof H.then=="function"}function y(H){const U=new n.$ee,re=H(U.token),ee=new Promise((fe,me)=>{const ve=U.token.onCancellationRequested(()=>{ve.dispose(),me(new j.$5)});Promise.resolve(re).then(ke=>{ve.dispose(),U.dispose(),fe(ke)},ke=>{ve.dispose(),U.dispose(),me(ke)})});return new class{cancel(){U.cancel(),U.dispose()}then(fe,me){return ee.then(fe,me)}catch(fe){return this.then(void 0,fe)}finally(fe){return ee.finally(fe)}}}function k(H,U,re){return new Promise((ee,fe)=>{const me=U.onCancellationRequested(()=>{me.dispose(),ee(re)});H.then(ee,fe).finally(()=>me.dispose())})}function g(H,U){return new Promise((re,ee)=>{const fe=U.onCancellationRequested(()=>{fe.dispose(),ee(new j.$5)});H.then(re,ee).finally(()=>fe.dispose())})}async function m(H){let U=-1;const re=H.map((ee,fe)=>ee.then(me=>(U=fe,me)));try{return await Promise.race(re)}finally{H.forEach((ee,fe)=>{fe!==U&&ee.cancel()})}}function v(H,U,re){let ee;const fe=setTimeout(()=>{ee?.(void 0),re?.()},U);return Promise.race([H.finally(()=>clearTimeout(fe)),new Promise(me=>ee=me)])}function w(H){return new Promise((U,re)=>{const ee=H();p(ee)?ee.then(U,re):U(ee)})}function $(){let H,U;return{promise:new Promise((ee,fe)=>{H=ee,U=fe}),resolve:H,reject:U}}class f{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(U){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=U,!this.b){const re=()=>{if(this.b=null,this.f)return;const ee=this.queue(this.d);return this.d=null,ee};this.b=new Promise(ee=>{this.a.then(re,re).then(ee)})}return new Promise((re,ee)=>{this.b.then(re,ee)})}return this.a=U(),new Promise((re,ee)=>{this.a.then(fe=>{this.a=null,re(fe)},fe=>{this.a=null,ee(fe)})})}dispose(){this.f=!0}}e.$ch=f;class l{constructor(){this.a=Promise.resolve(null)}queue(U){return this.a=this.a.then(()=>U(),()=>U())}}e.$dh=l;class d{constructor(){this.a=new Map}queue(U,re){const fe=(this.a.get(U)??Promise.resolve()).catch(()=>{}).then(re).finally(()=>{this.a.get(U)===fe&&this.a.delete(U)});return this.a.set(U,fe),fe}}e.$eh=d;const a=(H,U)=>{let re=!0;const ee=setTimeout(()=>{re=!1,U()},H);return{isTriggered:()=>re,dispose:()=>{clearTimeout(ee),re=!1}}},t=H=>{let U=!0;return queueMicrotask(()=>{U&&(U=!1,H())}),{isTriggered:()=>U,dispose:()=>{U=!1}}};class o{constructor(U){this.defaultDelay=U,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(U,re=this.defaultDelay){this.g=U,this.h(),this.b||(this.b=new Promise((fe,me)=>{this.d=fe,this.f=me}).then(()=>{if(this.b=null,this.d=null,this.g){const fe=this.g;return this.g=null,fe()}}));const ee=()=>{this.a=null,this.d?.(null)};return this.a=re===h.$4d?t(ee):a(re,ee),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new j.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$fh=o;class r{constructor(U){this.a=new o(U),this.b=new f}trigger(U,re){return this.a.trigger(()=>this.b.queue(U),re)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$gh=r;class i{constructor(){this.a=!1,this.b=new Promise((U,re)=>{this.d=U})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$hh=i;class s extends i{constructor(U){super(),this.f=setTimeout(()=>this.open(),U)}open(){clearTimeout(this.f),super.open()}}e.$ih=s;function u(H,U){return U?new Promise((re,ee)=>{const fe=setTimeout(()=>{me.dispose(),re()},H),me=U.onCancellationRequested(()=>{clearTimeout(fe),me.dispose(),ee(new j.$5)})}):y(re=>u(H,re))}function b(H,U=0,re){const ee=setTimeout(()=>{H(),re&&fe.dispose()},U),fe=(0,M.$Sc)(()=>{clearTimeout(ee),re?.deleteAndLeak(fe)});return re?.add(fe),fe}function C(H){const U=[];let re=0;const ee=H.length;function fe(){return re<ee?H[re++]():null}function me(ve){ve!=null&&U.push(ve);const ke=fe();return ke?ke.then(me):Promise.resolve(U)}return Promise.resolve(null).then(me)}function I(H,U=ee=>!!ee,re=null){let ee=0;const fe=H.length,me=()=>{if(ee>=fe)return Promise.resolve(re);const ve=H[ee++];return Promise.resolve(ve()).then(je=>U(je)?Promise.resolve(je):me())};return me()}function D(H,U=ee=>!!ee,re=null){if(H.length===0)return Promise.resolve(re);let ee=H.length;const fe=()=>{ee=-1;for(const me of H)me.cancel?.()};return new Promise((me,ve)=>{for(const ke of H)ke.then(je=>{--ee>=0&&U(je)?(fe(),me(je)):ee===0&&me(re)}).catch(je=>{--ee>=0&&(fe(),ve(je))})})}class O{constructor(U){this.a=0,this.b=!1,this.f=U,this.g=[],this.d=0,this.h=new P.$7d}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(U){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((re,ee)=>{this.g.push({factory:U,c:re,e:ee}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const U=this.g.shift();this.d++;const re=U.factory();re.then(U.c,U.e),re.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$oh=O;class R extends O{constructor(){super(1)}}e.$ph=R;class W{constructor(){this.a=new T,this.b=0}queue(U){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,U())):this.a.run(this.b++,U())}}e.$qh=W;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const U=new ce;return this.b.add(U),U.p}g(){for(const[,U]of this.a)if(U.size>0)return!1;return!0}queueSize(U,re=S.$Lg){const ee=re.getComparisonKey(U);return this.a.get(ee)?.size??0}queueFor(U,re,ee=S.$Lg){const fe=ee.getComparisonKey(U);let me=this.a.get(fe);if(!me){me=new R;const ve=this.f++,ke=P.Event.once(me.onDrained)(()=>{me?.dispose(),this.a.delete(fe),this.h(),this.d?.deleteAndDispose(ve),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$4c),this.d.set(ve,ke),this.a.set(fe,me)}return me.queue(re)}h(){this.g()&&this.j()}j(){for(const U of this.b)U.complete();this.b.clear()}dispose(){for(const[,U]of this.a)U.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$rh=F;class q{constructor(U,re){this.a=-1,typeof U=="function"&&typeof re=="number"&&this.setIfNotSet(U,re)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(U,re){this.cancel(),this.a=setTimeout(()=>{this.a=-1,U()},re)}setIfNotSet(U,re){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,U()},re))}}e.$sh=q;class x{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(U,re,ee=globalThis){this.cancel();const fe=ee.setInterval(()=>{U()},re);this.d=(0,M.$Sc)(()=>{ee.clearInterval(fe),this.d=void 0})}dispose(){this.cancel()}}e.$th=x;class le{constructor(U,re){this.b=-1,this.a=U,this.d=re,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(U=this.d){this.cancel(),this.b=setTimeout(this.f,U)}get delay(){return this.d}set delay(U){this.d=U}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$uh=le;class te{constructor(U,re){re%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${re}ms is not a multiple of 1000ms.`),this.a=U,this.b=re,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(U=this.b){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(U/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$vh=te;class ue extends le{constructor(U,re){super(U,re),this.j=[]}work(U){this.j.push(U),this.isScheduled()||this.schedule()}h(){const U=this.j;this.j=[],this.a?.(U)}dispose(){this.j=[],super.dispose()}}e.$wh=ue;class Y extends M.$Uc{constructor(U,re){super(),this.g=U,this.h=re,this.a=[],this.b=this.B(new M.$Vc),this.f=!1}get pending(){return this.a.length}work(U){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+U.length>this.g.maxBufferedWork)return!1}else if(this.pending+U.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const re of U)this.a.push(re);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new le(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$xh=Y,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$zh=(H,U)=>{(0,E.$B)(()=>{if(re)return;const ee=Date.now()+15;U(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ee-Date.now())}}))});let re=!1;return{dispose(){re||(re=!0)}}}:e.$zh=(H,U,re)=>{const ee=H.requestIdleCallback(U,typeof re=="number"?{timeout:re}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,H.cancelIdleCallback(ee))}}},e.$yh=H=>(0,e.$zh)(globalThis,H)}();class Z{constructor(U,re){this.g=!1,this.d=()=>{try{this.j=re()}catch(ee){this.l=ee}finally{this.g=!0}},this.f=(0,e.$zh)(U,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Ah=Z;class B extends Z{constructor(U){super(globalThis,U)}}e.$Bh=B;async function L(H,U,re){let ee;for(let fe=0;fe<re;fe++)try{return await H()}catch(me){ee=me,await u(U)}throw ee}class T{isRunning(U){return typeof U=="number"?this.a?.taskId===U:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(U,re,ee){return this.a={taskId:U,cancel:()=>ee?.(),promise:re},re.then(()=>this.d(U),()=>this.d(U)),re}d(U){this.a&&U===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const U=this.b;this.b=void 0,U.run().then(U.promiseResolve,U.promiseReject)}}queue(U){if(this.b)this.b.run=U;else{const{promise:re,resolve:ee,reject:fe}=$();this.b={run:U,promise:re,promiseResolve:ee,promiseReject:fe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Dh=T;class G{constructor(U,re=()=>Date.now()){this.d=U,this.f=re,this.a=0,this.b=0}increment(){const U=this.f();return U-this.a>this.d&&(this.a=U,this.b=0),this.b++,this.b}}e.$Eh=G;var z;(function(H){H[H.Resolved=0]="Resolved",H[H.Rejected=1]="Rejected"})(z||(z={}));class ce{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((U,re)=>{this.a=U,this.b=re})}complete(U){return new Promise(re=>{this.a(U),this.d={outcome:0,value:U},re()})}error(U){return new Promise(re=>{this.b(U),this.d={outcome:1,value:U},re()})}cancel(){return this.error(new j.$5)}}e.$Fh=ce;var he;(function(H){async function U(ee){let fe;const me=await Promise.all(ee.map(ve=>ve.then(ke=>ke,ke=>{fe||(fe=ke)})));if(typeof fe<"u")throw fe;return me}H.settled=U;function re(ee){return new Promise(async(fe,me)=>{try{await ee(fe,me)}catch(ve){me(ve)}})}H.withAsyncBody=re})(he||(e.Promises=he={}));class X{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(U){this.a=void 0,this.b=void 0,this.d=!1,this.promise=U.then(re=>(this.a=re,this.d=!0,re),re=>{throw this.b=re,this.d=!0,re})}requireValue(){if(!this.d)throw new j.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Gh=X;class A{constructor(U){this.b=U,this.a=new c.$V(()=>new X(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Hh=A;var N;(function(H){H[H.Initial=0]="Initial",H[H.DoneOK=1]="DoneOK",H[H.DoneError=2]="DoneError"})(N||(N={}));class _{static fromArray(U){return new _(re=>{re.emitMany(U)})}static fromPromise(U){return new _(async re=>{re.emitMany(await U)})}static fromPromises(U){return new _(async re=>{await Promise.all(U.map(async ee=>re.emitOne(await ee)))})}static merge(U){return new _(async re=>{await Promise.all(U.map(async ee=>{for await(const fe of ee)re.emitOne(fe)}))})}static{this.EMPTY=_.fromArray([])}constructor(U){this.a=0,this.b=[],this.d=null,this.f=new P.$7d,queueMicrotask(async()=>{const re={emitOne:ee=>this.g(ee),emitMany:ee=>this.h(ee),reject:ee=>this.k(ee)};try{await Promise.resolve(U(re)),this.j()}catch(ee){this.k(ee)}finally{re.emitOne=void 0,re.emitMany=void 0,re.reject=void 0}})}[Symbol.asyncIterator](){let U=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(U<this.b.length)return{done:!1,value:this.b[U++]};if(this.a===1)return{done:!0,value:void 0};await P.Event.toPromise(this.f.event)}while(!0)}}}static map(U,re){return new _(async ee=>{for await(const fe of U)ee.emitOne(re(fe))})}map(U){return _.map(this,U)}static filter(U,re){return new _(async ee=>{for await(const fe of U)re(fe)&&ee.emitOne(fe)})}filter(U){return _.filter(this,U)}static coalesce(U){return _.filter(U,re=>!!re)}coalesce(){return _.coalesce(this)}static async toPromise(U){const re=[];for await(const ee of U)re.push(ee);return re}toPromise(){return _.toPromise(this)}g(U){this.a===0&&(this.b.push(U),this.f.fire())}h(U){this.a===0&&(this.b=this.b.concat(U),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(U){this.a===0&&(this.a=2,this.d=U,this.f.fire())}}e.$Ih=_;class se extends _{constructor(U,re){super(re),this.l=U}cancel(){this.l.cancel()}}e.$Jh=se;function J(H){const U=new n.$ee,re=H(U.token);return new se(U,async ee=>{const fe=U.token.onCancellationRequested(()=>{fe.dispose(),U.dispose(),ee.reject(new j.$5)});try{for await(const me of re){if(U.token.isCancellationRequested)return;ee.emitOne(me)}fe.dispose(),U.dispose()}catch(me){fe.dispose(),U.dispose(),ee.reject(me)}})}class V{constructor(){this.a=new ce,this.b=new _(ee=>{if(U){ee.reject(U);return}return re&&ee.emitMany(re),this.d=fe=>ee.reject(fe),this.f=fe=>ee.emitOne(fe),this.a.p});let U,re;this.f=ee=>{re||(re=[]),re.push(ee)},this.d=ee=>{U||(U=ee)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(U){this.d(U),this.a.complete()}emitOne(U){this.f(U)}}e.$Lh=V}),define(oe[108],ae([0,1,22,8,31,32,9,4,25]),function(K,e,n,j,P,M,S,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_j=e.$$j=void 0,e.$0j=c,e.$ak=m,e.$bk=R,e.$ck=W,e.$dk=F,e.$ek=q,e.$fk=x,e.$gk=Y;function c(){return Object.create(null)}e.$$j="**",e.$_j="/";const p="[/\\\\]",y="[^/\\\\]",k=/\//g;function g(Z,B){switch(Z){case 0:return"";case 1:return`${y}*?`;default:return`(?:${p}|${y}+${p}${B?`|${p}${y}+`:""})*?`}}function m(Z,B){if(!Z)return[];const L=[];let T=!1,G=!1,z="";for(const ce of Z){switch(ce){case B:if(!T&&!G){L.push(z),z="";continue}break;case"{":T=!0;break;case"}":T=!1;break;case"[":G=!0;break;case"]":G=!1;break}z+=ce}return z&&L.push(z),L}function v(Z){if(!Z)return"";let B="";const L=m(Z,e.$_j);if(L.every(T=>T===e.$$j))B=".*";else{let T=!1;L.forEach((G,z)=>{if(G===e.$$j){if(T)return;B+=g(2,z===L.length-1)}else{let ce=!1,he="",X=!1,A="";for(const N of G){if(N!=="}"&&ce){he+=N;continue}if(X&&(N!=="]"||!A)){let _;N==="-"?_=N:(N==="^"||N==="!")&&!A?_="^":N===e.$_j?_="":_=(0,h.$Ze)(N),A+=_;continue}switch(N){case"{":ce=!0;continue;case"[":X=!0;continue;case"}":{const se=`(?:${m(he,",").map(J=>v(J)).join("|")})`;B+=se,ce=!1,he="";break}case"]":{B+="["+A+"]",X=!1,A="";break}case"?":B+=y;continue;case"*":B+=g(1);continue;default:B+=(0,h.$Ze)(N)}}z<L.length-1&&(L[z+1]!==e.$$j||z+2<L.length)&&(B+=p)}T=G===e.$$j})}return B}const w=/^\*\*\/\*\.[\w\.-]+$/,$=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,l=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.$Ec(1e4),o=function(){return!1},r=function(){return null};function i(Z,B){if(!Z)return r;let L;typeof Z!="string"?L=Z.pattern:L=Z,L=L.trim();const T=`${L}_${!!B.trimForExclusions}`;let G=t.get(T);if(G)return s(G,Z);let z;return w.test(L)?G=b(L.substr(4),L):(z=$.exec(u(L,B)))?G=C(z[1],L):(B.trimForExclusions?l:f).test(L)?G=I(L,B):(z=d.exec(u(L,B)))?G=D(z[1].substr(1),L,!0):(z=a.exec(u(L,B)))?G=D(z[1],L,!1):G=O(L),t.set(T,G),s(G,Z)}function s(Z,B){if(typeof B=="string")return Z;const L=function(T,G){return(0,P.$ig)(T,B.base,!E.$k)?Z((0,h.$5e)(T.substr(B.base.length),S.sep),G):null};return L.allBasenames=Z.allBasenames,L.allPaths=Z.allPaths,L.basenames=Z.basenames,L.patterns=Z.patterns,L}function u(Z,B){return B.trimForExclusions&&Z.endsWith("/**")?Z.substr(0,Z.length-2):Z}function b(Z,B){return function(L,T){return typeof L=="string"&&L.endsWith(Z)?B:null}}function C(Z,B){const L=`/${Z}`,T=`\\${Z}`,G=function(ce,he){return typeof ce!="string"?null:he?he===Z?B:null:ce===Z||ce.endsWith(L)||ce.endsWith(T)?B:null},z=[Z];return G.basenames=z,G.patterns=[B],G.allBasenames=z,G}function I(Z,B){const L=ue(Z.slice(1,-1).split(",").map(he=>i(he,B)).filter(he=>he!==r),Z),T=L.length;if(!T)return r;if(T===1)return L[0];const G=function(he,X){for(let A=0,N=L.length;A<N;A++)if(L[A](he,X))return Z;return null},z=L.find(he=>!!he.allBasenames);z&&(G.allBasenames=z.allBasenames);const ce=L.reduce((he,X)=>X.allPaths?he.concat(X.allPaths):he,[]);return ce.length&&(G.allPaths=ce),G}function D(Z,B,L){const T=S.sep===S.$hc.sep,G=T?Z:Z.replace(k,S.sep),z=S.sep+G,ce=S.$hc.sep+Z;let he;return L?he=function(X,A){return typeof X=="string"&&(X===G||X.endsWith(z)||!T&&(X===Z||X.endsWith(ce)))?B:null}:he=function(X,A){return typeof X=="string"&&(X===G||!T&&X===Z)?B:null},he.allPaths=[(L?"*/":"./")+Z],he}function O(Z){try{const B=new RegExp(`^${v(Z)}$`);return function(L){return B.lastIndex=0,typeof L=="string"&&B.test(L)?Z:null}}catch{return r}}function R(Z,B,L){return!Z||typeof B!="string"?!1:W(Z)(B,void 0,L)}function W(Z,B={}){if(!Z)return o;if(typeof Z=="string"||F(Z)){const L=i(Z,B);if(L===r)return o;const T=function(G,z){return!!L(G,z)};return L.allBasenames&&(T.allBasenames=L.allBasenames),L.allPaths&&(T.allPaths=L.allPaths),T}return le(Z,B)}function F(Z){const B=Z;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}function q(Z){return Z.allBasenames||[]}function x(Z){return Z.allPaths||[]}function le(Z,B){const L=ue(Object.getOwnPropertyNames(Z).map(he=>te(he,Z[he],B)).filter(he=>he!==r)),T=L.length;if(!T)return r;if(!L.some(he=>!!he.requiresSiblings)){if(T===1)return L[0];const he=function(N,_){let se;for(let J=0,V=L.length;J<V;J++){const H=L[J](N,_);if(typeof H=="string")return H;(0,j.$7g)(H)&&(se||(se=[]),se.push(H))}return se?(async()=>{for(const J of se){const V=await J;if(typeof V=="string")return V}return null})():null},X=L.find(N=>!!N.allBasenames);X&&(he.allBasenames=X.allBasenames);const A=L.reduce((N,_)=>_.allPaths?N.concat(_.allPaths):N,[]);return A.length&&(he.allPaths=A),he}const G=function(he,X,A){let N,_;for(let se=0,J=L.length;se<J;se++){const V=L[se];V.requiresSiblings&&A&&(X||(X=(0,S.$oc)(he)),N||(N=X.substr(0,X.length-(0,S.$pc)(he).length)));const H=V(he,X,N,A);if(typeof H=="string")return H;(0,j.$7g)(H)&&(_||(_=[]),_.push(H))}return _?(async()=>{for(const se of _){const J=await se;if(typeof J=="string")return J}return null})():null},z=L.find(he=>!!he.allBasenames);z&&(G.allBasenames=z.allBasenames);const ce=L.reduce((he,X)=>X.allPaths?he.concat(X.allPaths):he,[]);return ce.length&&(G.allPaths=ce),G}function te(Z,B,L){if(B===!1)return r;const T=i(Z,L);if(T===r)return r;if(typeof B=="boolean")return T;if(B){const G=B.when;if(typeof G=="string"){const z=(ce,he,X,A)=>{if(!A||!T(ce,he))return null;const N=G.replace("$(basename)",()=>X),_=A(N);return(0,j.$7g)(_)?_.then(se=>se?Z:null):_?Z:null};return z.requiresSiblings=!0,z}}return T}function ue(Z,B){const L=Z.filter(he=>!!he.basenames);if(L.length<2)return Z;const T=L.reduce((he,X)=>{const A=X.basenames;return A?he.concat(A):he},[]);let G;if(B){G=[];for(let he=0,X=T.length;he<X;he++)G.push(B)}else G=L.reduce((he,X)=>{const A=X.patterns;return A?he.concat(A):he},[]);const z=function(he,X){if(typeof he!="string")return null;if(!X){let N;for(N=he.length;N>0;N--){const _=he.charCodeAt(N-1);if(_===47||_===92)break}X=he.substr(N)}const A=T.indexOf(X);return A!==-1?G[A]:null};z.basenames=T,z.patterns=G,z.allBasenames=T;const ce=Z.filter(he=>!he.basenames);return ce.push(z),ce}function Y(Z,B){return(0,n.$ub)(Z,B,(L,T)=>typeof L=="string"&&typeof T=="string"?L===T:typeof L!="string"&&typeof T!="string"?L.base===T.base&&L.pattern===T.pattern:!1)}}),define(oe[48],ae([0,1,22,31,9,4,19,25]),function(K,e,n,j,P,M,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gw=h,e.$hw=p,e.$iw=k,e.$jw=g,e.$kw=$,e.$lw=l,e.$mw=d,e.$nw=a,e.$ow=t,e.$pw=o;function h(i,s){const{os:u,tildify:b,relative:C}=s;if(C){const O=c(i,C,u);if(typeof O=="string")return O}let I=i.fsPath;if(u===1&&!M.$i?I=I.replace(/\//g,"\\"):u!==1&&M.$i&&(I=I.replace(/\\/g,"/")),u!==1&&b?.userHome){const O=b.userHome.fsPath;let R;i.scheme!==b.userHome.scheme&&i.path[0]===P.$hc.sep&&i.path[1]!==P.$hc.sep?R=b.userHome.with({path:i.path}).fsPath:R=I,I=k(R,O,u)}return(u===1?P.$gc:P.$hc).normalize(p(I,u===1))}function c(i,s,u){const b=u===1?P.$gc:P.$hc,C=u===3?S.$Lg:S.$Ng,I=s.getWorkspace(),D=(0,n.$Ob)(I.folders);if(!D)return;i.scheme!==D.uri.scheme&&i.path[0]===P.$hc.sep&&i.path[1]!==P.$hc.sep&&(i=D.uri.with({path:i.path}));const O=s.getWorkspaceFolder(i);if(!O)return;let R;if(C.isEqual(O.uri,i)?R="":R=C.relativePath(O.uri,i)??"",R&&(R=b.normalize(R)),I.folders.length>1&&!s.noPrefix){const W=O.name?O.name:C.basenameOrAuthority(O.uri);R=R?`${W} \u2022 ${R}`:W}return R}function p(i,s=M.$i){return(0,j.$mg)(i,s)?i.charAt(0).toUpperCase()+i.slice(1):i}let y=Object.create(null);function k(i,s,u=M.OS){if(u===1||!i||!s)return i;let b=y.original===s?y.normalized:void 0;b||(b=s,M.$i&&(b=(0,j.$cg)(b)),b=`${(0,E.$6e)(b,P.$hc.sep)}${P.$hc.sep}`,y={original:s,normalized:b});let C=i;return M.$i&&(C=(0,j.$cg)(C)),(u===3?C.startsWith(b):(0,E.$mf)(C,b))?`~/${C.substr(b.length)}`:i}function g(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}const m="\u2026",v="\\\\",w="~";function $(i,s=P.sep){const u=new Array(i.length);let b=!1;for(let C=0;C<i.length;C++){const I=i[C];if(I===""){u[C]=`.${s}`;continue}if(!I){u[C]=I;continue}b=!0;let D="",O=I;O.indexOf(v)===0?(D=O.substr(0,O.indexOf(v)+v.length),O=O.substr(O.indexOf(v)+v.length)):O.indexOf(s)===0?(D=O.substr(0,O.indexOf(s)+s.length),O=O.substr(O.indexOf(s)+s.length)):O.indexOf(w)===0&&(D=O.substr(0,O.indexOf(w)+w.length),O=O.substr(O.indexOf(w)+w.length));const R=O.split(s);for(let W=1;b&&W<=R.length;W++)for(let F=R.length-W;b&&F>=0;F--){b=!1;let q=R.slice(F,F+W).join(s);for(let x=0;!b&&x<i.length;x++)if(x!==C&&i[x]&&i[x].indexOf(q)>-1){const le=F+W===R.length,te=F>0&&i[x].indexOf(s)>-1?s+q:q,ue=i[x].endsWith(te);b=!le||ue}if(!b){let x="";(R[0].endsWith(":")||D!=="")&&(F===1&&(F=0,W++,q=R[0]+s+q),F>0&&(x=R[0]+s),x=D+x),F>0&&(x=x+m+s),x=x+q,F+W<R.length&&(x=x+s+m),u[C]=x}}b&&(u[C]=I)}return u}var f;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function l(i,s=Object.create(null)){const u=[];let b=!1,C="";for(const I of i)if(I==="$"||b&&I==="{")C&&u.push({value:C,type:f.TEXT}),C="",b=!0;else if(I==="}"&&b){const D=s[C];if(typeof D=="string")D.length&&u.push({value:D,type:f.VARIABLE});else if(D){const O=u[u.length-1];(!O||O.type!==f.SEPARATOR)&&u.push({value:D.label,type:f.SEPARATOR})}C="",b=!1}else C+=I;return C&&!b&&u.push({value:C,type:f.TEXT}),u.filter((I,D)=>{if(I.type===f.SEPARATOR){const O=u[D-1],R=u[D+1];return[O,R].every(W=>W&&(W.type===f.VARIABLE||W.type===f.TEXT)&&W.value.length>0)}return!0}).map(I=>I.value).join("")}function d(i,s){return M.$j||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):i.replace(/&&|&/g,u=>u==="&"?"&&":"&")}function a(i,s){return M.$j||s?i.replace(/\(&&\w\)|&&/g,""):M.$i?i.replace(/&&|&/g,u=>u==="&"?"&&":"&"):i.replace(/&&/g,"_")}function t(i){return i.replace(/&/g,"&&")}function o(i){if(i.endsWith("]")){const s=i.lastIndexOf(" [",i.length-2);if(s!==-1){const u=r(i.substring(0,s)),b=i.substring(s);return{name:u.name+b,parentPath:u.parentPath}}}return r(i)}function r(i){const s=i.indexOf("/")!==-1?P.$hc:P.$gc,u=s.basename(i),b=s.dirname(i);return u.length?{name:u,parentPath:b}:{name:b,parentPath:""}}}),define(oe[157],ae([0,1,17,7]),function(K,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=void 0,e.$mn=E,e.$nn=c,e.$on=p;function P(y){return y.toJSON()}class M{constructor(k){this.a=k}transformIncoming(k){const g=this.a.transformIncoming(k);return g===k?k:P(j.URI.from(g))}transformOutgoing(k){const g=this.a.transformOutgoing(k);return g===k?k:P(j.URI.from(g))}transformOutgoingURI(k){const g=this.a.transformOutgoing(k);return g===k?k:j.URI.from(g)}transformOutgoingScheme(k){return this.a.transformOutgoingScheme(k)}}e.$kn=M,e.$ln=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function S(y,k,g){if(!y||g>200)return null;if(typeof y=="object"){if(y instanceof j.URI)return k.transformOutgoing(y);for(const m in y)if(Object.hasOwnProperty.call(y,m)){const v=S(y[m],k,g+1);v!==null&&(y[m]=v)}}return null}function E(y,k){const g=S(y,k,0);return g===null?y:g}function h(y,k,g,m){if(!y||m>200)return null;if(typeof y=="object"){if(y.$mid===1)return g?j.URI.revive(k.transformIncoming(y)):k.transformIncoming(y);if(y instanceof n.$ue)return null;for(const v in y)if(Object.hasOwnProperty.call(y,v)){const w=h(y[v],k,g,m+1);w!==null&&(y[v]=w)}}return null}function c(y,k){const g=h(y,k,!1,0);return g===null?y:g}function p(y,k){const g=h(y,k,!0,0);return g===null?y:g}}),define(oe[89],ae([0,1,26,59,33,147,4]),function(K,e,n,j,P,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=void 0,e.$rn=h,e.$sn=y,e.$qn=new class{c(k){return this.a||(this.a=j.$oi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(k)}value(){if(this.b===void 0){let k=0,g=0;const m=(0,n.networkInterfaces)();for(const v in m){const w=m[v];if(w)for(const{mac:$,internal:f}of w)f||(g+=1,this.c($.toUpperCase())&&(k+=1))}this.b=g>0?k/g:0}return this.b}};let E;async function h(k){return E||(E=(async()=>await c(k)||P.$Eg())()),E}async function c(k){try{const g=await new Promise((v,w)=>{K(["crypto"],v,w)}),m=(0,M.$pn)();return g.createHash("sha256").update(m,"utf8").digest("hex")}catch(g){k(g);return}}const p="Software\\Microsoft\\SQMClient";async function y(k){if(S.$i){const g=await new Promise((m,v)=>{K(["@vscode/windows-registry"],m,v)});try{return g.GetStringRegKey("HKEY_LOCAL_MACHINE",p,"MachineId")||""}catch(m){return k(m),""}}return""}}),define(oe[21],ae([0,1,43,26,158,8,31,86,9,4,19,7]),function(K,e,n,j,P,M,S,E,h,c,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=w,e.readdirSync=l,e.whenDeleted=t,e.configureFlushOnWrite=u,e.writeFileSync=C;var k;(function(te){te[te.UNLINK=0]="UNLINK",te[te.MOVE=1]="MOVE"})(k||(e.RimRafMode=k={}));async function g(te,ue=k.UNLINK,Y){if((0,S.$lg)(te))throw new Error("rimraf - will refuse to recursively delete root");return ue===k.UNLINK?v(te):m(te,Y)}async function m(te,ue=(0,S.$qg)((0,j.tmpdir)())){try{try{await n.promises.rename(te,ue)}catch(Y){return Y.code==="ENOENT"?void 0:v(te)}v(ue).catch(Y=>{})}catch(Y){if(Y.code!=="ENOENT")throw Y}}async function v(te){return(0,P.promisify)(n.rm)(te,{recursive:!0,force:!0,maxRetries:3})}function w(te){if((0,S.$lg)(te))throw new Error("rimraf - will refuse to recursively delete root");n.rmSync(te,{recursive:!0,force:!0,maxRetries:3})}async function $(te,ue){return d(await(ue?f(te):(0,P.promisify)(n.readdir)(te)))}async function f(te){try{return await(0,P.promisify)(n.readdir)(te,{withFileTypes:!0})}catch(Z){console.warn("[node.js fs] readdir with filetypes failed with error: ",Z)}const ue=[],Y=await $(te);for(const Z of Y){let B=!1,L=!1,T=!1;try{const G=await e.Promises.lstat((0,h.$kc)(te,Z));B=G.isFile(),L=G.isDirectory(),T=G.isSymbolicLink()}catch(G){console.warn("[node.js fs] unexpected error from lstat after readdir: ",G)}ue.push({name:Z,isFile:()=>B,isDirectory:()=>L,isSymbolicLink:()=>T})}return ue}function l(te){return d(n.readdirSync(te))}function d(te){return te.map(ue=>typeof ue=="string"?c.$j?(0,E.$Zl)(ue):ue:(ue.name=c.$j?(0,E.$Zl)(ue.name):ue.name,ue))}async function a(te){const ue=await $(te),Y=[];for(const Z of ue)await o.existsDirectory((0,h.$kc)(te,Z))&&Y.push(Z);return Y}function t(te,ue=1e3){return new Promise(Y=>{let Z=!1;const B=setInterval(()=>{Z||(Z=!0,n.access(te,L=>{Z=!1,L&&(clearInterval(B),Y(void 0))}))},ue)})}var o;(function(te){async function ue(B){let L;try{if(L=await e.Promises.lstat(B),!L.isSymbolicLink())return{stat:L}}catch{}try{return{stat:await e.Promises.stat(B),symbolicLink:L?.isSymbolicLink()?{dangling:!1}:void 0}}catch(T){if(T.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};if(c.$i&&T.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(G){if(G.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};throw G}throw T}}te.stat=ue;async function Y(B){try{const{stat:L,symbolicLink:T}=await te.stat(B);return L.isFile()&&T?.dangling!==!0}catch{}return!1}te.existsFile=Y;async function Z(B){try{const{stat:L,symbolicLink:T}=await te.stat(B);return L.isDirectory()&&T?.dangling!==!0}catch{}return!1}te.existsDirectory=Z})(o||(e.SymlinkSupport=o={}));const r=new M.$rh;function i(te,ue,Y){return r.queueFor(y.URI.file(te),()=>{const Z=I(Y);return new Promise((B,L)=>b(te,ue,Z,T=>T?L(T):B()))},p.$Mg)}let s=!0;function u(te){s=te}function b(te,ue,Y,Z){if(!s)return n.writeFile(te,ue,{mode:Y.mode,flag:Y.flag},Z);n.open(te,Y.flag,Y.mode,(B,L)=>{if(B)return Z(B);n.writeFile(L,ue,T=>{if(T)return n.close(L,()=>Z(T));n.fdatasync(L,G=>(G&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",G),u(!1)),n.close(L,z=>Z(z))))})})}function C(te,ue,Y){const Z=I(Y);if(!s)return n.writeFileSync(te,ue,{mode:Z.mode,flag:Z.flag});const B=n.openSync(te,Z.flag,Z.mode);try{n.writeFileSync(B,ue);try{n.fdatasyncSync(B)}catch(L){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",L),u(!1)}}finally{n.closeSync(B)}}function I(te){return te?{mode:typeof te.mode=="number"?te.mode:438,flag:typeof te.flag=="string"?te.flag:"w"}:{mode:438,flag:"w"}}async function D(te,ue,Y=6e4){if(te!==ue)try{c.$i&&typeof Y=="number"?await O(te,ue,Date.now(),Y):await(0,P.promisify)(n.rename)(te,ue)}catch(Z){if(te.toLowerCase()!==ue.toLowerCase()&&Z.code==="EXDEV"||te.endsWith("."))await R(te,ue,{preserveSymlinks:!1}),await g(te,k.MOVE);else throw Z}}async function O(te,ue,Y,Z,B=0){try{return await(0,P.promisify)(n.rename)(te,ue)}catch(L){if(L.code!=="EACCES"&&L.code!=="EPERM"&&L.code!=="EBUSY")throw L;if(Date.now()-Y>=Z)throw console.error(`[node.js fs] rename failed after ${B} retries with error: ${L}`),L;if(B===0){let T=!1;try{const{stat:G}=await o.stat(ue);G.isFile()||(T=!0)}catch{}if(T)throw L}return await(0,M.$jh)(Math.min(100,B*10)),O(te,ue,Y,Z,B+1)}}async function R(te,ue,Y){return F(te,ue,{root:{source:te,target:ue},options:Y,handledSourcePaths:new Set})}const W=511;async function F(te,ue,Y){if(Y.handledSourcePaths.has(te))return;Y.handledSourcePaths.add(te);const{stat:Z,symbolicLink:B}=await o.stat(te);if(B){if(Y.options.preserveSymlinks)try{return await le(te,ue,Y)}catch{}if(B.dangling)return}return Z.isDirectory()?q(te,ue,Z.mode&W,Y):x(te,ue,Z.mode&W)}async function q(te,ue,Y,Z){await e.Promises.mkdir(ue,{recursive:!0,mode:Y});const B=await $(te);for(const L of B)await F((0,h.$kc)(te,L),(0,h.$kc)(ue,L),Z)}async function x(te,ue,Y){await e.Promises.copyFile(te,ue),await e.Promises.chmod(ue,Y)}async function le(te,ue,Y){let Z=await e.Promises.readlink(te);(0,S.$ig)(Z,Y.root.source,!c.$k)&&(Z=(0,h.$kc)(Y.root.target,Z.substr(Y.root.source.length+1))),await e.Promises.symlink(Z,ue)}e.Promises=new class{get access(){return(0,P.promisify)(n.access)}get stat(){return(0,P.promisify)(n.stat)}get lstat(){return(0,P.promisify)(n.lstat)}get utimes(){return(0,P.promisify)(n.utimes)}get read(){return(te,ue,Y,Z,B)=>new Promise((L,T)=>{n.read(te,ue,Y,Z,B,(G,z,ce)=>G?T(G):L({bytesRead:z,buffer:ce}))})}get readFile(){return(0,P.promisify)(n.readFile)}get write(){return(te,ue,Y,Z,B)=>new Promise((L,T)=>{n.write(te,ue,Y,Z,B,(G,z,ce)=>G?T(G):L({bytesWritten:z,buffer:ce}))})}get appendFile(){return(0,P.promisify)(n.appendFile)}get fdatasync(){return(0,P.promisify)(n.fdatasync)}get truncate(){return(0,P.promisify)(n.truncate)}get copyFile(){return(0,P.promisify)(n.copyFile)}get open(){return(0,P.promisify)(n.open)}get close(){return(0,P.promisify)(n.close)}get symlink(){return(0,P.promisify)(n.symlink)}get readlink(){return(0,P.promisify)(n.readlink)}get chmod(){return(0,P.promisify)(n.chmod)}get mkdir(){return(0,P.promisify)(n.mkdir)}get unlink(){return(0,P.promisify)(n.unlink)}get rmdir(){return(0,P.promisify)(n.rmdir)}get realpath(){return(0,P.promisify)(n.realpath)}async exists(te){try{return await e.Promises.access(te),!0}catch{return!1}}get readdir(){return $}get readDirsInDir(){return a}get writeFile(){return i}get rm(){return g}get rename(){return D}get copy(){return R}}}),define(oe[109],ae([0,1,43,9,4,25,21]),function(K,e,n,j,P,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=E,e.$Oq=h,e.$Pq=c,e.$Qq=p;function E(k){if(P.$k)return k;const g=(0,j.$nc)(k);if(k===g)return k;const m=((0,j.$oc)(k)||k).toLowerCase();try{const w=(0,S.readdirSync)(g).filter($=>$.toLowerCase()===m);if(w.length===1){const $=E(g);if($)return(0,j.$kc)($,w[0])}else if(w.length>1){const $=w.indexOf(m);if($>=0){const f=E(g);if(f)return(0,j.$kc)(f,w[$])}}}catch{}return null}async function h(k,g){if(P.$k)return k;const m=(0,j.$nc)(k);if(k===m)return k;const v=((0,j.$oc)(k)||k).toLowerCase();try{if(g?.isCancellationRequested)return null;const $=(await S.Promises.readdir(m)).filter(f=>f.toLowerCase()===v);if($.length===1){const f=await h(m,g);if(f)return(0,j.$kc)(f,$[0])}else if($.length>1){const f=$.indexOf(v);if(f>=0){const l=await h(m,g);if(l)return(0,j.$kc)(l,$[f])}}}catch{}return null}async function c(k){try{return await S.Promises.realpath(k)}catch{const m=y(k);return await S.Promises.access(m,n.constants.R_OK),m}}function p(k){try{return n.realpathSync(k)}catch{const m=y(k);return n.accessSync(m,n.constants.R_OK),m}}function y(k){return(0,M.$6e)((0,j.$ic)(k),j.sep)}}),define(oe[110],ae([0,1,26,9,21]),function(K,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=f,e.$0l=l;const M=/^\d+$/,S=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var h;(function(d){d[d.x64=0]="x64",d[d.x86=1]="x86",d[d.ARM=2]="ARM"})(h||(h={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let p;process.env.PROCESSOR_ARCHITEW6432?p=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?p=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?p=1:p=0;class y{constructor(a,t,o){this.exePath=a,this.displayName=t,this.a=o}async exists(){return this.a===void 0&&(this.a=await P.SymlinkSupport.existsFile(this.exePath)),this.a}}function k({useAlternateBitness:d=!1}={}){return d?c===0?process.env["ProgramFiles(x86)"]||null:p===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:d=!1,findPreview:a=!1}={}){const t=k({useAlternateBitness:d});if(!t)return null;const o=j.$kc(t,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(o))return null;let r=-1,i=null;for(const b of await P.Promises.readdir(o)){let C=-1;if(a){const D=b.indexOf("-");if(D<0)continue;const O=b.substring(0,D);if(!M.test(O)||b.substring(D+1)!=="preview")continue;C=parseInt(O,10)}else{if(!M.test(b))continue;C=parseInt(b,10)}if(C<=r)continue;const I=j.$kc(o,b,"pwsh.exe");await P.SymlinkSupport.existsFile(I)&&(i=I,r=C)}if(!i)return null;const s=t.includes("x86")?" (x86)":"",u=a?" Preview":"";return new y(i,`PowerShell${u}${s}`,!0)}async function m({findPreview:d}={}){if(!process.env.LOCALAPPDATA)return null;const a=j.$kc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=d?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:S,pwshMsixName:"PowerShell (Store)"};for(const r of await P.Promises.readdir(a))if(t.test(r)){const i=j.$kc(a,r,"pwsh.exe");return new y(i,o)}return null}function v(){const d=j.$kc(n.homedir(),".dotnet","tools","pwsh.exe");return new y(d,".NET Core PowerShell Global Tool")}function w(){const d=j.$kc(process.env.windir,c===1&&p!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(d,"Windows PowerShell",!0)}async function*$(){let d=await g();d&&(yield d),d=await g({useAlternateBitness:!0}),d&&(yield d),d=await m(),d&&(yield d),d=v(),d&&(yield d),d=await g({findPreview:!0}),d&&(yield d),d=await m({findPreview:!0}),d&&(yield d),d=await g({useAlternateBitness:!0,findPreview:!0}),d&&(yield d),d=w(),d&&(yield d)}async function*f(){for await(const d of $())await d.exists()&&(yield d)}async function l(){for await(const d of f())return d;return null}}),define(oe[90],ae([0,1,9,4,36,75,12,21]),function(K,e,n,j,P,M,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$am=h,e.$bm=c,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function h(y=P.env){return y.comspec||"cmd.exe"}function c(y){let k=[],g=!1;const m=function(v){if(g){k.push(v);return}(!y.send(v,$=>{if($&&console.error($),g=!1,k.length>0){const f=k.slice(0);k=[],f.forEach(l=>m(l))}})||j.$i)&&(g=!0)};return{send:m}}var p;(function(y){async function k(g,m,v){if(n.$jc(g))return g;if(m===void 0&&(m=P.cwd()),n.$nc(g)!=="."||(v===void 0&&S.$Vf(P.env.PATH)&&(v=P.env.PATH.split(n.$uc)),v===void 0||v.length===0))return n.$kc(m,g);async function $(f){if(await E.Promises.exists(f)){let l;try{l=await E.Promises.stat(f)}catch(d){d.message.startsWith("EACCES")&&(l=await E.Promises.lstat(f))}return l?!l.isDirectory():!1}return!1}for(const f of v){let l;if(n.$jc(f)?l=n.$kc(f,g):l=n.$kc(m,f,g),await $(l))return l;let d=l+".com";if(await $(d)||(d=l+".exe",await $(d)))return d}return n.$kc(m,g)}y.findExecutable=k})(p||(e.win32=p={}))}),define(oe[111],ae([0,1,49,13]),function(K,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=P;function P(S){return new Promise((E,h)=>{let c;const p=new Map;function y(g,m,v,w,$){const f=p.get(m);if(g===S||f){const l={name:k(v),cmd:v,pid:g,ppid:m,load:w,mem:$};p.set(g,l),g===S&&(c=l),f&&(f.children||(f.children=[]),f.children.push(l),f.children.length>1&&(f.children=f.children.sort((d,a)=>d.pid-a.pid)))}}function k(g){const m=/--utility-sub-type=network/i,v=/--crashes-directory/i,w=/\\pipe\\winpty-control/i,$=/conhost\.exe.+--headless/i,f=/--type=([a-zA-Z-]+)/;if(v.exec(g))return"electron-crash-reporter";if(w.exec(g))return"winpty-agent";if($.exec(g))return"conpty-agent";let l=f.exec(g);if(l&&l.length===2)return l[1]==="renderer"?"window":l[1]==="utility"?m.exec(g)?"utility-network-service":"utility-process":l[1]==="extensionHost"?"extension-host":l[1];const d=/[a-zA-Z-]+\.js/g;let a="";do l=d.exec(g),l&&(a+=l+" ");while(l);return a&&g.indexOf("node ")<0&&g.indexOf("node.exe")<0?`electron-nodejs (${a})`:g}if(process.platform==="win32"){const g=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substring(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substring(5):m;new Promise((m,v)=>{K(["@vscode/windows-process-tree"],m,v)}).then(m=>{m.getProcessList(S,v=>{if(!v){h(new Error(`Root process ${S} not found`));return}m.getProcessCpuUsage(v,w=>{const $=new Map;w.forEach(f=>{const l=g(f.commandLine||"");$.set(f.pid,{name:k(l),cmd:l,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),c=$.get(S),c?($.forEach(f=>{const l=$.get(f.ppid);l&&(l.children||(l.children=[]),l.children.push(f))}),$.forEach(f=>{f.children&&(f.children=f.children.sort((l,d)=>l.pid-d.pid))}),E(c)):h(new Error(`Root process ${S} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{let g=function(){let m=[c];const v=[];for(;m.length;){const $=m.shift();$&&(v.push($.pid),$.children&&(m=m.concat($.children)))}let w=JSON.stringify(j.$Cg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);w+=" "+v.join(" "),(0,n.exec)(w,{},($,f,l)=>{if($||l)h($||new Error(l.toString()));else{const d=f.toString().split(`
`);for(let a=0;a<v.length;a++){const t=p.get(v[a]);t.load=parseFloat(d[a])}if(!c){h(new Error(`Root process ${S} not found`));return}E(c)}})};(0,n.exec)("which ps",{},(m,v,w)=>{if(m||w)if(process.platform!=="linux")h(m||new Error(w.toString()));else{const $=JSON.stringify(j.$Cg.asFileUri("vs/base/node/ps.sh").fsPath);(0,n.exec)($,{},(f,l,d)=>{f||d?h(f||new Error(d.toString())):(M(l,y),g())})}else{const $=v.toString().trim();(0,n.exec)(`${$} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(l,d,a)=>{l||a&&!a.includes("screen size is bogus")?h(l||new Error(a.toString())):(M(d,y),process.platform==="linux"?g():c?E(c):h(new Error(`Root process ${S} not found`)))})}})}})}function M(S,E){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,c=S.toString().split(`
`);for(const p of c){const y=h.exec(p.trim());y&&y.length===6&&E(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(oe[112],ae([0,1,26,4,110,90]),function(K,e,n,j,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cm=S;async function S(y,k){return y===1?j.$i?p():M.$am(k):h(y,k)}let E=null;function h(y,k){if(j.$k&&y===2||j.$j&&y===3)return"/bin/bash";if(!E){let g;if(j.$i)g="/bin/bash";else{if(g=k.SHELL,!g)try{g=(0,n.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}E=g}return E}let c=null;async function p(){return c||(c=(await(0,P.$0l)()).exePath),c}});var Ee=this&&this.__decorate||function(K,e,n,j){var P=arguments.length,M=P<3?e:j===null?j=Object.getOwnPropertyDescriptor(e,n):j,S;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(K,e,n,j);else for(var E=K.length-1;E>=0;E--)(S=K[E])&&(M=(P<3?S(M):P>3?S(e,n,M):S(e,n))||M);return P>3&&M&&Object.defineProperty(e,n,M),M};define(oe[44],ae([0,1,22,8,17,23,51,15,3,2,76,25,12]),function(K,e,n,j,P,M,S,E,h,c,p,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.ProxyChannel=e.$3h=e.$Zh=e.$Yh=e.$Xh=e.RequestInitiator=e.$Wh=e.$Th=e.$Sh=void 0,e.$Uh=u,e.$Vh=b,e.$1h=W,e.$2h=F;var g;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(g||(g={}));function m(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(v||(v={}));function w(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var $;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})($||($={}));function f(B){let L=0;for(let T=0;;T+=7){const G=B.read(1);if(L|=(G.buffer[0]&127)<<T,!(G.buffer[0]&128))return L}}const l=r(0);function d(B,L){if(L===0){B.write(l);return}let T=0;for(let z=L;z!==0;z=z>>>7)T++;const G=P.$ue.alloc(T);for(let z=0;L!==0;z++)G.buffer[z]=L&127,L=L>>>7,L>0&&(G.buffer[z]|=128);B.write(G)}class a{constructor(L){this.b=L,this.a=0}read(L){const T=this.b.slice(this.a,this.a+L);return this.a+=T.byteLength,T}}e.$Sh=a;class t{constructor(){this.a=[]}get buffer(){return P.$ue.concat(this.a)}write(L){this.a.push(L)}}e.$Th=t;var o;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(o||(o={}));function r(B){const L=P.$ue.alloc(1);return L.writeUInt8(B,0),L}const i={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object),Uint:r(o.Int)},s=typeof Buffer<"u";function u(B,L){if(typeof L>"u")B.write(i.Undefined);else if(typeof L=="string"){const T=P.$ue.fromString(L);B.write(i.String),d(B,T.byteLength),B.write(T)}else if(s&&Buffer.isBuffer(L)){const T=P.$ue.wrap(L);B.write(i.Buffer),d(B,T.byteLength),B.write(T)}else if(L instanceof P.$ue)B.write(i.VSBuffer),d(B,L.byteLength),B.write(L);else if(Array.isArray(L)){B.write(i.Array),d(B,L.length);for(const T of L)u(B,T)}else if(typeof L=="number"&&(L|0)===L)B.write(i.Uint),d(B,L);else{const T=P.$ue.fromString(JSON.stringify(L));B.write(i.Object),d(B,T.byteLength),B.write(T)}}function b(B){switch(B.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return B.read(f(B)).toString();case o.Buffer:return B.read(f(B)).buffer;case o.VSBuffer:return B.read(f(B));case o.Array:{const T=f(B),G=[];for(let z=0;z<T;z++)G.push(b(B));return G}case o.Object:return JSON.parse(B.read(f(B)).toString());case o.Int:return f(B)}}class C{constructor(L,T,G=null,z=1e3){this.h=L,this.j=T,this.k=G,this.l=z,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ce=>this.q(ce)),this.m({type:200})}registerChannel(L,T){this.b.set(L,T),setTimeout(()=>this.w(L),0)}m(L){switch(L.type){case 200:{const T=this.o([L.type]);this.k?.logOutgoing(T,0,1,w(L.type));return}case 201:case 202:case 204:case 203:{const T=this.o([L.type,L.id],L.data);this.k?.logOutgoing(T,L.id,1,w(L.type),L.data);return}}}o(L,T=void 0){const G=new t;return u(G,L),u(G,T),this.p(G.buffer)}p(L){try{return this.h.send(L),L.byteLength}catch{return 0}}q(L){const T=new a(L),G=b(T),z=b(T),ce=G[0];switch(ce){case 100:return this.k?.logIncoming(L.byteLength,G[1],1,`${m(ce)}: ${G[2]}.${G[3]}`,z),this.s({type:ce,id:G[1],channelName:G[2],name:G[3],arg:z});case 102:return this.k?.logIncoming(L.byteLength,G[1],1,`${m(ce)}: ${G[2]}.${G[3]}`,z),this.t({type:ce,id:G[1],channelName:G[2],name:G[3],arg:z});case 101:return this.k?.logIncoming(L.byteLength,G[1],1,`${m(ce)}`),this.u({type:ce,id:G[1]});case 103:return this.k?.logIncoming(L.byteLength,G[1],1,`${m(ce)}`),this.u({type:ce,id:G[1]})}}s(L){const T=this.b.get(L.channelName);if(!T){this.v(L);return}const G=new M.$ee;let z;try{z=T.call(this.j,L.name,L.arg,G.token)}catch(X){z=Promise.reject(X)}const ce=L.id;z.then(X=>{this.m({id:ce,data:X,type:201})},X=>{X instanceof Error?this.m({id:ce,data:{message:X.message,name:X.name,stack:X.stack?X.stack.split?X.stack.split(`
`):X.stack:void 0},type:202}):this.m({id:ce,data:X,type:203})}).finally(()=>{he.dispose(),this.d.delete(L.id)});const he=(0,c.$Sc)(()=>G.cancel());this.d.set(L.id,he)}t(L){const T=this.b.get(L.channelName);if(!T){this.v(L);return}const G=L.id,ce=T.listen(this.j,L.name,L.arg)(he=>this.m({id:G,data:he,type:204}));this.d.set(L.id,ce)}u(L){const T=this.d.get(L.id);T&&(T.dispose(),this.d.delete(L.id))}v(L){let T=this.g.get(L.channelName);T||(T=[],this.g.set(L.channelName,T));const G=setTimeout(()=>{console.error(`Unknown channel: ${L.channelName}`),L.type===100&&this.m({id:L.id,data:{name:"Unknown channel",message:`Channel name '${L.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);T.push({request:L,timeoutTimer:G})}w(L){const T=this.g.get(L);if(T){for(const G of T)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.s(G.request);break;case 102:this.t(G.request);break}this.g.delete(L)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Pc)(this.d.values()),this.d.clear()}}e.$Wh=C;var I;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class D{constructor(L,T=null){this.l=L,this.a=!1,this.b=$.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$7d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(G=>this.s(G)),this.j=T}getChannel(L){const T=this;return{call(G,z,ce){return T.a?Promise.reject(new E.$5):T.m(L,G,z,ce)},listen(G,z){return T.a?h.Event.None:T.o(L,G,z)}}}m(L,T,G,z=M.CancellationToken.None){const ce=this.g++,X={id:ce,type:100,channelName:L,name:T,arg:G};if(z.isCancellationRequested)return Promise.reject(new E.$5);let A;return new Promise((_,se)=>{if(z.isCancellationRequested)return se(new E.$5);const J=()=>{const re=ee=>{switch(ee.type){case 201:this.f.delete(ce),_(ee.data);break;case 202:{this.f.delete(ce);const fe=new Error(ee.data.message);fe.stack=Array.isArray(ee.data.stack)?ee.data.stack.join(`
`):ee.data.stack,fe.name=ee.data.name,se(fe);break}case 203:this.f.delete(ce),se(ee.data);break}};this.f.set(ce,re),this.p(X)};let V=null;this.b===$.Idle?J():(V=(0,j.$8g)(re=>this.u()),V.then(()=>{V=null,J()}));const H=()=>{V?(V.cancel(),V=null):this.p({id:ce,type:101}),se(new E.$5)},U=z.onCancellationRequested(H);A=(0,c.$Rc)((0,c.$Sc)(H),U),this.d.add(A)}).finally(()=>{A.dispose(),this.d.delete(A)})}o(L,T,G){const z=this.g++,he={id:z,type:102,channelName:L,name:T,arg:G};let X=null;const A=new h.$7d({onWillAddFirstListener:()=>{X=(0,j.$8g)(_=>this.u()),X.then(()=>{X=null,this.d.add(A),this.p(he)})},onDidRemoveLastListener:()=>{X?(X.cancel(),X=null):(this.d.delete(A),this.p({id:z,type:103}))}}),N=_=>A.fire(_.data);return this.f.set(z,N),A.event}p(L){switch(L.type){case 100:case 102:{const T=this.q([L.type,L.id,L.channelName,L.name],L.arg);this.j?.logOutgoing(T,L.id,0,`${m(L.type)}: ${L.channelName}.${L.name}`,L.arg);return}case 101:case 103:{const T=this.q([L.type,L.id]);this.j?.logOutgoing(T,L.id,0,m(L.type));return}}}q(L,T=void 0){const G=new t;return u(G,L),u(G,T),this.r(G.buffer)}r(L){try{return this.l.send(L),L.byteLength}catch{return 0}}s(L){const T=new a(L),G=b(T),z=b(T),ce=G[0];switch(ce){case 200:return this.j?.logIncoming(L.byteLength,0,0,w(ce)),this.t({type:G[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(L.byteLength,G[1],0,w(ce),z),this.t({type:G[0],id:G[1],data:z})}}t(L){if(L.type===200){this.b=$.Idle,this.k.fire();return}this.f.get(L.id)?.(L)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===$.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Pc)(this.d.values()),this.d.clear()}}e.$Xh=D,Ee([S.$Mh],D.prototype,"onDidInitializePromise",null);class O{get connections(){const L=[];return this.f.forEach(T=>L.push(T)),L}constructor(L,T,G){this.a=new Map,this.f=new Set,this.g=new h.$7d,this.onDidAddConnection=this.g.event,this.h=new h.$7d,this.onDidRemoveConnection=this.h.event,this.j=new c.$Tc,this.j.add(L(({protocol:z,onDidClientDisconnect:ce})=>{const he=h.Event.once(z.onMessage);this.j.add(he(X=>{const A=new a(X),N=b(A),_=new C(z,N,T,G),se=new D(z,T);this.a.forEach((V,H)=>_.registerChannel(H,V));const J={channelServer:_,channelClient:se,ctx:N};this.f.add(J),this.g.fire(J),this.j.add(ce(()=>{_.dispose(),se.dispose(),this.f.delete(J),this.h.fire(J)}))}))}))}getChannel(L,T){const G=this;return{call(z,ce,he){let X;if((0,k.$0f)(T)){const N=(0,n.$4b)(G.connections.filter(T));X=N?Promise.resolve(N):h.Event.toPromise(h.Event.filter(G.onDidAddConnection,T))}else X=T.routeCall(G,z,ce);const A=X.then(N=>N.channelClient.getChannel(L));return W(A).call(z,ce,he)},listen(z,ce){if((0,k.$0f)(T))return G.k(L,T,z,ce);const he=T.routeEvent(G,z,ce).then(X=>X.channelClient.getChannel(L));return W(he).listen(z,ce)}}}k(L,T,G,z){const ce=this;let he;const X=new h.$7d({onWillAddFirstListener:()=>{he=new c.$Tc;const A=new h.$ae,N=new Map,_=J=>{const H=J.channelClient.getChannel(L).listen(G,z),U=A.add(H);N.set(J,U)},se=J=>{const V=N.get(J);V&&(V.dispose(),N.delete(J))};ce.connections.filter(T).forEach(_),h.Event.filter(ce.onDidAddConnection,T)(_,void 0,he),ce.onDidRemoveConnection(se,void 0,he),A.event(X.fire,X,he),he.add(A)},onDidRemoveLastListener:()=>{he?.dispose(),he=void 0}});return X.event}registerChannel(L,T){this.a.set(L,T);for(const G of this.f)G.channelServer.registerChannel(L,T)}dispose(){this.j.dispose();for(const L of this.f)L.channelClient.dispose(),L.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Yh=O;class R{constructor(L,T,G=null){const z=new t;u(z,T),L.send(z.buffer),this.a=new D(L,G),this.d=new C(L,T,G)}getChannel(L){return this.a.getChannel(L)}registerChannel(L,T){this.d.registerChannel(L,T)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Zh=R;function W(B){return{call(L,T,G){return B.then(z=>z.call(L,T,G))},listen(L,T){const G=new h.$de;return B.then(z=>G.input=z.listen(L,T)),G.event}}}function F(B){let L=!1;return{call(T,G,z){return L?B.call(T,G,z):(0,j.$jh)(0).then(()=>L=!0).then(()=>B.call(T,G,z))},listen(T,G){if(L)return B.listen(T,G);const z=new h.$de;return(0,j.$jh)(0).then(()=>L=!0).then(()=>z.input=B.listen(T,G)),z.event}}}class q{constructor(L){this.a=L}routeCall(L){return this.b(L)}routeEvent(L){return this.b(L)}async b(L){for(const T of L.connections)if(await Promise.resolve(this.a(T.ctx)))return Promise.resolve(T);return await h.Event.toPromise(L.onDidAddConnection),await this.b(L)}}e.$3h=q;var x;(function(B){function L(ce,he,X){const A=ce,N=X&&X.disableMarshalling,_=new Map;for(const se in A)G(se)&&_.set(se,h.Event.buffer(A[se],!0,void 0,he));return new class{listen(se,J,V){const H=_.get(J);if(H)return H;const U=A[J];if(typeof U=="function"){if(z(J))return U.call(A,V);if(G(J))return _.set(J,h.Event.buffer(A[J],!0,void 0,he)),_.get(J)}throw new E.$bb(`Event not found: ${J}`)}call(se,J,V){const H=A[J];if(typeof H=="function"){if(!N&&Array.isArray(V))for(let re=0;re<V.length;re++)V[re]=(0,p.$Rh)(V[re]);let U=H.apply(A,V);return U instanceof Promise||(U=Promise.resolve(U)),U}throw new E.$bb(`Method not found: ${J}`)}}}B.fromService=L;function T(ce,he){const X=he&&he.disableMarshalling;return new Proxy({},{get(A,N){if(typeof N=="string")return he?.properties?.has(N)?he.properties.get(N):z(N)?function(_){return ce.listen(N,_)}:G(N)?ce.listen(N):async function(..._){let se;he&&!(0,k.$5f)(he.context)?se=[he.context,..._]:se=_;const J=await ce.call(N,se);return X?J:(0,p.$Rh)(J)};throw new E.$bb(`Property not found: ${String(N)}`)}})}B.toService=T;function G(ce){return ce[0]==="o"&&ce[1]==="n"&&y.$kf(ce.charCodeAt(2))}function z(ce){return/^onDynamic/.test(ce)&&y.$kf(ce.charCodeAt(9))}})(x||(e.ProxyChannel=x={}));const le=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function te(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const L=B.toString();if(L!=="[object Object]")return L}return B}function ue(B){return Array.isArray(B)?B.map(te):te(B)}function Y(B,L,T,G,z,ce,he){he=ue(he);const X=le[z],A=X[G%X.length];let N=[`%c[${B}]%c[${String(L).padStart(7," ")}]%c[len: ${String(T).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${ce}`,"color: darkgreen","color: grey","color: grey",`color: ${A}`];/\($/.test(ce)?(N=N.concat(he),N.push(")")):N.push(he),console.log.apply(console,N)}class Z{constructor(L,T){this.d=L,this.f=T,this.a=0,this.b=0}logOutgoing(L,T,G,z,ce){this.b+=L,Y(this.d,this.b,L,T,G,z,ce)}logIncoming(L,T,G,z,ce){this.a+=L,Y(this.f,this.a,L,T,G,z,ce)}}e.$4h=Z}),define(oe[159],ae([0,1,17,3,44]),function(K,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9V=e.$8V=void 0;class M{constructor(h){this.a=h,this.onMessage=j.Event.fromDOMEventEmitter(this.a,"message",c=>c.data?n.$ue.wrap(c.data):n.$ue.alloc(0)),h.start()}send(h){this.a.postMessage(h.buffer)}disconnect(){this.a.close()}}e.$8V=M;class S extends P.$Zh{constructor(h,c){const p=new M(h);super(p,c),this.b=p}dispose(){this.b.disconnect(),super.dispose()}}e.$9V=S}),define(oe[113],ae([0,1,17,3,2,44]),function(K,e,n,j,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$8h=e.$7h=e.$6h=e.ProtocolConstants=e.$5h=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var S;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(S||(e.SocketDiagnosticsEventType=S={}));var E;(function(i){i.enableDiagnostics=!1,i.records=[];const s=new WeakMap;let u=0;function b(I,D){if(!s.has(I)){const O=String(++u);s.set(I,O)}return s.get(I)}function C(I,D,O,R){if(!i.enableDiagnostics)return;const W=b(I,D);if(R instanceof n.$ue||R instanceof Uint8Array||R instanceof ArrayBuffer||ArrayBuffer.isView(R)){const F=n.$ue.alloc(R.byteLength);F.set(R),i.records.push({timestamp:Date.now(),id:W,label:D,type:O,buff:F})}else i.records.push({timestamp:Date.now(),id:W,label:D,type:O,data:R})}i.traceSocketEvent=C})(E||(e.SocketDiagnostics=E={}));var h;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h||(e.SocketCloseEventType=h={}));let c=null;function p(){return c||(c=n.$ue.alloc(0)),c}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(s){this.a.push(s),this.b+=s.byteLength}read(s){return this.c(s,!0)}peek(s){return this.c(s,!1)}c(s,u){if(s===0)return p();if(s>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===s){const D=this.a[0];return u&&(this.a.shift(),this.b-=s),D}if(this.a[0].byteLength>s){const D=this.a[0].slice(0,s);return u&&(this.a[0]=this.a[0].slice(s),this.b-=s),D}const b=n.$ue.alloc(s);let C=0,I=0;for(;s>0;){const D=this.a[I];if(D.byteLength>s){const O=D.slice(0,s);b.set(O,C),C+=s,u&&(this.a[I]=D.slice(s),this.b-=s),s-=s}else b.set(D,C),C+=D.byteLength,u?(this.a.shift(),this.b-=D.byteLength):I++,s-=D.byteLength}return b}}e.$5h=y;var k;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(k||(k={}));function g(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var m;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(m||(e.ProtocolConstants=m={}));class v{constructor(s,u,b,C){this.type=s,this.id=u,this.ack=b,this.data=C,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends P.$Uc{constructor(s){super(),this.f=this.B(new j.$7d),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=s,this.b=!1,this.c=new y,this.B(this.a.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(s);this.c.byteLength>=this.g.readLen;){const u=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=u.readUInt32BE(9),this.g.messageType=u.readUInt8(0),this.g.id=u.readUInt32BE(1),this.g.ack=u.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:g(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const b=this.g.messageType,C=this.g.id,I=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",u),this.f.fire(new v(b,C,I,u)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class ${constructor(s){this.k=null,this.a=!1,this.b=!1,this.c=s,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(s){if(this.a)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=n.$ue.alloc(13);u.writeUInt8(s.type,0),u.writeUInt32BE(s.id,1),u.writeUInt32BE(s.ack,5),u.writeUInt32BE(s.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:g(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",s.data),this.j(u,s.data)}g(s,u){const b=this.f===0;return this.d.push(s,u),this.f+=s.byteLength+u.byteLength,b}h(){const s=n.$ue.concat(this.d,this.f);return this.d.length=0,this.f=0,s}j(s,u){this.g(s,u)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const s=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this.c.write(s)}}class f extends P.$Uc{constructor(s){super(),this.f=new j.$7d,this.onMessage=this.f.event,this.g=new j.$7d,this.onDidDispose=this.g.event,this.a=s,this.b=this.B(new $(this.a)),this.c=this.B(new w(this.a)),this.B(this.c.onMessage(u=>{u.type===1&&this.f.fire(u.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(s){this.b.write(new v(1,0,0,s))}}e.$6h=f;class l extends M.$Zh{static fromSocket(s,u){return new l(new f(s),u)}get onDidDispose(){return this.b.onDidDispose}constructor(s,u,b=null){super(s,u,b),this.b=s}dispose(){super.dispose();const s=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),s.end()}}e.$7h=l;class d{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new j.$7d({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(s){this.b?this.d.length>0?this.d.push(s):this.a.fire(s):this.d.push(s)}flushBuffer(){this.d=[]}}e.$8h=d;class a{constructor(s){this.data=s,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let s=0,u=this.a;for(;u;)u=u.next,s++;return s}peek(){return this.a?this.a.data:null}toArray(){const s=[];let u=0,b=this.a;for(;b;)s[u++]=b.data,b=b.next;return s}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(s){const u=new a(s);if(!this.a){this.a=u,this.b=u;return}this.b.next=u,this.b=u}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const s=Date.now();for(let u=0;u<o.a;u++)this.c[u]=s-1e3*u;setInterval(()=>{for(let u=o.a;u>=1;u--)this.c[u]=this.c[u-1];this.c[0]=Date.now()},1e3)}d(){const s=Date.now(),u=(1+o.a)*1e3;let b=0;for(let C=0;C<o.a;C++)s-this.c[C]<=u&&b++;return 1-b/o.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(s){this.u=new d,this.onControlMessage=this.u.event,this.v=new d,this.onMessage=this.v.event,this.w=new d,this.onDidDispose=this.w.event,this.x=new d,this.onSocketClose=this.x.event,this.y=new d,this.onSocketTimeout=this.y.event,this.s=s.loadEstimator??o.getInstance(),this.t=s.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new P.$Tc,this.o=s.socket,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(u=>this.z(u))),this.r.add(this.o.onClose(u=>this.x.fire(u))),s.initialChunk&&this.q.acceptChunk(s.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const s=new v(5,0,0,p());this.p.write(s),this.p.flush()}sendPause(){const s=new v(7,0,0,p());this.p.write(s)}sendResume(){const s=new v(8,0,0,p());this.p.write(s)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(s,u){this.a=!0,this.r.dispose(),this.r=new P.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=s,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(b=>this.z(b))),this.r.add(this.o.onClose(b=>this.x.fire(b))),this.q.acceptChunk(u)}endAcceptReconnection(){this.a=!1,this.h=this.g;const s=new v(3,0,this.h,p());this.p.write(s);const u=this.b.toArray();for(let b=0,C=u.length;b<C;b++)this.p.write(u[b]);this.B()}acceptDisconnect(){this.w.fire()}z(s){if(s.ack>this.d){this.d=s.ack;do{const u=this.b.peek();if(u&&u.id<=s.ack)this.b.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this.g)if(s.id!==this.g+1){const u=Date.now();u-this.m>1e4&&(this.m=u,this.p.write(new v(6,0,0,p())))}else this.g=s.id,this.j=Date.now(),this.A(),this.v.fire(s.data);break}case 2:{this.u.fire(s.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const u=this.b.toArray();for(let b=0,C=u.length;b<C;b++)this.p.write(u[b]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(s){const u=++this.c;this.h=this.g;const b=new v(1,u,this.h,s);this.b.push(b),this.a||(this.p.write(b),this.B())}sendControl(s){const u=new v(2,0,0,s);this.p.write(u)}A(){if(this.g<=this.h||this.k)return;const s=Date.now()-this.j;if(s>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-s+5)}B(){if(this.c<=this.d||this.f||this.a)return;const s=this.b.peek(),u=Date.now()-s.writtenTime,b=Date.now()-this.q.lastReadTime,C=Date.now()-this.n;if(u>=2e4&&b>=2e4&&C>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:b});return}const I=Math.max(2e4-u,2e4-b,2e4-C,500);this.f=setTimeout(()=>{this.f=null,this.B()},I)}C(){if(this.g<=this.h)return;this.h=this.g;const s=new v(3,0,this.h,p());this.p.write(s)}D(){this.h=this.g;const s=new v(9,0,this.h,p());this.p.write(s)}}e.$9h=r}),define(oe[37],ae([0,1,14,15,13]),function(K,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5V=void 0;class M{constructor(){this.a=new WeakMap}on(E,h){const c=(p,...y)=>{this.b(E,p)&&h(p,...y)};return this.a.set(h,c),n.ipcMain.on(E,c),this}once(E,h){return n.ipcMain.once(E,(c,...p)=>{this.b(E,c)&&h(c,...p)}),this}handle(E,h){return n.ipcMain.handle(E,(c,...p)=>this.b(E,c)?h(c,...p):Promise.reject(`Invalid channel '${E}' or sender for ipcMain.handle() usage.`)),this}removeHandler(E){return n.ipcMain.removeHandler(E),this}removeListener(E,h){const c=this.a.get(h);return c&&(n.ipcMain.removeListener(E,c),this.a.delete(h)),this}b(E,h){if(!E||!E.startsWith("vscode:"))return(0,j.$1)(`Refused to handle ipcMain event for channel '${E}' because the channel is unknown.`),!1;const c=h.senderFrame,p=c.url;if(!p||p==="about:blank")return!0;let y="unknown";try{y=new URL(p).host}catch{return(0,j.$1)(`Refused to handle ipcMain event for channel '${E}' because of a malformed URL '${p}'.`),!1}return y!==P.$Bg?((0,j.$1)(`Refused to handle ipcMain event for channel '${E}' because of a bad origin of '${y}'.`),!1):c.parent!==null?((0,j.$1)(`Refused to handle ipcMain event for channel '${E}' because sender of origin '${y}' is not a main frame.`),!1):!0}}e.$5V=new M}),define(oe[160],ae([0,1,14,37,148]),function(K,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6V=M;function M(){j.$5V.on(P.$3V,(E,h,c,p,y)=>{const k=S(E,p,c);k.popup({x:y?y.x:void 0,y:y?y.y:void 0,positioningItem:y?y.positioningItem:void 0,callback:()=>{k&&E.sender.send(P.$4V,h)}})})}function S(E,h,c){const p=new n.Menu;return c.forEach(y=>{let k;y.type==="separator"?k=new n.MenuItem({type:y.type}):Array.isArray(y.submenu)?k=new n.MenuItem({submenu:S(E,h,y.submenu),label:y.label}):k=new n.MenuItem({label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:y.enabled,visible:y.visible,click:(g,m,v)=>E.sender.send(h,y.id,v)}),p.append(k)}),p}}),define(oe[161],ae([0,1,37,17,3,2,44,149]),function(K,e,n,j,P,M,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_V=void 0;function h(p,y){const k=P.Event.fromNodeEventEmitter(n.$5V,y,(m,v)=>({event:m,message:v})),g=P.Event.filter(k,({event:m})=>m.sender.id===p);return P.Event.map(g,({message:m})=>m&&j.$ue.wrap(m))}class c extends S.$Yh{static{this.b=new Map}static d(){const y=P.Event.fromNodeEventEmitter(n.$5V,"vscode:hello",({sender:k})=>k);return P.Event.map(y,k=>{const g=k.id;c.b.get(g)?.dispose();const v=new P.$7d;c.b.set(g,(0,M.$Sc)(()=>v.fire()));const w=h(g,"vscode:message"),$=P.Event.any(P.Event.signal(h(g,"vscode:disconnect")),v.event);return{protocol:new E.$$V(k,w),onDidClientDisconnect:$}})}constructor(){super(c.d())}}e.$_V=c}),define(oe[114],ae([0,1,37,3,33,159]),function(K,e,n,j,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aW=void 0,e.$bW=E;class S extends M.$9V{constructor(c,p){super({addEventListener:(y,k)=>c.addListener(y,k),removeEventListener:(y,k)=>c.removeListener(y,k),postMessage:y=>c.postMessage(y),start:()=>c.start(),close:()=>c.close()},p)}}e.$aW=S;async function E(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const c=(0,P.$Eg)();h.webContents.send("vscode:createMessageChannel",c);const p=j.Event.fromNodeEventEmitter(n.$5V,"vscode:createMessageChannelResult",(k,g)=>({nonce:g,port:k.ports[0]})),{port:y}=await j.Event.toPromise(j.Event.once(j.Event.filter(p,k=>k.nonce===c)));return y}}),define(oe[162],ae([0,1,49,8,17,23,156,15,3,2,35,90,75,44]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=e.$Jq=void 0;class m extends g.$Wh{constructor($){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",f=>P.$ue.wrap(Buffer.from(f,"base64")))},$),process.once("disconnect",()=>this.dispose())}}e.$Jq=m;class v{constructor($,f){this.i=$,this.j=f,this.c=new Set,this.g=new Map,this.h=new h.$7d,this.onDidProcessExit=this.h.event;const l=f&&f.timeout?f.timeout:6e4;this.b=new j.$fh(l),this.d=null,this.f=null}getChannel($){const f=this;return{call(l,d,a){return f.k($,l,d,a)},listen(l,d){return f.l($,l,d)}}}k($,f,l,d=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(E.$6());this.b.cancel();const a=this.n($),t=(0,j.$8g)(i=>a.call(f,l,i)),o=d.onCancellationRequested(()=>t.cancel()),r=(0,c.$Sc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{o.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l($,f,l){if(!this.b)return h.Event.None;this.b.cancel();let d;const a=new h.$7d({onWillAddFirstListener:()=>{d=this.n($).listen(f,l)(a.fire,a),this.c.add(d)},onDidRemoveLastListener:()=>{this.c.delete(d),d.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const $=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,p.$On)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u)).filter(u=>!u.startsWith("--vscode-"))),(0,k.$_l)(f.env),this.d=(0,n.fork)(this.i,$,f);const l=new h.$7d,a=h.Event.fromNodeEventEmitter(this.d,"message",u=>u)(u=>{if((0,S.$Fq)(u)){(0,S.log)(u,`IPC Library: ${this.j.serverName}`);return}l.fire(P.$ue.wrap(Buffer.from(u,"base64")))}),t=this.j.useQueue?(0,y.$bm)(this.d):this.d,o=u=>this.d&&this.d.connected&&t.send(u.buffer.toString("base64")),r=l.event,i={send:o,onMessage:r};this.f=new g.$Xh(i);const s=()=>this.o();process.once("exit",s),this.d.on("error",u=>console.warn('IPC "'+this.j.serverName+'" errored with '+u)),this.d.on("exit",(u,b)=>{process.removeListener("exit",s),a.dispose(),this.c.forEach(C=>(0,c.$Pc)(C)),this.c.clear(),u!==0&&b!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+u+" and signal "+b),this.b?.cancel(),this.o(),this.h.fire({code:u,signal:b})})}return this.f}n($){let f=this.g.get($);return f||(f=this.m.getChannel($),this.g.set($,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Kq=v}),define(oe[115],ae([0,1,8,3,2,76,12]),function(K,e,n,j,P,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Ip=e.StorageState=e.StorageHint=void 0,e.$Hp=h;var E;(function(k){k[k.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",k[k.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(E||(e.StorageHint=E={}));function h(k){const g=k;return g?.changed instanceof Map||g?.deleted instanceof Set}var c;(function(k){k[k.None=0]="None",k[k.Initialized=1]="Initialized",k[k.Closed=2]="Closed"})(c||(e.StorageState=c={}));class p extends P.$Uc{static{this.a=100}constructor(g,m=Object.create(null)){super(),this.r=g,this.s=m,this.b=this.B(new j.$0d),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new n.$gh(p.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(g=>this.u(g)))}u(g){this.b.pause();try{g.changed?.forEach((m,v)=>this.w(v,m)),g.deleted?.forEach(m=>this.w(m,void 0))}finally{this.b.resume()}}w(g,m){if(this.c===c.Closed)return;let v=!1;(0,S.$5f)(m)?v=this.f.delete(g):this.f.get(g)!==m&&(this.f.set(g,m),v=!0),v&&this.b.fire({key:g,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(g,m){const v=this.f.get(g);return(0,S.$5f)(v)?m:v}getBoolean(g,m){const v=this.get(g);return(0,S.$5f)(v)?m:v==="true"}getNumber(g,m){const v=this.get(g);return(0,S.$5f)(v)?m:parseInt(v,10)}getObject(g,m){const v=this.get(g);return(0,S.$5f)(v)?m:(0,M.$Qh)(v)}async set(g,m,v=!1){if(this.c===c.Closed)return;if((0,S.$5f)(m))return this.delete(g,v);const w=(0,S.$Xf)(m)||Array.isArray(m)?(0,M.$Ph)(m):String(m);if(this.f.get(g)!==w)return this.f.set(g,w),this.j.set(g,w),this.h.delete(g),this.b.fire({key:g,external:v}),this.D()}async delete(g,m=!1){if(!(this.c===c.Closed||!this.f.delete(g)))return this.h.has(g)||this.h.add(g),this.j.delete(g),this.b.fire({key:g,external:m}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const g={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(g).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(g){if(this.z)return this.D(g)}async D(g){return this.s.hint===E.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),g)}async whenFlushed(){if(this.z)return new Promise(g=>this.n.push(g))}isInMemory(){return this.s.hint===E.STORAGE_IN_MEMORY}}e.$Ip=p;class y{constructor(){this.onDidChangeItemsExternal=j.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(g){g.insert?.forEach((m,v)=>this.a.set(v,m)),g.delete?.forEach(m=>this.a.delete(m))}async optimize(){}async close(){}}e.$Jp=y}),define(oe[163],ae([0,1,8,3,32,9,21]),function(K,e,n,j,P,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xW=void 0;class E{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return j.Event.None}static{this.a=2e3}static{this.b=256}constructor(p,y=Object.create(null)){this.g=p,this.h=y,this.c=(0,M.$oc)(this.g),this.d=new h(this.h.logging),this.f=this.n(this.g)}async getItems(){const p=await this.f,y=new Map;return(await this.s(p,"SELECT * FROM ItemTable")).forEach(g=>y.set(g.key,g.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${y.size} rows`),y}async updateItems(p){const y=await this.f;return this.j(y,p)}j(p,y){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${y.insert?(0,P.$zc)(y.insert):"0"}), delete(${y.delete?(0,P.$Ac)(y.delete):"0"})`),this.t(p,()=>{const k=y.insert,g=y.delete;if(k&&k.size>0){const m=[];m.push([]);let v=0;k.forEach((w,$)=>{let f=m[v];f.length>E.b&&(v++,f=[],m.push(f)),f.push($,w)}),m.forEach(w=>{this.u(p,`INSERT INTO ItemTable VALUES ${new Array(w.length/2).fill("(?,?)").join(",")}`,$=>$.run(w),()=>{const $=[];let f=0;return k.forEach((l,d)=>{$.push(d),f+=l.length}),`Keys: ${$.join(", ")} Length: ${f}`})})}if(g&&g.size){const m=[];m.push([]);let v=0;g.forEach(w=>{let $=m[v];$.length>E.b&&(v++,$=[],m.push($)),$.push(w)}),m.forEach(w=>{this.u(p,`DELETE FROM ItemTable WHERE key IN (${new Array(w.length).fill("?").join(",")})`,$=>$.run(w),()=>{const $=[];return g.forEach(f=>{$.push(f)}),`Keys: ${$.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const p=await this.f;return this.q(p,"VACUUM")}async close(p){this.d.trace(`[storage ${this.c}] close()`);const y=await this.f;return this.k(y,p)}k(p,y){return new Promise((k,g)=>{p.db.close(m=>(m&&this.o(p,`[storage ${this.c}] close(): ${m}`),this.g===E.IN_MEMORY_PATH?k():!p.isErroneous&&!p.isInMemory?this.l().then(k,v=>(this.d.error(`[storage ${this.c}] backup(): ${v}`),k())):typeof y=="function"?S.Promises.unlink(this.g).then(()=>this.p(this.g).then(v=>{const w=()=>this.k(v,void 0);return this.j(v,{insert:y()}).then(()=>w(),$=>(w(),Promise.reject($)))})).then(k,g):g(m||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const p=this.m(this.g);return S.Promises.copy(this.g,p,{preserveSymlinks:!1})}m(p){return`${p}.backup`}async checkIntegrity(p){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${p})`);const y=await this.f,k=await this.r(y,p?"PRAGMA integrity_check":"PRAGMA quick_check"),g=p?k.integrity_check:k.quick_check;return y.isErroneous?`${g} (last error: ${y.lastError})`:y.isInMemory?`${g} (in-memory!)`:g}async n(p,y=!0){this.d.trace(`[storage ${this.c}] open(${p}, retryOnBusy: ${y})`);try{return await this.p(p)}catch(k){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${k}`),k.code==="SQLITE_BUSY"&&y)return await(0,n.$jh)(E.a),this.n(p,!1);try{await S.Promises.unlink(p);try{await S.Promises.rename(this.m(p),p,!1)}catch{}return await this.p(p)}catch(g){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${g}`),this.p(E.IN_MEMORY_PATH)}}}o(p,y){p.isErroneous=!0,p.lastError=y,this.d.error(y)}p(p){return new Promise((y,k)=>{new Promise((g,m)=>{K(["@vscode/sqlite3"],g,m)}).then(g=>{const m={db:new(this.d.isTracing?g.verbose().Database:g.Database)(p,v=>v?m.db&&v.code!=="SQLITE_CANTOPEN"?m.db.close(()=>k(v)):k(v):this.q(m,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>y(m),w=>m.db.close(()=>k(w)))),isInMemory:p===E.IN_MEMORY_PATH};m.db.on("error",v=>this.o(m,`[storage ${this.c}] Error (event): ${v}`)),this.d.isTracing&&m.db.on("trace",v=>this.d.trace(`[storage ${this.c}] Trace (event): ${v}`))},k)})}q(p,y){return new Promise((k,g)=>{p.db.exec(y,m=>m?(this.o(p,`[storage ${this.c}] exec(): ${m}`),g(m)):k())})}r(p,y){return new Promise((k,g)=>{p.db.get(y,(m,v)=>m?(this.o(p,`[storage ${this.c}] get(): ${m}`),g(m)):k(v))})}s(p,y){return new Promise((k,g)=>{p.db.all(y,(m,v)=>m?(this.o(p,`[storage ${this.c}] all(): ${m}`),g(m)):k(v))})}t(p,y){return new Promise((k,g)=>{p.db.serialize(()=>{p.db.run("BEGIN TRANSACTION"),y(),p.db.run("END TRANSACTION",m=>m?(this.o(p,`[storage ${this.c}] transaction(): ${m}`),g(m)):k())})})}u(p,y,k,g){const m=p.db.prepare(y),v=w=>{this.o(p,`[storage ${this.c}] prepare(): ${w} (${y}). Details: ${g()}`)};m.on("error",v),k(m),m.finalize(w=>{w&&v(w),m.removeListener("error",v)})}}e.$xW=E;class h{static{this.a="VSCODE_TRACE_STORAGE"}constructor(p){p&&typeof p.logTrace=="function"&&process.env[h.a]&&(this.b=p.logTrace),p&&typeof p.logError=="function"&&(this.c=p.logError)}get isTracing(){return!!this.b}trace(p){this.b?.(p)}error(p){this.c?.(p)}}}),define(oe[164],ae([11,10]),function(K,e){return K.create("vs/code/electron-main/app",e)}),define(oe[165],ae([11,10]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[166],ae([11,10]),function(K,e){return K.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[167],ae([11,10]),function(K,e){return K.create("vs/platform/contextkey/common/scanner",e)}),define(oe[168],ae([11,10]),function(K,e){return K.create("vs/platform/dialogs/common/dialogs",e)}),define(oe[169],ae([11,10]),function(K,e){return K.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(oe[170],ae([11,10]),function(K,e){return K.create("vs/platform/environment/node/argv",e)}),define(oe[171],ae([11,10]),function(K,e){return K.create("vs/platform/environment/node/argvHelper",e)}),define(oe[172],ae([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[173],ae([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[174],ae([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[175],ae([11,10]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[176],ae([11,10]),function(K,e){return K.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(oe[177],ae([11,10]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(oe[178],ae([11,10]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(oe[179],ae([11,10]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(oe[180],ae([11,10]),function(K,e){return K.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(oe[181],ae([11,10]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[182],ae([11,10]),function(K,e){return K.create("vs/platform/issue/electron-main/issueMainService",e)}),define(oe[183],ae([11,10]),function(K,e){return K.create("vs/platform/log/common/log",e)}),define(oe[184],ae([11,10]),function(K,e){return K.create("vs/platform/menubar/electron-main/menubar",e)}),define(oe[185],ae([11,10]),function(K,e){return K.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(oe[186],ae([11,10]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(oe[187],ae([11,10]),function(K,e){return K.create("vs/platform/shell/node/shellEnv",e)}),define(oe[188],ae([11,10]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[189],ae([11,10]),function(K,e){return K.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(oe[190],ae([11,10]),function(K,e){return K.create("vs/platform/terminal/common/terminalProfiles",e)}),define(oe[191],ae([11,10]),function(K,e){return K.create("vs/platform/update/common/update.config.contribution",e)}),define(oe[192],ae([11,10]),function(K,e){return K.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[193],ae([11,10]),function(K,e){return K.create("vs/platform/windows/electron-main/windowImpl",e)}),define(oe[194],ae([11,10]),function(K,e){return K.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(oe[195],ae([11,10]),function(K,e){return K.create("vs/platform/workspace/common/workspace",e)}),define(oe[196],ae([11,10]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(oe[197],ae([11,10]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(oe[198],ae([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Neb=n,e.$Oeb=j;function n(P){return P&&P.hasOwnProperty("folderUri")}function j(P){return P&&P.hasOwnProperty("workspace")}}),define(oe[199],ae([0,1,7]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q_b=j,e.$R_b=P,e.$S_b=M;function j(S){return typeof S?.backupFolder=="string"}function P(S){let E=[];try{Array.isArray(S.workspaces)&&(E=S.workspaces.map(h=>({workspace:{id:h.id,configPath:n.URI.parse(h.configURIPath)},remoteAuthority:h.remoteAuthority})))}catch{}return E}function M(S){let E=[];try{Array.isArray(S.folders)&&(E=S.folders.map(h=>({folderUri:n.URI.parse(h.folderUri),remoteAuthority:h.remoteAuthority})))}catch{}return E}}),define(oe[200],ae([0,1,15,167]),function(K,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dj=e.TokenType=void 0;var P;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(P||(e.TokenType=P={}));function M(...c){switch(c.length){case 1:return(0,j.localize)(0,null,c[0]);case 2:return(0,j.localize)(1,null,c[0],c[1]);case 3:return(0,j.localize)(2,null,c[0],c[1],c[2]);default:return}}const S=(0,j.localize)(3,null),E=(0,j.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(p){switch(p.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return p.isTripleEq?"===":"==";case 4:return p.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return p.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return p.lexeme;case 18:return p.lexeme;case 19:return p.lexeme;case 20:return"EOF";default:throw(0,n.$8)(`unhandled token type: ${JSON.stringify(p)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(p=>p.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(p){return this.c=p,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const y=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:y})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const y=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:y})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(p){return this.r()||this.c.charCodeAt(this.e)!==p?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(p){this.f.push({type:p,offset:this.d})}l(p){const y=this.d,k=this.c.substring(this.d,this.e),g={type:19,offset:this.d,lexeme:k};this.g.push({offset:y,lexeme:k,additionalInfo:p}),this.f.push(g)}n(){this.m.lastIndex=this.d;const p=this.m.exec(this.c);if(p){this.e=this.d+p[0].length;const y=this.c.substring(this.d,this.e),k=h.b.get(y);k?this.k(k):this.f.push({type:17,lexeme:y,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(S);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let p=this.e,y=!1,k=!1;for(;;){if(p>=this.c.length){this.e=p,this.l(E);return}const m=this.c.charCodeAt(p);if(y)y=!1;else if(m===47&&!k){p++;break}else m===91?k=!0:m===92?y=!0:m===93&&(k=!1);p++}for(;p<this.c.length&&h.a.has(this.c.charCodeAt(p));)p++;this.e=p;const g=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:g,offset:this.d})}r(){return this.e>=this.c.length}}e.$dj=h}),define(oe[201],ae([0,1,3,2]),function(K,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=e.$uo=void 0;class P{constructor(){this.a=new n.$7d,this.b=new n.$7d,this.c=new n.$7d,this.d=new n.$7d}static{this.ChannelName="extensionhostdebugservice"}call(E,h,c){switch(h){case"close":return Promise.resolve(this.a.fire({sessionId:c[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:c[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:c[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:c[0],port:c[1],subId:c[2]}))}throw new Error("Method not implemented.")}listen(E,h,c){switch(h){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$uo=P;class M extends j.$Uc{constructor(E){super(),this.b=E}reload(E){this.b.call("reload",[E])}get onReload(){return this.b.listen("reload")}close(E){this.b.call("close",[E])}get onClose(){return this.b.listen("close")}attachSession(E,h,c){this.b.call("attach",[E,h,c])}get onAttachSession(){return this.b.listen("attach")}terminateSession(E,h){this.b.call("terminate",[E,h])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(E,h){return this.b.call("openExtensionDevelopmentHostWindow",[E,h])}}e.$vo=M}),define(oe[202],ae([0,1,151,51,13,9,36,19,7]),function(K,e,n,j,P,M,S,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rm=e.$Qm=void 0,e.$Sm=p,e.$Tm=y,e.$Qm=/^([^.]+\..+)[:=](.+)$/;class c{get appRoot(){return(0,M.$nc)(P.$Cg.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,M.$kc)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,E.$Vg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:P.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,E.$Vg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const g=(0,n.$Pm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.$kc)(this.userDataPath,"logs",g)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.$Vg)(h.URI.file((0,M.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.$Vg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.$Vg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.$Vg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=S.env.VSCODE_PORTABLE;return g?h.URI.file((0,M.$kc)(g,"argv.json")):(0,E.$Vg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,M.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,M.$lc)(g):(0,M.$ic)((0,M.$kc)(P.$Cg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const g=this.args["extensions-download-dir"];return g?h.URI.file((0,M.$lc)(g)):h.URI.file((0,M.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,M.$lc)(g);const m=S.env.VSCODE_EXTENSIONS;if(m)return m;const v=S.env.VSCODE_PORTABLE;return v?(0,M.$kc)(v,"extensions"):(0,E.$Vg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(m=>/^[^:/?#]+?:\/\//.test(m)?h.URI.parse(m):h.URI.file((0,M.$ic)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?h.URI.parse(g):h.URI.file((0,M.$ic)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return p(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!S.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(g=>!e.$Qm.test(g))}get extensionLogLevel(){const g=[];for(const m of this.args.log||[]){const v=e.$Qm.exec(m);v&&v[1]&&v[2]&&g.push([v[1],v[2]])}return g.length?g:void 0}get serviceMachineIdResource(){return(0,E.$Vg)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const g=S.env.VSCODE_PORTABLE;return g?h.URI.file((0,M.$kc)(g,"policy.json")):(0,E.$Vg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(g){this.args.continueOn=g}get args(){return this.a}constructor(g,m,v){this.a=g,this.b=m,this.c=v,this.editSessionId=this.args.editSessionId}}e.$Rm=c,Ee([j.$Mh],c.prototype,"appRoot",null),Ee([j.$Mh],c.prototype,"userHome",null),Ee([j.$Mh],c.prototype,"userDataPath",null),Ee([j.$Mh],c.prototype,"appSettingsHome",null),Ee([j.$Mh],c.prototype,"tmpDir",null),Ee([j.$Mh],c.prototype,"cacheHome",null),Ee([j.$Mh],c.prototype,"stateResource",null),Ee([j.$Mh],c.prototype,"userRoamingDataHome",null),Ee([j.$Mh],c.prototype,"userDataSyncHome",null),Ee([j.$Mh],c.prototype,"sync",null),Ee([j.$Mh],c.prototype,"machineSettingsResource",null),Ee([j.$Mh],c.prototype,"workspaceStorageHome",null),Ee([j.$Mh],c.prototype,"localHistoryHome",null),Ee([j.$Mh],c.prototype,"keyboardLayoutResource",null),Ee([j.$Mh],c.prototype,"argvResource",null),Ee([j.$Mh],c.prototype,"isExtensionDevelopment",null),Ee([j.$Mh],c.prototype,"untitledWorkspacesHome",null),Ee([j.$Mh],c.prototype,"builtinExtensionsPath",null),Ee([j.$Mh],c.prototype,"extensionsPath",null),Ee([j.$Mh],c.prototype,"extensionDevelopmentLocationURI",null),Ee([j.$Mh],c.prototype,"extensionDevelopmentKind",null),Ee([j.$Mh],c.prototype,"extensionTestsLocationURI",null),Ee([j.$Mh],c.prototype,"debugExtensionHost",null),Ee([j.$Mh],c.prototype,"logLevel",null),Ee([j.$Mh],c.prototype,"extensionLogLevel",null),Ee([j.$Mh],c.prototype,"serviceMachineIdResource",null),Ee([j.$Mh],c.prototype,"disableTelemetry",null),Ee([j.$Mh],c.prototype,"disableWorkspaceTrust",null),Ee([j.$Mh],c.prototype,"useInMemorySecretStorage",null),Ee([j.$Mh],c.prototype,"policyFile",null);function p(k,g){return y(k["inspect-extensions"],k["inspect-brk-extensions"],5870,g,k.debugId,k.extensionEnvironment)}function y(k,g,m,v,w,$){const l=Number(g||k)||(v?null:m),d=l?!!g:!1;let a;if($)try{a=JSON.parse($)}catch{}return{port:l,break:d,debugId:w,env:a}}}),define(oe[116],ae([0,1,313,4,170]),function(K,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$em=e.$dm=void 0,e.$fm=E,e.$gm=c,e.$hm=g,e.$im=m;const M={o:(0,P.localize)(0,null),e:(0,P.localize)(1,null),t:(0,P.localize)(2,null)};e.$dm=["tunnel","serve-web"],e.$em={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,P.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,P.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,P.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,P.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,P.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,P.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,P.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,P.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,P.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,P.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,P.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,P.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,P.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,P.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,P.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,P.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,P.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,P.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,P.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,P.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,P.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,P.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,P.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,P.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,P.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,P.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,P.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,P.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,P.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,P.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,P.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,P.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,P.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,P.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,P.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const S={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function E(v,w,$=S){const f=v.find(u=>u.length>0&&u[0]!=="-"),l={},d=["_"],a=[],t={};let o;for(const u in w){const b=w[u];b.type==="subcommand"?u===f&&(o=b):(b.alias&&(l[u]=b.alias),b.type==="string"||b.type==="string[]"?(d.push(u),b.deprecates&&d.push(...b.deprecates)):b.type==="boolean"&&(a.push(u),b.deprecates&&a.push(...b.deprecates)),b.global&&(t[u]=b))}if(o&&f){const u=t;for(const D in o.options)u[D]=o.options[D];const b=v.filter(D=>D!==f),C=$.getSubcommandReporter?$.getSubcommandReporter(f):void 0,I=E(b,u,C);return{[f]:I,_:[]}}const r=n(v,{string:d,boolean:a,alias:l}),i={},s=r;i._=r._.map(u=>String(u)).filter(u=>u.length>0),delete s._;for(const u in w){const b=w[u];if(b.type==="subcommand")continue;b.alias&&delete s[b.alias];let C=s[u];if(b.deprecates)for(const I of b.deprecates)s.hasOwnProperty(I)&&(C||(C=s[I],C&&$.onDeprecatedOption(I,b.deprecationMessage||(0,P.localize)(38,null,u))),delete s[I]);if(typeof C<"u"){if(b.type==="string[]"){if(Array.isArray(C)||(C=[C]),!b.allowEmptyValue){const I=C.filter(D=>D.length>0);I.length!==C.length&&($.onEmptyValue(u),C=I.length>0?I:void 0)}}else b.type==="string"&&(Array.isArray(C)?(C=C.pop(),$.onMultipleValues(u,C)):!C&&!b.allowEmptyValue&&($.onEmptyValue(u),C=void 0));i[u]=C,b.deprecationMessage&&$.onDeprecatedOption(u,b.deprecationMessage)}delete s[u]}for(const u in s)$.onUnknownOption(u);return i}function h(v,w){let $="";return w.args&&(Array.isArray(w.args)?$=` <${w.args.join("> <")}>`:$=` <${w.args}>`),w.alias?`-${w.alias} --${v}${$}`:`--${v}${$}`}function c(v,w){const $=[];for(const f in v){const l=v[f],d=h(f,l);$.push([d,l.description])}return p($,w)}function p(v,w){const f=v.reduce((a,t)=>Math.max(a,t[0].length),12)+2+1;if(w-f<25)return v.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const l=w-f-1,d=[];for(const a of v){const t=a[0],o=k(a[1],l),r=y(f-t.length-2);d.push("  "+t+r+o[0]);for(let i=1;i<o.length;i++)d.push(y(f)+o[i])}return d}function y(v){return" ".repeat(v)}function k(v,w){const $=[];for(;v.length;){const f=v.length<w?v.length:v.lastIndexOf(" ",w),l=v.slice(0,f).trim();v=v.slice(f),$.push(l)}return $}function g(v,w,$,f,l){const d=process.stdout.isTTY&&process.stdout.columns||80,a=l?.noInputFiles!==!0?`[${(0,P.localize)(39,null)}...]`:"",t=[`${v} ${$}`];t.push(""),t.push(`${(0,P.localize)(40,null)}: ${w} [${(0,P.localize)(41,null)}]${a}`),t.push(""),l?.noPipe!==!0&&(j.$i?t.push((0,P.localize)(42,null,w)):t.push((0,P.localize)(43,null,w)),t.push(""));const o={},r=[];for(const i in f){const s=f[i];if(s.type==="subcommand")s.description&&r.push({command:i,description:s.description});else if(s.description&&s.cat){let u=o[s.cat];u||(o[s.cat]=u={}),u[i]=s}}for(const i in o){const s=i,u=o[s];u&&(t.push(M[s]),t.push(...c(u,d)),t.push(""))}return r.length&&(t.push((0,P.localize)(44,null)),t.push(...p(r.map(i=>[i.command,i.description]),d)),t.push("")),t.join(`
`)}function m(v,w){return`${v||(0,P.localize)(45,null)}
${w||(0,P.localize)(46,null)}
${process.arch}`}}),define(oe[203],ae([0,1,88,201,116]),function(K,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sac=void 0;class M extends j.$uo{constructor(E){super(),this.f=E}call(E,h,c){return h==="openExtensionDevelopmentHostWindow"?this.g(c[0],c[1]):super.call(E,h,c)}async g(E,h){const c=(0,P.$fm)(E,P.$em);c.debugRenderer=h;const p=c.extensionDevelopmentPath;if(!p)return{success:!1};const[y]=await this.f.openExtensionDevelopmentHostWindow(p,{context:5,cli:c,forceProfile:c.profile,forceTempProfile:c["profile-temp"]});if(!h)return{success:!0};const k=y.win;if(!k)return{success:!0};const g=k.webContents.debugger;let m=g.isAttached()?1/0:0;const v=(0,n.createServer)(w=>{m++===0&&g.attach();let $=!1;const f=a=>{$||w.write(JSON.stringify(a)+"\0")},l=(a,t,o,r)=>f({method:t,params:o,sessionId:r});k.on("close",()=>{g.removeListener("message",l),w.end(),$=!0}),g.addListener("message",l);let d=Buffer.alloc(0);w.on("data",a=>{d=Buffer.concat([d,a]);for(let t=d.indexOf(0);t!==-1;t=d.indexOf(0)){let o;try{const r=d.slice(0,t).toString("utf8");d=d.slice(t+1),o=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}g.sendCommand(o.method,o.params,o.sessionId).then(r=>f({id:o.id,sessionId:o.sessionId,result:r})).catch(r=>f({id:o.id,sessionId:o.sessionId,error:{code:0,message:r.message}}))}}),w.on("error",a=>{console.error("error on cdp pipe:",a)}),w.on("close",()=>{$=!0,--m===0&&g.detach()})});return await new Promise(w=>v.listen(0,w)),k.on("close",()=>v.close()),{rendererDebugPort:v.address().port,success:!0}}}e.$sac=M}),define(oe[64],ae([0,1,314,171,116]),function(K,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=E,e.$km=h,e.$lm=c,e.$mm=p;function M(y,k){const g=(l,d)=>{console.warn((0,j.localize)(0,null,l,d))},m=l=>{console.warn((0,j.localize)(1,null,l))},v=(l,d)=>{console.warn((0,j.localize)(2,null,l,d))},w=l=>({onUnknownOption:d=>{P.$dm.includes(l)||console.warn((0,j.localize)(3,null,d,l))},onMultipleValues:g,onEmptyValue:m,onDeprecatedOption:v,getSubcommandReporter:P.$dm.includes(l)?w:void 0}),$={onUnknownOption:l=>{console.warn((0,j.localize)(4,null,l))},onMultipleValues:g,onEmptyValue:m,onDeprecatedOption:v,getSubcommandReporter:w},f=(0,P.$fm)(y,P.$em,k?$:void 0);return f.goto&&f._.forEach(l=>n(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(l),(0,j.localize)(5,null))),f}function S(y){const k=y.findIndex(g=>!/^-/.test(g));if(k>-1)return[...y.slice(0,k),...y.slice(k+1)]}function E(y){let[,...k]=y;process.env.VSCODE_DEV&&(k=S(k)||[]);const g=!p(process.env);return M(k,g)}function h(y){let[,,...k]=y;return process.env.VSCODE_DEV&&(k=S(k)||[]),M(k,!0)}function c(y,...k){const g=y.indexOf("--");return g===-1?y.push(...k):y.splice(g,0,...k),y}function p(y){return y.VSCODE_CLI==="1"}}),function(){"use strict";function K(e,n,j){function P(S,E){const h=M(S,E),c=[h];return e.isAbsolute(h)||c.unshift(j),e.resolve(...c)}function M(S,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,E);const p=S["user-data-dir"];if(p)return p;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(y,"AppData","Roaming")}break;case"darwin":c=e.join(n.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(n.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,E)}return{getUserDataPath:P}}if(typeof define=="function")define(oe[204],ae([117,26,36]),function(e,n,j){return K(e,n,j.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("os");module.exports=K(e,n,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[91],ae([0,1,26,202,204]),function(K,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=void 0,e.$Vm=S,e.$Wm=E;class M extends j.$Rm{constructor(c,p){super(c,{homeDir:(0,n.homedir)(),tmpDir:(0,n.tmpdir)(),userDataDir:(0,P.getUserDataPath)(c,p.nameShort)},p)}}e.$Um=M;function S(h,c){return(0,j.$Tm)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,c,h.extensionEnvironment)}function E(h,c){return(0,j.$Tm)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,c,h.extensionEnvironment)}}),define(oe[205],ae([0,1,43,26,31]),function(K,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lbc=M;function M(S){const E=(0,P.$qg)((0,j.tmpdir)());try{return(0,n.writeFileSync)(E,""),S&&console.log(`Marker file for --wait created: ${E}`),E}catch(h){S&&console.error(`Failed to create marker file for --wait: ${h}`);return}}}),define(oe[206],ae([0,1,12,173]),function(K,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=P;function P(S,E,h,c){try{M(S,E,h,c)}catch(p){S.error(p?.message??p)}return E}function M(S,E,h,c){const p=(y,k,g)=>{const m=y[k];if((0,n.$Vf)(m)){const v=m,w=v.length;if(w>1&&v[0]==="%"&&v[w-1]==="%"){const $=v.substr(1,w-2);let f=h[$];f===void 0&&c&&(f=c[$]);const l=typeof f=="string"?f:f?.message,d=c?.[$],a=typeof d=="string"?d:d?.message;if(!l){a||S.warn(`[${E.name}]: ${(0,j.localize)(0,null,$)}`);return}if(g&&(k==="title"||k==="category")&&a&&a!==l){const t={value:l,original:a};y[k]=t}else y[k]=l}}else if((0,n.$Xf)(m))for(const v in m)m.hasOwnProperty(v)&&(v==="commands"?p(m,v,!0):p(m,v,g));else if(Array.isArray(m))for(let v=0;v<m.length;v++)p(m,v,g)};for(const y in E)E.hasOwnProperty(y)&&p(E,y)}}),define(oe[207],ae([0,1,19,73,175,208]),function(K,e,n,j,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=h,e.$tp=c,e.$up=p,e.$vp=y,e.$wp=k,e.$xp=g,e.$yp=m;const S=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function h($){return $=$.trim(),$==="*"||S.test($)}function c($){if(!h($))return null;if($=$.trim(),$==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=$.match(S);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}function p($){if(!$)return null;const f=$.majorBase,l=$.majorMustEqual,d=$.minorBase;let a=$.minorMustEqual;const t=$.patchBase;let o=$.patchMustEqual;$.hasCaret&&(f===0||(a=!1),o=!1);let r=0;if($.preRelease){const i=E.exec($.preRelease);if(i){const[,s,u,b]=i;r=Date.UTC(Number(s),Number(u)-1,Number(b))}}return{majorBase:f,majorMustEqual:l,minorBase:d,minorMustEqual:a,patchBase:t,patchMustEqual:o,isMinimum:$.hasGreaterEquals,notBefore:r}}function y($,f,l){let d;typeof $=="string"?d=p(c($)):d=$;let a;f instanceof Date?a=f.getTime():typeof f=="string"&&(a=new Date(f).getTime());let t;if(typeof l=="string"?t=p(c(l)):t=l,!d||!t)return!1;const o=d.majorBase,r=d.minorBase,i=d.patchBase;let s=t.majorBase,u=t.minorBase,b=t.patchBase;const C=t.notBefore;let I=t.majorMustEqual,D=t.minorMustEqual,O=t.patchMustEqual;return t.isMinimum?o>s?!0:o<s?!1:r>u?!0:r<u||a&&a<C?!1:i>=b:(o===1&&s===0&&(!I||!D||!O)&&(s=1,u=0,b=0,I=!0,D=!1,O=!1),o<s?!1:o>s?!I:r<u?!1:r>u?!D:i<b?!1:i>b?!O:!(a&&a<C))}function k($,f,l,d,a){const t=[];if(typeof d.publisher<"u"&&typeof d.publisher!="string")return t.push([j.default.Error,P.localize(0,null)]),t;if(typeof d.name!="string")return t.push([j.default.Error,P.localize(1,null,"name")]),t;if(typeof d.version!="string")return t.push([j.default.Error,P.localize(2,null,"version")]),t;if(!d.engines)return t.push([j.default.Error,P.localize(3,null,"engines")]),t;if(typeof d.engines.vscode!="string")return t.push([j.default.Error,P.localize(4,null,"engines.vscode")]),t;if(typeof d.extensionDependencies<"u"&&!w(d.extensionDependencies))return t.push([j.default.Error,P.localize(5,null,"extensionDependencies")]),t;if(typeof d.activationEvents<"u"){if(!w(d.activationEvents))return t.push([j.default.Error,P.localize(6,null,"activationEvents")]),t;if(typeof d.main>"u"&&typeof d.browser>"u")return t.push([j.default.Error,P.localize(7,null,"activationEvents","main","browser")]),t}if(typeof d.extensionKind<"u"&&typeof d.main>"u"&&t.push([j.default.Warning,P.localize(8,null,"extensionKind")]),typeof d.main<"u"){if(typeof d.main!="string")return t.push([j.default.Error,P.localize(9,null,"main")]),t;{const i=(0,n.$Vg)(l,d.main);(0,n.$Pg)(i,l)||t.push([j.default.Warning,P.localize(10,null,i.path,l.path)])}}if(typeof d.browser<"u"){if(typeof d.browser!="string")return t.push([j.default.Error,P.localize(11,null,"browser")]),t;{const i=(0,n.$Vg)(l,d.browser);(0,n.$Pg)(i,l)||t.push([j.default.Warning,P.localize(12,null,i.path,l.path)])}}if(!M.valid(d.version))return t.push([j.default.Error,P.localize(13,null)]),t;const o=[];if(!g($,f,d,a,o))for(const i of o)t.push([j.default.Error,i]);return t}function g($,f,l,d,a){return d||typeof l.main>"u"&&typeof l.browser>"u"?!0:v($,f,l.engines.vscode,a)}function m($,f,l){return $==="*"||v(f,l,$)}function v($,f,l,d=[]){const a=p(c(l));if(!a)return d.push(P.localize(14,null,l)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return d.push(P.localize(15,null,l)),!1}else if(!a.majorMustEqual)return d.push(P.localize(16,null,l)),!1;return y($,f,a)?!0:(d.push(P.localize(17,null,$,l)),!1)}function w($){if(!Array.isArray($))return!1;for(let f=0,l=$.length;f<l;f++)if(typeof $[f]!="string")return!1;return!0}}),define(oe[209],ae([0,1,17,33]),function(K,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=P;async function P(M,S,E){let h=E&&E.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const p=(await S.readFile(M.serviceMachineIdResource)).value.toString();h=(0,j.$Dg)(p)?p:null}catch{h=null}if(!h){h=(0,j.$Eg)();try{await S.writeFile(M.serviceMachineIdResource,n.$ue.fromString(h))}catch{}}return E?.store("storage.serviceMachineId",h,-1,1),h}}),define(oe[77],ae([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=void 0;class n{constructor(P,M=[],S=!1){this.ctor=P,this.staticArguments=M,this.supportsDelayedInstantiation=S}}e.$fi=n}),define(oe[210],ae([0,1,77]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$gs=M,e.$hs=S;const j=[];var P;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function M(E,h,c){h instanceof n.$fi||(h=new n.$fi(h,[],!!c)),j.push([E,h])}function S(){return j}}),define(oe[211],ae([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=void 0;class n{constructor(M,S){this.key=M,this.data=S,this.incoming=new Map,this.outgoing=new Map}}e.$Wq=n;class j{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const S of this.a.values())S.outgoing.size===0&&M.push(S);return M}insertEdge(M,S){const E=this.lookupOrInsertNode(M),h=this.lookupOrInsertNode(S);E.outgoing.set(h.key,h),h.incoming.set(E.key,E)}removeNode(M){const S=this.b(M);this.a.delete(S);for(const E of this.a.values())E.outgoing.delete(S),E.incoming.delete(S)}lookupOrInsertNode(M){const S=this.b(M);let E=this.a.get(S);return E||(E=new n(S,M),this.a.set(S,E)),E}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[S,E]of this.a)M.push(`${S}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,S]of this.a){const E=new Set([M]),h=this.c(S,E);if(h)return h}}c(M,S){for(const[E,h]of M.outgoing){if(S.has(E))return[...S,E].join(" -> ");S.add(E);const c=this.c(h,S);if(c)return c;S.delete(E)}}}e.$Xq=j}),define(oe[6],ae([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e._util=void 0,e.$ii=P,e.$ji=M;var n;(function(S){S.serviceIds=new Map,S.DI_TARGET="$di$target",S.DI_DEPENDENCIES="$di$dependencies";function E(h){return h[S.DI_DEPENDENCIES]||[]}S.getServiceDependencies=E})(n||(e._util=n={})),e.$hi=P("instantiationService");function j(S,E,h){E[n.DI_TARGET]===E?E[n.DI_DEPENDENCIES].push({id:S,index:h}):(E[n.DI_DEPENDENCIES]=[{id:S,index:h}],E[n.DI_TARGET]=E)}function P(S){if(n.serviceIds.has(S))return n.serviceIds.get(S);const E=function(h,c,p){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");j(E,h,p)};return E.toString=()=>S,n.serviceIds.set(S,E),E}function M(S){return S}}),define(oe[78],ae([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kac=void 0,e.$Kac=(0,n.$ii)("auxiliaryWindowsMainService")}),define(oe[65],ae([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T_b=void 0,e.$T_b=(0,n.$ii)("backupMainService")}),define(oe[18],ae([0,1,12,7,6]),function(K,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Oi=void 0,e.$Pi=M,e.$Qi=S,e.$Ri=h,e.$Si=c,e.$Ti=p,e.$Ui=y,e.$Vi=k,e.$Wi=m,e.$Xi=v,e.$Yi=w,e.$Oi=(0,P.$ii)("configurationService");function M($){return $&&typeof $=="object"&&(!$.overrideIdentifier||typeof $.overrideIdentifier=="string")&&(!$.resource||$.resource instanceof j.URI)}function S($){return $&&typeof $=="object"&&(!$.overrideIdentifiers||Array.isArray($.overrideIdentifiers))&&!$.overrideIdentifier&&(!$.resource||$.resource instanceof j.URI)}var E;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.USER=2]="USER",$[$.USER_LOCAL=3]="USER_LOCAL",$[$.USER_REMOTE=4]="USER_REMOTE",$[$.WORKSPACE=5]="WORKSPACE",$[$.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",$[$.DEFAULT=7]="DEFAULT",$[$.MEMORY=8]="MEMORY"})(E||(e.ConfigurationTarget=E={}));function h($){switch($){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function c($){return $.applicationValue!==void 0||$.userValue!==void 0||$.userLocalValue!==void 0||$.userRemoteValue!==void 0||$.workspaceValue!==void 0||$.workspaceFolderValue!==void 0}function p($,f){const l=Object.create(null);for(const d in $)y(l,d,$[d],f);return l}function y($,f,l,d){const a=f.split("."),t=a.pop();let o=$;for(let r=0;r<a.length;r++){const i=a[r];let s=o[i];switch(typeof s){case"undefined":s=o[i]=Object.create(null);break;case"object":break;default:d(`Ignoring ${f} as ${a.slice(0,r+1).join(".")} is ${JSON.stringify(s)}`);return}o=s}if(typeof o=="object"&&o!==null)try{o[t]=l}catch{d(`Ignoring ${f} as ${a.join(".")} is ${JSON.stringify(o)}`)}else d(`Ignoring ${f} as ${a.join(".")} is ${JSON.stringify(o)}`)}function k($,f){const l=f.split(".");g($,l)}function g($,f){const l=f.shift();if(f.length===0){delete $[l];return}if(Object.keys($).indexOf(l)!==-1){const d=$[l];typeof d=="object"&&!Array.isArray(d)&&(g(d,f),Object.keys(d).length===0&&delete $[l])}}function m($,f,l){function d(o,r){let i=o;for(const s of r){if(typeof i!="object"||i===null)return;i=i[s]}return i}const a=f.split("."),t=d($,a);return typeof t>"u"?l:t}function v($,f,l){Object.keys(f).forEach(d=>{d!=="__proto__"&&(d in $?n.$Xf($[d])&&n.$Xf(f[d])?v($[d],f[d],l):l&&($[d]=f[d]):$[d]=f[d])})}function w($){return $.replace(/[\[\]]/g,"")}}),define(oe[118],ae([0,1,4,25,200,6,166,15]),function(K,e,n,j,P,M,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$gj=e.$fj=e.ContextKeyExprType=void 0,e.$ej=c,e.$hj=o,e.$ij=r,e.$Bj=z;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",n.$j),h.set("isLinux",n.$k),h.set("isWindows",n.$i),h.set("isWeb",n.$o),h.set("isMacNative",n.$j&&!n.$o),h.set("isEdge",n.$H),h.set("isFirefox",n.$F),h.set("isChrome",n.$E),h.set("isSafari",n.$G);function c(X,A){if(h.get(X)!==void 0)throw(0,E.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(X,A)}const p=Object.prototype.hasOwnProperty;var y;(function(X){X[X.False=0]="False",X[X.True=1]="True",X[X.Defined=2]="Defined",X[X.Not=3]="Not",X[X.Equals=4]="Equals",X[X.NotEquals=5]="NotEquals",X[X.And=6]="And",X[X.Regex=7]="Regex",X[X.NotRegex=8]="NotRegex",X[X.Or=9]="Or",X[X.In=10]="In",X[X.NotIn=11]="NotIn",X[X.Greater=12]="Greater",X[X.GreaterEquals=13]="GreaterEquals",X[X.Smaller=14]="Smaller",X[X.SmallerEquals=15]="SmallerEquals"})(y||(e.ContextKeyExprType=y={}));const k={regexParsingWithErrorRecovery:!0},g=(0,S.localize)(0,null),m=(0,S.localize)(1,null),v=(0,S.localize)(2,null),w=(0,S.localize)(3,null),$=(0,S.localize)(4,null),f=(0,S.localize)(5,null),l=(0,S.localize)(6,null),d=(0,S.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(A=k){this.k=A,this.d=new P.$dj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(A){if(A===""){this.h.push({message:g,offset:0,lexeme:"",additionalInfo:m});return}this.f=this.d.reset(A).scan(),this.g=0,this.h=[];try{const N=this.l();if(!this.E()){const _=this.D(),se=_.type===17?f:void 0;throw this.h.push({message:$,offset:_.offset,lexeme:P.$dj.getLexeme(_),additionalInfo:se}),a.c}return N}catch(N){if(N!==a.c)throw N;return}}l(){return this.m()}m(){const A=[this.o()];for(;this.y(16);){const N=this.o();A.push(N)}return A.length===1?A[0]:t.or(...A)}o(){const A=[this.s()];for(;this.y(15);){const N=this.s();A.push(N)}return A.length===1?A[0]:t.and(...A)}s(){if(this.y(2)){const A=this.D();switch(A.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),u.INSTANCE;case 0:{this.z();const N=this.l();return this.A(1,w),N?.negate()}case 17:return this.z(),R.create(A.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",A)}}return this.t()}t(){const A=this.D();switch(A.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const N=this.l();return this.A(1,w),N}case 17:{const N=A.lexeme;if(this.z(),this.y(9)){const se=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),se.type!==10)throw this.B("REGEX",se);const J=se.lexeme,V=J.lastIndexOf("/"),H=V===J.length-1?void 0:this.w(J.substring(V+1));let U;try{U=new RegExp(J.substring(1,V),H)}catch{throw this.B("REGEX",se)}return te.create(N,U)}switch(se.type){case 10:case 19:{const J=[se.lexeme];this.z();let V=this.D(),H=0;for(let me=0;me<se.lexeme.length;me++)se.lexeme.charCodeAt(me)===40?H++:se.lexeme.charCodeAt(me)===41&&H--;for(;!this.E()&&V.type!==15&&V.type!==16;){switch(V.type){case 0:H++;break;case 1:H--;break;case 10:case 18:for(let me=0;me<V.lexeme.length;me++)V.lexeme.charCodeAt(me)===40?H++:se.lexeme.charCodeAt(me)===41&&H--}if(H<0)break;J.push(P.$dj.getLexeme(V)),this.z(),V=this.D()}const U=J.join(""),re=U.lastIndexOf("/"),ee=re===U.length-1?void 0:this.w(U.substring(re+1));let fe;try{fe=new RegExp(U.substring(1,re),ee)}catch{throw this.B("REGEX",se)}return t.regex(N,fe)}case 18:{const J=se.lexeme;this.z();let V=null;if(!(0,j.$Ue)(J)){const H=J.indexOf("/"),U=J.lastIndexOf("/");if(H!==U&&H>=0){const re=J.slice(H+1,U),ee=J[U+1]==="i"?"i":"";try{V=new RegExp(re,ee)}catch{throw this.B("REGEX",se)}}}if(V===null)throw this.B("REGEX",se);return te.create(N,V)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,v);const se=this.u();return t.notIn(N,se)}switch(this.D().type){case 3:{this.z();const se=this.u();if(this.x().type===18)return t.equals(N,se);switch(se){case"true":return t.has(N);case"false":return t.not(N);default:return t.equals(N,se)}}case 4:{this.z();const se=this.u();if(this.x().type===18)return t.notEquals(N,se);switch(se){case"true":return t.not(N);case"false":return t.has(N);default:return t.notEquals(N,se)}}case 5:return this.z(),x.create(N,this.u());case 6:return this.z(),le.create(N,this.u());case 7:return this.z(),F.create(N,this.u());case 8:return this.z(),q.create(N,this.u());case 13:return this.z(),t.in(N,this.u());default:return t.has(N)}}case 20:throw this.h.push({message:l,offset:A.offset,lexeme:"",additionalInfo:d}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const A=this.D();switch(A.type){case 17:case 18:return this.z(),A.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(A){return A.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(A){return this.C(A)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(A,N){if(this.C(A))return this.z();throw this.B(N,this.D())}B(A,N,_){const se=(0,S.localize)(8,null,A,P.$dj.getLexeme(N)),J=N.offset,V=P.$dj.getLexeme(N);return this.h.push({message:se,offset:J,lexeme:V,additionalInfo:_}),a.c}C(A){return this.D().type===A}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$fj=a;class t{static false(){return s.INSTANCE}static true(){return u.INSTANCE}static has(A){return b.create(A)}static equals(A,N){return C.create(A,N)}static notEquals(A,N){return O.create(A,N)}static regex(A,N){return te.create(A,N)}static in(A,N){return I.create(A,N)}static notIn(A,N){return D.create(A,N)}static not(A){return R.create(A)}static and(...A){return Z.create(A,null,!0)}static or(...A){return B.create(A,null,!0)}static greater(A,N){return F.create(A,N)}static greaterEquals(A,N){return q.create(A,N)}static smaller(A,N){return x.create(A,N)}static smallerEquals(A,N){return le.create(A,N)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(A){return A==null?void 0:this.c.parse(A)}}e.$gj=t;function o(X){const A=new a({regexParsingWithErrorRecovery:!1});return X.map(N=>(A.parse(N),A.lexingErrors.length>0?A.lexingErrors.map(_=>({errorMessage:_.additionalInfo?(0,S.localize)(9,null,_.additionalInfo):(0,S.localize)(10,null),offset:_.offset,length:_.lexeme.length})):A.parsingErrors.length>0?A.parsingErrors.map(_=>({errorMessage:_.additionalInfo?`${_.message}. ${_.additionalInfo}`:_.message,offset:_.offset,length:_.lexeme.length})):[]))}function r(X,A){const N=X?X.substituteConstants():void 0,_=A?A.substituteConstants():void 0;return!N&&!_?!0:!N||!_?!1:N.equals(_)}function i(X,A){return X.cmp(A)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return u.INSTANCE}}e.$jj=s;class u{static{this.INSTANCE=new u}constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return s.INSTANCE}}e.$kj=u;class b{static create(A,N=null){const _=h.get(A);return typeof _=="boolean"?_?u.INSTANCE:s.INSTANCE:new b(A,N)}constructor(A,N){this.key=A,this.c=N,this.type=2}cmp(A){return A.type!==this.type?this.type-A.type:T(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=h.get(this.key);return typeof A=="boolean"?A?u.INSTANCE:s.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.c||(this.c=R.create(this.key,this)),this.c}}e.$lj=b;class C{static create(A,N,_=null){if(typeof N=="boolean")return N?b.create(A,_):R.create(A,_);const se=h.get(A);return typeof se=="boolean"?N===(se?"true":"false")?u.INSTANCE:s.INSTANCE:new C(A,N,_)}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=4}cmp(A){return A.type!==this.type?this.type-A.type:G(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=h.get(this.c);if(typeof A=="boolean"){const N=A?"true":"false";return this.d===N?u.INSTANCE:s.INSTANCE}return this}evaluate(A){return A.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(A){return A.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$mj=C;class I{static create(A,N){return new I(A,N)}constructor(A,N){this.d=A,this.f=N,this.type=10,this.c=null}cmp(A){return A.type!==this.type?this.type-A.type:G(this.d,this.f,A.d,A.f)}equals(A){return A.type===this.type?this.d===A.d&&this.f===A.f:!1}substituteConstants(){return this}evaluate(A){const N=A.getValue(this.f),_=A.getValue(this.d);return Array.isArray(N)?N.includes(_):typeof _=="string"&&typeof N=="object"&&N!==null?p.call(N,_):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(A){return A.mapIn(this.d,this.f)}negate(){return this.c||(this.c=D.create(this.d,this.f)),this.c}}e.$nj=I;class D{static create(A,N){return new D(A,N)}constructor(A,N){this.d=A,this.f=N,this.type=11,this.c=I.create(A,N)}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(A){return A.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$oj=D;class O{static create(A,N,_=null){if(typeof N=="boolean")return N?R.create(A,_):b.create(A,_);const se=h.get(A);return typeof se=="boolean"?N===(se?"true":"false")?s.INSTANCE:u.INSTANCE:new O(A,N,_)}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=5}cmp(A){return A.type!==this.type?this.type-A.type:G(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=h.get(this.c);if(typeof A=="boolean"){const N=A?"true":"false";return this.d===N?s.INSTANCE:u.INSTANCE}return this}evaluate(A){return A.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(A){return A.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$pj=O;class R{static create(A,N=null){const _=h.get(A);return typeof _=="boolean"?_?s.INSTANCE:u.INSTANCE:new R(A,N)}constructor(A,N){this.c=A,this.d=N,this.type=3}cmp(A){return A.type!==this.type?this.type-A.type:T(this.c,A.c)}equals(A){return A.type===this.type?this.c===A.c:!1}substituteConstants(){const A=h.get(this.c);return typeof A=="boolean"?A?s.INSTANCE:u.INSTANCE:this}evaluate(A){return!A.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(A){return A.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$qj=R;function W(X,A){if(typeof X=="string"){const N=parseFloat(X);isNaN(N)||(X=N)}return typeof X=="string"||typeof X=="number"?A(X):s.INSTANCE}class F{static create(A,N,_=null){return W(N,se=>new F(A,se,_))}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=12}cmp(A){return A.type!==this.type?this.type-A.type:G(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}e.$rj=F;class q{static create(A,N,_=null){return W(N,se=>new q(A,se,_))}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=13}cmp(A){return A.type!==this.type?this.type-A.type:G(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.$sj=q;class x{static create(A,N,_=null){return W(N,se=>new x(A,se,_))}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=14}cmp(A){return A.type!==this.type?this.type-A.type:G(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$tj=x;class le{static create(A,N,_=null){return W(N,se=>new le(A,se,_))}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=15}cmp(A){return A.type!==this.type?this.type-A.type:G(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$uj=le;class te{static create(A,N){return new te(A,N)}constructor(A,N){this.d=A,this.f=N,this.type=7,this.c=null}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.d<A.d)return-1;if(this.d>A.d)return 1;const N=this.f?this.f.source:"",_=A.f?A.f.source:"";return N<_?-1:N>_?1:0}equals(A){if(A.type===this.type){const N=this.f?this.f.source:"",_=A.f?A.f.source:"";return this.d===A.d&&N===_}return!1}substituteConstants(){return this}evaluate(A){const N=A.getValue(this.d);return this.f?this.f.test(N):!1}serialize(){const A=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${A}`}keys(){return[this.d]}map(A){return A.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ue.create(this)),this.c}}e.$vj=te;class ue{static create(A){return new ue(A)}constructor(A){this.c=A,this.type=8}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(A){return new ue(this.c.map(A))}negate(){return this.c}}e.$wj=ue;function Y(X){let A=null;for(let N=0,_=X.length;N<_;N++){const se=X[N].substituteConstants();if(X[N]!==se&&A===null){A=[];for(let J=0;J<N;J++)A[J]=X[J]}A!==null&&(A[N]=se)}return A===null?X:A}class Z{static create(A,N,_){return Z.d(A,N,_)}constructor(A,N){this.expr=A,this.c=N,this.type=6}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let N=0,_=this.expr.length;N<_;N++){const se=i(this.expr[N],A.expr[N]);if(se!==0)return se}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let N=0,_=this.expr.length;N<_;N++)if(!this.expr[N].equals(A.expr[N]))return!1;return!0}return!1}substituteConstants(){const A=Y(this.expr);return A===this.expr?this:Z.create(A,this.c,!1)}evaluate(A){for(let N=0,_=this.expr.length;N<_;N++)if(!this.expr[N].evaluate(A))return!1;return!0}static d(A,N,_){const se=[];let J=!1;for(const V of A)if(V){if(V.type===1){J=!0;continue}if(V.type===0)return s.INSTANCE;if(V.type===6){se.push(...V.expr);continue}se.push(V)}if(se.length===0&&J)return u.INSTANCE;if(se.length!==0){if(se.length===1)return se[0];se.sort(i);for(let V=1;V<se.length;V++)se[V-1].equals(se[V])&&(se.splice(V,1),V--);if(se.length===1)return se[0];for(;se.length>1;){const V=se[se.length-1];if(V.type!==9)break;se.pop();const H=se.pop(),U=se.length===0,re=B.create(V.expr.map(ee=>Z.create([ee,H],null,_)),null,U);re&&(se.push(re),se.sort(i))}if(se.length===1)return se[0];if(_){for(let V=0;V<se.length;V++)for(let H=V+1;H<se.length;H++)if(se[V].negate().equals(se[H]))return s.INSTANCE;if(se.length===1)return se[0]}return new Z(se,N)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const N of this.expr)A.push(...N.keys());return A}map(A){return new Z(this.expr.map(N=>N.map(A)),null)}negate(){if(!this.c){const A=[];for(const N of this.expr)A.push(N.negate());this.c=B.create(A,this,!0)}return this.c}}e.$xj=Z;class B{static create(A,N,_){return B.d(A,N,_)}constructor(A,N){this.expr=A,this.c=N,this.type=9}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let N=0,_=this.expr.length;N<_;N++){const se=i(this.expr[N],A.expr[N]);if(se!==0)return se}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let N=0,_=this.expr.length;N<_;N++)if(!this.expr[N].equals(A.expr[N]))return!1;return!0}return!1}substituteConstants(){const A=Y(this.expr);return A===this.expr?this:B.create(A,this.c,!1)}evaluate(A){for(let N=0,_=this.expr.length;N<_;N++)if(this.expr[N].evaluate(A))return!0;return!1}static d(A,N,_){let se=[],J=!1;if(A){for(let V=0,H=A.length;V<H;V++){const U=A[V];if(U){if(U.type===0){J=!0;continue}if(U.type===1)return u.INSTANCE;if(U.type===9){se=se.concat(U.expr);continue}se.push(U)}}if(se.length===0&&J)return s.INSTANCE;se.sort(i)}if(se.length!==0){if(se.length===1)return se[0];for(let V=1;V<se.length;V++)se[V-1].equals(se[V])&&(se.splice(V,1),V--);if(se.length===1)return se[0];if(_){for(let V=0;V<se.length;V++)for(let H=V+1;H<se.length;H++)if(se[V].negate().equals(se[H]))return u.INSTANCE;if(se.length===1)return se[0]}return new B(se,N)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const N of this.expr)A.push(...N.keys());return A}map(A){return new B(this.expr.map(N=>N.map(A)),null)}negate(){if(!this.c){const A=[];for(const N of this.expr)A.push(N.negate());for(;A.length>1;){const N=A.shift(),_=A.shift(),se=[];for(const J of he(N))for(const V of he(_))se.push(Z.create([J,V],null,!1));A.unshift(B.create(se,null,!1))}this.c=B.create(A,this,!0)}return this.c}}e.$yj=B;class L extends b{static{this.d=[]}static all(){return L.d.values()}constructor(A,N,_){super(A,null),this.f=N,typeof _=="object"?L.d.push({..._,key:A}):_!==!0&&L.d.push({key:A,description:_,type:N!=null?typeof N:void 0})}bindTo(A){return A.createKey(this.key,this.f)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return C.create(this.key,A)}notEqualsTo(A){return O.create(this.key,A)}}e.$zj=L,e.$Aj=(0,M.$ii)("contextKeyService");function T(X,A){return X<A?-1:X>A?1:0}function G(X,A,N,_){return X<N?-1:X>N?1:A<_?-1:A>_?1:0}function z(X,A){if(X.type===0||A.type===1)return!0;if(X.type===9)return A.type===9?ce(X.expr,A.expr):!1;if(A.type===9){for(const N of A.expr)if(z(X,N))return!0;return!1}if(X.type===6){if(A.type===6)return ce(A.expr,X.expr);for(const N of X.expr)if(z(N,A))return!0;return!1}return X.equals(A)}function ce(X,A){let N=0,_=0;for(;N<X.length&&_<A.length;){const se=X[N].cmp(A[_]);if(se<0)return!1;se===0&&N++,_++}return N===X.length}function he(X){return X.type===9?X.expr:[X]}}),define(oe[92],ae([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=e.$2m=e.ID=void 0,e.$3m=j,e.ID="diagnosticsService",e.$2m=(0,n.$ii)(e.ID);function j(M){return!!M.hostName&&!!M.errorMessage}class P{async getPerformanceInfo(S,E){return{}}async getSystemInfo(S,E){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(S,E){return""}async getWorkspaceFileExtensions(S){return{extensions:[]}}async reportWorkspaceStats(S){}}e.$4m=P}),define(oe[119],ae([0,1,19,73,168,6,48,4,35]),function(K,e,n,j,P,M,S,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$sw=e.$rw=e.$qw=void 0,e.$tw=g,e.$uw=m,e.$qw=(0,M.$ii)("dialogService");var c;(function(v){v[v.Confirmation=1]="Confirmation",v[v.Prompt=2]="Prompt",v[v.Input=3]="Input"})(c||(c={}));class p{a(w){return this.d(w,c.Confirmation)}b(w){return this.d(w,c.Prompt)}c(w){return this.d(w,c.Input)}d(w,$){const f=[];switch($){case c.Confirmation:{const l=w;l.primaryButton?f.push(l.primaryButton):f.push((0,P.localize)(0,null)),l.cancelButton?f.push(l.cancelButton):f.push((0,P.localize)(1,null));break}case c.Prompt:{const l=w;Array.isArray(l.buttons)&&l.buttons.length>0&&f.push(...l.buttons.map(d=>d.label)),l.cancelButton&&(l.cancelButton===!0?f.push((0,P.localize)(2,null)):typeof l.cancelButton=="string"?f.push(l.cancelButton):l.cancelButton.label?f.push(l.cancelButton.label):f.push((0,P.localize)(3,null))),f.length===0&&f.push((0,P.localize)(4,null));break}case c.Input:{const l=w;l.primaryButton?f.push(l.primaryButton):f.push((0,P.localize)(5,null)),l.cancelButton?f.push(l.cancelButton):f.push((0,P.localize)(6,null));break}}return f}e(w){if(typeof w=="string")return w;if(typeof w=="number")return w===j.default.Info?"info":w===j.default.Error?"error":w===j.default.Warning?"warning":"none"}f(w,$,f){const l=[...w.buttons??[]];w.cancelButton&&typeof w.cancelButton!="string"&&typeof w.cancelButton!="boolean"&&l.push(w.cancelButton);let d=l[$]?.run({checkboxChecked:f});return d instanceof Promise||(d=Promise.resolve(d)),{result:d,checkboxChecked:f}}}e.$rw=p,e.$sw=(0,M.$ii)("fileDialogService");var y;(function(v){v[v.SAVE=0]="SAVE",v[v.DONT_SAVE=1]="DONT_SAVE",v[v.CANCEL=2]="CANCEL"})(y||(e.ConfirmResult=y={}));const k=10;function g(v){const w=[];return w.push(...v.slice(0,k).map($=>typeof $=="string"?$:(0,n.$Sg)($))),v.length>k&&(v.length-k===1?w.push((0,P.localize)(7,null)):w.push((0,P.localize)(8,null,v.length-k))),w.push(""),w.join(`
`)}function m(v,w){const $=(0,h.$On)(v);let f=($.buttons??[]).map(t=>(0,S.$nw)(t)),l=(v.buttons||[]).map((t,o)=>o),d=0,a=$.cancelId??f.length-1;if(f.length>1){const t=typeof a=="number"?f[a]:void 0;if(E.$k||E.$j){if(typeof t=="string"&&f.length>1&&a!==1){f.splice(a,1),f.splice(1,0,t);const o=l[a];l.splice(a,1),l.splice(1,0,o),a=1}E.$k&&f.length>1&&(f=f.reverse(),l=l.reverse(),d=f.length-1,typeof t=="string"&&(a=d-1))}else if(E.$i&&typeof t=="string"&&f.length>1&&a!==f.length-1){f.splice(a,1),f.push(t);const o=l[a];l.splice(a,1),l.push(o),a=f.length-1}}return $.buttons=f,$.defaultId=d,$.cancelId=a,$.noLink=!0,$.title=$.title||w.nameLong,{options:$,buttonIndeces:l}}}),define(oe[120],ae([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$NW=e.$MW=void 0,e.$OW=M,e.$PW=S,e.$MW=(0,n.$ii)("encryptionService"),e.$NW=(0,n.$ii)("encryptionMainService");var j;(function(E){E.kwallet="kwallet",E.kwallet5="kwallet5",E.gnomeLibsecret="gnome-libsecret",E.basic="basic"})(j||(e.PasswordStoreCLIOption=j={}));var P;(function(E){E.unknown="unknown",E.basicText="basic_text",E.gnomeAny="gnome_any",E.gnomeLibsecret="gnome_libsecret",E.gnomeKeyring="gnome_keyring",E.kwallet="kwallet",E.kwallet5="kwallet5",E.kwallet6="kwallet6",E.dplib="dpapi",E.keychainAccess="keychain_access"})(P||(e.KnownStorageProvider=P={}));function M(E){return E==="kwallet"||E==="kwallet5"||E==="kwallet6"}function S(E){return E==="gnome_any"||E==="gnome_libsecret"||E==="gnome_keyring"}}),define(oe[38],ae([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$pi=void 0,e.$pi=(0,n.$ii)("environmentService"),e.$qi=(0,n.$ji)(e.$pi)}),define(oe[121],ae([0,1,172,6]),function(K,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.ExtensionGalleryErrorCode=e.$So=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Ro=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=void 0,e.$Lo=P,e.$Mo=M,e.$No=S,e.$Oo=E,e.$Po=h,e.$Qo=c,e.$Fo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Go=new RegExp(e.$Fo),e.$Ho="__web_extension",e.$Io="skipWalkthrough",e.$Jo="extensionsSync",e.$Ko="dependecyOrPackExtensionInstall";function P(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function M(l){switch(l){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function S(l,d){switch(l){case 3:return d==="x64"?"win32-x64":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function E(l,d){return d==="web"&&!l.includes("web")}function h(l,d,a){return E(d,a)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===a}function c(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}var p;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(p||(e.SortBy=p={}));var y;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(y||(e.SortOrder=y={}));var k;(function(l){l.Install="install",l.Uninstall="uninstall"})(k||(e.StatisticType=k={}));var g;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(g||(e.InstallOperation=g={})),e.$Ro=(0,j.$ii)("extensionGalleryService");var m;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.DownloadSignature="DownloadSignature",l.UpdateMetadata="UpdateMetadata",l.Extract="Extract",l.Scanning="Scanning",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Signature="Signature",l.NotAllowed="NotAllowed",l.Gallery="Gallery",l.Unknown="Unknown",l.Internal="Internal"})(m||(e.ExtensionManagementErrorCode=m={}));var v;(function(l){l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(v||(e.ExtensionSignaturetErrorCode=v={}));class w extends Error{constructor(d,a){super(d),this.code=a,this.name=a}}e.$So=w;var $;(function(l){l.Timeout="Timeout",l.Cancelled="Cancelled",l.Failed="Failed"})($||(e.ExtensionGalleryErrorCode=$={}));class f extends Error{constructor(d,a){super(d),this.code=a,this.name=a}}e.$To=f,e.$Uo=(0,j.$ii)("extensionManagementService"),e.$Vo="extensionsIdentifiers/disabled",e.$Wo="extensionsIdentifiers/enabled",e.$Xo=(0,j.$ii)("IGlobalExtensionEnablementService"),e.$Yo=(0,j.$ii)("IExtensionTipsService"),e.$Zo=(0,n.localize2)(0,"Extensions"),e.$1o=(0,n.localize2)(1,"Preferences")}),define(oe[212],ae([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aac=e.$zac=void 0,e.$zac=(0,n.$ii)("extensionHostStarter"),e.$Aac="extensionHostStarter"}),define(oe[213],ae([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E5b=e.$D5b=void 0,e.$D5b=(0,n.$ii)("externalTerminal"),e.$E5b="Terminal.app"}),define(oe[214],ae([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cac=void 0,e.$Cac=(0,n.$ii)("externalTerminal")}),define(oe[215],ae([0,1,49,51,13,9,4,75,21,90,176,213]),function(K,e,n,j,P,M,S,E,h,c,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fac=e.$Eac=e.$Dac=void 0;const k=p.localize(0,null);class g{async getDefaultTerminalForPlatforms(){return{windows:m.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class m extends g{static{this.b="cmd.exe"}openTerminal(a,t){return this.spawnTerminal(n,a,c.$am(),t)}spawnTerminal(a,t,o,r){const i=t.windowsExec||m.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const s=M.$oc(i,".exe").toLowerCase();if(s==="cmder")return a.spawn(i,r?[r]:void 0),Promise.resolve(void 0);const u=["/c","start","/wait"];return i.indexOf(" ")>=0&&u.push('""'),u.push(i),s==="wt"&&u.push("-d ."),new Promise((b,C)=>{const I=$(process),D=a.spawn(o,u,{cwd:r,env:I,detached:!0});D.on("error",C),D.on("exit",()=>b())})}async runInTerminal(a,t,o,r,i){const s="windowsExec"in i&&i.windowsExec?i.windowsExec:m.getDefaultTerminalWindows(),u=await m.f();return new Promise((b,C)=>{const I=`"${t} - ${k}"`,D=`"${o.join('" "')}" & pause`,O=Object.assign({},$(process),r);Object.keys(O).filter(x=>O[x]===null).forEach(x=>delete O[x]);const R={cwd:t,env:O,windowsVerbatimArguments:!0};let W,F;M.$oc(s,".exe")==="wt"?(W=s,F=["-d",".",m.b,"/c",D]):u?(W=u,F=["-d",".",s,"/c",D]):(W=m.b,F=["/c","start",I,"/wait",s,"/c",`"${D}"`]),n.spawn(W,F,R).on("error",x=>{C(f(x))}),b(void 0)})}static getDefaultTerminalWindows(){if(!m.d){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");m.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return m.d}static async f(){try{const a=await c.win32.findExecutable("wt");return await h.Promises.exists(a)?a:void 0}catch{return}}}e.$Dac=m,Ee([j.$Mh],m,"f",null);class v extends g{static{this.b="/usr/bin/osascript"}openTerminal(a,t){return this.spawnTerminal(n,a,t)}runInTerminal(a,t,o,r,i){const s=i.osxExec||y.$E5b;return new Promise((u,b)=>{if(s===y.$E5b||s==="iTerm.app"){const C=s===y.$E5b?"TerminalHelper":"iTermHelper",D=[P.$Cg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${C}.scpt`).fsPath,"-t",a||k,"-w",t];for(const W of o)D.push("-a"),D.push(W);if(r){const W=Object.assign({},$(process),r);for(const F in W){const q=W[F];q===null?(D.push("-u"),D.push(F)):(D.push("-e"),D.push(`${F}=${q}`))}}let O="";const R=n.spawn(v.b,D);R.on("error",W=>{b(f(W))}),R.stderr.on("data",W=>{O+=W.toString()}),R.on("exit",W=>{if(W===0)u(void 0);else if(O){const F=O.split(`
`,1);b(new Error(F[0]))}else b(new Error(p.localize(1,null,C,W)))})}else b(new Error(p.localize(2,null,s)))})}spawnTerminal(a,t,o){const r=t.osxExec||y.$E5b;return new Promise((i,s)=>{const u=["-a",r];o&&u.push(o);const b=$(process),C=a.spawn("/usr/bin/open",u,{cwd:o,env:b});C.on("error",s),C.on("exit",()=>i())})}}e.$Eac=v;class w extends g{static{this.b=p.localize(3,null)}openTerminal(a,t){return this.spawnTerminal(n,a,t)}runInTerminal(a,t,o,r,i){const s=i.linuxExec?Promise.resolve(i.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((u,b)=>{const C=[];s.then(I=>{I.indexOf("gnome-terminal")>=0?C.push("-x"):C.push("-e"),C.push("bash"),C.push("-c");const D=`${l(o)}; echo; read -p "${w.b}" -n1;`;C.push(`''${D}''`);const O=Object.assign({},$(process),r);Object.keys(O).filter(q=>O[q]===null).forEach(q=>delete O[q]);const R={cwd:t,env:O};let W="";const F=n.spawn(I,C,R);F.on("error",q=>{b(f(q))}),F.stderr.on("data",q=>{W+=q.toString()}),F.on("exit",q=>{if(q===0)u(void 0);else if(W){const x=W.split(`
`,1);b(new Error(x[0]))}else b(new Error(p.localize(4,null,I,q)))})})})}static async getDefaultTerminalLinuxReady(){if(!w.d)if(!S.$k)w.d=Promise.resolve("xterm");else{const a=await h.Promises.exists("/etc/debian_version");w.d=new Promise(t=>{a?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return w.d}spawnTerminal(a,t,o){const r=t.linuxExec?Promise.resolve(t.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((i,s)=>{r.then(u=>{const b=$(process),C=a.spawn(u,[],{cwd:o,env:b});C.on("error",s),C.on("exit",()=>i())})})}}e.$Fac=w;function $(d){const a={...d.env};return(0,E.$$l)(a),a}function f(d){return"errno"in d&&d.errno==="ENOENT"&&"path"in d&&typeof d.path=="string"?new Error(p.localize(5,null,d.path)):d}function l(d){let a="";for(const t of d)t.indexOf(" ")>=0?a+='"'+t+'"':a+=t,a+=" ";return a}}),define(oe[16],ae([0,1,59,9,25,12,7,178,6,4,13,62]),function(K,e,n,j,P,M,S,E,h,c,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=e.$hl=e.FileKind=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.FileOperationResult=e.$_k=e.$$k=e.$0k=e.$8k=e.FileChangeType=e.$7k=e.FileOperation=e.$1k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Ok=void 0,e.$Pk=k,e.$Qk=v,e.$Rk=$,e.$Sk=f,e.$Tk=l,e.$Uk=d,e.$Vk=a,e.$Wk=t,e.$Xk=o,e.$Yk=r,e.$Zk=i,e.$2k=b,e.$3k=C,e.$4k=I,e.$5k=D,e.$6k=O,e.$9k=x,e.$il=B,e.$jl=L,e.$ll=G,e.$Ok=(0,h.$ii)("fileService");function k(z){return z.create===!0}var g;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(g||(e.FileType=g={}));var m;(function(z){z[z.Readonly=1]="Readonly",z[z.Locked=2]="Locked"})(m||(e.FilePermission=m={}));function v(z){const ce=z;return!!ce&&typeof ce.onDidChange=="function"}var w;(function(z){z[z.None=0]="None",z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock",z[z.FileAtomicRead=16384]="FileAtomicRead",z[z.FileAtomicWrite=32768]="FileAtomicWrite",z[z.FileAtomicDelete=65536]="FileAtomicDelete",z[z.FileClone=131072]="FileClone"})(w||(e.FileSystemProviderCapabilities=w={}));function $(z){return!!(z.capabilities&2)}function f(z){return!!(z.capabilities&8)}function l(z){return!!(z.capabilities&131072)}function d(z){return!!(z.capabilities&4)}function a(z){return!!(z.capabilities&16)}function t(z){return $(z)?!!(z.capabilities&16384):!1}function o(z){return $(z)?!!(z.capabilities&32768):!1}function r(z){return!!(z.capabilities&65536)}function i(z){return!!(z.capabilities&2048)}var s;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsStorageQuota="EntryExceedsStorageQuota",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(s||(e.FileSystemProviderErrorCode=s={}));class u extends Error{static create(ce,he){const X=new u(ce.toString(),he);return I(X,he),X}constructor(ce,he){super(ce),this.code=he}}e.$1k=u;function b(z,ce){return u.create(z,ce)}function C(z){return z||b((0,E.localize)(0,null),s.Unknown)}function I(z,ce){return z.name=ce?`${ce} (FileSystemError)`:"FileSystemError",z}function D(z){if(!z)return s.Unknown;if(z instanceof u)return z.code;const ce=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!ce)return s.Unknown;switch(ce[1]){case s.FileExists:return s.FileExists;case s.FileIsADirectory:return s.FileIsADirectory;case s.FileNotADirectory:return s.FileNotADirectory;case s.FileNotFound:return s.FileNotFound;case s.FileTooLarge:return s.FileTooLarge;case s.FileWriteLocked:return s.FileWriteLocked;case s.NoPermissions:return s.NoPermissions;case s.Unavailable:return s.Unavailable}return s.Unknown}function O(z){if(z instanceof le)return z.fileOperationResult;switch(D(z)){case s.FileNotFound:return 1;case s.FileIsADirectory:return 0;case s.FileNotADirectory:return 9;case s.FileWriteLocked:return 5;case s.NoPermissions:return 6;case s.FileExists:return 4;case s.FileTooLarge:return 7;default:return 10}}var R;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY",z[z.WRITE=4]="WRITE"})(R||(e.FileOperation=R={}));class W{constructor(ce,he,X){this.resource=ce,this.operation=he,this.target=X}isOperation(ce){return this.operation===ce}}e.$7k=W;var F;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class q{static{this.a=null}constructor(ce,he){this.c=he,this.b=void 0,this.d=new y.$V(()=>{const X=n.$oi.forUris(()=>this.c);return X.fill(this.rawAdded.map(A=>[A,!0])),X}),this.f=new y.$V(()=>{const X=n.$oi.forUris(()=>this.c);return X.fill(this.rawUpdated.map(A=>[A,!0])),X}),this.g=new y.$V(()=>{const X=n.$oi.forUris(()=>this.c);return X.fill(this.rawDeleted.map(A=>[A,!0])),X}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const X of ce){switch(X.type){case 1:this.rawAdded.push(X.resource);break;case 0:this.rawUpdated.push(X.resource);break;case 2:this.rawDeleted.push(X.resource);break}this.b!==q.a&&(typeof X.cId=="number"?this.b===void 0?this.b=X.cId:this.b!==X.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(ce,...he){return this.h(ce,{includeChildren:!1},...he)}affects(ce,...he){return this.h(ce,{includeChildren:!0},...he)}h(ce,he,...X){if(!ce)return!1;const A=X.length>0;return!!((!A||X.includes(1))&&(this.d.value.get(ce)||he.includeChildren&&this.d.value.findSuperstr(ce))||(!A||X.includes(0))&&(this.f.value.get(ce)||he.includeChildren&&this.f.value.findSuperstr(ce))||(!A||X.includes(2))&&(this.g.value.findSubstr(ce)||he.includeChildren&&this.g.value.findSuperstr(ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ce){return this.b===ce}hasCorrelation(){return typeof this.b=="number"}}e.$8k=q;function x(z,ce,he){return!z||!ce||z===ce||ce.length>z.length?!1:(ce.charAt(ce.length-1)!==j.sep&&(ce+=j.sep),he?(0,P.$mf)(z,ce):z.indexOf(ce)===0)}class le extends Error{constructor(ce,he,X){super(ce),this.fileOperationResult=he,this.options=X}}e.$0k=le;class te extends le{constructor(ce,he,X,A){super(ce,he,A),this.fileOperationResult=he,this.size=X}}e.$$k=te;class ue extends le{constructor(ce,he,X){super(ce,2,X),this.stat=he}}e.$_k=ue;var Y;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Y||(e.FileOperationResult=Y={})),e.$al={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$bl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$cl="files.associations",e.$dl="files.exclude",e.$el="files.readonlyInclude",e.$fl="files.readonlyExclude",e.$gl="files.readonlyFromPermissions";var Z;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(Z||(e.FileKind=Z={})),e.$hl="";function B(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}async function L(z,ce){if(!ce.hasProvider(S.URI.from({scheme:z.scheme})))return new Promise(he=>{const X=ce.onDidChangeFileSystemProviderRegistrations(A=>{A.scheme===z.scheme&&A.added&&(X.dispose(),he())})})}class T{static{this.KB=1024}static{this.MB=T.KB*T.KB}static{this.GB=T.MB*T.KB}static{this.TB=T.GB*T.KB}static formatSize(ce){return(0,M.$Zf)(ce)||(ce=0),ce<T.KB?(0,E.localize)(1,null,ce.toFixed(0)):ce<T.MB?(0,E.localize)(2,null,(ce/T.KB).toFixed(2)):ce<T.GB?(0,E.localize)(3,null,(ce/T.MB).toFixed(2)):ce<T.TB?(0,E.localize)(4,null,(ce/T.GB).toFixed(2)):(0,E.localize)(5,null,(ce/T.TB).toFixed(2))}}e.$kl=T;function G(z){const ce=typeof z=="string"||z?.scheme===p.Schemas.vscodeRemote;return typeof z!="string"&&z?.scheme===p.Schemas.file?1024*T.MB:ce?10*T.MB:c.$o?50*T.MB:1024*T.MB}}),define(oe[122],ae([0,1,17,15,179,16]),function(K,e,n,j,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=S;async function S(p,y,k,g,m,v){let w;try{await E(p,y,k,g,m,v)}catch($){w=$}finally{w&&m.errorTransformer&&(w=m.errorTransformer(w)),typeof w<"u"&&k.error(w),k.end()}}async function E(p,y,k,g,m,v){h(v);const w=await p.open(y,{create:!1});try{h(v);let $=0,f=0,l=m&&typeof m.length=="number"?m.length:void 0,d=n.$ue.alloc(Math.min(m.bufferSize,typeof l=="number"?l:m.bufferSize)),a=m&&typeof m.position=="number"?m.position:0,t=0;do f=await p.read(w,a,d.buffer,t,d.byteLength-t),a+=f,t+=f,$+=f,typeof l=="number"&&(l-=f),t===d.byteLength&&(await k.write(g(d)),d=n.$ue.alloc(Math.min(m.bufferSize,typeof l=="number"?l:m.bufferSize)),t=0);while(f>0&&(typeof l!="number"||l>0)&&h(v)&&c($,m));if(t>0){let o=t;typeof l=="number"&&(o=Math.min(t,l)),k.write(g(d.slice(0,o)))}}catch($){throw(0,M.$3k)($)}finally{await p.close(w)}}function h(p){if(p.isCancellationRequested)throw(0,j.$6)();return!0}function c(p,y){if(typeof y?.limits?.size=="number"&&p>y.limits.size)throw(0,M.$2k)((0,P.localize)(0,null),M.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[60],ae([0,1,108,2,9,4,7,16]),function(K,e,n,j,P,M,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=e.$yq=e.$xq=void 0,e.$vq=h,e.$wq=c,e.$Aq=g,e.$Bq=m,e.$Cq=v,e.$Dq=w;function h(f){return typeof f.correlationId=="number"}function c(f){return f.recursive===!0}class p extends j.$Uc{static{this.a=5}constructor(l,d,a,t){super(),this.h=l,this.j=d,this.m=a,this.n=t,this.c=this.B(new j.$Vc),this.f=void 0,this.g=0}s(){const l=new j.$Tc;this.c.value=l,this.b=this.r(l),this.b.setVerboseLogging(this.m),l.add(this.b.onDidChangeFile(d=>this.h(d))),l.add(this.b.onDidLogMessage(d=>this.j(d))),l.add(this.b.onDidError(d=>this.t(d)))}t(l){this.n.restartOnError?this.g<p.a&&this.f?(this.w(`restarting watcher after error: ${l}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${l}`):this.w(l)}u(l){this.g++,this.s(),this.watch(l)}async watch(l){this.f=l,await this.b?.watch(l)}async setVerboseLogging(l){this.m=l,await this.b?.setVerboseLogging(l)}w(l){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${l}`})}y(l){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${l}`})}dispose(){return this.b=void 0,super.dispose()}}e.$xq=p;class y extends p{constructor(l,d,a){super(l,d,a,{type:"node.js",restartOnError:!1})}}e.$yq=y;class k extends p{constructor(l,d,a){super(l,d,a,{type:"universal",restartOnError:!0})}}e.$zq=k;function g(f){return f.map(l=>({type:l.type,resource:S.URI.revive(l.resource),cId:l.cId}))}function m(f){const l=new $;for(const d of f)l.processEvent(d);return l.coalesce()}function v(f,l){return typeof l=="string"&&!l.startsWith(n.$$j)&&!(0,P.$jc)(l)?{base:f,pattern:l}:l}function w(f,l){const d=[];for(const a of l)d.push((0,n.$ck)(v(f,a)));return d}class ${constructor(){this.a=new Set,this.b=new Map}c(l){return M.$k?l.resource.fsPath:l.resource.fsPath.toLowerCase()}processEvent(l){const d=this.b.get(this.c(l));let a=!1;if(d){const t=d.type,o=l.type;d.resource.fsPath!==l.resource.fsPath&&(l.type===2||l.type===1)?a=!0:t===1&&o===2?(this.b.delete(this.c(l)),this.a.delete(d)):t===2&&o===1?d.type=0:t===1&&o===0||(d.type=o)}else a=!0;a&&(this.a.add(l),this.b.set(this.c(l),l))}coalesce(){const l=[],d=[];return Array.from(this.a).filter(a=>a.type!==2?(l.push(a),!1):!0).sort((a,t)=>a.resource.fsPath.length-t.resource.fsPath.length).filter(a=>d.some(t=>(0,E.$9k)(a.resource.fsPath,t,!M.$k))?!1:(d.push(a.resource.fsPath),!0)).concat(l)}}}),define(oe[216],ae([0,1,17,47,15,3,2,63,33,16,60]),function(K,e,n,j,P,M,S,E,h,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NP=e.$MP=void 0,e.$MP="localFilesystem";class y extends S.$Uc{constructor(g,m){super(),this.a=g,this.b=m,this.onDidChangeCapabilities=M.Event.None,this.f=this.B(new M.$7d),this.onDidChangeFile=this.f.event,this.g=this.B(new M.$7d),this.onDidWatchError=this.g.event,this.h=(0,h.$Eg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(g){return this.a.call("stat",[g])}readdir(g){return this.a.call("readdir",[g])}async readFile(g,m){const{buffer:v}=await this.a.call("readFile",[g,m]);return v}readFileStream(g,m,v){const w=(0,E.$ie)(f=>n.$ue.concat(f.map(l=>n.$ue.wrap(l))).buffer),$=new S.$Tc;return $.add(this.a.listen("readFileStream",[g,m])(f=>{if(f instanceof n.$ue)w.write(f.buffer);else{if(f==="end")w.end();else{let l;if(f instanceof Error)l=f;else{const d=f;l=(0,c.$2k)(d.message??(0,j.$6i)(d),d.code??c.FileSystemProviderErrorCode.Unknown)}w.error(l),w.end()}$.dispose()}})),$.add(v.onCancellationRequested(()=>{w.error((0,P.$6)()),w.end(),$.dispose()})),w}writeFile(g,m,v){return this.a.call("writeFile",[g,n.$ue.wrap(m),v])}open(g,m){return this.a.call("open",[g,m])}close(g){return this.a.call("close",[g])}async read(g,m,v,w,$){const[f,l]=await this.a.call("read",[g,m,$]);return v.set(f.buffer.slice(0,l),w),l}write(g,m,v,w,$){return this.a.call("write",[g,m,n.$ue.wrap(v),w,$])}mkdir(g){return this.a.call("mkdir",[g])}delete(g,m){return this.a.call("delete",[g,m])}rename(g,m,v){return this.a.call("rename",[g,m,v])}copy(g,m,v){return this.a.call("copy",[g,m,v])}cloneFile(g,m){return this.a.call("cloneFile",[g,m])}j(){this.B(this.a.listen("fileChange",[this.h])(g=>{if(Array.isArray(g)){const m=g;this.f.fire((0,p.$Aq)(m))}else{const m=g;this.g.fire(m)}}))}watch(g,m){const v=(0,h.$Eg)();return this.a.call("watch",[this.h,v,g,m]),(0,S.$Sc)(()=>this.a.call("unwatch",[this.h,v]))}}e.$NP=y}),define(oe[217],ae([0,1,43,2,60,3,7]),function(K,e,n,j,P,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0;class E extends j.$Uc{constructor(){super(),this.a=this.B(new M.$7d),this.onDidChangeFile=this.a.event,this.b=this.B(new M.$7d),this.onDidLogMessage=this.b.event,this.c=this.B(new M.$7d),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new j.$4c),this.m=5007,this.B(this.f(c=>this.n(c)))}n(c){this.r(c)&&this.t(c)}r(c){return(0,P.$vq)(c)}async watch(c){this.h.clear(),this.g.clear();for(const p of c)this.r(p)?this.h.set(p.correlationId,p):this.g.add(p);for(const[p]of this.j)this.h.has(p)||this.j.deleteAndDispose(p);return this.s()}s(){return this.D([...this.g,...Array.from(this.h.values()).filter(c=>!this.j.has(c.correlationId))])}t(c){if(this.j.has(c.correlationId))return;const p=new j.$Tc;this.j.set(c.correlationId,p),this.w(c,p),this.s()}u(c){this.j.deleteAndDispose(c.correlationId),this.s()}w(c,p){const y=S.URI.file(c.path),k=this;let g=!1;const m=(v,w)=>{if(p.isDisposed)return;const $=this.y(v),f=this.y(w),l=g;if(g=$,!$&&(f||l)){this.F(`fs.watchFile() detected ${c.path} exists again, resuming watcher (correlationId: ${c.correlationId})`);const d={resource:y,type:1,cId:c.correlationId};k.a.fire([d]),this.z(d,c),this.u(c)}};this.F(`starting fs.watchFile() on ${c.path} (correlationId: ${c.correlationId})`);try{(0,n.watchFile)(c.path,{persistent:!1,interval:this.m},m)}catch(v){this.G(`fs.watchFile() failed with error ${v} on path ${c.path} (correlationId: ${c.correlationId})`)}p.add((0,j.$Sc)(()=>{this.F(`stopping fs.watchFile() on ${c.path} (correlationId: ${c.correlationId})`);try{(0,n.unwatchFile)(c.path,m)}catch(v){this.G(`fs.unwatchFile() failed with error ${v} on path ${c.path} (correlationId: ${c.correlationId})`)}}))}y(c){return c.ctimeMs===0&&c.ino===0}async stop(){this.j.clearAndDisposeAll()}z(c,p){const y=` >> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`;this.F(typeof p.correlationId=="number"?`${y} (correlationId: ${p.correlationId})`:y)}C(c){return`${c.path} (excludes: ${c.excludes.length>0?c.excludes:"<none>"}, includes: ${c.includes&&c.includes.length>0?JSON.stringify(c.includes):"<all>"}, correlationId: ${typeof c.correlationId=="number"?c.correlationId:"<none>"})`}}e.$Mq=E}),define(oe[218],ae([0,1,43,8,23,31,2,86,9,4,19,7,109,21,60]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0,e.$Sq=w;class v extends S.$Uc{static{this.a=100}static{this.b=75}constructor(f,l,d,a,t){super(),this.m=f,this.n=l,this.r=d,this.s=a,this.t=t,this.c=this.B(new j.$xh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},o=>this.n(o))),this.f=this.B(new j.$wh(o=>this.D(o),v.b)),this.g=(0,m.$Dq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,m.$Dq)(this.m.path,this.m.includes):void 0,this.j=new P.$ee,this.ready=this.u()}async u(){try{const f=await this.w(this.m);if(this.j.token.isCancellationRequested)return;const l=await g.Promises.stat(f);if(this.j.token.isCancellationRequested)return;this.B(await this.y(f,l.isDirectory()))}catch(f){f.code!=="ENOENT"?this.G(f):this.I(`ignoring a path for watching who's stat info failed to resolve: ${this.m.path} (error: ${f})`),this.r?.()}}async w(f){let l=f.path;try{l=await g.Promises.realpath(f.path),f.path===l&&(l=await(0,k.$Oq)(f.path,this.j.token)??f.path),f.path!==l&&this.I(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${l})`)}catch{}return l}async y(f,l){if(c.$j&&(0,M.$ig)(f,"/Volumes/",!0))return this.G(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),S.$Uc.None;const d=new P.$ee(this.j.token),a=new S.$Tc;try{const t=y.URI.file(this.m.path),o=(0,h.$oc)(f),r=(0,n.watch)(f);a.add((0,S.$Sc)(()=>{r.removeAllListeners(),r.close()})),this.I(`Started watching: '${f}'`);const i=new Set;if(l)try{for(const u of await g.Promises.readdir(f))i.add(u)}catch(u){this.G(u)}const s=new Map;a.add((0,S.$Sc)(()=>{for(const[,u]of s)u.dispose();s.clear()})),r.on("error",(u,b)=>{this.G(`Failed to watch ${f} for changes using fs.watch() (${u}, ${b})`),this.r?.()}),r.on("change",(u,b)=>{if(d.token.isCancellationRequested)return;this.I(`[raw] ["${u}"] ${b}`);let C="";if(b&&(C=b.toString(),c.$j&&(C=(0,E.$Zl)(C))),!(!C||u!=="change"&&u!=="rename"))if(l)if(u==="rename"){s.get(C)?.dispose();const I=setTimeout(async()=>{if(s.delete(C),C===o&&!await g.Promises.exists(f)){this.z(t);return}const D=await this.F((0,h.$kc)(f,C));if(d.token.isCancellationRequested)return;let O;D?i.has(C)?O=0:(O=1,i.add(C)):(i.delete(C),O=2),this.C({resource:(0,p.$Vg)(t,C),type:O,cId:this.m.correlationId})},v.a);s.set(C,(0,S.$Sc)(()=>clearTimeout(I)))}else{let I;i.has(C)?I=0:(I=1,i.add(C)),this.C({resource:(0,p.$Vg)(t,C),type:I,cId:this.m.correlationId})}else if(u==="rename"||C!==o){const I=setTimeout(async()=>{const D=await g.Promises.exists(f);d.token.isCancellationRequested||(D?(this.C({resource:t,type:0,cId:this.m.correlationId},!0),a.add(await this.y(f,!1))):this.z(t))},v.a);a.clear(),a.add((0,S.$Sc)(()=>clearTimeout(I)))}else this.C({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){d.token.isCancellationRequested||this.G(`Failed to watch ${f} for changes using fs.watch() (${t.toString()})`),this.r?.()}return(0,S.$Sc)(()=>{d.dispose(!0),a.dispose()})}z(f){this.H("Watcher shutdown because watched path got deleted"),this.C({resource:f,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.r?.()}C(f,l=!1){this.j.token.isCancellationRequested||(this.t&&this.I(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.resource.fsPath}`),!l&&this.g.some(d=>d(f.resource.fsPath))?this.t&&this.I(` >> ignored (excluded) ${f.resource.fsPath}`):!l&&this.h&&this.h.length>0&&!this.h.some(d=>d(f.resource.fsPath))?this.t&&this.I(` >> ignored (not included) ${f.resource.fsPath}`):this.f.work(f))}D(f){const l=(0,m.$Bq)(f);if(l.length>0){if(this.t)for(const a of l)this.I(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.c.work(l)?this.c.pending>0&&this.I(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.H(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async F(f){if(c.$k)return g.Promises.exists(f);try{const l=(0,h.$oc)(f);return(await g.Promises.readdir((0,h.$nc)(f))).some(a=>a===l)}catch(l){return this.I(l),!1}}setVerboseLogging(f){this.t=f}G(f){this.j.token.isCancellationRequested||this.s?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}H(f){this.j.token.isCancellationRequested||this.s?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}I(f){!this.j.token.isCancellationRequested&&this.t&&this.s?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.j.dispose(!0),super.dispose()}}e.$Rq=v;async function w($,f,l,d,a=512){const t=await g.Promises.open($,"r"),o=Buffer.allocUnsafe(a),r=new P.$ee(d);let i,s=!1;const u={path:$,excludes:[],recursive:!1},b=new v(u,C=>{(async()=>{for(const{type:I}of C)if(I===0){if(s)return;s=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:D}=await g.Promises.read(t,o,0,a,null);if(!D||r.token.isCancellationRequested)break;f(o.slice(0,D))}}catch(D){i=new Error(D),r.dispose(!0)}finally{s=!1}}})()});return await b.ready,l(),new Promise((C,I)=>{r.token.onCancellationRequested(async()=>{b.dispose();try{await g.Promises.close(t)}catch(D){i=new Error(D)}i?I(i):C()})})}}),define(oe[219],ae([0,1,3,108,217,4,218,31]),function(K,e,n,j,P,M,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;class h extends P.$Mq{constructor(){super(...arguments),this.onDidError=n.Event.None,this.H=new Set,this.I=!1}async D(p){p=this.O(p);const y=[],k=new Set(Array.from(this.H));for(const g of p){const m=this.L(g);m&&(0,j.$gk)(m.request.excludes,g.excludes)&&(0,j.$gk)(m.request.includes,g.includes)?k.delete(m):y.push(g)}y.length&&this.F(`Request to start watching: ${y.map(g=>this.C(g)).join(",")}`),k.size&&this.F(`Request to stop watching: ${Array.from(k).map(g=>this.C(g.request)).join(",")}`);for(const g of k)this.N(g);for(const g of y)this.M(g)}L(p){for(const y of this.H)if(typeof p.correlationId=="number"||typeof y.request.correlationId=="number"){if(y.request.correlationId===p.correlationId)return y}else if((0,E.$hg)(y.request.path,p.path,!M.$k))return y}M(p){const y=new S.$Rq(p,g=>this.a.fire(g),()=>this.c.fire(p),g=>this.b.fire(g),this.I),k={request:p,instance:y};this.H.add(k)}async stop(){await super.stop();for(const p of this.H)this.N(p)}N(p){this.F("stopping file watcher",p),this.H.delete(p),p.instance.dispose()}O(p){const y=new Map;for(const k of p){const g=M.$k?k.path:k.path.toLowerCase();let m=y.get(k.correlationId);m||(m=new Map,y.set(k.correlationId,m)),m.has(g)&&this.F(`ignoring a request for watching who's path is already watched: ${this.C(k)}`),m.set(g,k)}return Array.from(y.values()).map(k=>Array.from(k.values())).flat()}async setVerboseLogging(p){this.I=p;for(const y of this.H)y.instance.setVerboseLogging(p)}F(p,y){this.I&&this.b.fire({type:"trace",message:this.R(p,y)})}G(p){this.b.fire({type:"warn",message:this.R(p)})}R(p,y){return y?`[File Watcher (node.js)] ${p} (${this.C(y.request)})`:`[File Watcher (node.js)] ${p}`}}e.$Tq=h}),define(oe[220],ae([0,1,60,219]),function(K,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class P extends n.$yq{constructor(S,E,h){super(S,E,h),this.s()}r(S){return S.add(new j.$Tq)}}e.$Uq=P}),define(oe[221],ae([0,1,13,44,162,60]),function(K,e,n,j,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=void 0;class S extends M.$zq{constructor(h,c,p){super(h,c,p),this.s()}r(h){const c=h.add(new P.$Kq(n.$Cg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(c.onDidProcessExit(({code:p,signal:y})=>this.t(`terminated by itself with code ${p}, signal: ${y}`))),j.ProxyChannel.toService((0,j.$2h)(c.getChannel("watcher")))}}e.$Lq=S}),define(oe[93],ae([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=void 0;class n{constructor(...P){this.a=new Map;for(const[M,S]of P)this.set(M,S)}set(P,M){const S=this.a.get(P);return this.a.set(P,M),S}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$gi=n}),define(oe[222],ae([0,1,8,15,2,77,211,6,93,104]),function(K,e,n,j,P,M,S,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Yq=void 0;const p=!1;class y extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class k{constructor(w=new h.$gi,$=!1,f,l=p){this.f=w,this.g=$,this.h=f,this.i=l,this.o=new Set,this.f.set(E.$hi,this),this._globalGraph=l?f?._globalGraph??new S.$Xq(d=>d):void 0}createChild(w){return new k(w,this.g,this,this.i)}invokeFunction(w,...$){const f=m.traceInvocation(this.i,w);let l=!1;try{return w({get:a=>{if(l)throw(0,j.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(a,f);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...$)}finally{l=!0,f.stop()}}createInstance(w,...$){let f,l;return w instanceof M.$fi?(f=m.traceCreation(this.i,w.ctor),l=this.j(w.ctor,w.staticArguments.concat($),f)):(f=m.traceCreation(this.i,w),l=this.j(w,$,f)),f.stop(),l}j(w,$=[],f){const l=E._util.getServiceDependencies(w).sort((t,o)=>t.index-o.index),d=[];for(const t of l){const o=this.m(t.id,f);o||this.u(`[createInstance] ${w.name} depends on UNKNOWN service ${t.id}.`,!1),d.push(o)}const a=l.length>0?l[0].index:$.length;if($.length!==a){console.trace(`[createInstance] First service dependency of ${w.name} at position ${a+1} conflicts with ${$.length} static arguments`);const t=a-$.length;t>0?$=$.concat(new Array(t)):$=$.slice(0,a)}return Reflect.construct(w,$.concat(d))}k(w,$){if(this.f.get(w)instanceof M.$fi)this.f.set(w,$);else if(this.h)this.h.k(w,$);else throw new Error("illegalState - setting UNKNOWN service instance")}l(w){const $=this.f.get(w);return!$&&this.h?this.h.l(w):$}m(w,$){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(w));const f=this.l(w);return f instanceof M.$fi?this.q(w,f,$.branch(w,!0)):($.branch(w,!1),f)}q(w,$,f){if(this.o.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this.o.add(w);try{return this.r(w,$,f)}finally{this.o.delete(w)}}r(w,$,f){const l=new S.$Xq(t=>t.id.toString());let d=0;const a=[{id:w,desc:$,_trace:f}];for(;a.length;){const t=a.pop();if(l.lookupOrInsertNode(t),d++>1e3)throw new y(l);for(const o of E._util.getServiceDependencies(t.desc.ctor)){const r=this.l(o.id);if(r||this.u(`[createInstance] ${w} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),r instanceof M.$fi){const i={id:o.id,desc:r,_trace:t._trace.branch(o.id,!0)};l.insertEdge(t,i),a.push(i)}}}for(;;){const t=l.roots();if(t.length===0){if(!l.isEmpty())throw new y(l);break}for(const{data:o}of t){if(this.l(o.id)instanceof M.$fi){const i=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,i)}l.removeNode(o)}}return this.l(w)}s(w,$,f=[],l,d){if(this.f.get(w)instanceof M.$fi)return this.t(w,$,f,l,d);if(this.h)return this.h.s(w,$,f,l,d);throw new Error(`illegalState - creating UNKNOWN service instance ${$.name}`)}t(w,$,f=[],l,d){if(l){const a=new k(void 0,this.g,this,this.i);a.c=String(w);const t=new Map,o=new n.$Bh(()=>{const r=a.j($,f,d);for(const[i,s]of t){const u=r[i];if(typeof u=="function")for(const b of s)b.disposable=u.apply(r,b.listener)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let b=t.get(i);return b||(b=new c.$5c,t.set(i,b)),(I,D,O)=>{if(o.isInitialized)return o.value[i](I,D,O);{const R={listener:[I,D,O],disposable:void 0},W=b.push(R);return(0,P.$Sc)(()=>{W(),R.disposable?.dispose()})}}}if(i in r)return r[i];const s=o.value;let u=s[i];return typeof u!="function"||(u=u.bind(s),r[i]=u),u},set(r,i,s){return o.value[i]=s,!0},getPrototypeOf(r){return $.prototype}})}else return this.j($,f,d)}u(w,$){if($&&console.warn(w),this.g)throw new Error(w)}}e.$Yq=k;var g;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(g||(g={}));class m{static{this.all=new Set}static{this.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(w,$){return w?new m(2,$.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(w,$){return w?new m(1,$.name):m.c}static{this.f=0}constructor(w,$){this.type=w,this.name=$,this.g=Date.now(),this.h=[]}branch(w,$){const f=new m(3,w.toString());return this.h.push([w,$,f]),f}stop(){const w=Date.now()-this.g;m.f+=w;let $=!1;function f(d,a){const t=[],o=new Array(d+1).join("	");for(const[r,i,s]of a.h)if(i&&s){$=!0,t.push(`${o}CREATES -> ${r}`);const u=f(d+1,s);u&&t.push(u)}else t.push(`${o}uses -> ${r}`);return t.join(`
`)}const l=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(w>2||$)&&m.all.add(l.join(`
`))}}e.$Zq=m}),define(oe[223],ae([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TCb=e.IssueSource=e.IssueType=void 0;var j;(function(M){M[M.Bug=0]="Bug",M[M.PerformanceIssue=1]="PerformanceIssue",M[M.FeatureRequest=2]="FeatureRequest"})(j||(e.IssueType=j={}));var P;(function(M){M.VSCode="vscode",M.Extension="extension",M.Marketplace="marketplace"})(P||(e.IssueSource=P={})),e.$TCb=(0,n.$ii)("issueService")}),define(oe[5],ae([0,1,183,47,3,46,2,32,4,19,12,7,118,6]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Rj=e.LogLevel=e.$Pj=e.$Oj=void 0,e.$Qj=v,e.log=$,e.$3j=b,e.$4j=C,e.$5j=I,e.$6j=D,e.$Oj=(0,g.$ii)("logService"),e.$Pj=(0,g.$ii)("loggerService");function m(){return new Date().toISOString()}function v(O){return(0,p.$Zf)(O)}var w;(function(O){O[O.Off=0]="Off",O[O.Trace=1]="Trace",O[O.Debug=2]="Debug",O[O.Info=3]="Info",O[O.Warning=4]="Warning",O[O.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$Rj=w.Info;function $(O,R,W){switch(R){case w.Trace:O.trace(W);break;case w.Debug:O.debug(W);break;case w.Info:O.info(W);break;case w.Warning:O.warn(W);break;case w.Error:O.error(W);break;case w.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function f(O,R=!1){let W="";for(let F=0;F<O.length;F++){let q=O[F];if(q instanceof Error&&(q=(0,j.$6i)(q,R)),typeof q=="object")try{q=JSON.stringify(q)}catch{}W+=(F>0?" ":"")+q}return W}class l extends S.$Uc{constructor(){super(...arguments),this.b=e.$Rj,this.c=this.B(new P.$7d),this.onDidChangeLogLevel=this.c.event}setLevel(R){this.b!==R&&(this.b=R,this.c.fire(this.b))}getLevel(){return this.b}f(R){return this.b!==w.Off&&this.b<=R}}e.$Tj=l;class d extends l{constructor(R){super(),this.h=R}f(R){return this.h||super.f(R)}trace(R,...W){this.f(w.Trace)&&this.g(w.Trace,f([R,...W],!0))}debug(R,...W){this.f(w.Debug)&&this.g(w.Debug,f([R,...W]))}info(R,...W){this.f(w.Info)&&this.g(w.Info,f([R,...W]))}warn(R,...W){this.f(w.Warning)&&this.g(w.Warning,f([R,...W]))}error(R,...W){if(this.f(w.Error))if(R instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=R.stack,this.g(w.Error,f(F))}else this.g(w.Error,f([R,...W]))}flush(){}}e.$Uj=d;class a extends l{constructor(R=e.$Rj){super(),this.setLevel(R),this.g=!h.$i}trace(R,...W){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,R,...W):console.log(`[main ${m()}]`,R,...W))}debug(R,...W){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,R,...W):console.log(`[main ${m()}]`,R,...W))}info(R,...W){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,R,...W):console.log(`[main ${m()}]`,R,...W))}warn(R,...W){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,R,...W):console.warn(`[main ${m()}]`,R,...W))}error(R,...W){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,R,...W):console.error(`[main ${m()}]`,R,...W))}flush(){}}e.$Vj=a;class t extends l{constructor(R=e.$Rj,W=!0){super(),this.g=W,this.setLevel(R)}trace(R,...W){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",R,...W):console.log(R,...W))}debug(R,...W){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",R,...W):console.log(R,...W))}info(R,...W){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",R,...W):console.log(R,...W))}warn(R,...W){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",R,...W):console.log(R,...W))}error(R,...W){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",R,...W):console.error(R,...W))}flush(){}}e.$Wj=t;class o extends l{constructor(R,W=e.$Rj){super(),this.g=R,this.setLevel(W)}trace(R,...W){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(R),...W])}debug(R,...W){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(R),...W])}info(R,...W){this.f(w.Info)&&this.g.log(w.Info,[this.h(R),...W])}warn(R,...W){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(R),...W])}error(R,...W){this.f(w.Error)&&this.g.log(w.Error,[this.h(R),...W])}h(R){return typeof R=="string"?R:(0,j.$6i)(R,this.f(w.Trace))}flush(){}}e.$Xj=o;class r extends l{constructor(R){super(),this.g=R,R.length&&this.setLevel(R[0].getLevel())}setLevel(R){for(const W of this.g)W.setLevel(R);super.setLevel(R)}trace(R,...W){for(const F of this.g)F.trace(R,...W)}debug(R,...W){for(const F of this.g)F.debug(R,...W)}info(R,...W){for(const F of this.g)F.info(R,...W)}warn(R,...W){for(const F of this.g)F.warn(R,...W)}error(R,...W){for(const F of this.g)F.error(R,...W)}flush(){for(const R of this.g)R.flush()}dispose(){for(const R of this.g)R.dispose();super.dispose()}}e.$Yj=r;class i extends S.$Uc{constructor(R,W,F){if(super(),this.h=R,this.j=W,this.b=new E.$Bc,this.c=this.B(new P.$7d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.$7d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.$7d),this.onDidChangeVisibility=this.g.event,F)for(const q of F)this.b.set(q.resource,{logger:void 0,info:q})}m(R){return(0,p.$Vf)(R)?[...this.b.values()].find(W=>W.info.id===R):this.b.get(R)}getLogger(R){return this.m(R)?.logger}createLogger(R,W){const F=this.n(R),q=(0,p.$Vf)(R)?R:W?.id??(0,M.$9i)(F.toString()).toString(16);let x=this.b.get(F)?.logger;const le=W?.logLevel==="always"?w.Trace:W?.logLevel;x||(x=this.s(F,le??this.getLogLevel(F)??this.h,{...W,id:q}));const te={logger:x,info:{resource:F,id:q,logLevel:le,name:W?.name,hidden:W?.hidden,extensionId:W?.extensionId,when:W?.when}};return this.registerLogger(te.info),this.b.set(F,te),x}n(R){return(0,p.$Vf)(R)?(0,c.$Vg)(this.j,`${R}.log`):R}setLogLevel(R,W){if(y.URI.isUri(R)){const F=R,q=W,x=this.b.get(F);x&&q!==x.info.logLevel&&(x.info.logLevel=q===this.h?void 0:q,x.logger?.setLevel(q),this.b.set(x.info.resource,x),this.f.fire([F,q]))}else{this.h=R;for(const[F,q]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&q.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(R,W){const F=this.m(R);F&&W!==!F.info.hidden&&(F.info.hidden=!W,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,W]))}getLogLevel(R){let W;return R&&(W=this.b.get(R)?.info.logLevel),W??this.h}registerLogger(R){const W=this.b.get(R.resource);W?W.info.hidden!==R.hidden&&this.setVisibility(R.resource,!R.hidden):(this.b.set(R.resource,{info:R,logger:void 0}),this.c.fire({added:[R],removed:[]}))}deregisterLogger(R){const W=this.b.get(R);W&&(W.logger&&W.logger.dispose(),this.b.delete(R),this.c.fire({added:[],removed:[W.info]}))}*getRegisteredLoggers(){for(const R of this.b.values())yield R.info}getRegisteredLogger(R){return this.b.get(R)?.info}dispose(){this.b.forEach(R=>R.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Zj=i;class s{constructor(){this.onDidChangeLogLevel=new P.$7d().event}setLevel(R){}getLevel(){return w.Info}trace(R,...W){}debug(R,...W){}info(R,...W){}warn(R,...W){}error(R,...W){}critical(R,...W){}dispose(){}flush(){}}e.$1j=s;class u extends s{}e.$2j=u;function b(O){if(O.verbose)return w.Trace;if(typeof O.logLevel=="string"){const R=D(O.logLevel.toLowerCase());if(R!==void 0)return R}return e.$Rj}function C(O){switch(O){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}function I(O){switch(O){case w.Trace:return{original:"Trace",value:n.localize(0,null)};case w.Debug:return{original:"Debug",value:n.localize(1,null)};case w.Info:return{original:"Info",value:n.localize(2,null)};case w.Warning:return{original:"Warning",value:n.localize(3,null)};case w.Error:return{original:"Error",value:n.localize(4,null)};case w.Off:return{original:"Off",value:n.localize(5,null)}}}function D(O){switch(O){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$7j=new k.$zj("logLevel",C(w.Info))});var ne=this&&this.__param||function(K,e){return function(n,j){e(n,j,K)}};define(oe[224],ae([0,1,14,4,5]),function(K,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yac=void 0;const M=n.safeStorage;let S=class{constructor(h){this.a=h,n.app.commandLine.getSwitchValue("password-store")==="basic"&&M.setUsePlainTextEncryption?.(!0)}async encrypt(h){this.a.trace("[EncryptionMainService] Encrypting value.");try{const c=JSON.stringify(M.encryptString(h));return this.a.trace("[EncryptionMainService] Encrypted value."),c}catch(c){throw this.a.error(c),c}}async decrypt(h){let c;try{if(c=JSON.parse(h),!c.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${h}`);const p=Buffer.from(c.data);this.a.trace("[EncryptionMainService] Decrypting value.");const y=M.decryptString(p);return this.a.trace("[EncryptionMainService] Decrypted value."),y}catch(p){throw this.a.error(p),p}}isEncryptionAvailable(){return Promise.resolve(M.isEncryptionAvailable())}getKeyStorageProvider(){if(j.$i)return Promise.resolve("dpapi");if(j.$j)return Promise.resolve("keychain_access");if(M.getSelectedStorageBackend)try{const h=M.getSelectedStorageBackend();return Promise.resolve(h)}catch(h){this.a.error(h)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(j.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(j.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!M.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");M.setUsePlainTextEncryption(!0)}};e.$yac=S,e.$yac=S=Ee([ne(0,P.$Oj)],S)}),define(oe[225],ae([0,1,22,8,15,3,2,9,60,5]),function(K,e,n,j,P,M,S,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=void 0;class p extends S.$Uc{constructor(k,g){super(),this.a=k,this.b=g,this.c=this.B(new M.$7d),this.onDidChangeFile=this.c.event,this.g=this.B(new M.$7d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new j.$gh(0)),this.w=[],this.y=this.B(new j.$gh(0))}watch(k,g){return g.recursive||this.b?.watcher?.forceUniversal?this.n(k,g):this.z(k,g)}n(k,g){const m={path:this.H(k),excludes:g.excludes,includes:g.includes,recursive:g.recursive,correlationId:g.correlationId},v=(0,n.$Ub)(this.j,m);return this.r(),(0,S.$Sc)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(k=>(0,P.$1)(k))}s(){this.h||(this.h=this.B(this.t(g=>this.c.fire((0,h.$Aq)(g)),g=>this.G(g),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const k=this.b?.watcher?.recursive?.usePolling;if(k===!0)for(const g of this.j)(0,h.$wq)(g)&&(g.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(k))for(const g of this.j)(0,h.$wq)(g)&&k.includes(g.path)&&(g.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(k,g){const m={path:this.H(k),excludes:g.excludes,includes:g.includes,recursive:!1,correlationId:g.correlationId},v=(0,n.$Ub)(this.w,m);return this.C(),(0,S.$Sc)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(k=>(0,P.$1)(k))}D(){return this.u||(this.u=this.B(this.F(k=>this.c.fire((0,h.$Aq)(k)),k=>this.G(k),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.u.watch(this.w)}G(k){k.type==="error"&&this.g.fire(k.message),this.a[k.type](k.message)}H(k){return(0,E.$ic)(k.fsPath)}}e.$Eq=p}),define(oe[226],ae([0,1,22,8,17,23,3,46,71,2,59,13,66,19,63,177,16,122,5,15]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g,m,v,w,$,f,l){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=void 0;let a=class extends c.$Uc{static{d=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new S.$7d),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new S.$7d),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new S.$7d),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new S.$7d),this.onDidRunOperation=this.r.event,this.X=this.B(new S.$7d),this.Y=this.B(new S.$7d),this.onDidFilesChange=this.Y.event,this.Z=this.B(new S.$7d),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new j.$rh)}registerProvider(o,r){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,k.mark)(`code/registerFilesystem/${o}`);const i=new c.$Tc;return this.h.set(o,r),this.c.fire({added:!0,scheme:o,provider:r}),i.add(r.onDidChangeFile(s=>{const u=new w.$8k(s,!this.S(r));this.X.fire(u),u.hasCorrelation()||this.Y.fire(u)})),typeof r.onDidWatchError=="function"&&i.add(r.onDidWatchError(s=>this.Z.fire(new Error(s)))),i.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:o}))),(0,c.$Sc)(()=>{this.c.fire({added:!1,scheme:o,provider:r}),this.h.delete(o),(0,c.$Pc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const r=[];this.f.fire({scheme:o,join(i){r.push(i)}}),!this.h.has(o)&&await j.Promises.settled(r)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,r){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&r)}listCapabilities(){return h.Iterable.map(this.h,([o,r])=>({scheme:o,capabilities:r.capabilities}))}async j(o){if(!(0,g.$Zg)(o))throw new w.$0k((0,v.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const r=this.h.get(o.scheme);if(!r){const i=new l.$bb;throw i.message=(0,v.localize)(1,null,o.toString()),i}return r}async m(o){const r=await this.j(o);if((0,w.$Uk)(r)||(0,w.$Rk)(r)||(0,w.$Vk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const r=await this.j(o);if((0,w.$Uk)(r)||(0,w.$Rk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,r){try{return await this.s(o,r)}catch(i){throw(0,w.$5k)(i)===w.FileSystemProviderErrorCode.FileNotFound?new w.$0k((0,v.localize)(2,null,this.sb(o)),1):(0,w.$3k)(i)}}async s(o,r){const i=await this.j(o),s=this.S(i),u=r?.resolveTo,b=r?.resolveSingleChildDescendants,C=r?.resolveMetadata,I=await i.stat(o);let D;return this.t(i,o,I,void 0,!!C,(O,R)=>(D||(D=p.$oi.forUris(()=>!s),D.set(o,!0),u&&D.fill(!0,u)),D.get(O.resource)||D.findSuperstr(O.resource.with({query:null,fragment:null}))?!0:O.isDirectory&&b?R===1:!1))}async t(o,r,i,s,u,b){const{providerExtUri:C}=this.R(o),I={resource:r,name:C.basename(r),isFile:(i.type&w.FileType.File)!==0,isDirectory:(i.type&w.FileType.Directory)!==0,isSymbolicLink:(i.type&w.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&w.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&w.FilePermission.Locked),etag:(0,w.$il)({mtime:i.mtime,size:i.size}),children:void 0};if(I.isDirectory&&b(I,s)){try{const D=await o.readdir(r),O=await j.Promises.settled(D.map(async([R,W])=>{try{const F=C.joinPath(r,R),q=u?await o.stat(F):{type:W};return await this.t(o,F,q,D.length,u,b)}catch(F){return this.b.trace(F),null}}));I.children=(0,n.$Hb)(O)}catch(D){this.b.trace(D),I.children=[]}return I}return I}async resolveAll(o){return j.Promises.settled(o.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const r=await this.j(o),i=await r.stat(o);return this.t(r,o,i,void 0,!0,()=>!1)}async exists(o){const r=await this.j(o);try{return!!await r.stat(o)}catch{return!1}}async canCreateFile(o,r){try{await this.u(o,r)}catch(i){return i}return!0}async u(o,r){if(!r?.overwrite&&await this.exists(o))throw new w.$0k((0,v.localize)(3,null,this.sb(o)),3,r)}async createFile(o,r=P.$ue.fromString(""),i){await this.u(o,i);const s=await this.writeFile(o,r);return this.r.fire(new w.$7k(o,0,s)),s}async writeFile(o,r,i){const s=this.qb(await this.n(o),o),{providerExtUri:u}=this.R(s);let b=i;if((0,w.$Xk)(s)&&!b?.atomic){const C=s.enforceAtomicWriteFile?.(o);C&&(b={...i,atomic:C})}try{await this.w(s,o,b)||await this.U(s,u.dirname(o));let I;if((0,w.$Rk)(s)&&!(r instanceof P.$ue))if((0,m.$ge)(r)){const D=await(0,m.$ne)(r,3);D.ended?I=P.$ue.concat(D.buffer):I=D}else I=(0,m.$ke)(r,D=>P.$ue.concat(D),3);else I=r;!(0,w.$Uk)(s)||(0,w.$Rk)(s)&&I instanceof P.$ue||(0,w.$Rk)(s)&&(0,w.$Xk)(s)&&b?.atomic?await this.hb(s,o,b,I):await this.db(s,o,b,I instanceof P.$ue?(0,P.$Fe)(I):I),this.r.fire(new w.$7k(o,4))}catch(C){throw new w.$0k((0,v.localize)(4,null,this.sb(o),(0,w.$3k)(C).toString()),(0,w.$6k)(C),b)}return this.resolve(o,{resolveMetadata:!0})}async w(o,r,i){const s=!!i?.unlock;if(s&&!(o.capabilities&8192))throw new Error((0,v.localize)(5,null,this.sb(r)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,v.localize)(6,null,this.sb(r)));if(!(o.capabilities&2))throw new Error((0,v.localize)(7,null,this.sb(r)));if(s)throw new Error((0,v.localize)(8,null,this.sb(r)))}let b;try{b=await o.stat(r)}catch{return}if(b.type&w.FileType.Directory)throw new w.$0k((0,v.localize)(9,null,this.sb(r)),0,i);if(this.rb(r,b),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==w.$hl&&typeof b.mtime=="number"&&typeof b.size=="number"&&i.mtime<b.mtime&&i.etag!==(0,w.$il)({mtime:i.mtime,size:b.size}))throw new w.$0k((0,v.localize)(10,null),3,i);return b}async readFile(o,r,i){const s=await this.m(o);return r?.atomic?this.z(s,o,r,i):this.C(s,o,r,i)}async z(o,r,i,s){return new Promise((u,b)=>{this.cb.queueFor(r,async()=>{try{const C=await this.C(o,r,i,s);u(C)}catch(C){b(C)}},this.R(o).providerExtUri)})}async C(o,r,i,s){const u=await this.D(o,r,{...i,preferUnbuffered:!0},s);return{...u,value:await(0,P.$Ge)(u.value)}}async readFileStream(o,r,i){const s=await this.m(o);return this.D(s,o,r,i)}async D(o,r,i,s){const u=new M.$ee(s);let b=i;(0,w.$Wk)(o)&&o.enforceAtomicReadFile?.(r)&&(b={...i,atomic:!0});const C=this.J(r,b).then(D=>D,D=>{throw u.dispose(!0),D});let I;try{return typeof b?.etag=="string"&&b.etag!==w.$hl&&await C,b?.atomic&&(0,w.$Wk)(o)||!((0,w.$Uk)(o)||(0,w.$Vk)(o))||(0,w.$Rk)(o)&&b?.preferUnbuffered?I=this.I(o,r,b):(0,w.$Vk)(o)?I=this.G(o,r,u.token,b):I=this.H(o,r,u.token,b),I.on("end",()=>u.dispose()),I.on("error",()=>u.dispose()),{...await C,value:I}}catch(D){throw I&&await(0,m.$le)(I),this.F(D,r,b)}}F(o,r,i){const s=(0,v.localize)(11,null,this.sb(r),(0,w.$3k)(o).toString());return o instanceof w.$_k?new w.$_k(s,o.stat,i):o instanceof w.$$k?new w.$$k(s,o.fileOperationResult,o.size,o.options):new w.$0k(s,(0,w.$6k)(o),i)}G(o,r,i,s=Object.create(null)){const u=o.readFileStream(r,s,i);return(0,m.$re)(u,{data:b=>b instanceof P.$ue?b:P.$ue.wrap(b),error:b=>this.F(b,r,s)},b=>P.$ue.concat(b))}H(o,r,i,s=Object.create(null)){const u=(0,P.$Ke)();return(0,$.$tq)(o,r,u,b=>b,{...s,bufferSize:this.a,errorTransformer:b=>this.F(b,r,s)},i),u}I(o,r,i){const s=(0,m.$ie)(u=>P.$ue.concat(u));return(async()=>{try{let u;i?.atomic&&(0,w.$Wk)(o)?u=await o.readFile(r,{atomic:!0}):u=await o.readFile(r),typeof i?.position=="number"&&(u=u.slice(i.position)),typeof i?.length=="number"&&(u=u.slice(0,i.length)),this.L(r,u.byteLength,i),s.end(P.$ue.wrap(u))}catch(u){s.error(u),s.end()}})(),s}async J(o,r){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new w.$0k((0,v.localize)(12,null,this.sb(o)),0,r);if(typeof r?.etag=="string"&&r.etag!==w.$hl&&r.etag===i.etag)throw new w.$_k((0,v.localize)(13,null),i,r);return this.L(o,i.size,r),i}L(o,r,i){if(typeof i?.limits?.size=="number"&&r>i.limits.size)throw new w.$$k((0,v.localize)(14,null,this.sb(o)),7,r,i)}async canMove(o,r,i){return this.M(o,r,"move",i)}async canCopy(o,r,i){return this.M(o,r,"copy",i)}async M(o,r,i,s){if(o.toString()!==r.toString())try{const u=i==="move"?this.qb(await this.n(o),o):await this.m(o),b=this.qb(await this.n(r),r);await this.Q(u,o,b,r,i,s)}catch(u){return u}return!0}async move(o,r,i){const s=this.qb(await this.n(o),o),u=this.qb(await this.n(r),r),b=await this.N(s,o,u,r,"move",!!i),C=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new w.$7k(o,b==="move"?2:3,C)),C}async copy(o,r,i){const s=await this.m(o),u=this.qb(await this.n(r),r),b=await this.N(s,o,u,r,"copy",!!i),C=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new w.$7k(o,b==="copy"?3:2,C)),C}async N(o,r,i,s,u,b){if(r.toString()===s.toString())return u;const{exists:C,isSameResourceWithDifferentPathCase:I}=await this.Q(o,r,i,s,u,b);if(C&&!I&&b&&await this.del(s,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(s)),u==="copy"){if(o===i&&(0,w.$Sk)(o))await o.copy(r,s,{overwrite:b});else{const D=await this.resolve(r);D.isDirectory?await this.P(o,D,i,s):await this.O(o,r,i,s)}return u}else return o===i?(await o.rename(r,s,{overwrite:b}),u):(await this.N(o,r,i,s,"copy",b),await this.del(r,{recursive:!0}),"copy")}async O(o,r,i,s){if((0,w.$Uk)(o)&&(0,w.$Uk)(i))return this.jb(o,r,i,s);if((0,w.$Uk)(o)&&(0,w.$Rk)(i))return this.pb(o,r,i,s);if((0,w.$Rk)(o)&&(0,w.$Uk)(i))return this.nb(o,r,i,s);if((0,w.$Rk)(o)&&(0,w.$Rk)(i))return this.lb(o,r,i,s)}async P(o,r,i,s){await i.mkdir(s),Array.isArray(r.children)&&await j.Promises.settled(r.children.map(async u=>{const b=this.R(i).providerExtUri.joinPath(s,u.name);return u.isDirectory?this.P(o,await this.resolve(u.resource),i,b):this.O(o,u.resource,i,b)}))}async Q(o,r,i,s,u,b){let C=!1;if(o===i){const{providerExtUri:D,isPathCaseSensitive:O}=this.R(o);if(O||(C=D.isEqual(r,s)),C&&u==="copy")throw new Error((0,v.localize)(15,null,this.sb(r),this.sb(s)));if(!C&&D.isEqualOrParent(s,r))throw new Error((0,v.localize)(16,null,this.sb(r),this.sb(s)))}const I=await this.exists(s);if(I&&!C){if(!b)throw new w.$0k((0,v.localize)(17,null,this.sb(r),this.sb(s)),4);if(o===i){const{providerExtUri:D}=this.R(o);if(D.isEqualOrParent(r,s))throw new Error((0,v.localize)(18,null,this.sb(r),this.sb(s)))}}return{exists:I,isSameResourceWithDifferentPathCase:C}}R(o){const r=this.S(o);return{providerExtUri:r?g.$Lg:g.$Ng,isPathCaseSensitive:r}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const r=this.qb(await this.j(o),o);await this.U(r,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new w.$7k(o,0,i)),i}async U(o,r){const i=[],{providerExtUri:s}=this.R(o);for(;!s.isEqual(r,s.dirname(r));)try{if(!((await o.stat(r)).type&w.FileType.Directory))throw new Error((0,v.localize)(19,null,this.sb(r)));break}catch(u){if((0,w.$5k)(u)!==w.FileSystemProviderErrorCode.FileNotFound)throw u;i.push(s.basename(r)),r=s.dirname(r)}for(let u=i.length-1;u>=0;u--){r=s.joinPath(r,i[u]);try{await o.mkdir(r)}catch(b){if((0,w.$5k)(b)!==w.FileSystemProviderErrorCode.FileExists)throw b}}}async canDelete(o,r){try{await this.W(o,r)}catch(i){return i}return!0}async W(o,r){const i=this.qb(await this.j(o),o),s=!!r?.useTrash;if(s&&!(i.capabilities&4096))throw new Error((0,v.localize)(20,null,this.sb(o)));const u=r?.atomic;if(u&&!(i.capabilities&65536))throw new Error((0,v.localize)(21,null,this.sb(o)));if(s&&u)throw new Error((0,v.localize)(22,null,this.sb(o)));let b;try{b=await i.stat(o)}catch{}if(b)this.rb(o,b);else throw new w.$0k((0,v.localize)(23,null,this.sb(o)),1);if(!!!r?.recursive){const I=await this.resolve(o);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,v.localize)(24,null,this.sb(o)))}return i}async del(o,r){const i=await this.W(o,r);let s=r;if((0,w.$Yk)(i)&&!s?.atomic){const I=i.enforceAtomicDelete?.(o);I&&(s={...r,atomic:I})}const u=!!s?.useTrash,b=!!s?.recursive,C=s?.atomic??!1;await i.delete(o,{recursive:b,useTrash:u,atomic:C}),this.r.fire(new w.$7k(o,1))}async cloneFile(o,r){const i=await this.j(o),s=this.qb(await this.n(r),r);if(!(i===s&&this.R(i).providerExtUri.isEqual(o,r)))return i===s&&(0,w.$Tk)(i)?i.cloneFile(o,r):(await this.U(s,this.R(s).providerExtUri.dirname(r)),i===s&&(0,w.$Sk)(i)?this.cb.queueFor(o,()=>i.copy(o,r,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(o,()=>this.O(i,o,s,r),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(o,r){return this.watch(o,{...r,correlationId:d.ab++})}watch(o,r={recursive:!1,excludes:[]}){const i=new c.$Tc;let s=!1,u=()=>{s=!0};i.add((0,c.$Sc)(()=>u())),(async()=>{try{const C=await this.bb(o,r);s?(0,c.$Pc)(C):u=()=>(0,c.$Pc)(C)}catch(C){this.b.error(C)}})();const b=r.correlationId;if(typeof b=="number"){const C=i.add(new S.$7d);return i.add(this.X.event(D=>{D.correlates(b)&&C.fire(D)})),{onDidChange:C.event,dispose:()=>i.dispose()}}return i}async bb(o,r){const i=await this.j(o),s=(0,E.$9i)([this.R(i).providerExtUri.getComparisonKey(o),r]);let u=this.$.get(s);return u||(u={count:0,disposable:i.watch(o,r)},this.$.set(s,u)),u.count+=1,(0,c.$Sc)(()=>{u&&(u.count--,u.count===0&&((0,c.$Pc)(u.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,c.$Pc)(o.disposable);this.$.clear()}async db(o,r,i,s){return this.cb.queueFor(r,async()=>{const u=await o.open(r,{create:!0,unlock:i?.unlock??!1});try{(0,m.$ge)(s)||(0,m.$he)(s)?await this.eb(o,u,s):await this.fb(o,u,s)}catch(b){throw(0,w.$3k)(b)}finally{await o.close(u)}},this.R(o).providerExtUri)}async eb(o,r,i){let s=0,u;if((0,m.$he)(i)){if(i.buffer.length>0){const b=P.$ue.concat(i.buffer);await this.gb(o,r,b,b.byteLength,s,0),s+=b.byteLength}if(i.ended)return;u=i.stream}else u=i;return new Promise((b,C)=>{(0,m.$me)(u,{onData:async I=>{u.pause();try{await this.gb(o,r,I,I.byteLength,s,0)}catch(D){return C(D)}s+=I.byteLength,setTimeout(()=>u.resume())},onError:I=>C(I),onEnd:()=>b()})})}async fb(o,r,i){let s=0,u;for(;(u=i.read())!==null;)await this.gb(o,r,u,u.byteLength,s,0),s+=u.byteLength}async gb(o,r,i,s,u,b){let C=0;for(;C<s;){const I=await o.write(r,u+C,i.buffer,b+C,s-C);C+=I}}async hb(o,r,i,s){return this.cb.queueFor(r,()=>this.ib(o,r,i,s),this.R(o).providerExtUri)}async ib(o,r,i,s){let u;s instanceof P.$ue?u=s:(0,m.$ge)(s)?u=await(0,P.$Ge)(s):(0,m.$he)(s)?u=await(0,P.$He)(s):u=(0,P.$Ee)(s),await o.writeFile(r,u.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,r,i,s){return this.cb.queueFor(s,()=>this.kb(o,r,i,s),this.R(i).providerExtUri)}async kb(o,r,i,s){let u,b;try{u=await o.open(r,{create:!1}),b=await i.open(s,{create:!0,unlock:!1});const C=P.$ue.alloc(this.a);let I=0,D=0,O=0;do O=await o.read(u,I,C.buffer,D,C.byteLength-D),await this.gb(i,b,C,O,I,D),I+=O,D+=O,D===C.byteLength&&(D=0);while(O>0)}catch(C){throw(0,w.$3k)(C)}finally{await j.Promises.settled([typeof u=="number"?o.close(u):Promise.resolve(),typeof b=="number"?i.close(b):Promise.resolve()])}}async lb(o,r,i,s){return this.cb.queueFor(s,()=>this.mb(o,r,i,s),this.R(i).providerExtUri)}async mb(o,r,i,s){return i.writeFile(s,await o.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,r,i,s){return this.cb.queueFor(s,()=>this.ob(o,r,i,s),this.R(i).providerExtUri)}async ob(o,r,i,s){const u=await i.open(s,{create:!0,unlock:!1});try{const b=await o.readFile(r);await this.gb(i,u,P.$ue.wrap(b),b.byteLength,0,0)}catch(b){throw(0,w.$3k)(b)}finally{await i.close(u)}}async pb(o,r,i,s){const u=await(0,P.$Ge)(this.H(o,r,M.CancellationToken.None));await this.hb(i,s,void 0,u)}qb(o,r){if(o.capabilities&2048)throw new w.$0k((0,v.localize)(25,null,this.sb(r)),6);return o}rb(o,r){if((r.permissions??0)&w.FilePermission.Readonly)throw new w.$0k((0,v.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===y.Schemas.file?o.fsPath:o.toString(!0)}};e.$uq=a,e.$uq=a=d=Ee([ne(0,f.$Oj)],a)}),define(oe[94],ae([0,1,43,315,8,32,17,3,31,2,9,4,19,63,21,181,16,122,225,47,221,220]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g,m,v,w,$,f,l,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=void 0,(()=>{try{(0,j.gracefulify)(n)}catch(o){console.error(`Error enabling graceful-fs: ${(0,l.$6i)(o)}`)}})();class t extends f.$Eq{static{this.I=!1}constructor(r,i){super(r,i),this.onDidChangeCapabilities=E.Event.None,this.N=new M.$Bc(s=>k.$Mg.getComparisonKey(s)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,y.$k&&(this.J|=1024)),this.J}async stat(r){try{const{stat:i,symbolicLink:s}=await m.SymlinkSupport.stat(this.H(r));return{type:this.M(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:w.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const i=await m.Promises.readdir(this.H(r),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async u=>{try{let b;u.isSymbolicLink()?b=(await this.stat((0,k.$Vg)(r,u.name))).type:b=this.M(u),s.push([u.name,b])}catch(b){this.a.trace(b)}})),s}catch(i){throw this.fb(i)}}M(r,i){let s;return i?.dangling?s=w.FileType.Unknown:r.isFile()?s=w.FileType.File:r.isDirectory()?s=w.FileType.Directory:s=w.FileType.Unknown,i&&(s|=w.FileType.SymbolicLink),s}async O(r){const i=this.H(r);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.N.get(r);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const u=new P.$hh;return this.N.set(r,u),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,c.$Sc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(r)===u&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(r)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),u.open()})}async readFile(r,i){let s;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(r)})`),s=await this.O(r));const u=this.H(r);return await m.Promises.readFile(u)}catch(u){throw this.fb(u)}finally{s?.dispose()}}P(r){t.I&&this.a.trace(r)}readFileStream(r,i,s){const u=(0,g.$ie)(b=>S.$ue.concat(b.map(C=>S.$ue.wrap(C))).buffer);return(0,$.$tq)(this,r,u,b=>b.buffer,{...i,bufferSize:256*1024},s),u}async writeFile(r,i,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.Q(r)?this.R(r,(0,k.$Vg)((0,k.$Ug)(r),`${(0,k.$Sg)(r)}${s.atomic.postfix}`),i,s):this.S(r,i,s)}async Q(r){try{const i=this.H(r),{symbolicLink:s}=await m.SymlinkSupport.stat(i);if(s)return!1}catch{}return!0}async R(r,i,s,u){const b=new c.$Tc;try{b.add(await this.O(r)),b.add(await this.O(i)),await this.S(i,s,u,!0);try{await this.rename(i,r,{overwrite:!0})}catch(C){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw C}}finally{b.dispose()}}async S(r,i,s,u){let b;try{const C=this.H(r);if(!s.create||!s.overwrite){if(await m.Promises.exists(C)){if(!s.overwrite)throw(0,w.$2k)((0,v.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,w.$2k)((0,v.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}b=await this.open(r,{create:!0,unlock:s.unlock},u),await this.write(b,0,i,0,i.byteLength)}catch(C){throw await this.gb(r,C)}finally{typeof b=="number"&&await this.close(b)}}static{this.Y=!0}static configureFlushOnWrite(r){t.Y=r}async open(r,i,s){const u=this.H(r);let b;(0,w.$Pk)(i)&&!s&&(b=await this.O(r));let C;try{if((0,w.$Pk)(i)&&i.unlock)try{const{stat:D}=await m.SymlinkSupport.stat(u);D.mode&128||await m.Promises.chmod(u,D.mode|128)}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}let I;if((0,w.$Pk)(i)){if(y.$i)try{await m.Promises.truncate(u,0),I="r+"}catch(D){D.code!=="ENOENT"&&this.a.trace(D)}I||(I="w")}else I="r";C=await m.Promises.open(u,I)}catch(I){throw b?.dispose(),(0,w.$Pk)(i)?await this.gb(r,I):this.fb(I)}if(this.U.set(C,0),(0,w.$Pk)(i)&&this.X.set(C,r),b){const I=this.W.get(C);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${C} (${u})`),this.W.set(C,b),I&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${C} (${u})`),I.dispose())}return C}async close(r){const i=this.W.get(r);try{if(this.U.delete(r),this.X.delete(r)&&t.Y)try{await m.Promises.fdatasync(r)}catch(s){t.configureFlushOnWrite(!1),this.a.error(s)}return await m.Promises.close(r)}catch(s){throw this.fb(s)}finally{i&&(this.W.get(r)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.W.delete(r)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,s,u,b){const C=this.Z(r,i);let I=null;try{I=(await m.Promises.read(r,s,u,b,C)).bytesRead}catch(D){throw this.fb(D)}finally{this.$(r,C,I)}return I}Z(r,i){return i===this.U.get(r)?null:i}$(r,i,s){const u=this.U.get(r);typeof u=="number"&&(typeof i=="number"||(typeof s=="number"?this.U.set(r,u+s):this.U.delete(r)))}async write(r,i,s,u,b){return(0,P.$Ch)(()=>this.ab(r,i,s,u,b),100,3)}async ab(r,i,s,u,b){const C=this.Z(r,i);let I=null;try{I=(await m.Promises.write(r,s,u,b,C)).bytesWritten}catch(D){throw await this.gb(this.X.get(r),D)}finally{this.$(r,C,I)}return I}async mkdir(r){try{await m.Promises.mkdir(this.H(r))}catch(i){throw this.fb(i)}}async delete(r,i){try{const s=this.H(r);if(i.recursive){let u;i?.atomic!==!1&&i.atomic.postfix&&(u=(0,p.$kc)((0,p.$nc)(s),`${(0,p.$oc)(s)}${i.atomic.postfix}`)),await m.Promises.rm(s,m.RimRafMode.MOVE,u)}else try{await m.Promises.unlink(s)}catch(u){if(u.code==="EPERM"||u.code==="EISDIR"){let b=!1;try{const{stat:C,symbolicLink:I}=await m.SymlinkSupport.stat(s);b=C.isDirectory()&&!I}catch{}if(b)await m.Promises.rmdir(s);else throw u}else throw u}}catch(s){throw this.fb(s)}}async rename(r,i,s){const u=this.H(r),b=this.H(i);if(u!==b)try{await this.bb(r,i,"move",s.overwrite),await m.Promises.rename(u,b)}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,v.localize)(2,null,(0,p.$oc)(u),(0,p.$oc)((0,p.$nc)(b)),C.toString()))),this.fb(C)}}async copy(r,i,s){const u=this.H(r),b=this.H(i);if(u!==b)try{await this.bb(r,i,"copy",s.overwrite),await m.Promises.copy(u,b,{preserveSymlinks:!0})}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,v.localize)(3,null,(0,p.$oc)(u),(0,p.$oc)((0,p.$nc)(b)),C.toString()))),this.fb(C)}}async bb(r,i,s,u){const b=this.H(r),C=this.H(i);let I=!1;if(!!(this.capabilities&1024)||(I=(0,h.$hg)(b,C,!0)),I){if(s==="copy")throw(0,w.$2k)((0,v.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const O=await this.L(r);if(!O)throw(0,w.$2k)((0,v.localize)(5,null),w.FileSystemProviderErrorCode.FileNotFound);const R=await this.L(i);if(R){if(!u)throw(0,w.$2k)((0,v.localize)(6,null),w.FileSystemProviderErrorCode.FileExists);O.type&w.FileType.File&&R.type&w.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,i){return this.cb(r,i,!1)}async cb(r,i,s){const u=this.H(r),b=this.H(i),C=!!(this.capabilities&1024);if((0,h.$hg)(u,b,!C))return;const I=new c.$Tc;try{I.add(await this.O(r)),I.add(await this.O(i)),s&&await m.Promises.mkdir((0,p.$nc)(b),{recursive:!0}),await m.Promises.copyFile(u,b)}catch(D){if(D.code==="ENOENT"&&!s)return this.cb(r,i,!0);throw this.fb(D)}finally{I.dispose()}}t(r,i,s){return new d.$Lq(u=>r(u),u=>i(u),s)}F(r,i,s){return new a.$Uq(u=>r(u),u=>i(u),s)}fb(r){if(r instanceof w.$1k)return r;let i=r,s;switch(r.code){case"ENOENT":s=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=w.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=w.FileSystemProviderErrorCode.Unknown;break;default:s=w.FileSystemProviderErrorCode.Unknown}return(0,w.$2k)(i,s)}async gb(r,i){let s=this.fb(i);if(r&&s.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await m.SymlinkSupport.stat(this.H(r));u.mode&128||(s=(0,w.$2k)(i,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.a.trace(u)}return s}}e.$Vq=t}),define(oe[227],ae([0,1,3,94,2,17,63,23]),function(K,e,n,j,P,M,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ts=e.$ss=void 0;class h extends P.$Uc{constructor(y,k){super(),this.a=y,this.b=k,this.F=new Map,this.G=new Map}call(y,k,g){const m=this.c(y);switch(k){case"stat":return this.g(m,g[0]);case"readdir":return this.h(m,g[0]);case"open":return this.r(m,g[0],g[1]);case"close":return this.s(g[0]);case"read":return this.t(g[0],g[1],g[2]);case"readFile":return this.j(m,g[0],g[1]);case"write":return this.u(g[0],g[1],g[2],g[3],g[4]);case"writeFile":return this.n(m,g[0],g[1],g[2]);case"rename":return this.z(m,g[0],g[1],g[2]);case"copy":return this.C(m,g[0],g[1],g[2]);case"cloneFile":return this.D(m,g[0],g[1]);case"mkdir":return this.w(m,g[0]);case"delete":return this.y(m,g[0],g[1]);case"watch":return this.I(m,g[0],g[1],g[2],g[3]);case"unwatch":return this.J(g[0],g[1])}throw new Error(`IPC Command ${k} not found`)}listen(y,k,g){const m=this.c(y);switch(k){case"fileChange":return this.H(m,g[0]);case"readFileStream":return this.m(m,g[0],g[1])}throw new Error(`Unknown event ${k}`)}g(y,k){const g=this.f(y,k,!0);return this.a.stat(g)}h(y,k){const g=this.f(y,k);return this.a.readdir(g)}async j(y,k,g){const m=this.f(y,k,!0),v=await this.a.readFile(m,g);return M.$ue.wrap(v)}m(y,k,g){const m=this.f(y,k,!0),v=new E.$ee,w=new n.$7d({onDidRemoveLastListener:()=>{v.cancel()}}),$=this.a.readFileStream(m,g,v.token);return(0,S.$me)($,{onData:f=>w.fire(M.$ue.wrap(f)),onError:f=>w.fire(f),onEnd:()=>{w.fire("end"),w.dispose(),v.dispose()}}),w.event}n(y,k,g,m){const v=this.f(y,k);return this.a.writeFile(v,g.buffer,m)}r(y,k,g){const m=this.f(y,k,!0);return this.a.open(m,g)}s(y){return this.a.close(y)}async t(y,k,g){const m=M.$ue.alloc(g),w=await this.a.read(y,k,m.buffer,0,g);return[m,w]}u(y,k,g,m,v){return this.a.write(y,k,g.buffer,m,v)}w(y,k){const g=this.f(y,k);return this.a.mkdir(g)}y(y,k,g){const m=this.f(y,k);return this.a.delete(m,g)}z(y,k,g,m){const v=this.f(y,k),w=this.f(y,g);return this.a.rename(v,w,m)}C(y,k,g,m){const v=this.f(y,k),w=this.f(y,g);return this.a.copy(v,w,m)}D(y,k,g){const m=this.f(y,k),v=this.f(y,g);return this.a.cloneFile(m,v)}H(y,k){const g=new n.$7d({onWillAddFirstListener:()=>{this.F.set(k,this.L(y,g))},onDidRemoveLastListener:()=>{(0,P.$Pc)(this.F.get(k)),this.F.delete(k)}});return g.event}async I(y,k,g,m,v){const w=this.F.get(k);if(w){const $=this.f(y,m),f=w.watch(g,$,v);this.G.set(k+g,f)}}async J(y,k){const g=y+k,m=this.G.get(g);m&&((0,P.$Pc)(m),this.G.delete(g))}dispose(){super.dispose();for(const[,y]of this.G)y.dispose();this.G.clear();for(const[,y]of this.F)y.dispose();this.F.clear()}}e.$ss=h;class c extends P.$Uc{constructor(y,k,g,m){super(),this.c=y,this.f=g,this.g=m,this.a=new Map,this.b=this.B(new j.$Vq(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(k)}h(y){const k=this.B(new n.$7d);this.B(k.event(g=>{y.fire(g.map(m=>({resource:this.c.transformOutgoingURI(m.resource),type:m.type,cId:m.cId})))})),this.B(this.b.onDidChangeFile(g=>k.fire(g))),this.B(this.b.onDidWatchError(g=>y.fire(g)))}j(y){}m(y){}watch(y,k,g){const m=this.m(this.g);return Array.isArray(m)&&(g.excludes=[...g.excludes,...m]),this.a.set(y,this.b.watch(k,g)),(0,P.$Sc)(()=>{(0,P.$Pc)(this.a.get(y)),this.a.delete(y)})}dispose(){for(const[,y]of this.a)y.dispose();this.a.clear(),super.dispose()}}e.$ts=c}),define(oe[228],ae([0,1,14,180,4,7,16,9,227,157,47]),function(K,e,n,j,P,M,S,E,h,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gac=void 0;class y extends h.$ss{constructor(m,v,w){super(m,v),this.M=w}c(m){return c.$ln}f(m,v){return M.URI.revive(v)}async y(m,v,w){if(!w.useTrash)return super.y(m,v,w);const $=this.f(m,v),f=(0,E.$ic)($.fsPath);try{await n.shell.trashItem(f)}catch(l){throw(0,S.$2k)(P.$i?(0,j.localize)(0,null,(0,E.$oc)(f),(0,p.$6i)(l)):(0,j.localize)(1,null,(0,E.$oc)(f),(0,p.$6i)(l)),S.FileSystemProviderErrorCode.Unknown)}}L(m,v){return new k(m,v,this.b,this.M)}}e.$Gac=y;class k extends h.$ts{watch(m,v,w){if(w.recursive)throw(0,S.$2k)("Recursive file watching is not supported from main process for performance reasons.",S.FileSystemProviderErrorCode.Unavailable);return super.watch(m,v,w)}}}),define(oe[229],ae([0,1,5]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u0b=void 0;class j extends n.$Uj{constructor(M=n.$Rj){super(),this.m=[],this.n=void 0,this.setLevel(M),this.B(this.onDidChangeLogLevel(S=>{this.n?.setLevel(S)}))}set logger(M){this.n=M;for(const{level:S,message:E}of this.m)(0,n.log)(M,S,E);this.m=[]}g(M,S){this.n?(0,n.log)(this.n,M,S):this.getLevel()<=M&&this.m.push({level:M,message:S})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$u0b=j}),define(oe[230],ae([0,1,7,3,5,2]),function(K,e,n,j,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=e.$Vr=e.$Ur=void 0;class S extends P.$Zj{constructor(y,k,g,m,v){super(k,g,m),this.r=y,this.t=v,this.B(v.listen("onDidChangeLogLevel",y)(w=>{(0,P.$Qj)(w)?super.setLogLevel(w):super.setLogLevel(n.URI.revive(w[0]),w[1])})),this.B(v.listen("onDidChangeVisibility",y)(([w,$])=>super.setVisibility(n.URI.revive(w),$))),this.B(v.listen("onDidChangeLoggers",y)(({added:w,removed:$})=>{for(const f of w)super.registerLogger({...f,resource:n.URI.revive(f.resource)});for(const f of $)super.deregisterLogger(f.resource)}))}createConsoleMainLogger(){return new P.$Xj({log:(y,k)=>{this.t.call("consoleLog",[y,k])}})}registerLogger(y){super.registerLogger(y),this.t.call("registerLogger",[y,this.r])}deregisterLogger(y){super.deregisterLogger(y),this.t.call("deregisterLogger",[y,this.r])}setLogLevel(y,k){super.setLogLevel(y,k),this.t.call("setLogLevel",[y,k])}setVisibility(y,k){super.setVisibility(y,k),this.t.call("setVisibility",[this.n(y),k])}s(y,k,g){return new E(this.t,y,k,g,this.r)}static setLogLevel(y,k,g){return y.call("setLogLevel",[k,g])}}e.$Ur=S;class E extends P.$Uj{constructor(y,k,g,m,v){super(m?.logLevel==="always"),this.r=y,this.s=k,this.m=!1,this.n=[],this.setLevel(g),this.r.call("createLogger",[k,m,v]).then(()=>{this.u(this.n),this.m=!0})}g(y,k){const g=[[y,k]];this.m?this.u(g):this.n.push(...g)}u(y){this.r.call("log",[this.s,y])}}class h{constructor(y,k){this.a=y,this.b=k}listen(y,k){const g=this.b(y);switch(k){case"onDidChangeLoggers":return j.Event.map(this.a.onDidChangeLoggers,m=>({added:[...m.added].map(v=>this.c(v,g)),removed:[...m.removed].map(v=>this.c(v,g))}));case"onDidChangeVisibility":return j.Event.map(this.a.onDidChangeVisibility,m=>[g.transformOutgoingURI(m[0]),m[1]]);case"onDidChangeLogLevel":return j.Event.map(this.a.onDidChangeLogLevel,m=>(0,P.$Qj)(m)?m:[g.transformOutgoingURI(m[0]),m[1]])}throw new Error(`Event not found: ${k}`)}async call(y,k,g){const m=this.b(y);switch(k){case"setLogLevel":return(0,P.$Qj)(g[0])?this.a.setLogLevel(g[0]):this.a.setLogLevel(n.URI.revive(m.transformIncoming(g[0][0])),g[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(v=>this.c(v,m)))}throw new Error(`Call not found: ${k}`)}c(y,k){return{...y,resource:k.transformOutgoingURI(y.resource)}}}e.$Vr=h;class c extends M.$Uc{constructor(y,k){super(),k.call("setLogLevel",[y.getLogLevel()]),this.B(y.onDidChangeLogLevel(g=>k.call("setLogLevel",[g]))),k.call("getRegisteredLoggers").then(g=>{for(const m of g)y.registerLogger({...m,resource:n.URI.revive(m.resource)})}),this.B(k.listen("onDidChangeVisibility")(([g,m])=>y.setVisibility(n.URI.revive(g),m))),this.B(k.listen("onDidChangeLoggers")(({added:g,removed:m})=>{for(const v of g)y.registerLogger({...v,resource:n.URI.revive(v.resource)});for(const v of m)y.deregisterLogger(v.resource)}))}}e.$Wr=c}),define(oe[231],ae([0,1,2,5]),function(K,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5P=void 0;class P extends n.$Uc{constructor(S,E=[]){super(),this.a=new j.$Yj([S,...E]),this.B(S.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(S){this.a.setLevel(S)}getLevel(){return this.a.getLevel()}trace(S,...E){this.a.trace(S,...E)}debug(S,...E){this.a.debug(S,...E)}info(S,...E){this.a.info(S,...E)}warn(S,...E){this.a.warn(S,...E)}error(S,...E){this.a.error(S,...E)}flush(){this.a.flush()}}e.$5P=P}),define(oe[232],ae([0,1,32,7,5]),function(K,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bbc=void 0;class M{constructor(E){this.b=E,this.a=new n.$Bc}listen(E,h,c){switch(h){case"onDidChangeLoggers":return c?this.b.getOnDidChangeLoggersEvent(c):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return c?this.b.getOnDidChangeLogLevelEvent(c):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return c?this.b.getOnDidChangeVisibilityEvent(c):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${h}`)}async call(E,h,c){switch(h){case"createLogger":this.c(j.URI.revive(c[0]),c[1],c[2]);return;case"log":return this.e(j.URI.revive(c[0]),c[1]);case"consoleLog":return this.d(c[0],c[1]);case"setLogLevel":return(0,P.$Qj)(c[0])?this.b.setLogLevel(c[0]):this.b.setLogLevel(j.URI.revive(c[0]),c[1]);case"setVisibility":return this.b.setVisibility(j.URI.revive(c[0]),c[1]);case"registerLogger":return this.b.registerLogger({...c[0],resource:j.URI.revive(c[0].resource)},c[1]);case"deregisterLogger":return this.b.deregisterLogger(j.URI.revive(c[0]))}throw new Error(`Call not found: ${h}`)}c(E,h,c){this.a.set(E,this.b.createLogger(E,h,c))}d(E,h){let c=console.log;switch(E){case P.LogLevel.Error:c=console.error;break;case P.LogLevel.Warning:c=console.warn;break;case P.LogLevel.Info:c=console.info;break}c.call(console,...h)}e(E,h){const c=this.a.get(E);if(!c)throw new Error("Create the logger before logging");for(const[p,y]of h)(0,P.log)(c,p,y)}}e.$Bbc=M}),define(oe[233],ae([0,1,16,5]),function(K,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TP=void 0;var P;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(P||(P={}));async function M(c,p,y,k,g){try{const m=await new Promise((w,$)=>{K(["@vscode/spdlog"],w,$)});m.setFlushOn(P.Trace);const v=await m.createAsyncRotatingLogger(c,p,y,k);return g?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(m){console.error(m)}return null}function S(c,p,y){switch(p){case j.LogLevel.Trace:c.trace(y);break;case j.LogLevel.Debug:c.debug(y);break;case j.LogLevel.Info:c.info(y);break;case j.LogLevel.Warning:c.warn(y);break;case j.LogLevel.Error:c.error(y);break;case j.LogLevel.Off:break;default:throw new Error(`Invalid log level ${p}`)}}function E(c,p){switch(p){case j.LogLevel.Trace:c.setLevel(P.Trace);break;case j.LogLevel.Debug:c.setLevel(P.Debug);break;case j.LogLevel.Info:c.setLevel(P.Info);break;case j.LogLevel.Warning:c.setLevel(P.Warning);break;case j.LogLevel.Error:c.setLevel(P.Error);break;case j.LogLevel.Off:c.setLevel(P.Off);break;default:throw new Error(`Invalid log level ${p}`)}}class h extends j.$Uj{constructor(p,y,k,g,m){super(),this.m=[],this.setLevel(m),this.n=this.s(p,y,k,g),this.B(this.onDidChangeLogLevel(v=>{this.r&&E(this.r,v)}))}async s(p,y,k,g){const m=k?6:1,v=30/m*n.$kl.MB,w=await M(p,y,v,m,g);if(w){this.r=w,E(this.r,this.getLevel());for(const{level:$,message:f}of this.m)S(this.r,$,f);this.m=[]}}g(p,y){this.r?S(this.r,p,y):this.getLevel()<=p&&this.m.push({level:p,message:y})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$TP=h}),define(oe[234],ae([0,1,33,5,233]),function(K,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UP=void 0;class M extends j.$Zj{s(E,h,c){return new P.$TP((0,n.$Eg)(),E.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,h)}}e.$UP=M}),define(oe[67],ae([0,1,32,3,6,5,234]),function(K,e,n,j,P,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cac=e.$bac=void 0,e.$bac=(0,P.$ji)(M.$Pj);class E extends S.$UP{constructor(){super(...arguments),this.u=new n.$Bc}createLogger(c,p,y){y!==void 0&&this.u.set(this.n(c),y);try{return super.createLogger(c,p)}catch(k){throw this.u.delete(this.n(c)),k}}registerLogger(c,p){p!==void 0&&this.u.set(c.resource,p),super.registerLogger(c)}deregisterLogger(c){this.u.delete(c),super.deregisterLogger(c)}getRegisteredLoggers(c){const p=[];for(const y of super.getRegisteredLoggers())c===this.u.get(y.resource)&&p.push(y);return p}getOnDidChangeLogLevelEvent(c){return j.Event.filter(this.onDidChangeLogLevel,p=>(0,M.$Qj)(p)||this.w(p[0],c))}getOnDidChangeVisibilityEvent(c){return j.Event.filter(this.onDidChangeVisibility,([p])=>this.w(p,c))}getOnDidChangeLoggersEvent(c){return j.Event.filter(j.Event.map(this.onDidChangeLoggers,p=>({added:[...p.added].filter(k=>this.w(k.resource,c)),removed:[...p.removed].filter(k=>this.w(k.resource,c))})),p=>p.added.length>0||p.removed.length>0)}deregisterLoggers(c){for(const[p,y]of this.u)y===c&&this.deregisterLogger(p)}w(c,p){const y=this.u.get(c);return y===void 0||y===p}dispose(){super.dispose(),this.u.clear()}}e.$cac=E}),define(oe[235],ae([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tac=n,e.$Uac=j,e.$Vac=P,e.$Wac=M;function n(S){return S.submenu!==void 0}function j(S){return S.id==="vscode.menubar.separator"}function P(S){return S.uri!==void 0}function M(S){return!n(S)&&!j(S)&&!P(S)}}),define(oe[39],ae([0,1,3,71,2,6]),function(K,e,n,j,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=e.$4n=e.$3n=void 0,e.$3n=(0,M.$ii)("policy");class S extends P.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new n.$7d),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const p=Object.keys(this.f).length;return this.f={...c,...this.f},p!==Object.keys(this.f).length&&await this.j(c),j.Iterable.reduce(this.g.entries(),(y,[k,g])=>({...y,[k]:g}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return j.Iterable.reduce(Object.entries(this.f),(c,[p,y])=>({...c,[p]:{definition:y,value:this.g.get(p)}}),{})}}e.$4n=S;class E{constructor(){this.onDidChange=n.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$5n=E}),define(oe[236],ae([0,1,8,3,71,12,16,5,39]),function(K,e,n,j,P,M,S,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ubc=void 0;function c(y,k){const g=[];for(const m of new Set(P.Iterable.concat(y.keys(),k.keys())))y.get(m)!==k.get(m)&&g.push(m);return g}let p=class extends h.$4n{constructor(k,g,m){super(),this.m=k,this.n=g,this.s=m,this.c=this.B(new n.$gh(500));const v=j.Event.filter(g.onDidFilesChange,w=>w.affects(k));this.B(g.watch(k)),this.B(v(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const k=new Map;try{const g=await this.n.readFile(this.m),m=JSON.parse(g.value.toString());if(!(0,M.$Xf)(m))throw new Error("Policy file isn't a JSON object");for(const v of Object.keys(m))this.f[v]&&k.set(v,m[v])}catch(g){g.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",g)}return k}async w(){const k=await this.u(),g=c(this.g,k);this.g=k,g.length>0&&this.h.fire(g)}};e.$Ubc=p,e.$Ubc=p=Ee([ne(1,S.$Ok),ne(2,E.$Oj)],p)}),define(oe[237],ae([0,1,3,2,39]),function(K,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tbc=e.$sbc=void 0;class M{constructor(h){this.b=h,this.a=new j.$Tc}listen(h,c){switch(c){case"onDidChange":return n.Event.map(this.b.onDidChange,p=>p.reduce((y,k)=>({...y,[k]:this.b.getPolicyValue(k)??null}),{}),this.a)}throw new Error(`Event not found: ${c}`)}call(h,c,p){switch(c){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(p)}throw new Error(`Call not found: ${c}`)}dispose(){this.a.dispose()}}e.$sbc=M;class S extends P.$4n{constructor(h,c){super(),this.a=c;for(const p in h){const{definition:y,value:k}=h[p];this.f[p]=y,k!==void 0&&this.g.set(p,k)}this.a.listen("onDidChange")(p=>{for(const y in p){const k=p[y];k===null?this.g.delete(y):this.g.set(y,k)}this.h.fire(Object.keys(p))})}async j(h){const c=await this.a.call("updatePolicyDefinitions",h);for(const p in c)this.g.set(p,c[p])}}e.$tbc=S}),define(oe[238],ae([0,1,39,8,2,5]),function(K,e,n,j,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tbc=void 0;let S=class extends n.$4n{constructor(h,c){super(),this.m=h,this.n=c,this.a=new j.$ch,this.b=this.B(new P.$Vc)}async j(h){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(h).length} policy definitions`);const{createWatcher:c}=await new Promise((p,y)=>{K(["@vscode/policy-watcher"],p,y)});await this.a.queue(()=>new Promise((p,y)=>{try{this.b.value=c(this.n,h,k=>{this.t(k),p()})}catch(k){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",k),y(k)}}))}t(h){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(h)}`);for(const c in h){const p=h[c];p===void 0?this.g.delete(c):this.g.set(c,p)}this.h.fire(Object.keys(h))}};e.$Tbc=S,e.$Tbc=S=Ee([ne(0,M.$Oj)],S)}),define(oe[79],ae([0,1,36]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let j;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.context<"u"){const M=P.context.configuration();if(M)j=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(j=globalThis._VSCODE_PRODUCT_JSON,n.env.VSCODE_DEV&&Object.assign(j,{nameShort:`${j.nameShort} Dev`,nameLong:`${j.nameLong} Dev`,dataFolderName:`${j.dataFolderName}-dev`,serverDataFolderName:j.serverDataFolderName?`${j.serverDataFolderName}-dev`:void 0}),!j.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(j,{version:M.version})}}else j={},Object.keys(j).length===0&&Object.assign(j,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=j}),define(oe[27],ae([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9j=e.$8j=void 0,e.$8j=(0,n.$ii)("productService"),e.$9j="vscode://schemas/vscode-product"}),define(oe[239],ae([0,1,8,5]),function(K,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jac=void 0;let P=class{constructor(S,E,h){this.a=S,this.b=E,this.c=h}async inspect(S){await this.d();const E=this.a.webContents.debugger;await E.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,n.$jh)(S);const h=await E.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),h.profile}async d(){const S=this.a.webContents.debugger;S.attach(),await S.sendCommand("Profiler.enable")}async e(){const S=this.a.webContents.debugger;await S.sendCommand("Profiler.disable"),S.detach()}};e.$Jac=P,e.$Jac=P=Ee([ne(2,j.$Oj)],P)}),define(oe[80],ae([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W_b=void 0,e.$W_b=(0,n.$ii)("protocolMainService")}),define(oe[45],ae([0,1,139,12]),function(K,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=void 0;class P{constructor(){this.a=new Map}add(S,E){n.ok(j.$Vf(S)),n.ok(j.$Xf(E)),n.ok(!this.a.has(S),"There is already an extension with this id"),this.a.set(S,E)}knows(S){return this.a.has(S)}as(S){return this.a.get(S)||null}}e.$1n=new P}),define(oe[240],ae([0,1,3,45]),function(K,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=void 0,e.$2n={JSONContribution:"base.contributions.json"};function P(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class M{constructor(){this.b=new n.$7d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,c){this.a[P(h)]=c,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const S=new M;j.$1n.add(e.$2n.JSONContribution,S)}),define(oe[52],ae([0,1,22,3,12,165,18,240,45]),function(K,e,n,j,P,M,S,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.ConfigurationScope=e.$6n=e.EditPresentationTypes=void 0,e.$eo=v,e.$fo=w,e.$go=$,e.$ho=l,e.$io=d;var c;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$6n={Configuration:"base.contributions.configuration"};var p;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(p||(e.ConfigurationScope=p={})),e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n={properties:{},patternProperties:{}},e.$$n={properties:{},patternProperties:{}},e.$_n={properties:{},patternProperties:{}},e.$ao="vscode://schemas/settings/resourceLanguage",e.$bo="vscode://schemas/settings/configurationDefaults";const y=h.$1n.as(E.$2n.JSONContribution);class k{constructor(){this.h=new Set,this.i=new j.$7d,this.onDidSchemaChange=this.i.event,this.j=new j.$7d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$ao,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const r=new Set;this.n(t,o,r),y.registerSchema(e.$ao,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const o=new Set;this.o(t,o),y.registerSchema(e.$ao,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const r=new Set;this.o(o,r),this.n(t,!1,r),y.registerSchema(e.$ao,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const r=[];for(const{overrides:i,source:s}of t)for(const u in i)if(o.add(u),e.$do.test(u)){const b=this.a.get(u),C=b?.valuesSources??new Map;if(s)for(const R of Object.keys(i[u]))C.set(R,s);const I={...b?.value||{},...i[u]};this.a.set(u,{source:s,value:I,valuesSources:C});const D=(0,S.$Yi)(u),O={type:"object",default:I,description:M.localize(1,null,D),$ref:e.$ao,defaultDefaultValue:I,source:P.$Vf(s)?void 0:s,defaultValueSource:s};r.push(...v(u)),this.d[u]=O,this.b.properties[u]=O}else{this.a.set(u,{value:i[u],source:s});const b=this.d[u];b&&(this.w(u,b),this.r(u,b))}this.m(r)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:r,source:i}of t)for(const s in r){const u=this.a.get(s),b=P.$Vf(i)?i:i?.id,C=P.$Vf(u?.source)?u?.source:u?.source?.id;if(b===C)if(o.add(s),this.a.delete(s),e.$do.test(s))delete this.d[s],delete this.b.properties[s];else{const I=this.d[s];I&&(this.w(s,I),this.r(s,I))}}this.u()}deltaConfiguration(t){let o=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,r){t.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,o){const r=i=>{if(i.properties)for(const s in i.properties){o.add(s);const u=this.d[s];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[s],this.s(s,i.properties[s])}i.allOf?.forEach(s=>r(s))};for(const i of t){r(i);const s=this.c.indexOf(i);s!==-1&&this.c.splice(s,1)}}p(t,o=!0,r,i,s=3,u){s=P.$5f(t.scope)?s:t.scope;const b=t.properties;if(b)for(const I in b){const D=b[I];if(o&&l(I,D)){delete b[I];continue}if(D.source=r,D.defaultDefaultValue=b[I].default,this.w(I,D),e.$do.test(I)?D.scope=void 0:(D.scope=P.$5f(D.scope)?s:D.scope,D.restricted=P.$5f(D.restricted)?!!i?.includes(I):D.restricted),b[I].hasOwnProperty("included")&&!b[I].included){this.f[I]=b[I],delete b[I];continue}else this.d[I]=b[I],b[I].policy?.name&&this.e.set(b[I].policy.name,I);!b[I].deprecationMessage&&b[I].markdownDeprecationMessage&&(b[I].deprecationMessage=b[I].markdownDeprecationMessage),u.add(I)}const C=t.allOf;if(C)for(const I of C)this.p(I,o,r,i,s,u)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=r=>{const i=r.properties;if(i)for(const u in i)this.r(u,i[u]);r.allOf?.forEach(o)};o(t)}r(t,o){switch(e.$7n.properties[t]=o,o.scope){case 1:e.$8n.properties[t]=o;break;case 2:e.$9n.properties[t]=o;break;case 6:e.$0n.properties[t]=o;break;case 3:e.$$n.properties[t]=o;break;case 4:e.$_n.properties[t]=o;break;case 5:e.$_n.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.$7n.properties[t],o.scope){case 1:delete e.$8n.properties[t];break;case 2:delete e.$9n.properties[t];break;case 6:delete e.$0n.properties[t];break;case 3:delete e.$$n.properties[t];break;case 4:case 5:delete e.$_n.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,r={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$ao};this.w(o,r),e.$7n.properties[o]=r,e.$8n.properties[o]=r,e.$9n.properties[o]=r,e.$0n.properties[o]=r,e.$$n.properties[o]=r,e.$_n.properties[o]=r}}v(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$ao};e.$7n.patternProperties[e.$co]=t,e.$8n.patternProperties[e.$co]=t,e.$9n.patternProperties[e.$co]=t,e.$0n.patternProperties[e.$co]=t,e.$$n.patternProperties[e.$co]=t,e.$_n.patternProperties[e.$co]=t,this.i.fire()}w(t,o){const r=this.a.get(t);let i=r?.value,s=r?.source;P.$3f(i)&&(i=o.defaultDefaultValue,s=void 0),P.$3f(i)&&(i=$(o.type)),o.default=i,o.defaultValueSource=s}}const g="\\[([^\\]]+)\\]",m=new RegExp(g,"g");e.$co=`^(${g})+$`,e.$do=new RegExp(e.$co);function v(a){const t=[];if(e.$do.test(a)){let o=m.exec(a);for(;o?.length;){const r=o[1].trim();r&&t.push(r),o=m.exec(a)}}return(0,n.$Mb)(t)}function w(a){return a.reduce((t,o)=>`${t}[${o}]`,"")}function $(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const f=new k;h.$1n.add(e.$6n.Configuration,f);function l(a,t){return a.trim()?e.$do.test(a)?M.localize(7,null,a):f.getConfigurationProperties()[a]!==void 0?M.localize(8,null,a):t.policy?.name&&f.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,a,t.policy?.name,f.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}function d(){const a=[],t=f.getConfigurationProperties();for(const o of Object.keys(t))a.push([o,t[o].scope]);return a.push(["launch",4]),a.push(["task",4]),a}}),define(oe[123],ae([0,1,22,3,42,2,32,35,12,7,18,52,45]),function(K,e,n,j,P,M,S,E,h,c,p,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$mo=e.$lo=e.$ko=e.$jo=void 0,e.$no=l;function g(o){return Object.isFrozen(o)?o:E.$Pn(o)}class m{constructor(r={},i=[],s=[],u){this.b=r,this.c=i,this.d=s,this.raw=u,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof m)return i;const s=new v("");return s.parseRaw(i),s.configurationModel});this.f=r.reduce((i,s)=>s===i?s:i.merge(s),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,p.$Wi)(this.contents,r):this.contents}inspect(r,i){const s=this;return{get value(){return g(s.rawConfiguration.getValue(r))},get override(){return i?g(s.rawConfiguration.getOverrideValue(r,i)):void 0},get merged(){return g(i?s.rawConfiguration.override(i).getValue(r):s.rawConfiguration.getValue(r))},get overrides(){const u=[];for(const{contents:b,identifiers:C,keys:I}of s.rawConfiguration.overrides){const D=new m(b,I).getValue(r);D!==void 0&&u.push({identifiers:C,value:D})}return u.length?g(u):void 0}}}getOverrideValue(r,i){const s=this.i(i);return s?r?(0,p.$Wi)(s,r):s:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const s of this.overrides)s.identifiers.includes(r)&&i.push(...s.keys);return n.$Mb(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return n.$Mb(r)}override(r){let i=this.a.get(r);return i||(i=this.g(r),this.a.set(r,i)),i}merge(...r){const i=E.$On(this.contents),s=E.$On(this.overrides),u=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const C of r)if(b.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.h(i,C.contents);for(const I of C.overrides){const[D]=s.filter(O=>n.$ub(O.identifiers,I.identifiers));D?(this.h(D.contents,I.contents),D.keys.push(...I.keys),D.keys=n.$Mb(D.keys)):s.push(E.$On(I))}for(const I of C.keys)u.indexOf(I)===-1&&u.push(I)}return new m(i,u,s,b.every(C=>C instanceof m)?void 0:b)}g(r){const i=this.i(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const s={};for(const u of n.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let b=this.contents[u];const C=i[u];C&&(typeof b=="object"&&typeof C=="object"?(b=E.$On(b),this.h(b,C)):b=C),s[u]=b}return new m(s,this.keys,this.overrides)}h(r,i){for(const s of Object.keys(i)){if(s in r&&h.$Xf(r[s])&&h.$Xf(i[s])){this.h(r[s],i[s]);continue}r[s]=E.$On(i[s])}}i(r){let i=null,s=null;const u=b=>{b&&(s?this.h(s,b):s=E.$On(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===r?i=b.contents:b.identifiers.includes(r)&&u(b.contents);return u(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.j(r,i,!0)}setValue(r,i){this.j(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,p.$Vi)(this.contents,r),y.$do.test(r)&&this.overrides.splice(this.overrides.findIndex(s=>n.$ub(s.identifiers,(0,y.$eo)(r))),1))}j(r,i,s){(0,p.$Ui)(this.contents,r,i,u=>console.error(u)),s=s||this.keys.indexOf(r)===-1,s&&this.keys.push(r),y.$do.test(r)&&this.overrides.push({identifiers:(0,y.$eo)(r),keys:Object.keys(this.contents[r]),contents:(0,p.$Ti)(this.contents[r],u=>console.error(u))})}}e.$jo=m;class v{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new m}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!h.$5f(r)){const s=this.g(r);this.parseRaw(s,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:s,keys:u,overrides:b,restricted:C,hasExcludedProperties:I}=this.h(r,i);this.b=new m(s,u,b,I?[r]:void 0),this.c=C||[]}g(r){let i={},s=null,u=[];const b=[],C=[];function I(O){Array.isArray(u)?u.push(O):s!==null&&(u[s]=O)}const D={onObjectBegin:()=>{const O={};I(O),b.push(u),u=O,s=null},onObjectProperty:O=>{s=O},onObjectEnd:()=>{u=b.pop()},onArrayBegin:()=>{const O=[];I(O),b.push(u),u=O,s=null},onArrayEnd:()=>{u=b.pop()},onLiteralValue:I,onError:(O,R,W)=>{C.push({error:O,offset:R,length:W})}};if(r)try{P.$Cn(r,D),i=u[0]||{}}catch(O){console.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return i}h(r,i){const s=k.$1n.as(y.$6n.Configuration).getConfigurationProperties(),u=this.i(r,s,!0,i);r=u.raw;const b=(0,p.$Ti)(r,D=>console.error(`Conflict in settings file ${this.f}: ${D}`)),C=Object.keys(r),I=this.j(r,D=>console.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:b,keys:C,overrides:I,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}i(r,i,s,u){let b=!1;if(!u?.scopes&&!u?.skipRestricted&&!u?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:b};const C={},I=[];for(const D in r)if(y.$do.test(D)&&s){const O=this.i(r[D],i,!1,u);C[D]=O.raw,b=b||O.hasExcludedProperties,I.push(...O.restricted)}else{const O=i[D],R=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&I.push(D),!u.exclude?.includes(D)&&(u.include?.includes(D)||(R===void 0||u.scopes===void 0||u.scopes.includes(R))&&!(u.skipRestricted&&O?.restricted))?C[D]=r[D]:b=!0}return{raw:C,restricted:I,hasExcludedProperties:b}}j(r,i){const s=[];for(const u of Object.keys(r))if(y.$do.test(u)){const b={};for(const C in r[u])b[C]=r[u][C];s.push({identifiers:(0,y.$eo)(u),keys:Object.keys(b),contents:(0,p.$Ti)(b,i)})}return s}}e.$ko=v;class w extends M.$Uc{constructor(r,i,s,u){super(),this.c=r,this.f=i,this.g=u,this.b=this.B(new j.$7d),this.onDidChange=this.b.event,this.a=new v(this.c.toString()),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(j.Event.any(j.Event.filter(this.g.onDidFilesChange,b=>b.contains(this.c)),j.Event.filter(this.g.onDidRunOperation,b=>(b.isOperation(0)||b.isOperation(3)||b.isOperation(1)||b.isOperation(4))&&s.isEqual(b.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new m}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$lo=w;class ${constructor(r,i,s,u,b,C,I,D,O,R,W,F,q){this.a=r,this.b=i,this.c=s,this.overrideIdentifiers=u,this.d=b,this.f=C,this.g=I,this.h=D,this.i=O,this.j=R,this.k=W,this.l=F,this.m=q}get value(){return g(this.c)}n(r){return r?.value!==void 0||r?.override!==void 0||r?.overrides!==void 0?r:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class f{constructor(r,i,s,u,b=new m,C=new m,I=new S.$Bc,D=new m,O=new S.$Bc){this.c=r,this.d=i,this.f=s,this.g=u,this.h=b,this.i=C,this.j=I,this.l=D,this.m=O,this.a=null,this.b=new S.$Bc,this.n=null}getValue(r,i,s){return this.p(r,i,s).getValue(r)}updateValue(r,i,s={}){let u;s.resource?(u=this.m.get(s.resource),u||(u=new m,this.m.set(s.resource,u))):u=this.l,i===void 0?u.removeValue(r):u.setValue(r,i),s.resource||(this.a=null)}inspect(r,i,s){const u=this.p(r,i,s),b=this.t(i.resource,s),C=i.resource?this.m.get(i.resource)||this.l:this.l,I=new Set;for(const D of u.overrides)for(const O of D.identifiers)u.getOverrideValue(r,O)!==void 0&&I.add(O);return new $(r,i,u.getValue(r),I.size?[...I]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,b||void 0,C)}keys(r){const i=this.t(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,i){this.j.set(r,i),this.b.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const s=[];if(!i){const{added:u,updated:b,removed:C}=a(this.c,r);i=[...u,...b,...C]}for(const u of i)for(const b of(0,y.$eo)(u)){const C=this.c.getKeysForOverrideIdentifier(b),I=r.getKeysForOverrideIdentifier(b),D=[...I.filter(O=>C.indexOf(O)===-1),...C.filter(O=>I.indexOf(O)===-1),...C.filter(O=>!E.$Sn(this.c.override(b).getValue(O),r.override(b).getValue(O)))];s.push([b,D])}return this.updateDefaultConfiguration(r),{keys:i,overrides:s}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:s,removed:u}=a(this.d,r),b=[...i,...s,...u];return b.length&&this.updatePolicyConfiguration(r),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:s,removed:u,overrides:b}=a(this.applicationConfiguration,r),C=[...i,...s,...u];return C.length&&this.updateApplicationConfiguration(r),{keys:C,overrides:b}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:s,removed:u,overrides:b}=a(this.localUserConfiguration,r),C=[...i,...s,...u];return C.length&&this.updateLocalUserConfiguration(r),{keys:C,overrides:b}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:s,removed:u,overrides:b}=a(this.remoteUserConfiguration,r),C=[...i,...s,...u];return C.length&&this.updateRemoteUserConfiguration(r),{keys:C,overrides:b}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:s,removed:u,overrides:b}=a(this.workspaceConfiguration,r),C=[...i,...s,...u];return C.length&&this.updateWorkspaceConfiguration(r),{keys:C,overrides:b}}compareAndUpdateFolderConfiguration(r,i){const s=this.folderConfigurations.get(r),{added:u,updated:b,removed:C,overrides:I}=a(s,i),D=[...u,...b,...C];return(D.length||!s)&&this.updateFolderConfiguration(r,i),{keys:D,overrides:I}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:s,updated:u,removed:b,overrides:C}=a(i,void 0);return{keys:[...s,...u,...b],overrides:C}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(r,i,s){let u=this.q(i,s);return i.overrideIdentifier&&(u=u.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(u=u.merge(this.d)),u}q({resource:r},i){let s=this.r();if(i&&r){const u=i.getFolder(r);u&&(s=this.s(u.uri)||s);const b=this.m.get(r);b&&(s=s.merge(b))}return s}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(r){let i=this.b.get(r);if(!i){const s=this.r(),u=this.j.get(r);u?(i=s.merge(u),this.b.set(r,i)):i=s}return i}t(r,i){if(i&&r){const s=i.getFolder(r);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,i)=>{const{contents:s,overrides:u,keys:b}=this.j.get(i);return r.push([i,{contents:s,overrides:u,keys:b}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this.i.keys.forEach(i=>r.add(i)),this.j.forEach(i=>i.keys.forEach(s=>r.add(s))),[...r.values()]}u(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(s=>r.add(s))),[...r.values()]}v(r){const i=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this.i.getKeysForOverrideIdentifier(r).forEach(s=>i.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(r).forEach(u=>i.add(u))),[...i.values()]}static parse(r){const i=this.w(r.defaults),s=this.w(r.policy),u=this.w(r.application),b=this.w(r.user),C=this.w(r.workspace),I=r.folders.reduce((D,O)=>(D.set(c.URI.revive(O[0]),this.w(O[1])),D),new S.$Bc);return new f(i,s,u,b,new m,C,I,new m,new S.$Bc)}static w(r){return new m(r.contents,r.keys,r.overrides)}}e.$mo=f;function l(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const r=new Set,i=new Map;for(const u of o)u.keys.forEach(b=>r.add(b)),u.overrides.forEach(([b,C])=>{const I=(0,S.$yc)(i,b,new Set);C.forEach(D=>I.add(D))});const s=[];return i.forEach((u,b)=>s.push([b,[...u.values()]])),{keys:[...r.values()],overrides:s}}class d{constructor(r,i,s,u){this.change=r,this.f=i,this.g=s,this.h=u,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const b of r.keys)this.affectedKeys.add(b);for(const[,b]of r.overrides)for(const C of b)this.affectedKeys.add(C);this.d=this.a;for(const b of this.affectedKeys)this.d+=b+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(r,i){const s=this.a+r,u=this.d.indexOf(s);if(u<0)return!1;const b=u+s.length;if(b>=this.d.length)return!1;const C=this.d.charCodeAt(b);if(C!==this.b&&C!==this.c)return!1;if(i){const I=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.f?.workspace):void 0,D=this.g.getValue(r,i,this.h);return!E.$Sn(I,D)}return!0}}e.$oo=d;function a(o,r){const{added:i,removed:s,updated:u}=t(r?.rawConfiguration,o?.rawConfiguration),b=[],C=o?.getAllOverrideIdentifiers()||[],I=r?.getAllOverrideIdentifiers()||[];if(r){const D=I.filter(O=>!C.includes(O));for(const O of D)b.push([O,r.getKeysForOverrideIdentifier(O)])}if(o){const D=C.filter(O=>!I.includes(O));for(const O of D)b.push([O,o.getKeysForOverrideIdentifier(O)])}if(r&&o){for(const D of C)if(I.includes(D)){const O=t({contents:o.getOverrideValue(void 0,D)||{},keys:o.getKeysForOverrideIdentifier(D)},{contents:r.getOverrideValue(void 0,D)||{},keys:r.getKeysForOverrideIdentifier(D)});b.push([D,[...O.added,...O.removed,...O.updated]])}}return{added:i,removed:s,updated:u,overrides:b}}function t(o,r){const i=o?r?o.keys.filter(b=>r.keys.indexOf(b)===-1):[...o.keys]:[],s=r?o?r.keys.filter(b=>o.keys.indexOf(b)===-1):[...r.keys]:[],u=[];if(o&&r){for(const b of r.keys)if(o.keys.indexOf(b)!==-1){const C=(0,p.$Wi)(r.contents,b),I=(0,p.$Wi)(o.contents,b);E.$Sn(C,I)||u.push(b)}}return{added:i,removed:s,updated:u}}}),define(oe[241],ae([0,1,22,3,2,35,12,123,52,5,39,45]),function(K,e,n,j,P,M,S,E,h,c,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=e.$qo=e.$po=void 0;class k extends P.$Uc{constructor(){super(...arguments),this.a=this.B(new j.$7d),this.onDidChangeConfiguration=this.a.event,this.b=new E.$jo}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(y.$1n.as(h.$6n.Configuration).onDidUpdateConfiguration(({properties:w,defaultsOverrides:$})=>this.c(Array.from(w),$))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(w,$){this.h(w,y.$1n.as(h.$6n.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:w})}f(){return{}}g(){this.b=new E.$jo;const w=y.$1n.as(h.$6n.Configuration).getConfigurationProperties();this.h(Object.keys(w),w)}h(w,$){const f=this.f();for(const l of w){const d=f[l],a=$[l];d!==void 0?this.b.addValue(l,d):a?this.b.addValue(l,a.default):this.b.removeValue(l)}}}e.$po=k;class g{constructor(){this.onDidChangeConfiguration=j.Event.None,this.configurationModel=new E.$jo}async initialize(){return this.configurationModel}}e.$qo=g;let m=class extends P.$Uc{get configurationModel(){return this.b}constructor(w,$,f){super(),this.c=w,this.f=$,this.g=f,this.a=this.B(new j.$7d),this.onDidChangeConfiguration=this.a.event,this.b=new E.$jo}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(w=>this.j(w))),this.B(this.c.onDidChangeConfiguration(async({properties:w})=>this.m(await this.h(w),!0))),this.b}async h(w){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",w);const $={},f=[],l=y.$1n.as(h.$6n.Configuration).getConfigurationProperties();for(const d of w){const a=l[d];if(!a){f.push(d);continue}if(a.policy){if(a.type!=="string"&&a.type!=="number"){this.g.warn(`Policy ${a.policy.name} has unsupported type ${a.type}`);continue}f.push(d),$[a.policy.name]={type:a.type}}}return(0,S.$9f)($)||await this.f.updatePolicyDefinitions($),f}j(w){this.g.trace("PolicyConfiguration#onDidChangePolicies",w);const $=y.$1n.as(h.$6n.Configuration).getPolicyConfigurations(),f=(0,n.$Hb)(w.map(l=>$.get(l)));this.m(f,!0)}m(w,$){this.g.trace("PolicyConfiguration#update",w);const f=y.$1n.as(h.$6n.Configuration).getConfigurationProperties(),l=[],d=this.b.isEmpty();for(const a of w){const t=f[a]?.policy?.name;if(t){const o=this.f.getPolicyValue(t);(d?o!==void 0:!(0,M.$Sn)(this.b.getValue(a),o))&&l.push([a,o])}else this.b.getValue(a)!==void 0&&l.push([a,void 0])}if(l.length){this.g.trace("PolicyConfiguration#changed",l);const a=this.b;this.b=new E.$jo;for(const t of a.keys)this.b.setValue(t,a.getValue(t));for(const[t,o]of l)o===void 0?this.b.removeValue(t):this.b.setValue(t,o);$&&this.a.fire(this.b)}}};e.$ro=m,e.$ro=m=Ee([ne(1,p.$3n),ne(2,c.$Oj)],m)}),define(oe[242],ae([0,1,22,8,17,3,42,103,2,35,4,19,18,123,52,241,39]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g,m,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=void 0;class $ extends h.$Uc{constructor(d,a,t,o){super(),this.m=d,this.h=this.B(new M.$7d),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new v.$po),this.c=t instanceof w.$5n?new v.$qo:this.B(new v.$ro(this.b,t,o)),this.f=this.B(new g.$lo(this.m,{},y.$Mg,a)),this.a=new g.$mo(this.b.configurationModel,this.c.configurationModel,new g.$jo,new g.$jo),this.j=new f(d,a,this),this.g=this.B(new j.$uh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:r,properties:i})=>this.r(r,i))),this.B(this.c.onDidChangeConfiguration(r=>this.s(r))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[d,a,t]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new g.$mo(d,a,new g.$jo,t)}getConfigurationData(){return this.a.toData()}getValue(d,a){const t=typeof d=="string"?d:void 0,o=(0,k.$Pi)(d)?d:(0,k.$Pi)(a)?a:{};return this.a.getValue(t,o,void 0)}async updateValue(d,a,t,o,r){const i=(0,k.$Qi)(t)?t:(0,k.$Pi)(t)?{resource:t.resource,overrideIdentifiers:t.overrideIdentifier?[t.overrideIdentifier]:void 0}:void 0,s=i?o:t;if(s!==void 0&&s!==3&&s!==2)throw new Error(`Unable to write ${d} to target ${s}.`);i?.overrideIdentifiers&&(i.overrideIdentifiers=(0,n.$Mb)(i.overrideIdentifiers),i.overrideIdentifiers=i.overrideIdentifiers.length?i.overrideIdentifiers:void 0);const u=this.inspect(d,{resource:i?.resource,overrideIdentifier:i?.overrideIdentifiers?i.overrideIdentifiers[0]:void 0});if(u.policyValue!==void 0)throw new Error(`Unable to write ${d} because it is configured in system policy.`);if((0,c.$Sn)(a,u.defaultValue)&&(a=void 0),i?.overrideIdentifiers?.length&&i.overrideIdentifiers.length>1){const C=i.overrideIdentifiers.sort(),I=this.a.localUserConfiguration.overrides.find(D=>(0,n.$ub)([...D.identifiers].sort(),C));I&&(i.overrideIdentifiers=I.identifiers)}const b=i?.overrideIdentifiers?.length?[(0,m.$fo)(i.overrideIdentifiers),d]:[d];await this.j.write(b,a),await this.reloadConfiguration()}inspect(d,a={}){return this.a.inspect(d,a,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const d=await this.f.loadConfiguration();this.n(d)}n(d){const a=this.a.toData(),t=this.a.compareAndUpdateLocalUserConfiguration(d);this.t(t,a,2)}r(d,a){const t=this.a.toData(),o=this.a.compareAndUpdateDefaultConfiguration(d,a);this.t(o,t,7)}s(d){const a=this.a.toData(),t=this.a.compareAndUpdatePolicyConfiguration(d);this.t(t,a,7)}t(d,a,t){const o=new g.$oo(d,{data:a},this.a);o.source=t,this.h.fire(o)}}e.$so=$;class f{constructor(d,a,t){this.b=d,this.c=a,this.d=t,this.a=new j.$ph}write(d,a){return this.a.queue(()=>this.e(d,a))}async e(d,a){let t;try{t=(await this.c.readFile(this.b)).value.toString()}catch(i){if(i.fileOperationResult===1)t="{}";else throw i}const o=[];if((0,S.$vn)(t,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const r=this.f(t,d,a);t=(0,E.$Nn)(t,r),await this.c.writeFile(this.b,P.$ue.fromString(t))}f(d,a,t){const{tabSize:o,insertSpaces:r,eol:i}=this.h;if(!a.length){const s=JSON.stringify(t,null,r?" ".repeat(o):"	");return[{content:s,length:s.length,offset:0}]}return(0,E.$Kn)(d,a,t,{tabSize:o,insertSpaces:r,eol:i})}get h(){if(!this.g){let d=p.OS===3||p.OS===2?`
`:`\r
`;const a=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});a&&typeof a=="string"&&a!=="auto"&&(d=a),this.g={eol:d,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(oe[243],ae([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ibc=e.$Hbc=e.$Gbc=void 0,e.$Gbc="request",e.$Hbc="remoteResourceHandler";class n{async routeCall(P,M,S){if(M!==e.$Gbc)throw new Error(`Call not found: ${M}`);const E=S[0];if(E?.authority){const h=P.connections.find(c=>c.ctx===E.authority);if(h)return h}throw new Error("Caller not found")}routeEvent(P,M){throw new Error(`Event not found: ${M}`)}}e.$Ibc=n}),define(oe[244],ae([0,1,15,6]),function(K,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=e.RemoteAuthorityResolverErrorCode=e.$vl=e.$ul=e.RemoteConnectionType=e.$tl=void 0,e.$xl=c,e.$tl=(0,j.$ii)("remoteAuthorityResolverService");var P;(function(p){p[p.WebSocket=0]="WebSocket",p[p.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class M{constructor(y){this.id=y,this.type=1}toString(){return`Managed(${this.id})`}}e.$ul=M;class S{constructor(y,k){this.host=y,this.port=k,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$vl=S;var E;(function(p){p.Unknown="Unknown",p.NotAvailable="NotAvailable",p.TemporarilyNotAvailable="TemporarilyNotAvailable",p.NoResolverFound="NoResolverFound",p.InvalidAuthority="InvalidAuthority"})(E||(e.RemoteAuthorityResolverErrorCode=E={}));class h extends n.$bb{static isNotAvailable(y){return y instanceof h&&y._code===E.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof h&&y._code===E.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof h&&y._code===E.NoResolverFound}static isInvalidAuthority(y){return y instanceof h&&y._code===E.InvalidAuthority}static isHandled(y){return y instanceof h&&y.isHandled}constructor(y,k=E.Unknown,g){super(y),this._message=y,this._code=k,this._detail=g,this.isHandled=k===E.NotAvailable&&g===!0,Object.setPrototypeOf(this,h.prototype)}}e.$wl=h;function c(p){const y=p.indexOf("+");return y===-1?p:p.substring(0,y)}}),define(oe[245],ae([0,1,8,17,23,15,3,2,13,66,72,33,113,244]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Cl=C,e.$Dl=I,e.$El=O;const m=30*1e3;var v;(function(X){X[X.Management=1]="Management",X[X.ExtensionHost=2]="ExtensionHost",X[X.Tunnel=3]="Tunnel"})(v||(e.ConnectionType=v={}));function w(X){switch(X){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function $(X){const A=new P.$ee;return setTimeout(()=>A.cancel(),X),A.token}function f(X,A){if(X.isCancellationRequested||A.isCancellationRequested)return P.CancellationToken.Cancelled;const N=new P.$ee;return X.onCancellationRequested(()=>N.cancel()),A.onCancellationRequested(()=>N.cancel()),N.token}class l{get didTimeout(){return this.c==="timedout"}constructor(A){this.c="pending",this.d=new E.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,n.$bh)(),A.isCancellationRequested?this.h():this.d.add(A.onCancellationRequested(()=>this.h()))}registerDisposable(A){this.c==="pending"?this.d.add(A):A.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const A=new Error("Time limit reached");return A.code="ETIMEDOUT",A.syscall="connect",A}resolve(A){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(A))}reject(A){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(A))}}function d(X,A){const N=new l(A);return N.registerDisposable(X.onControlMessage(_=>{const se=JSON.parse(_.toString()),J=L(se);J?N.reject(J):N.resolve(se)})),N.promise}function a(X,A,N,_,se,J,V,H){const U=new l(H),re=p.$3d.create(!1);return X.info(`Creating a socket (${V})...`),c.mark(`code/willCreateSocket/${J}`),A.connect(N,_,se,V).then(ee=>{U.didTimeout?(c.mark(`code/didCreateSocketError/${J}`),X.info(`Creating a socket (${V}) finished after ${re.elapsed()} ms, but this is too late and has timed out already.`),ee?.dispose()):(c.mark(`code/didCreateSocketOK/${J}`),X.info(`Creating a socket (${V}) was successful after ${re.elapsed()} ms.`),U.resolve(ee))},ee=>{c.mark(`code/didCreateSocketError/${J}`),X.info(`Creating a socket (${V}) returned an error after ${re.elapsed()} ms.`),X.error(ee),U.reject(ee)}),U.promise}function t(X,A){const N=new l(A);return X.then(_=>{N.didTimeout||N.resolve(_)},_=>{N.didTimeout||N.reject(_)}),N.promise}async function o(X,A,N,_){const se=ce(X,A);X.logService.trace(`${se} 1/6. invoking socketFactory.connect().`);let J;try{J=await a(X.logService,X.remoteSocketFactoryService,X.connectTo,h.$vg.getServerRootPath(),`reconnectionToken=${X.reconnectionToken}&reconnection=${X.reconnectionProtocol?"true":"false"}`,w(A),`renderer-${w(A)}-${X.reconnectionToken}`,_)}catch(ee){throw X.logService.error(`${se} socketFactory.connect() failed or timed out. Error:`),X.logService.error(ee),ee}X.logService.trace(`${se} 2/6. socketFactory.connect() was successful.`);let V,H;X.reconnectionProtocol?(X.reconnectionProtocol.beginAcceptReconnection(J,null),V=X.reconnectionProtocol,H=!1):(V=new k.$9h({socket:J}),H=!0),X.logService.trace(`${se} 3/6. sending AuthRequest control message.`);const U=await t(X.signService.createNewMessage((0,y.$Eg)()),_),re={type:"auth",auth:X.connectionToken||"00000000000000000000",data:U.data};V.sendControl(j.$ue.fromString(JSON.stringify(re)));try{const ee=await d(V,f(_,$(1e4)));if(ee.type!=="sign"||typeof ee.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(X.logService.trace(`${se} 4/6. received SignRequest control message.`),!await t(X.signService.validate(U,ee.signedData),_)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const me=await t(X.signService.sign(ee.data),_),ve={type:"connectionType",commit:X.commit,signedData:me,desiredConnectionType:A};return N&&(ve.args=N),X.logService.trace(`${se} 5/6. sending ConnectionTypeRequest control message.`),V.sendControl(j.$ue.fromString(JSON.stringify(ve))),{protocol:V,ownsProtocol:H}}catch(ee){throw ee&&ee.code==="ETIMEDOUT"&&(X.logService.error(`${se} the handshake timed out. Error:`),X.logService.error(ee)),ee&&ee.code==="VSCODE_CONNECTION_ERROR"&&(X.logService.error(`${se} received error control message when negotiating connection. Error:`),X.logService.error(ee)),H&&B(V),ee}}async function r(X,A,N,_){const se=Date.now(),J=ce(X,A),{protocol:V,ownsProtocol:H}=await o(X,A,N,_),U=new l(_);return U.registerDisposable(V.onControlMessage(re=>{const ee=JSON.parse(re.toString()),fe=L(ee);fe?(X.logService.error(`${J} received error control message when negotiating connection. Error:`),X.logService.error(fe),H&&B(V),U.reject(fe)):(X.reconnectionProtocol?.endAcceptReconnection(),X.logService.trace(`${J} 6/6. handshake finished, connection is up and running after ${he(se)}!`),U.resolve({protocol:V,firstMessage:ee}))})),U.promise}async function i(X,A){const{protocol:N}=await r(X,1,void 0,A);return{protocol:N}}async function s(X,A,N){const{protocol:_,firstMessage:se}=await r(X,2,A,N),J=se&&se.debugPort;return{protocol:_,debugPort:J}}async function u(X,A,N){const _=Date.now(),se=ce(X,3),{protocol:J}=await o(X,3,A,N);return X.logService.trace(`${se} 6/6. handshake finished, connection is up and running after ${he(_)}!`),J}async function b(X,A,N){const{connectTo:_,connectionToken:se}=await X.addressProvider.getAddress();return{commit:X.commit,quality:X.quality,connectTo:_,connectionToken:se,reconnectionToken:A,reconnectionProtocol:N,remoteSocketFactoryService:X.remoteSocketFactoryService,signService:X.signService,logService:X.logService}}async function C(X,A,N){return D(X,async _=>{const{protocol:se}=await i(_,P.CancellationToken.None);return new Y(X,A,N,_.reconnectionToken,se)})}async function I(X,A){return D(X,async N=>{const{protocol:_,debugPort:se}=await s(N,A,P.CancellationToken.None);return new Z(X,A,N.reconnectionToken,_,se)})}async function D(X,A){for(let _=1;;_++)try{const se=(0,y.$Eg)(),J=await b(X,se,null);return await A(J)}catch(se){if(_<5)X.logService.error(`[remote-connection][attempt ${_}] An error occurred in initial connection! Will retry... Error:`),X.logService.error(se);else throw X.logService.error(`[remote-connection][attempt ${_}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),X.logService.error(se),ue.triggerPermanentFailure(0,0,g.$wl.isHandled(se)),se}}async function O(X,A,N){const _=await b(X,(0,y.$Eg)(),null);return await u(_,{host:A,port:N},P.CancellationToken.None)}function R(X){return(0,n.$8g)(A=>new Promise((N,_)=>{const se=setTimeout(N,X*1e3);A.onCancellationRequested(()=>{clearTimeout(se),N()})}))}var W;(function(X){X[X.ConnectionLost=0]="ConnectionLost",X[X.ReconnectionWait=1]="ReconnectionWait",X[X.ReconnectionRunning=2]="ReconnectionRunning",X[X.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",X[X.ConnectionGain=4]="ConnectionGain"})(W||(e.PersistentConnectionEventType=W={}));class F{constructor(A,N){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.type=0}}e.$Fl=F;class q{constructor(A,N,_,se){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.durationSeconds=_,this.c=se,this.type=1}skipWait(){this.c.cancel()}}e.$Gl=q;class x{constructor(A,N,_){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.attempt=_,this.type=2}}e.$Hl=x;class le{constructor(A,N,_){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.attempt=_,this.type=4}}e.$Il=le;class te{constructor(A,N,_,se){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.attempt=_,this.handled=se,this.type=3}}e.$Jl=te;class ue extends E.$Uc{static triggerPermanentFailure(A,N,_){this._permanentFailure=!0,this.f=A,this.g=N,this.h=_,this.j.forEach(se=>se.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(A=>A.y())}static debugPauseSocketWriting(){this.j.forEach(A=>A.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ue._permanentFailure}constructor(A,N,_,se,J){super(),this.t=A,this.u=N,this.reconnectionToken=_,this.protocol=se,this.w=J,this.m=this.B(new S.$7d),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new le(this.reconnectionToken,0,0)),this.B(se.onSocketClose(V=>{const H=z(this.t,this.reconnectionToken,!0);V?V.type===0?(this.u.logService.info(`${H} received socket close event (hadError: ${V.hadError}).`),V.error&&this.u.logService.error(V.error)):(this.u.logService.info(`${H} received socket close event (wasClean: ${V.wasClean}, code: ${V.code}, reason: ${V.reason}).`),V.event&&this.u.logService.error(V.event)):this.u.logService.info(`${H} received socket close event.`),this.y()})),this.B(se.onSocketTimeout(V=>{const H=z(this.t,this.reconnectionToken,!0);this.u.logService.info(`${H} received socket timeout event (unacknowledgedMsgCount: ${V.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${V.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${V.timeSinceLastReceivedSomeData}).`),this.y()})),ue.j.push(this),this.B((0,E.$Sc)(()=>{const V=ue.j.indexOf(this);V>=0&&ue.j.splice(V,1)})),this.n&&this.D(ue.f,ue.g,ue.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const A=z(this.t,this.reconnectionToken,!0);this.u.logService.info(`${A} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const N=[0,5,5,10,10,10,10,10,30];let _=-1;do{_++;const se=_<N.length?N[_]:N[N.length-1];try{if(se>0){const V=R(se);this.m.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),se,V)),this.u.logService.info(`${A} waiting for ${se} seconds before reconnecting...`);try{await V}catch{}}if(this.n){this.u.logService.error(`${A} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1)),this.u.logService.info(`${A} resolving connection...`);const J=await b(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${A} connecting to ${J.connectTo}...`),await this.G(J,$(m)),this.u.logService.info(`${A} reconnected!`),this.m.fire(new le(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1));break}catch(J){if(J.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${A} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(_>360){this.u.logService.error(`${A} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(g.$wl.isTemporarilyNotAvailable(J)){this.u.logService.info(`${A} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(J);continue}if((J.code==="ETIMEDOUT"||J.code==="ENETUNREACH"||J.code==="ECONNREFUSED"||J.code==="ECONNRESET")&&J.syscall==="connect"){this.u.logService.info(`${A} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(J);continue}if((0,M.$4)(J)){this.u.logService.info(`${A} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(J);continue}if(J instanceof g.$wl){this.u.logService.error(`${A} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,g.$wl.isHandled(J));break}this.u.logService.error(`${A} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}}while(!this.n&&!this.s)}C(A,N,_){this.w?ue.triggerPermanentFailure(A,N,_):this.D(A,N,_)}D(A,N,_){this.m.fire(new te(this.reconnectionToken,A,N,_)),B(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Kl=ue;class Y extends ue{constructor(A,N,_,se,J){super(1,A,se,J,!0),this.client=this.B(new k.$7h(J,{remoteAuthority:N,clientId:_},A.ipcLogger))}async G(A,N){await i(A,N)}}e.$Ll=Y;class Z extends ue{constructor(A,N,_,se,J){super(2,A,_,se,!1),this.H=N,this.debugPort=J}async G(A,N){await s(A,this.H,N)}}e.$Ml=Z;function B(X){try{X.acceptDisconnect();const A=X.getSocket();X.dispose(),A.dispose()}catch(A){(0,M.$1)(A)}}function L(X){if(X&&X.type==="error"){const A=new Error(`Connection error: ${X.reason}`);return A.code="VSCODE_CONNECTION_ERROR",A}return null}function T(X,A){for(;X.length<A;)X+=" ";return X}function G(X,A){return`[remote-connection][${T(w(X),13)}][${A.substr(0,5)}\u2026]`}function z(X,A,N){return`${G(X,A)}[${N?"reconnect":"initial"}]`}function ce(X,A){return`${z(A,X.reconnectionToken,!!X.reconnectionProtocol)}[${X.connectTo}]`}function he(X){return`${Date.now()-X} ms`}}),define(oe[68],ae([0,1,13]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=j,e.$um=P,e.$vm=M,e.$wm=S;function j(h){return h.scheme===n.Schemas.vscodeRemote?h.authority:void 0}function P(h){if(!h)return;const c=h.indexOf("+");return c<0?h:h.substr(0,c)}function M(h){const{host:c,port:p}=E(h);if(typeof p>"u")throw new Error(`Invalid remote authority: ${h}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:p}}function S(h,c){let{host:p,port:y}=E(h);return typeof y>"u"&&(y=c),{host:p,port:y}}function E(h){const c=h.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const p=h.match(/^(\[[0-9a-z:]+\])$/);if(p)return{host:p[1],port:void 0};const y=h.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:h,port:void 0}}}),define(oe[124],ae([0,1,25,6,68]),function(K,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Km=e.$Fm=e.$Em=e.$Dm=e.TargetPlatform=e.ExtensionType=e.$Cm=e.$Am=e.$zm=e.$ym=e.$xm=void 0,e.$Bm=M,e.$Gm=y,e.$Hm=k,e.$Im=g,e.$Jm=m,e.$xm="extensions.user.cache",e.$ym="extensions.builtin.cache",e.$zm="undefined_publisher",e.$Am=["ui","workspace","web"];function M(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.$Cm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var S;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(S||(e.ExtensionType=S={}));var E;(function(v){v.WIN32_X64="win32-x64",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(E||(e.TargetPlatform=E={}));class h{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,$){if(typeof w>"u"||w===null)return typeof $>"u"||$===null;if(typeof $>"u"||$===null)return!1;if(typeof w=="string"||typeof $=="string"){const f=typeof w=="string"?w:w.value,l=typeof $=="string"?$:$.value;return n.$lf(f,l)}return w._lower===$._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.$Dm=h;class c{get size(){return this.c.size}constructor(w){if(this.c=new Set,w)for(const $ of w)this.add($)}add(w){this.c.add(h.toKey(w))}delete(w){return this.c.delete(h.toKey(w))}has(w){return this.c.has(h.toKey(w))}}e.$Em=c;class p{constructor(){this.c=new Map}clear(){this.c.clear()}delete(w){this.c.delete(h.toKey(w))}get(w){return this.c.get(h.toKey(w))}has(w){return this.c.has(h.toKey(w))}set(w,$){this.c.set(h.toKey(w),$)}values(){return this.c.values()}forEach(w){this.c.forEach(w)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Fm=p;function y(v){return k(v)}function k(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}function g(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}function m(v,w){if(w){const $=`onResolveRemoteAuthority:${(0,P.$um)(w)}`;return!!v.activationEvents?.includes($)}return!1}e.$Km=(0,j.$ii)("IBuiltinExtensionsScannerService")}),define(oe[246],ae([0,1,2,6]),function(K,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zl=e.$yl=void 0,e.$yl=(0,j.$ii)("remoteSocketFactoryService");class P{constructor(){this.a={}}register(S,E){return this.a[S]??=[],this.a[S].push(E),(0,n.$Sc)(()=>{const h=this.a[S]?.indexOf(E);typeof h=="number"&&h>=0&&this.a[S]?.splice(h,1)})}b(S){return(this.a[S.type]||[]).find(h=>h.supports(S))}connect(S,E,h,c){const p=this.b(S);if(!p)throw new Error(`No socket factory found for ${S}`);return p.connect(S,E,h,c)}}e.$zl=P}),define(oe[247],ae([0,1,26,49,21,117]),function(K,e,n,j,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iac=E;let S;async function E(g=!1){return(S===void 0||g)&&(S=h()),S}async function h(){const g=c();if(g===void 0)return!1;if(g>=22e3){const m=y();if(m)return new Promise(v=>{j.execFile(m,["--status"],w=>v(!w))})}else{const m=k();if(m)try{if((await P.Promises.stat(m)).isFile())return!0}catch{}}return!1}function c(){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());if(g)return parseInt(g[3])}function p(g){const m=process.env.SystemRoot;if(m){const v=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return M.join(m,v?"Sysnative":"System32",g)}}function y(){return p("wsl.exe")}function k(){return p("lxss\\LxssManager.dll")}}),define(oe[53],ae([0,1,17,15,2,186,52,6,5,45]),function(K,e,n,j,P,M,S,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=void 0,e.$Bp=k,e.$Cp=g,e.$Dp=m,e.$Ep=v,e.$Fp=w,e.$Gp=$,e.$zp=(0,E.$ii)("requestService");class p{constructor(a){this.b=a}toJSON(){if(!this.a){const a=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?a[t]="*****":a[t]=this.b[t];this.a=a}return this.a}}class y extends P.$Uc{constructor(a){super(),this.b=0,this.a=a.createLogger("network",{name:(0,M.localize)(0,null),when:h.$7j.isEqualTo((0,h.$4j)(h.LogLevel.Trace)).serialize()})}async c(a,t,o){const r=`${a} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new p(t.headers??{}));try{const i=await o();return this.a.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,t.type,(0,j.$0)(i)),i}}}e.$Ap=y;function k(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}function g(d){return d.res.statusCode===204}async function m(d){return g(d)?null:(await(0,n.$Ge)(d.stream)).toString()}async function v(d){if(!k(d))throw new Error("Server returned "+d.res.statusCode);return m(d)}async function w(d){if(!k(d))throw new Error("Server returned "+d.res.statusCode);if(g(d))return null;const t=(await(0,n.$Ge)(d.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}function $(d){l(d)}let f;function l(d){const a=c.$1n.as(S.$6n.Configuration),t=f;f={id:"http",order:15,title:(0,M.localize)(1,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,M.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(6,null),(0,M.localize)(7,null),(0,M.localize)(8,null),(0,M.localize)(9,null)],default:"override",description:(0,M.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,M.localize)(12,null),restricted:!0}}},a.updateConfigurations({add:[f],remove:t?[t]:[]})}l(1)}),define(oe[248],ae([0,1,17,23]),function(K,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=e.$Er=void 0;class P{constructor(E){this.a=E}listen(E,h){throw new Error("Invalid listen")}call(E,h,c,p=j.CancellationToken.None){switch(h){case"request":return this.a.request(c[0],p).then(async({res:y,stream:k})=>{const g=await(0,n.$Ge)(k);return[{statusCode:y.statusCode,headers:y.headers},g]});case"resolveProxy":return this.a.resolveProxy(c[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$Er=P;class M{constructor(E){this.a=E}async request(E,h){const[c,p]=await this.a.call("request",[E],h);return{res:c,stream:(0,n.$Ie)(p)}}async resolveProxy(E){return this.a.call("resolveProxy",[E])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$Fr=M}),define(oe[249],ae([0,1,250,12]),function(K,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gr=M;function P(S,E){return S.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:S.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function M(S,E,h={}){const c=(0,n.parse)(S),p=h.proxyUrl||P(c,E);if(!p)return null;const y=(0,n.parse)(p);if(!/^https?:$/.test(y.protocol||""))return null;const k={host:y.hostname||"",port:(y.port?+y.port:0)||(y.protocol==="https"?443:80),auth:y.auth,rejectUnauthorized:(0,j.$2f)(h.strictSSL)?h.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((g,m)=>{K(["http-proxy-agent"],g,m)})).HttpProxyAgent(p,k):new(await new Promise((g,m)=>{K(["https-proxy-agent"],g,m)})).HttpsProxyAgent(p,k)}}),define(oe[251],ae([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ac=e.$4ac=e.$3ac=void 0,e.$3ac={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$4ac={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$5ac={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(oe[95],ae([0,1,49,9,187,23,47,15,4,33,112,64,8,141]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=v;let m;async function v($,f,l,d){return l["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.$i?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,y.$mm)(d)&&!l["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,y.$mm)(d)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=k.Promises.withAsyncBody(async(a,t)=>{const o=new M.$ee;let r=1e4;const i=$.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,g.$nm)(i,1,120)*1e3);const s=setTimeout(()=>{o.dispose(!0),t(new Error((0,P.localize)(0,null)))},r);try{a(await w(f,o.token))}catch(u){!(0,E.$4)(u)&&!o.token.isCancellationRequested?t(new Error((0,P.localize)(1,null,(0,S.$6i)(u)))):a({})}finally{clearTimeout(s),o.dispose()}})),m)}async function w($,f){const l=process.env.ELECTRON_RUN_AS_NODE;$.trace("getUnixShellEnvironment#runAsNode",l);const d=process.env.ELECTRON_NO_ATTACH_CONSOLE;$.trace("getUnixShellEnvironment#noAttach",d);const a=(0,c.$Eg)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"({.*})"+a),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};$.trace("getUnixShellEnvironment#env",o);const r=await(0,p.$cm)(h.OS,o);return $.trace("getUnixShellEnvironment#shell",r),new Promise((i,s)=>{if(f.isCancellationRequested)return s(new E.$5);const u=(0,j.$oc)(r);let b,C;const I="";/^pwsh(-preview)?$/.test(u)?(b=`& '${process.execPath}' ${I} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,C=["-Login","-Command"]):u==="nu"?(b=`^'${process.execPath}' ${I} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,C=["-i","-l","-c"]):u==="xonsh"?(b=`import os, json; print("${a}", json.dumps(dict(os.environ)), "${a}")`,C=["-i","-l","-c"]):(b=`'${process.execPath}' ${I} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,u==="tcsh"||u==="csh"?C=["-ic"]:C=["-i","-l","-c"]),$.trace("getUnixShellEnvironment#spawn",JSON.stringify(C),b);const D=(0,n.spawn)(r,[...C,b],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});f.onCancellationRequested(()=>(D.kill(),s(new E.$5))),D.on("error",W=>{$.error("getUnixShellEnvironment#errorChildProcess",(0,S.$6i)(W)),s(W)});const O=[];D.stdout.on("data",W=>O.push(W));const R=[];D.stderr.on("data",W=>R.push(W)),D.on("close",(W,F)=>{const q=Buffer.concat(O).toString("utf8");$.trace("getUnixShellEnvironment#raw",q);const x=Buffer.concat(R).toString("utf8");if(x.trim()&&$.trace("getUnixShellEnvironment#stderr",x),W||F)return s(new Error((0,P.localize)(2,null,W,F)));const le=t.exec(q),te=le?le[1]:"{}";try{const ue=JSON.parse(te);l?ue.ELECTRON_RUN_AS_NODE=l:delete ue.ELECTRON_RUN_AS_NODE,d?ue.ELECTRON_NO_ATTACH_CONSOLE=d:delete ue.ELECTRON_NO_ATTACH_CONSOLE,delete ue.VSCODE_RESOLVING_ENVIRONMENT,delete ue.XDG_RUNTIME_DIR,$.trace("getUnixShellEnvironment#result",ue),i(ue)}catch(ue){$.error("getUnixShellEnvironment#errorCaught",(0,S.$6i)(ue)),s(ue)}})})}}),define(oe[252],ae([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W9b=void 0;class n{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(P){try{const M=await this.c();if(M){const S=String(n.a++);return this.b.set(S,M),{id:S,data:M.createNewMessage(P)}}}catch{}return{id:"",data:P}}async validate(P,M){if(!P.id)return!0;const S=this.b.get(P.id);if(!S)return!1;this.b.delete(P.id);try{return S.validate(M)==="ok"}catch{return!1}finally{S.dispose?.()}}async sign(P){try{return await this.d(P)}catch{}return P}}e.$W9b=n}),define(oe[96],ae([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bl=e.$Al=void 0,e.$Al="signService",e.$Bl=(0,n.$ii)(e.$Al)}),define(oe[253],ae([0,1,252]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sbc=void 0;class j extends n.$W9b{c(){return this.h().then(M=>new M.validator)}d(M){return this.h().then(S=>new S.signer().sign(M))}h(){return new Promise((M,S)=>K(["vsda"],M,S))}}e.$Sbc=j}),define(oe[34],ae([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WP=e.$VP=void 0,e.$VP=(0,n.$ii)("stateReadService"),e.$WP=(0,n.$ii)("stateService")}),define(oe[125],ae([0,1,8,17,2,12,38,16,5]),function(K,e,n,j,P,M,S,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZP=e.$YP=e.$XP=e.SaveStrategy=void 0;var c;(function(g){g[g.IMMEDIATE=0]="IMMEDIATE",g[g.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class p extends P.$Uc{constructor(m,v,w,$){super(),this.h=m,this.j=v,this.m=w,this.n=$,this.a=Object.create(null),this.b="",this.c=this.B(new n.$gh(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(m){m.fileOperationResult!==1&&this.m.error(m)}}getItem(m,v){const w=this.a[m];return(0,M.$5f)(w)?v:w}setItem(m,v){this.setItems([{key:m,data:v}])}setItems(m){let v=!1;for(const{key:w,data:$}of m)this.a[w]!==$&&((0,M.$5f)($)?(0,M.$3f)(this.a[w])||(this.a[w]=void 0,v=!0):(this.a[w]=$,v=!0));v&&this.s()}removeItem(m){(0,M.$3f)(this.a[m])||(this.a[m]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const m=JSON.stringify(this.a,null,4);if(m!==this.b)try{await this.n.writeFile(this.h,j.$ue.fromString(m),{atomic:{postfix:".vsctmp"}}),this.b=m}catch(v){this.m.error(v)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$XP=p;let y=class extends P.$Uc{constructor(m,v,w,$){super(),this.a=this.B(new p(v.stateResource,m,w,$))}async init(){await this.a.init()}getItem(m,v){return this.a.getItem(m,v)}};e.$YP=y,e.$YP=y=Ee([ne(1,S.$pi),ne(2,h.$Oj),ne(3,E.$Ok)],y);class k extends y{setItem(m,v){this.a.setItem(m,v)}setItems(m){this.a.setItems(m)}removeItem(m){this.a.removeItem(m)}close(){return this.a.close()}}e.$ZP=k}),define(oe[126],ae([0,1,4,36,33]),function(K,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=S,e.$3o=E;function M(h){if(n.$u===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function S(h,c,p,y,k,g,m,v,w){const $=Object.create(null);$["common.machineId"]=g,$["common.sqmId"]=m,$.sessionID=(0,P.$Eg)()+Date.now(),$.commitHash=y,$.version=k,$["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,n.$h)(n.$u),$["common.nodePlatform"]=j.$ec,$["common.nodeArch"]=p,$["common.product"]=w||"desktop",v&&($["common.msftInternal"]=v);let f=0;const l=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),n.$l&&($["common.snap"]="true");const d=M(c);return d&&($["common.platformDetail"]=d),$}function E(h){const c=j.env.USERDNSDOMAIN;if(!c)return!1;const p=c.toLowerCase();return h.some(y=>p===y)}}),define(oe[28],ae([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=void 0,e.$Nl=(0,n.$ii)("telemetryService"),e.$Ol=(0,n.$ii)("customEndpointTelemetryService"),e.$Pl="telemetry.currentSessionDate",e.$Ql="telemetry.firstSessionDate",e.$Rl="telemetry.lastSessionDate",e.$Sl="telemetry.machineId",e.$Tl="telemetry.sqmId",e.$Ul="telemetry",e.$Vl="telemetry.telemetryLevel",e.$Wl="telemetry.enableCrashReporter",e.$Xl="telemetry.enableTelemetry";var j;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(j||(e.TelemetryLevel=j={}));var P;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(oe[254],ae([0,1,26,8,42,13,9,4,7,89,21,111,92,16,27,28]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qs=void 0,e.$ns=$,e.$os=l,e.$ps=d;const w=new Map;async function $(t,o){const r=`${t}::${o.join(":")}`,i=w.get(r);if(i)return i;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,b=new Map,C=2e4;function I(O,R,W,F){const q=R.substring(O.length+1);return j.Promises.withAsyncBody(async x=>{let le;try{le=await p.Promises.readdir(R,{withFileTypes:!0})}catch{x();return}if(F.count>=C){F.count+=le.length,F.maxReached=!0,x();return}let te=le.length;if(te===0){x();return}let ue=le;F.count+le.length>C&&(F.maxReached=!0,te=C-F.count,ue=le.slice(0,te)),F.count+=le.length;for(const Y of ue)if(Y.isDirectory()){if(W.includes(Y.name)||await I(O,(0,S.$kc)(R,Y.name),W,F),--te===0){x();return}}else{const Z=Y.name.lastIndexOf(".");if(Z>=0){const B=Y.name.substring(Z+1);B&&u.set(B,(u.get(B)??0)+1)}for(const B of s)B.relativePathPattern?.test(q)!==!1&&B.filePattern.test(Y.name)&&b.set(B.tag,(b.get(B.tag)??0)+1);if(--te===0){x();return}}})}const D=j.Promises.withAsyncBody(async O=>{const R={count:0,maxReached:!1};await I(t,t,o,R);const W=await d(t);O({configFiles:f(b),fileTypes:f(u),fileCount:R.count,maxFilesReached:R.maxReached,launchConfigFiles:W})});return w.set(r,D),D}function f(t){return Array.from(t.entries(),([o,r])=>({name:o,count:r})).sort((o,r)=>r.count-o.count)}function l(){const t={os:`${n.type()} ${n.arch()} ${n.release()}`,memory:`${(n.totalmem()/g.$kl.GB).toFixed(2)}GB (${(n.freemem()/g.$kl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(c.$qn.value()*100)}%`},o=n.cpus();return o&&o.length>0&&(t.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),t}async function d(t){try{const o=new Map,r=(0,S.$kc)(t,".vscode","launch.json"),i=await p.Promises.readFile(r),s=[],u=(0,P.$vn)(i.toString(),s);if(s.length)return console.log(`Unable to parse ${r}`),[];if((0,P.$En)(u)==="object"&&u.configurations)for(const b of u.configurations){const C=b.type;C&&(o.has(C)?o.set(C,o.get(C)+1):o.set(C,1))}return f(o)}catch{return[]}}let a=class{constructor(o,r){this.c=o,this.d=r}f(o){const r=[];return r.push(`OS Version:       ${o.os}`),r.push(`CPUs:             ${o.cpus}`),r.push(`Memory (System):  ${o.memory}`),r.push(`VM:               ${o.vmHint}`),r.join(`
`)}g(o){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${n.type()} ${n.arch()} ${n.release()}`);const i=n.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(n.totalmem()/g.$kl.GB).toFixed(2)}GB (${(n.freemem()/g.$kl.GB).toFixed(2)}GB free)`),E.$i||r.push(`Load (avg):       ${n.loadavg().map(s=>Math.round(s)).join(", ")}`),r.push(`VM:               ${Math.round(c.$qn.value()*100)}%`),r.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${o.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(o,r){return Promise.all([(0,y.$ms)(o.mainPID),this.k(o)]).then(async i=>{let[s,u]=i,b=this.m(o,s);return r.forEach(C=>{if((0,k.$3m)(C))b+=`
${C.errorMessage}`,u+=`
${C.errorMessage}`;else if(b+=`

Remote: ${C.hostName}`,C.processes&&(b+=`
${this.m(o,C.processes)}`),C.workspaceMetadata){u+=`
|  Remote: ${C.hostName}`;for(const I of Object.keys(C.workspaceMetadata)){const D=C.workspaceMetadata[I];let O=`${D.fileCount} files`;D.maxFilesReached&&(O=`more than ${O}`),u+=`|    Folder (${I}): ${O}`,u+=this.h(D)}}}),{processInfo:b,workspaceInfo:u}})}async getSystemInfo(o,r){const{memory:i,vmHint:s,os:u,cpus:b}=l(),C={os:u,memory:i,cpus:b,vmHint:s,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:r};return E.$i||(C.load=`${n.loadavg().map(I=>Math.round(I)).join(", ")}`),E.$k&&(C.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(C)}async getDiagnostics(o,r){const i=[];return(0,y.$ms)(o.mainPID).then(async s=>(i.push(""),i.push(this.g(o)),i.push(""),i.push(this.m(o,s)),o.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(o))),r.forEach(u=>{if((0,k.$3m)(u))i.push(`
${u.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${u.hostName}`),i.push(this.f(u.machineInfo)),u.processes&&i.push(this.m(o,u.processes)),u.workspaceMetadata)for(const b of Object.keys(u.workspaceMetadata)){const C=u.workspaceMetadata[b];let I=`${C.fileCount} files`;C.maxFilesReached&&(I=`more than ${I}`),i.push(`Folder (${b}): ${I}`),i.push(this.h(C))}}),i.push(""),i.push(""),i.join(`
`)))}h(o){const r=[];let s=0;const u=(D,O)=>{const R=` ${D}(${O})`;s+R.length>60?(r.push(b),b="|                 ",s=b.length):s+=R.length,b+=R};let b="|      File types:";const C=10,I=o.fileTypes.length>C?C:o.fileTypes.length;for(let D=0;D<I;D++){const O=o.fileTypes[D];u(O.name,O.count)}if(r.push(b),o.configFiles.length>=0&&(b="|      Conf files:",s=0,o.configFiles.forEach(D=>{u(D.name,D.count)}),r.push(b)),o.launchConfigFiles.length>0){let D="|      Launch Configs:";o.launchConfigFiles.forEach(O=>{const R=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`;D+=R}),r.push(D)}return r.join(`
`)}j(o){const r=Math.max(...Object.keys(o).map(i=>i.length));return Object.keys(o).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${o[i]}`).join(`
                  `)}k(o){const r=[],i=[];return o.windows.forEach(s=>{s.folderURIs.length===0||s.remoteAuthority||(r.push(`|  Window (${s.title})`),s.folderURIs.forEach(u=>{const b=h.URI.revive(u);if(b.scheme===M.Schemas.file){const C=b.fsPath;i.push($(C,["node_modules",".git"]).then(I=>{let D=`${I.fileCount} files`;I.maxFilesReached&&(D=`more than ${D}`),r.push(`|    Folder (${(0,S.$oc)(C)}): ${D}`),r.push(this.h(I))}).catch(I=>{r.push(`|      Error: Unable to collect workspace stats for folder ${C} (${I.toString()})`)}))}else r.push(`|    Folder (${b.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(s=>r.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}m(o,r){const i=new Map;o.windows.forEach(u=>i.set(u.pid,`window [${u.id}] (${u.title})`)),o.pidToNames.forEach(({pid:u,name:b})=>i.set(u,b));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),r&&this.n(o.mainPID,i,s,r,0),s.join(`
`)}n(o,r,i,s,u){const b=u===0;let C;b?C=s.pid===o?`${this.d.applicationName} main`:"remote agent":r.has(s.pid)?C=r.get(s.pid):C=`${"  ".repeat(u)} ${s.name}`;const I=process.platform==="win32"?s.mem:n.totalmem()*(s.mem/100);i.push(`${s.load.toFixed(0).padStart(5," ")}	${(I/g.$kl.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${C}`),Array.isArray(s.children)&&s.children.forEach(D=>this.n(o,r,i,D,u+1))}async getWorkspaceFileExtensions(o){const r=new Set;for(const{uri:i}of o.folders){const s=h.URI.revive(i);if(s.scheme!==M.Schemas.file)continue;const u=s.fsPath;try{(await $(u,["node_modules",".git"])).fileTypes.forEach(C=>r.add(C.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(o){for(const{uri:r}of o.folders){const i=h.URI.revive(r);if(i.scheme!==M.Schemas.file)continue;const s=i.fsPath;try{const u=await $(s,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),u.fileTypes.forEach(b=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:b.name,count:b.count})}),u.launchConfigFiles.forEach(b=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:b.name,count:b.count})}),u.configFiles.forEach(b=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:b.name,count:b.count})})}catch{}}}};e.$qs=a,e.$qs=a=Ee([ne(0,v.$Nl),ne(1,m.$8j)],a)}),define(oe[255],ae([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ac=e.$8ac=void 0;class n{constructor(M){this.b=M}listen(M,S){throw new Error(`Event not found: ${S}`)}call(M,S,{eventName:E,data:h}){return this.b.forEach(c=>c.log(E,h)),Promise.resolve(null)}}e.$8ac=n;class j{constructor(M){this.b=M}log(M,S){return this.b.call("log",{eventName:M,data:S}).then(void 0,E=>`Failed to log telemetry: ${console.warn(E)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$9ac=j}),define(oe[54],ae([0,1,35,12,68,126,28]),function(K,e,n,j,P,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=void 0,e.$$o=p,e.$_o=y,e.$ap=k,e.$bp=g,e.$cp=v,e.$dp=$,e.$ep=f,e.$fp=a;class E{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.$4o=E;class h{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$5o=h,e.$6o=new h;class c{async publicLog(o,r,i){}async publicLogError(o,r,i){}}e.$7o=c,e.$8o="telemetry",e.$9o="extensionTelemetryLog",e.$0o={log:()=>null,flush:()=>Promise.resolve(null)};function p(t,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!t.enableTelemetry)}function y(t,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function k(t){const o=t.getValue(S.$Vl),r=t.getValue(S.$Wl);if(t.getValue(S.$Xl)===!1||r===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function g(t){const o={},r={},i={};w(t,i);for(let s in i){s=s.length>150?s.substr(s.length-149):s;const u=i[s];typeof u=="number"?r[s]=u:typeof u=="boolean"?r[s]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${u.length}`),o[s]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(o[s]=u)}return{properties:o,measurements:r}}const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function v(t){if(!t)return"none";const o=(0,P.$um)(t);return m.has(o)?o:"other"}function w(t,o,r=0,i){if(t)for(const s of Object.getOwnPropertyNames(t)){const u=t[s],b=i?i+s:s;Array.isArray(u)?o[b]=(0,n.$Tn)(u):u instanceof Date?o[b]=u.toISOString():(0,j.$Xf)(u)?r<2?w(u,o,r+1,b+"."):o[b]=(0,n.$Tn)(u):o[b]=u}}function $(t,o){const r=t.msftInternalDomains||[],i=o.getValue("telemetry.internalTesting");return(0,M.$3o)(r)||i}function f(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function l(t,o){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const i=[];for(const C of o)for(;;){const I=C.exec(t);if(!I)break;i.push([I.index,C.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(r="";;){const C=u.exec(t);if(!C)break;const I=i.some(([D,O])=>C.index<O&&D<u.lastIndex);!s.test(C[0])&&!I&&(r+=t.substring(b,C.index)+"<REDACTED: user-file-path>",b=u.lastIndex)}return b<t.length&&(r+=t.substr(b)),r}function d(t){if(!t)return t;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of o)if(r.regex.test(t))return`<REDACTED: ${r.label}>`;return t}function a(t,o){return(0,n.$Qn)(t,r=>{if(r instanceof E||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let i=r.replaceAll("%20"," ");i=l(i,o);for(const s of o)i=i.replace(s,"");return i=d(i),i}})}}),define(oe[127],ae([0,1,25,121,124,4,7,15,36,54]),function(K,e,n,j,P,M,S,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$hp=void 0,e.$gp=p,e.$ip=m,e.$jp=v,e.$kp=w,e.$lp=$,e.$mp=f,e.$np=l,e.$op=d,e.$qp=a,e.$rp=o;function p(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,n.$gf)(r.id,i.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class k{static create(i){const s=i.manifest?i.manifest.version:i.version,u=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new k(i.identifier,s,u)}static parse(i){const s=y.exec(i);return s&&s[1]&&s[2]?new k({id:s[1]},s[2],s[4]||void 0):null}constructor(i,s,u="undefined"){this.version=s,this.targetPlatform=u,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof k?p(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$hp=k;const g=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(r){const i=g.exec(r);return i&&i[1]?[w(i[1]),i[2]]:[w(r),void 0]}function v(r,i){return`${r}.${i}`}function w(r){return r.toLowerCase()}function $(r,i){return w(v(r??P.$zm,i))}function f(r,i){const s=[],u=b=>{for(const C of s)if(C.some(I=>p(i(I),i(b))))return C;return null};for(const b of r){const C=u(b);C?C.push(b):s.push([b])}return s}function l(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}function d(r){return{id:new c.$4o(r.identifier.id),name:new c.$4o(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$pp=new P.$Dm("pprice.better-merge");function a(r,i){const s=[],u=i.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const b=u.shift();if(b&&s.every(C=>!p(C.identifier,{id:b}))){const C=r.filter(I=>p(I.identifier,{id:b}));C.length===1&&(s.push(C[0]),u.push(...C[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function t(r,i){if(!M.$k)return!1;let s;try{s=(await r.readFile(S.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await r.readFile(S.URI.file("/usr/lib/os-release"))).value.toString()}catch(b){i.debug("Error while getting the os-release file.",(0,E.$0)(b))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(r,i){const s=await t(r,i),u=(0,j.$No)(s?"alpine":M.$u,h.$fc);return i.debug("ComputeTargetPlatform:",u),u}}),define(oe[256],ae([0,1,209,54]),function(K,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=P;async function P(M,S,E,h,c,p,y){const k={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M} (${S.nameShort})`};if((0,j.$$o)(S,E)&&(0,j.$ap)(h)===3){const g=await(0,n.$Sp)(E,c,p);k["X-Market-User-Id"]=g,k["VSCode-SessionId"]=y.machineId||g}return k}}),define(oe[257],ae([0,1,2,35,4,25,188,18,52,79,27,45,28,54]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jr=void 0;let m=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor($,f,l){this.k=f,this.l=l,this.d={},this.i=new n.$Tc,this.j=[],this.b=$.appenders,this.c=$.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=$.piiPaths||[],this.g=3,this.h=!!$.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const d of this.f)this.j.push(new RegExp((0,M.$Ze)(d),"gi")),d.indexOf("\\")>=0&&this.j.push(new RegExp((0,M.$Ze)(d.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(d=>{(d.affectsConfiguration(k.$Vl)||d.affectsConfiguration(k.$Xl)||d.affectsConfiguration(k.$Wl))&&this.m()}))}setExperimentProperty($,f){this.d[$]=f}m(){let $=(0,g.$ap)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const l=f.usage?3:f.error?2:0;$=Math.min($,l)}this.g=$}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n($,f,l){this.g<f||(l=(0,j.$Rn)(l,this.d),l=(0,g.$fp)(l,this.j),l=(0,j.$Rn)(l,this.c),this.b.forEach(d=>d.log($,l)))}publicLog($,f){this.n($,3,f)}publicLog2($,f){this.publicLog($,f)}publicLogError($,f){this.h&&this.n($,2,f)}publicLogError2($,f){this.publicLogError($,f)}};e.$Jr=m,e.$Jr=m=Ee([ne(1,E.$Oi),ne(2,p.$8j)],m);function v(){const w=(0,S.localize)(0,null,c.default.nameLong),$=c.default.privacyStatementUrl?(0,S.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,S.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=P.$o?"":(0,S.localize)(3,null),l=(0,S.localize)(4,null),d=(0,S.localize)(5,null),a=(0,S.localize)(6,null),t=(0,S.localize)(7,null),o=`
|       | ${l} | ${d} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,S.localize)(8,null);return`
${w} ${$} ${f}

&nbsp;

${t}
${o}

&nbsp;

${r}
`}y.$1n.as(h.$6n.Configuration).registerConfiguration({id:k.$Ul,order:1,type:"object",title:(0,S.localize)(9,null),properties:{[k.$Vl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,S.localize)(10,null),(0,S.localize)(11,null),(0,S.localize)(12,null),(0,S.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.$1n.as(h.$6n.Configuration).registerConfiguration({id:k.$Ul,order:110,type:"object",title:(0,S.localize)(14,null),properties:{[k.$Xl]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,S.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,S.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,S.localize)(17,null,`\`#${k.$Vl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[258],ae([0,1,4,89,28]),function(K,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xbc=M,e.$ybc=S;async function M(E,h){let c=E.getItem(P.$Sl);return(typeof c!="string"||n.$j&&c==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(c=await(0,j.$rn)(h.error.bind(h))),c}async function S(E,h){let c=E.getItem(P.$Tl);return typeof c!="string"&&(c=await(0,j.$sn)(h.error.bind(h))),c}}),define(oe[259],ae([0,1,28,258]),function(K,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zbc=P,e.$Abc=M;async function P(S,E){const h=await(0,j.$xbc)(S,E);return S.setItem(n.$Sl,h),h}async function M(S,E){const h=await(0,j.$ybc)(S,E);return S.setItem(n.$Tl,h),h}}),define(oe[128],ae([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var n;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(n||(e.EnvironmentVariableMutatorType=n={}))}),define(oe[260],ae([0,1,4,128]),function(K,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=void 0;const P=new Map([[j.EnvironmentVariableMutatorType.Append,"APPEND"],[j.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[j.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class M{constructor(p){this.collections=p,this.a=new Map,this.b=new Map,p.forEach((y,k)=>{this.d(y,k);const g=y.map.entries();let m=g.next();for(;!m.done;){const v=m.value[1],w=m.value[0];let $=this.a.get(w);if($||($=[],this.a.set(w,$)),$.length>0&&$[0].type===j.EnvironmentVariableMutatorType.Replace){m=g.next();continue}const f={extensionIdentifier:k,value:v.value,type:v.type,scope:v.scope,variable:v.variable,options:v.options};f.scope||delete f.scope,$.unshift(f),m=g.next()}})}async applyToProcessEnvironment(p,y,k){let g;n.$i&&(g={},Object.keys(p).forEach(m=>g[m.toLowerCase()]=m));for(const[m,v]of this.getVariableMap(y)){const w=n.$i&&g[m.toLowerCase()]||m;for(const $ of v){const f=k?await k($.value):$.value;if($.options?.applyAtProcessCreation??!0)switch($.type){case j.EnvironmentVariableMutatorType.Append:p[w]=(p[w]||"")+f;break;case j.EnvironmentVariableMutatorType.Prepend:p[w]=f+(p[w]||"");break;case j.EnvironmentVariableMutatorType.Replace:p[w]=f;break}if($.options?.applyAtShellIntegration??!1){const l=`VSCODE_ENV_${P.get($.type)}`;p[l]=(p[l]?p[l]+":":"")+m+"="+this.c(f)}}}}c(p){return p.replaceAll(":","\\x3a")}diff(p,y){const k=new Map,g=new Map,m=new Map;if(p.getVariableMap(y).forEach((v,w)=>{const $=this.getVariableMap(y).get(w),f=E(v,$);f&&k.set(w,f)}),this.getVariableMap(y).forEach((v,w)=>{const $=p.getVariableMap(y).get(w),f=E(v,$);f&&m.set(w,f)}),this.getVariableMap(y).forEach((v,w)=>{const $=p.getVariableMap(y).get(w),f=h(v,$);f&&g.set(w,f)}),!(k.size===0&&g.size===0&&m.size===0))return{added:k,changed:g,removed:m}}getVariableMap(p){const y=new Map;for(const k of this.a.values()){const g=k.filter(m=>S(m,p));g.length>0&&y.set(g[0].variable,g)}return y}getDescriptionMap(p){const y=new Map;for(const k of this.b.values()){const g=k.filter(m=>S(m,p,!0));for(const m of g)y.set(m.extensionIdentifier,m.description)}return y}d(p,y){if(!p.descriptionMap)return;const k=p.descriptionMap.entries();let g=k.next();for(;!g.done;){const m=g.value[1],v=g.value[0];let w=this.b.get(v);w||(w=[],this.b.set(v,w));const $={extensionIdentifier:y,scope:m.scope,description:m.description};$.scope||delete $.scope,w.push($),g=k.next()}}}e.$as=M;function S(c,p,y=!1){return c.scope?!!(c.scope.workspaceFolder&&p?.workspaceFolder&&c.scope.workspaceFolder.index===p.workspaceFolder.index):y?p===c.scope:!0}function E(c,p){if(!p)return c;const y=new Set;p.forEach(g=>y.add(g.extensionIdentifier));const k=[];return c.forEach(g=>{y.has(g.extensionIdentifier)||k.push(g)}),k.length===0?void 0:k}function h(c,p){if(!p)return;const y=new Map;p.forEach(g=>y.set(g.extensionIdentifier,g));const k=[];return c.forEach(g=>{const m=y.get(g.extensionIdentifier);m&&(g.type!==m.type||g.value!==m.value||g.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index)&&k.push(m)}),k.length===0?void 0:k}}),define(oe[261],ae([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7r=n,e.$8r=j,e.$9r=P,e.$0r=M,e.$$r=S,e.$_r=E;function n(h){return[...h.entries()]}function j(h){return h?[...h.entries()]:[]}function P(h){return new Map(h)}function M(h){return new Map(h??[])}function S(h){return Array.from(h.entries()).map(c=>[c[0],n(c[1].map),j(c[1].descriptionMap)])}function E(h){return new Map(h.map(c=>[c[0],{map:P(c[1]),descriptionMap:M(c[2])}]))}}),define(oe[262],ae([0,1,8,23,3,2,5]),function(K,e,n,j,P,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xr=void 0;let E=class extends M.$Uc{constructor(c,p){super(),this.h=p,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new P.$7d),this.onCreateRequest=this.g.event,this.b=c===void 0?15e3:c,this.B((0,M.$Sc)(()=>{for(const y of this.f.values())(0,M.$Pc)(y)}))}createRequest(c){return new Promise((p,y)=>{const k=++this.a;this.c.set(k,p),this.g.fire({requestId:k,...c});const g=new j.$ee;(0,n.$jh)(this.b,g.token).then(()=>y(`Request ${k} timed out (${this.b}ms)`)),this.f.set(k,[(0,M.$Sc)(()=>g.cancel())])})}acceptReply(c,p){const y=this.c.get(c);y?(this.c.delete(c),(0,M.$Pc)(this.f.get(c)||[]),this.f.delete(c),y(p)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${c}`)}};e.$Xr=E,e.$Xr=E=Ee([ne(1,S.$Oj)],E)}),define(oe[129],ae([0,1,6,118,45]),function(K,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=e.$Sr=e.$Rr=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$Qr=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$Pr=void 0,e.$Pr=new j.$zj("terminalTabFocusMode",!1,!0);var M;(function(a){a.AutomationProfile="terminal.integrated.automationProfile.",a.DefaultProfile="terminal.integrated.defaultProfile.",a.Profiles="terminal.integrated.profiles."})(M||(e.TerminalSettingPrefix=M={}));var S;(function(a){a.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",a.AutomationProfileLinux="terminal.integrated.automationProfile.linux",a.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",a.AutomationProfileWindows="terminal.integrated.automationProfile.windows",a.ProfilesWindows="terminal.integrated.profiles.windows",a.ProfilesMacOs="terminal.integrated.profiles.osx",a.ProfilesLinux="terminal.integrated.profiles.linux",a.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",a.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",a.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",a.UseWslProfiles="terminal.integrated.useWslProfiles",a.TabsDefaultColor="terminal.integrated.tabs.defaultColor",a.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",a.TabsEnabled="terminal.integrated.tabs.enabled",a.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",a.TabsHideCondition="terminal.integrated.tabs.hideCondition",a.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",a.TabsShowActions="terminal.integrated.tabs.showActions",a.TabsLocation="terminal.integrated.tabs.location",a.TabsFocusMode="terminal.integrated.tabs.focusMode",a.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",a.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",a.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",a.CopyOnSelection="terminal.integrated.copyOnSelection",a.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",a.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",a.FontFamily="terminal.integrated.fontFamily",a.FontSize="terminal.integrated.fontSize",a.LetterSpacing="terminal.integrated.letterSpacing",a.LineHeight="terminal.integrated.lineHeight",a.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",a.TabStopWidth="terminal.integrated.tabStopWidth",a.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",a.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",a.BellDuration="terminal.integrated.bellDuration",a.FontWeight="terminal.integrated.fontWeight",a.FontWeightBold="terminal.integrated.fontWeightBold",a.CursorBlinking="terminal.integrated.cursorBlinking",a.CursorStyle="terminal.integrated.cursorStyle",a.CursorStyleInactive="terminal.integrated.cursorStyleInactive",a.CursorWidth="terminal.integrated.cursorWidth",a.Scrollback="terminal.integrated.scrollback",a.DetectLocale="terminal.integrated.detectLocale",a.DefaultLocation="terminal.integrated.defaultLocation",a.GpuAcceleration="terminal.integrated.gpuAcceleration",a.TerminalTitleSeparator="terminal.integrated.tabs.separator",a.TerminalTitle="terminal.integrated.tabs.title",a.TerminalDescription="terminal.integrated.tabs.description",a.RightClickBehavior="terminal.integrated.rightClickBehavior",a.Cwd="terminal.integrated.cwd",a.ConfirmOnExit="terminal.integrated.confirmOnExit",a.ConfirmOnKill="terminal.integrated.confirmOnKill",a.EnableBell="terminal.integrated.enableBell",a.EnableVisualBell="terminal.integrated.enableVisualBell",a.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",a.AllowChords="terminal.integrated.allowChords",a.AllowMnemonics="terminal.integrated.allowMnemonics",a.TabFocusMode="terminal.integrated.tabFocusMode",a.EnvMacOs="terminal.integrated.env.osx",a.EnvLinux="terminal.integrated.env.linux",a.EnvWindows="terminal.integrated.env.windows",a.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",a.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",a.ShowExitAlert="terminal.integrated.showExitAlert",a.SplitCwd="terminal.integrated.splitCwd",a.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",a.WordSeparators="terminal.integrated.wordSeparators",a.EnableFileLinks="terminal.integrated.enableFileLinks",a.UnicodeVersion="terminal.integrated.unicodeVersion",a.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",a.LocalEchoEnabled="terminal.integrated.localEchoEnabled",a.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",a.LocalEchoStyle="terminal.integrated.localEchoStyle",a.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",a.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",a.HideOnStartup="terminal.integrated.hideOnStartup",a.CustomGlyphs="terminal.integrated.customGlyphs",a.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",a.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",a.InheritEnv="terminal.integrated.inheritEnv",a.ShowLinkHover="terminal.integrated.showLinkHover",a.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",a.AutoReplies="terminal.integrated.autoReplies",a.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",a.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",a.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",a.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",a.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",a.EnableImages="terminal.integrated.enableImages",a.SmoothScrolling="terminal.integrated.smoothScrolling",a.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",a.FocusAfterRun="terminal.integrated.focusAfterRun",a.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",a.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",a.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",a.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",a.MouseWheelZoom="terminal.integrated.mouseWheelZoom",a.ExperimentalInlineChat="terminal.integrated.experimentalInlineChat",a.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",a.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",a.DevMode="terminal.integrated.developer.devMode"})(S||(e.TerminalSettingId=S={}));var E;(function(a){a.PowerShell="pwsh",a.Bash="bash",a.Fish="fish",a.Sh="sh",a.Csh="csh",a.Ksh="ksh",a.Zsh="zsh",a.Python="python"})(E||(e.PosixShellType=E={}));var h;(function(a){a.CommandPrompt="cmd",a.PowerShell="pwsh",a.Wsl="wsl",a.GitBash="gitbash",a.Python="python"})(h||(e.WindowsShellType=h={}));var c;(function(a){a[a.Api=0]="Api",a[a.Process=1]="Process",a[a.Sequence=2]="Sequence",a[a.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var p;(function(a){a.LocalPty="localPty",a.PtyHost="ptyHost",a.PtyHostWindow="ptyHostWindow",a.Logger="logger",a.Heartbeat="heartbeat"})(p||(e.TerminalIpcChannels=p={}));var y;(function(a){a.Cwd="cwd",a.InitialCwd="initialCwd",a.FixedDimensions="fixedDimensions",a.Title="title",a.ShellType="shellType",a.HasChildProcesses="hasChildProcesses",a.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",a.OverrideDimensions="overrideDimensions",a.FailedShellIntegrationActivation="failedShellIntegrationActivation",a.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.$Qr=(0,n.$ii)("ptyService");var k;(function(a){a[a.BeatInterval=5e3]="BeatInterval",a[a.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",a[a.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",a[a.SecondWaitMultiplier=1]="SecondWaitMultiplier",a[a.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(k||(e.HeartbeatConstants=k={}));var g;(function(a){a[a.Panel=1]="Panel",a[a.Editor=2]="Editor"})(g||(e.TerminalLocation=g={}));var m;(function(a){a.TerminalView="view",a.Editor="editor"})(m||(e.TerminalLocationString=m={}));var v;(function(a){a[a.GraceTime=6e4]="GraceTime",a[a.ShortGraceTime=6e3]="ShortGraceTime"})(v||(e.LocalReconnectConstants=v={}));var w;(function(a){a[a.HighWatermarkChars=1e5]="HighWatermarkChars",a[a.LowWatermarkChars=5e3]="LowWatermarkChars",a[a.CharCountAckSize=5e3]="CharCountAckSize"})(w||(e.FlowControlConstants=w={}));var $;(function(a){a.GitBash="Git Bash",a.Pwsh="PowerShell"})($||(e.ProfileSource=$={}));var f;(function(a){a[a.Off=0]="Off",a[a.FinalTerm=1]="FinalTerm",a[a.VSCode=2]="VSCode"})(f||(e.ShellIntegrationStatus=f={}));var l;(function(a){a[a.Unknown=0]="Unknown",a[a.Shutdown=1]="Shutdown",a[a.Process=2]="Process",a[a.User=3]="User",a[a.Extension=4]="Extension"})(l||(e.TerminalExitReason=l={})),e.$Rr={Backend:"workbench.contributions.terminal.processBackend"};class d{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const o=this.b(t.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}P.$1n.add(e.$Rr.Backend,new d),e.$Sr=(0,n.$ii)("localPtyService"),e.$Tr=(0,n.$ii)("terminalLogService")}),define(oe[263],ae([0,1,74,7,190,106]),function(K,e,n,j,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yr=S,e.$Zr=c,e.$1r=p,e.$2r=y;function S(k,g){const m=[{name:null,description:(0,P.localize)(0,null)}];return m.push(...k.map(v=>({name:v.profileName,description:E(v)}))),g&&m.push(...g.map(v=>({name:v.title,description:h(v)}))),{values:m.map(v=>v.name),markdownDescriptions:m.map(v=>v.description)}}function E(k){let g=`$(${M.ThemeIcon.isThemeIcon(k.icon)?k.icon.id:k.icon?k.icon:n.$Hj.terminal.id}) ${k.profileName}
- path: ${k.path}`;return k.args&&(typeof k.args=="string"?g+=`
- args: "${k.args}"`:g+=`
- args: [${k.args.length===0?"":`'${k.args.join("','")}'`}]`),k.overrideName!==void 0&&(g+=`
- overrideName: ${k.overrideName}`),k.color&&(g+=`
- color: ${k.color}`),k.env&&(g+=`
- env: ${JSON.stringify(k.env)}`),g}function h(k){return`$(${M.ThemeIcon.isThemeIcon(k.icon)?k.icon.id:k.icon?k.icon:n.$Hj.terminal.id}) ${k.title}
- extensionIdentifier: ${k.extensionIdentifier}`}function c(k,g){if(!k&&!g)return!0;if(typeof k=="string"&&typeof g=="string")return k===g;if(Array.isArray(k)&&Array.isArray(g)){if(k.length!==g.length)return!1;for(let m=0;m<k.length;m++)if(k[m]!==g[m])return!1;return!0}return!1}function p(k,g){if(!k&&!g)return!0;if(!k||!g)return!1;if(M.ThemeIcon.isThemeIcon(k)&&M.ThemeIcon.isThemeIcon(g))return k.id===g.id&&k.color===g.color;if(typeof k=="object"&&"light"in k&&"dark"in k&&typeof g=="object"&&"light"in g&&"dark"in g){const m=k,v=g;if((j.URI.isUri(m.light)||y(m.light))&&(j.URI.isUri(m.dark)||y(m.dark))&&(j.URI.isUri(v.light)||y(v.light))&&(j.URI.isUri(v.dark)||y(v.dark)))return m.light.path===v.light.path&&m.dark.path===v.dark.path}if(j.URI.isUri(k)&&j.URI.isUri(g)||y(k)||y(g)){const m=k,v=g;return m.path===v.path&&m.scheme===v.scheme}return!1}function y(k){return k?typeof k.path=="string"&&typeof k.scheme=="string":!1}}),define(oe[264],ae([0,1,74,4,189,52,45,263]),function(K,e,n,j,P,M,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=e.$3r=void 0,e.$5r=g,e.$6r=v,e.$3r={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$4r={type:"string",enum:Array.from((0,n.$Fj)(),w=>w.id),markdownEnumDescriptions:Array.from((0,n.$Fj)(),w=>`$(${w.id})`)};const h={args:{description:(0,P.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,P.localize)(1,null),type:"boolean"},icon:{description:(0,P.localize)(2,null),...e.$4r},color:{description:(0,P.localize)(3,null),...e.$3r},env:{markdownDescription:(0,P.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},c={type:"object",required:["path"],properties:{path:{description:(0,P.localize)(5,null),type:["string","array"],items:{type:"string"}},...h}},p={type:"object",required:["path"],properties:{path:{description:(0,P.localize)(6,null),type:["string"],items:{type:"string"}},...h}};function y(w){const $=w===2?"linux":w===1?"osx":"windows";return(0,P.localize)(7,null,(0,j.$h)(w),'```json\n"terminal.integrated.profile.'+$+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const k={id:"terminal",order:100,title:(0,P.localize)(8,null),type:"object",properties:{"terminal.integrated.automationProfile.linux":{restricted:!0,markdownDescription:(0,P.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},p],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.osx":{restricted:!0,markdownDescription:(0,P.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},p],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.windows":{restricted:!0,markdownDescription:(0,P.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},p],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.profiles.windows":{restricted:!0,markdownDescription:y(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,P.localize)(12,null),enum:["PowerShell","Git Bash"]},...h}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(13,null),type:"string"},id:{description:(0,P.localize)(14,null),type:"string"},title:{description:(0,P.localize)(15,null),type:"string"},...h}},{type:"null"},c]}},"terminal.integrated.profiles.osx":{restricted:!0,markdownDescription:y(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(16,null),type:"string"},id:{description:(0,P.localize)(17,null),type:"string"},title:{description:(0,P.localize)(18,null),type:"string"},...h}},{type:"null"},c]}},"terminal.integrated.profiles.linux":{restricted:!0,markdownDescription:y(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,P.localize)(19,null),type:"string"},id:{description:(0,P.localize)(20,null),type:"string"},title:{description:(0,P.localize)(21,null),type:"string"},...h}},{type:"null"},c]}},"terminal.integrated.useWslProfiles":{description:(0,P.localize)(22,null),type:"boolean",default:!0},"terminal.integrated.inheritEnv":{scope:1,description:(0,P.localize)(23,null),type:"boolean",default:!0},"terminal.integrated.persistentSessionScrollback":{scope:1,markdownDescription:(0,P.localize)(24,null),type:"number",default:100},"terminal.integrated.showLinkHover":{scope:1,description:(0,P.localize)(25,null),type:"boolean",default:!0},"terminal.integrated.ignoreProcessNames":{markdownDescription:(0,P.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function g(){S.$1n.as(M.$6n.Configuration).registerConfiguration(k),v()}let m;function v(w,$){const f=S.$1n.as(M.$6n.Configuration);let l;w&&(l=(0,E.$Yr)(w?.profiles,$));const d=m;m={id:"terminal",order:100,title:(0,P.localize)(27,null),type:"object",properties:{"terminal.integrated.defaultProfile.linux":{restricted:!0,markdownDescription:(0,P.localize)(28,null),type:["string","null"],default:null,enum:w?.os===3?l?.values:void 0,markdownEnumDescriptions:w?.os===3?l?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.osx":{restricted:!0,markdownDescription:(0,P.localize)(29,null),type:["string","null"],default:null,enum:w?.os===2?l?.values:void 0,markdownEnumDescriptions:w?.os===2?l?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.windows":{restricted:!0,markdownDescription:(0,P.localize)(30,null),type:["string","null"],default:null,enum:w?.os===1?l?.values:void 0,markdownEnumDescriptions:w?.os===1?l?.markdownDescriptions:void 0}}},f.updateConfigurations({add:[m],remove:d?[d]:[]})}}),define(oe[265],ae([0,1,26,13,35,9,4,36,25,12,21,128,261,260]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=m,e.$cs=v,e.$ds=w;function m(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());let s=0;return i&&i.length===4&&(s=parseInt(i[3])),s}async function v(i,s,u,b=E.env,C=p.Promises.exists){if(M.$jc(i))return await C(i)?i:void 0;if(s===void 0&&(s=E.cwd()),M.$nc(i)!=="."){const R=M.$kc(s,i);return await C(R)?R:void 0}const D=(0,P.$Vn)(b,"PATH");if(u===void 0&&(0,c.$Vf)(D)&&(u=D.split(M.$uc)),u===void 0||u.length===0){const R=M.$kc(s,i);return await C(R)?R:void 0}for(const R of u){let W;if(M.$jc(R)?W=M.$kc(R,i):W=M.$kc(s,R,i),await C(W))return W;if(S.$i){let F=W+".com";if(await C(F)||(F=W+".exe",await C(F)))return F}}const O=M.$kc(s,i);return await C(O)?O:void 0}function w(i,s,u,b,C){const I=S.$i&&(!s.windowsEnableConpty||m()<18309);if(!s.shellIntegration.enabled||!i.executable||i.isFeatureTerminal&&!i.forceShellIntegration||i.ignoreShellIntegration||I)return;const D=i.args,O=E.$ec==="win32"?M.$oc(i.executable).toLowerCase():M.$oc(i.executable),R=M.$nc(j.$Cg.asFileUri("").fsPath);let W;const F={VSCODE_INJECTION:"1"};if(s.shellIntegration.nonce&&(F.VSCODE_NONCE=s.shellIntegration.nonce),S.$i){if(O==="pwsh.exe"||O==="powershell.exe")return!D||o(D)?W=l.get(f.WindowsPwsh):t(D)&&(W=l.get(f.WindowsPwshLogin)),W?(W=[...W],W[W.length-1]=(0,h.$Ve)(W[W.length-1],R,""),s.shellIntegration.suggestEnabled&&(F.VSCODE_SUGGEST="1"),{newArgs:W,envMixin:F}):void 0;b.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(O){case"bash":return!D||D.length===0?W=l.get(f.Bash):r(D)&&(F.VSCODE_SHELL_LOGIN="1",$(s,F),W=l.get(f.Bash)),W?(W=[...W],W[W.length-1]=(0,h.$Ve)(W[W.length-1],R),{newArgs:W,envMixin:F}):void 0;case"fish":{const q=u?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",x=M.$kc(R,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return F.XDG_DATA_DIRS=`${q}:${x}`,$(s,F),{newArgs:void 0,envMixin:F}}case"pwsh":return!D||o(D)?W=l.get(f.Pwsh):t(D)&&(W=l.get(f.PwshLogin)),W?(s.shellIntegration.suggestEnabled&&(F.VSCODE_SUGGEST="1"),W=[...W],W[W.length-1]=(0,h.$Ve)(W[W.length-1],R,""),{newArgs:W,envMixin:F}):void 0;case"zsh":{if(!D||D.length===0?W=l.get(f.Zsh):r(D)?(W=l.get(f.ZshLogin),$(s,F)):(D===l.get(f.Zsh)||D===l.get(f.ZshLogin))&&(W=D),!W)return;W=[...W],W[W.length-1]=(0,h.$Ve)(W[W.length-1],R);let q;try{q=n.userInfo().username}catch{q="unknown"}const x=M.$kc(n.tmpdir(),`${q}-${C.applicationName}-zsh`);F.ZDOTDIR=x;const le=u?.ZDOTDIR??n.homedir()??"~";F.USER_ZDOTDIR=le;const te=[];return te.push({source:M.$kc(R,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:M.$kc(x,".zshrc")}),te.push({source:M.$kc(R,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:M.$kc(x,".zprofile")}),te.push({source:M.$kc(R,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:M.$kc(x,".zshenv")}),te.push({source:M.$kc(R,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:M.$kc(x,".zlogin")}),{newArgs:W,envMixin:F,filesToCopy:te}}}b.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}function $(i,s){if(S.$j&&i.environmentVariableCollections){const u=(0,k.$_r)(i.environmentVariableCollections),C=new g.$as(u).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),I=[];if(C)for(const D of C)D.type===y.EnvironmentVariableMutatorType.Prepend&&I.push(D.value);I.length>0&&(s.VSCODE_PATH_PREFIX=I.join(""))}}var f;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(f||(f={}));const l=new Map;l.set(f.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),l.set(f.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),l.set(f.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),l.set(f.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),l.set(f.Zsh,["-i"]),l.set(f.ZshLogin,["-il"]),l.set(f.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const d=["-login","-l"],a=["-nol","-nologo"];function t(i){return typeof i=="string"?d.includes(i.toLowerCase()):i.length===1&&d.includes(i[0].toLowerCase())||i.length===2&&(d.includes(i[0].toLowerCase())||d.includes(i[1].toLowerCase()))&&(a.includes(i[0].toLowerCase())||a.includes(i[1].toLowerCase()))}function o(i){return typeof i=="string"?a.includes(i.toLowerCase()):i.length===0||i?.length===1&&a.includes(i[0].toLowerCase())}function r(i){return i==="string"&&d.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&d.includes(i[0].toLowerCase())}}),define(oe[266],ae([0,1,49,74,9,4,12,21,110,265,117]),function(K,e,n,j,P,M,S,E,h,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=m;var y;(function(u){u.UnixShellsPath="/etc/shells"})(y||(y={}));let k,g=!0;function m(u,b,C,I,D=process.env,O,R,W,F){return O=O||{existsFile:E.SymlinkSupport.existsFile,readFile:E.Promises.readFile},M.$i?v(C,O,D,R,I.getValue("terminal.integrated.useWslProfiles")!==!1,u&&typeof u=="object"?{...u}:I.getValue("terminal.integrated.profiles.windows"),typeof b=="string"?b:I.getValue("terminal.integrated.defaultProfile.windows"),F,W):r(O,R,C,u&&typeof u=="object"?{...u}:I.getValue(M.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof b=="string"?b:I.getValue(M.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),F,W,D)}async function v(u,b,C,I,D,O,R,W,F){const q=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),x=`${process.env.windir}\\${q?"Sysnative":"System32"}`;let le=!1;(0,c.$bs)()>=16299&&(le=!0),await l(W);const te=new Map;if(u){te.set("PowerShell",{source:"PowerShell",icon:j.$Hj.terminalPowershell,isAutoDetected:!0}),te.set("Windows PowerShell",{path:`${x}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:j.$Hj.terminalPowershell,isAutoDetected:!0}),te.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),te.set("Command Prompt",{path:`${x}\\cmd.exe`,icon:j.$Hj.terminalCmd,isAutoDetected:!0}),te.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),te.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:j.$Hj.terminalBash,isAutoDetected:!0});const Y=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;te.set("Cmder",{path:`${x}\\cmd.exe`,args:["/K",Y],requiresPath:process.env.CMDER_ROOT?Y:{path:Y,isUnsafe:!0},isAutoDetected:!0})}i(O,te);const ue=await w(te.entries(),R,b,C,I,F);if(u&&D)try{const Y=await t(`${x}\\${le?"wsl":"bash"}.exe`,R);for(const Z of Y)(!O||!(Z.profileName in O))&&ue.push(Z)}catch{g&&(I?.trace("WSL is not installed, so could not detect WSL profiles"),g=!1)}return ue}async function w(u,b,C,I=process.env,D,O){const R=[];for(const[W,F]of u)R.push($(W,F,b,C,I,D,O));return(await Promise.all(R)).filter(W=>!!W)}async function $(u,b,C,I,D=process.env,O,R){if(b===null)return;let W,F,q;if("source"in b&&!("path"in b)){const ue=k?.get(b.source);if(!ue)return;W=ue.paths,F=b.args||ue.args,b.icon?q=f(b.icon):ue.icon&&(q=ue.icon)}else W=Array.isArray(b.path)?b.path:[b.path],F=M.$i||Array.isArray(b.args)?b.args:void 0,q=f(b.icon);let x;if(R){const ue=W.map(Z=>typeof Z=="string"?Z:Z.path),Y=await R(ue);x=new Array(W.length);for(let Z=0;Z<W.length;Z++)typeof W[Z]=="string"?x[Z]=Y[Z]:x[Z]={path:Y[Z],isUnsafe:!0}}else x=W.slice();let le;if(b.requiresPath){let ue;if((0,S.$Vf)(b.requiresPath)?ue=b.requiresPath:(ue=b.requiresPath.path,b.requiresPath.isUnsafe&&(le=ue)),!await I.existsFile(ue))return}const te=await s(u,C,x,I,D,F,b.env,b.overrideName,b.isAutoDetected,le);if(!te){O?.debug("Terminal profile not validated",u,W);return}return te.isAutoDetected=b.isAutoDetected,te.icon=q,te.color=b.color,te}function f(u){return typeof u=="string"?{id:u}:u}async function l(u){if(k&&!u)return;const[b,C]=await Promise.all([d(),u||a()]);k=new Map,k.set("Git Bash",{profileName:"Git Bash",paths:b,args:["--login","-i"]}),k.set("PowerShell",{profileName:"PowerShell",paths:C,icon:j.$Hj.terminalPowershell})}async function d(){const u=new Set,b=await(0,c.$cs)("git.exe");if(b){const D=(0,p.dirname)(b);u.add((0,p.resolve)(D,"../.."))}function C(D,O){O&&D.add(O)}C(u,process.env.ProgramW6432),C(u,process.env.ProgramFiles),C(u,process.env["ProgramFiles(X86)"]),C(u,`${process.env.LocalAppData}\\Program`);const I=[];for(const D of u)I.push(`${D}\\Git\\bin\\bash.exe`,`${D}\\Git\\usr\\bin\\bash.exe`,`${D}\\usr\\bin\\bash.exe`);return I.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),I.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),I}async function a(){const u=[];for await(const b of(0,h.$9l)())u.push(b.exePath);return u}async function t(u,b){const C=[],I=await new Promise((R,W)=>{n.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(F,q)=>{if(F)return W("Problem occurred when getting wsl distros");R(q)})});if(!I)return[];const D=new RegExp(/[\r?\n]/),O=I.split(D).filter(R=>R.trim().length>0&&R!=="");for(const R of O){if(R===""||R.startsWith("docker-desktop"))continue;const W=`${R} (WSL)`,F={profileName:W,path:u,args:["-d",`${R}`],isDefault:W===b,icon:o(R),isAutoDetected:!1};C.push(F)}return C}function o(u){return u.includes("Ubuntu")?j.$Hj.terminalUbuntu:u.includes("Debian")?j.$Hj.terminalDebian:j.$Hj.terminalLinux}async function r(u,b,C,I,D,O,R,W){const F=new Map;if(C&&await u.existsFile("/etc/shells")){const q=(await u.readFile("/etc/shells")).toString(),x=(O||q.split(`
`)).map(te=>{const ue=te.indexOf("#");return ue===-1?te:te.substring(0,ue)}).filter(te=>te.trim().length>0),le=new Map;for(const te of x){let ue=(0,P.$oc)(te),Y=le.get(ue)||0;Y++,Y>1&&(ue=`${ue} (${Y})`),le.set(ue,Y),F.set(ue,{path:te,isAutoDetected:!0})}}return i(I,F),await w(F.entries(),D,u,W,b,R)}function i(u,b){if(u)for(const[C,I]of Object.entries(u))I===null||typeof I!="object"||!("path"in I)&&!("source"in I)?b.delete(C):(I.icon=I.icon||b.get(C)?.icon,b.set(C,I))}async function s(u,b,C,I,D,O,R,W,F,q){if(C.length===0)return Promise.resolve(void 0);const x=C.shift();if(x==="")return s(u,b,C,I,D,O,R,W,F);const le=typeof x!="string"&&x.isUnsafe,te=typeof x=="string"?x:x.path,ue={profileName:u,path:te,args:O,env:R,overrideName:W,isAutoDetected:F,isDefault:u===b,isUnsafePath:le,requiresUnsafePath:q};if((0,P.$oc)(te)===te){const Z=D.PATH?D.PATH.split(P.$uc):void 0,B=await(0,c.$cs)(te,void 0,Z,void 0,I.existsFile);return B?(ue.path=B,ue.isFromPath=!0,ue):s(u,b,C,I,D,O)}return await I.existsFile((0,P.$ic)(te))?ue:s(u,b,C,I,D,O,R,W,F)}}),define(oe[267],ae([0,1,3,2,4,44,18,5,230,95,262,129,264,266,112,72]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=void 0;var w;(function(f){f[f.MaxRestarts=5]="MaxRestarts"})(w||(w={}));let $=class extends j.$Uc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(l,d,a,t){super(),this.M=l,this.N=d,this.O=a,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new n.$7d),this.onPtyHostExit=this.u.event,this.w=this.B(new n.$7d),this.onPtyHostStart=this.w.event,this.y=this.B(new n.$7d),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new n.$7d),this.onPtyHostResponsive=this.z.event,this.C=this.B(new n.$7d),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new n.$7d),this.onProcessData=this.D.event,this.F=this.B(new n.$7d),this.onProcessReady=this.F.event,this.G=this.B(new n.$7d),this.onProcessReplay=this.G.event,this.H=this.B(new n.$7d),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new n.$7d),this.onDidRequestDetach=this.I.event,this.J=this.B(new n.$7d),this.onDidChangeProperty=this.J.event,this.L=this.B(new n.$7d),this.onProcessExit=this.L.event,(0,k.$5r)(),this.B(this.M),this.B((0,j.$Sc)(()=>this.W())),this.j=this.B(new p.$Xr(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&n.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(P.$i)return process.env;try{return await(0,c.$sm)(this.N,this.O,{_:[]},process.env)}catch(l){return this.O.error("ptyHost was unable to resolve shell environment",l),{}}}U(){const l=this.M.start(),d=l.client;this.O.getLevel()===E.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),M.ProxyChannel.toService(d.getChannel(y.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(l.onDidProcessExit(o=>{this.u.fire(o.code),!this.m&&!this.q.isDisposed&&(this.n<=w.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const t=M.ProxyChannel.toService(d.getChannel(y.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(o=>this.D.fire(o))),this.B(t.onProcessReady(o=>this.F.fire(o))),this.B(t.onProcessExit(o=>this.L.fire(o))),this.B(t.onDidChangeProperty(o=>this.J.fire(o))),this.B(t.onProcessReplay(o=>this.G.fire(o))),this.B(t.onProcessOrphanQuestion(o=>this.H.fire(o))),this.B(t.onDidRequestDetach(o=>this.I.fire(o))),this.B(new h.$Wr(this.P,d.getChannel(y.TerminalIpcChannels.Logger))),this.a=l,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[l,t]}async createProcess(l,d,a,t,o,r,i,s,u,b,C){const I=setTimeout(()=>this.$(),y.HeartbeatConstants.CreateProcessTimeout),D=await this.f.createProcess(l,d,a,t,o,r,i,s,u,b,C);return clearTimeout(I),D}updateTitle(l,d,a){return this.f.updateTitle(l,d,a)}updateIcon(l,d,a,t){return this.f.updateIcon(l,d,a,t)}attachToProcess(l){return this.f.attachToProcess(l)}detachFromProcess(l,d){return this.f.detachFromProcess(l,d)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(l){return this.f.start(l)}shutdown(l,d){return this.f.shutdown(l,d)}input(l,d){return this.f.input(l,d)}processBinary(l,d){return this.f.processBinary(l,d)}resize(l,d,a){return this.f.resize(l,d,a)}clearBuffer(l){return this.f.clearBuffer(l)}acknowledgeDataEvent(l,d){return this.f.acknowledgeDataEvent(l,d)}setUnicodeVersion(l,d){return this.f.setUnicodeVersion(l,d)}getInitialCwd(l){return this.f.getInitialCwd(l)}getCwd(l){return this.f.getCwd(l)}async getLatency(){const l=new v.$3d,d=await this.f.getLatency();return l.stop(),[{label:"ptyhostservice<->ptyhost",latency:l.elapsed()},...d]}orphanQuestionReply(l){return this.f.orphanQuestionReply(l)}installAutoReply(l,d){return this.f.installAutoReply(l,d)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(l){return this.f.uninstallAutoReply(l)}getDefaultSystemShell(l){return this.g?.getDefaultSystemShell(l)??(0,m.$cm)(l??P.OS,process.env)}async getProfiles(l,d,a,t=!1){const o=await this.S();return(0,g.$es)(d,a,t,this.N,o,void 0,this.O,this.bb.bind(this,l))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(l,d){return this.f.getWslPath(l,d)}getRevivedPtyNewId(l,d){return this.f.getRevivedPtyNewId(l,d)}setTerminalLayoutInfo(l){return this.f.setTerminalLayoutInfo(l)}async getTerminalLayoutInfo(l){return this.g?.getTerminalLayoutInfo(l)}async requestDetachInstance(l,d){return this.f.requestDetachInstance(l,d)}async acceptDetachInstanceReply(l,d){return this.f.acceptDetachInstanceReply(l,d)}async freePortKillProcess(l){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(l)}async serializeTerminalState(l){return this.f.serializeTerminalState(l)}async reviveTerminalProcesses(l,d,a){return this.f.reviveTerminalProcesses(l,d,a)}async refreshProperty(l,d){return this.f.refreshProperty(l,d)}async updateProperty(l,d,a){return this.f.updateProperty(l,d,a)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(l){this.ab(),this.s=setTimeout(()=>this.Y(),l?y.HeartbeatConstants.ConnectingBeatInterval:y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier+y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${y.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(l,d){return this.j.createRequest({workspaceId:l,originalText:d})}async acceptPtyHostResolvedVariables(l,d){this.j.acceptReply(l,d)}};e.$fs=$,e.$fs=$=Ee([ne(1,S.$Oi),ne(2,E.$Oj),ne(3,E.$Pj)],$)}),define(oe[69],ae([0,1,14,3,2,4,18,6,34]),function(K,e,n,j,P,M,S,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y_b=e.$X_b=void 0;const c="#FFFFFF",p="#1E1E1E",y="#000000",k="#FFFFFF",g="theme",m="themeBackground",v="windowSplash";e.$X_b=(0,E.$ii)("themeMainService");let w=class extends P.$Uc{constructor(f,l){super(),this.b=f,this.c=l,this.a=this.B(new j.$7d),this.onDidChangeColorScheme=this.a.event,this.B(this.c.onDidChangeConfiguration(d=>{d.affectsConfiguration("window.systemColorTheme")&&this.f()})),this.f(),this.B(j.Event.fromNodeEventEmitter(n.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){switch(this.c.getValue("window.systemColorTheme")){case"dark":n.nativeTheme.themeSource="dark";break;case"light":n.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":n.nativeTheme.themeSource="light";break;case"vs-dark":n.nativeTheme.themeSource="dark";break;default:n.nativeTheme.themeSource="system"}break;default:n.nativeTheme.themeSource="system";break}}getColorScheme(){if(M.$i){if(n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(M.$j){if(n.nativeTheme.shouldUseInvertedColorScheme||n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(M.$k&&n.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const f=this.getColorScheme();if(f.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return f.dark?y:k;let l=this.b.getItem(m,null);if(!l)switch(this.g()){case"vs":l=c;break;case"hc-black":l=y;break;case"hc-light":l=k;break;default:l=p}return M.$j&&l.toUpperCase()===p&&(l="#171717"),l}g(){switch(this.b.getItem(g,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(f,l){this.b.setItems([{key:g,data:l.baseTheme},{key:m,data:l.colorInfo.background},{key:v,data:l}]),typeof f=="number"&&this.h(f,l),this.f()}h(f,l){for(const d of n.BrowserWindow.getAllWindows())if(d.id===f){d.setBackgroundColor(l.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(v)}};e.$Y_b=w,e.$Y_b=w=Ee([ne(0,h.$WP),ne(1,S.$Oi)],w)}),define(oe[130],ae([0,1,3,7,18,6,5]),function(K,e,n,j,P,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8v=e.$7v=e.$4v=e.$2v=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Xv=e.$Wv=void 0,e.$Yv=c,e.$Zv=y,e.$1v=k,e.$3v=g,e.$5v=m,e.$6v=v,e.$Wv=(0,M.$ii)("tunnelService"),e.$Xv=(0,M.$ii)("sharedTunnelsService");var E;(function(f){f.Http="http",f.Https="https"})(E||(e.TunnelProtocol=E={}));var h;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(h||(e.TunnelPrivacyId=h={}));function c(f){return!!f.forwardPort}var p;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(p||(e.ProvidedOnAutoForward=p={}));function y(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(l)return{address:l[1],port:+l[2]}}function k(f){if(f.scheme!=="http"&&f.scheme!=="https"||!f.query)return;const l=f.query.split("&");for(const d of l){const a=d.split("=")[1];if(/^https?:/.exec(a)){const t=y(j.URI.parse(a));if(t)return t}}}e.$2v=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function g(f){return e.$2v.indexOf(f)>=0}e.$4v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(f){return e.$4v.indexOf(f)>=0}function v(f,l,d,a){if(d===1)return!1;if(d===2&&m(l)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(t?.length===4&&parseInt(t[1])>=18)return!1}return f<1024}class w{constructor(l,d,a){this.remoteAddress=l,this.localAddress=d,this.b=a,this.a=new n.$7d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$7v=w;let $=class{constructor(l,d){this.k=l,this.l=d,this.a=new n.$7d,this.onTunnelOpened=this.a.event,this.b=new n.$7d,this.onTunnelClosed=this.b.event,this.c=new n.$7d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const l=this.l.getValue("remote.localPortHost");return!l||l==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(l){return this.f=l,l?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(l){this.g=l.elevation,this.i=l.privacyOptions,this.h=l.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const l=[],d=Array.from(this.e.values());for(const a of d){const t=Array.from(a.values());for(const o of t){const r=await o.value;r&&typeof r!="string"&&l.push(r)}}return l}async dispose(){for(const l of this.e.values()){for(const{value:d}of l.values())await d.then(a=>typeof a!="string"?a?.dispose():void 0);l.clear()}this.e.clear()}setEnvironmentTunnel(l,d,a,t,o){this.q(l,d,Promise.resolve({tunnelRemoteHost:l,tunnelRemotePort:d,localAddress:a,privacy:t,protocol:o,dispose:()=>Promise.resolve()}))}async getExistingTunnel(l,d){(m(l)||g(l))&&(l=e.$2v[0]);const a=this.s(l,d);if(a)return++a.refcount,a.value}openTunnel(l,d,a,t,o,r=!1,i,s){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${a} on local port ${o}.`);const u=this.f??l;if(!u)return;if(d||(d="localhost"),t||(t=this.m),this.f&&this.j.has(a)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const b=this.t(u,d,a,t,o,r,i,s);return b?b.then(C=>{if(C){if(typeof C=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(d,a),C}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(d,a);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const I=this.o(C);return(C.tunnelRemoteHost!==d||C.tunnelRemotePort!==a)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),i&&C.privacy!==i&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(I),I}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),b)}o(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,privacy:l.privacy,protocol:l.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const d=this.e.get(l.tunnelRemoteHost);if(d){const a=d.get(l.tunnelRemotePort);a&&(a.refcount--,await this.p(l.tunnelRemoteHost,l.tunnelRemotePort,a))}}}}async p(l,d,a){if(a.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${d}.`);const t=a.value.then(async o=>{o&&typeof o!="string"&&(await o.dispose(!0),this.b.fire({host:o.tunnelRemoteHost,port:o.tunnelRemotePort}))});return this.e.has(l)&&this.e.get(l).delete(d),t}}async closeTunnel(l,d){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${d} `);const a=this.e.get(l);if(a&&a.has(d)){const t=a.get(d);t.refcount=0,await this.p(l,d,t)}}q(l,d,a){this.e.has(l)||this.e.set(l,new Map),this.e.get(l).set(d,{refcount:1,value:a})}async r(l,d){const a=this.e.get(l);if(a){const t=a.get(d),o=t?await t.value:void 0;(!o||typeof o=="string")&&a.delete(d),a.size===0&&this.e.delete(l)}}s(l,d){const a=[l];g(l)?(a.push(...e.$2v),a.push(...e.$4v)):m(l)&&a.push(...e.$4v);const t=a.map(o=>this.e.get(o));for(const o of t){const r=o?.get(d);if(r)return r}}canTunnel(l){return!!y(l)}u(l,d,a,t,o,r,i){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${a} on local port ${t}.`);const s=a;this.j.add(s);const u=t===void 0?a:t,b={elevationRequired:o?this.isPortPrivileged(u):!1},C={remoteAddress:{host:d,port:a},localAddressPort:t,privacy:r,public:r?r!==h.Private:void 0,protocol:i},I=l.forwardPort(C,b);return I?(this.q(d,a,I),I.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(s)})):this.j.delete(s),I}};e.$8v=$,e.$8v=$=Ee([ne(0,S.$Oj),ne(1,P.$Oi)],$)}),define(oe[50],ae([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4W=e.$3W=e.DisablementReason=e.UpdateType=e.StateType=void 0;var j;(function(S){S.Uninitialized="uninitialized",S.Idle="idle",S.Disabled="disabled",S.CheckingForUpdates="checking for updates",S.AvailableForDownload="available for download",S.Downloading="downloading",S.Downloaded="downloaded",S.Updating="updating",S.Ready="ready"})(j||(e.StateType=j={}));var P;(function(S){S[S.Setup=0]="Setup",S[S.Archive=1]="Archive",S[S.Snap=2]="Snap"})(P||(e.UpdateType=P={}));var M;(function(S){S[S.NotBuilt=0]="NotBuilt",S[S.DisabledByEnvironment=1]="DisabledByEnvironment",S[S.ManuallyDisabled=2]="ManuallyDisabled",S[S.MissingConfiguration=3]="MissingConfiguration",S[S.InvalidConfiguration=4]="InvalidConfiguration",S[S.RunningAsAdmin=5]="RunningAsAdmin"})(M||(e.DisablementReason=M={})),e.$3W={Uninitialized:{type:"uninitialized"},Disabled:S=>({type:"disabled",reason:S}),Idle:(S,E)=>({type:"idle",updateType:S,error:E}),CheckingForUpdates:S=>({type:"checking for updates",explicit:S}),AvailableForDownload:S=>({type:"available for download",update:S}),Downloading:{type:"downloading"},Downloaded:S=>({type:"downloaded",update:S}),Updating:S=>({type:"updating",update:S}),Ready:S=>({type:"ready",update:S})},e.$4W=(0,n.$ii)("updateService")}),define(oe[268],ae([0,1,4,191,52,45]),function(K,e,n,j,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.$1n.as(P.$6n.Configuration).registerConfiguration({id:"update",order:15,title:(0,j.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,j.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,j.localize)(2,null),(0,j.localize)(3,null),(0,j.localize)(4,null),(0,j.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,j.localize)(6,null),deprecationMessage:(0,j.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,j.localize)(8,null),description:(0,j.localize)(9,null),included:n.$i&&!n.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,j.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(oe[269],ae([0,1,3,50]),function(K,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ac=e.$0ac=void 0;class P{constructor(E){this.a=E}listen(E,h){switch(h){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${h}`)}call(E,h,c){switch(h){case"checkForUpdates":return this.a.checkForUpdates(c);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(c)}throw new Error(`Call not found: ${h}`)}}e.$0ac=P;class M{get state(){return this.b}set state(E){this.b=E,this.a.fire(E)}constructor(E){this.c=E,this.a=new n.$7d,this.onStateChange=this.a.event,this.b=j.$3W.Uninitialized,this.c.listen("onStateChange")(h=>this.state=h),this.c.call("_getInitialState").then(h=>this.state=h)}checkForUpdates(E){return this.c.call("checkForUpdates",E)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(E){return this.c.call("_applySpecificUpdate",E)}}e.$$ac=M}),define(oe[40],ae([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ml=void 0,e.$ml=(0,n.$ii)("IUriIdentityService")}),define(oe[270],ae([0,1,40,210,16,19,142,3,2]),function(K,e,n,j,P,M,S,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=void 0;class c{static{this._clock=0}constructor(k){this.uri=k,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let p=class{constructor(k){this.g=k,this.c=new h.$Tc,this.f=2**16;const g=new Map,m=v=>{let w=g.get(v.scheme);return w===void 0&&(w=k.hasProvider(v)&&!this.g.hasCapability(v,1024),g.set(v.scheme,w)),w};this.c.add(E.Event.any(k.onDidChangeFileSystemProviderRegistrations,k.onDidChangeFileSystemProviderCapabilities)(v=>{g.delete(v.scheme)})),this.extUri=new M.$Kg(m),this.d=new S.$is((v,w)=>this.extUri.compare(v,w,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(k){this.g.hasProvider(k)&&(k=(0,M.$Wg)(k));const g=this.d.get(k);return g?g.touch().uri.with({fragment:k.fragment}):(this.d.set(k,new c(k)),this.h(),k)}h(){if(this.d.size<this.f)return;const k=[...this.d.entries()].sort((m,v)=>m[1].time<v[1].time?1:m[1].time>v[1].time?-1:0);c._clock=0,this.d.clear();const g=this.f*.5;for(let m=0;m<g;m++)this.d.set(k[m][0],k[m][1].touch())}};e.$js=p,e.$js=p=Ee([ne(0,P.$Ok)],p),(0,j.$gs)(n.$ml,p,1)}),define(oe[131],ae([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TW=void 0,e.$TW=(0,n.$ii)("urlService")}),define(oe[271],ae([0,1,7]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hbc=e.$gbc=e.$fbc=void 0;class j{constructor(E){this.a=E}listen(E,h){throw new Error(`Event not found: ${h}`)}call(E,h,c){switch(h){case"handleURL":return this.a.handleURL(n.URI.revive(c[0]),c[1])}throw new Error(`Call not found: ${h}`)}}e.$fbc=j;class P{constructor(E){this.a=E}handleURL(E,h){return this.a.call("handleURL",[E.toJSON(),h])}}e.$gbc=P;class M{constructor(E,h){this.a=E,this.b=h}async routeCall(E,h,c,p){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(Array.isArray(c)&&c.length>0){const y=n.URI.revive(c[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",y.toString(!0)),y.query){const k=/\bwindowId=(\d+)/.exec(y.query);if(k){const g=k[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${g}"`,y.toString(!0));const m=new RegExp(`window:${g}`),v=E.connections.find(w=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",w.ctx),m.test(w.ctx)));if(v)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",y.toString(!0)),v;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",y.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",y.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(E,h,c,p)}routeEvent(E,h){throw new Error(`Event not found: ${h}`)}}e.$hbc=M}),define(oe[272],ae([0,1,8,2,7,27]),function(K,e,n,j,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VW=e.$UW=void 0;class S extends j.$Uc{constructor(){super(...arguments),this.a=new Set}open(c,p){const y=[...this.a.values()];return(0,n.$mh)(y.map(k=>()=>k.handleURL(c,p)),void 0,!1).then(k=>k||!1)}registerHandler(c){return this.a.add(c),(0,j.$Sc)(()=>this.a.delete(c))}}e.$UW=S;let E=class extends S{constructor(c){super(),this.b=c}create(c){let{authority:p,path:y,query:k,fragment:g}=c||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return p&&y&&y.indexOf("/")!==0&&(y=`/${y}`),P.URI.from({scheme:this.b.urlProtocol,authority:p,path:y,query:k,fragment:g})}};e.$VW=E,e.$VW=E=Ee([ne(0,M.$8j)],E)}),define(oe[273],ae([0,1,14,8,3,2,4,7]),function(K,e,n,j,P,M,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ibc=void 0;class h extends M.$Uc{constructor(p,y,k,g,m,v){if(super(),this.c=y,this.f=v,this.a=[],this.b=0,p&&(v.trace("ElectronURLListener initialUrisToHandle:",p.map(f=>f.originalUrl)),this.a=p),S.$i){const f=g.isBuilt?[]:[`"${g.appRoot}"`];f.push("--open-url","--"),n.app.setAsDefaultProtocolClient(m.urlProtocol,process.execPath,f)}const w=P.Event.map(P.Event.fromNodeEventEmitter(n.app,"open-url",(f,l)=>({event:f,url:l})),({event:f,url:l})=>(f.preventDefault(),l));this.B(w(f=>{const l=this.g(f);l&&this.c.open(l,{originalUrl:f})})),k.getWindows().filter(f=>f.isReady).length>0?(v.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(v.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(P.Event.once(k.onDidSignalReadyWindow)(()=>this.h())))}g(p){try{return E.URI.parse(p)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const p=[];for(const y of this.a)await this.c.open(y.uri,{originalUrl:y.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",y.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",y.originalUrl),p.push(y));p.length!==0&&(this.a=p,(0,j.$kh)(()=>this.h(),500,this.q))}}e.$ibc=h}),define(oe[274],ae([0,1,3,2,16,59,32]),function(K,e,n,j,P,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vbc=void 0;class E extends j.$Uc{constructor(c,p,y,k,g,m){super(),this.f=c,this.g=p,this.h=y,this.j=k,this.m=g,this.n=m,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new n.$7d),this.onDidChangeFile=this.a.event,this.b=M.$oi.forUris(()=>!(this.capabilities&1024)),this.c=new S.$Cc(v=>this.m.extUri.getComparisonKey(this.t(v))),this.r(),this.B(k.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(v=>this.s(v)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,p){return this.g.open(this.t(c),p)}close(c){return this.g.close(c)}read(c,p,y,k,g){return this.g.read(c,p,y,k,g)}write(c,p,y,k,g){return this.g.write(c,p,y,k,g)}watch(c,p){this.b.set(c,c);const y=this.g.watch(this.t(c),p);return(0,j.$Sc)(()=>{this.b.delete(c),y.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,p,y){return this.g.rename(this.t(c),this.t(p),y)}readFile(c,p){return this.g.readFile(this.t(c),p)}readFileStream(c,p,y){return this.g.readFileStream(this.t(c),p,y)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,p,y){return this.g.writeFile(this.t(c),p,y)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,p){return this.g.delete(this.t(c),p)}copy(c,p,y){if((0,P.$Sk)(this.g))return this.g.copy(this.t(c),this.t(p),y);throw new Error("copy not supported")}cloneFile(c,p){if((0,P.$Tk)(this.g))return this.g.cloneFile(this.t(c),this.t(p));throw new Error("clone not supported")}s(c){const p=[];for(const y of c){if(y.resource.scheme!==this.f)continue;const k=this.u(y.resource);this.b.findSubstr(k)&&p.push({resource:k,type:y.type,cId:y.cId})}p.length&&(this.n.debug("User data changed"),this.a.fire(p))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$Vbc=E}),define(oe[275],ae([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cbc=void 0,e.$Cbc="utilityProcessWorker"}),define(oe[276],ae([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jbc=void 0,e.$jbc=(0,n.$ii)("webviewManagerService")}),define(oe[277],ae([0,1,14,2,13,7]),function(K,e,n,j,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kbc=void 0;class S extends j.$Uc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const h=this.b.bind(this);n.protocol.registerFileProtocol(P.Schemas.vscodeWebview,h)}b(h,c){try{const p=M.URI.parse(h.url),y=S.a.get(p.path);if(typeof y=="string"){const k=`vs/workbench/contrib/webview/browser/pre/${y}`,g=P.$Cg.asFileUri(k);return c({path:g.fsPath,headers:{...P.COI.getHeadersFromQuery(h.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return c({error:-10})}catch{}return c({error:-2})}}e.$kbc=S}),define(oe[55],ae([0,1,4]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$_C=void 0,e.$aD=j,e.$bD=P,e.$cD=M,e.$dD=S,e.$eD=E,e.$fD=y,e.$gD=k,e.$hD=g,e.$iD=m,e.$jD=v,e.$kD=w,e.$_C={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function j($){return typeof $.parentId=="number"}function P($){return!!$.workspaceUri}function M($){return!!$.folderUri}function S($){return!!$.fileUri}function E($){const f=k($),l=$.getValue("window.menuBarVisibility");return l==="default"||f&&l==="compact"||n.$j&&n.$m?"classic":l}var h;(function($){$.TITLE_BAR_STYLE="window.titleBarStyle",$.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(h||(e.TitleBarSetting=h={}));var c;(function($){$.NATIVE="native",$.CUSTOM="custom"})(c||(e.TitlebarStyle=c={}));var p;(function($){$.AUTO="auto",$.WINDOWED="windowed",$.NEVER="never"})(p||(e.CustomTitleBarVisibility=p={}));function y($,f){return!0}function k($,f){return f||(f=g($)),f==="native"}function g($){if(n.$o)return"custom";const f=$.getValue("window");if(f){if(n.$j&&f.nativeTabs===!0||n.$j&&f.nativeFullScreen===!1)return"native";const a=f.titleBarStyle;if(a==="native"||a==="custom")return a}return n.$k?"native":"custom"}function m($){return!(!n.$i||n.$o||k($))}function v($){const f=$.getValue("window");return!f||typeof f.nativeFullScreen!="boolean"||f.nativeTabs?!0:f.nativeFullScreen!==!1}function w($=0){return Math.pow(1.2,$)}}),define(oe[81],ae([0,1,14]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$N_b=e.$M_b=e.UnloadReason=e.LoadReason=void 0;var j;(function(c){c[c.INITIAL=1]="INITIAL",c[c.LOAD=2]="LOAD",c[c.RELOAD=3]="RELOAD"})(j||(e.LoadReason=j={}));var P;(function(c){c[c.CLOSE=1]="CLOSE",c[c.QUIT=2]="QUIT",c[c.RELOAD=3]="RELOAD",c[c.LOAD=4]="LOAD"})(P||(e.UnloadReason=P={}));const M=function(c=1){return{width:1024,height:768,mode:c}};e.$M_b=M;const S=function(){const y=n.screen.getPrimaryDisplay().workArea,k=Math.max(y.x+y.width/2-800/2,0),g=Math.max(y.y+y.height/2-600/2,0);return{x:k,y:g,width:800,height:600,mode:1}};e.$N_b=S;var E;(function(c){c[c.Maximized=0]="Maximized",c[c.Normal=1]="Normal",c[c.Minimized=2]="Minimized",c[c.Fullscreen=3]="Fullscreen"})(E||(e.WindowMode=E={}));var h;(function(c){c[c.UNRESPONSIVE=1]="UNRESPONSIVE",c[c.PROCESS_GONE=2]="PROCESS_GONE",c[c.LOAD=3]="LOAD"})(h||(e.WindowError=h={}))}),define(oe[278],ae([0,1,8,3,2]),function(K,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qbc=void 0;class M extends P.$Uc{constructor({onDidOpenMainWindow:E,onDidFocusMainWindow:h,getActiveWindowId:c}){super(),this.a=this.B(new P.$Tc),j.Event.latch(j.Event.any(E,h))(this.f,this,this.a),this.b=(0,n.$8g)(()=>c()),(async()=>{try{const y=await this.b;this.c=typeof this.c=="number"?this.c:y}catch{}finally{this.b=void 0}})()}f(E){this.b&&(this.b.cancel(),this.b=void 0),this.c=E}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$qbc=M}),define(oe[30],ae([0,1,195,9,59,19,7,6,13]),function(K,e,n,j,P,M,S,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Ci=e.$Bi=e.WorkbenchState=e.$vi=e.$ui=e.$ri=void 0,e.$si=c,e.$ti=p,e.$wi=y,e.$xi=k,e.$yi=g,e.$zi=v,e.$Ai=w,e.$Di=l,e.$Ii=d,e.$Ji=a,e.$Li=t,e.$Mi=o,e.$Ni=r,e.$ri=(0,E.$ii)("contextService");function c(i){const s=i;return typeof s?.id=="string"&&S.URI.isUri(s.uri)}function p(i){return typeof i?.id=="string"&&!c(i)&&!k(i)}e.$ui={id:"ext-dev"},e.$vi={id:"empty-window"};function y(i,s){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,j.$oc)(i)}:s?e.$ui:e.$vi;const u=i;return u.configuration?{id:u.id,configPath:u.configuration}:u.folders.length===1?{id:u.id,uri:u.folders[0].uri}:{id:u.id}}function k(i){const s=i;return typeof s?.id=="string"&&S.URI.isUri(s.configPath)}function g(i){const s=i;if(s?.uri)return{id:s.id,uri:S.URI.revive(s.uri)};const u=i;if(u?.configPath)return{id:u.id,configPath:S.URI.revive(u.configPath)};if(i?.id)return{id:i.id}}var m;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(m||(e.WorkbenchState=m={}));function v(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function w(i){const s=i;return!!(s&&typeof s=="object"&&S.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class ${constructor(s,u,b,C,I){this.h=s,this.j=b,this.k=C,this.l=I,this.c=P.$oi.forUris(this.l,()=>!0),this.folders=u}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=P.$oi.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Bi=$;class f{constructor(s,u){this.raw=u,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,M.$Vg)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ci=f;function l(i){return new f({uri:i,index:0,name:(0,M.$Rg)(i)},{uri:i.toString()})}e.$Ei="code-workspace",e.$Fi=`.${e.$Ei}`,e.$Gi=[{name:(0,n.localize)(0,null),extensions:[e.$Ei]}],e.$Hi="workspace.json";function d(i,s){return M.$Mg.isEqualOrParent(i,s.untitledWorkspacesHome)}function a(i){let s;return S.URI.isUri(i)?s=i:s=i.configuration,s?.scheme===h.Schemas.tmp}e.$Ki="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$Ki}function o(i,s){return!d(i,s)&&!a(i)}function r(i){return(typeof i=="string"?(0,j.$pc)(i):(0,M.$Tg)(i))===e.$Fi}}),define(oe[56],ae([0,1,14,8,46,48,2,86,4,21,169,119,6,5,27,30]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V_b=e.$U_b=void 0,e.$U_b=(0,k.$ii)("dialogMainService");let w=class{constructor(f,l){this.d=f,this.e=l,this.a=new Map,this.b=new Map,this.c=new j.$ph}pickFileFolder(f,l){return this.f({...f,pickFolders:!0,pickFiles:!0,title:(0,p.localize)(0,null)},l)}pickFolder(f,l){return this.f({...f,pickFolders:!0,title:(0,p.localize)(1,null)},l)}pickFile(f,l){return this.f({...f,pickFiles:!0,title:(0,p.localize)(2,null)},l)}pickWorkspace(f,l){const d=(0,p.localize)(3,null),a=(0,M.$nw)((0,p.localize)(4,null)),t=v.$Gi;return this.f({...f,pickFiles:!0,title:d,filters:t,buttonLabel:a},l)}async f(f,l){const d={title:f.title,buttonLabel:f.buttonLabel,filters:f.filters,defaultPath:f.defaultPath};(typeof f.pickFiles=="boolean"||typeof f.pickFolders=="boolean")&&(d.properties=void 0,f.pickFiles&&f.pickFolders&&(d.properties=["multiSelections","openDirectory","openFile","createDirectory"])),d.properties||(d.properties=["multiSelections",f.pickFolders?"openDirectory":"openFile","createDirectory"]),h.$j&&d.properties.push("treatPackageAsDirectory");const a=await this.showOpenDialog(d,(l||n.BrowserWindow.getFocusedWindow())??void 0);if(a&&a.filePaths&&a.filePaths.length>0)return a.filePaths}g(f){if(f){let l=this.b.get(f.id);return l||(l=new j.$ph,this.b.set(f.id,l)),l}else return this.c}showMessageBox(f,l){return this.g(l).queue(async()=>{const{options:d,buttonIndeces:a}=(0,y.$uw)(f,this.e);let t;return l?t=await n.dialog.showMessageBox(l,d):t=await n.dialog.showMessageBox(d),{response:a[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(f,l){const d=this.j(f,l);if(!d)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(l).queue(async()=>{let a;return l?a=await n.dialog.showSaveDialog(l,f):a=await n.dialog.showSaveDialog(f),a.filePath=this.h(a.filePath),a})}finally{(0,S.$Pc)(d)}}h(f){return f&&h.$j&&(f=(0,E.$Zl)(f)),f}i(f){return f.map(l=>this.h(l))}async showOpenDialog(f,l){f.defaultPath&&(await c.Promises.exists(f.defaultPath)||(f.defaultPath=void 0));const d=this.j(f,l);if(!d)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(l).queue(async()=>{let a;return l?a=await n.dialog.showOpenDialog(l,f):a=await n.dialog.showOpenDialog(f),a.filePaths=this.i(a.filePaths),a})}finally{(0,S.$Pc)(d)}}j(f,l){if(!l)return S.$Uc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",f);let d=this.a.get(l.id);d||(d=new Set,this.a.set(l.id,d));const a=(0,P.$9i)(f);if(!d.has(a))return this.d.trace("[DialogMainService]: new file dialog lock created",f),d.add(a),(0,S.$Sc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",f),d?.delete(a),d?.size===0&&this.a.delete(l.id)})}};e.$V_b=w,e.$V_b=w=Ee([ne(0,g.$Oj),ne(1,m.$8j)],w)}),define(oe[279],ae([0,1,3,2,76,30]),function(K,e,n,j,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ac=void 0;class S extends j.$Uc{static{this.a=100}constructor(h,c){super(),this.f=h,this.g=c,this.b=this.B(new n.$7d),this.c=new Map,this.h(c.applicationStorage,this.b)}h(h,c){this.B(n.Event.debounce(h.onDidChangeStorage,(p,y)=>(p?p.push(y):p=[y],p),S.a)(p=>{p.length&&c.fire(this.j(p,h))}))}j(h,c){const p=new Map,y=new Set;return h.forEach(k=>{const g=c.get(k.key);typeof g=="string"?p.set(k.key,g):y.add(k.key)}),{changed:Array.from(p.entries()),deleted:Array.from(y.values())}}listen(h,c,p){switch(c){case"onDidChangeStorage":{const y=p.profile?(0,P.$Rh)(p.profile):void 0;if(!y)return this.b.event;let k=this.c.get(y.id);return k||(k=this.B(new n.$7d),this.h(this.g.profileStorage(y),k),this.c.set(y.id,k)),k.event}}throw new Error(`Event not found: ${c}`)}async call(h,c,p){const y=p.profile?(0,P.$Rh)(p.profile):void 0,k=(0,M.$yi)(p.workspace),g=await this.m(y,k);switch(c){case"getItems":return Array.from(g.items.entries());case"updateItems":{const m=p;if(m.insert)for(const[v,w]of m.insert)g.set(v,w);m.delete?.forEach(v=>g.delete(v));break}case"optimize":return g.optimize();case"isUsed":{const m=p.payload;if(typeof m=="string")return this.g.isUsed(m)}default:throw new Error(`Call not found: ${c}`)}}async m(h,c){let p;c?p=this.g.workspaceStorage(c):h?p=this.g.profileStorage(h):p=this.g.applicationStorage;try{await p.init()}catch(y){this.f.error(`StorageIPC#init: Unable to init ${c?"workspace":h?"profile":"application"} storage due to ${y}`)}return p}}e.$7ac=S}),define(oe[41],ae([0,1,46,3,2,19,7,192,38,16,6,5,30,32,40,8,33,25,12]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g,m,v,w,$,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$rl=e.$ol=e.ProfileResourceType=void 0,e.$nl=d,e.$pl=a,e.$ql=t;var l;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(l||(e.ProfileResourceType=l={}));function d(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&S.URI.isUri(s.location)&&S.URI.isUri(s.globalStorageHome)&&S.URI.isUri(s.settingsResource)&&S.URI.isUri(s.keybindingsResource)&&S.URI.isUri(s.tasksResource)&&S.URI.isUri(s.snippetsHome)&&S.URI.isUri(s.extensionsResource))}e.$ol=(0,p.$ii)("IUserDataProfilesService");function a(i,s){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:S.URI.revive(i.location).with({scheme:s}),globalStorageHome:S.URI.revive(i.globalStorageHome).with({scheme:s}),settingsResource:S.URI.revive(i.settingsResource).with({scheme:s}),keybindingsResource:S.URI.revive(i.keybindingsResource).with({scheme:s}),tasksResource:S.URI.revive(i.tasksResource).with({scheme:s}),snippetsHome:S.URI.revive(i.snippetsHome).with({scheme:s}),extensionsResource:S.URI.revive(i.extensionsResource).with({scheme:s}),cacheHome:S.URI.revive(i.cacheHome).with({scheme:s}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function t(i,s,u,b,C,I){return{id:i,name:s,location:u,isDefault:!1,shortName:C?.shortName,icon:C?.icon,globalStorageHome:I&&C?.useDefaultFlags?.globalState?I.globalStorageHome:(0,M.$Vg)(u,"globalStorage"),settingsResource:I&&C?.useDefaultFlags?.settings?I.settingsResource:(0,M.$Vg)(u,"settings.json"),keybindingsResource:I&&C?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,M.$Vg)(u,"keybindings.json"),tasksResource:I&&C?.useDefaultFlags?.tasks?I.tasksResource:(0,M.$Vg)(u,"tasks.json"),snippetsHome:I&&C?.useDefaultFlags?.snippets?I.snippetsHome:(0,M.$Vg)(u,"snippets"),extensionsResource:I&&C?.useDefaultFlags?.extensions?I.extensionsResource:(0,M.$Vg)(u,"extensions.json"),cacheHome:(0,M.$Vg)(b,i),useDefaultFlags:C?.useDefaultFlags,isTransient:C?.transient}}let o=class extends P.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,u,b,C){super(),this.t=s,this.u=u,this.w=b,this.y=C,this.f=!0,this.h=this.B(new j.$7d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new j.$7d),this.onWillCreateProfile=this.j.event,this.m=this.B(new j.$7d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new j.$7d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new g.$Bc,emptyWindows:new Map},this.profilesHome=(0,M.$Vg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,M.$Vg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),u=[s];if(this.f)try{for(const I of this.O()){if(!I.name||!(0,f.$Vf)(I.name)||!I.location){this.y.warn("Skipping the invalid stored profile",I.location||I.name);continue}u.push(t((0,M.$Sg)(I.location),I.name,I.location,this.g,{shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags},s))}}catch(I){this.y.error(I)}const b=new g.$Bc,C=new Map;if(u.length)try{const I=this.Q();if(I.workspaces)for(const[D,O]of Object.entries(I.workspaces)){const R=S.URI.parse(D),W=u.find(F=>F.id===O);W&&b.set(R,W)}if(I.emptyWindows)for(const[D,O]of Object.entries(I.emptyWindows)){const R=u.find(W=>W.id===O);R&&C.set(D,R)}}catch(I){this.y.error(I)}this.z={profiles:u,workspaces:b,emptyWindows:C}}return this.z}D(){const s=t("__default__profile__",(0,E.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const u="Temp",b=new RegExp(`${(0,$.$Ze)(u)}\\s(\\d+)`);let C=0;for(const D of this.profiles){const O=b.exec(D.name),R=O?parseInt(O[1]):0;C=R>C?R:C}const I=`${u} ${C+1}`;return this.createProfile((0,n.$9i)((0,w.$Eg)()).toString(16),I,{transient:!0},s)}async createNamedProfile(s,u,b){return this.createProfile((0,n.$9i)((0,w.$Eg)()).toString(16),s,u,b)}async createProfile(s,u,b,C){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.F(s,u,b);return C&&await this.setProfileForWorkspace(C,I),I}async F(s,u,b){if(!(0,f.$Vf)(u)||!u)throw new Error("Name of the profile is mandatory and must be of type `string`");let C=this.r.get(u);return C||(C=(async()=>{try{const I=this.profiles.find(R=>R.name===u||R.id===s);if(I)return I;const D=t(s,u,(0,M.$Vg)(this.profilesHome,s),this.g,b,this.defaultProfile);await this.u.createFolder(D.location);const O=[];return this.j.fire({profile:D,join(R){O.push(R)}}),await v.Promises.settled(O),this.I([D],[],[]),D}finally{this.r.delete(u)}})(),this.r.set(u,C)),C}async updateProfile(s,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let b=this.profiles.find(C=>C.id===s.id);if(!b)throw new Error(`Profile '${s.name}' does not exist`);return b=t(b.id,u.name??b.name,b.location,this.g,{shortName:u.shortName??b.shortName,icon:u.icon===null?void 0:u.icon??b.icon,transient:u.transient??b.isTransient,useDefaultFlags:u.useDefaultFlags??b.useDefaultFlags},this.defaultProfile),this.I([],[],[b]),b}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const u=this.profiles.find(C=>C.id===s.id);if(!u)throw new Error(`Profile '${s.name}' does not exist`);const b=[];this.m.fire({profile:u,join(C){b.push(C)}});try{await Promise.allSettled(b)}catch(C){this.y.error(C)}for(const C of[...this.C.emptyWindows.keys()])u.id===this.C.emptyWindows.get(C)?.id&&this.C.emptyWindows.delete(C);for(const C of[...this.C.workspaces.keys()])u.id===this.C.workspaces.get(C)?.id&&this.C.workspaces.delete(C);this.M(),this.I([],[u],[]);try{await this.u.del(u.cacheHome,{recursive:!0})}catch(C){(0,c.$6k)(C)!==1&&this.y.error(C)}}async setProfileForWorkspace(s,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=this.profiles.find(C=>C.id===u.id);if(!b)throw new Error(`Profile '${u.name}' does not exist`);this.L(s,b)}unsetWorkspace(s,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,u)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(u=>u.isDirectory&&this.profiles.every(b=>!this.w.extUri.isEqual(b.location,u.resource))).map(u=>this.u.del(u.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(u=>!this.H(u));await Promise.allSettled(s.map(u=>this.removeProfile(u)))}getProfileForWorkspace(s){const u=this.G(s);return S.URI.isUri(u)?this.s.workspaces.get(u)??this.C.workspaces.get(u):this.s.emptyWindows.get(u)??this.C.emptyWindows.get(u)}G(s){return(0,k.$si)(s)?s.uri:(0,k.$xi)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,s.location))||[...this.s.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,s.location))||[...this.C.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,s.location))||[...this.C.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,s.location)))}I(s,u,b){const C=[...this.profiles,...s],I=[];this.s.profiles=[];for(let D of C)D.isDefault||u.some(O=>D.id===O.id)||(D=b.find(O=>D.id===O.id)??D,D.isTransient?this.s.profiles.push(D):I.push({location:D.location,name:D.name,shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags}));this.P(I),this.z=void 0,this.J(s,u,b)}J(s,u,b){this.h.fire({added:s,removed:u,updated:b,all:this.profiles})}L(s,u,b){b=u?.isTransient?!0:b,b||this.L(s,void 0,!0);const C=this.G(s),I=b?this.s:this.C;S.URI.isUri(C)?(I.workspaces.delete(C),u&&I.workspaces.set(C,u)):(I.emptyWindows.delete(C),u&&I.emptyWindows.set(C,u)),b||this.M()}M(){const s={};for(const[b,C]of this.C.workspaces.entries())s[b.toString()]=C.id;const u={};for(const[b,C]of this.C.emptyWindows.entries())u[b.toString()]=C.id;this.R({workspaces:s,emptyWindows:u}),this.z=void 0}N(s){const u={},b=this.D();if(s.workspaces)for(const[I,D]of Object.entries(s.workspaces)){const O=S.URI.parse(D);u[I]=this.w.extUri.isEqual(O,b.location)?b.id:this.w.extUri.basename(O)}const C={};if(s.emptyWindows)for(const[I,D]of Object.entries(s.emptyWindows)){const O=S.URI.parse(D);C[I]=this.w.extUri.isEqual(O,b.location)?b.id:this.w.extUri.basename(O)}return{workspaces:u,emptyWindows:C}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$rl=o,e.$rl=o=Ee([ne(0,h.$pi),ne(1,c.$Ok),ne(2,m.$ml),ne(3,y.$Oj)],o);class r extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$sl=r}),define(oe[82],ae([0,1,8,17,2,3,32,7,121,127,16,6,5,41,40,12,15,28]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g,m,v,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=e.$aq=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class l extends Error{constructor(r,i){super(r),this.code=i}}e.$aq=l,e.$bq=(0,y.$ii)("IExtensionsProfileScannerService");let d=class extends P.$Uc{constructor(r,i,s,u,b,C){super(),this.j=r,this.m=i,this.n=s,this.r=u,this.s=b,this.t=C,this.b=this.B(new M.$7d),this.onAddExtensions=this.b.event,this.c=this.B(new M.$7d),this.onDidAddExtensions=this.c.event,this.f=this.B(new M.$7d),this.onRemoveExtensions=this.f.event,this.g=this.B(new M.$7d),this.onDidRemoveExtensions=this.g.event,this.h=new S.$Bc}scanProfileExtensions(r,i){return this.u(r,void 0,i)}async addExtensionsToProfile(r,i,s){const u=[],b=[];try{return await this.u(i,C=>{const I=[];if(s)I.push(...C);else for(const D of C)r.some(([O])=>(0,c.$gp)(O.identifier,D.identifier)&&O.manifest.version!==D.version)?u.push(D):I.push(D);for(const[D,O]of r){const R=I.findIndex(F=>(0,c.$gp)(F.identifier,D.identifier)&&F.version===D.manifest.version),W={identifier:D.identifier,version:D.manifest.version,location:D.location,metadata:O};R===-1?(b.push(W),I.push(W)):I.splice(R,1,W)}return b.length&&this.b.fire({extensions:b,profileLocation:i}),u.length&&this.f.fire({extensions:u,profileLocation:i}),I}),b.length&&this.c.fire({extensions:b,profileLocation:i}),u.length&&this.g.fire({extensions:u,profileLocation:i}),b}catch(C){throw b.length&&this.c.fire({extensions:b,error:C,profileLocation:i}),u.length&&this.g.fire({extensions:u,error:C,profileLocation:i}),C}}async updateMetadata(r,i){const s=[];return await this.u(i,u=>{const b=[];for(const C of u){const I=r.find(([D])=>(0,c.$gp)(D.identifier,C.identifier)&&D.manifest.version===C.version);I&&(C.metadata={...C.metadata,...I[1]},s.push(C)),b.push(C)}return b}),s}async removeExtensionFromProfile(r,i){const s=[];try{await this.u(i,u=>{const b=[];for(const C of u)(0,c.$gp)(C.identifier,r.identifier)?s.push(C):b.push(C);return s.length&&this.f.fire({extensions:s,profileLocation:i}),b}),s.length&&this.g.fire({extensions:s,profileLocation:i})}catch(u){throw s.length&&this.g.fire({extensions:s,error:u,profileLocation:i}),u}}async u(r,i,s){return this.F(r).queue(async()=>{let u=[],b;try{const C=await this.m.readFile(r);b=JSON.parse(C.value.toString().trim()||"[]")}catch(C){if((0,p.$6k)(C)!==1)throw C;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(b=await this.D()),!b&&s?.bailOutWhenFileNotFound)throw new l((0,w.$0)(C),"ERROR_PROFILE_NOT_FOUND")}if(b){Array.isArray(b)||this.w(r);let C=!1;for(const I of b){a(I)||this.w(r);let D;if((0,v.$Vf)(I.relativeLocation)&&I.relativeLocation)D=this.z(I.relativeLocation);else if((0,v.$Vf)(I.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${I.location}`);continue}else{D=E.URI.revive(I.location);const O=this.y(D);O&&(C=!0,I.relativeLocation=O)}(0,v.$3f)(I.metadata?.hasPreReleaseVersion)&&I.metadata?.preRelease&&(C=!0,I.metadata.hasPreReleaseVersion=!0),u.push({identifier:I.identifier,location:D,version:I.version,metadata:I.metadata})}C&&await this.m.writeFile(r,j.$ue.fromString(JSON.stringify(b)))}if(i){u=i(u);const C=u.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.y(I.location),metadata:I.metadata}));await this.m.writeFile(r,j.$ue.fromString(JSON.stringify(C)))}return u})}w(r){const i=new l(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(r)).value.toString()}catch(b){if((0,p.$6k)(b)===1)return;throw b}this.t.info("Migrating extensions from old default profile location",r.toString());let u;try{const b=JSON.parse(s);Array.isArray(b)&&b.every(C=>a(C))?u=b:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",b)}catch(b){this.t.error(b)}if(u)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,j.$ue.fromString(JSON.stringify(u)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(b){if((0,p.$6k)(b)===3)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw b}try{await this.m.del(r)}catch(b){(0,p.$6k)(b)!==1&&this.t.error(b)}try{await this.m.del(i)}catch(b){(0,p.$6k)(b)!==1&&this.t.error(b)}return u})()),this.C}F(r){let i=this.h.get(r);return i||(i=new n.$ph,this.h.set(r,i)),i}};e.$cq=d,e.$cq=d=Ee([ne(1,p.$Ok),ne(2,g.$ol),ne(3,m.$ml),ne(4,$.$Nl),ne(5,k.$Oj)],d);function a(o){return(0,v.$Xf)(o)&&(0,h.$Qo)(o.identifier)&&(t(o.location)||(0,v.$Vf)(o.location)&&o.location)&&((0,v.$3f)(o.relativeLocation)||(0,v.$Vf)(o.relativeLocation))&&o.version&&(0,v.$Vf)(o.version)}function t(o){return o?(0,v.$Vf)(o.path)&&(0,v.$Vf)(o.scheme):!1}}),define(oe[132],ae([0,1,22,8,35,17,15,42,154,2,13,9,4,19,208,73,12,7,174,38,127,124,207,16,6,5,27,3,76,82,41,40,206]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g,m,v,w,$,f,l,d,a,t,o,r,i,s,u,b,C,I,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$hq=e.$gq=e.$fq=e.Translations=void 0,e.$iq=le;var R;(function(ue){function Y(Z,B){if(Z===B)return!0;const L=Object.keys(Z),T=new Set;for(const G of Object.keys(B))T.add(G);if(L.length!==T.size)return!1;for(const G of L){if(Z[G]!==B[G])return!1;T.delete(G)}return T.size===0}ue.equals=Y})(R||(e.Translations=R={})),e.$fq=(0,r.$ii)("IExtensionsScannerService");let W=class extends c.$Uc{constructor(Y,Z,B,L,T,G,z,ce,he,X,A,N){super(),this.systemExtensionsLocation=Y,this.userExtensionsLocation=Z,this.r=B,this.s=L,this.t=T,this.u=G,this.w=z,this.y=ce,this.z=he,this.C=X,this.D=A,this.F=N,this.g=this.B(new u.$7d),this.onDidChangeCache=this.g.event,this.h=(0,g.$Vg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(x,this.s,this.h)),this.m=this.B(this.F.createInstance(x,this.s,this.h)),this.n=this.B(this.F.createInstance(q,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,d.$rp)(this.w,this.y)),this.G}async scanAllExtensions(Y,Z,B){const[L,T]=await Promise.all([this.scanSystemExtensions(Y),this.scanUserExtensions(Z)]),G=B?await this.scanExtensionsUnderDevelopment(Y,[...L,...T]):[];return this.L(L,T,G,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Y){const Z=[];Z.push(this.M(!!Y.useCache,Y.language)),Z.push(this.N(Y.language,!!Y.checkControlFile));const[B,L]=await Promise.all(Z);return this.J([...B,...L],0,Y,!1)}async scanUserExtensions(Y){const Z=Y.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Z);const B=this.D.extUri.isEqual(Y.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,L=await this.P(Z,!!Y.profileLocation,1,!Y.includeUninstalled,Y.language,!0,B,Y.productVersion??this.R()),T=Y.useCache&&!L.devMode&&L.excludeObsolete?this.m:this.n;let G;try{G=await T.scanExtensions(L)}catch(z){if(z instanceof C.$aq&&z.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),G=await T.scanExtensions(L);else throw z}return G=await this.J(G,1,Y,!0),this.y.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(Y,Z){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const B=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(L=>L.scheme===p.Schemas.file).map(async L=>{const T=await this.P(L,!1,1,!0,Y.language,!1,void 0,Y.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(T)).map(z=>(z.type=Z.find(ce=>(0,d.$gp)(ce.identifier,z.identifier))?.type??z.type,this.n.validate(z,T)))}))).flat();return this.J(B,"development",Y,!0)}return[]}async scanExistingExtension(Y,Z,B){const L=await this.P(Y,!1,Z,!0,B.language,!0,void 0,B.productVersion??this.R()),T=await this.n.scanExtension(L);return!T||!B.includeInvalid&&!T.isValid?null:T}async scanOneOrMultipleExtensions(Y,Z,B){const L=await this.P(Y,!1,Z,!0,B.language,!0,void 0,B.productVersion??this.R()),T=await this.n.scanOneOrMultipleExtensions(L);return this.J(T,Z,B,!0)}async scanMultipleExtensions(Y,Z,B){const L=[];return await Promise.all(Y.map(async T=>{const G=await this.scanOneOrMultipleExtensions(T,Z,B);L.push(...G)})),this.J(L,Z,B,!0)}async scanMetadata(Y){const Z=(0,g.$Vg)(Y,"package.json"),B=(await this.w.readFile(Z)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(Y,Z){const B=(0,g.$Vg)(Y,"package.json"),L=(await this.w.readFile(B)).value.toString(),T=JSON.parse(L);Z.isMachineScoped===!1&&delete Z.isMachineScoped,Z.isBuiltin===!1&&delete Z.isBuiltin,T.__metadata={...T.__metadata,...Z},await this.w.writeFile((0,g.$Vg)(Y,"package.json"),M.$ue.fromString(JSON.stringify(T,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Y){if(Y instanceof C.$aq&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw Y}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Y=await this.scanUserExtensions({includeInvalid:!0});if(Y.length)await this.u.addExtensionsToProfile(Y.map(Z=>[Z,Z.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,M.$ue.fromString(JSON.stringify([])))}catch(Z){(0,o.$6k)(Z)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,S.$0)(Z))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Y){this.y.error(Y)}finally{this.H=void 0}})()),this.H}async J(Y,Z,B,L){return B.includeAllVersions||(Y=this.L(Z===0?Y:void 0,Z===1?Y:void 0,Z==="development"?Y:void 0,await this.getTargetPlatform(),L)),B.includeInvalid||(Y=Y.filter(T=>T.isValid)),Y.sort((T,G)=>{const z=y.$oc(T.location.fsPath),ce=y.$oc(G.location.fsPath);return z<ce?-1:z>ce?1:0})}L(Y,Z,B,L,T){const G=(ce,he,X)=>{if(ce.isValid&&!he.isValid)return!1;if(ce.isValid===he.isValid){if(T&&m.gt(ce.manifest.version,he.manifest.version))return this.y.debug(`Skipping extension ${he.location.path} with lower version ${he.manifest.version} in favour of ${ce.location.path} with version ${ce.manifest.version}`),!1;if(m.eq(ce.manifest.version,he.manifest.version)){if(ce.type===0)return this.y.debug(`Skipping extension ${he.location.path} in favour of system extension ${ce.location.path} with same version`),!1;if(ce.targetPlatform===L)return this.y.debug(`Skipping extension ${he.location.path} from different target platform ${he.targetPlatform}`),!1}}return X?this.y.warn(`Overwriting user extension ${ce.location.path} with ${he.location.path}.`):this.y.debug(`Overwriting user extension ${ce.location.path} with ${he.location.path}.`),!0},z=new a.$Fm;return Y?.forEach(ce=>{const he=z.get(ce.identifier.id);(!he||G(he,ce,!1))&&z.set(ce.identifier.id,ce)}),Z?.forEach(ce=>{const he=z.get(ce.identifier.id);if(!he&&Y&&ce.type===0){this.y.debug(`Skipping obsolete system extension ${ce.location.path}.`);return}(!he||G(he,ce,!1))&&z.set(ce.identifier.id,ce)}),B?.forEach(ce=>{const he=z.get(ce.identifier.id);(!he||G(he,ce,!0))&&z.set(ce.identifier.id,ce),z.set(ce.identifier.id,ce)}),[...z.values()]}async M(Y,Z){this.y.trace("Started scanning system extensions");const B=await this.P(this.systemExtensionsLocation,!1,0,!0,Z,!0,void 0,this.R()),T=await(Y&&!B.devMode?this.j:this.n).scanExtensions(B);return this.y.trace("Scanned system extensions:",T.length),T}async N(Y,Z){const B=this.z.isBuilt?[]:this.C.builtInExtensions;if(!B?.length)return[];this.y.trace("Started scanning dev system extensions");const L=Z?await this.O():{},T=[],G=$.URI.file(y.$ic(y.$kc(p.$Cg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ce of B){const he=L[ce.name]||"marketplace";switch(he){case"disabled":break;case"marketplace":T.push((0,g.$Vg)(G,ce.name));break;default:T.push($.URI.file(he));break}}const z=await Promise.all(T.map(async ce=>this.n.scanExtension(await this.P(ce,!1,0,!0,Y,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",z.length),(0,n.$Hb)(z)}async O(){try{const Y=await this.w.readFile(this.r);return JSON.parse(Y.value.toString())}catch{return{}}}async P(Y,Z,B,L,T,G,z,ce){const he=await this.f(T??k.$w),X=await this.Q(Y),A=Z&&!this.D.extUri.isEqual(Y,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,N=A?await this.Q(A):void 0;return new F(Y,X,A,N,Z,z,B,L,G,ce.version,ce.date,this.C.commit,!this.z.isBuilt,T,he)}async Q(Y){try{const Z=await this.w.stat(Y);if(typeof Z.mtime=="number")return Z.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$gq=W,e.$gq=W=Ee([ne(4,I.$ol),ne(5,C.$bq),ne(6,o.$Ok),ne(7,i.$Oj),ne(8,l.$pi),ne(9,s.$8j),ne(10,D.$ml),ne(11,r.$hi)],W);class F{constructor(Y,Z,B,L,T,G,z,ce,he,X,A,N,_,se,J){this.location=Y,this.mtime=Z,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=L,this.profile=T,this.profileScanOptions=G,this.type=z,this.excludeObsolete=ce,this.validate=he,this.productVersion=X,this.productDate=A,this.productCommit=N,this.devMode=_,this.language=se,this.translations=J}static createNlsConfiguration(Y){return{language:Y.language,pseudo:Y.language==="pseudo",devMode:Y.devMode,translations:Y.translations}}static equals(Y,Z){return(0,g.$Og)(Y.location,Z.location)&&Y.mtime===Z.mtime&&(0,g.$Og)(Y.applicationExtensionslocation,Z.applicationExtensionslocation)&&Y.applicationExtensionslocationMtime===Z.applicationExtensionslocationMtime&&Y.profile===Z.profile&&P.$Sn(Y.profileScanOptions,Z.profileScanOptions)&&Y.type===Z.type&&Y.excludeObsolete===Z.excludeObsolete&&Y.validate===Z.validate&&Y.productVersion===Z.productVersion&&Y.productDate===Z.productDate&&Y.productCommit===Z.productCommit&&Y.devMode===Z.devMode&&Y.language===Z.language&&R.equals(Y.translations,Z.translations)}}e.$hq=F;let q=class extends c.$Uc{constructor(Y,Z,B,L,T){super(),this.f=Y,this.g=Z,this.h=B,this.j=L,this.m=T}async scanExtensions(Y){const Z=Y.profile?await this.r(Y):await this.n(Y);let B={};if(Y.excludeObsolete&&Y.type===1)try{const L=(await this.j.readFile(this.f)).value.toString();B=JSON.parse(L)}catch{}return(0,w.$9f)(B)?Z:Z.filter(L=>!B[d.$hp.create(L).toString()])}async n(Y){const Z=await this.j.resolve(Y.location);if(!Z.children?.length)return[];const B=await Promise.all(Z.children.map(async L=>{if(!L.isDirectory||Y.type===1&&(0,g.$Sg)(L.resource).indexOf(".")===0)return null;const T=new F(L.resource,Y.mtime,Y.applicationExtensionslocation,Y.applicationExtensionslocationMtime,Y.profile,Y.profileScanOptions,Y.type,Y.excludeObsolete,Y.validate,Y.productVersion,Y.productDate,Y.productCommit,Y.devMode,Y.language,Y.translations);return this.scanExtension(T)}));return(0,n.$Hb)(B).sort((L,T)=>L.location.path<T.location.path?-1:1)}async r(Y){let Z=await this.s(Y.location,()=>!0,Y);if(Y.applicationExtensionslocation&&!this.h.extUri.isEqual(Y.location,Y.applicationExtensionslocation)){Z=Z.filter(L=>!L.metadata?.isApplicationScoped);const B=await this.s(Y.applicationExtensionslocation,L=>!!L.metadata?.isBuiltin||!!L.metadata?.isApplicationScoped,Y);Z.push(...B)}return Z}async s(Y,Z,B){const L=await this.g.scanProfileExtensions(Y,B.profileScanOptions);if(!L.length)return[];const T=await Promise.all(L.map(async G=>{if(Z(G)){const z=new F(G.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(z,G.metadata)}return null}));return(0,n.$Hb)(T)}async scanOneOrMultipleExtensions(Y){try{if(await this.j.exists((0,g.$Vg)(Y.location,"package.json"))){const Z=await this.scanExtension(Y);return Z?[Z]:[]}else return await this.scanExtensions(Y)}catch(Z){return this.m.error(`Error scanning extensions at ${Y.location.path}:`,(0,S.$0)(Z)),[]}}async scanExtension(Y,Z){try{let B=await this.scanExtensionManifest(Y.location);if(B){B.publisher||(B.publisher=a.$zm),Z=Z??B.__metadata,delete B.__metadata;const L=(0,d.$lp)(B.publisher,B.name),T=Z?.id?{id:L,uuid:Z.id}:{id:L},G=Z?.isSystem?0:Y.type,z=G===0||!!Z?.isBuiltin;B=await this.t(Y.location,B,F.createNlsConfiguration(Y));const ce={type:G,identifier:T,manifest:B,location:Y.location,isBuiltin:z,targetPlatform:Z?.targetPlatform??"undefined",metadata:Z,isValid:!0,validations:[]};return Y.validate?this.validate(ce,Y):ce}}catch(B){Y.type!==0&&this.m.error(B)}return null}validate(Y,Z){let B=!0;const L=(0,t.$wp)(Z.productVersion,Z.productDate,Z.location,Y.manifest,Y.isBuiltin);for(const[T,G]of L)T===v.default.Error&&(B=!1,this.m.error(this.z(Z.location,G)));return Y.isValid=B,Y.validations=L,Y}async scanExtensionManifest(Y){const Z=(0,g.$Vg)(Y,"package.json");let B;try{B=(await this.j.readFile(Z)).value.toString()}catch(T){return(0,o.$6k)(T)!==1&&this.m.error(this.z(Y,(0,f.localize)(0,null,Z.path,T.message))),null}let L;try{L=JSON.parse(B)}catch{const G=[];(0,E.$vn)(B,G);for(const z of G)this.m.error(this.z(Y,(0,f.localize)(1,null,Z.path,z.offset,z.length,(0,h.$dq)(z.error))));return null}return(0,E.$En)(L)!=="object"?(this.m.error(this.z(Y,(0,f.localize)(2,null,Z.path))),null):L}async t(Y,Z,B){const L=await this.u(Y,Z,B);if(L)try{const T=[],G=await this.w(L.default,T);if(T.length>0)return T.forEach(ce=>{this.m.error(this.z(Y,(0,f.localize)(3,null,L.default?.path,(0,h.$dq)(ce.error))))}),Z;if((0,E.$En)(L)!=="object")return this.m.error(this.z(Y,(0,f.localize)(4,null,L.default?.path))),Z;const z=L.values||Object.create(null);return(0,O.$eq)(this.m,Z,z,G)}catch{}return Z}async u(Y,Z,B){const L=(0,g.$Vg)(Y,"package.nls.json"),T=(he,X)=>{X.forEach(A=>{this.m.error(this.z(Y,(0,f.localize)(5,null,he?.path,(0,h.$dq)(A.error))))})},G=he=>{this.m.error(this.z(Y,(0,f.localize)(6,null,he?.path)))},z=`${Z.publisher}.${Z.name}`,ce=B.translations[z];if(ce)try{const he=$.URI.file(ce),X=(await this.j.readFile(he)).value.toString(),A=[],N=(0,E.$vn)(X,A);return A.length>0?(T(he,A),{values:void 0,default:L}):(0,E.$En)(N)!=="object"?(G(he),{values:void 0,default:L}):{values:N.contents?N.contents.package:void 0,default:L}}catch{return{values:void 0,default:L}}else{if(!await this.j.exists(L))return;let X;try{X=await this.y(Y,B)}catch{return}if(!X.localized)return{values:void 0,default:X.original};try{const A=(await this.j.readFile(X.localized)).value.toString(),N=[],_=(0,E.$vn)(A,N);return N.length>0?(T(X.localized,N),{values:void 0,default:X.original}):(0,E.$En)(_)!=="object"?(G(X.localized),{values:void 0,default:X.original}):{values:_,default:X.original}}catch{return{values:void 0,default:X.original}}}}async w(Y,Z){if(Y)try{const B=(await this.j.readFile(Y)).value.toString();return(0,E.$vn)(B,Z)}catch{}}y(Y,Z){return new Promise((B,L)=>{const T=G=>{const z=(0,g.$Vg)(Y,`package.nls.${G}.json`);this.j.exists(z).then(ce=>{ce&&B({localized:z,original:(0,g.$Vg)(Y,"package.nls.json")});const he=G.lastIndexOf("-");he===-1?B({localized:(0,g.$Vg)(Y,"package.nls.json"),original:null}):(G=G.substring(0,he),T(G))})};if(Z.devMode||Z.pseudo||!Z.language)return B({localized:(0,g.$Vg)(Y,"package.nls.json"),original:null});T(Z.language)})}z(Y,Z){return`[${Y.path}]: ${Z}`}};q=Ee([ne(1,C.$bq),ne(2,D.$ml),ne(3,o.$Ok),ne(4,i.$Oj)],q);let x=class extends q{constructor(Y,Z,B,L,T,G,z){super(Z,L,T,G,z),this.G=Y,this.H=B,this.D=this.B(new j.$gh(3e3)),this.F=this.B(new u.$7d),this.onDidChangeCache=this.F.event}async scanExtensions(Y){const Z=this.M(Y),B=await this.I(Z);if(this.C=Y,B&&B.input&&F.equals(B.input,this.C))return this.m.debug("Using cached extensions scan result",Y.location.toString()),this.D.trigger(()=>this.L()),B.result.map(T=>(T.location=$.URI.revive(T.location),T));const L=await super.scanExtensions(Y);return await this.J(Z,{input:Y,result:L}),L}async I(Y){try{const Z=await this.j.readFile(Y),B=JSON.parse(Z.value.toString());return{result:B.result,input:(0,b.$Rh)(B.input)}}catch(Z){this.m.debug("Error while reading the extension cache file:",Y.path,(0,S.$0)(Z))}return null}async J(Y,Z){try{await this.j.writeFile(Y,M.$ue.fromString(JSON.stringify(Z)))}catch(B){this.m.debug("Error while writing the extension cache file:",Y.path,(0,S.$0)(B))}}async L(){if(!this.C)return;const Y=this.M(this.C),Z=await this.I(Y);if(!Z)return;const B=Z.result,L=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!P.$Sn(L,B))try{this.m.info("Invalidating Cache",B,L),await this.j.del(Y),this.F.fire()}catch(T){this.m.error(T)}}M(Y){const Z=this.N(Y);return this.h.extUri.joinPath(Z.cacheHome,Y.type===0?a.$ym:a.$xm)}N(Y){return Y.type===0?this.H.defaultProfile:Y.profile?this.h.extUri.isEqual(Y.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Z=>this.h.extUri.isEqual(Y.location,Z.extensionsResource))??this.G:this.H.defaultProfile}};x=Ee([ne(2,I.$ol),ne(3,C.$bq),ne(4,D.$ml),ne(5,o.$Ok),ne(6,i.$Oj)],x);function le(ue,Y){const Z=(0,d.$jp)(ue.manifest.publisher,ue.manifest.name);return{id:Z,identifier:new a.$Dm(Z),isBuiltin:ue.type===0,isUserBuiltin:ue.type===1&&ue.isBuiltin,isUnderDevelopment:Y,extensionLocation:ue.location,uuid:ue.identifier.uuid,targetPlatform:ue.targetPlatform,...ue.manifest}}class te extends W{constructor(Y,Z,B,L,T,G,z,ce,he,X,A,N){super(Y,Z,(0,g.$Vg)(B,".vscode-oss-dev","extensions","control.json"),L,T,G,z,ce,he,X,A,N),this.S=(async()=>{if(k.$z)try{const _=await this.w.readFile($.URI.file(k.$z));return JSON.parse(_.value.toString())}catch{}return Object.create(null)})()}f(Y){return this.S}}e.$jq=te}),define(oe[280],ae([0,1,5,41,40,28,82,16,38,7]),function(K,e,n,j,P,M,S,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4P=void 0;let p=class extends S.$cq{constructor(k,g,m,v,w,$){super(c.URI.file(k.extensionsPath),g,m,v,w,$)}};e.$4P=p,e.$4P=p=Ee([ne(0,h.$qi),ne(1,E.$Ok),ne(2,j.$ol),ne(3,P.$ml),ne(4,M.$Nl),ne(5,n.$Oj)],p)}),define(oe[281],ae([0,1,7,38,82,132,16,6,5,27,40,41]),function(K,e,n,j,P,M,S,E,h,c,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ubc=void 0;let k=class extends M.$jq{constructor(m,v,w,$,f,l,d,a){super(n.URI.file(f.builtinExtensionsPath),n.URI.file(f.extensionsPath),f.userHome,m.defaultProfile,m,v,w,$,f,l,d,a)}};e.$ubc=k,e.$ubc=k=Ee([ne(0,y.$ol),ne(1,P.$bq),ne(2,S.$Ok),ne(3,h.$Oj),ne(4,j.$qi),ne(5,c.$8j),ne(6,p.$ml),ne(7,E.$hi)],k)}),define(oe[282],ae([0,1,14,2,13,9,4,59,7,33,37,38,5,41]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mbc=void 0;let m=class extends j.$Uc{constructor(w,$,f){super(),this.c=w,this.f=f,this.a=E.$oi.forPaths(!S.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(w.appRoot),this.addValidFileRoot(w.extensionsPath),this.addValidFileRoot($.defaultProfile.globalStorageHome.with({scheme:P.Schemas.file}).fsPath),this.addValidFileRoot(w.workspaceStorageHome.with({scheme:P.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:w}=n.session;w.protocol.registerFileProtocol(P.Schemas.vscodeFileResource,($,f)=>this.j($,f)),w.protocol.interceptFileProtocol(P.Schemas.file,($,f)=>this.h($,f)),this.B((0,j.$Sc)(()=>{w.protocol.unregisterProtocol(P.Schemas.vscodeFileResource),w.protocol.uninterceptProtocol(P.Schemas.file)}))}addValidFileRoot(w){const $=(0,M.$ic)(w);return this.a.get($)?j.$Uc.None:(this.a.set($,!0),(0,j.$Sc)(()=>this.a.delete($)))}h(w,$){const f=h.URI.parse(w.url);return this.f.error(`Refused to load resource ${f.fsPath} from ${P.Schemas.file}: protocol (original URL: ${w.url})`),$({error:-3})}j(w,$){const f=this.m(w);let l;return this.c.crossOriginIsolated&&((0,M.$oc)(f)==="workbench.html"||(0,M.$oc)(f)==="workbench-dev.html"?l=P.COI.CoopAndCoep:l=P.COI.getHeadersFromQuery(w.url)),this.a.findSubstr(f)?$({path:f,headers:l}):this.b.has((0,M.$pc)(f).toLowerCase())?$({path:f}):(this.f.error(`${P.Schemas.vscodeFileResource}: Refused to load resource ${f} from ${P.Schemas.vscodeFileResource}: protocol (original URL: ${w.url})`),$({error:-3}))}m(w){const $=h.URI.parse(w.url),f=P.$Cg.uriToFileUri($);return(0,M.$ic)(f.fsPath)}createIPCObjectUrl(){let w;const $=h.URI.from({scheme:"vscode",path:(0,c.$Eg)()}),f=$.toString(),l=async()=>w;return p.$5V.handle(f,l),this.f.trace(`IPC Object URL: Registered new channel ${f}.`),{resource:$,update:d=>w=d,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${f}.`),p.$5V.removeHandler(f)}}}};e.$Mbc=m,e.$Mbc=m=Ee([ne(0,y.$qi),ne(1,g.$ol),ne(2,k.$Oj)],m)}),define(oe[97],ae([0,1,8,3,2,66,12,115,6,41]),function(K,e,n,j,P,M,S,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=e.$Op=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Mp=e.$Lp=e.$Kp=void 0,e.$Np=g,e.$Pp=v,e.$Rp=$,e.$Kp="__$__isNewStorageMarker",e.$Lp="__$__targetStorageMarker",e.$Mp=(0,h.$ii)("storageService");var p;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(p||(e.WillSaveStateReason=p={}));var y;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var k;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(k||(e.StorageTarget=k={}));function g(f){const l=f.get(e.$Lp);if(l)try{return JSON.parse(l)}catch{}return Object.create(null)}class m extends P.$Uc{static{this.a=60*1e3}constructor(l={flushInterval:m.a}){super(),this.m=l,this.b=this.B(new j.$0d),this.c=this.B(new j.$0d),this.onDidChangeTarget=this.c.event,this.f=this.B(new j.$7d),this.onWillSaveState=this.f.event,this.h=this.B(new n.$uh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new P.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(l,d,a){return j.Event.filter(this.b.event,t=>t.scope===l&&(d===void 0||t.key===d),a)}n(){this.j.value=(0,n.$yh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,P.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.O()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(l,d){const{key:a,external:t}=d;if(a===e.$Lp){switch(l){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:l})}else this.b.fire({scope:l,key:a,target:this.J(l)[a],external:t})}w(l){this.f.fire({reason:l})}get(l,d,a){return this.P(d)?.get(l,a)}getBoolean(l,d,a){return this.P(d)?.getBoolean(l,a)}getNumber(l,d,a){return this.P(d)?.getNumber(l,a)}getObject(l,d,a){return this.P(d)?.getObject(l,a)}storeAll(l,d){this.y(()=>{for(const a of l)this.store(a.key,a.value,a.scope,a.target,d)})}store(l,d,a,t,o=!1){if((0,S.$5f)(d)){this.remove(l,a,o);return}this.y(()=>{this.z(l,a,t),this.P(a)?.set(l,d,o)})}remove(l,d,a=!1){this.y(()=>{this.z(l,d,void 0),this.P(d)?.delete(l,a)})}y(l){this.b.pause(),this.c.pause();try{l()}finally{this.b.resume(),this.c.resume()}}keys(l,d){const a=[],t=this.J(l);for(const o of Object.keys(t))t[o]===d&&a.push(o);return a}z(l,d,a,t=!1){const o=this.J(d);typeof a=="number"?o[l]!==a&&(o[l]=a,this.P(d)?.set(e.$Lp,JSON.stringify(o),t)):typeof o[l]=="number"&&(delete o[l],this.P(d)?.set(e.$Lp,JSON.stringify(o),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(l){switch(l){case-1:return this.I;case 0:return this.G;default:return this.D}}L(l){const d=this.P(l);return d?g(d):Object.create(null)}isNew(l){return this.getBoolean(e.$Kp,l)===!0}async flush(l=p.NONE){this.f.fire({reason:l});const d=this.P(-1),a=this.P(0),t=this.P(1);switch(l){case p.NONE:await n.Promises.settled([d?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case p.SHUTDOWN:await n.Promises.settled([d?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const l=this.P(-1)?.items??new Map,d=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return $(l,d,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(l){return await this.flush(),this.P(l)?.optimize()}async switch(l,d){return this.w(p.NONE),(0,c.$nl)(l)?this.R(l,d):this.S(l,d)}M(l,d){return!(l.id===d.id||v(d)&&v(l))}N(l,d,a){this.y(()=>{const t=new Set;for(const[o,r]of l)t.add(o),d.get(o)!==r&&this.u(a,{key:o,external:!0});for(const[o]of d.items)t.has(o)||this.u(a,{key:o,external:!0})})}}e.$Op=m;function v(f){return f.isDefault||!!f.useDefaultFlags?.globalState}class w extends m{constructor(){super(),this.U=this.B(new E.$Ip(new E.$Jp,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new E.$Ip(new E.$Jp,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new E.$Ip(new E.$Jp,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(l=>this.u(1,l))),this.B(this.W.onDidChangeStorage(l=>this.u(0,l))),this.B(this.U.onDidChangeStorage(l=>this.u(-1,l)))}P(l){switch(l){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(l){switch(l){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(l){return!1}}e.$Qp=w;async function $(f,l,d,a,t,o){const r=R=>{try{return JSON.parse(R)}catch{return R}},i=new Map,s=new Map;f.forEach((R,W)=>{i.set(W,R),s.set(W,r(R))});const u=new Map,b=new Map;l.forEach((R,W)=>{u.set(W,R),b.set(W,r(R))});const C=new Map,I=new Map;d.forEach((R,W)=>{C.set(W,R),I.set(W,r(R))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const D=[];if(i.forEach((R,W)=>{D.push({key:W,value:R})}),console.table(D),console.groupEnd(),console.log(s),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const R=[];u.forEach((W,F)=>{R.push({key:F,value:W})}),console.table(R),console.groupEnd(),console.log(b)}console.group(`Storage: Workspace (path: ${o})`);const O=[];C.forEach((R,W)=>{O.push({key:W,value:R})}),console.table(O),console.groupEnd(),console.log(I)}}),define(oe[283],ae([0,1,22,8,3,2,9,72,7,21,115,163,5,97,28,30,13]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g,m,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lac=e.$kac=e.$jac=e.$iac=void 0;class $ extends M.$Uc{static{this.a=2e3}get storage(){return this.f}constructor(r,i){super(),this.m=r,this.n=i,this.b=this.B(new P.$7d),this.onDidChangeStorage=this.b.event,this.c=this.B(new P.$7d),this.onDidCloseStorage=this.c.event,this.f=this.B(new p.$Ip(new p.$Jp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new j.$Fh,this.whenInit=this.h.p,this.j=p.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===p.StorageState.None)try{const r=this.B(await this.t());this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(s=>this.b.fire(s))),await this.s(r);const i=r.getBoolean(g.$Kp);i===void 0?r.set(g.$Kp,!0):i&&r.set(g.$Kp,!1)}catch(r){this.m.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.j=p.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===k.LogLevel.Trace?r=>this.m.trace(r):void 0,logError:r=>this.m.error(r)}}s(r){return r.init()}get items(){return this.f.items}get(r,i){return this.f.get(r,i)}set(r,i){return this.f.set(r,i)}delete(r){return this.f.delete(r)}optimize(){return this.f.optimize()}async close(){const r=new E.$3d(!1);await this.w(),r.stop(),r.elapsed()>$.a&&await this.u(r),this.c.fire()}async u(r){if(this.path)try{const i=(0,n.top)(Array.from(this.f.items.entries()).map(([u,b])=>({key:u,length:b.length})),(u,b)=>b.length-u.length,5).map(u=>`${u.key}:${u.length}`).join(", "),s=(await this.n.stat(h.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${s}b, Large Keys: ${i}`)}catch(i){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async w(){this.g&&await this.g,this.j=p.StorageState.Closed,await this.f.close()}}class f extends ${static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,S.$kc)(this.z.globalStorageHome.with({scheme:w.Schemas.file}).fsPath,f.y)}constructor(r,i,s,u){super(s,u),this.z=r,this.C=i}async t(){return new p.$Ip(new y.$xW(this.path??y.$xW.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:p.StorageHint.STORAGE_IN_MEMORY})}}class l extends f{constructor(r,i,s,u){super(r,i,s,u)}}e.$iac=l;class d extends f{constructor(r,i,s,u){super(i.defaultProfile,r,s,u)}async s(r){await super.s(r),this.G(r)}G(r){r.get(m.$Ql,void 0)===void 0&&r.set(m.$Ql,new Date().toUTCString());const s=r.get(m.$Pl,void 0),u=new Date().toUTCString();r.set(m.$Rl,typeof s>"u"?null:s),r.set(m.$Pl,u)}}e.$jac=d;class a extends ${static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,S.$kc)(this.F.workspaceStorageHome.with({scheme:w.Schemas.file}).fsPath,this.C.id,a.y)}constructor(r,i,s,u,b){super(s,b),this.C=r,this.D=i,this.F=u}async t(){const{storageFilePath:r,wasCreated:i}=await this.H();return new p.$Ip(new y.$xW(r,{logging:this.r()}),{hint:this.D.useInMemoryStorage?p.StorageHint.STORAGE_IN_MEMORY:i?p.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:y.$xW.IN_MEMORY_PATH,wasCreated:!0};const r=(0,S.$kc)(this.F.workspaceStorageHome.with({scheme:w.Schemas.file}).fsPath,this.C.id),i=(0,S.$kc)(r,a.y);return await c.Promises.exists(r)?{storageFilePath:i,wasCreated:!1}:(await c.Promises.mkdir(r,{recursive:!0}),this.I(r),{storageFilePath:i,wasCreated:!0})}async I(r){let i;if((0,v.$si)(this.C)?i={folder:this.C.uri.toString()}:(0,v.$xi)(this.C)&&(i={workspace:this.C.configPath.toString()}),i)try{const s=(0,S.$kc)(r,a.z);await c.Promises.exists(s)||await c.Promises.writeFile(s,JSON.stringify(i,void 0,2))}catch(s){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${s}`)}}}e.$kac=a;class t extends ${get path(){}async t(){return new p.$Ip(new p.$Jp,{hint:p.StorageHint.STORAGE_IN_MEMORY})}}e.$lac=t}),define(oe[284],ae([0,1,3,2,97]),function(K,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wbc=void 0;class M extends j.$Uc{constructor(E,h,c){super(),this.b=E,this.c=h,this.f=c;const p=this.B(new j.$Vc);this.a=this.B(new n.$7d({onWillAddFirstListener:()=>p.value=this.g(),onDidRemoveLastListener:()=>p.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const E=new j.$Tc;return E.add(n.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(h,c)=>(h?h.push(c.key):h=[c.key],h),100)(h=>this.h(h))),E.add(n.Event.debounce(this.b.onDidChangeProfileStorage,(h,c)=>{h||(h=new Map);let p=h.get(c.profile.id);return p||h.set(c.profile.id,p={profile:c.profile,keys:[],storage:c.storage}),p.keys.push(c.key),h},100)(h=>this.j(h))),E}h(E){const h=E.includes(P.$Lp)?[this.c.defaultProfile]:[],c=[];if(E=E.filter(p=>p!==P.$Lp),E.length){const p=(0,P.$Np)(this.b.applicationStorage.storage);c.push({profile:this.c.defaultProfile,changes:E.map(y=>({key:y,scope:0,target:p[y]}))})}this.m(h,c)}j(E){const h=[],c=new Map;for(const[p,y]of E.entries()){y.keys.includes(P.$Lp)&&h.push(y.profile);const k=y.keys.filter(g=>g!==P.$Lp);if(k.length){const g=(0,P.$Np)(y.storage.storage);c.set(p,{profile:y.profile,changes:k.map(m=>({key:m,scope:0,target:g[m]}))})}}this.m(h,[...c.values()])}m(E,h){(E.length||h.length)&&this.a.fire({valueChanges:h,targetChanges:E})}listen(E,h,c){switch(h){case"onDidChange":return this.a.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${h}`)}async call(E,h){throw new Error(`Call not found: ${h}`)}}e.$wbc=M}),define(oe[285],ae([0,1,7,38,16,5,34,40,41,12,125]),function(K,e,n,j,P,M,S,E,h,c,p){"use strict";var y,k;Object.defineProperty(e,"__esModule",{value:!0}),e.$3P=e.$2P=e.$1P=void 0;let g=class extends h.$rl{static{y=this}static{this.a="profileAssociationsMigration"}constructor($,f,l,d,a){super(l,d,f,a),this.U=$,this.W=l}O(){return this.U.getItem(y.b,[]).map(f=>({...f,location:(0,c.$Vf)(f.location)?this.w.extUri.joinPath(this.profilesHome,f.location):n.URI.revive(f.location)}))}Q(){const $=this.U.getItem(y.c,{});return this.U.getItem(y.a,!1)?$:this.N($)}S(){return this.w.extUri.joinPath(n.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$1P=g,e.$1P=g=y=Ee([ne(0,S.$VP),ne(1,E.$ml),ne(2,j.$qi),ne(3,P.$Ok),ne(4,M.$Oj)],g);let m=k=class extends g{constructor($,f,l,d,a){super($,f,l,d,a),this.$=$}P($){$.length?this.$.setItem(k.b,$.map(f=>({...f,location:this.w.extUri.basename(f.location)}))):this.$.removeItem(k.b)}O(){const $=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P($),this.$.setItem("userDataProfilesMigration",!0)),$}R($){$.emptyWindows||$.workspaces?this.$.setItem(k.c,$):this.$.removeItem(k.c)}Q(){const $="workspaceAndProfileInfo",f=this.$.getItem($,void 0);if(f){this.$.removeItem($);const d=f.reduce((a,{workspace:t,profile:o})=>(a[n.URI.revive(t).toString()]=n.URI.revive(o).toString(),a),{});this.$.setItem(k.c,{workspaces:d})}const l=super.Q();return this.$.getItem(k.a,!1)||(this.R(l),this.$.setItem(k.a,!0)),l}};e.$2P=m,e.$2P=m=k=Ee([ne(0,S.$WP),ne(1,E.$ml),ne(2,j.$qi),ne(3,P.$Ok),ne(4,M.$Oj)],m);let v=class extends m{constructor($,f,l,d){super(new p.$ZP(0,f,d,l),$,f,l,d)}async init(){return await this.$.init(),super.init()}};e.$3P=v,e.$3P=v=Ee([ne(0,E.$ml),ne(1,j.$qi),ne(2,P.$Ok),ne(3,M.$Oj)],v)}),define(oe[57],ae([0,1,38,16,6,5,40,41,285,34]),function(K,e,n,j,P,M,S,E,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4_b=e.$3_b=void 0,e.$3_b=(0,P.$ji)(E.$ol);let p=class extends h.$2P{constructor(k,g,m,v,w){super(k,g,m,v,w)}getAssociatedEmptyWindows(){const k=[];for(const g of this.C.emptyWindows.keys())k.push({id:g});return k}};e.$4_b=p,e.$4_b=p=Ee([ne(0,c.$WP),ne(1,S.$ml),ne(2,n.$qi),ne(3,j.$Ok),ne(4,M.$Oj)],p)}),define(oe[133],ae([0,1,19,7,30]),function(K,e,n,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5_b=M,e.$6_b=S,e.$7_b=E;async function M(h,c,p){for(const k of h){const g=k.openedWorkspace;if((0,P.$xi)(g)){const m=await p(g);if(m){if(m.folders.some(v=>n.$Mg.isEqualOrParent(c,v.uri)))return k}else if(n.$Mg.isEqualOrParent(c,g.configPath))return k}}const y=h.filter(k=>(0,P.$si)(k.openedWorkspace)&&n.$Mg.isEqualOrParent(c,k.openedWorkspace.uri));if(y.length)return y.sort((k,g)=>-(k.openedWorkspace.uri.path.length-g.openedWorkspace.uri.path.length))[0]}function S(h,c){for(const p of h)if((0,P.$xi)(p.openedWorkspace)&&n.$Mg.isEqual(p.openedWorkspace.configPath,c)||(0,P.$si)(p.openedWorkspace)&&n.$Mg.isEqual(p.openedWorkspace.uri,c))return p}function E(h,c){const p=y=>c.some(k=>n.$Mg.isEqual(j.URI.file(k),j.URI.file(y)));for(const y of h)if(y.config?.extensionDevelopmentPath?.some(k=>p(k)))return y}}),define(oe[98],ae([0,1,31,42,103,48,13,9,4,19,7,6,68,30]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Peb=void 0,e.$Qeb=m,e.$Reb=v,e.$Seb=w,e.$Teb=$,e.$Ueb=d,e.$Veb=t,e.$Web=o,e.$Xeb=b,e.$Yeb=C,e.$Peb=(0,y.$ii)("workspacesService");function m(I){return I.hasOwnProperty("workspace")}function v(I){return I.hasOwnProperty("folderUri")}function w(I){return I.hasOwnProperty("fileUri")}function $(I){return f(I)||l(I)}function f(I){const D=I;return typeof D?.path=="string"&&(!D.name||typeof D.name=="string")}function l(I){const D=I;return typeof D?.uri=="string"&&(!D.name||typeof D.name=="string")}function d(I,D,O,R,W){if(I.scheme!==R.scheme)return{name:O,uri:I.toString(!0)};let F=D?void 0:W.relativePath(R,I);if(F!==void 0)F.length===0?F=".":h.$i&&(F=a(F));else if(I.scheme===S.Schemas.file)F=I.fsPath,h.$i&&(F=a(F));else if(W.isEqualAuthority(I.authority,R.authority))F=I.path;else return{name:O,uri:I.toString(!0)};return{name:O,path:F}}function a(I){return I=(0,M.$hw)(I),(0,n.$fg)(I)||(I=(0,n.$cg)(I)),I}function t(I,D,O){const R=[],W=new Set,F=O.dirname(D);for(const q of I){let x;if(f(q))q.path&&(x=O.resolvePath(F,q.path));else if(l(q))try{x=p.URI.parse(q.uri),x.path[0]!==E.$hc.sep&&(x=x.with({path:E.$hc.sep+x.path}))}catch(le){console.warn(le)}if(x){const le=O.getComparisonKey(x);if(!W.has(le)){W.add(le);const te=q.name||O.basenameOrAuthority(x);R.push(new g.$Ci({uri:x,name:te,index:R.length},q))}}}return R}function o(I,D,O,R,W){const F=r(D,I),q=W.dirname(D),x=W.dirname(R),le=[];for(const Z of F.folders){const B=f(Z)?W.resolvePath(q,Z.path):p.URI.parse(Z.uri);let L;O?L=!1:L=!f(Z)||(0,E.$jc)(Z.path),le.push(d(B,L,Z.name,x,W))}const te={insertSpaces:!1,tabSize:4,eol:h.$k||h.$j?`
`:`\r
`},ue=P.$Kn(I,["folders"],le,te);let Y=P.$Nn(I,ue);return(0,c.$1g)(F.remoteAuthority,(0,k.$tm)(R))&&(Y=P.$Nn(Y,P.$Jn(Y,["remoteAuthority"],te))),Y}function r(I,D){const O=j.$vn(D);if(O&&Array.isArray(O.folders))O.folders=O.folders.filter(R=>$(R));else throw new Error(`${I} looks like an invalid workspace file.`);return O}function i(I){return I.workspace&&typeof I.workspace=="object"&&typeof I.workspace.id=="string"&&typeof I.workspace.configPath=="string"}function s(I){return typeof I.folderUri=="string"}function u(I){return typeof I.fileUri=="string"}function b(I,D){const O={workspaces:[],files:[]};if(I){const R=function(F,q){for(let x=0;x<F.length;x++)try{q(F[x],x)}catch(le){D.warn(`Error restoring recent entry ${JSON.stringify(F[x])}: ${le.toString()}. Skip entry.`)}},W=I;Array.isArray(W.entries)&&R(W.entries,F=>{const q=F.label,x=F.remoteAuthority;i(F)?O.workspaces.push({label:q,remoteAuthority:x,workspace:{id:F.workspace.id,configPath:p.URI.parse(F.workspace.configPath)}}):s(F)?O.workspaces.push({label:q,remoteAuthority:x,folderUri:p.URI.parse(F.folderUri)}):u(F)&&O.files.push({label:q,remoteAuthority:x,fileUri:p.URI.parse(F.fileUri)})})}return O}function C(I){const D={entries:[]};for(const O of I.workspaces)v(O)?D.entries.push({folderUri:O.folderUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority}):D.entries.push({workspace:{id:O.workspace.id,configPath:O.workspace.configPath.toString()},label:O.label,remoteAuthority:O.remoteAuthority});for(const O of I.files)D.entries.push({fileUri:O.fileUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority});return D}}),define(oe[99],ae([0,1,87,13,4,19]),function(K,e,n,j,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8_b=void 0,e.$9_b=S,e.$0_b=E,e.$$_b=h,e.$8_b=128/4;function S(c){function p(){let y=c.scheme===j.Schemas.file?(0,M.$Jg)(c):c.toString();return P.$k||(y=y.toLowerCase()),(0,n.createHash)("md5").update(y).digest("hex")}return{id:p(),configPath:c}}function E(c,p){function y(){if(c.scheme!==j.Schemas.file)return(0,n.createHash)("md5").update(c.toString()).digest("hex");if(!p)return;let g;return P.$k?g=p.ino:P.$j?g=p.birthtime.getTime():P.$i&&(typeof p.birthtimeMs=="number"?g=Math.floor(p.birthtimeMs):g=p.birthtime.getTime()),(0,n.createHash)("md5").update(c.fsPath).update(g?String(g):"").digest("hex")}const k=y();if(typeof k=="string")return{id:k,uri:c}}function h(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(oe[100],ae([0,1,87,88,26,286,17,15,3,2,9,4,33,44,113]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.$_h=e.$$h=e.$0h=void 0,e.$ai=r,e.$bi=i,e.$di=b,e.$ei=C;class v{traceSocketEvent(D,O){m.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,D,O)}constructor(D,O=""){this.f=!0,this.debugLabel=O,this.socket=D,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=R=>{if(this.traceSocketEvent("error",{code:R?.code,message:R?.message}),R){if(R.code==="EPIPE")return;(0,E.$1)(R)}},this.socket.on("error",this.a),this.b=R=>{this.traceSocketEvent("close",{hadError:R}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(D){const O=R=>{this.traceSocketEvent("read",R),D(S.$ue.wrap(R))};return this.socket.on("data",O),{dispose:()=>this.socket.off("data",O)}}onClose(D){const O=R=>{D({type:0,hadError:R,error:void 0})};return this.socket.on("close",O),{dispose:()=>this.socket.off("close",O)}}onEnd(D){const O=()=>{D()};return this.socket.on("end",O),{dispose:()=>this.socket.off("end",O)}}write(D){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",D),this.socket.write(D.buffer,O=>{if(O){if(O.code==="EPIPE")return;(0,E.$1)(O)}})}catch(O){if(O.code==="EPIPE")return;(0,E.$1)(O)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((D,O)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),D();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),this.traceSocketEvent("nodeDrainEnd"),D()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.$0h=v;var w;(function(I){I[I.MinHeaderByteSize=2]="MinHeaderByteSize",I[I.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(w||(w={}));var $;(function(I){I[I.PeekHeader=1]="PeekHeader",I[I.ReadHeader=2]="ReadHeader",I[I.ReadBody=3]="ReadBody",I[I.Fin=4]="Fin"})($||($={}));class f extends c.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(D,O){this.socket.traceSocketEvent(D,O)}constructor(D,O,R,W){super(),this.f=this.B(new h.$7d),this.g=this.B(new h.$7d),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=D,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:O,inflateBytesLength:R?.byteLength||0,recordInflateBytes:W}),this.a=this.B(new l(this,O,R,W,this.f,(F,q)=>this.m(F,q))),this.B(this.a.onError(F=>{console.error(F),(0,E.$1)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new m.$5h,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await h.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(D){return this.f.event(D)}onClose(D){return this.g.event(D)}onEnd(D){return this.socket.onEnd(D)}write(D){let O=0;for(;O<D.byteLength;)this.a.writeMessage(D.slice(O,Math.min(O+262144,D.byteLength)),{compressed:!0,opcode:2}),O+=262144}m(D,{compressed:O,opcode:R}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",D);let W=2;D.byteLength<126?W+=0:D.byteLength<2**16?W+=2:W+=8;const F=S.$ue.alloc(W),q=O?64:0,x=R&15;if(F.writeUInt8(128|q|x,0),D.byteLength<126)F.writeUInt8(D.byteLength,1);else if(D.byteLength<2**16){F.writeUInt8(126,1);let le=1;F.writeUInt8(D.byteLength>>>8&255,++le),F.writeUInt8(D.byteLength>>>0&255,++le)}else{F.writeUInt8(127,1);let le=1;F.writeUInt8(0,++le),F.writeUInt8(0,++le),F.writeUInt8(0,++le),F.writeUInt8(0,++le),F.writeUInt8(D.byteLength>>>24&255,++le),F.writeUInt8(D.byteLength>>>16&255,++le),F.writeUInt8(D.byteLength>>>8&255,++le),F.writeUInt8(D.byteLength>>>0&255,++le)}this.socket.write(S.$ue.concat([F,D]))}end(){this.h=!0,this.socket.end()}n(D){if(D.byteLength!==0){for(this.b.acceptChunk(D);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const O=this.b.peek(this.j.readLen),R=O.readUInt8(0),W=(R&128)>>>7,F=(R&64)>>>6,q=R&15,x=O.readUInt8(1),le=(x&128)>>>7,te=x&127;this.j.state=2,this.j.readLen=2+(le?4:0)+(te===126?2:0)+(te===127?8:0),this.j.fin=W,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!W,this.j.mask=0,this.j.opcode=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const O=this.b.read(this.j.readLen),R=O.readUInt8(1),W=(R&128)>>>7;let F=R&127,q=1;F===126?F=O.readUInt8(++q)*2**8+O.readUInt8(++q):F===127&&(F=O.readUInt8(++q)*0+O.readUInt8(++q)*0+O.readUInt8(++q)*0+O.readUInt8(++q)*0+O.readUInt8(++q)*2**24+O.readUInt8(++q)*2**16+O.readUInt8(++q)*2**8+O.readUInt8(++q));let x=0;W&&(x=O.readUInt8(++q)*2**24+O.readUInt8(++q)*2**16+O.readUInt8(++q)*2**8+O.readUInt8(++q)),this.j.state=3,this.j.readLen=F,this.j.mask=x,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const O=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",O),t(O,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",O),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(O,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(O,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await h.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$$h=f;class l extends c.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:S.$ue.alloc(0)}constructor(D,O,R,W,F,q){super(),this.n=D,this.r=F,this.s=q,this.a=this.B(new h.$7d),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new h.$7d),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new h.$7d),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,O?(this.b=this.B(new d(this.n,W,R,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(x=>this.a.fire(x))),this.B(this.f.onError(x=>this.a.fire(x)))):(this.b=null,this.f=null)}writeMessage(D,O){this.g.push({data:D,options:O}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:D,options:O}=this.g.shift();if(this.f&&O.compressed){const R=await this.w(this.f,D);this.s(R,O)}else this.s(D,{...O,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(D,O){return new Promise((R,W)=>{D.write(O),D.flush(F=>R(F))})}acceptFrame(D,O,R){this.h.push({data:D,isCompressed:O,isLastFrameOfMessage:R}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const D=this.h.shift();if(this.b&&D.isCompressed){const O=await this.C(this.b,D.data,D.isLastFrameOfMessage);this.r.fire(O)}else this.r.fire(D.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(D,O,R){return new Promise((W,F)=>{D.write(O),R&&D.write(S.$ue.fromByteArray([0,0,255,255])),D.flush(q=>W(q))})}}class d extends c.$Uc{get recordedInflateBytes(){return this.j?S.$ue.concat(this.f):S.$ue.alloc(0)}constructor(D,O,R,W){super(),this.h=D,this.j=O,this.a=this.B(new h.$7d),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,M.createInflateRaw)(W),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(S.$ue.wrap(F))}),R&&(this.h.traceSocketEvent("zlibInflateInitialWrite",R.buffer),this.b.write(R.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(D){this.j&&this.f.push(D.clone()),this.h.traceSocketEvent("zlibInflateWrite",D),this.b.write(D.buffer)}flush(D){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const O=S.$ue.concat(this.g);this.g.length=0,D(O)})}}class a extends c.$Uc{constructor(D,O){super(),this.g=D,this.a=this.B(new h.$7d),this.onError=this.a.event,this.f=[],this.b=(0,M.createDeflateRaw)({windowBits:15}),this.b.on("error",R=>{this.g.traceSocketEvent("zlibDeflateError",{message:R?.message,code:R?.code}),this.a.fire(R)}),this.b.on("data",R=>{this.g.traceSocketEvent("zlibDeflateData",R),this.f.push(S.$ue.wrap(R))})}write(D){this.g.traceSocketEvent("zlibDeflateWrite",D.buffer),this.b.write(D.buffer)}flush(D){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let O=S.$ue.concat(this.f);this.f.length=0,O=O.slice(0,O.byteLength-4),D(O)})}}function t(I,D){if(D===0)return;const O=I.byteLength>>>2;for(let le=0;le<O;le++){const te=I.readUInt32BE(le*4);I.writeUInt32BE(te^D,le*4)}const R=O*4,W=I.byteLength-R,F=D>>>24&255,q=D>>>16&255,x=D>>>8&255;W>=1&&I.writeUInt8(I.readUInt8(R)^F,R),W>=2&&I.writeUInt8(I.readUInt8(R+1)^q,R+1),W>=3&&I.writeUInt8(I.readUInt8(R+2)^x,R+2)}e.$_h=process.env.XDG_RUNTIME_DIR;const o={2:107,1:103};function r(){const I=(0,k.$Eg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${I}-sock`;const D=process.platform!=="darwin"&&e.$_h?e.$_h:(0,P.tmpdir)(),O=(0,p.$kc)(D,`vscode-ipc-${I}.sock`);return s(O),O}function i(I,D,O){const W=(0,n.createHash)("sha256").update(I).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${W}-${O}-${D}-sock`;const F=O.substr(0,4),q=D.substr(0,6);let x;return process.platform!=="darwin"&&e.$_h&&!process.env.VSCODE_PORTABLE?x=(0,p.$kc)(e.$_h,`vscode-${W}-${F}-${q}.sock`):x=(0,p.$kc)(I,`${F}-${q}.sock`),s(x),x}function s(I){const D=o[y.$u];typeof D=="number"&&I.length>=D&&console.warn(`WARNING: IPC handle "${I}" is longer than ${D} chars, try a shorter --user-data-dir`)}class u extends g.$Yh{static b(D){const O=h.Event.fromNodeEventEmitter(D,"connection");return h.Event.map(O,R=>({protocol:new m.$6h(new v(R,"ipc-server-connection")),onDidClientDisconnect:h.Event.once(h.Event.fromNodeEventEmitter(R,"close"))}))}constructor(D){super(u.b(D)),this.d=D}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$ci=u;function b(I){return new Promise((D,O)=>{const R=(0,j.createServer)();R.on("error",O),R.listen(I,()=>{R.removeListener("error",O),D(new u(R))})})}function C(I,D){return new Promise((O,R)=>{const W=(0,j.createConnection)(I,()=>{W.removeListener("error",R),O(m.$7h.fromSocket(new v(W,`ipc-client${D}`),D))});W.once("error",R)})}}),define(oe[24],ae([0,1,51,9,4,100,38,91,6]),function(K,e,n,j,P,M,S,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P_b=e.$O_b=void 0,e.$O_b=(0,h.$ji)(S.$pi);class c extends E.$Um{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,j.$kc)(this.userDataPath,"clp")}get backupHome(){return(0,j.$kc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,M.$bi)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,j.$kc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(P.$k){for(const y in process.env)if(y.endsWith("_VSCODE_SNAP_ORIG")){const k=y.slice(0,-17);if(this.d[k])continue;process.env[k]&&(this.d[k]=process.env[k]),process.env[y]?process.env[k]=process.env[y]:delete process.env[k]}}}restoreSnapExportedVariables(){if(P.$k)for(const y in this.d)process.env[y]=this.d[y],delete this.d[y]}}e.$P_b=c,Ee([n.$Mh],c.prototype,"cachedLanguagesPath",null),Ee([n.$Mh],c.prototype,"backupHome",null),Ee([n.$Mh],c.prototype,"mainIPCHandle",null),Ee([n.$Mh],c.prototype,"mainLockfile",null),Ee([n.$Mh],c.prototype,"disableUpdates",null),Ee([n.$Mh],c.prototype,"crossOriginIsolated",null),Ee([n.$Mh],c.prototype,"codeCachePath",null),Ee([n.$Mh],c.prototype,"useCodeCache",null)}),define(oe[287],ae([0,1,87,31,13,9,4,19,21,199,18,24,34,16,5,198,30,99]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g,m,v,w,$){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$rac=void 0;let l=class{static{f=this}static{this.a="backupWorkspaces"}constructor(a,t,o,r){this.j=a,this.k=t,this.l=o,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=E.$Mg,this.i={isEqual:(i,s)=>(0,j.$hg)(i,s,!S.$k)}}async initialize(){const a=this.m.getItem(f.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(a.emptyWindows),this.d=await this.u((0,c.$R_b)(a)),this.e=await this.v((0,c.$S_b)(a)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==g.$bl.OFF}q(){return this.s()===g.$bl.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||g.$bl.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(a,t){this.d.some(r=>a.workspace.id===r.workspace.id)||(this.d.push(a),this.C());const o=(0,M.$kc)(this.c,a.workspace.id);return t?this.t(o,t).then(()=>o):o}async t(a,t){if(await h.Promises.exists(a)&&await this.z(a),await h.Promises.exists(t))try{await h.Promises.rename(t,a,!1)}catch(o){this.l.error(`Backup: Could not move backup folder to new location: ${o.toString()}`)}}registerFolderBackup(a){return this.e.some(t=>this.h.isEqual(a.folderUri,t.folderUri))||(this.e.push(a),this.C()),(0,M.$kc)(this.c,this.D(a))}registerEmptyWindowBackup(a){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,a.backupFolder))||(this.g.push(a),this.C()),(0,M.$kc)(this.c,a.backupFolder)}async u(a){if(!Array.isArray(a))return[];const t=new Set,o=[];for(const r of a){const i=r.workspace;if(!(0,w.$xi)(i))return[];if(!t.has(i.id)){t.add(i.id);const s=(0,M.$kc)(this.c,i.id);await this.B(s)?i.configPath.scheme!==P.Schemas.file||await h.Promises.exists(i.configPath.fsPath)?o.push(r):await this.z(s):await this.x(s)}}return o}async v(a){if(!Array.isArray(a))return[];const t=[],o=new Set;for(const r of a){const i=r.folderUri,s=this.h.getComparisonKey(i);if(!o.has(s)){o.add(s);const u=(0,M.$kc)(this.c,this.D(r));await this.B(u)?i.scheme!==P.Schemas.file||await h.Promises.exists(i.fsPath)?t.push(r):await this.z(u):await this.x(u)}}return t}async w(a){if(!Array.isArray(a))return[];const t=[],o=new Set;for(const r of a){const i=r.backupFolder;if(typeof i!="string")return[];if(!o.has(i)){o.add(i);const s=(0,M.$kc)(this.c,i);await this.B(s)?t.push(r):await this.x(s)}}return t}async x(a){try{await h.Promises.rm(a,h.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let a=(0,$.$$_b)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,a.id));)a=(0,$.$$_b)();return{backupFolder:a.id}}async z(a){const t=this.y(),o=(0,M.$kc)(this.c,t.backupFolder);try{await h.Promises.rename(a,o,!1)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const a=[];for(const t of this.d)await this.A(t)&&a.push(t);for(const t of this.e)await this.A(t)&&a.push(t);return a}A(a){let t;return(0,c.$Q_b)(a)?t=(0,M.$kc)(this.c,a.backupFolder):(0,v.$Neb)(a)?t=(0,M.$kc)(this.c,this.D(a)):t=(0,M.$kc)(this.c,a.workspace.id),this.B(t)}async B(a){try{const t=await h.Promises.readdir(a);for(const o of t)try{if((await h.Promises.readdir((0,M.$kc)(a,o))).length>0)return!0}catch{}}catch{}return!1}C(){const a={workspaces:this.d.map(({workspace:t,remoteAuthority:o})=>{const r={id:t.id,configURIPath:t.configPath.toString()};return o&&(r.remoteAuthority=o),r}),folders:this.e.map(({folderUri:t,remoteAuthority:o})=>{const r={folderUri:t.toString()};return o&&(r.remoteAuthority=o),r}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:o})=>{const r={backupFolder:t};return o&&(r.remoteAuthority=o),r})};this.m.setItem(f.a,a)}D(a){const t=a.folderUri;let o;return t.scheme===P.Schemas.file?o=S.$k?t.fsPath:t.fsPath.toLowerCase():o=t.toString().toLowerCase(),(0,n.createHash)("md5").update(o).digest("hex")}};e.$rac=l,e.$rac=l=f=Ee([ne(0,y.$O_b),ne(1,p.$Oi),ne(2,m.$Oj),ne(3,k.$WP)],l)}),define(oe[20],ae([0,1,14,37,8,3,2,4,36,12,6,5,34,24]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$hac=e.LifecycleMainPhase=e.ShutdownReason=e.$gac=void 0,e.$gac=(0,p.$ii)("lifecycleMainService");var v;(function(f){f[f.QUIT=1]="QUIT",f[f.KILL=2]="KILL"})(v||(e.ShutdownReason=v={}));var w;(function(f){f[f.Starting=1]="Starting",f[f.Ready=2]="Ready",f[f.AfterWindowOpen=3]="AfterWindowOpen",f[f.Eventually=4]="Eventually"})(w||(e.LifecycleMainPhase=w={}));let $=class extends S.$Uc{static{m=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(l,d,a){super(),this.F=l,this.G=d,this.H=a,this.c=this.B(new M.$7d),this.onBeforeShutdown=this.c.event,this.f=this.B(new M.$7d),this.onWillShutdown=this.f.event,this.g=this.B(new M.$7d),this.onWillLoadWindow=this.g.event,this.h=this.B(new M.$7d),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(m.b),this.m&&this.G.removeItem(m.b)}J(){const l=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),E.$j&&this.t===0&&this.L(1))};n.app.addListener("before-quit",l);const d=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!E.$j)&&n.app.quit()};n.app.addListener("window-all-closed",d),n.app.once("will-quit",a=>{this.S("Lifecycle#app.on(will-quit) - begin"),a.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),n.app.removeListener("before-quit",l),n.app.removeListener("window-all-closed",d),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),n.app.quit()})})}L(l){if(this.y)return this.y;const d=this.F;this.S("Lifecycle#onWillShutdown.fire()");const a=[];return this.f.fire({reason:l,join(t,o){d.trace(`Lifecycle#onWillShutdown - begin '${t}'`),a.push(o.finally(()=>{d.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await P.Promises.settled(a)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase(l){if(l<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===l)return;this.S(`lifecycle (main): phase changed (value: ${l})`),this.n=l;const d=this.C.get(this.n);d&&(d.open(),this.C.delete(this.n))}async when(l){if(l<=this.n)return;let d=this.C.get(l);d||(d=new P.$hh,this.C.set(l,d)),await d.wait()}registerWindow(l){const d=new S.$Tc;this.t++,d.add(l.onWillLoad(t=>this.g.fire({window:l,workspace:t.workspace,reason:t.reason})));const a=(0,c.$7f)(l.win);a.on("close",t=>{const o=l.id;if(this.r.has(o)){this.r.delete(o);return}this.S(`Lifecycle#window.on('close') - window ID ${l.id}`),t.preventDefault(),this.unload(l,1).then(r=>{if(r){this.r.delete(o);return}this.r.add(o),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this.h.fire(l),l.close()})}),a.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${l.id}`),this.t--,d.dispose(),this.t===0&&(!E.$j||this.j)&&this.L(1)})}registerAuxWindow(l){const d=(0,c.$7f)(l.win);d.on("close",a=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${l.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),a.preventDefault())}),d.on("closed",()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${l.id}`)})}async reload(l,d){await this.unload(l,3)||l.reload(d)}unload(l,d){const a=this.z.get(l.id);if(a)return a;const t=this.M(l,d).finally(()=>{this.z.delete(l.id)});return this.z.set(l.id,t),t}async M(l,d){if(!l.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${l.id}`);const a=this.j?2:d,t=await this.P(l,a);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${l.id})`),this.N(t)):(await this.Q(l,a),!1)}N(l){return l?(this.O(!0),this.j=!1,!0):!1}O(l){this.w&&(this.w(l),this.w=void 0,this.u=void 0)}P(l,d){return new Promise(a=>{const t=this.s++,o=`vscode:ok${t}`,r=`vscode:cancel${t}`;j.$5V.once(o,()=>{a(!1)}),j.$5V.once(r,()=>{a(!0)}),l.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:r,reason:d})})}Q(l,d){return new Promise(a=>{const o=`vscode:reply${this.s++}`;j.$5V.once(o,()=>a()),l.send("vscode:onWillUnload",{replyChannel:o,reason:d})})}quit(l){return this.R(l).then(d=>{if(!d&&l)try{if(E.$i){const a=(0,h.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.F.error(a)}return d})}R(l){return this.S(`Lifecycle#quit() - begin (willRestart: ${l})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(l&&this.G.setItem(m.b,!0),this.u=new Promise(d=>{this.w=d,this.S("Lifecycle#quit() - calling app.quit()"),n.app.quit()}),this.u)}S(l){this.H.args["enable-smoke-test-driver"]?this.F.info(l):this.F.trace(l)}setRelaunchHandler(l){this.D=l}async relaunch(l){this.S("Lifecycle#relaunch()");const d=process.argv.slice(1);if(l?.addArgs&&d.push(...l.addArgs),l?.removeArgs)for(const o of l.removeArgs){const r=d.indexOf(o);r>=0&&d.splice(r,1)}const a=()=>{this.D?.handleRelaunch(l)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),n.app.relaunch({args:d}))};n.app.once("quit",a),await this.quit(!0)&&n.app.removeListener("quit",a)}async kill(l){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,P.$jh)(1e3),(async()=>{for(const d of n.BrowserWindow.getAllWindows())if(d&&!d.isDestroyed()){let a;d.webContents&&!d.webContents.isDestroyed()?a=new Promise(t=>d.once("closed",t)):a=Promise.resolve(),d.destroy(),await a}})()]),n.app.exit(l)}};e.$hac=$,e.$hac=$=m=Ee([ne(0,y.$Oj),ne(1,k.$WP),ne(2,g.$O_b)],$)}),define(oe[288],ae([0,1,4,3,2,6,20]),function(K,e,n,j,P,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pac=e.$Oac=void 0,e.$Oac=(0,M.$ii)("keyboardLayoutMainService");let E=class extends P.$Uc{constructor(p){super(),this.a=this.B(new j.$7d),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,p.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const p=await new Promise((y,k)=>{K(["native-keymap"],y,k)});this.c=h(p),n.$t||p.onDidChangeKeyboardLayout(()=>{this.c=h(p),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$Pac=E,e.$Pac=E=Ee([ne(0,S.$gac)],E);function h(c){const p=c.getKeyMap(),y=c.getCurrentKeyboardLayout();return{keyboardMapping:p,keyboardLayoutInfo:y}}}),define(oe[289],ae([0,1,250,8,17,15,12,18,38,95,5,53,249,286]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=void 0,e.$Ir=w;let m=class extends y.$Ap{constructor(f,l,d,a){super(a),this.m=f,this.n=l,this.r=d,this.s(),this.B(f.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const f=this.m.getValue("http");this.f=f?.proxy,this.g=!!f?.proxyStrictSSL,this.h=f?.proxyAuthorization}async request(f,l){const{f:d,g:a}=this;let t;try{t=await(0,c.$sm)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,M.$0)(i)))}const o={...process.env,...t},r=f.agent?f.agent:await(0,k.$Gr)(f.url||"",o,{proxyUrl:d,strictSSL:a});return f.agent=r,f.strictSSL=a,this.h&&(f.headers={...f.headers||{},"Proxy-Authorization":this.h}),this.c(f.isChromiumNetwork?"electron":"node",f,()=>w(f,l))}async resolveProxy(f){}async loadCertificates(){return(await new Promise((l,d)=>{K(["@vscode/proxy-agent"],l,d)})).loadSystemCertificates({log:this.r})}};e.$Hr=m,e.$Hr=m=Ee([ne(0,E.$Oi),ne(1,h.$qi),ne(2,p.$Oj),ne(3,p.$Pj)],m);async function v($){return((0,n.parse)($.url).protocol==="https:"?await new Promise((d,a)=>{K(["https"],d,a)}):await new Promise((d,a)=>{K(["http"],d,a)})).request}async function w($,f){return j.Promises.withAsyncBody(async(l,d)=>{const a=(0,n.parse)($.url),t=$.getRawRequest?$.getRawRequest($):await v($),o={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:$.type||"GET",headers:$.headers,agent:$.agent,rejectUnauthorized:(0,S.$2f)($.strictSSL)?$.strictSSL:!0};$.user&&$.password&&(o.auth=$.user+":"+$.password);const r=t(o,i=>{const s=(0,S.$Zf)($.followRedirects)?$.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&s>0&&i.headers.location)w({...$,url:i.headers.location,followRedirects:s-1},f).then(l,d);else{let u=i;!$.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(u=i.pipe((0,g.createGunzip)())),l({res:i,stream:(0,P.$Je)(u)})}});r.on("error",d),$.timeout&&r.setTimeout($.timeout),$.isChromiumNetwork&&r.removeHeader("Content-Length"),$.data&&typeof $.data=="string"&&r.write($.data),r.end(),f.onCancellationRequested(()=>{r.abort(),d(new M.$5)})})}}),define(oe[290],ae([0,1,14,289]),function(K,e,n,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rbc=void 0;function P(S){return n.net.request}class M extends j.$Hr{request(E,h){return super.request({...E||{},getRawRequest:P,isChromiumNetwork:!0},h)}}e.$Rbc=M}),define(oe[83],ae([0,1,7,3,2,38,16,6,20,5,97,283,41,57,40,13]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pac=e.$oac=e.$nac=e.$mac=void 0,e.$mac=(0,E.$ii)("storageMainService");let w=class extends P.$Uc{constructor(l,d,a,t,o,r){super(),this.c=l,this.f=d,this.g=a,this.h=t,this.j=o,this.m=r,this.a=void 0,this.b=this.B(new j.$7d),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(l=>{l.window.profile&&this.profileStorage(l.window.profile).init(),l.workspace&&this.workspaceStorage(l.workspace).init()})),this.B(this.h.onWillShutdown(l=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=l.reason,l.join("applicationStorage",this.applicationStorage.close());for(const[,d]of this.t)l.join("profileStorage",d.close());for(const[,d]of this.w)l.join("workspaceStorage",d.close())})),this.B(this.g.onWillCreateProfile(l=>{l.join((async()=>{await this.j.exists(l.profile.globalStorageHome)||await this.j.createFolder(l.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(l=>{const d=this.t.get(l.profile.id);d&&l.join(d.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const l=new y.$jac(this.n(),this.g,this.c,this.j);return this.B(j.Event.once(l.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),l}profileStorage(l){if((0,p.$Pp)(l))return this.applicationStorage;let d=this.t.get(l.id);if(!d){this.c.trace(`StorageMainService: creating profile storage (${l.name})`),d=this.B(this.u(l)),this.t.set(l.id,d);const a=this.B(d.onDidChangeStorage(t=>this.b.fire({...t,storage:d,profile:l})));this.B(j.Event.once(d.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${l.name})`),this.t.delete(l.id),a.dispose()}))}return d}u(l){return this.a===2?new y.$lac(this.c,this.j):new y.$iac(l,this.n(),this.c,this.j)}workspaceStorage(l){let d=this.w.get(l.id);return d||(this.c.trace(`StorageMainService: creating workspace storage (${l.id})`),d=this.B(this.y(l)),this.w.set(l.id,d),this.B(j.Event.once(d.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${l.id})`),this.w.delete(l.id)}))),d}y(l){return this.a===2?new y.$lac(this.c,this.j):new y.$kac(l,this.n(),this.c,this.f,this.j)}isUsed(l){const d=n.URI.file(l);for(const a of[this.applicationStorage,...this.t.values(),...this.w.values()])if(a.path&&this.m.extUri.isEqualOrParent(n.URI.file(a.path),d))return!0;return!1}};e.$nac=w,e.$nac=w=Ee([ne(0,c.$Oj),ne(1,M.$pi),ne(2,g.$3_b),ne(3,h.$gac),ne(4,S.$Ok),ne(5,m.$ml)],w),e.$oac=(0,E.$ii)("applicationStorageMainService");let $=class extends p.$Op{constructor(l,d){super(),this.s=l,this.U=d,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(l){if(l===-1)return this.U.applicationStorage.storage}Q(l){if(l===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:v.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$pac=$,e.$pac=$=Ee([ne(0,k.$ol),ne(1,e.$mac)],$)}),define(oe[291],ae([0,1,88,26,107,100,8,2,4,18,5,27,245,246,96,130,17]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g,m,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qbc=e.$Pbc=e.$Obc=e.$Nbc=void 0;async function $(t,o,r,i,s){let u;for(let b=3;b&&(u?.dispose(),u=await new f(t,o,r,i,s).waitForReady(),!(s&&P.$Hg[s]||!P.$Hg[u.tunnelLocalPort]));b--);return u}class f extends E.$Uc{constructor(o,r,i,s,u){super(),this.m=r,this.n=u,this.privacy=v.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=n.createServer(),this.c=new S.$hh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=b=>this.r(b),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=s,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,r=(0,v.$5v)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,P.$Ig)(o,2,1e3,r),s=null;return this.b.listen(i,this.m),await this.c.wait(),s=this.b.address(),s||(i=0,this.b.listen(i,this.m),await this.c.wait(),s=this.b.address()),this.tunnelLocalPort=s.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${s.port}`,this}async r(o){o.pause();const r=(0,v.$3v)(this.tunnelRemoteHost)||(0,v.$5v)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,k.$El)(this.a,r,this.tunnelRemotePort),s=i.getSocket(),u=i.readEntireBuffer();i.dispose(),u.byteLength>0&&o.write(u.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),s.end()}),o.on("close",()=>s.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),s instanceof M.$0h?s.socket.destroy():s.end()}),s instanceof M.$0h?this.t(o,s):this.s(o,s),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),s.end()})}s(o,r){r.onClose(()=>o.destroy()),r.onEnd(()=>o.end()),r.onData(i=>o.write(i.buffer)),o.on("data",i=>r.write(w.$ue.wrap(i))),o.resume()}t(o,r){const i=r.socket;i.on("end",()=>o.end()),i.on("close",()=>o.end()),i.on("error",()=>{o.destroy()}),i.pipe(o),o.pipe(i)}}e.$Nbc=f;let l=class extends v.$8v{constructor(o,r,i,s,u){super(r,u),this.v=o,this.w=i,this.y=s}isPortPrivileged(o){return(0,v.$6v)(o,this.m,h.OS,j.release())}t(o,r,i,s,u,b,C,I){const D=this.s(r,i);if(D)return++D.refcount,D.value;if((0,v.$Yv)(o))return this.u(o,r,i,u,b,C,I);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${i} on local port ${u}.`);const O={commit:this.y.commit,quality:this.y.quality,addressProvider:o,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},R=$(O,s,r,i,u);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(r,i,R),R}}};e.$Obc=l,e.$Obc=l=Ee([ne(0,g.$yl),ne(1,p.$Oj),ne(2,m.$Bl),ne(3,y.$8j),ne(4,c.$Oi)],l);let d=class extends l{constructor(o,r,i,s,u){super(o,r,i,s,u)}};e.$Pbc=d,e.$Pbc=d=Ee([ne(0,g.$yl),ne(1,p.$Oj),ne(2,m.$Bl),ne(3,y.$8j),ne(4,c.$Oi)],d);let a=class extends E.$Uc{constructor(o,r,i,s,u){super(),this.b=o,this.c=r,this.f=i,this.g=s,this.h=u,this.a=new Map}async openTunnel(o,r,i,s,u,b,C,I,D){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${s} on local port ${b}.`),!this.a.has(o)){const O=new d(this.b,this.c,this.g,this.f,this.h);this.B(O),this.a.set(o,O),O.onTunnelClosed(async()=>{(await O.tunnels).length===0&&(O.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(r,i,s,u,b,C,I,D)}};e.$Qbc=a,e.$Qbc=a=Ee([ne(0,g.$yl),ne(1,p.$Oj),ne(2,y.$8j),ne(3,m.$Bl),ne(4,c.$Oi)],a)}),define(oe[101],ae([0,1,8,23,3,18,24,20,5,27,53,50]),function(K,e,n,j,P,M,S,E,h,c,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$abc=void 0,e.$_ac=k;function k(m,v,w){return`${w.updateUrl}/api/update/${m}/${v}/${w.commit}`}let g=class{get state(){return this.b}d(v){this.j.info("update#setState",v.type),this.b=v,this.c.fire(v)}constructor(v,w,$,f,l,d){this.f=v,this.g=w,this.h=$,this.i=f,this.j=l,this.k=d,this.b=y.$3W.Uninitialized,this.c=new P.$7d,this.onStateChange=this.c.event,v.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(y.$3W.Disabled(0));return}if(this.h.disableUpdates){this.d(y.$3W.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(y.$3W.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const v=this.g.getValue("update.mode"),w=this.m(v);if(!w){this.d(y.$3W.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(w),!this.a){this.d(y.$3W.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const $=new URL(this.a);$.searchParams.set("prss","true"),this.a=$.toString()}if(this.d(y.$3W.Idle(this.q())),v==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}v==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,$=>this.j.error($))}m(v){return v==="none"?void 0:this.k.quality}n(v=60*60*1e3){return(0,n.$jh)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(v){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(v)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(v){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(v=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},j.CancellationToken.None)).res.statusCode===204}catch(w){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(w);return}}async _applySpecificUpdate(v){}q(){return 1}r(){}};e.$abc=g,e.$abc=g=Ee([ne(0,E.$gac),ne(1,M.$Oi),ne(2,S.$O_b),ne(3,p.$zp),ne(4,h.$Oj),ne(5,c.$8j)],g)}),define(oe[292],ae([0,1,14,51,3,46,2,18,24,20,5,27,53,28,50,101]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bbc=void 0;let w=class extends v.$abc{get v(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"error",(f,l)=>l)}get w(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"update-not-available")}get x(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"update-available")}get y(){return P.Event.fromNodeEventEmitter(n.autoUpdater,"update-downloaded",(f,l,d,a)=>({version:d,productVersion:d,timestamp:a}))}constructor(f,l,d,a,t,o,r){super(f,l,a,t,o,r),this.z=d,this.u=new S.$Tc,f.setRelaunchHandler(this)}handleRelaunch(f){return f?.addArgs||f?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(f){this.z.publicLog2("update:error",{messageHash:String((0,M.$9i)(String(f)))}),this.j.error("UpdateService error:",f);const l=this.state.type==="checking for updates"&&this.state.explicit?f:void 0;this.d(m.$3W.Idle(1,l))}s(f){let l;this.k.darwinUniversalAssetId?l=this.k.darwinUniversalAssetId:l=process.arch==="x64"?"darwin":"darwin-arm64";const d=(0,v.$_ac)(l,f,this.k);try{n.autoUpdater.setFeedURL({url:d})}catch(a){this.j.error("Failed to set update feed URL",a);return}return d}t(f){this.d(m.$3W.CheckingForUpdates(f)),n.autoUpdater.checkForUpdates()}E(){this.state.type==="checking for updates"&&this.d(m.$3W.Downloading)}F(f){this.state.type==="downloading"&&(this.d(m.$3W.Downloaded(f)),this.z.publicLog2("update:downloaded",{version:f.version}),this.d(m.$3W.Ready(f)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(m.$3W.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),n.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$bbc=w,Ee([j.$Mh],w.prototype,"v",null),Ee([j.$Mh],w.prototype,"w",null),Ee([j.$Mh],w.prototype,"x",null),Ee([j.$Mh],w.prototype,"y",null),e.$bbc=w=Ee([ne(0,c.$gac),ne(1,E.$Oi),ne(2,g.$Nl),ne(3,h.$O_b),ne(4,k.$zp),ne(5,p.$Oj),ne(6,y.$8j)],w)}),define(oe[293],ae([0,1,49,43,8,3,9,24,20,5,28,50]),function(K,e,n,j,P,M,S,E,h,c,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dbc=void 0;let k=class{get state(){return this.a}d(v){this.g.info("update#setState",v.type),this.a=v,this.b.fire(v)}constructor(v,w,$){if(this.f=v,this.g=$,this.a=y.$3W.Uninitialized,this.b=new M.$7d,this.onStateChange=this.b.event,w.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(y.$3W.Idle(this.k())),this.h(30*1e3).then(void 0,f=>this.g.error(f))}h(v=60*60*1e3){return(0,P.$jh)(v).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(v){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(v)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(v){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(v=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${v}`),!v&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(v){}};k=Ee([ne(0,h.$gac),ne(1,E.$O_b),ne(2,c.$Oj)],k);let g=class extends k{constructor(v,w,$,f,l,d){super($,f,l),this.o=v,this.p=w,this.q=d;const a=(0,j.watch)(S.$nc(this.o)),t=M.Event.fromNodeEventEmitter(a,"change",(s,u)=>u),o=M.Event.filter(t,s=>s==="current"),i=M.Event.debounce(o,(s,u)=>u,2e3)(()=>this.checkForUpdates(!1));$.onWillShutdown(()=>{i.dispose(),a.close()})}m(){this.d(y.$3W.CheckingForUpdates(!1)),this.u().then(v=>{v?this.d(y.$3W.Ready({version:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(y.$3W.Idle(2)))},v=>{this.g.error(v),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(y.$3W.Idle(2,v.message||v))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,n.spawn)("sleep 3 && "+S.$oc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const v=await new Promise(($,f)=>(0,j.realpath)(`${S.$nc(this.o)}/current`,(l,d)=>l?f(l):$(d))),w=S.$oc(v);return this.p!==w}isLatestVersion(){return this.u().then(void 0,v=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$dbc=g,e.$dbc=g=Ee([ne(2,h.$gac),ne(3,E.$O_b),ne(4,c.$Oj),ne(5,p.$Nl)],g)}),define(oe[29],ae([0,1,14,4,6,81,55,69,27,18,24,9,138]),function(K,e,n,j,P,M,S,E,h,c,p,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.$Z_b=void 0,e.$1_b=m,e.$2_b=v,e.$Z_b=(0,P.$ii)("windowsMainService");var g;(function($){$[$.CLI=0]="CLI",$[$.DOCK=1]="DOCK",$[$.MENU=2]="MENU",$[$.DIALOG=3]="DIALOG",$[$.DESKTOP=4]="DESKTOP",$[$.API=5]="API"})(g||(e.OpenContext=g={}));function m($,f,l){const d=$.get(E.$X_b),a=$.get(h.$8j),t=$.get(c.$Oi),o=$.get(p.$O_b),r=t.getValue("window"),i={backgroundColor:d.getBackgroundColor(),minWidth:S.$_C.WIDTH,minHeight:S.$_C.HEIGHT,title:a.nameLong,...l,x:f.x,y:f.y,width:f.width,height:f.height,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,S.$kD)(f.zoomLevel??r?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...l?.webPreferences,sandbox:!0},experimentalDarkMode:!0};if(j.$k?i.icon=(0,y.$kc)(o.appRoot,"resources/linux/code.png"):j.$i&&!o.isBuilt&&(i.icon=(0,y.$kc)(o.appRoot,"resources/win32/code_150x150.png")),j.$j&&(i.acceptFirstMouse=!0,r?.clickThroughInactive===!1&&(i.acceptFirstMouse=!1)),j.$j&&!(0,S.$jD)(t)&&(i.fullscreenable=!1),j.$j&&r?.nativeTabs===!0&&(i.tabbingIdentifier=a.nameShort),!(0,S.$gD)(t)&&(i.titleBarStyle="hidden",j.$j||(i.frame=!1),(0,S.$iD)(t))){const b=d.getWindowSplash()?.colorInfo.titleBarBackground??d.getBackgroundColor(),C=k.$Gt.fromHex(b).isDarker()?"#FFFFFF":"#000000";i.titleBarOverlay={height:29,color:b,symbolColor:C}}return i}function v($){let f,l=Number.MIN_VALUE;for(const d of $)d.lastFocusTime>l&&(l=d.lastFocusTime,f=d);return f}var w;(function($){function f(d,a,t=n.screen.getAllDisplays()){if(d.trace(`window#validateWindowState: validating window state on ${t.length} display(s)`,a),typeof a.x!="number"||typeof a.y!="number"||typeof a.width!="number"||typeof a.height!="number"){d.trace("window#validateWindowState: unexpected type of state values");return}if(a.width<=0||a.height<=0){d.trace("window#validateWindowState: unexpected negative values");return}if(t.length===1){const i=l(t[0]);if(d.trace("window#validateWindowState: single monitor working area",i),i){let s=function(){!a||typeof a.x!="number"||typeof a.y!="number"||!i||(a.x<i.x&&(a.x=i.x),a.y<i.y&&(a.y=i.y))};s(),a.width>i.width&&(a.width=i.width),a.height>i.height&&(a.height=i.height),a.x>i.x+i.width-128&&(a.x=i.x+i.width-a.width),a.y>i.y+i.height-128&&(a.y=i.y+i.height-a.height),s()}return a}if(a.display&&a.mode===3){const i=t.find(s=>s.id===a.display);if(i&&typeof i.bounds?.x=="number"&&typeof i.bounds?.y=="number"){d.trace("window#validateWindowState: restoring fullscreen to previous display");const s=(0,M.$M_b)(3);return s.x=i.bounds.x,s.y=i.bounds.y,s}}let o,r;try{o=n.screen.getDisplayMatching({x:a.x,y:a.y,width:a.width,height:a.height}),r=l(o),d.trace("window#validateWindowState: multi-monitor working area",r)}catch(i){d.error("window#validateWindowState: error finding display for window state",i)}if(o&&r&&a.x+a.width>r.x&&a.y+a.height>r.y&&a.x<r.x+r.width&&a.y<r.y+r.height)return a;d.trace("window#validateWindowState: state is outside of the multi-monitor working area")}$.validateWindowState=f;function l(d){if(d.workArea.width>0&&d.workArea.height>0)return d.workArea;if(d.bounds.width>0&&d.bounds.height>0)return d.bounds}})(w||(e.WindowStateValidator=w={}))}),define(oe[294],ae([0,1,14,23,3,46,2,33,120,5,83,29]),function(K,e,n,j,P,M,S,E,h,c,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qac=void 0;var k;(function(m){m[m.Initial=1]="Initial",m[m.StoredCredentialsUsed=2]="StoredCredentialsUsed",m[m.LoginDialogShown=3]="LoginDialogShown"})(k||(k={}));let g=class extends S.$Uc{constructor(v,w,$,f){super(),this.g=v,this.h=w,this.j=$,this.m=f,this.a="proxy-credentials://",this.b=void 0,this.c=k.Initial,this.f=void 0,this.n()}n(){const v=P.Event.fromNodeEventEmitter(n.app,"login",(w,$,f,l,d)=>({event:w,webContents:$,req:f,authInfo:l,callback:d}));this.B(v(this.r,this))}async r({event:v,authInfo:w,req:$,callback:f}){if(!w.isProxy)return;if(!this.b&&this.c===k.LoginDialogShown&&$.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}v.preventDefault();let l;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),l=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(w);try{l=await this.b}finally{this.b=void 0}}f(l?.username,l?.password)}async s(v){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const w=await this.t(v);if(w)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),w;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(v){this.g.trace("auth#doResolveProxyCredentials - enter",v);const w=String((0,M.$9i)({scheme:v.scheme,host:v.host,port:v.port}));let $,f;try{const t=this.m.get(this.a+w,-1);if(t){const o=JSON.parse(await this.j.decrypt(t));$=o.username,f=o.password}}catch(t){this.g.error(t)}if(this.c!==k.StoredCredentialsUsed&&typeof $=="string"&&typeof f=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=k.StoredCredentialsUsed,{username:$,password:f};const l=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!l){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${l.id} to handle proxy login`);const d={authInfo:v,username:this.f?.username??$,password:this.f?.password??f,replyChannel:`vscode:proxyAuthResponse:${(0,E.$Eg)()}`};l.sendWhenReady("vscode:openProxyAuthenticationDialog",j.CancellationToken.None,d),this.c=k.LoginDialogShown;const a=await new Promise(t=>{const o=async(r,i,s)=>{if(i===d.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${l.id}`),l.win?.webContents.off("ipc-message",o),s){const u={username:s.username,password:s.password};try{if(s.remember){const b=await this.j.encrypt(JSON.stringify(u));this.m.store(this.a+w,b,-1,1)}else this.m.remove(this.a+w,-1)}catch(b){this.g.error(b)}t({username:u.username,password:u.password})}else t(void 0)};l.win?.webContents.on("ipc-message",o)});return this.f=a,a}};e.$qac=g,e.$qac=g=Ee([ne(0,c.$Oj),ne(1,y.$Z_b),ne(2,h.$NW),ne(3,p.$oac)],g)}),define(oe[295],ae([0,1,14,22,4,7,21,18,64,6,5,131,29]),function(K,e,n,j,P,M,S,E,h,c,p,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sac=e.$Rac=e.ID=void 0,e.ID="launchMainService",e.$Rac=(0,c.$ii)(e.ID);let g=class{constructor(v,w,$,f){this.a=v,this.b=w,this.c=$,this.d=f}async start(v,w){this.a.trace("Received data from other instance: ",v,w),P.$j&&n.app.focus({steal:!0});const $=this.e(v);if($.length){let f=Promise.resolve();if(this.b.getWindowCount()===0){const l=(0,j.$Ob)(await this.b.openEmptyWindow({context:4}));l&&(f=l.ready())}f.then(()=>{for(const{uri:l,originalUrl:d}of $)this.c.open(l,{originalUrl:d})})}else return this.f(v,w)}e(v){return v["open-url"]&&v._urls&&v._urls.length>0?(0,j.$Hb)(v._urls.map(w=>{try{return{uri:M.URI.parse(w),originalUrl:w}}catch{return null}})):[]}async f(v,w){const $=(0,h.$mm)(w)?0:4;let f=[];const l=v.wait&&v.waitMarkerFilePath?M.URI.file(v.waitMarkerFilePath):void 0,d=v.remote||void 0,a={context:$,cli:v,userEnv:v["preserve-env"]||$===0?w:void 0,waitMarkerFileURI:l,remoteAuthority:d,forceProfile:v.profile,forceTempProfile:v["profile-temp"]};if(v.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(v.extensionDevelopmentPath,a);else if(!v._.length&&!v["folder-uri"]&&!v["file-uri"]){let t=!1;if(v["new-window"]||v["unity-launch"]||a.forceProfile||a.forceTempProfile)t=!0;else if(v["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!P.$j}if(t)f=await this.b.open({...a,forceNewWindow:!0,forceEmpty:!0});else{const o=this.b.getLastActiveWindow();o?(this.b.openExistingWindow(o,a),f=[o]):f=await this.b.open({...a,forceEmpty:!0})}}else f=await this.b.open({...a,forceNewWindow:v["new-window"],preferNewWindow:!v["reuse-window"]&&!v.wait,forceReuseWindow:v["reuse-window"],diffMode:v.diff,mergeMode:v.merge,addMode:v.add,noRecentEntry:!!v["skip-add-to-recently-opened"],gotoLineMode:v.goto});if(l&&f.length===1&&f[0])return Promise.race([f[0].whenClosedOrLoaded,(0,S.whenDeleted)(l.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$Sac=g,e.$Sac=g=Ee([ne(0,p.$Oj),ne(1,k.$Z_b),ne(2,y.$TW),ne(3,E.$Oi)],g)}),define(oe[296],ae([0,1,2,20,57,30,8,29]),function(K,e,n,j,P,M,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vbc=void 0;let h=class extends n.$Uc{constructor(p,y,k){super(),this.a=y,this.b=k,this.B(p.onWillLoadWindow(g=>{g.reason===2&&this.c(g.window)})),this.B(p.onBeforeCloseWindow(g=>this.c(g))),this.B(new S.$uh(()=>this.g(),30*1e3)).schedule()}async c(p){const y=this.f(p),k=this.a.getProfileForWorkspace(y);k?.isTransient&&(this.a.unsetWorkspace(y,k.isTransient),k.isTransient&&await this.a.cleanUpTransientProfiles())}f(p){return p.openedWorkspace??(0,M.$wi)(p.backupPath,p.isExtensionDevelopmentHost)}g(){const p=this.a.getAssociatedEmptyWindows();if(p.length===0)return;const y=this.b.getWindows().map(k=>this.f(k));for(const k of p)y.some(g=>g.id===k.id)||this.a.unsetWorkspace(k,!1)}};e.$vbc=h,e.$vbc=h=Ee([ne(0,j.$gac),ne(1,P.$3_b),ne(2,E.$Z_b)],h)}),define(oe[61],ae([0,1,14,2,3,5,316,8,13,29,73,28,20,75,35,4,102]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g,m,v,w){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$uac=e.$tac=void 0;function f(a){return typeof a.responseWindowId=="number"}let l=class extends j.$Uc{static{$=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from($.b.values())}constructor(t,o,r){super(),this.u=t,this.w=o,this.y=r,this.c=String(++$.a),this.f=this.B(new P.$7d),this.onStdout=this.f.event,this.g=this.B(new P.$7d),this.onStderr=this.g.event,this.h=this.B(new P.$7d),this.onMessage=this.h.event,this.j=this.B(new P.$7d),this.onSpawn=this.j.event,this.m=this.B(new P.$7d),this.onExit=this.m.event,this.n=this.B(new P.$7d),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0}z(t,o){let r;switch(this.t?.correlationId?r=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`:r=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`,o){case p.default.Error:this.u.error(r);break;case p.default.Warning:this.u.warn(r);break;case p.default.Info:this.u.trace(r);break}}C(){return this.r?(this.z("Cannot start utility process because it is already running...",p.default.Error),!1):!0}start(t){const o=this.D(t);return o&&t.payload&&this.postMessage(t.payload)&&this.z("payload sent via postMessage()",p.default.Info),o}D(t){if(!this.C())return!1;this.t=t;const o=`${this.t.type}-${this.c}`,r=h.$Cg.asFileUri("bootstrap-fork.js").fsPath,i=this.t.args??[],s=this.t.execArgv??[],u=this.t.allowLoadingUnsignedLibraries,b=this.t.forceAllocationsToV8Sandbox,C="pipe",I=this.F(t);return this.z("creating new...",p.default.Info),this.r=n.utilityProcess.fork(r,i,{serviceName:o,env:I,execArgv:s,allowLoadingUnsignedLibraries:u,forceAllocationsToV8Sandbox:b,stdio:C}),this.G(this.r,this.t,o),!0}F(t){const o=t.env?{...t.env}:{...(0,m.$On)(process.env)};o.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,v.$i&&((0,w.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,w.getUNCHostAllowlist)().join("\\")),(0,g.$_l)(o);for(const r of Object.keys(o))o[r]=String(o[r]);return o}G(t,o,r){if(t.stdout){const i=new S.StringDecoder("utf-8");this.B(P.Event.fromNodeEventEmitter(t.stdout,"data")(s=>this.f.fire(typeof s=="string"?s:i.write(s))))}if(t.stderr){const i=new S.StringDecoder("utf-8");this.B(P.Event.fromNodeEventEmitter(t.stderr,"data")(s=>this.g.fire(typeof s=="string"?s:i.write(s))))}this.B(P.Event.fromNodeEventEmitter(t,"message")(i=>this.h.fire(i))),this.B(P.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.s=t.pid,typeof t.pid=="number"&&$.b.set(t.pid,{pid:t.pid,name:f(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.z("successfully created",p.default.Info),this.j.fire(t.pid)})),this.B(P.Event.fromNodeEventEmitter(t,"exit")(i=>{this.z(`received exit event with code ${i}`,p.default.Info),this.m.fire({pid:this.s,code:i,signal:"unknown"}),this.H()})),this.B(P.Event.fromNodeEventEmitter(n.app,"child-process-gone",(i,s)=>({event:i,details:s}))(({details:i})=>{i.type==="Utility"&&i.name===r&&(this.z(`crashed with code ${i.exitCode} and reason '${i.reason}'`,p.default.Error),this.w.publicLog2("utilityprocesscrash",{type:o.type,reason:i.reason,code:i.exitCode}),this.n.fire({pid:this.s,code:i.exitCode,reason:i.reason}),this.H())}))}once(t,o){const r=this.B(this.h.event(i=>{i===t&&(r.dispose(),o())}))}postMessage(t,o){return this.r?(this.r.postMessage(t,o),!0):!1}connect(t){const{port1:o,port2:r}=new n.MessageChannelMain;return this.postMessage(t,[r]),o}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.z("enabling inspect port",p.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.z("attempting to kill the process...",p.default.Info),this.r.kill()?(this.z("successfully killed the process",p.default.Info),this.H()):this.z("unable to kill the process",p.default.Warning)}H(){typeof this.s=="number"&&$.b.delete(this.s),this.r=void 0}async waitForExit(t){this.r&&(this.z("waiting to exit...",p.default.Info),await Promise.race([P.Event.toPromise(this.onExit),(0,E.$jh)(t)]),this.r&&(this.z(`did not exit within ${t}ms, will kill it now...`,p.default.Info),this.kill()))}};e.$tac=l,e.$tac=l=$=Ee([ne(0,M.$Oj),ne(1,y.$Nl),ne(2,k.$gac)],l);let d=class extends l{constructor(t,o,r,i){super(t,r,i),this.I=o}start(t){const o=this.I.getWindowById(t.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.z("Refusing to start utility process because requesting window cannot be found or is destroyed...",p.default.Error),!0;if(!super.D(t))return!1;this.J(o.win,t);const i=this.connect(t.payload);return o.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}J(t,o){o.windowLifecycleBound&&(this.B(P.Event.filter(this.y.onWillLoadWindow,r=>r.window.win===t)(()=>this.kill())),this.B(P.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$uac=d,e.$uac=d=Ee([ne(0,M.$Oj),ne(1,c.$Z_b),ne(2,y.$Nl),ne(3,k.$gac)],d)}),define(oe[297],ae([0,1,15,3,5,20,8,61,29,28]),function(K,e,n,j,P,M,S,E,h,c){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Bac=void 0;let y=class{static{p=this}static{this.a=0}constructor(g,m,v,w){this.d=g,this.f=m,this.g=v,this.h=w,this.b=new Map,this.c=!1,this.f.onWillShutdown($=>{this.c=!0,$.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(g){const m=this.b.get(g);if(!m)throw new Error("Unknown extension host!");return m}onDynamicStdout(g){return this.i(g).onStdout}onDynamicStderr(g){return this.i(g).onStderr}onDynamicMessage(g){return this.i(g).onMessage}onDynamicExit(g){return this.i(g).onExit}async createExtensionHost(){if(this.c)throw(0,n.$6)();const g=String(++p.a),m=new E.$uac(this.d,this.g,this.h,this.f);return this.b.set(g,m),m.onExit(({pid:v,code:w,signal:$})=>{this.d.info(`Extension host with pid ${v} exited with code: ${w}, signal: ${$}.`),setTimeout(()=>{m.dispose(),this.b.delete(g)}),setTimeout(()=>{try{process.kill(v,0),this.d.error(`Extension host with pid ${v} still exists, forcefully killing it...`),process.kill(v)}catch{}},1e3)}),{id:g}}async start(g,m){if(this.c)throw(0,n.$6)();const v=this.i(g);return v.start({...m,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:m.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:g}),{pid:await j.Event.toPromise(v.onSpawn)}}async enableInspectPort(g){if(this.c)throw(0,n.$6)();const m=this.b.get(g);return m?m.enableInspectPort():!1}async kill(g){if(this.c)throw(0,n.$6)();const m=this.b.get(g);m&&m.kill()}async _killAllNow(){for(const[,g]of this.b)g.kill()}async _waitForAllExit(g){const m=[];for(const[,v]of this.b)m.push(v.waitForExit(g));return S.Promises.settled(m).then(()=>{})}};e.$Bac=y,e.$Bac=y=p=Ee([ne(0,P.$Oj),ne(1,M.$gac),ne(2,h.$Z_b),ne(3,c.$Nl)],y)}),define(oe[298],ae([0,1,37,8,2,24,20,5,41,39,67,61,54,91,12,251]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ac=void 0;let w=class extends P.$Uc{constructor(f,l,d,a,t,o,r,i){super(),this.f=f,this.g=l,this.h=d,this.j=a,this.m=t,this.n=o,this.r=r,this.s=i,this.a=new j.$hh,this.b=void 0,this.c=void 0,this.y=void 0,this.z=void 0,this.t()}t(){n.$5V.on(v.$4ac.request,(f,l)=>this.u(f,l,v.$4ac.response)),n.$5V.on(v.$5ac.request,(f,l)=>this.u(f,l,v.$5ac.response)),this.B(this.m.onWillShutdown(()=>this.w()))}async u(f,l,d){this.n.trace(`[SharedProcess] onWindowConnection for: ${d}`),this.a.isOpen()||this.a.open(),await this.whenReady();const a=await this.connect(d);if(f.sender.isDestroyed())return a.close();f.sender.postMessage(d,l,[a])}w(){this.n.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(v.$3ac.exit),this.b=void 0}whenReady(){return this.y||(this.y=(async()=>{await this.C;const f=new j.$Fh;this.b?.once(v.$3ac.initDone,()=>f.complete()),await f.p,this.c?.dispose(),this.n.trace("[SharedProcess] Overall ready")})()),this.y}get C(){return this.z||(this.z=(async()=>{await this.a.wait(),this.D();const f=new j.$Fh;this.b?.once(v.$3ac.ipcReady,()=>f.complete()),await f.p,this.n.trace("[SharedProcess] IPC ready")})()),this.z}D(){this.b=this.B(new y.$tac(this.n,k.$6o,this.m)),this.c=this.b.onMessage(d=>{typeof d.warning=="string"?this.n.warn(d.warning):typeof d.error=="string"&&this.n.error(d.error)});const f=(0,g.$Wm)(this.h.args,this.h.isBuilt);let l;f.port&&(l=["--nolazy"],f.break?l.push(`--inspect-brk=${f.port}`):l.push(`--inspect=${f.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.F(),execArgv:l})}F(){return{machineId:this.f,sqmId:this.g,codeCachePath:this.h.codeCachePath,profiles:{home:this.j.profilesHome,all:this.j.profiles},args:this.h.args,logLevel:this.r.getLogLevel(),loggers:this.r.getRegisteredLoggers(),policiesData:this.s.serialize()}}async connect(f){return await this.C,(0,m.$7f)(this.b).connect(f)}};e.$6ac=w,e.$6ac=w=Ee([ne(2,M.$O_b),ne(3,h.$ol),ne(4,S.$gac),ne(5,E.$Oj),ne(6,p.$bac),ne(7,c.$3n)],w)}),define(oe[299],ae([0,1,24,91,20,5,54,61,114,37,2,3,35,18,13]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fbc=void 0;let v=class extends p.$Uc{constructor($,f,l,d,a){super(),this.f=$,this.g=f,this.h=l,this.j=d,this.m=a,this.a=void 0,this.b=new y.$7d,this.onRequestConnection=this.b.event,this.c=new y.$7d,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),c.$5V.on("vscode:createPtyHostMessageChannel",(t,o)=>this.r(t,o)),this.B((0,p.$Sc)(()=>{c.$5V.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new E.$tac(this.m,S.$6o,this.j);const $=(0,j.$Vm)(this.h.args,this.h.isBuilt),f=$.port?["--nolazy",`--inspect${$.break?"-brk":""}=${$.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:f,args:["--logsPath",this.h.logsHome.with({scheme:m.Schemas.file}).fsPath],env:this.n()});const l=this.a.connect(),d=new h.$aW(l,"ptyHost"),a=new p.$Tc;return a.add(d),a.add((0,p.$Sc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:d,store:a,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const $={...(0,k.$On)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},f=this.g.getValue("terminal.integrated.developer.ptyHost.latency");f&&typeof f=="number"&&($.VSCODE_LATENCY=String(f));const l=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return l&&typeof l=="number"&&($.VSCODE_STARTUP_DELAY=String(l)),this.h.restoreSnapExportedVariables(),$}r($,f){this.b.fire();const l=this.a.connect();if($.sender.isDestroyed()){l.close();return}$.sender.postMessage("vscode:createPtyHostMessageChannelResult",f,[l])}};e.$Fbc=v,e.$Fbc=v=Ee([ne(1,g.$Oi),ne(2,n.$O_b),ne(3,P.$gac),ne(4,M.$Oj)],v)}),define(oe[300],ae([0,1,2,6,5,29,61,28,46,3,8,20]),function(K,e,n,j,P,M,S,E,h,c,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ebc=e.$Dbc=void 0,e.$Dbc=(0,j.$ii)("utilityProcessWorker");let k=class extends n.$Uc{constructor(v,w,$,f){super(),this.b=v,this.c=w,this.f=$,this.g=f,this.a=new Map}async createWorker(v){const w=`window: ${v.reply.windowId}, moduleId: ${v.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${w})`);const $=this.h(v);this.a.has($)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${w})`),this.disposeWorker(v));const f=new g(this.b,this.c,this.f,this.g,v);if(!f.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set($,f);const l=new p.$Fh;return c.Event.once(f.onDidTerminate)(d=>{d.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${d.code}, signal: ${d.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${d.code}, signal: ${d.signal}`),this.a.delete($),l.complete({reason:d})}),l.p}h(v){return(0,h.$9i)({moduleId:v.process.moduleId,windowId:v.reply.windowId})}async disposeWorker(v){const w=this.h(v),$=this.a.get(w);$&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${v.reply.windowId}, moduleId: ${v.process.moduleId})`),$.kill(),this.a.delete(w))}};e.$Ebc=k,e.$Ebc=k=Ee([ne(0,P.$Oj),ne(1,M.$Z_b),ne(2,E.$Nl),ne(3,y.$gac)],k);let g=class extends n.$Uc{constructor(v,w,$,f,l){super(),this.c=v,this.f=w,this.g=$,this.h=f,this.j=l,this.a=this.B(new c.$7d),this.onDidTerminate=this.a.event,this.b=new S.$uac(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(v=>this.a.fire({code:v.code,signal:v.signal}))),this.B(this.b.onCrash(v=>this.a.fire({code:v.code,signal:"ECRASH"})))}spawn(){const w=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:w,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};g=Ee([ne(0,P.$Oj),ne(1,M.$Z_b),ne(2,E.$Nl),ne(3,y.$gac)],g)}),define(oe[301],ae([0,1,14,3,2,277,29]),function(K,e,n,j,P,M,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lbc=void 0;let E=class extends P.$Uc{constructor(c){super(),this.b=c,this.a=this.B(new j.$7d),this.onFoundInFrame=this.a.event,this.B(new M.$kbc)}async setIgnoreMenuShortcuts(c,p){let y;if(typeof c.windowId=="number"){const{windowId:k}=c,g=this.b.getWindowById(k);if(!g?.win)throw new Error(`Invalid windowId: ${k}`);y=g.win.webContents}else{const{webContentsId:k}=c;if(y=n.webContents.fromId(k),!y)throw new Error(`Invalid webContentsId: ${k}`)}y.isDestroyed()||y.setIgnoreMenuShortcuts(p)}async findInFrame(c,p,y,k){const m=this.c(c,p);if(typeof m.findInFrame=="function"){m.findInFrame(y,{findNext:k.findNext,forward:k.forward});const v=(w,$)=>{$.finalUpdate&&(this.a.fire($),m.removeListener("found-in-frame",v))};m.on("found-in-frame",v)}}async stopFindInFrame(c,p,y){const g=this.c(c,p);typeof g.stopFindInFrame=="function"&&g.stopFindInFrame(y.keepSelection?"keepSelection":"clearSelection")}c(c,p){const y=this.b.getWindowById(c.windowId);if(!y?.win)throw new Error(`Invalid windowId: ${c}`);const k=y.win.webContents.mainFrame.framesInSubtree.find(g=>g.name===p);if(!k)throw new Error(`Unknown frame: ${p}`);return k}};e.$lbc=E,e.$lbc=E=Ee([ne(0,S.$Z_b)],E)}),define(oe[302],ae([0,1,14,2,4,19,7,18,20,5,34,29,81,30]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$mbc=void 0,e.$nbc=w,e.$obc=f;let v=class extends j.$Uc{static{m=this}static{this.a="windowsState"}get state(){return this.b}constructor(a,t,o,r,i){super(),this.g=a,this.h=t,this.j=o,this.m=r,this.n=i,this.b=w(this.h.getItem(m.a)),this.c=void 0,this.f=!1,this.r()}r(){n.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(a=>this.u(a)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(a=>{a.newCount-a.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(a=>this.u(a))}s(){this.f=!0,this.t()}t(){const a=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(s=>!s.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.w(i),t.lastActiveWindow.uiState.mode===3&&a.add(t.lastActiveWindow.uiState.display))}const o=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);o&&(t.lastPluginDevelopmentHostWindow=this.w(o),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(a.has(t.lastPluginDevelopmentHostWindow.uiState.display)?P.$j&&!o.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):a.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const s=this.w(i);return s.uiState.mode===3&&(a.has(s.uiState.display)?P.$j&&s.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(s.uiState.mode=1):a.add(s.uiState.display)),s}));const r=f(t);this.h.setItem(m.a,r),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",r)}u(a){if(this.j.quitRequested)return;const t=this.w(a);a.isExtensionDevelopmentHost&&!a.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!a.isExtensionDevelopmentHost&&a.openedWorkspace&&this.b.openedWindows.forEach(o=>{const r=(0,g.$xi)(a.openedWorkspace)&&o.workspace?.id===a.openedWorkspace.id,i=(0,g.$si)(a.openedWorkspace)&&o.folderUri&&M.$Mg.isEqual(o.folderUri,a.openedWorkspace.uri);(r||i)&&(o.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}w(a){return{windowId:a.id,workspace:(0,g.$xi)(a.openedWorkspace)?a.openedWorkspace:void 0,folderUri:(0,g.$si)(a.openedWorkspace)?a.openedWorkspace.uri:void 0,backupPath:a.backupPath,remoteAuthority:a.remoteAuthority,uiState:a.serializeWindowState()}}getNewWindowState(a){const t=this.z(a),o=this.n.getValue("window");if(t.mode===3){let r;t.hasDefaultState?r=!!(o?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(o.newWindowDimensions)>=0):r=!!(this.j.wasRestarted||o?.restoreFullscreen),r||(t.mode=1)}return t}z(a){const t=this.g.getLastActiveWindow();if(!a.extensionTestsPath){if(a.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const b=a.workspace;if((0,g.$xi)(b)){const I=this.state.openedWindows.filter(D=>D.workspace&&D.workspace.id===b.id).map(D=>D.uiState);if(I.length)return I[0]}if((0,g.$si)(b)){const I=this.state.openedWindows.filter(D=>D.folderUri&&M.$Mg.isEqual(D.folderUri,b.uri)).map(D=>D.uiState);if(I.length)return I[0]}else if(a.backupPath){const I=this.state.openedWindows.filter(D=>D.backupPath===a.backupPath).map(D=>D.uiState);if(I.length)return I[0]}const C=this.c||this.state.lastActiveWindow;if(!t&&C)return C.uiState}let o;const r=n.screen.getAllDisplays();if(r.length===1)o=r[0];else{if(P.$j){const b=n.screen.getCursorScreenPoint();o=n.screen.getDisplayNearestPoint(b)}!o&&t&&(o=n.screen.getDisplayMatching(t.getBounds())),o||(o=n.screen.getPrimaryDisplay()||r[0])}let i=(0,k.$M_b)();i.x=Math.round(o.bounds.x+o.bounds.width/2-i.width/2),i.y=Math.round(o.bounds.y+o.bounds.height/2-i.height/2);const s=this.n.getValue("window");let u=!0;if(s?.newWindowDimensions){if(s.newWindowDimensions==="maximized")i.mode=0,u=!1;else if(s.newWindowDimensions==="fullscreen")i.mode=3,u=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&t){const b=t.serializeWindowState();b.mode===3?i.mode=3:i={...b,zoomLevel:void 0},u=i.mode!==3&&s.newWindowDimensions==="offset"}}return u&&(i=this.C(i)),i.hasDefaultState=!0,i}C(a){if(this.g.getWindows().length===0)return a;a.x=typeof a.x=="number"?a.x:0,a.y=typeof a.y=="number"?a.y:0;const t=this.g.getWindows().map(o=>o.getBounds());for(;t.some(o=>o.x===a.x||o.y===a.y);)a.x+=30,a.y+=30;return a}};e.$mbc=v,e.$mbc=v=m=Ee([ne(0,y.$Z_b),ne(1,p.$WP),ne(2,h.$gac),ne(3,c.$Oj),ne(4,E.$Oi)],v);function w(d){const a={openedWindows:[]},t=d||{openedWindows:[]};return t.lastActiveWindow&&(a.lastActiveWindow=$(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(a.lastPluginDevelopmentHostWindow=$(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(a.openedWindows=t.openedWindows.map(o=>$(o))),a}function $(d){const a={uiState:d.uiState};return d.backupPath&&(a.backupPath=d.backupPath),d.remoteAuthority&&(a.remoteAuthority=d.remoteAuthority),d.folder&&(a.folderUri=S.URI.parse(d.folder)),d.workspaceIdentifier&&(a.workspace={id:d.workspaceIdentifier.id,configPath:S.URI.parse(d.workspaceIdentifier.configURIPath)}),a}function f(d){return{lastActiveWindow:d.lastActiveWindow&&l(d.lastActiveWindow),lastPluginDevelopmentHostWindow:d.lastPluginDevelopmentHostWindow&&l(d.lastPluginDevelopmentHostWindow),openedWindows:d.openedWindows.map(a=>l(a))}}function l(d){return{workspaceIdentifier:d.workspace&&{id:d.workspace.id,configURIPath:d.workspace.configPath.toString()},folder:d.folderUri&&d.folderUri.toString(),backupPath:d.backupPath,remoteAuthority:d.remoteAuthority,uiState:d.uiState}}}),define(oe[58],ae([0,1,14,3,42,2,13,9,19,21,197,65,56,24,6,5,57,133,30,98,99]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g,m,v,w,$,f,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aac=e.$__b=void 0,e.$__b=(0,m.$ii)("workspacesManagementMainService");let a=class extends M.$Uc{constructor(o,r,i,s,u){super(),this.g=o,this.h=r,this.j=i,this.m=s,this.n=u,this.a=this.B(new j.$7d),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new j.$7d),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await c.Promises.readdir(this.c.with({scheme:S.Schemas.file}).fsPath)).map(r=>(0,h.$Vg)(this.c,r,f.$Hi));for(const r of o){const i=(0,d.$9_b)(r),s=await this.resolveLocalWorkspace(r);s?this.f.push({workspace:i,remoteAuthority:s.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.r(o,r=>c.Promises.readFile(r,"utf8"))}r(o,r){if(this.s(o)&&o.scheme===S.Schemas.file)try{const i=r(o.fsPath);return i instanceof Promise?i.then(s=>this.t(o,s),s=>{}):this.t(o,i)}catch{return}}s(o){return(0,f.$Ii)(o,this.g)||(0,f.$Ni)(o)}t(o,r){try{const i=this.u(o,r),s=(0,d.$9_b)(o);return{id:s.id,configPath:s.configPath,folders:(0,l.$Veb)(i.folders,s.configPath,h.$Mg),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.h.warn(i.toString())}}u(o,r){const i=(0,P.$vn)(r);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(s=>(0,l.$Teb)(s));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(o,r){const{workspace:i,storedWorkspace:s}=this.w(o,r),u=i.configPath.fsPath;return await c.Promises.mkdir((0,E.$nc)(u),{recursive:!0}),await c.Promises.writeFile(u,JSON.stringify(s,null,"	")),this.f.push({workspace:i,remoteAuthority:r}),i}w(o=[],r){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),s=(0,h.$Vg)(this.c,i),u=(0,h.$Vg)(s,f.$Hi),b=[];for(const C of o)b.push((0,l.$Ueb)(C.uri,!0,C.name,s,h.$Mg));return{workspace:(0,d.$9_b)(u),storedWorkspace:{folders:b,remoteAuthority:r}}}async getWorkspaceIdentifier(o){return(0,d.$9_b)(o)}isUntitledWorkspace(o){return(0,f.$Ii)(o.configPath,this.g)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.y(o),this.j.isEnabled()&&this.j.unsetWorkspace(o),this.a.fire(o))}async y(o){const r=(0,h.$Jg)(o.configPath);try{await c.Promises.rm((0,E.$nc)(r));const i=(0,E.$kc)(this.g.workspaceStorageHome.with({scheme:S.Schemas.file}).fsPath,o.id);await c.Promises.exists(i)&&await c.Promises.writeFile((0,E.$kc)(i,"obsolete"),""),this.f=this.f.filter(s=>s.workspace.id!==o.id)}catch(i){this.h.warn(`Unable to delete untitled workspace ${r} (${i}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,r,i){if(!o||!o.win||!o.isReady||!await this.z(o,r,i))return;const u=await this.C(o,(0,d.$9_b)(i));if(u)return this.b.fire({window:o,workspace:u.workspace}),u}async z(o,r,i){return i?(0,f.$xi)(o.openedWorkspace)&&h.$Mg.isEqual(o.openedWorkspace.configPath,i)?!1:(0,$.$6_b)(r,i)?(await this.n.showMessageBox({type:"info",buttons:[(0,p.localize)(0,null)],message:(0,p.localize)(1,null,(0,h.$Sg)(i)),detail:(0,p.localize)(2,null)},n.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(o,r){if(!o.config)return;o.focus();let i;return o.config.extensionDevelopmentPath||(o.config.backupPath?i=await this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority},o.config.backupPath):i=this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority})),(0,f.$xi)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=r,o.config.backupPath=i,{workspace:r,backupPath:i}}};e.$aac=a,e.$aac=a=Ee([ne(0,g.$O_b),ne(1,v.$Oj),ne(2,w.$3_b),ne(3,y.$T_b),ne(4,k.$U_b)],a)}),define(oe[134],ae([0,1,14,37,23,6,29,30,58,12,5,61]),function(K,e,n,j,P,M,S,E,h,c,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xac=e.$wac=e.ID=void 0,e.ID="diagnosticsMainService",e.$wac=(0,M.$ii)(e.ID);let k=class{constructor(m,v,w){this.a=m,this.b=v,this.c=w}async getRemoteDiagnostics(m){const v=this.a.getWindows();return(await Promise.all(v.map(async $=>{const f=$.remoteAuthority;if(!f)return;const l=`vscode:getDiagnosticInfoResponse${$.id}`,d={includeProcesses:m.includeProcesses,folders:m.includeWorkspaceMetadata?await this.f($):void 0};return new Promise(a=>{$.sendWhenReady("vscode:getDiagnosticInfo",P.CancellationToken.None,{replyChannel:l,args:d}),j.$5V.once(l,(t,o)=>{o||a({hostName:f,errorMessage:`Unable to resolve connection to '${f}'.`}),a(o)}),setTimeout(()=>{a({hostName:f,errorMessage:`Connection to '${f}' could not be established`})},5e3)})}))).filter($=>!!$)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const m=[];for(const w of n.BrowserWindow.getAllWindows()){const $=this.a.getWindowById(w.id);$?m.push(await this.d($)):m.push(this.e(w))}const v=[];for(const{pid:w,name:$}of y.$tac.getAll())v.push({pid:w,name:$});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:m,pidToNames:v,screenReader:!!n.app.accessibilitySupportEnabled,gpuFeatureStatus:n.app.getGPUFeatureStatus()}}async d(m){const v=await this.f(m),w=(0,c.$7f)(m.win);return this.e(w,v,m.remoteAuthority)}e(m,v=[],w){return{id:m.id,pid:m.webContents.getOSProcessId(),title:m.getTitle(),folderURIs:v,remoteAuthority:w}}async f(m){const v=[],w=m.openedWorkspace;if((0,E.$si)(w))v.push(w.uri);else if((0,E.$xi)(w)){const $=await this.b.resolveLocalWorkspace(w.configPath);$&&$.folders.forEach(l=>{v.push(l.uri)})}return v}};e.$xac=k,e.$xac=k=Ee([ne(0,S.$Z_b),ne(1,h.$__b),ne(2,p.$Oj)],k)}),define(oe[70],ae([0,1,49,14,26,158,51,3,2,13,9,4,7,109,89,21,107,185,56,24,6,20,5,27,69,29,30,58,17,247,239,78,15]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g,m,v,w,$,f,l,d,a,t,o,r,i,s,u,b,C,I,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mac=e.$Lac=void 0,e.$Lac=(0,d.$ii)("nativeHostMainService");let R=class extends h.$Uc{constructor(F,q,x,le,te,ue,Y,Z,B){super(),this.a=F,this.b=q,this.c=x,this.f=le,this.g=te,this.h=ue,this.j=Y,this.m=Z,this.n=B,this.onDidOpenMainWindow=E.Event.map(this.a.onDidOpenWindow,L=>L.id),this.onDidTriggerWindowSystemContextMenu=E.Event.any(E.Event.filter(E.Event.map(this.a.onDidTriggerSystemContextMenu,({window:L,x:T,y:G})=>({windowId:L.id,x:T,y:G})),({windowId:L})=>!!this.a.getWindowById(L)),E.Event.filter(E.Event.map(this.b.onDidTriggerSystemContextMenu,({window:L,x:T,y:G})=>({windowId:L.id,x:T,y:G})),({windowId:L})=>!!this.b.getWindowById(L))),this.onDidMaximizeWindow=E.Event.any(E.Event.filter(E.Event.map(this.a.onDidMaximizeWindow,L=>L.id),L=>!!this.a.getWindowById(L)),E.Event.filter(E.Event.map(this.b.onDidMaximizeWindow,L=>L.id),L=>!!this.b.getWindowById(L))),this.onDidUnmaximizeWindow=E.Event.any(E.Event.filter(E.Event.map(this.a.onDidUnmaximizeWindow,L=>L.id),L=>!!this.a.getWindowById(L)),E.Event.filter(E.Event.map(this.b.onDidUnmaximizeWindow,L=>L.id),L=>!!this.b.getWindowById(L))),this.onDidChangeWindowFullScreen=E.Event.any(E.Event.map(this.a.onDidChangeFullScreen,L=>({windowId:L.window.id,fullscreen:L.fullscreen})),E.Event.map(this.b.onDidChangeFullScreen,L=>({windowId:L.window.id,fullscreen:L.fullscreen}))),this.onDidBlurMainWindow=E.Event.filter(E.Event.fromNodeEventEmitter(j.app,"browser-window-blur",(L,T)=>T.id),L=>!!this.a.getWindowById(L)),this.onDidFocusMainWindow=E.Event.any(E.Event.map(E.Event.filter(E.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),L=>!!L),L=>L.id),E.Event.filter(E.Event.fromNodeEventEmitter(j.app,"browser-window-focus",(L,T)=>T.id),L=>!!this.a.getWindowById(L))),this.onDidBlurMainOrAuxiliaryWindow=E.Event.any(this.onDidBlurMainWindow,E.Event.filter(E.Event.fromNodeEventEmitter(j.app,"browser-window-blur",(L,T)=>T.id),L=>!!this.b.getWindowById(L))),this.onDidFocusMainOrAuxiliaryWindow=E.Event.any(this.onDidFocusMainWindow,E.Event.filter(E.Event.fromNodeEventEmitter(j.app,"browser-window-focus",(L,T)=>T.id),L=>!!this.b.getWindowById(L))),this.onDidResumeOS=E.Event.fromNodeEventEmitter(j.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.r=this.B(new E.$7d),this.onDidChangePassword=this.r.event,this.onDidChangeDisplay=E.Event.debounce(E.Event.any(E.Event.filter(E.Event.fromNodeEventEmitter(j.screen,"display-metrics-changed",(L,T,G)=>G),L=>!(Array.isArray(L)&&L.length===1&&L[0]==="workArea")),E.Event.fromNodeEventEmitter(j.screen,"display-added"),E.Event.fromNodeEventEmitter(j.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(F,q){const x=this.a.getWindows().map(te=>({id:te.id,workspace:te.openedWorkspace??(0,s.$wi)(te.backupPath,te.isExtensionDevelopmentHost),title:te.win?.getTitle()??"",filename:te.getRepresentedFilename(),dirty:te.isDocumentEdited()})),le=[];return q.includeAuxiliaryWindows&&le.push(...this.b.getWindows().map(te=>({id:te.id,parentId:te.parentId,title:te.win?.getTitle()??"",filename:te.getRepresentedFilename()}))),[...x,...le]}async getWindowCount(F){return this.a.getWindowCount()}async getActiveWindowId(F){const q=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(q)return q.id}openWindow(F,q,x){return Array.isArray(q)?this.s(F,q,x):this.t(F,q)}async s(F,q,x=Object.create(null)){q.length>0&&await this.a.open({context:5,contextWindowId:F,urisToOpen:q,cli:this.g.args,forceNewWindow:x.forceNewWindow,forceReuseWindow:x.forceReuseWindow,preferNewWindow:x.preferNewWindow,diffMode:x.diffMode,mergeMode:x.mergeMode,addMode:x.addMode,gotoLineMode:x.gotoLineMode,noRecentEntry:x.noRecentEntry,waitMarkerFileURI:x.waitMarkerFileURI,remoteAuthority:x.remoteAuthority||void 0,forceProfile:x.forceProfile,forceTempProfile:x.forceTempProfile})}async t(F,q){await this.a.openEmptyWindow({context:5,contextWindowId:F},q)}async toggleFullScreen(F,q){this.C(q?.targetWindowId,F)?.toggleFullScreen()}async handleTitleDoubleClick(F,q){this.C(q?.targetWindowId,F)?.handleTitleDoubleClick()}async getCursorScreenPoint(F){const q=j.screen.getCursorScreenPoint(),x=j.screen.getDisplayNearestPoint(q);return{point:q,display:x.bounds}}async isMaximized(F,q){return this.C(q?.targetWindowId,F)?.win?.isMaximized()??!1}async maximizeWindow(F,q){this.C(q?.targetWindowId,F)?.win?.maximize()}async unmaximizeWindow(F,q){this.C(q?.targetWindowId,F)?.win?.unmaximize()}async minimizeWindow(F,q){this.C(q?.targetWindowId,F)?.win?.minimize()}async moveWindowTop(F,q){this.C(q?.targetWindowId,F)?.win?.moveTop()}async positionWindow(F,q,x){const le=this.C(x?.targetWindowId,F);if(le?.win){if(le.win.isFullScreen()){const te=E.Event.toPromise(E.Event.once(E.Event.fromNodeEventEmitter(le.win,"leave-full-screen")));le.win.setFullScreen(!1),await te}le.win.setBounds(q)}}async updateWindowControls(F,q){this.C(q?.targetWindowId,F)?.updateWindowControls(q)}async focusWindow(F,q){this.C(q?.targetWindowId,F)?.focus({force:q?.force??!1})}async setMinimumSize(F,q,x){const le=this.D(F);if(le?.win){const[te,ue]=le.win.getSize(),[Y,Z]=le.win.getMinimumSize(),[B,L]=[q??Y,x??Z],[T,G]=[Math.max(te,B),Math.max(ue,L)];(Y!==B||Z!==L)&&le.win.setMinimumSize(B,L),(te!==T||ue!==G)&&le.win.setSize(T,G)}}async saveWindowSplash(F,q){this.m.saveWindowSplash(F,q)}async installShellCommand(F){const{source:q,target:x}=await this.u();try{const{symbolicLink:le}=await v.SymlinkSupport.stat(q);if(le&&!le.dangling){const te=await(0,g.$Pq)(q);if(x===te)return}await v.Promises.unlink(q)}catch(le){if(le.code!=="ENOENT")throw le}try{await v.Promises.symlink(x,q)}catch(le){if(le.code!=="EACCES"&&le.code!=="ENOENT")throw le;const{response:te}=await this.showMessageBox(F,{type:"info",message:(0,$.localize)(0,null,this.j.nameShort),buttons:[(0,$.localize)(1,null),(0,$.localize)(2,null)]});if(te===1)throw new O.$5;try{const ue=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${x}' '${q}'\\" with administrator privileges"`;await(0,M.promisify)(n.exec)(ue)}catch{throw new Error((0,$.localize)(3,null,q))}}}async uninstallShellCommand(F){const{source:q}=await this.u();try{await v.Promises.unlink(q)}catch(x){switch(x.code){case"EACCES":{const{response:le}=await this.showMessageBox(F,{type:"info",message:(0,$.localize)(4,null,this.j.nameShort),buttons:[(0,$.localize)(5,null),(0,$.localize)(6,null)]});if(le===1)throw new O.$5;try{const te=`osascript -e "do shell script \\"rm '${q}'\\" with administrator privileges"`;await(0,M.promisify)(n.exec)(te)}catch{throw new Error((0,$.localize)(7,null,q))}break}case"ENOENT":break;default:throw x}}}async u(){const F=(0,p.$lc)(this.g.appRoot,"bin","code"),q=`/usr/local/bin/${this.j.applicationName}`;if(!await v.Promises.exists(F))throw new Error((0,$.localize)(8,null,F));return{source:q,target:F}}async showMessageBox(F,q){const x=this.C(q?.targetWindowId,F);return this.c.showMessageBox(q,x?.win??void 0)}async showSaveDialog(F,q){const x=this.C(q?.targetWindowId,F);return this.c.showSaveDialog(q,x?.win??void 0)}async showOpenDialog(F,q){const x=this.C(q?.targetWindowId,F);return this.c.showOpenDialog(q,x?.win??void 0)}async pickFileFolderAndOpen(F,q){const x=await this.c.pickFileFolder(q);x&&await this.w(await Promise.all(x.map(async le=>await v.SymlinkSupport.existsDirectory(le)?{folderUri:k.URI.file(le)}:{fileUri:k.URI.file(le)})),q,F)}async pickFolderAndOpen(F,q){const x=await this.c.pickFolder(q);x&&await this.w(x.map(le=>({folderUri:k.URI.file(le)})),q,F)}async pickFileAndOpen(F,q){const x=await this.c.pickFile(q);x&&await this.w(x.map(le=>({fileUri:k.URI.file(le)})),q,F)}async pickWorkspaceAndOpen(F,q){const x=await this.c.pickWorkspace(q);x&&await this.w(x.map(le=>({workspaceUri:k.URI.file(le)})),q,F)}async w(F,q,x){await this.a.open({context:3,contextWindowId:x,cli:this.g.args,urisToOpen:F,forceNewWindow:q.forceNewWindow})}async showItemInFolder(F,q){j.shell.showItemInFolder(q)}async setRepresentedFilename(F,q,x){this.C(x?.targetWindowId,F)?.setRepresentedFilename(q)}async setDocumentEdited(F,q,x){this.C(x?.targetWindowId,F)?.setDocumentEdited(q)}async openExternal(F,q){return this.g.unsetSnapExportedVariables(),j.shell.openExternal(q),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(F,q){return j.shell.trashItem(q)}async isAdmin(){let F;return y.$i?F=(await new Promise((q,x)=>{K(["native-is-elevated"],q,x)}))():F=process.getuid?.()===0,F}async writeElevated(F,q,x,le){const te=await new Promise((ue,Y)=>{K(["@vscode/sudo-prompt"],ue,Y)});return new Promise((ue,Y)=>{const Z=[`"${this.z}"`];le?.unlock&&Z.push("--file-chmod"),Z.push("--file-write",`"${q.fsPath}"`,`"${x.fsPath}"`);const B={name:this.j.nameLong.replace("-",""),icns:y.$j&&this.g.isBuilt?(0,p.$kc)((0,p.$nc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};te.exec(Z.join(" "),B,(L,T,G)=>{T&&this.h.trace(`[sudo-prompt] received stdout: ${T}`),G&&this.h.trace(`[sudo-prompt] received stderr: ${G}`),L?Y(L):ue(void 0)})})}async isRunningUnderARM64Translation(){return y.$k||y.$i?!1:j.app.runningUnderARM64Translation}get z(){return y.$i?this.g.isBuilt?(0,p.$kc)((0,p.$nc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,p.$kc)(this.g.appRoot,"scripts","code-cli.bat"):y.$k?this.g.isBuilt?(0,p.$kc)((0,p.$nc)(process.execPath),"bin",`${this.j.applicationName}`):(0,p.$kc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,p.$kc)(this.g.appRoot,"bin","code"):(0,p.$kc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,P.totalmem)(),freemem:(0,P.freemem)(),loadavg:(0,P.loadavg)()}}async getOSProperties(){return{arch:(0,P.arch)(),platform:(0,P.platform)(),release:(0,P.release)(),type:(0,P.type)(),cpus:(0,P.cpus)()}}async getOSVirtualMachineHint(){return m.$qn.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return y.$i&&(0,C.$Iac)()}async killProcess(F,q,x){process.kill(q,x)}async readClipboardText(F,q){return j.clipboard.readText(q)}async writeClipboardText(F,q,x){return j.clipboard.writeText(q,x)}async readClipboardFindText(F){return j.clipboard.readFindText()}async writeClipboardFindText(F,q){return j.clipboard.writeFindText(q)}async writeClipboardBuffer(F,q,x,le){return j.clipboard.writeBuffer(q,Buffer.from(x.buffer),le)}async readClipboardBuffer(F,q){return b.$ue.wrap(j.clipboard.readBuffer(q))}async hasClipboard(F,q,x){return j.clipboard.has(q,x)}async newWindowTab(){await this.a.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){j.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){j.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){j.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){j.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){j.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(F,q){this.D(F)?.updateTouchBar(q)}async notifyReady(F){this.D(F)?.setReady()}async relaunch(F,q){return this.f.relaunch(q)}async reload(F,q){const x=this.D(F);if(x){if((0,s.$xi)(x.openedWorkspace)){const le=x.openedWorkspace.configPath;if(le.scheme===c.Schemas.file&&(await this.n.resolveLocalWorkspace(le))?.transient)return this.openWindow(x.id,{forceReuseWindow:!0})}return this.f.reload(x,q?.disableExtensions!==void 0?{_:[],"disable-extensions":q.disableExtensions}:void 0)}}async closeWindow(F,q){return this.C(q?.targetWindowId,F)?.win?.close()}async quit(F){const q=this.a.getLastActiveWindow();q?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&q.win?q.win.close():this.f.quit()}async exit(F,q){await this.f.kill(q)}async resolveProxy(F,q){return this.D(F)?.win?.webContents?.session?.resolveProxy(q)}async loadCertificates(F){return(await new Promise((x,le)=>{K(["@vscode/proxy-agent"],x,le)})).loadSystemCertificates({log:this.h})}findFreePort(F,q,x,le,te=1){return(0,w.$Gg)(q,x,le,te)}async openDevTools(F,q){this.C(q?.targetWindowId,F)?.win?.webContents.openDevTools(q?.mode?{mode:q.mode,activate:q.activate}:void 0)}async toggleDevTools(F,q){this.C(q?.targetWindowId,F)?.win?.webContents.toggleDevTools()}async profileRenderer(F,q,x){const le=this.D(F);if(!le||!le.win)throw new Error;return await new I.$Jac(le.win,q,this.h).inspect(x)}async windowsGetStringRegKey(F,q,x,le){if(!y.$i)return;const te=await new Promise((ue,Y)=>{K(["@vscode/windows-registry"],ue,Y)});try{return te.GetStringRegKey(q,x,le)}catch{return}}C(F,q){return this.D(F)??this.F(F)??this.D(q)}D(F){if(typeof F=="number")return this.a.getWindowById(F)}F(F){if(typeof F=="number")return this.b.getWindowById(F)}};e.$Mac=R,Ee([S.$Mh],R.prototype,"z",null),e.$Mac=R=Ee([ne(0,i.$Z_b),ne(1,D.$Kac),ne(2,f.$U_b),ne(3,a.$gac),ne(4,l.$O_b),ne(5,t.$Oj),ne(6,o.$8j),ne(7,r.$X_b),ne(8,u.$__b)],R)}),define(oe[303],ae([0,1,14,26,8,23,31,2,13,4,7,111,37,182,92,134,56,24,5,70,79,27,80,34,61,55,29]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g,m,v,w,$,f,l,d,a,t,o,r,i,s){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nac=void 0;const b="issue.processExplorerWindowState";let C=class{static{u=this}static{this.a="#1E1E1E"}constructor(O,R,W,F,q,x,le,te,ue,Y,Z){this.g=O,this.h=R,this.i=W,this.j=F,this.k=q,this.l=x,this.m=le,this.n=te,this.o=ue,this.p=Y,this.q=Z,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){k.$5V.on("vscode:listProcesses",async O=>{const R=[];try{R.push({name:(0,g.localize)(0,null),rootProcess:await(0,y.$ms)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(F=>{(0,m.$3m)(F)?R.push({name:F.hostName,rootProcess:F}):F.processes&&R.push({name:F.hostName,rootProcess:F.processes})})}catch(W){this.i.error(`Listing processes failed: ${W}`)}this.t(O,"vscode:listProcessesResponse",R)}),k.$5V.on("vscode:workbenchCommand",(O,R)=>{const{id:W,from:F,args:q}=R;let x;switch(F){case"processExplorer":x=this.f;break;default:throw new Error(`Unexpected command source: ${F}`)}x?.webContents.send("vscode:runAction",{id:W,from:F,args:q})}),k.$5V.on("vscode:closeProcessExplorer",O=>{this.d?.close()}),k.$5V.on("vscode:pidToNameRequest",async O=>{const R=await this.k.getMainDiagnostics(),W=[];for(const F of R.windows)W.push([F.pid,`window [${F.id}] (${F.title})`]);for(const{pid:F,name:q}of r.$tac.getAll())W.push([F,q]);this.t(O,"vscode:pidToNameResponse",W)})}async openReporter(O){if(this.b)this.b&&this.s(this.b);else if(this.c=n.BrowserWindow.getFocusedWindow(),this.c){const R=new E.$Tc,W=R.add(this.n.createIPCObjectUrl()),F=this.v(this.c,700,800);this.b=this.u(F,W,{backgroundColor:O.styles.backgroundColor,title:(0,g.localize)(1,null),zoomLevel:O.zoomLevel,alwaysOnTop:!1},"issue-reporter"),W.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:O,disableExtensions:!!this.h.disableExtensions,os:{type:(0,j.type)(),arch:(0,j.arch)(),release:(0,j.release)()},product:d.default}),this.b.loadURL(h.$Cg.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,R.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,R.dispose())})}}async openProcessExplorer(O){if(!this.d&&(this.f=n.BrowserWindow.getFocusedWindow(),this.f)){const R=new E.$Tc,W=R.add(this.n.createIPCObjectUrl()),F=this.p.getItem(b,void 0),q=I(F)?F:this.v(this.f,800,500);this.d=this.u(q,W,{backgroundColor:O.styles.backgroundColor,title:(0,g.localize)(2,null),zoomLevel:O.zoomLevel,alwaysOnTop:!0},"process-explorer"),W.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:O,product:d.default}),this.d.loadURL(h.$Cg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,R.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,R.dispose())});const x=()=>{if(!this.d)return;const le=this.d.getSize(),te=this.d.getPosition();if(!le||!te)return;const ue={width:le[0],height:le[1],x:te[0],y:te[1]};this.p.setItem(b,ue)};this.d.on("moved",x),this.d.on("resized",x)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const O=await n.contentTracing.stopRecording(`${(0,S.$qg)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,g.localize)(3,null),detail:(0,g.localize)(4,null,O),buttons:[(0,g.localize)(5,null)]},n.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,O)}async getSystemStatus(){const[O,R]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(O,R)}async $getSystemInfo(){const[O,R]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(O,R)}async $getPerformanceInfo(){try{const[O,R]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(O,R)}catch(O){throw this.i.warn("issueService#getPerformanceInfo ",O.message),O}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(O){this.i.error(O)}}async $showConfirmCloseDialog(){if(this.b){const{response:O}=await this.l.showMessageBox({type:"warning",message:(0,g.localize)(6,null),buttons:[(0,g.localize)(7,null),(0,g.localize)(8,null)]},this.b);O===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:O}=await this.l.showMessageBox({type:"warning",message:(0,g.localize)(9,null),buttons:[(0,g.localize)(10,null),(0,g.localize)(11,null)]},this.b);return O===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const O=this.q.getWindowById(this.c.id);if(!O)throw new Error("Window not found");return O}async $getIssueReporterUri(O){const R=this.issueReporterWindowCheck(),W=`vscode:triggerIssueUriRequestHandlerResponse${R.id}`;return P.Promises.withAsyncBody(async(F,q)=>{const x=new M.$ee;R.sendWhenReady("vscode:triggerIssueUriRequestHandler",x.token,{replyChannel:W,extensionId:O}),k.$5V.once(W,(le,te)=>{F(p.URI.parse(te))});try{await(0,P.$jh)(5e3),x.cancel(),q(new Error("Timed out waiting for issue reporter URI"))}finally{k.$5V.removeHandler(W)}})}async $getIssueReporterData(O){const R=this.issueReporterWindowCheck(),W=`vscode:triggerIssueDataProviderResponse${R.id}`;return P.Promises.withAsyncBody(async F=>{const q=new M.$ee;R.sendWhenReady("vscode:triggerIssueDataProvider",q.token,{replyChannel:W,extensionId:O}),k.$5V.once(W,(x,le)=>{F(le)});try{await(0,P.$jh)(5e3),q.cancel(),F("Error: Extension timed out waiting for issue reporter data")}finally{k.$5V.removeHandler(W)}})}async $getIssueReporterTemplate(O){const R=this.issueReporterWindowCheck(),W=`vscode:triggerIssueDataTemplateResponse${R.id}`;return P.Promises.withAsyncBody(async F=>{const q=new M.$ee;R.sendWhenReady("vscode:triggerIssueDataTemplate",q.token,{replyChannel:W,extensionId:O}),k.$5V.once(W,(x,le)=>{F(le)});try{await(0,P.$jh)(5e3),q.cancel(),F("Error: Extension timed out waiting for issue reporter template")}finally{k.$5V.removeHandler(W)}})}async $getReporterStatus(O,R){const W=[!1,!1],F=this.issueReporterWindowCheck(),q="vscode:triggerReporterStatus",x=new M.$ee;return F.sendWhenReady(q,x.token,{replyChannel:q,extensionId:O,extensionName:R}),await(0,P.$_g)(new Promise(te=>k.$5V.once("vscode:triggerReporterStatusResponse",(ue,Y)=>te(Y))),2e3,()=>{this.i.error("Error: Extension timed out waiting for reporter status"),x.cancel()})??W}async $sendReporterMenu(O,R){const W=this.issueReporterWindowCheck(),F="vscode:triggerReporterMenu",q=new M.$ee;return W.sendWhenReady(F,q.token,{replyChannel:F,extensionId:O,extensionName:R}),await(0,P.$_g)(new Promise(le=>k.$5V.once(`vscode:triggerReporterMenuResponse:${O}`,(te,ue)=>le(ue))),5e3,()=>{this.i.error(`Error: Extension ${O} timed out waiting for menu response`),q.cancel()})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(O){O.isMinimized()&&O.restore(),O.focus()}t(O,R,...W){O.sender.isDestroyed()||O.sender.send(R,...W)}u(O,R,W,F){const q=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:O.width,height:O.height,minWidth:300,minHeight:200,x:O.x,y:O.y,title:W.title,backgroundColor:W.backgroundColor||u.a,webPreferences:{preload:h.$Cg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${R.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,i.$kD)(W.zoomLevel),sandbox:!0},alwaysOnTop:W.alwaysOnTop,experimentalDarkMode:!0});return q.setMenuBarVisibility(!1),q}v(O,R,W){let F;const q=n.screen.getAllDisplays();if(q.length===1)F=q[0];else{if(c.$j){const te=n.screen.getCursorScreenPoint();F=n.screen.getDisplayNearestPoint(te)}!F&&O&&(F=n.screen.getDisplayMatching(O.getBounds())),F||(F=n.screen.getPrimaryDisplay()||q[0])}const x=F.bounds,le={width:R,height:W,x:x.x+x.width/2-R/2,y:x.y+x.height/2-W/2};return x.width>0&&x.height>0&&(le.x<x.x&&(le.x=x.x),le.y<x.y&&(le.y=x.y),le.x>x.x+x.width&&(le.x=x.x),le.y>x.y+x.height&&(le.y=x.y),le.width>x.width&&(le.width=x.width),le.height>x.height&&(le.height=x.height)),le}};e.$Nac=C,e.$Nac=C=u=Ee([ne(1,$.$O_b),ne(2,f.$Oj),ne(3,m.$2m),ne(4,v.$wac),ne(5,w.$U_b),ne(6,l.$Lac),ne(7,t.$W_b),ne(8,a.$8j),ne(9,o.$WP),ne(10,s.$Z_b)],C);function I(D){return typeof D!="object"||D===null?!1:"x"in D&&"y"in D&&"width"in D&&"height"in D}}),define(oe[304],ae([0,1,23,18,24,20,5,70,27,53,28,50,101]),function(K,e,n,j,P,M,S,E,h,c,p,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cbc=void 0;let g=class extends k.$abc{constructor(v,w,$,f,l,d,a,t){super(v,w,f,l,d,t),this.e=$,this.u=a}s(v){return(0,k.$_ac)(`linux-${process.arch}`,v,this.k)}t(v){this.a&&(this.d(y.$3W.CheckingForUpdates(v)),this.i.request({url:this.a},n.CancellationToken.None).then(c.$Fp).then(w=>{!w||!w.url||!w.version||!w.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!v}),this.d(y.$3W.Idle(1))):this.d(y.$3W.AvailableForDownload(w))}).then(void 0,w=>{this.j.error(w);const $=v?w.message||w:void 0;this.d(y.$3W.Idle(1,$))}))}async o(v){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):v.update.url&&this.u.openExternal(void 0,v.update.url),this.d(y.$3W.Idle(1))}};e.$cbc=g,e.$cbc=g=Ee([ne(0,M.$gac),ne(1,j.$Oi),ne(2,p.$Nl),ne(3,P.$O_b),ne(4,c.$zp),ne(5,S.$Oj),ne(6,E.$Lac),ne(7,h.$8j)],g)}),define(oe[305],ae([0,1,49,43,26,8,23,51,46,9,7,146,21,18,24,16,20,5,70,27,53,28,50,101]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g,m,v,w,$,f,l,d,a,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ebc=void 0;async function r(b,C=1e3){for(;!b();)await(0,M.$jh)(C)}let i;function s(){return typeof i>"u"&&(i=j.existsSync(c.$kc(c.$nc(process.execPath),"unins000.exe"))?0:1),i}let u=class extends o.$abc{get cachePath(){const C=c.$kc((0,P.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return k.Promises.mkdir(C,{recursive:!0}).then(()=>C)}constructor(C,I,D,O,R,W,F,q,x){super(C,I,O,R,W,x),this.u=D,this.v=F,this.w=q,C.setRelaunchHandler(this)}handleRelaunch(C){return C?.addArgs||C?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(t.$3W.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(C){let I=`win32-${process.arch}`;return s()===1?I+="-archive":this.k.target==="user"&&(I+="-user"),(0,o.$_ac)(I,C,this.k)}t(C){this.a&&(this.d(t.$3W.CheckingForUpdates(C)),this.i.request({url:this.a},S.CancellationToken.None).then(d.$Fp).then(I=>{const D=s();return!I||!I.url||!I.version||!I.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!C}),this.d(t.$3W.Idle(D)),Promise.resolve(null)):D===1?(this.d(t.$3W.AvailableForDownload(I)),Promise.resolve(null)):(this.d(t.$3W.Downloading),this.C(I.version).then(()=>this.B(I.version).then(O=>k.Promises.exists(O).then(R=>{if(R)return Promise.resolve(O);const W=`${O}.tmp`;return this.i.request({url:I.url},S.CancellationToken.None).then(F=>this.v.writeFile(p.URI.file(W),F.stream)).then(I.sha256hash?()=>(0,y.$ZV)(W,I.sha256hash):()=>{}).then(()=>k.Promises.rename(W,O,!1)).then(()=>O)})).then(O=>{this.e={packagePath:O},this.d(t.$3W.Downloaded(I)),this.g.getValue("update.enableWindowsBackgroundUpdates")?this.k.target==="user"&&this.p():this.d(t.$3W.Ready(I))})))}).then(void 0,I=>{this.u.publicLog2("update:error",{messageHash:String((0,h.$9i)(String(I)))}),this.j.error(I);const D=C?I.message||I:void 0;this.d(t.$3W.Idle(s(),D))}))}async o(C){C.update.url&&this.w.openExternal(void 0,C.update.url),this.d(t.$3W.Idle(s()))}async B(C){const I=await this.cachePath;return c.$kc(I,`CodeSetup-${this.k.quality}-${C}.exe`)}async C(C=null){const I=C?W=>!new RegExp(`${this.k.quality}-${C}\\.exe$`).test(W):()=>!0,D=await this.cachePath,R=(await k.Promises.readdir(D)).filter(I).map(async W=>{try{await k.Promises.unlink(c.$kc(D,W))}catch{}});await Promise.all(R)}async p(){if(this.state.type!=="downloaded"||!this.e)return Promise.resolve(void 0);const C=this.state.update;this.d(t.$3W.Updating(C));const I=await this.cachePath;this.e.updateFilePath=c.$kc(I,`CodeSetup-${this.k.quality}-${C.version}.flag`),await k.Promises.writeFile(this.e.updateFilePath,"flag"),(0,n.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(t.$3W.Idle(s()))});const O=`${this.k.win32MutexName}-ready`,R=await new Promise((W,F)=>{K(["@vscode/windows-mutex"],W,F)});r(()=>R.isActive(O)).then(()=>this.d(t.$3W.Ready(C)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?j.unlinkSync(this.e.updateFilePath):(0,n.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return s()}async _applySpecificUpdate(C){if(this.state.type!=="idle")return;const I=this.g.getValue("update.enableWindowsBackgroundUpdates"),D={version:"unknown",productVersion:"unknown"};this.d(t.$3W.Downloading),this.e={packagePath:C},this.d(t.$3W.Downloaded(D)),I?this.k.target==="user"&&this.p():this.d(t.$3W.Ready(D))}};e.$ebc=u,Ee([E.$Mh],u.prototype,"cachePath",null),e.$ebc=u=Ee([ne(0,w.$gac),ne(1,g.$Oi),ne(2,a.$Nl),ne(3,m.$O_b),ne(4,d.$zp),ne(5,$.$Oj),ne(6,v.$Ok),ne(7,f.$Lac),ne(8,l.$8j)],u)}),define(oe[135],ae([0,1,14,8,23,47,3,2,13,66,4,7,193,26,65,18,56,24,64,16,20,5,27,80,256,83,28,106,69,55,29,30,58,81,39,34,57,67,22,6]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g,m,v,w,$,f,l,d,a,t,o,r,i,s,u,b,C,I,D,O,R,W,F,q,x,le,te){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eac=e.$dac=void 0;var ue;(function(B){B[B.NONE=0]="NONE",B[B.NAVIGATING=1]="NAVIGATING",B[B.READY=2]="READY"})(ue||(ue={}));class Y extends E.$Uc{get lastFocusTime(){return this.j}get win(){return this.m}n(L){this.m=L,this.B(S.Event.fromNodeEventEmitter(L,"maximize")(()=>this.b.fire())),this.B(S.Event.fromNodeEventEmitter(L,"unmaximize")(()=>this.c.fire())),this.B(S.Event.fromNodeEventEmitter(L,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(S.Event.fromNodeEventEmitter(L,"focus")(()=>{this.j=Date.now()})),this.B(S.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(S.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const T=!(0,C.$gD)(this.r);if(p.$j&&T&&L.setSheetOffset((0,p.$J)((0,g.release)())?28:22),T&&(p.$i&&(0,C.$iD)(this.r)||p.$j)){const G=this.s.getItem(Y.C);G&&this.updateWindowControls({height:G})}p.$i&&T&&L.hookWindowMessage(278,()=>{const[z,ce]=L.getPosition(),he=n.screen.getCursorScreenPoint(),X=he.x-z,A=he.y-ce;return!(X>30&&A>=0&&A<=Math.max(L.getBounds().height*.15,35))||(L.setEnabled(!1),L.setEnabled(!0),this.f.fire({x:X,y:A})),0}),this.t.args["open-devtools"]===!0&&L.webContents.openDevTools(),p.$j&&(this.B(this.onDidEnterFullScreen(()=>{this.G?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.G?.complete(!0)})))}constructor(L,T,G,z){super(),this.r=L,this.s=T,this.t=G,this.u=z,this.a=this.B(new S.$7d),this.onDidClose=this.a.event,this.b=this.B(new S.$7d),this.onDidMaximize=this.b.event,this.c=this.B(new S.$7d),this.onDidUnmaximize=this.c.event,this.f=this.B(new S.$7d),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new S.$7d),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new S.$7d),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.D=(0,C.$iD)(this.r),this.F=void 0,this.G=void 0}setRepresentedFilename(L){p.$j?this.win?.setRepresentedFilename(L):this.w=L}getRepresentedFilename(){return p.$j?this.win?.getRepresentedFilename():this.w}setDocumentEdited(L){p.$j&&this.win?.setDocumentEdited(L),this.z=L}isDocumentEdited(){return p.$j?!!this.win?.isDocumentEdited():!!this.z}focus(L){p.$j&&L?.force&&n.app.focus({steal:!0});const T=this.win;T&&(T.isMinimized()&&T.restore(),T.focus())}handleTitleDoubleClick(){const L=this.win;if(L)if(p.$j)switch(n.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":L.minimize();break;case"None":break;case"Maximize":default:L.isMaximized()?L.unmaximize():L.maximize()}else L.isMaximized()?L.unmaximize():L.maximize()}static{this.C="windowControlHeight"}updateWindowControls(L){const T=this.win;if(T){if(L.height&&this.s.setItem(Z.C,L.height),p.$i&&this.D)T.setTitleBarOverlay({color:L.backgroundColor?.trim()===""?void 0:L.backgroundColor,symbolColor:L.foregroundColor?.trim()===""?void 0:L.foregroundColor,height:L.height?L.height-1:void 0});else if(p.$j&&L.height!==void 0){const G=(L.height-15)/2;G?T.setWindowButtonPosition({x:G,y:G}):T.setWindowButtonPosition(null)}}}toggleFullScreen(){this.H(!this.isFullScreen,!1)}H(L,T){(0,C.$jD)(this.r)?this.I(L,T):this.L(L)}get isFullScreen(){if(p.$j&&typeof this.F=="boolean")return this.F;const L=this.win,T=L?.isFullScreen(),G=L?.isSimpleFullScreen();return!!(T||G)}I(L,T){const G=this.win;G?.isSimpleFullScreen()&&G?.setSimpleFullScreen(!1),this.J(L,T)}J(L,T){if(p.$j){this.F=L;const z=this.G=new j.$Fh;(async()=>{const ce=await Promise.race([z.p,(0,j.$jh)(1e4).then(()=>!1)]);this.G===z&&(this.F=void 0,this.G=void 0,!ce&&L&&T&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(L)}L(L){const T=this.win;T?.isFullScreen()&&this.J(!1,!1),T?.setSimpleFullScreen(L),T?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$dac=Y;let Z=class extends Y{get id(){return this.P}get backupPath(){return this.R?.backupPath}get openedWorkspace(){return this.R?.workspace}get profile(){if(!this.config)return;const L=this.gb.profiles.find(T=>T.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&L?L:this.gb.getProfileForWorkspace(this.config.workspace??(0,D.$wi)(this.backupPath,this.isExtensionDevelopmentHost))??this.gb.defaultProfile}get remoteAuthority(){return this.R?.remoteAuthority}get config(){return this.R}get isExtensionDevelopmentHost(){return!!this.R?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.R?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.R?.debugId}constructor(L,T,G,z,ce,he,X,A,N,_,se,J,V,H,U,re,ee,fe,me,ve,ke){super(_,ve,z,T),this.eb=G,this.fb=ce,this.gb=he,this.hb=X,this.ib=A,this.jb=N,this.kb=se,this.lb=J,this.mb=V,this.nb=H,this.ob=U,this.pb=re,this.qb=ee,this.rb=fe,this.sb=me,this.M=this.B(new S.$7d),this.onWillLoad=this.M.event,this.N=this.B(new S.$7d),this.onDidSignalReady=this.N.event,this.O=this.B(new S.$7d),this.onDidDestroy=this.O.event,this.W=[],this.X=[],this.Y=void 0,this.Z=void 0,this.$=void 0,this.ab=this.B(this.rb.createIPCObjectUrl()),this.db=!1,this.tb=0;{const[je,Fe]=this.Db(L.state);this.S=je,this.u.trace("window#ctor: using window state",je);const ye=this.S.mode===0||this.S.mode===3,Q=ke.invokeFunction(I.$1_b,this.S,{show:!ye,webPreferences:{preload:h.$Cg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.ab.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"}});(0,c.mark)("code/willCreateCodeBrowserWindow"),this.m=new n.BrowserWindow(Q),(0,c.mark)("code/didCreateCodeBrowserWindow"),this.P=this.m.id,this.n(this.m);const de=this.r.getValue("window"),$e=p.$j&&de?.nativeTabs===!0;(p.$j||p.$i)&&Fe&&(!$e||n.BrowserWindow.getAllWindows().length===1)&&[this.S.width,this.S.height,this.S.x,this.S.y].every(Se=>typeof Se=="number")&&this.m.setBounds({width:this.S.width,height:this.S.height,x:this.S.x,y:this.S.y}),ye&&((0,c.mark)("code/willMaximizeCodeWindow"),this.m.maximize(),this.S.mode===3&&this.H(!0,!0),this.m.show(),(0,c.mark)("code/didMaximizeCodeWindow")),this.j=Date.now()}this.Ab(),this.Jb(),this.ub()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.P})`),this.tb=2;this.W.length;)this.W.pop()(this);this.N.fire()}ready(){return new Promise(L=>{if(this.isReady)return L(this);this.W.push(L)})}get isReady(){return this.tb===2}get whenClosedOrLoaded(){return new Promise(L=>{function T(){G.dispose(),z.dispose(),L()}const G=this.onDidClose(()=>T()),z=this.onWillLoad(()=>T())})}ub(){this.m.on("unresponsive",()=>this.xb(1)),this.m.webContents.on("render-process-gone",(T,G)=>this.xb(2,{...G})),this.m.webContents.on("did-fail-load",(T,G,z)=>this.xb(3,{reason:z,exitCode:G})),this.m.webContents.on("will-prevent-unload",T=>{T.preventDefault()}),this.m.webContents.on("did-finish-load",()=>{this.bb&&(this.R=this.bb,this.bb=void 0)}),this.B(this.onDidMaximize(()=>{this.R&&(this.R.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.R&&(this.R.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",P.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",P.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(T=>this.Ab(T))),this.B(this.lb.onDidDeleteUntitledWorkspace(T=>this.zb(T)));const L=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:L},async(T,G)=>{const z=await this.wb();G({cancel:!1,requestHeaders:Object.assign(T.requestHeaders,z)})})}wb(){return this.vb||(this.vb=(0,r.$Tp)(this.qb.version,this.qb,this.t,this.r,this.hb,this.ib,this.nb)),this.vb}async xb(L,T){switch(L){case 2:this.u.error(`CodeWindow: renderer process gone (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break;case 1:this.u.error("CodeWindow: detected unresponsive");break;case 3:this.u.error(`CodeWindow: failed to load (reason: ${T?.reason||"<unknown>"}, code: ${T?.exitCode||"<unknown>"})`);break}switch(this.nb.publicLog2("windowerror",{type:L,reason:T?.reason,code:T?.exitCode}),L){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.pb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.yb(!1,!1),this.pb.quit();return}if(L===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:G,checkboxChecked:z}=await this.ob.showMessageBox({type:"warning",buttons:[(0,k.localize)(0,null),(0,k.localize)(1,null),(0,k.localize)(2,null)],message:(0,k.localize)(3,null),detail:(0,k.localize)(4,null),checkboxLabel:this.R?.workspace?(0,k.localize)(5,null):void 0},this.m);if(G!==2){const ce=G===0;await this.yb(ce,z)}}else if(L===2){let G;T?G=(0,k.localize)(7,null,T.reason,T.exitCode??"<unknown>"):G=(0,k.localize)(6,null);const{response:z,checkboxChecked:ce}=await this.ob.showMessageBox({type:"warning",buttons:[this.R?.workspace?(0,k.localize)(8,null):(0,k.localize)(9,null),(0,k.localize)(10,null)],message:G,detail:this.R?.workspace?(0,k.localize)(11,null):(0,k.localize)(12,null),checkboxLabel:this.R?.workspace?(0,k.localize)(13,null):void 0},this.m),he=z===0;await this.yb(he,ce)}break}}async yb(L,T){const G=this.R?.workspace;if(T&&G)try{const z=this.jb.workspaceStorage(G);await z.init(),z.delete("memento/workbench.parts.editor"),await z.close()}catch(z){this.u.error(z)}this.O.fire();try{if(L&&this.R){let z,ce;(0,D.$si)(G)?z={folderUri:G.uri}:(0,D.$xi)(G)?z={workspaceUri:G.configPath}:ce=!0,(0,le.$Ob)(await this.sb.open({context:5,userEnv:this.R.userEnv,cli:{...this.t.args,_:[]},urisToOpen:z?[z]:void 0,forceEmpty:ce,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}zb(L){this.R?.workspace?.id===L.id&&(this.R.workspace=void 0)}Ab(L){if(!L||L.affectsConfiguration("window.menuBarVisibility")){const T=this.Fb();T!==this.U&&(this.U=T,this.Gb(T))}if(!L||L.affectsConfiguration("http.proxy")){let T=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;T?.endsWith("/")&&(T=T.substr(0,T.length-1));const G=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((T||"").indexOf("@")===-1&&(T!==this.Y||G!==this.Z)){this.Y=T,this.Z=G;const z=T||"",ce=G?`${G},<local>`:"<local>";this.u.trace(`Setting proxy to '${z}', bypassing '${ce}'`),this.m.webContents.session.setProxy({proxyRules:z,proxyBypassRules:ce,pacScript:""}),typeof n.app.setProxy=="function"&&n.app.setProxy({proxyRules:z,proxyBypassRules:ce,pacScript:""})}}}addTabbedWindow(L){p.$j&&L.win&&this.m.addTabbedWindow(L.win)}load(L,T=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.P})`),this.isDocumentEdited()&&(!T.isReload||!this.mb.isHotExitEnabled())&&this.setDocumentEdited(!1),T.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.qb.nameLong)),this.Bb(L,T),this.tb===0?this.R=L:this.bb=L,this.tb=1,this.m.loadURL(h.$Cg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const G=this.db;this.db=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new j.$uh(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.M.fire({workspace:L.workspace,reason:T.isReload?3:G?2:1})}Bb(L,T){const G=(this.R??this.bb)?.userEnv;if(G){const z=(0,f.$mm)(G)&&!(0,f.$mm)(L.userEnv),ce=this.isExtensionDevelopmentHost;(z||ce)&&(L.userEnv={...G,...L.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(L.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),T.disableExtensions!==void 0&&(L["disable-extensions"]=T.disableExtensions),L.fullscreen=this.isFullScreen,L.maximized=this.m.isMaximized(),L.partsSplash=this.kb.getWindowSplash(),L.zoomLevel=this.Ib(),L.isCustomZoomLevel=typeof this.$=="number",L.isCustomZoomLevel&&L.partsSplash&&(L.partsSplash.zoomLevel=L.zoomLevel),(0,c.mark)("code/willOpenNewWindow"),L.perfMarks=(0,c.getMarks)(),this.ab.update(L)}async reload(L){const T=Object.assign({},this.R);T.workspace=await this.Cb(T),delete T.filesToOpenOrCreate,delete T.filesToDiff,delete T.filesToMerge,delete T.filesToWait,this.isExtensionDevelopmentHost&&L&&(T.verbose=L.verbose,T.debugId=L.debugId,T.extensionEnvironment=L.extensionEnvironment,T["inspect-extensions"]=L["inspect-extensions"],T["inspect-brk-extensions"]=L["inspect-brk-extensions"],T["extensions-dir"]=L["extensions-dir"]),T.accessibilitySupport=n.app.isAccessibilitySupportEnabled(),T.isInitialStartup=!1,T.policiesData=this.fb.serialize(),T.continueOn=this.t.continueOn,T.profiles={all:this.gb.profiles,profile:this.profile||this.gb.defaultProfile,home:this.gb.profilesHome},T.logLevel=this.eb.getLogLevel(),T.loggers={window:this.eb.getRegisteredLoggers(this.id),global:this.eb.getRegisteredLoggers()},this.load(T,{isReload:!0,disableExtensions:L?.["disable-extensions"]})}async Cb(L){if((0,D.$xi)(L.workspace)){const T=L.workspace.configPath;if(T.scheme===h.Schemas.file&&!await this.hb.exists(T))return}else if((0,D.$si)(L.workspace)){const T=L.workspace.uri;if(T.scheme===h.Schemas.file&&!await this.hb.exists(T))return}return L.workspace}serializeWindowState(){if(!this.m)return(0,R.$M_b)();if(this.isFullScreen){let G;try{G=n.screen.getDisplayMatching(this.getBounds())}catch{}const z=(0,R.$M_b)();return{mode:3,display:G?G.id:void 0,width:this.S.width||z.width,height:this.S.height||z.height,x:this.S.x||0,y:this.S.y||0,zoomLevel:this.$}}const L=Object.create(null);let T;if(!p.$j&&this.m.isMaximized()?T=0:T=1,T===0?L.mode=0:L.mode=1,T===1||T===0){let G;T===1?G=this.getBounds():G=this.m.getNormalBounds(),L.x=G.x,L.y=G.y,L.width=G.width,L.height=G.height}return L.zoomLevel=this.$,L}Db(L){(0,c.mark)("code/willRestoreCodeWindowState");let T=!1;if(L){this.$=L.zoomLevel;try{const G=n.screen.getAllDisplays();T=G.length>1,L=I.WindowStateValidator.validateWindowState(this.u,L,G)}catch(G){this.u.warn(`Unexpected error validating window state: ${G}
${G.stack}`)}}return(0,c.mark)("code/didRestoreCodeWindowState"),[L||(0,R.$M_b)(),T]}getBounds(){const[L,T]=this.m.getPosition(),[G,z]=this.m.getSize();return{x:L,y:T,width:G,height:z}}H(L,T){super.H(L,T),this.sendWhenReady(L?"vscode:enterFullScreen":"vscode:leaveFullScreen",P.CancellationToken.None),this.U&&this.Gb(this.U,!1)}Fb(){let L=(0,C.$eD)(this.r);return["visible","toggle","hidden"].indexOf(L)<0&&(L="classic"),L}Gb(L,T=!0){p.$j||(L==="toggle"&&T&&this.send("vscode:showInfoMessage",(0,k.localize)(14,null)),L==="hidden"?setTimeout(()=>{this.Hb(L)}):this.Hb(L))}Hb(L){const T=this.isFullScreen;switch(L){case"classic":this.m.setMenuBarVisibility(!T),this.m.autoHideMenuBar=T;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(L){this.$=L}Ib(){return typeof this.$=="number"?this.$:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(L,T,...G){this.isReady?this.send(L,...G):this.ready().then(()=>{T.isCancellationRequested||this.send(L,...G)})}send(L,...T){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${L}' for window that is destroyed`);return}try{this.m.webContents.send(L,...T)}catch(G){this.u.warn(`Error sending IPC message to channel '${L}' of window ${this.P}: ${(0,M.$6i)(G)}`)}}}updateTouchBar(L){p.$j&&this.X.forEach((T,G)=>{const z=L[G];T.segments=this.Lb(z)})}Jb(){if(p.$j){for(let L=0;L<10;L++){const T=this.Kb();this.X.push(T)}this.m.setTouchBar(new n.TouchBar({items:this.X}))}}Kb(L=[]){const T=this.Lb(L),G=new n.TouchBar.TouchBarSegmentedControl({segments:T,mode:"buttons",segmentStyle:"automatic",change:z=>{this.sendWhenReady("vscode:runAction",P.CancellationToken.None,{id:G.segments[z].id,from:"touchbar"})}});return G}Lb(L=[]){return L.map(G=>{let z;G.icon&&!u.ThemeIcon.isThemeIcon(G.icon)&&G.icon?.dark?.scheme===h.Schemas.file&&(z=n.nativeImage.createFromPath(y.URI.revive(G.icon.dark).fsPath),z.isEmpty()&&(z=void 0));let ce;return typeof G.title=="string"?ce=G.title:ce=G.title.value,{id:G.id,label:z?void 0:ce,icon:z}})}dispose(){super.dispose(),this.eb.deregisterLoggers(this.id)}};e.$eac=Z,e.$eac=Z=Ee([ne(1,a.$Oj),ne(2,x.$bac),ne(3,$.$O_b),ne(4,W.$3n),ne(5,q.$3_b),ne(6,l.$Ok),ne(7,i.$oac),ne(8,i.$mac),ne(9,v.$Oi),ne(10,b.$X_b),ne(11,O.$__b),ne(12,m.$T_b),ne(13,s.$Nl),ne(14,w.$U_b),ne(15,d.$gac),ne(16,t.$8j),ne(17,o.$W_b),ne(18,I.$Z_b),ne(19,F.$WP),ne(20,te.$hi)],Z)}),define(oe[306],ae([0,1,14,4,18,24,20,5,34,55,135]),function(K,e,n,j,P,M,S,E,h,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fac=void 0;let y=class extends p.$dac{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(g,m,v,w,$,f){super(w,$,m,v),this.M=g,this.N=f,this.id=this.M.id,this.parentId=-1,this.tryClaimWindow()}tryClaimWindow(){if(this.m||this.q.isDisposed||this.M.isDestroyed())return;const g=n.BrowserWindow.fromWebContents(this.M);g&&(this.u.trace("[aux window] Claimed browser window instance"),this.n(g),g.setMenu(null),(j.$i||j.$k)&&(0,c.$gD)(this.r)&&g.setAutoHideMenuBar(!0),this.N.registerAuxWindow(this))}};e.$fac=y,e.$fac=y=Ee([ne(1,M.$O_b),ne(2,E.$Oj),ne(3,P.$Oi),ne(4,h.$WP),ne(5,S.$gac)],y)}),define(oe[307],ae([0,1,14,3,2,13,37,306,6,5,81,29]),function(K,e,n,j,P,M,S,E,h,c,p,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jbc=void 0;let k=class extends P.$Uc{constructor(m,v){super(),this.h=m,this.j=v,this.a=this.B(new j.$7d),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new j.$7d),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new j.$7d),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new j.$7d),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){n.app.on("browser-window-created",(m,v)=>{const w=this.getWindowById(v.id);w&&(this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),w.tryClaimWindow())}),S.$5V.handle("vscode:registerAuxiliaryWindow",async(m,v)=>{const w=this.getWindowById(m.sender.id);return w&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),w.parentId=v),m.sender.id})}createWindow(m){return this.h.invokeFunction(y.$1_b,this.n(m),{webPreferences:{preload:M.$Cg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath}})}n(m){const v={},w=m.features.split(",");for(const f of w){const[l,d]=f.split("=");switch(l){case"width":v.width=parseInt(d,10);break;case"height":v.height=parseInt(d,10);break;case"left":v.x=parseInt(d,10);break;case"top":v.y=parseInt(d,10);break}}const $=y.WindowStateValidator.validateWindowState(this.j,v)??(0,p.$N_b)();return this.j.trace("[aux window] using window state",$),$}registerWindow(m){const v=new P.$Tc,w=this.h.createInstance(E.$fac,m);this.g.set(w.id,w),v.add((0,P.$Sc)(()=>this.g.delete(w.id))),v.add(w.onDidMaximize(()=>this.a.fire(w))),v.add(w.onDidUnmaximize(()=>this.b.fire(w))),v.add(w.onDidEnterFullScreen(()=>this.c.fire({window:w,fullscreen:!0}))),v.add(w.onDidLeaveFullScreen(()=>this.c.fire({window:w,fullscreen:!1}))),v.add(w.onDidTriggerSystemContextMenu(({x:$,y:f})=>this.f.fire({window:w,x:$,y:f}))),j.Event.once(w.onDidClose)(()=>v.dispose())}getWindowById(m){return this.g.get(m)}getFocusedWindow(){const m=n.BrowserWindow.getFocusedWindow();if(m)return this.getWindowById(m.id)}getLastActiveWindow(){return(0,y.$2_b)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$Jbc=k,e.$Jbc=k=Ee([ne(0,h.$hi),ne(1,c.$Oj)],k)}),define(oe[84],ae([0,1,14,22,8,3,48,2,13,4,19,7,21,196,6,20,5,83,98,30,58,32,56]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g,m,v,w,$,f,l,d,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Yac=e.$Xac=void 0,e.$Xac=(0,m.$ii)("workspacesHistoryMainService");let r=class extends E.$Uc{static{o=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(s,u,b,C,I){super(),this.f=s,this.g=u,this.h=b,this.j=C,this.m=I,this.c=this.B(new M.$7d),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new P.$gh(800)),this.n()}n(){this.h.when(4).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(s=>this.addRecentlyOpened([{workspace:s.workspace,remoteAuthority:s.window.remoteAuthority}])))}async addRecentlyOpened(s){let u=[],b=[];for(const I of s)if((0,f.$Qeb)(I))!this.g.isUntitledWorkspace(I.workspace)&&!this.w(u,I.workspace)&&u.push(I);else if((0,f.$Reb)(I))this.y(u,I.folderUri)||u.push(I);else{const D=this.z(b,I.fileUri),O=I.fileUri.scheme===h.Schemas.file&&o.G.indexOf((0,p.$Sg)(I.fileUri))>=0;!D&&!O&&(b.push(I),c.$i&&I.fileUri.scheme===h.Schemas.file&&n.app.addRecentDocument(I.fileUri.fsPath))}const C=await this.r({workspaces:u,files:b});u=C.workspaces,b=C.files,u.length>o.a&&(u.length=o.a),b.length>o.a&&(b.length=o.a),await this.t({workspaces:u,files:b}),this.c.fire(),c.$j&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(s){const u=D=>{const O=this.u(D);for(const R of s)if(p.$Mg.isEqual(R,O))return!1;return!0},b=await this.getRecentlyOpened(),C=b.workspaces.filter(u),I=b.files.filter(u);(C.length!==b.workspaces.length||I.length!==b.files.length)&&(await this.t({files:I,workspaces:C}),this.c.fire(),c.$j&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(s){if(s?.confirm){const{response:u}=await this.m.showMessageBox({type:"warning",buttons:[(0,g.localize)(0,null),(0,g.localize)(1,null)],message:(0,g.localize)(2,null),detail:(0,g.localize)(3,null),cancelId:1});if(u!==0)return}await this.t({workspaces:[],files:[]}),n.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(s){const u=new a.$Bc(I=>p.$Mg.getComparisonKey(I));if(s?.workspaces)for(const I of s.workspaces)u.set(this.u(I),I);const b=new a.$Bc(I=>p.$Mg.getComparisonKey(I));if(s?.files)for(const I of s.files)b.set(this.u(I),I);const C=await this.s();for(const I of C.workspaces){const D=u.get(this.u(I));D?D.label=D.label??I.label:u.set(this.u(I),I)}for(const I of C.files){const D=b.get(this.u(I));D?D.label=D.label??I.label:b.set(this.u(I),I)}return{workspaces:[...u.values()],files:[...b.values()]}}async s(){await this.j.whenReady;let s;const u=this.j.get(o.b,-1);if(typeof u=="string")try{s=JSON.parse(u)}catch(b){this.f.error("Unexpected error parsing opened paths list",b)}return(0,f.$Xeb)(s,this.f)}async t(s){await this.j.whenReady,this.j.store(o.b,JSON.stringify((0,f.$Yeb)(s)),-1,1)}u(s){return(0,f.$Reb)(s)?s.folderUri:(0,f.$Seb)(s)?s.fileUri:s.workspace.configPath}w(s,u){return!!s.find(b=>(0,f.$Qeb)(b)&&b.workspace.id===u.id)}y(s,u){return!!s.find(b=>(0,f.$Reb)(b)&&p.$Mg.isEqual(b.folderUri,u))}z(s,u){return!!s.find(b=>p.$Mg.isEqual(b.fileUri,u))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG"]}async I(){c.$i&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!c.$i)return;const s=[];if(s.push({type:"tasks",items:[{type:"task",title:(0,g.localize)(4,null),description:(0,g.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const u=[];for(const I of n.app.getJumpListSettings().removedItems){const D=I.args;if(D){const O=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(D);O&&u.push(y.URI.parse(O[2]))}}await this.removeRecentlyOpened(u);let b=!1;const C=(0,j.$Hb)((await this.getRecentlyOpened()).workspaces.slice(0,o.F).map(I=>{const D=(0,f.$Qeb)(I)?I.workspace:I.folderUri,{title:O,description:R}=this.L(D,I.label);let W;return y.URI.isUri(D)?W=`--folder-uri "${D.toString()}"`:(b=!0,W=`--file-uri "${D.configPath.toString()}"`),{type:"task",title:O.substr(0,255),description:R.substr(0,255),program:process.execPath,args:W,iconPath:"explorer.exe",iconIndex:0}}));C.length>0&&s.push({type:"custom",name:b?(0,g.localize)(6,null):(0,g.localize)(7,null),items:C})}s.push({type:"recent"});try{const u=n.app.setJumpList(s);u&&u!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${u}`)}catch(u){this.f.warn("updateWindowsJumpList#setJumpList",u)}}L(s,u){if(u)return{title:(0,S.$pw)(u).name,description:u};if(y.URI.isUri(s))return{title:(0,p.$Sg)(s),description:this.M(s)};if(this.g.isUntitledWorkspace(s))return{title:(0,g.localize)(8,null),description:""};let b=(0,p.$Sg)(s.configPath);return b.endsWith(l.$Ei)&&(b=b.substr(0,b.length-l.$Ei.length-1)),{title:(0,g.localize)(9,null,b),description:this.M(s.configPath)}}M(s){return s.scheme==="file"?(0,S.$hw)(s.fsPath):s.toString()}async N(){if(!c.$j)return;n.app.clearRecentDocuments();const s=await this.getRecentlyOpened(),u=[];let b=0;for(let I=0;I<s.workspaces.length&&b<o.C;I++){const D=this.u(s.workspaces[I]);if(D.scheme===h.Schemas.file){const O=(0,p.$Jg)(D);await k.Promises.exists(O)&&(u.push(O),b++)}}const C=[];for(let I=0;I<s.files.length&&b<o.D;I++){const D=this.u(s.files[I]);if(D.scheme===h.Schemas.file){const O=(0,p.$Jg)(D);if(o.G.includes((0,p.$Sg)(D))||u.includes(O))continue;await k.Promises.exists(O)&&(C.push(O),b++)}}C.reverse().forEach(I=>n.app.addRecentDocument(I)),u.reverse().forEach(I=>n.app.addRecentDocument(I))}};e.$Yac=r,e.$Yac=r=o=Ee([ne(0,w.$Oj),ne(1,d.$__b),ne(2,v.$gac),ne(3,$.$oac),ne(4,t.$U_b)],r)}),define(oe[308],ae([0,1,14,8,23,48,4,7,184,78,18,24,20,5,235,70,27,34,28,50,55,29,84]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g,m,v,w,$,f,l,d,a,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zac=void 0;const r="menu";let i=class{static{o=this}static{this.a="lastKnownMenubarData"}constructor(b,C,I,D,O,R,W,F,q,x,le,te){this.n=b,this.o=C,this.p=I,this.q=D,this.r=O,this.s=R,this.t=W,this.u=F,this.v=q,this.w=x,this.x=le,this.y=te,this.m=Object.create(null),this.g=new j.$uh(()=>this.F(),0),this.h=new j.$uh(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(S.$j||(0,d.$gD)(C))&&this.z(),this.A(),this.d=!1,this.f=!1,this.j=[],this.I(),this.B()}z(){const b=this.t.getItem(o.a);b&&(b.menus&&(this.k=b.menus),b.keybindings&&(this.l=b.keybindings))}A(){this.m["workbench.action.files.newUntitledFile"]=(R,W,F)=>{this.Y({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.p.openEmptyWindow({context:2,contextWindowId:W?.id})},this.m["workbench.action.newWindow"]=(R,W,F)=>this.p.openEmptyWindow({context:2,contextWindowId:W?.id}),this.m["workbench.action.files.openFileFolder"]=(R,W,F)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:r}}),this.m["workbench.action.files.openFolder"]=(R,W,F)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:r}}),this.m["workbench.action.openWorkspace"]=(R,W,F)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:r}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened({confirm:!0});const b=this.x.youTubeUrl;b&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.ab(b,"openYouTubeUrl"));const C=this.x.requestFeatureUrl;C&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.ab(C,"openUserVoiceUrl"));const I=this.x.reportIssueUrl;I&&(this.m["workbench.action.openIssueReporter"]=()=>this.ab(I,"openReportIssues"));const D=this.x.licenseUrl;D&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(S.$w){const R=D.indexOf("?")>0?"&":"?";this.ab(`${D}${R}lang=${S.$w}`,"openLicenseUrl")}else this.ab(D,"openLicenseUrl")});const O=this.x.privacyStatementUrl;O&&D&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.ab(O,"openPrivacyStatement")})}B(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(b=>this.G(b)),this.w.onDidBlurMainWindow(()=>this.H()),this.w.onDidFocusMainWindow(()=>this.H())}get C(){const b=this.o.getValue("window.enableMenuBarMnemonics");return typeof b!="boolean"?!0:b}get D(){if(!S.$j)return!1;const b=this.o.getValue("window.nativeTabs");return typeof b!="boolean"?!1:b}updateMenu(b,C){this.k=b.menus,this.l=b.keybindings,this.t.setItem(o.a,b),this.E()}E(){this.g.schedule()}F(){this.b||setTimeout(()=>{this.b||this.I()},10)}G(b){S.$j&&(b.oldCount===0&&b.newCount>0||b.oldCount>0&&b.newCount===0)&&(this.d=b.newCount===0,this.E())}H(){if(!S.$j)return;const b=n.BrowserWindow.getFocusedWindow();this.f=!b||!!this.y.getWindowById(b.id),this.E()}I(){const b=n.Menu.getApplicationMenu();if(b&&this.j.push(b),Object.keys(this.k).length===0){this.J(S.$j?new n.Menu:null);return}const C=new n.Menu;let I;if(S.$j){const O=new n.Menu;I=new n.MenuItem({label:this.x.nameShort,submenu:O}),this.K(O),C.append(I)}if(S.$j&&!this.c){this.c=!0;const O=new n.Menu;O.append(new n.MenuItem({label:this.cb(h.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),n.app.dock.setMenu(O)}if(this.M("File")){const O=new n.Menu,R=new n.MenuItem({label:this.cb(h.localize(1,null)),submenu:O});this.O(O,"File"),C.append(R)}if(this.M("Edit")){const O=new n.Menu,R=new n.MenuItem({label:this.cb(h.localize(2,null)),submenu:O});this.O(O,"Edit"),C.append(R)}if(this.M("Selection")){const O=new n.Menu,R=new n.MenuItem({label:this.cb(h.localize(3,null)),submenu:O});this.O(O,"Selection"),C.append(R)}if(this.M("View")){const O=new n.Menu,R=new n.MenuItem({label:this.cb(h.localize(4,null)),submenu:O});this.O(O,"View"),C.append(R)}if(this.M("Go")){const O=new n.Menu,R=new n.MenuItem({label:this.cb(h.localize(5,null)),submenu:O});this.O(O,"Go"),C.append(R)}if(this.M("Run")){const O=new n.Menu,R=new n.MenuItem({label:this.cb(h.localize(6,null)),submenu:O});this.O(O,"Run"),C.append(R)}if(this.M("Terminal")){const O=new n.Menu,R=new n.MenuItem({label:this.cb(h.localize(7,null)),submenu:O});this.O(O,"Terminal"),C.append(R)}let D;if(this.M("Window")){const O=new n.Menu;D=new n.MenuItem({label:this.cb(h.localize(8,null)),submenu:O,role:"window"}),this.U(O)}if(D&&C.append(D),this.M("Help")){const O=new n.Menu,R=new n.MenuItem({label:this.cb(h.localize(9,null)),submenu:O,role:"help"});this.O(O,"Help"),C.append(R)}C.items&&C.items.length>0?this.J(C):this.J(null),this.h.schedule()}J(b){if(n.Menu.setApplicationMenu(b),b)for(const C of this.y.getWindows())C.win?.setMenu(null)}K(b){const C=this.W(h.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),I=this.V();let D;if(this.M("Preferences")){const te=new n.Menu;this.O(te,"Preferences"),D=new n.MenuItem({label:this.cb(h.localize(11,null)),submenu:te})}const O=new n.Menu,R=new n.MenuItem({label:h.localize(12,null),role:"services",submenu:O}),W=new n.MenuItem({label:h.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),F=new n.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),q=new n.MenuItem({label:h.localize(15,null),role:"unhide"}),x=new n.MenuItem(this.$("workbench.action.quit",{label:h.localize(16,null,this.x.nameLong),click:async(te,ue,Y)=>{const Z=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||n.BrowserWindow.getFocusedWindow()||Z?.win?.isMinimized())&&await this.L(Y)&&this.w.quit(void 0)}})),le=[C];le.push(...I),D&&le.push(s(),D),le.push(s(),R,s(),W,F,q,s(),x),le.forEach(te=>b.append(te))}async L(b){if(this.p.getWindowCount()===0)return!0;const C=this.o.getValue("window.confirmBeforeClose");if(C==="always"||C==="keyboardOnly"&&this.S(b)){const{response:I}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[h.localize(17,null),h.localize(18,null)],message:h.localize(19,null)});return I===0}return!0}M(b){if(!S.$j&&!(0,d.$gD)(this.o))return!1;switch(b){case"File":case"Help":if(S.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[b];case"Window":if(S.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[b]}}N(b,C){C.forEach(I=>{if((0,m.$Uac)(I))b.append(s());else if((0,m.$Tac)(I)){const D=new n.Menu,O=new n.MenuItem({label:this.cb(I.label),submenu:D});this.N(D,I.submenu.items),b.append(O)}else(0,m.$Vac)(I)?b.append(this.Q(I)):(0,m.$Wac)(I)&&(I.id==="workbench.action.showAboutDialog"&&this.P(b),S.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[I.id]?b.append(new n.MenuItem(this.$(I.id,{label:this.cb(I.label),click:this.m[I.id]}))):b.append(this.W(I.label,I.id,!1,I.checked)):b.append(this.W(I.label,I.id,I.enabled!==!1,!!I.checked)):b.append(this.W(I.label,I.id,I.enabled!==!1,!!I.checked)))})}O(b,C){this.k&&this.k[C]&&this.N(b,this.k[C].items)}P(b){const C=this.V();C.length&&(C.forEach(I=>b.append(I)),b.append(s()))}Q(b){const C=E.URI.revive(b.uri),I=b.id,D=I==="openRecentFile"?{fileUri:C}:I==="openRecentWorkspace"?{workspaceUri:C}:{folderUri:C};return new n.MenuItem(this.$(I,{label:b.label,click:async(O,R,W)=>{const F=this.R(W);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[D],forceNewWindow:F,gotoLineMode:!1,remoteAuthority:b.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([C])}},!1))}R(b){return!!(b&&(!S.$j&&(b.ctrlKey||b.shiftKey)||S.$j&&(b.metaKey||b.altKey)))}S(b){return!!(b.triggeredByAccelerator||b.altKey||b.ctrlKey||b.metaKey||b.shiftKey)}T(b,C,I){const D={label:this.cb(b),role:I,enabled:!0};return new n.MenuItem(this.Z(C,D))}U(b){const C=new n.MenuItem({label:h.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),I=new n.MenuItem({label:h.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),D=new n.MenuItem({label:h.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),O=this.W(h.localize(23,null),"workbench.action.switchWindow"),R=[];this.D&&(R.push(s()),R.push(this.W(h.localize(24,null),"workbench.action.newWindowTab")),R.push(this.T(h.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),R.push(this.T(h.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),R.push(this.T(h.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),R.push(this.T(h.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[C,I,s(),O,...R,s(),D].forEach(W=>b.append(W))}V(){switch(this.n.state.type){case"idle":return[new n.MenuItem({label:this.cb(h.localize(29,null)),click:()=>setTimeout(()=>{this.bb("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new n.MenuItem({label:h.localize(30,null),enabled:!1})];case"available for download":return[new n.MenuItem({label:this.cb(h.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new n.MenuItem({label:h.localize(32,null),enabled:!1})];case"downloaded":return S.$j?[]:[new n.MenuItem({label:this.cb(h.localize(33,null)),click:()=>{this.bb("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new n.MenuItem({label:h.localize(34,null),enabled:!1})];case"ready":return[new n.MenuItem({label:this.cb(h.localize(35,null)),click:()=>{this.bb("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}W(b,C,I,D){const O=this.cb(b),R=typeof C=="function"?C:(le,te,ue)=>{const Y=le?le.userSettingsLabel:null;let Z=C;Array.isArray(C)&&(Z=this.R(ue)?C[1]:C[0]),Y&&ue.triggeredByAccelerator?this.Y({type:"keybinding",userSettingsLabel:Y}):this.Y({type:"commandId",commandId:Z})},W=typeof I=="boolean"?I:this.p.getWindowCount()>0,F=typeof D=="boolean"?D:!1,q={label:O,click:R,enabled:W};F&&(q.type="checkbox",q.checked=F);let x;return typeof C=="string"?x=C:Array.isArray(C)&&(x=C[0]),S.$j&&(x==="editor.action.clipboardCutAction"?q.role="cut":x==="editor.action.clipboardCopyAction"?q.role="copy":x==="editor.action.clipboardPasteAction"&&(q.role="paste"),x==="undo"?q.click=this.X(R,{inDevTools:le=>le.undo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("undo:")}):x==="redo"?q.click=this.X(R,{inDevTools:le=>le.redo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("redo:")}):x==="editor.action.selectAll"&&(q.click=this.X(R,{inDevTools:le=>le.selectAll(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("selectAll:")}))),new n.MenuItem(this.Z(x,q))}X(b,C){return(I,D,O)=>{const R=n.BrowserWindow.getFocusedWindow();if(!R)return C.inNoWindow();if(R.webContents.isDevToolsFocused()&&R.webContents.devToolsWebContents)return C.inDevTools(R.webContents.devToolsWebContents);b(I,D||R,O)}}Y(b){let C=n.BrowserWindow.getFocusedWindow();if(C){const D=this.y.getWindowById(C.id);D&&(C=this.p.getWindowById(D.parentId)?.win??null)}if(!C){const D=this.p.getLastActiveWindow();D?.win?.isMinimized()&&(C=D.win)}const I=C?this.p.getWindowById(C.id):void 0;if(I){if(this.v.trace("menubar#runActionInRenderer",b),S.$j&&!this.q.isBuilt&&!I.isReady&&(b.type==="commandId"&&b.commandId==="workbench.action.toggleDevTools"||b.type!=="commandId"&&b.userSettingsLabel==="alt+cmd+i"))return!1;if(b.type==="commandId"){const D={id:b.commandId,from:"menu"};I.sendWhenReady("vscode:runAction",P.CancellationToken.None,D)}else{const D={userSettingsLabel:b.userSettingsLabel};I.sendWhenReady("vscode:runKeybinding",P.CancellationToken.None,D)}return!0}else return this.v.trace("menubar#runActionInRenderer: no active window found",b),!1}Z(b,C){const I=typeof b=="string"?this.l[b]:void 0;if(I?.label){if(I.isNative!==!1)C.accelerator=I.label,C.userSettingsLabel=I.userSettingsLabel;else if(typeof C.label=="string"){const D=C.label.indexOf("[");D>=0?C.label=`${C.label.substr(0,D)} [${I.label}]`:C.label=`${C.label} [${I.label}]`}}else C.accelerator=void 0;return C}$(b,C,I=!C.accelerator){I&&(C=this.Z(b,C));const D=C.click;return C.click=(O,R,W)=>{this.bb(b),D?.(O,R,W)},C}ab(b,C){this.w.openExternal(void 0,b),this.bb(C)}bb(b){this.r.publicLog2("workbenchActionExecuted",{id:b,from:r})}cb(b){return(0,M.$mw)(b,!this.C)}};e.$Zac=i,e.$Zac=i=o=Ee([ne(0,l.$4W),ne(1,p.$Oi),ne(2,a.$Z_b),ne(3,y.$O_b),ne(4,f.$Nl),ne(5,t.$Xac),ne(6,$.$WP),ne(7,k.$gac),ne(8,g.$Oj),ne(9,v.$Lac),ne(10,w.$8j),ne(11,c.$Kac)],i);function s(){return new n.MenuItem({type:"separator"})}}),define(oe[309],ae([0,1,6,20,5,308]),function(K,e,n,j,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ac=e.$1ac=void 0,e.$1ac=(0,n.$ii)("menubarMainService");let S=class{constructor(h,c,p){this.b=h,this.c=c,this.d=p,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(M.$Zac)}async updateMenubar(h,c){this.d.trace("menubarService#updateMenubar",h),(await this.a).updateMenu(c,h)}};e.$2ac=S,e.$2ac=S=Ee([ne(0,n.$hi),ne(1,j.$gac),ne(2,P.$Oj)],S)}),define(oe[310],ae([0,1,14,21,102,26,22,23,3,31,48,2,13,9,66,4,36,19,12,7,194,65,18,56,24,16,6,20,5,79,80,68,34,55,135,29,133,302,30,99,84,58,69,39,57,67,78]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g,m,v,w,$,f,l,d,a,t,o,r,i,s,u,b,C,I,D,O,R,W,F,q,x,le,te,ue,Y,Z,B,L,T,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pbc=void 0;function z(X){return(0,le.$xi)(X?.workspace)}function ce(X){return(0,le.$si)(X?.workspace)}let he=class extends y.$Uc{constructor(A,N,_,se,J,V,H,U,re,ee,fe,me,ve,ke,je,Fe,ye,Q,de,$e){super(),this.s=A,this.t=N,this.u=_,this.w=se,this.z=J,this.C=V,this.D=H,this.F=U,this.G=re,this.H=ee,this.I=fe,this.J=me,this.L=ve,this.M=ke,this.N=je,this.O=Fe,this.P=ye,this.Q=Q,this.R=de,this.S=$e,this.a=this.B(new h.$7d),this.onDidOpenWindow=this.a.event,this.b=this.B(new h.$7d),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new h.$7d),this.onDidDestroyWindow=this.c.event,this.f=this.B(new h.$7d),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new h.$7d),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new h.$7d),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new h.$7d),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new h.$7d),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new x.$mbc(this,this.C,this.H,this.w,this.J)),this.U()}U(){this.B(this.M.onDidEnterWorkspace(A=>this.b.fire(A.window))),this.B(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const N=new y.$Tc;if(N.add(h.Event.any(A.onDidClose,A.onDidDestroy)(()=>N.dispose())),A.config.extensionDevelopmentPath)for(const _ of A.config.extensionDevelopmentPath)N.add(this.Q.addValidFileRoot(_));A.config.extensionTestsPath&&N.add(this.Q.addValidFileRoot(A.config.extensionTestsPath))}}))}openEmptyWindow(A,N){const _=this.F.args,se=N?.remoteAuthority||void 0,J=!0,V=N?.forceReuseWindow,H=!V;return this.open({...A,cli:_,forceEmpty:J,forceNewWindow:H,forceReuseWindow:V,remoteAuthority:se})}openExistingWindow(A,N){A.focus(),this.W(N,[A])}async open(A){this.w.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const N=[],_=[],se=[],J=[],V=[];let H,U=0;const re=await this.cb(A);this.w.trace("windowsManager#open pathsToOpen",re);for(const ke of re)ce(ke)?A.addMode?N.push(ke):_.push(ke):z(ke)?se.push(ke):ke.fileUri?(H||(H={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:ke.remoteAuthority}),H.filesToOpenOrCreate.push(ke)):ke.backupPath?V.push({backupFolder:(0,g.$oc)(ke.backupPath),remoteAuthority:ke.remoteAuthority}):U++;A.diffMode&&H&&H.filesToOpenOrCreate.length>=2&&(H.filesToDiff=H.filesToOpenOrCreate.slice(0,2),H.filesToOpenOrCreate=[]),A.mergeMode&&H&&H.filesToOpenOrCreate.length===4&&(H.filesToMerge=H.filesToOpenOrCreate.slice(0,4),H.filesToOpenOrCreate=[],H.filesToDiff=[]),H&&A.waitMarkerFileURI&&(H.filesToWait={paths:(0,S.$Hb)([...H.filesToDiff,H.filesToMerge[3],...H.filesToOpenOrCreate]),waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(J.push(...this.M.getUntitledWorkspaces()),se.push(...J),V.push(...this.I.getEmptyWindowBackups())):V.length=0;const{windows:ee,filesOpenedInWindow:fe}=await this.X(A,se,_,V,U,H,N);if(this.w.trace(`windowsManager#open used window count ${ee.length} (workspacesToOpen: ${se.length}, foldersToOpen: ${_.length}, emptyToRestore: ${V.length}, emptyToOpen: ${U})`),ee.length>1)if(fe)fe.focus();else{const ke=this.r.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let je=!0,Fe=!0;if(ke){const ye=ee.filter(Q=>this.r.state.lastActiveWindow&&Q.backupPath===this.r.state.lastActiveWindow.backupPath);ye.length&&(ye[0].focus(),je=!1,Fe=!1)}if(je)for(let ye=ee.length-1;ye>=0;ye--){const Q=ee[ye];if(!(Q.openedWorkspace&&J.some(de=>Q.openedWorkspace&&de.workspace.id===Q.openedWorkspace.id)||Q.backupPath&&V.some(de=>Q.backupPath&&de.backupFolder===(0,g.$oc)(Q.backupPath)))){Q.focus(),Fe=!1;break}}Fe&&ee[ee.length-1].focus()}const me=H&&H.filesToDiff.length>0,ve=H&&H.filesToMerge.length>0;if(!ee.some(ke=>ke.isExtensionDevelopmentHost)&&!me&&!ve&&!A.noRecentEntry){const ke=[];for(const je of re)z(je)&&!je.transient?ke.push({label:je.label,workspace:je.workspace,remoteAuthority:je.remoteAuthority}):ce(je)?ke.push({label:je.label,folderUri:je.workspace.uri,remoteAuthority:je.remoteAuthority}):je.fileUri&&ke.push({label:je.label,fileUri:je.fileUri,remoteAuthority:je.remoteAuthority});this.L.addRecentlyOpened(ke)}return this.W(A,ee),ee}W(A,N){const _=A.waitMarkerFileURI;A.context===0&&_&&N.length===1&&N[0]&&(async()=>{await N[0].whenClosedOrLoaded;try{await this.P.del(_)}catch{}})()}async X(A,N,_,se,J,V,H){const U=[];let re;function ee(ye,Q){U.push(ye),Q&&(re=ye,V=void 0)}let{openFolderInNewWindow:fe,openFilesInNewWindow:me}=this.ob(A);if(!A.initialStartup&&H.length>0){const ye=H[0].remoteAuthority,Q=this.ub(ye);Q&&ee(this.$(Q,H.map(de=>de.workspace.uri)))}const ve=_.length+N.length+se.length;if(V&&ve===0){const ye=V.filesToOpenOrCreate[0]||V.filesToDiff[0]||V.filesToMerge[3],Q=this.getWindows().filter($e=>V&&(0,$.$1g)($e.remoteAuthority,V.remoteAuthority));let de;ye?.fileUri&&!me&&((A.context===4||A.context===0||A.context===1)&&(de=await(0,q.$5_b)(Q,ye.fileUri,async $e=>$e.configPath.scheme===k.Schemas.file?this.M.resolveLocalWorkspace($e.configPath):void 0)),de||(de=this.vb(Q))),de?(0,le.$xi)(de.openedWorkspace)?N.push({workspace:de.openedWorkspace,remoteAuthority:de.remoteAuthority}):(0,le.$si)(de.openedWorkspace)?_.push({workspace:de.openedWorkspace,remoteAuthority:de.remoteAuthority}):ee(this.Y(A,de,V),!0):ee(await this.pb({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:V,forceNewWindow:!0,remoteAuthority:V.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile}),!0)}const ke=(0,S.$Mb)(N,ye=>ye.workspace.id);if(ke.length>0){const ye=(0,S.$Hb)(ke.map(Q=>(0,q.$6_b)(this.getWindows(),Q.workspace.configPath)));if(ye.length>0){const Q=ye[0],de=(0,$.$1g)(V?.remoteAuthority,Q.remoteAuthority)?V:void 0;ee(this.Y(A,Q,de),!!de),fe=!0}for(const Q of ke){if(ye.some(Se=>Se.openedWorkspace&&Se.openedWorkspace.id===Q.workspace.id))continue;const de=Q.remoteAuthority,$e=(0,$.$1g)(V?.remoteAuthority,de)?V:void 0;ee(await this.bb(A,Q,fe,$e),!!$e),fe=!0}}const je=(0,S.$Mb)(_,ye=>$.$Mg.getComparisonKey(ye.workspace.uri));if(je.length>0){const ye=(0,S.$Hb)(je.map(Q=>(0,q.$6_b)(this.getWindows(),Q.workspace.uri)));if(ye.length>0){const Q=ye[0],de=(0,$.$1g)(V?.remoteAuthority,Q.remoteAuthority)?V:void 0;ee(this.Y(A,Q,de),!!de),fe=!0}for(const Q of je){if(ye.some(Se=>(0,le.$si)(Se.openedWorkspace)&&$.$Mg.isEqual(Se.openedWorkspace.uri,Q.workspace.uri)))continue;const de=Q.remoteAuthority,$e=(0,$.$1g)(V?.remoteAuthority,de)?V:void 0;ee(await this.bb(A,Q,fe,$e),!!$e),fe=!0}}const Fe=(0,S.$Mb)(se,ye=>ye.backupFolder);if(Fe.length>0)for(const ye of Fe){const Q=ye.remoteAuthority,de=(0,$.$1g)(V?.remoteAuthority,Q)?V:void 0;ee(await this.ab(A,!0,Q,de,ye),!!de),fe=!0}if(U.length===0||V){V&&!J&&J++;const ye=V?V.remoteAuthority:A.remoteAuthority;for(let Q=0;Q<J;Q++)ee(await this.ab(A,fe,ye,V),!!V),fe=!0}return{windows:(0,S.$Mb)(U),filesOpenedInWindow:re}}Y(A,N,_){this.w.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:_}),this.Z(N);const se={filesToOpenOrCreate:_?.filesToOpenOrCreate,filesToDiff:_?.filesToDiff,filesToMerge:_?.filesToMerge,filesToWait:_?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return N.sendWhenReady("vscode:openFiles",E.CancellationToken.None,se),N}Z(A){let N=A;const _=n.BrowserWindow.getFocusedWindow();if(_&&_.id!==A.id){const se=this.S.getWindowById(_.id);se&&se.parentId===A.id&&(N=se)}N.focus()}$(A,N){this.w.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:N}),A.focus();const _={foldersToAdd:N};return A.sendWhenReady("vscode:addFolders",E.CancellationToken.None,_),A}ab(A,N,_,se,J){this.w.trace("windowsManager#doOpenEmpty",{restore:!!J,remoteAuthority:_,filesToOpen:se,forceNewWindow:N});let V;return!N&&typeof A.contextWindowId=="number"&&(V=this.getWindowById(A.contextWindowId)),this.pb({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:_,forceNewWindow:N,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:se,windowToUse:V,emptyWindowBackupInfo:J,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}bb(A,N,_,se,J){return this.w.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:N,filesToOpen:se}),!_&&!J&&typeof A.contextWindowId=="number"&&(J=this.getWindowById(A.contextWindowId)),this.pb({workspace:N.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:N.remoteAuthority,forceNewWindow:_,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:se,windowToUse:J,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}async cb(A){let N,_=!1,se=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(N=await this.db(A),_=!0):A.forceEmpty?N=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(N=await this.eb(A.cli),N.length===0&&N.push(Object.create(null)),_=!0):(N=await this.gb(),N.length===0&&N.push(Object.create(null)),se=!0),!A.addMode&&_){const J=N.filter(V=>ce(V));if(J.length>1){const V=J[0].remoteAuthority;if(J.every(H=>(0,$.$1g)(H.remoteAuthority,V))){const H=await this.M.createUntitledWorkspace(J.map(U=>({uri:U.workspace.uri})));N.push({workspace:H,remoteAuthority:V}),N=N.filter(U=>!ce(U))}}}if(A.initialStartup&&!se&&this.J.getValue("window")?.restoreWindows==="preserve"){const J=await this.gb();N.unshift(...J.filter(V=>z(V)||ce(V)||V.backupPath))}return N}async db(A){const N={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority},_=await Promise.all((0,S.$Hb)(A.urisToOpen||[]).map(async se=>{const J=await this.ib(se,N);if(J)return J.label=se.label,J;const V=this.kb(se);this.O.showMessageBox({type:"info",buttons:[(0,d.localize)(0,null)],message:V.scheme===k.Schemas.file?(0,d.localize)(1,null):(0,d.localize)(2,null),detail:V.scheme===k.Schemas.file?(0,d.localize)(3,null,(0,p.$gw)(V,{os:v.OS,tildify:this.F})):(0,d.localize)(4,null,V.toString(!0))},n.BrowserWindow.getFocusedWindow()??void 0)}));return(0,S.$Hb)(_)}async eb(A){const N=[],_={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:A.diff&&A._.length===2||A.merge&&A._.length===4},se=A["folder-uri"];if(se){const H=await Promise.all(se.map(U=>{const re=this.fb(U);if(re)return this.ib({folderUri:re},_)}));N.push(...(0,S.$Hb)(H))}const J=A["file-uri"];if(J){const H=await Promise.all(J.map(U=>{const re=this.fb(U);if(re)return this.ib((0,le.$Ni)(U)?{workspaceUri:re}:{fileUri:re},_)}));N.push(...(0,S.$Hb)(H))}const V=await Promise.all(A._.map(H=>_.remoteAuthority?this.nb(H,_):this.lb(H,_)));return N.push(...(0,S.$Hb)(V)),N}fb(A){try{const N=l.URI.parse(A);if(!N.scheme){this.w.error(`Invalid URI input string, scheme missing: ${A}`);return}return N.path?N:N.with({path:"/"})}catch(N){this.w.error(`Invalid URI input string: ${A}, ${N.message}`)}}async gb(){const A=this.hb();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":{const N=[];A!=="one"&&N.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&N.push(this.r.state.lastActiveWindow);const _=await Promise.all(N.map(async se=>{if(se.workspace){const J=await this.ib({workspaceUri:se.workspace.configPath},{remoteAuthority:se.remoteAuthority,rejectTransientWorkspaces:!0});if(z(J))return J}else if(se.folderUri){const J=await this.ib({folderUri:se.folderUri},{remoteAuthority:se.remoteAuthority});if(ce(J))return J}else if(A!=="folders"&&se.backupPath)return{backupPath:se.backupPath,remoteAuthority:se.remoteAuthority}}));return(0,S.$Hb)(_)}}}hb(){let A;return this.H.wasRestarted?A="all":(A=this.J.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}async ib(A,N=Object.create(null)){const _=this.kb(A);return _.scheme===k.Schemas.file?((0,R.$dD)(A)&&(N={...N,forceOpenWorkspaceAsFile:!0}),this.lb(_.fsPath,N)):this.jb(A,N)}jb(A,N){let _=this.kb(A);const se=(0,D.$tm)(_)||N.remoteAuthority;if(_=(0,$.$3g)((0,$.$Wg)(_)),(0,R.$dD)(A)){if(N.gotoLineMode){const{path:J,line:V,column:H}=(0,c.$pg)(_.path);return{fileUri:_.with({path:J}),options:{selection:V?{startLineNumber:V,startColumn:H||1}:void 0},remoteAuthority:se}}return{fileUri:_,remoteAuthority:se}}else if((0,R.$bD)(A))return{workspace:(0,te.$9_b)(_),remoteAuthority:se};return{workspace:(0,te.$0_b)(_),remoteAuthority:se}}kb(A){return(0,R.$bD)(A)?A.workspaceUri:(0,R.$cD)(A)?A.folderUri:A.fileUri}async lb(A,N,_){let se,J;N.gotoLineMode&&({path:A,line:se,column:J}=(0,c.$pg)(A)),A=(0,c.$kg)((0,g.$ic)(A),(0,w.cwd)());try{const V=await j.Promises.stat(A);if(V.isFile()){if(!N.forceOpenWorkspaceAsFile){const H=await this.M.resolveLocalWorkspace(l.URI.file(A));if(H)return H.transient&&N.rejectTransientWorkspaces?void 0:{workspace:{id:H.id,configPath:H.configPath},type:i.FileType.File,exists:!0,remoteAuthority:H.remoteAuthority,transient:H.transient}}return{fileUri:l.URI.file(A),type:i.FileType.File,exists:!0,options:{selection:se?{startLineNumber:se,startColumn:J||1}:void 0}}}else{if(V.isDirectory())return{workspace:(0,te.$0_b)(l.URI.file(A),V),type:i.FileType.Directory,exists:!0};if(!v.$i&&A==="/dev/null")return{fileUri:l.URI.file(A),type:i.FileType.File,exists:!0}}}catch(V){if(V.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!_)return this.mb(A,N);const H=l.URI.file(A);if(this.L.removeRecentlyOpened([H]),N.ignoreFileNotFound)return{fileUri:H,type:i.FileType.File,exists:!1}}}async mb(A,N){const _=l.URI.file(A),{response:se,checkboxChecked:J}=await this.O.showMessageBox({type:"warning",buttons:[(0,d.localize)(5,null),(0,d.localize)(6,null),(0,d.localize)(7,null)],message:(0,d.localize)(8,null,_.authority),detail:(0,d.localize)(9,null,(0,p.$gw)(_,{os:v.OS,tildify:this.F})),checkboxLabel:(0,d.localize)(10,null,_.authority),cancelId:1});if(se===0){if((0,P.addUNCHostToAllowlist)(_.authority),J){const V={channel:"vscode:configureAllowedUNCHost",args:_.authority};this.sendToFocused(V.channel,V.args),this.sendToOpeningWindow(V.channel,V.args)}return this.lb(A,N,!0)}if(se===2)return n.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.mb(A,N)}nb(A,N){const _=A.charCodeAt(0),se=N.remoteAuthority;let J,V;N.gotoLineMode&&({path:A,line:J,column:V}=(0,c.$pg)(A)),_!==47&&((0,c.$jg)(_)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,c.$cg)(A)),A=`/${A}`);const H=l.URI.from({scheme:k.Schemas.vscodeRemote,authority:se,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,le.$Ni)(A))return N.forceOpenWorkspaceAsFile?{fileUri:H,options:{selection:J?{startLineNumber:J,startColumn:V||1}:void 0},remoteAuthority:N.remoteAuthority}:{workspace:(0,te.$9_b)(H),remoteAuthority:se};if(N.gotoLineMode||g.$hc.basename(A).indexOf(".")!==-1)return{fileUri:H,options:{selection:J?{startLineNumber:J,startColumn:V||1}:void 0},remoteAuthority:se}}return{workspace:(0,te.$0_b)(H),remoteAuthority:se}}ob(A){const N=this.J.getValue("window"),_=N?.openFoldersInNewWindow||"default",se=N?.openFilesInNewWindow||"off";let J=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(_==="on"||_==="off")&&(J=_==="on");let V=!1;return A.forceNewWindow||A.forceReuseWindow?V=!!A.forceNewWindow&&!A.forceReuseWindow:(v.$j?A.context===1&&(V=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(V=!0),!A.cli.extensionDevelopmentPath&&(se==="on"||se==="off")&&(V=se==="on")),{openFolderInNewWindow:!!J,openFilesInNewWindow:V}}async openExtensionDevelopmentHostWindow(A,N){const _=(0,q.$7_b)(this.getWindows(),A);if(_)return this.H.reload(_,N.cli),_.focus(),[_];let se=N.cli["folder-uri"]||[],J=N.cli["file-uri"]||[],V=N.cli._;if(!V.length&&!se.length&&!J.length&&!N.cli.extensionTestsPath){const re=this.r.state.lastPluginDevelopmentHostWindow,ee=re?.workspace??re?.folderUri;ee&&(l.URI.isUri(ee)?ee.scheme===k.Schemas.file?V=[ee.fsPath]:se=[ee.toString()]:ee.configPath.scheme===k.Schemas.file?V=[(0,$.$Jg)(ee.configPath)]:J=[ee.configPath.toString()])}let H=N.remoteAuthority;for(const re of A)if(re.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ee=l.URI.parse(re),fe=(0,D.$tm)(ee);fe&&(H?(0,$.$1g)(fe,H)||this.w.error("more than one extension development path authority"):H=fe)}V=V.filter(re=>{const ee=l.URI.file(re);return(0,q.$6_b)(this.getWindows(),ee)?!1:(0,$.$1g)((0,D.$tm)(ee),H)}),se=se.filter(re=>{const ee=this.fb(re);return ee&&(0,q.$6_b)(this.getWindows(),ee)?!1:ee?(0,$.$1g)((0,D.$tm)(ee),H):!1}),J=J.filter(re=>{const ee=this.fb(re);return ee&&(0,q.$6_b)(this.getWindows(),ee)?!1:ee?(0,$.$1g)((0,D.$tm)(ee),H):!1}),N.cli._=V,N.cli["folder-uri"]=se,N.cli["file-uri"]=J;const U={context:N.context,cli:N.cli,forceNewWindow:!0,forceEmpty:!V.length&&!se.length&&!J.length,userEnv:N.userEnv,noRecentEntry:!0,waitMarkerFileURI:N.waitMarkerFileURI,remoteAuthority:H,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile};return this.open(U)}async pb(A){const N=this.J.getValue("window"),_=this.getLastActiveWindow(),se=_?.profile??this.G.defaultProfile;let J;!A.forceNewWindow&&!A.forceNewTabbedWindow&&(J=A.windowToUse||_,J&&J.focus());const V={...this.F.args,...A.cli,machineId:this.s,sqmId:this.t,windowId:-1,mainPid:process.pid,appRoot:this.F.appRoot,execPath:process.execPath,codeCachePath:this.F.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,g.$kc)(this.F.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.G.profilesHome,all:this.G.profiles,profile:se},homeDir:this.F.userHome.with({scheme:k.Schemas.file}).fsPath,tmpDir:this.F.tmpDir.with({scheme:k.Schemas.file}).fsPath,userDataDir:this.F.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.u,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToMerge:A.filesToOpen?.filesToMerge,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.z.getLogLevel(),loggers:{window:[],global:this.z.getRegisteredLoggers()},logsPath:this.F.logsHome.with({scheme:k.Schemas.file}).fsPath,product:C.default,isInitialStartup:A.initialStartup,perfMarks:(0,m.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)(),arch:(0,M.arch)()},autoDetectHighContrast:N?.autoDetectHighContrast??!0,autoDetectColorScheme:N?.autoDetectColorScheme??!1,accessibilitySupport:n.app.accessibilitySupportEnabled,colorScheme:this.R.getColorScheme(),policiesData:this.D.serialize(),continueOn:this.F.continueOn};if(J){const H=J.config;!V.extensionDevelopmentPath&&H?.extensionDevelopmentPath&&(V.extensionDevelopmentPath=H.extensionDevelopmentPath,V.extensionDevelopmentKind=H.extensionDevelopmentKind,V["enable-proposed-api"]=H["enable-proposed-api"],V.verbose=H.verbose,V["inspect-extensions"]=H["inspect-extensions"],V["inspect-brk-extensions"]=H["inspect-brk-extensions"],V.debugId=H.debugId,V.extensionEnvironment=H.extensionEnvironment,V["extensions-dir"]=H["extensions-dir"],V["disable-extensions"]=H["disable-extensions"]),V.loggers={global:V.loggers.global,window:H?.loggers.window??V.loggers.window}}else{const H=this.r.getNewWindowState(V);(0,m.mark)("code/willCreateCodeWindow");const U=J=this.N.createInstance(W.$eac,{state:H,extensionDevelopmentPath:V.extensionDevelopmentPath,isExtensionTestHost:!!V.extensionTestsPath});(0,m.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(U),this.n.set(U.id,U),this.a.fire(U),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const re=new y.$Tc;re.add(U.onDidSignalReady(()=>this.b.fire(U))),re.add(h.Event.once(U.onDidClose)(()=>this.sb(U,re))),re.add(h.Event.once(U.onDidDestroy)(()=>this.tb(U))),re.add(U.onDidMaximize(()=>this.g.fire(U))),re.add(U.onDidUnmaximize(()=>this.h.fire(U))),re.add(U.onDidEnterFullScreen(()=>this.j.fire({window:U,fullscreen:!0}))),re.add(U.onDidLeaveFullScreen(()=>this.j.fire({window:U,fullscreen:!1}))),re.add(U.onDidTriggerSystemContextMenu(({x:fe,y:me})=>this.m.fire({window:U,x:fe,y:me})));const ee=(0,f.$7f)(U.win?.webContents);ee.removeAllListeners("devtools-reload-page"),ee.on("devtools-reload-page",()=>this.H.reload(U)),this.H.registerWindow(U)}return V.windowId=J.id,J.isReady?this.H.unload(J,4).then(async H=>{H||await this.qb(J,V,A,se)}):await this.qb(J,V,A,se),J}async qb(A,N,_,se){if(N.extensionDevelopmentPath||((0,le.$xi)(N.workspace)?N.backupPath=this.I.registerWorkspaceBackup({workspace:N.workspace,remoteAuthority:N.remoteAuthority}):(0,le.$si)(N.workspace)?N.backupPath=this.I.registerFolderBackup({folderUri:N.workspace.uri,remoteAuthority:N.remoteAuthority}):N.backupPath=this.I.registerEmptyWindowBackup({backupFolder:_.emptyWindowBackupInfo?.backupFolder??(0,te.$$_b)().id,remoteAuthority:N.remoteAuthority})),this.G.isEnabled()){const J=N.workspace??(0,le.$wi)(N.backupPath,!1),V=this.rb(_,J,se),H=V instanceof Promise?await V:V;N.profiles.profile=H,N.extensionDevelopmentPath||await this.G.setProfileForWorkspace(J,H)}A.load(N)}rb(A,N,_){return A.forceProfile?this.G.profiles.find(se=>se.name===A.forceProfile)??this.G.createNamedProfile(A.forceProfile):A.forceTempProfile?this.G.createTransientProfile():this.G.getProfileForWorkspace(N)??_}sb(A,N){this.n.delete(A.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),N.dispose()}tb(A){this.n.delete(A.id),this.c.fire(A)}getFocusedWindow(){const A=n.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.vb(this.getWindows())}ub(A){return this.vb(this.getWindows().filter(N=>(0,$.$1g)(N.remoteAuthority,A)))}vb(A){return(0,F.$2_b)(A)}sendToFocused(A,...N){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(A,E.CancellationToken.None,...N)}sendToOpeningWindow(A,...N){this.B(h.Event.once(this.onDidSignalReadyWindow)(_=>{_.sendWhenReady(A,E.CancellationToken.None,...N)}))}sendToAll(A,N,_){for(const se of this.getWindows())_&&_.indexOf(se.id)>=0||se.sendWhenReady(A,E.CancellationToken.None,N)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(A){return this.n.get(A)}getWindowByWebContents(A){const N=n.BrowserWindow.fromWebContents(A);if(N)return this.getWindowById(N.id)}};e.$pbc=he,e.$pbc=he=Ee([ne(3,b.$Oj),ne(4,T.$bac),ne(5,O.$WP),ne(6,B.$3n),ne(7,r.$O_b),ne(8,L.$3_b),ne(9,u.$gac),ne(10,a.$T_b),ne(11,t.$Oi),ne(12,ue.$Xac),ne(13,Y.$__b),ne(14,s.$hi),ne(15,o.$U_b),ne(16,i.$Ok),ne(17,I.$W_b),ne(18,Z.$X_b),ne(19,G.$Kac)],he)}),define(oe[311],ae([0,1,65,29,84,58]),function(K,e,n,j,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rbc=void 0;let S=class{constructor(h,c,p,y){this.a=h,this.b=c,this.c=p,this.d=y,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(h,c){const p=this.b.getWindowById(h);if(p)return this.a.enterWorkspace(p,this.b.getWindows(),c)}createUntitledWorkspace(h,c,p){return this.a.createUntitledWorkspace(c,p)}deleteUntitledWorkspace(h,c){return this.a.deleteUntitledWorkspace(c)}getWorkspaceIdentifier(h,c){return this.a.getWorkspaceIdentifier(c)}getRecentlyOpened(h){return this.c.getRecentlyOpened()}addRecentlyOpened(h,c){return this.c.addRecentlyOpened(c)}removeRecentlyOpened(h,c){return this.c.removeRecentlyOpened(c)}clearRecentlyOpened(h){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$rbc=S,e.$rbc=S=Ee([ne(0,M.$__b),ne(1,j.$Z_b),ne(2,P.$Xac),ne(3,n.$T_b)],S)}),define(oe[312],ae([0,1,14,102,37,26,17,47,15,31,3,42,48,2,13,9,4,12,7,33,160,44,161,114,294,164,65,287,18,203,92,134,56,120,224,24,64,95,212,297,214,215,216,16,228,94,77,6,93,223,303,288,295,20,5,309,70,27,68,298,96,34,279,83,126,28,255,257,54,50,269,292,304,293,305,131,271,272,273,276,301,55,29,310,278,30,98,84,311,58,39,237,57,248,53,82,132,281,296,284,8,259,280,232,67,300,275,22,129,299,267,243,62,78,307]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g,m,v,w,$,f,l,d,a,t,o,r,i,s,u,b,C,I,D,O,R,W,F,q,x,le,te,ue,Y,Z,B,L,T,G,z,ce,he,X,A,N,_,se,J,V,H,U,re,ee,fe,me,ve,ke,je,Fe,ye,Q,de,$e,Se,Re,qe,Me,Le,Ve,xe,Xe,Te,ie,ge,we,be,Pe,Ae,ze,Je,Qe,Ye,Ze,st,tt,ot,at,yt,vt,kt,Et,Pt,ct,gt,St,Ct,jt,lt,It,$t,ut,Ot,Dt,ht,Rt,mt,At){"use strict";var ft;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kbc=void 0;let dt=class extends g.$Uc{static{ft=this}static{this.a={[m.Schemas.file]:"security.promptForLocalFileProtocolHandling",[m.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Ce,Ie,De,pe,Oe,Be,Ue,Ge,We,Ne,He,Ke){super(),this.g=Ce,this.h=Ie,this.j=De,this.m=pe,this.n=Oe,this.s=Be,this.t=Ue,this.u=Ge,this.w=We,this.y=Ne,this.z=He,this.C=Ke,this.D(),this.F()}D(){const Ce=We=>We?.startsWith(`${m.Schemas.vscodeWebview}://`),Ie=new Set(["clipboard-read","clipboard-sanitized-write"]);n.session.defaultSession.setPermissionRequestHandler((We,Ne,He,Ke)=>Ce(Ke.requestingUrl)?He(Ie.has(Ne)):He(!1)),n.session.defaultSession.setPermissionCheckHandler((We,Ne,He,Ke)=>Ce(Ke.requestingUrl)?Ie.has(Ne):!1);const De=new Set([m.Schemas.file,m.Schemas.vscodeFileResource,m.Schemas.vscodeRemoteResource,m.Schemas.vscodeManagedRemoteResource,"devtools"]),pe=We=>{for(let Ne=We;Ne;Ne=Ne.parent)if(Ne.url.startsWith(`${m.Schemas.vscodeWebview}://`))return!0;return!1},Oe=We=>We.resourceType==="xhr"||pe(We.frame),Be=We=>{const Ne=We.frame;if(!Ne||!this.b)return!1;const He=n.BrowserWindow.getAllWindows();for(const Ke of He)if(Ne.processId===Ke.webContents.mainFrame.processId)return!0;return!1},Ue=(We,Ne)=>{if(We.path!=="/index.html")return!0;const He=Ne.frame;if(!He||!this.b)return!1;for(const Ke of this.b.getWindows())if(Ke.win&&He.processId===Ke.win.webContents.mainFrame.processId)return!0;return!1};n.session.defaultSession.webRequest.onBeforeRequest((We,Ne)=>{const He=f.URI.parse(We.url);return He.scheme===m.Schemas.vscodeWebview&&!Ue(He,We)?(this.m.error("Blocked vscode-webview request",We.url),Ne({cancel:!0})):He.scheme===m.Schemas.vscodeFileResource&&!Be(We)?(this.m.error("Blocked vscode-file request",We.url),Ne({cancel:!0})):He.path.endsWith(".svg")&&!De.has(He.scheme)?Ne({cancel:!Oe(We)}):Ne({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((We,Ne)=>{const He=We.responseHeaders,Ke=He["content-type"]||He["Content-Type"];if(Ke&&Array.isArray(Ke)){const _e=f.URI.parse(We.url);if(_e.path.endsWith(".svg")&&De.has(_e.scheme))return He["Content-Type"]=["image/svg+xml"],Ne({cancel:!1,responseHeaders:He});if(!_e.path.endsWith(m.Schemas.vscodeRemoteResource)&&Ke.some(it=>it.toLowerCase().includes("image/svg")))return Ne({cancel:!Oe(We)})}return Ne({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((We,Ne)=>{if(We.url.startsWith("https://vscode.download.prss.microsoft.com/")){const He=We.responseHeaders??Object.create(null);if(He["Access-Control-Allow-Origin"]===void 0)return He["Access-Control-Allow-Origin"]=["*"],Ne({cancel:!1,responseHeaders:He})}return Ne({cancel:!1})});const Ge=n.session.defaultSession;typeof Ge.setCodeCachePath=="function"&&this.s.codeCachePath&&Ge.setCodeCachePath((0,v.$kc)(this.s.codeCachePath,"chrome")),w.$i&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,j.disableUNCAccessRestrictions)():(0,j.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,h.setUnexpectedErrorHandler)(De=>this.H(De)),process.on("uncaughtException",De=>{(0,h.$Z)(De)||(0,h.$1)(De)}),process.on("unhandledRejection",De=>(0,h.$1)(De)),this.t.onWillShutdown(()=>this.dispose()),(0,d.$6V)(),n.app.on("accessibility-support-changed",(De,pe)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",pe)}),n.app.on("activate",async(De,pe)=>{this.m.trace("app#activate"),pe||await this.b?.openEmptyWindow({context:1})}),n.app.on("web-contents-created",(De,pe)=>{pe?.opener?.url.startsWith(`${m.Schemas.vscodeFileResource}://${m.$Bg}/`)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(pe)),pe.on("will-navigate",Oe=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Oe.preventDefault()}),pe.setWindowOpenHandler(Oe=>Oe.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow(Oe)}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Oe.url}}`),this.f?.openExternal(void 0,Oe.url),{action:"deny"}))});let Ce=[],Ie;n.app.on("open-file",(De,pe)=>{this.m.trace("app#open-file: ",pe),De.preventDefault(),Ce.push((0,Ae.$Ni)(pe)?{workspaceUri:f.URI.file(pe)}:{fileUri:f.URI.file(pe)}),Ie!==void 0&&(clearTimeout(Ie),Ie=void 0),Ie=setTimeout(async()=>{await this.b?.open({context:1,cli:this.s.args,urisToOpen:Ce,gotoLineMode:!1,preferNewWindow:!0}),Ce=[],Ie=void 0},100)}),n.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),P.$5V.handle("vscode:fetchShellEnv",De=>{const pe=this.b?.getWindowByWebContents(De.sender);let Oe,Be;return pe?.config?(Oe=pe.config,Be={...process.env,...pe.config.userEnv}):(Oe=this.s.args,Be=process.env),this.X(Oe,Be,!1)}),P.$5V.handle("vscode:writeNlsFile",(De,pe,Oe)=>{const Be=this.G([pe]);if(!Be||typeof Oe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(Be,S.$ue.fromString(Oe))}),P.$5V.handle("vscode:readNlsFile",async(De,...pe)=>{const Oe=this.G(pe);if(!Oe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(Oe)).value.toString()}),P.$5V.on("vscode:toggleDevTools",De=>De.sender.toggleDevTools()),P.$5V.on("vscode:openDevTools",De=>De.sender.openDevTools()),P.$5V.on("vscode:reloadWindow",De=>De.sender.reload()),P.$5V.handle("vscode:notifyZoomLevel",async(De,pe)=>{const Oe=this.b?.getWindowById(De.sender.id);Oe&&Oe.notifyZoomLevel(pe)})}G(Ce){let Ie;for(const De of Ce)typeof De=="string"&&(typeof Ie!="string"?Ie=De:Ie=(0,v.$kc)(Ie,De));if(!(typeof Ie!="string"||!(0,v.$jc)(Ie)||!(0,c.$ig)(Ie,this.s.cachedLanguagesPath,!w.$k)))return f.URI.file(Ie)}H(Ce){if(Ce){const Ie={message:`[uncaught exception in main]: ${Ce.message}`,stack:Ce.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(Ie))}this.m.error(`[uncaught exception in main]: ${Ce}`),Ce.stack&&this.m.error(Ce.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Ce=this.z.win32AppUserModelId;w.$i&&Ce&&n.app.setAppUserModelId(Ce);try{w.$j&&this.u.getValue("window.nativeTabs")===!0&&!n.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&n.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ne){this.m.error(Ne)}const Ie=new t.$_V;this.t.onWillShutdown(Ne=>{Ne.reason===2&&Ie.dispose()}),this.m.trace("Resolving machine identifier...");const[De,pe]=await Promise.all([(0,gt.$zbc)(this.w,this.m),(0,gt.$Abc)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${De}`);const{sharedProcessReady:Oe,sharedProcessClient:Be}=this.P(De,pe),Ue=await this.Q(De,pe,Oe);this.B(Ue.createInstance(r.$qac)),this.B(Ue.createInstance(Et.$vbc)),Ue.invokeFunction(Ne=>this.R(Ne,Ie,Be));const Ge=await Ue.invokeFunction(Ne=>this.I(Ne,Ie));this.J(Ie),this.t.phase=2,await Ue.invokeFunction(Ne=>this.S(Ne,Ge)),this.t.phase=3,this.U(),this.B(new ct.$uh(()=>{this.B((0,ct.$yh)(()=>this.t.phase=4,2500))},2500)).schedule()}async I(Ce,Ie){const De=this.b=Ce.get(we.$Z_b),pe=Ce.get(Le.$TW),Oe=this.f=Ce.get(V.$Lac),Be=Ce.get(O.$U_b),Ue=this;pe.registerHandler({async handleURL(_e,it){return Ue.O(De,Be,pe,_e,it)}});const Ge=this.B(new Pe.$qbc({onDidOpenMainWindow:Oe.onDidOpenMainWindow,onDidFocusMainWindow:Oe.onDidFocusMainWindow,getActiveWindowId:()=>Oe.getActiveWindowId(-1)})),We=new a.$3h(_e=>Ge.getActiveClientId().then(it=>_e===it)),Ne=new Ve.$hbc(We,this.m),He=Ie.getChannel("urlHandler",Ne);pe.registerHandler(new Ve.$gbc(He));const Ke=await this.L(De,Be);return this.B(new Xe.$ibc(Ke?.urls,pe,De,this.s,this.z,this.m)),Ke}J(Ce){const Ie=()=>({statusCode:404,data:"Not found"}),De=new Rt.$V(()=>Ce.getChannel(ht.$Hbc,new ht.$Ibc));n.protocol.registerBufferProtocol(m.Schemas.vscodeManagedRemoteResource,(pe,Oe)=>{const Be=f.URI.parse(pe.url);if(!Be.authority.startsWith("window:"))return Oe(Ie());De.value.call(ht.$Gbc,[Be]).then(Ue=>Oe({...Ue,data:Buffer.from(Ue.body,"base64")}),Ue=>{this.m.warn("error dispatching remote resource call",Ue),Oe({statusCode:500,data:String(Ue)})})})}async L(Ce,Ie){const De=this.s.args["open-url"]?this.s.args._urls||[]:[];De.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",De);const pe=global.getOpenUrls()||[];if(pe.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",pe),De.length+pe.length===0)return;const Oe=[...De,...pe].map(Ge=>{try{return{uri:f.URI.parse(Ge),originalUrl:Ge}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ge);return}}),Be=[],Ue=[];for(const Ge of Oe){if(!Ge)continue;const We=this.N(Ge.uri);if(We)if(await this.M(We,Ce,Ie)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ge.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ge.uri.toString(!0),We),Be.push(We);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ge.uri.toString(!0)),Ue.push(Ge)}return{urls:Ue,openables:Be}}async M(Ce,Ie,De){let pe,Oe;if((0,ge.$bD)(Ce)?(pe=Ce.workspaceUri,Oe=(0,i.localize)(0,null,pe.scheme===m.Schemas.file?(0,k.$gw)(pe,{os:w.OS,tildify:this.s}):pe.toString(!0),this.z.nameShort)):(0,ge.$cD)(Ce)?(pe=Ce.folderUri,Oe=(0,i.localize)(1,null,pe.scheme===m.Schemas.file?(0,k.$gw)(pe,{os:w.OS,tildify:this.s}):pe.toString(!0),this.z.nameShort)):(pe=Ce.fileUri,Oe=(0,i.localize)(2,null,pe.scheme===m.Schemas.file?(0,k.$gw)(pe,{os:w.OS,tildify:this.s}):pe.toString(!0),this.z.nameShort)),pe.scheme!==m.Schemas.file&&pe.scheme!==m.Schemas.vscodeRemote||this.u.getValue(ft.a[pe.scheme])===!1)return!1;const{response:Ue,checkboxChecked:Ge}=await De.showMessageBox({type:"warning",buttons:[(0,i.localize)(3,null),(0,i.localize)(4,null)],message:Oe,detail:(0,i.localize)(5,null),checkboxLabel:pe.scheme===m.Schemas.file?(0,i.localize)(6,null):(0,i.localize)(7,null),cancelId:1});if(Ue!==0)return!0;if(Ge){const We={channel:"vscode:disablePromptForProtocolHandling",args:pe.scheme===m.Schemas.file?"local":"remote"};Ie.sendToFocused(We.channel,We.args),Ie.sendToOpeningWindow(We.channel,We.args)}return!1}N(Ce){if(Ce.path){if(Ce.authority===m.Schemas.file){const Ie=f.URI.file(Ce.fsPath);return(0,Ae.$Ni)(Ie)?{workspaceUri:Ie}:{fileUri:Ie}}else if(Ce.authority===m.Schemas.vscodeRemote){const Ie=Ce.path.indexOf(v.$hc.sep,1);if(Ie!==-1){const De=Ce.path.substring(1,Ie),pe=Ce.path.substring(Ie);let Oe=Ce.query;const Be=new URLSearchParams(Ce.query);Be.get("windowId")==="_blank"&&(Be.delete("windowId"),Oe=Be.toString());const Ue=f.URI.from({scheme:m.Schemas.vscodeRemote,authority:De,path:pe,query:Oe,fragment:Ce.fragment});return(0,Ae.$Ni)(pe)?{workspaceUri:Ue}:/:[\d]+$/.test(pe)?{fileUri:Ue}:{folderUri:Ue}}}}}async O(Ce,Ie,De,pe,Oe){this.m.trace("app#handleProtocolUrl():",pe.toString(!0),Oe),pe.scheme===this.z.urlProtocol&&pe.path==="workspace"&&(pe=pe.with({authority:"file",path:f.URI.parse(pe.query).path,query:""}));let Be=!1;const Ue=new URLSearchParams(pe.query);Ue.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",pe.toString(!0)),Ue.delete("windowId"),pe=pe.with({query:Ue.toString()}),Be=!0):w.$j&&Ce.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",pe.toString(!0)),Be=!0);const Ge=Ue.get("continueOn");Ge!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",pe.toString(!0)),Ue.delete("continueOn"),pe=pe.with({query:Ue.toString()}),this.s.continueOn=Ge??void 0);const We=this.N(pe);return We?await this.M(We,Ce,Ie)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",pe.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",We,pe.toString(!0)),(0,$t.$Ob)(await Ce.open({context:5,cli:{...this.s.args},urisToOpen:[We],forceNewWindow:Be,gotoLineMode:!0}))?.focus(),!0):Be?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",pe.toString(!0)),await(0,$t.$Ob)(await Ce.open({context:5,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,U.$tm)(pe)}))?.ready(),De.open(pe,Oe)):(this.m.trace("app#handleProtocolUrl(): not handled",pe.toString(!0),Oe),!1)}P(Ce,Ie){const De=this.B(this.j.createInstance(re.$6ac,Ce,Ie)),pe=(async()=>{this.m.trace("Main->SharedProcess#connect");const Be=await De.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new o.$aW(Be,"main")})();return{sharedProcessReady:(async()=>(await De.whenReady(),pe))(),sharedProcessClient:pe}}async Q(Ce,Ie,De){const pe=new ce.$gi;switch(process.platform){case"win32":pe.set(de.$4W,new G.$fi(Me.$ebc));break;case"linux":w.$l?pe.set(de.$4W,new G.$fi(qe.$dbc,[process.env.SNAP,process.env.SNAP_REVISION])):pe.set(de.$4W,new G.$fi(Re.$cbc));break;case"darwin":pe.set(de.$4W,new G.$fi(Se.$bbc));break}pe.set(we.$Z_b,new G.$fi(be.$pbc,[Ce,Ie,this.h],!1)),pe.set(mt.$Kac,new G.$fi(At.$Jbc,void 0,!1));const Oe=new O.$V_b(this.m,this.z);pe.set(O.$U_b,Oe),pe.set(N.$Rac,new G.$fi(N.$Sac,void 0,!1)),pe.set(D.$wac,new G.$fi(D.$xac,void 0,!1)),pe.set(I.$2m,a.ProxyChannel.toService((0,a.$1h)(De.then(Ne=>Ne.getChannel("diagnostics"))))),pe.set(he.$TCb,new G.$fi(X.$Nac,[this.h])),pe.set(R.$NW,new G.$fi(W.$yac)),pe.set(A.$Oac,new G.$fi(A.$Pac)),pe.set(V.$Lac,new G.$fi(V.$Mac,void 0,!1)),pe.set(Te.$jbc,new G.$fi(ie.$lbc)),pe.set(J.$1ac,new G.$fi(J.$2ac)),pe.set(le.$zac,new G.$fi(te.$Bac)),pe.set(ve.$mac,new G.$fi(ve.$nac)),pe.set(ve.$oac,new G.$fi(ve.$pac));const Be=new Ot.$Fbc({graceTime:6e4,shortGraceTime:6e3,scrollback:this.u.getValue("terminal.integrated.persistentSessionScrollback")??100},this.u,this.s,this.t,this.m),Ue=new Dt.$fs(Be,this.u,this.m,this.n);pe.set(ut.$Sr,Ue),w.$i?pe.set(ue.$Cac,new G.$fi(Y.$Dac)):w.$j?pe.set(ue.$Cac,new G.$fi(Y.$Eac)):w.$k&&pe.set(ue.$Cac,new G.$fi(Y.$Fac));const Ge=new u.$rac(this.s,this.u,this.m,this.w);pe.set(s.$T_b,Ge);const We=new Ye.$aac(this.s,this.m,this.C,Ge,Oe);if(pe.set(Ye.$__b,We),pe.set(ze.$Peb,new G.$fi(Qe.$rbc,void 0,!1)),pe.set(Je.$Xac,new G.$fi(Je.$Yac,void 0,!1)),pe.set(Le.$TW,new G.$fi(xe.$VW,void 0,!1)),(0,Q.$$o)(this.z,this.s)){const Ne=(0,Q.$dp)(this.z,this.u),He=(0,a.$1h)(De.then(rt=>rt.getChannel("telemetryAppender"))),Ke=new Fe.$9ac(He),_e=(0,ke.$2o)((0,M.release)(),(0,M.hostname)(),process.arch,this.z.commit,this.z.version,Ce,Ie,Ne),it=(0,Q.$ep)(this.s),nt={appenders:[Ke],commonProperties:_e,piiPaths:it,sendErrorTelemetry:!0};pe.set(je.$Nl,new G.$fi(ye.$Jr,[nt],!1))}else pe.set(je.$Nl,Q.$6o);return pe.set(yt.$bq,new G.$fi(St.$4P,void 0,!0)),pe.set(vt.$fq,new G.$fi(kt.$ubc,void 0,!0)),pe.set(lt.$Dbc,new G.$fi(lt.$Ebc,void 0,!0)),await ct.Promises.settled([Ge.initialize(),We.initialize()]),this.j.createChild(pe)}R(Ce,Ie,De){const pe=this.B(new g.$Tc),Oe=a.ProxyChannel.fromService(Ce.get(N.$Rac),pe,{disableMarshalling:!0});this.g.registerChannel("launch",Oe);const Be=a.ProxyChannel.fromService(Ce.get(D.$wac),pe,{disableMarshalling:!0});this.g.registerChannel("diagnostics",Be);const Ue=new st.$sbc(Ce.get(Ze.$3n));Ie.registerChannel("policy",Ue),De.then(et=>et.registerChannel("policy",Ue));const Ge=this.y.getProvider(m.Schemas.file);(0,$.$6f)(Ge instanceof T.$Vq);const We=new L.$Gac(Ge,this.m,this.s);Ie.registerChannel(Z.$MP,We),De.then(et=>et.registerChannel(Z.$MP,We));const Ne=a.ProxyChannel.fromService(Ce.get(tt.$3_b),pe);Ie.registerChannel("userDataProfiles",Ne),De.then(et=>et.registerChannel("userDataProfiles",Ne));const He=new ot.$Er(Ce.get(at.$zp));De.then(et=>et.registerChannel("request",He));const Ke=new $e.$0ac(Ce.get(de.$4W));Ie.registerChannel("update",Ke);const _e=a.ProxyChannel.fromService(Ce.get(he.$TCb),pe);Ie.registerChannel("issue",_e);const it=a.ProxyChannel.fromService(Ce.get(R.$NW),pe);Ie.registerChannel("encryption",it);const nt=a.ProxyChannel.fromService(Ce.get(ee.$Bl),pe);Ie.registerChannel("sign",nt);const rt=a.ProxyChannel.fromService(Ce.get(A.$Oac),pe);Ie.registerChannel("keyboardLayout",rt),this.f=Ce.get(V.$Lac);const wt=a.ProxyChannel.fromService(this.f,pe);Ie.registerChannel("nativeHost",wt),De.then(et=>et.registerChannel("nativeHost",wt));const Mt=a.ProxyChannel.fromService(Ce.get(ze.$Peb),pe);Ie.registerChannel("workspaces",Mt);const Lt=a.ProxyChannel.fromService(Ce.get(J.$1ac),pe);Ie.registerChannel("menubar",Lt);const Wt=a.ProxyChannel.fromService(Ce.get(Le.$TW),pe);Ie.registerChannel("url",Wt);const Ft=a.ProxyChannel.fromService(Ce.get(Te.$jbc),pe);Ie.registerChannel("webview",Ft);const pt=this.B(new me.$7ac(this.m,Ce.get(ve.$mac)));Ie.registerChannel("storage",pt),De.then(et=>et.registerChannel("storage",pt));const Nt=this.B(new Pt.$wbc(Ce.get(ve.$mac),Ce.get(tt.$3_b),this.m));De.then(et=>et.registerChannel("profileStorageListener",Nt));const Tt=a.ProxyChannel.fromService(Ce.get(ut.$Sr),pe);Ie.registerChannel(ut.TerminalIpcChannels.LocalPty,Tt);const zt=a.ProxyChannel.fromService(Ce.get(ue.$Cac),pe);Ie.registerChannel("externalTerminal",zt);const bt=new Ct.$Bbc(Ce.get(jt.$bac));Ie.registerChannel("logger",bt),De.then(et=>et.registerChannel("logger",bt));const Bt=new C.$sac(Ce.get(we.$Z_b));Ie.registerChannel("extensionhostdebugservice",Bt);const qt=a.ProxyChannel.fromService(Ce.get(le.$zac),pe);Ie.registerChannel(le.$Aac,qt);const Ut=a.ProxyChannel.fromService(Ce.get(lt.$Dbc),pe);Ie.registerChannel(It.$Cbc,Ut)}async S(Ce,Ie){const De=this.b=Ce.get(we.$Z_b);this.c=Ce.get(mt.$Kac);const pe=(0,q.$mm)(process.env)?0:4,Oe=this.s.args;if(Ie){if(Ie.openables.length>0)return De.open({context:pe,cli:Oe,urisToOpen:Ie.openables,gotoLineMode:!0,initialStartup:!0});if(Ie.urls.length>0)for(const nt of Ie.urls){const rt=new URLSearchParams(nt.uri.query);if(rt.get("windowId")==="_blank")return rt.delete("windowId"),nt.originalUrl=nt.uri.toString(!0),nt.uri=nt.uri.with({query:rt.toString()}),De.open({context:pe,cli:Oe,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Be=global.macOpenFiles,Ue=Oe._.length,Ge=!!Oe["folder-uri"],We=!!Oe["file-uri"],Ne=Oe["skip-add-to-recently-opened"]===!0,He=Oe.wait&&Oe.waitMarkerFilePath?f.URI.file(Oe.waitMarkerFilePath):void 0,Ke=Oe.remote||void 0,_e=Oe.profile,it=Oe["profile-temp"];if(!Ue&&!Ge&&!We){if(Oe["new-window"]||_e||it)return De.open({context:pe,cli:Oe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ne,waitMarkerFileURI:He,initialStartup:!0,remoteAuthority:Ke,forceProfile:_e,forceTempProfile:it});if(Be.length)return De.open({context:1,cli:Oe,urisToOpen:Be.map(nt=>(0,Ae.$Ni)(nt)?{workspaceUri:f.URI.file(nt)}:{fileUri:f.URI.file(nt)}),noRecentEntry:Ne,waitMarkerFileURI:He,initialStartup:!0})}return De.open({context:pe,cli:Oe,forceNewWindow:Oe["new-window"]||!Ue&&Oe["unity-launch"],diffMode:Oe.diff,mergeMode:Oe.merge,noRecentEntry:Ne,waitMarkerFileURI:He,gotoLineMode:Oe.goto,initialStartup:!0,remoteAuthority:Ke,forceProfile:_e,forceTempProfile:it})}U(){this.W(),n.protocol.registerHttpProtocol(m.Schemas.vscodeRemoteResource,(Ce,Ie)=>{Ie({url:Ce.url.replace(/^vscode-remote-resource:/,"http:"),method:Ce.method})}),this.X(this.s.args,process.env,!0),this.Y(),w.$j&&n.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const Ce=this.z.win32MutexName;if(w.$i&&Ce)try{const Ie=await new Promise((pe,Oe)=>{K(["@vscode/windows-mutex"],pe,Oe)}),De=new Ie.Mutex(Ce);p.Event.once(this.t.onWillShutdown)(()=>De.release())}catch(Ie){this.m.error(Ie)}}async X(Ce,Ie,De){try{return await(0,x.$sm)(this.u,this.m,Ce,Ie)}catch(pe){const Oe=(0,E.$6i)(pe);De?this.b?.sendToFocused("vscode:showResolveShellEnvError",Oe):this.m.error(Oe)}return{}}async Y(){try{const Ie=(await this.y.readFile(this.s.argvResource)).value.toString(),De=JSON.parse((0,y.$Dn)(Ie)),Oe=(0,Q.$ap)(this.u)>=1;if(De["enable-crash-reporter"]===void 0){const Be=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Oe},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,l.$Eg)()}"`,"}"],Ue=Ie.substring(0,Ie.length-2).concat(`,
`,Be.join(`
`));await this.y.writeFile(this.s.argvResource,S.$ue.fromString(Ue))}else{const Be=Ie.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Oe},`);Be!==Ie&&await this.y.writeFile(this.s.argvResource,S.$ue.fromString(Be))}}catch(Ce){this.m.error(Ce)}}};e.$Kbc=dt,e.$Kbc=dt=ft=Ee([ne(2,z.$hi),ne(3,se.$Oj),ne(4,se.$Pj),ne(5,F.$O_b),ne(6,_.$gac),ne(7,b.$Oi),ne(8,fe.$WP),ne(9,B.$Ok),ne(10,H.$8j),ne(11,tt.$3_b)],dt)}),define(oe[317],ae([0,1,14,43,7,22,8,47,15,31,3,48,13,9,66,4,36,25,21,44,100,312,10,18,242,254,24,64,205,16,226,94,77,222,93,20,229,5,79,27,80,282,130,291,53,290,96,253,34,54,69,57,39,238,236,2,40,270,67,231,119,125,274,102,268]),function(K,e,n,j,P,M,S,E,h,c,p,y,k,g,m,v,w,$,f,l,d,a,t,o,r,i,s,u,b,C,I,D,O,R,W,F,q,x,le,te,ue,Y,Z,B,L,T,G,z,ce,he,X,A,N,_,se,J,V,H,U,re,ee,fe,me,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ke{main(){try{this.a()}catch(ye){console.error(ye.message),n.app.exit(1)}}async a(){(0,h.setUnexpectedErrorHandler)(Le=>console.error(Le));const[ye,Q,de,$e,Se,Re,qe,Me]=this.b();try{try{await this.d(de,Me,$e,Se,qe)}catch(Le){throw this.g(de,qe,Le),Le}await ye.invokeFunction(async Le=>{const Ve=Le.get(x.$Oj),xe=Le.get(F.$gac),Xe=Le.get(C.$Ok),Te=Le.get(x.$Pj),ie=await this.f(Ve,de,xe,ye,qe,!0);return f.Promises.writeFile(de.mainLockfile,String(process.pid)).catch(ge=>{Ve.warn(`app#startup(): Error writing main lockfile: ${ge.stack}`)}),Re.logger=Te.createLogger("main",{name:(0,t.localize)(0,null)}),p.Event.once(xe.onWillShutdown)(ge=>{Xe.dispose(),$e.dispose(),ge.join("instanceLockfile",f.Promises.unlink(de.mainLockfile).catch(()=>{}))}),ye.createInstance(a.$Kbc,ie,Q).startup()})}catch(Le){ye.invokeFunction(this.j,Le)}}b(){const ye=new W.$gi,Q=new J.$Tc;process.once("exit",()=>Q.dispose());const de={_serviceBrand:void 0,...le.default};ye.set(te.$8j,de);const $e=new s.$P_b(this.k(),de),Se=this.c($e);ye.set(s.$O_b,$e);const Re=new U.$cac((0,x.$3j)($e),$e.logsHome);ye.set(U.$bac,Re);const qe=new q.$u0b(Re.getLogLevel()),Me=Q.add(new re.$5P(qe,[new x.$Vj(Re.getLogLevel())]));ye.set(x.$Oj,Me);const Le=new I.$uq(Me);ye.set(C.$Ok,Le);const Ve=new D.$Vq(Me);Le.registerProvider(k.Schemas.file,Ve);const xe=new H.$js(Le);ye.set(V.$ml,xe);const Xe=new fe.$ZP(1,$e,Me,Le);ye.set(ce.$VP,Xe),ye.set(ce.$WP,Xe);const Te=new A.$4_b(Xe,xe,$e,Le,Me);ye.set(A.$3_b,Te),Le.registerProvider(k.Schemas.vscodeUserData,new me.$Vbc(k.Schemas.file,Ve,k.Schemas.vscodeUserData,Te,xe,Me));const ie=v.$i&&de.win32RegValueName?Q.add(new _.$Tbc(Me,de.win32RegValueName)):$e.policyFile?Q.add(new se.$Ubc($e.policyFile,Le,Me)):new N.$5n;ye.set(N.$3n,ie);const ge=new r.$so(Te.defaultProfile.settingsResource,Le,ie,Me);return ye.set(o.$Oi,ge),ye.set(F.$gac,new O.$fi(F.$hac,void 0,!1)),ye.set(L.$zp,new O.$fi(T.$Rbc,void 0,!0)),ye.set(X.$X_b,new O.$fi(X.$Y_b)),ye.set(G.$Bl,new O.$fi(z.$Sbc,void 0,!1)),ye.set(Z.$Wv,new O.$fi(B.$Pbc)),ye.set(ue.$W_b,new Y.$Mbc($e,Te,Me)),[new R.$Yq(ye,!0),Se,$e,ge,Xe,qe,de,Te]}c(ye){const Q={VSCODE_IPC_HOOK:ye.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(de=>{const $e=process.env[de];typeof $e=="string"&&(Q[de]=$e)}),Object.assign(process.env,Q),Q}async d(ye,Q,de,$e,Se){await S.Promises.settled([Promise.all([this.e(ye.extensionsPath),ye.codeCachePath,ye.logsHome.with({scheme:k.Schemas.file}).fsPath,Q.defaultProfile.globalStorageHome.with({scheme:k.Schemas.file}).fsPath,ye.workspaceStorageHome.with({scheme:k.Schemas.file}).fsPath,ye.localHistoryHome.with({scheme:k.Schemas.file}).fsPath,ye.backupHome].map(Re=>Re?f.Promises.mkdir(Re,{recursive:!0}):void 0)),$e.init(),de.initialize()]),Q.init()}e(ye){if(v.$i){const Q=(0,ve.getUNCHost)(ye);Q&&(0,ve.addUNCHostToAllowlist)(Q)}return ye}async f(ye,Q,de,$e,Se,Re){let qe;try{(0,m.mark)("code/willStartMainServer"),qe=await(0,d.$di)(Q.mainIPCHandle),(0,m.mark)("code/didStartMainServer"),p.Event.once(de.onWillShutdown)(()=>qe.dispose())}catch(Me){if(Me.code!=="EADDRINUSE")throw this.g(Q,Se,Me),Me;let Le;try{Le=await(0,d.$ei)(Q.mainIPCHandle,"main")}catch(Te){if(!Re||v.$i||Te.code!=="ECONNREFUSED")throw Te.code==="EPERM"&&this.h((0,t.localize)(1,null,Se.nameShort),(0,t.localize)(2,null),Se),Te;try{(0,j.unlinkSync)(Q.mainIPCHandle)}catch(ie){throw ye.warn("Could not delete obsolete instance handle",ie),ie}return this.f(ye,Q,de,$e,Se,!1)}if(Q.extensionTestsLocationURI&&!Q.debugExtensionHost.break){const Te=`Running extension tests from the command line is currently only supported if no other instance of ${Se.nameShort} is running.`;throw ye.error(Te),Le.dispose(),new Error(Te)}let Ve;!Q.args.wait&&!Q.args.status&&(Ve=setTimeout(()=>{this.h((0,t.localize)(3,null,Se.nameShort),(0,t.localize)(4,null),Se)},1e4));const xe=l.ProxyChannel.toService(Le.getChannel("launch"),{disableMarshalling:!0}),Xe=l.ProxyChannel.toService(Le.getChannel("diagnostics"),{disableMarshalling:!0});if(Q.args.status)return $e.invokeFunction(async()=>{const Te=new i.$qs(he.$6o,Se),ie=await Xe.getMainDiagnostics(),ge=await Xe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),we=await Te.getDiagnostics(ie,ge);throw console.log(we),new h.$ab});throw v.$i&&await this.i(xe,ye),ye.trace("Sending env to running instance..."),await xe.start(Q.args,process.env),Le.dispose(),Ve&&clearTimeout(Ve),new h.$ab("Sent env to running instance. Terminating...")}if(Q.args.status)throw console.log((0,t.localize)(5,null,Se.nameShort)),new h.$ab("Terminating...");return process.env.VSCODE_PID=String(process.pid),qe}g(ye,Q,de){if(de.code==="EACCES"||de.code==="EPERM"){const $e=(0,M.$Hb)([ye.userDataPath,ye.extensionsPath,d.$_h]).map(Se=>(0,y.$gw)(P.URI.file(Se),{os:v.OS,tildify:ye}));this.h((0,t.localize)(6,null),(0,t.localize)(7,null,(0,E.$6i)(de),$e.join(`
`)),Q)}}h(ye,Q,de){n.dialog.showMessageBoxSync((0,ee.$uw)({type:"warning",buttons:[(0,t.localize)(8,null)],message:ye,detail:Q},de).options)}async i(ye,Q){if(v.$i){const de=await ye.getMainProcessId();Q.trace("Sending some foreground love to the running instance:",de);try{(await new Promise(($e,Se)=>{K(["windows-foreground-love"],$e,Se)})).allowSetForegroundWindow(de)}catch($e){Q.error($e)}}}j(ye,Q){const de=ye.get(x.$Oj),$e=ye.get(F.$gac);let Se=0;Q&&(Q.isExpected?Q.message&&de.trace(Q.message):(Se=1,Q.stack?de.error(Q.stack):de.error(`Startup error: ${Q.toString()}`))),$e.kill(Se)}k(){const ye=this.l((0,u.$jm)(process.argv));if(ye.wait&&!ye.waitMarkerFilePath){const Q=(0,b.$Lbc)(ye.verbose);Q&&((0,u.$lm)(process.argv,"--waitMarkerFilePath",Q),ye.waitMarkerFilePath=Q)}return ye}l(ye){if(ye["open-url"]&&(ye._urls=ye._,ye._=[]),!ye.remote){const Q=this.m(ye._,ye.goto);ye._=Q}return ye}m(ye,Q){const de=(0,w.cwd)(),$e=ye.map(qe=>{let Me=String(qe),Le;Q&&(Le=(0,c.$pg)(Me),Me=Le.path),Me&&(Me=this.n(de,Me));const Ve=(0,c.$kg)(Me,de),xe=(0,g.$oc)(Ve);return xe&&!(0,c.$gg)(xe)?null:Q&&Le?(Le.path=Ve,this.o(Le)):Ve}),Se=v.$i||v.$j,Re=(0,M.$Mb)($e,qe=>qe&&Se?qe.toLowerCase():qe||"");return(0,M.$Hb)(Re)}n(ye,Q){return v.$i&&(Q=(0,$.$6e)(Q,'"')),Q=(0,$.$4e)((0,$.$4e)(Q," "),"	"),v.$i&&(Q=(0,g.$lc)(ye,Q),Q=(0,$.$6e)(Q,".")),Q}o(ye){const Q=[ye.path];return typeof ye.line=="number"&&Q.push(String(ye.line)),typeof ye.column=="number"&&Q.push(String(ye.column)),Q.join(":")}}new ke().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7c51753f7ce936a7aeb84ac881818c35c5a9ab8d/core/vs/code/electron-main/main.js.map
