/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/platform/log/common/log","vs/nls","vs/base/common/errors","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/base/common/json","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","fs","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/base/common/extpath","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],re=function(J){for(var e=[],D=0,j=J.length;D<j;D++)e[D]=ne[J[D]];return e};define(ne[71],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class D{static get(){const k=new Map,A=new Map,R=new Map,S=new Map;function u(p,w){p.has(w.detail)||p.set(w.detail,-w.timestamp)}function a(p,w){const O=p.get(w.detail);O&&(O>=0||p.set(w.detail,O+w.timestamp))}let y=[];typeof J=="function"&&typeof J.getStats=="function"&&(y=J.getStats().slice(0).sort((p,w)=>p.timestamp-w.timestamp));for(const p of y)switch(p.type){case 10:u(k,p);break;case 11:case 12:a(k,p);break;case 21:u(A,p);break;case 22:a(A,p);break;case 33:u(R,p);break;case 34:a(R,p);break;case 31:u(S,p);break;case 32:a(S,p);break}let v=0;R.forEach(p=>v+=p);function d(p){const w=[];return p.forEach((O,m)=>w.push([m,O])),w}return{amdLoad:d(k),amdInvoke:d(A),nodeRequire:d(R),nodeEval:d(S),nodeRequireTotal:v}}static toMarkdownTable(k,A){let R="";const S=[];return k.forEach((u,a)=>{S[a]=u.length}),A.forEach(u=>{u.forEach((a,y)=>{typeof a>"u"&&(a=u[y]="-");const v=a.toString().length;S[y]=Math.max(v,S[y])})}),k.forEach((u,a)=>{R+=`| ${u+" ".repeat(S[a]-u.toString().length)} `}),R+=`|
`,k.forEach((u,a)=>{R+=`| ${"-".repeat(S[a])} `}),R+=`|
`,A.forEach(u=>{u.forEach((a,y)=>{typeof a<"u"&&(R+=`| ${a+" ".repeat(S[y]-a.toString().length)} `)}),R+=`|
`}),R}}e.$U=D}),define(ne[54],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=j,e.$Nh=k,e.$Oh=A;function D(R){return(S,u,a)=>{let y=null,v=null;if(typeof a.value=="function"?(y="value",v=a.value):typeof a.get=="function"&&(y="get",v=a.get),!v)throw new Error("not supported");a[y]=R(v,u)}}function j(R,S,u){let a=null,y=null;if(typeof u.value=="function"?(a="value",y=u.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(a="get",y=u.get),!y)throw new Error("not supported");const v=`$memoize$${S}`;u[a]=function(...d){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,d)}),this[v]}}function k(R,S,u){return D((a,y)=>{const v=`$debounce$${y}`,d=`$debounce$result$${y}`;return function(...p){this[d]||(this[d]=u?u():void 0),clearTimeout(this[v]),S&&(this[d]=S(this[d],...p),p=[this[d]]),this[v]=setTimeout(()=>{a.apply(this,p),this[d]=u?u():void 0},R)}})}function A(R,S,u){return D((a,y)=>{const v=`$throttle$timer$${y}`,d=`$throttle$result$${y}`,p=`$throttle$lastRun$${y}`,w=`$throttle$pending$${y}`;return function(...O){if(this[d]||(this[d]=u?u():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),S&&(this[d]=S(this[d],...O)),this[w])return;const m=this[p]+R;m<=Date.now()?(this[p]=Date.now(),a.apply(this,[this[d]]),this[d]=u?u():void 0):(this[w]=!0,this[v]=setTimeout(()=>{this[w]=!1,this[p]=Date.now(),a.apply(this,[this[d]]),this[d]=u?u():void 0},m-Date.now()))}})}}),define(ne[72],re([0,1,8]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=j,e.$0c=k,e.$$c=A,e.$_c=R,e.$ad=S,e.$bd=u;function j(a,y){if(!a)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}function k(a,y="Unreachable"){throw new Error(y)}function A(a){if(!a)throw new D.$cb("Assertion Failed")}function R(a){a||(0,D.$1)(new D.$cb("Soft Assertion Failed"))}function S(a){if(!a()){debugger;a(),(0,D.$1)(new D.$cb("Assertion Failed"))}}function u(a,y){let v=0;for(;v<a.length-1;){const d=a[v],p=a[v+1];if(!y(d,p))return!1;v++}return!0}}),define(ne[38],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$tn=R,e.$un=v,e.$vn=d,e.$wn=p,e.$xn=w,e.$yn=O,e.$zn=m,e.$An=c,e.$Bn=b,e.$Cn=$,e.$Dn=h,e.$En=g;var D;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var j;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(j||(e.SyntaxKind=j={}));var k;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(k||(e.ParseErrorCode=k={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function R(i,r=!1){let t=0;const n=i.length;let s="",o=0,l=16,P=0;function I(ie){let ue=0,he=0;for(;ue<ie;){const ce=i.charCodeAt(t);if(ce>=48&&ce<=57)he=he*16+ce-48;else if(ce>=65&&ce<=70)he=he*16+ce-65+10;else if(ce>=97&&ce<=102)he=he*16+ce-97+10;else break;t++,ue++}return ue<ie&&(he=-1),he}function L(ie){t=ie,s="",o=0,l=16,P=0}function z(){const ie=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&a(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&a(i.charCodeAt(t)))for(t++;t<i.length&&a(i.charCodeAt(t));)t++;else return P=3,i.substring(ie,t);let ue=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&a(i.charCodeAt(t))){for(t++;t<i.length&&a(i.charCodeAt(t));)t++;ue=t}else P=3;return i.substring(ie,ue)}function U(){let ie="",ue=t;for(;;){if(t>=n){ie+=i.substring(ue,t),P=2;break}const he=i.charCodeAt(t);if(he===34){ie+=i.substring(ue,t),t++;break}if(he===92){if(ie+=i.substring(ue,t),t++,t>=n){P=2;break}switch(i.charCodeAt(t++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:{const B=I(4);B>=0?ie+=String.fromCharCode(B):P=4;break}default:P=5}ue=t;continue}if(he>=0&&he<=31)if(u(he)){ie+=i.substring(ue,t),P=2;break}else P=6;t++}return ie}function V(){if(s="",P=0,o=t,t>=n)return o=n,l=17;let ie=i.charCodeAt(t);if(S(ie)){do t++,s+=String.fromCharCode(ie),ie=i.charCodeAt(t);while(S(ie));return l=15}if(u(ie))return t++,s+=String.fromCharCode(ie),ie===13&&i.charCodeAt(t)===10&&(t++,s+=`
`),l=14;switch(ie){case 123:return t++,l=1;case 125:return t++,l=2;case 91:return t++,l=3;case 93:return t++,l=4;case 58:return t++,l=6;case 44:return t++,l=5;case 34:return t++,s=U(),l=10;case 47:{const ue=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<n&&!u(i.charCodeAt(t));)t++;return s=i.substring(ue,t),l=12}if(i.charCodeAt(t+1)===42){t+=2;const he=n-1;let ce=!1;for(;t<he;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,ce=!0;break}t++}return ce||(t++,P=1),s=i.substring(ue,t),l=13}return s+=String.fromCharCode(ie),t++,l=16}case 45:if(s+=String.fromCharCode(ie),t++,t===n||!a(i.charCodeAt(t)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=z(),l=11;default:for(;t<n&&X(ie);)t++,ie=i.charCodeAt(t);if(o!==t){switch(s=i.substring(o,t),s){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return s+=String.fromCharCode(ie),t++,l=16}}function X(ie){if(S(ie)||u(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let ie;do ie=V();while(ie>=12&&ie<=15);return ie}return{setPosition:L,getPosition:()=>t,scan:r?se:V,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>t-o,getTokenError:()=>P}}function S(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function u(i){return i===10||i===13||i===8232||i===8233}function a(i){return i>=48&&i<=57}var y;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(y||(y={}));function v(i,r){const t=[],n=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function P(I,L,z,U){o.value=I,o.offset=L,o.length=z,o.type=U,o.colonOffset=void 0,s=o}try{$(i,{onObjectBegin:(I,L)=>{if(r<=I)throw n;s=void 0,l=r>I,t.push("")},onObjectProperty:(I,L,z)=>{if(r<L||(P(I,L,z,"property"),t[t.length-1]=I,r<=L+z))throw n},onObjectEnd:(I,L)=>{if(r<=I)throw n;s=void 0,t.pop()},onArrayBegin:(I,L)=>{if(r<=I)throw n;s=void 0,t.push(0)},onArrayEnd:(I,L)=>{if(r<=I)throw n;s=void 0,t.pop()},onLiteralValue:(I,L,z)=>{if(r<L||(P(I,L,z,g(I)),r<=L+z))throw n},onSeparator:(I,L,z)=>{if(r<=L)throw n;if(I===":"&&s&&s.type==="property")s.colonOffset=L,l=!1,s=void 0;else if(I===","){const U=t[t.length-1];typeof U=="number"?t[t.length-1]=U+1:(l=!0,t[t.length-1]=""),s=void 0}}})}catch(I){if(I!==n)throw I}return{path:t,previousNode:s,isAtPropertyKey:l,matches:I=>{let L=0;for(let z=0;L<I.length&&z<t.length;z++)if(I[L]===t[z]||I[L]==="*")L++;else if(I[L]!=="**")return!1;return L===I.length}}}function d(i,r=[],t=A.DEFAULT){let n=null,s=[];const o=[];function l(I){Array.isArray(s)?s.push(I):n!==null&&(s[n]=I)}return $(i,{onObjectBegin:()=>{const I={};l(I),o.push(s),s=I,n=null},onObjectProperty:I=>{n=I},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const I=[];l(I),o.push(s),s=I,n=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:l,onError:(I,L,z)=>{r.push({error:I,offset:L,length:z})}},t),s[0]}function p(i,r=[],t=A.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(I){n.type==="property"&&(n.length=I-n.offset,n=n.parent)}function o(I){return n.children.push(I),I}$(i,{onObjectBegin:I=>{n=o({type:"object",offset:I,length:-1,parent:n,children:[]})},onObjectProperty:(I,L,z)=>{n=o({type:"property",offset:L,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:I,offset:L,length:z,parent:n})},onObjectEnd:(I,L)=>{n.length=I+L-n.offset,n=n.parent,s(I+L)},onArrayBegin:(I,L)=>{n=o({type:"array",offset:I,length:-1,parent:n,children:[]})},onArrayEnd:(I,L)=>{n.length=I+L-n.offset,n=n.parent,s(I+L)},onLiteralValue:(I,L,z)=>{o({type:g(I),offset:L,length:z,parent:n,value:I}),s(L+z)},onSeparator:(I,L,z)=>{n.type==="property"&&(I===":"?n.colonOffset=L:I===","&&s(L))},onError:(I,L,z)=>{r.push({error:I,offset:L,length:z})}},t);const P=n.children[0];return P&&delete P.parent,P}function w(i,r){if(!i)return;let t=i;for(const n of r)if(typeof n=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const o of t.children)if(Array.isArray(o.children)&&o.children[0].value===n){t=o.children[1],s=!0;break}if(!s)return}else{const s=n;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}function O(i){if(!i.parent||!i.parent.children)return[];const r=O(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;r.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&r.push(t)}return r}function m(i){switch(i.type){case"array":return i.children.map(m);case"object":{const r=Object.create(null);for(const t of i.children){const n=t.children[1];n&&(r[t.children[0].value]=m(n))}return r}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function c(i,r,t=!1){return r>=i.offset&&r<i.offset+i.length||t&&r===i.offset+i.length}function b(i,r,t=!1){if(c(i,r,t)){const n=i.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=r;s++){const o=b(n[s],r,t);if(o)return o}return i}}function $(i,r,t=A.DEFAULT){const n=R(i,!1);function s(Q){return Q?()=>Q(n.getTokenOffset(),n.getTokenLength()):()=>!0}function o(Q){return Q?_=>Q(_,n.getTokenOffset(),n.getTokenLength()):()=>!0}const l=s(r.onObjectBegin),P=o(r.onObjectProperty),I=s(r.onObjectEnd),L=s(r.onArrayBegin),z=s(r.onArrayEnd),U=o(r.onLiteralValue),V=o(r.onSeparator),X=s(r.onComment),se=o(r.onError),ie=t&&t.disallowComments,ue=t&&t.allowTrailingComma;function he(){for(;;){const Q=n.scan();switch(n.getTokenError()){case 4:ce(14);break;case 5:ce(15);break;case 3:ce(13);break;case 1:ie||ce(11);break;case 2:ce(12);break;case 6:ce(16);break}switch(Q){case 12:case 13:ie?ce(10):X();break;case 16:ce(1);break;case 15:case 14:break;default:return Q}}}function ce(Q,_=[],M=[]){if(se(Q),_.length+M.length>0){let F=n.getToken();for(;F!==17;){if(_.indexOf(F)!==-1){he();break}else if(M.indexOf(F)!==-1)break;F=he()}}}function B(Q){const _=n.getTokenValue();return Q?U(_):P(_),he(),!0}function Z(){switch(n.getToken()){case 11:{let Q=0;try{Q=JSON.parse(n.getTokenValue()),typeof Q!="number"&&(ce(2),Q=0)}catch{ce(2)}U(Q);break}case 7:U(null);break;case 8:U(!0);break;case 9:U(!1);break;default:return!1}return he(),!0}function q(){return n.getToken()!==10?(ce(3,[],[2,5]),!1):(B(!1),n.getToken()===6?(V(":"),he(),Y()||ce(4,[],[2,5])):ce(5,[],[2,5]),!0)}function T(){l(),he();let Q=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(Q||ce(4,[],[]),V(","),he(),n.getToken()===2&&ue)break}else Q&&ce(6,[],[]);q()||ce(4,[],[2,5]),Q=!0}return I(),n.getToken()!==2?ce(7,[2],[]):he(),!0}function x(){L(),he();let Q=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(Q||ce(4,[],[]),V(","),he(),n.getToken()===4&&ue)break}else Q&&ce(6,[],[]);Y()||ce(4,[],[4,5]),Q=!0}return z(),n.getToken()!==4?ce(8,[4],[]):he(),!0}function Y(){switch(n.getToken()){case 3:return x();case 1:return T();case 10:return B(!0);default:return Z()}}return he(),n.getToken()===17?t.allowEmptyContent?!0:(ce(4,[],[]),!1):Y()?(n.getToken()!==17&&ce(9,[],[]),!0):(ce(4,[],[]),!1)}function h(i,r){const t=R(i),n=[];let s,o=0,l;do switch(l=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:o!==l&&n.push(i.substring(o,l)),r!==void 0&&n.push(t.getTokenValue().replace(/[^\r\n]/g,r)),o=t.getPosition();break}while(s!==17);return n.join("")}function g(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(ne[73],re([0,1,38]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=j,e.$Gn=k,e.$Hn=S,e.$In=u;function j(a,y,v){let d,p,w,O,m;if(y){for(O=y.offset,m=O+y.length,w=O;w>0&&!u(a,w-1);)w--;let l=m;for(;l<a.length&&!u(a,l);)l++;p=a.substring(w,l),d=R(p,v)}else p=a,d=0,w=0,O=0,m=a.length;const c=S(v,a);let b=!1,$=0,h;v.insertSpaces?h=A(" ",v.tabSize||4):h="	";const g=(0,D.$tn)(p,!1);let i=!1;function r(){return c+A(h,d+$)}function t(){let l=g.scan();for(b=!1;l===15||l===14;)b=b||l===14,l=g.scan();return i=l===16||g.getTokenError()!==0,l}const n=[];function s(l,P,I){!i&&P<m&&I>O&&a.substring(P,I)!==l&&n.push({offset:P,length:I-P,content:l})}let o=t();if(o!==17){const l=g.getTokenOffset()+w,P=A(h,d);s(P,w,l)}for(;o!==17;){let l=g.getTokenOffset()+g.getTokenLength()+w,P=t(),I="";for(;!b&&(P===12||P===13);){const z=g.getTokenOffset()+w;s(" ",l,z),l=g.getTokenOffset()+g.getTokenLength()+w,I=P===12?r():"",P=t()}if(P===2)o!==1&&($--,I=r());else if(P===4)o!==3&&($--,I=r());else{switch(o){case 3:case 1:$++,I=r();break;case 5:case 12:I=r();break;case 13:b?I=r():I=" ";break;case 6:I=" ";break;case 10:if(P===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:P===12||P===13?I=" ":P!==5&&P!==17&&(i=!0);break;case 16:i=!0;break}b&&(P===12||P===13)&&(I=r())}const L=g.getTokenOffset()+w;s(I,l,L),o=P}return n}function k(a,y){const v=JSON.stringify(a,void 0,y.insertSpaces?y.tabSize||4:"	");return y.eol!==void 0?v.replace(/\r\n|\r|\n/g,y.eol):v}function A(a,y){let v="";for(let d=0;d<y;d++)v+=a;return v}function R(a,y){let v=0,d=0;const p=y.tabSize||4;for(;v<a.length;){const w=a.charAt(v);if(w===" ")d++;else if(w==="	")d+=p;else break;v++}return Math.floor(d/p)}function S(a,y){for(let v=0;v<y.length;v++){const d=y.charAt(v);if(d==="\r")return v+1<y.length&&y.charAt(v+1)===`
`?`\r
`:"\r";if(d===`
`)return`
`}return a&&a.eol||`
`}function u(a,y){return`\r
`.indexOf(a.charAt(y))!==-1}}),define(ne[74],re([0,1,38,73]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=k,e.$Kn=A,e.$Ln=R,e.$Mn=S,e.$Nn=u;function k(a,y,v){return A(a,y,void 0,v)}function A(a,y,v,d,p){const w=y.slice(),O=[],m=(0,D.$wn)(a,O);let c,b;for(;w.length>0&&(b=w.pop(),c=(0,D.$xn)(m,w),c===void 0&&v!==void 0);)typeof b=="string"?v={[b]:v}:v=[v];if(c)if(c.type==="object"&&typeof b=="string"&&Array.isArray(c.children)){const $=(0,D.$xn)(c,[b]);if($!==void 0)if(v===void 0){if(!$.parent)throw new Error("Malformed AST");const h=c.children.indexOf($.parent);let g,i=$.parent.offset+$.parent.length;if(h>0){const r=c.children[h-1];g=r.offset+r.length}else g=c.offset+1,c.children.length>1&&(i=c.children[1].offset);return R(a,{offset:g,length:i-g,content:""},d)}else return R(a,{offset:$.offset,length:$.length,content:JSON.stringify(v)},d);else{if(v===void 0)return[];const h=`${JSON.stringify(b)}: ${JSON.stringify(v)}`,g=p?p(c.children.map(r=>r.children[0].value)):c.children.length;let i;if(g>0){const r=c.children[g-1];i={offset:r.offset+r.length,length:0,content:","+h}}else c.children.length===0?i={offset:c.offset+1,length:0,content:h}:i={offset:c.offset+1,length:0,content:h+","};return R(a,i,d)}}else if(c.type==="array"&&typeof b=="number"&&Array.isArray(c.children))if(v!==void 0){const $=`${JSON.stringify(v)}`;let h;if(c.children.length===0||b===0)h={offset:c.offset+1,length:0,content:c.children.length===0?$:$+","};else{const g=b===-1||b>c.children.length?c.children.length:b,i=c.children[g-1];h={offset:i.offset+i.length,length:0,content:","+$}}return R(a,h,d)}else{const $=b,h=c.children[$];let g;if(c.children.length===1)g={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===$){const i=c.children[$-1],r=i.offset+i.length,t=c.offset+c.length;g={offset:r,length:t-2-r,content:""}}else g={offset:h.offset,length:c.children[$+1].offset-h.offset,content:""};return R(a,g,d)}else throw new Error(`Can not add ${typeof b!="number"?"index":"property"} to parent of type ${c.type}`);else{if(v===void 0)throw new Error("Can not delete in empty document");return R(a,{offset:m?m.offset:0,length:m?m.length:0,content:JSON.stringify(v)},d)}}function R(a,y,v){let d=S(a,y),p=y.offset,w=y.offset+y.content.length;if(y.length===0||y.content.length===0){for(;p>0&&!(0,j.$In)(d,p-1);)p--;for(;w<d.length&&!(0,j.$In)(d,w);)w++}const O=(0,j.$Fn)(d,{offset:p,length:w-p},v);for(let c=O.length-1;c>=0;c--){const b=O[c];d=S(d,b),p=Math.min(p,b.offset),w=Math.max(w,b.offset+b.length),w+=b.content.length-b.length}const m=a.length-(d.length-w)-p;return[{offset:p,length:m,content:d.substring(p,w)}]}function S(a,y){return a.substring(0,y.offset)+y.content+a.substring(y.offset+y.length)}function u(a,y){const v=y.slice(0).sort((p,w)=>{const O=p.offset-w.offset;return O===0?p.length-w.length:O});let d=a.length;for(let p=v.length-1;p>=0;p--){const w=v[p];if(w.offset+w.length<=d)a=S(a,w);else throw new Error("Overlapping edit");d=w.offset}return a}}),define(ne[75],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=e.$qm=e.$pm=void 0,e.$nm=D,e.rot=j;function D(S,u,a){return Math.min(Math.max(S,u),a)}function j(S,u){return(u+S%u)%u}class k{constructor(){this.a=0}getNext(){return this.a++}}e.$pm=k;class A{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$qm=A;class R{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const a=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$rm=R}),function(){function J(k){const A=[];typeof k=="number"&&A.push("code/timeOrigin",k);function R(u){A.push(u,Date.now())}function S(){const u=[];for(let a=0;a<A.length;a+=2)u.push({name:A[a],startTime:A[a+1]});return u}return{mark:R,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const R of performance.getEntriesByType("mark"))A.push({name:R.name,startTime:Math.round(k+R.startTime)});return A}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function D(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var j;typeof global=="object"?j=global:typeof self=="object"?j=self:j={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(j)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(j):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),j.perf=D(j))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var j in D)(typeof exports=="object"?exports:J)[j]=D[j]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function D(j){if(e[j])return e[j].exports;var k=e[j]={i:j,l:!1,exports:{}};return J[j].call(k.exports,k,k.exports,D),k.l=!0,k.exports}return D.m=J,D.c=e,D.d=function(j,k,A){D.o(j,k)||Object.defineProperty(j,k,{enumerable:!0,get:A})},D.r=function(j){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(j,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(j,"__esModule",{value:!0})},D.t=function(j,k){if(1&k&&(j=D(j)),8&k||4&k&&typeof j=="object"&&j&&j.__esModule)return j;var A=Object.create(null);if(D.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:j}),2&k&&typeof j!="string")for(var R in j)D.d(A,R,function(S){return j[S]}.bind(null,R));return A},D.n=function(j){var k=j&&j.__esModule?function(){return j.default}:function(){return j};return D.d(k,"a",k),k},D.o=function(j,k){return Object.prototype.hasOwnProperty.call(j,k)},D.p="",D(D.s=0)}([function(J,e,D){(function(j){var k;e=J.exports=M,k=typeof j=="object"&&j.env&&j.env.NODE_DEBUG&&/\bsemver\b/i.test(j.env.NODE_DEBUG)?function(){var H=Array.prototype.slice.call(arguments,0);H.unshift("SEMVER"),console.log.apply(console,H)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],u=e.src=[],a=0,y=a++;u[y]="0|[1-9]\\d*";var v=a++;u[v]="[0-9]+";var d=a++;u[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=a++;u[p]="("+u[y]+")\\.("+u[y]+")\\.("+u[y]+")";var w=a++;u[w]="("+u[v]+")\\.("+u[v]+")\\.("+u[v]+")";var O=a++;u[O]="(?:"+u[y]+"|"+u[d]+")";var m=a++;u[m]="(?:"+u[v]+"|"+u[d]+")";var c=a++;u[c]="(?:-("+u[O]+"(?:\\."+u[O]+")*))";var b=a++;u[b]="(?:-?("+u[m]+"(?:\\."+u[m]+")*))";var $=a++;u[$]="[0-9A-Za-z-]+";var h=a++;u[h]="(?:\\+("+u[$]+"(?:\\."+u[$]+")*))";var g=a++,i="v?"+u[p]+u[c]+"?"+u[h]+"?";u[g]="^"+i+"$";var r="[v=\\s]*"+u[w]+u[b]+"?"+u[h]+"?",t=a++;u[t]="^"+r+"$";var n=a++;u[n]="((?:<|>)?=?)";var s=a++;u[s]=u[v]+"|x|X|\\*";var o=a++;u[o]=u[y]+"|x|X|\\*";var l=a++;u[l]="[v=\\s]*("+u[o]+")(?:\\.("+u[o]+")(?:\\.("+u[o]+")(?:"+u[c]+")?"+u[h]+"?)?)?";var P=a++;u[P]="[v=\\s]*("+u[s]+")(?:\\.("+u[s]+")(?:\\.("+u[s]+")(?:"+u[b]+")?"+u[h]+"?)?)?";var I=a++;u[I]="^"+u[n]+"\\s*"+u[l]+"$";var L=a++;u[L]="^"+u[n]+"\\s*"+u[P]+"$";var z=a++;u[z]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var U=a++;u[U]="(?:~>?)";var V=a++;u[V]="(\\s*)"+u[U]+"\\s+",S[V]=new RegExp(u[V],"g");var X=a++;u[X]="^"+u[U]+u[l]+"$";var se=a++;u[se]="^"+u[U]+u[P]+"$";var ie=a++;u[ie]="(?:\\^)";var ue=a++;u[ue]="(\\s*)"+u[ie]+"\\s+",S[ue]=new RegExp(u[ue],"g");var he=a++;u[he]="^"+u[ie]+u[l]+"$";var ce=a++;u[ce]="^"+u[ie]+u[P]+"$";var B=a++;u[B]="^"+u[n]+"\\s*("+r+")$|^$";var Z=a++;u[Z]="^"+u[n]+"\\s*("+i+")$|^$";var q=a++;u[q]="(\\s*)"+u[n]+"\\s*("+r+"|"+u[l]+")",S[q]=new RegExp(u[q],"g");var T=a++;u[T]="^\\s*("+u[l]+")\\s+-\\s+("+u[l]+")\\s*$";var x=a++;u[x]="^\\s*("+u[P]+")\\s+-\\s+("+u[P]+")\\s*$";var Y=a++;u[Y]="(<|>)?=?\\s*\\*";for(var Q=0;Q<35;Q++)k(Q,u[Q]),S[Q]||(S[Q]=new RegExp(u[Q]));function _(H,K){if(H instanceof M)return H;if(typeof H!="string"||H.length>A||!(K?S[t]:S[g]).test(H))return null;try{return new M(H,K)}catch{return null}}function M(H,K){if(H instanceof M){if(H.loose===K)return H;H=H.version}else if(typeof H!="string")throw new TypeError("Invalid Version: "+H);if(H.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof M))return new M(H,K);k("SemVer",H,K),this.loose=K;var ee=H.trim().match(K?S[t]:S[g]);if(!ee)throw new TypeError("Invalid Version: "+H);if(this.raw=H,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var ve=+ge;if(ve>=0&&ve<R)return ve}return ge}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=_,e.valid=function(H,K){var ee=_(H,K);return ee?ee.version:null},e.clean=function(H,K){var ee=_(H.trim().replace(/^[=v]+/,""),K);return ee?ee.version:null},e.SemVer=M,M.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},M.prototype.toString=function(){return this.version},M.prototype.compare=function(H){return k("SemVer.compare",this.version,this.loose,H),H instanceof M||(H=new M(H,this.loose)),this.compareMain(H)||this.comparePre(H)},M.prototype.compareMain=function(H){return H instanceof M||(H=new M(H,this.loose)),f(this.major,H.major)||f(this.minor,H.minor)||f(this.patch,H.patch)},M.prototype.comparePre=function(H){if(H instanceof M||(H=new M(H,this.loose)),this.prerelease.length&&!H.prerelease.length)return-1;if(!this.prerelease.length&&H.prerelease.length)return 1;if(!this.prerelease.length&&!H.prerelease.length)return 0;var K=0;do{var ee=this.prerelease[K],ge=H.prerelease[K];if(k("prerelease compare",K,ee,ge),ee===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(ee===void 0)return-1;if(ee!==ge)return f(ee,ge)}while(++K)},M.prototype.inc=function(H,K){switch(H){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+H)}return this.format(),this.raw=this.version,this},e.inc=function(H,K,ee,ge){typeof ee=="string"&&(ge=ee,ee=void 0);try{return new M(H,ee).inc(K,ge).version}catch{return null}},e.diff=function(H,K){if(W(H,K))return null;var ee=_(H),ge=_(K);if(ee.prerelease.length||ge.prerelease.length){for(var ve in ee)if((ve==="major"||ve==="minor"||ve==="patch")&&ee[ve]!==ge[ve])return"pre"+ve;return"prerelease"}for(var ve in ee)if((ve==="major"||ve==="minor"||ve==="patch")&&ee[ve]!==ge[ve])return ve},e.compareIdentifiers=f;var F=/^[0-9]+$/;function f(H,K){var ee=F.test(H),ge=F.test(K);return ee&&ge&&(H=+H,K=+K),ee&&!ge?-1:ge&&!ee?1:H<K?-1:H>K?1:0}function E(H,K,ee){return new M(H,ee).compare(new M(K,ee))}function N(H,K,ee){return E(H,K,ee)>0}function C(H,K,ee){return E(H,K,ee)<0}function W(H,K,ee){return E(H,K,ee)===0}function G(H,K,ee){return E(H,K,ee)!==0}function te(H,K,ee){return E(H,K,ee)>=0}function ae(H,K,ee){return E(H,K,ee)<=0}function le(H,K,ee,ge){var ve;switch(K){case"===":typeof H=="object"&&(H=H.version),typeof ee=="object"&&(ee=ee.version),ve=H===ee;break;case"!==":typeof H=="object"&&(H=H.version),typeof ee=="object"&&(ee=ee.version),ve=H!==ee;break;case"":case"=":case"==":ve=W(H,ee,ge);break;case"!=":ve=G(H,ee,ge);break;case">":ve=N(H,ee,ge);break;case">=":ve=te(H,ee,ge);break;case"<":ve=C(H,ee,ge);break;case"<=":ve=ae(H,ee,ge);break;default:throw new TypeError("Invalid operator: "+K)}return ve}function pe(H,K){if(H instanceof pe){if(H.loose===K)return H;H=H.value}if(!(this instanceof pe))return new pe(H,K);k("comparator",H,K),this.loose=K,this.parse(H),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(H,K){return f(K,H)},e.major=function(H,K){return new M(H,K).major},e.minor=function(H,K){return new M(H,K).minor},e.patch=function(H,K){return new M(H,K).patch},e.compare=E,e.compareLoose=function(H,K){return E(H,K,!0)},e.rcompare=function(H,K,ee){return E(K,H,ee)},e.sort=function(H,K){return H.sort(function(ee,ge){return e.compare(ee,ge,K)})},e.rsort=function(H,K){return H.sort(function(ee,ge){return e.rcompare(ee,ge,K)})},e.gt=N,e.lt=C,e.eq=W,e.neq=G,e.gte=te,e.lte=ae,e.cmp=le,e.Comparator=pe;var ye={};function fe(H,K){if(H instanceof fe)return H.loose===K?H:new fe(H.raw,K);if(H instanceof pe)return new fe(H.value,K);if(!(this instanceof fe))return new fe(H,K);if(this.loose=K,this.raw=H,this.set=H.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+H);this.format()}function me(H){return!H||H.toLowerCase()==="x"||H==="*"}function de(H,K,ee,ge,ve,De,Pe,Le,Oe,Ae,Me,je,Ne){return((K=me(ee)?"":me(ge)?">="+ee+".0.0":me(ve)?">="+ee+"."+ge+".0":">="+K)+" "+(Le=me(Oe)?"":me(Ae)?"<"+(+Oe+1)+".0.0":me(Me)?"<"+Oe+"."+(+Ae+1)+".0":je?"<="+Oe+"."+Ae+"."+Me+"-"+je:"<="+Le)).trim()}function we(H,K){for(var ee=0;ee<H.length;ee++)if(!H[ee].test(K))return!1;if(K.prerelease.length){for(ee=0;ee<H.length;ee++)if(k(H[ee].semver),H[ee].semver!==ye&&H[ee].semver.prerelease.length>0){var ge=H[ee].semver;if(ge.major===K.major&&ge.minor===K.minor&&ge.patch===K.patch)return!0}return!1}return!0}function Ee(H,K,ee){try{K=new fe(K,ee)}catch{return!1}return K.test(H)}function ke(H,K,ee,ge){var ve,De,Pe,Le,Oe;switch(H=new M(H,ge),K=new fe(K,ge),ee){case">":ve=N,De=ae,Pe=C,Le=">",Oe=">=";break;case"<":ve=C,De=te,Pe=N,Le="<",Oe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ee(H,K,ge))return!1;for(var Ae=0;Ae<K.set.length;++Ae){var Me=K.set[Ae],je=null,Ne=null;if(Me.forEach(function(ze){ze.semver===ye&&(ze=new pe(">=0.0.0")),je=je||ze,Ne=Ne||ze,ve(ze.semver,je.semver,ge)?je=ze:Pe(ze.semver,Ne.semver,ge)&&(Ne=ze)}),je.operator===Le||je.operator===Oe||(!Ne.operator||Ne.operator===Le)&&De(H,Ne.semver)||Ne.operator===Oe&&Pe(H,Ne.semver))return!1}return!0}pe.prototype.parse=function(H){var K=this.loose?S[B]:S[Z],ee=H.match(K);if(!ee)throw new TypeError("Invalid comparator: "+H);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new M(ee[2],this.loose):this.semver=ye},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(H){return k("Comparator.test",H,this.loose),this.semver===ye||(typeof H=="string"&&(H=new M(H,this.loose)),le(H,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(H,K){if(!(H instanceof pe))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new fe(H.value,K),Ee(this.value,ee,K);if(H.operator==="")return ee=new fe(this.value,K),Ee(H.semver,ee,K);var ge=!(this.operator!==">="&&this.operator!==">"||H.operator!==">="&&H.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||H.operator!=="<="&&H.operator!=="<"),De=this.semver.version===H.semver.version,Pe=!(this.operator!==">="&&this.operator!=="<="||H.operator!==">="&&H.operator!=="<="),Le=le(this.semver,"<",H.semver,K)&&(this.operator===">="||this.operator===">")&&(H.operator==="<="||H.operator==="<"),Oe=le(this.semver,">",H.semver,K)&&(this.operator==="<="||this.operator==="<")&&(H.operator===">="||H.operator===">");return ge||ve||De&&Pe||Le||Oe},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(H){return H.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(H){var K=this.loose;H=H.trim(),k("range",H,K);var ee=K?S[x]:S[T];H=H.replace(ee,de),k("hyphen replace",H),H=H.replace(S[q],"$1$2$3"),k("comparator trim",H,S[q]),H=(H=(H=H.replace(S[V],"$1~")).replace(S[ue],"$1^")).split(/\s+/).join(" ");var ge=K?S[B]:S[Z],ve=H.split(" ").map(function(De){return function(Pe,Le){return k("comp",Pe),Pe=function(Oe,Ae){return Oe.trim().split(/\s+/).map(function(Me){return function(je,Ne){k("caret",je,Ne);var ze=Ne?S[ce]:S[he];return je.replace(ze,function(Fe,be,Se,Ie,Re){var Ue;return k("caret",je,Fe,be,Se,Ie,Re),me(be)?Ue="":me(Se)?Ue=">="+be+".0.0 <"+(+be+1)+".0.0":me(Ie)?Ue=be==="0"?">="+be+"."+Se+".0 <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+".0 <"+(+be+1)+".0.0":Re?(k("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Ue=be==="0"?Se==="0"?">="+be+"."+Se+"."+Ie+Re+" <"+be+"."+Se+"."+(+Ie+1):">="+be+"."+Se+"."+Ie+Re+" <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+"."+Ie+Re+" <"+(+be+1)+".0.0"):(k("no pr"),Ue=be==="0"?Se==="0"?">="+be+"."+Se+"."+Ie+" <"+be+"."+Se+"."+(+Ie+1):">="+be+"."+Se+"."+Ie+" <"+be+"."+(+Se+1)+".0":">="+be+"."+Se+"."+Ie+" <"+(+be+1)+".0.0"),k("caret return",Ue),Ue})}(Me,Ae)}).join(" ")}(Pe,Le),k("caret",Pe),Pe=function(Oe,Ae){return Oe.trim().split(/\s+/).map(function(Me){return function(je,Ne){var ze=Ne?S[se]:S[X];return je.replace(ze,function(Fe,be,Se,Ie,Re){var Ue;return k("tilde",je,Fe,be,Se,Ie,Re),me(be)?Ue="":me(Se)?Ue=">="+be+".0.0 <"+(+be+1)+".0.0":me(Ie)?Ue=">="+be+"."+Se+".0 <"+be+"."+(+Se+1)+".0":Re?(k("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Ue=">="+be+"."+Se+"."+Ie+Re+" <"+be+"."+(+Se+1)+".0"):Ue=">="+be+"."+Se+"."+Ie+" <"+be+"."+(+Se+1)+".0",k("tilde return",Ue),Ue})}(Me,Ae)}).join(" ")}(Pe,Le),k("tildes",Pe),Pe=function(Oe,Ae){return k("replaceXRanges",Oe,Ae),Oe.split(/\s+/).map(function(Me){return function(je,Ne){je=je.trim();var ze=Ne?S[L]:S[I];return je.replace(ze,function(Fe,be,Se,Ie,Re,Ue){k("xRange",je,Fe,be,Se,Ie,Re,Ue);var qe=me(Se),Ce=qe||me(Ie),Te=Ce||me(Re);return be==="="&&Te&&(be=""),qe?Fe=be===">"||be==="<"?"<0.0.0":"*":be&&Te?(Ce&&(Ie=0),Te&&(Re=0),be===">"?(be=">=",Ce?(Se=+Se+1,Ie=0,Re=0):Te&&(Ie=+Ie+1,Re=0)):be==="<="&&(be="<",Ce?Se=+Se+1:Ie=+Ie+1),Fe=be+Se+"."+Ie+"."+Re):Ce?Fe=">="+Se+".0.0 <"+(+Se+1)+".0.0":Te&&(Fe=">="+Se+"."+Ie+".0 <"+Se+"."+(+Ie+1)+".0"),k("xRange return",Fe),Fe})}(Me,Ae)}).join(" ")}(Pe,Le),k("xrange",Pe),Pe=function(Oe,Ae){return k("replaceStars",Oe,Ae),Oe.trim().replace(S[Y],"")}(Pe,Le),k("stars",Pe),Pe}(De,K)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(De){return!!De.match(ge)})),ve=ve.map(function(De){return new pe(De,K)})},fe.prototype.intersects=function(H,K){if(!(H instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function(ge){return H.set.some(function(ve){return ve.every(function(De){return ge.intersects(De,K)})})})})},e.toComparators=function(H,K){return new fe(H,K).set.map(function(ee){return ee.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(H){if(!H)return!1;typeof H=="string"&&(H=new M(H,this.loose));for(var K=0;K<this.set.length;K++)if(we(this.set[K],H))return!0;return!1},e.satisfies=Ee,e.maxSatisfying=function(H,K,ee){var ge=null,ve=null;try{var De=new fe(K,ee)}catch{return null}return H.forEach(function(Pe){De.test(Pe)&&(ge&&ve.compare(Pe)!==-1||(ve=new M(ge=Pe,ee)))}),ge},e.minSatisfying=function(H,K,ee){var ge=null,ve=null;try{var De=new fe(K,ee)}catch{return null}return H.forEach(function(Pe){De.test(Pe)&&(ge&&ve.compare(Pe)!==1||(ve=new M(ge=Pe,ee)))}),ge},e.validRange=function(H,K){try{return new fe(H,K).range||"*"}catch{return null}},e.ltr=function(H,K,ee){return ke(H,K,"<",ee)},e.gtr=function(H,K,ee){return ke(H,K,">",ee)},e.outside=ke,e.prerelease=function(H,K){var ee=_(H,K);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(H,K,ee){return H=new fe(H,ee),K=new fe(K,ee),H.intersects(K)},e.coerce=function(H){if(H instanceof M)return H;if(typeof H!="string")return null;var K=H.match(S[z]);return K==null?null:_((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,D(1))},function(J,e){var D,j,k=J.exports={};function A(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function S(m){if(D===setTimeout)return setTimeout(m,0);if((D===A||!D)&&setTimeout)return D=setTimeout,setTimeout(m,0);try{return D(m,0)}catch{try{return D.call(null,m,0)}catch{return D.call(this,m,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:A}catch{D=A}try{j=typeof clearTimeout=="function"?clearTimeout:R}catch{j=R}})();var u,a=[],y=!1,v=-1;function d(){y&&u&&(y=!1,u.length?a=u.concat(a):v=-1,a.length&&p())}function p(){if(!y){var m=S(d);y=!0;for(var c=a.length;c;){for(u=a,a=[];++v<c;)u&&u[v].run();v=-1,c=a.length}u=null,y=!1,function(b){if(j===clearTimeout)return clearTimeout(b);if((j===R||!j)&&clearTimeout)return j=clearTimeout,clearTimeout(b);try{j(b)}catch{try{return j.call(null,b)}catch{return j.call(this,b)}}}(m)}}function w(m,c){this.fun=m,this.array=c}function O(){}k.nextTick=function(m){var c=new Array(arguments.length-1);if(arguments.length>1)for(var b=1;b<arguments.length;b++)c[b-1]=arguments[b];a.push(new w(m,c)),a.length!==1||y||S(p)},w.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=O,k.addListener=O,k.once=O,k.off=O,k.removeListener=O,k.removeAllListeners=O,k.emit=O,k.prependListener=O,k.prependOnceListener=O,k.listeners=function(m){return[]},k.binding=function(m){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(m){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(ne[76],re([0,1]),function(J,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$is=void 0;class j{constructor(S,u,a){this.level=S,this.key=u,this.value=a,this.forward=[]}}const k=void 0;class A{constructor(S,u=2**16){this.comparator=S,this[D]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new j(this.c,k,k)}get size(){return this.f}clear(){this.e=new j(this.c,k,k),this.f=0}has(S){return!!A.g(this,S,this.comparator)}get(S){return A.g(this,S,this.comparator)?.value}set(S,u){return A.h(this,S,u,this.comparator)&&(this.f+=1),this}delete(S){const u=A.k(this,S,this.comparator);return u&&(this.f-=1),u}forEach(S,u){let a=this.e.forward[0];for(;a;)S.call(u,a.value,a.key,this),a=a.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this.e.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this.e.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this.e.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",u=this.e.forward[0];for(;u;)S+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return S}static g(S,u,a){let y=S.e;for(let v=S.d-1;v>=0;v--)for(;y.forward[v]&&a(y.forward[v].key,u)<0;)y=y.forward[v];if(y=y.forward[0],y&&a(y.key,u)===0)return y}static h(S,u,a,y){const v=[];let d=S.e;for(let p=S.d-1;p>=0;p--){for(;d.forward[p]&&y(d.forward[p].key,u)<0;)d=d.forward[p];v[p]=d}if(d=d.forward[0],d&&y(d.key,u)===0)return d.value=a,!1;{const p=A.j(S);if(p>S.d){for(let w=S.d;w<p;w++)v[w]=S.e;S.d=p}d=new j(p,u,a);for(let w=0;w<p;w++)d.forward[w]=v[w].forward[w],v[w].forward[w]=d;return!0}}static j(S,u=.5){let a=1;for(;Math.random()<u&&a<S.c;)a+=1;return a}static k(S,u,a){const y=[];let v=S.e;for(let d=S.d-1;d>=0;d--){for(;v.forward[d]&&a(v.forward[d].key,u)<0;)v=v.forward[d];y[d]=v}if(v=v.forward[0],!v||a(v.key,u)!==0)return!1;for(let d=0;d<S.d&&y[d].forward[d]===v;d++)y[d].forward[d]=v.forward[d];for(;S.d>0&&S.e.forward[S.d-1]===k;)S.d-=1;return!0}}e.$is=A}),define(ne[46],re([0,1,8,2]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=k,e.$ge=A,e.$he=R,e.$ie=S,e.$je=a,e.$ke=y,e.$le=v,e.$me=d,e.$ne=p,e.$oe=w,e.$pe=O,e.$qe=m,e.$re=c,e.$se=b,e.$te=$;function k(h){const g=h;return g?typeof g.read=="function":!1}function A(h){const g=h;return g?[g.on,g.pause,g.resume,g.destroy].every(i=>typeof i=="function"):!1}function R(h){const g=h;return g?A(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}function S(h,g){return new u(h,g)}class u{constructor(g,i){this.e=g,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(g){if(!this.a.destroyed){if(this.a.flowing)this.g(g);else if(this.b.data.push(g),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(g){this.a.destroyed||(this.a.flowing?this.h(g):this.b.error.push(g))}end(g){this.a.destroyed||(typeof g<"u"&&this.write(g),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(g){this.c.data.slice(0).forEach(i=>i(g))}h(g){this.c.error.length===0?(0,D.$1)(g):this.c.error.slice(0).forEach(i=>i(g))}i(){this.c.end.slice(0).forEach(g=>g())}on(g,i){if(!this.a.destroyed)switch(g){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(g,i){if(this.a.destroyed)return;let r;switch(g){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const t=r.indexOf(i);t>=0&&r.splice(t,1)}}j(){if(this.b.data.length>0){const g=this.e(this.b.data);this.g(g),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const g of this.b.error)this.h(g);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(h,g){const i=[];let r;for(;(r=h.read())!==null;)i.push(r);return g(i)}function y(h,g,i){const r=[];let t;for(;(t=h.read())!==null&&r.length<i;)r.push(t);return t===null&&r.length>0?g(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const n=t;return t=void 0,n}return h.read()}}}function v(h,g){return new Promise((i,r)=>{const t=[];d(h,{onData:n=>{g&&t.push(n)},onError:n=>{g?r(n):i(void 0)},onEnd:()=>{i(g?g(t):void 0)}})})}function d(h,g,i){h.on("error",r=>{i?.isCancellationRequested||g.onError(r)}),h.on("end",()=>{i?.isCancellationRequested||g.onEnd()}),h.on("data",r=>{i?.isCancellationRequested||g.onData(r)})}function p(h,g){return new Promise((i,r)=>{const t=new j.$Tc,n=[],s=P=>{if(n.push(P),n.length>g)return t.dispose(),h.pause(),i({stream:h,buffer:n,ended:!1})},o=P=>(t.dispose(),r(P)),l=()=>(t.dispose(),i({stream:h,buffer:n,ended:!0}));t.add((0,j.$Sc)(()=>h.removeListener("error",o))),h.on("error",o),t.add((0,j.$Sc)(()=>h.removeListener("end",l))),h.on("end",l),t.add((0,j.$Sc)(()=>h.removeListener("data",s))),h.on("data",s)})}function w(h,g){const i=S(g);return i.end(h),i}function O(){const h=S(()=>{throw new Error("not supported")});return h.end(),h}function m(h){let g=!1;return{read:()=>g?null:(g=!0,h)}}function c(h,g,i){const r=S(i);return d(h,{onData:t=>r.write(g.data(t)),onError:t=>r.error(g.error?g.error(t):t),onEnd:()=>r.end()}),r}function b(h,g,i){let r=!1;return{read:()=>{const t=g.read();return r?t:(r=!0,t!==null?i([h,t]):h)}}}function $(h,g,i){let r=!1;const t=S(i);return d(g,{onData:n=>r?t.write(n):(r=!0,t.write(i([h,n]))),onError:n=>t.error(n),onEnd:()=>{r||(r=!0,t.write(h)),t.end()}}),t}}),define(ne[14],re([0,1,169,46]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=void 0,e.$ve=a,e.$we=y,e.$xe=v,e.$ye=d,e.$ze=p,e.$Ae=w,e.$Be=O,e.$Ce=m,e.$De=c,e.$Ee=b,e.$Fe=$,e.$Ge=h,e.$He=g,e.$Ie=i,e.$Je=r,e.$Ke=t,e.$Le=n,e.$Me=s,e.$Ne=o,e.$Oe=I;const k=typeof Buffer<"u",A=new D.$V(()=>new Uint8Array(256));let R,S;class u{static alloc(z){return k?new u(Buffer.allocUnsafe(z)):new u(new Uint8Array(z))}static wrap(z){return k&&!Buffer.isBuffer(z)&&(z=Buffer.from(z.buffer,z.byteOffset,z.byteLength)),new u(z)}static fromString(z,U){return!(U?.dontUseNodeBuffer||!1)&&k?new u(Buffer.from(z)):(R||(R=new TextEncoder),new u(R.encode(z)))}static fromByteArray(z){const U=u.alloc(z.length);for(let V=0,X=z.length;V<X;V++)U.buffer[V]=z[V];return U}static concat(z,U){if(typeof U>"u"){U=0;for(let se=0,ie=z.length;se<ie;se++)U+=z[se].byteLength}const V=u.alloc(U);let X=0;for(let se=0,ie=z.length;se<ie;se++){const ue=z[se];V.set(ue,X),X+=ue.byteLength}return V}constructor(z){this.buffer=z,this.byteLength=this.buffer.byteLength}clone(){const z=u.alloc(this.byteLength);return z.set(this),z}toString(){return k?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(z,U){return new u(this.buffer.subarray(z,U))}set(z,U){if(z instanceof u)this.buffer.set(z.buffer,U);else if(z instanceof Uint8Array)this.buffer.set(z,U);else if(z instanceof ArrayBuffer)this.buffer.set(new Uint8Array(z),U);else if(ArrayBuffer.isView(z))this.buffer.set(new Uint8Array(z.buffer,z.byteOffset,z.byteLength),U);else throw new Error("Unknown argument 'array'")}readUInt32BE(z){return d(this.buffer,z)}writeUInt32BE(z,U){p(this.buffer,z,U)}readUInt32LE(z){return w(this.buffer,z)}writeUInt32LE(z,U){O(this.buffer,z,U)}readUInt8(z){return m(this.buffer,z)}writeUInt8(z,U){c(this.buffer,z,U)}indexOf(z,U=0){return a(this.buffer,z instanceof u?z.buffer:z,U)}}e.$ue=u;function a(L,z,U=0){const V=z.byteLength,X=L.byteLength;if(V===0)return 0;if(V===1)return L.indexOf(z[0]);if(V>X-U)return-1;const se=A.value;se.fill(z.length);for(let ce=0;ce<z.length;ce++)se[z[ce]]=z.length-ce-1;let ie=U+z.length-1,ue=ie,he=-1;for(;ie<X;)if(L[ie]===z[ue]){if(ue===0){he=ie;break}ie--,ue--}else ie+=Math.max(z.length-ue,se[L[ie]]),ue=z.length-1;return he}function y(L,z){return L[z+0]<<0>>>0|L[z+1]<<8>>>0}function v(L,z,U){L[U+0]=z&255,z=z>>>8,L[U+1]=z&255}function d(L,z){return L[z]*2**24+L[z+1]*2**16+L[z+2]*2**8+L[z+3]}function p(L,z,U){L[U+3]=z,z=z>>>8,L[U+2]=z,z=z>>>8,L[U+1]=z,z=z>>>8,L[U]=z}function w(L,z){return L[z+0]<<0>>>0|L[z+1]<<8>>>0|L[z+2]<<16>>>0|L[z+3]<<24>>>0}function O(L,z,U){L[U+0]=z&255,z=z>>>8,L[U+1]=z&255,z=z>>>8,L[U+2]=z&255,z=z>>>8,L[U+3]=z&255}function m(L,z){return L[z]}function c(L,z,U){L[U]=z}function b(L){return j.$je(L,z=>u.concat(z))}function $(L){return j.$qe(L)}function h(L){return j.$le(L,z=>u.concat(z))}async function g(L){return L.ended?u.concat(L.buffer):u.concat([...L.buffer,await h(L.stream)])}function i(L){return j.$oe(L,z=>u.concat(z))}function r(L){return j.$re(L,{data:z=>typeof z=="string"?u.fromString(z):u.wrap(z)},z=>u.concat(z))}function t(L){return j.$ie(z=>u.concat(z),L)}function n(L,z){return j.$se(L,z,U=>u.concat(U))}function s(L,z){return j.$te(L,z,U=>u.concat(U))}function o(L){let z=0,U=0,V=0;const X=new Uint8Array(Math.floor(L.length/4*3)),se=ue=>{switch(U){case 3:X[V++]=z|ue,U=0;break;case 2:X[V++]=z|ue>>>2,z=ue<<6,U=3;break;case 1:X[V++]=z|ue>>>4,z=ue<<4,U=2;break;default:z=ue<<2,U=1}};for(let ue=0;ue<L.length;ue++){const he=L.charCodeAt(ue);if(he>=65&&he<=90)se(he-65);else if(he>=97&&he<=122)se(he-97+26);else if(he>=48&&he<=57)se(he-48+52);else if(he===43||he===45)se(62);else if(he===47||he===95)se(63);else{if(he===61)break;throw new SyntaxError(`Unexpected base64 character ${L[ue]}`)}}const ie=V;for(;U>0;)se(0);return u.wrap(X).slice(0,ie)}const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:L},z=!0,U=!1){const V=U?P:l;let X="";const se=L.byteLength%3;let ie=0;for(;ie<L.byteLength-se;ie+=3){const ue=L[ie+0],he=L[ie+1],ce=L[ie+2];X+=V[ue>>>2],X+=V[(ue<<4|he>>>4)&63],X+=V[(he<<2|ce>>>6)&63],X+=V[ce&63]}if(se===1){const ue=L[ie+0];X+=V[ue>>>2],X+=V[ue<<4&63],z&&(X+="==")}else if(se===2){const ue=L[ie+0],he=L[ie+1];X+=V[ue>>>2],X+=V[(ue<<4|he>>>4)&63],X+=V[he<<2&63],z&&(X+="=")}return X}}),define(ne[43],re([0,1,30]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.$aj=void 0,e.$9i=j,e.$0i=k,e.$$i=A,e.$_i=S,e.$bj=O;function j(c){return k(c,0)}function k(c,b){switch(typeof c){case"object":return c===null?A(349,b):Array.isArray(c)?u(c,b):a(c,b);case"string":return S(c,b);case"boolean":return R(c,b);case"number":return A(c,b);case"undefined":return A(937,b);default:return A(617,b)}}function A(c,b){return(b<<5)-b+c|0}function R(c,b){return A(c?433:863,b)}function S(c,b){b=A(149417,b);for(let $=0,h=c.length;$<h;$++)b=A(c.charCodeAt($),b);return b}function u(c,b){return b=A(104579,b),c.reduce(($,h)=>k(h,$),b)}function a(c,b){return b=A(181387,b),Object.keys(c).sort().reduce(($,h)=>($=S(h,$),k(c[h],$)),b)}class y{constructor(){this.g=0}get value(){return this.g}hash(b){return this.g=k(b,this.g),this.g}}e.$aj=y;var v;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function d(c,b,$=32){const h=$-b,g=~((1<<h)-1);return(c<<b|(g&c)>>>h)>>>0}function p(c,b=0,$=c.byteLength,h=0){for(let g=0;g<$;g++)c[b+g]=h}function w(c,b,$="0"){for(;c.length<b;)c=$+c;return c}function O(c,b=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map($=>$.toString(16).padStart(2,"0")).join(""):w((c>>>0).toString(16),b/4)}class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(b){const $=b.length;if($===0)return;const h=this.p;let g=this.r,i=this.u,r,t;for(i!==0?(r=i,t=-1,i=0):(r=b.charCodeAt(0),t=0);;){let n=r;if(D.$pf(r))if(t+1<$){const s=b.charCodeAt(t+1);D.$qf(s)?(t++,n=D.$rf(r,s)):n=65533}else{i=r;break}else D.$qf(r)&&(n=65533);if(g=this.w(h,g,n),t++,t<$)r=b.charCodeAt(t);else break}this.r=g,this.u=i}w(b,$,h){return h<128?b[$++]=h:h<2048?(b[$++]=192|(h&1984)>>>6,b[$++]=128|(h&63)>>>0):h<65536?(b[$++]=224|(h&61440)>>>12,b[$++]=128|(h&4032)>>>6,b[$++]=128|(h&63)>>>0):(b[$++]=240|(h&1835008)>>>18,b[$++]=128|(h&258048)>>>12,b[$++]=128|(h&4032)>>>6,b[$++]=128|(h&63)>>>0),$>=64&&(this.y(),$-=64,this.t+=64,b[0]=b[64],b[1]=b[65],b[2]=b[66]),$}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),O(this.h)+O(this.l)+O(this.m)+O(this.n)+O(this.o)}x(){this.p[this.r++]=128,p(this.p,this.r),this.r>56&&(this.y(),p(this.p));const b=8*this.t;this.q.setUint32(56,Math.floor(b/4294967296),!1),this.q.setUint32(60,b%4294967296,!1),this.y()}y(){const b=m.g,$=this.q;for(let l=0;l<64;l+=4)b.setUint32(l,$.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)b.setUint32(l,d(b.getUint32(l-12,!1)^b.getUint32(l-32,!1)^b.getUint32(l-56,!1)^b.getUint32(l-64,!1),1),!1);let h=this.h,g=this.l,i=this.m,r=this.n,t=this.o,n,s,o;for(let l=0;l<80;l++)l<20?(n=g&i|~g&r,s=1518500249):l<40?(n=g^i^r,s=1859775393):l<60?(n=g&i|g&r|i&r,s=2400959708):(n=g^i^r,s=3395469782),o=d(h,5)+n+t+s+b.getUint32(l*4,!1)&4294967295,t=r,r=i,i=d(g,30),g=h,h=o;this.h=this.h+h&4294967295,this.l=this.l+g&4294967295,this.m=this.m+i&4294967295,this.n=this.n+r&4294967295,this.o=this.o+t&4294967295}}e.$cj=m}),define(ne[55],re([0,1,30]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var j;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(j||(j={})),function(k){const A="error",R="warning",S="warn",u="info",a="ignore";function y(d){return d?D.$lf(A,d)?k.Error:D.$lf(R,d)||D.$lf(S,d)?k.Warning:D.$lf(u,d)?k.Info:k.Ignore:k.Ignore}k.fromValue=y;function v(d){switch(d){case k.Error:return A;case k.Warning:return R;case k.Info:return u;default:return a}}k.toString=v}(j||(j={})),e.default=j}),define(ne[27],re([0,1,3]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=j,e.$Pn=k,e.$Qn=R,e.$Rn=u,e.$Sn=a,e.$Tn=y,e.$Un=v,e.$Vn=d,e.$Wn=p,e.$Xn=w,e.$Yn=O,e.$Zn=m;function j(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const b=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([$,h])=>{b[$]=h&&typeof h=="object"?j(h):h}),b}function k(c){if(!c||typeof c!="object")return c;const b=[c];for(;b.length>0;){const $=b.shift();Object.freeze($);for(const h in $)if(A.call($,h)){const g=$[h];typeof g=="object"&&!Object.isFrozen(g)&&!(0,D.$Yf)(g)&&b.push(g)}}return c}const A=Object.prototype.hasOwnProperty;function R(c,b){return S(c,b,new Set)}function S(c,b,$){if((0,D.$5f)(c))return c;const h=b(c);if(typeof h<"u")return h;if(Array.isArray(c)){const g=[];for(const i of c)g.push(S(i,b,$));return g}if((0,D.$Xf)(c)){if($.has(c))throw new Error("Cannot clone recursive data-structure");$.add(c);const g={};for(const i in c)A.call(c,i)&&(g[i]=S(c[i],b,$));return $.delete(c),g}return c}function u(c,b,$=!0){return(0,D.$Xf)(c)?((0,D.$Xf)(b)&&Object.keys(b).forEach(h=>{h in c?$&&((0,D.$Xf)(c[h])&&(0,D.$Xf)(b[h])?u(c[h],b[h],$):c[h]=b[h]):c[h]=b[h]}),c):b}function a(c,b){if(c===b)return!0;if(c==null||b===null||b===void 0||typeof c!=typeof b||typeof c!="object"||Array.isArray(c)!==Array.isArray(b))return!1;let $,h;if(Array.isArray(c)){if(c.length!==b.length)return!1;for($=0;$<c.length;$++)if(!a(c[$],b[$]))return!1}else{const g=[];for(h in c)g.push(h);g.sort();const i=[];for(h in b)i.push(h);if(i.sort(),!a(g,i))return!1;for($=0;$<g.length;$++)if(!a(c[g[$]],b[g[$]]))return!1}return!0}function y(c){const b=new Set;return JSON.stringify(c,($,h)=>{if((0,D.$Xf)(h)||Array.isArray(h)){if(b.has(h))return"[Circular]";b.add(h)}return h})}function v(c,b){const $=Object.create(null);return!c||!b||Object.keys(b).forEach(g=>{const i=c[g],r=b[g];a(i,r)||($[g]=r)}),$}function d(c,b){const $=b.toLowerCase(),h=Object.keys(c).find(g=>g.toLowerCase()===$);return h?c[h]:c[b]}function p(c,b){const $=Object.create(null);for(const[h,g]of Object.entries(c))b(h,g)&&($[h]=g);return $}function w(c){let b=[];for(;Object.prototype!==c;)b=b.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return b}function O(c){const b=[];for(const $ of w(c))typeof c[$]=="function"&&b.push($);return b}function m(c,b){const $=g=>function(){const i=Array.prototype.slice.call(arguments,0);return b(g,i)},h={};for(const g of c)h[g]=$(g);return h}}),define(ne[28],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=void 0,e.$Dg=j;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function j(k){return D.test(k)}e.$Eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(S){for(let u=0;u<S.length;u++)S[u]=Math.floor(Math.random()*256);return S};const A=new Uint8Array(16),R=[];for(let S=0;S<256;S++)R.push(S.toString(16).padStart(2,"0"));return function(){k(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let u=0,a="";return a+=R[A[u++]],a+=R[A[u++]],a+=R[A[u++]],a+=R[A[u++]],a+="-",a+=R[A[u++]],a+=R[A[u++]],a+="-",a+=R[A[u++]],a+=R[A[u++]],a+="-",a+=R[A[u++]],a+=R[A[u++]],a+="-",a+=R[A[u++]],a+=R[A[u++]],a+=R[A[u++]],a+=R[A[u++]],a+=R[A[u++]],a+=R[A[u++]],a}}()}),define(ne[77],re([0,1,33]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=A;const j=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(R){const S=R.replace(/\-/g,":").toLowerCase();return!j.has(S)}function A(){const R=(0,D.networkInterfaces)();for(const S in R){const u=R[S];if(u){for(const{mac:a}of u)if(k(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ne[78],re([7,4]),function(J,e){return J.create("vs/base/common/date",e)}),define(ne[79],re([0,1,78]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=a,e.$Om=y,e.$Pm=v;const j=60,k=j*60,A=k*24,R=A*7,S=A*30,u=A*365;function a(d,p,w,O){typeof d!="number"&&(d=d.getTime());const m=Math.round((new Date().getTime()-d)/1e3);if(m<-30)return(0,D.localize)(0,null,a(new Date().getTime()+m*1e3,!1));if(!O&&m<30)return(0,D.localize)(1,null);let c;return m<j?(c=m,p?c===1?w?(0,D.localize)(2,null,c):(0,D.localize)(3,null,c):w?(0,D.localize)(4,null,c):(0,D.localize)(5,null,c):c===1?w?(0,D.localize)(6,null,c):(0,D.localize)(7,null,c):w?(0,D.localize)(8,null,c):(0,D.localize)(9,null,c)):m<k?(c=Math.floor(m/j),p?c===1?w?(0,D.localize)(10,null,c):(0,D.localize)(11,null,c):w?(0,D.localize)(12,null,c):(0,D.localize)(13,null,c):c===1?w?(0,D.localize)(14,null,c):(0,D.localize)(15,null,c):w?(0,D.localize)(16,null,c):(0,D.localize)(17,null,c)):m<A?(c=Math.floor(m/k),p?c===1?w?(0,D.localize)(18,null,c):(0,D.localize)(19,null,c):w?(0,D.localize)(20,null,c):(0,D.localize)(21,null,c):c===1?w?(0,D.localize)(22,null,c):(0,D.localize)(23,null,c):w?(0,D.localize)(24,null,c):(0,D.localize)(25,null,c)):m<R?(c=Math.floor(m/A),p?c===1?(0,D.localize)(26,null,c):(0,D.localize)(27,null,c):c===1?(0,D.localize)(28,null,c):(0,D.localize)(29,null,c)):m<S?(c=Math.floor(m/R),p?c===1?w?(0,D.localize)(30,null,c):(0,D.localize)(31,null,c):w?(0,D.localize)(32,null,c):(0,D.localize)(33,null,c):c===1?w?(0,D.localize)(34,null,c):(0,D.localize)(35,null,c):w?(0,D.localize)(36,null,c):(0,D.localize)(37,null,c)):m<u?(c=Math.floor(m/S),p?c===1?w?(0,D.localize)(38,null,c):(0,D.localize)(39,null,c):w?(0,D.localize)(40,null,c):(0,D.localize)(41,null,c):c===1?w?(0,D.localize)(42,null,c):(0,D.localize)(43,null,c):w?(0,D.localize)(44,null,c):(0,D.localize)(45,null,c)):(c=Math.floor(m/u),p?c===1?w?(0,D.localize)(46,null,c):(0,D.localize)(47,null,c):w?(0,D.localize)(48,null,c):(0,D.localize)(49,null,c):c===1?w?(0,D.localize)(50,null,c):(0,D.localize)(51,null,c):w?(0,D.localize)(52,null,c):(0,D.localize)(53,null,c))}function y(d,p){const w=Math.abs(d/1e3);return w<1?p?(0,D.localize)(54,null,d):(0,D.localize)(55,null,d):w<j?p?(0,D.localize)(56,null,Math.round(d)/1e3):(0,D.localize)(57,null,Math.round(d)/1e3):w<k?p?(0,D.localize)(58,null,Math.round(d/(1e3*j))):(0,D.localize)(59,null,Math.round(d/(1e3*j))):w<A?p?(0,D.localize)(60,null,Math.round(d/(1e3*k))):(0,D.localize)(61,null,Math.round(d/(1e3*k))):(0,D.localize)(62,null,Math.round(d/(1e3*A)))}function v(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ne[80],re([7,4]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ne[34],re([0,1,19,3,80]),function(J,e,D,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6i=u,e.$7i=a,e.$8i=y;function A(v,d){return d&&(v.stack||v.stacktrace)?k.localize(0,null,S(v),R(v.stack)||R(v.stacktrace)):S(v)}function R(v){return Array.isArray(v)?v.join(`
`):v}function S(v){return v.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${v.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?k.localize(1,null,v.message):v.message||k.localize(2,null)}function u(v=null,d=!1){if(!v)return k.localize(3,null);if(Array.isArray(v)){const p=D.$Hb(v),w=u(p[0],d);return p.length>1?k.localize(4,null,w,p.length):w}if(j.$Vf(v))return v;if(v.detail){const p=v.detail;if(p.error)return A(p.error,d);if(p.exception)return A(p.exception,d)}return v.stack?A(v,d):v.message?v.message:k.localize(5,null)}function a(v){const d=v;return d instanceof Error&&Array.isArray(d.actions)}function y(v,d){let p;return typeof v=="string"?p=new Error(v):p=v,p.actions=d,p}}),define(ne[81],re([7,4]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(ne[82],re([0,1,81]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=j;function j(k){switch(k){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}}),define(ne[56],re([0,1,12]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$$l=A,e.$_l=R;var j;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(j||(e.Source=j={}));var k;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(k||(e.TerminateResponseCode=k={}));function A(S,...u){const a=u.reduce((d,p)=>(d[p]=!0,d),{}),y=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(d=>!a[d]).forEach(d=>{for(let p=0;p<y.length;p++)if(d.search(y[p])!==-1){delete S[d];break}})}function R(S){S&&(delete S.DEBUG,D.$j&&delete S.DYLD_LIBRARY_PATH,D.$k&&delete S.LD_PRELOAD)}}),define(ne[83],re([0,1,11]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=j,e.$Gq=k,e.$Hq=A,e.log=S;function j(a){const y=a;return y&&typeof y.type=="string"&&typeof y.severity=="string"}function k(a){const y=[];let v;try{const d=JSON.parse(a.arguments),p=d[d.length-1];p&&p.__$stack&&(d.pop(),v=p.__$stack),y.push(...d)}catch{y.push("Unable to log remote console arguments",a.arguments)}return{args:y,stack:v}}function A(a){if(typeof a!="string")return A(k(a).stack);const y=a;if(y){const v=R(y),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(d&&d.length===4)return{uri:D.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}function R(a){if(!a)return a;const y=a.indexOf(`
`);return y===-1?a:a.substring(0,y)}function S(a,y){const{args:v,stack:d}=k(a),p=typeof v[0]=="string"&&v.length===1;let w=R(d);w&&(w=`(${w.trim()})`);let O=[];if(typeof v[0]=="string"?w&&p?O=[`%c[${y}] %c${v[0]} %c${w}`,u("blue"),u(""),u("grey")]:O=[`%c[${y}] %c${v[0]}`,u("blue"),u(""),...v.slice(1)]:O=[`%c[${y}]%`,u("blue"),...v],w&&!p&&O.push(w),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,O)}function u(a){return`color: ${a}`}}),define(ne[47],re([0,1,14,11]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=k,e.$Qh=A,e.$Rh=S;function k(u){return JSON.stringify(u,R)}function A(u){let a=JSON.parse(u);return a=S(a),a}function R(u,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function S(u,a=0){if(!u||a>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return j.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof D.$ue||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let y=0;y<u.length;++y)u[y]=S(u[y],a+1);else for(const y in u)Object.hasOwnProperty.call(u,y)&&(u[y]=S(u[y],a+1))}return u}}),define(ne[84],re([0,1,71,15,12,11]),function(J,e,D,j,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FD=y;class R{constructor(d,p,w){this.id=d,this.dependencies=p,this.callback=w}}class S{static{this.INSTANCE=new S}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(d,p,w)=>{typeof d!="string"&&(w=p,p=d,d=null),(typeof p!="object"||!Array.isArray(p))&&(w=p,p=null),this.c.push(new R(d,p,w))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){if(d.startsWith(window.location.origin)||d.startsWith("vscode-file://vscode-app"))return d;throw new Error(`[trusted_script_src] Invalid script url: ${d}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){return d}})))}async load(d){this.g();const p=await(this.a?this.i(d):this.b?this.h(d):this.j(d));if(!p)throw new Error(`Did not receive a define call from script ${d}`);if(Array.isArray(p.dependencies)&&p.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${d}. The dependencies are: ${p.dependencies.join(", ")}`);return typeof p.callback=="function"?p.callback([]):p.callback}h(d){return new Promise((p,w)=>{const O=document.createElement("script");O.setAttribute("async","async"),O.setAttribute("type","text/javascript");const m=()=>{O.removeEventListener("load",c),O.removeEventListener("error",b)},c=$=>{m(),p(this.c.pop())},b=$=>{m(),w($)};O.addEventListener("load",c),O.addEventListener("error",b),this.f&&(d=this.f.createScriptURL(d)),O.setAttribute("src",d),window.document.getElementsByTagName("head")[0].appendChild(O)})}i(d){return new Promise((p,w)=>{try{this.f&&(d=this.f.createScriptURL(d)),importScripts(d),p(this.c.pop())}catch(O){w(O)}})}async j(d){try{const p=globalThis._VSCODE_NODE_MODULES.fs,w=globalThis._VSCODE_NODE_MODULES.vm,O=globalThis._VSCODE_NODE_MODULES.module,m=A.URI.parse(d).fsPath,c=p.readFileSync(m).toString(),b=O.wrap(c.replace(/^#!.*/,""));return new w.Script(b).runInThisContext().apply(),this.c.pop()}catch(p){throw p}}}const u=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function y(v,d,p){if(D.$T){p===void 0&&(p=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[v]&&(v=a[v]);const w=`${v}/${d}`;if(u.has(w))return u.get(w);let O;if(/^\w[\w\d+.-]*:\/\//.test(w))O=w;else{const $=`${p&&!k.$o?j.$zg:j.$yg}/${w}`;O=j.$Cg.asBrowserUri($).toString(!0)}const m=S.INSTANCE.load(O);return u.set(w,m),m}else return await new Promise((w,O)=>{J([v],w,O)})}}),define(ne[85],re([0,1,33,48,28,77,12]),function(J,e,D,j,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=void 0,e.$rn=u,e.$sn=v,e.$qn=new class{c(d){return this.a||(this.a=j.$oi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(d)}value(){if(this.b===void 0){let d=0,p=0;const w=(0,D.networkInterfaces)();for(const O in w){const m=w[O];if(m)for(const{mac:c,internal:b}of m)b||(p+=1,this.c(c.toUpperCase())&&(d+=1))}this.b=p>0?d/p:0}return this.b}};let S;async function u(d){return S||(S=(async()=>await a(d)||k.$Eg())()),S}async function a(d){try{const p=await new Promise((O,m)=>{J(["crypto"],O,m)}),w=(0,A.$pn)();return p.createHash("sha256").update(w,"utf8").digest("hex")}catch(p){d(p);return}}const y="Software\\Microsoft\\SQMClient";async function v(d){if(R.$i){const p=await new Promise((w,O)=>{J(["@vscode/windows-registry"],w,O)});try{return p.GetStringRegKey("HKEY_LOCAL_MACHINE",y,"MachineId")||""}catch(w){return d(w),""}}return""}}),define(ne[86],re([0,1,33,16,25]),function(J,e,D,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=b,e.$0l=$;const A=/^\d+$/,R=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var u;(function(h){h[h.x64=0]="x64",h[h.x86=1]="x86",h[h.ARM=2]="ARM"})(u||(u={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class v{constructor(g,i,r){this.exePath=g,this.displayName=i,this.a=r}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function d({useAlternateBitness:h=!1}={}){return h?a===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:h=!1,findPreview:g=!1}={}){const i=d({useAlternateBitness:h});if(!i)return null;const r=j.$kc(i,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(r))return null;let t=-1,n=null;for(const l of await k.Promises.readdir(r)){let P=-1;if(g){const L=l.indexOf("-");if(L<0)continue;const z=l.substring(0,L);if(!A.test(z)||l.substring(L+1)!=="preview")continue;P=parseInt(z,10)}else{if(!A.test(l))continue;P=parseInt(l,10)}if(P<=t)continue;const I=j.$kc(r,l,"pwsh.exe");await k.SymlinkSupport.existsFile(I)&&(n=I,t=P)}if(!n)return null;const s=i.includes("x86")?" (x86)":"",o=g?" Preview":"";return new v(n,`PowerShell${o}${s}`,!0)}async function w({findPreview:h}={}){if(!process.env.LOCALAPPDATA)return null;const g=j.$kc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(g))return null;const{pwshMsixDirRegex:i,pwshMsixName:r}=h?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:R,pwshMsixName:"PowerShell (Store)"};for(const t of await k.Promises.readdir(g))if(i.test(t)){const n=j.$kc(g,t,"pwsh.exe");return new v(n,r)}return null}function O(){const h=j.$kc(D.homedir(),".dotnet","tools","pwsh.exe");return new v(h,".NET Core PowerShell Global Tool")}function m(){const h=j.$kc(process.env.windir,a===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(h,"Windows PowerShell",!0)}async function*c(){let h=await p();h&&(yield h),h=await p({useAlternateBitness:!0}),h&&(yield h),h=await w(),h&&(yield h),h=O(),h&&(yield h),h=await p({findPreview:!0}),h&&(yield h),h=await w({findPreview:!0}),h&&(yield h),h=await p({useAlternateBitness:!0,findPreview:!0}),h&&(yield h),h=m(),h&&(yield h)}async function*b(){for await(const h of c())await h.exists()&&(yield h)}async function $(){for await(const h of b())return h;return null}}),define(ne[57],re([0,1,16,12,35,56,3,25]),function(J,e,D,j,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$am=u,e.$bm=a,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function u(v=k.env){return v.comspec||"cmd.exe"}function a(v){let d=[],p=!1;const w=function(O){if(p){d.push(O);return}(!v.send(O,c=>{if(c&&console.error(c),p=!1,d.length>0){const b=d.slice(0);d=[],b.forEach($=>w($))}})||j.$i)&&(p=!0)};return{send:w}}var y;(function(v){async function d(p,w,O){if(D.$jc(p))return p;if(w===void 0&&(w=k.cwd()),D.$nc(p)!=="."||(O===void 0&&R.$Vf(k.env.PATH)&&(O=k.env.PATH.split(D.$uc)),O===void 0||O.length===0))return D.$kc(w,p);async function c(b){if(await S.Promises.exists(b)){let $;try{$=await S.Promises.stat(b)}catch(h){h.message.startsWith("EACCES")&&($=await S.Promises.lstat(b))}return $?!$.isDirectory():!1}return!1}for(const b of O){let $;if(D.$jc(b)?$=D.$kc(b,p):$=D.$kc(w,b,p),await c($))return $;let h=$+".com";if(await c(h)||(h=$+".exe",await c(h)))return h}return D.$kc(w,p)}v.findExecutable=d})(y||(e.win32=y={}))}),define(ne[87],re([0,1,33,12,86,57]),function(J,e,D,j,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cm=R;async function R(v,d){return v===1?j.$i?y():A.$am(d):u(v,d)}let S=null;function u(v,d){if(j.$k&&v===2||j.$j&&v===3)return"/bin/bash";if(!S){let p;if(j.$i)p="/bin/bash";else{if(p=d.SHELL,!p)try{p=(0,D.userInfo)().shell}catch{}p||(p="sh"),p==="/bin/false"&&(p="/bin/bash")}S=p}return S}let a=null;async function y(){return a||(a=(await(0,k.$0l)()).exePath),a}});var $e=this&&this.__decorate||function(J,e,D,j){var k=arguments.length,A=k<3?e:j===null?j=Object.getOwnPropertyDescriptor(e,D):j,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(J,e,D,j);else for(var S=J.length-1;S>=0;S--)(R=J[S])&&(A=(k<3?R(A):k>3?R(e,D,A):R(e,D))||A);return k>3&&A&&Object.defineProperty(e,D,A),A};define(ne[58],re([0,1,19,9,14,20,54,8,5,2,47,30,3]),function(J,e,D,j,k,A,R,S,u,a,y,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.ProxyChannel=e.$3h=e.$Zh=e.$Yh=e.$Xh=e.RequestInitiator=e.$Wh=e.$Th=e.$Sh=void 0,e.$Uh=o,e.$Vh=l,e.$1h=V,e.$2h=X;var p;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(p||(p={}));function w(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var O;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(O||(O={}));function m(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(c||(c={}));function b(q){let T=0;for(let x=0;;x+=7){const Y=q.read(1);if(T|=(Y.buffer[0]&127)<<x,!(Y.buffer[0]&128))return T}}const $=t(0);function h(q,T){if(T===0){q.write($);return}let x=0;for(let Q=T;Q!==0;Q=Q>>>7)x++;const Y=k.$ue.alloc(x);for(let Q=0;T!==0;Q++)Y.buffer[Q]=T&127,T=T>>>7,T>0&&(Y.buffer[Q]|=128);q.write(Y)}class g{constructor(T){this.b=T,this.a=0}read(T){const x=this.b.slice(this.a,this.a+T);return this.a+=x.byteLength,x}}e.$Sh=g;class i{constructor(){this.a=[]}get buffer(){return k.$ue.concat(this.a)}write(T){this.a.push(T)}}e.$Th=i;var r;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(r||(r={}));function t(q){const T=k.$ue.alloc(1);return T.writeUInt8(q,0),T}const n={Undefined:t(r.Undefined),String:t(r.String),Buffer:t(r.Buffer),VSBuffer:t(r.VSBuffer),Array:t(r.Array),Object:t(r.Object),Uint:t(r.Int)},s=typeof Buffer<"u";function o(q,T){if(typeof T>"u")q.write(n.Undefined);else if(typeof T=="string"){const x=k.$ue.fromString(T);q.write(n.String),h(q,x.byteLength),q.write(x)}else if(s&&Buffer.isBuffer(T)){const x=k.$ue.wrap(T);q.write(n.Buffer),h(q,x.byteLength),q.write(x)}else if(T instanceof k.$ue)q.write(n.VSBuffer),h(q,T.byteLength),q.write(T);else if(Array.isArray(T)){q.write(n.Array),h(q,T.length);for(const x of T)o(q,x)}else if(typeof T=="number"&&(T|0)===T)q.write(n.Uint),h(q,T);else{const x=k.$ue.fromString(JSON.stringify(T));q.write(n.Object),h(q,x.byteLength),q.write(x)}}function l(q){switch(q.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return q.read(b(q)).toString();case r.Buffer:return q.read(b(q)).buffer;case r.VSBuffer:return q.read(b(q));case r.Array:{const x=b(q),Y=[];for(let Q=0;Q<x;Q++)Y.push(l(q));return Y}case r.Object:return JSON.parse(q.read(b(q)).toString());case r.Int:return b(q)}}class P{constructor(T,x,Y=null,Q=1e3){this.h=T,this.j=x,this.k=Y,this.l=Q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(_=>this.q(_)),this.m({type:200})}registerChannel(T,x){this.b.set(T,x),setTimeout(()=>this.w(T),0)}m(T){switch(T.type){case 200:{const x=this.o([T.type]);this.k?.logOutgoing(x,0,1,m(T.type));return}case 201:case 202:case 204:case 203:{const x=this.o([T.type,T.id],T.data);this.k?.logOutgoing(x,T.id,1,m(T.type),T.data);return}}}o(T,x=void 0){const Y=new i;return o(Y,T),o(Y,x),this.p(Y.buffer)}p(T){try{return this.h.send(T),T.byteLength}catch{return 0}}q(T){const x=new g(T),Y=l(x),Q=l(x),_=Y[0];switch(_){case 100:return this.k?.logIncoming(T.byteLength,Y[1],1,`${w(_)}: ${Y[2]}.${Y[3]}`,Q),this.s({type:_,id:Y[1],channelName:Y[2],name:Y[3],arg:Q});case 102:return this.k?.logIncoming(T.byteLength,Y[1],1,`${w(_)}: ${Y[2]}.${Y[3]}`,Q),this.t({type:_,id:Y[1],channelName:Y[2],name:Y[3],arg:Q});case 101:return this.k?.logIncoming(T.byteLength,Y[1],1,`${w(_)}`),this.u({type:_,id:Y[1]});case 103:return this.k?.logIncoming(T.byteLength,Y[1],1,`${w(_)}`),this.u({type:_,id:Y[1]})}}s(T){const x=this.b.get(T.channelName);if(!x){this.v(T);return}const Y=new A.$ee;let Q;try{Q=x.call(this.j,T.name,T.arg,Y.token)}catch(F){Q=Promise.reject(F)}const _=T.id;Q.then(F=>{this.m({id:_,data:F,type:201})},F=>{F instanceof Error?this.m({id:_,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.m({id:_,data:F,type:203})}).finally(()=>{M.dispose(),this.d.delete(T.id)});const M=(0,a.$Sc)(()=>Y.cancel());this.d.set(T.id,M)}t(T){const x=this.b.get(T.channelName);if(!x){this.v(T);return}const Y=T.id,_=x.listen(this.j,T.name,T.arg)(M=>this.m({id:Y,data:M,type:204}));this.d.set(T.id,_)}u(T){const x=this.d.get(T.id);x&&(x.dispose(),this.d.delete(T.id))}v(T){let x=this.g.get(T.channelName);x||(x=[],this.g.set(T.channelName,x));const Y=setTimeout(()=>{console.error(`Unknown channel: ${T.channelName}`),T.type===100&&this.m({id:T.id,data:{name:"Unknown channel",message:`Channel name '${T.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);x.push({request:T,timeoutTimer:Y})}w(T){const x=this.g.get(T);if(x){for(const Y of x)switch(clearTimeout(Y.timeoutTimer),Y.request.type){case 100:this.s(Y.request);break;case 102:this.t(Y.request);break}this.g.delete(T)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Pc)(this.d.values()),this.d.clear()}}e.$Wh=P;var I;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class L{constructor(T,x=null){this.l=T,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$7d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Y=>this.s(Y)),this.j=x}getChannel(T){const x=this;return{call(Y,Q,_){return x.a?Promise.reject(new S.$5):x.m(T,Y,Q,_)},listen(Y,Q){return x.a?u.Event.None:x.o(T,Y,Q)}}}m(T,x,Y,Q=A.CancellationToken.None){const _=this.g++,F={id:_,type:100,channelName:T,name:x,arg:Y};if(Q.isCancellationRequested)return Promise.reject(new S.$5);let f;return new Promise((N,C)=>{if(Q.isCancellationRequested)return C(new S.$5);const W=()=>{const le=pe=>{switch(pe.type){case 201:this.f.delete(_),N(pe.data);break;case 202:{this.f.delete(_);const ye=new Error(pe.data.message);ye.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,ye.name=pe.data.name,C(ye);break}case 203:this.f.delete(_),C(pe.data);break}};this.f.set(_,le),this.p(F)};let G=null;this.b===c.Idle?W():(G=(0,j.$8g)(le=>this.u()),G.then(()=>{G=null,W()}));const te=()=>{G?(G.cancel(),G=null):this.p({id:_,type:101}),C(new S.$5)},ae=Q.onCancellationRequested(te);f=(0,a.$Rc)((0,a.$Sc)(te),ae),this.d.add(f)}).finally(()=>{f.dispose(),this.d.delete(f)})}o(T,x,Y){const Q=this.g++,M={id:Q,type:102,channelName:T,name:x,arg:Y};let F=null;const f=new u.$7d({onWillAddFirstListener:()=>{F=(0,j.$8g)(N=>this.u()),F.then(()=>{F=null,this.d.add(f),this.p(M)})},onDidRemoveLastListener:()=>{F?(F.cancel(),F=null):(this.d.delete(f),this.p({id:Q,type:103}))}}),E=N=>f.fire(N.data);return this.f.set(Q,E),f.event}p(T){switch(T.type){case 100:case 102:{const x=this.q([T.type,T.id,T.channelName,T.name],T.arg);this.j?.logOutgoing(x,T.id,0,`${w(T.type)}: ${T.channelName}.${T.name}`,T.arg);return}case 101:case 103:{const x=this.q([T.type,T.id]);this.j?.logOutgoing(x,T.id,0,w(T.type));return}}}q(T,x=void 0){const Y=new i;return o(Y,T),o(Y,x),this.r(Y.buffer)}r(T){try{return this.l.send(T),T.byteLength}catch{return 0}}s(T){const x=new g(T),Y=l(x),Q=l(x),_=Y[0];switch(_){case 200:return this.j?.logIncoming(T.byteLength,0,0,m(_)),this.t({type:Y[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(T.byteLength,Y[1],0,m(_),Q),this.t({type:Y[0],id:Y[1],data:Q})}}t(T){if(T.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(T.id)?.(T)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Pc)(this.d.values()),this.d.clear()}}e.$Xh=L,$e([R.$Mh],L.prototype,"onDidInitializePromise",null);class z{get connections(){const T=[];return this.f.forEach(x=>T.push(x)),T}constructor(T,x,Y){this.a=new Map,this.f=new Set,this.g=new u.$7d,this.onDidAddConnection=this.g.event,this.h=new u.$7d,this.onDidRemoveConnection=this.h.event,this.j=new a.$Tc,this.j.add(T(({protocol:Q,onDidClientDisconnect:_})=>{const M=u.Event.once(Q.onMessage);this.j.add(M(F=>{const f=new g(F),E=l(f),N=new P(Q,E,x,Y),C=new L(Q,x);this.a.forEach((G,te)=>N.registerChannel(te,G));const W={channelServer:N,channelClient:C,ctx:E};this.f.add(W),this.g.fire(W),this.j.add(_(()=>{N.dispose(),C.dispose(),this.f.delete(W),this.h.fire(W)}))}))}))}getChannel(T,x){const Y=this;return{call(Q,_,M){let F;if((0,d.$0f)(x)){const E=(0,D.$4b)(Y.connections.filter(x));F=E?Promise.resolve(E):u.Event.toPromise(u.Event.filter(Y.onDidAddConnection,x))}else F=x.routeCall(Y,Q,_);const f=F.then(E=>E.channelClient.getChannel(T));return V(f).call(Q,_,M)},listen(Q,_){if((0,d.$0f)(x))return Y.k(T,x,Q,_);const M=x.routeEvent(Y,Q,_).then(F=>F.channelClient.getChannel(T));return V(M).listen(Q,_)}}}k(T,x,Y,Q){const _=this;let M;const F=new u.$7d({onWillAddFirstListener:()=>{M=new a.$Tc;const f=new u.$ae,E=new Map,N=W=>{const te=W.channelClient.getChannel(T).listen(Y,Q),ae=f.add(te);E.set(W,ae)},C=W=>{const G=E.get(W);G&&(G.dispose(),E.delete(W))};_.connections.filter(x).forEach(N),u.Event.filter(_.onDidAddConnection,x)(N,void 0,M),_.onDidRemoveConnection(C,void 0,M),f.event(F.fire,F,M),M.add(f)},onDidRemoveLastListener:()=>{M?.dispose(),M=void 0}});return F.event}registerChannel(T,x){this.a.set(T,x);for(const Y of this.f)Y.channelServer.registerChannel(T,x)}dispose(){this.j.dispose();for(const T of this.f)T.channelClient.dispose(),T.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Yh=z;class U{constructor(T,x,Y=null){const Q=new i;o(Q,x),T.send(Q.buffer),this.a=new L(T,Y),this.d=new P(T,x,Y)}getChannel(T){return this.a.getChannel(T)}registerChannel(T,x){this.d.registerChannel(T,x)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Zh=U;function V(q){return{call(T,x,Y){return q.then(Q=>Q.call(T,x,Y))},listen(T,x){const Y=new u.$de;return q.then(Q=>Y.input=Q.listen(T,x)),Y.event}}}function X(q){let T=!1;return{call(x,Y,Q){return T?q.call(x,Y,Q):(0,j.$jh)(0).then(()=>T=!0).then(()=>q.call(x,Y,Q))},listen(x,Y){if(T)return q.listen(x,Y);const Q=new u.$de;return(0,j.$jh)(0).then(()=>T=!0).then(()=>Q.input=q.listen(x,Y)),Q.event}}}class se{constructor(T){this.a=T}routeCall(T){return this.b(T)}routeEvent(T){return this.b(T)}async b(T){for(const x of T.connections)if(await Promise.resolve(this.a(x.ctx)))return Promise.resolve(x);return await u.Event.toPromise(T.onDidAddConnection),await this.b(T)}}e.$3h=se;var ie;(function(q){function T(_,M,F){const f=_,E=F&&F.disableMarshalling,N=new Map;for(const C in f)Y(C)&&N.set(C,u.Event.buffer(f[C],!0,void 0,M));return new class{listen(C,W,G){const te=N.get(W);if(te)return te;const ae=f[W];if(typeof ae=="function"){if(Q(W))return ae.call(f,G);if(Y(W))return N.set(W,u.Event.buffer(f[W],!0,void 0,M)),N.get(W)}throw new S.$bb(`Event not found: ${W}`)}call(C,W,G){const te=f[W];if(typeof te=="function"){if(!E&&Array.isArray(G))for(let le=0;le<G.length;le++)G[le]=(0,y.$Rh)(G[le]);let ae=te.apply(f,G);return ae instanceof Promise||(ae=Promise.resolve(ae)),ae}throw new S.$bb(`Method not found: ${W}`)}}}q.fromService=T;function x(_,M){const F=M&&M.disableMarshalling;return new Proxy({},{get(f,E){if(typeof E=="string")return M?.properties?.has(E)?M.properties.get(E):Q(E)?function(N){return _.listen(E,N)}:Y(E)?_.listen(E):async function(...N){let C;M&&!(0,d.$5f)(M.context)?C=[M.context,...N]:C=N;const W=await _.call(E,C);return F?W:(0,y.$Rh)(W)};throw new S.$bb(`Property not found: ${String(E)}`)}})}q.toService=x;function Y(_){return _[0]==="o"&&_[1]==="n"&&v.$kf(_.charCodeAt(2))}function Q(_){return/^onDynamic/.test(_)&&v.$kf(_.charCodeAt(9))}})(ie||(e.ProxyChannel=ie={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function he(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const T=q.toString();if(T!=="[object Object]")return T}return q}function ce(q){return Array.isArray(q)?q.map(he):he(q)}function B(q,T,x,Y,Q,_,M){M=ce(M);const F=ue[Q],f=F[Y%F.length];let E=[`%c[${q}]%c[${String(T).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(Y).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${f}`];/\($/.test(_)?(E=E.concat(M),E.push(")")):E.push(M),console.log.apply(console,E)}class Z{constructor(T,x){this.d=T,this.f=x,this.a=0,this.b=0}logOutgoing(T,x,Y,Q,_){this.b+=T,B(this.d,this.b,T,x,Y,Q,_)}logIncoming(T,x,Y,Q,_){this.a+=T,B(this.f,this.a,T,x,Y,Q,_)}}e.$4h=Z}),define(ne[88],re([0,1,59,9,14,20,83,8,5,2,27,57,56,58]),function(J,e,D,j,k,A,R,S,u,a,y,v,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=e.$Jq=void 0;class w extends p.$Wh{constructor(c){super({send:b=>{try{process.send?.(b.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",b=>k.$ue.wrap(Buffer.from(b,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$Jq=w;class O{constructor(c,b){this.i=c,this.j=b,this.c=new Set,this.g=new Map,this.h=new u.$7d,this.onDidProcessExit=this.h.event;const $=b&&b.timeout?b.timeout:6e4;this.b=new j.$fh($),this.d=null,this.f=null}getChannel(c){const b=this;return{call($,h,g){return b.k(c,$,h,g)},listen($,h){return b.l(c,$,h)}}}k(c,b,$,h=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(S.$6());this.b.cancel();const g=this.n(c),i=(0,j.$8g)(n=>g.call(b,$,n)),r=h.onCancellationRequested(()=>i.cancel()),t=(0,a.$Sc)(()=>i.cancel());return this.c.add(t),i.finally(()=>{r.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(c,b,$){if(!this.b)return u.Event.None;this.b.cancel();let h;const g=new u.$7d({onWillAddFirstListener:()=>{h=this.n(c).listen(b,$)(g.fire,g),this.c.add(h)},onDidRemoveLastListener:()=>{this.c.delete(h),h.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return g.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],b=Object.create(null);b.env={...(0,y.$On)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(b.env={...b.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(b.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(b.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(b.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),b.execArgv===void 0&&(b.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,d.$_l)(b.env),this.d=(0,D.fork)(this.i,c,b);const $=new u.$7d,g=u.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,R.$Fq)(o)){(0,R.log)(o,`IPC Library: ${this.j.serverName}`);return}$.fire(k.$ue.wrap(Buffer.from(o,"base64")))}),i=this.j.useQueue?(0,v.$bm)(this.d):this.d,r=o=>this.d&&this.d.connected&&i.send(o.buffer.toString("base64")),t=$.event,n={send:r,onMessage:t};this.f=new p.$Xh(n);const s=()=>this.o();process.once("exit",s),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,l)=>{process.removeListener("exit",s),g.dispose(),this.c.forEach(P=>(0,a.$Pc)(P)),this.c.clear(),o!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:l})})}return this.f}n(c){let b=this.g.get(c);return b||(b=this.m.getChannel(c),this.g.set(c,b)),b}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Kq=O}),define(ne[89],re([0,1,9,5,2,47,3]),function(J,e,D,j,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Ip=e.StorageState=e.StorageHint=void 0,e.$Hp=u;var S;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(S||(e.StorageHint=S={}));function u(d){const p=d;return p?.changed instanceof Map||p?.deleted instanceof Set}var a;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(a||(e.StorageState=a={}));class y extends k.$Uc{static{this.a=100}constructor(p,w=Object.create(null)){super(),this.r=p,this.s=w,this.b=this.B(new j.$0d),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new D.$gh(y.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(p=>this.u(p)))}u(p){this.b.pause();try{p.changed?.forEach((w,O)=>this.w(O,w)),p.deleted?.forEach(w=>this.w(w,void 0))}finally{this.b.resume()}}w(p,w){if(this.c===a.Closed)return;let O=!1;(0,R.$5f)(w)?O=this.f.delete(p):this.f.get(p)!==w&&(this.f.set(p,w),O=!0),O&&this.b.fire({key:p,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==S.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(p,w){const O=this.f.get(p);return(0,R.$5f)(O)?w:O}getBoolean(p,w){const O=this.get(p);return(0,R.$5f)(O)?w:O==="true"}getNumber(p,w){const O=this.get(p);return(0,R.$5f)(O)?w:parseInt(O,10)}getObject(p,w){const O=this.get(p);return(0,R.$5f)(O)?w:(0,A.$Qh)(O)}async set(p,w,O=!1){if(this.c===a.Closed)return;if((0,R.$5f)(w))return this.delete(p,O);const m=(0,R.$Xf)(w)||Array.isArray(w)?(0,A.$Ph)(w):String(w);if(this.f.get(p)!==m)return this.f.set(p,m),this.j.set(p,m),this.h.delete(p),this.b.fire({key:p,external:O}),this.D()}async delete(p,w=!1){if(!(this.c===a.Closed||!this.f.delete(p)))return this.h.has(p)||this.h.add(p),this.j.delete(p),this.b.fire({key:p,external:w}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const p={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(p).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(p){if(this.z)return this.D(p)}async D(p){return this.s.hint===S.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),p)}async whenFlushed(){if(this.z)return new Promise(p=>this.n.push(p))}isInMemory(){return this.s.hint===S.STORAGE_IN_MEMORY}}e.$Ip=y;class v{constructor(){this.onDidChangeItemsExternal=j.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(p){p.insert?.forEach((w,O)=>this.a.set(O,w)),p.delete?.forEach(w=>this.a.delete(w))}async optimize(){}async close(){}}e.$Jp=v}),define(ne[90],re([7,4]),function(J,e){return J.create("vs/base/node/zip",e)}),define(ne[49],re([0,1,60,9,16,3,25,90]),function(J,e,D,j,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=void 0,e.zip=m,e.$7p=c,e.$8p=$,e.$4p="end of central directory record signature not found";const u=new RegExp(e.$4p);class a extends Error{constructor(g,i){let r=i.message;switch(g){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=g,this.cause=i}}e.$5p=a;function y(h){const g=h.externalFileAttributes>>16||33188;return[448,56,7].map(i=>g&i).reduce((i,r)=>i+r,g&61440)}function v(h){if(h instanceof a)return h;let g;return u.test(h.message)&&(g="CorruptZip"),new a(g,h)}function d(h,g,i,r,t,n){const s=k.$nc(g),o=k.$kc(r,s);if(!o.startsWith(r))return Promise.reject(new Error(S.localize(0,null,g)));const l=k.$kc(r,g);let P;return n.onCancellationRequested(()=>{P?.destroy()}),Promise.resolve(R.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((I,L)=>{if(!n.isCancellationRequested)try{P=(0,D.createWriteStream)(l,{mode:i}),P.once("close",()=>I()),P.once("error",L),h.once("error",L),h.pipe(P)}catch(z){L(z)}}))}function p(h,g,i,r){let t=(0,j.$8g)(()=>Promise.resolve()),n=0;const s=r.onCancellationRequested(()=>{t.cancel(),h.close()});return new Promise((o,l)=>{const P=new j.$dh,I=L=>{L.isCancellationRequested||(n++,h.readEntry())};h.once("error",l),h.once("close",()=>t.then(()=>{r.isCancellationRequested||h.entryCount===n?o():l(new a("Incomplete",new Error(S.localize(1,null,n,h.entryCount))))},l)),h.readEntry(),h.on("entry",L=>{if(r.isCancellationRequested)return;if(!i.sourcePathRegex.test(L.fileName)){I(r);return}const z=L.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(z)){const X=k.$kc(g,z);t=(0,j.$8g)(se=>R.Promises.mkdir(X,{recursive:!0}).then(()=>I(se)).then(void 0,l));return}const U=O(h,L),V=y(L);t=(0,j.$8g)(X=>P.queue(()=>U.then(se=>d(se,z,V,g,i,X).then(()=>I(X)))).then(null,l))})}).finally(()=>s.dispose())}async function w(h,g=!1){const{open:i}=await new Promise((r,t)=>{J(["yauzl"],r,t)});return new Promise((r,t)=>{i(h,g?{lazyEntries:!0}:void 0,(n,s)=>{n?t(v(n)):r((0,A.$7f)(s))})})}function O(h,g){return new Promise((i,r)=>{h.openReadStream(g,(t,n)=>{t?r(v(t)):i((0,A.$7f)(n))})})}async function m(h,g){const{ZipFile:i}=await new Promise((r,t)=>{J(["yazl"],r,t)});return new Promise((r,t)=>{const n=new i;g.forEach(o=>{o.contents?n.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&n.addFile(o.localPath,o.path)}),n.end();const s=(0,D.createWriteStream)(h);n.outputStream.pipe(s),n.outputStream.once("error",t),s.once("error",t),s.once("finish",()=>r(h))})}function c(h,g,i={},r){const t=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let n=w(h,!0);return i.overwrite&&(n=n.then(s=>R.Promises.rm(g).then(()=>s))),n.then(s=>p(s,g,{sourcePathRegex:t},r))}function b(h,g){return w(h).then(i=>new Promise((r,t)=>{i.on("entry",n=>{n.fileName===g&&O(i,n).then(s=>r(s),s=>t(s))}),i.once("close",()=>t(new Error(S.localize(2,null,g))))}))}function $(h,g){return b(h,g).then(i=>new Promise((r,t)=>{const n=[];i.once("error",t),i.on("data",s=>n.push(s)),i.on("end",()=>r(Buffer.concat(n)))}))}}),define(ne[91],re([7,4]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[92],re([7,4]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(ne[93],re([7,4]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(ne[94],re([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[95],re([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[96],re([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ne[97],re([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[98],re([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[99],re([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[100],re([7,4]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[101],re([7,4]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[102],re([7,4]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ne[103],re([7,4]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ne[104],re([7,4]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[105],re([7,4]),function(J,e){return J.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[106],re([7,4]),function(J,e){return J.create("vs/platform/log/common/log",e)}),define(ne[107],re([7,4]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ne[108],re([7,4]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(ne[109],re([7,4]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[110],re([7,4]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[111],re([7,4]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(ne[112],re([0,1,8,93]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dj=e.TokenType=void 0;var k;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(k||(e.TokenType=k={}));function A(...a){switch(a.length){case 1:return(0,j.localize)(0,null,a[0]);case 2:return(0,j.localize)(1,null,a[0],a[1]);case 3:return(0,j.localize)(2,null,a[0],a[1],a[2]);default:return}}const R=(0,j.localize)(3,null),S=(0,j.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return y.isTripleEq?"===":"==";case 4:return y.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return y.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return y.lexeme;case 18:return y.lexeme;case 19:return y.lexeme;case 20:return"EOF";default:throw(0,D.$8)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const v=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:v})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const v=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:v})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const v=this.d,d=this.c.substring(this.d,this.e),p={type:19,offset:this.d,lexeme:d};this.g.push({offset:v,lexeme:d,additionalInfo:y}),this.f.push(p)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const v=this.c.substring(this.d,this.e),d=u.b.get(v);d?this.k(d):this.f.push({type:17,lexeme:v,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,v=!1,d=!1;for(;;){if(y>=this.c.length){this.e=y,this.l(S);return}const w=this.c.charCodeAt(y);if(v)v=!1;else if(w===47&&!d){y++;break}else w===91?d=!0:w===92?v=!0:w===93&&(d=!1);y++}for(;y<this.c.length&&u.a.has(this.c.charCodeAt(y));)y++;this.e=y;const p=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$dj=u}),define(ne[113],re([0,1,79,54,15,16,35,17,11]),function(J,e,D,j,k,A,R,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rm=e.$Qm=void 0,e.$Sm=y,e.$Tm=v,e.$Qm=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,A.$nc)(k.$Cg.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,A.$kc)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,S.$Vg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:k.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,S.$Vg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const p=(0,D.$Pm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$kc)(this.userDataPath,"logs",p)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.$Vg)(u.URI.file((0,A.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.$Vg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.$Vg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.$Vg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const p=R.env.VSCODE_PORTABLE;return p?u.URI.file((0,A.$kc)(p,"argv.json")):(0,S.$Vg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,A.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const p=this.args["builtin-extensions-dir"];return p?(0,A.$lc)(p):(0,A.$ic)((0,A.$kc)(k.$Cg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const p=this.args["extensions-download-dir"];return p?u.URI.file((0,A.$lc)(p)):u.URI.file((0,A.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const p=this.args["extensions-dir"];if(p)return(0,A.$lc)(p);const w=R.env.VSCODE_EXTENSIONS;if(w)return w;const O=R.env.VSCODE_PORTABLE;return O?(0,A.$kc)(O,"extensions"):(0,S.$Vg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const p=this.args.extensionDevelopmentPath;if(Array.isArray(p))return p.map(w=>/^[^:/?#]+?:\/\//.test(w)?u.URI.parse(w):u.URI.file((0,A.$ic)(w)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(p=>p==="ui"||p==="workspace"||p==="web"?p:"workspace")}get extensionTestsLocationURI(){const p=this.args.extensionTestsPath;if(p)return/^[^:/?#]+?:\/\//.test(p)?u.URI.parse(p):u.URI.file((0,A.$ic)(p))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const p=this.args["disable-extension"];if(p){if(typeof p=="string")return[p];if(Array.isArray(p)&&p.length>0)return p}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!R.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(p=>!e.$Qm.test(p))}get extensionLogLevel(){const p=[];for(const w of this.args.log||[]){const O=e.$Qm.exec(w);O&&O[1]&&O[2]&&p.push([O[1],O[2]])}return p.length?p:void 0}get serviceMachineIdResource(){return(0,S.$Vg)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const p=R.env.VSCODE_PORTABLE;return p?u.URI.file((0,A.$kc)(p,"policy.json")):(0,S.$Vg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(p){this.args.continueOn=p}get args(){return this.a}constructor(p,w,O){this.a=p,this.b=w,this.c=O,this.editSessionId=this.args.editSessionId}}e.$Rm=a,$e([j.$Mh],a.prototype,"appRoot",null),$e([j.$Mh],a.prototype,"userHome",null),$e([j.$Mh],a.prototype,"userDataPath",null),$e([j.$Mh],a.prototype,"appSettingsHome",null),$e([j.$Mh],a.prototype,"tmpDir",null),$e([j.$Mh],a.prototype,"cacheHome",null),$e([j.$Mh],a.prototype,"stateResource",null),$e([j.$Mh],a.prototype,"userRoamingDataHome",null),$e([j.$Mh],a.prototype,"userDataSyncHome",null),$e([j.$Mh],a.prototype,"sync",null),$e([j.$Mh],a.prototype,"machineSettingsResource",null),$e([j.$Mh],a.prototype,"workspaceStorageHome",null),$e([j.$Mh],a.prototype,"localHistoryHome",null),$e([j.$Mh],a.prototype,"keyboardLayoutResource",null),$e([j.$Mh],a.prototype,"argvResource",null),$e([j.$Mh],a.prototype,"isExtensionDevelopment",null),$e([j.$Mh],a.prototype,"untitledWorkspacesHome",null),$e([j.$Mh],a.prototype,"builtinExtensionsPath",null),$e([j.$Mh],a.prototype,"extensionsPath",null),$e([j.$Mh],a.prototype,"extensionDevelopmentLocationURI",null),$e([j.$Mh],a.prototype,"extensionDevelopmentKind",null),$e([j.$Mh],a.prototype,"extensionTestsLocationURI",null),$e([j.$Mh],a.prototype,"debugExtensionHost",null),$e([j.$Mh],a.prototype,"logLevel",null),$e([j.$Mh],a.prototype,"extensionLogLevel",null),$e([j.$Mh],a.prototype,"serviceMachineIdResource",null),$e([j.$Mh],a.prototype,"disableTelemetry",null),$e([j.$Mh],a.prototype,"disableWorkspaceTrust",null),$e([j.$Mh],a.prototype,"useInMemorySecretStorage",null),$e([j.$Mh],a.prototype,"policyFile",null);function y(d,p){return v(d["inspect-extensions"],d["inspect-brk-extensions"],5870,p,d.debugId,d.extensionEnvironment)}function v(d,p,w,O,m,c){const $=Number(p||d)||(O?null:w),h=$?!!p:!1;let g;if(c)try{g=JSON.parse(c)}catch{}return{port:$,break:h,debugId:m,env:g}}}),function(){"use strict";function J(e,D,j){function k(R,S){const u=A(R,S),a=[u];return e.isAbsolute(u)||a.unshift(j),e.resolve(...a)}function A(R,S){process.env.VSCODE_DEV&&(S="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,S);const y=R["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(v,"AppData","Roaming")}break;case"darwin":a=e.join(D.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,S)}return{getUserDataPath:k}}if(typeof define=="function")define(ne[114],re([170,33,35]),function(e,D,j){return J(e,D,j.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=J(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[115],re([0,1,33,113,114]),function(J,e,D,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=void 0,e.$Vm=R,e.$Wm=S;class A extends j.$Rm{constructor(a,y){super(a,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,k.getUserDataPath)(a,y.nameShort)},y)}}e.$Um=A;function R(u,a){return(0,j.$Tm)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,a,u.extensionEnvironment)}function S(u,a){return(0,j.$Tm)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,a,u.extensionEnvironment)}}),define(ne[116],re([0,1,3,97]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=k;function k(R,S,u,a){try{A(R,S,u,a)}catch(y){R.error(y?.message??y)}return S}function A(R,S,u,a){const y=(v,d,p)=>{const w=v[d];if((0,D.$Vf)(w)){const O=w,m=O.length;if(m>1&&O[0]==="%"&&O[m-1]==="%"){const c=O.substr(1,m-2);let b=u[c];b===void 0&&a&&(b=a[c]);const $=typeof b=="string"?b:b?.message,h=a?.[c],g=typeof h=="string"?h:h?.message;if(!$){g||R.warn(`[${S.name}]: ${(0,j.localize)(0,null,c)}`);return}if(p&&(d==="title"||d==="category")&&g&&g!==$){const i={value:$,original:g};v[d]=i}else v[d]=$}}else if((0,D.$Xf)(w))for(const O in w)w.hasOwnProperty(O)&&(O==="commands"?y(w,O,!0):y(w,O,p));else if(Array.isArray(w))for(let O=0;O<w.length;O++)y(w,O,p)};for(const v in S)S.hasOwnProperty(v)&&y(S,v)}}),define(ne[117],re([0,1,49,100]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=k;function k(A){return(0,D.$8p)(A,"extension/package.json").then(R=>{try{return JSON.parse(R.toString("utf8"))}catch{throw new Error((0,j.localize)(0,null))}})}}),define(ne[50],re([0,1,17,55,101,44]),function(J,e,D,j,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=u,e.$tp=a,e.$up=y,e.$vp=v,e.$wp=d,e.$xp=p,e.$yp=w;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function u(c){return c=c.trim(),c==="*"||R.test(c)}function a(c){if(!u(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const b=c.match(R);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}function y(c){if(!c)return null;const b=c.majorBase,$=c.majorMustEqual,h=c.minorBase;let g=c.minorMustEqual;const i=c.patchBase;let r=c.patchMustEqual;c.hasCaret&&(b===0||(g=!1),r=!1);let t=0;if(c.preRelease){const n=S.exec(c.preRelease);if(n){const[,s,o,l]=n;t=Date.UTC(Number(s),Number(o)-1,Number(l))}}return{majorBase:b,majorMustEqual:$,minorBase:h,minorMustEqual:g,patchBase:i,patchMustEqual:r,isMinimum:c.hasGreaterEquals,notBefore:t}}function v(c,b,$){let h;typeof c=="string"?h=y(a(c)):h=c;let g;b instanceof Date?g=b.getTime():typeof b=="string"&&(g=new Date(b).getTime());let i;if(typeof $=="string"?i=y(a($)):i=$,!h||!i)return!1;const r=h.majorBase,t=h.minorBase,n=h.patchBase;let s=i.majorBase,o=i.minorBase,l=i.patchBase;const P=i.notBefore;let I=i.majorMustEqual,L=i.minorMustEqual,z=i.patchMustEqual;return i.isMinimum?r>s?!0:r<s?!1:t>o?!0:t<o||g&&g<P?!1:n>=l:(r===1&&s===0&&(!I||!L||!z)&&(s=1,o=0,l=0,I=!0,L=!1,z=!1),r<s?!1:r>s?!I:t<o?!1:t>o?!L:n<l?!1:n>l?!z:!(g&&g<P))}function d(c,b,$,h,g){const i=[];if(typeof h.publisher<"u"&&typeof h.publisher!="string")return i.push([j.default.Error,k.localize(0,null)]),i;if(typeof h.name!="string")return i.push([j.default.Error,k.localize(1,null,"name")]),i;if(typeof h.version!="string")return i.push([j.default.Error,k.localize(2,null,"version")]),i;if(!h.engines)return i.push([j.default.Error,k.localize(3,null,"engines")]),i;if(typeof h.engines.vscode!="string")return i.push([j.default.Error,k.localize(4,null,"engines.vscode")]),i;if(typeof h.extensionDependencies<"u"&&!m(h.extensionDependencies))return i.push([j.default.Error,k.localize(5,null,"extensionDependencies")]),i;if(typeof h.activationEvents<"u"){if(!m(h.activationEvents))return i.push([j.default.Error,k.localize(6,null,"activationEvents")]),i;if(typeof h.main>"u"&&typeof h.browser>"u")return i.push([j.default.Error,k.localize(7,null,"activationEvents","main","browser")]),i}if(typeof h.extensionKind<"u"&&typeof h.main>"u"&&i.push([j.default.Warning,k.localize(8,null,"extensionKind")]),typeof h.main<"u"){if(typeof h.main!="string")return i.push([j.default.Error,k.localize(9,null,"main")]),i;{const n=(0,D.$Vg)($,h.main);(0,D.$Pg)(n,$)||i.push([j.default.Warning,k.localize(10,null,n.path,$.path)])}}if(typeof h.browser<"u"){if(typeof h.browser!="string")return i.push([j.default.Error,k.localize(11,null,"browser")]),i;{const n=(0,D.$Vg)($,h.browser);(0,D.$Pg)(n,$)||i.push([j.default.Warning,k.localize(12,null,n.path,$.path)])}}if(!A.valid(h.version))return i.push([j.default.Error,k.localize(13,null)]),i;const r=[];if(!p(c,b,h,g,r))for(const n of r)i.push([j.default.Error,n]);return i}function p(c,b,$,h,g){return h||typeof $.main>"u"&&typeof $.browser>"u"?!0:O(c,b,$.engines.vscode,g)}function w(c,b,$){return c==="*"||O(b,$,c)}function O(c,b,$,h=[]){const g=y(a($));if(!g)return h.push(k.localize(14,null,$)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return h.push(k.localize(15,null,$)),!1}else if(!g.majorMustEqual)return h.push(k.localize(16,null,$)),!1;return v(c,b,g)?!0:(h.push(k.localize(17,null,c,$)),!1)}function m(c){if(!Array.isArray(c))return!1;for(let b=0,$=c.length;b<$;b++)if(typeof c[b]!="string")return!1;return!0}}),define(ne[118],re([0,1,14,28]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=k;async function k(A,R,S){let u=S&&S.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const y=(await R.readFile(A.serviceMachineIdResource)).value.toString();u=(0,j.$Dg)(y)?y:null}catch{u=null}if(!u){u=(0,j.$Eg)();try{await R.writeFile(A.serviceMachineIdResource,D.$ue.fromString(u))}catch{}}return S?.store("storage.serviceMachineId",u,-1,1),u}}),define(ne[51],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=void 0;class D{constructor(k,A=[],R=!1){this.ctor=k,this.staticArguments=A,this.supportsDelayedInstantiation=R}}e.$fi=D}),define(ne[119],re([0,1,51]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$gs=A,e.$hs=R;const j=[];var k;(function(S){S[S.Eager=0]="Eager",S[S.Delayed=1]="Delayed"})(k||(e.InstantiationType=k={}));function A(S,u,a){u instanceof D.$fi||(u=new D.$fi(u,[],!!a)),j.push([S,u])}function R(){return j}}),define(ne[120],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=void 0;class D{constructor(A,R){this.key=A,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$Wq=D;class j{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const R of this.a.values())R.outgoing.size===0&&A.push(R);return A}insertEdge(A,R){const S=this.lookupOrInsertNode(A),u=this.lookupOrInsertNode(R);S.outgoing.set(u.key,u),u.incoming.set(S.key,S)}removeNode(A){const R=this.b(A);this.a.delete(R);for(const S of this.a.values())S.outgoing.delete(R),S.incoming.delete(R)}lookupOrInsertNode(A){const R=this.b(A);let S=this.a.get(R);return S||(S=new D(R,A),this.a.set(R,S)),S}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[R,S]of this.a)A.push(`${R}
	(-> incoming)[${[...S.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...S.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,R]of this.a){const S=new Set([A]),u=this.c(R,S);if(u)return u}}c(A,R){for(const[S,u]of A.outgoing){if(R.has(S))return[...R,S].join(" -> ");R.add(S);const a=this.c(u,R);if(a)return a;R.delete(S)}}}e.$Xq=j}),define(ne[29],re([0,1,3,11,10]),function(J,e,D,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Oi=void 0,e.$Pi=A,e.$Qi=R,e.$Ri=u,e.$Si=a,e.$Ti=y,e.$Ui=v,e.$Vi=d,e.$Wi=w,e.$Xi=O,e.$Yi=m,e.$Oi=(0,k.$ii)("configurationService");function A(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof j.URI)}function R(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof j.URI)}var S;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(S||(e.ConfigurationTarget=S={}));function u(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function a(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}function y(c,b){const $=Object.create(null);for(const h in c)v($,h,c[h],b);return $}function v(c,b,$,h){const g=b.split("."),i=g.pop();let r=c;for(let t=0;t<g.length;t++){const n=g[t];let s=r[n];switch(typeof s){case"undefined":s=r[n]=Object.create(null);break;case"object":break;default:h(`Ignoring ${b} as ${g.slice(0,t+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[i]=$}catch{h(`Ignoring ${b} as ${g.join(".")} is ${JSON.stringify(r)}`)}else h(`Ignoring ${b} as ${g.join(".")} is ${JSON.stringify(r)}`)}function d(c,b){const $=b.split(".");p(c,$)}function p(c,b){const $=b.shift();if(b.length===0){delete c[$];return}if(Object.keys(c).indexOf($)!==-1){const h=c[$];typeof h=="object"&&!Array.isArray(h)&&(p(h,b),Object.keys(h).length===0&&delete c[$])}}function w(c,b,$){function h(r,t){let n=r;for(const s of t){if(typeof n!="object"||n===null)return;n=n[s]}return n}const g=b.split("."),i=h(c,g);return typeof i>"u"?$:i}function O(c,b,$){Object.keys(b).forEach(h=>{h!=="__proto__"&&(h in c?D.$Xf(c[h])&&D.$Xf(b[h])?O(c[h],b[h],$):$&&(c[h]=b[h]):c[h]=b[h])})}function m(c){return c.replace(/[\[\]]/g,"")}}),define(ne[121],re([0,1,12,30,112,10,92,8]),function(J,e,D,j,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$gj=e.$fj=e.ContextKeyExprType=void 0,e.$ej=a,e.$hj=r,e.$ij=t,e.$Bj=Q;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",D.$j),u.set("isLinux",D.$k),u.set("isWindows",D.$i),u.set("isWeb",D.$o),u.set("isMacNative",D.$j&&!D.$o),u.set("isEdge",D.$H),u.set("isFirefox",D.$F),u.set("isChrome",D.$E),u.set("isSafari",D.$G);function a(F,f){if(u.get(F)!==void 0)throw(0,S.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(F,f)}const y=Object.prototype.hasOwnProperty;var v;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(v||(e.ContextKeyExprType=v={}));const d={regexParsingWithErrorRecovery:!0},p=(0,R.localize)(0,null),w=(0,R.localize)(1,null),O=(0,R.localize)(2,null),m=(0,R.localize)(3,null),c=(0,R.localize)(4,null),b=(0,R.localize)(5,null),$=(0,R.localize)(6,null),h=(0,R.localize)(7,null);class g{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(f=d){this.k=f,this.d=new k.$dj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(f){if(f===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:w});return}this.f=this.d.reset(f).scan(),this.g=0,this.h=[];try{const E=this.l();if(!this.E()){const N=this.D(),C=N.type===17?b:void 0;throw this.h.push({message:c,offset:N.offset,lexeme:k.$dj.getLexeme(N),additionalInfo:C}),g.c}return E}catch(E){if(E!==g.c)throw E;return}}l(){return this.m()}m(){const f=[this.o()];for(;this.y(16);){const E=this.o();f.push(E)}return f.length===1?f[0]:i.or(...f)}o(){const f=[this.s()];for(;this.y(15);){const E=this.s();f.push(E)}return f.length===1?f[0]:i.and(...f)}s(){if(this.y(2)){const f=this.D();switch(f.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const E=this.l();return this.A(1,m),E?.negate()}case 17:return this.z(),U.create(f.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",f)}}return this.t()}t(){const f=this.D();switch(f.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const E=this.l();return this.A(1,m),E}case 17:{const E=f.lexeme;if(this.z(),this.y(9)){const C=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),C.type!==10)throw this.B("REGEX",C);const W=C.lexeme,G=W.lastIndexOf("/"),te=G===W.length-1?void 0:this.w(W.substring(G+1));let ae;try{ae=new RegExp(W.substring(1,G),te)}catch{throw this.B("REGEX",C)}return he.create(E,ae)}switch(C.type){case 10:case 19:{const W=[C.lexeme];this.z();let G=this.D(),te=0;for(let fe=0;fe<C.lexeme.length;fe++)C.lexeme.charCodeAt(fe)===40?te++:C.lexeme.charCodeAt(fe)===41&&te--;for(;!this.E()&&G.type!==15&&G.type!==16;){switch(G.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let fe=0;fe<G.lexeme.length;fe++)G.lexeme.charCodeAt(fe)===40?te++:C.lexeme.charCodeAt(fe)===41&&te--}if(te<0)break;W.push(k.$dj.getLexeme(G)),this.z(),G=this.D()}const ae=W.join(""),le=ae.lastIndexOf("/"),pe=le===ae.length-1?void 0:this.w(ae.substring(le+1));let ye;try{ye=new RegExp(ae.substring(1,le),pe)}catch{throw this.B("REGEX",C)}return i.regex(E,ye)}case 18:{const W=C.lexeme;this.z();let G=null;if(!(0,j.$Ue)(W)){const te=W.indexOf("/"),ae=W.lastIndexOf("/");if(te!==ae&&te>=0){const le=W.slice(te+1,ae),pe=W[ae+1]==="i"?"i":"";try{G=new RegExp(le,pe)}catch{throw this.B("REGEX",C)}}}if(G===null)throw this.B("REGEX",C);return he.create(E,G)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,O);const C=this.u();return i.notIn(E,C)}switch(this.D().type){case 3:{this.z();const C=this.u();if(this.x().type===18)return i.equals(E,C);switch(C){case"true":return i.has(E);case"false":return i.not(E);default:return i.equals(E,C)}}case 4:{this.z();const C=this.u();if(this.x().type===18)return i.notEquals(E,C);switch(C){case"true":return i.not(E);case"false":return i.has(E);default:return i.notEquals(E,C)}}case 5:return this.z(),ie.create(E,this.u());case 6:return this.z(),ue.create(E,this.u());case 7:return this.z(),X.create(E,this.u());case 8:return this.z(),se.create(E,this.u());case 13:return this.z(),i.in(E,this.u());default:return i.has(E)}}case 20:throw this.h.push({message:$,offset:f.offset,lexeme:"",additionalInfo:h}),g.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const f=this.D();switch(f.type){case 17:case 18:return this.z(),f.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(f){return f.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(f){return this.C(f)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(f,E){if(this.C(f))return this.z();throw this.B(E,this.D())}B(f,E,N){const C=(0,R.localize)(8,null,f,k.$dj.getLexeme(E)),W=E.offset,G=k.$dj.getLexeme(E);return this.h.push({message:C,offset:W,lexeme:G,additionalInfo:N}),g.c}C(f){return this.D().type===f}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$fj=g;class i{static false(){return s.INSTANCE}static true(){return o.INSTANCE}static has(f){return l.create(f)}static equals(f,E){return P.create(f,E)}static notEquals(f,E){return z.create(f,E)}static regex(f,E){return he.create(f,E)}static in(f,E){return I.create(f,E)}static notIn(f,E){return L.create(f,E)}static not(f){return U.create(f)}static and(...f){return Z.create(f,null,!0)}static or(...f){return q.create(f,null,!0)}static greater(f,E){return X.create(f,E)}static greaterEquals(f,E){return se.create(f,E)}static smaller(f,E){return ie.create(f,E)}static smallerEquals(f,E){return ue.create(f,E)}static{this.c=new g({regexParsingWithErrorRecovery:!1})}static deserialize(f){return f==null?void 0:this.c.parse(f)}}e.$gj=i;function r(F){const f=new g({regexParsingWithErrorRecovery:!1});return F.map(E=>(f.parse(E),f.lexingErrors.length>0?f.lexingErrors.map(N=>({errorMessage:N.additionalInfo?(0,R.localize)(9,null,N.additionalInfo):(0,R.localize)(10,null),offset:N.offset,length:N.lexeme.length})):f.parsingErrors.length>0?f.parsingErrors.map(N=>({errorMessage:N.additionalInfo?`${N.message}. ${N.additionalInfo}`:N.message,offset:N.offset,length:N.lexeme.length})):[]))}function t(F,f){const E=F?F.substituteConstants():void 0,N=f?f.substituteConstants():void 0;return!E&&!N?!0:!E||!N?!1:E.equals(N)}function n(F,f){return F.cmp(f)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}substituteConstants(){return this}evaluate(f){return!1}serialize(){return"false"}keys(){return[]}map(f){return this}negate(){return o.INSTANCE}}e.$jj=s;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}substituteConstants(){return this}evaluate(f){return!0}serialize(){return"true"}keys(){return[]}map(f){return this}negate(){return s.INSTANCE}}e.$kj=o;class l{static create(f,E=null){const N=u.get(f);return typeof N=="boolean"?N?o.INSTANCE:s.INSTANCE:new l(f,E)}constructor(f,E){this.key=f,this.c=E,this.type=2}cmp(f){return f.type!==this.type?this.type-f.type:x(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}substituteConstants(){const f=u.get(this.key);return typeof f=="boolean"?f?o.INSTANCE:s.INSTANCE:this}evaluate(f){return!!f.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(f){return f.mapDefined(this.key)}negate(){return this.c||(this.c=U.create(this.key,this)),this.c}}e.$lj=l;class P{static create(f,E,N=null){if(typeof E=="boolean")return E?l.create(f,N):U.create(f,N);const C=u.get(f);return typeof C=="boolean"?E===(C?"true":"false")?o.INSTANCE:s.INSTANCE:new P(f,E,N)}constructor(f,E,N){this.c=f,this.d=E,this.f=N,this.type=4}cmp(f){return f.type!==this.type?this.type-f.type:Y(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){const f=u.get(this.c);if(typeof f=="boolean"){const E=f?"true":"false";return this.d===E?o.INSTANCE:s.INSTANCE}return this}evaluate(f){return f.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(f){return f.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$mj=P;class I{static create(f,E){return new I(f,E)}constructor(f,E){this.d=f,this.f=E,this.type=10,this.c=null}cmp(f){return f.type!==this.type?this.type-f.type:Y(this.d,this.f,f.d,f.f)}equals(f){return f.type===this.type?this.d===f.d&&this.f===f.f:!1}substituteConstants(){return this}evaluate(f){const E=f.getValue(this.f),N=f.getValue(this.d);return Array.isArray(E)?E.includes(N):typeof N=="string"&&typeof E=="object"&&E!==null?y.call(E,N):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(f){return f.mapIn(this.d,this.f)}negate(){return this.c||(this.c=L.create(this.d,this.f)),this.c}}e.$nj=I;class L{static create(f,E){return new L(f,E)}constructor(f,E){this.d=f,this.f=E,this.type=11,this.c=I.create(f,E)}cmp(f){return f.type!==this.type?this.type-f.type:this.c.cmp(f.c)}equals(f){return f.type===this.type?this.c.equals(f.c):!1}substituteConstants(){return this}evaluate(f){return!this.c.evaluate(f)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(f){return f.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$oj=L;class z{static create(f,E,N=null){if(typeof E=="boolean")return E?U.create(f,N):l.create(f,N);const C=u.get(f);return typeof C=="boolean"?E===(C?"true":"false")?s.INSTANCE:o.INSTANCE:new z(f,E,N)}constructor(f,E,N){this.c=f,this.d=E,this.f=N,this.type=5}cmp(f){return f.type!==this.type?this.type-f.type:Y(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){const f=u.get(this.c);if(typeof f=="boolean"){const E=f?"true":"false";return this.d===E?s.INSTANCE:o.INSTANCE}return this}evaluate(f){return f.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(f){return f.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$pj=z;class U{static create(f,E=null){const N=u.get(f);return typeof N=="boolean"?N?s.INSTANCE:o.INSTANCE:new U(f,E)}constructor(f,E){this.c=f,this.d=E,this.type=3}cmp(f){return f.type!==this.type?this.type-f.type:x(this.c,f.c)}equals(f){return f.type===this.type?this.c===f.c:!1}substituteConstants(){const f=u.get(this.c);return typeof f=="boolean"?f?s.INSTANCE:o.INSTANCE:this}evaluate(f){return!f.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(f){return f.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$qj=U;function V(F,f){if(typeof F=="string"){const E=parseFloat(F);isNaN(E)||(F=E)}return typeof F=="string"||typeof F=="number"?f(F):s.INSTANCE}class X{static create(f,E,N=null){return V(E,C=>new X(f,C,N))}constructor(f,E,N){this.c=f,this.d=E,this.f=N,this.type=12}cmp(f){return f.type!==this.type?this.type-f.type:Y(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(f){return f.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$rj=X;class se{static create(f,E,N=null){return V(E,C=>new se(f,C,N))}constructor(f,E,N){this.c=f,this.d=E,this.f=N,this.type=13}cmp(f){return f.type!==this.type?this.type-f.type:Y(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(f){return f.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ie.create(this.c,this.d,this)),this.f}}e.$sj=se;class ie{static create(f,E,N=null){return V(E,C=>new ie(f,C,N))}constructor(f,E,N){this.c=f,this.d=E,this.f=N,this.type=14}cmp(f){return f.type!==this.type?this.type-f.type:Y(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(f){return f.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=se.create(this.c,this.d,this)),this.f}}e.$tj=ie;class ue{static create(f,E,N=null){return V(E,C=>new ue(f,C,N))}constructor(f,E,N){this.c=f,this.d=E,this.f=N,this.type=15}cmp(f){return f.type!==this.type?this.type-f.type:Y(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(f){return f.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=X.create(this.c,this.d,this)),this.f}}e.$uj=ue;class he{static create(f,E){return new he(f,E)}constructor(f,E){this.d=f,this.f=E,this.type=7,this.c=null}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.d<f.d)return-1;if(this.d>f.d)return 1;const E=this.f?this.f.source:"",N=f.f?f.f.source:"";return E<N?-1:E>N?1:0}equals(f){if(f.type===this.type){const E=this.f?this.f.source:"",N=f.f?f.f.source:"";return this.d===f.d&&E===N}return!1}substituteConstants(){return this}evaluate(f){const E=f.getValue(this.d);return this.f?this.f.test(E):!1}serialize(){const f=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${f}`}keys(){return[this.d]}map(f){return f.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ce.create(this)),this.c}}e.$vj=he;class ce{static create(f){return new ce(f)}constructor(f){this.c=f,this.type=8}cmp(f){return f.type!==this.type?this.type-f.type:this.c.cmp(f.c)}equals(f){return f.type===this.type?this.c.equals(f.c):!1}substituteConstants(){return this}evaluate(f){return!this.c.evaluate(f)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(f){return new ce(this.c.map(f))}negate(){return this.c}}e.$wj=ce;function B(F){let f=null;for(let E=0,N=F.length;E<N;E++){const C=F[E].substituteConstants();if(F[E]!==C&&f===null){f=[];for(let W=0;W<E;W++)f[W]=F[W]}f!==null&&(f[E]=C)}return f===null?F:f}class Z{static create(f,E,N){return Z.d(f,E,N)}constructor(f,E){this.expr=f,this.c=E,this.type=6}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let E=0,N=this.expr.length;E<N;E++){const C=n(this.expr[E],f.expr[E]);if(C!==0)return C}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let E=0,N=this.expr.length;E<N;E++)if(!this.expr[E].equals(f.expr[E]))return!1;return!0}return!1}substituteConstants(){const f=B(this.expr);return f===this.expr?this:Z.create(f,this.c,!1)}evaluate(f){for(let E=0,N=this.expr.length;E<N;E++)if(!this.expr[E].evaluate(f))return!1;return!0}static d(f,E,N){const C=[];let W=!1;for(const G of f)if(G){if(G.type===1){W=!0;continue}if(G.type===0)return s.INSTANCE;if(G.type===6){C.push(...G.expr);continue}C.push(G)}if(C.length===0&&W)return o.INSTANCE;if(C.length!==0){if(C.length===1)return C[0];C.sort(n);for(let G=1;G<C.length;G++)C[G-1].equals(C[G])&&(C.splice(G,1),G--);if(C.length===1)return C[0];for(;C.length>1;){const G=C[C.length-1];if(G.type!==9)break;C.pop();const te=C.pop(),ae=C.length===0,le=q.create(G.expr.map(pe=>Z.create([pe,te],null,N)),null,ae);le&&(C.push(le),C.sort(n))}if(C.length===1)return C[0];if(N){for(let G=0;G<C.length;G++)for(let te=G+1;te<C.length;te++)if(C[G].negate().equals(C[te]))return s.INSTANCE;if(C.length===1)return C[0]}return new Z(C,E)}}serialize(){return this.expr.map(f=>f.serialize()).join(" && ")}keys(){const f=[];for(const E of this.expr)f.push(...E.keys());return f}map(f){return new Z(this.expr.map(E=>E.map(f)),null)}negate(){if(!this.c){const f=[];for(const E of this.expr)f.push(E.negate());this.c=q.create(f,this,!0)}return this.c}}e.$xj=Z;class q{static create(f,E,N){return q.d(f,E,N)}constructor(f,E){this.expr=f,this.c=E,this.type=9}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let E=0,N=this.expr.length;E<N;E++){const C=n(this.expr[E],f.expr[E]);if(C!==0)return C}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let E=0,N=this.expr.length;E<N;E++)if(!this.expr[E].equals(f.expr[E]))return!1;return!0}return!1}substituteConstants(){const f=B(this.expr);return f===this.expr?this:q.create(f,this.c,!1)}evaluate(f){for(let E=0,N=this.expr.length;E<N;E++)if(this.expr[E].evaluate(f))return!0;return!1}static d(f,E,N){let C=[],W=!1;if(f){for(let G=0,te=f.length;G<te;G++){const ae=f[G];if(ae){if(ae.type===0){W=!0;continue}if(ae.type===1)return o.INSTANCE;if(ae.type===9){C=C.concat(ae.expr);continue}C.push(ae)}}if(C.length===0&&W)return s.INSTANCE;C.sort(n)}if(C.length!==0){if(C.length===1)return C[0];for(let G=1;G<C.length;G++)C[G-1].equals(C[G])&&(C.splice(G,1),G--);if(C.length===1)return C[0];if(N){for(let G=0;G<C.length;G++)for(let te=G+1;te<C.length;te++)if(C[G].negate().equals(C[te]))return o.INSTANCE;if(C.length===1)return C[0]}return new q(C,E)}}serialize(){return this.expr.map(f=>f.serialize()).join(" || ")}keys(){const f=[];for(const E of this.expr)f.push(...E.keys());return f}map(f){return new q(this.expr.map(E=>E.map(f)),null)}negate(){if(!this.c){const f=[];for(const E of this.expr)f.push(E.negate());for(;f.length>1;){const E=f.shift(),N=f.shift(),C=[];for(const W of M(E))for(const G of M(N))C.push(Z.create([W,G],null,!1));f.unshift(q.create(C,null,!1))}this.c=q.create(f,this,!0)}return this.c}}e.$yj=q;class T extends l{static{this.d=[]}static all(){return T.d.values()}constructor(f,E,N){super(f,null),this.f=E,typeof N=="object"?T.d.push({...N,key:f}):N!==!0&&T.d.push({key:f,description:N,type:E!=null?typeof E:void 0})}bindTo(f){return f.createKey(this.key,this.f)}getValue(f){return f.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(f){return P.create(this.key,f)}notEqualsTo(f){return z.create(this.key,f)}}e.$zj=T,e.$Aj=(0,A.$ii)("contextKeyService");function x(F,f){return F<f?-1:F>f?1:0}function Y(F,f,E,N){return F<E?-1:F>E?1:f<N?-1:f>N?1:0}function Q(F,f){if(F.type===0||f.type===1)return!0;if(F.type===9)return f.type===9?_(F.expr,f.expr):!1;if(f.type===9){for(const E of f.expr)if(Q(F,E))return!0;return!1}if(F.type===6){if(f.type===6)return _(f.expr,F.expr);for(const E of F.expr)if(Q(E,f))return!0;return!1}return F.equals(f)}function _(F,f){let E=0,N=0;for(;E<F.length&&N<f.length;){const C=F[E].cmp(f[N]);if(C<0)return!1;C===0&&E++,N++}return E===F.length}function M(F){return F.type===9?F.expr:[F]}}),define(ne[61],re([0,1,10]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=void 0,e.$wo=(0,D.$ii)("downloadService")}),define(ne[18],re([0,1,10]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$pi=void 0,e.$pi=(0,D.$ii)("environmentService"),e.$qi=(0,D.$ji)(e.$pi)}),define(ne[21],re([0,1,95,10]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.ExtensionGalleryErrorCode=e.$So=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Ro=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=void 0,e.$Lo=k,e.$Mo=A,e.$No=R,e.$Oo=S,e.$Po=u,e.$Qo=a,e.$Fo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Go=new RegExp(e.$Fo),e.$Ho="__web_extension",e.$Io="skipWalkthrough",e.$Jo="extensionsSync",e.$Ko="dependecyOrPackExtensionInstall";function k($){switch($){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function A($){switch($){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function R($,h){switch($){case 3:return h==="x64"?"win32-x64":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function S($,h){return h==="web"&&!$.includes("web")}function u($,h,g){return S(h,g)?!1:$==="undefined"||$==="universal"?!0:$==="unknown"?!1:$===g}function a($){return $&&typeof $=="object"&&typeof $.id=="string"&&(!$.uuid||typeof $.uuid=="string")}var y;(function($){$[$.NoneOrRelevance=0]="NoneOrRelevance",$[$.LastUpdatedDate=1]="LastUpdatedDate",$[$.Title=2]="Title",$[$.PublisherName=3]="PublisherName",$[$.InstallCount=4]="InstallCount",$[$.PublishedDate=10]="PublishedDate",$[$.AverageRating=6]="AverageRating",$[$.WeightedRating=12]="WeightedRating"})(y||(e.SortBy=y={}));var v;(function($){$[$.Default=0]="Default",$[$.Ascending=1]="Ascending",$[$.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var d;(function($){$.Install="install",$.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var p;(function($){$[$.None=1]="None",$[$.Install=2]="Install",$[$.Update=3]="Update",$[$.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.$Ro=(0,j.$ii)("extensionGalleryService");var w;(function($){$.Unsupported="Unsupported",$.Deprecated="Deprecated",$.Malicious="Malicious",$.Incompatible="Incompatible",$.IncompatibleTargetPlatform="IncompatibleTargetPlatform",$.ReleaseVersionNotFound="ReleaseVersionNotFound",$.Invalid="Invalid",$.Download="Download",$.DownloadSignature="DownloadSignature",$.UpdateMetadata="UpdateMetadata",$.Extract="Extract",$.Scanning="Scanning",$.Delete="Delete",$.Rename="Rename",$.CorruptZip="CorruptZip",$.IncompleteZip="IncompleteZip",$.Signature="Signature",$.NotAllowed="NotAllowed",$.Gallery="Gallery",$.Unknown="Unknown",$.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));var O;(function($){$.UnknownError="UnknownError",$.PackageIsInvalidZip="PackageIsInvalidZip",$.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(O||(e.ExtensionSignaturetErrorCode=O={}));class m extends Error{constructor(h,g){super(h),this.code=g,this.name=g}}e.$So=m;var c;(function($){$.Timeout="Timeout",$.Cancelled="Cancelled",$.Failed="Failed"})(c||(e.ExtensionGalleryErrorCode=c={}));class b extends Error{constructor(h,g){super(h),this.code=g,this.name=g}}e.$To=b,e.$Uo=(0,j.$ii)("extensionManagementService"),e.$Vo="extensionsIdentifiers/disabled",e.$Wo="extensionsIdentifiers/enabled",e.$Xo=(0,j.$ii)("IGlobalExtensionEnablementService"),e.$Yo=(0,j.$ii)("IExtensionTipsService"),e.$Zo=(0,D.localize2)(0,"Extensions"),e.$1o=(0,D.localize2)(1,"Preferences")}),define(ne[62],re([0,1,14,8,103,13]),function(J,e,D,j,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=R;async function R(y,v,d,p,w,O){let m;try{await S(y,v,d,p,w,O)}catch(c){m=c}finally{m&&w.errorTransformer&&(m=w.errorTransformer(m)),typeof m<"u"&&d.error(m),d.end()}}async function S(y,v,d,p,w,O){u(O);const m=await y.open(v,{create:!1});try{u(O);let c=0,b=0,$=w&&typeof w.length=="number"?w.length:void 0,h=D.$ue.alloc(Math.min(w.bufferSize,typeof $=="number"?$:w.bufferSize)),g=w&&typeof w.position=="number"?w.position:0,i=0;do b=await y.read(m,g,h.buffer,i,h.byteLength-i),g+=b,i+=b,c+=b,typeof $=="number"&&($-=b),i===h.byteLength&&(await d.write(p(h)),h=D.$ue.alloc(Math.min(w.bufferSize,typeof $=="number"?$:w.bufferSize)),i=0);while(b>0&&(typeof $!="number"||$>0)&&u(O)&&a(c,w));if(i>0){let r=i;typeof $=="number"&&(r=Math.min(i,$)),d.write(p(h.slice(0,r)))}}catch(c){throw(0,A.$3k)(c)}finally{await y.close(m)}}function u(y){if(y.isCancellationRequested)throw(0,j.$6)();return!0}function a(y,v){if(typeof v?.limits?.size=="number"&&y>v.limits.size)throw(0,A.$2k)((0,k.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ne[122],re([0,1,60,2,52,5,11]),function(J,e,D,j,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0;class S extends j.$Uc{constructor(){super(),this.a=this.B(new A.$7d),this.onDidChangeFile=this.a.event,this.b=this.B(new A.$7d),this.onDidLogMessage=this.b.event,this.c=this.B(new A.$7d),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new j.$4c),this.m=5007,this.B(this.f(a=>this.n(a)))}n(a){this.r(a)&&this.t(a)}r(a){return(0,k.$vq)(a)}async watch(a){this.h.clear(),this.g.clear();for(const y of a)this.r(y)?this.h.set(y.correlationId,y):this.g.add(y);for(const[y]of this.j)this.h.has(y)||this.j.deleteAndDispose(y);return this.s()}s(){return this.D([...this.g,...Array.from(this.h.values()).filter(a=>!this.j.has(a.correlationId))])}t(a){if(this.j.has(a.correlationId))return;const y=new j.$Tc;this.j.set(a.correlationId,y),this.w(a,y),this.s()}u(a){this.j.deleteAndDispose(a.correlationId),this.s()}w(a,y){const v=R.URI.file(a.path),d=this;let p=!1;const w=(O,m)=>{if(y.isDisposed)return;const c=this.y(O),b=this.y(m),$=p;if(p=c,!c&&(b||$)){this.F(`fs.watchFile() detected ${a.path} exists again, resuming watcher (correlationId: ${a.correlationId})`);const h={resource:v,type:1,cId:a.correlationId};d.a.fire([h]),this.z(h,a),this.u(a)}};this.F(`starting fs.watchFile() on ${a.path} (correlationId: ${a.correlationId})`);try{(0,D.watchFile)(a.path,{persistent:!1,interval:this.m},w)}catch(O){this.G(`fs.watchFile() failed with error ${O} on path ${a.path} (correlationId: ${a.correlationId})`)}y.add((0,j.$Sc)(()=>{this.F(`stopping fs.watchFile() on ${a.path} (correlationId: ${a.correlationId})`);try{(0,D.unwatchFile)(a.path,w)}catch(O){this.G(`fs.unwatchFile() failed with error ${O} on path ${a.path} (correlationId: ${a.correlationId})`)}}))}y(a){return a.ctimeMs===0&&a.ino===0}async stop(){this.j.clearAndDisposeAll()}z(a,y){const v=` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`;this.F(typeof y.correlationId=="number"?`${v} (correlationId: ${y.correlationId})`:v)}C(a){return`${a.path} (excludes: ${a.excludes.length>0?a.excludes:"<none>"}, includes: ${a.includes&&a.includes.length>0?JSON.stringify(a.includes):"<all>"}, correlationId: ${typeof a.correlationId=="number"?a.correlationId:"<none>"})`}}e.$Mq=S}),define(ne[123],re([0,1,5,171,122,12,172,124]),function(J,e,D,j,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;class u extends k.$Mq{constructor(){super(...arguments),this.onDidError=D.Event.None,this.H=new Set,this.I=!1}async D(y){y=this.O(y);const v=[],d=new Set(Array.from(this.H));for(const p of y){const w=this.L(p);w&&(0,j.$gk)(w.request.excludes,p.excludes)&&(0,j.$gk)(w.request.includes,p.includes)?d.delete(w):v.push(p)}v.length&&this.F(`Request to start watching: ${v.map(p=>this.C(p)).join(",")}`),d.size&&this.F(`Request to stop watching: ${Array.from(d).map(p=>this.C(p.request)).join(",")}`);for(const p of d)this.N(p);for(const p of v)this.M(p)}L(y){for(const v of this.H)if(typeof y.correlationId=="number"||typeof v.request.correlationId=="number"){if(v.request.correlationId===y.correlationId)return v}else if((0,S.$hg)(v.request.path,y.path,!A.$k))return v}M(y){const v=new R.$Rq(y,p=>this.a.fire(p),()=>this.c.fire(y),p=>this.b.fire(p),this.I),d={request:y,instance:v};this.H.add(d)}async stop(){await super.stop();for(const y of this.H)this.N(y)}N(y){this.F("stopping file watcher",y),this.H.delete(y),y.instance.dispose()}O(y){const v=new Map;for(const d of y){const p=A.$k?d.path:d.path.toLowerCase();let w=v.get(d.correlationId);w||(w=new Map,v.set(d.correlationId,w)),w.has(p)&&this.F(`ignoring a request for watching who's path is already watched: ${this.C(d)}`),w.set(p,d)}return Array.from(v.values()).map(d=>Array.from(d.values())).flat()}async setVerboseLogging(y){this.I=y;for(const v of this.H)v.instance.setVerboseLogging(y)}F(y,v){this.I&&this.b.fire({type:"trace",message:this.R(y,v)})}G(y){this.b.fire({type:"warn",message:this.R(y)})}R(y,v){return v?`[File Watcher (node.js)] ${y} (${this.C(v.request)})`:`[File Watcher (node.js)] ${y}`}}e.$Tq=u}),define(ne[125],re([0,1,52,123]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class k extends D.$yq{constructor(R,S,u){super(R,S,u),this.s()}r(R){return R.add(new j.$Tq)}}e.$Uq=k}),define(ne[126],re([0,1,15,58,88,52]),function(J,e,D,j,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=void 0;class R extends A.$zq{constructor(u,a,y){super(u,a,y),this.s()}r(u){const a=u.add(new k.$Kq(D.$Cg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(a.onDidProcessExit(({code:y,signal:v})=>this.t(`terminated by itself with code ${y}, signal: ${v}`))),j.ProxyChannel.toService((0,j.$2h)(a.getChannel("watcher")))}}e.$Lq=R}),define(ne[63],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=void 0;class D{constructor(...k){this.a=new Map;for(const[A,R]of k)this.set(A,R)}set(k,A){const R=this.a.get(k);return this.a.set(k,A),R}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.$gi=D}),define(ne[127],re([0,1,9,8,2,51,120,10,63,173]),function(J,e,D,j,k,A,R,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Yq=void 0;const y=!1;class v extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class d{constructor(m=new u.$gi,c=!1,b,$=y){this.f=m,this.g=c,this.h=b,this.i=$,this.o=new Set,this.f.set(S.$hi,this),this._globalGraph=$?b?._globalGraph??new R.$Xq(h=>h):void 0}createChild(m){return new d(m,this.g,this,this.i)}invokeFunction(m,...c){const b=w.traceInvocation(this.i,m);let $=!1;try{return m({get:g=>{if($)throw(0,j.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(g,b);if(!i)throw new Error(`[invokeFunction] unknown service '${g}'`);return i}},...c)}finally{$=!0,b.stop()}}createInstance(m,...c){let b,$;return m instanceof A.$fi?(b=w.traceCreation(this.i,m.ctor),$=this.j(m.ctor,m.staticArguments.concat(c),b)):(b=w.traceCreation(this.i,m),$=this.j(m,c,b)),b.stop(),$}j(m,c=[],b){const $=S._util.getServiceDependencies(m).sort((i,r)=>i.index-r.index),h=[];for(const i of $){const r=this.m(i.id,b);r||this.u(`[createInstance] ${m.name} depends on UNKNOWN service ${i.id}.`,!1),h.push(r)}const g=$.length>0?$[0].index:c.length;if(c.length!==g){console.trace(`[createInstance] First service dependency of ${m.name} at position ${g+1} conflicts with ${c.length} static arguments`);const i=g-c.length;i>0?c=c.concat(new Array(i)):c=c.slice(0,g)}return Reflect.construct(m,c.concat(h))}k(m,c){if(this.f.get(m)instanceof A.$fi)this.f.set(m,c);else if(this.h)this.h.k(m,c);else throw new Error("illegalState - setting UNKNOWN service instance")}l(m){const c=this.f.get(m);return!c&&this.h?this.h.l(m):c}m(m,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const b=this.l(m);return b instanceof A.$fi?this.q(m,b,c.branch(m,!0)):(c.branch(m,!1),b)}q(m,c,b){if(this.o.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.o.add(m);try{return this.r(m,c,b)}finally{this.o.delete(m)}}r(m,c,b){const $=new R.$Xq(i=>i.id.toString());let h=0;const g=[{id:m,desc:c,_trace:b}];for(;g.length;){const i=g.pop();if($.lookupOrInsertNode(i),h++>1e3)throw new v($);for(const r of S._util.getServiceDependencies(i.desc.ctor)){const t=this.l(r.id);if(t||this.u(`[createInstance] ${m} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(r.id)),t instanceof A.$fi){const n={id:r.id,desc:t,_trace:i._trace.branch(r.id,!0)};$.insertEdge(i,n),g.push(n)}}}for(;;){const i=$.roots();if(i.length===0){if(!$.isEmpty())throw new v($);break}for(const{data:r}of i){if(this.l(r.id)instanceof A.$fi){const n=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,n)}$.removeNode(r)}}return this.l(m)}s(m,c,b=[],$,h){if(this.f.get(m)instanceof A.$fi)return this.t(m,c,b,$,h);if(this.h)return this.h.s(m,c,b,$,h);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}t(m,c,b=[],$,h){if($){const g=new d(void 0,this.g,this,this.i);g.c=String(m);const i=new Map,r=new D.$Bh(()=>{const t=g.j(c,b,h);for(const[n,s]of i){const o=t[n];if(typeof o=="function")for(const l of s)l.disposable=o.apply(t,l.listener)}return i.clear(),t});return new Proxy(Object.create(null),{get(t,n){if(!r.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let l=i.get(n);return l||(l=new a.$5c,i.set(n,l)),(I,L,z)=>{if(r.isInitialized)return r.value[n](I,L,z);{const U={listener:[I,L,z],disposable:void 0},V=l.push(U);return(0,k.$Sc)(()=>{V(),U.disposable?.dispose()})}}}if(n in t)return t[n];const s=r.value;let o=s[n];return typeof o!="function"||(o=o.bind(s),t[n]=o),o},set(t,n,s){return r.value[n]=s,!0},getPrototypeOf(t){return c.prototype}})}else return this.j(c,b,h)}u(m,c){if(c&&console.warn(m),this.g)throw new Error(m)}}e.$Yq=d;var p;(function(O){O[O.None=0]="None",O[O.Creation=1]="Creation",O[O.Invocation=2]="Invocation",O[O.Branch=3]="Branch"})(p||(p={}));class w{static{this.all=new Set}static{this.c=new class extends w{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(m,c){return m?new w(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation(m,c){return m?new w(1,c.name):w.c}static{this.f=0}constructor(m,c){this.type=m,this.name=c,this.g=Date.now(),this.h=[]}branch(m,c){const b=new w(3,m.toString());return this.h.push([m,c,b]),b}stop(){const m=Date.now()-this.g;w.f+=m;let c=!1;function b(h,g){const i=[],r=new Array(h+1).join("	");for(const[t,n,s]of g.h)if(n&&s){c=!0,i.push(`${r}CREATES -> ${t}`);const o=b(h+1,s);o&&i.push(o)}else i.push(`${r}uses -> ${t}`);return i.join(`
`)}const $=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];(m>2||c)&&w.all.add($.join(`
`))}}e.$Zq=w});var oe=this&&this.__param||function(J,e){return function(D,j){e(D,j,J)}};define(ne[64],re([0,1,20,2,12,105,21,10]),function(J,e,D,j,k,A,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=e.$Br=void 0,e.$Ar=u;function u(y){return y.tags.find(v=>v.startsWith("lp-"))?.split("lp-")[1]}e.$Br=(0,S.$ii)("languagePackService");let a=class extends j.$Uc{constructor(v){super(),this.c=v}async getAvailableLanguages(){const v=new D.$ee;setTimeout(()=>v.cancel(),1e3);let d;try{d=await this.c.query({text:'category:"language packs"',pageSize:20},v.token)}catch{return[]}const w=d.firstPage.filter(O=>O.properties.localizedLanguages?.length&&O.tags.some(m=>m.startsWith("lp-"))).map(O=>{const m=O.properties.localizedLanguages?.[0],c=u(O);return{...this.f(c,m,O),extensionId:O.identifier.id,galleryExtension:O}});return w.push(this.f("en","English")),w}f(v,d,p){const w=d??v;let O;if(w!==v&&(O=`(${v})`),v.toLowerCase()===k.$w.toLowerCase()&&(O??="",O+=(0,A.localize)(0,null)),p?.installCount){O??="";const m=p.installCount;let c;m>1e6?c=`${Math.floor(m/1e5)/10}M`:m>1e3?c=`${Math.floor(m/1e3)}K`:c=String(m),O+=` $(cloud-download) ${c}`}return{id:v,label:w,description:O}}};e.$Cr=a,e.$Cr=a=$e([oe(0,R.$Ro)],a)}),define(ne[6],re([0,1,106,34,5,43,2,31,12,17,3,11,121,10]),function(J,e,D,j,k,A,R,S,u,a,y,v,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Rj=e.LogLevel=e.$Pj=e.$Oj=void 0,e.$Qj=O,e.log=c,e.$3j=l,e.$4j=P,e.$5j=I,e.$6j=L,e.$Oj=(0,p.$ii)("logService"),e.$Pj=(0,p.$ii)("loggerService");function w(){return new Date().toISOString()}function O(z){return(0,y.$Zf)(z)}var m;(function(z){z[z.Off=0]="Off",z[z.Trace=1]="Trace",z[z.Debug=2]="Debug",z[z.Info=3]="Info",z[z.Warning=4]="Warning",z[z.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$Rj=m.Info;function c(z,U,V){switch(U){case m.Trace:z.trace(V);break;case m.Debug:z.debug(V);break;case m.Info:z.info(V);break;case m.Warning:z.warn(V);break;case m.Error:z.error(V);break;case m.Off:break;default:throw new Error(`Invalid log level ${U}`)}}function b(z,U=!1){let V="";for(let X=0;X<z.length;X++){let se=z[X];if(se instanceof Error&&(se=(0,j.$6i)(se,U)),typeof se=="object")try{se=JSON.stringify(se)}catch{}V+=(X>0?" ":"")+se}return V}class $ extends R.$Uc{constructor(){super(...arguments),this.b=e.$Rj,this.c=this.B(new k.$7d),this.onDidChangeLogLevel=this.c.event}setLevel(U){this.b!==U&&(this.b=U,this.c.fire(this.b))}getLevel(){return this.b}f(U){return this.b!==m.Off&&this.b<=U}}e.$Tj=$;class h extends ${constructor(U){super(),this.h=U}f(U){return this.h||super.f(U)}trace(U,...V){this.f(m.Trace)&&this.g(m.Trace,b([U,...V],!0))}debug(U,...V){this.f(m.Debug)&&this.g(m.Debug,b([U,...V]))}info(U,...V){this.f(m.Info)&&this.g(m.Info,b([U,...V]))}warn(U,...V){this.f(m.Warning)&&this.g(m.Warning,b([U,...V]))}error(U,...V){if(this.f(m.Error))if(U instanceof Error){const X=Array.prototype.slice.call(arguments);X[0]=U.stack,this.g(m.Error,b(X))}else this.g(m.Error,b([U,...V]))}flush(){}}e.$Uj=h;class g extends ${constructor(U=e.$Rj){super(),this.setLevel(U),this.g=!u.$i}trace(U,...V){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,U,...V):console.log(`[main ${w()}]`,U,...V))}debug(U,...V){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,U,...V):console.log(`[main ${w()}]`,U,...V))}info(U,...V){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,U,...V):console.log(`[main ${w()}]`,U,...V))}warn(U,...V){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${w()}]\x1B[0m`,U,...V):console.warn(`[main ${w()}]`,U,...V))}error(U,...V){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${w()}]\x1B[0m`,U,...V):console.error(`[main ${w()}]`,U,...V))}flush(){}}e.$Vj=g;class i extends ${constructor(U=e.$Rj,V=!0){super(),this.g=V,this.setLevel(U)}trace(U,...V){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",U,...V):console.log(U,...V))}debug(U,...V){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",U,...V):console.log(U,...V))}info(U,...V){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",U,...V):console.log(U,...V))}warn(U,...V){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",U,...V):console.log(U,...V))}error(U,...V){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",U,...V):console.error(U,...V))}flush(){}}e.$Wj=i;class r extends ${constructor(U,V=e.$Rj){super(),this.g=U,this.setLevel(V)}trace(U,...V){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(U),...V])}debug(U,...V){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(U),...V])}info(U,...V){this.f(m.Info)&&this.g.log(m.Info,[this.h(U),...V])}warn(U,...V){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(U),...V])}error(U,...V){this.f(m.Error)&&this.g.log(m.Error,[this.h(U),...V])}h(U){return typeof U=="string"?U:(0,j.$6i)(U,this.f(m.Trace))}flush(){}}e.$Xj=r;class t extends ${constructor(U){super(),this.g=U,U.length&&this.setLevel(U[0].getLevel())}setLevel(U){for(const V of this.g)V.setLevel(U);super.setLevel(U)}trace(U,...V){for(const X of this.g)X.trace(U,...V)}debug(U,...V){for(const X of this.g)X.debug(U,...V)}info(U,...V){for(const X of this.g)X.info(U,...V)}warn(U,...V){for(const X of this.g)X.warn(U,...V)}error(U,...V){for(const X of this.g)X.error(U,...V)}flush(){for(const U of this.g)U.flush()}dispose(){for(const U of this.g)U.dispose();super.dispose()}}e.$Yj=t;class n extends R.$Uc{constructor(U,V,X){if(super(),this.h=U,this.j=V,this.b=new S.$Bc,this.c=this.B(new k.$7d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new k.$7d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new k.$7d),this.onDidChangeVisibility=this.g.event,X)for(const se of X)this.b.set(se.resource,{logger:void 0,info:se})}m(U){return(0,y.$Vf)(U)?[...this.b.values()].find(V=>V.info.id===U):this.b.get(U)}getLogger(U){return this.m(U)?.logger}createLogger(U,V){const X=this.n(U),se=(0,y.$Vf)(U)?U:V?.id??(0,A.$9i)(X.toString()).toString(16);let ie=this.b.get(X)?.logger;const ue=V?.logLevel==="always"?m.Trace:V?.logLevel;ie||(ie=this.s(X,ue??this.getLogLevel(X)??this.h,{...V,id:se}));const he={logger:ie,info:{resource:X,id:se,logLevel:ue,name:V?.name,hidden:V?.hidden,extensionId:V?.extensionId,when:V?.when}};return this.registerLogger(he.info),this.b.set(X,he),ie}n(U){return(0,y.$Vf)(U)?(0,a.$Vg)(this.j,`${U}.log`):U}setLogLevel(U,V){if(v.URI.isUri(U)){const X=U,se=V,ie=this.b.get(X);ie&&se!==ie.info.logLevel&&(ie.info.logLevel=se===this.h?void 0:se,ie.logger?.setLevel(se),this.b.set(ie.info.resource,ie),this.f.fire([X,se]))}else{this.h=U;for(const[X,se]of this.b.entries())this.b.get(X)?.info.logLevel===void 0&&se.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(U,V){const X=this.m(U);X&&V!==!X.info.hidden&&(X.info.hidden=!V,this.b.set(X.info.resource,X),this.g.fire([X.info.resource,V]))}getLogLevel(U){let V;return U&&(V=this.b.get(U)?.info.logLevel),V??this.h}registerLogger(U){const V=this.b.get(U.resource);V?V.info.hidden!==U.hidden&&this.setVisibility(U.resource,!U.hidden):(this.b.set(U.resource,{info:U,logger:void 0}),this.c.fire({added:[U],removed:[]}))}deregisterLogger(U){const V=this.b.get(U);V&&(V.logger&&V.logger.dispose(),this.b.delete(U),this.c.fire({added:[],removed:[V.info]}))}*getRegisteredLoggers(){for(const U of this.b.values())yield U.info}getRegisteredLogger(U){return this.b.get(U)?.info}dispose(){this.b.forEach(U=>U.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Zj=n;class s{constructor(){this.onDidChangeLogLevel=new k.$7d().event}setLevel(U){}getLevel(){return m.Info}trace(U,...V){}debug(U,...V){}info(U,...V){}warn(U,...V){}error(U,...V){}critical(U,...V){}dispose(){}flush(){}}e.$1j=s;class o extends s{}e.$2j=o;function l(z){if(z.verbose)return m.Trace;if(typeof z.logLevel=="string"){const U=L(z.logLevel.toLowerCase());if(U!==void 0)return U}return e.$Rj}function P(z){switch(z){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function I(z){switch(z){case m.Trace:return{original:"Trace",value:D.localize(0,null)};case m.Debug:return{original:"Debug",value:D.localize(1,null)};case m.Info:return{original:"Info",value:D.localize(2,null)};case m.Warning:return{original:"Warning",value:D.localize(3,null)};case m.Error:return{original:"Error",value:D.localize(4,null)};case m.Off:return{original:"Off",value:D.localize(5,null)}}}function L(z){switch(z){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$7j=new d.$zj("logLevel",P(m.Info))}),define(ne[128],re([0,1,19,9,8,5,2,16,52,6]),function(J,e,D,j,k,A,R,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=void 0;class y extends R.$Uc{constructor(d,p){super(),this.a=d,this.b=p,this.c=this.B(new A.$7d),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$7d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new j.$gh(0)),this.w=[],this.y=this.B(new j.$gh(0))}watch(d,p){return p.recursive||this.b?.watcher?.forceUniversal?this.n(d,p):this.z(d,p)}n(d,p){const w={path:this.H(d),excludes:p.excludes,includes:p.includes,recursive:p.recursive,correlationId:p.correlationId},O=(0,D.$Ub)(this.j,w);return this.r(),(0,R.$Sc)(()=>{O(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(d=>(0,k.$1)(d))}s(){this.h||(this.h=this.B(this.t(p=>this.c.fire((0,u.$Aq)(p)),p=>this.G(p),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)})));const d=this.b?.watcher?.recursive?.usePolling;if(d===!0)for(const p of this.j)(0,u.$wq)(p)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const p of this.j)(0,u.$wq)(p)&&d.includes(p.path)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(d,p){const w={path:this.H(d),excludes:p.excludes,includes:p.includes,recursive:!1,correlationId:p.correlationId},O=(0,D.$Ub)(this.w,w);return this.C(),(0,R.$Sc)(()=>{O(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(d=>(0,k.$1)(d))}D(){return this.u||(this.u=this.B(this.F(d=>this.c.fire((0,u.$Aq)(d)),d=>this.G(d),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)}))),this.u.watch(this.w)}G(d){d.type==="error"&&this.g.fire(d.message),this.a[d.type](d.message)}H(d){return(0,S.$ic)(d.fsPath)}}e.$Eq=y}),define(ne[129],re([0,1,19,9,14,20,5,43,65,2,48,15,130,17,46,102,13,62,6,8]),function(J,e,D,j,k,A,R,S,u,a,y,v,d,p,w,O,m,c,b,$){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=void 0;let g=class extends a.$Uc{static{h=this}constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new R.$7d),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new R.$7d),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new R.$7d),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new R.$7d),this.onDidRunOperation=this.r.event,this.X=this.B(new R.$7d),this.Y=this.B(new R.$7d),this.onDidFilesChange=this.Y.event,this.Z=this.B(new R.$7d),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new j.$rh)}registerProvider(r,t){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${r}`);const n=new a.$Tc;return this.h.set(r,t),this.c.fire({added:!0,scheme:r,provider:t}),n.add(t.onDidChangeFile(s=>{const o=new m.$8k(s,!this.S(t));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof t.onDidWatchError=="function"&&n.add(t.onDidWatchError(s=>this.Z.fire(new Error(s)))),n.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:r}))),(0,a.$Sc)(()=>{this.c.fire({added:!1,scheme:r,provider:t}),this.h.delete(r),(0,a.$Pc)(n)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const t=[];this.f.fire({scheme:r,join(n){t.push(n)}}),!this.h.has(r)&&await j.Promises.settled(t)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,t){const n=this.h.get(r.scheme);return!!(n&&n.capabilities&t)}listCapabilities(){return u.Iterable.map(this.h,([r,t])=>({scheme:r,capabilities:t.capabilities}))}async j(r){if(!(0,p.$Zg)(r))throw new m.$0k((0,O.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const t=this.h.get(r.scheme);if(!t){const n=new $.$bb;throw n.message=(0,O.localize)(1,null,r.toString()),n}return t}async m(r){const t=await this.j(r);if((0,m.$Uk)(t)||(0,m.$Rk)(t)||(0,m.$Vk)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const t=await this.j(r);if((0,m.$Uk)(t)||(0,m.$Rk)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,t){try{return await this.s(r,t)}catch(n){throw(0,m.$5k)(n)===m.FileSystemProviderErrorCode.FileNotFound?new m.$0k((0,O.localize)(2,null,this.sb(r)),1):(0,m.$3k)(n)}}async s(r,t){const n=await this.j(r),s=this.S(n),o=t?.resolveTo,l=t?.resolveSingleChildDescendants,P=t?.resolveMetadata,I=await n.stat(r);let L;return this.t(n,r,I,void 0,!!P,(z,U)=>(L||(L=y.$oi.forUris(()=>!s),L.set(r,!0),o&&L.fill(!0,o)),L.get(z.resource)||L.findSuperstr(z.resource.with({query:null,fragment:null}))?!0:z.isDirectory&&l?U===1:!1))}async t(r,t,n,s,o,l){const{providerExtUri:P}=this.R(r),I={resource:t,name:P.basename(t),isFile:(n.type&m.FileType.File)!==0,isDirectory:(n.type&m.FileType.Directory)!==0,isSymbolicLink:(n.type&m.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&m.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((n.permissions??0)&m.FilePermission.Locked),etag:(0,m.$il)({mtime:n.mtime,size:n.size}),children:void 0};if(I.isDirectory&&l(I,s)){try{const L=await r.readdir(t),z=await j.Promises.settled(L.map(async([U,V])=>{try{const X=P.joinPath(t,U),se=o?await r.stat(X):{type:V};return await this.t(r,X,se,L.length,o,l)}catch(X){return this.b.trace(X),null}}));I.children=(0,D.$Hb)(z)}catch(L){this.b.trace(L),I.children=[]}return I}return I}async resolveAll(r){return j.Promises.settled(r.map(async t=>{try{return{stat:await this.s(t.resource,t.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(r){const t=await this.j(r),n=await t.stat(r);return this.t(t,r,n,void 0,!0,()=>!1)}async exists(r){const t=await this.j(r);try{return!!await t.stat(r)}catch{return!1}}async canCreateFile(r,t){try{await this.u(r,t)}catch(n){return n}return!0}async u(r,t){if(!t?.overwrite&&await this.exists(r))throw new m.$0k((0,O.localize)(3,null,this.sb(r)),3,t)}async createFile(r,t=k.$ue.fromString(""),n){await this.u(r,n);const s=await this.writeFile(r,t);return this.r.fire(new m.$7k(r,0,s)),s}async writeFile(r,t,n){const s=this.qb(await this.n(r),r),{providerExtUri:o}=this.R(s);let l=n;if((0,m.$Xk)(s)&&!l?.atomic){const P=s.enforceAtomicWriteFile?.(r);P&&(l={...n,atomic:P})}try{await this.w(s,r,l)||await this.U(s,o.dirname(r));let I;if((0,m.$Rk)(s)&&!(t instanceof k.$ue))if((0,w.$ge)(t)){const L=await(0,w.$ne)(t,3);L.ended?I=k.$ue.concat(L.buffer):I=L}else I=(0,w.$ke)(t,L=>k.$ue.concat(L),3);else I=t;!(0,m.$Uk)(s)||(0,m.$Rk)(s)&&I instanceof k.$ue||(0,m.$Rk)(s)&&(0,m.$Xk)(s)&&l?.atomic?await this.hb(s,r,l,I):await this.db(s,r,l,I instanceof k.$ue?(0,k.$Fe)(I):I),this.r.fire(new m.$7k(r,4))}catch(P){throw new m.$0k((0,O.localize)(4,null,this.sb(r),(0,m.$3k)(P).toString()),(0,m.$6k)(P),l)}return this.resolve(r,{resolveMetadata:!0})}async w(r,t,n){const s=!!n?.unlock;if(s&&!(r.capabilities&8192))throw new Error((0,O.localize)(5,null,this.sb(t)));if(!!n?.atomic){if(!(r.capabilities&32768))throw new Error((0,O.localize)(6,null,this.sb(t)));if(!(r.capabilities&2))throw new Error((0,O.localize)(7,null,this.sb(t)));if(s)throw new Error((0,O.localize)(8,null,this.sb(t)))}let l;try{l=await r.stat(t)}catch{return}if(l.type&m.FileType.Directory)throw new m.$0k((0,O.localize)(9,null,this.sb(t)),0,n);if(this.rb(t,l),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==m.$hl&&typeof l.mtime=="number"&&typeof l.size=="number"&&n.mtime<l.mtime&&n.etag!==(0,m.$il)({mtime:n.mtime,size:l.size}))throw new m.$0k((0,O.localize)(10,null),3,n);return l}async readFile(r,t,n){const s=await this.m(r);return t?.atomic?this.z(s,r,t,n):this.C(s,r,t,n)}async z(r,t,n,s){return new Promise((o,l)=>{this.cb.queueFor(t,async()=>{try{const P=await this.C(r,t,n,s);o(P)}catch(P){l(P)}},this.R(r).providerExtUri)})}async C(r,t,n,s){const o=await this.D(r,t,{...n,preferUnbuffered:!0},s);return{...o,value:await(0,k.$Ge)(o.value)}}async readFileStream(r,t,n){const s=await this.m(r);return this.D(s,r,t,n)}async D(r,t,n,s){const o=new A.$ee(s);let l=n;(0,m.$Wk)(r)&&r.enforceAtomicReadFile?.(t)&&(l={...n,atomic:!0});const P=this.J(t,l).then(L=>L,L=>{throw o.dispose(!0),L});let I;try{return typeof l?.etag=="string"&&l.etag!==m.$hl&&await P,l?.atomic&&(0,m.$Wk)(r)||!((0,m.$Uk)(r)||(0,m.$Vk)(r))||(0,m.$Rk)(r)&&l?.preferUnbuffered?I=this.I(r,t,l):(0,m.$Vk)(r)?I=this.G(r,t,o.token,l):I=this.H(r,t,o.token,l),I.on("end",()=>o.dispose()),I.on("error",()=>o.dispose()),{...await P,value:I}}catch(L){throw I&&await(0,w.$le)(I),this.F(L,t,l)}}F(r,t,n){const s=(0,O.localize)(11,null,this.sb(t),(0,m.$3k)(r).toString());return r instanceof m.$_k?new m.$_k(s,r.stat,n):r instanceof m.$$k?new m.$$k(s,r.fileOperationResult,r.size,r.options):new m.$0k(s,(0,m.$6k)(r),n)}G(r,t,n,s=Object.create(null)){const o=r.readFileStream(t,s,n);return(0,w.$re)(o,{data:l=>l instanceof k.$ue?l:k.$ue.wrap(l),error:l=>this.F(l,t,s)},l=>k.$ue.concat(l))}H(r,t,n,s=Object.create(null)){const o=(0,k.$Ke)();return(0,c.$tq)(r,t,o,l=>l,{...s,bufferSize:this.a,errorTransformer:l=>this.F(l,t,s)},n),o}I(r,t,n){const s=(0,w.$ie)(o=>k.$ue.concat(o));return(async()=>{try{let o;n?.atomic&&(0,m.$Wk)(r)?o=await r.readFile(t,{atomic:!0}):o=await r.readFile(t),typeof n?.position=="number"&&(o=o.slice(n.position)),typeof n?.length=="number"&&(o=o.slice(0,n.length)),this.L(t,o.byteLength,n),s.end(k.$ue.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async J(r,t){const n=await this.resolve(r,{resolveMetadata:!0});if(n.isDirectory)throw new m.$0k((0,O.localize)(12,null,this.sb(r)),0,t);if(typeof t?.etag=="string"&&t.etag!==m.$hl&&t.etag===n.etag)throw new m.$_k((0,O.localize)(13,null),n,t);return this.L(r,n.size,t),n}L(r,t,n){if(typeof n?.limits?.size=="number"&&t>n.limits.size)throw new m.$$k((0,O.localize)(14,null,this.sb(r)),7,t,n)}async canMove(r,t,n){return this.M(r,t,"move",n)}async canCopy(r,t,n){return this.M(r,t,"copy",n)}async M(r,t,n,s){if(r.toString()!==t.toString())try{const o=n==="move"?this.qb(await this.n(r),r):await this.m(r),l=this.qb(await this.n(t),t);await this.Q(o,r,l,t,n,s)}catch(o){return o}return!0}async move(r,t,n){const s=this.qb(await this.n(r),r),o=this.qb(await this.n(t),t),l=await this.N(s,r,o,t,"move",!!n),P=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new m.$7k(r,l==="move"?2:3,P)),P}async copy(r,t,n){const s=await this.m(r),o=this.qb(await this.n(t),t),l=await this.N(s,r,o,t,"copy",!!n),P=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new m.$7k(r,l==="copy"?3:2,P)),P}async N(r,t,n,s,o,l){if(t.toString()===s.toString())return o;const{exists:P,isSameResourceWithDifferentPathCase:I}=await this.Q(r,t,n,s,o,l);if(P&&!I&&l&&await this.del(s,{recursive:!0}),await this.U(n,this.R(n).providerExtUri.dirname(s)),o==="copy"){if(r===n&&(0,m.$Sk)(r))await r.copy(t,s,{overwrite:l});else{const L=await this.resolve(t);L.isDirectory?await this.P(r,L,n,s):await this.O(r,t,n,s)}return o}else return r===n?(await r.rename(t,s,{overwrite:l}),o):(await this.N(r,t,n,s,"copy",l),await this.del(t,{recursive:!0}),"copy")}async O(r,t,n,s){if((0,m.$Uk)(r)&&(0,m.$Uk)(n))return this.jb(r,t,n,s);if((0,m.$Uk)(r)&&(0,m.$Rk)(n))return this.pb(r,t,n,s);if((0,m.$Rk)(r)&&(0,m.$Uk)(n))return this.nb(r,t,n,s);if((0,m.$Rk)(r)&&(0,m.$Rk)(n))return this.lb(r,t,n,s)}async P(r,t,n,s){await n.mkdir(s),Array.isArray(t.children)&&await j.Promises.settled(t.children.map(async o=>{const l=this.R(n).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.P(r,await this.resolve(o.resource),n,l):this.O(r,o.resource,n,l)}))}async Q(r,t,n,s,o,l){let P=!1;if(r===n){const{providerExtUri:L,isPathCaseSensitive:z}=this.R(r);if(z||(P=L.isEqual(t,s)),P&&o==="copy")throw new Error((0,O.localize)(15,null,this.sb(t),this.sb(s)));if(!P&&L.isEqualOrParent(s,t))throw new Error((0,O.localize)(16,null,this.sb(t),this.sb(s)))}const I=await this.exists(s);if(I&&!P){if(!l)throw new m.$0k((0,O.localize)(17,null,this.sb(t),this.sb(s)),4);if(r===n){const{providerExtUri:L}=this.R(r);if(L.isEqualOrParent(t,s))throw new Error((0,O.localize)(18,null,this.sb(t),this.sb(s)))}}return{exists:I,isSameResourceWithDifferentPathCase:P}}R(r){const t=this.S(r);return{providerExtUri:t?p.$Lg:p.$Ng,isPathCaseSensitive:t}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const t=this.qb(await this.j(r),r);await this.U(t,r);const n=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new m.$7k(r,0,n)),n}async U(r,t){const n=[],{providerExtUri:s}=this.R(r);for(;!s.isEqual(t,s.dirname(t));)try{if(!((await r.stat(t)).type&m.FileType.Directory))throw new Error((0,O.localize)(19,null,this.sb(t)));break}catch(o){if((0,m.$5k)(o)!==m.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(s.basename(t)),t=s.dirname(t)}for(let o=n.length-1;o>=0;o--){t=s.joinPath(t,n[o]);try{await r.mkdir(t)}catch(l){if((0,m.$5k)(l)!==m.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(r,t){try{await this.W(r,t)}catch(n){return n}return!0}async W(r,t){const n=this.qb(await this.j(r),r),s=!!t?.useTrash;if(s&&!(n.capabilities&4096))throw new Error((0,O.localize)(20,null,this.sb(r)));const o=t?.atomic;if(o&&!(n.capabilities&65536))throw new Error((0,O.localize)(21,null,this.sb(r)));if(s&&o)throw new Error((0,O.localize)(22,null,this.sb(r)));let l;try{l=await n.stat(r)}catch{}if(l)this.rb(r,l);else throw new m.$0k((0,O.localize)(23,null,this.sb(r)),1);if(!!!t?.recursive){const I=await this.resolve(r);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,O.localize)(24,null,this.sb(r)))}return n}async del(r,t){const n=await this.W(r,t);let s=t;if((0,m.$Yk)(n)&&!s?.atomic){const I=n.enforceAtomicDelete?.(r);I&&(s={...t,atomic:I})}const o=!!s?.useTrash,l=!!s?.recursive,P=s?.atomic??!1;await n.delete(r,{recursive:l,useTrash:o,atomic:P}),this.r.fire(new m.$7k(r,1))}async cloneFile(r,t){const n=await this.j(r),s=this.qb(await this.n(t),t);if(!(n===s&&this.R(n).providerExtUri.isEqual(r,t)))return n===s&&(0,m.$Tk)(n)?n.cloneFile(r,t):(await this.U(s,this.R(s).providerExtUri.dirname(t)),n===s&&(0,m.$Sk)(n)?this.cb.queueFor(r,()=>n.copy(r,t,{overwrite:!0}),this.R(n).providerExtUri):this.cb.queueFor(r,()=>this.O(n,r,s,t),this.R(n).providerExtUri))}static{this.ab=0}createWatcher(r,t){return this.watch(r,{...t,correlationId:h.ab++})}watch(r,t={recursive:!1,excludes:[]}){const n=new a.$Tc;let s=!1,o=()=>{s=!0};n.add((0,a.$Sc)(()=>o())),(async()=>{try{const P=await this.bb(r,t);s?(0,a.$Pc)(P):o=()=>(0,a.$Pc)(P)}catch(P){this.b.error(P)}})();const l=t.correlationId;if(typeof l=="number"){const P=n.add(new R.$7d);return n.add(this.X.event(L=>{L.correlates(l)&&P.fire(L)})),{onDidChange:P.event,dispose:()=>n.dispose()}}return n}async bb(r,t){const n=await this.j(r),s=(0,S.$9i)([this.R(n).providerExtUri.getComparisonKey(r),t]);let o=this.$.get(s);return o||(o={count:0,disposable:n.watch(r,t)},this.$.set(s,o)),o.count+=1,(0,a.$Sc)(()=>{o&&(o.count--,o.count===0&&((0,a.$Pc)(o.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,a.$Pc)(r.disposable);this.$.clear()}async db(r,t,n,s){return this.cb.queueFor(t,async()=>{const o=await r.open(t,{create:!0,unlock:n?.unlock??!1});try{(0,w.$ge)(s)||(0,w.$he)(s)?await this.eb(r,o,s):await this.fb(r,o,s)}catch(l){throw(0,m.$3k)(l)}finally{await r.close(o)}},this.R(r).providerExtUri)}async eb(r,t,n){let s=0,o;if((0,w.$he)(n)){if(n.buffer.length>0){const l=k.$ue.concat(n.buffer);await this.gb(r,t,l,l.byteLength,s,0),s+=l.byteLength}if(n.ended)return;o=n.stream}else o=n;return new Promise((l,P)=>{(0,w.$me)(o,{onData:async I=>{o.pause();try{await this.gb(r,t,I,I.byteLength,s,0)}catch(L){return P(L)}s+=I.byteLength,setTimeout(()=>o.resume())},onError:I=>P(I),onEnd:()=>l()})})}async fb(r,t,n){let s=0,o;for(;(o=n.read())!==null;)await this.gb(r,t,o,o.byteLength,s,0),s+=o.byteLength}async gb(r,t,n,s,o,l){let P=0;for(;P<s;){const I=await r.write(t,o+P,n.buffer,l+P,s-P);P+=I}}async hb(r,t,n,s){return this.cb.queueFor(t,()=>this.ib(r,t,n,s),this.R(r).providerExtUri)}async ib(r,t,n,s){let o;s instanceof k.$ue?o=s:(0,w.$ge)(s)?o=await(0,k.$Ge)(s):(0,w.$he)(s)?o=await(0,k.$He)(s):o=(0,k.$Ee)(s),await r.writeFile(t,o.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async jb(r,t,n,s){return this.cb.queueFor(s,()=>this.kb(r,t,n,s),this.R(n).providerExtUri)}async kb(r,t,n,s){let o,l;try{o=await r.open(t,{create:!1}),l=await n.open(s,{create:!0,unlock:!1});const P=k.$ue.alloc(this.a);let I=0,L=0,z=0;do z=await r.read(o,I,P.buffer,L,P.byteLength-L),await this.gb(n,l,P,z,I,L),I+=z,L+=z,L===P.byteLength&&(L=0);while(z>0)}catch(P){throw(0,m.$3k)(P)}finally{await j.Promises.settled([typeof o=="number"?r.close(o):Promise.resolve(),typeof l=="number"?n.close(l):Promise.resolve()])}}async lb(r,t,n,s){return this.cb.queueFor(s,()=>this.mb(r,t,n,s),this.R(n).providerExtUri)}async mb(r,t,n,s){return n.writeFile(s,await r.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,t,n,s){return this.cb.queueFor(s,()=>this.ob(r,t,n,s),this.R(n).providerExtUri)}async ob(r,t,n,s){const o=await n.open(s,{create:!0,unlock:!1});try{const l=await r.readFile(t);await this.gb(n,o,k.$ue.wrap(l),l.byteLength,0,0)}catch(l){throw(0,m.$3k)(l)}finally{await n.close(o)}}async pb(r,t,n,s){const o=await(0,k.$Ge)(this.H(r,t,A.CancellationToken.None));await this.hb(n,s,void 0,o)}qb(r,t){if(r.capabilities&2048)throw new m.$0k((0,O.localize)(25,null,this.sb(t)),6);return r}rb(r,t){if((t.permissions??0)&m.FilePermission.Readonly)throw new m.$0k((0,O.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===v.Schemas.file?r.fsPath:r.toString(!0)}};e.$uq=g,e.$uq=g=h=$e([oe(0,b.$Oj)],g)}),define(ne[131],re([0,1,60,174,9,31,14,5,124,2,16,12,17,46,25,104,13,62,128,34,126,125]),function(J,e,D,j,k,A,R,S,u,a,y,v,d,p,w,O,m,c,b,$,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=void 0,(()=>{try{(0,j.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,$.$6i)(r)}`)}})();class i extends b.$Eq{static{this.I=!1}constructor(t,n){super(t,n),this.onDidChangeCapabilities=S.Event.None,this.N=new A.$Bc(s=>d.$Mg.getComparisonKey(s)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,v.$k&&(this.J|=1024)),this.J}async stat(t){try{const{stat:n,symbolicLink:s}=await w.SymlinkSupport.stat(this.H(t));return{type:this.M(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:m.FilePermission.Locked}}catch(n){throw this.fb(n)}}async L(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const n=await w.Promises.readdir(this.H(t),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async o=>{try{let l;o.isSymbolicLink()?l=(await this.stat((0,d.$Vg)(t,o.name))).type:l=this.M(o),s.push([o.name,l])}catch(l){this.a.trace(l)}})),s}catch(n){throw this.fb(n)}}M(t,n){let s;return n?.dangling?s=m.FileType.Unknown:t.isFile()?s=m.FileType.File:t.isDirectory()?s=m.FileType.Directory:s=m.FileType.Unknown,n&&(s|=m.FileType.SymbolicLink),s}async O(t){const n=this.H(t);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.N.get(t);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const o=new k.$hh;return this.N.set(t,o),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,a.$Sc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.N.get(t)===o&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.N.delete(t)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),o.open()})}async readFile(t,n){let s;try{n?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(t)})`),s=await this.O(t));const o=this.H(t);return await w.Promises.readFile(o)}catch(o){throw this.fb(o)}finally{s?.dispose()}}P(t){i.I&&this.a.trace(t)}readFileStream(t,n,s){const o=(0,p.$ie)(l=>R.$ue.concat(l.map(P=>R.$ue.wrap(P))).buffer);return(0,c.$tq)(this,t,o,l=>l.buffer,{...n,bufferSize:256*1024},s),o}async writeFile(t,n,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.Q(t)?this.R(t,(0,d.$Vg)((0,d.$Ug)(t),`${(0,d.$Sg)(t)}${s.atomic.postfix}`),n,s):this.S(t,n,s)}async Q(t){try{const n=this.H(t),{symbolicLink:s}=await w.SymlinkSupport.stat(n);if(s)return!1}catch{}return!0}async R(t,n,s,o){const l=new a.$Tc;try{l.add(await this.O(t)),l.add(await this.O(n)),await this.S(n,s,o,!0);try{await this.rename(n,t,{overwrite:!0})}catch(P){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw P}}finally{l.dispose()}}async S(t,n,s,o){let l;try{const P=this.H(t);if(!s.create||!s.overwrite){if(await w.Promises.exists(P)){if(!s.overwrite)throw(0,m.$2k)((0,O.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,m.$2k)((0,O.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(t,{create:!0,unlock:s.unlock},o),await this.write(l,0,n,0,n.byteLength)}catch(P){throw await this.gb(t,P)}finally{typeof l=="number"&&await this.close(l)}}static{this.Y=!0}static configureFlushOnWrite(t){i.Y=t}async open(t,n,s){const o=this.H(t);let l;(0,m.$Pk)(n)&&!s&&(l=await this.O(t));let P;try{if((0,m.$Pk)(n)&&n.unlock)try{const{stat:L}=await w.SymlinkSupport.stat(o);L.mode&128||await w.Promises.chmod(o,L.mode|128)}catch(L){L.code!=="ENOENT"&&this.a.trace(L)}let I;if((0,m.$Pk)(n)){if(v.$i)try{await w.Promises.truncate(o,0),I="r+"}catch(L){L.code!=="ENOENT"&&this.a.trace(L)}I||(I="w")}else I="r";P=await w.Promises.open(o,I)}catch(I){throw l?.dispose(),(0,m.$Pk)(n)?await this.gb(t,I):this.fb(I)}if(this.U.set(P,0),(0,m.$Pk)(n)&&this.X.set(P,t),l){const I=this.W.get(P);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${P} (${o})`),this.W.set(P,l),I&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${P} (${o})`),I.dispose())}return P}async close(t){const n=this.W.get(t);try{if(this.U.delete(t),this.X.delete(t)&&i.Y)try{await w.Promises.fdatasync(t)}catch(s){i.configureFlushOnWrite(!1),this.a.error(s)}return await w.Promises.close(t)}catch(s){throw this.fb(s)}finally{n&&(this.W.get(t)===n&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.W.delete(t)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),n.dispose())}}async read(t,n,s,o,l){const P=this.Z(t,n);let I=null;try{I=(await w.Promises.read(t,s,o,l,P)).bytesRead}catch(L){throw this.fb(L)}finally{this.$(t,P,I)}return I}Z(t,n){return n===this.U.get(t)?null:n}$(t,n,s){const o=this.U.get(t);typeof o=="number"&&(typeof n=="number"||(typeof s=="number"?this.U.set(t,o+s):this.U.delete(t)))}async write(t,n,s,o,l){return(0,k.$Ch)(()=>this.ab(t,n,s,o,l),100,3)}async ab(t,n,s,o,l){const P=this.Z(t,n);let I=null;try{I=(await w.Promises.write(t,s,o,l,P)).bytesWritten}catch(L){throw await this.gb(this.X.get(t),L)}finally{this.$(t,P,I)}return I}async mkdir(t){try{await w.Promises.mkdir(this.H(t))}catch(n){throw this.fb(n)}}async delete(t,n){try{const s=this.H(t);if(n.recursive){let o;n?.atomic!==!1&&n.atomic.postfix&&(o=(0,y.$kc)((0,y.$nc)(s),`${(0,y.$oc)(s)}${n.atomic.postfix}`)),await w.Promises.rm(s,w.RimRafMode.MOVE,o)}else try{await w.Promises.unlink(s)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let l=!1;try{const{stat:P,symbolicLink:I}=await w.SymlinkSupport.stat(s);l=P.isDirectory()&&!I}catch{}if(l)await w.Promises.rmdir(s);else throw o}else throw o}}catch(s){throw this.fb(s)}}async rename(t,n,s){const o=this.H(t),l=this.H(n);if(o!==l)try{await this.bb(t,n,"move",s.overwrite),await w.Promises.rename(o,l)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,O.localize)(2,null,(0,y.$oc)(o),(0,y.$oc)((0,y.$nc)(l)),P.toString()))),this.fb(P)}}async copy(t,n,s){const o=this.H(t),l=this.H(n);if(o!==l)try{await this.bb(t,n,"copy",s.overwrite),await w.Promises.copy(o,l,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,O.localize)(3,null,(0,y.$oc)(o),(0,y.$oc)((0,y.$nc)(l)),P.toString()))),this.fb(P)}}async bb(t,n,s,o){const l=this.H(t),P=this.H(n);let I=!1;if(!!(this.capabilities&1024)||(I=(0,u.$hg)(l,P,!0)),I){if(s==="copy")throw(0,m.$2k)((0,O.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const z=await this.L(t);if(!z)throw(0,m.$2k)((0,O.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const U=await this.L(n);if(U){if(!o)throw(0,m.$2k)((0,O.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);z.type&m.FileType.File&&U.type&m.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,n){return this.cb(t,n,!1)}async cb(t,n,s){const o=this.H(t),l=this.H(n),P=!!(this.capabilities&1024);if((0,u.$hg)(o,l,!P))return;const I=new a.$Tc;try{I.add(await this.O(t)),I.add(await this.O(n)),s&&await w.Promises.mkdir((0,y.$nc)(l),{recursive:!0}),await w.Promises.copyFile(o,l)}catch(L){if(L.code==="ENOENT"&&!s)return this.cb(t,n,!0);throw this.fb(L)}finally{I.dispose()}}t(t,n,s){return new h.$Lq(o=>t(o),o=>n(o),s)}F(t,n,s){return new g.$Uq(o=>t(o),o=>n(o),s)}fb(t){if(t instanceof m.$1k)return t;let n=t,s;switch(t.code){case"ENOENT":s=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=m.FileSystemProviderErrorCode.Unknown;break;default:s=m.FileSystemProviderErrorCode.Unknown}return(0,m.$2k)(n,s)}async gb(t,n){let s=this.fb(n);if(t&&s.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await w.SymlinkSupport.stat(this.H(t));o.mode&128||(s=(0,m.$2k)(n,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return s}}e.$Vq=i}),define(ne[132],re([0,1,2,6]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5P=void 0;class k extends D.$Uc{constructor(R,S=[]){super(),this.a=new j.$Yj([R,...S]),this.B(R.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...S){this.a.trace(R,...S)}debug(R,...S){this.a.debug(R,...S)}info(R,...S){this.a.info(R,...S)}warn(R,...S){this.a.warn(R,...S)}error(R,...S){this.a.error(R,...S)}flush(){this.a.flush()}}e.$5P=k}),define(ne[133],re([0,1,13,6]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TP=void 0;var k;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(k||(k={}));async function A(a,y,v,d,p){try{const w=await new Promise((m,c)=>{J(["@vscode/spdlog"],m,c)});w.setFlushOn(k.Trace);const O=await w.createAsyncRotatingLogger(a,y,v,d);return p?O.clearFormatters():O.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),O}catch(w){console.error(w)}return null}function R(a,y,v){switch(y){case j.LogLevel.Trace:a.trace(v);break;case j.LogLevel.Debug:a.debug(v);break;case j.LogLevel.Info:a.info(v);break;case j.LogLevel.Warning:a.warn(v);break;case j.LogLevel.Error:a.error(v);break;case j.LogLevel.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function S(a,y){switch(y){case j.LogLevel.Trace:a.setLevel(k.Trace);break;case j.LogLevel.Debug:a.setLevel(k.Debug);break;case j.LogLevel.Info:a.setLevel(k.Info);break;case j.LogLevel.Warning:a.setLevel(k.Warning);break;case j.LogLevel.Error:a.setLevel(k.Error);break;case j.LogLevel.Off:a.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${y}`)}}class u extends j.$Uj{constructor(y,v,d,p,w){super(),this.m=[],this.setLevel(w),this.n=this.s(y,v,d,p),this.B(this.onDidChangeLogLevel(O=>{this.r&&S(this.r,O)}))}async s(y,v,d,p){const w=d?6:1,O=30/w*D.$kl.MB,m=await A(y,v,O,w,p);if(m){this.r=m,S(this.r,this.getLevel());for(const{level:c,message:b}of this.m)R(this.r,c,b);this.m=[]}}g(y,v){this.r?R(this.r,y,v):this.getLevel()<=y&&this.m.push({level:y,message:v})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$TP=u}),define(ne[134],re([0,1,28,6,133]),function(J,e,D,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UP=void 0;class A extends j.$Zj{s(S,u,a){return new k.$TP((0,D.$Eg)(),S.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,u)}}e.$UP=A}),define(ne[39],re([0,1,5,65,2,10]),function(J,e,D,j,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=e.$4n=e.$3n=void 0,e.$3n=(0,A.$ii)("policy");class R extends k.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new D.$7d),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const y=Object.keys(this.f).length;return this.f={...a,...this.f},y!==Object.keys(this.f).length&&await this.j(a),j.Iterable.reduce(this.g.entries(),(v,[d,p])=>({...v,[d]:p}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return j.Iterable.reduce(Object.entries(this.f),(a,[y,v])=>({...a,[y]:{definition:v,value:this.g.get(y)}}),{})}}e.$4n=R;class S{constructor(){this.onDidChange=D.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$5n=S}),define(ne[135],re([0,1,9,5,65,3,13,6,39]),function(J,e,D,j,k,A,R,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ubc=void 0;function a(v,d){const p=[];for(const w of new Set(k.Iterable.concat(v.keys(),d.keys())))v.get(w)!==d.get(w)&&p.push(w);return p}let y=class extends u.$4n{constructor(d,p,w){super(),this.m=d,this.n=p,this.s=w,this.c=this.B(new D.$gh(500));const O=j.Event.filter(p.onDidFilesChange,m=>m.affects(d));this.B(p.watch(d)),this.B(O(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const d=new Map;try{const p=await this.n.readFile(this.m),w=JSON.parse(p.value.toString());if(!(0,A.$Xf)(w))throw new Error("Policy file isn't a JSON object");for(const O of Object.keys(w))this.f[O]&&d.set(O,w[O])}catch(p){p.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",p)}return d}async w(){const d=await this.u(),p=a(this.g,d);this.g=d,p.length>0&&this.h.fire(p)}};e.$Ubc=y,e.$Ubc=y=$e([oe(1,R.$Ok),oe(2,S.$Oj)],y)}),define(ne[136],re([0,1,39,9,2,6]),function(J,e,D,j,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tbc=void 0;let R=class extends D.$4n{constructor(u,a){super(),this.m=u,this.n=a,this.a=new j.$ch,this.b=this.B(new k.$Vc)}async j(u){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(u).length} policy definitions`);const{createWatcher:a}=await new Promise((y,v)=>{J(["@vscode/policy-watcher"],y,v)});await this.a.queue(()=>new Promise((y,v)=>{try{this.b.value=a(this.n,u,d=>{this.t(d),y()})}catch(d){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",d),v(d)}}))}t(u){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(u)}`);for(const a in u){const y=u[a];y===void 0?this.g.delete(a):this.g.set(a,y)}this.h.fire(Object.keys(u))}};e.$Tbc=R,e.$Tbc=R=$e([oe(0,A.$Oj)],R)}),define(ne[32],re([0,1,10]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9j=e.$8j=void 0,e.$8j=(0,D.$ii)("productService"),e.$9j="vscode://schemas/vscode-product"}),define(ne[36],re([0,1,72,3]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=void 0;class k{constructor(){this.a=new Map}add(R,S){D.ok(j.$Vf(R)),D.ok(j.$Xf(S)),D.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,S)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$1n=new k}),define(ne[137],re([0,1,5,36]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=void 0,e.$2n={JSONContribution:"base.contributions.json"};function k(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class A{constructor(){this.b=new D.$7d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,a){this.a[k(u)]=a,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const R=new A;j.$1n.add(e.$2n.JSONContribution,R)}),define(ne[40],re([0,1,19,5,3,91,29,137,36]),function(J,e,D,j,k,A,R,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.ConfigurationScope=e.$6n=e.EditPresentationTypes=void 0,e.$eo=O,e.$fo=m,e.$go=c,e.$ho=$,e.$io=h;var a;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$6n={Configuration:"base.contributions.configuration"};var y;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y||(e.ConfigurationScope=y={})),e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n={properties:{},patternProperties:{}},e.$$n={properties:{},patternProperties:{}},e.$_n={properties:{},patternProperties:{}},e.$ao="vscode://schemas/settings/resourceLanguage",e.$bo="vscode://schemas/settings/configurationDefaults";const v=u.$1n.as(S.$2n.JSONContribution);class d{constructor(){this.h=new Set,this.i=new j.$7d,this.onDidSchemaChange=this.i.event,this.j=new j.$7d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.$ao,this.g),this.v()}registerConfiguration(i,r=!0){this.registerConfigurations([i],r)}registerConfigurations(i,r=!0){const t=new Set;this.n(i,r,t),v.registerSchema(e.$ao,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(i){const r=new Set;this.o(i,r),v.registerSchema(e.$ao,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:i,remove:r}){const t=new Set;this.o(r,t),this.n(i,!1,t),v.registerSchema(e.$ao,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(i){const r=new Set;this.k(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(i,r){const t=[];for(const{overrides:n,source:s}of i)for(const o in n)if(r.add(o),e.$do.test(o)){const l=this.a.get(o),P=l?.valuesSources??new Map;if(s)for(const U of Object.keys(n[o]))P.set(U,s);const I={...l?.value||{},...n[o]};this.a.set(o,{source:s,value:I,valuesSources:P});const L=(0,R.$Yi)(o),z={type:"object",default:I,description:A.localize(1,null,L),$ref:e.$ao,defaultDefaultValue:I,source:k.$Vf(s)?void 0:s,defaultValueSource:s};t.push(...O(o)),this.d[o]=z,this.b.properties[o]=z}else{this.a.set(o,{value:n[o],source:s});const l=this.d[o];l&&(this.w(o,l),this.r(o,l))}this.m(t)}deregisterDefaultConfigurations(i){const r=new Set;this.l(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(i,r){for(const{overrides:t,source:n}of i)for(const s in t){const o=this.a.get(s),l=k.$Vf(n)?n:n?.id,P=k.$Vf(o?.source)?o?.source:o?.source?.id;if(l===P)if(r.add(s),this.a.delete(s),e.$do.test(s))delete this.d[s],delete this.b.properties[s];else{const I=this.d[s];I&&(this.w(s,I),this.r(s,I))}}this.u()}deltaConfiguration(i){let r=!1;const t=new Set;i.removedDefaults&&(this.l(i.removedDefaults,t),r=!0),i.addedDefaults&&(this.k(i.addedDefaults,t),r=!0),i.removedConfigurations&&this.o(i.removedConfigurations,t),i.addedConfigurations&&this.n(i.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const r of i)this.h.add(r);this.u()}n(i,r,t){i.forEach(n=>{this.p(n,r,n.extensionInfo,n.restrictedProperties,void 0,t),this.c.push(n),this.q(n)})}o(i,r){const t=n=>{if(n.properties)for(const s in n.properties){r.add(s);const o=this.d[s];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[s],this.s(s,n.properties[s])}n.allOf?.forEach(s=>t(s))};for(const n of i){t(n);const s=this.c.indexOf(n);s!==-1&&this.c.splice(s,1)}}p(i,r=!0,t,n,s=3,o){s=k.$5f(i.scope)?s:i.scope;const l=i.properties;if(l)for(const I in l){const L=l[I];if(r&&$(I,L)){delete l[I];continue}if(L.source=t,L.defaultDefaultValue=l[I].default,this.w(I,L),e.$do.test(I)?L.scope=void 0:(L.scope=k.$5f(L.scope)?s:L.scope,L.restricted=k.$5f(L.restricted)?!!n?.includes(I):L.restricted),l[I].hasOwnProperty("included")&&!l[I].included){this.f[I]=l[I],delete l[I];continue}else this.d[I]=l[I],l[I].policy?.name&&this.e.set(l[I].policy.name,I);!l[I].deprecationMessage&&l[I].markdownDeprecationMessage&&(l[I].deprecationMessage=l[I].markdownDeprecationMessage),o.add(I)}const P=i.allOf;if(P)for(const I of P)this.p(I,r,t,n,s,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const r=t=>{const n=t.properties;if(n)for(const o in n)this.r(o,n[o]);t.allOf?.forEach(r)};r(i)}r(i,r){switch(e.$7n.properties[i]=r,r.scope){case 1:e.$8n.properties[i]=r;break;case 2:e.$9n.properties[i]=r;break;case 6:e.$0n.properties[i]=r;break;case 3:e.$$n.properties[i]=r;break;case 4:e.$_n.properties[i]=r;break;case 5:e.$_n.properties[i]=r,this.g.properties[i]=r;break}}s(i,r){switch(delete e.$7n.properties[i],r.scope){case 1:delete e.$8n.properties[i];break;case 2:delete e.$9n.properties[i];break;case 6:delete e.$0n.properties[i];break;case 3:delete e.$$n.properties[i];break;case 4:case 5:delete e.$_n.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const r=`[${i}]`,t={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$ao};this.w(r,t),e.$7n.properties[r]=t,e.$8n.properties[r]=t,e.$9n.properties[r]=t,e.$0n.properties[r]=t,e.$$n.properties[r]=t,e.$_n.properties[r]=t}}v(){const i={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$ao};e.$7n.patternProperties[e.$co]=i,e.$8n.patternProperties[e.$co]=i,e.$9n.patternProperties[e.$co]=i,e.$0n.patternProperties[e.$co]=i,e.$$n.patternProperties[e.$co]=i,e.$_n.patternProperties[e.$co]=i,this.i.fire()}w(i,r){const t=this.a.get(i);let n=t?.value,s=t?.source;k.$3f(n)&&(n=r.defaultDefaultValue,s=void 0),k.$3f(n)&&(n=c(r.type)),r.default=n,r.defaultValueSource=s}}const p="\\[([^\\]]+)\\]",w=new RegExp(p,"g");e.$co=`^(${p})+$`,e.$do=new RegExp(e.$co);function O(g){const i=[];if(e.$do.test(g)){let r=w.exec(g);for(;r?.length;){const t=r[1].trim();t&&i.push(t),r=w.exec(g)}}return(0,D.$Mb)(i)}function m(g){return g.reduce((i,r)=>`${i}[${r}]`,"")}function c(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const b=new d;u.$1n.add(e.$6n.Configuration,b);function $(g,i){return g.trim()?e.$do.test(g)?A.localize(7,null,g):b.getConfigurationProperties()[g]!==void 0?A.localize(8,null,g):i.policy?.name&&b.getPolicyConfigurations().get(i.policy?.name)!==void 0?A.localize(9,null,g,i.policy?.name,b.getPolicyConfigurations().get(i.policy?.name)):null:A.localize(6,null)}function h(){const g=[],i=b.getConfigurationProperties();for(const r of Object.keys(i))g.push([r,i[r].scope]);return g.push(["launch",4]),g.push(["task",4]),g}}),define(ne[66],re([0,1,19,5,38,2,31,27,3,11,29,40,36]),function(J,e,D,j,k,A,R,S,u,a,y,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$mo=e.$lo=e.$ko=e.$jo=void 0,e.$no=$;function p(r){return Object.isFrozen(r)?r:S.$Pn(r)}class w{constructor(t={},n=[],s=[],o){this.b=t,this.c=n,this.d=s,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(n=>{if(n instanceof w)return n;const s=new O("");return s.parseRaw(n),s.configurationModel});this.f=t.reduce((n,s)=>s===n?s:n.merge(s),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,y.$Wi)(this.contents,t):this.contents}inspect(t,n){const s=this;return{get value(){return p(s.rawConfiguration.getValue(t))},get override(){return n?p(s.rawConfiguration.getOverrideValue(t,n)):void 0},get merged(){return p(n?s.rawConfiguration.override(n).getValue(t):s.rawConfiguration.getValue(t))},get overrides(){const o=[];for(const{contents:l,identifiers:P,keys:I}of s.rawConfiguration.overrides){const L=new w(l,I).getValue(t);L!==void 0&&o.push({identifiers:P,value:L})}return o.length?p(o):void 0}}}getOverrideValue(t,n){const s=this.i(n);return s?t?(0,y.$Wi)(s,t):s:void 0}getKeysForOverrideIdentifier(t){const n=[];for(const s of this.overrides)s.identifiers.includes(t)&&n.push(...s.keys);return D.$Mb(n)}getAllOverrideIdentifiers(){const t=[];for(const n of this.overrides)t.push(...n.identifiers);return D.$Mb(t)}override(t){let n=this.a.get(t);return n||(n=this.g(t),this.a.set(t,n)),n}merge(...t){const n=S.$On(this.contents),s=S.$On(this.overrides),o=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const P of t)if(l.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.h(n,P.contents);for(const I of P.overrides){const[L]=s.filter(z=>D.$ub(z.identifiers,I.identifiers));L?(this.h(L.contents,I.contents),L.keys.push(...I.keys),L.keys=D.$Mb(L.keys)):s.push(S.$On(I))}for(const I of P.keys)o.indexOf(I)===-1&&o.push(I)}return new w(n,o,s,l.every(P=>P instanceof w)?void 0:l)}g(t){const n=this.i(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const s={};for(const o of D.$Mb([...Object.keys(this.contents),...Object.keys(n)])){let l=this.contents[o];const P=n[o];P&&(typeof l=="object"&&typeof P=="object"?(l=S.$On(l),this.h(l,P)):l=P),s[o]=l}return new w(s,this.keys,this.overrides)}h(t,n){for(const s of Object.keys(n)){if(s in t&&u.$Xf(t[s])&&u.$Xf(n[s])){this.h(t[s],n[s]);continue}t[s]=S.$On(n[s])}}i(t){let n=null,s=null;const o=l=>{l&&(s?this.h(s,l):s=S.$On(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===t?n=l.contents:l.identifiers.includes(t)&&o(l.contents);return o(n),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,n){this.j(t,n,!0)}setValue(t,n){this.j(t,n,!1)}removeValue(t){const n=this.keys.indexOf(t);n!==-1&&(this.keys.splice(n,1),(0,y.$Vi)(this.contents,t),v.$do.test(t)&&this.overrides.splice(this.overrides.findIndex(s=>D.$ub(s.identifiers,(0,v.$eo)(t))),1))}j(t,n,s){(0,y.$Ui)(this.contents,t,n,o=>console.error(o)),s=s||this.keys.indexOf(t)===-1,s&&this.keys.push(t),v.$do.test(t)&&this.overrides.push({identifiers:(0,v.$eo)(t),keys:Object.keys(this.contents[t]),contents:(0,y.$Ti)(this.contents[t],o=>console.error(o))})}}e.$jo=w;class O{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new w}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,n){if(!u.$5f(t)){const s=this.g(t);this.parseRaw(s,n)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,n){this.a=t;const{contents:s,keys:o,overrides:l,restricted:P,hasExcludedProperties:I}=this.h(t,n);this.b=new w(s,o,l,I?[t]:void 0),this.c=P||[]}g(t){let n={},s=null,o=[];const l=[],P=[];function I(z){Array.isArray(o)?o.push(z):s!==null&&(o[s]=z)}const L={onObjectBegin:()=>{const z={};I(z),l.push(o),o=z,s=null},onObjectProperty:z=>{s=z},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const z=[];I(z),l.push(o),o=z,s=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:I,onError:(z,U,V)=>{P.push({error:z,offset:U,length:V})}};if(t)try{k.$Cn(t,L),n=o[0]||{}}catch(z){console.error(`Error while parsing settings file ${this.f}: ${z}`),this.d=[z]}return n}h(t,n){const s=d.$1n.as(v.$6n.Configuration).getConfigurationProperties(),o=this.i(t,s,!0,n);t=o.raw;const l=(0,y.$Ti)(t,L=>console.error(`Conflict in settings file ${this.f}: ${L}`)),P=Object.keys(t),I=this.j(t,L=>console.error(`Conflict in settings file ${this.f}: ${L}`));return{contents:l,keys:P,overrides:I,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(t,n,s,o){let l=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:l};const P={},I=[];for(const L in t)if(v.$do.test(L)&&s){const z=this.i(t[L],n,!1,o);P[L]=z.raw,l=l||z.hasExcludedProperties,I.push(...z.restricted)}else{const z=n[L],U=z?typeof z.scope<"u"?z.scope:3:void 0;z?.restricted&&I.push(L),!o.exclude?.includes(L)&&(o.include?.includes(L)||(U===void 0||o.scopes===void 0||o.scopes.includes(U))&&!(o.skipRestricted&&z?.restricted))?P[L]=t[L]:l=!0}return{raw:P,restricted:I,hasExcludedProperties:l}}j(t,n){const s=[];for(const o of Object.keys(t))if(v.$do.test(o)){const l={};for(const P in t[o])l[P]=t[o][P];s.push({identifiers:(0,v.$eo)(o),keys:Object.keys(l),contents:(0,y.$Ti)(l,n)})}return s}}e.$ko=O;class m extends A.$Uc{constructor(t,n,s,o){super(),this.c=t,this.f=n,this.g=o,this.b=this.B(new j.$7d),this.onDidChange=this.b.event,this.a=new O(this.c.toString()),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(j.Event.any(j.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),j.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&s.isEqual(l.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new w}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$lo=m;class c{constructor(t,n,s,o,l,P,I,L,z,U,V,X,se){this.a=t,this.b=n,this.c=s,this.overrideIdentifiers=o,this.d=l,this.f=P,this.g=I,this.h=L,this.i=z,this.j=U,this.k=V,this.l=X,this.m=se}get value(){return p(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class b{constructor(t,n,s,o,l=new w,P=new w,I=new R.$Bc,L=new w,z=new R.$Bc){this.c=t,this.d=n,this.f=s,this.g=o,this.h=l,this.i=P,this.j=I,this.l=L,this.m=z,this.a=null,this.b=new R.$Bc,this.n=null}getValue(t,n,s){return this.p(t,n,s).getValue(t)}updateValue(t,n,s={}){let o;s.resource?(o=this.m.get(s.resource),o||(o=new w,this.m.set(s.resource,o))):o=this.l,n===void 0?o.removeValue(t):o.setValue(t,n),s.resource||(this.a=null)}inspect(t,n,s){const o=this.p(t,n,s),l=this.t(n.resource,s),P=n.resource?this.m.get(n.resource)||this.l:this.l,I=new Set;for(const L of o.overrides)for(const z of L.identifiers)o.getOverrideValue(t,z)!==void 0&&I.add(z);return new c(t,n,o.getValue(t),I.size?[...I]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,l||void 0,P)}keys(t){const n=this.t(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,n){this.j.set(t,n),this.b.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const s=[];if(!n){const{added:o,updated:l,removed:P}=g(this.c,t);n=[...o,...l,...P]}for(const o of n)for(const l of(0,v.$eo)(o)){const P=this.c.getKeysForOverrideIdentifier(l),I=t.getKeysForOverrideIdentifier(l),L=[...I.filter(z=>P.indexOf(z)===-1),...P.filter(z=>I.indexOf(z)===-1),...P.filter(z=>!S.$Sn(this.c.override(l).getValue(z),t.override(l).getValue(z)))];s.push([l,L])}return this.updateDefaultConfiguration(t),{keys:n,overrides:s}}compareAndUpdatePolicyConfiguration(t){const{added:n,updated:s,removed:o}=g(this.d,t),l=[...n,...s,...o];return l.length&&this.updatePolicyConfiguration(t),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=g(this.applicationConfiguration,t),P=[...n,...s,...o];return P.length&&this.updateApplicationConfiguration(t),{keys:P,overrides:l}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=g(this.localUserConfiguration,t),P=[...n,...s,...o];return P.length&&this.updateLocalUserConfiguration(t),{keys:P,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=g(this.remoteUserConfiguration,t),P=[...n,...s,...o];return P.length&&this.updateRemoteUserConfiguration(t),{keys:P,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:s,removed:o,overrides:l}=g(this.workspaceConfiguration,t),P=[...n,...s,...o];return P.length&&this.updateWorkspaceConfiguration(t),{keys:P,overrides:l}}compareAndUpdateFolderConfiguration(t,n){const s=this.folderConfigurations.get(t),{added:o,updated:l,removed:P,overrides:I}=g(s,n),L=[...o,...l,...P];return(L.length||!s)&&this.updateFolderConfiguration(t,n),{keys:L,overrides:I}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:o,removed:l,overrides:P}=g(n,void 0);return{keys:[...s,...o,...l],overrides:P}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(t,n,s){let o=this.q(n,s);return n.overrideIdentifier&&(o=o.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(o=o.merge(this.d)),o}q({resource:t},n){let s=this.r();if(n&&t){const o=n.getFolder(t);o&&(s=this.s(o.uri)||s);const l=this.m.get(t);l&&(s=s.merge(l))}return s}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(t){let n=this.b.get(t);if(!n){const s=this.r(),o=this.j.get(t);o?(n=s.merge(o),this.b.set(t,n)):n=s}return n}t(t,n){if(n&&t){const s=n.getFolder(t);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,n)=>{const{contents:s,overrides:o,keys:l}=this.j.get(n);return t.push([n,{contents:s,overrides:o,keys:l}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(n=>t.add(n)),this.userConfiguration.keys.forEach(n=>t.add(n)),this.i.keys.forEach(n=>t.add(n)),this.j.forEach(n=>n.keys.forEach(s=>t.add(s))),[...t.values()]}u(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(s=>t.add(s))),[...t.values()]}v(t){const n=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.i.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o))),[...n.values()]}static parse(t){const n=this.w(t.defaults),s=this.w(t.policy),o=this.w(t.application),l=this.w(t.user),P=this.w(t.workspace),I=t.folders.reduce((L,z)=>(L.set(a.URI.revive(z[0]),this.w(z[1])),L),new R.$Bc);return new b(n,s,o,l,new w,P,I,new w,new R.$Bc)}static w(t){return new w(t.contents,t.keys,t.overrides)}}e.$mo=b;function $(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,n=new Map;for(const o of r)o.keys.forEach(l=>t.add(l)),o.overrides.forEach(([l,P])=>{const I=(0,R.$yc)(n,l,new Set);P.forEach(L=>I.add(L))});const s=[];return n.forEach((o,l)=>s.push([l,[...o.values()]])),{keys:[...t.values()],overrides:s}}class h{constructor(t,n,s,o){this.change=t,this.f=n,this.g=s,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const l of t.keys)this.affectedKeys.add(l);for(const[,l]of t.overrides)for(const P of l)this.affectedKeys.add(P);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=b.parse(this.f.data)),this.i}affectsConfiguration(t,n){const s=this.a+t,o=this.d.indexOf(s);if(o<0)return!1;const l=o+s.length;if(l>=this.d.length)return!1;const P=this.d.charCodeAt(l);if(P!==this.b&&P!==this.c)return!1;if(n){const I=this.previousConfiguration?this.previousConfiguration.getValue(t,n,this.f?.workspace):void 0,L=this.g.getValue(t,n,this.h);return!S.$Sn(I,L)}return!0}}e.$oo=h;function g(r,t){const{added:n,removed:s,updated:o}=i(t?.rawConfiguration,r?.rawConfiguration),l=[],P=r?.getAllOverrideIdentifiers()||[],I=t?.getAllOverrideIdentifiers()||[];if(t){const L=I.filter(z=>!P.includes(z));for(const z of L)l.push([z,t.getKeysForOverrideIdentifier(z)])}if(r){const L=P.filter(z=>!I.includes(z));for(const z of L)l.push([z,r.getKeysForOverrideIdentifier(z)])}if(t&&r){for(const L of P)if(I.includes(L)){const z=i({contents:r.getOverrideValue(void 0,L)||{},keys:r.getKeysForOverrideIdentifier(L)},{contents:t.getOverrideValue(void 0,L)||{},keys:t.getKeysForOverrideIdentifier(L)});l.push([L,[...z.added,...z.removed,...z.updated]])}}return{added:n,removed:s,updated:o,overrides:l}}function i(r,t){const n=r?t?r.keys.filter(l=>t.keys.indexOf(l)===-1):[...r.keys]:[],s=t?r?t.keys.filter(l=>r.keys.indexOf(l)===-1):[...t.keys]:[],o=[];if(r&&t){for(const l of t.keys)if(r.keys.indexOf(l)!==-1){const P=(0,y.$Wi)(t.contents,l),I=(0,y.$Wi)(r.contents,l);S.$Sn(P,I)||o.push(l)}}return{added:n,removed:s,updated:o}}}),define(ne[138],re([0,1,19,5,2,27,3,66,40,6,39,36]),function(J,e,D,j,k,A,R,S,u,a,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=e.$qo=e.$po=void 0;class d extends k.$Uc{constructor(){super(...arguments),this.a=this.B(new j.$7d),this.onDidChangeConfiguration=this.a.event,this.b=new S.$jo}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(v.$1n.as(u.$6n.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:c})=>this.c(Array.from(m),c))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(m,c){this.h(m,v.$1n.as(u.$6n.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:m})}f(){return{}}g(){this.b=new S.$jo;const m=v.$1n.as(u.$6n.Configuration).getConfigurationProperties();this.h(Object.keys(m),m)}h(m,c){const b=this.f();for(const $ of m){const h=b[$],g=c[$];h!==void 0?this.b.addValue($,h):g?this.b.addValue($,g.default):this.b.removeValue($)}}}e.$po=d;class p{constructor(){this.onDidChangeConfiguration=j.Event.None,this.configurationModel=new S.$jo}async initialize(){return this.configurationModel}}e.$qo=p;let w=class extends k.$Uc{get configurationModel(){return this.b}constructor(m,c,b){super(),this.c=m,this.f=c,this.g=b,this.a=this.B(new j.$7d),this.onDidChangeConfiguration=this.a.event,this.b=new S.$jo}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(m=>this.j(m))),this.B(this.c.onDidChangeConfiguration(async({properties:m})=>this.m(await this.h(m),!0))),this.b}async h(m){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",m);const c={},b=[],$=v.$1n.as(u.$6n.Configuration).getConfigurationProperties();for(const h of m){const g=$[h];if(!g){b.push(h);continue}if(g.policy){if(g.type!=="string"&&g.type!=="number"){this.g.warn(`Policy ${g.policy.name} has unsupported type ${g.type}`);continue}b.push(h),c[g.policy.name]={type:g.type}}}return(0,R.$9f)(c)||await this.f.updatePolicyDefinitions(c),b}j(m){this.g.trace("PolicyConfiguration#onDidChangePolicies",m);const c=v.$1n.as(u.$6n.Configuration).getPolicyConfigurations(),b=(0,D.$Hb)(m.map($=>c.get($)));this.m(b,!0)}m(m,c){this.g.trace("PolicyConfiguration#update",m);const b=v.$1n.as(u.$6n.Configuration).getConfigurationProperties(),$=[],h=this.b.isEmpty();for(const g of m){const i=b[g]?.policy?.name;if(i){const r=this.f.getPolicyValue(i);(h?r!==void 0:!(0,A.$Sn)(this.b.getValue(g),r))&&$.push([g,r])}else this.b.getValue(g)!==void 0&&$.push([g,void 0])}if($.length){this.g.trace("PolicyConfiguration#changed",$);const g=this.b;this.b=new S.$jo;for(const i of g.keys)this.b.setValue(i,g.getValue(i));for(const[i,r]of $)r===void 0?this.b.removeValue(i):this.b.setValue(i,r);c&&this.a.fire(this.b)}}};e.$ro=w,e.$ro=w=$e([oe(1,y.$3n),oe(2,a.$Oj)],w)}),define(ne[139],re([0,1,19,9,14,5,38,74,2,27,12,17,29,66,40,138,39]),function(J,e,D,j,k,A,R,S,u,a,y,v,d,p,w,O,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=void 0;class c extends u.$Uc{constructor(h,g,i,r){super(),this.m=h,this.h=this.B(new A.$7d),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new O.$po),this.c=i instanceof m.$5n?new O.$qo:this.B(new O.$ro(this.b,i,r)),this.f=this.B(new p.$lo(this.m,{},v.$Mg,g)),this.a=new p.$mo(this.b.configurationModel,this.c.configurationModel,new p.$jo,new p.$jo),this.j=new b(h,g,this),this.g=this.B(new j.$uh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:t,properties:n})=>this.r(t,n))),this.B(this.c.onDidChangeConfiguration(t=>this.s(t))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[h,g,i]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new p.$mo(h,g,new p.$jo,i)}getConfigurationData(){return this.a.toData()}getValue(h,g){const i=typeof h=="string"?h:void 0,r=(0,d.$Pi)(h)?h:(0,d.$Pi)(g)?g:{};return this.a.getValue(i,r,void 0)}async updateValue(h,g,i,r,t){const n=(0,d.$Qi)(i)?i:(0,d.$Pi)(i)?{resource:i.resource,overrideIdentifiers:i.overrideIdentifier?[i.overrideIdentifier]:void 0}:void 0,s=n?r:i;if(s!==void 0&&s!==3&&s!==2)throw new Error(`Unable to write ${h} to target ${s}.`);n?.overrideIdentifiers&&(n.overrideIdentifiers=(0,D.$Mb)(n.overrideIdentifiers),n.overrideIdentifiers=n.overrideIdentifiers.length?n.overrideIdentifiers:void 0);const o=this.inspect(h,{resource:n?.resource,overrideIdentifier:n?.overrideIdentifiers?n.overrideIdentifiers[0]:void 0});if(o.policyValue!==void 0)throw new Error(`Unable to write ${h} because it is configured in system policy.`);if((0,a.$Sn)(g,o.defaultValue)&&(g=void 0),n?.overrideIdentifiers?.length&&n.overrideIdentifiers.length>1){const P=n.overrideIdentifiers.sort(),I=this.a.localUserConfiguration.overrides.find(L=>(0,D.$ub)([...L.identifiers].sort(),P));I&&(n.overrideIdentifiers=I.identifiers)}const l=n?.overrideIdentifiers?.length?[(0,w.$fo)(n.overrideIdentifiers),h]:[h];await this.j.write(l,g),await this.reloadConfiguration()}inspect(h,g={}){return this.a.inspect(h,g,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const h=await this.f.loadConfiguration();this.n(h)}n(h){const g=this.a.toData(),i=this.a.compareAndUpdateLocalUserConfiguration(h);this.t(i,g,2)}r(h,g){const i=this.a.toData(),r=this.a.compareAndUpdateDefaultConfiguration(h,g);this.t(r,i,7)}s(h){const g=this.a.toData(),i=this.a.compareAndUpdatePolicyConfiguration(h);this.t(i,g,7)}t(h,g,i){const r=new p.$oo(h,{data:g},this.a);r.source=i,this.h.fire(r)}}e.$so=c;class b{constructor(h,g,i){this.b=h,this.c=g,this.d=i,this.a=new j.$ph}write(h,g){return this.a.queue(()=>this.e(h,g))}async e(h,g){let i;try{i=(await this.c.readFile(this.b)).value.toString()}catch(n){if(n.fileOperationResult===1)i="{}";else throw n}const r=[];if((0,R.$vn)(i,r,{allowTrailingComma:!0,allowEmptyContent:!0}),r.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const t=this.f(i,h,g);i=(0,S.$Nn)(i,t),await this.c.writeFile(this.b,k.$ue.fromString(i))}f(h,g,i){const{tabSize:r,insertSpaces:t,eol:n}=this.h;if(!g.length){const s=JSON.stringify(i,null,t?" ".repeat(r):"	");return[{content:s,length:s.length,offset:0}]}return(0,S.$Kn)(h,g,i,{tabSize:r,insertSpaces:t,eol:n})}get h(){if(!this.g){let h=y.OS===3||y.OS===2?`
`:`\r
`;const g=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});g&&typeof g=="string"&&g!=="auto"&&(h=g),this.g={eol:h,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ne[67],re([0,1,15]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=j,e.$um=k,e.$vm=A,e.$wm=R;function j(u){return u.scheme===D.Schemas.vscodeRemote?u.authority:void 0}function k(u){if(!u)return;const a=u.indexOf("+");return a<0?u:u.substr(0,a)}function A(u){const{host:a,port:y}=S(u);if(typeof y>"u")throw new Error(`Invalid remote authority: ${u}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:y}}function R(u,a){let{host:y,port:v}=S(u);return typeof v>"u"&&(v=a),{host:y,port:v}}function S(u){const a=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const y=u.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const v=u.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:u,port:void 0}}}),define(ne[37],re([0,1,30,10,67]),function(J,e,D,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Km=e.$Fm=e.$Em=e.$Dm=e.TargetPlatform=e.ExtensionType=e.$Cm=e.$Am=e.$zm=e.$ym=e.$xm=void 0,e.$Bm=A,e.$Gm=v,e.$Hm=d,e.$Im=p,e.$Jm=w,e.$xm="extensions.user.cache",e.$ym="extensions.builtin.cache",e.$zm="undefined_publisher",e.$Am=["ui","workspace","web"];function A(O){if(typeof O=="object"&&O!==null&&O.supported!==!0)return O.description}e.$Cm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var R;(function(O){O[O.System=0]="System",O[O.User=1]="User"})(R||(e.ExtensionType=R={}));var S;(function(O){O.WIN32_X64="win32-x64",O.WIN32_ARM64="win32-arm64",O.LINUX_X64="linux-x64",O.LINUX_ARM64="linux-arm64",O.LINUX_ARMHF="linux-armhf",O.ALPINE_X64="alpine-x64",O.ALPINE_ARM64="alpine-arm64",O.DARWIN_X64="darwin-x64",O.DARWIN_ARM64="darwin-arm64",O.WEB="web",O.UNIVERSAL="universal",O.UNKNOWN="unknown",O.UNDEFINED="undefined"})(S||(e.TargetPlatform=S={}));class u{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,c){if(typeof m>"u"||m===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof m=="string"||typeof c=="string"){const b=typeof m=="string"?m:m.value,$=typeof c=="string"?c:c.value;return D.$lf(b,$)}return m._lower===c._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$Dm=u;class a{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const c of m)this.add(c)}add(m){this.c.add(u.toKey(m))}delete(m){return this.c.delete(u.toKey(m))}has(m){return this.c.has(u.toKey(m))}}e.$Em=a;class y{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete(u.toKey(m))}get(m){return this.c.get(u.toKey(m))}has(m){return this.c.has(u.toKey(m))}set(m,c){this.c.set(u.toKey(m),c)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Fm=y;function v(O){return d(O)}function d(O){return O.contributes&&O.contributes.localizations?O.contributes.localizations.length>0:!1}function p(O){return O.contributes&&O.contributes.authentication?O.contributes.authentication.length>0:!1}function w(O,m){if(m){const c=`onResolveRemoteAuthority:${(0,k.$um)(m)}`;return!!O.activationEvents?.includes(c)}return!1}e.$Km=(0,j.$ii)("IBuiltinExtensionsScannerService")}),define(ne[140],re([0,1,2,37,13]),function(J,e,D,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=void 0;class A extends D.$Uc{constructor(S,u,a,y,v){super(),this.a=S,this.b=u,this.c=a,this.f=v,this.B(y.onDidInstallExtensions(d=>this.g(d))),this.B(y.onDidUninstallExtension(d=>this.h(d)))}g(S){for(const u of S)u.local&&this.invalidate(u.profileLocation)}h(S){S.error||this.invalidate(S.profileLocation)}async invalidate(S){if(S)for(const u of this.a.profiles)this.c.extUri.isEqual(u.extensionsResource,S)&&await this.j(u);else await this.j(this.a.defaultProfile)}async j(S){try{await this.b.del(this.c.extUri.joinPath(S.cacheHome,j.$xm))}catch(u){(0,k.$6k)(u)!==1&&this.f.error(u)}}}e.$nq=A}),define(ne[45],re([0,1,14,8,2,107,40,10,6,36]),function(J,e,D,j,k,A,R,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=e.$zp=void 0,e.$Bp=d,e.$Cp=p,e.$Dp=w,e.$Ep=O,e.$Fp=m,e.$Gp=c,e.$zp=(0,S.$ii)("requestService");class y{constructor(g){this.b=g}toJSON(){if(!this.a){const g=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?g[i]="*****":g[i]=this.b[i];this.a=g}return this.a}}class v extends k.$Uc{constructor(g){super(),this.b=0,this.a=g.createLogger("network",{name:(0,A.localize)(0,null),when:u.$7j.isEqualTo((0,u.$4j)(u.LogLevel.Trace)).serialize()})}async c(g,i,r){const t=`${g} #${++this.b}: ${i.url}`;this.a.trace(`${t} - begin`,i.type,new y(i.headers??{}));try{const n=await r();return this.a.trace(`${t} - end`,i.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${t} - error`,i.type,(0,j.$0)(n)),n}}}e.$Ap=v;function d(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}function p(h){return h.res.statusCode===204}async function w(h){return p(h)?null:(await(0,D.$Ge)(h.stream)).toString()}async function O(h){if(!d(h))throw new Error("Server returned "+h.res.statusCode);return w(h)}async function m(h){if(!d(h))throw new Error("Server returned "+h.res.statusCode);if(p(h))return null;const i=(await(0,D.$Ge)(h.stream)).toString();try{return JSON.parse(i)}catch(r){throw r.message+=`:
`+i,r}}function c(h){$(h)}let b;function $(h){const g=a.$1n.as(R.$6n.Configuration),i=b;b={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},g.updateConfigurations({add:[b],remove:i?[i]:[]})}$(1)}),define(ne[141],re([0,1,20,15,13,45]),function(J,e,D,j,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hQ=void 0;let R=class{constructor(u,a){this.a=u,this.b=a}async download(u,a,y=D.CancellationToken.None){if(u.scheme===j.Schemas.file||u.scheme===j.Schemas.vscodeRemote){await this.b.copy(u,a);return}const v={type:"GET",url:u.toString(!0)},d=await this.a.request(v,y);if(d.res.statusCode===200)await this.b.writeFile(a,d.stream);else{const p=await(0,A.$Ep)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${p}`)}}};e.$hQ=R,e.$hQ=R=$e([oe(0,A.$zp),oe(1,k.$Ok)],R)}),define(ne[142],re([0,1,143,3]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gr=A;function k(R,S){return R.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:R.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function A(R,S,u={}){const a=(0,D.parse)(R),y=u.proxyUrl||k(a,S);if(!y)return null;const v=(0,D.parse)(y);if(!/^https?:$/.test(v.protocol||""))return null;const d={host:v.hostname||"",port:(v.port?+v.port:0)||(v.protocol==="https"?443:80),auth:v.auth,rejectUnauthorized:(0,j.$2f)(u.strictSSL)?u.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((p,w)=>{J(["http-proxy-agent"],p,w)})).HttpProxyAgent(y,d):new(await new Promise((p,w)=>{J(["https-proxy-agent"],p,w)})).HttpsProxyAgent(y,d)}}),define(ne[144],re([0,1,59,16,108,20,34,8,12,28,87,175,9,75]),function(J,e,D,j,k,A,R,S,u,a,y,v,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=O;let w;async function O(c,b,$,h){return $["force-disable-user-env"]?(b.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$i?(b.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.$mm)(h)&&!$["force-user-env"]?(b.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.$mm)(h)?b.trace("resolveShellEnv(): running (--force-user-env)"):b.trace("resolveShellEnv(): running (macOS/Linux)"),w||(w=d.Promises.withAsyncBody(async(g,i)=>{const r=new A.$ee;let t=1e4;const n=c.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(t=(0,p.$nm)(n,1,120)*1e3);const s=setTimeout(()=>{r.dispose(!0),i(new Error((0,k.localize)(0,null)))},t);try{g(await m(b,r.token))}catch(o){!(0,S.$4)(o)&&!r.token.isCancellationRequested?i(new Error((0,k.localize)(1,null,(0,R.$6i)(o)))):g({})}finally{clearTimeout(s),r.dispose()}})),w)}async function m(c,b){const $=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",$);const h=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",h);const g=(0,a.$Eg)().replace(/-/g,"").substr(0,12),i=new RegExp(g+"({.*})"+g),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};c.trace("getUnixShellEnvironment#env",r);const t=await(0,y.$cm)(u.OS,r);return c.trace("getUnixShellEnvironment#shell",t),new Promise((n,s)=>{if(b.isCancellationRequested)return s(new S.$5);const o=(0,j.$oc)(t);let l,P;const I="";/^pwsh(-preview)?$/.test(o)?(l=`& '${process.execPath}' ${I} -p '''${g}'' + JSON.stringify(process.env) + ''${g}'''`,P=["-Login","-Command"]):o==="nu"?(l=`^'${process.execPath}' ${I} -p '"${g}" + JSON.stringify(process.env) + "${g}"'`,P=["-i","-l","-c"]):o==="xonsh"?(l=`import os, json; print("${g}", json.dumps(dict(os.environ)), "${g}")`,P=["-i","-l","-c"]):(l=`'${process.execPath}' ${I} -p '"${g}" + JSON.stringify(process.env) + "${g}"'`,o==="tcsh"||o==="csh"?P=["-ic"]:P=["-i","-l","-c"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),l);const L=(0,D.spawn)(t,[...P,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});b.onCancellationRequested(()=>(L.kill(),s(new S.$5))),L.on("error",V=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,R.$6i)(V)),s(V)});const z=[];L.stdout.on("data",V=>z.push(V));const U=[];L.stderr.on("data",V=>U.push(V)),L.on("close",(V,X)=>{const se=Buffer.concat(z).toString("utf8");c.trace("getUnixShellEnvironment#raw",se);const ie=Buffer.concat(U).toString("utf8");if(ie.trim()&&c.trace("getUnixShellEnvironment#stderr",ie),V||X)return s(new Error((0,k.localize)(2,null,V,X)));const ue=i.exec(se),he=ue?ue[1]:"{}";try{const ce=JSON.parse(he);$?ce.ELECTRON_RUN_AS_NODE=$:delete ce.ELECTRON_RUN_AS_NODE,h?ce.ELECTRON_NO_ATTACH_CONSOLE=h:delete ce.ELECTRON_NO_ATTACH_CONSOLE,delete ce.VSCODE_RESOLVING_ENVIRONMENT,delete ce.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",ce),n(ce)}catch(ce){c.error("getUnixShellEnvironment#errorCaught",(0,R.$6i)(ce)),s(ce)}})})}}),define(ne[145],re([0,1,10]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WP=e.$VP=void 0,e.$VP=(0,D.$ii)("stateReadService"),e.$WP=(0,D.$ii)("stateService")}),define(ne[68],re([0,1,9,14,2,3,18,13,6]),function(J,e,D,j,k,A,R,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZP=e.$YP=e.$XP=e.SaveStrategy=void 0;var a;(function(p){p[p.IMMEDIATE=0]="IMMEDIATE",p[p.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class y extends k.$Uc{constructor(w,O,m,c){super(),this.h=w,this.j=O,this.m=m,this.n=c,this.a=Object.create(null),this.b="",this.c=this.B(new D.$gh(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(w){w.fileOperationResult!==1&&this.m.error(w)}}getItem(w,O){const m=this.a[w];return(0,A.$5f)(m)?O:m}setItem(w,O){this.setItems([{key:w,data:O}])}setItems(w){let O=!1;for(const{key:m,data:c}of w)this.a[m]!==c&&((0,A.$5f)(c)?(0,A.$3f)(this.a[m])||(this.a[m]=void 0,O=!0):(this.a[m]=c,O=!0));O&&this.s()}removeItem(w){(0,A.$3f)(this.a[w])||(this.a[w]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const w=JSON.stringify(this.a,null,4);if(w!==this.b)try{await this.n.writeFile(this.h,j.$ue.fromString(w),{atomic:{postfix:".vsctmp"}}),this.b=w}catch(O){this.m.error(O)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$XP=y;let v=class extends k.$Uc{constructor(w,O,m,c){super(),this.a=this.B(new y(O.stateResource,w,m,c))}async init(){await this.a.init()}getItem(w,O){return this.a.getItem(w,O)}};e.$YP=v,e.$YP=v=$e([oe(1,R.$pi),oe(2,u.$Oj),oe(3,S.$Ok)],v);class d extends v{setItem(w,O){this.a.setItem(w,O)}setItems(w){this.a.setItems(w)}removeItem(w){this.a.removeItem(w)}close(){return this.a.close()}}e.$ZP=d}),define(ne[69],re([0,1,12,35,28]),function(J,e,D,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=R,e.$3o=S;function A(u){if(D.$u===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function R(u,a,y,v,d,p,w,O,m){const c=Object.create(null);c["common.machineId"]=p,c["common.sqmId"]=w,c.sessionID=(0,k.$Eg)()+Date.now(),c.commitHash=v,c.version=d,c["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,D.$h)(D.$u),c["common.nodePlatform"]=j.$ec,c["common.nodeArch"]=y,c["common.product"]=m||"desktop",O&&(c["common.msftInternal"]=O);let b=0;const $=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-$,enumerable:!0},"common.sequence":{get:()=>b++,enumerable:!0}}),D.$l&&(c["common.snap"]="true");const h=A(a);return h&&(c["common.platformDetail"]=h),c}function S(u){const a=j.env.USERDNSDOMAIN;if(!a)return!1;const y=a.toLowerCase();return u.some(v=>y===v)}}),define(ne[22],re([0,1,10]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=void 0,e.$Nl=(0,D.$ii)("telemetryService"),e.$Ol=(0,D.$ii)("customEndpointTelemetryService"),e.$Pl="telemetry.currentSessionDate",e.$Ql="telemetry.firstSessionDate",e.$Rl="telemetry.lastSessionDate",e.$Sl="telemetry.machineId",e.$Tl="telemetry.sqmId",e.$Ul="telemetry",e.$Vl="telemetry.telemetryLevel",e.$Wl="telemetry.enableCrashReporter",e.$Xl="telemetry.enableTelemetry";var j;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(j||(e.TelemetryLevel=j={}));var k;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(k||(e.TelemetryConfiguration=k={}))}),define(ne[70],re([0,1,8,10,6,22]),function(J,e,D,j,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=void 0,e.$Xp=(0,j.$ii)("IExtensionSignatureVerificationService");let R=class{constructor(u,a){this.b=u,this.c=a}d(){return this.a||(this.a=new Promise((u,a)=>J(["@vscode/vsce-sign"],async y=>u(y),a))),this.a}async verify(u,a,y){let v;try{v=await this.d()}catch(O){return this.b.error("Could not load vsce-sign module",(0,D.$0)(O)),!1}const d=new Date().getTime();let p,w;try{return p=await v.verify(u,a,y),p}catch(O){throw w=O,O}finally{const O=new Date().getTime()-d;this.c.publicLog2("extensionsignature:verification",{duration:O,verified:p,error:w?w.code??"unknown":void 0})}}};e.$Yp=R,e.$Yp=R=$e([oe(0,k.$Oj),oe(1,A.$Nl)],R)}),define(ne[41],re([0,1,27,3,67,69,22]),function(J,e,D,j,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=void 0,e.$$o=y,e.$_o=v,e.$ap=d,e.$bp=p,e.$cp=O,e.$dp=c,e.$ep=b,e.$fp=g;class S{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$4o=S;class u{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$5o=u,e.$6o=new u;class a{async publicLog(r,t,n){}async publicLogError(r,t,n){}}e.$7o=a,e.$8o="telemetry",e.$9o="extensionTelemetryLog",e.$0o={log:()=>null,flush:()=>Promise.resolve(null)};function y(i,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!i.enableTelemetry)}function v(i,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function d(i){const r=i.getValue(R.$Vl),t=i.getValue(R.$Wl);if(i.getValue(R.$Xl)===!1||t===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function p(i){const r={},t={},n={};m(i,n);for(let s in n){s=s.length>150?s.substr(s.length-149):s;const o=n[s];typeof o=="number"?t[s]=o:typeof o=="boolean"?t[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),r[s]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(r[s]=o)}return{properties:r,measurements:t}}const w=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function O(i){if(!i)return"none";const r=(0,k.$um)(i);return w.has(r)?r:"other"}function m(i,r,t=0,n){if(i)for(const s of Object.getOwnPropertyNames(i)){const o=i[s],l=n?n+s:s;Array.isArray(o)?r[l]=(0,D.$Tn)(o):o instanceof Date?r[l]=o.toISOString():(0,j.$Xf)(o)?t<2?m(o,r,t+1,l+"."):r[l]=(0,D.$Tn)(o):r[l]=o}}function c(i,r){const t=i.msftInternalDomains||[],n=r.getValue("telemetry.internalTesting");return(0,A.$3o)(t)||n}function b(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function $(i,r){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let t=i;const n=[];for(const P of r)for(;;){const I=P.exec(i);if(!I)break;n.push([I.index,P.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(t="";;){const P=o.exec(i);if(!P)break;const I=n.some(([L,z])=>P.index<z&&L<o.lastIndex);!s.test(P[0])&&!I&&(t+=i.substring(l,P.index)+"<REDACTED: user-file-path>",l=o.lastIndex)}return l<i.length&&(t+=i.substr(l)),t}function h(i){if(!i)return i;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const t of r)if(t.regex.test(i))return`<REDACTED: ${t.label}>`;return i}function g(i,r){return(0,D.$Qn)(i,t=>{if(t instanceof S||Object.hasOwnProperty.call(t,"isTrustedTelemetryValue"))return t.value;if(typeof t=="string"){let n=t.replaceAll("%20"," ");n=$(n,r);for(const s of r)n=n.replace(s,"");return n=h(n),n}})}}),define(ne[26],re([0,1,30,21,37,12,11,8,35,41]),function(J,e,D,j,k,A,R,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$hp=void 0,e.$gp=y,e.$ip=w,e.$jp=O,e.$kp=m,e.$lp=c,e.$mp=b,e.$np=$,e.$op=h,e.$qp=g,e.$rp=r;function y(t,n){return t.uuid&&n.uuid?t.uuid===n.uuid:t.id===n.id?!0:(0,D.$gf)(t.id,n.id)===0}const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(n){const s=n.manifest?n.manifest.version:n.version,o=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new d(n.identifier,s,o)}static parse(n){const s=v.exec(n);return s&&s[1]&&s[2]?new d({id:s[1]},s[2],s[4]||void 0):null}constructor(n,s,o="undefined"){this.version=s,this.targetPlatform=o,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof d?y(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$hp=d;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(t){const n=p.exec(t);return n&&n[1]?[m(n[1]),n[2]]:[m(t),void 0]}function O(t,n){return`${t}.${n}`}function m(t){return t.toLowerCase()}function c(t,n){return m(O(t??k.$zm,n))}function b(t,n){const s=[],o=l=>{for(const P of s)if(P.some(I=>y(n(I),n(l))))return P;return null};for(const l of t){const P=o(l);P?P.push(l):s.push([l])}return s}function $(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}function h(t){return{id:new a.$4o(t.identifier.id),name:new a.$4o(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$pp=new k.$Dm("pprice.better-merge");function g(t,n){const s=[],o=n.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const l=o.shift();if(l&&s.every(P=>!y(P.identifier,{id:l}))){const P=t.filter(I=>y(I.identifier,{id:l}));P.length===1&&(s.push(P[0]),o.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function i(t,n){if(!A.$k)return!1;let s;try{s=(await t.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await t.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){n.debug("Error while getting the os-release file.",(0,S.$0)(l))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(t,n){const s=await i(t,n),o=(0,j.$No)(s?"alpine":A.$u,u.$fc);return n.debug("ComputeTargetPlatform:",o),o}}),define(ne[146],re([0,1,20,8,15,17,44,11,96,21,26,37]),function(J,e,D,j,k,A,R,S,u,a,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=void 0;const d=O=>(0,u.localize)(0,null,O),p=(0,u.localize)(1,null,"ms-dotnettools.csharp");let w=class{constructor(m,c,b){this.a=m,this.b=c,this.d=b}get f(){}async listExtensions(m,c,b){let $=await this.b.getInstalled(1,b);const h=v.$Cm.map(i=>i.toLowerCase());if(c&&c!==""){if(h.indexOf(c.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}$=$.filter(i=>i.manifest.categories?i.manifest.categories.map(t=>t.toLowerCase()).indexOf(c.toLowerCase())>-1:!1)}else if(c===""){this.a.info("Possible Categories: "),h.forEach(i=>{this.a.info(i)});return}this.f&&this.a.info((0,u.localize)(2,null,this.f)),$=$.sort((i,r)=>i.identifier.id.localeCompare(r.identifier.id));let g;for(const i of $)g!==i.identifier.id&&(g=i.identifier.id,this.a.info(m?`${g}@${i.manifest.version}`:g))}async installExtensions(m,c,b,$){const h=[];try{m.length&&this.a.info(this.f?(0,u.localize)(3,null,this.f):(0,u.localize)(4,null));const g=[],i=[],r=(n,s,o)=>{i.push({id:n,version:s!=="prerelease"?s:void 0,installOptions:{...b,isBuiltin:o,installPreReleaseVersion:s==="prerelease"||b.installPreReleaseVersion}})};for(const n of m)if(n instanceof S.URI)g.push({vsix:n,installOptions:b});else{const[s,o]=(0,y.$ip)(n);r(s,o,!1)}for(const n of c)if(n instanceof S.URI)g.push({vsix:n,installOptions:{...b,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,o]=(0,y.$ip)(n);r(s,o,!0)}const t=await this.b.getInstalled(1,b.profileLocation);if(g.length&&await Promise.all(g.map(async({vsix:n,installOptions:s})=>{try{await this.h(n,s,$,t)}catch(o){this.a.error(o),h.push(n.toString())}})),i.length){const n=await this.g(i,t,$);h.push(...n)}}catch(g){throw this.a.error((0,u.localize)(5,null,(0,j.$0)(g))),g}if(h.length)throw new Error((0,u.localize)(6,null,h.join(", ")))}async updateExtensions(m){const c=await this.b.getInstalled(1,m),b=[];for(const i of c)i.identifier.uuid&&b.push({...i.identifier,preRelease:i.preRelease});this.a.trace((0,u.localize)(7,null,b.length));const $=await this.d.getExtensions(b,{compatible:!0},D.CancellationToken.None),h=[];for(const i of $)for(const r of c)(0,y.$gp)(r.identifier,i.identifier)&&(0,R.gt)(i.version,r.manifest.version)&&h.push({extension:i,options:{operation:3,installPreReleaseVersion:r.isPreReleaseVersion}});if(!h.length){this.a.info((0,u.localize)(8,null));return}this.a.info((0,u.localize)(9,null,h.map(i=>i.extension.identifier.id).join(", ")));const g=await this.b.installGalleryExtensions(h);for(const i of g)i.error?this.a.error((0,u.localize)(10,null,i.identifier.id,(0,j.$0)(i.error))):this.a.info((0,u.localize)(11,null,i.identifier.id,i.local?.manifest.version))}async g(m,c,b){if(m=m.filter(({id:i,version:r})=>{const t=c.find(n=>(0,y.$gp)(n.identifier,{id:i}));if(t){if(!b&&(!r||r==="prerelease"&&t.preRelease))return this.a.info((0,u.localize)(12,null,i,t.manifest.version,i)),!1;if(r&&t.manifest.version===r)return this.a.info((0,u.localize)(13,null,`${i}@${r}`)),!1}return!0}),!m.length)return[];const $=[],h=[],g=await this.j(m);if(await Promise.all(m.map(async({id:i,version:r,installOptions:t})=>{const n=g.get(i.toLowerCase());if(!n){this.a.error(`${d(r?`${i}@${r}`:i)}
${p}`),$.push(i);return}try{const o=await this.d.getManifest(n,D.CancellationToken.None);if(o&&!this.k(o))return}catch(o){this.a.error(o.message||o.stack||o),$.push(i);return}const s=c.find(o=>(0,y.$gp)(o.identifier,n.identifier));if(s){if(n.version===s.manifest.version){this.a.info((0,u.localize)(14,null,r?`${i}@${r}`:i));return}this.a.info((0,u.localize)(15,null,i,n.version))}t.isBuiltin?this.a.info(r?(0,u.localize)(16,null,i,r):(0,u.localize)(17,null,i)):this.a.info(r?(0,u.localize)(18,null,i,r):(0,u.localize)(19,null,i)),h.push({extension:n,options:{...t,installGivenVersion:!!r}})})),h.length){const i=await this.b.installGalleryExtensions(h);for(const r of i)r.error?(this.a.error((0,u.localize)(20,null,r.identifier.id,(0,j.$0)(r.error))),$.push(r.identifier.id)):this.a.info((0,u.localize)(21,null,r.identifier.id,r.local?.manifest.version))}return $}async h(m,c,b,$){const h=await this.b.getManifest(m);if(!h)throw new Error("Invalid vsix");if(await this.l(h,b,c.profileLocation,$))try{await this.b.install(m,c),this.a.info((0,u.localize)(22,null,(0,A.$Sg)(m)))}catch(i){if((0,j.$4)(i))this.a.info((0,u.localize)(23,null,(0,A.$Sg)(m)));else throw i}}async j(m){const c=new Map,b=m.some(g=>g.installOptions.installPreReleaseVersion),$=await this.b.getTargetPlatform(),h=[];for(const g of m)a.$Go.test(g.id)&&h.push({...g,preRelease:b});if(h.length){const g=await this.d.getExtensions(h,{targetPlatform:$},D.CancellationToken.None);for(const i of g)c.set(i.identifier.id.toLowerCase(),i)}return c}k(m){return!0}async l(m,c,b,$){if(!c){const h={id:(0,y.$lp)(m.publisher,m.name)},g=$.find(i=>(0,y.$gp)(h,i.identifier)&&(0,R.gt)(i.manifest.version,m.version));if(g)return this.a.info((0,u.localize)(24,null,g.identifier.id,g.manifest.version,m.version)),!1}return this.k(m)}async uninstallExtensions(m,c,b){const $=async g=>{if(g instanceof S.URI){const i=await this.b.getManifest(g);return(0,y.$jp)(i.publisher,i.name)}return g},h=[];for(const g of m){const i=await $(g),t=(await this.b.getInstalled(void 0,b)).filter(n=>(0,y.$gp)(n.identifier,{id:i}));if(!t.length)throw new Error(`${this.m(i)}
${p}`);if(t.some(n=>n.type===0)){this.a.info((0,u.localize)(25,null,i));return}if(!c&&t.some(n=>n.isBuiltin)){this.a.info((0,u.localize)(26,null,i));return}this.a.info((0,u.localize)(27,null,i));for(const n of t)await this.b.uninstall(n,{profileLocation:b}),h.push(n);this.f?this.a.info((0,u.localize)(28,null,i,this.f)):this.a.info((0,u.localize)(29,null,i))}}async locateExtension(m){const c=await this.b.getInstalled();m.forEach(b=>{c.forEach($=>{if($.identifier.id===b&&$.location.scheme===k.Schemas.file){this.a.info($.location.fsPath);return}})})}m(m){return this.f?(0,u.localize)(30,null,m,this.f):(0,u.localize)(31,null,m)}};e.$Zp=w,e.$Zp=w=$e([oe(1,a.$Uo),oe(2,a.$Ro)],w)}),define(ne[147],re([0,1,9,8,2,15,17,44,3,28,25,49,29,18,21,26,70,13,6]),function(J,e,D,j,k,A,R,S,u,a,y,v,d,p,w,O,m,c,b){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=void 0;let h=class extends k.$Uc{static{$=this}static{this.c=".sigzip"}constructor(i,r,t,n,s,o){super(),this.h=r,this.j=t,this.m=n,this.n=s,this.r=o,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(i,r,t){await this.g;const n=(0,R.$Vg)(this.extensionsDownloadDir,this.z(i));try{await this.w(i,n,o=>this.j.download(i,o,r))}catch(o){throw new w.$So(o.message,w.ExtensionManagementErrorCode.Download)}let s=!1;if(t&&this.t(i)){const o=await this.u(i);try{s=await this.n.verify(n.fsPath,o.fsPath,this.r.getLevel()===b.LogLevel.Trace)}catch(l){const P=l;if(s=P.code,P.output&&this.r.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${P.output}`),s===w.ExtensionSignaturetErrorCode.PackageIsInvalidZip||s===w.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(n)}catch(I){this.r.error(I)}throw new w.$So(v.$4p,w.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(o)}catch(l){this.r.error(l)}}}return s===!0?this.r.info(`Extension signature is verified: ${i.identifier.id}`):s===!1?this.r.info(`Extension signature verification is not done: ${i.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${s}': ${i.identifier.id}`),{location:n,verificationStatus:s}}t(i){if(!i.isSigned)return this.r.info(`Extension is not signed: ${i.identifier.id}`),!1;const r=this.m.getValue("extensions.verifySignature");return(0,u.$2f)(r)?r:!0}async u(i){await this.g;const r=(0,R.$Vg)(this.extensionsDownloadDir,`${this.z(i)}${$.c}`);try{await this.w(i,r,t=>this.j.downloadSignatureArchive(i,t))}catch(t){throw new w.$So(t.message,w.ExtensionManagementErrorCode.DownloadSignature)}return r}async w(i,r,t){if(await this.h.exists(r))return;if(r.scheme!==A.Schemas.file){await t(r);return}const n=(0,R.$Vg)(this.extensionsDownloadDir,`.${(0,a.$Eg)()}`);await this.h.exists(n)||await t(n);try{await y.Promises.rename(n.fsPath,r.fsPath,2*60*1e3)}catch(s){try{await this.h.del(n)}catch{}if(s.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,r.path);else throw this.r.info(`Rename failed because of ${(0,j.$0)(s)}. Deleted the file from downloaded location`,n.path),s}}async delete(i){await this.g,await this.h.del(i)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const r=[],t=[],n=[];for(const l of i.children)if(l.name.endsWith($.c))n.push(l.resource);else{const P=O.$hp.parse(l.name);P&&t.push([P,l])}const s=(0,O.$mp)(t,([l])=>l),o=[];for(const l of s)l.sort((P,I)=>S.rcompare(P[0].version,I[0].version)),r.push(...l.slice(1).map(P=>P[1].resource)),o.push(l[0][1]);o.sort((l,P)=>l.mtime-P.mtime),r.push(...o.slice(0,Math.max(0,o.length-this.f)).map(l=>l.resource)),r.push(...n),await D.Promises.settled(r.map(l=>(this.r.trace("Deleting from cache",l.path),this.h.del(l))))}}catch(i){this.r.error(i)}}z(i){return this.f?O.$hp.create(i).toString().toLowerCase():(0,a.$Eg)()}};e.$kq=h,e.$kq=h=$=$e([oe(0,p.$qi),oe(1,c.$Ok),oe(2,w.$Ro),oe(3,d.$Oi),oe(4,m.$Xp),oe(5,b.$Oj)],h)}),define(ne[148],re([0,1,5,2,31,26,37]),function(J,e,D,j,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=void 0;class S extends j.$Uc{constructor(a,y,v,d,p,w,O){super(),this.f=a,this.g=y,this.h=v,this.j=d,this.m=p,this.n=w,this.r=O,this.a=this.B(new D.$7d),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new j.$4c),this.s().then(null,m=>O.error(m))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(a=>this.u(a.added))),this.B(this.j.onAddExtensions(a=>this.w(a))),this.B(this.j.onDidAddExtensions(a=>this.y(a))),this.B(this.j.onRemoveExtensions(a=>this.z(a))),this.B(this.j.onDidRemoveExtensions(a=>this.C(a))),this.B(this.n.onDidFilesChange(a=>this.D(a)))}async u(a){try{a.length&&await Promise.all(a.map(y=>(this.c.set(y.id,(0,j.$Rc)(this.n.watch(this.m.extUri.dirname(y.extensionsResource)),this.n.watch(y.extensionsResource))),this.G(y.extensionsResource))))}catch(y){throw this.r.error(y),y}}async w(a){for(const y of a.extensions)this.I(this.L(y.identifier,y.version),a.profileLocation)}async y(a){for(const y of a.extensions){const v=this.L(y.identifier,y.version);a.error?this.J(v,a.profileLocation):this.I(v,a.profileLocation)}}async z(a){for(const y of a.extensions)this.J(this.L(y.identifier,y.version),a.profileLocation)}async C(a){const y=[],v=[];for(const d of a.extensions){const p=this.L(d.identifier,d.version);a.error?this.I(p,a.profileLocation):(this.J(p,a.profileLocation),this.b.has(p)||(this.r.debug("Extension is removed from all profiles",d.identifier.id,d.version),v.push(this.f.scanInstalledExtensionAtLocation(d.location).then(w=>{w?y.push(w):this.r.info("Extension not found at the location",d.location.toString())},w=>this.r.error(w)))))}try{await Promise.all(v),y.length&&await this.H(y)}catch(d){this.r.error(d)}}D(a){for(const y of this.h.profiles)a.contains(y.extensionsResource,0,1)&&this.F(y.extensionsResource)}async F(a){const y=[],v=[],d=await this.j.scanProfileExtensions(a),p=new Set,w=new Set;for(const[O,m]of this.b)m.has(a)&&w.add(O);for(const O of d){const m=this.L(O.identifier,O.version);p.add(m),w.has(m)||(y.push(O.identifier),this.I(m,a))}for(const O of w)if(!p.has(O)){const m=this.M(O);m&&(v.push(m.identifier),this.J(O,a))}(y.length||v.length)&&this.a.fire({added:y.length?{extensions:y,profileLocation:a}:void 0,removed:v.length?{extensions:v,profileLocation:a}:void 0})}async G(a){const y=await this.j.scanProfileExtensions(a);for(const v of y)this.I(this.L(v.identifier,v.version),a)}async H(a){a||(a=(await this.f.scanAllUserInstalledExtensions()).filter(v=>!this.b.has(this.L(v.identifier,v.manifest.version)))),a.length&&await this.f.markAsUninstalled(...a)}I(a,y){let v=this.b.get(a);v||this.b.set(a,v=new k.$Cc(d=>this.m.extUri.getComparisonKey(d))),v.add(y)}J(a,y){const v=this.b.get(a);v&&v.delete(y),v?.size||this.b.delete(a)}L(a,y){return`${R.$Dm.toKey(a.id)}@${y}`}M(a){const[y,v]=(0,A.$ip)(a);return v?{identifier:{id:y},version:v}:void 0}}e.$oq=S}),define(ne[149],re([0,1,118,41]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=k;async function k(A,R,S,u,a,y,v){const d={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${R.nameShort})`};if((0,j.$$o)(R,S)&&(0,j.$ap)(u)===3){const p=await(0,D.$Sp)(S,a,y);d["X-Market-User-Id"]=p,d["VSCode-SessionId"]=v.machineId||p}return d}}),define(ne[150],re([0,1,176,19,9,2,15,16,25,18,21,26,6,64,11]),function(J,e,D,j,k,A,R,S,u,a,y,v,d,p,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=void 0;let O=class extends p.$Cr{constructor($,h,g,i){super(g),this.h=$,this.j=i,this.g=this.B(new m(h,i)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri($,h){const i=(await this.g.getLanguagePacks())[h];if(!i){this.j.warn(`No language pack found for ${h}`);return}const r=i.translations[$];return r?w.URI.file(r):void 0}async getInstalledLanguages(){const $=await this.g.getLanguagePacks(),h=Object.keys($).map(g=>{const i=$[g];return{...this.f(g,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return h.push(this.f("en","English")),h.sort((g,i)=>g.label.localeCompare(i.label)),h}async m($){$&&$.manifest&&$.manifest.contributes&&$.manifest.contributes.localizations&&$.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",$.identifier.id),await this.update())}async n($){const h=await this.g.getLanguagePacks();Object.keys(h).some(g=>h[g]&&h[g].extensions.some(i=>(0,v.$gp)(i.extensionIdentifier,$.identifier)))&&(this.j.info("Removing language packs from the extension",$.identifier.id),await this.update())}async update(){const[$,h]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),g=await this.g.update(h);return!(0,j.$ub)(Object.keys($),Object.keys(g))}};e.$Dr=O,e.$Dr=O=$e([oe(0,y.$Uo),oe(1,a.$qi),oe(2,y.$Ro),oe(3,d.$Oj)],O);let m=class extends A.$Uc{constructor($,h){super(),this.j=h,this.c={},this.f=(0,S.$kc)($.userDataPath,"languagepacks.json"),this.g=new k.$ph}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update($){return this.s(h=>{Object.keys(h).forEach(g=>delete h[g]),this.m(h,...$)}).then(()=>this.c)}m($,...h){for(const g of h)g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&this.n($,g);Object.keys($).forEach(g=>this.r($[g]))}n($,h){const g=h.identifier,i=h.manifest.contributes&&h.manifest.contributes.localizations?h.manifest.contributes.localizations:[];for(const r of i)if(h.location.scheme===R.Schemas.file&&c(r)){let t=$[r.languageId];t||(t={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},$[r.languageId]=t);const n=t.extensions.filter(s=>(0,v.$gp)(s.extensionIdentifier,g))[0];n?n.version=h.manifest.version:t.extensions.push({extensionIdentifier:g,version:h.manifest.version});for(const s of r.translations)t.translations[s.id]=(0,S.$kc)(h.location.fsPath,s.path)}}r($){if($){const h=(0,D.createHash)("md5");for(const g of $.extensions)h.update(g.extensionIdentifier.uuid||g.extensionIdentifier.id).update(g.version);$.hash=h.digest("hex")}}s($=()=>null){return this.g.queue(()=>{let h=null;return u.Promises.readFile(this.f,"utf8").then(void 0,g=>g.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(g)).then(g=>{try{return JSON.parse(g)}catch{return{}}}).then(g=>(h=$(g),g)).then(g=>{for(const r of Object.keys(g))g[r]||delete g[r];this.c=g,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),u.Promises.writeFile(this.f,i)}).then(()=>h,g=>this.j.error(g))})}};m=$e([oe(0,a.$qi),oe(1,d.$Oj)],m);function c(b){if(typeof b.languageId!="string"||!Array.isArray(b.translations)||b.translations.length===0)return!1;for(const $ of b.translations)if(typeof $.id!="string"||typeof $.path!="string")return!1;return!(b.languageName&&typeof b.languageName!="string"||b.localizedLanguageName&&typeof b.localizedLanguageName!="string")}}),define(ne[151],re([0,1,84,8,27,41]),function(J,e,D,j,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RP=void 0;const R="https://mobile.events.data.microsoft.com/OneCollector/1.0",S="https://mobile.events.data.microsoft.com/ping";async function u(y,v,d){const p=await(0,D.$FD)("@microsoft/1ds-core-js","dist/ms.core.js"),w=await(0,D.$FD)("@microsoft/1ds-post-js","dist/ms.post.js"),O=new p.AppInsightsCore,m=new w.PostChannel,c={instrumentationKey:y,endpointUrl:R,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[m]]};if(d){c.extensionConfig={};const b={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:d};c.extensionConfig[m.identifier]=b}return O.initialize(c,[]),O.addTelemetryInitializer(b=>{b.ext=b.ext??{},b.ext.web=b.ext.web??{},b.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',v&&(b.ext.utc=b.ext.utc??{},b.ext.utc.flags=8462029)}),O}class a{constructor(v,d,p,w,O){this.e=v,this.f=d,this.g=p,this.h=O,this.c=R,this.d=S,this.g||(this.g={}),typeof w=="function"?this.a=w():this.a=w,this.b=null}i(v){if(this.a){if(typeof this.a!="string"){v(this.a);return}this.b||(this.b=u(this.a,this.e,this.h)),this.b.then(d=>{v(d)},d=>{(0,j.$1)(d),console.error(d)})}}log(v,d){if(!this.a)return;d=(0,k.$Rn)(d,this.g),d=(0,A.$bp)(d);const p=this.f+"/"+v;try{this.i(w=>{w.pluginVersionString=d?.properties.version??"Unknown",w.track({name:p,baseData:{name:p,properties:d?.properties,measurements:d?.measurements}})})}catch{}}flush(){return this.a?new Promise(v=>{this.i(d=>{d.unload(!0,()=>{this.a=void 0,v(void 0)})})}):Promise.resolve(void 0)}}e.$RP=a}),define(ne[152],re([0,1,2,27,12,30,109,29,40,153,32,36,22,41]),function(J,e,D,j,k,A,R,S,u,a,y,v,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jr=void 0;let w=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(c,b,$){this.k=b,this.l=$,this.d={},this.i=new D.$Tc,this.j=[],this.b=c.appenders,this.c=c.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const h of this.f)this.j.push(new RegExp((0,A.$Ze)(h),"gi")),h.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$Ze)(h.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(h=>{(h.affectsConfiguration(d.$Vl)||h.affectsConfiguration(d.$Xl)||h.affectsConfiguration(d.$Wl))&&this.m()}))}setExperimentProperty(c,b){this.d[c]=b}m(){let c=(0,p.$ap)(this.k);const b=this.l.enabledTelemetryLevels;if(b){this.h=this.sendErrorTelemetry?b.error:!1;const $=b.usage?3:b.error?2:0;c=Math.min(c,$)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(c,b,$){this.g<b||($=(0,j.$Rn)($,this.d),$=(0,p.$fp)($,this.j),$=(0,j.$Rn)($,this.c),this.b.forEach(h=>h.log(c,$)))}publicLog(c,b){this.n(c,3,b)}publicLog2(c,b){this.publicLog(c,b)}publicLogError(c,b){this.h&&this.n(c,2,b)}publicLogError2(c,b){this.publicLogError(c,b)}};e.$Jr=w,e.$Jr=w=$e([oe(1,S.$Oi),oe(2,y.$8j)],w);function O(){const m=(0,R.localize)(0,null,a.default.nameLong),c=a.default.privacyStatementUrl?(0,R.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,R.localize)(1,null,"https://aka.ms/vscode-telemetry"),b=k.$o?"":(0,R.localize)(3,null),$=(0,R.localize)(4,null),h=(0,R.localize)(5,null),g=(0,R.localize)(6,null),i=(0,R.localize)(7,null),r=`
|       | ${$} | ${h} | ${g} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,R.localize)(8,null);return`
${m} ${c} ${b}

&nbsp;

${i}
${r}

&nbsp;

${t}
`}v.$1n.as(u.$6n.Configuration).registerConfiguration({id:d.$Ul,order:1,type:"object",title:(0,R.localize)(9,null),properties:{[d.$Vl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,R.localize)(10,null),(0,R.localize)(11,null),(0,R.localize)(12,null),(0,R.localize)(13,null)],markdownDescription:O(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.$1n.as(u.$6n.Configuration).registerConfiguration({id:d.$Ul,order:110,type:"object",title:(0,R.localize)(14,null),properties:{[d.$Xl]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,R.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,R.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,R.localize)(17,null,`\`#${d.$Vl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[154],re([0,1,14,20,177,151]),function(J,e,D,j,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SP=void 0;async function R(y,v){const d=await v.request(y,j.CancellationToken.None),p=(await(0,D.$Ge)(d.stream)).toString(),w=d.res.statusCode??200;return{headers:d.res.headers,statusCode:w,responseData:p}}async function S(y){const v={method:y.type,headers:y.headers};return new Promise((p,w)=>{const O=k.request(y.url??"",v,m=>{m.on("data",function(c){p({headers:m.headers,statusCode:m.statusCode??200,responseData:c.toString()})}),m.on("error",function(c){w(c)})});O.write(y.data,m=>{m&&w(m)}),O.end()})}async function u(y,v,d){const p=typeof v.data=="string"?v.data:new TextDecoder().decode(v.data),w={type:"POST",headers:{...v.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(v.data).toString()},url:v.urlString,data:p};try{const O=y?await R(w,y):await S(w);d(O.statusCode,O.headers,O.responseData)}catch{d(0,{})}}class a extends A.$RP{constructor(v,d,p,w,O){const m={sendPOST:(c,b)=>{u(v,c,b)}};super(d,p,w,O,m)}}e.$SP=a}),define(ne[155],re([0,1,16,25]),function(J,e,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hcc=k;async function k(A,R){const S=Object.create(null),u=(y,v)=>{const d=JSON.parse(y);S[v]=d};if(R){const y=[],v=await j.Promises.readdir(R);for(const p of v)try{(await j.Promises.stat((0,D.$kc)(R,p))).isDirectory()&&y.push(p)}catch{}const d=[];for(const p of y)(await j.Promises.readdir((0,D.$kc)(R,p))).filter(O=>O==="telemetry.json").length===1&&d.push(p);for(const p of d){const w=(await j.Promises.readFile((0,D.$kc)(R,p,"telemetry.json"))).toString();u(w,p)}}let a=(await j.Promises.readFile((0,D.$kc)(A,"telemetry-core.json"))).toString();return u(a,"vscode-core"),a=(await j.Promises.readFile((0,D.$kc)(A,"telemetry-extensions.json"))).toString(),u(a,"vscode-extensions"),JSON.stringify(S,null,4)}}),define(ne[156],re([0,1,12,85,22]),function(J,e,D,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xbc=A,e.$ybc=R;async function A(S,u){let a=S.getItem(k.$Sl);return(typeof a!="string"||D.$j&&a==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(a=await(0,j.$rn)(u.error.bind(u))),a}async function R(S,u){let a=S.getItem(k.$Tl);return typeof a!="string"&&(a=await(0,j.$sn)(u.error.bind(u))),a}}),define(ne[23],re([0,1,10]),function(J,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ml=void 0,e.$ml=(0,D.$ii)("IUriIdentityService")}),define(ne[157],re([0,1,23,119,13,17,76,5,2]),function(J,e,D,j,k,A,R,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=void 0;class a{static{this._clock=0}constructor(d){this.uri=d,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let y=class{constructor(d){this.g=d,this.c=new u.$Tc,this.f=2**16;const p=new Map,w=O=>{let m=p.get(O.scheme);return m===void 0&&(m=d.hasProvider(O)&&!this.g.hasCapability(O,1024),p.set(O.scheme,m)),m};this.c.add(S.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(O=>{p.delete(O.scheme)})),this.extUri=new A.$Kg(w),this.d=new R.$is((O,m)=>this.extUri.compare(O,m,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,A.$Wg)(d));const p=this.d.get(d);return p?p.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new a(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort((w,O)=>w[1].time<O[1].time?1:w[1].time>O[1].time?-1:0);a._clock=0,this.d.clear();const p=this.f*.5;for(let w=0;w<p;w++)this.d.set(d[w][0],d[w][1].touch())}};e.$js=y,e.$js=y=$e([oe(0,k.$Ok)],y),(0,j.$gs)(D.$ml,y,1)}),define(ne[158],re([0,1,5,2,13,48,31]),function(J,e,D,j,k,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vbc=void 0;class S extends j.$Uc{constructor(a,y,v,d,p,w){super(),this.f=a,this.g=y,this.h=v,this.j=d,this.m=p,this.n=w,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new D.$7d),this.onDidChangeFile=this.a.event,this.b=A.$oi.forUris(()=>!(this.capabilities&1024)),this.c=new R.$Cc(O=>this.m.extUri.getComparisonKey(this.t(O))),this.r(),this.B(d.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(O=>this.s(O)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,y){return this.g.open(this.t(a),y)}close(a){return this.g.close(a)}read(a,y,v,d,p){return this.g.read(a,y,v,d,p)}write(a,y,v,d,p){return this.g.write(a,y,v,d,p)}watch(a,y){this.b.set(a,a);const v=this.g.watch(this.t(a),y);return(0,j.$Sc)(()=>{this.b.delete(a),v.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,y,v){return this.g.rename(this.t(a),this.t(y),v)}readFile(a,y){return this.g.readFile(this.t(a),y)}readFileStream(a,y,v){return this.g.readFileStream(this.t(a),y,v)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,y,v){return this.g.writeFile(this.t(a),y,v)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,y){return this.g.delete(this.t(a),y)}copy(a,y,v){if((0,k.$Sk)(this.g))return this.g.copy(this.t(a),this.t(y),v);throw new Error("copy not supported")}cloneFile(a,y){if((0,k.$Tk)(this.g))return this.g.cloneFile(this.t(a),this.t(y));throw new Error("clone not supported")}s(a){const y=[];for(const v of a){if(v.resource.scheme!==this.f)continue;const d=this.u(v.resource);this.b.findSubstr(d)&&y.push({resource:d,type:v.type,cId:v.cId})}y.length&&(this.n.debug("User data changed"),this.a.fire(y))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$Vbc=S}),define(ne[159],re([0,1,111,16,48,17,11,10,15]),function(J,e,D,j,k,A,R,S,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Ci=e.$Bi=e.WorkbenchState=e.$vi=e.$ui=e.$ri=void 0,e.$si=a,e.$ti=y,e.$wi=v,e.$xi=d,e.$yi=p,e.$zi=O,e.$Ai=m,e.$Di=$,e.$Ii=h,e.$Ji=g,e.$Li=i,e.$Mi=r,e.$Ni=t,e.$ri=(0,S.$ii)("contextService");function a(n){const s=n;return typeof s?.id=="string"&&R.URI.isUri(s.uri)}function y(n){return typeof n?.id=="string"&&!a(n)&&!d(n)}e.$ui={id:"ext-dev"},e.$vi={id:"empty-window"};function v(n,s){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,j.$oc)(n)}:s?e.$ui:e.$vi;const o=n;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function d(n){const s=n;return typeof s?.id=="string"&&R.URI.isUri(s.configPath)}function p(n){const s=n;if(s?.uri)return{id:s.id,uri:R.URI.revive(s.uri)};const o=n;if(o?.configPath)return{id:o.id,configPath:R.URI.revive(o.configPath)};if(n?.id)return{id:n.id}}var w;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(w||(e.WorkbenchState=w={}));function O(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function m(n){const s=n;return!!(s&&typeof s=="object"&&R.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class c{constructor(s,o,l,P,I){this.h=s,this.j=l,this.k=P,this.l=I,this.c=k.$oi.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=k.$oi.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Bi=c;class b{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,A.$Vg)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ci=b;function $(n){return new b({uri:n,index:0,name:(0,A.$Rg)(n)},{uri:n.toString()})}e.$Ei="code-workspace",e.$Fi=`.${e.$Ei}`,e.$Gi=[{name:(0,D.localize)(0,null),extensions:[e.$Ei]}],e.$Hi="workspace.json";function h(n,s){return A.$Mg.isEqualOrParent(n,s.untitledWorkspacesHome)}function g(n){let s;return R.URI.isUri(n)?s=n:s=n.configuration,s?.scheme===u.Schemas.tmp}e.$Ki="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(n){return n.id===e.$Ki}function r(n,s){return!h(n,s)&&!g(n)}function t(n){return(typeof n=="string"?(0,j.$pc)(n):(0,A.$Tg)(n))===e.$Fi}}),define(ne[24],re([0,1,43,5,2,17,11,110,18,13,10,6,159,31,23,9,28,30,3]),function(J,e,D,j,k,A,R,S,u,a,y,v,d,p,w,O,m,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$rl=e.$ol=e.ProfileResourceType=void 0,e.$nl=h,e.$pl=g,e.$ql=i;var $;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})($||(e.ProfileResourceType=$={}));function h(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&R.URI.isUri(s.location)&&R.URI.isUri(s.globalStorageHome)&&R.URI.isUri(s.settingsResource)&&R.URI.isUri(s.keybindingsResource)&&R.URI.isUri(s.tasksResource)&&R.URI.isUri(s.snippetsHome)&&R.URI.isUri(s.extensionsResource))}e.$ol=(0,y.$ii)("IUserDataProfilesService");function g(n,s){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:R.URI.revive(n.location).with({scheme:s}),globalStorageHome:R.URI.revive(n.globalStorageHome).with({scheme:s}),settingsResource:R.URI.revive(n.settingsResource).with({scheme:s}),keybindingsResource:R.URI.revive(n.keybindingsResource).with({scheme:s}),tasksResource:R.URI.revive(n.tasksResource).with({scheme:s}),snippetsHome:R.URI.revive(n.snippetsHome).with({scheme:s}),extensionsResource:R.URI.revive(n.extensionsResource).with({scheme:s}),cacheHome:R.URI.revive(n.cacheHome).with({scheme:s}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}function i(n,s,o,l,P,I){return{id:n,name:s,location:o,isDefault:!1,shortName:P?.shortName,icon:P?.icon,globalStorageHome:I&&P?.useDefaultFlags?.globalState?I.globalStorageHome:(0,A.$Vg)(o,"globalStorage"),settingsResource:I&&P?.useDefaultFlags?.settings?I.settingsResource:(0,A.$Vg)(o,"settings.json"),keybindingsResource:I&&P?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,A.$Vg)(o,"keybindings.json"),tasksResource:I&&P?.useDefaultFlags?.tasks?I.tasksResource:(0,A.$Vg)(o,"tasks.json"),snippetsHome:I&&P?.useDefaultFlags?.snippets?I.snippetsHome:(0,A.$Vg)(o,"snippets"),extensionsResource:I&&P?.useDefaultFlags?.extensions?I.extensionsResource:(0,A.$Vg)(o,"extensions.json"),cacheHome:(0,A.$Vg)(l,n),useDefaultFlags:P?.useDefaultFlags,isTransient:P?.transient}}let r=class extends k.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,o,l,P){super(),this.t=s,this.u=o,this.w=l,this.y=P,this.f=!0,this.h=this.B(new j.$7d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new j.$7d),this.onWillCreateProfile=this.j.event,this.m=this.B(new j.$7d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new j.$7d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new p.$Bc,emptyWindows:new Map},this.profilesHome=(0,A.$Vg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$Vg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),o=[s];if(this.f)try{for(const I of this.O()){if(!I.name||!(0,b.$Vf)(I.name)||!I.location){this.y.warn("Skipping the invalid stored profile",I.location||I.name);continue}o.push(i((0,A.$Sg)(I.location),I.name,I.location,this.g,{shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags},s))}}catch(I){this.y.error(I)}const l=new p.$Bc,P=new Map;if(o.length)try{const I=this.Q();if(I.workspaces)for(const[L,z]of Object.entries(I.workspaces)){const U=R.URI.parse(L),V=o.find(X=>X.id===z);V&&l.set(U,V)}if(I.emptyWindows)for(const[L,z]of Object.entries(I.emptyWindows)){const U=o.find(V=>V.id===z);U&&P.set(L,U)}}catch(I){this.y.error(I)}this.z={profiles:o,workspaces:l,emptyWindows:P}}return this.z}D(){const s=i("__default__profile__",(0,S.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const o="Temp",l=new RegExp(`${(0,c.$Ze)(o)}\\s(\\d+)`);let P=0;for(const L of this.profiles){const z=l.exec(L.name),U=z?parseInt(z[1]):0;P=U>P?U:P}const I=`${o} ${P+1}`;return this.createProfile((0,D.$9i)((0,m.$Eg)()).toString(16),I,{transient:!0},s)}async createNamedProfile(s,o,l){return this.createProfile((0,D.$9i)((0,m.$Eg)()).toString(16),s,o,l)}async createProfile(s,o,l,P){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.F(s,o,l);return P&&await this.setProfileForWorkspace(P,I),I}async F(s,o,l){if(!(0,b.$Vf)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let P=this.r.get(o);return P||(P=(async()=>{try{const I=this.profiles.find(U=>U.name===o||U.id===s);if(I)return I;const L=i(s,o,(0,A.$Vg)(this.profilesHome,s),this.g,l,this.defaultProfile);await this.u.createFolder(L.location);const z=[];return this.j.fire({profile:L,join(U){z.push(U)}}),await O.Promises.settled(z),this.I([L],[],[]),L}finally{this.r.delete(o)}})(),this.r.set(o,P)),P}async updateProfile(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(P=>P.id===s.id);if(!l)throw new Error(`Profile '${s.name}' does not exist`);return l=i(l.id,o.name??l.name,l.location,this.g,{shortName:o.shortName??l.shortName,icon:o.icon===null?void 0:o.icon??l.icon,transient:o.transient??l.isTransient,useDefaultFlags:o.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(P=>P.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const l=[];this.m.fire({profile:o,join(P){l.push(P)}});try{await Promise.allSettled(l)}catch(P){this.y.error(P)}for(const P of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(P)?.id&&this.C.emptyWindows.delete(P);for(const P of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(P)?.id&&this.C.workspaces.delete(P);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(P){(0,a.$6k)(P)!==1&&this.y.error(P)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(P=>P.id===o.id);if(!l)throw new Error(`Profile '${o.name}' does not exist`);this.L(s,l)}unsetWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.G(s);return R.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(s){return(0,d.$si)(s)?s.uri:(0,d.$xi)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location)))}I(s,o,l){const P=[...this.profiles,...s],I=[];this.s.profiles=[];for(let L of P)L.isDefault||o.some(z=>L.id===z.id)||(L=l.find(z=>L.id===z.id)??L,L.isTransient?this.s.profiles.push(L):I.push({location:L.location,name:L.name,shortName:L.shortName,icon:L.icon,useDefaultFlags:L.useDefaultFlags}));this.P(I),this.z=void 0,this.J(s,o,l)}J(s,o,l){this.h.fire({added:s,removed:o,updated:l,all:this.profiles})}L(s,o,l){l=o?.isTransient?!0:l,l||this.L(s,void 0,!0);const P=this.G(s),I=l?this.s:this.C;R.URI.isUri(P)?(I.workspaces.delete(P),o&&I.workspaces.set(P,o)):(I.emptyWindows.delete(P),o&&I.emptyWindows.set(P,o)),l||this.M()}M(){const s={};for(const[l,P]of this.C.workspaces.entries())s[l.toString()]=P.id;const o={};for(const[l,P]of this.C.emptyWindows.entries())o[l.toString()]=P.id;this.R({workspaces:s,emptyWindows:o}),this.z=void 0}N(s){const o={},l=this.D();if(s.workspaces)for(const[I,L]of Object.entries(s.workspaces)){const z=R.URI.parse(L);o[I]=this.w.extUri.isEqual(z,l.location)?l.id:this.w.extUri.basename(z)}const P={};if(s.emptyWindows)for(const[I,L]of Object.entries(s.emptyWindows)){const z=R.URI.parse(L);P[I]=this.w.extUri.isEqual(z,l.location)?l.id:this.w.extUri.basename(z)}return{workspaces:o,emptyWindows:P}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$rl=r,e.$rl=r=$e([oe(0,u.$pi),oe(1,a.$Ok),oe(2,w.$ml),oe(3,v.$Oj)],r);class t extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$sl=t}),define(ne[160],re([0,1,19,9,20,8,5,2,12,3,11,94,21,26,37,6,32,22,23,24]),function(J,e,D,j,k,A,R,S,u,a,y,v,d,p,w,O,m,c,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=e.$9p=void 0,e.$0p=g,e.$$p=i;let h=class extends S.$Uc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(s,o,l,P,I,L){super(),this.z=s,this.C=o,this.D=l,this.F=P,this.G=I,this.H=L,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new R.$7d),this.s=this.B(new R.$7d),this.t=this.B(new R.$7d),this.u=this.B(new R.$7d),this.w=this.B(new R.$7d),this.y=[],this.B((0,S.$Sc)(()=>{this.j.forEach(({task:z})=>z.cancel()),this.m.forEach(z=>z.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(s){const o=await this.getTargetPlatform();return s.allTargetPlatforms.some(l=>(0,d.$Po)(l,s.allTargetPlatforms,o))}async installFromGallery(s,o={}){try{const P=(await this.installGalleryExtensions([{extension:s,options:o}])).find(({identifier:I})=>(0,p.$gp)(I,s.identifier));if(P?.local)return P?.local;throw P?.error?P.error:new d.$So(`Unknown error while installing extension ${s.identifier.id}`,d.ExtensionManagementErrorCode.Unknown)}catch(l){throw i(l)}}async installGalleryExtensions(s){if(!this.z.isEnabled())throw new d.$So(v.localize(0,null),d.ExtensionManagementErrorCode.NotAllowed);const o=[],l=[];await Promise.allSettled(s.map(async({extension:P,options:I})=>{try{const L=await this.N(P,!!I?.installGivenVersion,!!I?.installPreReleaseVersion,I.productVersion??{version:this.G.version,date:this.G.date});l.push({...L,options:I})}catch(L){o.push({identifier:P.identifier,operation:2,source:P,error:L})}})),l.length&&o.push(...await this.I(l));for(const P of o)P.error&&(this.F.error("Failed to install extension.",P.identifier.id),this.F.error(P.error),P.source&&!y.URI.isUri(P.source)&&r(this.C,"extensionGallery:install",{extensionData:(0,p.$op)(P.source),error:P.error}));return o}async uninstall(s,o={}){return this.F.trace("ExtensionManagementService#uninstall",s.identifier.id),this.P(s,o)}async toggleAppliationScope(s,o){if((0,w.$Gm)(s.manifest)||s.isBuiltin)return s;if(s.isApplicationScoped){let l=await this.updateMetadata(s,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)||(l=await this.$(s,this.H.defaultProfile.extensionsResource,o));for(const P of this.H.profiles){const I=(await this.getInstalled(1,P.extensionsResource)).find(L=>(0,p.$gp)(L.identifier,s.identifier));I?this.w.fire(I):this.u.fire({identifier:s.identifier,profileLocation:P.extensionsResource})}return l}else{const l=this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(s,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(s,o,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:l.identifier,operation:2,local:l,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.g||s-this.h>1e3*60*5)&&(this.g=this.W(),this.h=s),this.g}registerParticipant(s){this.y.push(s)}async I(s){const o=[],l=new Map,P=[],I=[],L=(U,V)=>`${p.$hp.create(U).toString()}-${V.toString()}`,z=(U,V,X)=>{const se=this.Y(U,V,X),ie=y.URI.isUri(V)?V.path:`${V.identifier.id.toLowerCase()}-${X.profileLocation.toString()}`;l.set(ie,{task:se,manifest:U}),this.n.fire({identifier:se.identifier,source:V,profileLocation:X.profileLocation}),this.F.info("Installing extension:",se.identifier.id),y.URI.isUri(V)||this.j.set(L(V,X.profileLocation),{task:se,waitingTasks:[]})};try{for(const{manifest:U,extension:V,options:X}of s){const se=X.isApplicationScoped||X.isBuiltin||(0,w.$Gm)(U),ie={...X,installOnlyNewlyAddedFromExtensionPack:X.installOnlyNewlyAddedFromExtensionPack??!y.URI.isUri(V),isApplicationScoped:se,profileLocation:se?this.H.defaultProfile.extensionsResource:X.profileLocation??this.X(),productVersion:X.productVersion??{version:this.G.version,date:this.G.date}},ue=y.URI.isUri(V)?void 0:this.j.get(L(V,ie.profileLocation));ue?(this.F.info("Extension is already requested to install",ue.task.identifier.id),P.push(ue.task.waitUntilTaskIsFinished())):z(U,V,ie)}await Promise.all([...l.values()].map(async({task:U,manifest:V})=>{if(U.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",U.identifier.id);else try{const X=await this.M(U.identifier,V,!!U.options.installOnlyNewlyAddedFromExtensionPack,!!U.options.installPreReleaseVersion,U.options.profileLocation,U.options.productVersion),se=await this.getInstalled(void 0,U.options.profileLocation,U.options.productVersion),ie={...U.options,donotIncludePackAndDependencies:!0,context:{...U.options.context,[d.$Ko]:!0}};for(const{gallery:ue,manifest:he}of(0,D.$Mb)(X,({gallery:ce})=>ce.identifier.id)){if(l.has(`${ue.identifier.id.toLowerCase()}-${ie.profileLocation.toString()}`))continue;const ce=this.j.get(L(ue,ie.profileLocation));if(ce){if(this.J(U,ce.task)){const B=ce.task.identifier;this.F.info("Waiting for already requested installing extension",B.id,U.identifier.id),ce.waitingTasks.push(U),P.push(R.Event.toPromise(R.Event.filter(this.onDidInstallExtensions,Z=>Z.some(q=>(0,p.$gp)(q.identifier,B)))).then(Z=>{if(this.F.info("Finished waiting for already requested installing extension",B.id,U.identifier.id),!Z.find(T=>(0,p.$gp)(T.identifier,B))?.local)throw new Error(`Extension ${B.id} is not installed`)}))}}else se.some(({identifier:B})=>(0,p.$gp)(B,ue.identifier))||z(he,ue,ie)}}catch(X){if(y.URI.isUri(U.source))(0,D.$Lb)(V.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",U.identifier.id,X.message),(0,D.$Lb)(V.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",U.identifier.id,X.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",U.identifier.id),X}})),await this.L([...l.values()].map(async({task:U})=>{const V=new Date().getTime();try{const X=await U.run();if(await this.L(this.y.map(se=>se.postInstall(X,U.source,U.options,k.CancellationToken.None))),!y.URI.isUri(U.source)){const se=U.operation===3,ie=se?void 0:(new Date().getTime()-U.source.lastUpdated)/1e3;if(r(this.C,se?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.$op)(U.source),verificationStatus:U.verificationStatus,duration:new Date().getTime()-V,durationSinceUpdate:ie}),u.$o&&U.operation!==3)try{await this.z.reportStatistic(X.manifest.publisher,X.manifest.name,X.manifest.version,"install")}catch{}}I.push({local:X,identifier:U.identifier,operation:U.operation,source:U.source,context:U.options.context,profileLocation:U.profileLocation,applicationScoped:X.isApplicationScoped})}catch(X){throw this.F.error("Error while installing the extension",U.identifier.id,(0,A.$0)(X)),X}})),P.length&&await this.L(P);for(const U of I)this.F.info("Extension installed successfully:",U.identifier.id),o.push(U);return o}catch(U){I.length&&await Promise.allSettled(I.map(async({local:V,profileLocation:X})=>{try{await this.Z(V,{versionOnly:!0,profileLocation:X}).run(),this.F.info("Rollback: Uninstalled extension",V.identifier.id)}catch(se){this.F.warn("Rollback: Error while uninstalling extension",V.identifier.id,(0,A.$0)(se))}}));for(const{task:V}of l.values())V.cancel(),o.push({identifier:V.identifier,operation:2,source:V.source,context:V.options.context,profileLocation:V.profileLocation,error:U});throw U}finally{for(const{task:U}of l.values())U.source&&!y.URI.isUri(U.source)&&this.j.delete(L(U.source,U.profileLocation));o.length&&this.s.fire(o)}}J(s,o){for(const[,{task:l,waitingTasks:P}]of this.j.entries())if(l===s&&(P.includes(o)||P.some(I=>this.J(I,o)))||l===o&&P[0]&&!this.J(s,P[0]))return!1;return!0}async L(s){const o=[],l=[],P=await Promise.allSettled(s);for(const I of P)I.status==="fulfilled"?o.push(I.value):l.push(I.reason);if(l.length)throw g(l);return o}async M(s,o,l,P,I,L){if(!this.z.isEnabled())return[];const z=await this.getInstalled(void 0,I,L),U=[],V=[],X=async(se,ie)=>{U.push(se);const ue=ie.extensionDependencies||[],he=[...ue];if(ie.extensionPack){const ce=l?z.find(B=>(0,p.$gp)(B.identifier,se)):void 0;for(const B of ie.extensionPack)ce&&ce.manifest.extensionPack&&ce.manifest.extensionPack.some(Z=>(0,p.$gp)({id:Z},{id:B}))||he.every(Z=>!(0,p.$gp)({id:Z},{id:B}))&&he.push(B)}if(he.length){const ce=he.filter(B=>U.every(Z=>!(0,p.$gp)(Z,{id:B})));if(ce.length){const B=await this.z.getExtensions(ce.map(Z=>({id:Z,preRelease:P})),k.CancellationToken.None);for(const Z of B){if(U.find(x=>(0,p.$gp)(x,Z.identifier)))continue;const q=ue.some(x=>(0,p.$gp)({id:x},Z.identifier));let T;try{T=await this.N(Z,!1,P,L)}catch(x){if(q)throw x;this.F.info("Skipping the packed extension as it cannot be installed",Z.identifier.id,(0,A.$0)(x));continue}V.push({gallery:T.extension,manifest:T.manifest}),await X(T.extension.identifier,T.manifest)}}}};return await X(s,o),V}async N(s,o,l,P){let I;const L=await this.getExtensionsControlManifest();if(L.malicious.some(V=>(0,p.$gp)(s.identifier,V)))throw new d.$So(v.localize(1,null,s.identifier.id),d.ExtensionManagementErrorCode.Malicious);const z=L.deprecated[s.identifier.id.toLowerCase()];if(z?.extension?.autoMigrate){if(this.F.info(`The '${s.identifier.id}' extension is deprecated, fetching the compatible '${z.extension.id}' extension instead.`),I=(await this.z.getExtensions([{id:z.extension.id,preRelease:z.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:P},k.CancellationToken.None))[0],!I)throw new d.$So(v.localize(2,null,s.identifier.id,z.extension.id),d.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(s)){const V=await this.getTargetPlatform();throw new d.$So(v.localize(3,null,s.identifier.id,this.G.nameLong,(0,d.$Lo)(V)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(I=await this.O(s,o,l,P),!I)throw!l&&s.properties.isPreReleaseVersion&&(await this.z.getExtensions([s.identifier],k.CancellationToken.None))[0]?new d.$So(v.localize(4,null,s.displayName??s.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.$So(v.localize(5,null,s.identifier.id,this.G.nameLong,this.G.version),d.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",I.identifier.id);const U=await this.z.getManifest(I,k.CancellationToken.None);if(U===null)throw new d.$So(`Missing manifest for extension ${I.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(U.version!==I.version)throw new d.$So(`Cannot install '${I.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:I,manifest:U}}async O(s,o,l,P){const I=await this.getTargetPlatform();let L=null;return!o&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==l&&(L=(await this.z.getExtensions([{...s.identifier,preRelease:l}],{targetPlatform:I,compatible:!0,productVersion:P},k.CancellationToken.None))[0]||null),!L&&await this.z.isExtensionCompatible(s,l,I,P)&&(L=s),L||(o?L=(await this.z.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:I,compatible:!0,productVersion:P},k.CancellationToken.None))[0]||null:L=await this.z.getCompatibleExtension(s,l,I,P)),L}async P(s,o){const l={...o,profileLocation:s.isApplicationScoped?this.H.defaultProfile.extensionsResource:o.profileLocation??this.X()},P=X=>`${X.id.toLowerCase()}${l.versionOnly?`-${s.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,I=this.m.get(P(s.identifier));if(I)return this.F.info("Extensions is already requested to uninstall",s.identifier.id),I.waitUntilTaskIsFinished();const L=X=>{const se=this.Z(X,l);return this.m.set(P(se.extension.identifier),se),l.profileLocation?this.F.info("Uninstalling extension from the profile:",`${X.identifier.id}@${X.manifest.version}`,l.profileLocation.toString()):this.F.info("Uninstalling extension:",`${X.identifier.id}@${X.manifest.version}`),this.t.fire({identifier:X.identifier,profileLocation:l.profileLocation,applicationScoped:X.isApplicationScoped}),se},z=(X,se)=>{se?l.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${X.identifier.id}@${X.manifest.version}`,l.profileLocation.toString(),se.message):this.F.error("Failed to uninstall extension:",`${X.identifier.id}@${X.manifest.version}`,se.message):l.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${X.identifier.id}@${X.manifest.version}`,l.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${X.identifier.id}@${X.manifest.version}`),r(this.C,"extensionGallery:uninstall",{extensionData:(0,p.$np)(X),error:se}),this.u.fire({identifier:X.identifier,error:se?.code,profileLocation:l.profileLocation,applicationScoped:X.isApplicationScoped})},U=[],V=[];try{U.push(L(s));const X=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const se=this.S(s,X);for(const ie of se)this.m.has(P(ie.identifier))?this.F.info("Extensions is already requested to uninstall",ie.identifier.id):U.push(L(ie))}l.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.Q(U.map(se=>se.extension),X,s),await this.L(U.map(async se=>{try{if(await se.run(),await this.L(this.y.map(ie=>ie.postUninstall(se.extension,l,k.CancellationToken.None))),se.extension.identifier.uuid)try{await this.z.reportStatistic(se.extension.manifest.publisher,se.extension.manifest.name,se.extension.manifest.version,"uninstall")}catch{}z(se.extension)}catch(ie){const ue=ie instanceof d.$So?ie:new d.$So((0,A.$0)(ie),d.ExtensionManagementErrorCode.Internal);throw z(se.extension,ue),ue}finally{V.push(se)}}))}catch(X){const se=X instanceof d.$So?X:new d.$So((0,A.$0)(X),d.ExtensionManagementErrorCode.Internal);for(const ie of U){try{ie.cancel()}catch{}V.includes(ie)||z(ie.extension,se)}throw se}finally{for(const X of U)this.m.delete(P(X.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",X.extension.identifier.id)}}Q(s,o,l){for(const P of s){const I=this.U(P,o);if(I.length){const L=I.filter(z=>!s.some(U=>(0,p.$gp)(U.identifier,z.identifier)));if(L.length)throw new Error(this.R(P,L,l))}}}R(s,o,l){return l===s?o.length===1?v.localize(6,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?v.localize(7,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):v.localize(8,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?v.localize(9,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?v.localize(10,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):v.localize(11,null,l.manifest.displayName||l.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}S(s,o,l=[]){if(l.indexOf(s)!==-1)return[];l.push(s);const P=s.manifest.extensionPack?s.manifest.extensionPack:[];if(P.length){const I=o.filter(z=>!z.isBuiltin&&P.some(U=>(0,p.$gp)({id:U},z.identifier))),L=[];for(const z of I)L.push(...this.S(z,o,l));return[...I,...L]}return[]}U(s,o){return o.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(P=>(0,p.$gp)({id:P},s.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(s){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,A.$0)(s)),{malicious:[],deprecated:{},search:[]}}}};e.$9p=h,e.$9p=h=$e([oe(0,d.$Ro),oe(1,c.$Nl),oe(2,b.$ml),oe(3,O.$Oj),oe(4,m.$8j),oe(5,$.$ol)],h);function g(n){const s=Array.isArray(n)?n:[n];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((o,l)=>new Error(`${o.message}${o.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}function i(n){if(n instanceof d.$So)return n;if(n instanceof d.$To){const o=new d.$So(n.message,d.ExtensionManagementErrorCode.Gallery);return o.stack=n.stack,o}const s=new d.$So(n.message,d.ExtensionManagementErrorCode.Internal);return s.stack=n.stack,s}function r(n,s,{extensionData:o,verificationStatus:l,duration:P,error:I,durationSinceUpdate:L}){let z,U;(0,a.$4f)(l)&&(l===!0?l="Verified":(l===!1||(z=d.ExtensionManagementErrorCode.Signature,U=l),l="Unverified")),I&&(I instanceof d.$So||I instanceof d.$To?(z=I.code,I.code===d.ExtensionManagementErrorCode.Signature&&(U=I.message)):z=d.ExtensionManagementErrorCode.Internal),n.publicLog(s,{...o,verificationStatus:l,success:!I,duration:P,errorcode:z,errorcodeDetail:U,durationSinceUpdate:L})}class t{constructor(){this.d=new j.$hh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,j.$8g)(s=>this.h(s))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,j.$8g)(s=>new Promise((o,l)=>{const P=s.onCancellationRequested(()=>{P.dispose(),l(new A.$5)})})),this.d.open()),this.g.cancel()}}e.$_p=t}),define(ne[42],re([0,1,9,14,2,5,31,11,21,26,13,10,6,24,23,3,8,22]),function(J,e,D,j,k,A,R,S,u,a,y,v,d,p,w,O,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=e.$aq=e.ExtensionsProfileScanningErrorCode=void 0;var b;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(b||(e.ExtensionsProfileScanningErrorCode=b={}));class $ extends Error{constructor(t,n){super(t),this.code=n}}e.$aq=$,e.$bq=(0,v.$ii)("IExtensionsProfileScannerService");let h=class extends k.$Uc{constructor(t,n,s,o,l,P){super(),this.j=t,this.m=n,this.n=s,this.r=o,this.s=l,this.t=P,this.b=this.B(new A.$7d),this.onAddExtensions=this.b.event,this.c=this.B(new A.$7d),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$7d),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$7d),this.onDidRemoveExtensions=this.g.event,this.h=new R.$Bc}scanProfileExtensions(t,n){return this.u(t,void 0,n)}async addExtensionsToProfile(t,n,s){const o=[],l=[];try{return await this.u(n,P=>{const I=[];if(s)I.push(...P);else for(const L of P)t.some(([z])=>(0,a.$gp)(z.identifier,L.identifier)&&z.manifest.version!==L.version)?o.push(L):I.push(L);for(const[L,z]of t){const U=I.findIndex(X=>(0,a.$gp)(X.identifier,L.identifier)&&X.version===L.manifest.version),V={identifier:L.identifier,version:L.manifest.version,location:L.location,metadata:z};U===-1?(l.push(V),I.push(V)):I.splice(U,1,V)}return l.length&&this.b.fire({extensions:l,profileLocation:n}),o.length&&this.f.fire({extensions:o,profileLocation:n}),I}),l.length&&this.c.fire({extensions:l,profileLocation:n}),o.length&&this.g.fire({extensions:o,profileLocation:n}),l}catch(P){throw l.length&&this.c.fire({extensions:l,error:P,profileLocation:n}),o.length&&this.g.fire({extensions:o,error:P,profileLocation:n}),P}}async updateMetadata(t,n){const s=[];return await this.u(n,o=>{const l=[];for(const P of o){const I=t.find(([L])=>(0,a.$gp)(L.identifier,P.identifier)&&L.manifest.version===P.version);I&&(P.metadata={...P.metadata,...I[1]},s.push(P)),l.push(P)}return l}),s}async removeExtensionFromProfile(t,n){const s=[];try{await this.u(n,o=>{const l=[];for(const P of o)(0,a.$gp)(P.identifier,t.identifier)?s.push(P):l.push(P);return s.length&&this.f.fire({extensions:s,profileLocation:n}),l}),s.length&&this.g.fire({extensions:s,profileLocation:n})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:n}),o}}async u(t,n,s){return this.F(t).queue(async()=>{let o=[],l;try{const P=await this.m.readFile(t);l=JSON.parse(P.value.toString().trim()||"[]")}catch(P){if((0,y.$6k)(P)!==1)throw P;if(this.r.extUri.isEqual(t,this.n.defaultProfile.extensionsResource)&&(l=await this.D()),!l&&s?.bailOutWhenFileNotFound)throw new $((0,m.$0)(P),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.w(t);let P=!1;for(const I of l){g(I)||this.w(t);let L;if((0,O.$Vf)(I.relativeLocation)&&I.relativeLocation)L=this.z(I.relativeLocation);else if((0,O.$Vf)(I.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${I.location}`);continue}else{L=S.URI.revive(I.location);const z=this.y(L);z&&(P=!0,I.relativeLocation=z)}(0,O.$3f)(I.metadata?.hasPreReleaseVersion)&&I.metadata?.preRelease&&(P=!0,I.metadata.hasPreReleaseVersion=!0),o.push({identifier:I.identifier,location:L,version:I.version,metadata:I.metadata})}P&&await this.m.writeFile(t,j.$ue.fromString(JSON.stringify(l)))}if(n){o=n(o);const P=o.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.y(I.location),metadata:I.metadata}));await this.m.writeFile(t,j.$ue.fromString(JSON.stringify(P)))}return o})}w(t){const n=new $(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}y(t){return this.r.extUri.isEqual(this.r.extUri.dirname(t),this.j)?this.r.extUri.basename(t):void 0}z(t){return this.r.extUri.joinPath(this.j,t)}async D(){return this.C||(this.C=(async()=>{const t=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),n=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(t)).value.toString()}catch(l){if((0,y.$6k)(l)===1)return;throw l}this.t.info("Migrating extensions from old default profile location",t.toString());let o;try{const l=JSON.parse(s);Array.isArray(l)&&l.every(P=>g(P))?o=l:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.t.error(l)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,j.$ue.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",t.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(l){if((0,y.$6k)(l)===3)this.t.info("Migration from old default profile location to new location is done by another window",t.toString(),this.n.defaultProfile.extensionsResource.toString());else throw l}try{await this.m.del(t)}catch(l){(0,y.$6k)(l)!==1&&this.t.error(l)}try{await this.m.del(n)}catch(l){(0,y.$6k)(l)!==1&&this.t.error(l)}return o})()),this.C}F(t){let n=this.h.get(t);return n||(n=new D.$ph,this.h.set(t,n)),n}};e.$cq=h,e.$cq=h=$e([oe(1,y.$Ok),oe(2,p.$ol),oe(3,w.$ml),oe(4,c.$Nl),oe(5,d.$Oj)],h);function g(r){return(0,O.$Xf)(r)&&(0,u.$Qo)(r.identifier)&&(i(r.location)||(0,O.$Vf)(r.location)&&r.location)&&((0,O.$3f)(r.relativeLocation)||(0,O.$Vf)(r.relativeLocation))&&r.version&&(0,O.$Vf)(r.version)}function i(r){return r?(0,O.$Vf)(r.path)&&(0,O.$Vf)(r.scheme):!1}}),define(ne[53],re([0,1,19,9,27,14,8,38,82,2,15,16,12,17,44,55,3,11,98,18,26,37,50,13,10,6,32,5,47,42,24,23,116]),function(J,e,D,j,k,A,R,S,u,a,y,v,d,p,w,O,m,c,b,$,h,g,i,r,t,n,s,o,l,P,I,L,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$hq=e.$gq=e.$fq=e.Translations=void 0,e.$iq=ue;var U;(function(ce){function B(Z,q){if(Z===q)return!0;const T=Object.keys(Z),x=new Set;for(const Y of Object.keys(q))x.add(Y);if(T.length!==x.size)return!1;for(const Y of T){if(Z[Y]!==q[Y])return!1;x.delete(Y)}return x.size===0}ce.equals=B})(U||(e.Translations=U={})),e.$fq=(0,t.$ii)("IExtensionsScannerService");let V=class extends a.$Uc{constructor(B,Z,q,T,x,Y,Q,_,M,F,f,E){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=Z,this.r=q,this.s=T,this.t=x,this.u=Y,this.w=Q,this.y=_,this.z=M,this.C=F,this.D=f,this.F=E,this.g=this.B(new o.$7d),this.onDidChangeCache=this.g.event,this.h=(0,p.$Vg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ie,this.s,this.h)),this.m=this.B(this.F.createInstance(ie,this.s,this.h)),this.n=this.B(this.F.createInstance(se,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,h.$rp)(this.w,this.y)),this.G}async scanAllExtensions(B,Z,q){const[T,x]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(Z)]),Y=q?await this.scanExtensionsUnderDevelopment(B,[...T,...x]):[];return this.L(T,x,Y,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const Z=[];Z.push(this.M(!!B.useCache,B.language)),Z.push(this.N(B.language,!!B.checkControlFile));const[q,T]=await Promise.all(Z);return this.J([...q,...T],0,B,!1)}async scanUserExtensions(B){const Z=B.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Z);const q=this.D.extUri.isEqual(B.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,T=await this.P(Z,!!B.profileLocation,1,!B.includeUninstalled,B.language,!0,q,B.productVersion??this.R()),x=B.useCache&&!T.devMode&&T.excludeObsolete?this.m:this.n;let Y;try{Y=await x.scanExtensions(T)}catch(Q){if(Q instanceof P.$aq&&Q.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),Y=await x.scanExtensions(T);else throw Q}return Y=await this.J(Y,1,B,!0),this.y.trace("Scanned user extensions:",Y.length),Y}async scanExtensionsUnderDevelopment(B,Z){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const q=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(T=>T.scheme===y.Schemas.file).map(async T=>{const x=await this.P(T,!1,1,!0,B.language,!1,void 0,B.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(x)).map(Q=>(Q.type=Z.find(_=>(0,h.$gp)(_.identifier,Q.identifier))?.type??Q.type,this.n.validate(Q,x)))}))).flat();return this.J(q,"development",B,!0)}return[]}async scanExistingExtension(B,Z,q){const T=await this.P(B,!1,Z,!0,q.language,!0,void 0,q.productVersion??this.R()),x=await this.n.scanExtension(T);return!x||!q.includeInvalid&&!x.isValid?null:x}async scanOneOrMultipleExtensions(B,Z,q){const T=await this.P(B,!1,Z,!0,q.language,!0,void 0,q.productVersion??this.R()),x=await this.n.scanOneOrMultipleExtensions(T);return this.J(x,Z,q,!0)}async scanMultipleExtensions(B,Z,q){const T=[];return await Promise.all(B.map(async x=>{const Y=await this.scanOneOrMultipleExtensions(x,Z,q);T.push(...Y)})),this.J(T,Z,q,!0)}async scanMetadata(B){const Z=(0,p.$Vg)(B,"package.json"),q=(await this.w.readFile(Z)).value.toString();return JSON.parse(q).__metadata}async updateMetadata(B,Z){const q=(0,p.$Vg)(B,"package.json"),T=(await this.w.readFile(q)).value.toString(),x=JSON.parse(T);Z.isMachineScoped===!1&&delete Z.isMachineScoped,Z.isBuiltin===!1&&delete Z.isBuiltin,x.__metadata={...x.__metadata,...Z},await this.w.writeFile((0,p.$Vg)(B,"package.json"),A.$ue.fromString(JSON.stringify(x,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(B){if(B instanceof P.$aq&&B.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw B}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const B=await this.scanUserExtensions({includeInvalid:!0});if(B.length)await this.u.addExtensionsToProfile(B.map(Z=>[Z,Z.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$ue.fromString(JSON.stringify([])))}catch(Z){(0,r.$6k)(Z)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,R.$0)(Z))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(B){this.y.error(B)}finally{this.H=void 0}})()),this.H}async J(B,Z,q,T){return q.includeAllVersions||(B=this.L(Z===0?B:void 0,Z===1?B:void 0,Z==="development"?B:void 0,await this.getTargetPlatform(),T)),q.includeInvalid||(B=B.filter(x=>x.isValid)),B.sort((x,Y)=>{const Q=v.$oc(x.location.fsPath),_=v.$oc(Y.location.fsPath);return Q<_?-1:Q>_?1:0})}L(B,Z,q,T,x){const Y=(_,M,F)=>{if(_.isValid&&!M.isValid)return!1;if(_.isValid===M.isValid){if(x&&w.gt(_.manifest.version,M.manifest.version))return this.y.debug(`Skipping extension ${M.location.path} with lower version ${M.manifest.version} in favour of ${_.location.path} with version ${_.manifest.version}`),!1;if(w.eq(_.manifest.version,M.manifest.version)){if(_.type===0)return this.y.debug(`Skipping extension ${M.location.path} in favour of system extension ${_.location.path} with same version`),!1;if(_.targetPlatform===T)return this.y.debug(`Skipping extension ${M.location.path} from different target platform ${M.targetPlatform}`),!1}}return F?this.y.warn(`Overwriting user extension ${_.location.path} with ${M.location.path}.`):this.y.debug(`Overwriting user extension ${_.location.path} with ${M.location.path}.`),!0},Q=new g.$Fm;return B?.forEach(_=>{const M=Q.get(_.identifier.id);(!M||Y(M,_,!1))&&Q.set(_.identifier.id,_)}),Z?.forEach(_=>{const M=Q.get(_.identifier.id);if(!M&&B&&_.type===0){this.y.debug(`Skipping obsolete system extension ${_.location.path}.`);return}(!M||Y(M,_,!1))&&Q.set(_.identifier.id,_)}),q?.forEach(_=>{const M=Q.get(_.identifier.id);(!M||Y(M,_,!0))&&Q.set(_.identifier.id,_),Q.set(_.identifier.id,_)}),[...Q.values()]}async M(B,Z){this.y.trace("Started scanning system extensions");const q=await this.P(this.systemExtensionsLocation,!1,0,!0,Z,!0,void 0,this.R()),x=await(B&&!q.devMode?this.j:this.n).scanExtensions(q);return this.y.trace("Scanned system extensions:",x.length),x}async N(B,Z){const q=this.z.isBuilt?[]:this.C.builtInExtensions;if(!q?.length)return[];this.y.trace("Started scanning dev system extensions");const T=Z?await this.O():{},x=[],Y=c.URI.file(v.$ic(v.$kc(y.$Cg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const _ of q){const M=T[_.name]||"marketplace";switch(M){case"disabled":break;case"marketplace":x.push((0,p.$Vg)(Y,_.name));break;default:x.push(c.URI.file(M));break}}const Q=await Promise.all(x.map(async _=>this.n.scanExtension(await this.P(_,!1,0,!0,B,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",Q.length),(0,D.$Hb)(Q)}async O(){try{const B=await this.w.readFile(this.r);return JSON.parse(B.value.toString())}catch{return{}}}async P(B,Z,q,T,x,Y,Q,_){const M=await this.f(x??d.$w),F=await this.Q(B),f=Z&&!this.D.extUri.isEqual(B,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,E=f?await this.Q(f):void 0;return new X(B,F,f,E,Z,Q,q,T,Y,_.version,_.date,this.C.commit,!this.z.isBuilt,x,M)}async Q(B){try{const Z=await this.w.stat(B);if(typeof Z.mtime=="number")return Z.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$gq=V,e.$gq=V=$e([oe(4,I.$ol),oe(5,P.$bq),oe(6,r.$Ok),oe(7,n.$Oj),oe(8,$.$pi),oe(9,s.$8j),oe(10,L.$ml),oe(11,t.$hi)],V);class X{constructor(B,Z,q,T,x,Y,Q,_,M,F,f,E,N,C,W){this.location=B,this.mtime=Z,this.applicationExtensionslocation=q,this.applicationExtensionslocationMtime=T,this.profile=x,this.profileScanOptions=Y,this.type=Q,this.excludeObsolete=_,this.validate=M,this.productVersion=F,this.productDate=f,this.productCommit=E,this.devMode=N,this.language=C,this.translations=W}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,Z){return(0,p.$Og)(B.location,Z.location)&&B.mtime===Z.mtime&&(0,p.$Og)(B.applicationExtensionslocation,Z.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===Z.applicationExtensionslocationMtime&&B.profile===Z.profile&&k.$Sn(B.profileScanOptions,Z.profileScanOptions)&&B.type===Z.type&&B.excludeObsolete===Z.excludeObsolete&&B.validate===Z.validate&&B.productVersion===Z.productVersion&&B.productDate===Z.productDate&&B.productCommit===Z.productCommit&&B.devMode===Z.devMode&&B.language===Z.language&&U.equals(B.translations,Z.translations)}}e.$hq=X;let se=class extends a.$Uc{constructor(B,Z,q,T,x){super(),this.f=B,this.g=Z,this.h=q,this.j=T,this.m=x}async scanExtensions(B){const Z=B.profile?await this.r(B):await this.n(B);let q={};if(B.excludeObsolete&&B.type===1)try{const T=(await this.j.readFile(this.f)).value.toString();q=JSON.parse(T)}catch{}return(0,m.$9f)(q)?Z:Z.filter(T=>!q[h.$hp.create(T).toString()])}async n(B){const Z=await this.j.resolve(B.location);if(!Z.children?.length)return[];const q=await Promise.all(Z.children.map(async T=>{if(!T.isDirectory||B.type===1&&(0,p.$Sg)(T.resource).indexOf(".")===0)return null;const x=new X(T.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(x)}));return(0,D.$Hb)(q).sort((T,x)=>T.location.path<x.location.path?-1:1)}async r(B){let Z=await this.s(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.h.extUri.isEqual(B.location,B.applicationExtensionslocation)){Z=Z.filter(T=>!T.metadata?.isApplicationScoped);const q=await this.s(B.applicationExtensionslocation,T=>!!T.metadata?.isBuiltin||!!T.metadata?.isApplicationScoped,B);Z.push(...q)}return Z}async s(B,Z,q){const T=await this.g.scanProfileExtensions(B,q.profileScanOptions);if(!T.length)return[];const x=await Promise.all(T.map(async Y=>{if(Z(Y)){const Q=new X(Y.location,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(Q,Y.metadata)}return null}));return(0,D.$Hb)(x)}async scanOneOrMultipleExtensions(B){try{if(await this.j.exists((0,p.$Vg)(B.location,"package.json"))){const Z=await this.scanExtension(B);return Z?[Z]:[]}else return await this.scanExtensions(B)}catch(Z){return this.m.error(`Error scanning extensions at ${B.location.path}:`,(0,R.$0)(Z)),[]}}async scanExtension(B,Z){try{let q=await this.scanExtensionManifest(B.location);if(q){q.publisher||(q.publisher=g.$zm),Z=Z??q.__metadata,delete q.__metadata;const T=(0,h.$lp)(q.publisher,q.name),x=Z?.id?{id:T,uuid:Z.id}:{id:T},Y=Z?.isSystem?0:B.type,Q=Y===0||!!Z?.isBuiltin;q=await this.t(B.location,q,X.createNlsConfiguration(B));const _={type:Y,identifier:x,manifest:q,location:B.location,isBuiltin:Q,targetPlatform:Z?.targetPlatform??"undefined",metadata:Z,isValid:!0,validations:[]};return B.validate?this.validate(_,B):_}}catch(q){B.type!==0&&this.m.error(q)}return null}validate(B,Z){let q=!0;const T=(0,i.$wp)(Z.productVersion,Z.productDate,Z.location,B.manifest,B.isBuiltin);for(const[x,Y]of T)x===O.default.Error&&(q=!1,this.m.error(this.z(Z.location,Y)));return B.isValid=q,B.validations=T,B}async scanExtensionManifest(B){const Z=(0,p.$Vg)(B,"package.json");let q;try{q=(await this.j.readFile(Z)).value.toString()}catch(x){return(0,r.$6k)(x)!==1&&this.m.error(this.z(B,(0,b.localize)(0,null,Z.path,x.message))),null}let T;try{T=JSON.parse(q)}catch{const Y=[];(0,S.$vn)(q,Y);for(const Q of Y)this.m.error(this.z(B,(0,b.localize)(1,null,Z.path,Q.offset,Q.length,(0,u.$dq)(Q.error))));return null}return(0,S.$En)(T)!=="object"?(this.m.error(this.z(B,(0,b.localize)(2,null,Z.path))),null):T}async t(B,Z,q){const T=await this.u(B,Z,q);if(T)try{const x=[],Y=await this.w(T.default,x);if(x.length>0)return x.forEach(_=>{this.m.error(this.z(B,(0,b.localize)(3,null,T.default?.path,(0,u.$dq)(_.error))))}),Z;if((0,S.$En)(T)!=="object")return this.m.error(this.z(B,(0,b.localize)(4,null,T.default?.path))),Z;const Q=T.values||Object.create(null);return(0,z.$eq)(this.m,Z,Q,Y)}catch{}return Z}async u(B,Z,q){const T=(0,p.$Vg)(B,"package.nls.json"),x=(M,F)=>{F.forEach(f=>{this.m.error(this.z(B,(0,b.localize)(5,null,M?.path,(0,u.$dq)(f.error))))})},Y=M=>{this.m.error(this.z(B,(0,b.localize)(6,null,M?.path)))},Q=`${Z.publisher}.${Z.name}`,_=q.translations[Q];if(_)try{const M=c.URI.file(_),F=(await this.j.readFile(M)).value.toString(),f=[],E=(0,S.$vn)(F,f);return f.length>0?(x(M,f),{values:void 0,default:T}):(0,S.$En)(E)!=="object"?(Y(M),{values:void 0,default:T}):{values:E.contents?E.contents.package:void 0,default:T}}catch{return{values:void 0,default:T}}else{if(!await this.j.exists(T))return;let F;try{F=await this.y(B,q)}catch{return}if(!F.localized)return{values:void 0,default:F.original};try{const f=(await this.j.readFile(F.localized)).value.toString(),E=[],N=(0,S.$vn)(f,E);return E.length>0?(x(F.localized,E),{values:void 0,default:F.original}):(0,S.$En)(N)!=="object"?(Y(F.localized),{values:void 0,default:F.original}):{values:N,default:F.original}}catch{return{values:void 0,default:F.original}}}}async w(B,Z){if(B)try{const q=(await this.j.readFile(B)).value.toString();return(0,S.$vn)(q,Z)}catch{}}y(B,Z){return new Promise((q,T)=>{const x=Y=>{const Q=(0,p.$Vg)(B,`package.nls.${Y}.json`);this.j.exists(Q).then(_=>{_&&q({localized:Q,original:(0,p.$Vg)(B,"package.nls.json")});const M=Y.lastIndexOf("-");M===-1?q({localized:(0,p.$Vg)(B,"package.nls.json"),original:null}):(Y=Y.substring(0,M),x(Y))})};if(Z.devMode||Z.pseudo||!Z.language)return q({localized:(0,p.$Vg)(B,"package.nls.json"),original:null});x(Z.language)})}z(B,Z){return`[${B.path}]: ${Z}`}};se=$e([oe(1,P.$bq),oe(2,L.$ml),oe(3,r.$Ok),oe(4,n.$Oj)],se);let ie=class extends se{constructor(B,Z,q,T,x,Y,Q){super(Z,T,x,Y,Q),this.G=B,this.H=q,this.D=this.B(new j.$gh(3e3)),this.F=this.B(new o.$7d),this.onDidChangeCache=this.F.event}async scanExtensions(B){const Z=this.M(B),q=await this.I(Z);if(this.C=B,q&&q.input&&X.equals(q.input,this.C))return this.m.debug("Using cached extensions scan result",B.location.toString()),this.D.trigger(()=>this.L()),q.result.map(x=>(x.location=c.URI.revive(x.location),x));const T=await super.scanExtensions(B);return await this.J(Z,{input:B,result:T}),T}async I(B){try{const Z=await this.j.readFile(B),q=JSON.parse(Z.value.toString());return{result:q.result,input:(0,l.$Rh)(q.input)}}catch(Z){this.m.debug("Error while reading the extension cache file:",B.path,(0,R.$0)(Z))}return null}async J(B,Z){try{await this.j.writeFile(B,A.$ue.fromString(JSON.stringify(Z)))}catch(q){this.m.debug("Error while writing the extension cache file:",B.path,(0,R.$0)(q))}}async L(){if(!this.C)return;const B=this.M(this.C),Z=await this.I(B);if(!Z)return;const q=Z.result,T=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!k.$Sn(T,q))try{this.m.info("Invalidating Cache",q,T),await this.j.del(B),this.F.fire()}catch(x){this.m.error(x)}}M(B){const Z=this.N(B);return this.h.extUri.joinPath(Z.cacheHome,B.type===0?g.$ym:g.$xm)}N(B){return B.type===0?this.H.defaultProfile:B.profile?this.h.extUri.isEqual(B.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Z=>this.h.extUri.isEqual(B.location,Z.extensionsResource))??this.G:this.H.defaultProfile}};ie=$e([oe(2,I.$ol),oe(3,P.$bq),oe(4,L.$ml),oe(5,r.$Ok),oe(6,n.$Oj)],ie);function ue(ce,B){const Z=(0,h.$jp)(ce.manifest.publisher,ce.manifest.name);return{id:Z,identifier:new g.$Dm(Z),isBuiltin:ce.type===0,isUserBuiltin:ce.type===1&&ce.isBuiltin,isUnderDevelopment:B,extensionLocation:ce.location,uuid:ce.identifier.uuid,targetPlatform:ce.targetPlatform,...ce.manifest}}class he extends V{constructor(B,Z,q,T,x,Y,Q,_,M,F,f,E){super(B,Z,(0,p.$Vg)(q,".vscode-oss-dev","extensions","control.json"),T,x,Y,Q,_,M,F,f,E),this.S=(async()=>{if(d.$z)try{const N=await this.w.readFile(c.URI.file(d.$z));return JSON.parse(N.value.toString())}catch{}return Object.create(null)})()}f(B){return this.S}}e.$jq=he}),define(ne[161],re([0,1,59,9,34,5,2,15,16,25,6,24]),function(J,e,D,j,k,A,R,S,u,a,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=void 0;let d=class extends R.$Uc{constructor(w,O){super(),this.b=w,this.f=O,this.a=new j.$oh(5)}async postUninstall(w){const O=this.g(w,"uninstall");O&&(this.f.info(w.identifier.id,w.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(O.script,"uninstall",O.args,!0,w),this.f.info("Finished running post uninstall script",w.identifier.id,w.manifest.version)}catch(m){this.f.error("Failed to run post uninstall script",w.identifier.id,w.manifest.version),this.f.error(m)}}));try{await a.Promises.rm(this.m(w))}catch(m){this.f.error("Error while removing extension storage path",w.identifier.id),this.f.error(m)}}g(w,O){const m=`vscode:${O}`;if(w.location.scheme===S.Schemas.file&&w.manifest&&w.manifest.scripts&&typeof w.manifest.scripts[m]=="string"){const c=w.manifest.scripts[m].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.f.warn(w.identifier.id,w.manifest.version,`${m} should be a node script`),null):{script:(0,u.$kc)(w.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}h(w,O,m,c,b){return new Promise(($,h)=>{const g=this.j(w,O,m,b);let i;const r=t=>{i&&(clearTimeout(i),i=null),t?h(t):$(void 0)};g.on("error",t=>{r((0,k.$6i)(t)||"Unknown")}),g.on("exit",(t,n)=>{r(t?`post-${O} process exited with code ${t}`:void 0)}),c&&(i=setTimeout(()=>{i=null,g.kill(),h("timed out")},5e3))})}j(w,O,m,c){const b={silent:!0,execArgv:void 0},$=(0,D.fork)(w,[`--type=extension-post-${O}`,...m],b);$.stdout.setEncoding("utf8"),$.stderr.setEncoding("utf8");const h=A.Event.fromNodeEventEmitter($.stdout,"data"),g=A.Event.fromNodeEventEmitter($.stderr,"data");h(t=>this.f.info(c.identifier.id,c.manifest.version,`post-${O}`,t)),g(t=>this.f.error(c.identifier.id,c.manifest.version,`post-${O}`,t));const i=A.Event.any(A.Event.map(h,t=>({data:`%c${t}`,format:[""]})),A.Event.map(g,t=>({data:`%c${t}`,format:["color: red"]})));return A.Event.debounce(i,(t,n)=>t?{data:t.data+n.data,format:[...t.format,...n.format]}:{data:n.data,format:n.format},100)(t=>{console.group(c.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),$}m(w){return(0,u.$kc)(this.b.defaultProfile.globalStorageHome.fsPath,w.identifier.id.toLowerCase())}};e.$lq=d,e.$lq=d=$e([oe(0,v.$ol),oe(1,y.$Oj)],d)}),define(ne[162],re([0,1,9,14,20,34,8,5,43,2,31,15,16,17,44,3,11,28,25,49,99,61,18,160,21,26,42,53,147,161,117,140,148,50,13,10,6,32,22,23,24]),function(J,e,D,j,k,A,R,S,u,a,y,v,d,p,w,O,m,c,b,$,h,g,i,r,t,n,s,o,l,P,I,L,z,U,V,X,se,ie,ue,he,ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$rq=e.$qq=e.$pq=void 0,e.$pq=(0,X.$ji)(t.$Uo);const B=".vsctmp";let Z=class extends r.$9p{constructor(M,F,f,E,N,C,W,G,te,ae,le,pe){super(M,F,le,f,ae,pe),this.eb=N,this.fb=C,this.gb=W,this.hb=te,this.db=new Map,this.qb=new y.$Cc;const ye=this.B(G.createInstance(P.$lq));this.ab=this.B(G.createInstance(q,me=>ye.postUninstall(me))),this.bb=this.B(new L.$nq(pe,te,le,this,this.F)),this.cb=this.B(G.createInstance(l.$kq));const fe=this.B(new z.$oq(this,this.eb,pe,C,le,te,f));this.B(fe.onDidChangeExtensionsByAnotherSource(me=>this.pb(me))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,n.$rp)(this.hb,this.F)),this.ib}async zip(M){this.F.trace("ExtensionManagementService#zip",M.identifier.id);const F=await this.ob(M),f=await(0,$.zip)((0,p.$Vg)(this.cb.extensionsDownloadDir,(0,c.$Eg)()).fsPath,F);return m.URI.file(f)}async unzip(M){return this.F.trace("ExtensionManagementService#unzip",M.toString()),(await this.install(M)).identifier}async getManifest(M){const{location:F,cleanup:f}=await this.kb(M),E=d.$lc(F.fsPath);try{return await(0,I.$mq)(E)}finally{await f()}}getInstalled(M,F=this.H.defaultProfile.extensionsResource,f={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(M??null,F,f)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(M){return this.ab.scanUserExtensionAtLocation(M)}async install(M,F={}){this.F.trace("ExtensionManagementService#install",M.toString());const{location:f,cleanup:E}=await this.kb(M);try{const N=await(0,I.$mq)(d.$lc(f.fsPath)),C=(0,n.$lp)(N.publisher,N.name);if(N.engines&&N.engines.vscode&&!(0,U.$yp)(N.engines.vscode,this.G.version,this.G.date))throw new Error(h.localize(0,null,C,this.G.version));const G=(await this.I([{manifest:N,extension:f,options:F}])).find(({identifier:te})=>(0,n.$gp)(te,{id:C}));if(G?.local)return G.local;throw G?.error?G.error:(0,r.$$p)(new Error(`Unknown error while installing extension ${C}`))}finally{await E()}}async installFromLocation(M,F){this.F.trace("ExtensionManagementService#installFromLocation",M.toString());const f=await this.ab.scanUserExtensionAtLocation(M);if(!f||!f.manifest.name||!f.manifest.version)throw new Error(`Cannot find a valid extension from the location ${M.toString()}`);return await this.tb([[f,{source:"resource"}]],F),this.F.info("Successfully installed extension",f.identifier.id,F.toString()),f}async installExtensionsFromProfile(M,F,f){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",M,F.toString(),f.toString());const E=(await this.getInstalled(1,F)).filter(N=>M.some(C=>(0,n.$gp)(C,N.identifier)));if(E.length){const N=await Promise.all(E.map(C=>this.ab.scanMetadata(C,F)));await this.tb(E.map((C,W)=>[C,N[W]]),f),this.F.info("Successfully installed extensions",E.map(C=>C.identifier.id),f.toString())}return E}async updateMetadata(M,F,f=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",M.identifier.id),F.isPreReleaseVersion&&(F.preRelease=!0,F.hasPreReleaseVersion=!0),F.isMachineScoped===!1&&(F.isMachineScoped=void 0),F.isBuiltin===!1&&(F.isBuiltin=void 0),F.pinned===!1&&(F.pinned=void 0),M=await this.ab.updateMetadata(M,F,f),this.bb.invalidate(f),this.w.fire(M),M}async reinstallFromGallery(M){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",M.identifier.id),!this.z.isEnabled())throw new Error(h.localize(1,null));const F=await this.getTargetPlatform(),[f]=await this.z.getExtensions([{...M.identifier,preRelease:M.preRelease}],{targetPlatform:F,compatible:!0},k.CancellationToken.None);if(!f)throw new Error(h.localize(2,null));await this.ab.setUninstalled(M);try{await this.ab.removeUninstalledExtension(M)}catch(E){throw new Error(h.localize(3,null,(0,A.$6i)(E)))}return this.installFromGallery(f)}$(M,F,f,E){return this.ab.copyExtension(M,F,f,E)}copyExtensions(M,F){return this.ab.copyExtensions(M,F,{version:this.G.version,date:this.G.date})}markAsUninstalled(...M){return this.ab.setUninstalled(...M)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(M){this.F.error(M)}}async download(M,F,f){const{location:E}=await this.cb.download(M,F,!f);return E}async kb(M){if(M.scheme===v.Schemas.file)return{location:M,async cleanup(){}};this.F.trace("Downloading extension from",M.toString());const F=(0,p.$Vg)(this.cb.extensionsDownloadDir,(0,c.$Eg)());return await this.gb.download(M,F),this.F.info("Downloaded extension to",F.toString()),{location:F,cleanup:async()=>{try{await this.hb.del(F)}catch(E){this.F.error(E)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(M,F,f){if(m.URI.isUri(F))return new Y(M,F,f,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const E=n.$hp.create(F).toString();let N=this.db.get(E);return N||(this.db.set(E,N=new x(M,F,f,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F)),N.waitUntilTaskIsFinished().finally(()=>this.db.delete(E))),N}Z(M,F){return new Q(M,F.profileLocation,this.fb)}async ob(M){const F=async E=>{let N=await b.Promises.readdir(E);N=N.map(G=>d.$kc(E,G));const C=await Promise.all(N.map(G=>b.Promises.stat(G)));let W=Promise.resolve([]);return C.forEach((G,te)=>{const ae=N[te];G.isFile()&&(W=W.then(le=>[...le,ae])),G.isDirectory()&&(W=W.then(le=>F(ae).then(pe=>[...le,...pe])))}),W};return(await F(M.location.fsPath)).map(E=>({path:`extension/${d.$mc(M.location.fsPath,E)}`,localPath:E}))}async pb({added:M,removed:F}){if(F){const f=M&&this.D.extUri.isEqual(F.profileLocation,M.profileLocation)?F.extensions.filter(E=>M.extensions.every(N=>!(0,n.$gp)(N,E))):F.extensions;for(const E of f)this.F.info("Extensions removed from another source",E.id,F.profileLocation.toString()),this.u.fire({identifier:E,profileLocation:F.profileLocation})}if(M){const E=(await this.getInstalled(1,M.profileLocation)).filter(N=>M.extensions.some(C=>(0,n.$gp)(C,N.identifier)));this.s.fire(E.map(N=>(this.F.info("Extensions added from another source",N.identifier.id,M.profileLocation.toString()),{identifier:N.identifier,local:N,profileLocation:M.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(F=>this.qb.add(F)));const M=await this.hb.resolve(this.eb.userExtensionsLocation);for(const F of M.children??[])F.isDirectory&&this.qb.add(F.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(F=>this.sb(F)))}async sb(M){if(!M.affects(this.eb.userExtensionsLocation,1))return;const F=[];for(const f of M.rawAdded){if(this.qb.has(f)||!this.D.extUri.isEqual(this.D.extUri.dirname(f),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(f,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(f).startsWith(".")||!(await this.hb.stat(f)).isDirectory)continue;const E=await this.ab.scanUserExtensionAtLocation(f);E&&E.installedTimestamp===void 0&&(this.qb.add(f),F.push(E))}F.length&&(await this.tb(F.map(f=>[f,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",F.map(f=>f.identifier.id)))}async tb(M,F){const f=M.map(E=>E[0]);await this.ub(f),await this.fb.addExtensionsToProfile(M,F),this.s.fire(f.map(E=>({local:E,identifier:E.identifier,operation:1,profileLocation:F})))}async ub(M){const F=await this.ab.getUninstalledExtensions();for(const f of M){const E=n.$hp.create(f);F[E.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",E.id),await this.ab.setInstalled(E),this.F.info("Removed the extension from uninstalled list:",E.id))}}};e.$qq=Z,e.$qq=Z=$e([oe(0,t.$Ro),oe(1,ue.$Nl),oe(2,se.$Oj),oe(3,i.$qi),oe(4,o.$fq),oe(5,s.$bq),oe(6,g.$wo),oe(7,X.$hi),oe(8,V.$Ok),oe(9,ie.$8j),oe(10,he.$ml),oe(11,ce.$ol)],Z);let q=class extends a.$Uc{constructor(M,F,f,E,N,C){super(),this.j=M,this.m=F,this.n=f,this.s=E,this.t=N,this.u=C,this.h=this.B(new S.$7d),this.onExtract=this.h.event,this.c=(0,p.$Vg)(this.n.userExtensionsLocation,".obsolete"),this.g=new D.$ph}async cleanUp(){await this.H(),await this.G()}async scanExtensions(M,F,f){const E={includeInvalid:!0,profileLocation:F,productVersion:f};let N=[];return M===null||M===0?N.push(...await this.n.scanAllExtensions({includeInvalid:!0},E,!1)):M===1&&N.push(...await this.n.scanUserExtensions(E)),N=M!==null?N.filter(C=>C.type===M):N,Promise.all(N.map(C=>this.F(C)))}async scanAllUserExtensions(M){const F=await this.n.scanUserExtensions({includeAllVersions:!M,includeInvalid:!0});return Promise.all(F.map(f=>this.F(f)))}async scanUserExtensionAtLocation(M){try{const F=await this.n.scanExistingExtension(M,1,{includeInvalid:!0});if(F)return await this.F(F)}catch(F){this.u.error(F)}return null}async extractUserExtension(M,F,f,E,N){const C=M.toString(),W=m.URI.file(d.$kc(this.n.userExtensionsLocation.fsPath,`.${(0,c.$Eg)()}`)),G=m.URI.file(d.$kc(this.n.userExtensionsLocation.fsPath,C));let te=await this.m.exists(G);if(te&&E){try{await this.y(M.id,G,"removeExisting")}catch{throw new t.$So(h.localize(4,null,G.fsPath,M.id),t.ExtensionManagementErrorCode.Delete)}te=!1}if(te)await this.n.updateMetadata(G,f);else try{try{this.u.trace(`Started extracting the extension from ${F} to ${G.fsPath}`),await(0,$.$7p)(F,W.fsPath,{sourcePath:"extension",overwrite:!0},N),this.u.info(`Extracted extension to ${G}:`,M.id)}catch(ae){let le=t.ExtensionManagementErrorCode.Extract;throw ae instanceof $.$5p&&(ae.type==="CorruptZip"?le=t.ExtensionManagementErrorCode.CorruptZip:ae.type==="Incomplete"&&(le=t.ExtensionManagementErrorCode.IncompleteZip)),new t.$So(ae.message,le)}await this.n.updateMetadata(W,f);try{this.u.trace(`Started renaming the extension from ${W.fsPath} to ${G.fsPath}`),await this.C(W.fsPath,G.fsPath),this.u.info("Renamed to",G.fsPath)}catch(ae){if(ae.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",M.id);else throw this.u.info(`Rename failed because of ${(0,R.$0)(ae)}. Deleted from extracted location`,W),ae}this.h.fire(G)}catch(ae){try{await this.m.del(W,{recursive:!0})}catch{}throw ae}return this.D(G,1)}async scanMetadata(M,F){return F?(await this.w(M,F))?.metadata:this.n.scanMetadata(M.location)}async w(M,F){return(await this.s.scanProfileExtensions(F)).find(E=>(0,n.$gp)(E.identifier,M.identifier))}async updateMetadata(M,F,f){return f?await this.s.updateMetadata([[M,F]],f):await this.n.updateMetadata(M.location,F),this.D(M.location,M.type,f)}getUninstalledExtensions(){return this.z()}async setUninstalled(...M){const F=M.map(f=>n.$hp.create(f));await this.z(f=>F.forEach(E=>{f[E.toString()]=!0,this.u.info("Marked extension as uninstalled",E.toString())}))}async setInstalled(M){await this.z(F=>delete F[M.toString()])}async removeExtension(M,F){if(this.t.extUri.isEqualOrParent(M.location,this.n.userExtensionsLocation))return this.y(M.identifier.id,M.location,F)}async removeUninstalledExtension(M){await this.removeExtension(M,"uninstalled"),await this.z(F=>delete F[n.$hp.create(M).toString()])}async copyExtension(M,F,f,E){const N=await this.w(M,F),C=await this.w(M,f);if(E={...N?.metadata,...E},C)if(this.t.extUri.isEqual(C.location,M.location))await this.s.updateMetadata([[M,{...C.metadata,...E}]],f);else{const W=await this.D(C.location,M.type,f);await this.s.removeExtensionFromProfile(W,f),await this.s.addExtensionsToProfile([[M,{...C.metadata,...E}]],f)}else await this.s.addExtensionsToProfile([[M,E]],f);return this.D(M.location,M.type,f)}async copyExtensions(M,F,f){const E=await this.scanExtensions(1,M,f),N=await Promise.all(E.filter(C=>!C.isApplicationScoped).map(async C=>[C,await this.scanMetadata(C,M)]));await this.s.addExtensionsToProfile(N,F)}async y(M,F,f){this.u.trace(`Deleting ${f} extension from disk`,M,F.fsPath);const E=this.t.extUri.joinPath(this.t.extUri.dirname(F),`${this.t.extUri.basename(F)}.${(0,u.$9i)((0,c.$Eg)()).toString(16)}${B}`);await this.C(F.fsPath,E.fsPath),await this.m.del(E,{recursive:!0}),this.u.info(`Deleted ${f} extension from disk`,M,F.fsPath)}async z(M){return this.g.queue(async()=>{let F;try{F=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(E){if((0,V.$6k)(E)!==1)throw E}let f={};if(F)try{f=JSON.parse(F)}catch{}return M&&(M(f),Object.keys(f).length?await this.m.writeFile(this.c,j.$ue.fromString(JSON.stringify(f))):await this.m.del(this.c)),f})}async C(M,F){try{await b.Promises.rename(M,F,2*60*1e3)}catch(f){throw new t.$So(f.message||h.localize(5,null,M,F),f.code||t.ExtensionManagementErrorCode.Rename)}}async D(M,F,f){if(f){const N=(await this.n.scanUserExtensions({profileLocation:f})).find(C=>this.t.extUri.isEqual(C.location,M));if(N)return this.F(N)}else{const E=await this.n.scanExistingExtension(M,F,{includeInvalid:!0});if(E)return this.F(E)}throw new Error(h.localize(6,null,M.path))}async F(M){const F=await this.m.resolve(M.location);let f,E;return F.children&&(f=F.children.find(({name:N})=>/^readme(\.txt|\.md|)$/i.test(N))?.resource,E=F.children.find(({name:N})=>/^changelog(\.txt|\.md|)$/i.test(N))?.resource),{identifier:M.identifier,type:M.type,isBuiltin:M.isBuiltin||!!M.metadata?.isBuiltin,location:M.location,manifest:M.manifest,targetPlatform:M.targetPlatform,validations:M.validations,isValid:M.isValid,readmeUrl:f,changelogUrl:E,publisherDisplayName:M.metadata?.publisherDisplayName||null,publisherId:M.metadata?.publisherId||null,isApplicationScoped:!!M.metadata?.isApplicationScoped,isMachineScoped:!!M.metadata?.isMachineScoped,isPreReleaseVersion:!!M.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!M.metadata?.hasPreReleaseVersion,preRelease:!!M.metadata?.preRelease,installedTimestamp:M.metadata?.installedTimestamp,updated:!!M.metadata?.updated,pinned:!!M.metadata?.pinned,isWorkspaceScoped:!1,source:M.metadata?.source??(M.identifier.uuid?"gallery":"vsix")}}async G(){const M=await this.getUninstalledExtensions();if(Object.keys(M).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(M));const F=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),f=new Set;for(const N of F)M[n.$hp.create(N).toString()]||f.add(N.identifier.id.toLowerCase());try{const N=(0,n.$mp)(F,C=>C.identifier);await D.Promises.settled(N.map(async C=>{const W=C.sort((G,te)=>w.rcompare(G.manifest.version,te.manifest.version))[0];f.has(W.identifier.id.toLowerCase())||await this.j(await this.F(W))}))}catch(N){this.u.error(N)}const E=F.filter(N=>N.metadata&&M[n.$hp.create(N).toString()]);await Promise.allSettled(E.map(N=>this.removeUninstalledExtension(N)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let M;try{M=await this.m.resolve(this.n.userExtensionsLocation)}catch(F){(0,V.$6k)(F)!==1&&this.u.error(F);return}if(M?.children)try{await Promise.allSettled(M.children.map(async F=>{if(!(!F.isDirectory||!F.name.endsWith(B))){this.u.trace("Deleting the temporarily deleted folder",F.resource.toString());try{await this.m.del(F.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",F.resource.toString())}catch(f){(0,V.$6k)(f)!==1&&this.u.error(f)}}}))}catch{}}};e.$rq=q,e.$rq=q=$e([oe(1,V.$Ok),oe(2,o.$fq),oe(3,s.$bq),oe(4,he.$ml),oe(5,se.$Oj)],q);class T extends r.$_p{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,O.$3f)(this.options.operation)?this.l:this.options.operation}constructor(M,F,f,E,N,C,W,G,te){super(),this.identifier=M,this.source=F,this.options=f,this.m=E,this.n=N,this.o=C,this.p=W,this.q=G,this.s=te,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(M){const[F,f]=await this.x(M);return this.j=F.isBuiltin||F.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[F,f]],this.j,!F.isValid),F}async u({zipPath:M,key:F,metadata:f},E,N){let C=await this.v(F);return C?C=await this.m.updateMetadata(C,f):(this.s.trace("Extracting extension...",F.id),C=await this.m.extractUserExtension(F,M,f,E,N),this.s.info("Extracting extension completed.",F.id)),C}async v(M){return await this.w(M)?(this.s.trace("Removing the extension from uninstalled list:",M.id),await this.m.setInstalled(M),this.s.info("Removed the extension from uninstalled list:",M.id),(await this.m.scanAllUserExtensions(!0)).find(E=>n.$hp.create(E).equals(M))):void 0}async w(M){return!!(await this.m.getUninstalledExtensions())[M.toString()]}}class x extends T{constructor(M,F,f,E,N,C,W,G,te,ae){super(F.identifier,F,f,N,C,W,G,te,ae),this.y=F,this.z=E}async x(M){let F;try{F=await this.m.scanExtensions(null,this.options.profileLocation,this.options.productVersion)}catch(W){throw new t.$So(W,t.ExtensionManagementErrorCode.Scanning)}const f=F.find(W=>(0,n.$gp)(W.identifier,this.y.identifier));f&&(this.l=3);const E={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||f?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||f?.isMachineScoped,isBuiltin:this.options.isBuiltin||f?.isBuiltin,isSystem:f?.type===0?!0:void 0,updated:!!f,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:f?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??f?.pinned,preRelease:(0,O.$2f)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||f?.preRelease,source:"gallery"};if(f?.manifest.version===this.y.version)try{return[await this.m.updateMetadata(f,E),E]}catch(W){throw new t.$So((0,R.$0)(W),t.ExtensionManagementErrorCode.UpdateMetadata)}const{location:N,verificationStatus:C}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=C,this.B(N.fsPath),[await this.u({zipPath:N.fsPath,key:n.$hp.create(this.y),metadata:E},!1,M),E]}catch(W){try{await this.z.delete(N)}catch(G){this.s.warn("Error while deleting the downloaded file",N.toString(),(0,R.$0)(G))}throw W}}async B(M){try{await(0,I.$mq)(M)}catch(F){throw new t.$So((0,r.$0p)(F).message,t.ExtensionManagementErrorCode.Invalid)}}}e.$sq=x;class Y extends T{constructor(M,F,f,E,N,C,W,G,te,ae){super({id:(0,n.$lp)(M.publisher,M.name)},F,f,N,C,W,G,te,ae),this.y=M,this.z=F,this.A=E}async h(M){const F=await super.h(M);return this.D(F,M),F}async x(M){const F=new n.$hp(this.identifier,this.y.version),E=(await this.m.scanExtensions(1,this.options.profileLocation,this.options.productVersion)).find(W=>(0,n.$gp)(this.identifier,W.identifier)),N={isApplicationScoped:this.options.isApplicationScoped||E?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||E?.isMachineScoped,isBuiltin:this.options.isBuiltin||E?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??E?.pinned,source:"vsix"};if(E)if(this.l=3,F.equals(new n.$hp(E.identifier,E.manifest.version)))try{await this.m.removeExtension(E,"existing")}catch{throw new Error(h.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&w.gt(E.manifest.version,this.y.version)&&await this.m.setUninstalled(E);else{const W=await this.v(F);if(W)try{await this.m.removeExtension(W,"existing")}catch{throw new Error(h.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:d.$lc(this.z.fsPath),key:F,metadata:N},!0,M),N]}async D(M,F){try{let[f]=await this.A.getExtensions([{id:M.identifier.id,version:M.manifest.version}],F);if(f||([f]=await this.A.getExtensions([{id:M.identifier.id}],F)),f){const E={id:f.identifier.uuid,publisherDisplayName:f.publisherDisplayName,publisherId:f.publisherId,isPreReleaseVersion:f.properties.isPreReleaseVersion,hasPreReleaseVersion:M.hasPreReleaseVersion||f.properties.isPreReleaseVersion,preRelease:f.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(M,E,this.options.profileLocation)}}catch{}}}class Q extends r.$_p{constructor(M,F,f){super(),this.extension=M,this.j=F,this.k=f}async h(M){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ne[163],re([0,1,6,24,23,22,42,13,18,11]),function(J,e,D,j,k,A,R,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4P=void 0;let y=class extends R.$cq{constructor(d,p,w,O,m,c){super(a.URI.file(d.extensionsPath),p,w,O,m,c)}};e.$4P=y,e.$4P=y=$e([oe(0,u.$qi),oe(1,S.$Ok),oe(2,j.$ol),oe(3,k.$ml),oe(4,A.$Nl),oe(5,D.$Oj)],y)}),define(ne[164],re([0,1,11,18,42,53,13,10,6,32,23,24]),function(J,e,D,j,k,A,R,S,u,a,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ubc=void 0;let d=class extends A.$jq{constructor(w,O,m,c,b,$,h,g){super(D.URI.file(b.builtinExtensionsPath),D.URI.file(b.extensionsPath),b.userHome,w.defaultProfile,w,O,m,c,b,$,h,g)}};e.$ubc=d,e.$ubc=d=$e([oe(0,v.$ol),oe(1,k.$bq),oe(2,R.$Ok),oe(3,u.$Oj),oe(4,j.$qi),oe(5,a.$8j),oe(6,y.$ml),oe(7,S.$hi)],d)}),define(ne[165],re([0,1,9,5,2,130,3,89,10,24]),function(J,e,D,j,k,A,R,S,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=e.$Op=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Mp=e.$Lp=e.$Kp=void 0,e.$Np=p,e.$Pp=O,e.$Rp=c,e.$Kp="__$__isNewStorageMarker",e.$Lp="__$__targetStorageMarker",e.$Mp=(0,u.$ii)("storageService");var y;(function(b){b[b.NONE=0]="NONE",b[b.SHUTDOWN=1]="SHUTDOWN"})(y||(e.WillSaveStateReason=y={}));var v;(function(b){b[b.APPLICATION=-1]="APPLICATION",b[b.PROFILE=0]="PROFILE",b[b.WORKSPACE=1]="WORKSPACE"})(v||(e.StorageScope=v={}));var d;(function(b){b[b.USER=0]="USER",b[b.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function p(b){const $=b.get(e.$Lp);if($)try{return JSON.parse($)}catch{}return Object.create(null)}class w extends k.$Uc{static{this.a=60*1e3}constructor($={flushInterval:w.a}){super(),this.m=$,this.b=this.B(new j.$0d),this.c=this.B(new j.$0d),this.onDidChangeTarget=this.c.event,this.f=this.B(new j.$7d),this.onWillSaveState=this.f.event,this.h=this.B(new D.$uh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new k.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue($,h,g){return j.Event.filter(this.b.event,i=>i.scope===$&&(h===void 0||i.key===h),g)}n(){this.j.value=(0,D.$yh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,k.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u($,h){const{key:g,external:i}=h;if(g===e.$Lp){switch($){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:$})}else this.b.fire({scope:$,key:g,target:this.J($)[g],external:i})}w($){this.f.fire({reason:$})}get($,h,g){return this.P(h)?.get($,g)}getBoolean($,h,g){return this.P(h)?.getBoolean($,g)}getNumber($,h,g){return this.P(h)?.getNumber($,g)}getObject($,h,g){return this.P(h)?.getObject($,g)}storeAll($,h){this.y(()=>{for(const g of $)this.store(g.key,g.value,g.scope,g.target,h)})}store($,h,g,i,r=!1){if((0,R.$5f)(h)){this.remove($,g,r);return}this.y(()=>{this.z($,g,i),this.P(g)?.set($,h,r)})}remove($,h,g=!1){this.y(()=>{this.z($,h,void 0),this.P(h)?.delete($,g)})}y($){this.b.pause(),this.c.pause();try{$()}finally{this.b.resume(),this.c.resume()}}keys($,h){const g=[],i=this.J($);for(const r of Object.keys(i))i[r]===h&&g.push(r);return g}z($,h,g,i=!1){const r=this.J(h);typeof g=="number"?r[$]!==g&&(r[$]=g,this.P(h)?.set(e.$Lp,JSON.stringify(r),i)):typeof r[$]=="number"&&(delete r[$],this.P(h)?.set(e.$Lp,JSON.stringify(r),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J($){switch($){case-1:return this.I;case 0:return this.G;default:return this.D}}L($){const h=this.P($);return h?p(h):Object.create(null)}isNew($){return this.getBoolean(e.$Kp,$)===!0}async flush($=y.NONE){this.f.fire({reason:$});const h=this.P(-1),g=this.P(0),i=this.P(1);switch($){case y.NONE:await D.Promises.settled([h?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await D.Promises.settled([h?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const $=this.P(-1)?.items??new Map,h=this.P(0)?.items??new Map,g=this.P(1)?.items??new Map;return c($,h,g,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize($){return await this.flush(),this.P($)?.optimize()}async switch($,h){return this.w(y.NONE),(0,a.$nl)($)?this.R($,h):this.S($,h)}M($,h){return!($.id===h.id||O(h)&&O($))}N($,h,g){this.y(()=>{const i=new Set;for(const[r,t]of $)i.add(r),h.get(r)!==t&&this.u(g,{key:r,external:!0});for(const[r]of h.items)i.has(r)||this.u(g,{key:r,external:!0})})}}e.$Op=w;function O(b){return b.isDefault||!!b.useDefaultFlags?.globalState}class m extends w{constructor(){super(),this.U=this.B(new S.$Ip(new S.$Jp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new S.$Ip(new S.$Jp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new S.$Ip(new S.$Jp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage($=>this.u(1,$))),this.B(this.W.onDidChangeStorage($=>this.u(0,$))),this.B(this.U.onDidChangeStorage($=>this.u(-1,$)))}P($){switch($){case-1:return this.U;case 0:return this.W;default:return this.X}}Q($){switch($){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope($){return!1}}e.$Qp=m;async function c(b,$,h,g,i,r){const t=U=>{try{return JSON.parse(U)}catch{return U}},n=new Map,s=new Map;b.forEach((U,V)=>{n.set(V,U),s.set(V,t(U))});const o=new Map,l=new Map;$.forEach((U,V)=>{o.set(V,U),l.set(V,t(U))});const P=new Map,I=new Map;h.forEach((U,V)=>{P.set(V,U),I.set(V,t(U))}),console.group(g!==i?`Storage: Application (path: ${g})`:`Storage: Application & Profile (path: ${g}, default profile)`);const L=[];if(n.forEach((U,V)=>{L.push({key:V,value:U})}),console.table(L),console.groupEnd(),console.log(s),g!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const U=[];o.forEach((V,X)=>{U.push({key:X,value:V})}),console.table(U),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${r})`);const z=[];P.forEach((U,V)=>{z.push({key:V,value:U})}),console.table(z),console.groupEnd(),console.log(I)}}),define(ne[166],re([0,1,19,20,8,12,35,3,11,29,18,21,26,50,13,6,32,45,149,165,22,178]),function(J,e,D,j,k,A,R,S,u,a,y,v,d,p,w,O,m,c,b,$,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=void 0,e.$Up=Y;const i=A.$o?"web":(0,v.$No)(A.$u,R.$fc),r="X-Market-Search-Activity-Id";var t;(function(E){E[E.None=0]="None",E[E.IncludeVersions=1]="IncludeVersions",E[E.IncludeFiles=2]="IncludeFiles",E[E.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",E[E.IncludeSharedAccounts=8]="IncludeSharedAccounts",E[E.IncludeVersionProperties=16]="IncludeVersionProperties",E[E.ExcludeNonValidated=32]="ExcludeNonValidated",E[E.IncludeInstallationTargets=64]="IncludeInstallationTargets",E[E.IncludeAssetUri=128]="IncludeAssetUri",E[E.IncludeStatistics=256]="IncludeStatistics",E[E.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",E[E.Unpublished=4096]="Unpublished",E[E.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function n(...E){return String(E.reduce((N,C)=>N|C,0))}var s;(function(E){E[E.Tag=1]="Tag",E[E.ExtensionId=4]="ExtensionId",E[E.Category=5]="Category",E[E.ExtensionName=7]="ExtensionName",E[E.Target=8]="Target",E[E.Featured=9]="Featured",E[E.SearchText=10]="SearchText",E[E.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},I={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class L{constructor(N=I){this.d=N}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(N,C=this.d.pageSize){return new L({...this.d,pageNumber:N,pageSize:C})}withFilter(N,...C){const W=[...this.d.criteria,...C.length?C.map(G=>({filterType:N,value:G})):[{filterType:N}]];return new L({...this.d,criteria:W})}withSortBy(N){return new L({...this.d,sortBy:N})}withSortOrder(N){return new L({...this.d,sortOrder:N})}withFlags(...N){return new L({...this.d,flags:N.reduce((C,W)=>C|W,0)})}withAssetTypes(...N){return new L({...this.d,assetTypes:N})}withSource(N){return new L({...this.d,source:N})}get raw(){const{criteria:N,pageNumber:C,pageSize:W,sortBy:G,sortOrder:te,flags:ae,assetTypes:le}=this.d;return{filters:[{criteria:N,pageNumber:C,pageSize:W,sortBy:G,sortOrder:te}],assetTypes:le,flags:ae}}get searchText(){const N=this.d.criteria.filter(C=>C.filterType===s.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(N=>String(N.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function z(E,N){const C=(E||[]).filter(W=>W.statisticName===N)[0];return C?C.value:0}function U(E){const N="Microsoft.VisualStudio.Code.Translation.";return E.files.filter(W=>W.assetType.indexOf(N)===0).reduce((W,G)=>{const te=se(E,G.assetType);return te&&W.push([G.assetType.substring(N.length),te]),W},[])}function V(E){if(E.properties){const N=E.properties.filter(G=>G.key===o.Repository),C=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),W=N.filter(G=>C.test(G.value))[0];return W?{uri:W.value,fallbackUri:W.value}:null}return se(E,o.Repository)}function X(E){return{uri:`${E.fallbackAssetUri}/${o.VSIX}?redirect=true${E.targetPlatform?`&targetPlatform=${E.targetPlatform}`:""}`,fallbackUri:`${E.fallbackAssetUri}/${o.VSIX}${E.targetPlatform?`?targetPlatform=${E.targetPlatform}`:""}`}}function se(E,N){return E.files.filter(W=>W.assetType===N)[0]?{uri:`${E.assetUri}/${N}${E.targetPlatform?`?targetPlatform=${E.targetPlatform}`:""}`,fallbackUri:`${E.fallbackAssetUri}/${N}${E.targetPlatform?`?targetPlatform=${E.targetPlatform}`:""}`}:null}function ie(E,N){const C=E.properties?E.properties.filter(G=>G.key===N):[],W=C.length>0&&C[0].value;return W?W.split(",").map(G=>(0,d.$kp)(G)):[]}function ue(E){const N=E.properties?E.properties.filter(C=>C.key===l.Engine):[];return N.length>0&&N[0].value||""}function he(E){const N=E.properties?E.properties.filter(C=>C.key===l.PreRelease):[];return N.length>0&&N[0].value==="true"}function ce(E){const N=E.properties?E.properties.filter(W=>W.key===l.LocalizedLanguages):[],C=N.length>0&&N[0].value||"";return C?C.split(","):[]}function B(E){return E.properties?.find(N=>N.key===l.SponsorLink)?.value}function Z(E){return E.properties?.find(N=>N.key===l.SupportLink)?.value}function q(E){return E.indexOf("preview")!==-1}function T(E){return E.targetPlatform?(0,v.$Mo)(E.targetPlatform):"undefined"}function x(E){const N=(0,D.$Mb)(E.versions.map(T)),C=!!E.tags?.includes(v.$Ho),W=N.indexOf("web");return C?W===-1&&N.push("web"):W!==-1&&N.splice(W,1),N}function Y(E,N){for(let C=0;C<E.length;C++){const W=E[C];if(W.version===E[C-1]?.version){let G=C;if(T(W)===N)for(;G>0&&E[G-1].version===W.version;)G--;G!==C&&(E.splice(C,1),E.splice(G,0,W))}}return E}function Q(E,N,C){E.telemetryData={index:N,querySource:C,queryActivityId:E.queryContext?.[r]}}function _(E,N,C,W){const G=E.versions[0],te={manifest:se(N,o.Manifest),readme:se(N,o.Details),changelog:se(N,o.Changelog),license:se(N,o.License),repository:V(N),download:X(N),icon:se(N,o.Icon),signature:se(N,o.Signature),coreTranslations:U(N)};return{identifier:{id:(0,d.$lp)(E.publisher.publisherName,E.extensionName),uuid:E.extensionId},name:E.extensionName,version:N.version,displayName:E.displayName,publisherId:E.publisher.publisherId,publisher:E.publisher.publisherName,publisherDisplayName:E.publisher.displayName,publisherDomain:E.publisher.domain?{link:E.publisher.domain,verified:!!E.publisher.isDomainVerified}:void 0,publisherSponsorLink:B(G),description:E.shortDescription??"",installCount:z(E.statistics,"install"),rating:z(E.statistics,"averagerating"),ratingCount:z(E.statistics,"ratingcount"),categories:E.categories||[],tags:E.tags||[],releaseDate:Date.parse(E.releaseDate),lastUpdated:Date.parse(E.lastUpdated),allTargetPlatforms:C,assets:te,properties:{dependencies:ie(N,l.Dependency),extensionPack:ie(N,l.ExtensionPack),engine:ue(N),localizedLanguages:ce(N),targetPlatform:T(N),isPreReleaseVersion:he(N)},hasPreReleaseVersion:he(G),hasReleaseVersion:!0,preview:q(E.flags),isSigned:!!te.signature,queryContext:W,supportLink:Z(G)}}let M=class{constructor(N,C,W,G,te,ae,le,pe){this.k=C,this.l=W,this.n=G,this.o=te,this.q=ae,this.u=le,this.w=pe;const ye=le.extensionsGallery,fe=ye?.servicePPEUrl&&pe.getValue("_extensionsGallery.enablePPE");this.d=fe?ye.servicePPEUrl:ye?.serviceUrl,this.g=fe?void 0:ye?.searchUrl,this.h=ye?.controlUrl,this.j=(0,b.$Tp)(le.version,le,this.n,this.w,this.q,N,this.o)}x(N=""){return`${this.d}${N}`}isEnabled(){return!!this.d}async getExtensions(N,C,W){const G=j.CancellationToken.isCancellationToken(C)?{}:C,te=j.CancellationToken.isCancellationToken(C)?C:W,ae=[],le=[],pe=[],ye=[];let fe=!0;for(const we of N){we.uuid?le.push(we.uuid):ae.push(we.id);const Ee=!!(we.version||we.preRelease);pe.push({id:we.id,uuid:we.uuid,includePreRelease:Ee}),we.version&&ye.push({id:we.id,uuid:we.uuid,version:we.version}),fe=fe&&!!we.hasPreRelease&&!Ee}if(!le.length&&!ae.length)return[];let me=new L().withPage(1,N.length);le.length&&(me=me.withFilter(s.ExtensionId,...le)),ae.length&&(me=me.withFilter(s.ExtensionName,...ae)),(G.queryAllVersions||fe)&&(me=me.withFlags(me.flags,t.IncludeVersions)),G.source&&(me=me.withSource(G.source));const{extensions:de}=await this.z(me,{targetPlatform:G.targetPlatform??i,includePreRelease:pe,versions:ye,compatible:!!G.compatible,productVersion:G.productVersion??{version:this.u.version,date:this.u.date}},te);return G.source&&de.forEach((we,Ee)=>Q(we,Ee,G.source)),de}async getCompatibleExtension(N,C,W,G={version:this.u.version,date:this.u.date}){if((0,v.$Oo)(N.allTargetPlatforms,W))return null;if(await this.isExtensionCompatible(N,C,W))return N;const te=new L().withFlags(t.IncludeVersions).withPage(1,1).withFilter(s.ExtensionId,N.identifier.uuid),{extensions:ae}=await this.z(te,{targetPlatform:W,compatible:!0,includePreRelease:C,productVersion:G},j.CancellationToken.None);return ae[0]||null}async isExtensionCompatible(N,C,W,G={version:this.u.version,date:this.u.date}){if(!(0,v.$Po)(N.properties.targetPlatform,N.allTargetPlatforms,W)||!C&&N.properties.isPreReleaseVersion)return!1;let te=N.properties.engine;if(!te){const ae=await this.getManifest(N,j.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");te=ae.engines.vscode}return(0,p.$yp)(te,G.version,G.date)}async y(N,C,W,G,te,ae,le={version:this.u.version,date:this.u.date}){if(!(0,v.$Po)(T(C),te,ae)||W!=="any"&&he(C)!==(W==="prerelease"))return!1;if(G)try{const pe=await this.E(N,C);if(!(0,p.$yp)(pe,le.version,le.date))return!1}catch(pe){return this.l.error(`Error while getting the engine for the version ${C.version}.`,(0,k.$0)(pe)),!1}return!0}async query(N,C){let W=N.text||"";const G=N.pageSize??50;let te=new L().withPage(1,G);W?(W=W.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,de)=>(te=te.withFilter(s.Category,de||me),"")),W=W.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,de)=>(te=te.withFilter(s.Tag,de||me),"")),W=W.replace(/\bfeatured(\s+|\b|$)/g,()=>(te=te.withFilter(s.Featured),"")),W=W.trim(),W&&(W=W.length<200?W:W.substring(0,200),te=te.withFilter(s.SearchText,W)),te=te.withSortBy(0)):N.ids?te=te.withFilter(s.ExtensionId,...N.ids):N.names?te=te.withFilter(s.ExtensionName,...N.names):te=te.withSortBy(4),typeof N.sortBy=="number"&&(te=te.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(te=te.withSortOrder(N.sortOrder)),N.source&&(te=te.withSource(N.source));const ae=async(fe,me)=>{const{extensions:de,total:we}=await this.z(fe,{targetPlatform:i,compatible:!1,includePreRelease:!!N.includePreRelease,productVersion:N.productVersion??{version:this.u.version,date:this.u.date}},me);return de.forEach((Ee,ke)=>Q(Ee,(fe.pageNumber-1)*fe.pageSize+ke,N.source)),{extensions:de,total:we}},{extensions:le,total:pe}=await ae(te,C),ye=async(fe,me)=>{if(me.isCancellationRequested)throw new k.$5;const{extensions:de}=await ae(te.withPage(fe+1),me);return de};return{firstPage:le,total:pe,pageSize:te.pageSize,getPage:ye}}async z(N,C,W){const G=N.flags;N.flags&t.IncludeLatestVersionOnly&&N.flags&t.IncludeVersions&&(N=N.withFlags(N.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(N.flags&t.IncludeLatestVersionOnly)&&!(N.flags&t.IncludeVersions)&&(N=N.withFlags(N.flags,t.IncludeLatestVersionOnly)),C.versions?.length&&(N=N.withFlags(N.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),N=N.withFlags(N.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:te,total:ae,context:le}=await this.B(N,W);if(!(N.flags&t.IncludeLatestVersionOnly)){const me=[];for(const de of te){const we=await this.A(de,C,le);we&&me.push(we)}return{extensions:me,total:ae}}const ye=[],fe=new Map;for(let me=0;me<te.length;me++){const de=te[me],we={id:(0,d.$lp)(de.publisher.publisherName,de.extensionName),uuid:de.extensionId},Ee=(0,S.$2f)(C.includePreRelease)?C.includePreRelease:!!C.includePreRelease.find(H=>(0,d.$gp)(H,we))?.includePreRelease;if(C.compatible&&(0,v.$Oo)(x(de),C.targetPlatform))continue;const ke=await this.A(de,C,le);!ke||ke.properties.isPreReleaseVersion&&(!Ee||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==C.targetPlatform&&ke.hasPreReleaseVersion?fe.set(de.extensionId,me):ye.push([me,ke])}if(fe.size){const me=new g.$3d,de=new L().withFlags(G&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,fe.size).withFilter(s.ExtensionId,...fe.keys()),{extensions:we}=await this.z(de,C,W);this.o.publicLog2("galleryService:additionalQuery",{duration:me.elapsed(),count:fe.size});for(const Ee of we){const ke=fe.get(Ee.identifier.uuid);ye.push([ke,Ee])}}return{extensions:ye.sort((me,de)=>me[0]-de[0]).map(([,me])=>me),total:ae}}async A(N,C,W){const G={id:(0,d.$lp)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},te=C.versions?.find(ye=>(0,d.$gp)(ye,G))?.version,ae=(0,S.$2f)(C.includePreRelease)?C.includePreRelease:!!C.includePreRelease.find(ye=>(0,d.$gp)(ye,G))?.includePreRelease,le=x(N),pe=Y(N.versions,C.targetPlatform);if(C.compatible&&(0,v.$Oo)(le,C.targetPlatform))return null;for(let ye=0;ye<pe.length;ye++){const fe=pe[ye];if(!(te&&fe.version!==te)){if(await this.y((0,d.$lp)(N.publisher.publisherName,N.extensionName),fe,ae?"any":"release",C.compatible,le,C.targetPlatform,C.productVersion))return _(N,fe,le,W);if(te&&fe.version===te)return null}}return te||C.compatible?null:_(N,N.versions[0],le)}async B(N,C){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,t.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,n(t.Unpublished));const W=await this.j,G=JSON.stringify(N.raw),te={...W,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(G.length)},ae=new g.$3d;let le,pe,ye=0;try{if(le=await this.k.request({type:"POST",url:this.g&&N.criteria.some(me=>me.filterType===s.SearchText)?this.g:this.x("/extensionquery"),data:G,headers:te},C),le.res.statusCode&&le.res.statusCode>=400&&le.res.statusCode<500)return{galleryExtensions:[],total:ye};const fe=await(0,c.$Fp)(le);if(fe){const me=fe.results[0],de=me.extensions,we=me.resultMetadata&&me.resultMetadata.filter(Ee=>Ee.metadataType==="ResultCount")[0];return ye=we&&we.metadataItems.filter(Ee=>Ee.name==="TotalCount")[0].count||0,{galleryExtensions:de,total:ye,context:{[r]:le.res.headers.activityid}}}return{galleryExtensions:[],total:ye}}catch(fe){const me=(0,k.$4)(fe)?v.ExtensionGalleryErrorCode.Cancelled:(0,k.$0)(fe).startsWith("XHR timeout")?v.ExtensionGalleryErrorCode.Timeout:v.ExtensionGalleryErrorCode.Failed;throw pe=new v.$To((0,k.$0)(fe),me),pe}finally{this.o.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(G.length),duration:ae.elapsed(),success:!!le&&(0,c.$Bp)(le),responseBodySize:le?.res.headers["Content-Length"],statusCode:le?String(le.res.statusCode):void 0,errorCode:pe?.code,count:String(ye)})}}async reportStatistic(N,C,W,G){if(!this.isEnabled())return;const te=A.$o?this.x(`/itemName/${N}.${C}/version/${W}/statType/${G==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${N}/extensions/${C}/${W}/stats?statType=${G}`),ae=A.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.j,Accept:ae};try{await this.k.request({type:"POST",url:te,headers:pe},j.CancellationToken.None)}catch{}}async download(N,C,W){this.l.trace("ExtensionGalleryService#download",N.identifier.id);const G=(0,d.$op)(N),te=new Date().getTime(),ae=me=>this.o.publicLog("galleryService:downloadVSIX",{...G,duration:me}),le=W===2?"install":W===3?"update":"",pe=le?{uri:`${N.assets.download.uri}${u.URI.parse(N.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${N.assets.download.fallbackUri}${u.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:N.assets.download,ye=N.queryContext?.[r]?{[r]:N.queryContext[r]}:void 0,fe=await this.D(N.identifier.id,pe,o.VSIX,ye?{headers:ye}:void 0);await this.q.writeFile(C,fe.stream),ae(new Date().getTime()-te)}async downloadSignatureArchive(N,C){if(!N.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",N.identifier.id);const W=await this.D(N.identifier.id,N.assets.signature,o.Signature);await this.q.writeFile(C,W.stream)}async getReadme(N,C){if(N.assets.readme){const W=await this.D(N.identifier.id,N.assets.readme,o.Details,{},C);return await(0,c.$Ep)(W)||""}return""}async getManifest(N,C){if(N.assets.manifest){const W=await this.D(N.identifier.id,N.assets.manifest,o.Manifest,{},C),G=await(0,c.$Ep)(W);return G?JSON.parse(G):null}return null}async C(N,C,W){const G=se(C,o.Manifest);if(!G)throw new Error("Manifest was not found");const te={"Accept-Encoding":"gzip"},ae=await this.D(N,G,o.Manifest,{headers:te});return await(0,c.$Fp)(ae)}async getCoreTranslation(N,C){const W=N.assets.coreTranslations.filter(G=>G[0]===C.toUpperCase())[0];if(W){const G=await this.D(N.identifier.id,W[1],W[0]),te=await(0,c.$Ep)(G);return te?JSON.parse(te):null}return null}async getChangelog(N,C){if(N.assets.changelog){const W=await this.D(N.identifier.id,N.assets.changelog,o.Changelog,{},C);return await(0,c.$Ep)(W)||""}return""}async getAllCompatibleVersions(N,C,W){let G=new L().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);N.identifier.uuid?G=G.withFilter(s.ExtensionId,N.identifier.uuid):G=G.withFilter(s.ExtensionName,N.identifier.id);const{galleryExtensions:te}=await this.B(G,j.CancellationToken.None);if(!te.length)return[];const ae=x(te[0]);if((0,v.$Oo)(ae,W))return[];const le=[];await Promise.all(te[0].versions.map(async fe=>{try{await this.y(N.identifier.id,fe,C?"any":"release",!0,ae,W)&&le.push(fe)}catch{}}));const pe=[],ye=new Set;for(const fe of Y(le,W))ye.has(fe.version)||(ye.add(fe.version),pe.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:he(fe)}));return pe}async D(N,C,W,G={},te=j.CancellationToken.None){const ae=await this.j,le={type:"GET"},pe={...ae,...G.headers||{}};G={...G,...le,headers:pe};const ye=C.uri,fe=C.fallbackUri,me={...G,url:ye};try{const de=await this.k.request(me,te);if(de.res.statusCode===200)return de;const we=await(0,c.$Ep)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${we}`)}catch(de){if((0,k.$4)(de))throw de;const we=(0,k.$0)(de);this.o.publicLog2("galleryService:cdnFallback",{extension:N,assetType:W,message:we});const Ee={...G,url:fe};return this.k.request(Ee,te)}}async E(N,C){let W=ue(C);if(!W){this.o.publicLog2("galleryService:engineFallback",{extension:N,version:C.version});const G=await this.C(N,C,j.CancellationToken.None);if(!G)throw new Error("Manifest was not found");W=G.engines.vscode}return W}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const N=await this.k.request({type:"GET",url:this.h},j.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const C=await(0,c.$Fp)(N),W=[],G={},te=[];if(C){for(const ae of C.malicious)W.push({id:ae});if(C.migrateToPreRelease)for(const[ae,le]of Object.entries(C.migrateToPreRelease))(!le.engine||(0,p.$yp)(le.engine,this.u.version,this.u.date))&&(G[ae.toLowerCase()]={disallowInstall:!0,extension:{id:le.id,displayName:le.displayName,autoMigrate:{storage:!!le.migrateStorage},preRelease:!0}});if(C.deprecated)for(const[ae,le]of Object.entries(C.deprecated))le&&(G[ae.toLowerCase()]=(0,S.$2f)(le)?{}:le);if(C.search)for(const ae of C.search)te.push(ae)}return{malicious:W,deprecated:G,search:te}}};M=$e([oe(1,c.$zp),oe(2,O.$Oj),oe(3,y.$pi),oe(4,h.$Nl),oe(5,w.$Ok),oe(6,m.$8j),oe(7,a.$Oi)],M);let F=class extends M{constructor(N,C,W,G,te,ae,le,pe){super(N,C,W,G,te,ae,le,pe)}};e.$Vp=F,e.$Vp=F=$e([oe(0,$.$Mp),oe(1,c.$zp),oe(2,O.$Oj),oe(3,y.$pi),oe(4,h.$Nl),oe(5,w.$Ok),oe(6,m.$8j),oe(7,a.$Oi)],F);let f=class extends M{constructor(N,C,W,G,te,ae,le){super(void 0,N,C,W,G,te,ae,le)}};e.$Wp=f,e.$Wp=f=$e([oe(0,c.$zp),oe(1,O.$Oj),oe(2,y.$pi),oe(3,h.$Nl),oe(4,w.$Ok),oe(5,m.$8j),oe(6,a.$Oi)],f)}),define(ne[167],re([0,1,11,18,13,6,145,23,24,3,68]),function(J,e,D,j,k,A,R,S,u,a,y){"use strict";var v,d;Object.defineProperty(e,"__esModule",{value:!0}),e.$3P=e.$2P=e.$1P=void 0;let p=class extends u.$rl{static{v=this}static{this.a="profileAssociationsMigration"}constructor(c,b,$,h,g){super($,h,b,g),this.U=c,this.W=$}O(){return this.U.getItem(v.b,[]).map(b=>({...b,location:(0,a.$Vf)(b.location)?this.w.extUri.joinPath(this.profilesHome,b.location):D.URI.revive(b.location)}))}Q(){const c=this.U.getItem(v.c,{});return this.U.getItem(v.a,!1)?c:this.N(c)}S(){return this.w.extUri.joinPath(D.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$1P=p,e.$1P=p=v=$e([oe(0,R.$VP),oe(1,S.$ml),oe(2,j.$qi),oe(3,k.$Ok),oe(4,A.$Oj)],p);let w=d=class extends p{constructor(c,b,$,h,g){super(c,b,$,h,g),this.$=c}P(c){c.length?this.$.setItem(d.b,c.map(b=>({...b,location:this.w.extUri.basename(b.location)}))):this.$.removeItem(d.b)}O(){const c=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(c),this.$.setItem("userDataProfilesMigration",!0)),c}R(c){c.emptyWindows||c.workspaces?this.$.setItem(d.c,c):this.$.removeItem(d.c)}Q(){const c="workspaceAndProfileInfo",b=this.$.getItem(c,void 0);if(b){this.$.removeItem(c);const h=b.reduce((g,{workspace:i,profile:r})=>(g[D.URI.revive(i).toString()]=D.URI.revive(r).toString(),g),{});this.$.setItem(d.c,{workspaces:h})}const $=super.Q();return this.$.getItem(d.a,!1)||(this.R($),this.$.setItem(d.a,!0)),$}};e.$2P=w,e.$2P=w=d=$e([oe(0,R.$WP),oe(1,S.$ml),oe(2,j.$qi),oe(3,k.$Ok),oe(4,A.$Oj)],w);let O=class extends w{constructor(c,b,$,h){super(new y.$ZP(0,b,h,$),c,b,$,h)}async init(){return await this.$.init(),super.init()}};e.$3P=O,e.$3P=O=$e([oe(0,S.$ml),oe(1,j.$qi),oe(2,k.$Ok),oe(3,A.$Oj)],O)}),define(ne[168],re([0,1,143,9,14,8,3,29,18,144,6,45,142,179]),function(J,e,D,j,k,A,R,S,u,a,y,v,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=void 0,e.$Ir=m;let w=class extends v.$Ap{constructor(b,$,h,g){super(g),this.m=b,this.n=$,this.r=h,this.s(),this.B(b.onDidChangeConfiguration(i=>{i.affectsConfiguration("http")&&this.s()}))}s(){const b=this.m.getValue("http");this.f=b?.proxy,this.g=!!b?.proxyStrictSSL,this.h=b?.proxyAuthorization}async request(b,$){const{f:h,g}=this;let i;try{i=await(0,a.$sm)(this.m,this.r,this.n.args,process.env)}catch(n){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,A.$0)(n)))}const r={...process.env,...i},t=b.agent?b.agent:await(0,d.$Gr)(b.url||"",r,{proxyUrl:h,strictSSL:g});return b.agent=t,b.strictSSL=g,this.h&&(b.headers={...b.headers||{},"Proxy-Authorization":this.h}),this.c(b.isChromiumNetwork?"electron":"node",b,()=>m(b,$))}async resolveProxy(b){}async loadCertificates(){return(await new Promise(($,h)=>{J(["@vscode/proxy-agent"],$,h)})).loadSystemCertificates({log:this.r})}};e.$Hr=w,e.$Hr=w=$e([oe(0,S.$Oi),oe(1,u.$qi),oe(2,y.$Oj),oe(3,y.$Pj)],w);async function O(c){return((0,D.parse)(c.url).protocol==="https:"?await new Promise((h,g)=>{J(["https"],h,g)}):await new Promise((h,g)=>{J(["http"],h,g)})).request}async function m(c,b){return j.Promises.withAsyncBody(async($,h)=>{const g=(0,D.parse)(c.url),i=c.getRawRequest?c.getRawRequest(c):await O(c),r={hostname:g.hostname,port:g.port?parseInt(g.port):g.protocol==="https:"?443:80,protocol:g.protocol,path:g.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,R.$2f)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(r.auth=c.user+":"+c.password);const t=i(r,n=>{const s=(0,R.$Zf)(c.followRedirects)?c.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&s>0&&n.headers.location)m({...c,url:n.headers.location,followRedirects:s-1},b).then($,h);else{let o=n;!c.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(o=n.pipe((0,p.createGunzip)())),$({res:n,stream:(0,k.$Je)(o)})}});t.on("error",h),c.timeout&&t.setTimeout(c.timeout),c.isChromiumNetwork&&t.removeHeader("Content-Length"),c.data&&typeof c.data=="string"&&t.write(c.data),t.end(),b.onCancellationRequested(()=>{t.abort(),h(new A.$5)})})}}),define(ne[180],re([0,1,33,9,34,8,2,15,16,12,35,11,25,29,139,61,141,18,115,166,21,70,146,42,53,162,164,13,129,131,51,127,63,64,150,6,135,39,136,153,32,45,168,68,69,22,152,41,154,155,23,157,24,167,156,163,132,134,4,158,181]),function(J,e,D,j,k,A,R,S,u,a,y,v,d,p,w,O,m,c,b,$,h,g,i,r,t,n,s,o,l,P,I,L,z,U,V,X,se,ie,ue,he,ce,B,Z,q,T,x,Y,Q,_,M,F,f,E,N,C,W,G,te,ae,le,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=fe;class ye extends R.$Uc{constructor(de){super(),this.b=de,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[de,we]=await this.f();return de.invokeFunction(async Ee=>{const ke=Ee.get(X.$Oj),H=Ee.get(o.$Ok),K=Ee.get(c.$qi),ee=Ee.get(E.$ol);ke.info("CLI main",this.b),this.h(ke),await this.j(K,H,ee,de),await Promise.all(we.map(ge=>{(0,j.$_g)(ge.flush(),1e3)}))})}async f(){const de=new z.$gi,we={_serviceBrand:void 0,...he.default};de.set(ce.$8j,we);const Ee=new b.$Um(this.b,we);de.set(c.$qi,Ee),await Promise.all([this.g(Ee.appSettingsHome.with({scheme:S.Schemas.file}).fsPath),this.g(Ee.extensionsPath)].map(be=>be?d.Promises.mkdir(be,{recursive:!0}):void 0));const ke=new te.$UP((0,X.$3j)(Ee),Ee.logsHome);de.set(X.$Pj,ke);const H=this.B(ke.createLogger("cli",{name:(0,ae.localize)(0,null)})),K=[];ke.getLogLevel()===X.LogLevel.Trace&&K.push(new X.$Wj(ke.getLogLevel()));const ee=this.B(new G.$5P(H,K));de.set(X.$Oj,ee);const ge=this.B(new l.$uq(ee));de.set(o.$Ok,ge);const ve=this.B(new P.$Vq(ee));ge.registerProvider(S.Schemas.file,ve);const De=new f.$js(ge);de.set(F.$ml,De);const Pe=new q.$YP(1,Ee,ee,ge),Le=new N.$1P(Pe,De,Ee,ge,ee);de.set(E.$ol,Le),ge.registerProvider(S.Schemas.vscodeUserData,new le.$Vbc(S.Schemas.file,ve,S.Schemas.vscodeUserData,Le,De,ee));const Oe=a.$i&&we.win32RegValueName?this.B(new ue.$Tbc(ee,we.win32RegValueName)):Ee.policyFile?this.B(new se.$Ubc(Ee.policyFile,ge,ee)):new ie.$5n;de.set(ie.$3n,Oe);const Ae=this.B(new w.$so(Le.defaultProfile.settingsResource,ge,Oe,ee));de.set(p.$Oi,Ae),await Promise.all([Pe.init(),Ae.initialize()]);let Me;try{Me=await(0,C.$xbc)(Pe,ee)}catch(be){be.code!=="ENOENT"&&ee.error(be)}const je=await(0,C.$ybc)(Pe,ee);Le.init(),de.set(F.$ml,new f.$js(ge));const Ne=new Z.$Hr(Ae,Ee,ee,ke);de.set(B.$zp,Ne),de.set(O.$wo,new I.$fi(m.$hQ,void 0,!0)),de.set(r.$bq,new I.$fi(W.$4P,void 0,!0)),de.set(t.$fq,new I.$fi(s.$ubc,void 0,!0)),de.set(g.$Xp,new I.$fi(g.$Yp,void 0,!0)),de.set(n.$pq,new I.$fi(n.$qq,void 0,!0)),de.set(h.$Ro,new I.$fi($.$Wp,void 0,!0)),de.set(U.$Br,new I.$fi(V.$Dr,void 0,!1));const ze=[],Fe=(0,Q.$dp)(we,Ae);if((0,Q.$$o)(we,Ee)){we.aiConfig&&we.aiConfig.ariaKey&&ze.push(new _.$SP(Ne,Fe,"monacoworkbench",null,we.aiConfig.ariaKey));const be={appenders:ze,sendErrorTelemetry:!1,commonProperties:(0,T.$2o)((0,D.release)(),(0,D.hostname)(),process.arch,we.commit,we.version,Me,je,Fe),piiPaths:(0,Q.$ep)(Ee)};de.set(x.$Nl,new I.$fi(Y.$Jr,[be],!1))}else de.set(x.$Nl,Q.$6o);return[new L.$Yq(de),ze]}g(de){if(a.$i){const we=(0,pe.getUNCHost)(de);we&&(0,pe.addUNCHostToAllowlist)(we)}return de}h(de){(0,A.setUnexpectedErrorHandler)(we=>{const Ee=(0,k.$6i)(we,!0);Ee&&de.error(`[uncaught exception in CLI]: ${Ee}`)}),process.on("uncaughtException",we=>{(0,A.$Z)(we)||(0,A.$1)(we)}),process.on("unhandledRejection",we=>(0,A.$1)(we))}async j(de,we,Ee,ke){let H;if(de.args.profile&&(H=Ee.profiles.find(ee=>ee.name===de.args.profile),!H))throw new Error(`Profile '${de.args.profile}' not found.`);const K=(H??Ee.defaultProfile).extensionsResource;if(this.b["list-extensions"])return ke.createInstance(i.$Zp,new X.$Wj(X.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,K);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const ee={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:K};return ke.createInstance(i.$Zp,new X.$Wj(X.LogLevel.Info,!1)).installExtensions(this.m(this.b["install-extension"]||[]),this.m(this.b["install-builtin-extension"]||[]),ee,!!this.b.force)}else{if(this.b["uninstall-extension"])return ke.createInstance(i.$Zp,new X.$Wj(X.LogLevel.Info,!1)).uninstallExtensions(this.m(this.b["uninstall-extension"]),!!this.b.force,K);if(this.b["update-extensions"])return ke.createInstance(i.$Zp,new X.$Wj(X.LogLevel.Info,!1)).updateExtensions(K);if(this.b["locate-extension"])return ke.createInstance(i.$Zp,new X.$Wj(X.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,M.$hcc)(de.appRoot,de.extensionsPath))}}m(de){return de.map(we=>/\.vsix$/i.test(we)?v.URI.file((0,u.$jc)(we)?we:(0,u.$kc)((0,y.cwd)(),we)):we)}}async function fe(me){const de=new ye(me);try{await de.run()}finally{de.dispose()}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7c51753f7ce936a7aeb84ac881818c35c5a9ab8d/core/vs/code/node/cliProcessMain.js.map
