/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/contextkey/common/contextkey","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","fs","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/hash","vs/base/common/themables","vs/base/common/marshalling","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/platform/files/common/watcher","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContributionService","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","crypto","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ee=function(he){for(var e=[],u=0,L=he.length;u<L;u++)e[u]=ke[he[u]];return e};define(ke[161],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class u{static get(){const M=new Map,P=new Map,R=new Map,b=new Map;function $(E,v){E.has(v.detail)||E.set(v.detail,-v.timestamp)}function y(E,v){const a=E.get(v.detail);a&&(a>=0||E.set(v.detail,a+v.timestamp))}let A=[];typeof he=="function"&&typeof he.getStats=="function"&&(A=he.getStats().slice(0).sort((E,v)=>E.timestamp-v.timestamp));for(const E of A)switch(E.type){case 10:$(M,E);break;case 11:case 12:y(M,E);break;case 21:$(P,E);break;case 22:y(P,E);break;case 33:$(R,E);break;case 34:y(R,E);break;case 31:$(b,E);break;case 32:y(b,E);break}let I=0;R.forEach(E=>I+=E);function p(E){const v=[];return E.forEach((a,m)=>v.push([m,a])),v}return{amdLoad:p(M),amdInvoke:p(P),nodeRequire:p(R),nodeEval:p(b),nodeRequireTotal:I}}static toMarkdownTable(M,P){let R="";const b=[];return M.forEach(($,y)=>{b[y]=$.length}),P.forEach($=>{$.forEach((y,A)=>{typeof y>"u"&&(y=$[A]="-");const I=y.toString().length;b[A]=Math.max(I,b[A])})}),M.forEach(($,y)=>{R+=`| ${$+" ".repeat(b[y]-$.toString().length)} `}),R+=`|
`,M.forEach(($,y)=>{R+=`| ${"-".repeat(b[y])} `}),R+=`|
`,P.forEach($=>{$.forEach((y,A)=>{typeof y<"u"&&(R+=`| ${y+" ".repeat(b[A]-y.toString().length)} `)}),R+=`|
`}),R}}e.$U=u}),define(ke[162],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=u,e.$gb=L,e.$hb=M,e.$ib=P,e.$jb=R,e.$kb=b,e.$lb=$,e.$nb=A,e.$ob=I,e.$pb=p,e.$qb=E,e.$rb=v;function u(a,m,o){const n=L(a,m);if(n!==-1)return a[n]}function L(a,m,o=a.length-1){for(let n=o;n>=0;n--){const i=a[n];if(m(i))return n}return-1}function M(a,m){const o=P(a,m);return o===-1?void 0:a[o]}function P(a,m,o=0,n=a.length){let i=o,r=n;for(;i<r;){const s=Math.floor((i+r)/2);m(a[s])?i=s+1:r=s}return i-1}function R(a,m){const o=b(a,m);return o===a.length?void 0:a[o]}function b(a,m,o=0,n=a.length){let i=o,r=n;for(;i<r;){const s=Math.floor((i+r)/2);m(a[s])?r=s:i=s+1}return i}function $(a,m,o=0,n=a.length){const i=b(a,m,o,n);return i===a.length?-1:i}class y{static{this.assertInvariants=!1}constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(y.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!m(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const o=P(this.e,m,this.c);return this.c=o+1,o===-1?void 0:this.e[o]}}e.$mb=y;function A(a,m){if(a.length===0)return;let o=a[0];for(let n=1;n<a.length;n++){const i=a[n];m(i,o)>0&&(o=i)}return o}function I(a,m){if(a.length===0)return;let o=a[0];for(let n=1;n<a.length;n++){const i=a[n];m(i,o)>=0&&(o=i)}return o}function p(a,m){return A(a,(o,n)=>-m(o,n))}function E(a,m){if(a.length===0)return-1;let o=0;for(let n=1;n<a.length;n++){const i=a[n];m(i,a[o])>0&&(o=n)}return o}function v(a,m){for(const o of a){const n=m(o);if(n!==void 0)return n}}}),define(ke[73],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=u,e.$L=L,e.$M=M,e.$N=P;function u(R,b){const $=Object.create(null);for(const y of R){const A=b(y);let I=$[A];I||(I=$[A]=[]),I.push(y)}return $}function L(R,b){const $=[],y=[];for(const A of R)b.has(A)||$.push(A);for(const A of b)R.has(A)||y.push(A);return{removed:$,added:y}}function M(R,b){const $=[],y=[];for(const[A,I]of R)b.has(A)||$.push(I);for(const[A,I]of b)R.has(A)||y.push(I);return{removed:$,added:y}}function P(R,b){const $=new Set;for(const y of b)R.has(y)&&$.add(y);return $}}),define(ke[54],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=L,e.$Nh=M,e.$Oh=P;function u(R){return(b,$,y)=>{let A=null,I=null;if(typeof y.value=="function"?(A="value",I=y.value):typeof y.get=="function"&&(A="get",I=y.get),!I)throw new Error("not supported");y[A]=R(I,$)}}function L(R,b,$){let y=null,A=null;if(typeof $.value=="function"?(y="value",A=$.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(y="get",A=$.get),!A)throw new Error("not supported");const I=`$memoize$${b}`;$[y]=function(...p){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,p)}),this[I]}}function M(R,b,$){return u((y,A)=>{const I=`$debounce$${A}`,p=`$debounce$result$${A}`;return function(...E){this[p]||(this[p]=$?$():void 0),clearTimeout(this[I]),b&&(this[p]=b(this[p],...E),E=[this[p]]),this[I]=setTimeout(()=>{y.apply(this,E),this[p]=$?$():void 0},R)}})}function P(R,b,$){return u((y,A)=>{const I=`$throttle$timer$${A}`,p=`$throttle$result$${A}`,E=`$throttle$lastRun$${A}`,v=`$throttle$pending$${A}`;return function(...a){if(this[p]||(this[p]=$?$():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),b&&(this[p]=b(this[p],...a)),this[v])return;const m=this[E]+R;m<=Date.now()?(this[E]=Date.now(),y.apply(this,[this[p]]),this[p]=$?$():void 0):(this[v]=!0,this[I]=setTimeout(()=>{this[v]=!1,this[E]=Date.now(),y.apply(this,[this[p]]),this[p]=$?$():void 0},m-Date.now()))}})}}),define(ke[13],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=L,e.$Z=M,e.$1=P,e.$2=R,e.$3=b,e.$4=y,e.$6=I,e.$7=p,e.$8=E,e.$0=a;class u{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?i.isErrorNoTelemetry(t)?new i(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(f=>{f(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=u,e.$X=new u;function L(s){e.$X.setUnexpectedErrorHandler(s)}function M(s){if(!s||typeof s!="object")return!1;const t=s;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function P(s){y(s)||e.$X.onUnexpectedError(s)}function R(s){y(s)||e.$X.onUnexpectedExternalError(s)}function b(s){if(s instanceof Error){const{name:t,message:f}=s,d=s.stacktrace||s.stack;return{$isError:!0,name:t,message:f,stack:d,noTelemetry:i.isErrorNoTelemetry(s)}}return s}const $="Canceled";function y(s){return s instanceof A?!0:s instanceof Error&&s.name===$&&s.message===$}class A extends Error{constructor(){super($),this.name=this.message}}e.$5=A;function I(){const s=new Error($);return s.name=s.message,s}function p(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}function E(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}class v extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=v;function a(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}class m extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=m;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=o;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=n;class i extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof i)return t;const f=new i;return f.message=t.message,f.stack=t.stack,f}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=i;class r extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,r.prototype)}}e.$cb=r}),define(ke[19],Ee([1,0,13,162]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=M,e.$tb=P,e.$ub=R,e.$vb=b,e.$wb=$,e.$xb=y,e.$yb=A,e.$zb=I,e.$Ab=p,e.$Bb=E,e.$Cb=v,e.$Db=a,e.$Eb=m,e.top=o,e.$Gb=n,e.$Hb=r,e.$Ib=s,e.$Jb=t,e.$Kb=f,e.$Lb=d,e.$Mb=l,e.$Nb=c,e.$Ob=h,e.$Pb=g,e.$Qb=S,e.$Rb=w,e.$Sb=C,e.$Tb=k,e.$Ub=D,e.$Vb=O,e.$Wb=F,e.$Xb=T,e.$Yb=z,e.$Zb=j,e.$1b=N,e.$2b=B,e.$3b=W,e.$4b=Z,e.$5b=_,e.$6b=X,e.$7b=Y,e.$8b=me,e.$$b=U;function M(ae,ce=0){return ae[ae.length-(1+ce)]}function P(ae){if(ae.length===0)throw new Error("Invalid tail call");return[ae.slice(0,ae.length-1),ae[ae.length-1]]}function R(ae,ce,se=(K,te)=>K===te){if(ae===ce)return!0;if(!ae||!ce||ae.length!==ce.length)return!1;for(let K=0,te=ae.length;K<te;K++)if(!se(ae[K],ce[K]))return!1;return!0}function b(ae,ce){const se=ae.length-1;ce<se&&(ae[ce]=ae[se]),ae.pop()}function $(ae,ce,se){return y(ae.length,K=>se(ae[K],ce))}function y(ae,ce){let se=0,K=ae-1;for(;se<=K;){const te=(se+K)/2|0,le=ce(te);if(le<0)se=te+1;else if(le>0)K=te-1;else return te}return-(se+1)}function A(ae,ce,se){if(ae=ae|0,ae>=ce.length)throw new TypeError("invalid index");const K=ce[Math.floor(ce.length*Math.random())],te=[],le=[],de=[];for(const Ae of ce){const $e=se(Ae,K);$e<0?te.push(Ae):$e>0?le.push(Ae):de.push(Ae)}return ae<te.length?A(ae,te,se):ae<te.length+de.length?de[0]:A(ae-(te.length+de.length),le,se)}function I(ae,ce){const se=[];let K;for(const te of ae.slice(0).sort(ce))!K||ce(K[0],te)!==0?(K=[te],se.push(K)):K.push(te);return se}function*p(ae,ce){let se,K;for(const te of ae)K!==void 0&&ce(K,te)?se.push(te):(se&&(yield se),se=[te]),K=te;se&&(yield se)}function E(ae,ce){for(let se=0;se<=ae.length;se++)ce(se===0?void 0:ae[se-1],se===ae.length?void 0:ae[se])}function v(ae,ce){for(let se=0;se<ae.length;se++)ce(se===0?void 0:ae[se-1],ae[se],se+1===ae.length?void 0:ae[se+1])}function a(ae,ce,se){const K=[];function te(Ae,$e,Ie){if($e===0&&Ie.length===0)return;const Re=K[K.length-1];Re&&Re.start+Re.deleteCount===Ae?(Re.deleteCount+=$e,Re.toInsert.push(...Ie)):K.push({start:Ae,deleteCount:$e,toInsert:Ie})}let le=0,de=0;for(;;){if(le===ae.length){te(le,0,ce.slice(de));break}if(de===ce.length){te(le,ae.length-le,[]);break}const Ae=ae[le],$e=ce[de],Ie=se(Ae,$e);Ie===0?(le+=1,de+=1):Ie<0?(te(le,1,[]),le+=1):Ie>0&&(te(le,0,[$e]),de+=1)}return K}function m(ae,ce,se){const K=a(ae,ce,se),te=[],le=[];for(const de of K)te.push(...ae.slice(de.start,de.start+de.deleteCount)),le.push(...de.toInsert);return{removed:te,added:le}}function o(ae,ce,se){if(se===0)return[];const K=ae.slice(0,se).sort(ce);return i(ae,ce,K,se,ae.length),K}function n(ae,ce,se,K,te){return se===0?Promise.resolve([]):new Promise((le,de)=>{(async()=>{const Ae=ae.length,$e=ae.slice(0,se).sort(ce);for(let Ie=se,Re=Math.min(se+K,Ae);Ie<Ae;Ie=Re,Re=Math.min(Re+K,Ae)){if(Ie>se&&await new Promise(Fe=>setTimeout(Fe)),te&&te.isCancellationRequested)throw new u.$5;i(ae,ce,$e,Ie,Re)}return $e})().then(le,de)})}function i(ae,ce,se,K,te){for(const le=se.length;K<te;K++){const de=ae[K];if(ce(de,se[le-1])<0){se.pop();const Ae=(0,L.$kb)(se,$e=>ce(de,$e)<0);se.splice(Ae,0,de)}}}function r(ae){return ae.filter(ce=>!!ce)}function s(ae){let ce=0;for(let se=0;se<ae.length;se++)ae[se]&&(ae[ce]=ae[se],ce+=1);ae.length=ce}function t(ae,ce,se){ae.splice(se,0,ae.splice(ce,1)[0])}function f(ae){return!Array.isArray(ae)||ae.length===0}function d(ae){return Array.isArray(ae)&&ae.length>0}function l(ae,ce=se=>se){const se=new Set;return ae.filter(K=>{const te=ce(K);return se.has(te)?!1:(se.add(te),!0)})}function c(ae){const ce=new Set;return se=>{const K=ae(se);return ce.has(K)?!1:(ce.add(K),!0)}}function h(ae,ce){return ae.length>0?ae[0]:ce}function g(ae,ce){return ae.length>0?ae[ae.length-1]:ce}function S(ae,ce,se=(K,te)=>K===te){let K=0;for(let te=0,le=Math.min(ae.length,ce.length);te<le&&se(ae[te],ce[te]);te++)K++;return K}function w(ae){return[].concat(...ae)}function C(ae,ce){let se=typeof ce=="number"?ae:0;typeof ce=="number"?se=ae:(se=0,ce=ae);const K=[];if(se<=ce)for(let te=se;te<ce;te++)K.push(te);else for(let te=se;te>ce;te--)K.push(te);return K}function k(ae,ce,se){return ae.reduce((K,te)=>(K[ce(te)]=se?se(te):te,K),Object.create(null))}function D(ae,ce){return ae.push(ce),()=>O(ae,ce)}function O(ae,ce){const se=ae.indexOf(ce);if(se>-1)return ae.splice(se,1),ce}function F(ae,ce,se){const K=ae.slice(0,ce),te=ae.slice(ce);return K.concat(se,te)}function T(ae,ce){let se;if(typeof ce=="number"){let K=ce;se=()=>{const te=Math.sin(K++)*179426549;return te-Math.floor(te)}}else se=Math.random;for(let K=ae.length-1;K>0;K-=1){const te=Math.floor(se()*(K+1)),le=ae[K];ae[K]=ae[te],ae[te]=le}}function z(ae,ce){const se=ae.indexOf(ce);se>-1&&(ae.splice(se,1),ae.unshift(ce))}function j(ae,ce){const se=ae.indexOf(ce);se>-1&&(ae.splice(se,1),ae.push(ce))}function N(ae,ce){for(const se of ce)ae.push(se)}function B(ae,ce){return Array.isArray(ae)?ae.map(ce):ce(ae)}function W(ae){return Array.isArray(ae)?ae:[ae]}function Z(ae){return ae[Math.floor(Math.random()*ae.length)]}function _(ae,ce,se){const K=x(ae,ce),te=ae.length,le=se.length;ae.length=te+le;for(let de=te-1;de>=K;de--)ae[de+le]=ae[de];for(let de=0;de<le;de++)ae[de+K]=se[de]}function X(ae,ce,se,K){const te=x(ae,ce);let le=ae.splice(te,se);return le===void 0&&(le=[]),_(ae,te,K),le}function x(ae,ce){return ce<0?Math.max(ce+ae.length,0):Math.min(ce,ae.length)}var re;(function(ae){function ce(le){return le<0}ae.isLessThan=ce;function se(le){return le<=0}ae.isLessThanOrEqual=se;function K(le){return le>0}ae.isGreaterThan=K;function te(le){return le===0}ae.isNeitherLessOrGreaterThan=te,ae.greaterThan=1,ae.lessThan=-1,ae.neitherLessOrGreaterThan=0})(re||(e.CompareResult=re={}));function Y(ae,ce){return(se,K)=>ce(ae(se),ae(K))}function me(...ae){return(ce,se)=>{for(const K of ae){const te=K(ce,se);if(!re.isNeitherLessOrGreaterThan(te))return te}return re.neitherLessOrGreaterThan}}const Ce=(ae,ce)=>ae-ce;e.$9b=Ce;const ee=(ae,ce)=>(0,e.$9b)(ae?1:0,ce?1:0);e.$0b=ee;function U(ae){return(ce,se)=>-ae(ce,se)}class ie{constructor(ce){this.g=ce,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ce){let se=this.c;for(;se<this.g.length&&ce(this.g[se]);)se++;const K=se===this.c?null:this.g.slice(this.c,se);return this.c=se,K}takeFromEndWhile(ce){let se=this.d;for(;se>=0&&ce(this.g[se]);)se--;const K=se===this.d?null:this.g.slice(se+1,this.d+1);return this.d=se,K}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ce=this.g[this.c];return this.c++,ce}removeLast(){const ce=this.g[this.d];return this.d--,ce}takeCount(ce){const se=this.g.slice(this.c,this.c+ce);return this.c+=ce,se}}e.$_b=ie;class be{static{this.empty=new be(ce=>{})}constructor(ce){this.iterate=ce}forEach(ce){this.iterate(se=>(ce(se),!0))}toArray(){const ce=[];return this.iterate(se=>(ce.push(se),!0)),ce}filter(ce){return new be(se=>this.iterate(K=>ce(K)?se(K):!0))}map(ce){return new be(se=>this.iterate(K=>se(ce(K))))}some(ce){let se=!1;return this.iterate(K=>(se=ce(K),!se)),se}findFirst(ce){let se;return this.iterate(K=>ce(K)?(se=K,!1):!0),se}findLast(ce){let se;return this.iterate(K=>(ce(K)&&(se=K),!0)),se}findLastMaxBy(ce){let se,K=!0;return this.iterate(te=>((K||re.isGreaterThan(ce(te,se)))&&(K=!1,se=te),!0)),se}}e.$ac=be;class Se{constructor(ce){this.c=ce}static createSortPermutation(ce,se){const K=Array.from(ce.keys()).sort((te,le)=>se(ce[te],ce[le]));return new Se(K)}apply(ce){return ce.map((se,K)=>ce[this.c[K]])}inverse(){const ce=this.c.slice();for(let se=0;se<this.c.length;se++)ce[this.c[se]]=se;return new Se(ce)}}e.$bc=Se}),define(ke[61],Ee([1,0,13]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=L,e.$0c=M,e.$$c=P,e.$_c=R,e.$ad=b,e.$bd=$;function L(y,A){if(!y)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}function M(y,A="Unreachable"){throw new Error(A)}function P(y){if(!y)throw new u.$cb("Assertion Failed")}function R(y){y||(0,u.$1)(new u.$cb("Soft Assertion Failed"))}function b(y){if(!y()){debugger;y(),(0,u.$1)(new u.$cb("Assertion Failed"))}}function $(y,A){let I=0;for(;I<y.length-1;){const p=y[I],E=y[I+1];if(!A(p,E))return!1;I++}return!0}}),define(ke[74],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=u;function u(L,M){const P=this;let R=!1,b;return function(){if(R)return b;if(R=!0,M)try{b=L.apply(P,arguments)}finally{M()}else b=L.apply(P,arguments);return b}}}),define(ke[124],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MO=e.$LO=void 0;class u{constructor(M){this.a=M,this.b=0}nextId(){return this.a+ ++this.b}}e.$LO=u,e.$MO=new u("id#")}),define(ke[38],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var u;(function(L){function M(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}L.is=M;const P=Object.freeze([]);function R(){return P}L.empty=R;function*b(t){yield t}L.single=b;function $(t){return M(t)?t:b(t)}L.wrap=$;function y(t){return t||P}L.from=y;function*A(t){for(let f=t.length-1;f>=0;f--)yield t[f]}L.reverse=A;function I(t){return!t||t[Symbol.iterator]().next().done===!0}L.isEmpty=I;function p(t){return t[Symbol.iterator]().next().value}L.first=p;function E(t,f){for(const d of t)if(f(d))return!0;return!1}L.some=E;function v(t,f){for(const d of t)if(f(d))return d}L.find=v;function*a(t,f){for(const d of t)f(d)&&(yield d)}L.filter=a;function*m(t,f){let d=0;for(const l of t)yield f(l,d++)}L.map=m;function*o(...t){for(const f of t)yield*f}L.concat=o;function n(t,f,d){let l=d;for(const c of t)l=f(l,c);return l}L.reduce=n;function*i(t,f,d=t.length){for(f<0&&(f+=t.length),d<0?d+=t.length:d>t.length&&(d=t.length);f<d;f++)yield t[f]}L.slice=i;function r(t,f=Number.POSITIVE_INFINITY){const d=[];if(f===0)return[d,t];const l=t[Symbol.iterator]();for(let c=0;c<f;c++){const h=l.next();if(h.done)return[d,L.empty()];d.push(h.value)}return[d,{[Symbol.iterator](){return l}}]}L.consume=r;async function s(t){const f=[];for await(const d of t)f.push(d);return Promise.resolve(f)}L.asyncToArray=s})(u||(e.Iterable=u={}))}),define(ke[163],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$tn=R,e.$un=I,e.$vn=p,e.$wn=E,e.$xn=v,e.$yn=a,e.$zn=m,e.$An=o,e.$Bn=n,e.$Cn=i,e.$Dn=r,e.$En=s;var u;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(u||(e.ScanError=u={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var M;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(M||(e.ParseErrorCode=M={}));var P;(function(t){t.DEFAULT={allowTrailingComma:!0}})(P||(e.ParseOptions=P={}));function R(t,f=!1){let d=0;const l=t.length;let c="",h=0,g=16,S=0;function w(z){let j=0,N=0;for(;j<z;){const B=t.charCodeAt(d);if(B>=48&&B<=57)N=N*16+B-48;else if(B>=65&&B<=70)N=N*16+B-65+10;else if(B>=97&&B<=102)N=N*16+B-97+10;else break;d++,j++}return j<z&&(N=-1),N}function C(z){d=z,c="",h=0,g=16,S=0}function k(){const z=d;if(t.charCodeAt(d)===48)d++;else for(d++;d<t.length&&y(t.charCodeAt(d));)d++;if(d<t.length&&t.charCodeAt(d)===46)if(d++,d<t.length&&y(t.charCodeAt(d)))for(d++;d<t.length&&y(t.charCodeAt(d));)d++;else return S=3,t.substring(z,d);let j=d;if(d<t.length&&(t.charCodeAt(d)===69||t.charCodeAt(d)===101))if(d++,(d<t.length&&t.charCodeAt(d)===43||t.charCodeAt(d)===45)&&d++,d<t.length&&y(t.charCodeAt(d))){for(d++;d<t.length&&y(t.charCodeAt(d));)d++;j=d}else S=3;return t.substring(z,j)}function D(){let z="",j=d;for(;;){if(d>=l){z+=t.substring(j,d),S=2;break}const N=t.charCodeAt(d);if(N===34){z+=t.substring(j,d),d++;break}if(N===92){if(z+=t.substring(j,d),d++,d>=l){S=2;break}switch(t.charCodeAt(d++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const W=w(4);W>=0?z+=String.fromCharCode(W):S=4;break}default:S=5}j=d;continue}if(N>=0&&N<=31)if($(N)){z+=t.substring(j,d),S=2;break}else S=6;d++}return z}function O(){if(c="",S=0,h=d,d>=l)return h=l,g=17;let z=t.charCodeAt(d);if(b(z)){do d++,c+=String.fromCharCode(z),z=t.charCodeAt(d);while(b(z));return g=15}if($(z))return d++,c+=String.fromCharCode(z),z===13&&t.charCodeAt(d)===10&&(d++,c+=`
`),g=14;switch(z){case 123:return d++,g=1;case 125:return d++,g=2;case 91:return d++,g=3;case 93:return d++,g=4;case 58:return d++,g=6;case 44:return d++,g=5;case 34:return d++,c=D(),g=10;case 47:{const j=d-1;if(t.charCodeAt(d+1)===47){for(d+=2;d<l&&!$(t.charCodeAt(d));)d++;return c=t.substring(j,d),g=12}if(t.charCodeAt(d+1)===42){d+=2;const N=l-1;let B=!1;for(;d<N;){if(t.charCodeAt(d)===42&&t.charCodeAt(d+1)===47){d+=2,B=!0;break}d++}return B||(d++,S=1),c=t.substring(j,d),g=13}return c+=String.fromCharCode(z),d++,g=16}case 45:if(c+=String.fromCharCode(z),d++,d===l||!y(t.charCodeAt(d)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=k(),g=11;default:for(;d<l&&F(z);)d++,z=t.charCodeAt(d);if(h!==d){switch(c=t.substring(h,d),c){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return c+=String.fromCharCode(z),d++,g=16}}function F(z){if(b(z)||$(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let z;do z=O();while(z>=12&&z<=15);return z}return{setPosition:C,getPosition:()=>d,scan:f?T:O,getToken:()=>g,getTokenValue:()=>c,getTokenOffset:()=>h,getTokenLength:()=>d-h,getTokenError:()=>S}}function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function $(t){return t===10||t===13||t===8232||t===8233}function y(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function I(t,f){const d=[],l=new Object;let c;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function S(w,C,k,D){h.value=w,h.offset=C,h.length=k,h.type=D,h.colonOffset=void 0,c=h}try{i(t,{onObjectBegin:(w,C)=>{if(f<=w)throw l;c=void 0,g=f>w,d.push("")},onObjectProperty:(w,C,k)=>{if(f<C||(S(w,C,k,"property"),d[d.length-1]=w,f<=C+k))throw l},onObjectEnd:(w,C)=>{if(f<=w)throw l;c=void 0,d.pop()},onArrayBegin:(w,C)=>{if(f<=w)throw l;c=void 0,d.push(0)},onArrayEnd:(w,C)=>{if(f<=w)throw l;c=void 0,d.pop()},onLiteralValue:(w,C,k)=>{if(f<C||(S(w,C,k,s(w)),f<=C+k))throw l},onSeparator:(w,C,k)=>{if(f<=C)throw l;if(w===":"&&c&&c.type==="property")c.colonOffset=C,g=!1,c=void 0;else if(w===","){const D=d[d.length-1];typeof D=="number"?d[d.length-1]=D+1:(g=!0,d[d.length-1]=""),c=void 0}}})}catch(w){if(w!==l)throw w}return{path:d,previousNode:c,isAtPropertyKey:g,matches:w=>{let C=0;for(let k=0;C<w.length&&k<d.length;k++)if(w[C]===d[k]||w[C]==="*")C++;else if(w[C]!=="**")return!1;return C===w.length}}}function p(t,f=[],d=P.DEFAULT){let l=null,c=[];const h=[];function g(w){Array.isArray(c)?c.push(w):l!==null&&(c[l]=w)}return i(t,{onObjectBegin:()=>{const w={};g(w),h.push(c),c=w,l=null},onObjectProperty:w=>{l=w},onObjectEnd:()=>{c=h.pop()},onArrayBegin:()=>{const w=[];g(w),h.push(c),c=w,l=null},onArrayEnd:()=>{c=h.pop()},onLiteralValue:g,onError:(w,C,k)=>{f.push({error:w,offset:C,length:k})}},d),c[0]}function E(t,f=[],d=P.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(w){l.type==="property"&&(l.length=w-l.offset,l=l.parent)}function h(w){return l.children.push(w),w}i(t,{onObjectBegin:w=>{l=h({type:"object",offset:w,length:-1,parent:l,children:[]})},onObjectProperty:(w,C,k)=>{l=h({type:"property",offset:C,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:w,offset:C,length:k,parent:l})},onObjectEnd:(w,C)=>{l.length=w+C-l.offset,l=l.parent,c(w+C)},onArrayBegin:(w,C)=>{l=h({type:"array",offset:w,length:-1,parent:l,children:[]})},onArrayEnd:(w,C)=>{l.length=w+C-l.offset,l=l.parent,c(w+C)},onLiteralValue:(w,C,k)=>{h({type:s(w),offset:C,length:k,parent:l,value:w}),c(C+k)},onSeparator:(w,C,k)=>{l.type==="property"&&(w===":"?l.colonOffset=C:w===","&&c(C))},onError:(w,C,k)=>{f.push({error:w,offset:C,length:k})}},d);const S=l.children[0];return S&&delete S.parent,S}function v(t,f){if(!t)return;let d=t;for(const l of f)if(typeof l=="string"){if(d.type!=="object"||!Array.isArray(d.children))return;let c=!1;for(const h of d.children)if(Array.isArray(h.children)&&h.children[0].value===l){d=h.children[1],c=!0;break}if(!c)return}else{const c=l;if(d.type!=="array"||c<0||!Array.isArray(d.children)||c>=d.children.length)return;d=d.children[c]}return d}function a(t){if(!t.parent||!t.parent.children)return[];const f=a(t.parent);if(t.parent.type==="property"){const d=t.parent.children[0].value;f.push(d)}else if(t.parent.type==="array"){const d=t.parent.children.indexOf(t);d!==-1&&f.push(d)}return f}function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const f=Object.create(null);for(const d of t.children){const l=d.children[1];l&&(f[d.children[0].value]=m(l))}return f}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function o(t,f,d=!1){return f>=t.offset&&f<t.offset+t.length||d&&f===t.offset+t.length}function n(t,f,d=!1){if(o(t,f,d)){const l=t.children;if(Array.isArray(l))for(let c=0;c<l.length&&l[c].offset<=f;c++){const h=n(l[c],f,d);if(h)return h}return t}}function i(t,f,d=P.DEFAULT){const l=R(t,!1);function c(Y){return Y?()=>Y(l.getTokenOffset(),l.getTokenLength()):()=>!0}function h(Y){return Y?me=>Y(me,l.getTokenOffset(),l.getTokenLength()):()=>!0}const g=c(f.onObjectBegin),S=h(f.onObjectProperty),w=c(f.onObjectEnd),C=c(f.onArrayBegin),k=c(f.onArrayEnd),D=h(f.onLiteralValue),O=h(f.onSeparator),F=c(f.onComment),T=h(f.onError),z=d&&d.disallowComments,j=d&&d.allowTrailingComma;function N(){for(;;){const Y=l.scan();switch(l.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:z||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(Y){case 12:case 13:z?B(10):F();break;case 16:B(1);break;case 15:case 14:break;default:return Y}}}function B(Y,me=[],Ce=[]){if(T(Y),me.length+Ce.length>0){let ee=l.getToken();for(;ee!==17;){if(me.indexOf(ee)!==-1){N();break}else if(Ce.indexOf(ee)!==-1)break;ee=N()}}}function W(Y){const me=l.getTokenValue();return Y?D(me):S(me),N(),!0}function Z(){switch(l.getToken()){case 11:{let Y=0;try{Y=JSON.parse(l.getTokenValue()),typeof Y!="number"&&(B(2),Y=0)}catch{B(2)}D(Y);break}case 7:D(null);break;case 8:D(!0);break;case 9:D(!1);break;default:return!1}return N(),!0}function _(){return l.getToken()!==10?(B(3,[],[2,5]),!1):(W(!1),l.getToken()===6?(O(":"),N(),re()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function X(){g(),N();let Y=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(Y||B(4,[],[]),O(","),N(),l.getToken()===2&&j)break}else Y&&B(6,[],[]);_()||B(4,[],[2,5]),Y=!0}return w(),l.getToken()!==2?B(7,[2],[]):N(),!0}function x(){C(),N();let Y=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(Y||B(4,[],[]),O(","),N(),l.getToken()===4&&j)break}else Y&&B(6,[],[]);re()||B(4,[],[4,5]),Y=!0}return k(),l.getToken()!==4?B(8,[4],[]):N(),!0}function re(){switch(l.getToken()){case 3:return x();case 1:return X();case 10:return W(!0);default:return Z()}}return N(),l.getToken()===17?d.allowEmptyContent?!0:(B(4,[],[]),!1):re()?(l.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}function r(t,f){const d=R(t),l=[];let c,h=0,g;do switch(g=d.getPosition(),c=d.scan(),c){case 12:case 13:case 17:h!==g&&l.push(t.substring(h,g)),f!==void 0&&l.push(d.getTokenValue().replace(/[^\r\n]/g,f)),h=d.getPosition();break}while(c!==17);return l.join("")}function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ke[45],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class u{constructor(M){this.d=M,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(M){this.c=M}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=u}),define(ke[75],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class u{static{this.Undefined=new u(void 0)}constructor(P){this.element=P,this.next=u.Undefined,this.prev=u.Undefined}}class L{constructor(){this.a=u.Undefined,this.b=u.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===u.Undefined}clear(){let P=this.a;for(;P!==u.Undefined;){const R=P.next;P.prev=u.Undefined,P.next=u.Undefined,P=R}this.a=u.Undefined,this.b=u.Undefined,this.c=0}unshift(P){return this.d(P,!1)}push(P){return this.d(P,!0)}d(P,R){const b=new u(P);if(this.a===u.Undefined)this.a=b,this.b=b;else if(R){const y=this.b;this.b=b,b.prev=y,y.next=b}else{const y=this.a;this.a=b,b.next=y,y.prev=b}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(b))}}shift(){if(this.a!==u.Undefined){const P=this.a.element;return this.e(this.a),P}}pop(){if(this.b!==u.Undefined){const P=this.b.element;return this.e(this.b),P}}e(P){if(P.prev!==u.Undefined&&P.next!==u.Undefined){const R=P.prev;R.next=P.next,P.next.prev=R}else P.prev===u.Undefined&&P.next===u.Undefined?(this.a=u.Undefined,this.b=u.Undefined):P.next===u.Undefined?(this.b=this.b.prev,this.b.next=u.Undefined):P.prev===u.Undefined&&(this.a=this.a.next,this.a.prev=u.Undefined);this.c-=1}*[Symbol.iterator](){let P=this.a;for(;P!==u.Undefined;)yield P.element,P=P.next}}e.$5c=L}),define(ke[27],Ee([1,0]),function(he,e){"use strict";var u,L,M;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=P,e.$zc=R,e.$Ac=b,e.$Ic=n;function P(i,r,s){let t=i.get(r);return t===void 0&&(t=s,i.set(r,t)),t}function R(i){const r=[];return i.forEach((s,t)=>{r.push(`${t} => ${s}`)}),`Map(${i.size}) {${r.join(", ")}}`}function b(i){const r=[];return i.forEach(s=>{r.push(s)}),`Set(${i.size}) {${r.join(", ")}}`}class ${constructor(r,s){this.uri=r,this.value=s}}function y(i){return Array.isArray(i)}class A{static{this.c=r=>r.toString()}constructor(r,s){if(this[u]="ResourceMap",r instanceof A)this.d=new Map(r.d),this.e=s??A.c;else if(y(r)){this.d=new Map,this.e=s??A.c;for(const[t,f]of r)this.set(t,f)}else this.d=new Map,this.e=r??A.c}set(r,s){return this.d.set(this.e(r),new $(r,s)),this}get(r){return this.d.get(this.e(r))?.value}has(r){return this.d.has(this.e(r))}get size(){return this.d.size}clear(){this.d.clear()}delete(r){return this.d.delete(this.e(r))}forEach(r,s){typeof s<"u"&&(r=r.bind(s));for(const[t,f]of this.d)r(f.value,f.uri,this)}*values(){for(const r of this.d.values())yield r.value}*keys(){for(const r of this.d.values())yield r.uri}*entries(){for(const r of this.d.values())yield[r.uri,r.value]}*[(u=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.d)yield[r.uri,r.value]}}e.$Bc=A;class I{constructor(r,s){this[L]="ResourceSet",!r||typeof r=="function"?this.c=new A(r):(this.c=new A(s),r.forEach(this.add,this))}get size(){return this.c.size}add(r){return this.c.set(r,r),this}clear(){this.c.clear()}delete(r){return this.c.delete(r)}forEach(r,s){this.c.forEach((t,f)=>r.call(s,f,f,this))}has(r){return this.c.has(r)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=I;var p;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class E{constructor(){this[M]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(r){return this.c.has(r)}get(r,s=0){const t=this.c.get(r);if(t)return s!==0&&this.l(t,s),t.value}set(r,s,t=0){let f=this.c.get(r);if(f)f.value=s,t!==0&&this.l(f,t);else{switch(f={key:r,value:s,next:void 0,previous:void 0},t){case 0:this.j(f);break;case 1:this.i(f);break;case 2:this.j(f);break;default:this.j(f);break}this.c.set(r,f),this.f++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this.c.get(r);if(s)return this.c.delete(r),this.k(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const r=this.d;return this.c.delete(r.key),this.k(r),this.f--,r.value}forEach(r,s){const t=this.g;let f=this.d;for(;f;){if(s?r.bind(s)(f.value,f.key,this):r(f.value,f.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const r=this,s=this.g;let t=this.d;const f={[Symbol.iterator](){return f},next(){if(r.g!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const d={value:t.key,done:!1};return t=t.next,d}else return{value:void 0,done:!0}}};return f}values(){const r=this,s=this.g;let t=this.d;const f={[Symbol.iterator](){return f},next(){if(r.g!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const d={value:t.value,done:!1};return t=t.next,d}else return{value:void 0,done:!0}}};return f}entries(){const r=this,s=this.g;let t=this.d;const f={[Symbol.iterator](){return f},next(){if(r.g!==s)throw new Error("LinkedMap got modified during iteration.");if(t){const d={value:[t.key,t.value],done:!1};return t=t.next,d}else return{value:void 0,done:!0}}};return f}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this.d,t=this.size;for(;s&&t>r;)this.c.delete(s.key),s=s.next,t--;this.d=s,this.f=t,s&&(s.previous=void 0),this.g++}i(r){if(!this.d&&!this.e)this.e=r;else if(this.d)r.next=this.d,this.d.previous=r;else throw new Error("Invalid list");this.d=r,this.g++}j(r){if(!this.d&&!this.e)this.d=r;else if(this.e)r.previous=this.e,this.e.next=r;else throw new Error("Invalid list");this.e=r,this.g++}k(r){if(r===this.d&&r===this.e)this.d=void 0,this.e=void 0;else if(r===this.d){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.d=r.next}else if(r===this.e){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.e=r.previous}else{const s=r.next,t=r.previous;if(!s||!t)throw new Error("Invalid list");s.previous=t,t.next=s}r.next=void 0,r.previous=void 0,this.g++}l(r,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this.d)return;const t=r.next,f=r.previous;r===this.e?(f.next=void 0,this.e=f):(t.previous=f,f.next=t),r.previous=void 0,r.next=this.d,this.d.previous=r,this.d=r,this.g++}else if(s===2){if(r===this.e)return;const t=r.next,f=r.previous;r===this.d?(t.previous=void 0,this.d=t):(t.previous=f,f.next=t),r.next=void 0,r.previous=this.e,this.e.next=r,this.e=r,this.g++}}}toJSON(){const r=[];return this.forEach((s,t)=>{r.push([t,s])}),r}fromJSON(r){this.clear();for(const[s,t]of r)this.set(s,t)}}e.$Dc=E;class v extends E{constructor(r,s=1){super(),this.m=r,this.n=Math.min(Math.max(0,s),1)}get limit(){return this.m}set limit(r){this.m=r,this.o()}get ratio(){return this.n}set ratio(r){this.n=Math.min(Math.max(0,r),1),this.o()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Ec=v;class a{constructor(){this.c=new Map}add(r){return this.c.set(r,(this.c.get(r)||0)+1),this}delete(r){let s=this.c.get(r)||0;return s===0?!1:(s--,s===0?this.c.delete(r):this.c.set(r,s),!0)}has(r){return this.c.has(r)}}e.$Fc=a;class m{constructor(r){if(this.c=new Map,this.d=new Map,r)for(const[s,t]of r)this.set(s,t)}clear(){this.c.clear(),this.d.clear()}set(r,s){this.c.set(r,s),this.d.set(s,r)}get(r){return this.c.get(r)}getKey(r){return this.d.get(r)}delete(r){const s=this.c.get(r);return s===void 0?!1:(this.c.delete(r),this.d.delete(s),!0)}forEach(r,s){this.c.forEach((t,f)=>{r.call(s,t,f,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=m;class o{constructor(){this.c=new Map}add(r,s){let t=this.c.get(r);t||(t=new Set,this.c.set(r,t)),t.add(s)}delete(r,s){const t=this.c.get(r);t&&(t.delete(s),t.size===0&&this.c.delete(r))}forEach(r,s){const t=this.c.get(r);t&&t.forEach(s)}get(r){const s=this.c.get(r);return s||new Set}}e.$Hc=o;function n(i,r){if(i===r)return!0;if(i.size!==r.size)return!1;for(const[s,t]of i)if(!r.has(s)||r.get(s)!==t)return!1;for(const[s]of r)if(!i.has(s))return!1;return!0}}),define(ke[3],Ee([1,0,19,73,27,74,38]),function(he,e,u,L,M,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=A,e.$Lc=I,e.$Mc=p,e.$Nc=a,e.$Oc=m,e.$Pc=o,e.$Qc=n,e.$Rc=i,e.$Sc=r,e.$3c=w;const b=!1;let $=null;class y{constructor(){this.b=new Map}static{this.a=0}c(D){let O=this.b.get(D);return O||(O={parent:null,source:null,isSingleton:!1,value:D,idx:y.a++},this.b.set(D,O)),O}trackDisposable(D){const O=this.c(D);O.source||(O.source=new Error().stack)}setParent(D,O){const F=this.c(D);F.parent=O}markAsDisposed(D){this.b.delete(D)}markAsSingleton(D){this.c(D).isSingleton=!0}f(D,O){const F=O.get(D);if(F)return F;const T=D.parent?this.f(this.c(D.parent),O):D;return O.set(D,T),T}getTrackedDisposables(){const D=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,D).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(D=10,O){let F;if(O)F=O;else{const B=new Map,W=[...this.b.values()].filter(_=>_.source!==null&&!this.f(_,B).isSingleton);if(W.length===0)return;const Z=new Set(W.map(_=>_.value));if(F=W.filter(_=>!(_.parent&&Z.has(_.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function T(B){function W(_,X){for(;_.length>0&&X.some(x=>typeof x=="string"?x===_[0]:_[0].match(x));)_.shift()}const Z=B.source.split(`
`).map(_=>_.trim().replace("at ","")).filter(_=>_!=="");return W(Z,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Z.reverse()}const z=new M.$Hc;for(const B of F){const W=T(B);for(let Z=0;Z<=W.length;Z++)z.add(W.slice(0,Z).join(`
`),B)}F.sort((0,u.$7b)(B=>B.idx,u.$9b));let j="",N=0;for(const B of F.slice(0,D)){N++;const W=T(B),Z=[];for(let _=0;_<W.length;_++){let X=W[_];X=`(shared with ${z.get(W.slice(0,_+1).join(`
`)).size}/${F.length} leaks) at ${X}`;const re=z.get(W.slice(0,_).join(`
`)),Y=(0,L.$K)([...re].map(me=>T(me)[_]),me=>me);delete Y[W[_]];for(const[me,Ce]of Object.entries(Y))Z.unshift(`    - stacktraces of ${Ce.length} other leaks continue with ${me}`);Z.unshift(X)}j+=`


==================== Leaking disposable ${N}/${F.length}: ${B.value.constructor.name} ====================
${Z.join(`
`)}
============================================================

`}return F.length>D&&(j+=`


... and ${F.length-D} more leaking disposables

`),{leaks:F,details:j}}}e.$Jc=y;function A(k){$=k}if(b){const k="__is_disposable_tracked__";A(new class{trackDisposable(D){const O=new Error("Potentially leaked disposable").stack;setTimeout(()=>{D[k]||console.log(O)},3e3)}setParent(D,O){if(D&&D!==t.None)try{D[k]=!0}catch{}}markAsDisposed(D){if(D&&D!==t.None)try{D[k]=!0}catch{}}markAsSingleton(D){}})}function I(k){return $?.trackDisposable(k),k}function p(k){$?.markAsDisposed(k)}function E(k,D){$?.setParent(k,D)}function v(k,D){if($)for(const O of k)$.setParent(O,D)}function a(k){return $?.markAsSingleton(k),k}function m(k){return typeof k.dispose=="function"&&k.dispose.length===0}function o(k){if(R.Iterable.is(k)){const D=[];for(const O of k)if(O)try{O.dispose()}catch(F){D.push(F)}if(D.length===1)throw D[0];if(D.length>1)throw new AggregateError(D,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}function n(k){for(const D of k)m(D)&&D.dispose();return[]}function i(...k){const D=r(()=>o(k));return v(k,D),D}function r(k){const D=I({dispose:(0,P.$db)(()=>{p(D),k()})});return D}class s{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,I(this)}dispose(){this.g||(p(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{o(this.f)}finally{this.f.clear()}}add(D){if(!D)return D;if(D===this)throw new Error("Cannot register a disposable on itself!");return E(D,this),this.g?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(D),D}delete(D){if(D){if(D===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(D),D.dispose()}}deleteAndLeak(D){D&&this.f.has(D)&&(this.f.delete(D),E(D,null))}}e.$Tc=s;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new s,I(this),E(this.q,this)}dispose(){p(this),this.q.dispose()}B(D){if(D===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(D)}}e.$Uc=t;class f{constructor(){this.b=!1,I(this)}get value(){return this.b?void 0:this.a}set value(D){this.b||D===this.a||(this.a?.dispose(),D&&E(D,this),this.a=D)}clear(){this.value=void 0}dispose(){this.b=!0,p(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const D=this.a;return this.a=void 0,D&&E(D,null),D}}e.$Vc=f;class d{constructor(D){this.a=new f,this.b=!1,this.a.value=D}get value(){return this.a.value}set value(D){this.b||D===this.a.value||(this.a.value=D)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=d;class l{constructor(D){this.b=D,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=l;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,I(this)}set(D){let O=D;return this.unset=()=>O=void 0,this.isset=()=>O!==void 0,this.dispose=()=>{O&&(O(),O=void 0,p(this))},this}}e.$Yc=c;class h{constructor(){this.a=new Map}acquire(D,...O){let F=this.a.get(D);F||(F={counter:0,object:this.b(D,...O)},this.a.set(D,F));const{object:T}=F,z=(0,P.$db)(()=>{--F.counter===0&&(this.c(D,F.object),this.a.delete(D))});return F.counter++,{object:T,dispose:z}}}e.$Zc=h;class g{constructor(D){this.a=D}async acquire(D,...O){const F=this.a.acquire(D,...O);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(T){throw F.dispose(),T}}}e.$1c=g;class S{constructor(D){this.object=D}dispose(){}}e.$2c=S;function w(k){const D=new s;try{k(D)}finally{D.dispose()}}class C{constructor(){this.a=new Map,this.b=!1,I(this)}dispose(){p(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{o(this.a.values())}finally{this.a.clear()}}has(D){return this.a.has(D)}get size(){return this.a.size}get(D){return this.a.get(D)}set(D,O,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(D)?.dispose(),this.a.set(D,O)}deleteAndDispose(D){this.a.get(D)?.dispose(),this.a.delete(D)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=C}),function(he,e){typeof define=="function"&&define.amd?define(ke[164],Ee([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(he=typeof globalThis<"u"?globalThis:he||self,e(he.marked={}))}(this,function(he){"use strict";function e(ae,ce){for(var se=0;se<ce.length;se++){var K=ce[se];K.enumerable=K.enumerable||!1,K.configurable=!0,"value"in K&&(K.writable=!0),Object.defineProperty(ae,K.key,K)}}function u(ae,ce,se){return ce&&e(ae.prototype,ce),se&&e(ae,se),Object.defineProperty(ae,"prototype",{writable:!1}),ae}function L(ae,ce){if(ae){if(typeof ae=="string")return M(ae,ce);var se=Object.prototype.toString.call(ae).slice(8,-1);if(se==="Object"&&ae.constructor&&(se=ae.constructor.name),se==="Map"||se==="Set")return Array.from(ae);if(se==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(se))return M(ae,ce)}}function M(ae,ce){(ce==null||ce>ae.length)&&(ce=ae.length);for(var se=0,K=new Array(ce);se<ce;se++)K[se]=ae[se];return K}function P(ae,ce){var se=typeof Symbol<"u"&&ae[Symbol.iterator]||ae["@@iterator"];if(se)return(se=se.call(ae)).next.bind(se);if(Array.isArray(ae)||(se=L(ae))||ce&&ae&&typeof ae.length=="number"){se&&(ae=se);var K=0;return function(){return K>=ae.length?{done:!0}:{done:!1,value:ae[K++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}he.defaults=R();function b(ae){he.defaults=ae}var $=/[&<>"']/,y=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,p={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(ce){return p[ce]};function v(ae,ce){if(ce){if($.test(ae))return ae.replace(y,E)}else if(A.test(ae))return ae.replace(I,E);return ae}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(ae){return ae.replace(a,function(ce,se){return se=se.toLowerCase(),se==="colon"?":":se.charAt(0)==="#"?se.charAt(1)==="x"?String.fromCharCode(parseInt(se.substring(2),16)):String.fromCharCode(+se.substring(1)):""})}var o=/(^|[^\[])\^/g;function n(ae,ce){ae=typeof ae=="string"?ae:ae.source,ce=ce||"";var se={replace:function(te,le){return le=le.source||le,le=le.replace(o,"$1"),ae=ae.replace(te,le),se},getRegex:function(){return new RegExp(ae,ce)}};return se}var i=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function s(ae,ce,se){if(ae){var K;try{K=decodeURIComponent(m(se)).replace(i,"").toLowerCase()}catch{return null}if(K.indexOf("javascript:")===0||K.indexOf("vbscript:")===0||K.indexOf("data:")===0)return null}ce&&!r.test(se)&&(se=c(ce,se));try{se=encodeURI(se).replace(/%25/g,"%")}catch{return null}return se}var t={},f=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(ae,ce){t[" "+ae]||(f.test(ae)?t[" "+ae]=ae+"/":t[" "+ae]=w(ae,"/",!0)),ae=t[" "+ae];var se=ae.indexOf(":")===-1;return ce.substring(0,2)==="//"?se?ce:ae.replace(d,"$1")+ce:ce.charAt(0)==="/"?se?ce:ae.replace(l,"$1")+ce:ae+ce}var h={exec:function(){}};function g(ae){for(var ce=1,se,K;ce<arguments.length;ce++){se=arguments[ce];for(K in se)Object.prototype.hasOwnProperty.call(se,K)&&(ae[K]=se[K])}return ae}function S(ae,ce){var se=ae.replace(/\|/g,function(le,de,Ae){for(var $e=!1,Ie=de;--Ie>=0&&Ae[Ie]==="\\";)$e=!$e;return $e?"|":" |"}),K=se.split(/ \|/),te=0;if(K[0].trim()||K.shift(),K.length>0&&!K[K.length-1].trim()&&K.pop(),K.length>ce)K.splice(ce);else for(;K.length<ce;)K.push("");for(;te<K.length;te++)K[te]=K[te].trim().replace(/\\\|/g,"|");return K}function w(ae,ce,se){var K=ae.length;if(K===0)return"";for(var te=0;te<K;){var le=ae.charAt(K-te-1);if(le===ce&&!se)te++;else if(le!==ce&&se)te++;else break}return ae.slice(0,K-te)}function C(ae,ce){if(ae.indexOf(ce[1])===-1)return-1;for(var se=ae.length,K=0,te=0;te<se;te++)if(ae[te]==="\\")te++;else if(ae[te]===ce[0])K++;else if(ae[te]===ce[1]&&(K--,K<0))return te;return-1}function k(ae){ae&&ae.sanitize&&!ae.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function D(ae,ce){if(ce<1)return"";for(var se="";ce>1;)ce&1&&(se+=ae),ce>>=1,ae+=ae;return se+ae}function O(ae,ce,se,K){var te=ce.href,le=ce.title?v(ce.title):null,de=ae[1].replace(/\\([\[\]])/g,"$1");if(ae[0].charAt(0)!=="!"){K.state.inLink=!0;var Ae={type:"link",raw:se,href:te,title:le,text:de,tokens:K.inlineTokens(de)};return K.state.inLink=!1,Ae}return{type:"image",raw:se,href:te,title:le,text:v(de)}}function F(ae,ce){var se=ae.match(/^(\s+)(?:```)/);if(se===null)return ce;var K=se[1];return ce.split(`
`).map(function(te){var le=te.match(/^\s+/);if(le===null)return te;var de=le[0];return de.length>=K.length?te.slice(K.length):te}).join(`
`)}var T=function(){function ae(se){this.options=se||he.defaults}var ce=ae.prototype;return ce.space=function(K){var te=this.rules.block.newline.exec(K);if(te&&te[0].length>0)return{type:"space",raw:te[0]}},ce.code=function(K){var te=this.rules.block.code.exec(K);if(te){var le=te[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:te[0],codeBlockStyle:"indented",text:this.options.pedantic?le:w(le,`
`)}}},ce.fences=function(K){var te=this.rules.block.fences.exec(K);if(te){var le=te[0],de=F(le,te[3]||"");return{type:"code",raw:le,lang:te[2]?te[2].trim():te[2],text:de}}},ce.heading=function(K){var te=this.rules.block.heading.exec(K);if(te){var le=te[2].trim();if(/#$/.test(le)){var de=w(le,"#");(this.options.pedantic||!de||/ $/.test(de))&&(le=de.trim())}return{type:"heading",raw:te[0],depth:te[1].length,text:le,tokens:this.lexer.inline(le)}}},ce.hr=function(K){var te=this.rules.block.hr.exec(K);if(te)return{type:"hr",raw:te[0]}},ce.blockquote=function(K){var te=this.rules.block.blockquote.exec(K);if(te){var le=te[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:te[0],tokens:this.lexer.blockTokens(le,[]),text:le}}},ce.list=function(K){var te=this.rules.block.list.exec(K);if(te){var le,de,Ae,$e,Ie,Re,Fe,q,V,Q,J,fe,we=te[1].trim(),Te=we.length>1,He={type:"list",raw:"",ordered:Te,start:Te?+we.slice(0,-1):"",loose:!1,items:[]};we=Te?"\\d{1,9}\\"+we.slice(-1):"\\"+we,this.options.pedantic&&(we=Te?we:"[*+-]");for(var xe=new RegExp("^( {0,3}"+we+")((?:[	 ][^\\n]*)?(?:\\n|$))");K&&(fe=!1,!(!(te=xe.exec(K))||this.rules.block.hr.test(K)));){if(le=te[0],K=K.substring(le.length),q=te[2].split(`
`,1)[0],V=K.split(`
`,1)[0],this.options.pedantic?($e=2,J=q.trimLeft()):($e=te[2].search(/[^ ]/),$e=$e>4?1:$e,J=q.slice($e),$e+=te[1].length),Re=!1,!q&&/^ *$/.test(V)&&(le+=V+`
`,K=K.substring(V.length+1),fe=!0),!fe)for(var it=new RegExp("^ {0,"+Math.min(3,$e-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),rt=new RegExp("^ {0,"+Math.min(3,$e-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),at=new RegExp("^ {0,"+Math.min(3,$e-1)+"}(?:```|~~~)"),ot=new RegExp("^ {0,"+Math.min(3,$e-1)+"}#");K&&(Q=K.split(`
`,1)[0],q=Q,this.options.pedantic&&(q=q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(at.test(q)||ot.test(q)||it.test(q)||rt.test(K)));){if(q.search(/[^ ]/)>=$e||!q.trim())J+=`
`+q.slice($e);else if(!Re)J+=`
`+q;else break;!Re&&!q.trim()&&(Re=!0),le+=Q+`
`,K=K.substring(Q.length+1)}He.loose||(Fe?He.loose=!0:/\n *\n *$/.test(le)&&(Fe=!0)),this.options.gfm&&(de=/^\[[ xX]\] /.exec(J),de&&(Ae=de[0]!=="[ ] ",J=J.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:le,task:!!de,checked:Ae,loose:!1,text:J}),He.raw+=le}He.items[He.items.length-1].raw=le.trimRight(),He.items[He.items.length-1].text=J.trimRight(),He.raw=He.raw.trimRight();var De=He.items.length;for(Ie=0;Ie<De;Ie++){this.lexer.state.top=!1,He.items[Ie].tokens=this.lexer.blockTokens(He.items[Ie].text,[]);var Be=He.items[Ie].tokens.filter(function(Oe){return Oe.type==="space"}),Ge=Be.every(function(Oe){for(var Qe=Oe.raw.split(""),oe=0,ue=P(Qe),Pe;!(Pe=ue()).done;){var Ke=Pe.value;if(Ke===`
`&&(oe+=1),oe>1)return!0}return!1});!He.loose&&Be.length&&Ge&&(He.loose=!0,He.items[Ie].loose=!0)}return He}},ce.html=function(K){var te=this.rules.block.html.exec(K);if(te){var le={type:"html",raw:te[0],pre:!this.options.sanitizer&&(te[1]==="pre"||te[1]==="script"||te[1]==="style"),text:te[0]};if(this.options.sanitize){var de=this.options.sanitizer?this.options.sanitizer(te[0]):v(te[0]);le.type="paragraph",le.text=de,le.tokens=this.lexer.inline(de)}return le}},ce.def=function(K){var te=this.rules.block.def.exec(K);if(te){te[3]&&(te[3]=te[3].substring(1,te[3].length-1));var le=te[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:le,raw:te[0],href:te[2],title:te[3]}}},ce.table=function(K){var te=this.rules.block.table.exec(K);if(te){var le={type:"table",header:S(te[1]).map(function(Fe){return{text:Fe}}),align:te[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:te[3]&&te[3].trim()?te[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=te[0];var de=le.align.length,Ae,$e,Ie,Re;for(Ae=0;Ae<de;Ae++)/^ *-+: *$/.test(le.align[Ae])?le.align[Ae]="right":/^ *:-+: *$/.test(le.align[Ae])?le.align[Ae]="center":/^ *:-+ *$/.test(le.align[Ae])?le.align[Ae]="left":le.align[Ae]=null;for(de=le.rows.length,Ae=0;Ae<de;Ae++)le.rows[Ae]=S(le.rows[Ae],le.header.length).map(function(Fe){return{text:Fe}});for(de=le.header.length,$e=0;$e<de;$e++)le.header[$e].tokens=this.lexer.inline(le.header[$e].text);for(de=le.rows.length,$e=0;$e<de;$e++)for(Re=le.rows[$e],Ie=0;Ie<Re.length;Ie++)Re[Ie].tokens=this.lexer.inline(Re[Ie].text);return le}}},ce.lheading=function(K){var te=this.rules.block.lheading.exec(K);if(te)return{type:"heading",raw:te[0],depth:te[2].charAt(0)==="="?1:2,text:te[1],tokens:this.lexer.inline(te[1])}},ce.paragraph=function(K){var te=this.rules.block.paragraph.exec(K);if(te){var le=te[1].charAt(te[1].length-1)===`
`?te[1].slice(0,-1):te[1];return{type:"paragraph",raw:te[0],text:le,tokens:this.lexer.inline(le)}}},ce.text=function(K){var te=this.rules.block.text.exec(K);if(te)return{type:"text",raw:te[0],text:te[0],tokens:this.lexer.inline(te[0])}},ce.escape=function(K){var te=this.rules.inline.escape.exec(K);if(te)return{type:"escape",raw:te[0],text:v(te[1])}},ce.tag=function(K){var te=this.rules.inline.tag.exec(K);if(te)return!this.lexer.state.inLink&&/^<a /i.test(te[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(te[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(te[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(te[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:te[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):v(te[0]):te[0]}},ce.link=function(K){var te=this.rules.inline.link.exec(K);if(te){var le=te[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var de=w(le.slice(0,-1),"\\");if((le.length-de.length)%2===0)return}else{var Ae=C(te[2],"()");if(Ae>-1){var $e=te[0].indexOf("!")===0?5:4,Ie=$e+te[1].length+Ae;te[2]=te[2].substring(0,Ae),te[0]=te[0].substring(0,Ie).trim(),te[3]=""}}var Re=te[2],Fe="";if(this.options.pedantic){var q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Re);q&&(Re=q[1],Fe=q[3])}else Fe=te[3]?te[3].slice(1,-1):"";return Re=Re.trim(),/^</.test(Re)&&(this.options.pedantic&&!/>$/.test(le)?Re=Re.slice(1):Re=Re.slice(1,-1)),O(te,{href:Re&&Re.replace(this.rules.inline._escapes,"$1"),title:Fe&&Fe.replace(this.rules.inline._escapes,"$1")},te[0],this.lexer)}},ce.reflink=function(K,te){var le;if((le=this.rules.inline.reflink.exec(K))||(le=this.rules.inline.nolink.exec(K))){var de=(le[2]||le[1]).replace(/\s+/g," ");if(de=te[de.toLowerCase()],!de||!de.href){var Ae=le[0].charAt(0);return{type:"text",raw:Ae,text:Ae}}return O(le,de,le[0],this.lexer)}},ce.emStrong=function(K,te,le){le===void 0&&(le="");var de=this.rules.inline.emStrong.lDelim.exec(K);if(de&&!(de[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ae=de[1]||de[2]||"";if(!Ae||Ae&&(le===""||this.rules.inline.punctuation.exec(le))){var $e=de[0].length-1,Ie,Re,Fe=$e,q=0,V=de[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(V.lastIndex=0,te=te.slice(-1*K.length+$e);(de=V.exec(te))!=null;)if(Ie=de[1]||de[2]||de[3]||de[4]||de[5]||de[6],!!Ie){if(Re=Ie.length,de[3]||de[4]){Fe+=Re;continue}else if((de[5]||de[6])&&$e%3&&!(($e+Re)%3)){q+=Re;continue}if(Fe-=Re,!(Fe>0)){if(Re=Math.min(Re,Re+Fe+q),Math.min($e,Re)%2){var Q=K.slice(1,$e+de.index+Re);return{type:"em",raw:K.slice(0,$e+de.index+Re+1),text:Q,tokens:this.lexer.inlineTokens(Q)}}var J=K.slice(2,$e+de.index+Re-1);return{type:"strong",raw:K.slice(0,$e+de.index+Re+1),text:J,tokens:this.lexer.inlineTokens(J)}}}}}},ce.codespan=function(K){var te=this.rules.inline.code.exec(K);if(te){var le=te[2].replace(/\n/g," "),de=/[^ ]/.test(le),Ae=/^ /.test(le)&&/ $/.test(le);return de&&Ae&&(le=le.substring(1,le.length-1)),le=v(le,!0),{type:"codespan",raw:te[0],text:le}}},ce.br=function(K){var te=this.rules.inline.br.exec(K);if(te)return{type:"br",raw:te[0]}},ce.del=function(K){var te=this.rules.inline.del.exec(K);if(te)return{type:"del",raw:te[0],text:te[2],tokens:this.lexer.inlineTokens(te[2])}},ce.autolink=function(K,te){var le=this.rules.inline.autolink.exec(K);if(le){var de,Ae;return le[2]==="@"?(de=v(this.options.mangle?te(le[1]):le[1]),Ae="mailto:"+de):(de=v(le[1]),Ae=de),{type:"link",raw:le[0],text:de,href:Ae,tokens:[{type:"text",raw:de,text:de}]}}},ce.url=function(K,te){var le;if(le=this.rules.inline.url.exec(K)){var de,Ae;if(le[2]==="@")de=v(this.options.mangle?te(le[0]):le[0]),Ae="mailto:"+de;else{var $e;do $e=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while($e!==le[0]);de=v(le[0]),le[1]==="www."?Ae="http://"+de:Ae=de}return{type:"link",raw:le[0],text:de,href:Ae,tokens:[{type:"text",raw:de,text:de}]}}},ce.inlineText=function(K,te){var le=this.rules.inline.text.exec(K);if(le){var de;return this.lexer.state.inRawBlock?de=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):v(le[0]):le[0]:de=v(this.options.smartypants?te(le[0]):le[0]),{type:"text",raw:le[0],text:de}}},ae}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=n(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=n(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=n(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=n(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=n(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=g({},z),z.gfm=g({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=n(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=n(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=g({},z.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:n(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var j={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};j._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",j.punctuation=n(j.punctuation).replace(/punctuation/g,j._punctuation).getRegex(),j.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,j.escapedEmSt=/\\\*|\\_/g,j._comment=n(z._comment).replace("(?:-->|$)","-->").getRegex(),j.emStrong.lDelim=n(j.emStrong.lDelim).replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimAst=n(j.emStrong.rDelimAst,"g").replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimUnd=n(j.emStrong.rDelimUnd,"g").replace(/punct/g,j._punctuation).getRegex(),j._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,j._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,j._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,j.autolink=n(j.autolink).replace("scheme",j._scheme).replace("email",j._email).getRegex(),j._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,j.tag=n(j.tag).replace("comment",j._comment).replace("attribute",j._attribute).getRegex(),j._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,j._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,j._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,j.link=n(j.link).replace("label",j._label).replace("href",j._href).replace("title",j._title).getRegex(),j.reflink=n(j.reflink).replace("label",j._label).replace("ref",z._label).getRegex(),j.nolink=n(j.nolink).replace("ref",z._label).getRegex(),j.reflinkSearch=n(j.reflinkSearch,"g").replace("reflink",j.reflink).replace("nolink",j.nolink).getRegex(),j.normal=g({},j),j.pedantic=g({},j.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",j._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",j._label).getRegex()}),j.gfm=g({},j.normal,{escape:n(j.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),j.gfm.url=n(j.gfm.url,"i").replace("email",j.gfm._extended_email).getRegex(),j.breaks=g({},j.gfm,{br:n(j.br).replace("{2,}","*").getRegex(),text:n(j.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(ae){return ae.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function B(ae){var ce="",se,K,te=ae.length;for(se=0;se<te;se++)K=ae.charCodeAt(se),Math.random()>.5&&(K="x"+K.toString(16)),ce+="&#"+K+";";return ce}var W=function(){function ae(se){this.tokens=[],this.tokens.links=Object.create(null),this.options=se||he.defaults,this.options.tokenizer=this.options.tokenizer||new T,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var K={block:z.normal,inline:j.normal};this.options.pedantic?(K.block=z.pedantic,K.inline=j.pedantic):this.options.gfm&&(K.block=z.gfm,this.options.breaks?K.inline=j.breaks:K.inline=j.gfm),this.tokenizer.rules=K}ae.lex=function(K,te){var le=new ae(te);return le.lex(K)},ae.lexInline=function(K,te){var le=new ae(te);return le.inlineTokens(K)};var ce=ae.prototype;return ce.lex=function(K){K=K.replace(/\r\n|\r/g,`
`),this.blockTokens(K,this.tokens);for(var te;te=this.inlineQueue.shift();)this.inlineTokens(te.src,te.tokens);return this.tokens},ce.blockTokens=function(K,te){var le=this;te===void 0&&(te=[]),this.options.pedantic?K=K.replace(/\t/g,"    ").replace(/^ +$/gm,""):K=K.replace(/^( *)(\t+)/gm,function(Fe,q,V){return q+"    ".repeat(V.length)});for(var de,Ae,$e,Ie;K;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Fe){return(de=Fe.call({lexer:le},K,te))?(K=K.substring(de.raw.length),te.push(de),!0):!1}))){if(de=this.tokenizer.space(K)){K=K.substring(de.raw.length),de.raw.length===1&&te.length>0?te[te.length-1].raw+=`
`:te.push(de);continue}if(de=this.tokenizer.code(K)){K=K.substring(de.raw.length),Ae=te[te.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+de.raw,Ae.text+=`
`+de.text,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):te.push(de);continue}if(de=this.tokenizer.fences(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.heading(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.hr(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.blockquote(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.list(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.html(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.def(K)){K=K.substring(de.raw.length),Ae=te[te.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+de.raw,Ae.text+=`
`+de.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):this.tokens.links[de.tag]||(this.tokens.links[de.tag]={href:de.href,title:de.title});continue}if(de=this.tokenizer.table(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.lheading(K)){K=K.substring(de.raw.length),te.push(de);continue}if($e=K,this.options.extensions&&this.options.extensions.startBlock&&function(){var Fe=1/0,q=K.slice(1),V=void 0;le.options.extensions.startBlock.forEach(function(Q){V=Q.call({lexer:this},q),typeof V=="number"&&V>=0&&(Fe=Math.min(Fe,V))}),Fe<1/0&&Fe>=0&&($e=K.substring(0,Fe+1))}(),this.state.top&&(de=this.tokenizer.paragraph($e))){Ae=te[te.length-1],Ie&&Ae.type==="paragraph"?(Ae.raw+=`
`+de.raw,Ae.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):te.push(de),Ie=$e.length!==K.length,K=K.substring(de.raw.length);continue}if(de=this.tokenizer.text(K)){K=K.substring(de.raw.length),Ae=te[te.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+de.raw,Ae.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):te.push(de);continue}if(K){var Re="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(Re);break}else throw new Error(Re)}}return this.state.top=!0,te},ce.inline=function(K,te){return te===void 0&&(te=[]),this.inlineQueue.push({src:K,tokens:te}),te},ce.inlineTokens=function(K,te){var le=this;te===void 0&&(te=[]);var de,Ae,$e,Ie=K,Re,Fe,q;if(this.tokens.links){var V=Object.keys(this.tokens.links);if(V.length>0)for(;(Re=this.tokenizer.rules.inline.reflinkSearch.exec(Ie))!=null;)V.includes(Re[0].slice(Re[0].lastIndexOf("[")+1,-1))&&(Ie=Ie.slice(0,Re.index)+"["+D("a",Re[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Re=this.tokenizer.rules.inline.blockSkip.exec(Ie))!=null;)Ie=Ie.slice(0,Re.index)+"["+D("a",Re[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Re=this.tokenizer.rules.inline.escapedEmSt.exec(Ie))!=null;)Ie=Ie.slice(0,Re.index)+"++"+Ie.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;K;)if(Fe||(q=""),Fe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(J){return(de=J.call({lexer:le},K,te))?(K=K.substring(de.raw.length),te.push(de),!0):!1}))){if(de=this.tokenizer.escape(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.tag(K)){K=K.substring(de.raw.length),Ae=te[te.length-1],Ae&&de.type==="text"&&Ae.type==="text"?(Ae.raw+=de.raw,Ae.text+=de.text):te.push(de);continue}if(de=this.tokenizer.link(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.reflink(K,this.tokens.links)){K=K.substring(de.raw.length),Ae=te[te.length-1],Ae&&de.type==="text"&&Ae.type==="text"?(Ae.raw+=de.raw,Ae.text+=de.text):te.push(de);continue}if(de=this.tokenizer.emStrong(K,Ie,q)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.codespan(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.br(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.del(K)){K=K.substring(de.raw.length),te.push(de);continue}if(de=this.tokenizer.autolink(K,B)){K=K.substring(de.raw.length),te.push(de);continue}if(!this.state.inLink&&(de=this.tokenizer.url(K,B))){K=K.substring(de.raw.length),te.push(de);continue}if($e=K,this.options.extensions&&this.options.extensions.startInline&&function(){var J=1/0,fe=K.slice(1),we=void 0;le.options.extensions.startInline.forEach(function(Te){we=Te.call({lexer:this},fe),typeof we=="number"&&we>=0&&(J=Math.min(J,we))}),J<1/0&&J>=0&&($e=K.substring(0,J+1))}(),de=this.tokenizer.inlineText($e,N)){K=K.substring(de.raw.length),de.raw.slice(-1)!=="_"&&(q=de.raw.slice(-1)),Fe=!0,Ae=te[te.length-1],Ae&&Ae.type==="text"?(Ae.raw+=de.raw,Ae.text+=de.text):te.push(de);continue}if(K){var Q="Infinite loop on byte: "+K.charCodeAt(0);if(this.options.silent){console.error(Q);break}else throw new Error(Q)}}return te},u(ae,null,[{key:"rules",get:function(){return{block:z,inline:j}}}]),ae}(),Z=function(){function ae(se){this.options=se||he.defaults}var ce=ae.prototype;return ce.code=function(K,te,le){var de=(te||"").match(/\S*/)[0];if(this.options.highlight){var Ae=this.options.highlight(K,de);Ae!=null&&Ae!==K&&(le=!0,K=Ae)}return K=K.replace(/\n$/,"")+`
`,de?'<pre><code class="'+this.options.langPrefix+v(de,!0)+'">'+(le?K:v(K,!0))+`</code></pre>
`:"<pre><code>"+(le?K:v(K,!0))+`</code></pre>
`},ce.blockquote=function(K){return`<blockquote>
`+K+`</blockquote>
`},ce.html=function(K){return K},ce.heading=function(K,te,le,de){if(this.options.headerIds){var Ae=this.options.headerPrefix+de.slug(le);return"<h"+te+' id="'+Ae+'">'+K+"</h"+te+`>
`}return"<h"+te+">"+K+"</h"+te+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(K,te,le){var de=te?"ol":"ul",Ae=te&&le!==1?' start="'+le+'"':"";return"<"+de+Ae+`>
`+K+"</"+de+`>
`},ce.listitem=function(K){return"<li>"+K+`</li>
`},ce.checkbox=function(K){return"<input "+(K?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(K){return"<p>"+K+`</p>
`},ce.table=function(K,te){return te&&(te="<tbody>"+te+"</tbody>"),`<table>
<thead>
`+K+`</thead>
`+te+`</table>
`},ce.tablerow=function(K){return`<tr>
`+K+`</tr>
`},ce.tablecell=function(K,te){var le=te.header?"th":"td",de=te.align?"<"+le+' align="'+te.align+'">':"<"+le+">";return de+K+("</"+le+`>
`)},ce.strong=function(K){return"<strong>"+K+"</strong>"},ce.em=function(K){return"<em>"+K+"</em>"},ce.codespan=function(K){return"<code>"+K+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(K){return"<del>"+K+"</del>"},ce.link=function(K,te,le){if(K=s(this.options.sanitize,this.options.baseUrl,K),K===null)return le;var de='<a href="'+v(K)+'"';return te&&(de+=' title="'+te+'"'),de+=">"+le+"</a>",de},ce.image=function(K,te,le){if(K=s(this.options.sanitize,this.options.baseUrl,K),K===null)return le;var de='<img src="'+K+'" alt="'+le+'"';return te&&(de+=' title="'+te+'"'),de+=this.options.xhtml?"/>":">",de},ce.text=function(K){return K},ae}(),_=function(){function ae(){}var ce=ae.prototype;return ce.strong=function(K){return K},ce.em=function(K){return K},ce.codespan=function(K){return K},ce.del=function(K){return K},ce.html=function(K){return K},ce.text=function(K){return K},ce.link=function(K,te,le){return""+le},ce.image=function(K,te,le){return""+le},ce.br=function(){return""},ae}(),X=function(){function ae(){this.seen={}}var ce=ae.prototype;return ce.serialize=function(K){return K.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(K,te){var le=K,de=0;if(this.seen.hasOwnProperty(le)){de=this.seen[K];do de++,le=K+"-"+de;while(this.seen.hasOwnProperty(le))}return te||(this.seen[K]=de,this.seen[le]=0),le},ce.slug=function(K,te){te===void 0&&(te={});var le=this.serialize(K);return this.getNextSafeSlug(le,te.dryrun)},ae}(),x=function(){function ae(se){this.options=se||he.defaults,this.options.renderer=this.options.renderer||new Z,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new _,this.slugger=new X}ae.parse=function(K,te){var le=new ae(te);return le.parse(K)},ae.parseInline=function(K,te){var le=new ae(te);return le.parseInline(K)};var ce=ae.prototype;return ce.parse=function(K,te){te===void 0&&(te=!0);var le="",de,Ae,$e,Ie,Re,Fe,q,V,Q,J,fe,we,Te,He,xe,it,rt,at,ot,De=K.length;for(de=0;de<De;de++){if(J=K[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[J.type]&&(ot=this.options.extensions.renderers[J.type].call({parser:this},J),ot!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(J.type))){le+=ot||"";continue}switch(J.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(J.tokens),J.depth,m(this.parseInline(J.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(J.text,J.lang,J.escaped);continue}case"table":{for(V="",q="",Ie=J.header.length,Ae=0;Ae<Ie;Ae++)q+=this.renderer.tablecell(this.parseInline(J.header[Ae].tokens),{header:!0,align:J.align[Ae]});for(V+=this.renderer.tablerow(q),Q="",Ie=J.rows.length,Ae=0;Ae<Ie;Ae++){for(Fe=J.rows[Ae],q="",Re=Fe.length,$e=0;$e<Re;$e++)q+=this.renderer.tablecell(this.parseInline(Fe[$e].tokens),{header:!1,align:J.align[$e]});Q+=this.renderer.tablerow(q)}le+=this.renderer.table(V,Q);continue}case"blockquote":{Q=this.parse(J.tokens),le+=this.renderer.blockquote(Q);continue}case"list":{for(fe=J.ordered,we=J.start,Te=J.loose,Ie=J.items.length,Q="",Ae=0;Ae<Ie;Ae++)xe=J.items[Ae],it=xe.checked,rt=xe.task,He="",xe.task&&(at=this.renderer.checkbox(it),Te?xe.tokens.length>0&&xe.tokens[0].type==="paragraph"?(xe.tokens[0].text=at+" "+xe.tokens[0].text,xe.tokens[0].tokens&&xe.tokens[0].tokens.length>0&&xe.tokens[0].tokens[0].type==="text"&&(xe.tokens[0].tokens[0].text=at+" "+xe.tokens[0].tokens[0].text)):xe.tokens.unshift({type:"text",text:at}):He+=at),He+=this.parse(xe.tokens,Te),Q+=this.renderer.listitem(He,rt,it);le+=this.renderer.list(Q,fe,we);continue}case"html":{le+=this.renderer.html(J.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(J.tokens));continue}case"text":{for(Q=J.tokens?this.parseInline(J.tokens):J.text;de+1<De&&K[de+1].type==="text";)J=K[++de],Q+=`
`+(J.tokens?this.parseInline(J.tokens):J.text);le+=te?this.renderer.paragraph(Q):Q;continue}default:{var Be='Token with "'+J.type+'" type was not found.';if(this.options.silent){console.error(Be);return}else throw new Error(Be)}}}return le},ce.parseInline=function(K,te){te=te||this.renderer;var le="",de,Ae,$e,Ie=K.length;for(de=0;de<Ie;de++){if(Ae=K[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&($e=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),$e!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ae.type))){le+=$e||"";continue}switch(Ae.type){case"escape":{le+=te.text(Ae.text);break}case"html":{le+=te.html(Ae.text);break}case"link":{le+=te.link(Ae.href,Ae.title,this.parseInline(Ae.tokens,te));break}case"image":{le+=te.image(Ae.href,Ae.title,Ae.text);break}case"strong":{le+=te.strong(this.parseInline(Ae.tokens,te));break}case"em":{le+=te.em(this.parseInline(Ae.tokens,te));break}case"codespan":{le+=te.codespan(Ae.text);break}case"br":{le+=te.br();break}case"del":{le+=te.del(this.parseInline(Ae.tokens,te));break}case"text":{le+=te.text(Ae.text);break}default:{var Re='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(Re);return}else throw new Error(Re)}}}return le},ae}();function re(ae,ce,se){if(typeof ae>"u"||ae===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ae!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ae)+", string expected");if(typeof ce=="function"&&(se=ce,ce=null),ce=g({},re.defaults,ce||{}),k(ce),se){var K=ce.highlight,te;try{te=W.lex(ae,ce)}catch(Ie){return se(Ie)}var le=function(Re){var Fe;if(!Re)try{ce.walkTokens&&re.walkTokens(te,ce.walkTokens),Fe=x.parse(te,ce)}catch(q){Re=q}return ce.highlight=K,Re?se(Re):se(null,Fe)};if(!K||K.length<3||(delete ce.highlight,!te.length))return le();var de=0;re.walkTokens(te,function(Ie){Ie.type==="code"&&(de++,setTimeout(function(){K(Ie.text,Ie.lang,function(Re,Fe){if(Re)return le(Re);Fe!=null&&Fe!==Ie.text&&(Ie.text=Fe,Ie.escaped=!0),de--,de===0&&le()})},0))}),de===0&&le();return}function Ae(Ie){if(Ie.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+v(Ie.message+"",!0)+"</pre>";throw Ie}try{var $e=W.lex(ae,ce);if(ce.walkTokens){if(ce.async)return Promise.all(re.walkTokens($e,ce.walkTokens)).then(function(){return x.parse($e,ce)}).catch(Ae);re.walkTokens($e,ce.walkTokens)}return x.parse($e,ce)}catch(Ie){Ae(Ie)}}re.options=re.setOptions=function(ae){return g(re.defaults,ae),b(re.defaults),re},re.getDefaults=R,re.defaults=he.defaults,re.use=function(){for(var ae=arguments.length,ce=new Array(ae),se=0;se<ae;se++)ce[se]=arguments[se];var K=g.apply(void 0,[{}].concat(ce)),te=re.defaults.extensions||{renderers:{},childTokens:{}},le;ce.forEach(function(de){if(de.extensions&&(le=!0,de.extensions.forEach(function($e){if(!$e.name)throw new Error("extension name required");if($e.renderer){var Ie=te.renderers?te.renderers[$e.name]:null;Ie?te.renderers[$e.name]=function(){for(var Re=arguments.length,Fe=new Array(Re),q=0;q<Re;q++)Fe[q]=arguments[q];var V=$e.renderer.apply(this,Fe);return V===!1&&(V=Ie.apply(this,Fe)),V}:te.renderers[$e.name]=$e.renderer}if($e.tokenizer){if(!$e.level||$e.level!=="block"&&$e.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");te[$e.level]?te[$e.level].unshift($e.tokenizer):te[$e.level]=[$e.tokenizer],$e.start&&($e.level==="block"?te.startBlock?te.startBlock.push($e.start):te.startBlock=[$e.start]:$e.level==="inline"&&(te.startInline?te.startInline.push($e.start):te.startInline=[$e.start]))}$e.childTokens&&(te.childTokens[$e.name]=$e.childTokens)})),de.renderer&&function(){var $e=re.defaults.renderer||new Z,Ie=function(q){var V=$e[q];$e[q]=function(){for(var Q=arguments.length,J=new Array(Q),fe=0;fe<Q;fe++)J[fe]=arguments[fe];var we=de.renderer[q].apply($e,J);return we===!1&&(we=V.apply($e,J)),we}};for(var Re in de.renderer)Ie(Re);K.renderer=$e}(),de.tokenizer&&function(){var $e=re.defaults.tokenizer||new T,Ie=function(q){var V=$e[q];$e[q]=function(){for(var Q=arguments.length,J=new Array(Q),fe=0;fe<Q;fe++)J[fe]=arguments[fe];var we=de.tokenizer[q].apply($e,J);return we===!1&&(we=V.apply($e,J)),we}};for(var Re in de.tokenizer)Ie(Re);K.tokenizer=$e}(),de.walkTokens){var Ae=re.defaults.walkTokens;K.walkTokens=function($e){var Ie=[];return Ie.push(de.walkTokens.call(this,$e)),Ae&&(Ie=Ie.concat(Ae.call(this,$e))),Ie}}le&&(K.extensions=te),re.setOptions(K)})},re.walkTokens=function(ae,ce){for(var se=[],K=function(){var Ae=le.value;switch(se=se.concat(ce.call(re,Ae)),Ae.type){case"table":{for(var $e=P(Ae.header),Ie;!(Ie=$e()).done;){var Re=Ie.value;se=se.concat(re.walkTokens(Re.tokens,ce))}for(var Fe=P(Ae.rows),q;!(q=Fe()).done;)for(var V=q.value,Q=P(V),J;!(J=Q()).done;){var fe=J.value;se=se.concat(re.walkTokens(fe.tokens,ce))}break}case"list":{se=se.concat(re.walkTokens(Ae.items,ce));break}default:re.defaults.extensions&&re.defaults.extensions.childTokens&&re.defaults.extensions.childTokens[Ae.type]?re.defaults.extensions.childTokens[Ae.type].forEach(function(we){se=se.concat(re.walkTokens(Ae[we],ce))}):Ae.tokens&&(se=se.concat(re.walkTokens(Ae.tokens,ce)))}},te=P(ae),le;!(le=te()).done;)K();return se},re.parseInline=function(ae,ce){if(typeof ae>"u"||ae===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ae!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ae)+", string expected");ce=g({},re.defaults,ce||{}),k(ce);try{var se=W.lexInline(ae,ce);return ce.walkTokens&&re.walkTokens(se,ce.walkTokens),x.parseInline(se,ce)}catch(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+v(K.message+"",!0)+"</pre>";throw K}},re.Parser=x,re.parser=x.parse,re.Renderer=Z,re.TextRenderer=_,re.Lexer=W,re.lexer=W.lex,re.Tokenizer=T,re.Slugger=X,re.parse=re;var Y=re.options,me=re.setOptions,Ce=re.use,ee=re.walkTokens,U=re.parseInline,ie=re,be=x.parse,Se=W.lex;he.Lexer=W,he.Parser=x,he.Renderer=Z,he.Slugger=X,he.TextRenderer=_,he.Tokenizer=T,he.getDefaults=R,he.lexer=Se,he.marked=re,he.options=Y,he.parse=ie,he.parseInline=U,he.parser=be,he.setOptions=me,he.use=Ce,he.walkTokens=ee,Object.defineProperty(he,"__esModule",{value:!0})}),define(ke[165],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=u;function u(a){const m=P(a);if(m&&m.length>0)return new Uint32Array(m)}let L=0;const M=new Uint32Array(10);function P(a){if(L=0,R(a,I,4352),L>0||(R(a,p,4449),L>0)||(R(a,E,4520),L>0)||(R(a,v,12593),L))return M.subarray(0,L);if(a>=44032&&a<=55203){const m=a-44032,o=m%588,n=Math.floor(m/588),i=Math.floor(o/28),r=o%28-1;if(n<I.length?R(n,I,0):4352+n-12593<v.length&&R(4352+n,v,12593),i<p.length?R(i,p,0):4449+i-12593<v.length&&R(4449+i-12593,v,12593),r>=0&&(r<E.length?R(r,E,0):4520+r-12593<v.length&&R(4520+r-12593,v,12593)),L>0)return M.subarray(0,L)}}function R(a,m,o){a>=o&&a<o+m.length&&b(m[a-o])}function b(a){a!==0&&(M[L++]=a&255,a>>8&&(M[L++]=a>>8&255),a>>16&&(M[L++]=a>>16&255))}var $;(function(a){a[a.InitialConsonant=4352]="InitialConsonant",a[a.Vowel=4449]="Vowel",a[a.FinalConsonant=4520]="FinalConsonant",a[a.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var y;(function(a){a[a.NUL=0]="NUL",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z"})(y||(y={}));var A;(function(a){a[a.fa=24934]="fa",a[a.fg=26470]="fg",a[a.fq=29030]="fq",a[a.fr=29286]="fr",a[a.ft=29798]="ft",a[a.fv=30310]="fv",a[a.fx=30822]="fx",a[a.hk=27496]="hk",a[a.hl=27752]="hl",a[a.ho=28520]="ho",a[a.ml=27757]="ml",a[a.nj=27246]="nj",a[a.nl=27758]="nl",a[a.np=28782]="np",a[a.qt=29809]="qt",a[a.rt=29810]="rt",a[a.sg=26483]="sg",a[a.sw=30579]="sw"})(A||(A={}));const I=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),p=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),E=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),v=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ke[76],Ee([1,0,27]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2l=void 0,e.$Zl=M,e.$1l=R;const L=new u.$Ec(1e4);function M(y){return $(y,"NFC",L)}const P=new u.$Ec(1e4);function R(y){return $(y,"NFD",P)}const b=/[^\u0000-\u0080]/;function $(y,A,I){if(!y)return y;const p=I.get(y);if(p)return p;let E;return b.test(y)?E=y.normalize(A):E=y,I.set(y,E),E}e.$2l=function(){const y=/[\u0300-\u036f]/g;return function(A){return R(A).replace(y,"")}}()}),define(ke[125],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=e.$qm=e.$pm=void 0,e.$nm=u,e.rot=L;function u(b,$,y){return Math.min(Math.max(b,$),y)}function L(b,$){return($+b%$)%$}class M{constructor(){this.a=0}getNext(){return this.a++}}e.$pm=M;class P{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$qm=P;class R{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const y=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=y,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$rm=R}),function(){function he(M){const P=[];typeof M=="number"&&P.push("code/timeOrigin",M);function R($){P.push($,Date.now())}function b(){const $=[];for(let y=0;y<P.length;y+=2)$.push({name:P[y],startTime:P[y+1]});return $}return{mark:R,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?he():{mark(M){performance.mark(M)},getMarks(){let M=performance.timeOrigin;typeof M!="number"&&(M=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(M)}];for(const R of performance.getEntriesByType("mark"))P.push({name:R.name,startTime:Math.round(M+R.startTime)});return P}};if(typeof process=="object"){const M=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return he(M)}else return console.trace("perf-util loaded in UNKNOWN environment"),he()}function u(M){return M.MonacoPerformanceMarks||(M.MonacoPerformanceMarks=e()),M.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return u(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=u(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=u(L))}(),define(ke[166],Ee([1,0,38]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vO=void 0;const L=Symbol("unset");class M{constructor(){this.a=new R,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||u.Iterable.empty()}insert($,y,A){this.d($,I=>I._value=y,A)}mutate($,y){this.d($,A=>A._value=y(A._value===L?void 0:A._value))}delete($){const y=this.c($);if(!y)return;let A=y.length-1;const I=y[A].node._value;if(I!==L){for(this.b--,y[A].node._value=L;A>0;A--){const{node:p,part:E}=y[A];if(p.children?.size||p._value!==L)break;y[A-1].node.children.delete(E)}return I}}*deleteRecursive($){const y=this.c($);if(!y)return;const A=y[y.length-1].node;for(let I=y.length-1;I>0;I--){const p=y[I-1];if(p.node.children.delete(y[I].part),p.node.children.size>0||p.node._value!==L)break}for(const I of P(A))I._value!==L&&(this.b--,yield I._value)}find($){let y=this.a;for(const A of $){const I=y.children?.get(A);if(!I)return;y=I}return y._value===L?void 0:y._value}hasKeyOrParent($){let y=this.a;for(const A of $){const I=y.children?.get(A);if(!I)return!1;if(I._value!==L)return!0;y=I}return!1}hasKeyOrChildren($){let y=this.a;for(const A of $){const I=y.children?.get(A);if(!I)return!1;y=I}return!0}hasKey($){let y=this.a;for(const A of $){const I=y.children?.get(A);if(!I)return!1;y=I}return y._value!==L}c($){const y=[{part:"",node:this.a}];let A=0;for(const I of $){const p=y[A].node.children?.get(I);if(!p)return;y.push({part:I,node:p}),A++}return y}d($,y,A){let I=this.a;for(const v of $){if(I.children)if(I.children.has(v))I=I.children.get(v);else{const a=new R;I.children.set(v,a),I=a}else{const a=new R;I.children=new Map([[v,a]]),I=a}A?.(I)}const p=I._value===L?0:1;y(I);const E=I._value===L?0:1;this.b+=E-p}*values(){for(const{_value:$}of P(this.a))$!==L&&(yield $)}}e.$vO=M;function*P(b){const $=[b];for(;$.length>0;){const y=$.pop();if(yield y,y.children)for(const A of y.children.values())$.push(A)}}class R{constructor(){this._value=L}get value(){return this._value===L?void 0:this._value}set value($){this._value=$===void 0?L:$}}}),function(he,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var u=e();for(var L in u)(typeof exports=="object"?exports:he)[L]=u[L]}}(typeof self<"u"?self:this,function(){return function(he){var e={};function u(L){if(e[L])return e[L].exports;var M=e[L]={i:L,l:!1,exports:{}};return he[L].call(M.exports,M,M.exports,u),M.l=!0,M.exports}return u.m=he,u.c=e,u.d=function(L,M,P){u.o(L,M)||Object.defineProperty(L,M,{enumerable:!0,get:P})},u.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},u.t=function(L,M){if(1&M&&(L=u(L)),8&M||4&M&&typeof L=="object"&&L&&L.__esModule)return L;var P=Object.create(null);if(u.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:L}),2&M&&typeof L!="string")for(var R in L)u.d(P,R,function(b){return L[b]}.bind(null,R));return P},u.n=function(L){var M=L&&L.__esModule?function(){return L.default}:function(){return L};return u.d(M,"a",M),M},u.o=function(L,M){return Object.prototype.hasOwnProperty.call(L,M)},u.p="",u(u.s=0)}([function(he,e,u){(function(L){var M;e=he.exports=Ce,M=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],$=e.src=[],y=0,A=y++;$[A]="0|[1-9]\\d*";var I=y++;$[I]="[0-9]+";var p=y++;$[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=y++;$[E]="("+$[A]+")\\.("+$[A]+")\\.("+$[A]+")";var v=y++;$[v]="("+$[I]+")\\.("+$[I]+")\\.("+$[I]+")";var a=y++;$[a]="(?:"+$[A]+"|"+$[p]+")";var m=y++;$[m]="(?:"+$[I]+"|"+$[p]+")";var o=y++;$[o]="(?:-("+$[a]+"(?:\\."+$[a]+")*))";var n=y++;$[n]="(?:-?("+$[m]+"(?:\\."+$[m]+")*))";var i=y++;$[i]="[0-9A-Za-z-]+";var r=y++;$[r]="(?:\\+("+$[i]+"(?:\\."+$[i]+")*))";var s=y++,t="v?"+$[E]+$[o]+"?"+$[r]+"?";$[s]="^"+t+"$";var f="[v=\\s]*"+$[v]+$[n]+"?"+$[r]+"?",d=y++;$[d]="^"+f+"$";var l=y++;$[l]="((?:<|>)?=?)";var c=y++;$[c]=$[I]+"|x|X|\\*";var h=y++;$[h]=$[A]+"|x|X|\\*";var g=y++;$[g]="[v=\\s]*("+$[h]+")(?:\\.("+$[h]+")(?:\\.("+$[h]+")(?:"+$[o]+")?"+$[r]+"?)?)?";var S=y++;$[S]="[v=\\s]*("+$[c]+")(?:\\.("+$[c]+")(?:\\.("+$[c]+")(?:"+$[n]+")?"+$[r]+"?)?)?";var w=y++;$[w]="^"+$[l]+"\\s*"+$[g]+"$";var C=y++;$[C]="^"+$[l]+"\\s*"+$[S]+"$";var k=y++;$[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var D=y++;$[D]="(?:~>?)";var O=y++;$[O]="(\\s*)"+$[D]+"\\s+",b[O]=new RegExp($[O],"g");var F=y++;$[F]="^"+$[D]+$[g]+"$";var T=y++;$[T]="^"+$[D]+$[S]+"$";var z=y++;$[z]="(?:\\^)";var j=y++;$[j]="(\\s*)"+$[z]+"\\s+",b[j]=new RegExp($[j],"g");var N=y++;$[N]="^"+$[z]+$[g]+"$";var B=y++;$[B]="^"+$[z]+$[S]+"$";var W=y++;$[W]="^"+$[l]+"\\s*("+f+")$|^$";var Z=y++;$[Z]="^"+$[l]+"\\s*("+t+")$|^$";var _=y++;$[_]="(\\s*)"+$[l]+"\\s*("+f+"|"+$[g]+")",b[_]=new RegExp($[_],"g");var X=y++;$[X]="^\\s*("+$[g]+")\\s+-\\s+("+$[g]+")\\s*$";var x=y++;$[x]="^\\s*("+$[S]+")\\s+-\\s+("+$[S]+")\\s*$";var re=y++;$[re]="(<|>)?=?\\s*\\*";for(var Y=0;Y<35;Y++)M(Y,$[Y]),b[Y]||(b[Y]=new RegExp($[Y]));function me(V,Q){if(V instanceof Ce)return V;if(typeof V!="string"||V.length>P||!(Q?b[d]:b[s]).test(V))return null;try{return new Ce(V,Q)}catch{return null}}function Ce(V,Q){if(V instanceof Ce){if(V.loose===Q)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof Ce))return new Ce(V,Q);M("SemVer",V,Q),this.loose=Q;var J=V.trim().match(Q?b[d]:b[s]);if(!J)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function(fe){if(/^[0-9]+$/.test(fe)){var we=+fe;if(we>=0&&we<R)return we}return fe}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}e.parse=me,e.valid=function(V,Q){var J=me(V,Q);return J?J.version:null},e.clean=function(V,Q){var J=me(V.trim().replace(/^[=v]+/,""),Q);return J?J.version:null},e.SemVer=Ce,Ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Ce.prototype.toString=function(){return this.version},Ce.prototype.compare=function(V){return M("SemVer.compare",this.version,this.loose,V),V instanceof Ce||(V=new Ce(V,this.loose)),this.compareMain(V)||this.comparePre(V)},Ce.prototype.compareMain=function(V){return V instanceof Ce||(V=new Ce(V,this.loose)),U(this.major,V.major)||U(this.minor,V.minor)||U(this.patch,V.patch)},Ce.prototype.comparePre=function(V){if(V instanceof Ce||(V=new Ce(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var Q=0;do{var J=this.prerelease[Q],fe=V.prerelease[Q];if(M("prerelease compare",Q,J,fe),J===void 0&&fe===void 0)return 0;if(fe===void 0)return 1;if(J===void 0)return-1;if(J!==fe)return U(J,fe)}while(++Q)},Ce.prototype.inc=function(V,Q){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Q),this.inc("pre",Q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Q),this.inc("pre",Q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}Q&&(this.prerelease[0]===Q?isNaN(this.prerelease[1])&&(this.prerelease=[Q,0]):this.prerelease=[Q,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,Q,J,fe){typeof J=="string"&&(fe=J,J=void 0);try{return new Ce(V,J).inc(Q,fe).version}catch{return null}},e.diff=function(V,Q){if(ae(V,Q))return null;var J=me(V),fe=me(Q);if(J.prerelease.length||fe.prerelease.length){for(var we in J)if((we==="major"||we==="minor"||we==="patch")&&J[we]!==fe[we])return"pre"+we;return"prerelease"}for(var we in J)if((we==="major"||we==="minor"||we==="patch")&&J[we]!==fe[we])return we},e.compareIdentifiers=U;var ee=/^[0-9]+$/;function U(V,Q){var J=ee.test(V),fe=ee.test(Q);return J&&fe&&(V=+V,Q=+Q),J&&!fe?-1:fe&&!J?1:V<Q?-1:V>Q?1:0}function ie(V,Q,J){return new Ce(V,J).compare(new Ce(Q,J))}function be(V,Q,J){return ie(V,Q,J)>0}function Se(V,Q,J){return ie(V,Q,J)<0}function ae(V,Q,J){return ie(V,Q,J)===0}function ce(V,Q,J){return ie(V,Q,J)!==0}function se(V,Q,J){return ie(V,Q,J)>=0}function K(V,Q,J){return ie(V,Q,J)<=0}function te(V,Q,J,fe){var we;switch(Q){case"===":typeof V=="object"&&(V=V.version),typeof J=="object"&&(J=J.version),we=V===J;break;case"!==":typeof V=="object"&&(V=V.version),typeof J=="object"&&(J=J.version),we=V!==J;break;case"":case"=":case"==":we=ae(V,J,fe);break;case"!=":we=ce(V,J,fe);break;case">":we=be(V,J,fe);break;case">=":we=se(V,J,fe);break;case"<":we=Se(V,J,fe);break;case"<=":we=K(V,J,fe);break;default:throw new TypeError("Invalid operator: "+Q)}return we}function le(V,Q){if(V instanceof le){if(V.loose===Q)return V;V=V.value}if(!(this instanceof le))return new le(V,Q);M("comparator",V,Q),this.loose=Q,this.parse(V),this.semver===de?this.value="":this.value=this.operator+this.semver.version,M("comp",this)}e.rcompareIdentifiers=function(V,Q){return U(Q,V)},e.major=function(V,Q){return new Ce(V,Q).major},e.minor=function(V,Q){return new Ce(V,Q).minor},e.patch=function(V,Q){return new Ce(V,Q).patch},e.compare=ie,e.compareLoose=function(V,Q){return ie(V,Q,!0)},e.rcompare=function(V,Q,J){return ie(Q,V,J)},e.sort=function(V,Q){return V.sort(function(J,fe){return e.compare(J,fe,Q)})},e.rsort=function(V,Q){return V.sort(function(J,fe){return e.rcompare(J,fe,Q)})},e.gt=be,e.lt=Se,e.eq=ae,e.neq=ce,e.gte=se,e.lte=K,e.cmp=te,e.Comparator=le;var de={};function Ae(V,Q){if(V instanceof Ae)return V.loose===Q?V:new Ae(V.raw,Q);if(V instanceof le)return new Ae(V.value,Q);if(!(this instanceof Ae))return new Ae(V,Q);if(this.loose=Q,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function $e(V){return!V||V.toLowerCase()==="x"||V==="*"}function Ie(V,Q,J,fe,we,Te,He,xe,it,rt,at,ot,De){return((Q=$e(J)?"":$e(fe)?">="+J+".0.0":$e(we)?">="+J+"."+fe+".0":">="+Q)+" "+(xe=$e(it)?"":$e(rt)?"<"+(+it+1)+".0.0":$e(at)?"<"+it+"."+(+rt+1)+".0":ot?"<="+it+"."+rt+"."+at+"-"+ot:"<="+xe)).trim()}function Re(V,Q){for(var J=0;J<V.length;J++)if(!V[J].test(Q))return!1;if(Q.prerelease.length){for(J=0;J<V.length;J++)if(M(V[J].semver),V[J].semver!==de&&V[J].semver.prerelease.length>0){var fe=V[J].semver;if(fe.major===Q.major&&fe.minor===Q.minor&&fe.patch===Q.patch)return!0}return!1}return!0}function Fe(V,Q,J){try{Q=new Ae(Q,J)}catch{return!1}return Q.test(V)}function q(V,Q,J,fe){var we,Te,He,xe,it;switch(V=new Ce(V,fe),Q=new Ae(Q,fe),J){case">":we=be,Te=K,He=Se,xe=">",it=">=";break;case"<":we=Se,Te=se,He=be,xe="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Fe(V,Q,fe))return!1;for(var rt=0;rt<Q.set.length;++rt){var at=Q.set[rt],ot=null,De=null;if(at.forEach(function(Be){Be.semver===de&&(Be=new le(">=0.0.0")),ot=ot||Be,De=De||Be,we(Be.semver,ot.semver,fe)?ot=Be:He(Be.semver,De.semver,fe)&&(De=Be)}),ot.operator===xe||ot.operator===it||(!De.operator||De.operator===xe)&&Te(V,De.semver)||De.operator===it&&He(V,De.semver))return!1}return!0}le.prototype.parse=function(V){var Q=this.loose?b[W]:b[Z],J=V.match(Q);if(!J)throw new TypeError("Invalid comparator: "+V);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new Ce(J[2],this.loose):this.semver=de},le.prototype.toString=function(){return this.value},le.prototype.test=function(V){return M("Comparator.test",V,this.loose),this.semver===de||(typeof V=="string"&&(V=new Ce(V,this.loose)),te(V,this.operator,this.semver,this.loose))},le.prototype.intersects=function(V,Q){if(!(V instanceof le))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new Ae(V.value,Q),Fe(this.value,J,Q);if(V.operator==="")return J=new Ae(this.value,Q),Fe(V.semver,J,Q);var fe=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),we=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),Te=this.semver.version===V.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),xe=te(this.semver,"<",V.semver,Q)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),it=te(this.semver,">",V.semver,Q)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return fe||we||Te&&He||xe||it},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(V){var Q=this.loose;V=V.trim(),M("range",V,Q);var J=Q?b[x]:b[X];V=V.replace(J,Ie),M("hyphen replace",V),V=V.replace(b[_],"$1$2$3"),M("comparator trim",V,b[_]),V=(V=(V=V.replace(b[O],"$1~")).replace(b[j],"$1^")).split(/\s+/).join(" ");var fe=Q?b[W]:b[Z],we=V.split(" ").map(function(Te){return function(He,xe){return M("comp",He),He=function(it,rt){return it.trim().split(/\s+/).map(function(at){return function(ot,De){M("caret",ot,De);var Be=De?b[B]:b[N];return ot.replace(Be,function(Ge,Oe,Qe,oe,ue){var Pe;return M("caret",ot,Ge,Oe,Qe,oe,ue),$e(Oe)?Pe="":$e(Qe)?Pe=">="+Oe+".0.0 <"+(+Oe+1)+".0.0":$e(oe)?Pe=Oe==="0"?">="+Oe+"."+Qe+".0 <"+Oe+"."+(+Qe+1)+".0":">="+Oe+"."+Qe+".0 <"+(+Oe+1)+".0.0":ue?(M("replaceCaret pr",ue),ue.charAt(0)!=="-"&&(ue="-"+ue),Pe=Oe==="0"?Qe==="0"?">="+Oe+"."+Qe+"."+oe+ue+" <"+Oe+"."+Qe+"."+(+oe+1):">="+Oe+"."+Qe+"."+oe+ue+" <"+Oe+"."+(+Qe+1)+".0":">="+Oe+"."+Qe+"."+oe+ue+" <"+(+Oe+1)+".0.0"):(M("no pr"),Pe=Oe==="0"?Qe==="0"?">="+Oe+"."+Qe+"."+oe+" <"+Oe+"."+Qe+"."+(+oe+1):">="+Oe+"."+Qe+"."+oe+" <"+Oe+"."+(+Qe+1)+".0":">="+Oe+"."+Qe+"."+oe+" <"+(+Oe+1)+".0.0"),M("caret return",Pe),Pe})}(at,rt)}).join(" ")}(He,xe),M("caret",He),He=function(it,rt){return it.trim().split(/\s+/).map(function(at){return function(ot,De){var Be=De?b[T]:b[F];return ot.replace(Be,function(Ge,Oe,Qe,oe,ue){var Pe;return M("tilde",ot,Ge,Oe,Qe,oe,ue),$e(Oe)?Pe="":$e(Qe)?Pe=">="+Oe+".0.0 <"+(+Oe+1)+".0.0":$e(oe)?Pe=">="+Oe+"."+Qe+".0 <"+Oe+"."+(+Qe+1)+".0":ue?(M("replaceTilde pr",ue),ue.charAt(0)!=="-"&&(ue="-"+ue),Pe=">="+Oe+"."+Qe+"."+oe+ue+" <"+Oe+"."+(+Qe+1)+".0"):Pe=">="+Oe+"."+Qe+"."+oe+" <"+Oe+"."+(+Qe+1)+".0",M("tilde return",Pe),Pe})}(at,rt)}).join(" ")}(He,xe),M("tildes",He),He=function(it,rt){return M("replaceXRanges",it,rt),it.split(/\s+/).map(function(at){return function(ot,De){ot=ot.trim();var Be=De?b[C]:b[w];return ot.replace(Be,function(Ge,Oe,Qe,oe,ue,Pe){M("xRange",ot,Ge,Oe,Qe,oe,ue,Pe);var Ke=$e(Qe),_e=Ke||$e(oe),Ne=_e||$e(ue);return Oe==="="&&Ne&&(Oe=""),Ke?Ge=Oe===">"||Oe==="<"?"<0.0.0":"*":Oe&&Ne?(_e&&(oe=0),Ne&&(ue=0),Oe===">"?(Oe=">=",_e?(Qe=+Qe+1,oe=0,ue=0):Ne&&(oe=+oe+1,ue=0)):Oe==="<="&&(Oe="<",_e?Qe=+Qe+1:oe=+oe+1),Ge=Oe+Qe+"."+oe+"."+ue):_e?Ge=">="+Qe+".0.0 <"+(+Qe+1)+".0.0":Ne&&(Ge=">="+Qe+"."+oe+".0 <"+Qe+"."+(+oe+1)+".0"),M("xRange return",Ge),Ge})}(at,rt)}).join(" ")}(He,xe),M("xrange",He),He=function(it,rt){return M("replaceStars",it,rt),it.trim().replace(b[re],"")}(He,xe),M("stars",He),He}(Te,Q)}).join(" ").split(/\s+/);return this.loose&&(we=we.filter(function(Te){return!!Te.match(fe)})),we=we.map(function(Te){return new le(Te,Q)})},Ae.prototype.intersects=function(V,Q){if(!(V instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function(fe){return V.set.some(function(we){return we.every(function(Te){return fe.intersects(Te,Q)})})})})},e.toComparators=function(V,Q){return new Ae(V,Q).set.map(function(J){return J.map(function(fe){return fe.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new Ce(V,this.loose));for(var Q=0;Q<this.set.length;Q++)if(Re(this.set[Q],V))return!0;return!1},e.satisfies=Fe,e.maxSatisfying=function(V,Q,J){var fe=null,we=null;try{var Te=new Ae(Q,J)}catch{return null}return V.forEach(function(He){Te.test(He)&&(fe&&we.compare(He)!==-1||(we=new Ce(fe=He,J)))}),fe},e.minSatisfying=function(V,Q,J){var fe=null,we=null;try{var Te=new Ae(Q,J)}catch{return null}return V.forEach(function(He){Te.test(He)&&(fe&&we.compare(He)!==1||(we=new Ce(fe=He,J)))}),fe},e.validRange=function(V,Q){try{return new Ae(V,Q).range||"*"}catch{return null}},e.ltr=function(V,Q,J){return q(V,Q,"<",J)},e.gtr=function(V,Q,J){return q(V,Q,">",J)},e.outside=q,e.prerelease=function(V,Q){var J=me(V,Q);return J&&J.prerelease.length?J.prerelease:null},e.intersects=function(V,Q,J){return V=new Ae(V,J),Q=new Ae(Q,J),V.intersects(Q)},e.coerce=function(V){if(V instanceof Ce)return V;if(typeof V!="string")return null;var Q=V.match(b[k]);return Q==null?null:me((Q[1]||"0")+"."+(Q[2]||"0")+"."+(Q[3]||"0"))}}).call(this,u(1))},function(he,e){var u,L,M=he.exports={};function P(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function b(m){if(u===setTimeout)return setTimeout(m,0);if((u===P||!u)&&setTimeout)return u=setTimeout,setTimeout(m,0);try{return u(m,0)}catch{try{return u.call(null,m,0)}catch{return u.call(this,m,0)}}}(function(){try{u=typeof setTimeout=="function"?setTimeout:P}catch{u=P}try{L=typeof clearTimeout=="function"?clearTimeout:R}catch{L=R}})();var $,y=[],A=!1,I=-1;function p(){A&&$&&(A=!1,$.length?y=$.concat(y):I=-1,y.length&&E())}function E(){if(!A){var m=b(p);A=!0;for(var o=y.length;o;){for($=y,y=[];++I<o;)$&&$[I].run();I=-1,o=y.length}$=null,A=!1,function(n){if(L===clearTimeout)return clearTimeout(n);if((L===R||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(n);try{L(n)}catch{try{return L.call(null,n)}catch{return L.call(this,n)}}}(m)}}function v(m,o){this.fun=m,this.array=o}function a(){}M.nextTick=function(m){var o=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)o[n-1]=arguments[n];y.push(new v(m,o)),y.length!==1||A||b(E)},v.prototype.run=function(){this.fun.apply(null,this.array)},M.title="browser",M.browser=!0,M.env={},M.argv=[],M.version="",M.versions={},M.on=a,M.addListener=a,M.once=a,M.off=a,M.removeListener=a,M.removeAllListeners=a,M.emit=a,M.prependListener=a,M.prependOnceListener=a,M.listeners=function(m){return[]},M.binding=function(m){throw new Error("process.binding is not supported")},M.cwd=function(){return"/"},M.chdir=function(m){throw new Error("process.chdir is not supported")},M.umask=function(){return 0}}])}),define(ke[39],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=void 0;const u=globalThis.performance&&typeof globalThis.performance.now=="function";class L{static create(P){return new L(P)}constructor(P){this.c=u&&P===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$3d=L}),define(ke[4],Ee([1,0,13,74,3,75,39]),function(he,e,u,L,M,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$5d=e.Event=void 0,e.$6d=E;const b=!1,$=!1,y=!1;var A;(function(k){k.None=()=>M.$Uc.None;function D(le){if(y){const{onDidAddListener:de}=le,Ae=a.create();let $e=0;le.onDidAddListener=()=>{++$e===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Ae.print()),de?.()}}}function O(le,de){return X(le,()=>{},0,void 0,!0,void 0,de)}k.defer=O;function F(le){return(de,Ae=null,$e)=>{let Ie=!1,Re;return Re=le(Fe=>{if(!Ie)return Re?Re.dispose():Ie=!0,de.call(Ae,Fe)},null,$e),Ie&&Re.dispose(),Re}}k.once=F;function T(le,de,Ae){return Z(($e,Ie=null,Re)=>le(Fe=>$e.call(Ie,de(Fe)),null,Re),Ae)}k.map=T;function z(le,de,Ae){return Z(($e,Ie=null,Re)=>le(Fe=>{de(Fe),$e.call(Ie,Fe)},null,Re),Ae)}k.forEach=z;function j(le,de,Ae){return Z(($e,Ie=null,Re)=>le(Fe=>de(Fe)&&$e.call(Ie,Fe),null,Re),Ae)}k.filter=j;function N(le){return le}k.signal=N;function B(...le){return(de,Ae=null,$e)=>{const Ie=(0,M.$Rc)(...le.map(Re=>Re(Fe=>de.call(Ae,Fe))));return _(Ie,$e)}}k.any=B;function W(le,de,Ae,$e){let Ie=Ae;return T(le,Re=>(Ie=de(Ie,Re),Ie),$e)}k.reduce=W;function Z(le,de){let Ae;const $e={onWillAddFirstListener(){Ae=le(Ie.fire,Ie)},onDidRemoveLastListener(){Ae?.dispose()}};de||D($e);const Ie=new s($e);return de?.add(Ie),Ie.event}function _(le,de){return de instanceof Array?de.push(le):de&&de.add(le),le}function X(le,de,Ae=100,$e=!1,Ie=!1,Re,Fe){let q,V,Q,J=0,fe;const we={leakWarningThreshold:Re,onWillAddFirstListener(){q=le(He=>{J++,V=de(V,He),$e&&!Q&&(Te.fire(V),V=void 0),fe=()=>{const xe=V;V=void 0,Q=void 0,(!$e||J>1)&&Te.fire(xe),J=0},typeof Ae=="number"?(clearTimeout(Q),Q=setTimeout(fe,Ae)):Q===void 0&&(Q=0,queueMicrotask(fe))})},onWillRemoveListener(){Ie&&J>0&&fe?.()},onDidRemoveLastListener(){fe=void 0,q.dispose()}};Fe||D(we);const Te=new s(we);return Fe?.add(Te),Te.event}k.debounce=X;function x(le,de=0,Ae){return k.debounce(le,($e,Ie)=>$e?($e.push(Ie),$e):[Ie],de,void 0,!0,void 0,Ae)}k.accumulate=x;function re(le,de=($e,Ie)=>$e===Ie,Ae){let $e=!0,Ie;return j(le,Re=>{const Fe=$e||!de(Re,Ie);return $e=!1,Ie=Re,Fe},Ae)}k.latch=re;function Y(le,de,Ae){return[k.filter(le,de,Ae),k.filter(le,$e=>!de($e),Ae)]}k.split=Y;function me(le,de=!1,Ae=[],$e){let Ie=Ae.slice(),Re=le(V=>{Ie?Ie.push(V):q.fire(V)});$e&&$e.add(Re);const Fe=()=>{Ie?.forEach(V=>q.fire(V)),Ie=null},q=new s({onWillAddFirstListener(){Re||(Re=le(V=>q.fire(V)),$e&&$e.add(Re))},onDidAddFirstListener(){Ie&&(de?setTimeout(Fe):Fe())},onDidRemoveLastListener(){Re&&Re.dispose(),Re=null}});return $e&&$e.add(q),q.event}k.buffer=me;function Ce(le,de){return($e,Ie,Re)=>{const Fe=de(new U);return le(function(q){const V=Fe.evaluate(q);V!==ee&&$e.call(Ie,V)},void 0,Re)}}k.chain=Ce;const ee=Symbol("HaltChainable");class U{constructor(){this.f=[]}map(de){return this.f.push(de),this}forEach(de){return this.f.push(Ae=>(de(Ae),Ae)),this}filter(de){return this.f.push(Ae=>de(Ae)?Ae:ee),this}reduce(de,Ae){let $e=Ae;return this.f.push(Ie=>($e=de($e,Ie),$e)),this}latch(de=(Ae,$e)=>Ae===$e){let Ae=!0,$e;return this.f.push(Ie=>{const Re=Ae||!de(Ie,$e);return Ae=!1,$e=Ie,Re?Ie:ee}),this}evaluate(de){for(const Ae of this.f)if(de=Ae(de),de===ee)break;return de}}function ie(le,de,Ae=$e=>$e){const $e=(...q)=>Fe.fire(Ae(...q)),Ie=()=>le.on(de,$e),Re=()=>le.removeListener(de,$e),Fe=new s({onWillAddFirstListener:Ie,onDidRemoveLastListener:Re});return Fe.event}k.fromNodeEventEmitter=ie;function be(le,de,Ae=$e=>$e){const $e=(...q)=>Fe.fire(Ae(...q)),Ie=()=>le.addEventListener(de,$e),Re=()=>le.removeEventListener(de,$e),Fe=new s({onWillAddFirstListener:Ie,onDidRemoveLastListener:Re});return Fe.event}k.fromDOMEventEmitter=be;function Se(le){return new Promise(de=>F(le)(de))}k.toPromise=Se;function ae(le){const de=new s;return le.then(Ae=>{de.fire(Ae)},()=>{de.fire(void 0)}).finally(()=>{de.dispose()}),de.event}k.fromPromise=ae;function ce(le,de,Ae){return de(Ae),le($e=>de($e))}k.runAndSubscribe=ce;class se{constructor(de,Ae){this._observable=de,this.f=0,this.g=!1;const $e={onWillAddFirstListener:()=>{de.addObserver(this)},onDidRemoveLastListener:()=>{de.removeObserver(this)}};Ae||D($e),this.emitter=new s($e),Ae&&Ae.add(this.emitter)}beginUpdate(de){this.f++}handlePossibleChange(de){}handleChange(de,Ae){this.g=!0}endUpdate(de){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function K(le,de){return new se(le,de).emitter.event}k.fromObservable=K;function te(le){return(de,Ae,$e)=>{let Ie=0,Re=!1;const Fe={beginUpdate(){Ie++},endUpdate(){Ie--,Ie===0&&(le.reportChanges(),Re&&(Re=!1,de.call(Ae)))},handlePossibleChange(){},handleChange(){Re=!0}};le.addObserver(Fe),le.reportChanges();const q={dispose(){le.removeObserver(Fe)}};return $e instanceof M.$Tc?$e.add(q):Array.isArray($e)&&$e.push(q),q}}k.fromObservableLight=te})(A||(e.Event=A={}));class I{static{this.all=new Set}static{this.f=0}constructor(D){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${D}_${I.f++}`,I.all.add(this)}start(D){this.g=new R.$3d,this.listenerCount=D}stop(){if(this.g){const D=this.g.elapsed();this.durations.push(D),this.elapsedOverall+=D,this.invocationCount+=1,this.g=void 0}}}e.$5d=I;let p=-1;function E(k){const D=p;return p=k,{dispose(){p=D}}}class v{constructor(D,O=Math.random().toString(18).slice(2,5)){this.threshold=D,this.name=O,this.g=0}dispose(){this.f?.clear()}check(D,O){const F=this.threshold;if(F<=0||O<F)return;this.f||(this.f=new Map);const T=this.f.get(D.value)||0;if(this.f.set(D.value,T+1),this.g-=1,this.g<=0){this.g=F*.5;let z,j=0;for(const[N,B]of this.f)(!z||j<B)&&(z=N,j=B);console.warn(`[${this.name}] potential listener LEAK detected, having ${O} listeners already. MOST frequent listener (${j}):`),console.warn(z)}return()=>{const z=this.f.get(D.value)||0;this.f.set(D.value,z-1)}}}class a{static create(){return new a(new Error().stack??"")}constructor(D){this.value=D}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let m=0;class o{constructor(D){this.value=D,this.id=m++}}const n=2,i=(k,D)=>{if(k instanceof o)D(k);else for(let O=0;O<k.length;O++){const F=k[O];F&&D(F)}},r=b?new FinalizationRegistry(k=>{typeof k=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(k))}):void 0;class s{constructor(D){this.w=0,this.f=D,this.g=p>0||this.f?.leakWarningThreshold?new v(this.f?.leakWarningThreshold??p):void 0,this.j=this.f?._profName?new I(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if($){const D=this.t;queueMicrotask(()=>{i(D,O=>O.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(D,O,F)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),M.$Uc.None;if(this.m)return M.$Uc.None;O&&(D=D.bind(O));const T=new o(D);let z,j;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(T.stack=a.create(),z=this.g.check(T.stack,this.w+1)),$&&(T.stack=j??a.create()),this.t?this.t instanceof o?(this.u??=new f,this.t=[this.t,T]):this.t.push(T):(this.f?.onWillAddFirstListener?.(this),this.t=T,this.f?.onDidAddFirstListener?.(this)),this.w++;const N=(0,M.$Sc)(()=>{r?.unregister(N),z?.(),this.x(T)});if(F instanceof M.$Tc?F.add(N):Array.isArray(F)&&F.push(N),r){const B=new Error().stack.split(`
`).slice(2).join(`
`).trim();r.register(N,B,N)}return N},this.q}x(D){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const O=this.t,F=O.indexOf(D);if(F===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,O[F]=void 0;const T=this.u.current===this;if(this.w*n<=O.length){let z=0;for(let j=0;j<O.length;j++)O[j]?O[z++]=O[j]:T&&(this.u.end--,z<this.u.i&&this.u.i--);O.length=z}}y(D,O){if(!D)return;const F=this.f?.onListenerError||u.$1;if(!F){D.value(O);return}try{D.value(O)}catch(T){F(T)}}z(D){const O=D.current.t;for(;D.i<D.end;)this.y(O[D.i++],D.value);D.reset()}fire(D){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof o)this.y(this.t,D);else{const O=this.u;O.enqueue(this,D,this.t.length),this.z(O)}this.j?.stop()}hasListeners(){return this.w>0}}e.$7d=s;const t=()=>new f;e.$8d=t;class f{constructor(){this.i=-1,this.end=0}enqueue(D,O,F){this.i=0,this.end=F,this.current=D,this.value=O}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class d extends s{async fireAsync(D,O,F){if(this.t)for(this.h||(this.h=new P.$5c),i(this.t,T=>this.h.push([T.value,D]));this.h.size>0&&!O.isCancellationRequested;){const[T,z]=this.h.shift(),j=[],N={...z,token:O,waitUntil:B=>{if(Object.isFrozen(j))throw new Error("waitUntil can NOT be called asynchronous");F&&(B=F(B,T)),j.push(B)}};try{T(N)}catch(B){(0,u.$1)(B);continue}Object.freeze(j),await Promise.allSettled(j).then(B=>{for(const W of B)W.status==="rejected"&&(0,u.$1)(W.reason)})}}}e.$9d=d;class l extends s{get isPaused(){return this.h!==0}constructor(D){super(D),this.h=0,this.s=new P.$5c,this.A=D?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const D=Array.from(this.s);this.s.clear(),super.fire(this.A(D))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(D){this.w&&(this.h!==0?this.s.push(D):super.fire(D))}}e.$0d=l;class c extends l{constructor(D){super(D),this.k=D.delay??100}fire(D){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(D)}}e.$$d=c;class h extends s{constructor(D){super(D),this.h=[],this.k=D?.merge}fire(D){this.hasListeners()&&(this.h.push(D),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(O=>super.fire(O)),this.h=[]}))}}e.$_d=h;class g{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(D){const O={event:D,listener:null};this.h.push(O),this.g&&this.m(O);const F=()=>{this.g&&this.o(O);const T=this.h.indexOf(O);this.h.splice(T,1)};return(0,M.$Sc)((0,L.$db)(F))}j(){this.g=!0,this.h.forEach(D=>this.m(D))}k(){this.g=!1,this.h.forEach(D=>this.o(D))}m(D){D.listener=D.event(O=>this.f.fire(O))}o(D){D.listener?.dispose(),D.listener=null}dispose(){this.f.dispose();for(const D of this.h)D.listener?.dispose();this.h=[]}}e.$ae=g;class S{constructor(D,O,F,T){this.f=new M.$Tc;const z=this.f.add(new g),j=this.f.add(new M.$4c);function N(B){j.set(B,z.add(T(B)))}for(const B of D)N(B);this.f.add(O(B=>{N(B)})),this.f.add(F(B=>{j.deleteAndDispose(B)})),this.event=z.event}dispose(){this.f.dispose()}}e.$be=S;class w{constructor(){this.f=[]}wrapEvent(D){return(O,F,T)=>D(z=>{const j=this.f[this.f.length-1];j?j.push(()=>O.call(F,z)):O.call(F,z)},void 0,T)}bufferEvents(D){const O=[];this.f.push(O);const F=D();return this.f.pop(),O.forEach(T=>T()),F}}e.$ce=w;class C{constructor(){this.f=!1,this.g=A.None,this.h=M.$Uc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(D){this.g=D,this.f&&(this.h.dispose(),this.h=D(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$de=C}),define(ke[22],Ee([1,0,4]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.CancellationToken=void 0;const L=Object.freeze(function(b,$){const y=setTimeout(b.bind($),0);return{dispose(){clearTimeout(y)}}});var M;(function(b){function $(y){return y===b.None||y===b.Cancelled||y instanceof P?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}b.isCancellationToken=$,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:u.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(M||(e.CancellationToken=M={}));class P{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?L:(this.b||(this.b=new u.$7d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor($){this.f=void 0,this.g=void 0,this.g=$&&$.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new P),this.f}cancel(){this.f?this.f instanceof P&&this.f.cancel():this.f=M.Cancelled}dispose($=!1){$&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof P&&this.f.dispose():this.f=M.None}}e.$ee=R}),define(ke[167],Ee([1,0,22]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Re=e.$Qe=e.$Pe=void 0;class L{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new u.$ee,$=this.b(b.token);return this.a={promise:$,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$Pe=L;class M{constructor(b){this.c=b,this.a=void 0,this.b=void 0}get(b){const $=JSON.stringify(b);return this.b!==$&&(this.b=$,this.a=this.c(b)),this.a}}e.$Qe=M;class P{get cachedValues(){return this.a}constructor(b){this.b=b,this.a=new Map}get(b){if(this.a.has(b))return this.a.get(b);const $=this.b(b);return this.a.set(b,$),$}}e.$Re=P}),define(ke[98],Ee([1,0,13,3]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=M,e.$ge=P,e.$he=R,e.$ie=b,e.$je=y,e.$ke=A,e.$le=I,e.$me=p,e.$ne=E,e.$oe=v,e.$pe=a,e.$qe=m,e.$re=o,e.$se=n,e.$te=i;function M(r){const s=r;return s?typeof s.read=="function":!1}function P(r){const s=r;return s?[s.on,s.pause,s.resume,s.destroy].every(t=>typeof t=="function"):!1}function R(r){const s=r;return s?P(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}function b(r,s){return new $(r,s)}class ${constructor(s,t){this.e=s,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(s){if(!this.a.destroyed){if(this.a.flowing)this.g(s);else if(this.b.data.push(s),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(s){this.a.destroyed||(this.a.flowing?this.h(s):this.b.error.push(s))}end(s){this.a.destroyed||(typeof s<"u"&&this.write(s),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(s){this.c.data.slice(0).forEach(t=>t(s))}h(s){this.c.error.length===0?(0,u.$1)(s):this.c.error.slice(0).forEach(t=>t(s))}i(){this.c.end.slice(0).forEach(s=>s())}on(s,t){if(!this.a.destroyed)switch(s){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(s,t){if(this.a.destroyed)return;let f;switch(s){case"data":f=this.c.data;break;case"end":f=this.c.end;break;case"error":f=this.c.error;break}if(f){const d=f.indexOf(t);d>=0&&f.splice(d,1)}}j(){if(this.b.data.length>0){const s=this.e(this.b.data);this.g(s),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(f=>f())}}k(){if(this.c.error.length>0){for(const s of this.b.error)this.h(s);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function y(r,s){const t=[];let f;for(;(f=r.read())!==null;)t.push(f);return s(t)}function A(r,s,t){const f=[];let d;for(;(d=r.read())!==null&&f.length<t;)f.push(d);return d===null&&f.length>0?s(f):{read:()=>{if(f.length>0)return f.shift();if(typeof d<"u"){const l=d;return d=void 0,l}return r.read()}}}function I(r,s){return new Promise((t,f)=>{const d=[];p(r,{onData:l=>{s&&d.push(l)},onError:l=>{s?f(l):t(void 0)},onEnd:()=>{t(s?s(d):void 0)}})})}function p(r,s,t){r.on("error",f=>{t?.isCancellationRequested||s.onError(f)}),r.on("end",()=>{t?.isCancellationRequested||s.onEnd()}),r.on("data",f=>{t?.isCancellationRequested||s.onData(f)})}function E(r,s){return new Promise((t,f)=>{const d=new L.$Tc,l=[],c=S=>{if(l.push(S),l.length>s)return d.dispose(),r.pause(),t({stream:r,buffer:l,ended:!1})},h=S=>(d.dispose(),f(S)),g=()=>(d.dispose(),t({stream:r,buffer:l,ended:!0}));d.add((0,L.$Sc)(()=>r.removeListener("error",h))),r.on("error",h),d.add((0,L.$Sc)(()=>r.removeListener("end",g))),r.on("end",g),d.add((0,L.$Sc)(()=>r.removeListener("data",c))),r.on("data",c)})}function v(r,s){const t=b(s);return t.end(r),t}function a(){const r=b(()=>{throw new Error("not supported")});return r.end(),r}function m(r){let s=!1;return{read:()=>s?null:(s=!0,r)}}function o(r,s,t){const f=b(t);return p(r,{onData:d=>f.write(s.data(d)),onError:d=>f.error(s.error?s.error(d):d),onEnd:()=>f.end()}),f}function n(r,s,t){let f=!1;return{read:()=>{const d=s.read();return f?d:(f=!0,d!==null?t([r,d]):r)}}}function i(r,s,t){let f=!1;const d=b(t);return p(s,{onData:l=>f?d.write(l):(f=!0,d.write(t([r,l]))),onError:l=>d.error(l),onEnd:()=>{f||(f=!0,d.write(r)),d.end()}}),d}}),define(ke[21],Ee([1,0,45,98]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=void 0,e.$ve=y,e.$we=A,e.$xe=I,e.$ye=p,e.$ze=E,e.$Ae=v,e.$Be=a,e.$Ce=m,e.$De=o,e.$Ee=n,e.$Fe=i,e.$Ge=r,e.$He=s,e.$Ie=t,e.$Je=f,e.$Ke=d,e.$Le=l,e.$Me=c,e.$Ne=h,e.$Oe=w;const M=typeof Buffer<"u",P=new u.$V(()=>new Uint8Array(256));let R,b;class ${static alloc(k){return M?new $(Buffer.allocUnsafe(k)):new $(new Uint8Array(k))}static wrap(k){return M&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new $(k)}static fromString(k,D){return!(D?.dontUseNodeBuffer||!1)&&M?new $(Buffer.from(k)):(R||(R=new TextEncoder),new $(R.encode(k)))}static fromByteArray(k){const D=$.alloc(k.length);for(let O=0,F=k.length;O<F;O++)D.buffer[O]=k[O];return D}static concat(k,D){if(typeof D>"u"){D=0;for(let T=0,z=k.length;T<z;T++)D+=k[T].byteLength}const O=$.alloc(D);let F=0;for(let T=0,z=k.length;T<z;T++){const j=k[T];O.set(j,F),F+=j.byteLength}return O}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=$.alloc(this.byteLength);return k.set(this),k}toString(){return M?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(k,D){return new $(this.buffer.subarray(k,D))}set(k,D){if(k instanceof $)this.buffer.set(k.buffer,D);else if(k instanceof Uint8Array)this.buffer.set(k,D);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),D);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return p(this.buffer,k)}writeUInt32BE(k,D){E(this.buffer,k,D)}readUInt32LE(k){return v(this.buffer,k)}writeUInt32LE(k,D){a(this.buffer,k,D)}readUInt8(k){return m(this.buffer,k)}writeUInt8(k,D){o(this.buffer,k,D)}indexOf(k,D=0){return y(this.buffer,k instanceof $?k.buffer:k,D)}}e.$ue=$;function y(C,k,D=0){const O=k.byteLength,F=C.byteLength;if(O===0)return 0;if(O===1)return C.indexOf(k[0]);if(O>F-D)return-1;const T=P.value;T.fill(k.length);for(let B=0;B<k.length;B++)T[k[B]]=k.length-B-1;let z=D+k.length-1,j=z,N=-1;for(;z<F;)if(C[z]===k[j]){if(j===0){N=z;break}z--,j--}else z+=Math.max(k.length-j,T[C[z]]),j=k.length-1;return N}function A(C,k){return C[k+0]<<0>>>0|C[k+1]<<8>>>0}function I(C,k,D){C[D+0]=k&255,k=k>>>8,C[D+1]=k&255}function p(C,k){return C[k]*2**24+C[k+1]*2**16+C[k+2]*2**8+C[k+3]}function E(C,k,D){C[D+3]=k,k=k>>>8,C[D+2]=k,k=k>>>8,C[D+1]=k,k=k>>>8,C[D]=k}function v(C,k){return C[k+0]<<0>>>0|C[k+1]<<8>>>0|C[k+2]<<16>>>0|C[k+3]<<24>>>0}function a(C,k,D){C[D+0]=k&255,k=k>>>8,C[D+1]=k&255,k=k>>>8,C[D+2]=k&255,k=k>>>8,C[D+3]=k&255}function m(C,k){return C[k]}function o(C,k,D){C[D]=k}function n(C){return L.$je(C,k=>$.concat(k))}function i(C){return L.$qe(C)}function r(C){return L.$le(C,k=>$.concat(k))}async function s(C){return C.ended?$.concat(C.buffer):$.concat([...C.buffer,await r(C.stream)])}function t(C){return L.$oe(C,k=>$.concat(k))}function f(C){return L.$re(C,{data:k=>typeof k=="string"?$.fromString(k):$.wrap(k)},k=>$.concat(k))}function d(C){return L.$ie(k=>$.concat(k),C)}function l(C,k){return L.$se(C,k,D=>$.concat(D))}function c(C,k){return L.$te(C,k,D=>$.concat(D))}function h(C){let k=0,D=0,O=0;const F=new Uint8Array(Math.floor(C.length/4*3)),T=j=>{switch(D){case 3:F[O++]=k|j,D=0;break;case 2:F[O++]=k|j>>>2,k=j<<6,D=3;break;case 1:F[O++]=k|j>>>4,k=j<<4,D=2;break;default:k=j<<2,D=1}};for(let j=0;j<C.length;j++){const N=C.charCodeAt(j);if(N>=65&&N<=90)T(N-65);else if(N>=97&&N<=122)T(N-97+26);else if(N>=48&&N<=57)T(N-48+52);else if(N===43||N===45)T(62);else if(N===47||N===95)T(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${C[j]}`)}}const z=O;for(;D>0;)T(0);return $.wrap(F).slice(0,z)}const g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function w({buffer:C},k=!0,D=!1){const O=D?S:g;let F="";const T=C.byteLength%3;let z=0;for(;z<C.byteLength-T;z+=3){const j=C[z+0],N=C[z+1],B=C[z+2];F+=O[j>>>2],F+=O[(j<<4|N>>>4)&63],F+=O[(N<<2|B>>>6)&63],F+=O[B&63]}if(T===1){const j=C[z+0];F+=O[j>>>2],F+=O[j<<4&63],k&&(F+="==")}else if(T===2){const j=C[z+0],N=C[z+1];F+=O[j>>>2],F+=O[(j<<4|N>>>4)&63],F+=O[N<<2&63],k&&(F+="=")}return F}}),define(ke[14],Ee([1,0,167,45]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uf=e.$Tf=e.$Sf=e.GraphemeBreakType=e.$If=e.$Bf=e.$uf=e.$tf=void 0,e.$Ue=M,e.$Ve=R,e.$We=$,e.$Xe=y,e.$Ye=A,e.$Ze=I,e.$1e=p,e.$2e=E,e.$3e=v,e.$4e=a,e.$5e=m,e.$6e=o,e.$7e=n,e.$8e=i,e.$9e=r,e.$0e=s,e.$$e=t,e.$_e=f,e.$af=d,e.$bf=l,e.$cf=c,e.$df=h,e.$ef=g,e.$ff=S,e.$gf=w,e.$hf=C,e.$if=k,e.$jf=D,e.$kf=O,e.$lf=F,e.$mf=T,e.$nf=z,e.$of=j,e.$pf=N,e.$qf=B,e.$rf=W,e.$sf=Z,e.$vf=re,e.$wf=Y,e.$xf=me,e.$yf=Ce,e.$zf=ie,e.$Af=Se,e.$Cf=ae,e.$Df=ce,e.$Ef=se,e.$Ff=K,e.$Gf=le,e.$Hf=de,e.$Jf=Ae,e.$Kf=$e,e.$Lf=Ie,e.$Mf=Re,e.$Nf=Fe,e.$Of=q,e.$Pf=V,e.$Qf=Q,e.$Rf=He;function M(De){return!De||typeof De!="string"?!0:De.trim().length===0}const P=/{(\d+)}/g;function R(De,...Be){return Be.length===0?De:De.replace(P,function(Ge,Oe){const Qe=parseInt(Oe,10);return isNaN(Qe)||Qe<0||Qe>=Be.length?Ge:Be[Qe]})}const b=/{([^}]+)}/g;function $(De,Be){return Object.keys(Be).length===0?De:De.replace(b,(Ge,Oe)=>Be[Oe]??Ge)}function y(De){return De.replace(/[<>"'&]/g,Be=>{switch(Be){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Be})}function A(De){return De.replace(/[<>&]/g,function(Be){switch(Be){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Be}})}function I(De){return De.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function p(De,Be){let Ge=0;const Oe=Be.charCodeAt(0);for(let Qe=De.length-1;Qe>=0;Qe--)De.charCodeAt(Qe)===Oe&&Ge++;return Ge}function E(De,Be,Ge="\u2026"){return De.length<=Be?De:`${De.substr(0,Be)}${Ge}`}function v(De,Be,Ge="\u2026"){if(De.length<=Be)return De;const Oe=Math.ceil(Be/2)-Ge.length/2,Qe=Math.floor(Be/2)-Ge.length/2;return`${De.substr(0,Oe)}${Ge}${De.substr(De.length-Qe)}`}function a(De,Be=" "){const Ge=m(De,Be);return o(Ge,Be)}function m(De,Be){if(!De||!Be)return De;const Ge=Be.length;if(Ge===0||De.length===0)return De;let Oe=0;for(;De.indexOf(Be,Oe)===Oe;)Oe=Oe+Ge;return De.substring(Oe)}function o(De,Be){if(!De||!Be)return De;const Ge=Be.length,Oe=De.length;if(Ge===0||Oe===0)return De;let Qe=Oe,oe=-1;for(;oe=De.lastIndexOf(Be,Qe-1),!(oe===-1||oe+Ge!==Qe);){if(oe===0)return"";Qe=oe}return De.substring(0,Qe)}function n(De){return De.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function i(De){return De.replace(/\*/g,"")}function r(De,Be,Ge={}){if(!De)throw new Error("Cannot create regex from empty string");Be||(De=I(De)),Ge.wholeWord&&(/\B/.test(De.charAt(0))||(De="\\b"+De),/\B/.test(De.charAt(De.length-1))||(De=De+"\\b"));let Oe="";return Ge.global&&(Oe+="g"),Ge.matchCase||(Oe+="i"),Ge.multiline&&(Oe+="m"),Ge.unicode&&(Oe+="u"),new RegExp(De,Oe)}function s(De){return De.source==="^"||De.source==="^$"||De.source==="$"||De.source==="^\\s*$"?!1:!!(De.exec("")&&De.lastIndex===0)}function t(De){return De.split(/\r\n|\r|\n/)}function f(De){const Be=[],Ge=De.split(/(\r\n|\r|\n)/);for(let Oe=0;Oe<Math.ceil(Ge.length/2);Oe++)Be.push(Ge[2*Oe]+(Ge[2*Oe+1]??""));return Be}function d(De){for(let Be=0,Ge=De.length;Be<Ge;Be++){const Oe=De.charCodeAt(Be);if(Oe!==32&&Oe!==9)return Be}return-1}function l(De,Be=0,Ge=De.length){for(let Oe=Be;Oe<Ge;Oe++){const Qe=De.charCodeAt(Oe);if(Qe!==32&&Qe!==9)return De.substring(Be,Oe)}return De.substring(Be,Ge)}function c(De,Be=De.length-1){for(let Ge=Be;Ge>=0;Ge--){const Oe=De.charCodeAt(Ge);if(Oe!==32&&Oe!==9)return Ge}return-1}function h(De,Be,Ge){const Oe=[];let Qe=0;for(const oe of De.matchAll(Be)){if(Oe.push(De.slice(Qe,oe.index)),oe.index===void 0)throw new Error("match.index should be defined");Qe=oe.index+oe[0].length,Oe.push(Ge(oe[0],...oe.slice(1),oe.index,De,oe.groups))}return Oe.push(De.slice(Qe)),Promise.all(Oe).then(oe=>oe.join(""))}function g(De,Be){return De<Be?-1:De>Be?1:0}function S(De,Be,Ge=0,Oe=De.length,Qe=0,oe=Be.length){for(;Ge<Oe&&Qe<oe;Ge++,Qe++){const Ke=De.charCodeAt(Ge),_e=Be.charCodeAt(Qe);if(Ke<_e)return-1;if(Ke>_e)return 1}const ue=Oe-Ge,Pe=oe-Qe;return ue<Pe?-1:ue>Pe?1:0}function w(De,Be){return C(De,Be,0,De.length,0,Be.length)}function C(De,Be,Ge=0,Oe=De.length,Qe=0,oe=Be.length){for(;Ge<Oe&&Qe<oe;Ge++,Qe++){let Ke=De.charCodeAt(Ge),_e=Be.charCodeAt(Qe);if(Ke===_e)continue;if(Ke>=128||_e>=128)return S(De.toLowerCase(),Be.toLowerCase(),Ge,Oe,Qe,oe);D(Ke)&&(Ke-=32),D(_e)&&(_e-=32);const Ne=Ke-_e;if(Ne!==0)return Ne}const ue=Oe-Ge,Pe=oe-Qe;return ue<Pe?-1:ue>Pe?1:0}function k(De){return De>=48&&De<=57}function D(De){return De>=97&&De<=122}function O(De){return De>=65&&De<=90}function F(De,Be){return De.length===Be.length&&C(De,Be)===0}function T(De,Be){const Ge=Be.length;return Be.length>De.length?!1:C(De,Be,0,Ge)===0}function z(De,Be){const Ge=Math.min(De.length,Be.length);let Oe;for(Oe=0;Oe<Ge;Oe++)if(De.charCodeAt(Oe)!==Be.charCodeAt(Oe))return Oe;return Ge}function j(De,Be){const Ge=Math.min(De.length,Be.length);let Oe;const Qe=De.length-1,oe=Be.length-1;for(Oe=0;Oe<Ge;Oe++)if(De.charCodeAt(Qe-Oe)!==Be.charCodeAt(oe-Oe))return Oe;return Ge}function N(De){return 55296<=De&&De<=56319}function B(De){return 56320<=De&&De<=57343}function W(De,Be){return(De-55296<<10)+(Be-56320)+65536}function Z(De,Be,Ge){const Oe=De.charCodeAt(Ge);if(N(Oe)&&Ge+1<Be){const Qe=De.charCodeAt(Ge+1);if(B(Qe))return W(Oe,Qe)}return Oe}function _(De,Be){const Ge=De.charCodeAt(Be-1);if(B(Ge)&&Be>1){const Oe=De.charCodeAt(Be-2);if(N(Oe))return W(Oe,Ge)}return Ge}class X{get offset(){return this.e}constructor(Be,Ge=0){this.c=Be,this.d=Be.length,this.e=Ge}setOffset(Be){this.e=Be}prevCodePoint(){const Be=_(this.c,this.e);return this.e-=Be>=65536?2:1,Be}nextCodePoint(){const Be=Z(this.c,this.d,this.e);return this.e+=Be>=65536?2:1,Be}eol(){return this.e>=this.d}}e.$tf=X;class x{get offset(){return this.c.offset}constructor(Be,Ge=0){this.c=new X(Be,Ge)}nextGraphemeLength(){const Be=we.getInstance(),Ge=this.c,Oe=Ge.offset;let Qe=Be.getGraphemeBreakType(Ge.nextCodePoint());for(;!Ge.eol();){const oe=Ge.offset,ue=Be.getGraphemeBreakType(Ge.nextCodePoint());if(J(Qe,ue)){Ge.setOffset(oe);break}Qe=ue}return Ge.offset-Oe}prevGraphemeLength(){const Be=we.getInstance(),Ge=this.c,Oe=Ge.offset;let Qe=Be.getGraphemeBreakType(Ge.prevCodePoint());for(;Ge.offset>0;){const oe=Ge.offset,ue=Be.getGraphemeBreakType(Ge.prevCodePoint());if(J(ue,Qe)){Ge.setOffset(oe);break}Qe=ue}return Oe-Ge.offset}eol(){return this.c.eol()}}e.$uf=x;function re(De,Be){return new x(De,Be).nextGraphemeLength()}function Y(De,Be){return new x(De,Be).prevGraphemeLength()}function me(De,Be){Be>0&&B(De.charCodeAt(Be))&&Be--;const Ge=Be+re(De,Be);return[Ge-Y(De,Ge),Ge]}function Ce(De){const Be=new x(De);let Ge=0;for(;!Be.eol();)Ge++,Be.nextGraphemeLength();return Ge}let ee;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ie(De){return ee||(ee=U()),ee.test(De)}const be=/^[\t\n\r\x20-\x7E]*$/;function Se(De){return be.test(De)}e.$Bf=/[\u2028\u2029]/;function ae(De){return e.$Bf.test(De)}function ce(De){return De>=11904&&De<=55215||De>=63744&&De<=64255||De>=65281&&De<=65374}function se(De){return De>=127462&&De<=127487||De===8986||De===8987||De===9200||De===9203||De>=9728&&De<=10175||De===11088||De===11093||De>=127744&&De<=128591||De>=128640&&De<=128764||De>=128992&&De<=129008||De>=129280&&De<=129535||De>=129648&&De<=129782}function K(De,Be,Ge=""){const Oe=De.trimStart();if(Oe.length<Be)return Oe;const Qe=/\b/g;let oe=0;for(;Qe.test(Oe)&&!(Oe.length-Qe.lastIndex<Be);)oe=Qe.lastIndex,Qe.lastIndex+=1;return oe===0?Oe:Ge+Oe.substring(oe).trimStart()}const te=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*le(De){let Be=0;for(const Ge of De.matchAll(te))Be!==Ge.index&&(yield{isCode:!1,str:De.substring(Be,Ge.index)}),yield{isCode:!0,str:Ge[0]},Be=Ge.index+Ge[0].length;Be!==De.length&&(yield{isCode:!1,str:De.substring(Be)})}function de(De){return De&&(De=De.replace(te,"")),De}e.$If="\uFEFF";function Ae(De){return!!(De&&De.length>0&&De.charCodeAt(0)===65279)}function $e(De){return Ae(De)?De.substr(1):De}function Ie(De,Be){if(!De||!Be||De.length<Be.length)return!1;const Ge=Be.length,Oe=De.toLowerCase();let Qe=0,oe=-1;for(;Qe<Ge;){const ue=Oe.indexOf(Be[Qe],oe+1);if(ue<0)return!1;oe=ue,Qe++}return!0}function Re(De,Be=!1){return De?(Be&&(De=De.replace(/\\./g,"")),De.toLowerCase()!==De):!1}function Fe(De){return De.charAt(0).toUpperCase()+De.slice(1)}function q(De,Be=1){if(Be===0)return"";let Ge=-1;do Ge=De.indexOf(`
`,Ge+1),Be--;while(Be>0&&Ge>=0);return Ge===-1?De:(De[Ge-1]==="\r"&&Ge--,De.substr(0,Ge))}function V(De){return De=De%(2*26),De<26?String.fromCharCode(97+De):String.fromCharCode(65+De-26)}function Q(De){return we.getInstance().getGraphemeBreakType(De)}function J(De,Be){return De===0?Be!==5&&Be!==7:De===2&&Be===3?!1:De===4||De===2||De===3||Be===4||Be===2||Be===3?!0:!(De===8&&(Be===8||Be===9||Be===11||Be===12)||(De===11||De===9)&&(Be===9||Be===10)||(De===12||De===10)&&Be===10||Be===5||Be===13||Be===7||De===1||De===13&&Be===14||De===6&&Be===6)}var fe;(function(De){De[De.Other=0]="Other",De[De.Prepend=1]="Prepend",De[De.CR=2]="CR",De[De.LF=3]="LF",De[De.Control=4]="Control",De[De.Extend=5]="Extend",De[De.Regional_Indicator=6]="Regional_Indicator",De[De.SpacingMark=7]="SpacingMark",De[De.L=8]="L",De[De.V=9]="V",De[De.T=10]="T",De[De.LV=11]="LV",De[De.LVT=12]="LVT",De[De.ZWJ=13]="ZWJ",De[De.Extended_Pictographic=14]="Extended_Pictographic"})(fe||(e.GraphemeBreakType=fe={}));class we{static{this.c=null}static getInstance(){return we.c||(we.c=new we),we.c}constructor(){this.d=Te()}getGraphemeBreakType(Be){if(Be<32)return Be===10?3:Be===13?2:4;if(Be<127)return 0;const Ge=this.d,Oe=Ge.length/3;let Qe=1;for(;Qe<=Oe;)if(Be<Ge[3*Qe])Qe=2*Qe;else if(Be>Ge[3*Qe+1])Qe=2*Qe+1;else return Ge[3*Qe+2];return 0}}function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(De,Be){if(De===0)return 0;const Ge=xe(De,Be);if(Ge!==void 0)return Ge;const Oe=new X(Be,De);return Oe.prevCodePoint(),Oe.offset}function xe(De,Be){const Ge=new X(Be,De);let Oe=Ge.prevCodePoint();for(;it(Oe)||Oe===65039||Oe===8419;){if(Ge.offset===0)return;Oe=Ge.prevCodePoint()}if(!se(Oe))return;let Qe=Ge.offset;return Qe>0&&Ge.prevCodePoint()===8205&&(Qe=Ge.offset),Qe}function it(De){return 127995<=De&&De<=127999}var rt;(function(De){De[De.zwj=8205]="zwj",De[De.emojiVariantSelector=65039]="emojiVariantSelector",De[De.enclosingKeyCap=8419]="enclosingKeyCap"})(rt||(rt={})),e.$Sf="\xA0";class at{static{this.c=new L.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new u.$Qe(Be=>{function Ge(Ne){const lt=new Map;for(let wt=0;wt<Ne.length;wt+=2)lt.set(Ne[wt],Ne[wt+1]);return lt}function Oe(Ne,lt){const wt=new Map(Ne);for(const[At,zt]of lt)wt.set(At,zt);return wt}function Qe(Ne,lt){if(!Ne)return lt;const wt=new Map;for(const[At,zt]of Ne)lt.has(At)&&wt.set(At,zt);return wt}const oe=this.c.value;let ue=Be.filter(Ne=>!Ne.startsWith("_")&&Ne in oe);ue.length===0&&(ue=["_default"]);let Pe;for(const Ne of ue){const lt=Ge(oe[Ne]);Pe=Qe(Pe,lt)}const Ke=Ge(oe._common),_e=Oe(Ke,Pe);return new at(_e)})}static getInstance(Be){return at.d.get(Array.from(Be))}static{this.e=new L.$V(()=>Object.keys(at.c.value).filter(Be=>!Be.startsWith("_")))}static getLocales(){return at.e.value}constructor(Be){this.f=Be}isAmbiguous(Be){return this.f.has(Be)}getPrimaryConfusable(Be){return this.f.get(Be)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Tf=at;class ot{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(ot.c())),this.d}static isInvisibleCharacter(Be){return ot.e().has(Be)}static get codePoints(){return ot.e()}}e.$Uf=ot}),define(ke[126],Ee([1,0,27,165,14]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.FuzzyScore=e.$kk=e.$jk=void 0,e.or=P,e.$lk=b,e.$mk=$,e.$nk=I,e.$ok=h,e.$pk=g,e.$qk=O,e.$rk=F,e.$sk=T,e.$tk=z,e.$uk=ie,e.$wk=ce,e.$xk=te,e.$yk=le;function P(...$e){return function(Ie,Re){for(let Fe=0,q=$e.length;Fe<q;Fe++){const V=$e[Fe](Ie,Re);if(V)return V}return null}}e.$jk=R.bind(void 0,!1),e.$kk=R.bind(void 0,!0);function R($e,Ie,Re){if(!Re||Re.length<Ie.length)return null;let Fe;return $e?Fe=M.$mf(Re,Ie):Fe=Re.indexOf(Ie)===0,Fe?Ie.length>0?[{start:0,end:Ie.length}]:[]:null}function b($e,Ie){const Re=Ie.toLowerCase().indexOf($e.toLowerCase());return Re===-1?null:[{start:Re,end:Re+$e.length}]}function $($e,Ie){return y($e.toLowerCase(),Ie.toLowerCase(),0,0)}function y($e,Ie,Re,Fe){if(Re===$e.length)return[];if(Fe===Ie.length)return null;if($e[Re]===Ie[Fe]){let q=null;return(q=y($e,Ie,Re+1,Fe+1))?r({start:Fe,end:Fe+1},q):null}return y($e,Ie,Re,Fe+1)}function A($e){return 97<=$e&&$e<=122}function I($e){return 65<=$e&&$e<=90}function p($e){return 48<=$e&&$e<=57}function E($e){return $e===32||$e===9||$e===10||$e===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach($e=>v.add($e.charCodeAt(0)));function a($e){return E($e)||v.has($e)}function m($e,Ie){return $e===Ie||a($e)&&a(Ie)}const o=new Map;function n($e){if(o.has($e))return o.get($e);let Ie;const Re=(0,L.$hk)($e);return Re&&(Ie=Re),o.set($e,Ie),Ie}function i($e){return A($e)||I($e)||p($e)}function r($e,Ie){return Ie.length===0?Ie=[$e]:$e.end===Ie[0].start?Ie[0].start=$e.start:Ie.unshift($e),Ie}function s($e,Ie){for(let Re=Ie;Re<$e.length;Re++){const Fe=$e.charCodeAt(Re);if(I(Fe)||p(Fe)||Re>0&&!i($e.charCodeAt(Re-1)))return Re}return $e.length}function t($e,Ie,Re,Fe){if(Re===$e.length)return[];if(Fe===Ie.length)return null;if($e[Re]!==Ie[Fe].toLowerCase())return null;{let q=null,V=Fe+1;for(q=t($e,Ie,Re+1,Fe+1);!q&&(V=s(Ie,V))<Ie.length;)q=t($e,Ie,Re+1,V),V++;return q===null?null:r({start:Fe,end:Fe+1},q)}}function f($e){let Ie=0,Re=0,Fe=0,q=0,V=0;for(let Te=0;Te<$e.length;Te++)V=$e.charCodeAt(Te),I(V)&&Ie++,A(V)&&Re++,i(V)&&Fe++,p(V)&&q++;const Q=Ie/$e.length,J=Re/$e.length,fe=Fe/$e.length,we=q/$e.length;return{upperPercent:Q,lowerPercent:J,alphaPercent:fe,numericPercent:we}}function d($e){const{upperPercent:Ie,lowerPercent:Re}=$e;return Re===0&&Ie>.6}function l($e){const{upperPercent:Ie,lowerPercent:Re,alphaPercent:Fe,numericPercent:q}=$e;return Re>.2&&Ie<.8&&Fe>.6&&q<.2}function c($e){let Ie=0,Re=0,Fe=0,q=0;for(let V=0;V<$e.length;V++)Fe=$e.charCodeAt(V),I(Fe)&&Ie++,A(Fe)&&Re++,E(Fe)&&q++;return(Ie===0||Re===0)&&q===0?$e.length<=30:Ie<=5}function h($e,Ie){if(!Ie||(Ie=Ie.trim(),Ie.length===0)||!c($e))return null;Ie.length>60&&(Ie=Ie.substring(0,60));const Re=f(Ie);if(!l(Re)){if(!d(Re))return null;Ie=Ie.toLowerCase()}let Fe=null,q=0;for($e=$e.toLowerCase();q<Ie.length&&(Fe=t($e,Ie,0,q))===null;)q=s(Ie,q+1);return Fe}function g($e,Ie,Re=!1){if(!Ie||Ie.length===0)return null;let Fe=null,q=0;for($e=$e.toLowerCase(),Ie=Ie.toLowerCase();q<Ie.length&&(Fe=S($e,Ie,0,q,Re),Fe===null);)q=w(Ie,q+1);return Fe}function S($e,Ie,Re,Fe,q){let V=0;if(Re===$e.length)return[];if(Fe===Ie.length)return null;if(!m($e.charCodeAt(Re),Ie.charCodeAt(Fe))){const fe=n($e.charCodeAt(Re));if(!fe)return null;for(let we=0;we<fe.length;we++)if(!m(fe[we],Ie.charCodeAt(Fe+we)))return null;V+=fe.length-1}let Q=null,J=Fe+V+1;if(Q=S($e,Ie,Re+1,J,q),!q)for(;!Q&&(J=w(Ie,J))<Ie.length;)Q=S($e,Ie,Re+1,J,q),J++;if(!Q)return null;if($e.charCodeAt(Re)!==Ie.charCodeAt(Fe)){const fe=n($e.charCodeAt(Re));if(!fe)return Q;for(let we=0;we<fe.length;we++)if(fe[we]!==Ie.charCodeAt(Fe+we))return Q}return r({start:Fe,end:Fe+V+1},Q)}function w($e,Ie){for(let Re=Ie;Re<$e.length;Re++)if(a($e.charCodeAt(Re))||Re>0&&a($e.charCodeAt(Re-1)))return Re;return $e.length}const C=P(e.$kk,h,b),k=P(e.$kk,h,$),D=new u.$Ec(1e4);function O($e,Ie,Re=!1){if(typeof $e!="string"||typeof Ie!="string")return null;let Fe=D.get($e);Fe||(Fe=new RegExp(M.$7e($e),"i"),D.set($e,Fe));const q=Fe.exec(Ie);return q?[{start:q.index,end:q.index+q[0].length}]:Re?k($e,Ie):C($e,Ie)}function F($e,Ie){const Re=ce($e,$e.toLowerCase(),0,Ie,Ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Re?z(Re):null}function T($e,Ie,Re,Fe,q,V){const Q=Math.min(13,$e.length);for(;Re<Q;Re++){const J=ce($e,Ie,Re,Fe,q,V,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(J)return J}return[0,V]}function z($e){if(typeof $e>"u")return[];const Ie=[],Re=$e[1];for(let Fe=$e.length-1;Fe>1;Fe--){const q=$e[Fe]+Re,V=Ie[Ie.length-1];V&&V.end===q?V.end=q+1:Ie.push({start:q,end:q+1})}return Ie}const j=128;function N(){const $e=[],Ie=[];for(let Re=0;Re<=j;Re++)Ie[Re]=0;for(let Re=0;Re<=j;Re++)$e.push(Ie.slice(0));return $e}function B($e){const Ie=[];for(let Re=0;Re<=$e;Re++)Ie[Re]=0;return Ie}const W=B(2*j),Z=B(2*j),_=N(),X=N(),x=N(),re=!1;function Y($e,Ie,Re,Fe,q){function V(J,fe,we=" "){for(;J.length<fe;)J=we+J;return J}let Q=` |   |${Fe.split("").map(J=>V(J,3)).join("|")}
`;for(let J=0;J<=Re;J++)J===0?Q+=" |":Q+=`${Ie[J-1]}|`,Q+=$e[J].slice(0,q+1).map(fe=>V(fe.toString(),3)).join("|")+`
`;return Q}function me($e,Ie,Re,Fe){$e=$e.substr(Ie),Re=Re.substr(Fe),console.log(Y(X,$e,$e.length,Re,Re.length)),console.log(Y(x,$e,$e.length,Re,Re.length)),console.log(Y(_,$e,$e.length,Re,Re.length))}function Ce($e,Ie){if(Ie<0||Ie>=$e.length)return!1;const Re=$e.codePointAt(Ie);switch(Re){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!M.$Ef(Re)}}function ee($e,Ie){if(Ie<0||Ie>=$e.length)return!1;switch($e.charCodeAt(Ie)){case 32:case 9:return!0;default:return!1}}function U($e,Ie,Re){return Ie[$e]!==Re[$e]}function ie($e,Ie,Re,Fe,q,V,Q=!1){for(;Ie<Re&&q<V;)$e[Ie]===Fe[q]&&(Q&&(W[Ie]=q),Ie+=1),q+=1;return Ie===Re}var be;(function($e){$e[$e.Diag=1]="Diag",$e[$e.Left=2]="Left",$e[$e.LeftLeft=3]="LeftLeft"})(be||(be={}));var Se;(function($e){$e.Default=[-100,0];function Ie(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}$e.isDefault=Ie})(Se||(e.FuzzyScore=Se={}));class ae{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ie,Re){this.firstMatchCanBeWeak=Ie,this.boostFullMatch=Re}}e.$vk=ae;function ce($e,Ie,Re,Fe,q,V,Q=ae.default){const J=$e.length>j?j:$e.length,fe=Fe.length>j?j:Fe.length;if(Re>=J||V>=fe||J-Re>fe-V||!ie(Ie,Re,J,q,V,fe,!0))return;se(J,fe,Re,V,Ie,q);let we=1,Te=1,He=Re,xe=V;const it=[!1];for(we=1,He=Re;He<J;we++,He++){const Be=W[He],Ge=Z[He],Oe=He+1<J?Z[He+1]:fe;for(Te=Be-V+1,xe=Be;xe<Oe;Te++,xe++){let Qe=Number.MIN_SAFE_INTEGER,oe=!1;xe<=Ge&&(Qe=K($e,Ie,He,Re,Fe,q,xe,fe,V,_[we-1][Te-1]===0,it));let ue=0;Qe!==Number.MAX_SAFE_INTEGER&&(oe=!0,ue=Qe+X[we-1][Te-1]);const Pe=xe>Be,Ke=Pe?X[we][Te-1]+(_[we][Te-1]>0?-5:0):0,_e=xe>Be+1&&_[we][Te-1]>0,Ne=_e?X[we][Te-2]+(_[we][Te-2]>0?-5:0):0;if(_e&&(!Pe||Ne>=Ke)&&(!oe||Ne>=ue))X[we][Te]=Ne,x[we][Te]=3,_[we][Te]=0;else if(Pe&&(!oe||Ke>=ue))X[we][Te]=Ke,x[we][Te]=2,_[we][Te]=0;else if(oe)X[we][Te]=ue,x[we][Te]=1,_[we][Te]=_[we-1][Te-1]+1;else throw new Error("not possible")}}if(re&&me($e,Re,Fe,V),!it[0]&&!Q.firstMatchCanBeWeak)return;we--,Te--;const rt=[X[we][Te],V];let at=0,ot=0;for(;we>=1;){let Be=Te;do{const Ge=x[we][Be];if(Ge===3)Be=Be-2;else if(Ge===2)Be=Be-1;else break}while(Be>=1);at>1&&Ie[Re+we-1]===q[V+Te-1]&&!U(Be+V-1,Fe,q)&&at+1>_[we][Be]&&(Be=Te),Be===Te?at++:at=1,ot||(ot=Be),we--,Te=Be-1,rt.push(Te)}fe===J&&Q.boostFullMatch&&(rt[0]+=2);const De=ot-J;return rt[0]-=De,rt}function se($e,Ie,Re,Fe,q,V){let Q=$e-1,J=Ie-1;for(;Q>=Re&&J>=Fe;)q[Q]===V[J]&&(Z[Q]=J,Q--),J--}function K($e,Ie,Re,Fe,q,V,Q,J,fe,we,Te){if(Ie[Re]!==V[Q])return Number.MIN_SAFE_INTEGER;let He=1,xe=!1;return Q===Re-Fe?He=$e[Re]===q[Q]?7:5:U(Q,q,V)&&(Q===0||!U(Q-1,q,V))?(He=$e[Re]===q[Q]?7:5,xe=!0):Ce(V,Q)&&(Q===0||!Ce(V,Q-1))?He=5:(Ce(V,Q-1)||ee(V,Q-1))&&(He=5,xe=!0),He>1&&Re===Fe&&(Te[0]=!0),xe||(xe=U(Q,q,V)||Ce(V,Q-1)||ee(V,Q-1)),Re===Fe?Q>fe&&(He-=xe?3:5):we?He+=xe?2:0:He+=xe?0:1,Q+1===J&&(He-=xe?3:5),He}function te($e,Ie,Re,Fe,q,V,Q){return de($e,Ie,Re,Fe,q,V,!0,Q)}function le($e,Ie,Re,Fe,q,V,Q){return de($e,Ie,Re,Fe,q,V,!1,Q)}function de($e,Ie,Re,Fe,q,V,Q,J){let fe=ce($e,Ie,Re,Fe,q,V,J);if(fe&&!Q)return fe;if($e.length>=3){const we=Math.min(7,$e.length-1);for(let Te=Re+1;Te<we;Te++){const He=Ae($e,Te);if(He){const xe=ce(He,He.toLowerCase(),Re,Fe,q,V,J);xe&&(xe[0]-=3,(!fe||xe[0]>fe[0])&&(fe=xe))}}}return fe}function Ae($e,Ie){if(Ie+1>=$e.length)return;const Re=$e[Ie],Fe=$e[Ie+1];if(Re!==Fe)return $e.slice(0,Ie)+Fe+Re+$e.slice(Ie+2)}}),define(ke[55],Ee([1,0,14]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cj=e.$aj=void 0,e.$9i=L,e.$0i=M,e.$$i=P,e.$_i=b,e.$bj=a;function L(o){return M(o,0)}function M(o,n){switch(typeof o){case"object":return o===null?P(349,n):Array.isArray(o)?$(o,n):y(o,n);case"string":return b(o,n);case"boolean":return R(o,n);case"number":return P(o,n);case"undefined":return P(937,n);default:return P(617,n)}}function P(o,n){return(n<<5)-n+o|0}function R(o,n){return P(o?433:863,n)}function b(o,n){n=P(149417,n);for(let i=0,r=o.length;i<r;i++)n=P(o.charCodeAt(i),n);return n}function $(o,n){return n=P(104579,n),o.reduce((i,r)=>M(r,i),n)}function y(o,n){return n=P(181387,n),Object.keys(o).sort().reduce((i,r)=>(i=b(r,i),M(o[r],i)),n)}class A{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=M(n,this.g),this.g}}e.$aj=A;var I;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function p(o,n,i=32){const r=i-n,s=~((1<<r)-1);return(o<<n|(s&o)>>>r)>>>0}function E(o,n=0,i=o.byteLength,r=0){for(let s=0;s<i;s++)o[n+s]=r}function v(o,n,i="0"){for(;o.length<n;)o=i+o;return o}function a(o,n=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(i=>i.toString(16).padStart(2,"0")).join(""):v((o>>>0).toString(16),n/4)}class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const i=n.length;if(i===0)return;const r=this.p;let s=this.r,t=this.u,f,d;for(t!==0?(f=t,d=-1,t=0):(f=n.charCodeAt(0),d=0);;){let l=f;if(u.$pf(f))if(d+1<i){const c=n.charCodeAt(d+1);u.$qf(c)?(d++,l=u.$rf(f,c)):l=65533}else{t=f;break}else u.$qf(f)&&(l=65533);if(s=this.w(r,s,l),d++,d<i)f=n.charCodeAt(d);else break}this.r=s,this.u=t}w(n,i,r){return r<128?n[i++]=r:r<2048?(n[i++]=192|(r&1984)>>>6,n[i++]=128|(r&63)>>>0):r<65536?(n[i++]=224|(r&61440)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0):(n[i++]=240|(r&1835008)>>>18,n[i++]=128|(r&258048)>>>12,n[i++]=128|(r&4032)>>>6,n[i++]=128|(r&63)>>>0),i>=64&&(this.y(),i-=64,this.t+=64,n[0]=n[64],n[1]=n[65],n[2]=n[66]),i}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),a(this.h)+a(this.l)+a(this.m)+a(this.n)+a(this.o)}x(){this.p[this.r++]=128,E(this.p,this.r),this.r>56&&(this.y(),E(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=m.g,i=this.q;for(let g=0;g<64;g+=4)n.setUint32(g,i.getUint32(g,!1),!1);for(let g=64;g<320;g+=4)n.setUint32(g,p(n.getUint32(g-12,!1)^n.getUint32(g-32,!1)^n.getUint32(g-56,!1)^n.getUint32(g-64,!1),1),!1);let r=this.h,s=this.l,t=this.m,f=this.n,d=this.o,l,c,h;for(let g=0;g<80;g++)g<20?(l=s&t|~s&f,c=1518500249):g<40?(l=s^t^f,c=1859775393):g<60?(l=s&t|s&f|t&f,c=2400959708):(l=s^t^f,c=3395469782),h=p(r,5)+l+d+c+n.getUint32(g*4,!1)&4294967295,d=f,f=t,t=p(s,30),s=r,r=h;this.h=this.h+r&4294967295,this.l=this.l+s&4294967295,this.m=this.m+t&4294967295,this.n=this.n+f&4294967295,this.o=this.o+d&4294967295}}e.$cj=m}),define(ke[40],Ee([1,0,14]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(M){M[M.Ignore=0]="Ignore",M[M.Info=1]="Info",M[M.Warning=2]="Warning",M[M.Error=3]="Error"})(L||(L={})),function(M){const P="error",R="warning",b="warn",$="info",y="ignore";function A(p){return p?u.$lf(P,p)?M.Error:u.$lf(R,p)||u.$lf(b,p)?M.Warning:u.$lf($,p)?M.Info:M.Ignore:M.Ignore}M.fromValue=A;function I(p){switch(p){case M.Error:return P;case M.Warning:return R;case M.Info:return $;default:return y}}M.toString=I}(L||(L={})),e.default=L}),define(ke[168],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=void 0,e.$4d=Symbol("MicrotaskDelay")}),define(ke[77],Ee([1,0,19,14]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.$ki=void 0;class M{constructor(){this.b="",this.c=0}reset(E){return this.b=E,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(E){const v=E.charCodeAt(0),a=this.b.charCodeAt(this.c);return v-a}value(){return this.b[this.c]}}e.$ki=M;class P{constructor(E=!0){this.e=E}reset(E){return this.b=E,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let E=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(E)this.c++;else break;else E=!1;return this}cmp(E){return this.e?(0,L.$ff)(E,this.b,0,E.length,this.c,this.d):(0,L.$hf)(E,this.b,0,E.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$li=P;class R{constructor(E=!0,v=!0){this.f=E,this.g=v}reset(E){this.d=0,this.e=0,this.b=E,this.c=E.length;for(let v=E.length-1;v>=0;v--,this.c--){const a=this.b.charCodeAt(v);if(!(a===47||this.f&&a===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let E=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(E)this.d++;else break;else E=!1}return this}cmp(E){return this.g?(0,L.$ff)(E,this.b,0,E.length,this.d,this.e):(0,L.$hf)(E,this.b,0,E.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$mi=R;var b;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(b||(b={}));class ${constructor(E,v){this.f=E,this.g=v,this.d=[],this.e=0}reset(E){return this.c=E,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(E)),this.b.reset(E.path),this.b.value()&&this.d.push(3)),this.g(E)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(E){if(this.d[this.e]===1)return(0,L.$gf)(E,this.c.scheme);if(this.d[this.e]===2)return(0,L.$gf)(E,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(E);if(this.d[this.e]===4)return(0,L.$ef)(E,this.c.query);if(this.d[this.e]===5)return(0,L.$ef)(E,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ni=$;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const E=this.right;return this.right=E.left,E.left=this,this.updateHeight(),E.updateHeight(),E}rotateRight(){const E=this.left;return this.left=E.right,E.right=this,this.updateHeight(),E.updateHeight(),E}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(A||(A={}));class I{static forUris(E=()=>!1,v=()=>!1){return new I(new $(E,v))}static forPaths(E=!1){return new I(new R(void 0,!E))}static forStrings(){return new I(new M)}static forConfigKeys(){return new I(new P)}constructor(E){this.b=E}clear(){this.c=void 0}fill(E,v){if(v){const a=v.slice(0);(0,u.$Xb)(a);for(const m of a)this.set(m,E)}else{const a=E.slice(0);(0,u.$Xb)(a);for(const m of a)this.set(m[0],m[1])}}set(E,v){const a=this.b.reset(E);let m;this.c||(this.c=new y,this.c.segment=a.value());const o=[];for(m=this.c;;){const i=a.cmp(m.segment);if(i>0)m.left||(m.left=new y,m.left.segment=a.value()),o.push([-1,m]),m=m.left;else if(i<0)m.right||(m.right=new y,m.right.segment=a.value()),o.push([1,m]),m=m.right;else if(a.hasNext())a.next(),m.mid||(m.mid=new y,m.mid.segment=a.value()),o.push([0,m]),m=m.mid;else break}const n=m.value;m.value=v,m.key=E;for(let i=o.length-1;i>=0;i--){const r=o[i][1];r.updateHeight();const s=r.balanceFactor();if(s<-1||s>1){const t=o[i][0],f=o[i+1][0];if(t===1&&f===1)o[i][1]=r.rotateLeft();else if(t===-1&&f===-1)o[i][1]=r.rotateRight();else if(t===1&&f===-1)r.right=o[i+1][1]=o[i+1][1].rotateRight(),o[i][1]=r.rotateLeft();else if(t===-1&&f===1)r.left=o[i+1][1]=o[i+1][1].rotateLeft(),o[i][1]=r.rotateRight();else throw new Error;if(i>0)switch(o[i-1][0]){case-1:o[i-1][1].left=o[i][1];break;case 1:o[i-1][1].right=o[i][1];break;case 0:o[i-1][1].mid=o[i][1];break}else this.c=o[0][1]}}return n}get(E){return this.d(E)?.value}d(E){const v=this.b.reset(E);let a=this.c;for(;a;){const m=v.cmp(a.segment);if(m>0)a=a.left;else if(m<0)a=a.right;else if(v.hasNext())v.next(),a=a.mid;else break}return a}has(E){const v=this.d(E);return!(v?.value===void 0&&v?.mid===void 0)}delete(E){return this.e(E,!1)}deleteSuperstr(E){return this.e(E,!0)}e(E,v){const a=this.b.reset(E),m=[];let o=this.c;for(;o;){const n=a.cmp(o.segment);if(n>0)m.push([-1,o]),o=o.left;else if(n<0)m.push([1,o]),o=o.right;else if(a.hasNext())a.next(),m.push([0,o]),o=o.mid;else break}if(o){if(v?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const n=this.f(o.right);if(n.key){const{key:i,value:r,segment:s}=n;this.e(n.key,!1),o.key=i,o.value=r,o.segment=s}}else{const n=o.left??o.right;if(m.length>0){const[i,r]=m[m.length-1];switch(i){case-1:r.left=n;break;case 0:r.mid=n;break;case 1:r.right=n;break}}else this.c=n}for(let n=m.length-1;n>=0;n--){const i=m[n][1];i.updateHeight();const r=i.balanceFactor();if(r>1?(i.right.balanceFactor()>=0||(i.right=i.right.rotateRight()),m[n][1]=i.rotateLeft()):r<-1&&(i.left.balanceFactor()<=0||(i.left=i.left.rotateLeft()),m[n][1]=i.rotateRight()),n>0)switch(m[n-1][0]){case-1:m[n-1][1].left=m[n][1];break;case 1:m[n-1][1].right=m[n][1];break;case 0:m[n-1][1].mid=m[n][1];break}else this.c=m[0][1]}}}f(E){for(;E.left;)E=E.left;return E}findSubstr(E){const v=this.b.reset(E);let a=this.c,m;for(;a;){const o=v.cmp(a.segment);if(o>0)a=a.left;else if(o<0)a=a.right;else if(v.hasNext())v.next(),m=a.value||m,a=a.mid;else break}return a&&a.value||m}findSuperstr(E){return this.g(E,!1)}g(E,v){const a=this.b.reset(E);let m=this.c;for(;m;){const o=a.cmp(m.segment);if(o>0)m=m.left;else if(o<0)m=m.right;else if(a.hasNext())a.next(),m=m.mid;else return m.mid?this.h(m.mid):v?m.value:void 0}}hasElementOrSubtree(E){return this.g(E,!0)!==void 0}forEach(E){for(const[v,a]of this)E(a,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(E){const v=[];return this.j(E,v),v[Symbol.iterator]()}j(E,v){E&&(E.left&&this.j(E.left,v),E.value&&v.push([E.key,E.value]),E.mid&&this.j(E.mid,v),E.right&&this.j(E.right,v))}_isBalanced(){const E=v=>{if(!v)return!0;const a=v.balanceFactor();return a<-1||a>1?!1:E(v.left)&&E(v.right)};return E(this.c)}}e.$oi=I}),define(ke[18],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vf=u,e.$Wf=L,e.$Xf=M,e.$Yf=P,e.$Zf=R,e.$1f=b,e.$2f=$,e.$3f=y,e.$4f=A,e.$5f=I,e.$6f=p,e.$7f=E,e.$8f=v,e.$9f=m,e.$0f=o,e.$$f=n,e.$_f=i,e.$ag=r;function u(s){return typeof s=="string"}function L(s){return Array.isArray(s)&&s.every(t=>u(t))}function M(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}function P(s){const t=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof t}function R(s){return typeof s=="number"&&!isNaN(s)}function b(s){return!!s&&typeof s[Symbol.iterator]=="function"}function $(s){return s===!0||s===!1}function y(s){return typeof s>"u"}function A(s){return!I(s)}function I(s){return y(s)||s===null}function p(s,t){if(!s)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function E(s){if(I(s))throw new Error("Assertion Failed: argument is undefined or null");return s}function v(...s){const t=[];for(let f=0;f<s.length;f++){const d=s[f];if(I(d))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);t.push(d)}return t}const a=Object.prototype.hasOwnProperty;function m(s){if(!M(s))return!1;for(const t in s)if(a.call(s,t))return!1;return!0}function o(s){return typeof s=="function"}function n(...s){return s.length>0&&s.every(o)}function i(s,t){const f=Math.min(s.length,t.length);for(let d=0;d<f;d++)r(s[d],t[d])}function r(s,t){if(u(t)){if(typeof s!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(s instanceof t)return}catch{}if(!I(s)&&s.constructor===t||t.length===1&&t.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ke[99],Ee([1,0,18]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=M,e.$Dj=P;const L=Object.create(null);function M(R,b){if((0,u.$Vf)(b)){const $=L[b];if($===void 0)throw new Error(`${R} references an unknown codicon: ${b}`);b=$}return L[R]=b,{id:R}}function P(){return L}}),define(ke[169],Ee([1,0,99]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=void 0,e.$Ej={add:(0,u.$Cj)("add",6e4),plus:(0,u.$Cj)("plus",6e4),gistNew:(0,u.$Cj)("gist-new",6e4),repoCreate:(0,u.$Cj)("repo-create",6e4),lightbulb:(0,u.$Cj)("lightbulb",60001),lightBulb:(0,u.$Cj)("light-bulb",60001),repo:(0,u.$Cj)("repo",60002),repoDelete:(0,u.$Cj)("repo-delete",60002),gistFork:(0,u.$Cj)("gist-fork",60003),repoForked:(0,u.$Cj)("repo-forked",60003),gitPullRequest:(0,u.$Cj)("git-pull-request",60004),gitPullRequestAbandoned:(0,u.$Cj)("git-pull-request-abandoned",60004),recordKeys:(0,u.$Cj)("record-keys",60005),keyboard:(0,u.$Cj)("keyboard",60005),tag:(0,u.$Cj)("tag",60006),gitPullRequestLabel:(0,u.$Cj)("git-pull-request-label",60006),tagAdd:(0,u.$Cj)("tag-add",60006),tagRemove:(0,u.$Cj)("tag-remove",60006),person:(0,u.$Cj)("person",60007),personFollow:(0,u.$Cj)("person-follow",60007),personOutline:(0,u.$Cj)("person-outline",60007),personFilled:(0,u.$Cj)("person-filled",60007),gitBranch:(0,u.$Cj)("git-branch",60008),gitBranchCreate:(0,u.$Cj)("git-branch-create",60008),gitBranchDelete:(0,u.$Cj)("git-branch-delete",60008),sourceControl:(0,u.$Cj)("source-control",60008),mirror:(0,u.$Cj)("mirror",60009),mirrorPublic:(0,u.$Cj)("mirror-public",60009),star:(0,u.$Cj)("star",60010),starAdd:(0,u.$Cj)("star-add",60010),starDelete:(0,u.$Cj)("star-delete",60010),starEmpty:(0,u.$Cj)("star-empty",60010),comment:(0,u.$Cj)("comment",60011),commentAdd:(0,u.$Cj)("comment-add",60011),alert:(0,u.$Cj)("alert",60012),warning:(0,u.$Cj)("warning",60012),search:(0,u.$Cj)("search",60013),searchSave:(0,u.$Cj)("search-save",60013),logOut:(0,u.$Cj)("log-out",60014),signOut:(0,u.$Cj)("sign-out",60014),logIn:(0,u.$Cj)("log-in",60015),signIn:(0,u.$Cj)("sign-in",60015),eye:(0,u.$Cj)("eye",60016),eyeUnwatch:(0,u.$Cj)("eye-unwatch",60016),eyeWatch:(0,u.$Cj)("eye-watch",60016),circleFilled:(0,u.$Cj)("circle-filled",60017),primitiveDot:(0,u.$Cj)("primitive-dot",60017),closeDirty:(0,u.$Cj)("close-dirty",60017),debugBreakpoint:(0,u.$Cj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,u.$Cj)("debug-breakpoint-disabled",60017),debugHint:(0,u.$Cj)("debug-hint",60017),terminalDecorationSuccess:(0,u.$Cj)("terminal-decoration-success",60017),primitiveSquare:(0,u.$Cj)("primitive-square",60018),edit:(0,u.$Cj)("edit",60019),pencil:(0,u.$Cj)("pencil",60019),info:(0,u.$Cj)("info",60020),issueOpened:(0,u.$Cj)("issue-opened",60020),gistPrivate:(0,u.$Cj)("gist-private",60021),gitForkPrivate:(0,u.$Cj)("git-fork-private",60021),lock:(0,u.$Cj)("lock",60021),mirrorPrivate:(0,u.$Cj)("mirror-private",60021),close:(0,u.$Cj)("close",60022),removeClose:(0,u.$Cj)("remove-close",60022),x:(0,u.$Cj)("x",60022),repoSync:(0,u.$Cj)("repo-sync",60023),sync:(0,u.$Cj)("sync",60023),clone:(0,u.$Cj)("clone",60024),desktopDownload:(0,u.$Cj)("desktop-download",60024),beaker:(0,u.$Cj)("beaker",60025),microscope:(0,u.$Cj)("microscope",60025),vm:(0,u.$Cj)("vm",60026),deviceDesktop:(0,u.$Cj)("device-desktop",60026),file:(0,u.$Cj)("file",60027),fileText:(0,u.$Cj)("file-text",60027),more:(0,u.$Cj)("more",60028),ellipsis:(0,u.$Cj)("ellipsis",60028),kebabHorizontal:(0,u.$Cj)("kebab-horizontal",60028),mailReply:(0,u.$Cj)("mail-reply",60029),reply:(0,u.$Cj)("reply",60029),organization:(0,u.$Cj)("organization",60030),organizationFilled:(0,u.$Cj)("organization-filled",60030),organizationOutline:(0,u.$Cj)("organization-outline",60030),newFile:(0,u.$Cj)("new-file",60031),fileAdd:(0,u.$Cj)("file-add",60031),newFolder:(0,u.$Cj)("new-folder",60032),fileDirectoryCreate:(0,u.$Cj)("file-directory-create",60032),trash:(0,u.$Cj)("trash",60033),trashcan:(0,u.$Cj)("trashcan",60033),history:(0,u.$Cj)("history",60034),clock:(0,u.$Cj)("clock",60034),folder:(0,u.$Cj)("folder",60035),fileDirectory:(0,u.$Cj)("file-directory",60035),symbolFolder:(0,u.$Cj)("symbol-folder",60035),logoGithub:(0,u.$Cj)("logo-github",60036),markGithub:(0,u.$Cj)("mark-github",60036),github:(0,u.$Cj)("github",60036),terminal:(0,u.$Cj)("terminal",60037),console:(0,u.$Cj)("console",60037),repl:(0,u.$Cj)("repl",60037),zap:(0,u.$Cj)("zap",60038),symbolEvent:(0,u.$Cj)("symbol-event",60038),error:(0,u.$Cj)("error",60039),stop:(0,u.$Cj)("stop",60039),variable:(0,u.$Cj)("variable",60040),symbolVariable:(0,u.$Cj)("symbol-variable",60040),array:(0,u.$Cj)("array",60042),symbolArray:(0,u.$Cj)("symbol-array",60042),symbolModule:(0,u.$Cj)("symbol-module",60043),symbolPackage:(0,u.$Cj)("symbol-package",60043),symbolNamespace:(0,u.$Cj)("symbol-namespace",60043),symbolObject:(0,u.$Cj)("symbol-object",60043),symbolMethod:(0,u.$Cj)("symbol-method",60044),symbolFunction:(0,u.$Cj)("symbol-function",60044),symbolConstructor:(0,u.$Cj)("symbol-constructor",60044),symbolBoolean:(0,u.$Cj)("symbol-boolean",60047),symbolNull:(0,u.$Cj)("symbol-null",60047),symbolNumeric:(0,u.$Cj)("symbol-numeric",60048),symbolNumber:(0,u.$Cj)("symbol-number",60048),symbolStructure:(0,u.$Cj)("symbol-structure",60049),symbolStruct:(0,u.$Cj)("symbol-struct",60049),symbolParameter:(0,u.$Cj)("symbol-parameter",60050),symbolTypeParameter:(0,u.$Cj)("symbol-type-parameter",60050),symbolKey:(0,u.$Cj)("symbol-key",60051),symbolText:(0,u.$Cj)("symbol-text",60051),symbolReference:(0,u.$Cj)("symbol-reference",60052),goToFile:(0,u.$Cj)("go-to-file",60052),symbolEnum:(0,u.$Cj)("symbol-enum",60053),symbolValue:(0,u.$Cj)("symbol-value",60053),symbolRuler:(0,u.$Cj)("symbol-ruler",60054),symbolUnit:(0,u.$Cj)("symbol-unit",60054),activateBreakpoints:(0,u.$Cj)("activate-breakpoints",60055),archive:(0,u.$Cj)("archive",60056),arrowBoth:(0,u.$Cj)("arrow-both",60057),arrowDown:(0,u.$Cj)("arrow-down",60058),arrowLeft:(0,u.$Cj)("arrow-left",60059),arrowRight:(0,u.$Cj)("arrow-right",60060),arrowSmallDown:(0,u.$Cj)("arrow-small-down",60061),arrowSmallLeft:(0,u.$Cj)("arrow-small-left",60062),arrowSmallRight:(0,u.$Cj)("arrow-small-right",60063),arrowSmallUp:(0,u.$Cj)("arrow-small-up",60064),arrowUp:(0,u.$Cj)("arrow-up",60065),bell:(0,u.$Cj)("bell",60066),bold:(0,u.$Cj)("bold",60067),book:(0,u.$Cj)("book",60068),bookmark:(0,u.$Cj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,u.$Cj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,u.$Cj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,u.$Cj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,u.$Cj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,u.$Cj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,u.$Cj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,u.$Cj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,u.$Cj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,u.$Cj)("debug-breakpoint-log-disabled",60075),briefcase:(0,u.$Cj)("briefcase",60076),broadcast:(0,u.$Cj)("broadcast",60077),browser:(0,u.$Cj)("browser",60078),bug:(0,u.$Cj)("bug",60079),calendar:(0,u.$Cj)("calendar",60080),caseSensitive:(0,u.$Cj)("case-sensitive",60081),check:(0,u.$Cj)("check",60082),checklist:(0,u.$Cj)("checklist",60083),chevronDown:(0,u.$Cj)("chevron-down",60084),chevronLeft:(0,u.$Cj)("chevron-left",60085),chevronRight:(0,u.$Cj)("chevron-right",60086),chevronUp:(0,u.$Cj)("chevron-up",60087),chromeClose:(0,u.$Cj)("chrome-close",60088),chromeMaximize:(0,u.$Cj)("chrome-maximize",60089),chromeMinimize:(0,u.$Cj)("chrome-minimize",60090),chromeRestore:(0,u.$Cj)("chrome-restore",60091),circleOutline:(0,u.$Cj)("circle-outline",60092),circle:(0,u.$Cj)("circle",60092),debugBreakpointUnverified:(0,u.$Cj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,u.$Cj)("terminal-decoration-incomplete",60092),circleSlash:(0,u.$Cj)("circle-slash",60093),circuitBoard:(0,u.$Cj)("circuit-board",60094),clearAll:(0,u.$Cj)("clear-all",60095),clippy:(0,u.$Cj)("clippy",60096),closeAll:(0,u.$Cj)("close-all",60097),cloudDownload:(0,u.$Cj)("cloud-download",60098),cloudUpload:(0,u.$Cj)("cloud-upload",60099),code:(0,u.$Cj)("code",60100),collapseAll:(0,u.$Cj)("collapse-all",60101),colorMode:(0,u.$Cj)("color-mode",60102),commentDiscussion:(0,u.$Cj)("comment-discussion",60103),creditCard:(0,u.$Cj)("credit-card",60105),dash:(0,u.$Cj)("dash",60108),dashboard:(0,u.$Cj)("dashboard",60109),database:(0,u.$Cj)("database",60110),debugContinue:(0,u.$Cj)("debug-continue",60111),debugDisconnect:(0,u.$Cj)("debug-disconnect",60112),debugPause:(0,u.$Cj)("debug-pause",60113),debugRestart:(0,u.$Cj)("debug-restart",60114),debugStart:(0,u.$Cj)("debug-start",60115),debugStepInto:(0,u.$Cj)("debug-step-into",60116),debugStepOut:(0,u.$Cj)("debug-step-out",60117),debugStepOver:(0,u.$Cj)("debug-step-over",60118),debugStop:(0,u.$Cj)("debug-stop",60119),debug:(0,u.$Cj)("debug",60120),deviceCameraVideo:(0,u.$Cj)("device-camera-video",60121),deviceCamera:(0,u.$Cj)("device-camera",60122),deviceMobile:(0,u.$Cj)("device-mobile",60123),diffAdded:(0,u.$Cj)("diff-added",60124),diffIgnored:(0,u.$Cj)("diff-ignored",60125),diffModified:(0,u.$Cj)("diff-modified",60126),diffRemoved:(0,u.$Cj)("diff-removed",60127),diffRenamed:(0,u.$Cj)("diff-renamed",60128),diff:(0,u.$Cj)("diff",60129),diffSidebyside:(0,u.$Cj)("diff-sidebyside",60129),discard:(0,u.$Cj)("discard",60130),editorLayout:(0,u.$Cj)("editor-layout",60131),emptyWindow:(0,u.$Cj)("empty-window",60132),exclude:(0,u.$Cj)("exclude",60133),extensions:(0,u.$Cj)("extensions",60134),eyeClosed:(0,u.$Cj)("eye-closed",60135),fileBinary:(0,u.$Cj)("file-binary",60136),fileCode:(0,u.$Cj)("file-code",60137),fileMedia:(0,u.$Cj)("file-media",60138),filePdf:(0,u.$Cj)("file-pdf",60139),fileSubmodule:(0,u.$Cj)("file-submodule",60140),fileSymlinkDirectory:(0,u.$Cj)("file-symlink-directory",60141),fileSymlinkFile:(0,u.$Cj)("file-symlink-file",60142),fileZip:(0,u.$Cj)("file-zip",60143),files:(0,u.$Cj)("files",60144),filter:(0,u.$Cj)("filter",60145),flame:(0,u.$Cj)("flame",60146),foldDown:(0,u.$Cj)("fold-down",60147),foldUp:(0,u.$Cj)("fold-up",60148),fold:(0,u.$Cj)("fold",60149),folderActive:(0,u.$Cj)("folder-active",60150),folderOpened:(0,u.$Cj)("folder-opened",60151),gear:(0,u.$Cj)("gear",60152),gift:(0,u.$Cj)("gift",60153),gistSecret:(0,u.$Cj)("gist-secret",60154),gist:(0,u.$Cj)("gist",60155),gitCommit:(0,u.$Cj)("git-commit",60156),gitCompare:(0,u.$Cj)("git-compare",60157),compareChanges:(0,u.$Cj)("compare-changes",60157),gitMerge:(0,u.$Cj)("git-merge",60158),githubAction:(0,u.$Cj)("github-action",60159),githubAlt:(0,u.$Cj)("github-alt",60160),globe:(0,u.$Cj)("globe",60161),grabber:(0,u.$Cj)("grabber",60162),graph:(0,u.$Cj)("graph",60163),gripper:(0,u.$Cj)("gripper",60164),heart:(0,u.$Cj)("heart",60165),home:(0,u.$Cj)("home",60166),horizontalRule:(0,u.$Cj)("horizontal-rule",60167),hubot:(0,u.$Cj)("hubot",60168),inbox:(0,u.$Cj)("inbox",60169),issueReopened:(0,u.$Cj)("issue-reopened",60171),issues:(0,u.$Cj)("issues",60172),italic:(0,u.$Cj)("italic",60173),jersey:(0,u.$Cj)("jersey",60174),json:(0,u.$Cj)("json",60175),kebabVertical:(0,u.$Cj)("kebab-vertical",60176),key:(0,u.$Cj)("key",60177),law:(0,u.$Cj)("law",60178),lightbulbAutofix:(0,u.$Cj)("lightbulb-autofix",60179),linkExternal:(0,u.$Cj)("link-external",60180),link:(0,u.$Cj)("link",60181),listOrdered:(0,u.$Cj)("list-ordered",60182),listUnordered:(0,u.$Cj)("list-unordered",60183),liveShare:(0,u.$Cj)("live-share",60184),loading:(0,u.$Cj)("loading",60185),location:(0,u.$Cj)("location",60186),mailRead:(0,u.$Cj)("mail-read",60187),mail:(0,u.$Cj)("mail",60188),markdown:(0,u.$Cj)("markdown",60189),megaphone:(0,u.$Cj)("megaphone",60190),mention:(0,u.$Cj)("mention",60191),milestone:(0,u.$Cj)("milestone",60192),gitPullRequestMilestone:(0,u.$Cj)("git-pull-request-milestone",60192),mortarBoard:(0,u.$Cj)("mortar-board",60193),move:(0,u.$Cj)("move",60194),multipleWindows:(0,u.$Cj)("multiple-windows",60195),mute:(0,u.$Cj)("mute",60196),noNewline:(0,u.$Cj)("no-newline",60197),note:(0,u.$Cj)("note",60198),octoface:(0,u.$Cj)("octoface",60199),openPreview:(0,u.$Cj)("open-preview",60200),package:(0,u.$Cj)("package",60201),paintcan:(0,u.$Cj)("paintcan",60202),pin:(0,u.$Cj)("pin",60203),play:(0,u.$Cj)("play",60204),run:(0,u.$Cj)("run",60204),plug:(0,u.$Cj)("plug",60205),preserveCase:(0,u.$Cj)("preserve-case",60206),preview:(0,u.$Cj)("preview",60207),project:(0,u.$Cj)("project",60208),pulse:(0,u.$Cj)("pulse",60209),question:(0,u.$Cj)("question",60210),quote:(0,u.$Cj)("quote",60211),radioTower:(0,u.$Cj)("radio-tower",60212),reactions:(0,u.$Cj)("reactions",60213),references:(0,u.$Cj)("references",60214),refresh:(0,u.$Cj)("refresh",60215),regex:(0,u.$Cj)("regex",60216),remoteExplorer:(0,u.$Cj)("remote-explorer",60217),remote:(0,u.$Cj)("remote",60218),remove:(0,u.$Cj)("remove",60219),replaceAll:(0,u.$Cj)("replace-all",60220),replace:(0,u.$Cj)("replace",60221),repoClone:(0,u.$Cj)("repo-clone",60222),repoForcePush:(0,u.$Cj)("repo-force-push",60223),repoPull:(0,u.$Cj)("repo-pull",60224),repoPush:(0,u.$Cj)("repo-push",60225),report:(0,u.$Cj)("report",60226),requestChanges:(0,u.$Cj)("request-changes",60227),rocket:(0,u.$Cj)("rocket",60228),rootFolderOpened:(0,u.$Cj)("root-folder-opened",60229),rootFolder:(0,u.$Cj)("root-folder",60230),rss:(0,u.$Cj)("rss",60231),ruby:(0,u.$Cj)("ruby",60232),saveAll:(0,u.$Cj)("save-all",60233),saveAs:(0,u.$Cj)("save-as",60234),save:(0,u.$Cj)("save",60235),screenFull:(0,u.$Cj)("screen-full",60236),screenNormal:(0,u.$Cj)("screen-normal",60237),searchStop:(0,u.$Cj)("search-stop",60238),server:(0,u.$Cj)("server",60240),settingsGear:(0,u.$Cj)("settings-gear",60241),settings:(0,u.$Cj)("settings",60242),shield:(0,u.$Cj)("shield",60243),smiley:(0,u.$Cj)("smiley",60244),sortPrecedence:(0,u.$Cj)("sort-precedence",60245),splitHorizontal:(0,u.$Cj)("split-horizontal",60246),splitVertical:(0,u.$Cj)("split-vertical",60247),squirrel:(0,u.$Cj)("squirrel",60248),starFull:(0,u.$Cj)("star-full",60249),starHalf:(0,u.$Cj)("star-half",60250),symbolClass:(0,u.$Cj)("symbol-class",60251),symbolColor:(0,u.$Cj)("symbol-color",60252),symbolConstant:(0,u.$Cj)("symbol-constant",60253),symbolEnumMember:(0,u.$Cj)("symbol-enum-member",60254),symbolField:(0,u.$Cj)("symbol-field",60255),symbolFile:(0,u.$Cj)("symbol-file",60256),symbolInterface:(0,u.$Cj)("symbol-interface",60257),symbolKeyword:(0,u.$Cj)("symbol-keyword",60258),symbolMisc:(0,u.$Cj)("symbol-misc",60259),symbolOperator:(0,u.$Cj)("symbol-operator",60260),symbolProperty:(0,u.$Cj)("symbol-property",60261),wrench:(0,u.$Cj)("wrench",60261),wrenchSubaction:(0,u.$Cj)("wrench-subaction",60261),symbolSnippet:(0,u.$Cj)("symbol-snippet",60262),tasklist:(0,u.$Cj)("tasklist",60263),telescope:(0,u.$Cj)("telescope",60264),textSize:(0,u.$Cj)("text-size",60265),threeBars:(0,u.$Cj)("three-bars",60266),thumbsdown:(0,u.$Cj)("thumbsdown",60267),thumbsup:(0,u.$Cj)("thumbsup",60268),tools:(0,u.$Cj)("tools",60269),triangleDown:(0,u.$Cj)("triangle-down",60270),triangleLeft:(0,u.$Cj)("triangle-left",60271),triangleRight:(0,u.$Cj)("triangle-right",60272),triangleUp:(0,u.$Cj)("triangle-up",60273),twitter:(0,u.$Cj)("twitter",60274),unfold:(0,u.$Cj)("unfold",60275),unlock:(0,u.$Cj)("unlock",60276),unmute:(0,u.$Cj)("unmute",60277),unverified:(0,u.$Cj)("unverified",60278),verified:(0,u.$Cj)("verified",60279),versions:(0,u.$Cj)("versions",60280),vmActive:(0,u.$Cj)("vm-active",60281),vmOutline:(0,u.$Cj)("vm-outline",60282),vmRunning:(0,u.$Cj)("vm-running",60283),watch:(0,u.$Cj)("watch",60284),whitespace:(0,u.$Cj)("whitespace",60285),wholeWord:(0,u.$Cj)("whole-word",60286),window:(0,u.$Cj)("window",60287),wordWrap:(0,u.$Cj)("word-wrap",60288),zoomIn:(0,u.$Cj)("zoom-in",60289),zoomOut:(0,u.$Cj)("zoom-out",60290),listFilter:(0,u.$Cj)("list-filter",60291),listFlat:(0,u.$Cj)("list-flat",60292),listSelection:(0,u.$Cj)("list-selection",60293),selection:(0,u.$Cj)("selection",60293),listTree:(0,u.$Cj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,u.$Cj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,u.$Cj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,u.$Cj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,u.$Cj)("debug-stackframe-active",60297),circleSmallFilled:(0,u.$Cj)("circle-small-filled",60298),debugStackframeDot:(0,u.$Cj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,u.$Cj)("terminal-decoration-mark",60298),debugStackframe:(0,u.$Cj)("debug-stackframe",60299),debugStackframeFocused:(0,u.$Cj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,u.$Cj)("debug-breakpoint-unsupported",60300),symbolString:(0,u.$Cj)("symbol-string",60301),debugReverseContinue:(0,u.$Cj)("debug-reverse-continue",60302),debugStepBack:(0,u.$Cj)("debug-step-back",60303),debugRestartFrame:(0,u.$Cj)("debug-restart-frame",60304),debugAlt:(0,u.$Cj)("debug-alt",60305),callIncoming:(0,u.$Cj)("call-incoming",60306),callOutgoing:(0,u.$Cj)("call-outgoing",60307),menu:(0,u.$Cj)("menu",60308),expandAll:(0,u.$Cj)("expand-all",60309),feedback:(0,u.$Cj)("feedback",60310),gitPullRequestReviewer:(0,u.$Cj)("git-pull-request-reviewer",60310),groupByRefType:(0,u.$Cj)("group-by-ref-type",60311),ungroupByRefType:(0,u.$Cj)("ungroup-by-ref-type",60312),account:(0,u.$Cj)("account",60313),gitPullRequestAssignee:(0,u.$Cj)("git-pull-request-assignee",60313),bellDot:(0,u.$Cj)("bell-dot",60314),debugConsole:(0,u.$Cj)("debug-console",60315),library:(0,u.$Cj)("library",60316),output:(0,u.$Cj)("output",60317),runAll:(0,u.$Cj)("run-all",60318),syncIgnored:(0,u.$Cj)("sync-ignored",60319),pinned:(0,u.$Cj)("pinned",60320),githubInverted:(0,u.$Cj)("github-inverted",60321),serverProcess:(0,u.$Cj)("server-process",60322),serverEnvironment:(0,u.$Cj)("server-environment",60323),pass:(0,u.$Cj)("pass",60324),issueClosed:(0,u.$Cj)("issue-closed",60324),stopCircle:(0,u.$Cj)("stop-circle",60325),playCircle:(0,u.$Cj)("play-circle",60326),record:(0,u.$Cj)("record",60327),debugAltSmall:(0,u.$Cj)("debug-alt-small",60328),vmConnect:(0,u.$Cj)("vm-connect",60329),cloud:(0,u.$Cj)("cloud",60330),merge:(0,u.$Cj)("merge",60331),export:(0,u.$Cj)("export",60332),graphLeft:(0,u.$Cj)("graph-left",60333),magnet:(0,u.$Cj)("magnet",60334),notebook:(0,u.$Cj)("notebook",60335),redo:(0,u.$Cj)("redo",60336),checkAll:(0,u.$Cj)("check-all",60337),pinnedDirty:(0,u.$Cj)("pinned-dirty",60338),passFilled:(0,u.$Cj)("pass-filled",60339),circleLargeFilled:(0,u.$Cj)("circle-large-filled",60340),circleLarge:(0,u.$Cj)("circle-large",60341),circleLargeOutline:(0,u.$Cj)("circle-large-outline",60341),combine:(0,u.$Cj)("combine",60342),gather:(0,u.$Cj)("gather",60342),table:(0,u.$Cj)("table",60343),variableGroup:(0,u.$Cj)("variable-group",60344),typeHierarchy:(0,u.$Cj)("type-hierarchy",60345),typeHierarchySub:(0,u.$Cj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,u.$Cj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,u.$Cj)("git-pull-request-create",60348),runAbove:(0,u.$Cj)("run-above",60349),runBelow:(0,u.$Cj)("run-below",60350),notebookTemplate:(0,u.$Cj)("notebook-template",60351),debugRerun:(0,u.$Cj)("debug-rerun",60352),workspaceTrusted:(0,u.$Cj)("workspace-trusted",60353),workspaceUntrusted:(0,u.$Cj)("workspace-untrusted",60354),workspaceUnknown:(0,u.$Cj)("workspace-unknown",60355),terminalCmd:(0,u.$Cj)("terminal-cmd",60356),terminalDebian:(0,u.$Cj)("terminal-debian",60357),terminalLinux:(0,u.$Cj)("terminal-linux",60358),terminalPowershell:(0,u.$Cj)("terminal-powershell",60359),terminalTmux:(0,u.$Cj)("terminal-tmux",60360),terminalUbuntu:(0,u.$Cj)("terminal-ubuntu",60361),terminalBash:(0,u.$Cj)("terminal-bash",60362),arrowSwap:(0,u.$Cj)("arrow-swap",60363),copy:(0,u.$Cj)("copy",60364),personAdd:(0,u.$Cj)("person-add",60365),filterFilled:(0,u.$Cj)("filter-filled",60366),wand:(0,u.$Cj)("wand",60367),debugLineByLine:(0,u.$Cj)("debug-line-by-line",60368),inspect:(0,u.$Cj)("inspect",60369),layers:(0,u.$Cj)("layers",60370),layersDot:(0,u.$Cj)("layers-dot",60371),layersActive:(0,u.$Cj)("layers-active",60372),compass:(0,u.$Cj)("compass",60373),compassDot:(0,u.$Cj)("compass-dot",60374),compassActive:(0,u.$Cj)("compass-active",60375),azure:(0,u.$Cj)("azure",60376),issueDraft:(0,u.$Cj)("issue-draft",60377),gitPullRequestClosed:(0,u.$Cj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,u.$Cj)("git-pull-request-draft",60379),debugAll:(0,u.$Cj)("debug-all",60380),debugCoverage:(0,u.$Cj)("debug-coverage",60381),runErrors:(0,u.$Cj)("run-errors",60382),folderLibrary:(0,u.$Cj)("folder-library",60383),debugContinueSmall:(0,u.$Cj)("debug-continue-small",60384),beakerStop:(0,u.$Cj)("beaker-stop",60385),graphLine:(0,u.$Cj)("graph-line",60386),graphScatter:(0,u.$Cj)("graph-scatter",60387),pieChart:(0,u.$Cj)("pie-chart",60388),bracket:(0,u.$Cj)("bracket",60175),bracketDot:(0,u.$Cj)("bracket-dot",60389),bracketError:(0,u.$Cj)("bracket-error",60390),lockSmall:(0,u.$Cj)("lock-small",60391),azureDevops:(0,u.$Cj)("azure-devops",60392),verifiedFilled:(0,u.$Cj)("verified-filled",60393),newline:(0,u.$Cj)("newline",60394),layout:(0,u.$Cj)("layout",60395),layoutActivitybarLeft:(0,u.$Cj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,u.$Cj)("layout-activitybar-right",60397),layoutPanelLeft:(0,u.$Cj)("layout-panel-left",60398),layoutPanelCenter:(0,u.$Cj)("layout-panel-center",60399),layoutPanelJustify:(0,u.$Cj)("layout-panel-justify",60400),layoutPanelRight:(0,u.$Cj)("layout-panel-right",60401),layoutPanel:(0,u.$Cj)("layout-panel",60402),layoutSidebarLeft:(0,u.$Cj)("layout-sidebar-left",60403),layoutSidebarRight:(0,u.$Cj)("layout-sidebar-right",60404),layoutStatusbar:(0,u.$Cj)("layout-statusbar",60405),layoutMenubar:(0,u.$Cj)("layout-menubar",60406),layoutCentered:(0,u.$Cj)("layout-centered",60407),target:(0,u.$Cj)("target",60408),indent:(0,u.$Cj)("indent",60409),recordSmall:(0,u.$Cj)("record-small",60410),errorSmall:(0,u.$Cj)("error-small",60411),terminalDecorationError:(0,u.$Cj)("terminal-decoration-error",60411),arrowCircleDown:(0,u.$Cj)("arrow-circle-down",60412),arrowCircleLeft:(0,u.$Cj)("arrow-circle-left",60413),arrowCircleRight:(0,u.$Cj)("arrow-circle-right",60414),arrowCircleUp:(0,u.$Cj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,u.$Cj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,u.$Cj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,u.$Cj)("layout-sidebar-left-off",60418),blank:(0,u.$Cj)("blank",60419),heartFilled:(0,u.$Cj)("heart-filled",60420),map:(0,u.$Cj)("map",60421),mapFilled:(0,u.$Cj)("map-filled",60422),circleSmall:(0,u.$Cj)("circle-small",60423),bellSlash:(0,u.$Cj)("bell-slash",60424),bellSlashDot:(0,u.$Cj)("bell-slash-dot",60425),commentUnresolved:(0,u.$Cj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,u.$Cj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,u.$Cj)("git-pull-request-new-changes",60428),searchFuzzy:(0,u.$Cj)("search-fuzzy",60429),commentDraft:(0,u.$Cj)("comment-draft",60430),send:(0,u.$Cj)("send",60431),sparkle:(0,u.$Cj)("sparkle",60432),insert:(0,u.$Cj)("insert",60433),mic:(0,u.$Cj)("mic",60434),thumbsdownFilled:(0,u.$Cj)("thumbsdown-filled",60435),thumbsupFilled:(0,u.$Cj)("thumbsup-filled",60436),coffee:(0,u.$Cj)("coffee",60437),snake:(0,u.$Cj)("snake",60438),game:(0,u.$Cj)("game",60439),vr:(0,u.$Cj)("vr",60440),chip:(0,u.$Cj)("chip",60441),piano:(0,u.$Cj)("piano",60442),music:(0,u.$Cj)("music",60443),micFilled:(0,u.$Cj)("mic-filled",60444),repoFetch:(0,u.$Cj)("repo-fetch",60445),copilot:(0,u.$Cj)("copilot",60446),lightbulbSparkle:(0,u.$Cj)("lightbulb-sparkle",60447),robot:(0,u.$Cj)("robot",60448),sparkleFilled:(0,u.$Cj)("sparkle-filled",60449),diffSingle:(0,u.$Cj)("diff-single",60450),diffMultiple:(0,u.$Cj)("diff-multiple",60451),surroundWith:(0,u.$Cj)("surround-with",60452),share:(0,u.$Cj)("share",60453),gitStash:(0,u.$Cj)("git-stash",60454),gitStashApply:(0,u.$Cj)("git-stash-apply",60455),gitStashPop:(0,u.$Cj)("git-stash-pop",60456),vscode:(0,u.$Cj)("vscode",60457),vscodeInsiders:(0,u.$Cj)("vscode-insiders",60458),codeOss:(0,u.$Cj)("code-oss",60459),runCoverage:(0,u.$Cj)("run-coverage",60460),runAllCoverage:(0,u.$Cj)("run-all-coverage",60461),coverage:(0,u.$Cj)("coverage",60462),githubProject:(0,u.$Cj)("github-project",60463)}}),define(ke[78],Ee([1,0,99,169]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hj=e.$Gj=void 0,e.$Fj=M;function M(){return Object.values(e.$Hj)}e.$Gj={dialogError:(0,u.$Cj)("dialog-error","error"),dialogWarning:(0,u.$Cj)("dialog-warning","warning"),dialogInfo:(0,u.$Cj)("dialog-info","info"),dialogClose:(0,u.$Cj)("dialog-close","close"),treeItemExpanded:(0,u.$Cj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,u.$Cj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,u.$Cj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,u.$Cj)("tree-filter-clear","close"),treeItemLoading:(0,u.$Cj)("tree-item-loading","loading"),menuSelection:(0,u.$Cj)("menu-selection","check"),menuSubmenu:(0,u.$Cj)("menu-submenu","chevron-right"),menuBarMore:(0,u.$Cj)("menubar-more","more"),scrollbarButtonLeft:(0,u.$Cj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,u.$Cj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,u.$Cj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,u.$Cj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,u.$Cj)("toolbar-more","more"),quickInputBack:(0,u.$Cj)("quick-input-back","arrow-left"),dropDownButton:(0,u.$Cj)("drop-down-button",60084),symbolCustomColor:(0,u.$Cj)("symbol-customcolor",60252),exportIcon:(0,u.$Cj)("export",60332),workspaceUnspecified:(0,u.$Cj)("workspace-unspecified",60355),newLine:(0,u.$Cj)("newline",60394),thumbsDownFilled:(0,u.$Cj)("thumbsdown-filled",60435),thumbsUpFilled:(0,u.$Cj)("thumbsup-filled",60436),gitFetch:(0,u.$Cj)("git-fetch",60445),lightbulbSparkleAutofix:(0,u.$Cj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,u.$Cj)("debug-breakpoint-pending",60377)},e.$Hj={...L.$Ej,...e.$Gj}}),define(ke[24],Ee([1,0,18]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=L,e.$Pn=M,e.$Qn=R,e.$Rn=$,e.$Sn=y,e.$Tn=A,e.$Un=I,e.$Vn=p,e.$Wn=E,e.$Xn=v,e.$Yn=a,e.$Zn=m;function L(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const n=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([i,r])=>{n[i]=r&&typeof r=="object"?L(r):r}),n}function M(o){if(!o||typeof o!="object")return o;const n=[o];for(;n.length>0;){const i=n.shift();Object.freeze(i);for(const r in i)if(P.call(i,r)){const s=i[r];typeof s=="object"&&!Object.isFrozen(s)&&!(0,u.$Yf)(s)&&n.push(s)}}return o}const P=Object.prototype.hasOwnProperty;function R(o,n){return b(o,n,new Set)}function b(o,n,i){if((0,u.$5f)(o))return o;const r=n(o);if(typeof r<"u")return r;if(Array.isArray(o)){const s=[];for(const t of o)s.push(b(t,n,i));return s}if((0,u.$Xf)(o)){if(i.has(o))throw new Error("Cannot clone recursive data-structure");i.add(o);const s={};for(const t in o)P.call(o,t)&&(s[t]=b(o[t],n,i));return i.delete(o),s}return o}function $(o,n,i=!0){return(0,u.$Xf)(o)?((0,u.$Xf)(n)&&Object.keys(n).forEach(r=>{r in o?i&&((0,u.$Xf)(o[r])&&(0,u.$Xf)(n[r])?$(o[r],n[r],i):o[r]=n[r]):o[r]=n[r]}),o):n}function y(o,n){if(o===n)return!0;if(o==null||n===null||n===void 0||typeof o!=typeof n||typeof o!="object"||Array.isArray(o)!==Array.isArray(n))return!1;let i,r;if(Array.isArray(o)){if(o.length!==n.length)return!1;for(i=0;i<o.length;i++)if(!y(o[i],n[i]))return!1}else{const s=[];for(r in o)s.push(r);s.sort();const t=[];for(r in n)t.push(r);if(t.sort(),!y(s,t))return!1;for(i=0;i<s.length;i++)if(!y(o[s[i]],n[s[i]]))return!1}return!0}function A(o){const n=new Set;return JSON.stringify(o,(i,r)=>{if((0,u.$Xf)(r)||Array.isArray(r)){if(n.has(r))return"[Circular]";n.add(r)}return r})}function I(o,n){const i=Object.create(null);return!o||!n||Object.keys(n).forEach(s=>{const t=o[s],f=n[s];y(t,f)||(i[s]=f)}),i}function p(o,n){const i=n.toLowerCase(),r=Object.keys(o).find(s=>s.toLowerCase()===i);return r?o[r]:o[n]}function E(o,n){const i=Object.create(null);for(const[r,s]of Object.entries(o))n(r,s)&&(i[r]=s);return i}function v(o){let n=[];for(;Object.prototype!==o;)n=n.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return n}function a(o){const n=[];for(const i of v(o))typeof o[i]=="function"&&n.push(i);return n}function m(o,n){const i=s=>function(){const t=Array.prototype.slice.call(arguments,0);return n(s,t)},r={};for(const s of o)r[s]=i(s);return r}}),define(ke[56],Ee([1,0,78]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Ij=M;var L;(function(R){function b($){return $&&typeof $=="object"&&typeof $.id=="string"}R.isThemeColor=b})(L||(e.ThemeColor=L={}));function M(R){return{id:R}}var P;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function $(n){const i=b.exec(n.id);if(!i)return $(u.$Hj.error);const[,r,s]=i,t=["codicon","codicon-"+r];return s&&t.push("codicon-modifier-"+s.substring(1)),t}R.asClassNameArray=$;function y(n){return $(n).join(" ")}R.asClassName=y;function A(n){return"."+$(n).join(".")}R.asCSSSelector=A;function I(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||L.isThemeColor(n.color))}R.isThemeIcon=I;const p=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function E(n){const i=p.exec(n);if(!i)return;const[,r]=i;return{id:r}}R.fromString=E;function v(n){return{id:n}}R.fromId=v;function a(n,i){let r=n.id;const s=r.lastIndexOf("~");return s!==-1&&(r=r.substring(0,s)),i&&(r=`${r}~${i}`),{id:r}}R.modify=a;function m(n){const i=n.id.lastIndexOf("~");if(i!==-1)return n.id.substring(i+1)}R.getModifier=m;function o(n,i){return n.id===i.id&&n.color?.id===i.color?.id}R.isEqual=o})(P||(e.ThemeIcon=P={}))}),define(ke[170],Ee([1,0,126,14,56]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=$,e.$Ak=A,e.$Bk=p,e.$Ck=E,e.$Dk=a,e.$Ek=m;const P="$(",R=new RegExp(`\\$\\(${M.ThemeIcon.iconNameExpression}(?:${M.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${R.source}`,"g");function $(o){return o.replace(b,(n,i)=>i?n:`\\${n}`)}const y=new RegExp(`\\\\${R.source}`,"g");function A(o){return o.replace(y,n=>`\\${n}`)}const I=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function p(o){return o.indexOf(P)===-1?o:o.replace(I,(n,i,r,s)=>r?n:i||s||"")}function E(o){return o?o.replace(/\$\((.*?)\)/g,(n,i)=>` ${i} `).trim():""}const v=new RegExp(`\\$\\(${M.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(o){v.lastIndex=0;let n="";const i=[];let r=0;for(;;){const s=v.lastIndex,t=v.exec(o),f=o.substring(s,t?.index);if(f.length>0){n+=f;for(let d=0;d<f.length;d++)i.push(r)}if(!t)break;r+=t[0].length}return{text:n,iconOffsets:i}}function m(o,n,i=!1){const{text:r,iconOffsets:s}=n;if(!s||s.length===0)return(0,u.$qk)(o,r,i);const t=(0,L.$5e)(r," "),f=r.length-t.length,d=(0,u.$qk)(o,t,i);if(d)for(const l of d){const c=s[l.start+f]+f;l.start+=c,l.end+=c}return d}}),define(ke[127],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$Se=L,e.$Te=M;var u;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(u||(e.Constants=u={}));function L(P){return P<0?0:P>255?255:P|0}function M(P){return P<0?0:P>4294967295?4294967295:P|0}}),define(ke[30],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=void 0,e.$Dg=L;const u=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(M){return u.test(M)}e.$Eg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let M;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?M=crypto.getRandomValues.bind(crypto):M=function(b){for(let $=0;$<b.length;$++)b[$]=Math.floor(Math.random()*256);return b};const P=new Uint8Array(16),R=[];for(let b=0;b<256;b++)R.push(b.toString(16).padStart(2,"0"));return function(){M(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let $=0,y="";return y+=R[P[$++]],y+=R[P[$++]],y+=R[P[$++]],y+=R[P[$++]],y+="-",y+=R[P[$++]],y+=R[P[$++]],y+="-",y+=R[P[$++]],y+=R[P[$++]],y+="-",y+=R[P[$++]],y+=R[P[$++]],y+="-",y+=R[P[$++]],y+=R[P[$++]],y+=R[P[$++]],y+=R[P[$++]],y+=R[P[$++]],y+=R[P[$++]],y}}()}),define(ke[171],Ee([1,0,19,38,30]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lt=e.$Jt=void 0,e.$Ht=P,e.$It=R,e.$Kt=y;function P(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}function R(I,p,E){const v={id:(0,M.$Eg)(),name:I,uri:p,data:E};return{asString:async()=>"",asFile:()=>v,value:void 0}}class b{constructor(){this.a=new Map}get size(){let p=0;for(const E of this.a)p++;return p}has(p){return this.a.has(this.b(p))}matches(p){const E=[...this.a.keys()];return L.Iterable.some(this,([v,a])=>a.asFile())&&E.push("files"),A($(p),E)}get(p){return this.a.get(this.b(p))?.[0]}append(p,E){const v=this.a.get(p);v?v.push(E):this.a.set(this.b(p),[E])}replace(p,E){this.a.set(this.b(p),[E])}delete(p){this.a.delete(this.b(p))}*[Symbol.iterator](){for(const[p,E]of this.a)for(const v of E)yield[p,v]}b(p){return $(p)}}e.$Jt=b;function $(I){return I.toLowerCase()}function y(I,p){return A($(I),p.map($))}function A(I,p){if(I==="*/*")return p.length>0;if(p.includes(I))return!0;const E=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!E)return!1;const[v,a,m]=E;return m==="*"?p.some(o=>o.startsWith(a+"/")):!1}e.$Lt=Object.freeze({create:I=>(0,u.$Mb)(I.map(p=>p.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.$Lt.split(I).filter(p=>!p.startsWith("#"))})}),define(ke[172],Ee([1,0,62]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hg=void 0,e.$Gg=L,e.$Ig=P;function L(b,$,y,A=1){let I=!1;return new Promise(p=>{const E=setTimeout(()=>{if(!I)return I=!0,p(0)},y);M(b,$,A,v=>{if(!I)return I=!0,clearTimeout(E),p(v)})})}function M(b,$,y,A){if($===0)return A(0);const I=new u.Socket;I.once("connect",()=>(R(I),M(b+y,$-1,y,A))),I.once("data",()=>{}),I.once("error",p=>(R(I),p.code!=="ECONNREFUSED"?M(b+y,$-1,y,A):A(b))),I.connect(b,"127.0.0.1")}e.$Hg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function P(b,$,y,A="127.0.0.1"){let I=!1,p,E=1;const v=u.createServer({pauseOnConnect:!0});function a(m,o){I||(I=!0,v.removeAllListeners(),v.close(),p&&clearTimeout(p),o(m))}return new Promise(m=>{p=setTimeout(()=>{a(0,m)},y),v.on("listening",()=>{a(b,m)}),v.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&E<$?(b++,E++,v.listen(b,A)):a(0,m)}),v.on("close",()=>{a(0,m)}),v.listen(b,A)})}function R(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch($){console.error($)}}}),define(ke[128],Ee([1,0,127]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$At=e.$zt=void 0;class L{constructor(b){const $=(0,u.$Se)(b);this.c=$,this.a=L.d($),this.b=new Map}static d(b){const $=new Uint8Array(256);return $.fill(b),$}set(b,$){const y=(0,u.$Se)($);b>=0&&b<256?this.a[b]=y:this.b.set(b,y)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$zt=L;var M;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(M||(M={}));class P{constructor(){this.a=new L(0)}add(b){this.a.set(b,1)}has(b){return this.a.get(b)===1}clear(){return this.a.clear()}}e.$At=P}),define(ke[173],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Ot=L;var u;(function(M){M[M.Unknown=0]="Unknown",M[M.Invalid=3]="Invalid",M[M.LF=1]="LF",M[M.CRLF=2]="CRLF"})(u||(e.StringEOL=u={}));function L(M){let P=0,R=0,b=0,$=0;for(let y=0,A=M.length;y<A;y++){const I=M.charCodeAt(y);I===13?(P===0&&(R=y),P++,y+1<A&&M.charCodeAt(y+1)===10?($|=2,y++):$|=3,b=y+1):I===10&&($|=1,P===0&&(R=y),P++,b=y+1)}return P===0&&(R=M.length),[P,R,M.length-b,$]}}),define(ke[49],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bt=void 0;class u{constructor(M,P){this.lineNumber=M,this.column=P}with(M=this.lineNumber,P=this.column){return M===this.lineNumber&&P===this.column?this:new u(M,P)}delta(M=0,P=0){return this.with(this.lineNumber+M,this.column+P)}equals(M){return u.equals(this,M)}static equals(M,P){return!M&&!P?!0:!!M&&!!P&&M.lineNumber===P.lineNumber&&M.column===P.column}isBefore(M){return u.isBefore(this,M)}static isBefore(M,P){return M.lineNumber<P.lineNumber?!0:P.lineNumber<M.lineNumber?!1:M.column<P.column}isBeforeOrEqual(M){return u.isBeforeOrEqual(this,M)}static isBeforeOrEqual(M,P){return M.lineNumber<P.lineNumber?!0:P.lineNumber<M.lineNumber?!1:M.column<=P.column}static compare(M,P){const R=M.lineNumber|0,b=P.lineNumber|0;if(R===b){const $=M.column|0,y=P.column|0;return $-y}return R-b}clone(){return new u(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(M){return new u(M.lineNumber,M.column)}static isIPosition(M){return M&&typeof M.lineNumber=="number"&&typeof M.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$bt=u}),define(ke[29],Ee([1,0,49]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=void 0;class L{constructor(P,R,b,$){P>b||P===b&&R>$?(this.startLineNumber=b,this.startColumn=$,this.endLineNumber=P,this.endColumn=R):(this.startLineNumber=P,this.startColumn=R,this.endLineNumber=b,this.endColumn=$)}isEmpty(){return L.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return L.containsPosition(this,P)}static containsPosition(P,R){return!(R.lineNumber<P.startLineNumber||R.lineNumber>P.endLineNumber||R.lineNumber===P.startLineNumber&&R.column<P.startColumn||R.lineNumber===P.endLineNumber&&R.column>P.endColumn)}static strictContainsPosition(P,R){return!(R.lineNumber<P.startLineNumber||R.lineNumber>P.endLineNumber||R.lineNumber===P.startLineNumber&&R.column<=P.startColumn||R.lineNumber===P.endLineNumber&&R.column>=P.endColumn)}containsRange(P){return L.containsRange(this,P)}static containsRange(P,R){return!(R.startLineNumber<P.startLineNumber||R.endLineNumber<P.startLineNumber||R.startLineNumber>P.endLineNumber||R.endLineNumber>P.endLineNumber||R.startLineNumber===P.startLineNumber&&R.startColumn<P.startColumn||R.endLineNumber===P.endLineNumber&&R.endColumn>P.endColumn)}strictContainsRange(P){return L.strictContainsRange(this,P)}static strictContainsRange(P,R){return!(R.startLineNumber<P.startLineNumber||R.endLineNumber<P.startLineNumber||R.startLineNumber>P.endLineNumber||R.endLineNumber>P.endLineNumber||R.startLineNumber===P.startLineNumber&&R.startColumn<=P.startColumn||R.endLineNumber===P.endLineNumber&&R.endColumn>=P.endColumn)}plusRange(P){return L.plusRange(this,P)}static plusRange(P,R){let b,$,y,A;return R.startLineNumber<P.startLineNumber?(b=R.startLineNumber,$=R.startColumn):R.startLineNumber===P.startLineNumber?(b=R.startLineNumber,$=Math.min(R.startColumn,P.startColumn)):(b=P.startLineNumber,$=P.startColumn),R.endLineNumber>P.endLineNumber?(y=R.endLineNumber,A=R.endColumn):R.endLineNumber===P.endLineNumber?(y=R.endLineNumber,A=Math.max(R.endColumn,P.endColumn)):(y=P.endLineNumber,A=P.endColumn),new L(b,$,y,A)}intersectRanges(P){return L.intersectRanges(this,P)}static intersectRanges(P,R){let b=P.startLineNumber,$=P.startColumn,y=P.endLineNumber,A=P.endColumn;const I=R.startLineNumber,p=R.startColumn,E=R.endLineNumber,v=R.endColumn;return b<I?(b=I,$=p):b===I&&($=Math.max($,p)),y>E?(y=E,A=v):y===E&&(A=Math.min(A,v)),b>y||b===y&&$>A?null:new L(b,$,y,A)}equalsRange(P){return L.equalsRange(this,P)}static equalsRange(P,R){return!P&&!R?!0:!!P&&!!R&&P.startLineNumber===R.startLineNumber&&P.startColumn===R.startColumn&&P.endLineNumber===R.endLineNumber&&P.endColumn===R.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(P){return new u.$bt(P.endLineNumber,P.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(P){return new u.$bt(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,R){return new L(this.startLineNumber,this.startColumn,P,R)}setStartPosition(P,R){return new L(P,R,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(P){return new L(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}collapseToEnd(){return L.collapseToEnd(this)}static collapseToEnd(P){return new L(P.endLineNumber,P.endColumn,P.endLineNumber,P.endColumn)}delta(P){return new L(this.startLineNumber+P,this.startColumn,this.endLineNumber+P,this.endColumn)}static fromPositions(P,R=P){return new L(P.lineNumber,P.column,R.lineNumber,R.column)}static lift(P){return P?new L(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,R){return!(P.endLineNumber<R.startLineNumber||P.endLineNumber===R.startLineNumber&&P.endColumn<R.startColumn||R.endLineNumber<P.startLineNumber||R.endLineNumber===P.startLineNumber&&R.endColumn<P.startColumn)}static areIntersecting(P,R){return!(P.endLineNumber<R.startLineNumber||P.endLineNumber===R.startLineNumber&&P.endColumn<=R.startColumn||R.endLineNumber<P.startLineNumber||R.endLineNumber===P.startLineNumber&&R.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,R){if(P&&R){const y=P.startLineNumber|0,A=R.startLineNumber|0;if(y===A){const I=P.startColumn|0,p=R.startColumn|0;if(I===p){const E=P.endLineNumber|0,v=R.endLineNumber|0;if(E===v){const a=P.endColumn|0,m=R.endColumn|0;return a-m}return E-v}return I-p}return y-A}return(P?1:0)-(R?1:0)}static compareRangesUsingEnds(P,R){return P.endLineNumber===R.endLineNumber?P.endColumn===R.endColumn?P.startLineNumber===R.startLineNumber?P.startColumn-R.startColumn:P.startLineNumber-R.startLineNumber:P.endColumn-R.endColumn:P.endLineNumber-R.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.$ct=L}),define(ke[174],Ee([1,0,29]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=void 0;class L{static insert(P,R){return{range:new u.$ct(P.lineNumber,P.column,P.lineNumber,P.column),text:R,forceMoveMarkers:!0}}static delete(P){return{range:P,text:null}}static replace(P,R){return{range:P,text:R}}static replaceMove(P,R){return{range:P,text:R,forceMoveMarkers:!0}}}e.$dt=L}),define(ke[175],Ee([1,0,49,29]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.SelectionDirection=void 0;var M;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(M||(e.SelectionDirection=M={}));class P extends L.$ct{constructor(b,$,y,A){super(b,$,y,A),this.selectionStartLineNumber=b,this.selectionStartColumn=$,this.positionLineNumber=y,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return P.selectionsEqual(this,b)}static selectionsEqual(b,$){return b.selectionStartLineNumber===$.selectionStartLineNumber&&b.selectionStartColumn===$.selectionStartColumn&&b.positionLineNumber===$.positionLineNumber&&b.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,$){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,b,$):new P(b,$,this.startLineNumber,this.startColumn)}getPosition(){return new u.$bt(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new u.$bt(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,$){return this.getDirection()===0?new P(b,$,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,b,$)}static fromPositions(b,$=b){return new P(b.lineNumber,b.column,$.lineNumber,$.column)}static fromRange(b,$){return $===0?new P(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new P(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new P(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,$){if(b&&!$||!b&&$)return!1;if(!b&&!$)return!0;if(b.length!==$.length)return!1;for(let y=0,A=b.length;y<A;y++)if(!this.selectionsEqual(b[y],$[y]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,$,y,A,I){return I===0?new P(b,$,y,A):new P(y,A,b,$)}}e.$et=P}),define(ke[176],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ms=void 0,e.$Ms={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[177],Ee([1,0,27,128]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bt=e.WordCharacterClass=void 0,e.$Ct=b;var M;(function($){$[$.Regular=0]="Regular",$[$.Whitespace=1]="Whitespace",$[$.WordSeparator=2]="WordSeparator"})(M||(e.WordCharacterClass=M={}));class P extends L.$zt{constructor(y,A){super(0),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=A,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let I=0,p=y.length;I<p;I++)this.set(y.charCodeAt(I),2);this.set(32,1),this.set(9,1)}findPrevIntlWordBeforeOrAtOffset(y,A){let I=null;for(const p of this.h(y)){if(p.index>A)break;I=p}return I}findNextIntlWordAtOrAfterOffset(y,A){for(const I of this.h(y))if(!(I.index<A))return I;return null}h(y){return this.e?this.f===y?this.g:(this.f=y,this.g=this.j(this.e.segment(y)),this.g):[]}j(y){const A=[];for(const I of y)this.k(I)&&A.push(I);return A}k(y){return!!y.isWordLike}}e.$Bt=P;const R=new u.$Ec(10);function b($,y){const A=`${$}/${y.join(",")}`;let I=R.get(A);return I||(I=new P($,y),R.set(A,I)),I}}),define(ke[129],Ee([1,0,38,3,75]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Os=e.$Ns=void 0,e.$Ps=R,e.$Qs=$,e.$Rs=y,e.$Ns="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(I=""){let p="(-?\\d*\\.\\d\\w*)|([^";for(const E of e.$Ns)I.indexOf(E)>=0||(p+="\\"+E);return p+="\\s]+)",new RegExp(p,"g")}e.$Os=P();function R(I){let p=e.$Os;if(I&&I instanceof RegExp)if(I.global)p=I;else{let E="g";I.ignoreCase&&(E+="i"),I.multiline&&(E+="m"),I.unicode&&(E+="u"),p=new RegExp(I.source,E)}return p.lastIndex=0,p}const b=new M.$5c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(I){const p=b.unshift(I);return(0,L.$Sc)(p)}function y(I,p,E,v,a){if(p=R(p),a||(a=u.Iterable.first(b)),E.length>a.maxLen){let r=I-a.maxLen/2;return r<0?r=0:v+=r,E=E.substring(r,I+a.maxLen/2),y(I,p,E,v,a)}const m=Date.now(),o=I-1-v;let n=-1,i=null;for(let r=1;!(Date.now()-m>=a.timeBudget);r++){const s=o-a.windowSize*r;p.lastIndex=Math.max(0,s);const t=A(p,E,o,n);if(!t&&i||(i=t,s<=0))break;n=s}if(i){const r={word:i[0],startColumn:v+1+i.index,endColumn:v+1+i.index+i[0].length};return p.lastIndex=0,r}return null}function A(I,p,E,v){let a;for(;a=I.exec(p);){const m=a.index||0;if(m<=E&&I.lastIndex>=E)return a;if(v>0&&m>v)return null}return null}}),define(ke[178],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cu=e.$bu=e.IndentAction=void 0;var u;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(u||(e.IndentAction=u={}));class L{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let $=0,y=b.notIn.length;$<y;$++)switch(b.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,$){if(b.getTokenCount()===0)return!0;const y=b.findTokenIndexAtOffset($-2),A=b.getStandardTokenType(y);return this.isOK(A)}g(b,$){for(let y=b;y<=$;y++){const A=String.fromCharCode(y);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$bu=L;class M{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of b)P(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),P(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),P(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),P(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&P(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$cu=M;function P(R,b,$){R.has(b)?R.get(b).push($):R.set(b,[$])}}),define(ke[179],Ee([1,0,128]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q2=e.$p2=e.State=void 0,e.$r2=p;var L;(function(E){E[E.Invalid=0]="Invalid",E[E.Start=1]="Start",E[E.H=2]="H",E[E.HT=3]="HT",E[E.HTT=4]="HTT",E[E.HTTP=5]="HTTP",E[E.F=6]="F",E[E.FI=7]="FI",E[E.FIL=8]="FIL",E[E.BeforeColon=9]="BeforeColon",E[E.AfterColon=10]="AfterColon",E[E.AlmostThere=11]="AlmostThere",E[E.End=12]="End",E[E.Accept=13]="Accept",E[E.LastKnownState=14]="LastKnownState"})(L||(e.State=L={}));class M{constructor(v,a,m){const o=new Uint8Array(v*a);for(let n=0,i=v*a;n<i;n++)o[n]=m;this.a=o,this.rows=v,this.cols=a}get(v,a){return this.a[v*this.cols+a]}set(v,a,m){this.a[v*this.cols+a]=m}}class P{constructor(v){let a=0,m=0;for(let n=0,i=v.length;n<i;n++){const[r,s,t]=v[n];s>a&&(a=s),r>m&&(m=r),t>m&&(m=t)}a++,m++;const o=new M(m,a,0);for(let n=0,i=v.length;n<i;n++){const[r,s,t]=v[n];o.set(r,s,t)}this.a=o,this.b=a}nextState(v,a){return a<0||a>=this.b?0:this.a.get(v,a)}}e.$p2=P;let R=null;function b(){return R===null&&(R=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var $;(function(E){E[E.None=0]="None",E[E.ForceTermination=1]="ForceTermination",E[E.CannotEndIn=2]="CannotEndIn"})($||($={}));let y=null;function A(){if(y===null){y=new u.$zt(0);const E=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let a=0;a<E.length;a++)y.set(E.charCodeAt(a),1);const v=".,;:";for(let a=0;a<v.length;a++)y.set(v.charCodeAt(a),2)}return y}class I{static a(v,a,m,o,n){let i=n-1;do{const r=a.charCodeAt(i);if(v.get(r)!==2)break;i--}while(i>o);if(o>0){const r=a.charCodeAt(o-1),s=a.charCodeAt(i);(r===40&&s===41||r===91&&s===93||r===123&&s===125)&&i--}return{range:{startLineNumber:m,startColumn:o+1,endLineNumber:m,endColumn:i+2},url:a.substring(o,i+1)}}static computeLinks(v,a=b()){const m=A(),o=[];for(let n=1,i=v.getLineCount();n<=i;n++){const r=v.getLineContent(n),s=r.length;let t=0,f=0,d=0,l=1,c=!1,h=!1,g=!1,S=!1;for(;t<s;){let w=!1;const C=r.charCodeAt(t);if(l===13){let k;switch(C){case 40:c=!0,k=0;break;case 41:k=c?0:1;break;case 91:g=!0,h=!0,k=0;break;case 93:g=!1,k=h?0:1;break;case 123:S=!0,k=0;break;case 125:k=S?0:1;break;case 39:case 34:case 96:d===C?k=1:d===39||d===34||d===96?k=0:k=1;break;case 42:k=d===42?1:0;break;case 124:k=d===124?1:0;break;case 32:k=g?0:1;break;default:k=m.get(C)}k===1&&(o.push(I.a(m,r,n,f,t)),w=!0)}else if(l===12){let k;C===91?(h=!0,k=0):k=m.get(C),k===1?w=!0:l=13}else l=a.nextState(l,C),l===0&&(w=!0);w&&(l=1,c=!1,h=!1,S=!1,f=t+1,d=C),t++}l===13&&o.push(I.a(m,r,n,f,s))}return o}}e.$q2=I;function p(E){return!E||typeof E.getLineCount!="function"||typeof E.getLineContent!="function"?[]:I.computeLinks(E)}}),define(ke[79],Ee([1,0,24]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Av=e.$zv=e.$yv=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$wv=e.$vv=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$xv=v,e.$Bv=r;var L;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=4]="Right",s[s.Full=7]="Full"})(L||(e.OverviewRulerLane=L={}));var M;(function(s){s[s.Left=1]="Left",s[s.Center=2]="Center",s[s.Right=3]="Right"})(M||(e.GlyphMarginLane=M={}));var P;(function(s){s[s.Inline=1]="Inline",s[s.Gutter=2]="Gutter"})(P||(e.MinimapPosition=P={}));var R;(function(s){s[s.Normal=1]="Normal",s[s.Underlined=2]="Underlined"})(R||(e.MinimapSectionHeaderStyle=R={}));var b;(function(s){s[s.Both=0]="Both",s[s.Right=1]="Right",s[s.Left=2]="Left",s[s.None=3]="None"})(b||(e.InjectedTextCursorStops=b={}));var $;(function(s){s[s.TextDefined=0]="TextDefined",s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})($||(e.EndOfLinePreference=$={}));var y;(function(s){s[s.LF=1]="LF",s[s.CRLF=2]="CRLF"})(y||(e.DefaultEndOfLine=y={}));var A;(function(s){s[s.LF=0]="LF",s[s.CRLF=1]="CRLF"})(A||(e.EndOfLineSequence=A={}));class I{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(t){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,t.tabSize|0),t.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,t.indentSize|0),this.a=!1),this.insertSpaces=!!t.insertSpaces,this.defaultEOL=t.defaultEOL|0,this.trimAutoWhitespace=!!t.trimAutoWhitespace,this.bracketPairColorizationOptions=t.bracketPairColorizationOptions}equals(t){return this.tabSize===t.tabSize&&this.a===t.a&&this.indentSize===t.indentSize&&this.insertSpaces===t.insertSpaces&&this.defaultEOL===t.defaultEOL&&this.trimAutoWhitespace===t.trimAutoWhitespace&&(0,u.$Sn)(this.bracketPairColorizationOptions,t.bracketPairColorizationOptions)}createChangeEvent(t){return{tabSize:this.tabSize!==t.tabSize,indentSize:this.indentSize!==t.indentSize,insertSpaces:this.insertSpaces!==t.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==t.trimAutoWhitespace}}}e.$vv=I;class p{constructor(t,f){this._findMatchBrand=void 0,this.range=t,this.matches=f}}e.$wv=p;var E;(function(s){s[s.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",s[s.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",s[s.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",s[s.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(E||(e.TrackedRangeStickiness=E={}));function v(s){return s&&typeof s.read=="function"}var a;(function(s){s[s.Left=0]="Left",s[s.Right=1]="Right",s[s.None=2]="None",s[s.LeftOfInjectedText=3]="LeftOfInjectedText",s[s.RightOfInjectedText=4]="RightOfInjectedText"})(a||(e.PositionAffinity=a={}));var m;(function(s){s[s.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(m||(e.ModelConstants=m={}));class o{constructor(t,f,d,l,c,h){this.identifier=t,this.range=f,this.text=d,this.forceMoveMarkers=l,this.isAutoWhitespaceEdit=c,this._isTracked=h}}e.$yv=o;class n{constructor(t,f,d){this.regex=t,this.wordSeparators=f,this.simpleSearch=d}}e.$zv=n;class i{constructor(t,f,d){this.reverseEdits=t,this.changes=f,this.trimAutoWhitespaceLineNumbers=d}}e.$Av=i;function r(s){return!s.isTooLargeForSyncing()&&!s.isForSimpleWidget}}),define(ke[180],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fC=e.NodeColor=e.$eC=void 0,e.$gC=M,e.$hC=P,e.$iC=y,e.$jC=A,e.$kC=I,e.$lC=p,e.$mC=E,e.$nC=v;class u{constructor(m,o){this.piece=m,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$fC)return M(this.right);let m=this;for(;m.parent!==e.$fC&&m.parent.left!==m;)m=m.parent;return m.parent===e.$fC?e.$fC:m.parent}prev(){if(this.left!==e.$fC)return P(this.left);let m=this;for(;m.parent!==e.$fC&&m.parent.right!==m;)m=m.parent;return m.parent===e.$fC?e.$fC:m.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$eC=u;var L;(function(a){a[a.Black=0]="Black",a[a.Red=1]="Red"})(L||(e.NodeColor=L={})),e.$fC=new u(null,0),e.$fC.parent=e.$fC,e.$fC.left=e.$fC,e.$fC.right=e.$fC,e.$fC.color=0;function M(a){for(;a.left!==e.$fC;)a=a.left;return a}function P(a){for(;a.right!==e.$fC;)a=a.right;return a}function R(a){return a===e.$fC?0:a.size_left+a.piece.length+R(a.right)}function b(a){return a===e.$fC?0:a.lf_left+a.piece.lineFeedCnt+b(a.right)}function $(){e.$fC.parent=e.$fC}function y(a,m){const o=m.right;o.size_left+=m.size_left+(m.piece?m.piece.length:0),o.lf_left+=m.lf_left+(m.piece?m.piece.lineFeedCnt:0),m.right=o.left,o.left!==e.$fC&&(o.left.parent=m),o.parent=m.parent,m.parent===e.$fC?a.root=o:m.parent.left===m?m.parent.left=o:m.parent.right=o,o.left=m,m.parent=o}function A(a,m){const o=m.left;m.left=o.right,o.right!==e.$fC&&(o.right.parent=m),o.parent=m.parent,m.size_left-=o.size_left+(o.piece?o.piece.length:0),m.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),m.parent===e.$fC?a.root=o:m===m.parent.right?m.parent.right=o:m.parent.left=o,o.right=m,m.parent=o}function I(a,m){let o,n;if(m.left===e.$fC?(n=m,o=n.right):m.right===e.$fC?(n=m,o=n.left):(n=M(m.right),o=n.right),n===a.root){a.root=o,o.color=0,m.detach(),$(),a.root.parent=e.$fC;return}const i=n.color===1;if(n===n.parent.left?n.parent.left=o:n.parent.right=o,n===m?(o.parent=n.parent,v(a,o)):(n.parent===m?o.parent=n:o.parent=n.parent,v(a,o),n.left=m.left,n.right=m.right,n.parent=m.parent,n.color=m.color,m===a.root?a.root=n:m===m.parent.left?m.parent.left=n:m.parent.right=n,n.left!==e.$fC&&(n.left.parent=n),n.right!==e.$fC&&(n.right.parent=n),n.size_left=m.size_left,n.lf_left=m.lf_left,v(a,n)),m.detach(),o.parent.left===o){const s=R(o),t=b(o);if(s!==o.parent.size_left||t!==o.parent.lf_left){const f=s-o.parent.size_left,d=t-o.parent.lf_left;o.parent.size_left=s,o.parent.lf_left=t,E(a,o.parent,f,d)}}if(v(a,o.parent),i){$();return}let r;for(;o!==a.root&&o.color===0;)o===o.parent.left?(r=o.parent.right,r.color===1&&(r.color=0,o.parent.color=1,y(a,o.parent),r=o.parent.right),r.left.color===0&&r.right.color===0?(r.color=1,o=o.parent):(r.right.color===0&&(r.left.color=0,r.color=1,A(a,r),r=o.parent.right),r.color=o.parent.color,o.parent.color=0,r.right.color=0,y(a,o.parent),o=a.root)):(r=o.parent.left,r.color===1&&(r.color=0,o.parent.color=1,A(a,o.parent),r=o.parent.left),r.left.color===0&&r.right.color===0?(r.color=1,o=o.parent):(r.left.color===0&&(r.right.color=0,r.color=1,y(a,r),r=o.parent.left),r.color=o.parent.color,o.parent.color=0,r.left.color=0,A(a,o.parent),o=a.root));o.color=0,$()}function p(a,m){for(v(a,m);m!==a.root&&m.parent.color===1;)if(m.parent===m.parent.parent.left){const o=m.parent.parent.right;o.color===1?(m.parent.color=0,o.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.right&&(m=m.parent,y(a,m)),m.parent.color=0,m.parent.parent.color=1,A(a,m.parent.parent))}else{const o=m.parent.parent.left;o.color===1?(m.parent.color=0,o.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.left&&(m=m.parent,A(a,m)),m.parent.color=0,m.parent.parent.color=1,y(a,m.parent.parent))}a.root.color=0}function E(a,m,o,n){for(;m!==a.root&&m!==e.$fC;)m.parent.left===m&&(m.parent.size_left+=o,m.parent.lf_left+=n),m=m.parent}function v(a,m){let o=0,n=0;if(m!==a.root){for(;m!==a.root&&m===m.parent.right;)m=m.parent;if(m!==a.root)for(m=m.parent,o=R(m.left)-m.size_left,n=b(m.left)-m.lf_left,m.size_left+=o,m.lf_left+=n;m!==a.root&&(o!==0||n!==0);)m.parent.left===m&&(m.parent.size_left+=o,m.parent.lf_left+=n),m=m.parent}}}),define(ke[181],Ee([1,0,19,127]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gv=e.$Fv=e.$Ev=void 0;class M{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,y){$=(0,L.$Te)($);const A=this.a,I=this.b,p=y.length;return p===0?!1:(this.a=new Uint32Array(A.length+p),this.a.set(A.subarray(0,$),0),this.a.set(A.subarray($),$+p),this.a.set(y,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}setValue($,y){return $=(0,L.$Te)($),y=(0,L.$Te)(y),this.a[$]===y?!1:(this.a[$]=y,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,y){$=(0,L.$Te)($),y=(0,L.$Te)(y);const A=this.a,I=this.b;if($>=A.length)return!1;const p=A.length-$;return y>=p&&(y=p),y===0?!1:(this.a=new Uint32Array(A.length-y),this.a.set(A.subarray(0,$),0),this.a.set(A.subarray($+y),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,L.$Te)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let y=this.c[0]+1;y===0&&(this.b[0]=this.a[0],y++),$>=this.a.length&&($=this.a.length-1);for(let A=y;A<=$;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let y=0,A=this.a.length-1,I=0,p=0,E=0;for(;y<=A;)if(I=y+(A-y)/2|0,p=this.b[I],E=p-this.a[I],$<E)A=I-1;else if($>=p)y=I+1;else break;return new R(I,$-E)}}e.$Ev=M;class P{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const y=this.e[$],A=y>0?this.d[y-1]:0;return new R(y,$-A)}removeValues($,y){this.a.splice($,y),this.f($)}insertValues($,y){this.a=(0,u.$Wb)(this.a,$,y),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,y=this.a.length;$<y;$++){const A=this.a[$],I=$>0?this.d[$-1]:0;this.d[$]=I+A;for(let p=0;p<A;p++)this.e[I+p]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,y){this.a[$]!==y&&(this.a[$]=y,this.f($))}}e.$Fv=P;class R{constructor($,y){this.index=$,this.remainder=y,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=y}}e.$Gv=R}),define(ke[182],Ee([1,0,14,49,181]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hv=void 0;class P{constructor(b,$,y,A){this.d=b,this.f=$,this.g=y,this.h=A,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(b){b.eol&&b.eol!==this.g&&(this.g=b.eol,this.j=null);const $=b.changes;for(const y of $)this.o(y.range),this.p(new L.$bt(y.range.startLineNumber,y.range.startColumn),y.text);this.h=b.versionId,this.k=null}l(){if(!this.j){const b=this.g.length,$=this.f.length,y=new Uint32Array($);for(let A=0;A<$;A++)y[A]=this.f[A].length+b;this.j=new M.$Ev(y)}}n(b,$){this.f[b]=$,this.j&&this.j.setValue(b,this.f[b].length+this.g.length)}o(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.startLineNumber-1].substring(b.endColumn-1));return}this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.endLineNumber-1].substring(b.endColumn-1)),this.f.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.j&&this.j.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}p(b,$){if($.length===0)return;const y=(0,u.$$e)($);if(y.length===1){this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+y[0]+this.f[b.lineNumber-1].substring(b.column-1));return}y[y.length-1]+=this.f[b.lineNumber-1].substring(b.column-1),this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+y[0]);const A=new Uint32Array(y.length-1);for(let I=1;I<y.length;I++)this.f.splice(b.lineNumber+I-1,0,y[I]),A[I-1]=y[I].length+this.g.length;this.j&&this.j.insertValues(b.lineNumber,A)}}e.$Hv=P}),define(ke[100],Ee([1,0,14,177,49,29,79]),function(he,e,u,L,M,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tC=e.$rC=e.$oC=void 0,e.$pC=y,e.$qC=A,e.$sC=a;const b=999;class ${constructor(n,i,r,s){this.searchString=n,this.isRegex=i,this.matchCase=r,this.wordSeparators=s}parseSearchRequest(){if(this.searchString==="")return null;let n;this.isRegex?n=y(this.searchString):n=this.searchString.indexOf(`
`)>=0;let i=null;try{i=u.$9e(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:n,global:!0,unicode:!0})}catch{return null}if(!i)return null;let r=!this.isRegex&&!n;return r&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(r=this.matchCase),new R.$zv(i,this.wordSeparators?(0,L.$Ct)(this.wordSeparators,[]):null,r?this.searchString:null)}}e.$oC=$;function y(o){if(!o||o.length===0)return!1;for(let n=0,i=o.length;n<i;n++){const r=o.charCodeAt(n);if(r===10)return!0;if(r===92){if(n++,n>=i)break;const s=o.charCodeAt(n);if(s===110||s===114||s===87)return!0}}return!1}function A(o,n,i){if(!i)return new R.$wv(o,null);const r=[];for(let s=0,t=n.length;s<t;s++)r[s]=n[s];return new R.$wv(o,r)}class I{constructor(n){const i=[];let r=0;for(let s=0,t=n.length;s<t;s++)n.charCodeAt(s)===10&&(i[r++]=s);this.a=i}findLineFeedCountBeforeOffset(n){const i=this.a;let r=0,s=i.length-1;if(s===-1||n<=i[0])return 0;for(;r<s;){const t=r+((s-r)/2>>0);i[t]>=n?s=t-1:i[t+1]>=n?(r=t,s=t):r=t+1}return r+1}}class p{static findMatches(n,i,r,s,t){const f=i.parseSearchRequest();return f?f.regex.multiline?this.b(n,r,new m(f.wordSeparators,f.regex),s,t):this.c(n,r,f,s,t):[]}static a(n,i,r,s,t,f){let d,l=0;s?(l=s.findLineFeedCountBeforeOffset(t),d=i+t+l):d=i+t;let c;if(s){const w=s.findLineFeedCountBeforeOffset(t+f.length)-l;c=d+f.length+w}else c=d+f.length;const h=n.getPositionAt(d),g=n.getPositionAt(c);return new P.$ct(h.lineNumber,h.column,g.lineNumber,g.column)}static b(n,i,r,s,t){const f=n.getOffsetAt(i.getStartPosition()),d=n.getValueInRange(i,1),l=n.getEOL()===`\r
`?new I(d):null,c=[];let h=0,g;for(r.reset(0);g=r.next(d);)if(c[h++]=A(this.a(n,f,d,l,g.index,g[0]),g,s),h>=t)return c;return c}static c(n,i,r,s,t){const f=[];let d=0;if(i.startLineNumber===i.endLineNumber){const c=n.getLineContent(i.startLineNumber).substring(i.startColumn-1,i.endColumn-1);return d=this.d(r,c,i.startLineNumber,i.startColumn-1,d,f,s,t),f}const l=n.getLineContent(i.startLineNumber).substring(i.startColumn-1);d=this.d(r,l,i.startLineNumber,i.startColumn-1,d,f,s,t);for(let c=i.startLineNumber+1;c<i.endLineNumber&&d<t;c++)d=this.d(r,n.getLineContent(c),c,0,d,f,s,t);if(d<t){const c=n.getLineContent(i.endLineNumber).substring(0,i.endColumn-1);d=this.d(r,c,i.endLineNumber,0,d,f,s,t)}return f}static d(n,i,r,s,t,f,d,l){const c=n.wordSeparators;if(!d&&n.simpleSearch){const S=n.simpleSearch,w=S.length,C=i.length;let k=-w;for(;(k=i.indexOf(S,k+w))!==-1;)if((!c||a(c,i,C,k,w))&&(f[t++]=new R.$wv(new P.$ct(r,k+1+s,r,k+1+w+s),null),t>=l))return t;return t}const h=new m(n.wordSeparators,n.regex);let g;h.reset(0);do if(g=h.next(i),g&&(f[t++]=A(new P.$ct(r,g.index+1+s,r,g.index+1+g[0].length+s),g,d),t>=l))return t;while(g);return t}static findNextMatch(n,i,r,s){const t=i.parseSearchRequest();if(!t)return null;const f=new m(t.wordSeparators,t.regex);return t.regex.multiline?this.e(n,r,f,s):this.f(n,r,f,s)}static e(n,i,r,s){const t=new M.$bt(i.lineNumber,1),f=n.getOffsetAt(t),d=n.getLineCount(),l=n.getValueInRange(new P.$ct(t.lineNumber,t.column,d,n.getLineMaxColumn(d)),1),c=n.getEOL()===`\r
`?new I(l):null;r.reset(i.column-1);const h=r.next(l);return h?A(this.a(n,f,l,c,h.index,h[0]),h,s):i.lineNumber!==1||i.column!==1?this.e(n,new M.$bt(1,1),r,s):null}static f(n,i,r,s){const t=n.getLineCount(),f=i.lineNumber,d=n.getLineContent(f),l=this.g(r,d,f,i.column,s);if(l)return l;for(let c=1;c<=t;c++){const h=(f+c-1)%t,g=n.getLineContent(h+1),S=this.g(r,g,h+1,1,s);if(S)return S}return null}static g(n,i,r,s,t){n.reset(s-1);const f=n.next(i);return f?A(new P.$ct(r,f.index+1,r,f.index+1+f[0].length),f,t):null}static findPreviousMatch(n,i,r,s){const t=i.parseSearchRequest();if(!t)return null;const f=new m(t.wordSeparators,t.regex);return t.regex.multiline?this.h(n,r,f,s):this.j(n,r,f,s)}static h(n,i,r,s){const t=this.b(n,new P.$ct(1,1,i.lineNumber,i.column),r,s,10*b);if(t.length>0)return t[t.length-1];const f=n.getLineCount();return i.lineNumber!==f||i.column!==n.getLineMaxColumn(f)?this.h(n,new M.$bt(f,n.getLineMaxColumn(f)),r,s):null}static j(n,i,r,s){const t=n.getLineCount(),f=i.lineNumber,d=n.getLineContent(f).substring(0,i.column-1),l=this.k(r,d,f,s);if(l)return l;for(let c=1;c<=t;c++){const h=(t+f-c-1)%t,g=n.getLineContent(h+1),S=this.k(r,g,h+1,s);if(S)return S}return null}static k(n,i,r,s){let t=null,f;for(n.reset(0);f=n.next(i);)t=A(new P.$ct(r,f.index+1,r,f.index+1+f[0].length),f,s);return t}}e.$rC=p;function E(o,n,i,r,s){if(r===0)return!0;const t=n.charCodeAt(r-1);if(o.get(t)!==0||t===13||t===10)return!0;if(s>0){const f=n.charCodeAt(r);if(o.get(f)!==0)return!0}return!1}function v(o,n,i,r,s){if(r+s===i)return!0;const t=n.charCodeAt(r+s);if(o.get(t)!==0||t===13||t===10)return!0;if(s>0){const f=n.charCodeAt(r+s-1);if(o.get(f)!==0)return!0}return!1}function a(o,n,i,r,s){return E(o,n,i,r,s)&&v(o,n,i,r,s)}class m{constructor(n,i){this._wordSeparators=n,this.a=i,this.b=-1,this.c=0}reset(n){this.a.lastIndex=n,this.b=-1,this.c=0}next(n){const i=n.length;let r;do{if(this.b+this.c===i||(r=this.a.exec(n),!r))return null;const s=r.index,t=r[0].length;if(s===this.b&&t===this.c){if(t===0){u.$sf(n,i,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=s,this.c=t,!this._wordSeparators||a(this._wordSeparators,n,i,s,t))return r}while(r);return null}}e.$tC=m}),define(ke[130],Ee([1,0,49,29,79,180,100]),function(he,e,u,L,M,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yC=e.$xC=e.$wC=void 0,e.$uC=A,e.$vC=I;const b=65535;function $(o){let n;return o[o.length-1]<65536?n=new Uint16Array(o.length):n=new Uint32Array(o.length),n.set(o,0),n}class y{constructor(n,i,r,s,t){this.lineStarts=n,this.cr=i,this.lf=r,this.crlf=s,this.isBasicASCII=t}}function A(o,n=!0){const i=[0];let r=1;for(let s=0,t=o.length;s<t;s++){const f=o.charCodeAt(s);f===13?s+1<t&&o.charCodeAt(s+1)===10?(i[r++]=s+2,s++):i[r++]=s+1:f===10&&(i[r++]=s+1)}return n?$(i):i}function I(o,n){o.length=0,o[0]=0;let i=1,r=0,s=0,t=0,f=!0;for(let l=0,c=n.length;l<c;l++){const h=n.charCodeAt(l);h===13?l+1<c&&n.charCodeAt(l+1)===10?(t++,o[i++]=l+2,l++):(r++,o[i++]=l+1):h===10?(s++,o[i++]=l+1):f&&h!==9&&(h<32||h>126)&&(f=!1)}const d=new y($(o),r,s,t,f);return o.length=0,d}class p{constructor(n,i,r,s,t){this.bufferIndex=n,this.start=i,this.end=r,this.lineFeedCnt=s,this.length=t}}e.$wC=p;class E{constructor(n,i){this.buffer=n,this.lineStarts=i}}e.$xC=E;class v{constructor(n,i){this.a=[],this.c=n,this.d=i,this.b=0,n.root!==P.$fC&&n.iterate(n.root,r=>(r!==P.$fC&&this.a.push(r.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class a{constructor(n){this.a=n,this.b=[]}get(n){for(let i=this.b.length-1;i>=0;i--){const r=this.b[i];if(r.nodeStartOffset<=n&&r.nodeStartOffset+r.node.piece.length>=n)return r}return null}get2(n){for(let i=this.b.length-1;i>=0;i--){const r=this.b[i];if(r.nodeStartLineNumber&&r.nodeStartLineNumber<n&&r.nodeStartLineNumber+r.node.piece.lineFeedCnt>=n)return r}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let i=!1;const r=this.b;for(let s=0;s<r.length;s++){const t=r[s];if(t.node.parent===null||t.nodeStartOffset>=n){r[s]=null,i=!0;continue}}if(i){const s=[];for(const t of r)t!==null&&s.push(t);this.b=s}}}class m{constructor(n,i,r){this.create(n,i,r)}create(n,i,r){this.a=[new E("",[0])],this.g={line:0,column:0},this.root=P.$fC,this.b=1,this.c=0,this.d=i,this.e=i.length,this.f=r;let s=null;for(let t=0,f=n.length;t<f;t++)if(n[t].buffer.length>0){n[t].lineStarts||(n[t].lineStarts=A(n[t].buffer));const d=new p(t+1,{line:0,column:0},{line:n[t].lineStarts.length-1,column:n[t].buffer.length-n[t].lineStarts[n[t].lineStarts.length-1]},n[t].lineStarts.length-1,n[t].buffer.length);this.a.push(n[t]),s=this.S(s,d)}this.h=new a(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const i=b,r=i-Math.floor(i/3),s=r*2;let t="",f=0;const d=[];if(this.iterate(this.root,l=>{const c=this.R(l),h=c.length;if(f<=r||f+h<s)return t+=c,f+=h,!0;const g=t.replace(/\r\n|\r|\n/g,n);return d.push(new E(g,A(g))),t=c,f=h,!0}),f>0){const l=t.replace(/\r\n|\r|\n/g,n);d.push(new E(l,A(l)))}this.create(d,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new v(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let i=0;return this.iterate(this.root,s=>{if(s===P.$fC)return!0;const t=this.R(s),f=t.length,d=n.G(i),l=n.G(i+f),c=n.getValueInRange2(d,l);return i+=f,t===c})}getOffsetAt(n,i){let r=0,s=this.root;for(;s!==P.$fC;)if(s.left!==P.$fC&&s.lf_left+1>=n)s=s.left;else if(s.lf_left+s.piece.lineFeedCnt+1>=n){r+=s.size_left;const t=this.B(s,n-s.lf_left-2);return r+=t+i-1}else n-=s.lf_left+s.piece.lineFeedCnt,r+=s.size_left+s.piece.length,s=s.right;return r}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let i=this.root,r=0;const s=n;for(;i!==P.$fC;)if(i.size_left!==0&&i.size_left>=n)i=i.left;else if(i.size_left+i.piece.length>=n){const t=this.A(i,n-i.size_left);if(r+=i.lf_left+t.index,t.index===0){const f=this.getOffsetAt(r+1,1),d=s-f;return new u.$bt(r+1,d+1)}return new u.$bt(r+1,t.remainder+1)}else if(n-=i.size_left+i.piece.length,r+=i.lf_left+i.piece.lineFeedCnt,i.right===P.$fC){const t=this.getOffsetAt(r+1,1),f=s-n-t;return new u.$bt(r+1,f+1)}else i=i.right;return new u.$bt(1,1)}getValueInRange(n,i){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const r=this.H(n.startLineNumber,n.startColumn),s=this.H(n.endLineNumber,n.endColumn),t=this.getValueInRange2(r,s);return i?i!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,i):i===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,i):t}getValueInRange2(n,i){if(n.node===i.node){const d=n.node,l=this.a[d.piece.bufferIndex].buffer,c=this.u(d.piece.bufferIndex,d.piece.start);return l.substring(c+n.remainder,c+i.remainder)}let r=n.node;const s=this.a[r.piece.bufferIndex].buffer,t=this.u(r.piece.bufferIndex,r.piece.start);let f=s.substring(t+n.remainder,t+r.piece.length);for(r=r.next();r!==P.$fC;){const d=this.a[r.piece.bufferIndex].buffer,l=this.u(r.piece.bufferIndex,r.piece.start);if(r===i.node){f+=d.substring(l,l+i.remainder);break}else f+=d.substr(l,r.piece.length);r=r.next()}return f}getLinesContent(){const n=[];let i=0,r="",s=!1;return this.iterate(this.root,t=>{if(t===P.$fC)return!0;const f=t.piece;let d=f.length;if(d===0)return!0;const l=this.a[f.bufferIndex].buffer,c=this.a[f.bufferIndex].lineStarts,h=f.start.line,g=f.end.line;let S=c[h]+f.start.column;if(s&&(l.charCodeAt(S)===10&&(S++,d--),n[i++]=r,r="",s=!1,d===0))return!0;if(h===g)return!this.f&&l.charCodeAt(S+d-1)===13?(s=!0,r+=l.substr(S,d-1)):r+=l.substr(S,d),!0;r+=this.f?l.substring(S,Math.max(S,c[h+1]-this.e)):l.substring(S,c[h+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=r;for(let w=h+1;w<g;w++)r=this.f?l.substring(c[w],c[w+1]-this.e):l.substring(c[w],c[w+1]).replace(/(\r\n|\r|\n)$/,""),n[i++]=r;return!this.f&&l.charCodeAt(c[g]+f.end.column-1)===13?(s=!0,f.end.column===0?i--:r=l.substr(c[g],f.end.column-1)):r=l.substr(c[g],f.end.column),!0}),s&&(n[i++]=r,r=""),n[i++]=r,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const i=n.node.next();if(!i)return 0;const r=this.a[i.piece.bufferIndex],s=this.u(i.piece.bufferIndex,i.piece.start);return r.buffer.charCodeAt(s)}else{const i=this.a[n.node.piece.bufferIndex],s=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return i.buffer.charCodeAt(s)}}getLineCharCode(n,i){const r=this.H(n,i+1);return this.l(r)}getLineLength(n){if(n===this.getLineCount()){const i=this.getOffsetAt(n,1);return this.getLength()-i}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const i=this.G(n);return this.l(i)}findMatchesInNode(n,i,r,s,t,f,d,l,c,h,g){const S=this.a[n.piece.bufferIndex],w=this.u(n.piece.bufferIndex,n.piece.start),C=this.u(n.piece.bufferIndex,t),k=this.u(n.piece.bufferIndex,f);let D;const O={line:0,column:0};let F,T;i._wordSeparators?(F=S.buffer.substring(C,k),T=z=>z+C,i.reset(0)):(F=S.buffer,T=z=>z,i.reset(C));do if(D=i.next(F),D){if(T(D.index)>=k)return h;this.s(n,T(D.index)-w,O);const z=this.t(n.piece.bufferIndex,t,O),j=O.line===t.line?O.column-t.column+s:O.column+1,N=j+D[0].length;if(g[h++]=(0,R.$qC)(new L.$ct(r+z,j,r+z,N),D,l),T(D.index)+D[0].length>=k||h>=c)return h}while(D);return h}findMatchesLineByLine(n,i,r,s){const t=[];let f=0;const d=new R.$tC(i.wordSeparators,i.regex);let l=this.H(n.startLineNumber,n.startColumn);if(l===null)return[];const c=this.H(n.endLineNumber,n.endColumn);if(c===null)return[];let h=this.s(l.node,l.remainder);const g=this.s(c.node,c.remainder);if(l.node===c.node)return this.findMatchesInNode(l.node,d,n.startLineNumber,n.startColumn,h,g,i,r,s,f,t),t;let S=n.startLineNumber,w=l.node;for(;w!==c.node;){const k=this.t(w.piece.bufferIndex,h,w.piece.end);if(k>=1){const O=this.a[w.piece.bufferIndex].lineStarts,F=this.u(w.piece.bufferIndex,w.piece.start),T=O[h.line+k],z=S===n.startLineNumber?n.startColumn:1;if(f=this.findMatchesInNode(w,d,S,z,h,this.s(w,T-F),i,r,s,f,t),f>=s)return t;S+=k}const D=S===n.startLineNumber?n.startColumn-1:0;if(S===n.endLineNumber){const O=this.getLineContent(S).substring(D,n.endColumn-1);return f=this.n(i,d,O,n.endLineNumber,D,f,t,r,s),t}if(f=this.n(i,d,this.getLineContent(S).substr(D),S,D,f,t,r,s),f>=s)return t;S++,l=this.H(S,1),w=l.node,h=this.s(l.node,l.remainder)}if(S===n.endLineNumber){const k=S===n.startLineNumber?n.startColumn-1:0,D=this.getLineContent(S).substring(k,n.endColumn-1);return f=this.n(i,d,D,n.endLineNumber,k,f,t,r,s),t}const C=S===n.startLineNumber?n.startColumn:1;return f=this.findMatchesInNode(c.node,d,S,C,h,g,i,r,s,f,t),t}n(n,i,r,s,t,f,d,l,c){const h=n.wordSeparators;if(!l&&n.simpleSearch){const S=n.simpleSearch,w=S.length,C=r.length;let k=-w;for(;(k=r.indexOf(S,k+w))!==-1;)if((!h||(0,R.$sC)(h,r,C,k,w))&&(d[f++]=new M.$wv(new L.$ct(s,k+1+t,s,k+1+w+t),null),f>=c))return f;return f}let g;i.reset(0);do if(g=i.next(r),g&&(d[f++]=(0,R.$qC)(new L.$ct(s,g.index+1+t,s,g.index+1+g[0].length+t),g,l),f>=c))return f;while(g);return f}insert(n,i,r=!1){if(this.f=this.f&&r,this.j.lineNumber=0,this.j.value="",this.root!==P.$fC){const{node:s,remainder:t,nodeStartOffset:f}=this.G(n),d=s.piece,l=d.bufferIndex,c=this.s(s,t);if(s.piece.bufferIndex===0&&d.end.line===this.g.line&&d.end.column===this.g.column&&f+d.length===n&&i.length<b){this.F(s,i),this.y();return}if(f===n)this.o(i,s),this.h.validate(n);else if(f+s.piece.length>n){const h=[];let g=new p(d.bufferIndex,c,d.end,this.t(d.bufferIndex,c,d.end),this.u(l,d.end)-this.u(l,c));if(this.K()&&this.M(i)&&this.I(s,t)===10){const k={line:g.start.line+1,column:0};g=new p(g.bufferIndex,k,g.end,this.t(g.bufferIndex,k,g.end),g.length-1),i+=`
`}if(this.K()&&this.L(i))if(this.I(s,t-1)===13){const k=this.s(s,t-1);this.C(s,k),i="\r"+i,s.piece.length===0&&h.push(s)}else this.C(s,c);else this.C(s,c);const S=this.w(i);g.length>0&&this.S(s,g);let w=s;for(let C=0;C<S.length;C++)w=this.S(w,S[C]);this.v(h)}else this.q(i,s)}else{const s=this.w(i);let t=this.T(null,s[0]);for(let f=1;f<s.length;f++)t=this.S(t,s[f])}this.y()}delete(n,i){if(this.j.lineNumber=0,this.j.value="",i<=0||this.root===P.$fC)return;const r=this.G(n),s=this.G(n+i),t=r.node,f=s.node;if(t===f){const S=this.s(t,r.remainder),w=this.s(t,s.remainder);if(r.nodeStartOffset===n){if(i===t.piece.length){const C=t.next();(0,P.$kC)(this,t),this.N(C),this.y();return}this.D(t,w),this.h.validate(n),this.N(t),this.y();return}if(r.nodeStartOffset+t.piece.length===n+i){this.C(t,S),this.O(t),this.y();return}this.E(t,S,w),this.y();return}const d=[],l=this.s(t,r.remainder);this.C(t,l),this.h.validate(n),t.piece.length===0&&d.push(t);const c=this.s(f,s.remainder);this.D(f,c),f.piece.length===0&&d.push(f);const h=t.next();for(let S=h;S!==P.$fC&&S!==f;S=S.next())d.push(S);const g=t.piece.length===0?t.prev():t;this.v(d),this.O(g),this.y()}o(n,i){const r=[];if(this.K()&&this.M(n)&&this.L(i)){const f=i.piece,d={line:f.start.line+1,column:0},l=new p(f.bufferIndex,d,f.end,this.t(f.bufferIndex,d,f.end),f.length-1);i.piece=l,n+=`
`,(0,P.$mC)(this,i,-1,-1),i.piece.length===0&&r.push(i)}const s=this.w(n);let t=this.T(i,s[s.length-1]);for(let f=s.length-2;f>=0;f--)t=this.T(t,s[f]);this.N(t),this.v(r)}q(n,i){this.Q(n,i)&&(n+=`
`);const r=this.w(n),s=this.S(i,r[0]);let t=s;for(let f=1;f<r.length;f++)t=this.S(t,r[f]);this.N(s)}s(n,i,r){const s=n.piece,t=n.piece.bufferIndex,f=this.a[t].lineStarts,l=f[s.start.line]+s.start.column+i;let c=s.start.line,h=s.end.line,g=0,S=0,w=0;for(;c<=h&&(g=c+(h-c)/2|0,w=f[g],g!==h);)if(S=f[g+1],l<w)h=g-1;else if(l>=S)c=g+1;else break;return r?(r.line=g,r.column=l-w,null):{line:g,column:l-w}}t(n,i,r){if(r.column===0)return r.line-i.line;const s=this.a[n].lineStarts;if(r.line===s.length-1)return r.line-i.line;const t=s[r.line+1],f=s[r.line]+r.column;if(t>f+1)return r.line-i.line;const d=f-1;return this.a[n].buffer.charCodeAt(d)===13?r.line-i.line+1:r.line-i.line}u(n,i){return this.a[n].lineStarts[i.line]+i.column}v(n){for(let i=0;i<n.length;i++)(0,P.$kC)(this,n[i])}w(n){if(n.length>b){const h=[];for(;n.length>b;){const S=n.charCodeAt(b-1);let w;S===13||S>=55296&&S<=56319?(w=n.substring(0,b-1),n=n.substring(b-1)):(w=n.substring(0,b),n=n.substring(b));const C=A(w);h.push(new p(this.a.length,{line:0,column:0},{line:C.length-1,column:w.length-C[C.length-1]},C.length-1,w.length)),this.a.push(new E(w,C))}const g=A(n);return h.push(new p(this.a.length,{line:0,column:0},{line:g.length-1,column:n.length-g[g.length-1]},g.length-1,n.length)),this.a.push(new E(n,g)),h}let i=this.a[0].buffer.length;const r=A(n,!1);let s=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===i&&i!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},s=this.g;for(let h=0;h<r.length;h++)r[h]+=i+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+="_"+n,i+=1}else{if(i!==0)for(let h=0;h<r.length;h++)r[h]+=i;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+=n}const t=this.a[0].buffer.length,f=this.a[0].lineStarts.length-1,d=t-this.a[0].lineStarts[f],l={line:f,column:d},c=new p(0,s,l,this.t(0,s,l),t-i);return this.g=l,[c]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,i=0){let r=this.root,s="";const t=this.h.get2(n);if(t){r=t.node;const f=this.B(r,n-t.nodeStartLineNumber-1),d=this.a[r.piece.bufferIndex].buffer,l=this.u(r.piece.bufferIndex,r.piece.start);if(t.nodeStartLineNumber+r.piece.lineFeedCnt===n)s=d.substring(l+f,l+r.piece.length);else{const c=this.B(r,n-t.nodeStartLineNumber);return d.substring(l+f,l+c-i)}}else{let f=0;const d=n;for(;r!==P.$fC;)if(r.left!==P.$fC&&r.lf_left>=n-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>n-1){const l=this.B(r,n-r.lf_left-2),c=this.B(r,n-r.lf_left-1),h=this.a[r.piece.bufferIndex].buffer,g=this.u(r.piece.bufferIndex,r.piece.start);return f+=r.size_left,this.h.set({node:r,nodeStartOffset:f,nodeStartLineNumber:d-(n-1-r.lf_left)}),h.substring(g+l,g+c-i)}else if(r.lf_left+r.piece.lineFeedCnt===n-1){const l=this.B(r,n-r.lf_left-2),c=this.a[r.piece.bufferIndex].buffer,h=this.u(r.piece.bufferIndex,r.piece.start);s=c.substring(h+l,h+r.piece.length);break}else n-=r.lf_left+r.piece.lineFeedCnt,f+=r.size_left+r.piece.length,r=r.right}for(r=r.next();r!==P.$fC;){const f=this.a[r.piece.bufferIndex].buffer;if(r.piece.lineFeedCnt>0){const d=this.B(r,0),l=this.u(r.piece.bufferIndex,r.piece.start);return s+=f.substring(l,l+d-i),s}else{const d=this.u(r.piece.bufferIndex,r.piece.start);s+=f.substr(d,r.piece.length)}r=r.next()}return s}y(){let n=this.root,i=1,r=0;for(;n!==P.$fC;)i+=n.lf_left+n.piece.lineFeedCnt,r+=n.size_left+n.piece.length,n=n.right;this.b=i,this.c=r,this.h.validate(this.c)}A(n,i){const r=n.piece,s=this.s(n,i),t=s.line-r.start.line;if(this.u(r.bufferIndex,r.end)-this.u(r.bufferIndex,r.start)===i){const f=this.t(n.piece.bufferIndex,r.start,s);if(f!==t)return{index:f,remainder:0}}return{index:t,remainder:s.column}}B(n,i){if(i<0)return 0;const r=n.piece,s=this.a[r.bufferIndex].lineStarts,t=r.start.line+i+1;return t>r.end.line?s[r.end.line]+r.end.column-s[r.start.line]-r.start.column:s[t]-s[r.start.line]-r.start.column}C(n,i){const r=n.piece,s=r.lineFeedCnt,t=this.u(r.bufferIndex,r.end),f=i,d=this.u(r.bufferIndex,f),l=this.t(r.bufferIndex,r.start,f),c=l-s,h=d-t,g=r.length+h;n.piece=new p(r.bufferIndex,r.start,f,l,g),(0,P.$mC)(this,n,h,c)}D(n,i){const r=n.piece,s=r.lineFeedCnt,t=this.u(r.bufferIndex,r.start),f=i,d=this.t(r.bufferIndex,f,r.end),l=this.u(r.bufferIndex,f),c=d-s,h=t-l,g=r.length+h;n.piece=new p(r.bufferIndex,f,r.end,d,g),(0,P.$mC)(this,n,h,c)}E(n,i,r){const s=n.piece,t=s.start,f=s.end,d=s.length,l=s.lineFeedCnt,c=i,h=this.t(s.bufferIndex,s.start,c),g=this.u(s.bufferIndex,i)-this.u(s.bufferIndex,t);n.piece=new p(s.bufferIndex,s.start,c,h,g),(0,P.$mC)(this,n,g-d,h-l);const S=new p(s.bufferIndex,r,f,this.t(s.bufferIndex,r,f),this.u(s.bufferIndex,f)-this.u(s.bufferIndex,r)),w=this.S(n,S);this.N(w)}F(n,i){this.Q(i,n)&&(i+=`
`);const r=this.K()&&this.L(i)&&this.M(n),s=this.a[0].buffer.length;this.a[0].buffer+=i;const t=A(i,!1);for(let w=0;w<t.length;w++)t[w]+=s;if(r){const w=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:s-w}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const f=this.a[0].lineStarts.length-1,d=this.a[0].buffer.length-this.a[0].lineStarts[f],l={line:f,column:d},c=n.piece.length+i.length,h=n.piece.lineFeedCnt,g=this.t(0,n.piece.start,l),S=g-h;n.piece=new p(n.piece.bufferIndex,n.piece.start,l,g,c),this.g=l,(0,P.$mC)(this,n,i.length,S)}G(n){let i=this.root;const r=this.h.get(n);if(r)return{node:r.node,nodeStartOffset:r.nodeStartOffset,remainder:n-r.nodeStartOffset};let s=0;for(;i!==P.$fC;)if(i.size_left>n)i=i.left;else if(i.size_left+i.piece.length>=n){s+=i.size_left;const t={node:i,remainder:n-i.size_left,nodeStartOffset:s};return this.h.set(t),t}else n-=i.size_left+i.piece.length,s+=i.size_left+i.piece.length,i=i.right;return null}H(n,i){let r=this.root,s=0;for(;r!==P.$fC;)if(r.left!==P.$fC&&r.lf_left>=n-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>n-1){const t=this.B(r,n-r.lf_left-2),f=this.B(r,n-r.lf_left-1);return s+=r.size_left,{node:r,remainder:Math.min(t+i-1,f),nodeStartOffset:s}}else if(r.lf_left+r.piece.lineFeedCnt===n-1){const t=this.B(r,n-r.lf_left-2);if(t+i-1<=r.piece.length)return{node:r,remainder:t+i-1,nodeStartOffset:s};i-=r.piece.length-t;break}else n-=r.lf_left+r.piece.lineFeedCnt,s+=r.size_left+r.piece.length,r=r.right;for(r=r.next();r!==P.$fC;){if(r.piece.lineFeedCnt>0){const t=this.B(r,0),f=this.J(r);return{node:r,remainder:Math.min(i-1,t),nodeStartOffset:f}}else if(r.piece.length>=i-1){const t=this.J(r);return{node:r,remainder:i-1,nodeStartOffset:t}}else i-=r.piece.length;r=r.next()}return null}I(n,i){if(n.piece.lineFeedCnt<1)return-1;const r=this.a[n.piece.bufferIndex],s=this.u(n.piece.bufferIndex,n.piece.start)+i;return r.buffer.charCodeAt(s)}J(n){if(!n)return 0;let i=n.size_left;for(;n!==this.root;)n.parent.right===n&&(i+=n.parent.size_left+n.parent.piece.length),n=n.parent;return i}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===P.$fC||n.piece.lineFeedCnt===0)return!1;const i=n.piece,r=this.a[i.bufferIndex].lineStarts,s=i.start.line,t=r[s]+i.start.column;return s===r.length-1||r[s+1]>t+1?!1:this.a[i.bufferIndex].buffer.charCodeAt(t)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===P.$fC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const i=n.prev();this.M(i)&&this.P(i,n)}}O(n){if(this.K()&&this.M(n)){const i=n.next();this.L(i)&&this.P(n,i)}}P(n,i){const r=[],s=this.a[n.piece.bufferIndex].lineStarts;let t;n.piece.end.column===0?t={line:n.piece.end.line-1,column:s[n.piece.end.line]-s[n.piece.end.line-1]-1}:t={line:n.piece.end.line,column:n.piece.end.column-1};const f=n.piece.length-1,d=n.piece.lineFeedCnt-1;n.piece=new p(n.piece.bufferIndex,n.piece.start,t,d,f),(0,P.$mC)(this,n,-1,-1),n.piece.length===0&&r.push(n);const l={line:i.piece.start.line+1,column:0},c=i.piece.length-1,h=this.t(i.piece.bufferIndex,l,i.piece.end);i.piece=new p(i.piece.bufferIndex,l,i.piece.end,h,c),(0,P.$mC)(this,i,-1,-1),i.piece.length===0&&r.push(i);const g=this.w(`\r
`);this.S(n,g[0]);for(let S=0;S<r.length;S++)(0,P.$kC)(this,r[S])}Q(n,i){if(this.K()&&this.M(n)){const r=i.next();if(this.L(r)){if(n+=`
`,r.piece.length===1)(0,P.$kC)(this,r);else{const s=r.piece,t={line:s.start.line+1,column:0},f=s.length-1,d=this.t(s.bufferIndex,t,s.end);r.piece=new p(s.bufferIndex,t,s.end,d,f),(0,P.$mC)(this,r,-1,-1)}return!0}}return!1}iterate(n,i){if(n===P.$fC)return i(P.$fC);const r=this.iterate(n.left,i);return r&&i(n)&&this.iterate(n.right,i)}R(n){if(n===P.$fC)return"";const i=this.a[n.piece.bufferIndex],r=n.piece,s=this.u(r.bufferIndex,r.start),t=this.u(r.bufferIndex,r.end);return i.buffer.substring(s,t)}getPieceContent(n){const i=this.a[n.bufferIndex],r=this.u(n.bufferIndex,n.start),s=this.u(n.bufferIndex,n.end);return i.buffer.substring(r,s)}S(n,i){const r=new P.$eC(i,1);if(r.left=P.$fC,r.right=P.$fC,r.parent=P.$fC,r.size_left=0,r.lf_left=0,this.root===P.$fC)this.root=r,r.color=0;else if(n.right===P.$fC)n.right=r,r.parent=n;else{const t=(0,P.$gC)(n.right);t.left=r,r.parent=t}return(0,P.$lC)(this,r),r}T(n,i){const r=new P.$eC(i,1);if(r.left=P.$fC,r.right=P.$fC,r.parent=P.$fC,r.size_left=0,r.lf_left=0,this.root===P.$fC)this.root=r,r.color=0;else if(n.left===P.$fC)n.left=r,r.parent=n;else{const s=(0,P.$hC)(n.left);s.right=r,r.parent=s}return(0,P.$lC)(this,r),r}U(n){let i="";return this.iterate(n,r=>(i+=this.R(r),!0)),i}}e.$yC=m}),define(ke[183],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b0=e.$a0=void 0;class u{constructor(){this.a=new Map}removeDragOperationTransfer(P){if(P&&this.a.has(P)){const R=this.a.get(P);return this.a.delete(P),R}}addDragOperationTransfer(P,R){this.a.set(P,R)}}e.$a0=u;class L{constructor(P){this.identifier=P}}e.$b0=L}),define(ke[184],Ee([1,0,4,3]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nt=void 0;class M{constructor(){this.a=new Map,this.b=new Map,this.c=new u.$7d,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,$){return this.a.set(b,$),this.handleChange([b]),(0,L.$Sc)(()=>{this.a.get(b)===$&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,$){this.b.get(b)?.dispose();const y=new P(this,b,$);return this.b.set(b,y),(0,L.$Sc)(()=>{const A=this.b.get(b);!A||A!==y||(this.b.delete(b),A.dispose())})}async getOrCreate(b){const $=this.get(b);if($)return $;const y=this.b.get(b);return!y||y.isResolved?null:(await y.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const y=this.b.get(b);return!!(!y||y.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Nt=M;class P extends L.$Uc{get isResolved(){return this.c}constructor(b,$,y){super(),this.f=b,this.g=$,this.h=y,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(ke[185],Ee([9,10]),function(he,e){return he.create("vs/base/common/actions",e)}),define(ke[186],Ee([1,0,4,3,185]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=void 0,e.$5i=A;class P extends L.$Uc{constructor(p,E="",v="",a=!0,m){super(),this.h=this.B(new u.$7d),this.onDidChange=this.h.event,this.w=!0,this.j=p,this.m=E,this.u=v,this.w=a,this.C=m}get id(){return this.j}get label(){return this.m}set label(p){this.D(p)}D(p){this.m!==p&&(this.m=p,this.h.fire({label:p}))}get tooltip(){return this.n||""}set tooltip(p){this.F(p)}F(p){this.n!==p&&(this.n=p,this.h.fire({tooltip:p}))}get class(){return this.u}set class(p){this.G(p)}G(p){this.u!==p&&(this.u=p,this.h.fire({class:p}))}get enabled(){return this.w}set enabled(p){this.H(p)}H(p){this.w!==p&&(this.w=p,this.h.fire({enabled:p}))}get checked(){return this.z}set checked(p){this.I(p)}I(p){this.z!==p&&(this.z=p,this.h.fire({checked:p}))}async run(p,E){this.C&&await this.C(p)}}e.$Zi=P;class R extends L.$Uc{constructor(){super(...arguments),this.f=this.B(new u.$7d),this.onWillRun=this.f.event,this.m=this.B(new u.$7d),this.onDidRun=this.m.event}async run(p,E){if(!p.enabled)return;this.f.fire({action:p});let v;try{await this.u(p,E)}catch(a){v=a}this.m.fire({action:p,error:v})}async u(p,E){await p.run(E)}}e.$1i=R;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...p){let E=[];for(const v of p)v.length&&(E.length?E=[...E,new b,...v]:E=v);return E}static{this.ID="vs.actions.separator"}async run(){}}e.$2i=b;class ${get actions(){return this.a}constructor(p,E,v,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=p,this.label=E,this.class=a,this.a=v}async run(){}}e.$3i=$;class y extends P{static{this.ID="vs.actions.empty"}constructor(){super(y.ID,M.localize(0,null),void 0,!1)}}e.$4i=y;function A(I){return{id:I.id,label:I.label,class:I.class,enabled:I.enabled??!0,checked:I.checked,run:async(...p)=>I.run(...p),tooltip:I.label}}}),define(ke[187],Ee([9,10]),function(he,e){return he.create("vs/base/common/date",e)}),define(ke[188],Ee([1,0,187]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=y,e.$Om=A,e.$Pm=I;const L=60,M=L*60,P=M*24,R=P*7,b=P*30,$=P*365;function y(p,E,v,a){typeof p!="number"&&(p=p.getTime());const m=Math.round((new Date().getTime()-p)/1e3);if(m<-30)return(0,u.localize)(0,null,y(new Date().getTime()+m*1e3,!1));if(!a&&m<30)return(0,u.localize)(1,null);let o;return m<L?(o=m,E?o===1?v?(0,u.localize)(2,null,o):(0,u.localize)(3,null,o):v?(0,u.localize)(4,null,o):(0,u.localize)(5,null,o):o===1?v?(0,u.localize)(6,null,o):(0,u.localize)(7,null,o):v?(0,u.localize)(8,null,o):(0,u.localize)(9,null,o)):m<M?(o=Math.floor(m/L),E?o===1?v?(0,u.localize)(10,null,o):(0,u.localize)(11,null,o):v?(0,u.localize)(12,null,o):(0,u.localize)(13,null,o):o===1?v?(0,u.localize)(14,null,o):(0,u.localize)(15,null,o):v?(0,u.localize)(16,null,o):(0,u.localize)(17,null,o)):m<P?(o=Math.floor(m/M),E?o===1?v?(0,u.localize)(18,null,o):(0,u.localize)(19,null,o):v?(0,u.localize)(20,null,o):(0,u.localize)(21,null,o):o===1?v?(0,u.localize)(22,null,o):(0,u.localize)(23,null,o):v?(0,u.localize)(24,null,o):(0,u.localize)(25,null,o)):m<R?(o=Math.floor(m/P),E?o===1?(0,u.localize)(26,null,o):(0,u.localize)(27,null,o):o===1?(0,u.localize)(28,null,o):(0,u.localize)(29,null,o)):m<b?(o=Math.floor(m/R),E?o===1?v?(0,u.localize)(30,null,o):(0,u.localize)(31,null,o):v?(0,u.localize)(32,null,o):(0,u.localize)(33,null,o):o===1?v?(0,u.localize)(34,null,o):(0,u.localize)(35,null,o):v?(0,u.localize)(36,null,o):(0,u.localize)(37,null,o)):m<$?(o=Math.floor(m/b),E?o===1?v?(0,u.localize)(38,null,o):(0,u.localize)(39,null,o):v?(0,u.localize)(40,null,o):(0,u.localize)(41,null,o):o===1?v?(0,u.localize)(42,null,o):(0,u.localize)(43,null,o):v?(0,u.localize)(44,null,o):(0,u.localize)(45,null,o)):(o=Math.floor(m/$),E?o===1?v?(0,u.localize)(46,null,o):(0,u.localize)(47,null,o):v?(0,u.localize)(48,null,o):(0,u.localize)(49,null,o):o===1?v?(0,u.localize)(50,null,o):(0,u.localize)(51,null,o):v?(0,u.localize)(52,null,o):(0,u.localize)(53,null,o))}function A(p,E){const v=Math.abs(p/1e3);return v<1?E?(0,u.localize)(54,null,p):(0,u.localize)(55,null,p):v<L?E?(0,u.localize)(56,null,Math.round(p)/1e3):(0,u.localize)(57,null,Math.round(p)/1e3):v<M?E?(0,u.localize)(58,null,Math.round(p/(1e3*L))):(0,u.localize)(59,null,Math.round(p/(1e3*L))):v<P?E?(0,u.localize)(60,null,Math.round(p/(1e3*M))):(0,u.localize)(61,null,Math.round(p/(1e3*M))):(0,u.localize)(62,null,Math.round(p/(1e3*P)))}function I(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ke[189],Ee([9,10]),function(he,e){return he.create("vs/base/common/errorMessage",e)}),define(ke[46],Ee([1,0,19,18,189]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6i=$,e.$7i=y,e.$8i=A;function P(I,p){return p&&(I.stack||I.stacktrace)?M.localize(0,null,b(I),R(I.stack)||R(I.stacktrace)):b(I)}function R(I){return Array.isArray(I)?I.join(`
`):I}function b(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?M.localize(1,null,I.message):I.message||M.localize(2,null)}function $(I=null,p=!1){if(!I)return M.localize(3,null);if(Array.isArray(I)){const E=u.$Hb(I),v=$(E[0],p);return E.length>1?M.localize(4,null,v,E.length):v}if(L.$Vf(I))return I;if(I.detail){const E=I.detail;if(E.error)return P(E.error,p);if(E.exception)return P(E.exception,p)}return I.stack?P(I,p):I.message?I.message:M.localize(5,null)}function y(I){const p=I;return p instanceof Error&&Array.isArray(p.actions)}function A(I,p){let E;return typeof I=="string"?E=new Error(I):E=I,E.actions=p,E}}),define(ke[190],Ee([9,10]),function(he,e){return he.create("vs/base/common/platform",e)}),define(ke[11],Ee([1,0,190]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=f,e.$D=S,e.$J=w,e.$g="en";let L=!1,M=!1,P=!1,R=!1,b=!1,$=!1,y=!1,A=!1,I=!1,p=!1,E,v=e.$g,a=e.$g,m,o;const n=globalThis;let i;typeof n.vscode<"u"&&typeof n.vscode.process<"u"?i=n.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(i=process);const r=typeof i?.versions?.electron=="string",s=r&&i?.type==="renderer";if(typeof i=="object"){L=i.platform==="win32",M=i.platform==="darwin",P=i.platform==="linux",R=P&&!!i.env.SNAP&&!!i.env.SNAP_REVISION,y=r,I=!!i.env.CI||!!i.env.BUILD_ARTIFACTSTAGINGDIRECTORY,E=e.$g,v=e.$g;const C=i.env.VSCODE_NLS_CONFIG;if(C)try{const k=JSON.parse(C),D=k.availableLanguages["*"];E=k.locale,a=k.osLocale,v=D||e.$g,m=k._translationsConfigFile}catch{}b=!0}else typeof navigator=="object"&&!s?(o=navigator.userAgent,L=o.indexOf("Windows")>=0,M=o.indexOf("Macintosh")>=0,A=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=o.indexOf("Linux")>=0,p=o?.indexOf("Mobi")>=0,$=!0,E=u.getConfiguredDefaultLocale(u.localize(0,null))||e.$g,v=E,a=navigator.language):console.error("Unable to resolve platform.");var t;(function(C){C[C.Web=0]="Web",C[C.Mac=1]="Mac",C[C.Linux=2]="Linux",C[C.Windows=3]="Windows"})(t||(e.Platform=t={}));function f(C){switch(C){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let d=0;M?d=1:L?d=3:P&&(d=2),e.$i=L,e.$j=M,e.$k=P,e.$l=R,e.$m=b,e.$n=y,e.$o=$,e.$p=$&&typeof n.importScripts=="function",e.$q=e.$p?n.origin:void 0,e.$r=A,e.$s=p,e.$t=I,e.$u=d,e.$v=o,e.$w=v;var l;(function(C){function k(){return e.$w}C.value=k;function D(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}C.isDefaultVariant=D;function O(){return e.$w==="en"}C.isDefault=O})(l||(e.Language=l={})),e.$x=E,e.$y=a,e.$z=m,e.$A=typeof n.postMessage=="function"&&!n.importScripts,e.$B=(()=>{if(e.$A){const C=[];n.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let O=0,F=C.length;O<F;O++){const T=C[O];if(T.id===D.data.vscodeScheduleAsyncWork){C.splice(O,1),T.callback();return}}});let k=0;return D=>{const O=++k;C.push({id:O,callback:D}),n.postMessage({vscodeScheduleAsyncWork:O},"*")}}return C=>setTimeout(C)})();var c;(function(C){C[C.Windows=1]="Windows",C[C.Macintosh=2]="Macintosh",C[C.Linux=3]="Linux"})(c||(e.OperatingSystem=c={})),e.OS=M||A?2:L?1:3;let h=!0,g=!1;function S(){if(!g){g=!0;const C=new Uint8Array(2);C[0]=1,C[1]=2,h=new Uint16Array(C.buffer)[0]===513}return h}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function w(C){return parseFloat(C)>=20}}),define(ke[50],Ee([1,0,11]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let L;const M=globalThis.vscode;if(typeof M<"u"&&typeof M.process<"u"){const P=M.process;L={get platform(){return P.platform},get arch(){return P.arch},get env(){return P.env},cwd(){return P.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return u.$i?"win32":u.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.$ec=L.platform,e.$fc=L.arch}),define(ke[17],Ee([1,0,50]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const L=65,M=97,P=90,R=122,b=46,$=47,y=92,A=58,I=63;class p extends Error{constructor(f,d,l){let c;typeof d=="string"&&d.indexOf("not ")===0?(c="must not be",d=d.replace(/^not /,"")):c="must be";const h=f.indexOf(".")!==-1?"property":"argument";let g=`The "${f}" ${h} ${c} of type ${d}`;g+=`. Received type ${typeof l}`,super(g),this.code="ERR_INVALID_ARG_TYPE"}}function E(t,f){if(t===null||typeof t!="object")throw new p(f,"Object",t)}function v(t,f){if(typeof t!="string")throw new p(f,"string",t)}const a=u.$ec==="win32";function m(t){return t===$||t===y}function o(t){return t===$}function n(t){return t>=L&&t<=P||t>=M&&t<=R}function i(t,f,d,l){let c="",h=0,g=-1,S=0,w=0;for(let C=0;C<=t.length;++C){if(C<t.length)w=t.charCodeAt(C);else{if(l(w))break;w=$}if(l(w)){if(!(g===C-1||S===1))if(S===2){if(c.length<2||h!==2||c.charCodeAt(c.length-1)!==b||c.charCodeAt(c.length-2)!==b){if(c.length>2){const k=c.lastIndexOf(d);k===-1?(c="",h=0):(c=c.slice(0,k),h=c.length-1-c.lastIndexOf(d)),g=C,S=0;continue}else if(c.length!==0){c="",h=0,g=C,S=0;continue}}f&&(c+=c.length>0?`${d}..`:"..",h=2)}else c.length>0?c+=`${d}${t.slice(g+1,C)}`:c=t.slice(g+1,C),h=C-g-1;g=C,S=0}else w===b&&S!==-1?++S:S=-1}return c}function r(t,f){E(f,"pathObject");const d=f.dir||f.root,l=f.base||`${f.name||""}${f.ext||""}`;return d?d===f.root?`${d}${l}`:`${d}${t}${l}`:l}e.$gc={resolve(...t){let f="",d="",l=!1;for(let c=t.length-1;c>=-1;c--){let h;if(c>=0){if(h=t[c],v(h,"path"),h.length===0)continue}else f.length===0?h=u.cwd():(h=u.env[`=${f}`]||u.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==f.toLowerCase()&&h.charCodeAt(2)===y)&&(h=`${f}\\`));const g=h.length;let S=0,w="",C=!1;const k=h.charCodeAt(0);if(g===1)m(k)&&(S=1,C=!0);else if(m(k))if(C=!0,m(h.charCodeAt(1))){let D=2,O=D;for(;D<g&&!m(h.charCodeAt(D));)D++;if(D<g&&D!==O){const F=h.slice(O,D);for(O=D;D<g&&m(h.charCodeAt(D));)D++;if(D<g&&D!==O){for(O=D;D<g&&!m(h.charCodeAt(D));)D++;(D===g||D!==O)&&(w=`\\\\${F}\\${h.slice(O,D)}`,S=D)}}}else S=1;else n(k)&&h.charCodeAt(1)===A&&(w=h.slice(0,2),S=2,g>2&&m(h.charCodeAt(2))&&(C=!0,S=3));if(w.length>0)if(f.length>0){if(w.toLowerCase()!==f.toLowerCase())continue}else f=w;if(l){if(f.length>0)break}else if(d=`${h.slice(S)}\\${d}`,l=C,C&&f.length>0)break}return d=i(d,!l,"\\",m),l?`${f}\\${d}`:`${f}${d}`||"."},normalize(t){v(t,"path");const f=t.length;if(f===0)return".";let d=0,l,c=!1;const h=t.charCodeAt(0);if(f===1)return o(h)?"\\":t;if(m(h))if(c=!0,m(t.charCodeAt(1))){let S=2,w=S;for(;S<f&&!m(t.charCodeAt(S));)S++;if(S<f&&S!==w){const C=t.slice(w,S);for(w=S;S<f&&m(t.charCodeAt(S));)S++;if(S<f&&S!==w){for(w=S;S<f&&!m(t.charCodeAt(S));)S++;if(S===f)return`\\\\${C}\\${t.slice(w)}\\`;S!==w&&(l=`\\\\${C}\\${t.slice(w,S)}`,d=S)}}}else d=1;else n(h)&&t.charCodeAt(1)===A&&(l=t.slice(0,2),d=2,f>2&&m(t.charCodeAt(2))&&(c=!0,d=3));let g=d<f?i(t.slice(d),!c,"\\",m):"";return g.length===0&&!c&&(g="."),g.length>0&&m(t.charCodeAt(f-1))&&(g+="\\"),l===void 0?c?`\\${g}`:g:c?`${l}\\${g}`:`${l}${g}`},isAbsolute(t){v(t,"path");const f=t.length;if(f===0)return!1;const d=t.charCodeAt(0);return m(d)||f>2&&n(d)&&t.charCodeAt(1)===A&&m(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let f,d;for(let h=0;h<t.length;++h){const g=t[h];v(g,"path"),g.length>0&&(f===void 0?f=d=g:f+=`\\${g}`)}if(f===void 0)return".";let l=!0,c=0;if(typeof d=="string"&&m(d.charCodeAt(0))){++c;const h=d.length;h>1&&m(d.charCodeAt(1))&&(++c,h>2&&(m(d.charCodeAt(2))?++c:l=!1))}if(l){for(;c<f.length&&m(f.charCodeAt(c));)c++;c>=2&&(f=`\\${f.slice(c)}`)}return e.$gc.normalize(f)},relative(t,f){if(v(t,"from"),v(f,"to"),t===f)return"";const d=e.$gc.resolve(t),l=e.$gc.resolve(f);if(d===l||(t=d.toLowerCase(),f=l.toLowerCase(),t===f))return"";let c=0;for(;c<t.length&&t.charCodeAt(c)===y;)c++;let h=t.length;for(;h-1>c&&t.charCodeAt(h-1)===y;)h--;const g=h-c;let S=0;for(;S<f.length&&f.charCodeAt(S)===y;)S++;let w=f.length;for(;w-1>S&&f.charCodeAt(w-1)===y;)w--;const C=w-S,k=g<C?g:C;let D=-1,O=0;for(;O<k;O++){const T=t.charCodeAt(c+O);if(T!==f.charCodeAt(S+O))break;T===y&&(D=O)}if(O!==k){if(D===-1)return l}else{if(C>k){if(f.charCodeAt(S+O)===y)return l.slice(S+O+1);if(O===2)return l.slice(S+O)}g>k&&(t.charCodeAt(c+O)===y?D=O:O===2&&(D=3)),D===-1&&(D=0)}let F="";for(O=c+D+1;O<=h;++O)(O===h||t.charCodeAt(O)===y)&&(F+=F.length===0?"..":"\\..");return S+=D,F.length>0?`${F}${l.slice(S,w)}`:(l.charCodeAt(S)===y&&++S,l.slice(S,w))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const f=e.$gc.resolve(t);if(f.length<=2)return t;if(f.charCodeAt(0)===y){if(f.charCodeAt(1)===y){const d=f.charCodeAt(2);if(d!==I&&d!==b)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(n(f.charCodeAt(0))&&f.charCodeAt(1)===A&&f.charCodeAt(2)===y)return`\\\\?\\${f}`;return t},dirname(t){v(t,"path");const f=t.length;if(f===0)return".";let d=-1,l=0;const c=t.charCodeAt(0);if(f===1)return m(c)?t:".";if(m(c)){if(d=l=1,m(t.charCodeAt(1))){let S=2,w=S;for(;S<f&&!m(t.charCodeAt(S));)S++;if(S<f&&S!==w){for(w=S;S<f&&m(t.charCodeAt(S));)S++;if(S<f&&S!==w){for(w=S;S<f&&!m(t.charCodeAt(S));)S++;if(S===f)return t;S!==w&&(d=l=S+1)}}}}else n(c)&&t.charCodeAt(1)===A&&(d=f>2&&m(t.charCodeAt(2))?3:2,l=d);let h=-1,g=!0;for(let S=f-1;S>=l;--S)if(m(t.charCodeAt(S))){if(!g){h=S;break}}else g=!1;if(h===-1){if(d===-1)return".";h=d}return t.slice(0,h)},basename(t,f){f!==void 0&&v(f,"ext"),v(t,"path");let d=0,l=-1,c=!0,h;if(t.length>=2&&n(t.charCodeAt(0))&&t.charCodeAt(1)===A&&(d=2),f!==void 0&&f.length>0&&f.length<=t.length){if(f===t)return"";let g=f.length-1,S=-1;for(h=t.length-1;h>=d;--h){const w=t.charCodeAt(h);if(m(w)){if(!c){d=h+1;break}}else S===-1&&(c=!1,S=h+1),g>=0&&(w===f.charCodeAt(g)?--g===-1&&(l=h):(g=-1,l=S))}return d===l?l=S:l===-1&&(l=t.length),t.slice(d,l)}for(h=t.length-1;h>=d;--h)if(m(t.charCodeAt(h))){if(!c){d=h+1;break}}else l===-1&&(c=!1,l=h+1);return l===-1?"":t.slice(d,l)},extname(t){v(t,"path");let f=0,d=-1,l=0,c=-1,h=!0,g=0;t.length>=2&&t.charCodeAt(1)===A&&n(t.charCodeAt(0))&&(f=l=2);for(let S=t.length-1;S>=f;--S){const w=t.charCodeAt(S);if(m(w)){if(!h){l=S+1;break}continue}c===-1&&(h=!1,c=S+1),w===b?d===-1?d=S:g!==1&&(g=1):d!==-1&&(g=-1)}return d===-1||c===-1||g===0||g===1&&d===c-1&&d===l+1?"":t.slice(d,c)},format:r.bind(null,"\\"),parse(t){v(t,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return f;const d=t.length;let l=0,c=t.charCodeAt(0);if(d===1)return m(c)?(f.root=f.dir=t,f):(f.base=f.name=t,f);if(m(c)){if(l=1,m(t.charCodeAt(1))){let D=2,O=D;for(;D<d&&!m(t.charCodeAt(D));)D++;if(D<d&&D!==O){for(O=D;D<d&&m(t.charCodeAt(D));)D++;if(D<d&&D!==O){for(O=D;D<d&&!m(t.charCodeAt(D));)D++;D===d?l=D:D!==O&&(l=D+1)}}}}else if(n(c)&&t.charCodeAt(1)===A){if(d<=2)return f.root=f.dir=t,f;if(l=2,m(t.charCodeAt(2))){if(d===3)return f.root=f.dir=t,f;l=3}}l>0&&(f.root=t.slice(0,l));let h=-1,g=l,S=-1,w=!0,C=t.length-1,k=0;for(;C>=l;--C){if(c=t.charCodeAt(C),m(c)){if(!w){g=C+1;break}continue}S===-1&&(w=!1,S=C+1),c===b?h===-1?h=C:k!==1&&(k=1):h!==-1&&(k=-1)}return S!==-1&&(h===-1||k===0||k===1&&h===S-1&&h===g+1?f.base=f.name=t.slice(g,S):(f.name=t.slice(g,h),f.base=t.slice(g,S),f.ext=t.slice(h,S))),g>0&&g!==l?f.dir=t.slice(0,g-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null};const s=(()=>{if(a){const t=/\\/g;return()=>{const f=u.cwd().replace(t,"/");return f.slice(f.indexOf("/"))}}return()=>u.cwd()})();e.$hc={resolve(...t){let f="",d=!1;for(let l=t.length-1;l>=-1&&!d;l--){const c=l>=0?t[l]:s();v(c,"path"),c.length!==0&&(f=`${c}/${f}`,d=c.charCodeAt(0)===$)}return f=i(f,!d,"/",o),d?`/${f}`:f.length>0?f:"."},normalize(t){if(v(t,"path"),t.length===0)return".";const f=t.charCodeAt(0)===$,d=t.charCodeAt(t.length-1)===$;return t=i(t,!f,"/",o),t.length===0?f?"/":d?"./":".":(d&&(t+="/"),f?`/${t}`:t)},isAbsolute(t){return v(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let f;for(let d=0;d<t.length;++d){const l=t[d];v(l,"path"),l.length>0&&(f===void 0?f=l:f+=`/${l}`)}return f===void 0?".":e.$hc.normalize(f)},relative(t,f){if(v(t,"from"),v(f,"to"),t===f||(t=e.$hc.resolve(t),f=e.$hc.resolve(f),t===f))return"";const d=1,l=t.length,c=l-d,h=1,g=f.length-h,S=c<g?c:g;let w=-1,C=0;for(;C<S;C++){const D=t.charCodeAt(d+C);if(D!==f.charCodeAt(h+C))break;D===$&&(w=C)}if(C===S)if(g>S){if(f.charCodeAt(h+C)===$)return f.slice(h+C+1);if(C===0)return f.slice(h+C)}else c>S&&(t.charCodeAt(d+C)===$?w=C:C===0&&(w=0));let k="";for(C=d+w+1;C<=l;++C)(C===l||t.charCodeAt(C)===$)&&(k+=k.length===0?"..":"/..");return`${k}${f.slice(h+w)}`},toNamespacedPath(t){return t},dirname(t){if(v(t,"path"),t.length===0)return".";const f=t.charCodeAt(0)===$;let d=-1,l=!0;for(let c=t.length-1;c>=1;--c)if(t.charCodeAt(c)===$){if(!l){d=c;break}}else l=!1;return d===-1?f?"/":".":f&&d===1?"//":t.slice(0,d)},basename(t,f){f!==void 0&&v(f,"ext"),v(t,"path");let d=0,l=-1,c=!0,h;if(f!==void 0&&f.length>0&&f.length<=t.length){if(f===t)return"";let g=f.length-1,S=-1;for(h=t.length-1;h>=0;--h){const w=t.charCodeAt(h);if(w===$){if(!c){d=h+1;break}}else S===-1&&(c=!1,S=h+1),g>=0&&(w===f.charCodeAt(g)?--g===-1&&(l=h):(g=-1,l=S))}return d===l?l=S:l===-1&&(l=t.length),t.slice(d,l)}for(h=t.length-1;h>=0;--h)if(t.charCodeAt(h)===$){if(!c){d=h+1;break}}else l===-1&&(c=!1,l=h+1);return l===-1?"":t.slice(d,l)},extname(t){v(t,"path");let f=-1,d=0,l=-1,c=!0,h=0;for(let g=t.length-1;g>=0;--g){const S=t.charCodeAt(g);if(S===$){if(!c){d=g+1;break}continue}l===-1&&(c=!1,l=g+1),S===b?f===-1?f=g:h!==1&&(h=1):f!==-1&&(h=-1)}return f===-1||l===-1||h===0||h===1&&f===l-1&&f===d+1?"":t.slice(f,l)},format:r.bind(null,"/"),parse(t){v(t,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return f;const d=t.charCodeAt(0)===$;let l;d?(f.root="/",l=1):l=0;let c=-1,h=0,g=-1,S=!0,w=t.length-1,C=0;for(;w>=l;--w){const k=t.charCodeAt(w);if(k===$){if(!S){h=w+1;break}continue}g===-1&&(S=!1,g=w+1),k===b?c===-1?c=w:C!==1&&(C=1):c!==-1&&(C=-1)}if(g!==-1){const k=h===0&&d?1:h;c===-1||C===0||C===1&&c===g-1&&c===h+1?f.base=f.name=t.slice(k,g):(f.name=t.slice(k,c),f.base=t.slice(k,g),f.ext=t.slice(c,g))}return h>0?f.dir=t.slice(0,h-1):d&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=a?e.$gc.normalize:e.$hc.normalize,e.$jc=a?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=a?e.$gc.join:e.$hc.join,e.$lc=a?e.$gc.resolve:e.$hc.resolve,e.$mc=a?e.$gc.relative:e.$hc.relative,e.$nc=a?e.$gc.dirname:e.$hc.dirname,e.$oc=a?e.$gc.basename:e.$hc.basename,e.$pc=a?e.$gc.extname:e.$hc.extname,e.$qc=a?e.$gc.format:e.$hc.format,e.$rc=a?e.$gc.parse:e.$hc.parse,e.$sc=a?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=a?e.$gc.sep:e.$hc.sep,e.$uc=a?e.$gc.delimiter:e.$hc.delimiter}),define(ke[131],Ee([1,0,45,17]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=b,e.$4q=$,e.$5q=y,e.$6q=A,e.$7q=I,e.$8q=p,e.$9q=E,e.$0q=v,e.$$q=a,e.$_q=m,e.$ar=c,e.$br=h,e.$cr=g;const M=new u.$V(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),P=new u.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new u.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(S,w,C=!1){const k=S||"",D=w||"",O=M.value.collator.compare(k,D);return M.value.collatorIsNumeric&&O===0&&k!==D?k<D?-1:1:O}function $(S,w){const C=P.value.collator;return S=S||"",w=w||"",r(C,S,w)}function y(S,w){const C=P.value.collator;return S=S||"",w=w||"",d(S,w)||r(C,S,w)}function A(S,w){const C=P.value.collator;return S=S||"",w=w||"",f(S,w)||r(C,S,w)}function I(S,w){return S=S||"",w=w||"",S===w?0:S<w?-1:1}function p(S,w){const[C,k]=n(S),[D,O]=n(w);let F=M.value.collator.compare(k,O);if(F===0){if(M.value.collatorIsNumeric&&k!==O)return k<O?-1:1;if(F=M.value.collator.compare(C,D),M.value.collatorIsNumeric&&F===0&&C!==D)return C<D?-1:1}return F}function E(S,w){S=S||"",w=w||"";const C=i(S),k=i(w),D=P.value.collator,O=R.value.collator;return r(O,C,k)||r(D,S,w)}function v(S,w){S=S||"",w=w||"";const C=i(S),k=i(w),D=P.value.collator,O=R.value.collator;return r(O,C,k)||d(S,w)||r(D,S,w)}function a(S,w){S=S||"",w=w||"";const C=i(S),k=i(w),D=P.value.collator,O=R.value.collator;return r(O,C,k)||f(S,w)||r(D,S,w)}function m(S,w){S=S||"",w=w||"";const C=i(S).toLowerCase(),k=i(w).toLowerCase();return C!==k?C<k?-1:1:S!==w?S<w?-1:1:0}const o=/^(.*?)(\.([^.]*))?$/;function n(S,w=!1){const C=S?o.exec(S):[];let k=[C&&C[1]||"",C&&C[3]||""];return w&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function i(S){const w=S?o.exec(S):[];return w&&w[1]&&w[1].charAt(0)!=="."&&w[3]||""}function r(S,w,C){const k=S.compare(w,C);return k!==0?k:w.length!==C.length?w.length<C.length?-1:1:0}function s(S){const w=S.charAt(0);return w.toLocaleUpperCase()!==w}function t(S){const w=S.charAt(0);return w.toLocaleLowerCase()!==w}function f(S,w){return s(S)&&t(w)?-1:t(S)&&s(w)?1:0}function d(S,w){return t(S)&&s(w)?-1:s(S)&&t(w)?1:0}function l(S,w,C=!1){return C||(S=S&&S.toLowerCase(),w=w&&w.toLowerCase()),S===w?0:S<w?-1:1}function c(S,w,C=!1){const k=S.split(L.sep),D=w.split(L.sep),O=k.length-1,F=D.length-1;let T,z;for(let j=0;;j++){if(T=O===j,z=F===j,T&&z)return b(k[j],D[j],C);if(T)return-1;if(z)return 1;const N=l(k[j],D[j],C);if(N!==0)return N}}function h(S,w,C){const k=S.toLowerCase(),D=w.toLowerCase(),O=g(S,w,C);if(O)return O;const F=k.endsWith(C),T=D.endsWith(C);if(F!==T)return F?-1:1;const z=b(k,D);return z!==0?z:k.localeCompare(D)}function g(S,w,C){const k=S.toLowerCase(),D=w.toLowerCase(),O=k.startsWith(C),F=D.startsWith(C);if(O!==F)return O?-1:1;if(O&&F){if(k.length<D.length)return-1;if(k.length>D.length)return 1}return 0}}),define(ke[34],Ee([1,0,17,11,14,18]),function(he,e,u,L,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=R,e.$cg=b,e.$dg=$,e.$eg=y,e.$fg=A,e.$gg=v,e.$hg=a,e.$ig=m,e.$jg=o,e.$kg=n,e.$lg=i,e.$mg=r,e.$ng=s,e.$og=t,e.$pg=f,e.$qg=c;function R(h){return h===47||h===92}function b(h){return h.replace(/[\\/]/g,u.$hc.sep)}function $(h){return h.indexOf("/")===-1&&(h=b(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}function y(h,g=u.$hc.sep){if(!h)return"";const S=h.length,w=h.charCodeAt(0);if(R(w)){if(R(h.charCodeAt(1))&&!R(h.charCodeAt(2))){let k=3;const D=k;for(;k<S&&!R(h.charCodeAt(k));k++);if(D!==k&&!R(h.charCodeAt(k+1))){for(k+=1;k<S;k++)if(R(h.charCodeAt(k)))return h.slice(0,k+1).replace(/[\\/]/g,g)}}return g}else if(o(w)&&h.charCodeAt(1)===58)return R(h.charCodeAt(2))?h.slice(0,2)+g:h.slice(0,2);let C=h.indexOf("://");if(C!==-1){for(C+=3;C<S;C++)if(R(h.charCodeAt(C)))return h.slice(0,C+1)}return""}function A(h){if(!L.$i||!h||h.length<5)return!1;let g=h.charCodeAt(0);if(g!==92||(g=h.charCodeAt(1),g!==92))return!1;let S=2;const w=S;for(;S<h.length&&(g=h.charCodeAt(S),g!==92);S++);return!(w===S||(g=h.charCodeAt(S+1),isNaN(g)||g===92))}const I=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(h,g=L.$i){const S=g?I:p;return!(!h||h.length===0||/^\s+$/.test(h)||(S.lastIndex=0,S.test(h))||g&&E.test(h)||h==="."||h===".."||g&&h[h.length-1]==="."||g&&h.length!==h.trim().length||h.length>255)}function a(h,g,S){const w=h===g;return!S||w?w:!h||!g?!1:(0,M.$lf)(h,g)}function m(h,g,S,w=u.sep){if(h===g)return!0;if(!h||!g||g.length>h.length)return!1;if(S){if(!(0,M.$mf)(h,g))return!1;if(g.length===h.length)return!0;let k=g.length;return g.charAt(g.length-1)===w&&k--,h.charAt(k)===w}return g.charAt(g.length-1)!==w&&(g+=w),h.indexOf(g)===0}function o(h){return h>=65&&h<=90||h>=97&&h<=122}function n(h,g){return L.$i&&h.endsWith(":")&&(h+=u.sep),(0,u.$jc)(h)||(h=(0,u.$kc)(g,h)),h=(0,u.$ic)(h),L.$i?(h=(0,M.$6e)(h,u.sep),h.endsWith(":")&&(h+=u.sep)):(h=(0,M.$6e)(h,u.sep),h||(h=u.sep)),h}function i(h){const g=(0,u.$ic)(h);return L.$i?h.length>3?!1:r(g)&&(h.length===2||g.charCodeAt(2)===92):g===u.$hc.sep}function r(h,g=L.$i){return g?o(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}function s(h,g=L.$i){return r(h,g)?h[0]:void 0}function t(h,g,S){return g.length>h.length?-1:h===g?0:(S&&(h=h.toLowerCase(),g=g.toLowerCase()),h.indexOf(g))}function f(h){const g=h.split(":");let S,w,C;for(const k of g){const D=Number(k);(0,P.$Zf)(D)?w===void 0?w=D:C===void 0&&(C=D):S=S?[S,k].join(":"):k}if(!S)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:S,line:w!==void 0?w:void 0,column:C!==void 0?C:w!==void 0?1:void 0}}const d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",l="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function c(h,g,S=8){let w="";for(let k=0;k<S;k++){let D;k===0&&L.$i&&!g&&(S===3||S===4)?D=l:D=d,w+=D.charAt(Math.floor(Math.random()*D.length))}let C;return g?C=`${g}-${w}`:C=w,h?(0,u.$kc)(h,C):C}}),define(ke[132],Ee([1,0,131,126,55,17,11,14]),function(he,e,u,L,M,P,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=A,e.$er=m,e.$fr=d,e.$gr=C,e.$hr=z,e.$ir=N;const $=0,y=[$,[]];function A(B,W,Z,_){if(!B||!W)return y;const X=B.length,x=W.length;if(X<x)return y;const re=B.toLowerCase();return I(W,Z,x,B,re,X,_)}function I(B,W,Z,_,X,x,re){const Y=[],me=[];for(let ie=0;ie<Z;ie++){const be=ie*x,Se=be-x,ae=ie>0,ce=B[ie],se=W[ie];for(let K=0;K<x;K++){const te=K>0,le=be+K,de=le-1,Ae=Se+K-1,$e=te?Y[de]:0,Ie=ae&&te?Y[Ae]:0,Re=ae&&te?me[Ae]:0;let Fe;!Ie&&ae?Fe=0:Fe=p(ce,se,_,X,K,Re),Fe&&Ie+Fe>=$e&&(re||ae||X.startsWith(W,K))?(me[le]=Re+1,Y[le]=Ie+Fe):(me[le]=$,Y[le]=$e)}}const Ce=[];let ee=Z-1,U=x-1;for(;ee>=0&&U>=0;){const ie=ee*x+U;me[ie]===$||(Ce.push(U),ee--),U--}return[Y[Z*x-1],Ce.reverse()]}function p(B,W,Z,_,X,x){let re=0;if(!E(W,_[X]))return re;if(re+=1,x>0&&(re+=x*5),B===Z[X]&&(re+=1),X===0)re+=8;else{const Y=v(Z.charCodeAt(X-1));Y?re+=Y:(0,L.$nk)(Z.charCodeAt(X))&&x===0&&(re+=2)}return re}function E(B,W){return B===W?!0:B==="/"||B==="\\"?W==="/"||W==="\\":!1}function v(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const a=[void 0,[]];function m(B,W,Z=0,_=0){const X=W;return X.values&&X.values.length>1?o(B,X.values,Z,_):n(B,W,Z,_)}function o(B,W,Z,_){let X=0;const x=[];for(const re of W){const[Y,me]=n(B,re,Z,_);if(typeof Y!="number")return a;X+=Y,x.push(...me)}return[X,S(x)]}function n(B,W,Z,_){const X=(0,L.$wk)(W.original,W.originalLowercase,Z,B,B.toLowerCase(),_,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return X?[X[0],(0,L.$tk)(X)]:a}const i=Object.freeze({score:0}),r=1<<18,s=1<<17,t=65536;function f(B,W,Z,_){const X=_.values?_.values:[_];return(0,M.$9i)({[_.normalized]:{values:X.map(re=>({value:re.normalized,expectContiguousMatch:re.expectContiguousMatch})),label:B,description:W,allowNonContiguousMatches:Z}})}function d(B,W,Z,_,X){if(!B||!W.normalized)return i;const x=_.getItemLabel(B);if(!x)return i;const re=_.getItemDescription(B),Y=f(x,re,Z,W),me=X[Y];if(me)return me;const Ce=l(x,re,_.getItemPath(B),W,Z);return X[Y]=Ce,Ce}function l(B,W,Z,_,X){const x=!Z||!_.containsPathSeparator;return Z&&(R.$k?_.pathNormalized===Z:(0,b.$lf)(_.pathNormalized,Z))?{score:r,labelMatch:[{start:0,end:B.length}],descriptionMatch:W?[{start:0,end:W.length}]:void 0}:_.values&&_.values.length>1?c(B,W,Z,_.values,x,X):h(B,W,Z,_,x,X)}function c(B,W,Z,_,X,x){let re=0;const Y=[],me=[];for(const Ce of _){const{score:ee,labelMatch:U,descriptionMatch:ie}=h(B,W,Z,Ce,X,x);if(ee===$)return i;re+=ee,U&&Y.push(...U),ie&&me.push(...ie)}return{score:re,labelMatch:S(Y),descriptionMatch:S(me)}}function h(B,W,Z,_,X,x){if(X||!W){const[re,Y]=A(B,_.normalized,_.normalizedLowercase,x&&!_.expectContiguousMatch);if(re){const me=(0,L.$kk)(_.normalized,B);let Ce;if(me){Ce=s;const ee=Math.round(_.normalized.length/B.length*100);Ce+=ee}else Ce=t;return{score:Ce+re,labelMatch:me||g(Y)}}}if(W){let re=W;Z&&(re=`${W}${P.sep}`);const Y=re.length,me=`${re}${B}`,[Ce,ee]=A(me,_.normalized,_.normalizedLowercase,x&&!_.expectContiguousMatch);if(Ce){const U=g(ee),ie=[],be=[];return U.forEach(Se=>{Se.start<Y&&Se.end>Y?(ie.push({start:0,end:Se.end-Y}),be.push({start:Se.start,end:Y})):Se.start>=Y?ie.push({start:Se.start-Y,end:Se.end-Y}):be.push(Se)}),{score:Ce,labelMatch:ie,descriptionMatch:be}}}return i}function g(B){const W=[];if(!B)return W;let Z;for(const _ of B)Z&&Z.end===_?Z.end+=1:(Z={start:_,end:_+1},W.push(Z));return W}function S(B){const W=B.sort((X,x)=>X.start-x.start),Z=[];let _;for(const X of W)!_||!w(_,X)?(_=X,Z.push(X)):(_.start=Math.min(_.start,X.start),_.end=Math.max(_.end,X.end));return Z}function w(B,W){return!(B.end<W.start||W.end<B.start)}function C(B,W,Z,_,X,x){const re=d(B,Z,_,X,x),Y=d(W,Z,_,X,x),me=re.score,Ce=Y.score;if((me===r||Ce===r)&&me!==Ce)return me===r?-1:1;if(me>t||Ce>t){if(me!==Ce)return me>Ce?-1:1;if(me<s&&Ce<s){const ce=D(re.labelMatch,Y.labelMatch);if(ce!==0)return ce}const Se=X.getItemLabel(B)||"",ae=X.getItemLabel(W)||"";if(Se.length!==ae.length)return Se.length-ae.length}if(me!==Ce)return me>Ce?-1:1;const ee=Array.isArray(re.labelMatch)&&re.labelMatch.length>0,U=Array.isArray(Y.labelMatch)&&Y.labelMatch.length>0;if(ee&&!U)return-1;if(U&&!ee)return 1;const ie=k(B,re,X),be=k(W,Y,X);return ie&&be&&ie!==be?be>ie?-1:1:O(B,W,Z,X)}function k(B,W,Z){let _=-1,X=-1;if(W.descriptionMatch&&W.descriptionMatch.length?_=W.descriptionMatch[0].start:W.labelMatch&&W.labelMatch.length&&(_=W.labelMatch[0].start),W.labelMatch&&W.labelMatch.length){if(X=W.labelMatch[W.labelMatch.length-1].end,W.descriptionMatch&&W.descriptionMatch.length){const x=Z.getItemDescription(B);x&&(X+=x.length)}}else W.descriptionMatch&&W.descriptionMatch.length&&(X=W.descriptionMatch[W.descriptionMatch.length-1].end);return X-_}function D(B,W){if(!B&&!W||(!B||!B.length)&&(!W||!W.length))return 0;if(!W||!W.length)return-1;if(!B||!B.length)return 1;const Z=B[0].start,X=B[B.length-1].end-Z,x=W[0].start,Y=W[W.length-1].end-x;return X===Y?0:Y<X?1:-1}function O(B,W,Z,_){const X=_.getItemLabel(B)||"",x=_.getItemLabel(W)||"",re=_.getItemDescription(B),Y=_.getItemDescription(W),me=X.length+(re?re.length:0),Ce=x.length+(Y?Y.length:0);if(me!==Ce)return me-Ce;const ee=_.getItemPath(B),U=_.getItemPath(W);return ee&&U&&ee.length!==U.length?ee.length-U.length:X!==x?(0,u.$br)(X,x,Z.normalized):re&&Y&&re!==Y?(0,u.$br)(re,Y,Z.normalized):ee&&U&&ee!==U?(0,u.$br)(ee,U,Z.normalized):0}function F(B){return B.startsWith('"')&&B.endsWith('"')}const T=" ";function z(B){typeof B!="string"&&(B="");const W=B.toLowerCase(),{pathNormalized:Z,normalized:_,normalizedLowercase:X}=j(B),x=Z.indexOf(P.sep)>=0,re=F(B);let Y;const me=B.split(T);if(me.length>1)for(const Ce of me){const ee=F(Ce),{pathNormalized:U,normalized:ie,normalizedLowercase:be}=j(Ce);ie&&(Y||(Y=[]),Y.push({original:Ce,originalLowercase:Ce.toLowerCase(),pathNormalized:U,normalized:ie,normalizedLowercase:be,expectContiguousMatch:ee}))}return{original:B,originalLowercase:W,pathNormalized:Z,normalized:_,normalizedLowercase:X,values:Y,containsPathSeparator:x,expectContiguousMatch:re}}function j(B){let W;R.$i?W=B.replace(/\//g,P.sep):W=B.replace(/\\/g,P.sep);const Z=(0,b.$8e)(W).replace(/\s|"/g,"");return{pathNormalized:W,normalized:Z,normalizedLowercase:Z.toLowerCase()}}function N(B){return Array.isArray(B)?z(B.map(W=>W.original).join(T)):z(B.original)}}),define(ke[101],Ee([1,0,17]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=void 0,e.$As=P,e.$Bs=R,e.$Cs=b,e.$Ds=y,e.$zs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},M={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(A){const I=(0,u.$pc)(A),p=L[I.toLowerCase()];return p!==void 0?p:R(A)}function R(A){const I=(0,u.$pc)(A);return M[I.toLowerCase()]}function b(A){for(const I in M)if(M[I]===A)return I}const $=/^(.+)\/(.+?)(;.+)?$/;function y(A,I){const p=$.exec(A);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:I?void 0:A}}),define(ke[102],Ee([1,0,11]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$$l=P,e.$_l=R;var L;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(L||(e.Source=L={}));var M;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(M||(e.TerminateResponseCode=M={}));function P(b,...$){const y=$.reduce((p,E)=>(p[E]=!0,p),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(p=>!y[p]).forEach(p=>{for(let E=0;E<A.length;E++)if(p.search(A[E])!==-1){delete b[p];break}})}function R(b){b&&(delete b.DEBUG,u.$j&&delete b.DYLD_LIBRARY_PATH,u.$k&&delete b.LD_PRELOAD)}}),define(ke[2],Ee([1,0,17,11]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=v,e.$xc=r;const M=/^\w[\w\d+.-]*$/,P=/^\//,R=/^\/\//;function b(l,c){if(!l.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!M.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!P.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(l,c){return!l&&!c?"file":l}function y(l,c){switch(l){case"https":case"http":case"file":c?c[0]!==I&&(c=I+c):c=I;break}return c}const A="",I="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class E{static isUri(c){return c instanceof E?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,h,g,S,w,C=!1){typeof c=="object"?(this.scheme=c.scheme||A,this.authority=c.authority||A,this.path=c.path||A,this.query=c.query||A,this.fragment=c.fragment||A):(this.scheme=$(c,C),this.authority=h||A,this.path=y(this.scheme,g||A),this.query=S||A,this.fragment=w||A,b(this,C))}get fsPath(){return r(this,!1)}with(c){if(!c)return this;let{scheme:h,authority:g,path:S,query:w,fragment:C}=c;return h===void 0?h=this.scheme:h===null&&(h=A),g===void 0?g=this.authority:g===null&&(g=A),S===void 0?S=this.path:S===null&&(S=A),w===void 0?w=this.query:w===null&&(w=A),C===void 0?C=this.fragment:C===null&&(C=A),h===this.scheme&&g===this.authority&&S===this.path&&w===this.query&&C===this.fragment?this:new m(h,g,S,w,C)}static parse(c,h=!1){const g=p.exec(c);return g?new m(g[2]||A,d(g[4]||A),d(g[5]||A),d(g[7]||A),d(g[9]||A),h):new m(A,A,A,A,A)}static file(c){let h=A;if(L.$i&&(c=c.replace(/\\/g,I)),c[0]===I&&c[1]===I){const g=c.indexOf(I,2);g===-1?(h=c.substring(2),c=I):(h=c.substring(2,g),c=c.substring(g)||I)}return new m("file",h,c,A,A)}static from(c,h){return new m(c.scheme,c.authority,c.path,c.query,c.fragment,h)}static joinPath(c,...h){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return L.$i&&c.scheme==="file"?g=E.file(u.$gc.join(r(c,!0),...h)).path:g=u.$hc.join(c.path,...h),c.with({path:g})}toString(c=!1){return s(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof E)return c;{const h=new m(c);return h._formatted=c.external??null,h._fsPath=c._sep===a?c.fsPath??null:null,h}}else return c}}e.URI=E;function v(l){return!l||typeof l!="object"?!1:typeof l.scheme=="string"&&(typeof l.authority=="string"||typeof l.authority>"u")&&(typeof l.path=="string"||typeof l.path>"u")&&(typeof l.query=="string"||typeof l.query>"u")&&(typeof l.fragment=="string"||typeof l.fragment>"u")}const a=L.$i?1:void 0;class m extends E{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(c=!1){return c?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=a),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const o={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function n(l,c,h){let g,S=-1;for(let w=0;w<l.length;w++){const C=l.charCodeAt(w);if(C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57||C===45||C===46||C===95||C===126||c&&C===47||h&&C===91||h&&C===93||h&&C===58)S!==-1&&(g+=encodeURIComponent(l.substring(S,w)),S=-1),g!==void 0&&(g+=l.charAt(w));else{g===void 0&&(g=l.substr(0,w));const k=o[C];k!==void 0?(S!==-1&&(g+=encodeURIComponent(l.substring(S,w)),S=-1),g+=k):S===-1&&(S=w)}}return S!==-1&&(g+=encodeURIComponent(l.substring(S))),g!==void 0?g:l}function i(l){let c;for(let h=0;h<l.length;h++){const g=l.charCodeAt(h);g===35||g===63?(c===void 0&&(c=l.substr(0,h)),c+=o[g]):c!==void 0&&(c+=l[h])}return c!==void 0?c:l}function r(l,c){let h;return l.authority&&l.path.length>1&&l.scheme==="file"?h=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?c?h=l.path.substr(1):h=l.path[1].toLowerCase()+l.path.substr(2):h=l.path,L.$i&&(h=h.replace(/\//g,"\\")),h}function s(l,c){const h=c?i:n;let g="",{scheme:S,authority:w,path:C,query:k,fragment:D}=l;if(S&&(g+=S,g+=":"),(w||S==="file")&&(g+=I,g+=I),w){let O=w.indexOf("@");if(O!==-1){const F=w.substr(0,O);w=w.substr(O+1),O=F.lastIndexOf(":"),O===-1?g+=h(F,!1,!1):(g+=h(F.substr(0,O),!1,!1),g+=":",g+=h(F.substr(O+1),!1,!0)),g+="@"}w=w.toLowerCase(),O=w.lastIndexOf(":"),O===-1?g+=h(w,!1,!0):(g+=h(w.substr(0,O),!1,!0),g+=w.substr(O))}if(C){if(C.length>=3&&C.charCodeAt(0)===47&&C.charCodeAt(2)===58){const O=C.charCodeAt(1);O>=65&&O<=90&&(C=`/${String.fromCharCode(O+32)}:${C.substr(3)}`)}else if(C.length>=2&&C.charCodeAt(1)===58){const O=C.charCodeAt(0);O>=65&&O<=90&&(C=`${String.fromCharCode(O+32)}:${C.substr(2)}`)}g+=h(C,!0,!1)}return k&&(g+="?",g+=h(k,!1,!1)),D&&(g+="#",g+=c?D:n(D,!1,!1)),g}function t(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+t(l.substr(3)):l}}const f=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function d(l){return l.match(f)?l.replace(f,c=>t(c)):l}}),define(ke[191],Ee([1,0,2]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=L,e.$Gq=M,e.$Hq=P,e.log=b;function L(y){const A=y;return A&&typeof A.type=="string"&&typeof A.severity=="string"}function M(y){const A=[];let I;try{const p=JSON.parse(y.arguments),E=p[p.length-1];E&&E.__$stack&&(p.pop(),I=E.__$stack),A.push(...p)}catch{A.push("Unable to log remote console arguments",y.arguments)}return{args:A,stack:I}}function P(y){if(typeof y!="string")return P(M(y).stack);const A=y;if(A){const I=R(A),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(p&&p.length===4)return{uri:u.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}function R(y){if(!y)return y;const A=y.indexOf(`
`);return A===-1?y:y.substring(0,A)}function b(y,A){const{args:I,stack:p}=M(y),E=typeof I[0]=="string"&&I.length===1;let v=R(p);v&&(v=`(${v.trim()})`);let a=[];if(typeof I[0]=="string"?v&&E?a=[`%c[${A}] %c${I[0]} %c${v}`,$("blue"),$(""),$("grey")]:a=[`%c[${A}] %c${I[0]}`,$("blue"),$(""),...I.slice(1)]:a=[`%c[${A}]%`,$("blue"),...I],v&&!E&&a.push(v),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,a)}function $(y){return`color: ${y}`}}),define(ke[57],Ee([1,0,21,2]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=M,e.$Qh=P,e.$Rh=b;function M($){return JSON.stringify($,R)}function P($){let y=JSON.parse($);return y=b(y),y}function R($,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:y.flags}:y}function b($,y=0){if(!$||y>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return L.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof u.$ue||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let A=0;A<$.length;++A)$[A]=b($[A],y+1);else for(const A in $)Object.hasOwnProperty.call($,A)&&($[A]=b($[A],y+1))}return $}}),define(ke[15],Ee([1,0,13,11,14,2,17]),function(he,e,u,L,M,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$vg=e.$ug=e.$tg=e.Schemas=void 0,e.$rg=$,e.$sg=y,e.$wg=I;var b;(function(v){v.inMemory="inmemory",v.vscode="vscode",v.internal="private",v.walkThrough="walkThrough",v.walkThroughSnippet="walkThroughSnippet",v.http="http",v.https="https",v.file="file",v.mailto="mailto",v.untitled="untitled",v.data="data",v.command="command",v.vscodeRemote="vscode-remote",v.vscodeRemoteResource="vscode-remote-resource",v.vscodeManagedRemoteResource="vscode-managed-remote-resource",v.vscodeUserData="vscode-userdata",v.vscodeCustomEditor="vscode-custom-editor",v.vscodeNotebookCell="vscode-notebook-cell",v.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",v.vscodeNotebookCellOutput="vscode-notebook-cell-output",v.vscodeInteractiveInput="vscode-interactive-input",v.vscodeSettings="vscode-settings",v.vscodeWorkspaceTrust="vscode-workspace-trust",v.vscodeTerminal="vscode-terminal",v.vscodeChatCodeBlock="vscode-chat-code-block",v.vscodeChatSesssion="vscode-chat-editor",v.webviewPanel="webview-panel",v.vscodeWebview="vscode-webview",v.extension="extension",v.vscodeFileResource="vscode-file",v.tmp="tmp",v.vsls="vsls",v.vscodeSourceControl="vscode-scm",v.codeSetting="code-setting"})(b||(e.Schemas=b={}));function $(v,a){return P.URI.isUri(v)?(0,M.$lf)(v.scheme,a):(0,M.$mf)(v,a+":")}function y(v,...a){return a.some(m=>$(v,m))}e.$tg="vscode-tkn",e.$ug="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(a){this.d=a}setDelegate(a){this.e=a}setServerRootPath(a,m){this.f=I(a,m)}getServerRootPath(){return this.f}get g(){return R.$hc.join(this.f,b.vscodeRemoteResource)}set(a,m,o){this.a[a]=m,this.b[a]=o}setConnectionToken(a,m){this.c[a]=m}getPreferredWebSchema(){return this.d}rewrite(a){if(this.e)try{return this.e(a)}catch(s){return u.$1(s),a}const m=a.authority;let o=this.a[m];o&&o.indexOf(":")!==-1&&o.indexOf("[")===-1&&(o=`[${o}]`);const n=this.b[m],i=this.c[m];let r=`path=${encodeURIComponent(a.path)}`;return typeof i=="string"&&(r+=`&${e.$ug}=${encodeURIComponent(i)}`),P.URI.from({scheme:L.$o?this.d:b.vscodeRemoteResource,authority:`${o}:${n}`,path:this.g,query:r})}}e.$vg=new A;function I(v,a){return R.$hc.join(a??"/",`${v.quality??"oss"}-${v.commit??"dev"}`)}e.$xg="vs/../../extensions",e.$yg="vs/../../node_modules",e.$zg="vs/../../node_modules.asar",e.$Ag="vs/../../node_modules.asar.unpacked",e.$Bg="vscode-app";class p{static{this.a=e.$Bg}asBrowserUri(a){const m=this.b(a,he);return this.uriToBrowserUri(m)}uriToBrowserUri(a){return a.scheme===b.vscodeRemote?e.$vg.rewrite(a):a.scheme===b.file&&(L.$m||L.$q===`${b.vscodeFileResource}://${p.a}`)?a.with({scheme:b.vscodeFileResource,authority:a.authority||p.a,query:null,fragment:null}):a}asFileUri(a){const m=this.b(a,he);return this.uriToFileUri(m)}uriToFileUri(a){return a.scheme===b.vscodeFileResource?a.with({scheme:b.file,authority:a.authority!==p.a?a.authority:null,query:null,fragment:null}):a}b(a,m){return P.URI.isUri(a)?a:P.URI.parse(m.toUrl(a))}}e.$Cg=new p;var E;(function(v){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);v.CoopAndCoep=Object.freeze(a.get("3"));const m="vscode-coi";function o(i){let r;typeof i=="string"?r=new URL(i).searchParams:i instanceof URL?r=i.searchParams:P.URI.isUri(i)&&(r=new URL(i.toString(!0)).searchParams);const s=r?.get(m);if(s)return a.get(s)}v.getHeadersFromQuery=o;function n(i,r,s){if(!globalThis.crossOriginIsolated)return;const t=r&&s?"3":s?"2":"1";i instanceof URLSearchParams?i.set(m,t):i[m]=t}v.addSearchParam=n})(E||(e.COI=E={}))}),define(ke[192],Ee([1,0,161,15,11,2]),function(he,e,u,L,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FD=A;class R{constructor(p,E,v){this.id=p,this.dependencies=E,this.callback=v}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(p,E,v)=>{typeof p!="string"&&(v=E,E=p,p=null),(typeof E!="object"||!Array.isArray(E))&&(v=E,E=null),this.c.push(new R(p,E,v))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){if(p.startsWith(window.location.origin)||p.startsWith("vscode-file://vscode-app"))return p;throw new Error(`[trusted_script_src] Invalid script url: ${p}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){return p}})))}async load(p){this.g();const E=await(this.a?this.i(p):this.b?this.h(p):this.j(p));if(!E)throw new Error(`Did not receive a define call from script ${p}`);if(Array.isArray(E.dependencies)&&E.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${p}. The dependencies are: ${E.dependencies.join(", ")}`);return typeof E.callback=="function"?E.callback([]):E.callback}h(p){return new Promise((E,v)=>{const a=document.createElement("script");a.setAttribute("async","async"),a.setAttribute("type","text/javascript");const m=()=>{a.removeEventListener("load",o),a.removeEventListener("error",n)},o=i=>{m(),E(this.c.pop())},n=i=>{m(),v(i)};a.addEventListener("load",o),a.addEventListener("error",n),this.f&&(p=this.f.createScriptURL(p)),a.setAttribute("src",p),window.document.getElementsByTagName("head")[0].appendChild(a)})}i(p){return new Promise((E,v)=>{try{this.f&&(p=this.f.createScriptURL(p)),importScripts(p),E(this.c.pop())}catch(a){v(a)}})}async j(p){try{const E=globalThis._VSCODE_NODE_MODULES.fs,v=globalThis._VSCODE_NODE_MODULES.vm,a=globalThis._VSCODE_NODE_MODULES.module,m=P.URI.parse(p).fsPath,o=E.readFileSync(m).toString(),n=a.wrap(o.replace(/^#!.*/,""));return new v.Script(n).runInThisContext().apply(),this.c.pop()}catch(E){throw E}}}const $=new Map;let y={};typeof globalThis.require=="object"&&(y=globalThis.require.paths??{});async function A(I,p,E){if(u.$T){E===void 0&&(E=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),y[I]&&(I=y[I]);const v=`${I}/${p}`;if($.has(v))return $.get(v);let a;if(/^\w[\w\d+.-]*:\/\//.test(v))a=v;else{const i=`${E&&!M.$o?L.$zg:L.$yg}/${v}`;a=L.$Cg.asBrowserUri(i).toString(!0)}const m=b.INSTANCE.load(a);return $.set(v,m),m}else return await new Promise((v,a)=>{he([I],v,a)})}}),define(ke[23],Ee([1,0,34,15,17,11,14,2]),function(he,e,u,L,M,P,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=void 0,e.$Jg=$,e.$5g=A,e.$6g=p;function $(E){return(0,b.$xc)(E,!0)}class y{constructor(v){this.a=v}compare(v,a,m=!1){return v===a?0:(0,R.$ef)(this.getComparisonKey(v,m),this.getComparisonKey(a,m))}isEqual(v,a,m=!1){return v===a?!0:!v||!a?!1:this.getComparisonKey(v,m)===this.getComparisonKey(a,m)}getComparisonKey(v,a=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,a,m=!1){if(v.scheme===a.scheme){if(v.scheme===L.Schemas.file)return u.$ig($(v),$(a),this.a(v))&&v.query===a.query&&(m||v.fragment===a.fragment);if((0,e.$1g)(v.authority,a.authority))return u.$ig(v.path,a.path,this.a(v),"/")&&v.query===a.query&&(m||v.fragment===a.fragment)}return!1}joinPath(v,...a){return b.URI.joinPath(v,...a)}basenameOrAuthority(v){return(0,e.$Sg)(v)||v.authority}basename(v){return M.$hc.basename(v.path)}extname(v){return M.$hc.extname(v.path)}dirname(v){if(v.path.length===0)return v;let a;return v.scheme===L.Schemas.file?a=b.URI.file(M.$nc($(v))).path:(a=M.$hc.dirname(v.path),v.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),a="/")),v.with({path:a})}normalizePath(v){if(!v.path.length)return v;let a;return v.scheme===L.Schemas.file?a=b.URI.file(M.$ic($(v))).path:a=M.$hc.normalize(v.path),v.with({path:a})}relativePath(v,a){if(v.scheme!==a.scheme||!(0,e.$1g)(v.authority,a.authority))return;if(v.scheme===L.Schemas.file){const n=M.$mc($(v),$(a));return P.$i?u.$cg(n):n}let m=v.path||"/";const o=a.path||"/";if(this.a(v)){let n=0;for(const i=Math.min(m.length,o.length);n<i&&!(m.charCodeAt(n)!==o.charCodeAt(n)&&m.charAt(n).toLowerCase()!==o.charAt(n).toLowerCase());n++);m=o.substr(0,n)+m.substr(n)}return M.$hc.relative(m,o)}resolvePath(v,a){if(v.scheme===L.Schemas.file){const m=b.URI.file(M.$lc($(v),a));return v.with({authority:m.authority,path:m.path})}return a=u.$dg(a),v.with({path:M.$hc.resolve(v.path,a)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,a){return v===a||v!==void 0&&a!==void 0&&(0,R.$lf)(v,a)}hasTrailingPathSeparator(v,a=M.sep){if(v.scheme===L.Schemas.file){const m=$(v);return m.length>u.$eg(m).length&&m[m.length-1]===a}else{const m=v.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,a=M.sep){return(0,e.$2g)(v,a)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,a=M.sep){let m=!1;if(v.scheme===L.Schemas.file){const o=$(v);m=o!==void 0&&o.length===u.$eg(o).length&&o[o.length-1]===a}else{a="/";const o=v.path;m=o.length===1&&o.charCodeAt(o.length-1)===47}return!m&&!(0,e.$2g)(v,a)?v.with({path:v.path+"/"}):v}}e.$Kg=y,e.$Lg=new y(()=>!1),e.$Mg=new y(E=>E.scheme===L.Schemas.file?!P.$k:!0),e.$Ng=new y(E=>!0),e.$Og=e.$Lg.isEqual.bind(e.$Lg),e.$Pg=e.$Lg.isEqualOrParent.bind(e.$Lg),e.$Qg=e.$Lg.getComparisonKey.bind(e.$Lg),e.$Rg=e.$Lg.basenameOrAuthority.bind(e.$Lg),e.$Sg=e.$Lg.basename.bind(e.$Lg),e.$Tg=e.$Lg.extname.bind(e.$Lg),e.$Ug=e.$Lg.dirname.bind(e.$Lg),e.$Vg=e.$Lg.joinPath.bind(e.$Lg),e.$Wg=e.$Lg.normalizePath.bind(e.$Lg),e.$Xg=e.$Lg.relativePath.bind(e.$Lg),e.$Yg=e.$Lg.resolvePath.bind(e.$Lg),e.$Zg=e.$Lg.isAbsolutePath.bind(e.$Lg),e.$1g=e.$Lg.isEqualAuthority.bind(e.$Lg),e.$2g=e.$Lg.hasTrailingPathSeparator.bind(e.$Lg),e.$3g=e.$Lg.removeTrailingPathSeparator.bind(e.$Lg),e.$4g=e.$Lg.addTrailingPathSeparator.bind(e.$Lg);function A(E,v){const a=[];for(let m=0;m<E.length;m++){const o=v(E[m]);E.some((n,i)=>i===m?!1:(0,e.$Pg)(o,v(n)))||a.push(E[m])}return a}var I;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function v(a){const m=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(i=>{const[r,s]=i.split(":");r&&s&&m.set(r,s)});const n=a.path.substring(0,a.path.indexOf(";"));return n&&m.set(E.META_DATA_MIME,n),m}E.parseMetaData=v})(I||(e.DataUri=I={}));function p(E,v,a){if(v){let m=E.path;return m&&m[0]!==M.$hc.sep&&(m=M.$hc.sep+m),E.with({scheme:a,authority:v,path:m})}return E.with({scheme:a})}}),define(ke[8],Ee([1,0,22,13,4,3,23,11,168,45]),function(he,e,u,L,M,P,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.Promises=e.$Fh=e.$Eh=e.$Dh=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=void 0,e.$7g=A,e.$8g=I,e.$9g=p,e.$0g=E,e.$$g=v,e.$_g=a,e.$ah=m,e.$bh=o,e.$jh=h,e.$kh=g,e.$lh=S,e.$mh=w,e.$nh=C,e.$Ch=X,e.$Kh=ae;function A(se){return!!se&&typeof se.then=="function"}function I(se){const K=new u.$ee,te=se(K.token),le=new Promise((de,Ae)=>{const $e=K.token.onCancellationRequested(()=>{$e.dispose(),Ae(new L.$5)});Promise.resolve(te).then(Ie=>{$e.dispose(),K.dispose(),de(Ie)},Ie=>{$e.dispose(),K.dispose(),Ae(Ie)})});return new class{cancel(){K.cancel(),K.dispose()}then(de,Ae){return le.then(de,Ae)}catch(de){return this.then(void 0,de)}finally(de){return le.finally(de)}}}function p(se,K,te){return new Promise((le,de)=>{const Ae=K.onCancellationRequested(()=>{Ae.dispose(),le(te)});se.then(le,de).finally(()=>Ae.dispose())})}function E(se,K){return new Promise((te,le)=>{const de=K.onCancellationRequested(()=>{de.dispose(),le(new L.$5)});se.then(te,le).finally(()=>de.dispose())})}async function v(se){let K=-1;const te=se.map((le,de)=>le.then(Ae=>(K=de,Ae)));try{return await Promise.race(te)}finally{se.forEach((le,de)=>{de!==K&&le.cancel()})}}function a(se,K,te){let le;const de=setTimeout(()=>{le?.(void 0),te?.()},K);return Promise.race([se.finally(()=>clearTimeout(de)),new Promise(Ae=>le=Ae)])}function m(se){return new Promise((K,te)=>{const le=se();A(le)?le.then(K,te):K(le)})}function o(){let se,K;return{promise:new Promise((le,de)=>{se=le,K=de}),resolve:se,reject:K}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(K){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=K,!this.b){const te=()=>{if(this.b=null,this.f)return;const le=this.queue(this.d);return this.d=null,le};this.b=new Promise(le=>{this.a.then(te,te).then(le)})}return new Promise((te,le)=>{this.b.then(te,le)})}return this.a=K(),new Promise((te,le)=>{this.a.then(de=>{this.a=null,te(de)},de=>{this.a=null,le(de)})})}dispose(){this.f=!0}}e.$ch=n;class i{constructor(){this.a=Promise.resolve(null)}queue(K){return this.a=this.a.then(()=>K(),()=>K())}}e.$dh=i;class r{constructor(){this.a=new Map}queue(K,te){const de=(this.a.get(K)??Promise.resolve()).catch(()=>{}).then(te).finally(()=>{this.a.get(K)===de&&this.a.delete(K)});return this.a.set(K,de),de}}e.$eh=r;const s=(se,K)=>{let te=!0;const le=setTimeout(()=>{te=!1,K()},se);return{isTriggered:()=>te,dispose:()=>{clearTimeout(le),te=!1}}},t=se=>{let K=!0;return queueMicrotask(()=>{K&&(K=!1,se())}),{isTriggered:()=>K,dispose:()=>{K=!1}}};class f{constructor(K){this.defaultDelay=K,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(K,te=this.defaultDelay){this.g=K,this.h(),this.b||(this.b=new Promise((de,Ae)=>{this.d=de,this.f=Ae}).then(()=>{if(this.b=null,this.d=null,this.g){const de=this.g;return this.g=null,de()}}));const le=()=>{this.a=null,this.d?.(null)};return this.a=te===$.$4d?t(le):s(te,le),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$fh=f;class d{constructor(K){this.a=new f(K),this.b=new n}trigger(K,te){return this.a.trigger(()=>this.b.queue(K),te)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$gh=d;class l{constructor(){this.a=!1,this.b=new Promise((K,te)=>{this.d=K})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$hh=l;class c extends l{constructor(K){super(),this.f=setTimeout(()=>this.open(),K)}open(){clearTimeout(this.f),super.open()}}e.$ih=c;function h(se,K){return K?new Promise((te,le)=>{const de=setTimeout(()=>{Ae.dispose(),te()},se),Ae=K.onCancellationRequested(()=>{clearTimeout(de),Ae.dispose(),le(new L.$5)})}):I(te=>h(se,te))}function g(se,K=0,te){const le=setTimeout(()=>{se(),te&&de.dispose()},K),de=(0,P.$Sc)(()=>{clearTimeout(le),te?.deleteAndLeak(de)});return te?.add(de),de}function S(se){const K=[];let te=0;const le=se.length;function de(){return te<le?se[te++]():null}function Ae($e){$e!=null&&K.push($e);const Ie=de();return Ie?Ie.then(Ae):Promise.resolve(K)}return Promise.resolve(null).then(Ae)}function w(se,K=le=>!!le,te=null){let le=0;const de=se.length,Ae=()=>{if(le>=de)return Promise.resolve(te);const $e=se[le++];return Promise.resolve($e()).then(Re=>K(Re)?Promise.resolve(Re):Ae())};return Ae()}function C(se,K=le=>!!le,te=null){if(se.length===0)return Promise.resolve(te);let le=se.length;const de=()=>{le=-1;for(const Ae of se)Ae.cancel?.()};return new Promise((Ae,$e)=>{for(const Ie of se)Ie.then(Re=>{--le>=0&&K(Re)?(de(),Ae(Re)):le===0&&Ae(te)}).catch(Re=>{--le>=0&&(de(),$e(Re))})})}class k{constructor(K){this.a=0,this.b=!1,this.f=K,this.g=[],this.d=0,this.h=new M.$7d}whenIdle(){return this.size>0?M.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(K){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((te,le)=>{this.g.push({factory:K,c:te,e:le}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const K=this.g.shift();this.d++;const te=K.factory();te.then(K.c,K.e),te.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$oh=k;class D extends k{constructor(){super(1)}}e.$ph=D;class O{constructor(){this.a=new x,this.b=0}queue(K){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,K())):this.a.run(this.b++,K())}}e.$qh=O;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const K=new me;return this.b.add(K),K.p}g(){for(const[,K]of this.a)if(K.size>0)return!1;return!0}queueSize(K,te=R.$Lg){const le=te.getComparisonKey(K);return this.a.get(le)?.size??0}queueFor(K,te,le=R.$Lg){const de=le.getComparisonKey(K);let Ae=this.a.get(de);if(!Ae){Ae=new D;const $e=this.f++,Ie=M.Event.once(Ae.onDrained)(()=>{Ae?.dispose(),this.a.delete(de),this.h(),this.d?.deleteAndDispose($e),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new P.$4c),this.d.set($e,Ie),this.a.set(de,Ae)}return Ae.queue(te)}h(){this.g()&&this.j()}j(){for(const K of this.b)K.complete();this.b.clear()}dispose(){for(const[,K]of this.a)K.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$rh=F;class T{constructor(K,te){this.a=-1,typeof K=="function"&&typeof te=="number"&&this.setIfNotSet(K,te)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(K,te){this.cancel(),this.a=setTimeout(()=>{this.a=-1,K()},te)}setIfNotSet(K,te){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,K()},te))}}e.$sh=T;class z{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(K,te,le=globalThis){this.cancel();const de=le.setInterval(()=>{K()},te);this.d=(0,P.$Sc)(()=>{le.clearInterval(de),this.d=void 0})}dispose(){this.cancel()}}e.$th=z;class j{constructor(K,te){this.b=-1,this.a=K,this.d=te,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(K=this.d){this.cancel(),this.b=setTimeout(this.f,K)}get delay(){return this.d}set delay(K){this.d=K}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$uh=j;class N{constructor(K,te){te%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.a=K,this.b=te,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(K=this.b){K%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${K}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(K/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$vh=N;class B extends j{constructor(K,te){super(K,te),this.j=[]}work(K){this.j.push(K),this.isScheduled()||this.schedule()}h(){const K=this.j;this.j=[],this.a?.(K)}dispose(){this.j=[],super.dispose()}}e.$wh=B;class W extends P.$Uc{constructor(K,te){super(),this.g=K,this.h=te,this.a=[],this.b=this.B(new P.$Vc),this.f=!1}get pending(){return this.a.length}work(K){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+K.length>this.g.maxBufferedWork)return!1}else if(this.pending+K.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const te of K)this.a.push(te);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new j(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$xh=W,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$zh=(se,K)=>{(0,b.$B)(()=>{if(te)return;const le=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let te=!1;return{dispose(){te||(te=!0)}}}:e.$zh=(se,K,te)=>{const le=se.requestIdleCallback(K,typeof te=="number"?{timeout:te}:void 0);let de=!1;return{dispose(){de||(de=!0,se.cancelIdleCallback(le))}}},e.$yh=se=>(0,e.$zh)(globalThis,se)}();class Z{constructor(K,te){this.g=!1,this.d=()=>{try{this.j=te()}catch(le){this.l=le}finally{this.g=!0}},this.f=(0,e.$zh)(K,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Ah=Z;class _ extends Z{constructor(K){super(globalThis,K)}}e.$Bh=_;async function X(se,K,te){let le;for(let de=0;de<te;de++)try{return await se()}catch(Ae){le=Ae,await h(K)}throw le}class x{isRunning(K){return typeof K=="number"?this.a?.taskId===K:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(K,te,le){return this.a={taskId:K,cancel:()=>le?.(),promise:te},te.then(()=>this.d(K),()=>this.d(K)),te}d(K){this.a&&K===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const K=this.b;this.b=void 0,K.run().then(K.promiseResolve,K.promiseReject)}}queue(K){if(this.b)this.b.run=K;else{const{promise:te,resolve:le,reject:de}=o();this.b={run:K,promise:te,promiseResolve:le,promiseReject:de}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Dh=x;class re{constructor(K,te=()=>Date.now()){this.d=K,this.f=te,this.a=0,this.b=0}increment(){const K=this.f();return K-this.a>this.d&&(this.a=K,this.b=0),this.b++,this.b}}e.$Eh=re;var Y;(function(se){se[se.Resolved=0]="Resolved",se[se.Rejected=1]="Rejected"})(Y||(Y={}));class me{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((K,te)=>{this.a=K,this.b=te})}complete(K){return new Promise(te=>{this.a(K),this.d={outcome:0,value:K},te()})}error(K){return new Promise(te=>{this.b(K),this.d={outcome:1,value:K},te()})}cancel(){return this.error(new L.$5)}}e.$Fh=me;var Ce;(function(se){async function K(le){let de;const Ae=await Promise.all(le.map($e=>$e.then(Ie=>Ie,Ie=>{de||(de=Ie)})));if(typeof de<"u")throw de;return Ae}se.settled=K;function te(le){return new Promise(async(de,Ae)=>{try{await le(de,Ae)}catch($e){Ae($e)}})}se.withAsyncBody=te})(Ce||(e.Promises=Ce={}));class ee{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(K){this.a=void 0,this.b=void 0,this.d=!1,this.promise=K.then(te=>(this.a=te,this.d=!0,te),te=>{throw this.b=te,this.d=!0,te})}requireValue(){if(!this.d)throw new L.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Gh=ee;class U{constructor(K){this.b=K,this.a=new y.$V(()=>new ee(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Hh=U;var ie;(function(se){se[se.Initial=0]="Initial",se[se.DoneOK=1]="DoneOK",se[se.DoneError=2]="DoneError"})(ie||(ie={}));class be{static fromArray(K){return new be(te=>{te.emitMany(K)})}static fromPromise(K){return new be(async te=>{te.emitMany(await K)})}static fromPromises(K){return new be(async te=>{await Promise.all(K.map(async le=>te.emitOne(await le)))})}static merge(K){return new be(async te=>{await Promise.all(K.map(async le=>{for await(const de of le)te.emitOne(de)}))})}static{this.EMPTY=be.fromArray([])}constructor(K){this.a=0,this.b=[],this.d=null,this.f=new M.$7d,queueMicrotask(async()=>{const te={emitOne:le=>this.g(le),emitMany:le=>this.h(le),reject:le=>this.k(le)};try{await Promise.resolve(K(te)),this.j()}catch(le){this.k(le)}finally{te.emitOne=void 0,te.emitMany=void 0,te.reject=void 0}})}[Symbol.asyncIterator](){let K=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(K<this.b.length)return{done:!1,value:this.b[K++]};if(this.a===1)return{done:!0,value:void 0};await M.Event.toPromise(this.f.event)}while(!0)}}}static map(K,te){return new be(async le=>{for await(const de of K)le.emitOne(te(de))})}map(K){return be.map(this,K)}static filter(K,te){return new be(async le=>{for await(const de of K)te(de)&&le.emitOne(de)})}filter(K){return be.filter(this,K)}static coalesce(K){return be.filter(K,te=>!!te)}coalesce(){return be.coalesce(this)}static async toPromise(K){const te=[];for await(const le of K)te.push(le);return te}toPromise(){return be.toPromise(this)}g(K){this.a===0&&(this.b.push(K),this.f.fire())}h(K){this.a===0&&(this.b=this.b.concat(K),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(K){this.a===0&&(this.a=2,this.d=K,this.f.fire())}}e.$Ih=be;class Se extends be{constructor(K,te){super(te),this.l=K}cancel(){this.l.cancel()}}e.$Jh=Se;function ae(se){const K=new u.$ee,te=se(K.token);return new Se(K,async le=>{const de=K.token.onCancellationRequested(()=>{de.dispose(),K.dispose(),le.reject(new L.$5)});try{for await(const Ae of te){if(K.token.isCancellationRequested)return;le.emitOne(Ae)}de.dispose(),K.dispose()}catch(Ae){de.dispose(),K.dispose(),le.reject(Ae)}})}class ce{constructor(){this.a=new me,this.b=new be(le=>{if(K){le.reject(K);return}return te&&le.emitMany(te),this.d=de=>le.reject(de),this.f=de=>le.emitOne(de),this.a.p});let K,te;this.f=le=>{te||(te=[]),te.push(le)},this.d=le=>{K||(K=le)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(K){this.d(K),this.a.complete()}emitOne(K){this.f(K)}}e.$Lh=ce}),define(ke[35],Ee([1,0,19,8,34,27,17,11,14]),function(he,e,u,L,M,P,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_j=e.$$j=void 0,e.$0j=y,e.$ak=v,e.$bk=D,e.$ck=O,e.$dk=F,e.$ek=T,e.$fk=z,e.$gk=W;function y(){return Object.create(null)}e.$$j="**",e.$_j="/";const A="[/\\\\]",I="[^/\\\\]",p=/\//g;function E(Z,_){switch(Z){case 0:return"";case 1:return`${I}*?`;default:return`(?:${A}|${I}+${A}${_?`|${A}${I}+`:""})*?`}}function v(Z,_){if(!Z)return[];const X=[];let x=!1,re=!1,Y="";for(const me of Z){switch(me){case _:if(!x&&!re){X.push(Y),Y="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":re=!0;break;case"]":re=!1;break}Y+=me}return Y&&X.push(Y),X}function a(Z){if(!Z)return"";let _="";const X=v(Z,e.$_j);if(X.every(x=>x===e.$$j))_=".*";else{let x=!1;X.forEach((re,Y)=>{if(re===e.$$j){if(x)return;_+=E(2,Y===X.length-1)}else{let me=!1,Ce="",ee=!1,U="";for(const ie of re){if(ie!=="}"&&me){Ce+=ie;continue}if(ee&&(ie!=="]"||!U)){let be;ie==="-"?be=ie:(ie==="^"||ie==="!")&&!U?be="^":ie===e.$_j?be="":be=(0,$.$Ze)(ie),U+=be;continue}switch(ie){case"{":me=!0;continue;case"[":ee=!0;continue;case"}":{const Se=`(?:${v(Ce,",").map(ae=>a(ae)).join("|")})`;_+=Se,me=!1,Ce="";break}case"]":{_+="["+U+"]",ee=!1,U="";break}case"?":_+=I;continue;case"*":_+=E(1);continue;default:_+=(0,$.$Ze)(ie)}}Y<X.length-1&&(X[Y+1]!==e.$$j||Y+2<X.length)&&(_+=A)}x=re===e.$$j})}return _}const m=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,i=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new P.$Ec(1e4),f=function(){return!1},d=function(){return null};function l(Z,_){if(!Z)return d;let X;typeof Z!="string"?X=Z.pattern:X=Z,X=X.trim();const x=`${X}_${!!_.trimForExclusions}`;let re=t.get(x);if(re)return c(re,Z);let Y;return m.test(X)?re=g(X.substr(4),X):(Y=o.exec(h(X,_)))?re=S(Y[1],X):(_.trimForExclusions?i:n).test(X)?re=w(X,_):(Y=r.exec(h(X,_)))?re=C(Y[1].substr(1),X,!0):(Y=s.exec(h(X,_)))?re=C(Y[1],X,!1):re=k(X),t.set(x,re),c(re,Z)}function c(Z,_){if(typeof _=="string")return Z;const X=function(x,re){return(0,M.$ig)(x,_.base,!b.$k)?Z((0,$.$5e)(x.substr(_.base.length),R.sep),re):null};return X.allBasenames=Z.allBasenames,X.allPaths=Z.allPaths,X.basenames=Z.basenames,X.patterns=Z.patterns,X}function h(Z,_){return _.trimForExclusions&&Z.endsWith("/**")?Z.substr(0,Z.length-2):Z}function g(Z,_){return function(X,x){return typeof X=="string"&&X.endsWith(Z)?_:null}}function S(Z,_){const X=`/${Z}`,x=`\\${Z}`,re=function(me,Ce){return typeof me!="string"?null:Ce?Ce===Z?_:null:me===Z||me.endsWith(X)||me.endsWith(x)?_:null},Y=[Z];return re.basenames=Y,re.patterns=[_],re.allBasenames=Y,re}function w(Z,_){const X=B(Z.slice(1,-1).split(",").map(Ce=>l(Ce,_)).filter(Ce=>Ce!==d),Z),x=X.length;if(!x)return d;if(x===1)return X[0];const re=function(Ce,ee){for(let U=0,ie=X.length;U<ie;U++)if(X[U](Ce,ee))return Z;return null},Y=X.find(Ce=>!!Ce.allBasenames);Y&&(re.allBasenames=Y.allBasenames);const me=X.reduce((Ce,ee)=>ee.allPaths?Ce.concat(ee.allPaths):Ce,[]);return me.length&&(re.allPaths=me),re}function C(Z,_,X){const x=R.sep===R.$hc.sep,re=x?Z:Z.replace(p,R.sep),Y=R.sep+re,me=R.$hc.sep+Z;let Ce;return X?Ce=function(ee,U){return typeof ee=="string"&&(ee===re||ee.endsWith(Y)||!x&&(ee===Z||ee.endsWith(me)))?_:null}:Ce=function(ee,U){return typeof ee=="string"&&(ee===re||!x&&ee===Z)?_:null},Ce.allPaths=[(X?"*/":"./")+Z],Ce}function k(Z){try{const _=new RegExp(`^${a(Z)}$`);return function(X){return _.lastIndex=0,typeof X=="string"&&_.test(X)?Z:null}}catch{return d}}function D(Z,_,X){return!Z||typeof _!="string"?!1:O(Z)(_,void 0,X)}function O(Z,_={}){if(!Z)return f;if(typeof Z=="string"||F(Z)){const X=l(Z,_);if(X===d)return f;const x=function(re,Y){return!!X(re,Y)};return X.allBasenames&&(x.allBasenames=X.allBasenames),X.allPaths&&(x.allPaths=X.allPaths),x}return j(Z,_)}function F(Z){const _=Z;return _?typeof _.base=="string"&&typeof _.pattern=="string":!1}function T(Z){return Z.allBasenames||[]}function z(Z){return Z.allPaths||[]}function j(Z,_){const X=B(Object.getOwnPropertyNames(Z).map(Ce=>N(Ce,Z[Ce],_)).filter(Ce=>Ce!==d)),x=X.length;if(!x)return d;if(!X.some(Ce=>!!Ce.requiresSiblings)){if(x===1)return X[0];const Ce=function(ie,be){let Se;for(let ae=0,ce=X.length;ae<ce;ae++){const se=X[ae](ie,be);if(typeof se=="string")return se;(0,L.$7g)(se)&&(Se||(Se=[]),Se.push(se))}return Se?(async()=>{for(const ae of Se){const ce=await ae;if(typeof ce=="string")return ce}return null})():null},ee=X.find(ie=>!!ie.allBasenames);ee&&(Ce.allBasenames=ee.allBasenames);const U=X.reduce((ie,be)=>be.allPaths?ie.concat(be.allPaths):ie,[]);return U.length&&(Ce.allPaths=U),Ce}const re=function(Ce,ee,U){let ie,be;for(let Se=0,ae=X.length;Se<ae;Se++){const ce=X[Se];ce.requiresSiblings&&U&&(ee||(ee=(0,R.$oc)(Ce)),ie||(ie=ee.substr(0,ee.length-(0,R.$pc)(Ce).length)));const se=ce(Ce,ee,ie,U);if(typeof se=="string")return se;(0,L.$7g)(se)&&(be||(be=[]),be.push(se))}return be?(async()=>{for(const Se of be){const ae=await Se;if(typeof ae=="string")return ae}return null})():null},Y=X.find(Ce=>!!Ce.allBasenames);Y&&(re.allBasenames=Y.allBasenames);const me=X.reduce((Ce,ee)=>ee.allPaths?Ce.concat(ee.allPaths):Ce,[]);return me.length&&(re.allPaths=me),re}function N(Z,_,X){if(_===!1)return d;const x=l(Z,X);if(x===d)return d;if(typeof _=="boolean")return x;if(_){const re=_.when;if(typeof re=="string"){const Y=(me,Ce,ee,U)=>{if(!U||!x(me,Ce))return null;const ie=re.replace("$(basename)",()=>ee),be=U(ie);return(0,L.$7g)(be)?be.then(Se=>Se?Z:null):be?Z:null};return Y.requiresSiblings=!0,Y}}return x}function B(Z,_){const X=Z.filter(Ce=>!!Ce.basenames);if(X.length<2)return Z;const x=X.reduce((Ce,ee)=>{const U=ee.basenames;return U?Ce.concat(U):Ce},[]);let re;if(_){re=[];for(let Ce=0,ee=x.length;Ce<ee;Ce++)re.push(_)}else re=X.reduce((Ce,ee)=>{const U=ee.patterns;return U?Ce.concat(U):Ce},[]);const Y=function(Ce,ee){if(typeof Ce!="string")return null;if(!ee){let ie;for(ie=Ce.length;ie>0;ie--){const be=Ce.charCodeAt(ie-1);if(be===47||be===92)break}ee=Ce.substr(ie)}const U=x.indexOf(ee);return U!==-1?re[U]:null};Y.basenames=x,Y.patterns=re,Y.allBasenames=x;const me=Z.filter(Ce=>!Ce.basenames);return me.push(Y),me}function W(Z,_){return(0,u.$ub)(Z,_,(X,x)=>typeof X=="string"&&typeof x=="string"?X===x:typeof X!="string"&&typeof x!="string"?X.base===x.base&&X.pattern===x.pattern:!1)}}),define(ke[80],Ee([1,0,13,170,23,14,2]),function(he,e,u,L,M,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.MarkdownStringTextNewlineStyle=void 0,e.$Gk=y,e.$Hk=A,e.$Ik=I,e.$Jk=p,e.$Kk=E,e.$Lk=v,e.$Mk=a,e.$Nk=m;var b;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class ${constructor(n="",i=!1){if(this.value=n,typeof this.value!="string")throw(0,u.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(n,i=0){return this.value+=p(this.supportThemeIcons?(0,L.$zk)(n):n).replace(/([ \t]+)/g,(r,s)=>"&nbsp;".repeat(s.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,i){return this.value+=`
${E(i,n)}
`,this}appendLink(n,i,r){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(n),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(n,i){const r=new RegExp((0,P.$Ze)(i),"g");return n.replace(r,(s,t)=>n.charAt(t-1)!=="\\"?`\\${s}`:s)}}e.$Fk=$;function y(o){return A(o)?!o.value:Array.isArray(o)?o.every(y):!0}function A(o){return o instanceof $?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}function I(o,n){return o===n?!0:!o||!n?!1:o.value===n.value&&o.isTrusted===n.isTrusted&&o.supportThemeIcons===n.supportThemeIcons&&o.supportHtml===n.supportHtml&&(o.baseUri===n.baseUri||!!o.baseUri&&!!n.baseUri&&(0,M.$Og)(R.URI.from(o.baseUri),R.URI.from(n.baseUri)))}function p(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function E(o,n){const i=o.match(/^`+/gm)?.reduce((s,t)=>s.length>t.length?s:t).length??0,r=i>=3?i+1:3;return[`${"`".repeat(r)}${n}`,o,`${"`".repeat(r)}`].join(`
`)}function v(o){return o.replace(/"/g,"&quot;")}function a(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function m(o){const n=[],i=o.split("|").map(s=>s.trim());o=i[0];const r=i[1];if(r){const s=/height=(\d+)/.exec(r),t=/width=(\d+)/.exec(r),f=s?s[1]:"",d=t?t[1]:"",l=isFinite(parseInt(d)),c=isFinite(parseInt(f));l&&n.push(`width="${d}"`),c&&n.push(`height="${f}"`)}return{href:o,dimensions:n}}}),define(ke[103],Ee([1,0,19,34,17,11,23,14]),function(he,e,u,L,M,P,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gw=$,e.$hw=A,e.$iw=p,e.$jw=E,e.$kw=o,e.$lw=i,e.$mw=r,e.$nw=s,e.$ow=t,e.$pw=f;function $(l,c){const{os:h,tildify:g,relative:S}=c;if(S){const k=y(l,S,h);if(typeof k=="string")return k}let w=l.fsPath;if(h===1&&!P.$i?w=w.replace(/\//g,"\\"):h!==1&&P.$i&&(w=w.replace(/\\/g,"/")),h!==1&&g?.userHome){const k=g.userHome.fsPath;let D;l.scheme!==g.userHome.scheme&&l.path[0]===M.$hc.sep&&l.path[1]!==M.$hc.sep?D=g.userHome.with({path:l.path}).fsPath:D=w,w=p(D,k,h)}return(h===1?M.$gc:M.$hc).normalize(A(w,h===1))}function y(l,c,h){const g=h===1?M.$gc:M.$hc,S=h===3?R.$Lg:R.$Ng,w=c.getWorkspace(),C=(0,u.$Ob)(w.folders);if(!C)return;l.scheme!==C.uri.scheme&&l.path[0]===M.$hc.sep&&l.path[1]!==M.$hc.sep&&(l=C.uri.with({path:l.path}));const k=c.getWorkspaceFolder(l);if(!k)return;let D;if(S.isEqual(k.uri,l)?D="":D=S.relativePath(k.uri,l)??"",D&&(D=g.normalize(D)),w.folders.length>1&&!c.noPrefix){const O=k.name?k.name:S.basenameOrAuthority(k.uri);D=D?`${O} \u2022 ${D}`:O}return D}function A(l,c=P.$i){return(0,L.$mg)(l,c)?l.charAt(0).toUpperCase()+l.slice(1):l}let I=Object.create(null);function p(l,c,h=P.OS){if(h===1||!l||!c)return l;let g=I.original===c?I.normalized:void 0;g||(g=c,P.$i&&(g=(0,L.$cg)(g)),g=`${(0,b.$6e)(g,M.$hc.sep)}${M.$hc.sep}`,I={original:c,normalized:g});let S=l;return P.$i&&(S=(0,L.$cg)(S)),(h===3?S.startsWith(g):(0,b.$mf)(S,g))?`~/${S.substr(g.length)}`:l}function E(l,c){return l.replace(/^~($|\/|\\)/,`${c}$1`)}const v="\u2026",a="\\\\",m="~";function o(l,c=M.sep){const h=new Array(l.length);let g=!1;for(let S=0;S<l.length;S++){const w=l[S];if(w===""){h[S]=`.${c}`;continue}if(!w){h[S]=w;continue}g=!0;let C="",k=w;k.indexOf(a)===0?(C=k.substr(0,k.indexOf(a)+a.length),k=k.substr(k.indexOf(a)+a.length)):k.indexOf(c)===0?(C=k.substr(0,k.indexOf(c)+c.length),k=k.substr(k.indexOf(c)+c.length)):k.indexOf(m)===0&&(C=k.substr(0,k.indexOf(m)+m.length),k=k.substr(k.indexOf(m)+m.length));const D=k.split(c);for(let O=1;g&&O<=D.length;O++)for(let F=D.length-O;g&&F>=0;F--){g=!1;let T=D.slice(F,F+O).join(c);for(let z=0;!g&&z<l.length;z++)if(z!==S&&l[z]&&l[z].indexOf(T)>-1){const j=F+O===D.length,N=F>0&&l[z].indexOf(c)>-1?c+T:T,B=l[z].endsWith(N);g=!j||B}if(!g){let z="";(D[0].endsWith(":")||C!=="")&&(F===1&&(F=0,O++,T=D[0]+c+T),F>0&&(z=D[0]+c),z=C+z),F>0&&(z=z+v+c),z=z+T,F+O<D.length&&(z=z+c+v),h[S]=z}}g&&(h[S]=w)}return h}var n;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function i(l,c=Object.create(null)){const h=[];let g=!1,S="";for(const w of l)if(w==="$"||g&&w==="{")S&&h.push({value:S,type:n.TEXT}),S="",g=!0;else if(w==="}"&&g){const C=c[S];if(typeof C=="string")C.length&&h.push({value:C,type:n.VARIABLE});else if(C){const k=h[h.length-1];(!k||k.type!==n.SEPARATOR)&&h.push({value:C.label,type:n.SEPARATOR})}S="",g=!1}else S+=w;return S&&!g&&h.push({value:S,type:n.TEXT}),h.filter((w,C)=>{if(w.type===n.SEPARATOR){const k=h[C-1],D=h[C+1];return[k,D].every(O=>O&&(O.type===n.VARIABLE||O.type===n.TEXT)&&O.value.length>0)}return!0}).map(w=>w.value).join("")}function r(l,c){return P.$j||c?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.$j?"&":"&&"):l.replace(/&&|&/g,h=>h==="&"?"&&":"&")}function s(l,c){return P.$j||c?l.replace(/\(&&\w\)|&&/g,""):P.$i?l.replace(/&&|&/g,h=>h==="&"?"&&":"&"):l.replace(/&&/g,"_")}function t(l){return l.replace(/&/g,"&&")}function f(l){if(l.endsWith("]")){const c=l.lastIndexOf(" [",l.length-2);if(c!==-1){const h=d(l.substring(0,c)),g=l.substring(c);return{name:h.name+g,parentPath:h.parentPath}}}return d(l)}function d(l){const c=l.indexOf("/")!==-1?M.$hc:M.$gc,h=c.basename(l),g=c.dirname(l);return h.length?{name:h,parentPath:g}:{name:g,parentPath:""}}}),define(ke[133],Ee([1,0,21,2]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=void 0,e.$mn=b,e.$nn=y,e.$on=A;function M(I){return I.toJSON()}class P{constructor(p){this.a=p}transformIncoming(p){const E=this.a.transformIncoming(p);return E===p?p:M(L.URI.from(E))}transformOutgoing(p){const E=this.a.transformOutgoing(p);return E===p?p:M(L.URI.from(E))}transformOutgoingURI(p){const E=this.a.transformOutgoing(p);return E===p?p:L.URI.from(E)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$kn=P,e.$ln=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function R(I,p,E){if(!I||E>200)return null;if(typeof I=="object"){if(I instanceof L.URI)return p.transformOutgoing(I);for(const v in I)if(Object.hasOwnProperty.call(I,v)){const a=R(I[v],p,E+1);a!==null&&(I[v]=a)}}return null}function b(I,p){const E=R(I,p,0);return E===null?I:E}function $(I,p,E,v){if(!I||v>200)return null;if(typeof I=="object"){if(I.$mid===1)return E?L.URI.revive(p.transformIncoming(I)):p.transformIncoming(I);if(I instanceof u.$ue)return null;for(const a in I)if(Object.hasOwnProperty.call(I,a)){const m=$(I[a],p,E,v+1);m!==null&&(I[a]=m)}}return null}function y(I,p){const E=$(I,p,!1,0);return E===null?I:E}function A(I,p){const E=$(I,p,!0,0);return E===null?I:E}}),define(ke[31],Ee([1,0,51,63,396,8,34,76,17,11,23,2]),function(he,e,u,L,M,P,R,b,$,y,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=m,e.readdirSync=i,e.whenDeleted=t,e.configureFlushOnWrite=h,e.writeFileSync=S;var p;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function E(N,B=p.UNLINK,W){if((0,R.$lg)(N))throw new Error("rimraf - will refuse to recursively delete root");return B===p.UNLINK?a(N):v(N,W)}async function v(N,B=(0,R.$qg)((0,L.tmpdir)())){try{try{await u.promises.rename(N,B)}catch(W){return W.code==="ENOENT"?void 0:a(N)}a(B).catch(W=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function a(N){return(0,M.promisify)(u.rm)(N,{recursive:!0,force:!0,maxRetries:3})}function m(N){if((0,R.$lg)(N))throw new Error("rimraf - will refuse to recursively delete root");u.rmSync(N,{recursive:!0,force:!0,maxRetries:3})}async function o(N,B){return r(await(B?n(N):(0,M.promisify)(u.readdir)(N)))}async function n(N){try{return await(0,M.promisify)(u.readdir)(N,{withFileTypes:!0})}catch(Z){console.warn("[node.js fs] readdir with filetypes failed with error: ",Z)}const B=[],W=await o(N);for(const Z of W){let _=!1,X=!1,x=!1;try{const re=await e.Promises.lstat((0,$.$kc)(N,Z));_=re.isFile(),X=re.isDirectory(),x=re.isSymbolicLink()}catch(re){console.warn("[node.js fs] unexpected error from lstat after readdir: ",re)}B.push({name:Z,isFile:()=>_,isDirectory:()=>X,isSymbolicLink:()=>x})}return B}function i(N){return r(u.readdirSync(N))}function r(N){return N.map(B=>typeof B=="string"?y.$j?(0,b.$Zl)(B):B:(B.name=y.$j?(0,b.$Zl)(B.name):B.name,B))}async function s(N){const B=await o(N),W=[];for(const Z of B)await f.existsDirectory((0,$.$kc)(N,Z))&&W.push(Z);return W}function t(N,B=1e3){return new Promise(W=>{let Z=!1;const _=setInterval(()=>{Z||(Z=!0,u.access(N,X=>{Z=!1,X&&(clearInterval(_),W(void 0))}))},B)})}var f;(function(N){async function B(_){let X;try{if(X=await e.Promises.lstat(_),!X.isSymbolicLink())return{stat:X}}catch{}try{return{stat:await e.Promises.stat(_),symbolicLink:X?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&X)return{stat:X,symbolicLink:{dangling:!0}};if(y.$i&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(_)),symbolicLink:{dangling:!1}}}catch(re){if(re.code==="ENOENT"&&X)return{stat:X,symbolicLink:{dangling:!0}};throw re}throw x}}N.stat=B;async function W(_){try{const{stat:X,symbolicLink:x}=await N.stat(_);return X.isFile()&&x?.dangling!==!0}catch{}return!1}N.existsFile=W;async function Z(_){try{const{stat:X,symbolicLink:x}=await N.stat(_);return X.isDirectory()&&x?.dangling!==!0}catch{}return!1}N.existsDirectory=Z})(f||(e.SymlinkSupport=f={}));const d=new P.$rh;function l(N,B,W){return d.queueFor(I.URI.file(N),()=>{const Z=w(W);return new Promise((_,X)=>g(N,B,Z,x=>x?X(x):_()))},A.$Mg)}let c=!0;function h(N){c=N}function g(N,B,W,Z){if(!c)return u.writeFile(N,B,{mode:W.mode,flag:W.flag},Z);u.open(N,W.flag,W.mode,(_,X)=>{if(_)return Z(_);u.writeFile(X,B,x=>{if(x)return u.close(X,()=>Z(x));u.fdatasync(X,re=>(re&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",re),h(!1)),u.close(X,Y=>Z(Y))))})})}function S(N,B,W){const Z=w(W);if(!c)return u.writeFileSync(N,B,{mode:Z.mode,flag:Z.flag});const _=u.openSync(N,Z.flag,Z.mode);try{u.writeFileSync(_,B);try{u.fdatasyncSync(_)}catch(X){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",X),h(!1)}}finally{u.closeSync(_)}}function w(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function C(N,B,W=6e4){if(N!==B)try{y.$i&&typeof W=="number"?await k(N,B,Date.now(),W):await(0,M.promisify)(u.rename)(N,B)}catch(Z){if(N.toLowerCase()!==B.toLowerCase()&&Z.code==="EXDEV"||N.endsWith("."))await D(N,B,{preserveSymlinks:!1}),await E(N,p.MOVE);else throw Z}}async function k(N,B,W,Z,_=0){try{return await(0,M.promisify)(u.rename)(N,B)}catch(X){if(X.code!=="EACCES"&&X.code!=="EPERM"&&X.code!=="EBUSY")throw X;if(Date.now()-W>=Z)throw console.error(`[node.js fs] rename failed after ${_} retries with error: ${X}`),X;if(_===0){let x=!1;try{const{stat:re}=await f.stat(B);re.isFile()||(x=!0)}catch{}if(x)throw X}return await(0,P.$jh)(Math.min(100,_*10)),k(N,B,W,Z,_+1)}}async function D(N,B,W){return F(N,B,{root:{source:N,target:B},options:W,handledSourcePaths:new Set})}const O=511;async function F(N,B,W){if(W.handledSourcePaths.has(N))return;W.handledSourcePaths.add(N);const{stat:Z,symbolicLink:_}=await f.stat(N);if(_){if(W.options.preserveSymlinks)try{return await j(N,B,W)}catch{}if(_.dangling)return}return Z.isDirectory()?T(N,B,Z.mode&O,W):z(N,B,Z.mode&O)}async function T(N,B,W,Z){await e.Promises.mkdir(B,{recursive:!0,mode:W});const _=await o(N);for(const X of _)await F((0,$.$kc)(N,X),(0,$.$kc)(B,X),Z)}async function z(N,B,W){await e.Promises.copyFile(N,B),await e.Promises.chmod(B,W)}async function j(N,B,W){let Z=await e.Promises.readlink(N);(0,R.$ig)(Z,W.root.source,!y.$k)&&(Z=(0,$.$kc)(W.root.target,Z.substr(W.root.source.length+1))),await e.Promises.symlink(Z,B)}e.Promises=new class{get access(){return(0,M.promisify)(u.access)}get stat(){return(0,M.promisify)(u.stat)}get lstat(){return(0,M.promisify)(u.lstat)}get utimes(){return(0,M.promisify)(u.utimes)}get read(){return(N,B,W,Z,_)=>new Promise((X,x)=>{u.read(N,B,W,Z,_,(re,Y,me)=>re?x(re):X({bytesRead:Y,buffer:me}))})}get readFile(){return(0,M.promisify)(u.readFile)}get write(){return(N,B,W,Z,_)=>new Promise((X,x)=>{u.write(N,B,W,Z,_,(re,Y,me)=>re?x(re):X({bytesWritten:Y,buffer:me}))})}get appendFile(){return(0,M.promisify)(u.appendFile)}get fdatasync(){return(0,M.promisify)(u.fdatasync)}get truncate(){return(0,M.promisify)(u.truncate)}get copyFile(){return(0,M.promisify)(u.copyFile)}get open(){return(0,M.promisify)(u.open)}get close(){return(0,M.promisify)(u.close)}get symlink(){return(0,M.promisify)(u.symlink)}get readlink(){return(0,M.promisify)(u.readlink)}get chmod(){return(0,M.promisify)(u.chmod)}get mkdir(){return(0,M.promisify)(u.mkdir)}get unlink(){return(0,M.promisify)(u.unlink)}get rmdir(){return(0,M.promisify)(u.rmdir)}get realpath(){return(0,M.promisify)(u.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return s}get writeFile(){return l}get rm(){return E}get rename(){return C}get copy(){return D}}}),define(ke[104],Ee([1,0,51,17,11,14,31]),function(he,e,u,L,M,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=b,e.$Oq=$,e.$Pq=y,e.$Qq=A;function b(p){if(M.$k)return p;const E=(0,L.$nc)(p);if(p===E)return p;const v=((0,L.$oc)(p)||p).toLowerCase();try{const m=(0,R.readdirSync)(E).filter(o=>o.toLowerCase()===v);if(m.length===1){const o=b(E);if(o)return(0,L.$kc)(o,m[0])}else if(m.length>1){const o=m.indexOf(v);if(o>=0){const n=b(E);if(n)return(0,L.$kc)(n,m[o])}}}catch{}return null}async function $(p,E){if(M.$k)return p;const v=(0,L.$nc)(p);if(p===v)return p;const a=((0,L.$oc)(p)||p).toLowerCase();try{if(E?.isCancellationRequested)return null;const o=(await R.Promises.readdir(v)).filter(n=>n.toLowerCase()===a);if(o.length===1){const n=await $(v,E);if(n)return(0,L.$kc)(n,o[0])}else if(o.length>1){const n=o.indexOf(a);if(n>=0){const i=await $(v,E);if(i)return(0,L.$kc)(i,o[n])}}}catch{}return null}async function y(p){try{return await R.Promises.realpath(p)}catch{const v=I(p);return await R.Promises.access(v,u.constants.R_OK),v}}function A(p){try{return u.realpathSync(p)}catch{const v=I(p);return u.accessSync(v,u.constants.R_OK),v}}function I(p){return(0,P.$6e)((0,L.$ic)(p),L.sep)}}),define(ke[105],Ee([1,0,17,11,50,102,18,31]),function(he,e,u,L,M,P,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$am=$,e.$bm=y,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function $(I=M.env){return I.comspec||"cmd.exe"}function y(I){let p=[],E=!1;const v=function(a){if(E){p.push(a);return}(!I.send(a,o=>{if(o&&console.error(o),E=!1,p.length>0){const n=p.slice(0);p=[],n.forEach(i=>v(i))}})||L.$i)&&(E=!0)};return{send:v}}var A;(function(I){async function p(E,v,a){if(u.$jc(E))return E;if(v===void 0&&(v=M.cwd()),u.$nc(E)!=="."||(a===void 0&&R.$Vf(M.env.PATH)&&(a=M.env.PATH.split(u.$uc)),a===void 0||a.length===0))return u.$kc(v,E);async function o(n){if(await b.Promises.exists(n)){let i;try{i=await b.Promises.stat(n)}catch(r){r.message.startsWith("EACCES")&&(i=await b.Promises.lstat(n))}return i?!i.isDirectory():!1}return!1}for(const n of a){let i;if(u.$jc(n)?i=u.$kc(n,E):i=u.$kc(v,n,E),await o(i))return i;let r=i+".com";if(await o(r)||(r=i+".exe",await o(r)))return r}return u.$kc(v,E)}I.findExecutable=p})(A||(e.win32=A={}))});var Je=this&&this.__decorate||function(he,e,u,L){var M=arguments.length,P=M<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,u):L,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(he,e,u,L);else for(var b=he.length-1;b>=0;b--)(R=he[b])&&(P=(M<3?R(P):M>3?R(e,u,P):R(e,u))||P);return M>3&&P&&Object.defineProperty(e,u,P),P};define(ke[81],Ee([1,0,19,8,21,22,54,13,4,3,57,14,18]),function(he,e,u,L,M,P,R,b,$,y,A,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.ProxyChannel=e.$3h=e.$Zh=e.$Yh=e.$Xh=e.RequestInitiator=e.$Wh=e.$Th=e.$Sh=void 0,e.$Uh=h,e.$Vh=g,e.$1h=O,e.$2h=F;var E;(function(_){_[_.Promise=100]="Promise",_[_.PromiseCancel=101]="PromiseCancel",_[_.EventListen=102]="EventListen",_[_.EventDispose=103]="EventDispose"})(E||(E={}));function v(_){switch(_){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(_){_[_.Initialize=200]="Initialize",_[_.PromiseSuccess=201]="PromiseSuccess",_[_.PromiseError=202]="PromiseError",_[_.PromiseErrorObj=203]="PromiseErrorObj",_[_.EventFire=204]="EventFire"})(a||(a={}));function m(_){switch(_){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(_){_[_.Uninitialized=0]="Uninitialized",_[_.Idle=1]="Idle"})(o||(o={}));function n(_){let X=0;for(let x=0;;x+=7){const re=_.read(1);if(X|=(re.buffer[0]&127)<<x,!(re.buffer[0]&128))return X}}const i=d(0);function r(_,X){if(X===0){_.write(i);return}let x=0;for(let Y=X;Y!==0;Y=Y>>>7)x++;const re=M.$ue.alloc(x);for(let Y=0;X!==0;Y++)re.buffer[Y]=X&127,X=X>>>7,X>0&&(re.buffer[Y]|=128);_.write(re)}class s{constructor(X){this.b=X,this.a=0}read(X){const x=this.b.slice(this.a,this.a+X);return this.a+=x.byteLength,x}}e.$Sh=s;class t{constructor(){this.a=[]}get buffer(){return M.$ue.concat(this.a)}write(X){this.a.push(X)}}e.$Th=t;var f;(function(_){_[_.Undefined=0]="Undefined",_[_.String=1]="String",_[_.Buffer=2]="Buffer",_[_.VSBuffer=3]="VSBuffer",_[_.Array=4]="Array",_[_.Object=5]="Object",_[_.Int=6]="Int"})(f||(f={}));function d(_){const X=M.$ue.alloc(1);return X.writeUInt8(_,0),X}const l={Undefined:d(f.Undefined),String:d(f.String),Buffer:d(f.Buffer),VSBuffer:d(f.VSBuffer),Array:d(f.Array),Object:d(f.Object),Uint:d(f.Int)},c=typeof Buffer<"u";function h(_,X){if(typeof X>"u")_.write(l.Undefined);else if(typeof X=="string"){const x=M.$ue.fromString(X);_.write(l.String),r(_,x.byteLength),_.write(x)}else if(c&&Buffer.isBuffer(X)){const x=M.$ue.wrap(X);_.write(l.Buffer),r(_,x.byteLength),_.write(x)}else if(X instanceof M.$ue)_.write(l.VSBuffer),r(_,X.byteLength),_.write(X);else if(Array.isArray(X)){_.write(l.Array),r(_,X.length);for(const x of X)h(_,x)}else if(typeof X=="number"&&(X|0)===X)_.write(l.Uint),r(_,X);else{const x=M.$ue.fromString(JSON.stringify(X));_.write(l.Object),r(_,x.byteLength),_.write(x)}}function g(_){switch(_.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return _.read(n(_)).toString();case f.Buffer:return _.read(n(_)).buffer;case f.VSBuffer:return _.read(n(_));case f.Array:{const x=n(_),re=[];for(let Y=0;Y<x;Y++)re.push(g(_));return re}case f.Object:return JSON.parse(_.read(n(_)).toString());case f.Int:return n(_)}}class S{constructor(X,x,re=null,Y=1e3){this.h=X,this.j=x,this.k=re,this.l=Y,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(me=>this.q(me)),this.m({type:200})}registerChannel(X,x){this.b.set(X,x),setTimeout(()=>this.w(X),0)}m(X){switch(X.type){case 200:{const x=this.o([X.type]);this.k?.logOutgoing(x,0,1,m(X.type));return}case 201:case 202:case 204:case 203:{const x=this.o([X.type,X.id],X.data);this.k?.logOutgoing(x,X.id,1,m(X.type),X.data);return}}}o(X,x=void 0){const re=new t;return h(re,X),h(re,x),this.p(re.buffer)}p(X){try{return this.h.send(X),X.byteLength}catch{return 0}}q(X){const x=new s(X),re=g(x),Y=g(x),me=re[0];switch(me){case 100:return this.k?.logIncoming(X.byteLength,re[1],1,`${v(me)}: ${re[2]}.${re[3]}`,Y),this.s({type:me,id:re[1],channelName:re[2],name:re[3],arg:Y});case 102:return this.k?.logIncoming(X.byteLength,re[1],1,`${v(me)}: ${re[2]}.${re[3]}`,Y),this.t({type:me,id:re[1],channelName:re[2],name:re[3],arg:Y});case 101:return this.k?.logIncoming(X.byteLength,re[1],1,`${v(me)}`),this.u({type:me,id:re[1]});case 103:return this.k?.logIncoming(X.byteLength,re[1],1,`${v(me)}`),this.u({type:me,id:re[1]})}}s(X){const x=this.b.get(X.channelName);if(!x){this.v(X);return}const re=new P.$ee;let Y;try{Y=x.call(this.j,X.name,X.arg,re.token)}catch(ee){Y=Promise.reject(ee)}const me=X.id;Y.then(ee=>{this.m({id:me,data:ee,type:201})},ee=>{ee instanceof Error?this.m({id:me,data:{message:ee.message,name:ee.name,stack:ee.stack?ee.stack.split?ee.stack.split(`
`):ee.stack:void 0},type:202}):this.m({id:me,data:ee,type:203})}).finally(()=>{Ce.dispose(),this.d.delete(X.id)});const Ce=(0,y.$Sc)(()=>re.cancel());this.d.set(X.id,Ce)}t(X){const x=this.b.get(X.channelName);if(!x){this.v(X);return}const re=X.id,me=x.listen(this.j,X.name,X.arg)(Ce=>this.m({id:re,data:Ce,type:204}));this.d.set(X.id,me)}u(X){const x=this.d.get(X.id);x&&(x.dispose(),this.d.delete(X.id))}v(X){let x=this.g.get(X.channelName);x||(x=[],this.g.set(X.channelName,x));const re=setTimeout(()=>{console.error(`Unknown channel: ${X.channelName}`),X.type===100&&this.m({id:X.id,data:{name:"Unknown channel",message:`Channel name '${X.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);x.push({request:X,timeoutTimer:re})}w(X){const x=this.g.get(X);if(x){for(const re of x)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.s(re.request);break;case 102:this.t(re.request);break}this.g.delete(X)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,y.$Pc)(this.d.values()),this.d.clear()}}e.$Wh=S;var w;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(w||(e.RequestInitiator=w={}));class C{constructor(X,x=null){this.l=X,this.a=!1,this.b=o.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$7d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=x}getChannel(X){const x=this;return{call(re,Y,me){return x.a?Promise.reject(new b.$5):x.m(X,re,Y,me)},listen(re,Y){return x.a?$.Event.None:x.o(X,re,Y)}}}m(X,x,re,Y=P.CancellationToken.None){const me=this.g++,ee={id:me,type:100,channelName:X,name:x,arg:re};if(Y.isCancellationRequested)return Promise.reject(new b.$5);let U;return new Promise((be,Se)=>{if(Y.isCancellationRequested)return Se(new b.$5);const ae=()=>{const te=le=>{switch(le.type){case 201:this.f.delete(me),be(le.data);break;case 202:{this.f.delete(me);const de=new Error(le.data.message);de.stack=Array.isArray(le.data.stack)?le.data.stack.join(`
`):le.data.stack,de.name=le.data.name,Se(de);break}case 203:this.f.delete(me),Se(le.data);break}};this.f.set(me,te),this.p(ee)};let ce=null;this.b===o.Idle?ae():(ce=(0,L.$8g)(te=>this.u()),ce.then(()=>{ce=null,ae()}));const se=()=>{ce?(ce.cancel(),ce=null):this.p({id:me,type:101}),Se(new b.$5)},K=Y.onCancellationRequested(se);U=(0,y.$Rc)((0,y.$Sc)(se),K),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(X,x,re){const Y=this.g++,Ce={id:Y,type:102,channelName:X,name:x,arg:re};let ee=null;const U=new $.$7d({onWillAddFirstListener:()=>{ee=(0,L.$8g)(be=>this.u()),ee.then(()=>{ee=null,this.d.add(U),this.p(Ce)})},onDidRemoveLastListener:()=>{ee?(ee.cancel(),ee=null):(this.d.delete(U),this.p({id:Y,type:103}))}}),ie=be=>U.fire(be.data);return this.f.set(Y,ie),U.event}p(X){switch(X.type){case 100:case 102:{const x=this.q([X.type,X.id,X.channelName,X.name],X.arg);this.j?.logOutgoing(x,X.id,0,`${v(X.type)}: ${X.channelName}.${X.name}`,X.arg);return}case 101:case 103:{const x=this.q([X.type,X.id]);this.j?.logOutgoing(x,X.id,0,v(X.type));return}}}q(X,x=void 0){const re=new t;return h(re,X),h(re,x),this.r(re.buffer)}r(X){try{return this.l.send(X),X.byteLength}catch{return 0}}s(X){const x=new s(X),re=g(x),Y=g(x),me=re[0];switch(me){case 200:return this.j?.logIncoming(X.byteLength,0,0,m(me)),this.t({type:re[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(X.byteLength,re[1],0,m(me),Y),this.t({type:re[0],id:re[1],data:Y})}}t(X){if(X.type===200){this.b=o.Idle,this.k.fire();return}this.f.get(X.id)?.(X)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,y.$Pc)(this.d.values()),this.d.clear()}}e.$Xh=C,Je([R.$Mh],C.prototype,"onDidInitializePromise",null);class k{get connections(){const X=[];return this.f.forEach(x=>X.push(x)),X}constructor(X,x,re){this.a=new Map,this.f=new Set,this.g=new $.$7d,this.onDidAddConnection=this.g.event,this.h=new $.$7d,this.onDidRemoveConnection=this.h.event,this.j=new y.$Tc,this.j.add(X(({protocol:Y,onDidClientDisconnect:me})=>{const Ce=$.Event.once(Y.onMessage);this.j.add(Ce(ee=>{const U=new s(ee),ie=g(U),be=new S(Y,ie,x,re),Se=new C(Y,x);this.a.forEach((ce,se)=>be.registerChannel(se,ce));const ae={channelServer:be,channelClient:Se,ctx:ie};this.f.add(ae),this.g.fire(ae),this.j.add(me(()=>{be.dispose(),Se.dispose(),this.f.delete(ae),this.h.fire(ae)}))}))}))}getChannel(X,x){const re=this;return{call(Y,me,Ce){let ee;if((0,p.$0f)(x)){const ie=(0,u.$4b)(re.connections.filter(x));ee=ie?Promise.resolve(ie):$.Event.toPromise($.Event.filter(re.onDidAddConnection,x))}else ee=x.routeCall(re,Y,me);const U=ee.then(ie=>ie.channelClient.getChannel(X));return O(U).call(Y,me,Ce)},listen(Y,me){if((0,p.$0f)(x))return re.k(X,x,Y,me);const Ce=x.routeEvent(re,Y,me).then(ee=>ee.channelClient.getChannel(X));return O(Ce).listen(Y,me)}}}k(X,x,re,Y){const me=this;let Ce;const ee=new $.$7d({onWillAddFirstListener:()=>{Ce=new y.$Tc;const U=new $.$ae,ie=new Map,be=ae=>{const se=ae.channelClient.getChannel(X).listen(re,Y),K=U.add(se);ie.set(ae,K)},Se=ae=>{const ce=ie.get(ae);ce&&(ce.dispose(),ie.delete(ae))};me.connections.filter(x).forEach(be),$.Event.filter(me.onDidAddConnection,x)(be,void 0,Ce),me.onDidRemoveConnection(Se,void 0,Ce),U.event(ee.fire,ee,Ce),Ce.add(U)},onDidRemoveLastListener:()=>{Ce?.dispose(),Ce=void 0}});return ee.event}registerChannel(X,x){this.a.set(X,x);for(const re of this.f)re.channelServer.registerChannel(X,x)}dispose(){this.j.dispose();for(const X of this.f)X.channelClient.dispose(),X.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Yh=k;class D{constructor(X,x,re=null){const Y=new t;h(Y,x),X.send(Y.buffer),this.a=new C(X,re),this.d=new S(X,x,re)}getChannel(X){return this.a.getChannel(X)}registerChannel(X,x){this.d.registerChannel(X,x)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Zh=D;function O(_){return{call(X,x,re){return _.then(Y=>Y.call(X,x,re))},listen(X,x){const re=new $.$de;return _.then(Y=>re.input=Y.listen(X,x)),re.event}}}function F(_){let X=!1;return{call(x,re,Y){return X?_.call(x,re,Y):(0,L.$jh)(0).then(()=>X=!0).then(()=>_.call(x,re,Y))},listen(x,re){if(X)return _.listen(x,re);const Y=new $.$de;return(0,L.$jh)(0).then(()=>X=!0).then(()=>Y.input=_.listen(x,re)),Y.event}}}class T{constructor(X){this.a=X}routeCall(X){return this.b(X)}routeEvent(X){return this.b(X)}async b(X){for(const x of X.connections)if(await Promise.resolve(this.a(x.ctx)))return Promise.resolve(x);return await $.Event.toPromise(X.onDidAddConnection),await this.b(X)}}e.$3h=T;var z;(function(_){function X(me,Ce,ee){const U=me,ie=ee&&ee.disableMarshalling,be=new Map;for(const Se in U)re(Se)&&be.set(Se,$.Event.buffer(U[Se],!0,void 0,Ce));return new class{listen(Se,ae,ce){const se=be.get(ae);if(se)return se;const K=U[ae];if(typeof K=="function"){if(Y(ae))return K.call(U,ce);if(re(ae))return be.set(ae,$.Event.buffer(U[ae],!0,void 0,Ce)),be.get(ae)}throw new b.$bb(`Event not found: ${ae}`)}call(Se,ae,ce){const se=U[ae];if(typeof se=="function"){if(!ie&&Array.isArray(ce))for(let te=0;te<ce.length;te++)ce[te]=(0,A.$Rh)(ce[te]);let K=se.apply(U,ce);return K instanceof Promise||(K=Promise.resolve(K)),K}throw new b.$bb(`Method not found: ${ae}`)}}}_.fromService=X;function x(me,Ce){const ee=Ce&&Ce.disableMarshalling;return new Proxy({},{get(U,ie){if(typeof ie=="string")return Ce?.properties?.has(ie)?Ce.properties.get(ie):Y(ie)?function(be){return me.listen(ie,be)}:re(ie)?me.listen(ie):async function(...be){let Se;Ce&&!(0,p.$5f)(Ce.context)?Se=[Ce.context,...be]:Se=be;const ae=await me.call(ie,Se);return ee?ae:(0,A.$Rh)(ae)};throw new b.$bb(`Property not found: ${String(ie)}`)}})}_.toService=x;function re(me){return me[0]==="o"&&me[1]==="n"&&I.$kf(me.charCodeAt(2))}function Y(me){return/^onDynamic/.test(me)&&I.$kf(me.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const j=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(_){if(Array.isArray(_))return _;if(_&&typeof _=="object"&&typeof _.toString=="function"){const X=_.toString();if(X!=="[object Object]")return X}return _}function B(_){return Array.isArray(_)?_.map(N):N(_)}function W(_,X,x,re,Y,me,Ce){Ce=B(Ce);const ee=j[Y],U=ee[re%ee.length];let ie=[`%c[${_}]%c[${String(X).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${me}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(me)?(ie=ie.concat(Ce),ie.push(")")):ie.push(Ce),console.log.apply(console,ie)}class Z{constructor(X,x){this.d=X,this.f=x,this.a=0,this.b=0}logOutgoing(X,x,re,Y,me){this.b+=X,W(this.d,this.b,X,x,re,Y,me)}logIncoming(X,x,re,Y,me){this.a+=X,W(this.f,this.a,X,x,re,Y,me)}}e.$4h=Z}),define(ke[82],Ee([1,0,21,4,3,81]),function(he,e,u,L,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$8h=e.$7h=e.$6h=e.ProtocolConstants=e.$5h=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(l){l.Created="created",l.Read="read",l.Write="write",l.Open="open",l.Error="error",l.Close="close",l.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",l.NodeEndReceived="nodeEndReceived",l.NodeEndSent="nodeEndSent",l.NodeDrainBegin="nodeDrainBegin",l.NodeDrainEnd="nodeDrainEnd",l.zlibInflateError="zlibInflateError",l.zlibInflateData="zlibInflateData",l.zlibInflateInitialWrite="zlibInflateInitialWrite",l.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",l.zlibInflateWrite="zlibInflateWrite",l.zlibInflateFlushFired="zlibInflateFlushFired",l.zlibDeflateError="zlibDeflateError",l.zlibDeflateData="zlibDeflateData",l.zlibDeflateWrite="zlibDeflateWrite",l.zlibDeflateFlushFired="zlibDeflateFlushFired",l.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",l.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",l.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",l.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",l.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",l.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",l.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",l.ProtocolHeaderRead="protocolHeaderRead",l.ProtocolMessageRead="protocolMessageRead",l.ProtocolHeaderWrite="protocolHeaderWrite",l.ProtocolMessageWrite="protocolMessageWrite",l.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var b;(function(l){l.enableDiagnostics=!1,l.records=[];const c=new WeakMap;let h=0;function g(w,C){if(!c.has(w)){const k=String(++h);c.set(w,k)}return c.get(w)}function S(w,C,k,D){if(!l.enableDiagnostics)return;const O=g(w,C);if(D instanceof u.$ue||D instanceof Uint8Array||D instanceof ArrayBuffer||ArrayBuffer.isView(D)){const F=u.$ue.alloc(D.byteLength);F.set(D),l.records.push({timestamp:Date.now(),id:O,label:C,type:k,buff:F})}else l.records.push({timestamp:Date.now(),id:O,label:C,type:k,data:D})}l.traceSocketEvent=S})(b||(e.SocketDiagnostics=b={}));var $;(function(l){l[l.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",l[l.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let y=null;function A(){return y||(y=u.$ue.alloc(0)),y}class I{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(c){this.a.push(c),this.b+=c.byteLength}read(c){return this.c(c,!0)}peek(c){return this.c(c,!1)}c(c,h){if(c===0)return A();if(c>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===c){const C=this.a[0];return h&&(this.a.shift(),this.b-=c),C}if(this.a[0].byteLength>c){const C=this.a[0].slice(0,c);return h&&(this.a[0]=this.a[0].slice(c),this.b-=c),C}const g=u.$ue.alloc(c);let S=0,w=0;for(;c>0;){const C=this.a[w];if(C.byteLength>c){const k=C.slice(0,c);g.set(k,S),S+=c,h&&(this.a[w]=C.slice(c),this.b-=c),c-=c}else g.set(C,S),S+=C.byteLength,h?(this.a.shift(),this.b-=C.byteLength):w++,c-=C.byteLength}return g}}e.$5h=I;var p;(function(l){l[l.None=0]="None",l[l.Regular=1]="Regular",l[l.Control=2]="Control",l[l.Ack=3]="Ack",l[l.Disconnect=5]="Disconnect",l[l.ReplayRequest=6]="ReplayRequest",l[l.Pause=7]="Pause",l[l.Resume=8]="Resume",l[l.KeepAlive=9]="KeepAlive"})(p||(p={}));function E(l){switch(l){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var v;(function(l){l[l.HeaderLength=13]="HeaderLength",l[l.AcknowledgeTime=2e3]="AcknowledgeTime",l[l.TimeoutTime=2e4]="TimeoutTime",l[l.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",l[l.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",l[l.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(v||(e.ProtocolConstants=v={}));class a{constructor(c,h,g,S){this.type=c,this.id=h,this.ack=g,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends M.$Uc{constructor(c){super(),this.f=this.B(new L.$7d),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=c,this.b=!1,this.c=new I,this.B(this.a.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(c);this.c.byteLength>=this.g.readLen;){const h=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=h.readUInt32BE(9),this.g.messageType=h.readUInt8(0),this.g.id=h.readUInt32BE(1),this.g.ack=h.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:E(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const g=this.g.messageType,S=this.g.id,w=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",h),this.f.fire(new a(g,S,w,h)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class o{constructor(c){this.k=null,this.a=!1,this.b=!1,this.c=c,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(c){if(this.a)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=u.$ue.alloc(13);h.writeUInt8(c.type,0),h.writeUInt32BE(c.id,1),h.writeUInt32BE(c.ack,5),h.writeUInt32BE(c.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:E(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",c.data),this.j(h,c.data)}g(c,h){const g=this.f===0;return this.d.push(c,h),this.f+=c.byteLength+h.byteLength,g}h(){const c=u.$ue.concat(this.d,this.f);return this.d.length=0,this.f=0,c}j(c,h){this.g(c,h)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const c=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:c.byteLength}),this.c.write(c)}}class n extends M.$Uc{constructor(c){super(),this.f=new L.$7d,this.onMessage=this.f.event,this.g=new L.$7d,this.onDidDispose=this.g.event,this.a=c,this.b=this.B(new o(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(h=>{h.type===1&&this.f.fire(h.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(c){this.b.write(new a(1,0,0,c))}}e.$6h=n;class i extends P.$Zh{static fromSocket(c,h){return new i(new n(c),h)}get onDidDispose(){return this.b.onDidDispose}constructor(c,h,g=null){super(c,h,g),this.b=c}dispose(){super.dispose();const c=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),c.end()}}e.$7h=i;class r{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new L.$7d({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(c){this.b?this.d.length>0?this.d.push(c):this.a.fire(c):this.d.push(c)}flushBuffer(){this.d=[]}}e.$8h=r;class s{constructor(c){this.data=c,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let c=0,h=this.a;for(;h;)h=h.next,c++;return c}peek(){return this.a?this.a.data:null}toArray(){const c=[];let h=0,g=this.a;for(;g;)c[h++]=g.data,g=g.next;return c}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(c){const h=new s(c);if(!this.a){this.a=h,this.b=h;return}this.b.next=h,this.b=h}}class f{static{this.a=10}static{this.b=null}static getInstance(){return f.b||(f.b=new f),f.b}constructor(){this.c=[];const c=Date.now();for(let h=0;h<f.a;h++)this.c[h]=c-1e3*h;setInterval(()=>{for(let h=f.a;h>=1;h--)this.c[h]=this.c[h-1];this.c[0]=Date.now()},1e3)}d(){const c=Date.now(),h=(1+f.a)*1e3;let g=0;for(let S=0;S<f.a;S++)c-this.c[S]<=h&&g++;return 1-g/f.a}hasHighLoad(){return this.d()>=.5}}class d{get unacknowledgedCount(){return this.c-this.d}constructor(c){this.u=new r,this.onControlMessage=this.u.event,this.v=new r,this.onMessage=this.v.event,this.w=new r,this.onDidDispose=this.w.event,this.x=new r,this.onSocketClose=this.x.event,this.y=new r,this.onSocketTimeout=this.y.event,this.s=c.loadEstimator??f.getInstance(),this.t=c.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new M.$Tc,this.o=c.socket,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(h=>this.z(h))),this.r.add(this.o.onClose(h=>this.x.fire(h))),c.initialChunk&&this.q.acceptChunk(c.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const c=new a(5,0,0,A());this.p.write(c),this.p.flush()}sendPause(){const c=new a(7,0,0,A());this.p.write(c)}sendResume(){const c=new a(8,0,0,A());this.p.write(c)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(c,h){this.a=!0,this.r.dispose(),this.r=new M.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=c,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(g=>this.z(g))),this.r.add(this.o.onClose(g=>this.x.fire(g))),this.q.acceptChunk(h)}endAcceptReconnection(){this.a=!1,this.h=this.g;const c=new a(3,0,this.h,A());this.p.write(c);const h=this.b.toArray();for(let g=0,S=h.length;g<S;g++)this.p.write(h[g]);this.B()}acceptDisconnect(){this.w.fire()}z(c){if(c.ack>this.d){this.d=c.ack;do{const h=this.b.peek();if(h&&h.id<=c.ack)this.b.pop();else break}while(!0)}switch(c.type){case 0:break;case 1:{if(c.id>this.g)if(c.id!==this.g+1){const h=Date.now();h-this.m>1e4&&(this.m=h,this.p.write(new a(6,0,0,A())))}else this.g=c.id,this.j=Date.now(),this.A(),this.v.fire(c.data);break}case 2:{this.u.fire(c.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const h=this.b.toArray();for(let g=0,S=h.length;g<S;g++)this.p.write(h[g]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(c){const h=++this.c;this.h=this.g;const g=new a(1,h,this.h,c);this.b.push(g),this.a||(this.p.write(g),this.B())}sendControl(c){const h=new a(2,0,0,c);this.p.write(h)}A(){if(this.g<=this.h||this.k)return;const c=Date.now()-this.j;if(c>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-c+5)}B(){if(this.c<=this.d||this.f||this.a)return;const c=this.b.peek(),h=Date.now()-c.writtenTime,g=Date.now()-this.q.lastReadTime,S=Date.now()-this.n;if(h>=2e4&&g>=2e4&&S>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:h,timeSinceLastReceivedSomeData:g});return}const w=Math.max(2e4-h,2e4-g,2e4-S,500);this.f=setTimeout(()=>{this.f=null,this.B()},w)}C(){if(this.g<=this.h)return;this.h=this.g;const c=new a(3,0,this.h,A());this.p.write(c)}D(){this.h=this.g;const c=new a(9,0,this.h,A());this.p.write(c)}}e.$9h=d}),define(ke[193],Ee([1,0,52,8,21,22,191,13,4,3,24,105,102,81]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=e.$Jq=void 0;class v extends E.$Wh{constructor(o){super({send:n=>{try{process.send?.(n.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",n=>M.$ue.wrap(Buffer.from(n,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.$Jq=v;class a{constructor(o,n){this.i=o,this.j=n,this.c=new Set,this.g=new Map,this.h=new $.$7d,this.onDidProcessExit=this.h.event;const i=n&&n.timeout?n.timeout:6e4;this.b=new L.$fh(i),this.d=null,this.f=null}getChannel(o){const n=this;return{call(i,r,s){return n.k(o,i,r,s)},listen(i,r){return n.l(o,i,r)}}}k(o,n,i,r=P.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(b.$6());this.b.cancel();const s=this.n(o),t=(0,L.$8g)(l=>s.call(n,i,l)),f=r.onCancellationRequested(()=>t.cancel()),d=(0,y.$Sc)(()=>t.cancel());return this.c.add(d),t.finally(()=>{f.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(o,n,i){if(!this.b)return $.Event.None;this.b.cancel();let r;const s=new $.$7d({onWillAddFirstListener:()=>{r=this.n(o).listen(n,i)(s.fire,s),this.c.add(r)},onDidRemoveLastListener:()=>{this.c.delete(r),r.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return s.event}get m(){if(!this.f){const o=this.j&&this.j.args?this.j.args:[],n=Object.create(null);n.env={...(0,A.$On)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(n.env={...n.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(n.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(n.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(n.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),n.execArgv===void 0&&(n.execArgv=process.execArgv.filter(h=>!/^--inspect(-brk)?=/.test(h)).filter(h=>!h.startsWith("--vscode-"))),(0,p.$_l)(n.env),this.d=(0,u.fork)(this.i,o,n);const i=new $.$7d,s=$.Event.fromNodeEventEmitter(this.d,"message",h=>h)(h=>{if((0,R.$Fq)(h)){(0,R.log)(h,`IPC Library: ${this.j.serverName}`);return}i.fire(M.$ue.wrap(Buffer.from(h,"base64")))}),t=this.j.useQueue?(0,I.$bm)(this.d):this.d,f=h=>this.d&&this.d.connected&&t.send(h.buffer.toString("base64")),d=i.event,l={send:f,onMessage:d};this.f=new E.$Xh(l);const c=()=>this.o();process.once("exit",c),this.d.on("error",h=>console.warn('IPC "'+this.j.serverName+'" errored with '+h)),this.d.on("exit",(h,g)=>{process.removeListener("exit",c),s.dispose(),this.c.forEach(S=>(0,y.$Pc)(S)),this.c.clear(),h!==0&&g!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+h+" and signal "+g),this.b?.cancel(),this.o(),this.h.fire({code:h,signal:g})})}return this.f}n(o){let n=this.g.get(o);return n||(n=this.m.getChannel(o),this.g.set(o,n)),n}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Kq=a}),define(ke[194],Ee([1,0,8,4,3,57,18]),function(he,e,u,L,M,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Ip=e.StorageState=e.StorageHint=void 0,e.$Hp=$;var b;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function $(p){const E=p;return E?.changed instanceof Map||E?.deleted instanceof Set}var y;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(y||(e.StorageState=y={}));class A extends M.$Uc{static{this.a=100}constructor(E,v=Object.create(null)){super(),this.r=E,this.s=v,this.b=this.B(new L.$0d),this.onDidChangeStorage=this.b.event,this.c=y.None,this.f=new Map,this.g=this.B(new u.$gh(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(E=>this.u(E)))}u(E){this.b.pause();try{E.changed?.forEach((v,a)=>this.w(a,v)),E.deleted?.forEach(v=>this.w(v,void 0))}finally{this.b.resume()}}w(E,v){if(this.c===y.Closed)return;let a=!1;(0,R.$5f)(v)?a=this.f.delete(E):this.f.get(E)!==v&&(this.f.set(E,v),a=!0),a&&this.b.fire({key:E,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===y.None&&(this.c=y.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(E,v){const a=this.f.get(E);return(0,R.$5f)(a)?v:a}getBoolean(E,v){const a=this.get(E);return(0,R.$5f)(a)?v:a==="true"}getNumber(E,v){const a=this.get(E);return(0,R.$5f)(a)?v:parseInt(a,10)}getObject(E,v){const a=this.get(E);return(0,R.$5f)(a)?v:(0,P.$Qh)(a)}async set(E,v,a=!1){if(this.c===y.Closed)return;if((0,R.$5f)(v))return this.delete(E,a);const m=(0,R.$Xf)(v)||Array.isArray(v)?(0,P.$Ph)(v):String(v);if(this.f.get(E)!==m)return this.f.set(E,m),this.j.set(E,m),this.h.delete(E),this.b.fire({key:E,external:a}),this.D()}async delete(E,v=!1){if(!(this.c===y.Closed||!this.f.delete(E)))return this.h.has(E)||this.h.add(E),this.j.delete(E),this.b.fire({key:E,external:v}),this.D()}async optimize(){if(this.c!==y.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=y.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const E={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(E).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(E){if(this.z)return this.D(E)}async D(E){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),E)}async whenFlushed(){if(this.z)return new Promise(E=>this.n.push(E))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$Ip=A;class I{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(E){E.insert?.forEach((v,a)=>this.a.set(a,v)),E.delete?.forEach(v=>this.a.delete(v))}async optimize(){}async close(){}}e.$Jp=I}),define(ke[195],Ee([1,0,14,11,21]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=void 0,e.$ut=A,e.$vt=I;let P;function R(){return P||(P=new TextDecoder("UTF-16LE")),P}let b;function $(){return b||(b=new TextDecoder("UTF-16BE")),b}let y;function A(){return y||(y=L.$D()?R():$()),y}function I(v,a,m){const o=new Uint16Array(v.buffer,a,m);return m>0&&(o[0]===65279||o[0]===65534)?p(v,a,m):R().decode(o)}function p(v,a,m){const o=[];let n=0;for(let i=0;i<m;i++){const r=M.$we(v,a);a+=2,o[n++]=String.fromCharCode(r)}return o.join("")}class E{constructor(a){this.a=a|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const a=new Uint16Array(this.b.buffer,0,this.d);return A().decode(a)}f(){const a=this.e();this.d=0,this.c===null?this.c=[a]:this.c[this.c.length]=a}appendCharCode(a){const m=this.a-this.d;m<=1&&(m===0||u.$pf(a))&&this.f(),this.b[this.d++]=a}appendASCIICharCode(a){this.d===this.a&&this.f(),this.b[this.d++]=a}appendString(a){const m=a.length;if(this.d+m>=this.a){this.f(),this.c[this.c.length]=a;return}for(let o=0;o<m;o++)this.b[this.d++]=a.charCodeAt(o)}}e.$wt=E}),define(ke[196],Ee([1,0,21,195]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xt=void 0,e.$yt=R;function M($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class P{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(y,A,I,p){this.oldPosition=y,this.oldText=A,this.newPosition=I,this.newText=p}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${M(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${M(this.oldText)}")`:`(replace@${this.oldPosition} "${M(this.oldText)}" with "${M(this.newText)}")`}static a(y){return 4+2*y.length}static c(y,A,I){const p=A.length;u.$ze(y,p,I),I+=4;for(let E=0;E<p;E++)u.$xe(y,A.charCodeAt(E),I),I+=2;return I}static d(y,A){const I=u.$ye(y,A);return A+=4,(0,L.$vt)(y,A,I)}writeSize(){return 8+P.a(this.oldText)+P.a(this.newText)}write(y,A){return u.$ze(y,this.oldPosition,A),A+=4,u.$ze(y,this.newPosition,A),A+=4,A=P.c(y,this.oldText,A),A=P.c(y,this.newText,A),A}static read(y,A,I){const p=u.$ye(y,A);A+=4;const E=u.$ye(y,A);A+=4;const v=P.d(y,A);A+=P.a(v);const a=P.d(y,A);return A+=P.a(a),I.push(new P(p,v,E,a)),A}}e.$xt=P;function R($,y){return $===null||$.length===0?y:new b($,y).compress()}class b{constructor(y,A){this.a=y,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let y=0,A=0,I=this.n(y),p=this.l(A);for(;y<this.f||A<this.h;){if(I===null){this.k(p),p=this.l(++A);continue}if(p===null){this.m(I),I=this.n(++y);continue}if(p.oldEnd<=I.newPosition){this.k(p),p=this.l(++A);continue}if(I.newEnd<=p.oldPosition){this.m(I),I=this.n(++y);continue}if(p.oldPosition<I.newPosition){const[o,n]=b.r(p,I.newPosition-p.oldPosition);this.k(o),p=n;continue}if(I.newPosition<p.oldPosition){const[o,n]=b.q(I,p.oldPosition-I.newPosition);this.m(o),I=n;continue}let a,m;if(p.oldEnd===I.newEnd)a=I,m=p,I=this.n(++y),p=this.l(++A);else if(p.oldEnd<I.newEnd){const[o,n]=b.q(I,p.oldLength);a=o,m=p,I=n,p=this.l(++A)}else{const[o,n]=b.r(p,I.newLength);a=I,m=o,I=this.n(++y),p=n}this.d[this.e++]=new P(a.oldPosition,a.oldText,m.newPosition,m.newText),this.g+=a.newLength-a.oldLength,this.j+=m.newLength-m.oldLength}const E=b.s(this.d);return b.t(E)}k(y){this.d[this.e++]=b.o(this.g,y),this.j+=y.newLength-y.oldLength}l(y){return y<this.h?this.c[y]:null}m(y){this.d[this.e++]=b.p(this.j,y),this.g+=y.newLength-y.oldLength}n(y){return y<this.f?this.a[y]:null}static o(y,A){return new P(A.oldPosition-y,A.oldText,A.newPosition,A.newText)}static p(y,A){return new P(A.oldPosition,A.oldText,A.newPosition+y,A.newText)}static q(y,A){const I=y.newText.substr(0,A),p=y.newText.substr(A);return[new P(y.oldPosition,y.oldText,y.newPosition,I),new P(y.oldEnd,"",y.newPosition+A,p)]}static r(y,A){const I=y.oldText.substr(0,A),p=y.oldText.substr(A);return[new P(y.oldPosition,I,y.newPosition,y.newText),new P(y.oldPosition+A,p,y.newEnd,"")]}static s(y){if(y.length===0)return y;const A=[];let I=0,p=y[0];for(let E=1;E<y.length;E++){const v=y[E];p.oldEnd===v.oldPosition?p=new P(p.oldPosition,p.oldText+v.oldText,p.newPosition,p.newText+v.newText):(A[I++]=p,p=v)}return A[I++]=p,A}static t(y){if(y.length===0)return y;const A=[];let I=0;for(let p=0;p<y.length;p++){const E=y[p];E.oldText!==E.newText&&(A[I++]=E)}return A}}}),define(ke[197],Ee([1,0,35,17]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vt=M,e.$Wt=P;function M(R,b,$,y,A,I){if(Array.isArray(R)){let p=0;for(const E of R){const v=M(E,b,$,y,A,I);if(v===10)return v;v>p&&(p=v)}return p}else{if(typeof R=="string")return y?R==="*"?5:R===$?10:0:0;if(R){const{language:p,pattern:E,scheme:v,hasAccessToAllModels:a,notebookType:m}=R;if(!y&&!a)return 0;m&&A&&(b=A);let o=0;if(v)if(v===b.scheme)o=10;else if(v==="*")o=5;else return 0;if(p)if(p===$)o=10;else if(p==="*")o=Math.max(o,5);else return 0;if(m)if(m===I)o=10;else if(m==="*"&&I!==void 0)o=Math.max(o,5);else return 0;if(E){let n;if(typeof E=="string"?n=E:n={...E,base:(0,L.$ic)(E.base)},n===b.fsPath||(0,u.$bk)(n,b.fsPath))o=10;else return 0}return o}else return 0}}function P(R){return typeof R=="string"?!1:Array.isArray(R)?R.some(P):!!R.notebookType}}),define(ke[198],Ee([1,0,4,14,29,79,130,173,196,3]),function(he,e,u,L,M,P,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zC=void 0;class A extends y.$Uc{constructor(p,E,v,a,m,o,n){super(),this.m=this.B(new u.$7d),this.onDidChangeContent=this.m.event,this.f=E,this.j=!o,this.g=a,this.h=m,this.c=new R.$yC(p,v,n)}equals(p){return!(p instanceof A)||this.f!==p.f||this.getEOL()!==p.getEOL()?!1:this.c.equal(p.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(p){return this.c.createSnapshot(p?this.f:"")}getOffsetAt(p,E){return this.c.getOffsetAt(p,E)}getPositionAt(p){return this.c.getPositionAt(p)}getRangeAt(p,E){const v=p+E,a=this.getPositionAt(p),m=this.getPositionAt(v);return new M.$ct(a.lineNumber,a.column,m.lineNumber,m.column)}getValueInRange(p,E=0){if(p.isEmpty())return"";const v=this.n(E);return this.c.getValueInRange(p,v)}getValueLengthInRange(p,E=0){if(p.isEmpty())return 0;if(p.startLineNumber===p.endLineNumber)return p.endColumn-p.startColumn;const v=this.getOffsetAt(p.startLineNumber,p.startColumn),a=this.getOffsetAt(p.endLineNumber,p.endColumn);let m=0;const o=this.n(E),n=this.getEOL();if(o.length!==n.length){const i=o.length-n.length,r=p.endLineNumber-p.startLineNumber;m=i*r}return a-v+m}getCharacterCountInRange(p,E=0){if(this.j){let v=0;const a=p.startLineNumber,m=p.endLineNumber;for(let o=a;o<=m;o++){const n=this.getLineContent(o),i=o===a?p.startColumn-1:0,r=o===m?p.endColumn-1:n.length;for(let s=i;s<r;s++)L.$pf(n.charCodeAt(s))?(v=v+1,s=s+1):v=v+1}return v+=this.n(E).length*(m-a),v}return this.getValueLengthInRange(p,E)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(p){return this.c.getLineContent(p)}getLineCharCode(p,E){return this.c.getLineCharCode(p,E)}getCharCode(p){return this.c.getCharCode(p)}getLineLength(p){return this.c.getLineLength(p)}getLineMinColumn(p){return 1}getLineMaxColumn(p){return this.getLineLength(p)+1}getLineFirstNonWhitespaceColumn(p){const E=L.$af(this.getLineContent(p));return E===-1?0:E+1}getLineLastNonWhitespaceColumn(p){const E=L.$cf(this.getLineContent(p));return E===-1?0:E+2}n(p){switch(p){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(p){this.c.setEOL(p)}applyEdits(p,E,v){let a=this.g,m=this.h,o=this.j,n=!0,i=[];for(let c=0;c<p.length;c++){const h=p[c];n&&h._isTracked&&(n=!1);const g=h.range;if(h.text){let D=!0;o||(D=!L.$Af(h.text),o=D),!a&&D&&(a=L.$zf(h.text)),!m&&D&&(m=L.$Cf(h.text))}let S="",w=0,C=0,k=0;if(h.text){let D;[w,C,k,D]=(0,b.$Ot)(h.text);const O=this.getEOL();D===0||D===(O===`\r
`?2:1)?S=h.text:S=h.text.replace(/\r\n|\r|\n/g,O)}i[c]={sortIndex:c,identifier:h.identifier||null,range:g,rangeOffset:this.getOffsetAt(g.startLineNumber,g.startColumn),rangeLength:this.getValueLengthInRange(g),text:S,eolCount:w,firstLineLength:C,lastLineLength:k,forceMoveMarkers:!!h.forceMoveMarkers,isAutoWhitespaceEdit:h.isAutoWhitespaceEdit||!1}}i.sort(A.u);let r=!1;for(let c=0,h=i.length-1;c<h;c++){const g=i[c].range.getEndPosition(),S=i[c+1].range.getStartPosition();if(S.isBeforeOrEqual(g)){if(S.isBefore(g))throw new Error("Overlapping ranges are not allowed!");r=!0}}n&&(i=this.s(i));const s=v||E?A._getInverseEditRanges(i):[],t=[];if(E)for(let c=0;c<i.length;c++){const h=i[c],g=s[c];if(h.isAutoWhitespaceEdit&&h.range.isEmpty())for(let S=g.startLineNumber;S<=g.endLineNumber;S++){let w="";S===g.startLineNumber&&(w=this.getLineContent(h.range.startLineNumber),L.$af(w)!==-1)||t.push({lineNumber:S,oldContent:w})}}let f=null;if(v){let c=0;f=[];for(let h=0;h<i.length;h++){const g=i[h],S=s[h],w=this.getValueInRange(g.range),C=g.rangeOffset+c;c+=g.text.length-w.length,f[h]={sortIndex:g.sortIndex,identifier:g.identifier,range:S,text:w,textChange:new $.$xt(g.rangeOffset,w,C,g.text)}}r||f.sort((h,g)=>h.sortIndex-g.sortIndex)}this.g=a,this.h=m,this.j=o;const d=this.t(i);let l=null;if(E&&t.length>0){t.sort((c,h)=>h.lineNumber-c.lineNumber),l=[];for(let c=0,h=t.length;c<h;c++){const g=t[c].lineNumber;if(c>0&&t[c-1].lineNumber===g)continue;const S=t[c].oldContent,w=this.getLineContent(g);w.length===0||w===S||L.$af(w)!==-1||l.push(g)}}return this.m.fire(),new P.$Av(f,d,l)}s(p){return p.length<1e3?p:[this._toSingleEditOperation(p)]}_toSingleEditOperation(p){let E=!1;const v=p[0].range,a=p[p.length-1].range,m=new M.$ct(v.startLineNumber,v.startColumn,a.endLineNumber,a.endColumn);let o=v.startLineNumber,n=v.startColumn;const i=[];for(let d=0,l=p.length;d<l;d++){const c=p[d],h=c.range;E=E||c.forceMoveMarkers,i.push(this.getValueInRange(new M.$ct(o,n,h.startLineNumber,h.startColumn))),c.text.length>0&&i.push(c.text),o=h.endLineNumber,n=h.endColumn}const r=i.join(""),[s,t,f]=(0,b.$Ot)(r);return{sortIndex:0,identifier:p[0].identifier,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m,0),text:r,eolCount:s,firstLineLength:t,lastLineLength:f,forceMoveMarkers:E,isAutoWhitespaceEdit:!1}}t(p){p.sort(A.w);const E=[];for(let v=0;v<p.length;v++){const a=p[v],m=a.range.startLineNumber,o=a.range.startColumn,n=a.range.endLineNumber,i=a.range.endColumn;if(m===n&&o===i&&a.text.length===0)continue;a.text?(this.c.delete(a.rangeOffset,a.rangeLength),this.c.insert(a.rangeOffset,a.text,!0)):this.c.delete(a.rangeOffset,a.rangeLength);const r=new M.$ct(m,o,n,i);E.push({range:r,rangeLength:a.rangeLength,text:a.text,rangeOffset:a.rangeOffset,forceMoveMarkers:a.forceMoveMarkers})}return E}findMatchesLineByLine(p,E,v,a){return this.c.findMatchesLineByLine(p,E,v,a)}getPieceTree(){return this.c}static _getInverseEditRange(p,E){const v=p.startLineNumber,a=p.startColumn,[m,o,n]=(0,b.$Ot)(E);let i;if(E.length>0){const r=m+1;r===1?i=new M.$ct(v,a,v,a+o):i=new M.$ct(v,a,v+r-1,n+1)}else i=new M.$ct(v,a,v,a);return i}static _getInverseEditRanges(p){const E=[];let v=0,a=0,m=null;for(let o=0,n=p.length;o<n;o++){const i=p[o];let r,s;m?m.range.endLineNumber===i.range.startLineNumber?(r=v,s=a+(i.range.startColumn-m.range.endColumn)):(r=v+(i.range.startLineNumber-m.range.endLineNumber),s=i.range.startColumn):(r=i.range.startLineNumber,s=i.range.startColumn);let t;if(i.text.length>0){const f=i.eolCount+1;f===1?t=new M.$ct(r,s,r,s+i.firstLineLength):t=new M.$ct(r,s,r+f-1,i.lastLineLength+1)}else t=new M.$ct(r,s,r,s);v=t.endLineNumber,a=t.endColumn,E.push(t),m=i}return E}static u(p,E){const v=M.$ct.compareRangesUsingEnds(p.range,E.range);return v===0?p.sortIndex-E.sortIndex:v}static w(p,E){const v=M.$ct.compareRangesUsingEnds(p.range,E.range);return v===0?E.sortIndex-p.sortIndex:-v}}e.$zC=A}),define(ke[199],Ee([1,0,14,130,198]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AC=void 0;class P{constructor($,y,A,I,p,E,v,a,m){this.a=$,this.b=y,this.c=A,this.d=I,this.e=p,this.f=E,this.g=v,this.h=a,this.j=m}k($){const y=this.c+this.d+this.e,A=this.c+this.e;return y===0?$===1?`
`:`\r
`:A>y/2?`\r
`:`
`}create($){const y=this.k($),A=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let p=0,E=A.length;p<E;p++){const v=A[p].buffer.replace(/\r\n|\r|\n/g,y),a=(0,L.$uC)(v);A[p]=new L.$xC(v,a)}const I=new M.$zC(A,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:I,disposable:I}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&u.$Jf($)&&(this.b=u.$If,$=$.substr(1));const y=$.charCodeAt($.length-1);y===13||y>=55296&&y<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=y):(this.m($,!1),this.c=!1,this.d=y)}m($,y){!y&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const y=(0,L.$vC)(this.e,$);this.a.push(new L.$xC($,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=u.$zf($)),this.k||(this.k=u.$Cf($)))}finish($=!0){return this.o(),new P(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const y=(0,L.$uC)($.buffer);$.lineStarts=y,this.d===13&&this.f++}}}e.$AC=R}),define(ke[134],Ee([1,0,21,11]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hab=$,e.$Iab=A;var M;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(M||(M={}));function P(I){for(let p=0,E=I.length;p<E;p+=4){const v=I[p+0],a=I[p+1],m=I[p+2],o=I[p+3];I[p+0]=o,I[p+1]=m,I[p+2]=a,I[p+3]=v}}function R(I){const p=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return L.$D()||P(p),u.$ue.wrap(p)}function b(I){const p=I.buffer;if(L.$D()||P(p),p.byteOffset%4===0)return new Uint32Array(p.buffer,p.byteOffset,p.length/4);{const E=new Uint8Array(p.byteLength);return E.set(p),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function $(I){const p=new Uint32Array(y(I));let E=0;if(p[E++]=I.id,I.type==="full")p[E++]=1,p[E++]=I.data.length,p.set(I.data,E),E+=I.data.length;else{p[E++]=2,p[E++]=I.deltas.length;for(const v of I.deltas)p[E++]=v.start,p[E++]=v.deleteCount,v.data?(p[E++]=v.data.length,p.set(v.data,E),E+=v.data.length):p[E++]=0}return R(p)}function y(I){let p=0;if(p+=2,I.type==="full")p+=1+I.data.length;else{p+=1,p+=3*I.deltas.length;for(const E of I.deltas)E.data&&(p+=E.data.length)}return p}function A(I){const p=b(I);let E=0;const v=p[E++];if(p[E++]===1){const n=p[E++],i=p.subarray(E,E+n);return E+=n,{id:v,type:"full",data:i}}const m=p[E++],o=[];for(let n=0;n<m;n++){const i=p[E++],r=p[E++],s=p[E++];let t;s>0&&(t=p.subarray(E,E+s),E+=s),o[n]={start:i,deleteCount:r,data:t}}return{id:v,type:"delta",deltas:o}}}),define(ke[200],Ee([9,10]),function(he,e){return he.create("vs/editor/common/config/editorOptions",e)}),define(ke[135],Ee([1,0,19,24,11,176,129,200]),function(he,e,u,L,M,P,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=m,e.clampedInt=n,e.clampedFloat=r,e.stringSet=f,e.cursorStyleToString=k,e.filterValidationDecorations=de;var $;(function(oe){oe[oe.None=0]="None",oe[oe.Keep=1]="Keep",oe[oe.Brackets=2]="Brackets",oe[oe.Advanced=3]="Advanced",oe[oe.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(ue){this.c=ue}hasChanged(ue){return this.c[ue]}}e.ConfigurationChangedEvent=y;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class I{constructor(ue,Pe,Ke,_e){this.id=ue,this.name=Pe,this.defaultValue=Ke,this.schema=_e}applyUpdate(ue,Pe){return E(ue,Pe)}compute(ue,Pe,Ke){return Ke}}class p{constructor(ue,Pe){this.newValue=ue,this.didChange=Pe}}e.ApplyUpdateResult=p;function E(oe,ue){if(typeof oe!="object"||typeof ue!="object"||!oe||!ue)return new p(ue,oe!==ue);if(Array.isArray(oe)||Array.isArray(ue)){const Ke=Array.isArray(oe)&&Array.isArray(ue)&&u.$ub(oe,ue);return new p(ue,!Ke)}let Pe=!1;for(const Ke in ue)if(ue.hasOwnProperty(Ke)){const _e=E(oe[Ke],ue[Ke]);_e.didChange&&(oe[Ke]=_e.newValue,Pe=!0)}return new p(oe,Pe)}class v{constructor(ue){this.schema=void 0,this.id=ue,this.name="_never_",this.defaultValue=void 0}applyUpdate(ue,Pe){return E(ue,Pe)}validate(ue){return this.defaultValue}}class a{constructor(ue,Pe,Ke,_e){this.id=ue,this.name=Pe,this.defaultValue=Ke,this.schema=_e}applyUpdate(ue,Pe){return E(ue,Pe)}validate(ue){return typeof ue>"u"?this.defaultValue:ue}compute(ue,Pe,Ke){return Ke}}function m(oe,ue){return typeof oe>"u"?ue:oe==="false"?!1:!!oe}class o extends a{constructor(ue,Pe,Ke,_e=void 0){typeof _e<"u"&&(_e.type="boolean",_e.default=Ke),super(ue,Pe,Ke,_e)}validate(ue){return m(ue,this.defaultValue)}}function n(oe,ue,Pe,Ke){if(typeof oe>"u")return ue;let _e=parseInt(oe,10);return isNaN(_e)?ue:(_e=Math.max(Pe,_e),_e=Math.min(Ke,_e),_e|0)}class i extends a{static clampedInt(ue,Pe,Ke,_e){return n(ue,Pe,Ke,_e)}constructor(ue,Pe,Ke,_e,Ne,lt=void 0){typeof lt<"u"&&(lt.type="integer",lt.default=Ke,lt.minimum=_e,lt.maximum=Ne),super(ue,Pe,Ke,lt),this.minimum=_e,this.maximum=Ne}validate(ue){return i.clampedInt(ue,this.defaultValue,this.minimum,this.maximum)}}function r(oe,ue,Pe,Ke){if(typeof oe>"u")return ue;const _e=s.float(oe,ue);return s.clamp(_e,Pe,Ke)}class s extends a{static clamp(ue,Pe,Ke){return ue<Pe?Pe:ue>Ke?Ke:ue}static float(ue,Pe){if(typeof ue=="number")return ue;if(typeof ue>"u")return Pe;const Ke=parseFloat(ue);return isNaN(Ke)?Pe:Ke}constructor(ue,Pe,Ke,_e,Ne){typeof Ne<"u"&&(Ne.type="number",Ne.default=Ke),super(ue,Pe,Ke,Ne),this.validationFn=_e}validate(ue){return this.validationFn(s.float(ue,this.defaultValue))}}class t extends a{static string(ue,Pe){return typeof ue!="string"?Pe:ue}constructor(ue,Pe,Ke,_e=void 0){typeof _e<"u"&&(_e.type="string",_e.default=Ke),super(ue,Pe,Ke,_e)}validate(ue){return t.string(ue,this.defaultValue)}}function f(oe,ue,Pe,Ke){return typeof oe!="string"?ue:Ke&&oe in Ke?Ke[oe]:Pe.indexOf(oe)===-1?ue:oe}class d extends a{constructor(ue,Pe,Ke,_e,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.enum=_e,Ne.default=Ke),super(ue,Pe,Ke,Ne),this.c=_e}validate(ue){return f(ue,this.defaultValue,this.c)}}class l extends I{constructor(ue,Pe,Ke,_e,Ne,lt,wt=void 0){typeof wt<"u"&&(wt.type="string",wt.enum=Ne,wt.default=_e),super(ue,Pe,Ke,wt),this.c=Ne,this.d=lt}validate(ue){return typeof ue!="string"?this.defaultValue:this.c.indexOf(ue)===-1?this.defaultValue:this.d(ue)}}function c(oe){switch(oe){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(ue){switch(ue){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ue,Pe,Ke){return Ke===0?ue.accessibilitySupport:Ke}}class g extends I{constructor(){const ue={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",ue,{"editor.comments.insertSpace":{type:"boolean",default:ue.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ue.ignoreEmptyLines,description:b.localize(5,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{insertSpace:m(Pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:m(Pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var S;(function(oe){oe[oe.Hidden=0]="Hidden",oe[oe.Blink=1]="Blink",oe[oe.Smooth=2]="Smooth",oe[oe.Phase=3]="Phase",oe[oe.Expand=4]="Expand",oe[oe.Solid=5]="Solid"})(S||(e.TextEditorCursorBlinkingStyle=S={}));function w(oe){switch(oe){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var C;(function(oe){oe[oe.Line=1]="Line",oe[oe.Block=2]="Block",oe[oe.Underline=3]="Underline",oe[oe.LineThin=4]="LineThin",oe[oe.BlockOutline=5]="BlockOutline",oe[oe.UnderlineThin=6]="UnderlineThin"})(C||(e.TextEditorCursorStyle=C={}));function k(oe){switch(oe){case C.Line:return"line";case C.Block:return"block";case C.Underline:return"underline";case C.LineThin:return"line-thin";case C.BlockOutline:return"block-outline";case C.UnderlineThin:return"underline-thin"}}function D(oe){switch(oe){case"line":return C.Line;case"block":return C.Block;case"underline":return C.Underline;case"line-thin":return C.LineThin;case"block-outline":return C.BlockOutline;case"underline-thin":return C.UnderlineThin}}class O extends v{constructor(){super(142)}compute(ue,Pe,Ke){const _e=["monaco-editor"];return Pe.get(39)&&_e.push(Pe.get(39)),ue.extraEditorClassName&&_e.push(ue.extraEditorClassName),Pe.get(74)==="default"?_e.push("mouse-default"):Pe.get(74)==="copy"&&_e.push("mouse-copy"),Pe.get(111)&&_e.push("showUnused"),Pe.get(140)&&_e.push("showDeprecated"),_e.join(" ")}}class F extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(ue,Pe,Ke){return Ke&&ue.emptySelectionClipboard}}class T extends I{constructor(){const ue={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",ue,{"editor.find.cursorMoveOnType":{type:"boolean",default:ue.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ue.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ue.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ue.globalFindClipboard,description:b.localize(16,null),included:M.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ue.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:ue.loop,description:b.localize(18,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{cursorMoveOnType:m(Pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ue.seedSearchStringFromSelection=="boolean"?ue.seedSearchStringFromSelection?"always":"never":f(Pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ue.autoFindInSelection=="boolean"?ue.autoFindInSelection?"always":"never":f(Pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:m(Pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:m(Pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:m(Pe.loop,this.defaultValue.loop)}}}class z extends I{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"||ue.length===0?z.OFF:ue==="true"?z.ON:ue:ue?z.ON:z.OFF}}e.EditorFontLigatures=z;class j extends I{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",j.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(ue){return typeof ue>"u"?this.defaultValue:typeof ue=="string"?ue==="false"?j.OFF:ue==="true"?j.TRANSLATE:ue:ue?j.TRANSLATE:j.OFF}compute(ue,Pe,Ke){return ue.fontInfo.fontVariationSettings}}e.EditorFontVariations=j;class N extends v{constructor(){super(50)}compute(ue,Pe,Ke){return ue.fontInfo}}class B extends a{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(ue){const Pe=s.float(ue,this.defaultValue);return Pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:s.clamp(Pe,6,100)}compute(ue,Pe,Ke){return ue.fontInfo.fontSize}}class W extends I{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.d,maximum:W.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(ue){return ue==="normal"||ue==="bold"?ue:String(i.clampedInt(ue,e.EDITOR_FONT_DEFAULTS.fontWeight,W.d,W.e))}}class Z extends I{constructor(){const ue={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:ue.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},Ke=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",ue,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...Pe},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...Pe},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...Pe},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...Pe},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...Pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ue.alternativeDefinitionCommand,enum:Ke,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ue.alternativeTypeDefinitionCommand,enum:Ke,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ue.alternativeDeclarationCommand,enum:Ke,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ue.alternativeImplementationCommand,enum:Ke,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ue.alternativeReferenceCommand,enum:Ke,description:b.localize(41,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{multiple:f(Pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Pe.multipleDefinitions??f(Pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Pe.multipleTypeDefinitions??f(Pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Pe.multipleDeclarations??f(Pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Pe.multipleImplementations??f(Pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Pe.multipleReferences??f(Pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class _ extends I{constructor(){const ue={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",ue,{"editor.hover.enabled":{type:"boolean",default:ue.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:ue.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:ue.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ue.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:ue.above,description:b.localize(46,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{enabled:m(Pe.enabled,this.defaultValue.enabled),delay:i.clampedInt(Pe.delay,this.defaultValue.delay,0,1e4),sticky:m(Pe.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(Pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:m(Pe.above,this.defaultValue.above)}}}var X;(function(oe){oe[oe.None=0]="None",oe[oe.Text=1]="Text",oe[oe.Blocks=2]="Blocks"})(X||(e.RenderMinimap=X={}));class x extends v{constructor(){super(145)}compute(ue,Pe,Ke){return x.computeLayout(Pe,{memory:ue.memory,outerWidth:ue.outerWidth,outerHeight:ue.outerHeight,isDominatedByLongLines:ue.isDominatedByLongLines,lineHeight:ue.fontInfo.lineHeight,viewLineCount:ue.viewLineCount,lineNumbersDigitCount:ue.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ue.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ue.fontInfo.maxDigitWidth,pixelRatio:ue.pixelRatio,glyphMarginDecorationLaneCount:ue.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ue){const Pe=ue.height/ue.lineHeight,Ke=Math.floor(ue.paddingTop/ue.lineHeight);let _e=Math.floor(ue.paddingBottom/ue.lineHeight);ue.scrollBeyondLastLine&&(_e=Math.max(_e,Pe-1));const Ne=(Ke+ue.viewLineCount+_e)/(ue.pixelRatio*ue.height),lt=Math.floor(ue.viewLineCount/Ne);return{typicalViewportLineCount:Pe,extraLinesBeforeFirstLine:Ke,extraLinesBeyondLastLine:_e,desiredRatio:Ne,minimapLineCount:lt}}static c(ue,Pe){const Ke=ue.outerWidth,_e=ue.outerHeight,Ne=ue.pixelRatio;if(!ue.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ne*_e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:_e};const lt=Pe.stableMinimapLayoutInput,wt=lt&&ue.outerHeight===lt.outerHeight&&ue.lineHeight===lt.lineHeight&&ue.typicalHalfwidthCharacterWidth===lt.typicalHalfwidthCharacterWidth&&ue.pixelRatio===lt.pixelRatio&&ue.scrollBeyondLastLine===lt.scrollBeyondLastLine&&ue.paddingTop===lt.paddingTop&&ue.paddingBottom===lt.paddingBottom&&ue.minimap.enabled===lt.minimap.enabled&&ue.minimap.side===lt.minimap.side&&ue.minimap.size===lt.minimap.size&&ue.minimap.showSlider===lt.minimap.showSlider&&ue.minimap.renderCharacters===lt.minimap.renderCharacters&&ue.minimap.maxColumn===lt.minimap.maxColumn&&ue.minimap.scale===lt.minimap.scale&&ue.verticalScrollbarWidth===lt.verticalScrollbarWidth&&ue.isViewportWrapping===lt.isViewportWrapping,At=ue.lineHeight,zt=ue.typicalHalfwidthCharacterWidth,Qt=ue.scrollBeyondLastLine,_t=ue.minimap.renderCharacters;let Ct=Ne>=2?Math.round(ue.minimap.scale*2):ue.minimap.scale;const Xt=ue.minimap.maxColumn,Vt=ue.minimap.size,ai=ue.minimap.side,tt=ue.verticalScrollbarWidth,ei=ue.viewLineCount,ti=ue.remainingWidth,ft=ue.isViewportWrapping,bt=_t?2:3;let si=Math.floor(Ne*_e);const ii=si/Ne;let jt=!1,mt=!1,Rt=bt*Ct,qt=Ct/Ne,Zt=1;if(Vt==="fill"||Vt==="fit"){const{typicalViewportLineCount:Ot,extraLinesBeforeFirstLine:Tt,extraLinesBeyondLastLine:ni,desiredRatio:oi,minimapLineCount:Ht}=x.computeContainedMinimapLineCount({viewLineCount:ei,scrollBeyondLastLine:Qt,paddingTop:ue.paddingTop,paddingBottom:ue.paddingBottom,height:_e,lineHeight:At,pixelRatio:Ne});if(ei/Ht>1)jt=!0,mt=!0,Ct=1,Rt=1,qt=Ct/Ne;else{let St=!1,Gt=Ct+1;if(Vt==="fit"){const Pt=Math.ceil((Tt+ei+ni)*Rt);ft&&wt&&ti<=Pe.stableFitRemainingWidth?(St=!0,Gt=Pe.stableFitMaxMinimapScale):St=Pt>si}if(Vt==="fill"||St){jt=!0;const Pt=Ct;Rt=Math.min(At*Ne,Math.max(1,Math.floor(1/oi))),ft&&wt&&ti<=Pe.stableFitRemainingWidth&&(Gt=Pe.stableFitMaxMinimapScale),Ct=Math.min(Gt,Math.max(1,Math.floor(Rt/bt))),Ct>Pt&&(Zt=Math.min(2,Ct/Pt)),qt=Ct/Ne/Zt,si=Math.ceil(Math.max(Ot,Tt+ei+ni)*Rt),ft?(Pe.stableMinimapLayoutInput=ue,Pe.stableFitRemainingWidth=ti,Pe.stableFitMaxMinimapScale=Ct):(Pe.stableMinimapLayoutInput=null,Pe.stableFitRemainingWidth=0)}}}const Ze=Math.floor(Xt*qt),Yt=Math.min(Ze,Math.max(0,Math.floor((ti-tt-2)*qt/(zt+qt)))+e.MINIMAP_GUTTER_WIDTH);let Bt=Math.floor(Ne*Yt);const Ut=Bt/Ne;Bt=Math.floor(Bt*Zt);const $t=_t?1:2,Ft=ai==="left"?0:Ke-Yt-tt;return{renderMinimap:$t,minimapLeft:Ft,minimapWidth:Yt,minimapHeightIsEditorHeight:jt,minimapIsSampling:mt,minimapScale:Ct,minimapLineHeight:Rt,minimapCanvasInnerWidth:Bt,minimapCanvasInnerHeight:si,minimapCanvasOuterWidth:Ut,minimapCanvasOuterHeight:ii}}static computeLayout(ue,Pe){const Ke=Pe.outerWidth|0,_e=Pe.outerHeight|0,Ne=Pe.lineHeight|0,lt=Pe.lineNumbersDigitCount|0,wt=Pe.typicalHalfwidthCharacterWidth,At=Pe.maxDigitWidth,zt=Pe.pixelRatio,Qt=Pe.viewLineCount,_t=ue.get(137),Ct=_t==="inherit"?ue.get(136):_t,Xt=Ct==="inherit"?ue.get(132):Ct,Vt=ue.get(135),ai=Pe.isDominatedByLongLines,tt=ue.get(57),ei=ue.get(68).renderType!==0,ti=ue.get(69),ft=ue.get(105),bt=ue.get(84),si=ue.get(73),ii=ue.get(103),jt=ii.verticalScrollbarSize,mt=ii.verticalHasArrows,Rt=ii.arrowSize,qt=ii.horizontalScrollbarSize,Zt=ue.get(43),Ze=ue.get(110)!=="never";let Yt=ue.get(66);Zt&&Ze&&(Yt+=16);let Bt=0;if(ei){const Dt=Math.max(lt,ti);Bt=Math.round(Dt*At)}let Ut=0;tt&&(Ut=Ne*Pe.glyphMarginDecorationLaneCount);let $t=0,Ft=$t+Ut,Ot=Ft+Bt,Tt=Ot+Yt;const ni=Ke-Ut-Bt-Yt;let oi=!1,Ht=!1,It=-1;Ct==="inherit"&&ai?(oi=!0,Ht=!0):Xt==="on"||Xt==="bounded"?Ht=!0:Xt==="wordWrapColumn"&&(It=Vt);const St=x.c({outerWidth:Ke,outerHeight:_e,lineHeight:Ne,typicalHalfwidthCharacterWidth:wt,pixelRatio:zt,scrollBeyondLastLine:ft,paddingTop:bt.top,paddingBottom:bt.bottom,minimap:si,verticalScrollbarWidth:jt,viewLineCount:Qt,remainingWidth:ni,isViewportWrapping:Ht},Pe.memory||new A);St.renderMinimap!==0&&St.minimapLeft===0&&($t+=St.minimapWidth,Ft+=St.minimapWidth,Ot+=St.minimapWidth,Tt+=St.minimapWidth);const Gt=ni-St.minimapWidth,Pt=Math.max(1,Math.floor((Gt-jt-2)/wt)),yt=mt?Rt:0;return Ht&&(It=Math.max(1,Pt),Xt==="bounded"&&(It=Math.min(It,Vt))),{width:Ke,height:_e,glyphMarginLeft:$t,glyphMarginWidth:Ut,glyphMarginDecorationLaneCount:Pe.glyphMarginDecorationLaneCount,lineNumbersLeft:Ft,lineNumbersWidth:Bt,decorationsLeft:Ot,decorationsWidth:Yt,contentLeft:Tt,contentWidth:Gt,minimap:St,viewportColumn:Pt,isWordWrapMinified:oi,isViewportWrapping:Ht,wrappingColumn:It,verticalScrollbarWidth:jt,horizontalScrollbarHeight:qt,overviewRuler:{top:yt,width:jt,height:_e-2*yt,right:0}}}}e.EditorLayoutInfoComputer=x;class re extends I{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(ue){return f(ue,"simple",["simple","advanced"])}compute(ue,Pe,Ke){return Pe.get(2)===2?"advanced":Ke}}var Y;(function(oe){oe.Off="off",oe.OnCode="onCode",oe.On="on"})(Y||(e.ShowLightbulbIconMode=Y={}));class me extends I{constructor(){const ue={enabled:Y.OnCode};super(65,"lightbulb",ue,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Y.Off,Y.OnCode,Y.On],default:ue.enabled,enumDescriptions:[b.localize(50,null),b.localize(51,null),b.localize(52,null)],description:b.localize(53,null)}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{enabled:f(ue.enabled,this.defaultValue.enabled,[Y.Off,Y.OnCode,Y.On])}}}class Ce extends I{constructor(){const ue={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",ue,{"editor.stickyScroll.enabled":{type:"boolean",default:ue.enabled,description:b.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:ue.maxLineCount,minimum:1,maximum:20,description:b.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ue.defaultModel,description:b.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ue.scrollWithEditor,description:b.localize(57,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{enabled:m(Pe.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(Pe.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:f(Pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:m(Pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ee extends I{constructor(){const ue={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",ue,{"editor.inlayHints.enabled":{type:"string",default:ue.enabled,description:b.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(59,null),b.localize(60,null,M.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(61,null,M.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:ue.fontSize,markdownDescription:b.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ue.fontFamily,markdownDescription:b.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ue.padding,description:b.localize(65,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return typeof Pe.enabled=="boolean"&&(Pe.enabled=Pe.enabled?"on":"off"),{enabled:f(Pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(Pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Pe.fontFamily,this.defaultValue.fontFamily),padding:m(Pe.padding,this.defaultValue.padding)}}}class U extends I{constructor(){super(66,"lineDecorationsWidth",10)}validate(ue){return typeof ue=="string"&&/^\d+(\.\d+)?ch$/.test(ue)?-parseFloat(ue.substring(0,ue.length-2)):i.clampedInt(ue,this.defaultValue,0,1e3)}compute(ue,Pe,Ke){return Ke<0?i.clampedInt(-Ke*ue.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ke}}class ie extends s{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ue=>s.clamp(ue,0,150),{markdownDescription:b.localize(66,null)})}compute(ue,Pe,Ke){return ue.fontInfo.lineHeight}}class be extends I{constructor(){const ue={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",ue,{"editor.minimap.enabled":{type:"boolean",default:ue.enabled,description:b.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:ue.autohide,description:b.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(69,null),b.localize(70,null),b.localize(71,null)],default:ue.size,description:b.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ue.side,description:b.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ue.showSlider,description:b.localize(74,null)},"editor.minimap.scale":{type:"number",default:ue.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ue.renderCharacters,description:b.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:ue.maxColumn,description:b.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:ue.showRegionSectionHeaders,description:b.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:ue.showMarkSectionHeaders,description:b.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:ue.sectionHeaderFontSize,description:b.localize(80,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{enabled:m(Pe.enabled,this.defaultValue.enabled),autohide:m(Pe.autohide,this.defaultValue.autohide),size:f(Pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:f(Pe.side,this.defaultValue.side,["right","left"]),showSlider:f(Pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:m(Pe.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(Pe.scale,1,1,3),maxColumn:i.clampedInt(Pe.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:m(Pe.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:m(Pe.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:s.clamp(Pe.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Se(oe){return oe==="ctrlCmd"?M.$j?"metaKey":"ctrlKey":"altKey"}class ae extends I{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(82,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{top:i.clampedInt(Pe.top,0,0,1e3),bottom:i.clampedInt(Pe.bottom,0,0,1e3)}}}class ce extends I{constructor(){const ue={enabled:!0,cycle:!0};super(86,"parameterHints",ue,{"editor.parameterHints.enabled":{type:"boolean",default:ue.enabled,description:b.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:ue.cycle,description:b.localize(84,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{enabled:m(Pe.enabled,this.defaultValue.enabled),cycle:m(Pe.cycle,this.defaultValue.cycle)}}}class se extends v{constructor(){super(143)}compute(ue,Pe,Ke){return ue.pixelRatio}}class K extends I{constructor(){const ue={other:"on",comments:"off",strings:"off"},Pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(85,null),b.localize(86,null),b.localize(87,null)]}];super(89,"quickSuggestions",ue,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Pe,default:ue.strings,description:b.localize(88,null)},comments:{anyOf:Pe,default:ue.comments,description:b.localize(89,null)},other:{anyOf:Pe,default:ue.other,description:b.localize(90,null)}},default:ue,markdownDescription:b.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=ue}validate(ue){if(typeof ue=="boolean"){const zt=ue?"on":"off";return{comments:zt,strings:zt,other:zt}}if(!ue||typeof ue!="object")return this.defaultValue;const{other:Pe,comments:Ke,strings:_e}=ue,Ne=["on","inline","off"];let lt,wt,At;return typeof Pe=="boolean"?lt=Pe?"on":"off":lt=f(Pe,this.defaultValue.other,Ne),typeof Ke=="boolean"?wt=Ke?"on":"off":wt=f(Ke,this.defaultValue.comments,Ne),typeof _e=="boolean"?At=_e?"on":"off":At=f(_e,this.defaultValue.strings,Ne),{other:lt,comments:wt,strings:At}}}var te;(function(oe){oe[oe.Off=0]="Off",oe[oe.On=1]="On",oe[oe.Relative=2]="Relative",oe[oe.Interval=3]="Interval",oe[oe.Custom=4]="Custom"})(te||(e.RenderLineNumbersType=te={}));class le extends I{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(92,null),b.localize(93,null),b.localize(94,null),b.localize(95,null)],default:"on",description:b.localize(96,null)})}validate(ue){let Pe=this.defaultValue.renderType,Ke=this.defaultValue.renderFn;return typeof ue<"u"&&(typeof ue=="function"?(Pe=4,Ke=ue):ue==="interval"?Pe=3:ue==="relative"?Pe=2:ue==="on"?Pe=1:Pe=0),{renderType:Pe,renderFn:Ke}}}function de(oe){const ue=oe.get(98);return ue==="editable"?oe.get(91):ue!=="on"}class Ae extends I{constructor(){const ue=[],Pe={type:"number",description:b.localize(97,null)};super(102,"rulers",ue,{type:"array",items:{anyOf:[Pe,{type:["object"],properties:{column:Pe,color:{type:"string",description:b.localize(98,null),format:"color-hex"}}}]},default:ue,description:b.localize(99,null)})}validate(ue){if(Array.isArray(ue)){const Pe=[];for(const Ke of ue)if(typeof Ke=="number")Pe.push({column:i.clampedInt(Ke,0,0,1e4),color:null});else if(Ke&&typeof Ke=="object"){const _e=Ke;Pe.push({column:i.clampedInt(_e.column,0,0,1e4),color:_e.color})}return Pe.sort((Ke,_e)=>Ke.column-_e.column),Pe}return this.defaultValue}}class $e extends I{constructor(){super(92,"readOnlyMessage",void 0)}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:ue}}function Ie(oe,ue){if(typeof oe!="string")return ue;switch(oe){case"hidden":return 2;case"visible":return 3;default:return 1}}class Re extends I{constructor(){const ue={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",ue,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(100,null),b.localize(101,null),b.localize(102,null)],default:"auto",description:b.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(104,null),b.localize(105,null),b.localize(106,null)],default:"auto",description:b.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ue.verticalScrollbarSize,description:b.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ue.horizontalScrollbarSize,description:b.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ue.scrollByPage,description:b.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ue.ignoreHorizontalScrollbarInContentHeight,description:b.localize(111,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue,Ke=i.clampedInt(Pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),_e=i.clampedInt(Pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(Pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(Pe.vertical,this.defaultValue.vertical),horizontal:Ie(Pe.horizontal,this.defaultValue.horizontal),useShadows:m(Pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:m(Pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:m(Pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:m(Pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:m(Pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ke,horizontalSliderSize:i.clampedInt(Pe.horizontalSliderSize,Ke,0,1e3),verticalScrollbarSize:_e,verticalSliderSize:i.clampedInt(Pe.verticalSliderSize,_e,0,1e3),scrollByPage:m(Pe.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:m(Pe.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Fe extends I{constructor(){const ue={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",ue,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.nonBasicASCII,description:b.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ue.invisibleCharacters,description:b.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ue.ambiguousCharacters,description:b.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeComments,description:b.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ue.includeStrings,description:b.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ue.allowedCharacters,description:b.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ue.allowedLocales,description:b.localize(118,null)}})}applyUpdate(ue,Pe){let Ke=!1;Pe.allowedCharacters&&ue&&(L.$Sn(ue.allowedCharacters,Pe.allowedCharacters)||(ue={...ue,allowedCharacters:Pe.allowedCharacters},Ke=!0)),Pe.allowedLocales&&ue&&(L.$Sn(ue.allowedLocales,Pe.allowedLocales)||(ue={...ue,allowedLocales:Pe.allowedLocales},Ke=!0));const _e=super.applyUpdate(ue,Pe);return Ke?new p(_e.newValue,!0):_e}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{nonBasicASCII:fe(Pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:m(Pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:m(Pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:fe(Pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:fe(Pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ue.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ue.allowedLocales,this.defaultValue.allowedLocales)}}c(ue,Pe){if(typeof ue!="object"||!ue)return Pe;const Ke={};for(const[_e,Ne]of Object.entries(ue))Ne===!0&&(Ke[_e]=!0);return Ke}}class q extends I{constructor(){const ue={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",ue,{"editor.inlineSuggest.enabled":{type:"boolean",default:ue.enabled,description:b.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ue.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(120,null),b.localize(121,null),b.localize(122,null)],description:b.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ue.suppressSuggestions,description:b.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:ue.fontFamily,description:b.localize(125,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{enabled:m(Pe.enabled,this.defaultValue.enabled),mode:f(Pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:f(Pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:m(Pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:m(Pe.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Pe.fontFamily,this.defaultValue.fontFamily)}}}class V extends I{constructor(){const ue={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",ue,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:ue.enabled,description:b.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:ue.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(127,null),b.localize(128,null),b.localize(129,null)],description:b.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:ue.fontFamily,description:b.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:ue.backgroundColoring,description:b.localize(132,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{enabled:m(Pe.enabled,this.defaultValue.enabled),showToolbar:f(Pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(Pe.fontFamily,this.defaultValue.fontFamily),keepOnBlur:m(Pe.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:m(Pe.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Q extends I{constructor(){const ue={enabled:P.$Ms.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:P.$Ms.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",ue,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ue.enabled,markdownDescription:b.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ue.independentColorPoolPerBracketType,description:b.localize(134,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{enabled:m(Pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:m(Pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class J extends I{constructor(){const ue={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",ue,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(135,null),b.localize(136,null),b.localize(137,null)],default:ue.bracketPairs,description:b.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(139,null),b.localize(140,null),b.localize(141,null)],default:ue.bracketPairsHorizontal,description:b.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ue.highlightActiveBracketPair,description:b.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:ue.indentation,description:b.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(145,null),b.localize(146,null),b.localize(147,null)],default:ue.highlightActiveIndentation,description:b.localize(148,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{bracketPairs:fe(Pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:fe(Pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:m(Pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:m(Pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:fe(Pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function fe(oe,ue,Pe){const Ke=Pe.indexOf(oe);return Ke===-1?ue:Pe[Ke]}class we extends I{constructor(){const ue={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",ue,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(149,null),b.localize(150,null)],default:ue.insertMode,description:b.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ue.filterGraceful,description:b.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:ue.localityBonus,description:b.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ue.shareSuggestSelections,markdownDescription:b.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(155,null),b.localize(156,null),b.localize(157,null),b.localize(158,null)],default:ue.selectionMode,markdownDescription:b.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ue.snippetsPreventQuickSuggestions,description:b.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:ue.showIcons,description:b.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ue.showStatusBar,description:b.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:ue.preview,description:b.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ue.showInlineDetails,description:b.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(196,null)}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{insertMode:f(Pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:m(Pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:m(Pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:m(Pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:m(Pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:f(Pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:m(Pe.showIcons,this.defaultValue.showIcons),showStatusBar:m(Pe.showStatusBar,this.defaultValue.showStatusBar),preview:m(Pe.preview,this.defaultValue.preview),previewMode:f(Pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:m(Pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:m(Pe.showMethods,this.defaultValue.showMethods),showFunctions:m(Pe.showFunctions,this.defaultValue.showFunctions),showConstructors:m(Pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:m(Pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:m(Pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:m(Pe.showFields,this.defaultValue.showFields),showVariables:m(Pe.showVariables,this.defaultValue.showVariables),showClasses:m(Pe.showClasses,this.defaultValue.showClasses),showStructs:m(Pe.showStructs,this.defaultValue.showStructs),showInterfaces:m(Pe.showInterfaces,this.defaultValue.showInterfaces),showModules:m(Pe.showModules,this.defaultValue.showModules),showProperties:m(Pe.showProperties,this.defaultValue.showProperties),showEvents:m(Pe.showEvents,this.defaultValue.showEvents),showOperators:m(Pe.showOperators,this.defaultValue.showOperators),showUnits:m(Pe.showUnits,this.defaultValue.showUnits),showValues:m(Pe.showValues,this.defaultValue.showValues),showConstants:m(Pe.showConstants,this.defaultValue.showConstants),showEnums:m(Pe.showEnums,this.defaultValue.showEnums),showEnumMembers:m(Pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:m(Pe.showKeywords,this.defaultValue.showKeywords),showWords:m(Pe.showWords,this.defaultValue.showWords),showColors:m(Pe.showColors,this.defaultValue.showColors),showFiles:m(Pe.showFiles,this.defaultValue.showFiles),showReferences:m(Pe.showReferences,this.defaultValue.showReferences),showFolders:m(Pe.showFolders,this.defaultValue.showFolders),showTypeParameters:m(Pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:m(Pe.showSnippets,this.defaultValue.showSnippets),showUsers:m(Pe.showUsers,this.defaultValue.showUsers),showIssues:m(Pe.showIssues,this.defaultValue.showIssues)}}}class Te extends I{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(198,null),default:!0,type:"boolean"}})}validate(ue){return!ue||typeof ue!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:m(ue.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:m(ue.selectSubwords,this.defaultValue.selectSubwords)}}}class He extends I{constructor(){const ue=[];super(130,"wordSegmenterLocales",ue,{anyOf:[{description:b.localize(199,null),type:"string"},{description:b.localize(200,null),type:"array",items:{type:"string"}}]})}validate(ue){if(typeof ue=="string"&&(ue=[ue]),Array.isArray(ue)){const Pe=[];for(const Ke of ue)if(typeof Ke=="string")try{Intl.Segmenter.supportedLocalesOf(Ke).length>0&&Pe.push(Ke)}catch{}return Pe}return this.defaultValue}}var xe;(function(oe){oe[oe.None=0]="None",oe[oe.Same=1]="Same",oe[oe.Indent=2]="Indent",oe[oe.DeepIndent=3]="DeepIndent"})(xe||(e.WrappingIndent=xe={}));class it extends I{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(201,null),b.localize(202,null),b.localize(203,null),b.localize(204,null)],description:b.localize(205,null),default:"same"}})}validate(ue){switch(ue){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(ue,Pe,Ke){return Pe.get(2)===2?0:Ke}}class rt extends v{constructor(){super(146)}compute(ue,Pe,Ke){const _e=Pe.get(145);return{isDominatedByLongLines:ue.isDominatedByLongLines,isWordWrapMinified:_e.isWordWrapMinified,isViewportWrapping:_e.isViewportWrapping,wrappingColumn:_e.wrappingColumn}}}class at extends I{constructor(){const ue={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",ue,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ue.enabled,markdownDescription:b.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(208,null),b.localize(209,null)],default:"afterDrop"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{enabled:m(Pe.enabled,this.defaultValue.enabled),showDropSelector:f(Pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ot extends I{constructor(){const ue={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",ue,{"editor.pasteAs.enabled":{type:"boolean",default:ue.enabled,markdownDescription:b.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(212,null),b.localize(213,null)],default:"afterPaste"}})}validate(ue){if(!ue||typeof ue!="object")return this.defaultValue;const Pe=ue;return{enabled:m(Pe.enabled,this.defaultValue.enabled),showPasteSelector:f(Pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const De="Consolas, 'Courier New', monospace",Be="Menlo, Monaco, 'Courier New', monospace",Ge="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:M.$j?Be:M.$k?Ge:De,fontWeight:"normal",fontSize:M.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Oe(oe){return e.editorOptionsRegistry[oe.id]=oe,oe}var Qe;(function(oe){oe[oe.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",oe[oe.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",oe[oe.accessibilitySupport=2]="accessibilitySupport",oe[oe.accessibilityPageSize=3]="accessibilityPageSize",oe[oe.ariaLabel=4]="ariaLabel",oe[oe.ariaRequired=5]="ariaRequired",oe[oe.autoClosingBrackets=6]="autoClosingBrackets",oe[oe.autoClosingComments=7]="autoClosingComments",oe[oe.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",oe[oe.autoClosingDelete=9]="autoClosingDelete",oe[oe.autoClosingOvertype=10]="autoClosingOvertype",oe[oe.autoClosingQuotes=11]="autoClosingQuotes",oe[oe.autoIndent=12]="autoIndent",oe[oe.automaticLayout=13]="automaticLayout",oe[oe.autoSurround=14]="autoSurround",oe[oe.bracketPairColorization=15]="bracketPairColorization",oe[oe.guides=16]="guides",oe[oe.codeLens=17]="codeLens",oe[oe.codeLensFontFamily=18]="codeLensFontFamily",oe[oe.codeLensFontSize=19]="codeLensFontSize",oe[oe.colorDecorators=20]="colorDecorators",oe[oe.colorDecoratorsLimit=21]="colorDecoratorsLimit",oe[oe.columnSelection=22]="columnSelection",oe[oe.comments=23]="comments",oe[oe.contextmenu=24]="contextmenu",oe[oe.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",oe[oe.cursorBlinking=26]="cursorBlinking",oe[oe.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",oe[oe.cursorStyle=28]="cursorStyle",oe[oe.cursorSurroundingLines=29]="cursorSurroundingLines",oe[oe.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",oe[oe.cursorWidth=31]="cursorWidth",oe[oe.disableLayerHinting=32]="disableLayerHinting",oe[oe.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",oe[oe.domReadOnly=34]="domReadOnly",oe[oe.dragAndDrop=35]="dragAndDrop",oe[oe.dropIntoEditor=36]="dropIntoEditor",oe[oe.emptySelectionClipboard=37]="emptySelectionClipboard",oe[oe.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",oe[oe.extraEditorClassName=39]="extraEditorClassName",oe[oe.fastScrollSensitivity=40]="fastScrollSensitivity",oe[oe.find=41]="find",oe[oe.fixedOverflowWidgets=42]="fixedOverflowWidgets",oe[oe.folding=43]="folding",oe[oe.foldingStrategy=44]="foldingStrategy",oe[oe.foldingHighlight=45]="foldingHighlight",oe[oe.foldingImportsByDefault=46]="foldingImportsByDefault",oe[oe.foldingMaximumRegions=47]="foldingMaximumRegions",oe[oe.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",oe[oe.fontFamily=49]="fontFamily",oe[oe.fontInfo=50]="fontInfo",oe[oe.fontLigatures=51]="fontLigatures",oe[oe.fontSize=52]="fontSize",oe[oe.fontWeight=53]="fontWeight",oe[oe.fontVariations=54]="fontVariations",oe[oe.formatOnPaste=55]="formatOnPaste",oe[oe.formatOnType=56]="formatOnType",oe[oe.glyphMargin=57]="glyphMargin",oe[oe.gotoLocation=58]="gotoLocation",oe[oe.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",oe[oe.hover=60]="hover",oe[oe.inDiffEditor=61]="inDiffEditor",oe[oe.inlineSuggest=62]="inlineSuggest",oe[oe.inlineEdit=63]="inlineEdit",oe[oe.letterSpacing=64]="letterSpacing",oe[oe.lightbulb=65]="lightbulb",oe[oe.lineDecorationsWidth=66]="lineDecorationsWidth",oe[oe.lineHeight=67]="lineHeight",oe[oe.lineNumbers=68]="lineNumbers",oe[oe.lineNumbersMinChars=69]="lineNumbersMinChars",oe[oe.linkedEditing=70]="linkedEditing",oe[oe.links=71]="links",oe[oe.matchBrackets=72]="matchBrackets",oe[oe.minimap=73]="minimap",oe[oe.mouseStyle=74]="mouseStyle",oe[oe.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",oe[oe.mouseWheelZoom=76]="mouseWheelZoom",oe[oe.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",oe[oe.multiCursorModifier=78]="multiCursorModifier",oe[oe.multiCursorPaste=79]="multiCursorPaste",oe[oe.multiCursorLimit=80]="multiCursorLimit",oe[oe.occurrencesHighlight=81]="occurrencesHighlight",oe[oe.overviewRulerBorder=82]="overviewRulerBorder",oe[oe.overviewRulerLanes=83]="overviewRulerLanes",oe[oe.padding=84]="padding",oe[oe.pasteAs=85]="pasteAs",oe[oe.parameterHints=86]="parameterHints",oe[oe.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",oe[oe.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",oe[oe.quickSuggestions=89]="quickSuggestions",oe[oe.quickSuggestionsDelay=90]="quickSuggestionsDelay",oe[oe.readOnly=91]="readOnly",oe[oe.readOnlyMessage=92]="readOnlyMessage",oe[oe.renameOnType=93]="renameOnType",oe[oe.renderControlCharacters=94]="renderControlCharacters",oe[oe.renderFinalNewline=95]="renderFinalNewline",oe[oe.renderLineHighlight=96]="renderLineHighlight",oe[oe.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",oe[oe.renderValidationDecorations=98]="renderValidationDecorations",oe[oe.renderWhitespace=99]="renderWhitespace",oe[oe.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",oe[oe.roundedSelection=101]="roundedSelection",oe[oe.rulers=102]="rulers",oe[oe.scrollbar=103]="scrollbar",oe[oe.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",oe[oe.scrollBeyondLastLine=105]="scrollBeyondLastLine",oe[oe.scrollPredominantAxis=106]="scrollPredominantAxis",oe[oe.selectionClipboard=107]="selectionClipboard",oe[oe.selectionHighlight=108]="selectionHighlight",oe[oe.selectOnLineNumbers=109]="selectOnLineNumbers",oe[oe.showFoldingControls=110]="showFoldingControls",oe[oe.showUnused=111]="showUnused",oe[oe.snippetSuggestions=112]="snippetSuggestions",oe[oe.smartSelect=113]="smartSelect",oe[oe.smoothScrolling=114]="smoothScrolling",oe[oe.stickyScroll=115]="stickyScroll",oe[oe.stickyTabStops=116]="stickyTabStops",oe[oe.stopRenderingLineAfter=117]="stopRenderingLineAfter",oe[oe.suggest=118]="suggest",oe[oe.suggestFontSize=119]="suggestFontSize",oe[oe.suggestLineHeight=120]="suggestLineHeight",oe[oe.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",oe[oe.suggestSelection=122]="suggestSelection",oe[oe.tabCompletion=123]="tabCompletion",oe[oe.tabIndex=124]="tabIndex",oe[oe.unicodeHighlighting=125]="unicodeHighlighting",oe[oe.unusualLineTerminators=126]="unusualLineTerminators",oe[oe.useShadowDOM=127]="useShadowDOM",oe[oe.useTabStops=128]="useTabStops",oe[oe.wordBreak=129]="wordBreak",oe[oe.wordSegmenterLocales=130]="wordSegmenterLocales",oe[oe.wordSeparators=131]="wordSeparators",oe[oe.wordWrap=132]="wordWrap",oe[oe.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",oe[oe.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",oe[oe.wordWrapColumn=135]="wordWrapColumn",oe[oe.wordWrapOverride1=136]="wordWrapOverride1",oe[oe.wordWrapOverride2=137]="wordWrapOverride2",oe[oe.wrappingIndent=138]="wrappingIndent",oe[oe.wrappingStrategy=139]="wrappingStrategy",oe[oe.showDeprecated=140]="showDeprecated",oe[oe.inlayHints=141]="inlayHints",oe[oe.editorClassName=142]="editorClassName",oe[oe.pixelRatio=143]="pixelRatio",oe[oe.tabFocusMode=144]="tabFocusMode",oe[oe.layoutInfo=145]="layoutInfo",oe[oe.wrappingInfo=146]="wrappingInfo",oe[oe.defaultColorDecorators=147]="defaultColorDecorators",oe[oe.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",oe[oe.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(Qe||(e.EditorOption=Qe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Oe(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(214,null)})),acceptSuggestionOnEnter:Oe(new d(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(215,null),""],markdownDescription:b.localize(216,null)})),accessibilitySupport:Oe(new h),accessibilityPageSize:Oe(new i(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(217,null),tags:["accessibility"]})),ariaLabel:Oe(new t(4,"ariaLabel",b.localize(218,null))),ariaRequired:Oe(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Oe(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Oe(new d(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(220,null),b.localize(221,null),""],description:b.localize(222,null)})),autoClosingComments:Oe(new d(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(223,null),b.localize(224,null),""],description:b.localize(225,null)})),autoClosingDelete:Oe(new d(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(226,null),""],description:b.localize(227,null)})),autoClosingOvertype:Oe(new d(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(228,null),""],description:b.localize(229,null)})),autoClosingQuotes:Oe(new d(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(230,null),b.localize(231,null),""],description:b.localize(232,null)})),autoIndent:Oe(new l(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[b.localize(233,null),b.localize(234,null),b.localize(235,null),b.localize(236,null),b.localize(237,null)],description:b.localize(238,null)})),automaticLayout:Oe(new o(13,"automaticLayout",!1)),autoSurround:Oe(new d(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(239,null),b.localize(240,null),b.localize(241,null),""],description:b.localize(242,null)})),bracketPairColorization:Oe(new Q),bracketPairGuides:Oe(new J),stickyTabStops:Oe(new o(116,"stickyTabStops",!1,{description:b.localize(243,null)})),codeLens:Oe(new o(17,"codeLens",!0,{description:b.localize(244,null)})),codeLensFontFamily:Oe(new t(18,"codeLensFontFamily","",{description:b.localize(245,null)})),codeLensFontSize:Oe(new i(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(246,null)})),colorDecorators:Oe(new o(20,"colorDecorators",!0,{description:b.localize(247,null)})),colorDecoratorActivatedOn:Oe(new d(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(248,null),b.localize(249,null),b.localize(250,null)],description:b.localize(251,null)})),colorDecoratorsLimit:Oe(new i(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(252,null)})),columnSelection:Oe(new o(22,"columnSelection",!1,{description:b.localize(253,null)})),comments:Oe(new g),contextmenu:Oe(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Oe(new o(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(254,null)})),cursorBlinking:Oe(new l(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],w,{description:b.localize(255,null)})),cursorSmoothCaretAnimation:Oe(new d(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(256,null),b.localize(257,null),b.localize(258,null)],description:b.localize(259,null)})),cursorStyle:Oe(new l(28,"cursorStyle",C.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],D,{description:b.localize(260,null)})),cursorSurroundingLines:Oe(new i(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(261,null)})),cursorSurroundingLinesStyle:Oe(new d(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(262,null),b.localize(263,null)],markdownDescription:b.localize(264,null)})),cursorWidth:Oe(new i(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(265,null)})),disableLayerHinting:Oe(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Oe(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Oe(new o(34,"domReadOnly",!1)),dragAndDrop:Oe(new o(35,"dragAndDrop",!0,{description:b.localize(266,null)})),emptySelectionClipboard:Oe(new F),dropIntoEditor:Oe(new at),stickyScroll:Oe(new Ce),experimentalWhitespaceRendering:Oe(new d(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(267,null),b.localize(268,null),b.localize(269,null)],description:b.localize(270,null)})),extraEditorClassName:Oe(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Oe(new s(40,"fastScrollSensitivity",5,oe=>oe<=0?5:oe,{markdownDescription:b.localize(271,null)})),find:Oe(new T),fixedOverflowWidgets:Oe(new o(42,"fixedOverflowWidgets",!1)),folding:Oe(new o(43,"folding",!0,{description:b.localize(272,null)})),foldingStrategy:Oe(new d(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(273,null),b.localize(274,null)],description:b.localize(275,null)})),foldingHighlight:Oe(new o(45,"foldingHighlight",!0,{description:b.localize(276,null)})),foldingImportsByDefault:Oe(new o(46,"foldingImportsByDefault",!1,{description:b.localize(277,null)})),foldingMaximumRegions:Oe(new i(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(278,null)})),unfoldOnClickAfterEndOfLine:Oe(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(279,null)})),fontFamily:Oe(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(280,null)})),fontInfo:Oe(new N),fontLigatures2:Oe(new z),fontSize:Oe(new B),fontWeight:Oe(new W),fontVariations:Oe(new j),formatOnPaste:Oe(new o(55,"formatOnPaste",!1,{description:b.localize(281,null)})),formatOnType:Oe(new o(56,"formatOnType",!1,{description:b.localize(282,null)})),glyphMargin:Oe(new o(57,"glyphMargin",!0,{description:b.localize(283,null)})),gotoLocation:Oe(new Z),hideCursorInOverviewRuler:Oe(new o(59,"hideCursorInOverviewRuler",!1,{description:b.localize(284,null)})),hover:Oe(new _),inDiffEditor:Oe(new o(61,"inDiffEditor",!1)),letterSpacing:Oe(new s(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,oe=>s.clamp(oe,-5,20),{description:b.localize(285,null)})),lightbulb:Oe(new me),lineDecorationsWidth:Oe(new U),lineHeight:Oe(new ie),lineNumbers:Oe(new le),lineNumbersMinChars:Oe(new i(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Oe(new o(70,"linkedEditing",!1,{description:b.localize(286,null)})),links:Oe(new o(71,"links",!0,{description:b.localize(287,null)})),matchBrackets:Oe(new d(72,"matchBrackets","always",["always","near","never"],{description:b.localize(288,null)})),minimap:Oe(new be),mouseStyle:Oe(new d(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Oe(new s(75,"mouseWheelScrollSensitivity",1,oe=>oe===0?1:oe,{markdownDescription:b.localize(289,null)})),mouseWheelZoom:Oe(new o(76,"mouseWheelZoom",!1,{markdownDescription:M.$j?b.localize(290,null):b.localize(291,null)})),multiCursorMergeOverlapping:Oe(new o(77,"multiCursorMergeOverlapping",!0,{description:b.localize(292,null)})),multiCursorModifier:Oe(new l(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Se,{markdownEnumDescriptions:[b.localize(293,null),b.localize(294,null)],markdownDescription:b.localize(295,null)})),multiCursorPaste:Oe(new d(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(296,null),b.localize(297,null)],markdownDescription:b.localize(298,null)})),multiCursorLimit:Oe(new i(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(299,null)})),occurrencesHighlight:Oe(new d(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[b.localize(300,null),b.localize(301,null),b.localize(302,null)],markdownDescription:b.localize(303,null)})),overviewRulerBorder:Oe(new o(82,"overviewRulerBorder",!0,{description:b.localize(304,null)})),overviewRulerLanes:Oe(new i(83,"overviewRulerLanes",3,0,3)),padding:Oe(new ae),pasteAs:Oe(new ot),parameterHints:Oe(new ce),peekWidgetDefaultFocus:Oe(new d(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(305,null),b.localize(306,null)],description:b.localize(307,null)})),definitionLinkOpensInPeek:Oe(new o(88,"definitionLinkOpensInPeek",!1,{description:b.localize(308,null)})),quickSuggestions:Oe(new K),quickSuggestionsDelay:Oe(new i(90,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(309,null)})),readOnly:Oe(new o(91,"readOnly",!1)),readOnlyMessage:Oe(new $e),renameOnType:Oe(new o(93,"renameOnType",!1,{description:b.localize(310,null),markdownDeprecationMessage:b.localize(311,null)})),renderControlCharacters:Oe(new o(94,"renderControlCharacters",!0,{description:b.localize(312,null),restricted:!0})),renderFinalNewline:Oe(new d(95,"renderFinalNewline",M.$k?"dimmed":"on",["off","on","dimmed"],{description:b.localize(313,null)})),renderLineHighlight:Oe(new d(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(314,null)],description:b.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Oe(new o(97,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(316,null)})),renderValidationDecorations:Oe(new d(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Oe(new d(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(317,null),b.localize(318,null),b.localize(319,null),""],description:b.localize(320,null)})),revealHorizontalRightPadding:Oe(new i(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Oe(new o(101,"roundedSelection",!0,{description:b.localize(321,null)})),rulers:Oe(new Ae),scrollbar:Oe(new Re),scrollBeyondLastColumn:Oe(new i(104,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(322,null)})),scrollBeyondLastLine:Oe(new o(105,"scrollBeyondLastLine",!0,{description:b.localize(323,null)})),scrollPredominantAxis:Oe(new o(106,"scrollPredominantAxis",!0,{description:b.localize(324,null)})),selectionClipboard:Oe(new o(107,"selectionClipboard",!0,{description:b.localize(325,null),included:M.$k})),selectionHighlight:Oe(new o(108,"selectionHighlight",!0,{description:b.localize(326,null)})),selectOnLineNumbers:Oe(new o(109,"selectOnLineNumbers",!0)),showFoldingControls:Oe(new d(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(327,null),b.localize(328,null),b.localize(329,null)],description:b.localize(330,null)})),showUnused:Oe(new o(111,"showUnused",!0,{description:b.localize(331,null)})),showDeprecated:Oe(new o(140,"showDeprecated",!0,{description:b.localize(332,null)})),inlayHints:Oe(new ee),snippetSuggestions:Oe(new d(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(333,null),b.localize(334,null),b.localize(335,null),b.localize(336,null)],description:b.localize(337,null)})),smartSelect:Oe(new Te),smoothScrolling:Oe(new o(114,"smoothScrolling",!1,{description:b.localize(338,null)})),stopRenderingLineAfter:Oe(new i(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Oe(new we),inlineSuggest:Oe(new q),inlineEdit:Oe(new V),inlineCompletionsAccessibilityVerbose:Oe(new o(149,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(339,null)})),suggestFontSize:Oe(new i(119,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Oe(new i(120,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Oe(new o(121,"suggestOnTriggerCharacters",!0,{description:b.localize(342,null)})),suggestSelection:Oe(new d(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(343,null),b.localize(344,null),b.localize(345,null)],description:b.localize(346,null)})),tabCompletion:Oe(new d(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(347,null),b.localize(348,null),b.localize(349,null)],description:b.localize(350,null)})),tabIndex:Oe(new i(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Oe(new Fe),unusualLineTerminators:Oe(new d(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(351,null),b.localize(352,null),b.localize(353,null)],description:b.localize(354,null)})),useShadowDOM:Oe(new o(127,"useShadowDOM",!0)),useTabStops:Oe(new o(128,"useTabStops",!0,{description:b.localize(355,null)})),wordBreak:Oe(new d(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(356,null),b.localize(357,null)],description:b.localize(358,null)})),wordSegmenterLocales:Oe(new He),wordSeparators:Oe(new t(131,"wordSeparators",R.$Ns,{description:b.localize(359,null)})),wordWrap:Oe(new d(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(360,null),b.localize(361,null),b.localize(362,null),b.localize(363,null)],description:b.localize(364,null)})),wordWrapBreakAfterCharacters:Oe(new t(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Oe(new t(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Oe(new i(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(365,null)})),wordWrapOverride1:Oe(new d(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Oe(new d(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Oe(new O),defaultColorDecorators:Oe(new o(147,"defaultColorDecorators",!1,{markdownDescription:b.localize(366,null)})),pixelRatio:Oe(new se),tabFocusMode:Oe(new o(144,"tabFocusMode",!1,{markdownDescription:b.localize(367,null)})),layoutInfo:Oe(new x),wrappingInfo:Oe(new rt),wrappingIndent:Oe(new it),wrappingStrategy:Oe(new re)}}),define(ke[201],Ee([9,10]),function(he,e){return he.create("vs/editor/common/languages",e)}),define(ke[83],Ee([1,0,78,2,174,29,184,201]),function(he,e,u,L,M,P,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$9t=e.$8t=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTag=e.$7t=e.$6t=e.SymbolKinds=e.SymbolTag=e.$4t=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$2t=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$1t=e.$Zt=e.$Yt=void 0,e.$3t=f,e.$5t=l;class ${constructor(Z,_,X){this.offset=Z,this.type=_,this.language=X,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Yt=$;class y{constructor(Z,_){this.tokens=Z,this.endState=_,this._tokenizationResultBrand=void 0}}e.$Zt=y;class A{constructor(Z,_){this.tokens=Z,this.endState=_,this._encodedTokenizationResultBrand=void 0}}e.$1t=A;var I;(function(W){W[W.Method=0]="Method",W[W.Function=1]="Function",W[W.Constructor=2]="Constructor",W[W.Field=3]="Field",W[W.Variable=4]="Variable",W[W.Class=5]="Class",W[W.Struct=6]="Struct",W[W.Interface=7]="Interface",W[W.Module=8]="Module",W[W.Property=9]="Property",W[W.Event=10]="Event",W[W.Operator=11]="Operator",W[W.Unit=12]="Unit",W[W.Value=13]="Value",W[W.Constant=14]="Constant",W[W.Enum=15]="Enum",W[W.EnumMember=16]="EnumMember",W[W.Keyword=17]="Keyword",W[W.Text=18]="Text",W[W.Color=19]="Color",W[W.File=20]="File",W[W.Reference=21]="Reference",W[W.Customcolor=22]="Customcolor",W[W.Folder=23]="Folder",W[W.TypeParameter=24]="TypeParameter",W[W.User=25]="User",W[W.Issue=26]="Issue",W[W.Snippet=27]="Snippet"})(I||(e.CompletionItemKind=I={}));var p;(function(W){const Z=new Map;Z.set(0,u.$Hj.symbolMethod),Z.set(1,u.$Hj.symbolFunction),Z.set(2,u.$Hj.symbolConstructor),Z.set(3,u.$Hj.symbolField),Z.set(4,u.$Hj.symbolVariable),Z.set(5,u.$Hj.symbolClass),Z.set(6,u.$Hj.symbolStruct),Z.set(7,u.$Hj.symbolInterface),Z.set(8,u.$Hj.symbolModule),Z.set(9,u.$Hj.symbolProperty),Z.set(10,u.$Hj.symbolEvent),Z.set(11,u.$Hj.symbolOperator),Z.set(12,u.$Hj.symbolUnit),Z.set(13,u.$Hj.symbolValue),Z.set(15,u.$Hj.symbolEnum),Z.set(14,u.$Hj.symbolConstant),Z.set(15,u.$Hj.symbolEnum),Z.set(16,u.$Hj.symbolEnumMember),Z.set(17,u.$Hj.symbolKeyword),Z.set(27,u.$Hj.symbolSnippet),Z.set(18,u.$Hj.symbolText),Z.set(19,u.$Hj.symbolColor),Z.set(20,u.$Hj.symbolFile),Z.set(21,u.$Hj.symbolReference),Z.set(22,u.$Hj.symbolCustomColor),Z.set(23,u.$Hj.symbolFolder),Z.set(24,u.$Hj.symbolTypeParameter),Z.set(25,u.$Hj.account),Z.set(26,u.$Hj.issues);function _(re){let Y=Z.get(re);return Y||(console.info("No codicon found for CompletionItemKind "+re),Y=u.$Hj.symbolProperty),Y}W.toIcon=_;const X=new Map;X.set("method",0),X.set("function",1),X.set("constructor",2),X.set("field",3),X.set("variable",4),X.set("class",5),X.set("struct",6),X.set("interface",7),X.set("module",8),X.set("property",9),X.set("event",10),X.set("operator",11),X.set("unit",12),X.set("value",13),X.set("constant",14),X.set("enum",15),X.set("enum-member",16),X.set("enumMember",16),X.set("keyword",17),X.set("snippet",27),X.set("text",18),X.set("color",19),X.set("file",20),X.set("reference",21),X.set("customcolor",22),X.set("folder",23),X.set("type-parameter",24),X.set("typeParameter",24),X.set("account",25),X.set("issue",26);function x(re,Y){let me=X.get(re);return typeof me>"u"&&!Y&&(me=9),me}W.fromString=x})(p||(e.CompletionItemKinds=p={}));var E;(function(W){W[W.Deprecated=1]="Deprecated"})(E||(e.CompletionItemTag=E={}));var v;(function(W){W[W.None=0]="None",W[W.KeepWhitespace=1]="KeepWhitespace",W[W.InsertAsSnippet=4]="InsertAsSnippet"})(v||(e.CompletionItemInsertTextRule=v={}));var a;(function(W){W[W.Word=0]="Word",W[W.Line=1]="Line",W[W.Suggest=2]="Suggest"})(a||(e.PartialAcceptTriggerKind=a={}));var m;(function(W){W[W.Invoke=0]="Invoke",W[W.TriggerCharacter=1]="TriggerCharacter",W[W.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m||(e.CompletionTriggerKind=m={}));var o;(function(W){W[W.Automatic=0]="Automatic",W[W.Explicit=1]="Explicit"})(o||(e.InlineCompletionTriggerKind=o={}));class n{constructor(Z,_,X,x){this.range=Z,this.text=_,this.completionKind=X,this.isSnippetText=x}equals(Z){return P.$ct.lift(this.range).equalsRange(Z.range)&&this.text===Z.text&&this.completionKind===Z.completionKind&&this.isSnippetText===Z.isSnippetText}}e.$2t=n;var i;(function(W){W[W.Invoke=1]="Invoke",W[W.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var r;(function(W){W[W.Automatic=0]="Automatic",W[W.PasteAs=1]="PasteAs"})(r||(e.DocumentPasteTriggerKind=r={}));var s;(function(W){W[W.Invoke=1]="Invoke",W[W.TriggerCharacter=2]="TriggerCharacter",W[W.ContentChange=3]="ContentChange"})(s||(e.SignatureHelpTriggerKind=s={}));var t;(function(W){W[W.Text=0]="Text",W[W.Read=1]="Read",W[W.Write=2]="Write"})(t||(e.DocumentHighlightKind=t={}));function f(W){return W&&L.URI.isUri(W.uri)&&P.$ct.isIRange(W.range)&&(P.$ct.isIRange(W.originSelectionRange)||P.$ct.isIRange(W.targetSelectionRange))}var d;(function(W){W[W.File=0]="File",W[W.Module=1]="Module",W[W.Namespace=2]="Namespace",W[W.Package=3]="Package",W[W.Class=4]="Class",W[W.Method=5]="Method",W[W.Property=6]="Property",W[W.Field=7]="Field",W[W.Constructor=8]="Constructor",W[W.Enum=9]="Enum",W[W.Interface=10]="Interface",W[W.Function=11]="Function",W[W.Variable=12]="Variable",W[W.Constant=13]="Constant",W[W.String=14]="String",W[W.Number=15]="Number",W[W.Boolean=16]="Boolean",W[W.Array=17]="Array",W[W.Object=18]="Object",W[W.Key=19]="Key",W[W.Null=20]="Null",W[W.EnumMember=21]="EnumMember",W[W.Struct=22]="Struct",W[W.Event=23]="Event",W[W.Operator=24]="Operator",W[W.TypeParameter=25]="TypeParameter"})(d||(e.SymbolKind=d={})),e.$4t={17:(0,b.localize)(0,null),16:(0,b.localize)(1,null),4:(0,b.localize)(2,null),13:(0,b.localize)(3,null),8:(0,b.localize)(4,null),9:(0,b.localize)(5,null),21:(0,b.localize)(6,null),23:(0,b.localize)(7,null),7:(0,b.localize)(8,null),0:(0,b.localize)(9,null),11:(0,b.localize)(10,null),10:(0,b.localize)(11,null),19:(0,b.localize)(12,null),5:(0,b.localize)(13,null),1:(0,b.localize)(14,null),2:(0,b.localize)(15,null),20:(0,b.localize)(16,null),15:(0,b.localize)(17,null),18:(0,b.localize)(18,null),24:(0,b.localize)(19,null),3:(0,b.localize)(20,null),6:(0,b.localize)(21,null),14:(0,b.localize)(22,null),22:(0,b.localize)(23,null),25:(0,b.localize)(24,null),12:(0,b.localize)(25,null)};function l(W,Z){return(0,b.localize)(26,null,W,e.$4t[Z])}var c;(function(W){W[W.Deprecated=1]="Deprecated"})(c||(e.SymbolTag=c={}));var h;(function(W){const Z=new Map;Z.set(0,u.$Hj.symbolFile),Z.set(1,u.$Hj.symbolModule),Z.set(2,u.$Hj.symbolNamespace),Z.set(3,u.$Hj.symbolPackage),Z.set(4,u.$Hj.symbolClass),Z.set(5,u.$Hj.symbolMethod),Z.set(6,u.$Hj.symbolProperty),Z.set(7,u.$Hj.symbolField),Z.set(8,u.$Hj.symbolConstructor),Z.set(9,u.$Hj.symbolEnum),Z.set(10,u.$Hj.symbolInterface),Z.set(11,u.$Hj.symbolFunction),Z.set(12,u.$Hj.symbolVariable),Z.set(13,u.$Hj.symbolConstant),Z.set(14,u.$Hj.symbolString),Z.set(15,u.$Hj.symbolNumber),Z.set(16,u.$Hj.symbolBoolean),Z.set(17,u.$Hj.symbolArray),Z.set(18,u.$Hj.symbolObject),Z.set(19,u.$Hj.symbolKey),Z.set(20,u.$Hj.symbolNull),Z.set(21,u.$Hj.symbolEnumMember),Z.set(22,u.$Hj.symbolStruct),Z.set(23,u.$Hj.symbolEvent),Z.set(24,u.$Hj.symbolOperator),Z.set(25,u.$Hj.symbolTypeParameter);function _(X){let x=Z.get(X);return x||(console.info("No codicon found for SymbolKind "+X),x=u.$Hj.symbolProperty),x}W.toIcon=_})(h||(e.SymbolKinds=h={}));class g{static asEditOperation(Z){return M.$dt.replace(P.$ct.lift(Z.range),Z.text)}}e.$6t=g;class S{static{this.Comment=new S("comment")}static{this.Imports=new S("imports")}static{this.Region=new S("region")}static fromValue(Z){switch(Z){case"comment":return S.Comment;case"imports":return S.Imports;case"region":return S.Region}return new S(Z)}constructor(Z){this.value=Z}}e.$7t=S;var w;(function(W){W[W.AIGenerated=1]="AIGenerated"})(w||(e.NewSymbolNameTag=w={}));var C;(function(W){function Z(_){return!_||typeof _!="object"?!1:typeof _.id=="string"&&typeof _.title=="string"}W.is=Z})(C||(e.Command=C={}));var k;(function(W){W[W.Collapsed=0]="Collapsed",W[W.Expanded=1]="Expanded"})(k||(e.CommentThreadCollapsibleState=k={}));var D;(function(W){W[W.Unresolved=0]="Unresolved",W[W.Resolved=1]="Resolved"})(D||(e.CommentThreadState=D={}));var O;(function(W){W[W.Current=0]="Current",W[W.Outdated=1]="Outdated"})(O||(e.CommentThreadApplicability=O={}));var F;(function(W){W[W.Editing=0]="Editing",W[W.Preview=1]="Preview"})(F||(e.CommentMode=F={}));var T;(function(W){W[W.Published=0]="Published",W[W.Draft=1]="Draft"})(T||(e.CommentState=T={}));var z;(function(W){W[W.Type=1]="Type",W[W.Parameter=2]="Parameter"})(z||(e.InlayHintKind=z={}));class j{constructor(Z){this.b=Z,this.a=null}dispose(){this.a&&this.a.then(Z=>{Z&&Z.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$8t=j,e.$9t=new R.$Nt;var N;(function(W){W[W.None=0]="None",W[W.Option=1]="Option",W[W.Default=2]="Default",W[W.Preferred=3]="Preferred"})(N||(e.ExternalUriOpenerPriority=N={}));var B;(function(W){W[W.Invoke=0]="Invoke",W[W.Automatic=1]="Automatic"})(B||(e.InlineEditTriggerKind=B={}))}),define(ke[202],Ee([9,10]),function(he,e){return he.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[203],Ee([9,10]),function(he,e){return he.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[204],Ee([9,10]),function(he,e){return he.create("vs/platform/contextkey/common/scanner",e)}),define(ke[205],Ee([9,10]),function(he,e){return he.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[206],Ee([9,10]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[207],Ee([9,10]),function(he,e){return he.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[208],Ee([9,10]),function(he,e){return he.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[209],Ee([9,10]),function(he,e){return he.create("vs/platform/files/common/files",e)}),define(ke[210],Ee([9,10]),function(he,e){return he.create("vs/platform/files/common/io",e)}),define(ke[211],Ee([9,10]),function(he,e){return he.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[212],Ee([9,10]),function(he,e){return he.create("vs/platform/log/common/log",e)}),define(ke[213],Ee([9,10]),function(he,e){return he.create("vs/platform/markers/common/markers",e)}),define(ke[214],Ee([9,10]),function(he,e){return he.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[215],Ee([9,10]),function(he,e){return he.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[216],Ee([9,10]),function(he,e){return he.create("vs/platform/workspace/common/workspace",e)}),define(ke[217],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(ke[218],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[219],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[220],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[221],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(ke[222],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[223],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[224],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[225],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[226],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[227],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[228],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[229],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[230],Ee([9,10]),function(he,e){return he.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[231],Ee([9,10]),function(he,e){return he.create("vs/workbench/common/configuration",e)}),define(ke[232],Ee([9,10]),function(he,e){return he.create("vs/workbench/common/editor",e)}),define(ke[233],Ee([9,10]),function(he,e){return he.create("vs/workbench/common/views",e)}),define(ke[234],Ee([9,10]),function(he,e){return he.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[235],Ee([9,10]),function(he,e){return he.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[236],Ee([9,10]),function(he,e){return he.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[237],Ee([9,10]),function(he,e){return he.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[238],Ee([9,10]),function(he,e){return he.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[239],Ee([9,10]),function(he,e){return he.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[240],Ee([9,10]),function(he,e){return he.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[241],Ee([9,10]),function(he,e){return he.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[242],Ee([9,10]),function(he,e){return he.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[243],Ee([9,10]),function(he,e){return he.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[244],Ee([1,0,13,204]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dj=e.TokenType=void 0;var M;(function(y){y[y.LParen=0]="LParen",y[y.RParen=1]="RParen",y[y.Neg=2]="Neg",y[y.Eq=3]="Eq",y[y.NotEq=4]="NotEq",y[y.Lt=5]="Lt",y[y.LtEq=6]="LtEq",y[y.Gt=7]="Gt",y[y.GtEq=8]="GtEq",y[y.RegexOp=9]="RegexOp",y[y.RegexStr=10]="RegexStr",y[y.True=11]="True",y[y.False=12]="False",y[y.In=13]="In",y[y.Not=14]="Not",y[y.And=15]="And",y[y.Or=16]="Or",y[y.Str=17]="Str",y[y.QuotedStr=18]="QuotedStr",y[y.Error=19]="Error",y[y.EOF=20]="EOF"})(M||(e.TokenType=M={}));function P(...y){switch(y.length){case 1:return(0,L.localize)(0,null,y[0]);case 2:return(0,L.localize)(1,null,y[0],y[1]);case 3:return(0,L.localize)(2,null,y[0],y[1],y[2]);default:return}}const R=(0,L.localize)(3,null),b=(0,L.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,u.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(P("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(P("&&"));break;case 124:this.h(124)?this.k(16):this.l(P("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const I=this.d,p=this.c.substring(this.d,this.e),E={type:19,offset:this.d,lexeme:p};this.g.push({offset:I,lexeme:p,additionalInfo:A}),this.f.push(E)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const I=this.c.substring(this.d,this.e),p=$.b.get(I);p?this.k(p):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,I=!1,p=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(b);return}const v=this.c.charCodeAt(A);if(I)I=!1;else if(v===47&&!p){A++;break}else v===91?p=!0:v===92?I=!0:v===93&&(p=!1);A++}for(;A<this.c.length&&$.a.has(this.c.charCodeAt(A));)A++;this.e=A;const E=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:E,offset:this.d})}r(){return this.e>=this.c.length}}e.$dj=$}),define(ke[245],Ee([1,0,23,40,207,397]),function(he,e,u,L,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=$,e.$tp=y,e.$up=A,e.$vp=I,e.$wp=p,e.$xp=E,e.$yp=v;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function $(o){return o=o.trim(),o==="*"||R.test(o)}function y(o){if(!$(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=o.match(R);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function A(o){if(!o)return null;const n=o.majorBase,i=o.majorMustEqual,r=o.minorBase;let s=o.minorMustEqual;const t=o.patchBase;let f=o.patchMustEqual;o.hasCaret&&(n===0||(s=!1),f=!1);let d=0;if(o.preRelease){const l=b.exec(o.preRelease);if(l){const[,c,h,g]=l;d=Date.UTC(Number(c),Number(h)-1,Number(g))}}return{majorBase:n,majorMustEqual:i,minorBase:r,minorMustEqual:s,patchBase:t,patchMustEqual:f,isMinimum:o.hasGreaterEquals,notBefore:d}}function I(o,n,i){let r;typeof o=="string"?r=A(y(o)):r=o;let s;n instanceof Date?s=n.getTime():typeof n=="string"&&(s=new Date(n).getTime());let t;if(typeof i=="string"?t=A(y(i)):t=i,!r||!t)return!1;const f=r.majorBase,d=r.minorBase,l=r.patchBase;let c=t.majorBase,h=t.minorBase,g=t.patchBase;const S=t.notBefore;let w=t.majorMustEqual,C=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?f>c?!0:f<c?!1:d>h?!0:d<h||s&&s<S?!1:l>=g:(f===1&&c===0&&(!w||!C||!k)&&(c=1,h=0,g=0,w=!0,C=!1,k=!1),f<c?!1:f>c?!w:d<h?!1:d>h?!C:l<g?!1:l>g?!k:!(s&&s<S))}function p(o,n,i,r,s){const t=[];if(typeof r.publisher<"u"&&typeof r.publisher!="string")return t.push([L.default.Error,M.localize(0,null)]),t;if(typeof r.name!="string")return t.push([L.default.Error,M.localize(1,null,"name")]),t;if(typeof r.version!="string")return t.push([L.default.Error,M.localize(2,null,"version")]),t;if(!r.engines)return t.push([L.default.Error,M.localize(3,null,"engines")]),t;if(typeof r.engines.vscode!="string")return t.push([L.default.Error,M.localize(4,null,"engines.vscode")]),t;if(typeof r.extensionDependencies<"u"&&!m(r.extensionDependencies))return t.push([L.default.Error,M.localize(5,null,"extensionDependencies")]),t;if(typeof r.activationEvents<"u"){if(!m(r.activationEvents))return t.push([L.default.Error,M.localize(6,null,"activationEvents")]),t;if(typeof r.main>"u"&&typeof r.browser>"u")return t.push([L.default.Error,M.localize(7,null,"activationEvents","main","browser")]),t}if(typeof r.extensionKind<"u"&&typeof r.main>"u"&&t.push([L.default.Warning,M.localize(8,null,"extensionKind")]),typeof r.main<"u"){if(typeof r.main!="string")return t.push([L.default.Error,M.localize(9,null,"main")]),t;{const l=(0,u.$Vg)(i,r.main);(0,u.$Pg)(l,i)||t.push([L.default.Warning,M.localize(10,null,l.path,i.path)])}}if(typeof r.browser<"u"){if(typeof r.browser!="string")return t.push([L.default.Error,M.localize(11,null,"browser")]),t;{const l=(0,u.$Vg)(i,r.browser);(0,u.$Pg)(l,i)||t.push([L.default.Warning,M.localize(12,null,l.path,i.path)])}}if(!P.valid(r.version))return t.push([L.default.Error,M.localize(13,null)]),t;const f=[];if(!E(o,n,r,s,f))for(const l of f)t.push([L.default.Error,l]);return t}function E(o,n,i,r,s){return r||typeof i.main>"u"&&typeof i.browser>"u"?!0:a(o,n,i.engines.vscode,s)}function v(o,n,i){return o==="*"||a(n,i,o)}function a(o,n,i,r=[]){const s=A(y(i));if(!s)return r.push(M.localize(14,null,i)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return r.push(M.localize(15,null,i)),!1}else if(!s.majorMustEqual)return r.push(M.localize(16,null,i)),!1;return I(o,n,s)?!0:(r.push(M.localize(17,null,o,i)),!1)}function m(o){if(!Array.isArray(o))return!1;for(let n=0,i=o.length;n<i;n++)if(typeof o[n]!="string")return!1;return!0}}),define(ke[106],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=void 0;class u{constructor(M,P=[],R=!1){this.ctor=M,this.staticArguments=P,this.supportsDelayedInstantiation=R}}e.$fi=u}),define(ke[84],Ee([1,0,106]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$gs=P,e.$hs=R;const L=[];var M;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(M||(e.InstantiationType=M={}));function P(b,$,y){$ instanceof u.$fi||($=new u.$fi($,[],!!y)),L.push([b,$])}function R(){return L}}),define(ke[246],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xq=e.$Wq=void 0;class u{constructor(P,R){this.key=P,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$Wq=u;class L{constructor(P){this.b=P,this.a=new Map}roots(){const P=[];for(const R of this.a.values())R.outgoing.size===0&&P.push(R);return P}insertEdge(P,R){const b=this.lookupOrInsertNode(P),$=this.lookupOrInsertNode(R);b.outgoing.set($.key,$),$.incoming.set(b.key,b)}removeNode(P){const R=this.b(P);this.a.delete(R);for(const b of this.a.values())b.outgoing.delete(R),b.incoming.delete(R)}lookupOrInsertNode(P){const R=this.b(P);let b=this.a.get(R);return b||(b=new u(R,P),this.a.set(R,b)),b}lookup(P){return this.a.get(this.b(P))}isEmpty(){return this.a.size===0}toString(){const P=[];for(const[R,b]of this.a)P.push(`${R}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return P.join(`
`)}findCycleSlow(){for(const[P,R]of this.a){const b=new Set([P]),$=this.c(R,b);if($)return $}}c(P,R){for(const[b,$]of P.outgoing){if(R.has(b))return[...R,b].join(" -> ");R.add(b);const y=this.c($,R);if(y)return y;R.delete(b)}}}e.$Xq=L}),define(ke[5],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e._util=void 0,e.$ii=M,e.$ji=P;var u;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function b($){return $[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=b})(u||(e._util=u={})),e.$hi=M("instantiationService");function L(R,b,$){b[u.DI_TARGET]===b?b[u.DI_DEPENDENCIES].push({id:R,index:$}):(b[u.DI_DEPENDENCIES]=[{id:R,index:$}],b[u.DI_TARGET]=b)}function M(R){if(u.serviceIds.has(R))return u.serviceIds.get(R);const b=function($,y,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(b,$,A)};return b.toString=()=>R,u.serviceIds.set(R,b),b}function P(R){return R}}),define(ke[53],Ee([1,0,18,2,5]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$Oi=void 0,e.$Pi=P,e.$Qi=R,e.$Ri=$,e.$Si=y,e.$Ti=A,e.$Ui=I,e.$Vi=p,e.$Wi=v,e.$Xi=a,e.$Yi=m,e.$Oi=(0,M.$ii)("configurationService");function P(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof L.URI)}function R(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof L.URI)}var b;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function $(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function y(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}function A(o,n){const i=Object.create(null);for(const r in o)I(i,r,o[r],n);return i}function I(o,n,i,r){const s=n.split("."),t=s.pop();let f=o;for(let d=0;d<s.length;d++){const l=s[d];let c=f[l];switch(typeof c){case"undefined":c=f[l]=Object.create(null);break;case"object":break;default:r(`Ignoring ${n} as ${s.slice(0,d+1).join(".")} is ${JSON.stringify(c)}`);return}f=c}if(typeof f=="object"&&f!==null)try{f[t]=i}catch{r(`Ignoring ${n} as ${s.join(".")} is ${JSON.stringify(f)}`)}else r(`Ignoring ${n} as ${s.join(".")} is ${JSON.stringify(f)}`)}function p(o,n){const i=n.split(".");E(o,i)}function E(o,n){const i=n.shift();if(n.length===0){delete o[i];return}if(Object.keys(o).indexOf(i)!==-1){const r=o[i];typeof r=="object"&&!Array.isArray(r)&&(E(r,n),Object.keys(r).length===0&&delete o[i])}}function v(o,n,i){function r(f,d){let l=f;for(const c of d){if(typeof l!="object"||l===null)return;l=l[c]}return l}const s=n.split("."),t=r(o,s);return typeof t>"u"?i:t}function a(o,n,i){Object.keys(n).forEach(r=>{r!=="__proto__"&&(r in o?u.$Xf(o[r])&&u.$Xf(n[r])?a(o[r],n[r],i):i&&(o[r]=n[r]):o[r]=n[r])})}function m(o){return o.replace(/[\[\]]/g,"")}}),define(ke[41],Ee([1,0,11,14,244,5,203,13]),function(he,e,u,L,M,P,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$gj=e.$fj=e.ContextKeyExprType=void 0,e.$ej=y,e.$hj=f,e.$ij=d,e.$Bj=Y;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",u.$j),$.set("isLinux",u.$k),$.set("isWindows",u.$i),$.set("isWeb",u.$o),$.set("isMacNative",u.$j&&!u.$o),$.set("isEdge",u.$H),$.set("isFirefox",u.$F),$.set("isChrome",u.$E),$.set("isSafari",u.$G);function y(ee,U){if($.get(ee)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(ee,U)}const A=Object.prototype.hasOwnProperty;var I;(function(ee){ee[ee.False=0]="False",ee[ee.True=1]="True",ee[ee.Defined=2]="Defined",ee[ee.Not=3]="Not",ee[ee.Equals=4]="Equals",ee[ee.NotEquals=5]="NotEquals",ee[ee.And=6]="And",ee[ee.Regex=7]="Regex",ee[ee.NotRegex=8]="NotRegex",ee[ee.Or=9]="Or",ee[ee.In=10]="In",ee[ee.NotIn=11]="NotIn",ee[ee.Greater=12]="Greater",ee[ee.GreaterEquals=13]="GreaterEquals",ee[ee.Smaller=14]="Smaller",ee[ee.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const p={regexParsingWithErrorRecovery:!0},E=(0,R.localize)(0,null),v=(0,R.localize)(1,null),a=(0,R.localize)(2,null),m=(0,R.localize)(3,null),o=(0,R.localize)(4,null),n=(0,R.localize)(5,null),i=(0,R.localize)(6,null),r=(0,R.localize)(7,null);class s{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=p){this.k=U,this.d=new M.$dj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:E,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const ie=this.l();if(!this.E()){const be=this.D(),Se=be.type===17?n:void 0;throw this.h.push({message:o,offset:be.offset,lexeme:M.$dj.getLexeme(be),additionalInfo:Se}),s.c}return ie}catch(ie){if(ie!==s.c)throw ie;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const ie=this.o();U.push(ie)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const ie=this.s();U.push(ie)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),c.INSTANCE;case 12:return this.z(),h.INSTANCE;case 0:{this.z();const ie=this.l();return this.A(1,m),ie?.negate()}case 17:return this.z(),D.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ie=this.l();return this.A(1,m),ie}case 17:{const ie=U.lexeme;if(this.z(),this.y(9)){const Se=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Se.type!==10)throw this.B("REGEX",Se);const ae=Se.lexeme,ce=ae.lastIndexOf("/"),se=ce===ae.length-1?void 0:this.w(ae.substring(ce+1));let K;try{K=new RegExp(ae.substring(1,ce),se)}catch{throw this.B("REGEX",Se)}return N.create(ie,K)}switch(Se.type){case 10:case 19:{const ae=[Se.lexeme];this.z();let ce=this.D(),se=0;for(let Ae=0;Ae<Se.lexeme.length;Ae++)Se.lexeme.charCodeAt(Ae)===40?se++:Se.lexeme.charCodeAt(Ae)===41&&se--;for(;!this.E()&&ce.type!==15&&ce.type!==16;){switch(ce.type){case 0:se++;break;case 1:se--;break;case 10:case 18:for(let Ae=0;Ae<ce.lexeme.length;Ae++)ce.lexeme.charCodeAt(Ae)===40?se++:Se.lexeme.charCodeAt(Ae)===41&&se--}if(se<0)break;ae.push(M.$dj.getLexeme(ce)),this.z(),ce=this.D()}const K=ae.join(""),te=K.lastIndexOf("/"),le=te===K.length-1?void 0:this.w(K.substring(te+1));let de;try{de=new RegExp(K.substring(1,te),le)}catch{throw this.B("REGEX",Se)}return t.regex(ie,de)}case 18:{const ae=Se.lexeme;this.z();let ce=null;if(!(0,L.$Ue)(ae)){const se=ae.indexOf("/"),K=ae.lastIndexOf("/");if(se!==K&&se>=0){const te=ae.slice(se+1,K),le=ae[K+1]==="i"?"i":"";try{ce=new RegExp(te,le)}catch{throw this.B("REGEX",Se)}}}if(ce===null)throw this.B("REGEX",Se);return N.create(ie,ce)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,a);const Se=this.u();return t.notIn(ie,Se)}switch(this.D().type){case 3:{this.z();const Se=this.u();if(this.x().type===18)return t.equals(ie,Se);switch(Se){case"true":return t.has(ie);case"false":return t.not(ie);default:return t.equals(ie,Se)}}case 4:{this.z();const Se=this.u();if(this.x().type===18)return t.notEquals(ie,Se);switch(Se){case"true":return t.not(ie);case"false":return t.has(ie);default:return t.notEquals(ie,Se)}}case 5:return this.z(),z.create(ie,this.u());case 6:return this.z(),j.create(ie,this.u());case 7:return this.z(),F.create(ie,this.u());case 8:return this.z(),T.create(ie,this.u());case 13:return this.z(),t.in(ie,this.u());default:return t.has(ie)}}case 20:throw this.h.push({message:i,offset:U.offset,lexeme:"",additionalInfo:r}),s.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,ie){if(this.C(U))return this.z();throw this.B(ie,this.D())}B(U,ie,be){const Se=(0,R.localize)(8,null,U,M.$dj.getLexeme(ie)),ae=ie.offset,ce=M.$dj.getLexeme(ie);return this.h.push({message:Se,offset:ae,lexeme:ce,additionalInfo:be}),s.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$fj=s;class t{static false(){return c.INSTANCE}static true(){return h.INSTANCE}static has(U){return g.create(U)}static equals(U,ie){return S.create(U,ie)}static notEquals(U,ie){return k.create(U,ie)}static regex(U,ie){return N.create(U,ie)}static in(U,ie){return w.create(U,ie)}static notIn(U,ie){return C.create(U,ie)}static not(U){return D.create(U)}static and(...U){return Z.create(U,null,!0)}static or(...U){return _.create(U,null,!0)}static greater(U,ie){return F.create(U,ie)}static greaterEquals(U,ie){return T.create(U,ie)}static smaller(U,ie){return z.create(U,ie)}static smallerEquals(U,ie){return j.create(U,ie)}static{this.c=new s({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$gj=t;function f(ee){const U=new s({regexParsingWithErrorRecovery:!1});return ee.map(ie=>(U.parse(ie),U.lexingErrors.length>0?U.lexingErrors.map(be=>({errorMessage:be.additionalInfo?(0,R.localize)(9,null,be.additionalInfo):(0,R.localize)(10,null),offset:be.offset,length:be.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(be=>({errorMessage:be.additionalInfo?`${be.message}. ${be.additionalInfo}`:be.message,offset:be.offset,length:be.lexeme.length})):[]))}function d(ee,U){const ie=ee?ee.substituteConstants():void 0,be=U?U.substituteConstants():void 0;return!ie&&!be?!0:!ie||!be?!1:ie.equals(be)}function l(ee,U){return ee.cmp(U)}class c{static{this.INSTANCE=new c}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return h.INSTANCE}}e.$jj=c;class h{static{this.INSTANCE=new h}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return c.INSTANCE}}e.$kj=h;class g{static create(U,ie=null){const be=$.get(U);return typeof be=="boolean"?be?h.INSTANCE:c.INSTANCE:new g(U,ie)}constructor(U,ie){this.key=U,this.c=ie,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:x(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=$.get(this.key);return typeof U=="boolean"?U?h.INSTANCE:c.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=D.create(this.key,this)),this.c}}e.$lj=g;class S{static create(U,ie,be=null){if(typeof ie=="boolean")return ie?g.create(U,be):D.create(U,be);const Se=$.get(U);return typeof Se=="boolean"?ie===(Se?"true":"false")?h.INSTANCE:c.INSTANCE:new S(U,ie,be)}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:re(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=$.get(this.c);if(typeof U=="boolean"){const ie=U?"true":"false";return this.d===ie?h.INSTANCE:c.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$mj=S;class w{static create(U,ie){return new w(U,ie)}constructor(U,ie){this.d=U,this.f=ie,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:re(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const ie=U.getValue(this.f),be=U.getValue(this.d);return Array.isArray(ie)?ie.includes(be):typeof be=="string"&&typeof ie=="object"&&ie!==null?A.call(ie,be):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=C.create(this.d,this.f)),this.c}}e.$nj=w;class C{static create(U,ie){return new C(U,ie)}constructor(U,ie){this.d=U,this.f=ie,this.type=11,this.c=w.create(U,ie)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$oj=C;class k{static create(U,ie,be=null){if(typeof ie=="boolean")return ie?D.create(U,be):g.create(U,be);const Se=$.get(U);return typeof Se=="boolean"?ie===(Se?"true":"false")?c.INSTANCE:h.INSTANCE:new k(U,ie,be)}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:re(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=$.get(this.c);if(typeof U=="boolean"){const ie=U?"true":"false";return this.d===ie?c.INSTANCE:h.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$pj=k;class D{static create(U,ie=null){const be=$.get(U);return typeof be=="boolean"?be?c.INSTANCE:h.INSTANCE:new D(U,ie)}constructor(U,ie){this.c=U,this.d=ie,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:x(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=$.get(this.c);return typeof U=="boolean"?U?c.INSTANCE:h.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=g.create(this.c,this)),this.d}}e.$qj=D;function O(ee,U){if(typeof ee=="string"){const ie=parseFloat(ee);isNaN(ie)||(ee=ie)}return typeof ee=="string"||typeof ee=="number"?U(ee):c.INSTANCE}class F{static create(U,ie,be=null){return O(ie,Se=>new F(U,Se,be))}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:re(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$rj=F;class T{static create(U,ie,be=null){return O(ie,Se=>new T(U,Se,be))}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:re(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$sj=T;class z{static create(U,ie,be=null){return O(ie,Se=>new z(U,Se,be))}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:re(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$tj=z;class j{static create(U,ie,be=null){return O(ie,Se=>new j(U,Se,be))}constructor(U,ie,be){this.c=U,this.d=ie,this.f=be,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:re(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$uj=j;class N{static create(U,ie){return new N(U,ie)}constructor(U,ie){this.d=U,this.f=ie,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const ie=this.f?this.f.source:"",be=U.f?U.f.source:"";return ie<be?-1:ie>be?1:0}equals(U){if(U.type===this.type){const ie=this.f?this.f.source:"",be=U.f?U.f.source:"";return this.d===U.d&&ie===be}return!1}substituteConstants(){return this}evaluate(U){const ie=U.getValue(this.d);return this.f?this.f.test(ie):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=B.create(this)),this.c}}e.$vj=N;class B{static create(U){return new B(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new B(this.c.map(U))}negate(){return this.c}}e.$wj=B;function W(ee){let U=null;for(let ie=0,be=ee.length;ie<be;ie++){const Se=ee[ie].substituteConstants();if(ee[ie]!==Se&&U===null){U=[];for(let ae=0;ae<ie;ae++)U[ae]=ee[ae]}U!==null&&(U[ie]=Se)}return U===null?ee:U}class Z{static create(U,ie,be){return Z.d(U,ie,be)}constructor(U,ie){this.expr=U,this.c=ie,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ie=0,be=this.expr.length;ie<be;ie++){const Se=l(this.expr[ie],U.expr[ie]);if(Se!==0)return Se}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ie=0,be=this.expr.length;ie<be;ie++)if(!this.expr[ie].equals(U.expr[ie]))return!1;return!0}return!1}substituteConstants(){const U=W(this.expr);return U===this.expr?this:Z.create(U,this.c,!1)}evaluate(U){for(let ie=0,be=this.expr.length;ie<be;ie++)if(!this.expr[ie].evaluate(U))return!1;return!0}static d(U,ie,be){const Se=[];let ae=!1;for(const ce of U)if(ce){if(ce.type===1){ae=!0;continue}if(ce.type===0)return c.INSTANCE;if(ce.type===6){Se.push(...ce.expr);continue}Se.push(ce)}if(Se.length===0&&ae)return h.INSTANCE;if(Se.length!==0){if(Se.length===1)return Se[0];Se.sort(l);for(let ce=1;ce<Se.length;ce++)Se[ce-1].equals(Se[ce])&&(Se.splice(ce,1),ce--);if(Se.length===1)return Se[0];for(;Se.length>1;){const ce=Se[Se.length-1];if(ce.type!==9)break;Se.pop();const se=Se.pop(),K=Se.length===0,te=_.create(ce.expr.map(le=>Z.create([le,se],null,be)),null,K);te&&(Se.push(te),Se.sort(l))}if(Se.length===1)return Se[0];if(be){for(let ce=0;ce<Se.length;ce++)for(let se=ce+1;se<Se.length;se++)if(Se[ce].negate().equals(Se[se]))return c.INSTANCE;if(Se.length===1)return Se[0]}return new Z(Se,ie)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const ie of this.expr)U.push(...ie.keys());return U}map(U){return new Z(this.expr.map(ie=>ie.map(U)),null)}negate(){if(!this.c){const U=[];for(const ie of this.expr)U.push(ie.negate());this.c=_.create(U,this,!0)}return this.c}}e.$xj=Z;class _{static create(U,ie,be){return _.d(U,ie,be)}constructor(U,ie){this.expr=U,this.c=ie,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ie=0,be=this.expr.length;ie<be;ie++){const Se=l(this.expr[ie],U.expr[ie]);if(Se!==0)return Se}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ie=0,be=this.expr.length;ie<be;ie++)if(!this.expr[ie].equals(U.expr[ie]))return!1;return!0}return!1}substituteConstants(){const U=W(this.expr);return U===this.expr?this:_.create(U,this.c,!1)}evaluate(U){for(let ie=0,be=this.expr.length;ie<be;ie++)if(this.expr[ie].evaluate(U))return!0;return!1}static d(U,ie,be){let Se=[],ae=!1;if(U){for(let ce=0,se=U.length;ce<se;ce++){const K=U[ce];if(K){if(K.type===0){ae=!0;continue}if(K.type===1)return h.INSTANCE;if(K.type===9){Se=Se.concat(K.expr);continue}Se.push(K)}}if(Se.length===0&&ae)return c.INSTANCE;Se.sort(l)}if(Se.length!==0){if(Se.length===1)return Se[0];for(let ce=1;ce<Se.length;ce++)Se[ce-1].equals(Se[ce])&&(Se.splice(ce,1),ce--);if(Se.length===1)return Se[0];if(be){for(let ce=0;ce<Se.length;ce++)for(let se=ce+1;se<Se.length;se++)if(Se[ce].negate().equals(Se[se]))return h.INSTANCE;if(Se.length===1)return Se[0]}return new _(Se,ie)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const ie of this.expr)U.push(...ie.keys());return U}map(U){return new _(this.expr.map(ie=>ie.map(U)),null)}negate(){if(!this.c){const U=[];for(const ie of this.expr)U.push(ie.negate());for(;U.length>1;){const ie=U.shift(),be=U.shift(),Se=[];for(const ae of Ce(ie))for(const ce of Ce(be))Se.push(Z.create([ae,ce],null,!1));U.unshift(_.create(Se,null,!1))}this.c=_.create(U,this,!0)}return this.c}}e.$yj=_;class X extends g{static{this.d=[]}static all(){return X.d.values()}constructor(U,ie,be){super(U,null),this.f=ie,typeof be=="object"?X.d.push({...be,key:U}):be!==!0&&X.d.push({key:U,description:be,type:ie!=null?typeof ie:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return S.create(this.key,U)}notEqualsTo(U){return k.create(this.key,U)}}e.$zj=X,e.$Aj=(0,P.$ii)("contextKeyService");function x(ee,U){return ee<U?-1:ee>U?1:0}function re(ee,U,ie,be){return ee<ie?-1:ee>ie?1:U<be?-1:U>be?1:0}function Y(ee,U){if(ee.type===0||U.type===1)return!0;if(ee.type===9)return U.type===9?me(ee.expr,U.expr):!1;if(U.type===9){for(const ie of U.expr)if(Y(ee,ie))return!0;return!1}if(ee.type===6){if(U.type===6)return me(U.expr,ee.expr);for(const ie of ee.expr)if(Y(ie,U))return!0;return!1}return ee.equals(U)}function me(ee,U){let ie=0,be=0;for(;ie<ee.length&&be<U.length;){const Se=ee[ie].cmp(U[be]);if(Se<0)return!1;Se===0&&ie++,be++}return ie===ee.length}function Ce(ee){return ee.type===9?ee.expr:[ee]}}),define(ke[247],Ee([1,0,23,40,205,5,103,11,24]),function(he,e,u,L,M,P,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$sw=e.$rw=e.$qw=void 0,e.$tw=E,e.$uw=v,e.$qw=(0,P.$ii)("dialogService");var y;(function(a){a[a.Confirmation=1]="Confirmation",a[a.Prompt=2]="Prompt",a[a.Input=3]="Input"})(y||(y={}));class A{a(m){return this.d(m,y.Confirmation)}b(m){return this.d(m,y.Prompt)}c(m){return this.d(m,y.Input)}d(m,o){const n=[];switch(o){case y.Confirmation:{const i=m;i.primaryButton?n.push(i.primaryButton):n.push((0,M.localize)(0,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,M.localize)(1,null));break}case y.Prompt:{const i=m;Array.isArray(i.buttons)&&i.buttons.length>0&&n.push(...i.buttons.map(r=>r.label)),i.cancelButton&&(i.cancelButton===!0?n.push((0,M.localize)(2,null)):typeof i.cancelButton=="string"?n.push(i.cancelButton):i.cancelButton.label?n.push(i.cancelButton.label):n.push((0,M.localize)(3,null))),n.length===0&&n.push((0,M.localize)(4,null));break}case y.Input:{const i=m;i.primaryButton?n.push(i.primaryButton):n.push((0,M.localize)(5,null)),i.cancelButton?n.push(i.cancelButton):n.push((0,M.localize)(6,null));break}}return n}e(m){if(typeof m=="string")return m;if(typeof m=="number")return m===L.default.Info?"info":m===L.default.Error?"error":m===L.default.Warning?"warning":"none"}f(m,o,n){const i=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&i.push(m.cancelButton);let r=i[o]?.run({checkboxChecked:n});return r instanceof Promise||(r=Promise.resolve(r)),{result:r,checkboxChecked:n}}}e.$rw=A,e.$sw=(0,P.$ii)("fileDialogService");var I;(function(a){a[a.SAVE=0]="SAVE",a[a.DONT_SAVE=1]="DONT_SAVE",a[a.CANCEL=2]="CANCEL"})(I||(e.ConfirmResult=I={}));const p=10;function E(a){const m=[];return m.push(...a.slice(0,p).map(o=>typeof o=="string"?o:(0,u.$Sg)(o))),a.length>p&&(a.length-p===1?m.push((0,M.localize)(7,null)):m.push((0,M.localize)(8,null,a.length-p))),m.push(""),m.join(`
`)}function v(a,m){const o=(0,$.$On)(a);let n=(o.buttons??[]).map(t=>(0,R.$nw)(t)),i=(a.buttons||[]).map((t,f)=>f),r=0,s=o.cancelId??n.length-1;if(n.length>1){const t=typeof s=="number"?n[s]:void 0;if(b.$k||b.$j){if(typeof t=="string"&&n.length>1&&s!==1){n.splice(s,1),n.splice(1,0,t);const f=i[s];i.splice(s,1),i.splice(1,0,f),s=1}b.$k&&n.length>1&&(n=n.reverse(),i=i.reverse(),r=n.length-1,typeof t=="string"&&(s=r-1))}else if(b.$i&&typeof t=="string"&&n.length>1&&s!==n.length-1){n.splice(s,1),n.push(t);const f=i[s];i.splice(s,1),i.push(f),s=n.length-1}}return o.buttons=n,o.defaultId=r,o.cancelId=s,o.noLink=!0,o.title=o.title||m.nameLong,{options:o,buttonIndeces:i}}}),define(ke[136],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$pi=void 0,e.$pi=(0,u.$ii)("environmentService"),e.$qi=(0,u.$ji)(e.$pi)}),define(ke[137],Ee([1,0,206,5]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.ExtensionGalleryErrorCode=e.$So=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Ro=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=void 0,e.$Lo=M,e.$Mo=P,e.$No=R,e.$Oo=b,e.$Po=$,e.$Qo=y,e.$Fo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Go=new RegExp(e.$Fo),e.$Ho="__web_extension",e.$Io="skipWalkthrough",e.$Jo="extensionsSync",e.$Ko="dependecyOrPackExtensionInstall";function M(i){switch(i){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function P(i){switch(i){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function R(i,r){switch(i){case 3:return r==="x64"?"win32-x64":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function b(i,r){return r==="web"&&!i.includes("web")}function $(i,r,s){return b(r,s)?!1:i==="undefined"||i==="universal"?!0:i==="unknown"?!1:i===s}function y(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var A;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var I;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(I||(e.SortOrder=I={}));var p;(function(i){i.Install="install",i.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var E;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(E||(e.InstallOperation=E={})),e.$Ro=(0,L.$ii)("extensionGalleryService");var v;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.Delete="Delete",i.Rename="Rename",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Unknown="Unknown",i.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var a;(function(i){i.UnknownError="UnknownError",i.PackageIsInvalidZip="PackageIsInvalidZip",i.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(a||(e.ExtensionSignaturetErrorCode=a={}));class m extends Error{constructor(r,s){super(r),this.code=s,this.name=s}}e.$So=m;var o;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed"})(o||(e.ExtensionGalleryErrorCode=o={}));class n extends Error{constructor(r,s){super(r),this.code=s,this.name=s}}e.$To=n,e.$Uo=(0,L.$ii)("extensionManagementService"),e.$Vo="extensionsIdentifiers/disabled",e.$Wo="extensionsIdentifiers/enabled",e.$Xo=(0,L.$ii)("IGlobalExtensionEnablementService"),e.$Yo=(0,L.$ii)("IExtensionTipsService"),e.$Zo=(0,u.localize2)(0,"Extensions"),e.$1o=(0,u.localize2)(1,"Preferences")}),define(ke[248],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E5b=e.$D5b=void 0,e.$D5b=(0,u.$ii)("externalTerminal"),e.$E5b="Terminal.app"}),define(ke[249],Ee([1,0,52,54,15,17,11,102,31,105,208,248]),function(he,e,u,L,M,P,R,b,$,y,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fac=e.$Eac=e.$Dac=void 0;const p=A.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:v.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class v extends E{static{this.b="cmd.exe"}openTerminal(s,t){return this.spawnTerminal(u,s,y.$am(),t)}spawnTerminal(s,t,f,d){const l=t.windowsExec||v.getDefaultTerminalWindows();d&&d[1]===":"&&(d=d[0].toUpperCase()+d.substr(1));const c=P.$oc(l,".exe").toLowerCase();if(c==="cmder")return s.spawn(l,d?[d]:void 0),Promise.resolve(void 0);const h=["/c","start","/wait"];return l.indexOf(" ")>=0&&h.push('""'),h.push(l),c==="wt"&&h.push("-d ."),new Promise((g,S)=>{const w=o(process),C=s.spawn(f,h,{cwd:d,env:w,detached:!0});C.on("error",S),C.on("exit",()=>g())})}async runInTerminal(s,t,f,d,l){const c="windowsExec"in l&&l.windowsExec?l.windowsExec:v.getDefaultTerminalWindows(),h=await v.f();return new Promise((g,S)=>{const w=`"${t} - ${p}"`,C=`"${f.join('" "')}" & pause`,k=Object.assign({},o(process),d);Object.keys(k).filter(z=>k[z]===null).forEach(z=>delete k[z]);const D={cwd:t,env:k,windowsVerbatimArguments:!0};let O,F;P.$oc(c,".exe")==="wt"?(O=c,F=["-d",".",v.b,"/c",C]):h?(O=h,F=["-d",".",c,"/c",C]):(O=v.b,F=["/c","start",w,"/wait",c,"/c",`"${C}"`]),u.spawn(O,F,D).on("error",z=>{S(n(z))}),g(void 0)})}static getDefaultTerminalWindows(){if(!v.d){const s=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");v.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${s?"Sysnative":"System32"}\\cmd.exe`}return v.d}static async f(){try{const s=await y.win32.findExecutable("wt");return await $.Promises.exists(s)?s:void 0}catch{return}}}e.$Dac=v,Je([L.$Mh],v,"f",null);class a extends E{static{this.b="/usr/bin/osascript"}openTerminal(s,t){return this.spawnTerminal(u,s,t)}runInTerminal(s,t,f,d,l){const c=l.osxExec||I.$E5b;return new Promise((h,g)=>{if(c===I.$E5b||c==="iTerm.app"){const S=c===I.$E5b?"TerminalHelper":"iTermHelper",C=[M.$Cg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${S}.scpt`).fsPath,"-t",s||p,"-w",t];for(const O of f)C.push("-a"),C.push(O);if(d){const O=Object.assign({},o(process),d);for(const F in O){const T=O[F];T===null?(C.push("-u"),C.push(F)):(C.push("-e"),C.push(`${F}=${T}`))}}let k="";const D=u.spawn(a.b,C);D.on("error",O=>{g(n(O))}),D.stderr.on("data",O=>{k+=O.toString()}),D.on("exit",O=>{if(O===0)h(void 0);else if(k){const F=k.split(`
`,1);g(new Error(F[0]))}else g(new Error(A.localize(1,null,S,O)))})}else g(new Error(A.localize(2,null,c)))})}spawnTerminal(s,t,f){const d=t.osxExec||I.$E5b;return new Promise((l,c)=>{const h=["-a",d];f&&h.push(f);const g=o(process),S=s.spawn("/usr/bin/open",h,{cwd:f,env:g});S.on("error",c),S.on("exit",()=>l())})}}e.$Eac=a;class m extends E{static{this.b=A.localize(3,null)}openTerminal(s,t){return this.spawnTerminal(u,s,t)}runInTerminal(s,t,f,d,l){const c=l.linuxExec?Promise.resolve(l.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((h,g)=>{const S=[];c.then(w=>{w.indexOf("gnome-terminal")>=0?S.push("-x"):S.push("-e"),S.push("bash"),S.push("-c");const C=`${i(f)}; echo; read -p "${m.b}" -n1;`;S.push(`''${C}''`);const k=Object.assign({},o(process),d);Object.keys(k).filter(T=>k[T]===null).forEach(T=>delete k[T]);const D={cwd:t,env:k};let O="";const F=u.spawn(w,S,D);F.on("error",T=>{g(n(T))}),F.stderr.on("data",T=>{O+=T.toString()}),F.on("exit",T=>{if(T===0)h(void 0);else if(O){const z=O.split(`
`,1);g(new Error(z[0]))}else g(new Error(A.localize(4,null,w,T)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!R.$k)m.d=Promise.resolve("xterm");else{const s=await $.Promises.exists("/etc/debian_version");m.d=new Promise(t=>{s?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return m.d}spawnTerminal(s,t,f){const d=t.linuxExec?Promise.resolve(t.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((l,c)=>{d.then(h=>{const g=o(process),S=s.spawn(h,[],{cwd:f,env:g});S.on("error",c),S.on("exit",()=>l())})})}}e.$Fac=m;function o(r){const s={...r.env};return(0,b.$$l)(s),s}function n(r){return"errno"in r&&r.errno==="ENOENT"&&"path"in r&&typeof r.path=="string"?new Error(A.localize(5,null,r.path)):r}function i(r){let s="";for(const t of r)t.indexOf(" ")>=0?s+='"'+t+'"':s+=t,s+=" ";return s}}),define(ke[32],Ee([1,0,77,17,14,18,2,209,5,11,15,45]),function(he,e,u,L,M,P,R,b,$,y,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=e.$hl=e.FileKind=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.FileOperationResult=e.$_k=e.$$k=e.$0k=e.$8k=e.FileChangeType=e.$7k=e.FileOperation=e.$1k=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Ok=void 0,e.$Pk=p,e.$Qk=a,e.$Rk=o,e.$Sk=n,e.$Tk=i,e.$Uk=r,e.$Vk=s,e.$Wk=t,e.$Xk=f,e.$Yk=d,e.$Zk=l,e.$2k=g,e.$3k=S,e.$4k=w,e.$5k=C,e.$6k=k,e.$9k=z,e.$il=_,e.$jl=X,e.$ll=re,e.$Ok=(0,$.$ii)("fileService");function p(Y){return Y.create===!0}var E;(function(Y){Y[Y.Unknown=0]="Unknown",Y[Y.File=1]="File",Y[Y.Directory=2]="Directory",Y[Y.SymbolicLink=64]="SymbolicLink"})(E||(e.FileType=E={}));var v;(function(Y){Y[Y.Readonly=1]="Readonly",Y[Y.Locked=2]="Locked"})(v||(e.FilePermission=v={}));function a(Y){const me=Y;return!!me&&typeof me.onDidChange=="function"}var m;(function(Y){Y[Y.None=0]="None",Y[Y.FileReadWrite=2]="FileReadWrite",Y[Y.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Y[Y.FileReadStream=16]="FileReadStream",Y[Y.FileFolderCopy=8]="FileFolderCopy",Y[Y.PathCaseSensitive=1024]="PathCaseSensitive",Y[Y.Readonly=2048]="Readonly",Y[Y.Trash=4096]="Trash",Y[Y.FileWriteUnlock=8192]="FileWriteUnlock",Y[Y.FileAtomicRead=16384]="FileAtomicRead",Y[Y.FileAtomicWrite=32768]="FileAtomicWrite",Y[Y.FileAtomicDelete=65536]="FileAtomicDelete",Y[Y.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function o(Y){return!!(Y.capabilities&2)}function n(Y){return!!(Y.capabilities&8)}function i(Y){return!!(Y.capabilities&131072)}function r(Y){return!!(Y.capabilities&4)}function s(Y){return!!(Y.capabilities&16)}function t(Y){return o(Y)?!!(Y.capabilities&16384):!1}function f(Y){return o(Y)?!!(Y.capabilities&32768):!1}function d(Y){return!!(Y.capabilities&65536)}function l(Y){return!!(Y.capabilities&2048)}var c;(function(Y){Y.FileExists="EntryExists",Y.FileNotFound="EntryNotFound",Y.FileNotADirectory="EntryNotADirectory",Y.FileIsADirectory="EntryIsADirectory",Y.FileExceedsStorageQuota="EntryExceedsStorageQuota",Y.FileTooLarge="EntryTooLarge",Y.FileWriteLocked="EntryWriteLocked",Y.NoPermissions="NoPermissions",Y.Unavailable="Unavailable",Y.Unknown="Unknown"})(c||(e.FileSystemProviderErrorCode=c={}));class h extends Error{static create(me,Ce){const ee=new h(me.toString(),Ce);return w(ee,Ce),ee}constructor(me,Ce){super(me),this.code=Ce}}e.$1k=h;function g(Y,me){return h.create(Y,me)}function S(Y){return Y||g((0,b.localize)(0,null),c.Unknown)}function w(Y,me){return Y.name=me?`${me} (FileSystemError)`:"FileSystemError",Y}function C(Y){if(!Y)return c.Unknown;if(Y instanceof h)return Y.code;const me=/^(.+) \(FileSystemError\)$/.exec(Y.name);if(!me)return c.Unknown;switch(me[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileTooLarge:return c.FileTooLarge;case c.FileWriteLocked:return c.FileWriteLocked;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}function k(Y){if(Y instanceof j)return Y.fileOperationResult;switch(C(Y)){case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 9;case c.FileWriteLocked:return 5;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileTooLarge:return 7;default:return 10}}var D;(function(Y){Y[Y.CREATE=0]="CREATE",Y[Y.DELETE=1]="DELETE",Y[Y.MOVE=2]="MOVE",Y[Y.COPY=3]="COPY",Y[Y.WRITE=4]="WRITE"})(D||(e.FileOperation=D={}));class O{constructor(me,Ce,ee){this.resource=me,this.operation=Ce,this.target=ee}isOperation(me){return this.operation===me}}e.$7k=O;var F;(function(Y){Y[Y.UPDATED=0]="UPDATED",Y[Y.ADDED=1]="ADDED",Y[Y.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class T{static{this.a=null}constructor(me,Ce){this.c=Ce,this.b=void 0,this.d=new I.$V(()=>{const ee=u.$oi.forUris(()=>this.c);return ee.fill(this.rawAdded.map(U=>[U,!0])),ee}),this.f=new I.$V(()=>{const ee=u.$oi.forUris(()=>this.c);return ee.fill(this.rawUpdated.map(U=>[U,!0])),ee}),this.g=new I.$V(()=>{const ee=u.$oi.forUris(()=>this.c);return ee.fill(this.rawDeleted.map(U=>[U,!0])),ee}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const ee of me){switch(ee.type){case 1:this.rawAdded.push(ee.resource);break;case 0:this.rawUpdated.push(ee.resource);break;case 2:this.rawDeleted.push(ee.resource);break}this.b!==T.a&&(typeof ee.cId=="number"?this.b===void 0?this.b=ee.cId:this.b!==ee.cId&&(this.b=T.a):this.b!==void 0&&(this.b=T.a))}}contains(me,...Ce){return this.h(me,{includeChildren:!1},...Ce)}affects(me,...Ce){return this.h(me,{includeChildren:!0},...Ce)}h(me,Ce,...ee){if(!me)return!1;const U=ee.length>0;return!!((!U||ee.includes(1))&&(this.d.value.get(me)||Ce.includeChildren&&this.d.value.findSuperstr(me))||(!U||ee.includes(0))&&(this.f.value.get(me)||Ce.includeChildren&&this.f.value.findSuperstr(me))||(!U||ee.includes(2))&&(this.g.value.findSubstr(me)||Ce.includeChildren&&this.g.value.findSuperstr(me)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(me){return this.b===me}hasCorrelation(){return typeof this.b=="number"}}e.$8k=T;function z(Y,me,Ce){return!Y||!me||Y===me||me.length>Y.length?!1:(me.charAt(me.length-1)!==L.sep&&(me+=L.sep),Ce?(0,M.$mf)(Y,me):Y.indexOf(me)===0)}class j extends Error{constructor(me,Ce,ee){super(me),this.fileOperationResult=Ce,this.options=ee}}e.$0k=j;class N extends j{constructor(me,Ce,ee,U){super(me,Ce,U),this.fileOperationResult=Ce,this.size=ee}}e.$$k=N;class B extends j{constructor(me,Ce,ee){super(me,2,ee),this.stat=Ce}}e.$_k=B;var W;(function(Y){Y[Y.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Y[Y.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Y[Y.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Y[Y.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Y[Y.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Y[Y.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Y[Y.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Y[Y.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Y[Y.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Y[Y.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Y[Y.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(W||(e.FileOperationResult=W={})),e.$al={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$bl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$cl="files.associations",e.$dl="files.exclude",e.$el="files.readonlyInclude",e.$fl="files.readonlyExclude",e.$gl="files.readonlyFromPermissions";var Z;(function(Y){Y[Y.FILE=0]="FILE",Y[Y.FOLDER=1]="FOLDER",Y[Y.ROOT_FOLDER=2]="ROOT_FOLDER"})(Z||(e.FileKind=Z={})),e.$hl="";function _(Y){if(!(typeof Y.size!="number"||typeof Y.mtime!="number"))return Y.mtime.toString(29)+Y.size.toString(31)}async function X(Y,me){if(!me.hasProvider(R.URI.from({scheme:Y.scheme})))return new Promise(Ce=>{const ee=me.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===Y.scheme&&U.added&&(ee.dispose(),Ce())})})}class x{static{this.KB=1024}static{this.MB=x.KB*x.KB}static{this.GB=x.MB*x.KB}static{this.TB=x.GB*x.KB}static formatSize(me){return(0,P.$Zf)(me)||(me=0),me<x.KB?(0,b.localize)(1,null,me.toFixed(0)):me<x.MB?(0,b.localize)(2,null,(me/x.KB).toFixed(2)):me<x.GB?(0,b.localize)(3,null,(me/x.MB).toFixed(2)):me<x.TB?(0,b.localize)(4,null,(me/x.GB).toFixed(2)):(0,b.localize)(5,null,(me/x.TB).toFixed(2))}}e.$kl=x;function re(Y){const me=typeof Y=="string"||Y?.scheme===A.Schemas.vscodeRemote;return typeof Y!="string"&&Y?.scheme===A.Schemas.file?1024*x.MB:me?10*x.MB:y.$o?50*x.MB:1024*x.MB}}),define(ke[250],Ee([1,0,21,13,210,32]),function(he,e,u,L,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tq=R;async function R(A,I,p,E,v,a){let m;try{await b(A,I,p,E,v,a)}catch(o){m=o}finally{m&&v.errorTransformer&&(m=v.errorTransformer(m)),typeof m<"u"&&p.error(m),p.end()}}async function b(A,I,p,E,v,a){$(a);const m=await A.open(I,{create:!1});try{$(a);let o=0,n=0,i=v&&typeof v.length=="number"?v.length:void 0,r=u.$ue.alloc(Math.min(v.bufferSize,typeof i=="number"?i:v.bufferSize)),s=v&&typeof v.position=="number"?v.position:0,t=0;do n=await A.read(m,s,r.buffer,t,r.byteLength-t),s+=n,t+=n,o+=n,typeof i=="number"&&(i-=n),t===r.byteLength&&(await p.write(E(r)),r=u.$ue.alloc(Math.min(v.bufferSize,typeof i=="number"?i:v.bufferSize)),t=0);while(n>0&&(typeof i!="number"||i>0)&&$(a)&&y(o,v));if(t>0){let f=t;typeof i=="number"&&(f=Math.min(t,i)),p.write(E(r.slice(0,f)))}}catch(o){throw(0,P.$3k)(o)}finally{await A.close(m)}}function $(A){if(A.isCancellationRequested)throw(0,L.$6)();return!0}function y(A,I){if(typeof I?.limits?.size=="number"&&A>I.limits.size)throw(0,P.$2k)((0,M.localize)(0,null),P.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[64],Ee([1,0,35,3,17,11,2,32]),function(he,e,u,L,M,P,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=e.$yq=e.$xq=void 0,e.$vq=$,e.$wq=y,e.$Aq=E,e.$Bq=v,e.$Cq=a,e.$Dq=m;function $(n){return typeof n.correlationId=="number"}function y(n){return n.recursive===!0}class A extends L.$Uc{static{this.a=5}constructor(i,r,s,t){super(),this.h=i,this.j=r,this.m=s,this.n=t,this.c=this.B(new L.$Vc),this.f=void 0,this.g=0}s(){const i=new L.$Tc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(r=>this.h(r))),i.add(this.b.onDidLogMessage(r=>this.j(r))),i.add(this.b.onDidError(r=>this.t(r)))}t(i){this.n.restartOnError?this.g<A.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$xq=A;class I extends A{constructor(i,r,s){super(i,r,s,{type:"node.js",restartOnError:!1})}}e.$yq=I;class p extends A{constructor(i,r,s){super(i,r,s,{type:"universal",restartOnError:!0})}}e.$zq=p;function E(n){return n.map(i=>({type:i.type,resource:R.URI.revive(i.resource),cId:i.cId}))}function v(n){const i=new o;for(const r of n)i.processEvent(r);return i.coalesce()}function a(n,i){return typeof i=="string"&&!i.startsWith(u.$$j)&&!(0,M.$jc)(i)?{base:n,pattern:i}:i}function m(n,i){const r=[];for(const s of i)r.push((0,u.$ck)(a(n,s)));return r}class o{constructor(){this.a=new Set,this.b=new Map}c(i){return P.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const r=this.b.get(this.c(i));let s=!1;if(r){const t=r.type,f=i.type;r.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?s=!0:t===1&&f===2?(this.b.delete(this.c(i)),this.a.delete(r)):t===2&&f===1?r.type=0:t===1&&f===0||(r.type=f)}else s=!0;s&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],r=[];return Array.from(this.a).filter(s=>s.type!==2?(i.push(s),!1):!0).sort((s,t)=>s.resource.fsPath.length-t.resource.fsPath.length).filter(s=>r.some(t=>(0,b.$9k)(s.resource.fsPath,t,!P.$k))?!1:(r.push(s.resource.fsPath),!0)).concat(i)}}}),define(ke[251],Ee([1,0,51,3,64,4,2]),function(he,e,u,L,M,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0;class b extends L.$Uc{constructor(){super(),this.a=this.B(new P.$7d),this.onDidChangeFile=this.a.event,this.b=this.B(new P.$7d),this.onDidLogMessage=this.b.event,this.c=this.B(new P.$7d),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new L.$4c),this.m=5007,this.B(this.f(y=>this.n(y)))}n(y){this.r(y)&&this.t(y)}r(y){return(0,M.$vq)(y)}async watch(y){this.h.clear(),this.g.clear();for(const A of y)this.r(A)?this.h.set(A.correlationId,A):this.g.add(A);for(const[A]of this.j)this.h.has(A)||this.j.deleteAndDispose(A);return this.s()}s(){return this.D([...this.g,...Array.from(this.h.values()).filter(y=>!this.j.has(y.correlationId))])}t(y){if(this.j.has(y.correlationId))return;const A=new L.$Tc;this.j.set(y.correlationId,A),this.w(y,A),this.s()}u(y){this.j.deleteAndDispose(y.correlationId),this.s()}w(y,A){const I=R.URI.file(y.path),p=this;let E=!1;const v=(a,m)=>{if(A.isDisposed)return;const o=this.y(a),n=this.y(m),i=E;if(E=o,!o&&(n||i)){this.F(`fs.watchFile() detected ${y.path} exists again, resuming watcher (correlationId: ${y.correlationId})`);const r={resource:I,type:1,cId:y.correlationId};p.a.fire([r]),this.z(r,y),this.u(y)}};this.F(`starting fs.watchFile() on ${y.path} (correlationId: ${y.correlationId})`);try{(0,u.watchFile)(y.path,{persistent:!1,interval:this.m},v)}catch(a){this.G(`fs.watchFile() failed with error ${a} on path ${y.path} (correlationId: ${y.correlationId})`)}A.add((0,L.$Sc)(()=>{this.F(`stopping fs.watchFile() on ${y.path} (correlationId: ${y.correlationId})`);try{(0,u.unwatchFile)(y.path,v)}catch(a){this.G(`fs.unwatchFile() failed with error ${a} on path ${y.path} (correlationId: ${y.correlationId})`)}}))}y(y){return y.ctimeMs===0&&y.ino===0}async stop(){this.j.clearAndDisposeAll()}z(y,A){const I=` >> normalized ${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.resource.fsPath}`;this.F(typeof A.correlationId=="number"?`${I} (correlationId: ${A.correlationId})`:I)}C(y){return`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"}, correlationId: ${typeof y.correlationId=="number"?y.correlationId:"<none>"})`}}e.$Mq=b}),define(ke[252],Ee([1,0,51,8,22,34,3,76,17,11,23,2,104,31,64]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0,e.$Sq=m;class a extends R.$Uc{static{this.a=100}static{this.b=75}constructor(n,i,r,s,t){super(),this.m=n,this.n=i,this.r=r,this.s=s,this.t=t,this.c=this.B(new L.$xh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},f=>this.n(f))),this.f=this.B(new L.$wh(f=>this.D(f),a.b)),this.g=(0,v.$Dq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,v.$Dq)(this.m.path,this.m.includes):void 0,this.j=new M.$ee,this.ready=this.u()}async u(){try{const n=await this.w(this.m);if(this.j.token.isCancellationRequested)return;const i=await E.Promises.stat(n);if(this.j.token.isCancellationRequested)return;this.B(await this.y(n,i.isDirectory()))}catch(n){n.code!=="ENOENT"?this.G(n):this.I(`ignoring a path for watching who's stat info failed to resolve: ${this.m.path} (error: ${n})`),this.r?.()}}async w(n){let i=n.path;try{i=await E.Promises.realpath(n.path),n.path===i&&(i=await(0,p.$Oq)(n.path,this.j.token)??n.path),n.path!==i&&this.I(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${n.path}, real: ${i})`)}catch{}return i}async y(n,i){if(y.$j&&(0,P.$ig)(n,"/Volumes/",!0))return this.G(`Refusing to watch ${n} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.$Uc.None;const r=new M.$ee(this.j.token),s=new R.$Tc;try{const t=I.URI.file(this.m.path),f=(0,$.$oc)(n),d=(0,u.watch)(n);s.add((0,R.$Sc)(()=>{d.removeAllListeners(),d.close()})),this.I(`Started watching: '${n}'`);const l=new Set;if(i)try{for(const h of await E.Promises.readdir(n))l.add(h)}catch(h){this.G(h)}const c=new Map;s.add((0,R.$Sc)(()=>{for(const[,h]of c)h.dispose();c.clear()})),d.on("error",(h,g)=>{this.G(`Failed to watch ${n} for changes using fs.watch() (${h}, ${g})`),this.r?.()}),d.on("change",(h,g)=>{if(r.token.isCancellationRequested)return;this.I(`[raw] ["${h}"] ${g}`);let S="";if(g&&(S=g.toString(),y.$j&&(S=(0,b.$Zl)(S))),!(!S||h!=="change"&&h!=="rename"))if(i)if(h==="rename"){c.get(S)?.dispose();const w=setTimeout(async()=>{if(c.delete(S),S===f&&!await E.Promises.exists(n)){this.z(t);return}const C=await this.F((0,$.$kc)(n,S));if(r.token.isCancellationRequested)return;let k;C?l.has(S)?k=0:(k=1,l.add(S)):(l.delete(S),k=2),this.C({resource:(0,A.$Vg)(t,S),type:k,cId:this.m.correlationId})},a.a);c.set(S,(0,R.$Sc)(()=>clearTimeout(w)))}else{let w;l.has(S)?w=0:(w=1,l.add(S)),this.C({resource:(0,A.$Vg)(t,S),type:w,cId:this.m.correlationId})}else if(h==="rename"||S!==f){const w=setTimeout(async()=>{const C=await E.Promises.exists(n);r.token.isCancellationRequested||(C?(this.C({resource:t,type:0,cId:this.m.correlationId},!0),s.add(await this.y(n,!1))):this.z(t))},a.a);s.clear(),s.add((0,R.$Sc)(()=>clearTimeout(w)))}else this.C({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){r.token.isCancellationRequested||this.G(`Failed to watch ${n} for changes using fs.watch() (${t.toString()})`),this.r?.()}return(0,R.$Sc)(()=>{r.dispose(!0),s.dispose()})}z(n){this.H("Watcher shutdown because watched path got deleted"),this.C({resource:n,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.r?.()}C(n,i=!1){this.j.token.isCancellationRequested||(this.t&&this.I(`${n.type===1?"[ADDED]":n.type===2?"[DELETED]":"[CHANGED]"} ${n.resource.fsPath}`),!i&&this.g.some(r=>r(n.resource.fsPath))?this.t&&this.I(` >> ignored (excluded) ${n.resource.fsPath}`):!i&&this.h&&this.h.length>0&&!this.h.some(r=>r(n.resource.fsPath))?this.t&&this.I(` >> ignored (not included) ${n.resource.fsPath}`):this.f.work(n))}D(n){const i=(0,v.$Bq)(n);if(i.length>0){if(this.t)for(const s of i)this.I(` >> normalized ${s.type===1?"[ADDED]":s.type===2?"[DELETED]":"[CHANGED]"} ${s.resource.fsPath}`);this.c.work(i)?this.c.pending>0&&this.I(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.H(`started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async F(n){if(y.$k)return E.Promises.exists(n);try{const i=(0,$.$oc)(n);return(await E.Promises.readdir((0,$.$nc)(n))).some(s=>s===i)}catch(i){return this.I(i),!1}}setVerboseLogging(n){this.t=n}G(n){this.j.token.isCancellationRequested||this.s?.({type:"error",message:`[File Watcher (node.js)] ${n}`})}H(n){this.j.token.isCancellationRequested||this.s?.({type:"warn",message:`[File Watcher (node.js)] ${n}`})}I(n){!this.j.token.isCancellationRequested&&this.t&&this.s?.({type:"trace",message:`[File Watcher (node.js)] ${n}`})}dispose(){this.j.dispose(!0),super.dispose()}}e.$Rq=a;async function m(o,n,i,r,s=512){const t=await E.Promises.open(o,"r"),f=Buffer.allocUnsafe(s),d=new M.$ee(r);let l,c=!1;const h={path:o,excludes:[],recursive:!1},g=new a(h,S=>{(async()=>{for(const{type:w}of S)if(w===0){if(c)return;c=!0;try{for(;!d.token.isCancellationRequested;){const{bytesRead:C}=await E.Promises.read(t,f,0,s,null);if(!C||d.token.isCancellationRequested)break;n(f.slice(0,C))}}catch(C){l=new Error(C),d.dispose(!0)}finally{c=!1}}})()});return await g.ready,i(),new Promise((S,w)=>{d.token.onCancellationRequested(async()=>{g.dispose();try{await E.Promises.close(t)}catch(C){l=new Error(C)}l?w(l):S()})})}}),define(ke[253],Ee([1,0,4,35,251,11,252,34]),function(he,e,u,L,M,P,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;class $ extends M.$Mq{constructor(){super(...arguments),this.onDidError=u.Event.None,this.H=new Set,this.I=!1}async D(A){A=this.O(A);const I=[],p=new Set(Array.from(this.H));for(const E of A){const v=this.L(E);v&&(0,L.$gk)(v.request.excludes,E.excludes)&&(0,L.$gk)(v.request.includes,E.includes)?p.delete(v):I.push(E)}I.length&&this.F(`Request to start watching: ${I.map(E=>this.C(E)).join(",")}`),p.size&&this.F(`Request to stop watching: ${Array.from(p).map(E=>this.C(E.request)).join(",")}`);for(const E of p)this.N(E);for(const E of I)this.M(E)}L(A){for(const I of this.H)if(typeof A.correlationId=="number"||typeof I.request.correlationId=="number"){if(I.request.correlationId===A.correlationId)return I}else if((0,b.$hg)(I.request.path,A.path,!P.$k))return I}M(A){const I=new R.$Rq(A,E=>this.a.fire(E),()=>this.c.fire(A),E=>this.b.fire(E),this.I),p={request:A,instance:I};this.H.add(p)}async stop(){await super.stop();for(const A of this.H)this.N(A)}N(A){this.F("stopping file watcher",A),this.H.delete(A),A.instance.dispose()}O(A){const I=new Map;for(const p of A){const E=P.$k?p.path:p.path.toLowerCase();let v=I.get(p.correlationId);v||(v=new Map,I.set(p.correlationId,v)),v.has(E)&&this.F(`ignoring a request for watching who's path is already watched: ${this.C(p)}`),v.set(E,p)}return Array.from(I.values()).map(p=>Array.from(p.values())).flat()}async setVerboseLogging(A){this.I=A;for(const I of this.H)I.instance.setVerboseLogging(A)}F(A,I){this.I&&this.b.fire({type:"trace",message:this.R(A,I)})}G(A){this.b.fire({type:"warn",message:this.R(A)})}R(A,I){return I?`[File Watcher (node.js)] ${A} (${this.C(I.request)})`:`[File Watcher (node.js)] ${A}`}}e.$Tq=$}),define(ke[254],Ee([1,0,64,253]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class M extends u.$yq{constructor(R,b,$){super(R,b,$),this.s()}r(R){return R.add(new L.$Tq)}}e.$Uq=M}),define(ke[255],Ee([1,0,15,81,193,64]),function(he,e,u,L,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=void 0;class R extends P.$zq{constructor($,y,A){super($,y,A),this.s()}r($){const y=$.add(new M.$Kq(u.$Cg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(y.onDidProcessExit(({code:A,signal:I})=>this.t(`terminated by itself with code ${A}, signal: ${I}`))),L.ProxyChannel.toService((0,L.$2h)(y.getChannel("watcher")))}}e.$Lq=R}),define(ke[107],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=void 0;class u{constructor(...M){this.a=new Map;for(const[P,R]of M)this.set(P,R)}set(M,P){const R=this.a.get(M);return this.a.set(M,P),R}has(M){return this.a.has(M)}get(M){return this.a.get(M)}}e.$gi=u}),define(ke[256],Ee([1,0,8,13,3,106,246,5,107,75]),function(he,e,u,L,M,P,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Yq=void 0;const A=!1;class I extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class p{constructor(m=new $.$gi,o=!1,n,i=A){this.f=m,this.g=o,this.h=n,this.i=i,this.o=new Set,this.f.set(b.$hi,this),this._globalGraph=i?n?._globalGraph??new R.$Xq(r=>r):void 0}createChild(m){return new p(m,this.g,this,this.i)}invokeFunction(m,...o){const n=v.traceInvocation(this.i,m);let i=!1;try{return m({get:s=>{if(i)throw(0,L.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(s,n);if(!t)throw new Error(`[invokeFunction] unknown service '${s}'`);return t}},...o)}finally{i=!0,n.stop()}}createInstance(m,...o){let n,i;return m instanceof P.$fi?(n=v.traceCreation(this.i,m.ctor),i=this.j(m.ctor,m.staticArguments.concat(o),n)):(n=v.traceCreation(this.i,m),i=this.j(m,o,n)),n.stop(),i}j(m,o=[],n){const i=b._util.getServiceDependencies(m).sort((t,f)=>t.index-f.index),r=[];for(const t of i){const f=this.m(t.id,n);f||this.u(`[createInstance] ${m.name} depends on UNKNOWN service ${t.id}.`,!1),r.push(f)}const s=i.length>0?i[0].index:o.length;if(o.length!==s){console.trace(`[createInstance] First service dependency of ${m.name} at position ${s+1} conflicts with ${o.length} static arguments`);const t=s-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,s)}return Reflect.construct(m,o.concat(r))}k(m,o){if(this.f.get(m)instanceof P.$fi)this.f.set(m,o);else if(this.h)this.h.k(m,o);else throw new Error("illegalState - setting UNKNOWN service instance")}l(m){const o=this.f.get(m);return!o&&this.h?this.h.l(m):o}m(m,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const n=this.l(m);return n instanceof P.$fi?this.q(m,n,o.branch(m,!0)):(o.branch(m,!1),n)}q(m,o,n){if(this.o.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.o.add(m);try{return this.r(m,o,n)}finally{this.o.delete(m)}}r(m,o,n){const i=new R.$Xq(t=>t.id.toString());let r=0;const s=[{id:m,desc:o,_trace:n}];for(;s.length;){const t=s.pop();if(i.lookupOrInsertNode(t),r++>1e3)throw new I(i);for(const f of b._util.getServiceDependencies(t.desc.ctor)){const d=this.l(f.id);if(d||this.u(`[createInstance] ${m} depends on ${f.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(f.id)),d instanceof P.$fi){const l={id:f.id,desc:d,_trace:t._trace.branch(f.id,!0)};i.insertEdge(t,l),s.push(l)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new I(i);break}for(const{data:f}of t){if(this.l(f.id)instanceof P.$fi){const l=this.s(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this.k(f.id,l)}i.removeNode(f)}}return this.l(m)}s(m,o,n=[],i,r){if(this.f.get(m)instanceof P.$fi)return this.t(m,o,n,i,r);if(this.h)return this.h.s(m,o,n,i,r);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}t(m,o,n=[],i,r){if(i){const s=new p(void 0,this.g,this,this.i);s.c=String(m);const t=new Map,f=new u.$Bh(()=>{const d=s.j(o,n,r);for(const[l,c]of t){const h=d[l];if(typeof h=="function")for(const g of c)g.disposable=h.apply(d,g.listener)}return t.clear(),d});return new Proxy(Object.create(null),{get(d,l){if(!f.isInitialized&&typeof l=="string"&&(l.startsWith("onDid")||l.startsWith("onWill"))){let g=t.get(l);return g||(g=new y.$5c,t.set(l,g)),(w,C,k)=>{if(f.isInitialized)return f.value[l](w,C,k);{const D={listener:[w,C,k],disposable:void 0},O=g.push(D);return(0,M.$Sc)(()=>{O(),D.disposable?.dispose()})}}}if(l in d)return d[l];const c=f.value;let h=c[l];return typeof h!="function"||(h=h.bind(c),d[l]=h),h},set(d,l,c){return f.value[l]=c,!0},getPrototypeOf(d){return o.prototype}})}else return this.j(o,n,r)}u(m,o){if(o&&console.warn(m),this.g)throw new Error(m)}}e.$Yq=p;var E;(function(a){a[a.None=0]="None",a[a.Creation=1]="Creation",a[a.Invocation=2]="Invocation",a[a.Branch=3]="Branch"})(E||(E={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(m,o){return m?new v(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(m,o){return m?new v(1,o.name):v.c}static{this.f=0}constructor(m,o){this.type=m,this.name=o,this.g=Date.now(),this.h=[]}branch(m,o){const n=new v(3,m.toString());return this.h.push([m,o,n]),n}stop(){const m=Date.now()-this.g;v.f+=m;let o=!1;function n(r,s){const t=[],f=new Array(r+1).join("	");for(const[d,l,c]of s.h)if(l&&c){o=!0,t.push(`${f}CREATES -> ${d}`);const h=n(r+1,c);h&&t.push(h)}else t.push(`${f}uses -> ${d}`);return t.join(`
`)}const i=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(m>2||o)&&v.all.add(i.join(`
`))}}e.$Zq=v}),define(ke[12],Ee([1,0,212,46,4,55,3,27,11,23,18,2,41,5]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Rj=e.LogLevel=e.$Pj=e.$Oj=void 0,e.$Qj=a,e.log=o,e.$3j=g,e.$4j=S,e.$5j=w,e.$6j=C,e.$Oj=(0,E.$ii)("logService"),e.$Pj=(0,E.$ii)("loggerService");function v(){return new Date().toISOString()}function a(k){return(0,A.$Zf)(k)}var m;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$Rj=m.Info;function o(k,D,O){switch(D){case m.Trace:k.trace(O);break;case m.Debug:k.debug(O);break;case m.Info:k.info(O);break;case m.Warning:k.warn(O);break;case m.Error:k.error(O);break;case m.Off:break;default:throw new Error(`Invalid log level ${D}`)}}function n(k,D=!1){let O="";for(let F=0;F<k.length;F++){let T=k[F];if(T instanceof Error&&(T=(0,L.$6i)(T,D)),typeof T=="object")try{T=JSON.stringify(T)}catch{}O+=(F>0?" ":"")+T}return O}class i extends R.$Uc{constructor(){super(...arguments),this.b=e.$Rj,this.c=this.B(new M.$7d),this.onDidChangeLogLevel=this.c.event}setLevel(D){this.b!==D&&(this.b=D,this.c.fire(this.b))}getLevel(){return this.b}f(D){return this.b!==m.Off&&this.b<=D}}e.$Tj=i;class r extends i{constructor(D){super(),this.h=D}f(D){return this.h||super.f(D)}trace(D,...O){this.f(m.Trace)&&this.g(m.Trace,n([D,...O],!0))}debug(D,...O){this.f(m.Debug)&&this.g(m.Debug,n([D,...O]))}info(D,...O){this.f(m.Info)&&this.g(m.Info,n([D,...O]))}warn(D,...O){this.f(m.Warning)&&this.g(m.Warning,n([D,...O]))}error(D,...O){if(this.f(m.Error))if(D instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=D.stack,this.g(m.Error,n(F))}else this.g(m.Error,n([D,...O]))}flush(){}}e.$Uj=r;class s extends i{constructor(D=e.$Rj){super(),this.setLevel(D),this.g=!$.$i}trace(D,...O){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,D,...O):console.log(`[main ${v()}]`,D,...O))}debug(D,...O){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,D,...O):console.log(`[main ${v()}]`,D,...O))}info(D,...O){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,D,...O):console.log(`[main ${v()}]`,D,...O))}warn(D,...O){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,D,...O):console.warn(`[main ${v()}]`,D,...O))}error(D,...O){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,D,...O):console.error(`[main ${v()}]`,D,...O))}flush(){}}e.$Vj=s;class t extends i{constructor(D=e.$Rj,O=!0){super(),this.g=O,this.setLevel(D)}trace(D,...O){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",D,...O):console.log(D,...O))}debug(D,...O){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",D,...O):console.log(D,...O))}info(D,...O){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",D,...O):console.log(D,...O))}warn(D,...O){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",D,...O):console.log(D,...O))}error(D,...O){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",D,...O):console.error(D,...O))}flush(){}}e.$Wj=t;class f extends i{constructor(D,O=e.$Rj){super(),this.g=D,this.setLevel(O)}trace(D,...O){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(D),...O])}debug(D,...O){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(D),...O])}info(D,...O){this.f(m.Info)&&this.g.log(m.Info,[this.h(D),...O])}warn(D,...O){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(D),...O])}error(D,...O){this.f(m.Error)&&this.g.log(m.Error,[this.h(D),...O])}h(D){return typeof D=="string"?D:(0,L.$6i)(D,this.f(m.Trace))}flush(){}}e.$Xj=f;class d extends i{constructor(D){super(),this.g=D,D.length&&this.setLevel(D[0].getLevel())}setLevel(D){for(const O of this.g)O.setLevel(D);super.setLevel(D)}trace(D,...O){for(const F of this.g)F.trace(D,...O)}debug(D,...O){for(const F of this.g)F.debug(D,...O)}info(D,...O){for(const F of this.g)F.info(D,...O)}warn(D,...O){for(const F of this.g)F.warn(D,...O)}error(D,...O){for(const F of this.g)F.error(D,...O)}flush(){for(const D of this.g)D.flush()}dispose(){for(const D of this.g)D.dispose();super.dispose()}}e.$Yj=d;class l extends R.$Uc{constructor(D,O,F){if(super(),this.h=D,this.j=O,this.b=new b.$Bc,this.c=this.B(new M.$7d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$7d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$7d),this.onDidChangeVisibility=this.g.event,F)for(const T of F)this.b.set(T.resource,{logger:void 0,info:T})}m(D){return(0,A.$Vf)(D)?[...this.b.values()].find(O=>O.info.id===D):this.b.get(D)}getLogger(D){return this.m(D)?.logger}createLogger(D,O){const F=this.n(D),T=(0,A.$Vf)(D)?D:O?.id??(0,P.$9i)(F.toString()).toString(16);let z=this.b.get(F)?.logger;const j=O?.logLevel==="always"?m.Trace:O?.logLevel;z||(z=this.s(F,j??this.getLogLevel(F)??this.h,{...O,id:T}));const N={logger:z,info:{resource:F,id:T,logLevel:j,name:O?.name,hidden:O?.hidden,extensionId:O?.extensionId,when:O?.when}};return this.registerLogger(N.info),this.b.set(F,N),z}n(D){return(0,A.$Vf)(D)?(0,y.$Vg)(this.j,`${D}.log`):D}setLogLevel(D,O){if(I.URI.isUri(D)){const F=D,T=O,z=this.b.get(F);z&&T!==z.info.logLevel&&(z.info.logLevel=T===this.h?void 0:T,z.logger?.setLevel(T),this.b.set(z.info.resource,z),this.f.fire([F,T]))}else{this.h=D;for(const[F,T]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(D,O){const F=this.m(D);F&&O!==!F.info.hidden&&(F.info.hidden=!O,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,O]))}getLogLevel(D){let O;return D&&(O=this.b.get(D)?.info.logLevel),O??this.h}registerLogger(D){const O=this.b.get(D.resource);O?O.info.hidden!==D.hidden&&this.setVisibility(D.resource,!D.hidden):(this.b.set(D.resource,{info:D,logger:void 0}),this.c.fire({added:[D],removed:[]}))}deregisterLogger(D){const O=this.b.get(D);O&&(O.logger&&O.logger.dispose(),this.b.delete(D),this.c.fire({added:[],removed:[O.info]}))}*getRegisteredLoggers(){for(const D of this.b.values())yield D.info}getRegisteredLogger(D){return this.b.get(D)?.info}dispose(){this.b.forEach(D=>D.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Zj=l;class c{constructor(){this.onDidChangeLogLevel=new M.$7d().event}setLevel(D){}getLevel(){return m.Info}trace(D,...O){}debug(D,...O){}info(D,...O){}warn(D,...O){}error(D,...O){}critical(D,...O){}dispose(){}flush(){}}e.$1j=c;class h extends c{}e.$2j=h;function g(k){if(k.verbose)return m.Trace;if(typeof k.logLevel=="string"){const D=C(k.logLevel.toLowerCase());if(D!==void 0)return D}return e.$Rj}function S(k){switch(k){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function w(k){switch(k){case m.Trace:return{original:"Trace",value:u.localize(0,null)};case m.Debug:return{original:"Debug",value:u.localize(1,null)};case m.Info:return{original:"Info",value:u.localize(2,null)};case m.Warning:return{original:"Warning",value:u.localize(3,null)};case m.Error:return{original:"Error",value:u.localize(4,null)};case m.Off:return{original:"Off",value:u.localize(5,null)}}}function C(k){switch(k){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$7j=new p.$zj("logLevel",S(m.Info))}),define(ke[257],Ee([1,0,19,8,13,4,3,17,64,12]),function(he,e,u,L,M,P,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=void 0;class A extends R.$Uc{constructor(p,E){super(),this.a=p,this.b=E,this.c=this.B(new P.$7d),this.onDidChangeFile=this.c.event,this.g=this.B(new P.$7d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new L.$gh(0)),this.w=[],this.y=this.B(new L.$gh(0))}watch(p,E){return E.recursive||this.b?.watcher?.forceUniversal?this.n(p,E):this.z(p,E)}n(p,E){const v={path:this.H(p),excludes:E.excludes,includes:E.includes,recursive:E.recursive,correlationId:E.correlationId},a=(0,u.$Ub)(this.j,v);return this.r(),(0,R.$Sc)(()=>{a(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(p=>(0,M.$1)(p))}s(){this.h||(this.h=this.B(this.t(E=>this.c.fire((0,$.$Aq)(E)),E=>this.G(E),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const E of this.j)(0,$.$wq)(E)&&(E.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const E of this.j)(0,$.$wq)(E)&&p.includes(E.path)&&(E.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(p,E){const v={path:this.H(p),excludes:E.excludes,includes:E.includes,recursive:!1,correlationId:E.correlationId},a=(0,u.$Ub)(this.w,v);return this.C(),(0,R.$Sc)(()=>{a(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(p=>(0,M.$1)(p))}D(){return this.u||(this.u=this.B(this.F(p=>this.c.fire((0,$.$Aq)(p)),p=>this.G(p),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)}))),this.u.watch(this.w)}G(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}H(p){return(0,b.$ic)(p.fsPath)}}e.$Eq=A}),define(ke[258],Ee([1,0,51,398,8,27,21,4,34,3,17,11,23,98,31,211,32,250,257,46,255,254]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v,a,m,o,n,i,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=void 0,(()=>{try{(0,L.gracefulify)(u)}catch(f){console.error(`Error enabling graceful-fs: ${(0,i.$6i)(f)}`)}})();class t extends n.$Eq{static{this.I=!1}constructor(d,l){super(d,l),this.onDidChangeCapabilities=b.Event.None,this.N=new P.$Bc(c=>p.$Mg.getComparisonKey(c)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,I.$k&&(this.J|=1024)),this.J}async stat(d){try{const{stat:l,symbolicLink:c}=await v.SymlinkSupport.stat(this.H(d));return{type:this.M(l,c),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size,permissions:l.mode&128?void 0:m.FilePermission.Locked}}catch(l){throw this.fb(l)}}async L(d){try{return await this.stat(d)}catch{return}}async readdir(d){try{const l=await v.Promises.readdir(this.H(d),{withFileTypes:!0}),c=[];return await Promise.all(l.map(async h=>{try{let g;h.isSymbolicLink()?g=(await this.stat((0,p.$Vg)(d,h.name))).type:g=this.M(h),c.push([h.name,g])}catch(g){this.a.trace(g)}})),c}catch(l){throw this.fb(l)}}M(d,l){let c;return l?.dangling?c=m.FileType.Unknown:d.isFile()?c=m.FileType.File:d.isDirectory()?c=m.FileType.Directory:c=m.FileType.Unknown,l&&(c|=m.FileType.SymbolicLink),c}async O(d){const l=this.H(d);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${l})`);let c;for(;c=this.N.get(d);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${l})`),await c.wait();const h=new M.$hh;return this.N.set(d,h),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${l})`),(0,y.$Sc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${l})`),this.N.get(d)===h&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${l})`),this.N.delete(d)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${l})`),h.open()})}async readFile(d,l){let c;try{l?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(d)})`),c=await this.O(d));const h=this.H(d);return await v.Promises.readFile(h)}catch(h){throw this.fb(h)}finally{c?.dispose()}}P(d){t.I&&this.a.trace(d)}readFileStream(d,l,c){const h=(0,E.$ie)(g=>R.$ue.concat(g.map(S=>R.$ue.wrap(S))).buffer);return(0,o.$tq)(this,d,h,g=>g.buffer,{...l,bufferSize:256*1024},c),h}async writeFile(d,l,c){return c?.atomic!==!1&&c?.atomic?.postfix&&await this.Q(d)?this.R(d,(0,p.$Vg)((0,p.$Ug)(d),`${(0,p.$Sg)(d)}${c.atomic.postfix}`),l,c):this.S(d,l,c)}async Q(d){try{const l=this.H(d),{symbolicLink:c}=await v.SymlinkSupport.stat(l);if(c)return!1}catch{}return!0}async R(d,l,c,h){const g=new y.$Tc;try{g.add(await this.O(d)),g.add(await this.O(l)),await this.S(l,c,h,!0);try{await this.rename(l,d,{overwrite:!0})}catch(S){try{await this.delete(l,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw S}}finally{g.dispose()}}async S(d,l,c,h){let g;try{const S=this.H(d);if(!c.create||!c.overwrite){if(await v.Promises.exists(S)){if(!c.overwrite)throw(0,m.$2k)((0,a.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,m.$2k)((0,a.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}g=await this.open(d,{create:!0,unlock:c.unlock},h),await this.write(g,0,l,0,l.byteLength)}catch(S){throw await this.gb(d,S)}finally{typeof g=="number"&&await this.close(g)}}static{this.Y=!0}static configureFlushOnWrite(d){t.Y=d}async open(d,l,c){const h=this.H(d);let g;(0,m.$Pk)(l)&&!c&&(g=await this.O(d));let S;try{if((0,m.$Pk)(l)&&l.unlock)try{const{stat:C}=await v.SymlinkSupport.stat(h);C.mode&128||await v.Promises.chmod(h,C.mode|128)}catch(C){C.code!=="ENOENT"&&this.a.trace(C)}let w;if((0,m.$Pk)(l)){if(I.$i)try{await v.Promises.truncate(h,0),w="r+"}catch(C){C.code!=="ENOENT"&&this.a.trace(C)}w||(w="w")}else w="r";S=await v.Promises.open(h,w)}catch(w){throw g?.dispose(),(0,m.$Pk)(l)?await this.gb(d,w):this.fb(w)}if(this.U.set(S,0),(0,m.$Pk)(l)&&this.X.set(S,d),g){const w=this.W.get(S);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${S} (${h})`),this.W.set(S,g),w&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${S} (${h})`),w.dispose())}return S}async close(d){const l=this.W.get(d);try{if(this.U.delete(d),this.X.delete(d)&&t.Y)try{await v.Promises.fdatasync(d)}catch(c){t.configureFlushOnWrite(!1),this.a.error(c)}return await v.Promises.close(d)}catch(c){throw this.fb(c)}finally{l&&(this.W.get(d)===l&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${d}`),this.W.delete(d)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${d}`),l.dispose())}}async read(d,l,c,h,g){const S=this.Z(d,l);let w=null;try{w=(await v.Promises.read(d,c,h,g,S)).bytesRead}catch(C){throw this.fb(C)}finally{this.$(d,S,w)}return w}Z(d,l){return l===this.U.get(d)?null:l}$(d,l,c){const h=this.U.get(d);typeof h=="number"&&(typeof l=="number"||(typeof c=="number"?this.U.set(d,h+c):this.U.delete(d)))}async write(d,l,c,h,g){return(0,M.$Ch)(()=>this.ab(d,l,c,h,g),100,3)}async ab(d,l,c,h,g){const S=this.Z(d,l);let w=null;try{w=(await v.Promises.write(d,c,h,g,S)).bytesWritten}catch(C){throw await this.gb(this.X.get(d),C)}finally{this.$(d,S,w)}return w}async mkdir(d){try{await v.Promises.mkdir(this.H(d))}catch(l){throw this.fb(l)}}async delete(d,l){try{const c=this.H(d);if(l.recursive){let h;l?.atomic!==!1&&l.atomic.postfix&&(h=(0,A.$kc)((0,A.$nc)(c),`${(0,A.$oc)(c)}${l.atomic.postfix}`)),await v.Promises.rm(c,v.RimRafMode.MOVE,h)}else try{await v.Promises.unlink(c)}catch(h){if(h.code==="EPERM"||h.code==="EISDIR"){let g=!1;try{const{stat:S,symbolicLink:w}=await v.SymlinkSupport.stat(c);g=S.isDirectory()&&!w}catch{}if(g)await v.Promises.rmdir(c);else throw h}else throw h}}catch(c){throw this.fb(c)}}async rename(d,l,c){const h=this.H(d),g=this.H(l);if(h!==g)try{await this.bb(d,l,"move",c.overwrite),await v.Promises.rename(h,g)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,a.localize)(2,null,(0,A.$oc)(h),(0,A.$oc)((0,A.$nc)(g)),S.toString()))),this.fb(S)}}async copy(d,l,c){const h=this.H(d),g=this.H(l);if(h!==g)try{await this.bb(d,l,"copy",c.overwrite),await v.Promises.copy(h,g,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,a.localize)(3,null,(0,A.$oc)(h),(0,A.$oc)((0,A.$nc)(g)),S.toString()))),this.fb(S)}}async bb(d,l,c,h){const g=this.H(d),S=this.H(l);let w=!1;if(!!(this.capabilities&1024)||(w=(0,$.$hg)(g,S,!0)),w){if(c==="copy")throw(0,m.$2k)((0,a.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(c==="move")return}const k=await this.L(d);if(!k)throw(0,m.$2k)((0,a.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const D=await this.L(l);if(D){if(!h)throw(0,m.$2k)((0,a.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);k.type&m.FileType.File&&D.type&m.FileType.File||await this.delete(l,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(d,l){return this.cb(d,l,!1)}async cb(d,l,c){const h=this.H(d),g=this.H(l),S=!!(this.capabilities&1024);if((0,$.$hg)(h,g,!S))return;const w=new y.$Tc;try{w.add(await this.O(d)),w.add(await this.O(l)),c&&await v.Promises.mkdir((0,A.$nc)(g),{recursive:!0}),await v.Promises.copyFile(h,g)}catch(C){if(C.code==="ENOENT"&&!c)return this.cb(d,l,!0);throw this.fb(C)}finally{w.dispose()}}t(d,l,c){return new r.$Lq(h=>d(h),h=>l(h),c)}F(d,l,c){return new s.$Uq(h=>d(h),h=>l(h),c)}fb(d){if(d instanceof m.$1k)return d;let l=d,c;switch(d.code){case"ENOENT":c=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":c=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":c=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":c=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":c=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":l=`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,c=m.FileSystemProviderErrorCode.Unknown;break;default:c=m.FileSystemProviderErrorCode.Unknown}return(0,m.$2k)(l,c)}async gb(d,l){let c=this.fb(l);if(d&&c.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:h}=await v.SymlinkSupport.stat(this.H(d));h.mode&128||(c=(0,m.$2k)(l,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(h){this.a.trace(h)}return c}}e.$Vq=t}),define(ke[259],Ee([1,0,3,12]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5P=void 0;class M extends u.$Uc{constructor(R,b=[]){super(),this.a=new L.$Yj([R,...b]),this.B(R.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...b){this.a.trace(R,...b)}debug(R,...b){this.a.debug(R,...b)}info(R,...b){this.a.info(R,...b)}warn(R,...b){this.a.warn(R,...b)}error(R,...b){this.a.error(R,...b)}flush(){this.a.flush()}}e.$5P=M}),define(ke[260],Ee([1,0,32,12]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TP=void 0;var M;(function(y){y[y.Trace=0]="Trace",y[y.Debug=1]="Debug",y[y.Info=2]="Info",y[y.Warning=3]="Warning",y[y.Error=4]="Error",y[y.Critical=5]="Critical",y[y.Off=6]="Off"})(M||(M={}));async function P(y,A,I,p,E){try{const v=await new Promise((m,o)=>{he(["@vscode/spdlog"],m,o)});v.setFlushOn(M.Trace);const a=await v.createAsyncRotatingLogger(y,A,I,p);return E?a.clearFormatters():a.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),a}catch(v){console.error(v)}return null}function R(y,A,I){switch(A){case L.LogLevel.Trace:y.trace(I);break;case L.LogLevel.Debug:y.debug(I);break;case L.LogLevel.Info:y.info(I);break;case L.LogLevel.Warning:y.warn(I);break;case L.LogLevel.Error:y.error(I);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function b(y,A){switch(A){case L.LogLevel.Trace:y.setLevel(M.Trace);break;case L.LogLevel.Debug:y.setLevel(M.Debug);break;case L.LogLevel.Info:y.setLevel(M.Info);break;case L.LogLevel.Warning:y.setLevel(M.Warning);break;case L.LogLevel.Error:y.setLevel(M.Error);break;case L.LogLevel.Off:y.setLevel(M.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class $ extends L.$Uj{constructor(A,I,p,E,v){super(),this.m=[],this.setLevel(v),this.n=this.s(A,I,p,E),this.B(this.onDidChangeLogLevel(a=>{this.r&&b(this.r,a)}))}async s(A,I,p,E){const v=p?6:1,a=30/v*u.$kl.MB,m=await P(A,I,a,v,E);if(m){this.r=m,b(this.r,this.getLevel());for(const{level:o,message:n}of this.m)R(this.r,o,n);this.m=[]}}g(A,I){this.r?R(this.r,A,I):this.getLevel()<=A&&this.m.push({level:A,message:I})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$TP=$}),define(ke[138],Ee([1,0,40,213,5]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(P||(e.MarkerTag=P={}));var R;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function($){function y(v,a){return a-v}$.compare=y;const A=Object.create(null);A[$.Error]=(0,L.localize)(0,null),A[$.Warning]=(0,L.localize)(1,null),A[$.Info]=(0,L.localize)(2,null);function I(v){return A[v]||""}$.toString=I;function p(v){switch(v){case u.default.Error:return $.Error;case u.default.Warning:return $.Warning;case u.default.Info:return $.Info;case u.default.Ignore:return $.Hint}}$.fromSeverity=p;function E(v){switch(v){case $.Error:return u.default.Error;case $.Warning:return u.default.Warning;case $.Info:return u.default.Info;case $.Hint:return u.default.Ignore}}$.toSeverity=E}(R||(e.MarkerSeverity=R={}));var b;(function($){const y="";function A(p){return I(p,!0)}$.makeKey=A;function I(p,E){const v=[y];return p.source?v.push(p.source.replace("\xA6","\\\xA6")):v.push(y),p.code?typeof p.code=="string"?v.push(p.code.replace("\xA6","\\\xA6")):v.push(p.code.value.replace("\xA6","\\\xA6")):v.push(y),p.severity!==void 0&&p.severity!==null?v.push(R.toString(p.severity)):v.push(y),p.message&&E?v.push(p.message.replace("\xA6","\\\xA6")):v.push(y),p.startLineNumber!==void 0&&p.startLineNumber!==null?v.push(p.startLineNumber.toString()):v.push(y),p.startColumn!==void 0&&p.startColumn!==null?v.push(p.startColumn.toString()):v.push(y),p.endLineNumber!==void 0&&p.endLineNumber!==null?v.push(p.endLineNumber.toString()):v.push(y),p.endColumn!==void 0&&p.endColumn!==null?v.push(p.endColumn.toString()):v.push(y),v.push(y),v.join("\xA6")}$.makeKeyOptionalMessage=I})(b||(e.IMarkerData=b={})),e.$Ut=(0,M.$ii)("markerService")}),define(ke[261],Ee([1,0,4,40,5]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ov=e.$Nv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Lv=e.Severity=void 0,e.$Mv=b,e.Severity=L.default,e.$Lv=(0,M.$ii)("notificationService");var P;(function(I){I[I.DEFAULT=0]="DEFAULT",I[I.SILENT=1]="SILENT",I[I.URGENT=2]="URGENT"})(P||(e.NotificationPriority=P={}));var R;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.PROFILE=1]="PROFILE",I[I.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function b(I){if(I){const p=I;return typeof p.id=="string"&&typeof p.label=="string"}return!1}var $;(function(I){I[I.OFF=0]="OFF",I[I.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class y{constructor(){this.progress=new A,this.onDidClose=u.Event.None,this.onDidChangeVisibility=u.Event.None}updateSeverity(p){}updateMessage(p){}updateActions(p){}close(){}}e.$Nv=y;class A{infinite(){}done(){}total(p){}worked(p){}}e.$Ov=A}),define(ke[262],Ee([1,0,50]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;const M=globalThis.vscode;if(typeof M<"u"&&typeof M.context<"u"){const P=M.context.configuration();if(P)L=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(L=globalThis._VSCODE_PRODUCT_JSON,u.env.VSCODE_DEV&&Object.assign(L,{nameShort:`${L.nameShort} Dev`,nameLong:`${L.nameLong} Dev`,dataFolderName:`${L.dataFolderName}-dev`,serverDataFolderName:L.serverDataFolderName?`${L.serverDataFolderName}-dev`:void 0}),!L.version){const P=globalThis._VSCODE_PACKAGE_JSON;Object.assign(L,{version:P.version})}}else L={},Object.keys(L).length===0&&Object.assign(L,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=L}),define(ke[139],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9j=e.$8j=void 0,e.$8j=(0,u.$ii)("productService"),e.$9j="vscode://schemas/vscode-product"});var qe=this&&this.__param||function(he,e){return function(u,L){e(u,L,he)}};define(ke[108],Ee([1,0,8,22,3,5]),function(he,e,u,L,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vv=e.$Uv=e.$Tv=e.$Sv=e.$Rv=e.$Qv=e.ProgressLocation=e.$Pv=void 0,e.$Pv=(0,P.$ii)("progressService");var R;(function(I){I[I.Explorer=1]="Explorer",I[I.Scm=3]="Scm",I[I.Extensions=5]="Extensions",I[I.Window=10]="Window",I[I.Notification=15]="Notification",I[I.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$Qv=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(p){this.b=p}report(p){this.a=p,this.b(this.a)}}e.$Rv=b;class ${get value(){return this.a}constructor(p){this.e=p}report(p){this.b?this.b.push(p):this.b=[p],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const p=this.b.shift();this.a=p,await this.e(this.a)}}finally{this.c=!1;const p=this.d;this.d=void 0,p?.()}}drain(){return this.c?new Promise(p=>{const E=this.d;this.d=()=>{E?.(),p()}}):Promise.resolve()}}e.$Sv=$;let y=class extends M.$Uc{constructor(p,E){super(),this.a=new u.$Fh,E.withProgress(p,v=>(this.b=v,this.c&&v.report(this.c),this.a.p)),this.B((0,M.$Sc)(()=>this.a.complete()))}report(p){this.b?this.b.report(p):this.c=p}};e.$Tv=y,e.$Tv=y=Je([qe(1,e.$Pv)],y);class A extends M.$Uc{constructor(p){super(),this.g=p,this.a=0,this.b=this.B(new M.$Tc)}start(p){this.stop();const E=++this.a,v=new L.$ee;return this.f=setTimeout(()=>{E===this.a&&(this.c=this.g.show(!0))},p),this.b.add((0,M.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,M.$Sc)(()=>v.cancel())),this.b.add((0,M.$Sc)(()=>this.c?this.c.done():void 0)),{id:E,token:v.token,stop:()=>this.h(E),isCurrent:()=>this.a===E}}stop(){this.h(this.a)}h(p){this.a===p&&this.b.clear()}}e.$Uv=A,e.$Vv=(0,P.$ii)("editorProgressService")}),define(ke[37],Ee([1,0,61,18]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=void 0;class M{constructor(){this.a=new Map}add(R,b){u.ok(L.$Vf(R)),u.ok(L.$Xf(b)),u.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,b)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$1n=new M}),define(ke[109],Ee([1,0,4,37]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=void 0,e.$2n={JSONContribution:"base.contributions.json"};function M(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class P{constructor(){this.b=new u.$7d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,y){this.a[M($)]=y,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const R=new P;L.$1n.add(e.$2n.JSONContribution,R)}),define(ke[85],Ee([1,0,19,4,18,202,53,109,37]),function(he,e,u,L,M,P,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.ConfigurationScope=e.$6n=e.EditPresentationTypes=void 0,e.$eo=a,e.$fo=m,e.$go=o,e.$ho=i,e.$io=r;var y;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(y||(e.EditPresentationTypes=y={})),e.$6n={Configuration:"base.contributions.configuration"};var A;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n={properties:{},patternProperties:{}},e.$$n={properties:{},patternProperties:{}},e.$_n={properties:{},patternProperties:{}},e.$ao="vscode://schemas/settings/resourceLanguage",e.$bo="vscode://schemas/settings/configurationDefaults";const I=$.$1n.as(b.$2n.JSONContribution);class p{constructor(){this.h=new Set,this.i=new L.$7d,this.onDidSchemaChange=this.i.event,this.j=new L.$7d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$ao,this.g),this.v()}registerConfiguration(t,f=!0){this.registerConfigurations([t],f)}registerConfigurations(t,f=!0){const d=new Set;this.n(t,f,d),I.registerSchema(e.$ao,this.g),this.i.fire(),this.j.fire({properties:d})}deregisterConfigurations(t){const f=new Set;this.o(t,f),I.registerSchema(e.$ao,this.g),this.i.fire(),this.j.fire({properties:f})}updateConfigurations({add:t,remove:f}){const d=new Set;this.o(f,d),this.n(t,!1,d),I.registerSchema(e.$ao,this.g),this.i.fire(),this.j.fire({properties:d})}registerDefaultConfigurations(t){const f=new Set;this.k(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}k(t,f){const d=[];for(const{overrides:l,source:c}of t)for(const h in l)if(f.add(h),e.$do.test(h)){const g=this.a.get(h),S=g?.valuesSources??new Map;if(c)for(const D of Object.keys(l[h]))S.set(D,c);const w={...g?.value||{},...l[h]};this.a.set(h,{source:c,value:w,valuesSources:S});const C=(0,R.$Yi)(h),k={type:"object",default:w,description:P.localize(1,null,C),$ref:e.$ao,defaultDefaultValue:w,source:M.$Vf(c)?void 0:c,defaultValueSource:c};d.push(...a(h)),this.d[h]=k,this.b.properties[h]=k}else{this.a.set(h,{value:l[h],source:c});const g=this.d[h];g&&(this.w(h,g),this.r(h,g))}this.m(d)}deregisterDefaultConfigurations(t){const f=new Set;this.l(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}l(t,f){for(const{overrides:d,source:l}of t)for(const c in d){const h=this.a.get(c),g=M.$Vf(l)?l:l?.id,S=M.$Vf(h?.source)?h?.source:h?.source?.id;if(g===S)if(f.add(c),this.a.delete(c),e.$do.test(c))delete this.d[c],delete this.b.properties[c];else{const w=this.d[c];w&&(this.w(c,w),this.r(c,w))}}this.u()}deltaConfiguration(t){let f=!1;const d=new Set;t.removedDefaults&&(this.l(t.removedDefaults,d),f=!0),t.addedDefaults&&(this.k(t.addedDefaults,d),f=!0),t.removedConfigurations&&this.o(t.removedConfigurations,d),t.addedConfigurations&&this.n(t.addedConfigurations,!1,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:f})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const f of t)this.h.add(f);this.u()}n(t,f,d){t.forEach(l=>{this.p(l,f,l.extensionInfo,l.restrictedProperties,void 0,d),this.c.push(l),this.q(l)})}o(t,f){const d=l=>{if(l.properties)for(const c in l.properties){f.add(c);const h=this.d[c];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[c],this.s(c,l.properties[c])}l.allOf?.forEach(c=>d(c))};for(const l of t){d(l);const c=this.c.indexOf(l);c!==-1&&this.c.splice(c,1)}}p(t,f=!0,d,l,c=3,h){c=M.$5f(t.scope)?c:t.scope;const g=t.properties;if(g)for(const w in g){const C=g[w];if(f&&i(w,C)){delete g[w];continue}if(C.source=d,C.defaultDefaultValue=g[w].default,this.w(w,C),e.$do.test(w)?C.scope=void 0:(C.scope=M.$5f(C.scope)?c:C.scope,C.restricted=M.$5f(C.restricted)?!!l?.includes(w):C.restricted),g[w].hasOwnProperty("included")&&!g[w].included){this.f[w]=g[w],delete g[w];continue}else this.d[w]=g[w],g[w].policy?.name&&this.e.set(g[w].policy.name,w);!g[w].deprecationMessage&&g[w].markdownDeprecationMessage&&(g[w].deprecationMessage=g[w].markdownDeprecationMessage),h.add(w)}const S=t.allOf;if(S)for(const w of S)this.p(w,f,d,l,c,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const f=d=>{const l=d.properties;if(l)for(const h in l)this.r(h,l[h]);d.allOf?.forEach(f)};f(t)}r(t,f){switch(e.$7n.properties[t]=f,f.scope){case 1:e.$8n.properties[t]=f;break;case 2:e.$9n.properties[t]=f;break;case 6:e.$0n.properties[t]=f;break;case 3:e.$$n.properties[t]=f;break;case 4:e.$_n.properties[t]=f;break;case 5:e.$_n.properties[t]=f,this.g.properties[t]=f;break}}s(t,f){switch(delete e.$7n.properties[t],f.scope){case 1:delete e.$8n.properties[t];break;case 2:delete e.$9n.properties[t];break;case 6:delete e.$0n.properties[t];break;case 3:delete e.$$n.properties[t];break;case 4:case 5:delete e.$_n.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const f=`[${t}]`,d={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.$ao};this.w(f,d),e.$7n.properties[f]=d,e.$8n.properties[f]=d,e.$9n.properties[f]=d,e.$0n.properties[f]=d,e.$$n.properties[f]=d,e.$_n.properties[f]=d}}v(){const t={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.$ao};e.$7n.patternProperties[e.$co]=t,e.$8n.patternProperties[e.$co]=t,e.$9n.patternProperties[e.$co]=t,e.$0n.patternProperties[e.$co]=t,e.$$n.patternProperties[e.$co]=t,e.$_n.patternProperties[e.$co]=t,this.i.fire()}w(t,f){const d=this.a.get(t);let l=d?.value,c=d?.source;M.$3f(l)&&(l=f.defaultDefaultValue,c=void 0),M.$3f(l)&&(l=o(f.type)),f.default=l,f.defaultValueSource=c}}const E="\\[([^\\]]+)\\]",v=new RegExp(E,"g");e.$co=`^(${E})+$`,e.$do=new RegExp(e.$co);function a(s){const t=[];if(e.$do.test(s)){let f=v.exec(s);for(;f?.length;){const d=f[1].trim();d&&t.push(d),f=v.exec(s)}}return(0,u.$Mb)(t)}function m(s){return s.reduce((t,f)=>`${t}[${f}]`,"")}function o(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new p;$.$1n.add(e.$6n.Configuration,n);function i(s,t){return s.trim()?e.$do.test(s)?P.localize(7,null,s):n.getConfigurationProperties()[s]!==void 0?P.localize(8,null,s):t.policy?.name&&n.getPolicyConfigurations().get(t.policy?.name)!==void 0?P.localize(9,null,s,t.policy?.name,n.getPolicyConfigurations().get(t.policy?.name)):null:P.localize(6,null)}function r(){const s=[],t=n.getConfigurationProperties();for(const f of Object.keys(t))s.push([f,t[f].scope]);return s.push(["launch",4]),s.push(["task",4]),s}}),define(ke[263],Ee([1,0,19,4,163,3,27,24,18,2,53,85,37]),function(he,e,u,L,M,P,R,b,$,y,A,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$mo=e.$lo=e.$ko=e.$jo=void 0,e.$no=i;function E(f){return Object.isFrozen(f)?f:b.$Pn(f)}class v{constructor(d={},l=[],c=[],h){this.b=d,this.c=l,this.d=c,this.raw=h,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const d=this.raw.map(l=>{if(l instanceof v)return l;const c=new a("");return c.parseRaw(l),c.configurationModel});this.f=d.reduce((l,c)=>c===l?c:l.merge(c),d[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(d){return d?(0,A.$Wi)(this.contents,d):this.contents}inspect(d,l){const c=this;return{get value(){return E(c.rawConfiguration.getValue(d))},get override(){return l?E(c.rawConfiguration.getOverrideValue(d,l)):void 0},get merged(){return E(l?c.rawConfiguration.override(l).getValue(d):c.rawConfiguration.getValue(d))},get overrides(){const h=[];for(const{contents:g,identifiers:S,keys:w}of c.rawConfiguration.overrides){const C=new v(g,w).getValue(d);C!==void 0&&h.push({identifiers:S,value:C})}return h.length?E(h):void 0}}}getOverrideValue(d,l){const c=this.i(l);return c?d?(0,A.$Wi)(c,d):c:void 0}getKeysForOverrideIdentifier(d){const l=[];for(const c of this.overrides)c.identifiers.includes(d)&&l.push(...c.keys);return u.$Mb(l)}getAllOverrideIdentifiers(){const d=[];for(const l of this.overrides)d.push(...l.identifiers);return u.$Mb(d)}override(d){let l=this.a.get(d);return l||(l=this.g(d),this.a.set(d,l)),l}merge(...d){const l=b.$On(this.contents),c=b.$On(this.overrides),h=[...this.keys],g=this.raw?.length?[...this.raw]:[this];for(const S of d)if(g.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.h(l,S.contents);for(const w of S.overrides){const[C]=c.filter(k=>u.$ub(k.identifiers,w.identifiers));C?(this.h(C.contents,w.contents),C.keys.push(...w.keys),C.keys=u.$Mb(C.keys)):c.push(b.$On(w))}for(const w of S.keys)h.indexOf(w)===-1&&h.push(w)}return new v(l,h,c,g.every(S=>S instanceof v)?void 0:g)}g(d){const l=this.i(d);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const c={};for(const h of u.$Mb([...Object.keys(this.contents),...Object.keys(l)])){let g=this.contents[h];const S=l[h];S&&(typeof g=="object"&&typeof S=="object"?(g=b.$On(g),this.h(g,S)):g=S),c[h]=g}return new v(c,this.keys,this.overrides)}h(d,l){for(const c of Object.keys(l)){if(c in d&&$.$Xf(d[c])&&$.$Xf(l[c])){this.h(d[c],l[c]);continue}d[c]=b.$On(l[c])}}i(d){let l=null,c=null;const h=g=>{g&&(c?this.h(c,g):c=b.$On(g))};for(const g of this.overrides)g.identifiers.length===1&&g.identifiers[0]===d?l=g.contents:g.identifiers.includes(d)&&h(g.contents);return h(l),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(d,l){this.j(d,l,!0)}setValue(d,l){this.j(d,l,!1)}removeValue(d){const l=this.keys.indexOf(d);l!==-1&&(this.keys.splice(l,1),(0,A.$Vi)(this.contents,d),I.$do.test(d)&&this.overrides.splice(this.overrides.findIndex(c=>u.$ub(c.identifiers,(0,I.$eo)(d))),1))}j(d,l,c){(0,A.$Ui)(this.contents,d,l,h=>console.error(h)),c=c||this.keys.indexOf(d)===-1,c&&this.keys.push(d),I.$do.test(d)&&this.overrides.push({identifiers:(0,I.$eo)(d),keys:Object.keys(this.contents[d]),contents:(0,A.$Ti)(this.contents[d],h=>console.error(h))})}}e.$jo=v;class a{constructor(d){this.f=d,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(d,l){if(!$.$5f(d)){const c=this.g(d);this.parseRaw(c,l)}}reparse(d){this.a&&this.parseRaw(this.a,d)}parseRaw(d,l){this.a=d;const{contents:c,keys:h,overrides:g,restricted:S,hasExcludedProperties:w}=this.h(d,l);this.b=new v(c,h,g,w?[d]:void 0),this.c=S||[]}g(d){let l={},c=null,h=[];const g=[],S=[];function w(k){Array.isArray(h)?h.push(k):c!==null&&(h[c]=k)}const C={onObjectBegin:()=>{const k={};w(k),g.push(h),h=k,c=null},onObjectProperty:k=>{c=k},onObjectEnd:()=>{h=g.pop()},onArrayBegin:()=>{const k=[];w(k),g.push(h),h=k,c=null},onArrayEnd:()=>{h=g.pop()},onLiteralValue:w,onError:(k,D,O)=>{S.push({error:k,offset:D,length:O})}};if(d)try{M.$Cn(d,C),l=h[0]||{}}catch(k){console.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return l}h(d,l){const c=p.$1n.as(I.$6n.Configuration).getConfigurationProperties(),h=this.i(d,c,!0,l);d=h.raw;const g=(0,A.$Ti)(d,C=>console.error(`Conflict in settings file ${this.f}: ${C}`)),S=Object.keys(d),w=this.j(d,C=>console.error(`Conflict in settings file ${this.f}: ${C}`));return{contents:g,keys:S,overrides:w,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}i(d,l,c,h){let g=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:d,restricted:[],hasExcludedProperties:g};const S={},w=[];for(const C in d)if(I.$do.test(C)&&c){const k=this.i(d[C],l,!1,h);S[C]=k.raw,g=g||k.hasExcludedProperties,w.push(...k.restricted)}else{const k=l[C],D=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&w.push(C),!h.exclude?.includes(C)&&(h.include?.includes(C)||(D===void 0||h.scopes===void 0||h.scopes.includes(D))&&!(h.skipRestricted&&k?.restricted))?S[C]=d[C]:g=!0}return{raw:S,restricted:w,hasExcludedProperties:g}}j(d,l){const c=[];for(const h of Object.keys(d))if(I.$do.test(h)){const g={};for(const S in d[h])g[S]=d[h][S];c.push({identifiers:(0,I.$eo)(h),keys:Object.keys(g),contents:(0,A.$Ti)(g,l)})}return c}}e.$ko=a;class m extends P.$Uc{constructor(d,l,c,h){super(),this.c=d,this.f=l,this.g=h,this.b=this.B(new L.$7d),this.onDidChange=this.b.event,this.a=new a(this.c.toString()),this.B(this.g.watch(c.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(L.Event.any(L.Event.filter(this.g.onDidFilesChange,g=>g.contains(this.c)),L.Event.filter(this.g.onDidRunOperation,g=>(g.isOperation(0)||g.isOperation(3)||g.isOperation(1)||g.isOperation(4))&&c.isEqual(g.resource,d)))(()=>this.b.fire()))}async loadConfiguration(){try{const d=await this.g.readFile(this.c);return this.a.parse(d.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new v}}reparse(d){return d&&(this.f=d),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$lo=m;class o{constructor(d,l,c,h,g,S,w,C,k,D,O,F,T){this.a=d,this.b=l,this.c=c,this.overrideIdentifiers=h,this.d=g,this.f=S,this.g=w,this.h=C,this.i=k,this.j=D,this.k=O,this.l=F,this.m=T}get value(){return E(this.c)}n(d){return d?.value!==void 0||d?.override!==void 0||d?.overrides!==void 0?d:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(d,l,c,h,g=new v,S=new v,w=new R.$Bc,C=new v,k=new R.$Bc){this.c=d,this.d=l,this.f=c,this.g=h,this.h=g,this.i=S,this.j=w,this.l=C,this.m=k,this.a=null,this.b=new R.$Bc,this.n=null}getValue(d,l,c){return this.p(d,l,c).getValue(d)}updateValue(d,l,c={}){let h;c.resource?(h=this.m.get(c.resource),h||(h=new v,this.m.set(c.resource,h))):h=this.l,l===void 0?h.removeValue(d):h.setValue(d,l),c.resource||(this.a=null)}inspect(d,l,c){const h=this.p(d,l,c),g=this.t(l.resource,c),S=l.resource?this.m.get(l.resource)||this.l:this.l,w=new Set;for(const C of h.overrides)for(const k of C.identifiers)h.getOverrideValue(d,k)!==void 0&&w.add(k);return new o(d,l,h.getValue(d),w.size?[...w]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,c?this.i:void 0,g||void 0,S)}keys(d){const l=this.t(void 0,d);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:l?l.keys.slice(0):[]}}updateDefaultConfiguration(d){this.c=d,this.a=null,this.b.clear()}updatePolicyConfiguration(d){this.d=d}updateApplicationConfiguration(d){this.f=d,this.a=null,this.b.clear()}updateLocalUserConfiguration(d){this.g=d,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(d){this.h=d,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(d){this.i=d,this.a=null,this.b.clear()}updateFolderConfiguration(d,l){this.j.set(d,l),this.b.delete(d)}deleteFolderConfiguration(d){this.folderConfigurations.delete(d),this.b.delete(d)}compareAndUpdateDefaultConfiguration(d,l){const c=[];if(!l){const{added:h,updated:g,removed:S}=s(this.c,d);l=[...h,...g,...S]}for(const h of l)for(const g of(0,I.$eo)(h)){const S=this.c.getKeysForOverrideIdentifier(g),w=d.getKeysForOverrideIdentifier(g),C=[...w.filter(k=>S.indexOf(k)===-1),...S.filter(k=>w.indexOf(k)===-1),...S.filter(k=>!b.$Sn(this.c.override(g).getValue(k),d.override(g).getValue(k)))];c.push([g,C])}return this.updateDefaultConfiguration(d),{keys:l,overrides:c}}compareAndUpdatePolicyConfiguration(d){const{added:l,updated:c,removed:h}=s(this.d,d),g=[...l,...c,...h];return g.length&&this.updatePolicyConfiguration(d),{keys:g,overrides:[]}}compareAndUpdateApplicationConfiguration(d){const{added:l,updated:c,removed:h,overrides:g}=s(this.applicationConfiguration,d),S=[...l,...c,...h];return S.length&&this.updateApplicationConfiguration(d),{keys:S,overrides:g}}compareAndUpdateLocalUserConfiguration(d){const{added:l,updated:c,removed:h,overrides:g}=s(this.localUserConfiguration,d),S=[...l,...c,...h];return S.length&&this.updateLocalUserConfiguration(d),{keys:S,overrides:g}}compareAndUpdateRemoteUserConfiguration(d){const{added:l,updated:c,removed:h,overrides:g}=s(this.remoteUserConfiguration,d),S=[...l,...c,...h];return S.length&&this.updateRemoteUserConfiguration(d),{keys:S,overrides:g}}compareAndUpdateWorkspaceConfiguration(d){const{added:l,updated:c,removed:h,overrides:g}=s(this.workspaceConfiguration,d),S=[...l,...c,...h];return S.length&&this.updateWorkspaceConfiguration(d),{keys:S,overrides:g}}compareAndUpdateFolderConfiguration(d,l){const c=this.folderConfigurations.get(d),{added:h,updated:g,removed:S,overrides:w}=s(c,l),C=[...h,...g,...S];return(C.length||!c)&&this.updateFolderConfiguration(d,l),{keys:C,overrides:w}}compareAndDeleteFolderConfiguration(d){const l=this.folderConfigurations.get(d);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(d);const{added:c,updated:h,removed:g,overrides:S}=s(l,void 0);return{keys:[...c,...h,...g],overrides:S}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(d,l,c){let h=this.q(l,c);return l.overrideIdentifier&&(h=h.override(l.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(d)!==void 0&&(h=h.merge(this.d)),h}q({resource:d},l){let c=this.r();if(l&&d){const h=l.getFolder(d);h&&(c=this.s(h.uri)||c);const g=this.m.get(d);g&&(c=c.merge(g))}return c}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(d){let l=this.b.get(d);if(!l){const c=this.r(),h=this.j.get(d);h?(l=c.merge(h),this.b.set(d,l)):l=c}return l}t(d,l){if(l&&d){const c=l.getFolder(d);if(c)return this.j.get(c.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((d,l)=>{const{contents:c,overrides:h,keys:g}=this.j.get(l);return d.push([l,{contents:c,overrides:h,keys:g}]),d},[])}}allKeys(){const d=new Set;return this.c.keys.forEach(l=>d.add(l)),this.userConfiguration.keys.forEach(l=>d.add(l)),this.i.keys.forEach(l=>d.add(l)),this.j.forEach(l=>l.keys.forEach(c=>d.add(c))),[...d.values()]}u(){const d=new Set;return this.c.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.userConfiguration.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.i.getAllOverrideIdentifiers().forEach(l=>d.add(l)),this.j.forEach(l=>l.getAllOverrideIdentifiers().forEach(c=>d.add(c))),[...d.values()]}v(d){const l=new Set;return this.c.getKeysForOverrideIdentifier(d).forEach(c=>l.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(d).forEach(c=>l.add(c)),this.i.getKeysForOverrideIdentifier(d).forEach(c=>l.add(c)),this.j.forEach(c=>c.getKeysForOverrideIdentifier(d).forEach(h=>l.add(h))),[...l.values()]}static parse(d){const l=this.w(d.defaults),c=this.w(d.policy),h=this.w(d.application),g=this.w(d.user),S=this.w(d.workspace),w=d.folders.reduce((C,k)=>(C.set(y.URI.revive(k[0]),this.w(k[1])),C),new R.$Bc);return new n(l,c,h,g,new v,S,w,new v,new R.$Bc)}static w(d){return new v(d.contents,d.keys,d.overrides)}}e.$mo=n;function i(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const d=new Set,l=new Map;for(const h of f)h.keys.forEach(g=>d.add(g)),h.overrides.forEach(([g,S])=>{const w=(0,R.$yc)(l,g,new Set);S.forEach(C=>w.add(C))});const c=[];return l.forEach((h,g)=>c.push([g,[...h.values()]])),{keys:[...d.values()],overrides:c}}class r{constructor(d,l,c,h){this.change=d,this.f=l,this.g=c,this.h=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const g of d.keys)this.affectedKeys.add(g);for(const[,g]of d.overrides)for(const S of g)this.affectedKeys.add(S);this.d=this.a;for(const g of this.affectedKeys)this.d+=g+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(d,l){const c=this.a+d,h=this.d.indexOf(c);if(h<0)return!1;const g=h+c.length;if(g>=this.d.length)return!1;const S=this.d.charCodeAt(g);if(S!==this.b&&S!==this.c)return!1;if(l){const w=this.previousConfiguration?this.previousConfiguration.getValue(d,l,this.f?.workspace):void 0,C=this.g.getValue(d,l,this.h);return!b.$Sn(w,C)}return!0}}e.$oo=r;function s(f,d){const{added:l,removed:c,updated:h}=t(d?.rawConfiguration,f?.rawConfiguration),g=[],S=f?.getAllOverrideIdentifiers()||[],w=d?.getAllOverrideIdentifiers()||[];if(d){const C=w.filter(k=>!S.includes(k));for(const k of C)g.push([k,d.getKeysForOverrideIdentifier(k)])}if(f){const C=S.filter(k=>!w.includes(k));for(const k of C)g.push([k,f.getKeysForOverrideIdentifier(k)])}if(d&&f){for(const C of S)if(w.includes(C)){const k=t({contents:f.getOverrideValue(void 0,C)||{},keys:f.getKeysForOverrideIdentifier(C)},{contents:d.getOverrideValue(void 0,C)||{},keys:d.getKeysForOverrideIdentifier(C)});g.push([C,[...k.added,...k.removed,...k.updated]])}}return{added:l,removed:c,updated:h,overrides:g}}function t(f,d){const l=f?d?f.keys.filter(g=>d.keys.indexOf(g)===-1):[...f.keys]:[],c=d?f?d.keys.filter(g=>f.keys.indexOf(g)===-1):[...d.keys]:[],h=[];if(f&&d){for(const g of d.keys)if(f.keys.indexOf(g)!==-1){const S=(0,A.$Wi)(d.contents,g),w=(0,A.$Wi)(f.contents,g);b.$Sn(S,w)||h.push(g)}}return{added:l,removed:c,updated:h}}}),define(ke[264],Ee([1,0,21,4,3,82]),function(he,e,u,L,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kub=e.$iub=e.$hub=void 0,e.$jub=b;const R=(y,A,I)=>{const p=new Uint8Array(16);for(let a=0;a<16;a++)p[a]=Math.round(Math.random()*256);const E=(0,u.$Oe)(u.$ue.wrap(p));return[`GET ws://localhost${y}?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${E}`].join(`\r
`)+`\r
\r
`};e.$hub=R,e.$iub=u.$ue.fromString(`\r
\r
`);async function b(y,A,I,p,E){y.write(u.$ue.fromString((0,e.$hub)(A,I,p)));const v=new M.$Tc;try{return await new Promise((a,m)=>{let o;v.add(y.onData(n=>{o?o=u.$ue.concat([o,n],o.byteLength+n.byteLength):o=n;const i=o.indexOf(e.$iub);if(i===-1)return;a(y),y.pauseData();const r=o.slice(i+e.$iub.byteLength);r.byteLength&&E.onData.fire(r)})),v.add(y.onClose(n=>m(n??new Error("socket closed")))),v.add(y.onEnd(()=>m(new Error("socket ended"))))})}catch(a){throw y.dispose(),a}finally{v.dispose()}}class $ extends M.$Uc{constructor(A,I){super(),this.g=A,this.a=this.B(new L.$0d),this.onData=(...p)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...p)),this.b=this.B(new L.$7d),this.onDidDispose=this.b.event,this.f=!1,this.B(I.onData),this.B(I.onData.event(p=>this.a.fire(p))),this.onClose=this.B(I.onClose).event,this.onEnd=this.B(I.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(A,I){P.SocketDiagnostics.traceSocketEvent(this,this.g,A,I)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$kub=$}),define(ke[65],Ee([1,0,13,5]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=e.RemoteAuthorityResolverErrorCode=e.$vl=e.$ul=e.RemoteConnectionType=e.$tl=void 0,e.$xl=y,e.$tl=(0,L.$ii)("remoteAuthorityResolverService");var M;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(M||(e.RemoteConnectionType=M={}));class P{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.$ul=P;class R{constructor(I,p){this.host=I,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$vl=R;var b;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class $ extends u.$bb{static isNotAvailable(I){return I instanceof $&&I._code===b.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof $&&I._code===b.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof $&&I._code===b.NoResolverFound}static isInvalidAuthority(I){return I instanceof $&&I._code===b.InvalidAuthority}static isHandled(I){return I instanceof $&&I.isHandled}constructor(I,p=b.Unknown,E){super(I),this._message=I,this._code=p,this._detail=E,this.isHandled=p===b.NotAvailable&&E===!0,Object.setPrototypeOf(this,$.prototype)}}e.$wl=$;function y(A){const I=A.indexOf("+");return I===-1?A:A.substring(0,I)}}),define(ke[265],Ee([1,0,8,21,22,13,4,3,15,58,39,30,82,65]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Cl=S,e.$Dl=w,e.$El=k;const v=30*1e3;var a;(function(ee){ee[ee.Management=1]="Management",ee[ee.ExtensionHost=2]="ExtensionHost",ee[ee.Tunnel=3]="Tunnel"})(a||(e.ConnectionType=a={}));function m(ee){switch(ee){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(ee){const U=new M.$ee;return setTimeout(()=>U.cancel(),ee),U.token}function n(ee,U){if(ee.isCancellationRequested||U.isCancellationRequested)return M.CancellationToken.Cancelled;const ie=new M.$ee;return ee.onCancellationRequested(()=>ie.cancel()),U.onCancellationRequested(()=>ie.cancel()),ie.token}class i{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new b.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,u.$bh)(),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function r(ee,U){const ie=new i(U);return ie.registerDisposable(ee.onControlMessage(be=>{const Se=JSON.parse(be.toString()),ae=X(Se);ae?ie.reject(ae):ie.resolve(Se)})),ie.promise}function s(ee,U,ie,be,Se,ae,ce,se){const K=new i(se),te=A.$3d.create(!1);return ee.info(`Creating a socket (${ce})...`),y.mark(`code/willCreateSocket/${ae}`),U.connect(ie,be,Se,ce).then(le=>{K.didTimeout?(y.mark(`code/didCreateSocketError/${ae}`),ee.info(`Creating a socket (${ce}) finished after ${te.elapsed()} ms, but this is too late and has timed out already.`),le?.dispose()):(y.mark(`code/didCreateSocketOK/${ae}`),ee.info(`Creating a socket (${ce}) was successful after ${te.elapsed()} ms.`),K.resolve(le))},le=>{y.mark(`code/didCreateSocketError/${ae}`),ee.info(`Creating a socket (${ce}) returned an error after ${te.elapsed()} ms.`),ee.error(le),K.reject(le)}),K.promise}function t(ee,U){const ie=new i(U);return ee.then(be=>{ie.didTimeout||ie.resolve(be)},be=>{ie.didTimeout||ie.reject(be)}),ie.promise}async function f(ee,U,ie,be){const Se=me(ee,U);ee.logService.trace(`${Se} 1/6. invoking socketFactory.connect().`);let ae;try{ae=await s(ee.logService,ee.remoteSocketFactoryService,ee.connectTo,$.$vg.getServerRootPath(),`reconnectionToken=${ee.reconnectionToken}&reconnection=${ee.reconnectionProtocol?"true":"false"}`,m(U),`renderer-${m(U)}-${ee.reconnectionToken}`,be)}catch(le){throw ee.logService.error(`${Se} socketFactory.connect() failed or timed out. Error:`),ee.logService.error(le),le}ee.logService.trace(`${Se} 2/6. socketFactory.connect() was successful.`);let ce,se;ee.reconnectionProtocol?(ee.reconnectionProtocol.beginAcceptReconnection(ae,null),ce=ee.reconnectionProtocol,se=!1):(ce=new p.$9h({socket:ae}),se=!0),ee.logService.trace(`${Se} 3/6. sending AuthRequest control message.`);const K=await t(ee.signService.createNewMessage((0,I.$Eg)()),be),te={type:"auth",auth:ee.connectionToken||"00000000000000000000",data:K.data};ce.sendControl(L.$ue.fromString(JSON.stringify(te)));try{const le=await r(ce,n(be,o(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const Ie=new Error("Unexpected handshake message");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}if(ee.logService.trace(`${Se} 4/6. received SignRequest control message.`),!await t(ee.signService.validate(K,le.signedData),be)){const Ie=new Error("Refused to connect to unsupported server");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}const Ae=await t(ee.signService.sign(le.data),be),$e={type:"connectionType",commit:ee.commit,signedData:Ae,desiredConnectionType:U};return ie&&($e.args=ie),ee.logService.trace(`${Se} 5/6. sending ConnectionTypeRequest control message.`),ce.sendControl(L.$ue.fromString(JSON.stringify($e))),{protocol:ce,ownsProtocol:se}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(ee.logService.error(`${Se} the handshake timed out. Error:`),ee.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(ee.logService.error(`${Se} received error control message when negotiating connection. Error:`),ee.logService.error(le)),se&&_(ce),le}}async function d(ee,U,ie,be){const Se=Date.now(),ae=me(ee,U),{protocol:ce,ownsProtocol:se}=await f(ee,U,ie,be),K=new i(be);return K.registerDisposable(ce.onControlMessage(te=>{const le=JSON.parse(te.toString()),de=X(le);de?(ee.logService.error(`${ae} received error control message when negotiating connection. Error:`),ee.logService.error(de),se&&_(ce),K.reject(de)):(ee.reconnectionProtocol?.endAcceptReconnection(),ee.logService.trace(`${ae} 6/6. handshake finished, connection is up and running after ${Ce(Se)}!`),K.resolve({protocol:ce,firstMessage:le}))})),K.promise}async function l(ee,U){const{protocol:ie}=await d(ee,1,void 0,U);return{protocol:ie}}async function c(ee,U,ie){const{protocol:be,firstMessage:Se}=await d(ee,2,U,ie),ae=Se&&Se.debugPort;return{protocol:be,debugPort:ae}}async function h(ee,U,ie){const be=Date.now(),Se=me(ee,3),{protocol:ae}=await f(ee,3,U,ie);return ee.logService.trace(`${Se} 6/6. handshake finished, connection is up and running after ${Ce(be)}!`),ae}async function g(ee,U,ie){const{connectTo:be,connectionToken:Se}=await ee.addressProvider.getAddress();return{commit:ee.commit,quality:ee.quality,connectTo:be,connectionToken:Se,reconnectionToken:U,reconnectionProtocol:ie,remoteSocketFactoryService:ee.remoteSocketFactoryService,signService:ee.signService,logService:ee.logService}}async function S(ee,U,ie){return C(ee,async be=>{const{protocol:Se}=await l(be,M.CancellationToken.None);return new W(ee,U,ie,be.reconnectionToken,Se)})}async function w(ee,U){return C(ee,async ie=>{const{protocol:be,debugPort:Se}=await c(ie,U,M.CancellationToken.None);return new Z(ee,U,ie.reconnectionToken,be,Se)})}async function C(ee,U){for(let be=1;;be++)try{const Se=(0,I.$Eg)(),ae=await g(ee,Se,null);return await U(ae)}catch(Se){if(be<5)ee.logService.error(`[remote-connection][attempt ${be}] An error occurred in initial connection! Will retry... Error:`),ee.logService.error(Se);else throw ee.logService.error(`[remote-connection][attempt ${be}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),ee.logService.error(Se),B.triggerPermanentFailure(0,0,E.$wl.isHandled(Se)),Se}}async function k(ee,U,ie){const be=await g(ee,(0,I.$Eg)(),null);return await h(be,{host:U,port:ie},M.CancellationToken.None)}function D(ee){return(0,u.$8g)(U=>new Promise((ie,be)=>{const Se=setTimeout(ie,ee*1e3);U.onCancellationRequested(()=>{clearTimeout(Se),ie()})}))}var O;(function(ee){ee[ee.ConnectionLost=0]="ConnectionLost",ee[ee.ReconnectionWait=1]="ReconnectionWait",ee[ee.ReconnectionRunning=2]="ReconnectionRunning",ee[ee.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",ee[ee.ConnectionGain=4]="ConnectionGain"})(O||(e.PersistentConnectionEventType=O={}));class F{constructor(U,ie){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.type=0}}e.$Fl=F;class T{constructor(U,ie,be,Se){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.durationSeconds=be,this.c=Se,this.type=1}skipWait(){this.c.cancel()}}e.$Gl=T;class z{constructor(U,ie,be){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.attempt=be,this.type=2}}e.$Hl=z;class j{constructor(U,ie,be){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.attempt=be,this.type=4}}e.$Il=j;class N{constructor(U,ie,be,Se){this.reconnectionToken=U,this.millisSinceLastIncomingData=ie,this.attempt=be,this.handled=Se,this.type=3}}e.$Jl=N;class B extends b.$Uc{static triggerPermanentFailure(U,ie,be){this._permanentFailure=!0,this.f=U,this.g=ie,this.h=be,this.j.forEach(Se=>Se.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||B._permanentFailure}constructor(U,ie,be,Se,ae){super(),this.t=U,this.u=ie,this.reconnectionToken=be,this.protocol=Se,this.w=ae,this.m=this.B(new R.$7d),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new j(this.reconnectionToken,0,0)),this.B(Se.onSocketClose(ce=>{const se=Y(this.t,this.reconnectionToken,!0);ce?ce.type===0?(this.u.logService.info(`${se} received socket close event (hadError: ${ce.hadError}).`),ce.error&&this.u.logService.error(ce.error)):(this.u.logService.info(`${se} received socket close event (wasClean: ${ce.wasClean}, code: ${ce.code}, reason: ${ce.reason}).`),ce.event&&this.u.logService.error(ce.event)):this.u.logService.info(`${se} received socket close event.`),this.y()})),this.B(Se.onSocketTimeout(ce=>{const se=Y(this.t,this.reconnectionToken,!0);this.u.logService.info(`${se} received socket timeout event (unacknowledgedMsgCount: ${ce.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ce.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ce.timeSinceLastReceivedSomeData}).`),this.y()})),B.j.push(this),this.B((0,b.$Sc)(()=>{const ce=B.j.indexOf(this);ce>=0&&B.j.splice(ce,1)})),this.n&&this.D(B.f,B.g,B.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=Y(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ie=[0,5,5,10,10,10,10,10,30];let be=-1;do{be++;const Se=be<ie.length?ie[be]:ie[ie.length-1];try{if(Se>0){const ce=D(Se);this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Se,ce)),this.u.logService.info(`${U} waiting for ${Se} seconds before reconnecting...`);try{await ce}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),be+1)),this.u.logService.info(`${U} resolving connection...`);const ae=await g(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${ae.connectTo}...`),await this.G(ae,o(v)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),be+1));break}catch(ae){if(ae.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ae),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}if(be>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ae),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}if(E.$wl.isTemporarilyNotAvailable(ae)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ae);continue}if((ae.code==="ETIMEDOUT"||ae.code==="ENETUNREACH"||ae.code==="ECONNREFUSED"||ae.code==="ECONNRESET")&&ae.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ae);continue}if((0,P.$4)(ae)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ae);continue}if(ae instanceof E.$wl){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ae),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,E.$wl.isHandled(ae));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ae),this.C(this.protocol.getMillisSinceLastIncomingData(),be+1,!1);break}}while(!this.n&&!this.s)}C(U,ie,be){this.w?B.triggerPermanentFailure(U,ie,be):this.D(U,ie,be)}D(U,ie,be){this.m.fire(new N(this.reconnectionToken,U,ie,be)),_(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Kl=B;class W extends B{constructor(U,ie,be,Se,ae){super(1,U,Se,ae,!0),this.client=this.B(new p.$7h(ae,{remoteAuthority:ie,clientId:be},U.ipcLogger))}async G(U,ie){await l(U,ie)}}e.$Ll=W;class Z extends B{constructor(U,ie,be,Se,ae){super(2,U,be,Se,!1),this.H=ie,this.debugPort=ae}async G(U,ie){await c(U,this.H,ie)}}e.$Ml=Z;function _(ee){try{ee.acceptDisconnect();const U=ee.getSocket();ee.dispose(),U.dispose()}catch(U){(0,P.$1)(U)}}function X(ee){if(ee&&ee.type==="error"){const U=new Error(`Connection error: ${ee.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function x(ee,U){for(;ee.length<U;)ee+=" ";return ee}function re(ee,U){return`[remote-connection][${x(m(ee),13)}][${U.substr(0,5)}\u2026]`}function Y(ee,U,ie){return`${re(ee,U)}[${ie?"reconnect":"initial"}]`}function me(ee,U){return`${Y(U,ee.reconnectionToken,!!ee.reconnectionProtocol)}[${ee.connectTo}]`}function Ce(ee){return`${Date.now()-ee} ms`}}),define(ke[86],Ee([1,0,15]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=L,e.$um=M,e.$vm=P,e.$wm=R;function L($){return $.scheme===u.Schemas.vscodeRemote?$.authority:void 0}function M($){if(!$)return;const y=$.indexOf("+");return y<0?$:$.substr(0,y)}function P($){const{host:y,port:A}=b($);if(typeof A>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:y,port:A}}function R($,y){let{host:A,port:I}=b($);return typeof I>"u"&&(I=y),{host:A,port:I}}function b($){const y=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(y)return{host:y[1],port:parseInt(y[2],10)};const A=$.match(/^(\[[0-9a-z:]+\])$/);if(A)return{host:A[1],port:void 0};const I=$.match(/(.*):(\d+)$/);return I?{host:I[1],port:parseInt(I[2],10)}:{host:$,port:void 0}}}),define(ke[25],Ee([1,0,14,5,86]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Km=e.$Fm=e.$Em=e.$Dm=e.TargetPlatform=e.ExtensionType=e.$Cm=e.$Am=e.$zm=e.$ym=e.$xm=void 0,e.$Bm=P,e.$Gm=I,e.$Hm=p,e.$Im=E,e.$Jm=v,e.$xm="extensions.user.cache",e.$ym="extensions.builtin.cache",e.$zm="undefined_publisher",e.$Am=["ui","workspace","web"];function P(a){if(typeof a=="object"&&a!==null&&a.supported!==!0)return a.description}e.$Cm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var R;(function(a){a[a.System=0]="System",a[a.User=1]="User"})(R||(e.ExtensionType=R={}));var b;(function(a){a.WIN32_X64="win32-x64",a.WIN32_ARM64="win32-arm64",a.LINUX_X64="linux-x64",a.LINUX_ARM64="linux-arm64",a.LINUX_ARMHF="linux-armhf",a.ALPINE_X64="alpine-x64",a.ALPINE_ARM64="alpine-arm64",a.DARWIN_X64="darwin-x64",a.DARWIN_ARM64="darwin-arm64",a.WEB="web",a.UNIVERSAL="universal",a.UNKNOWN="unknown",a.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class ${constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,o){if(typeof m>"u"||m===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof m=="string"||typeof o=="string"){const n=typeof m=="string"?m:m.value,i=typeof o=="string"?o:o.value;return u.$lf(n,i)}return m._lower===o._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$Dm=$;class y{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const o of m)this.add(o)}add(m){this.c.add($.toKey(m))}delete(m){return this.c.delete($.toKey(m))}has(m){return this.c.has($.toKey(m))}}e.$Em=y;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete($.toKey(m))}get(m){return this.c.get($.toKey(m))}has(m){return this.c.has($.toKey(m))}set(m,o){this.c.set($.toKey(m),o)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Fm=A;function I(a){return p(a)}function p(a){return a.contributes&&a.contributes.localizations?a.contributes.localizations.length>0:!1}function E(a){return a.contributes&&a.contributes.authentication?a.contributes.authentication.length>0:!1}function v(a,m){if(m){const o=`onResolveRemoteAuthority:${(0,M.$um)(m)}`;return!!a.activationEvents?.includes(o)}return!1}e.$Km=(0,L.$ii)("IBuiltinExtensionsScannerService")}),define(ke[140],Ee([1,0,13,25]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OF=e.$NF=void 0;class M{constructor(){this.a=new Map,this.b=new WeakMap}register(R,b){this.a.set(R,b)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const b=Object.create(null);for(const $ of R){const y=this.readActivationEvents($);y.length>0&&(b[L.$Dm.toKey($.identifier)]=y)}return b}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const b=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let $=0;$<b.length;$++)b[$]==="onUri"&&(b[$]=`onUri:${L.$Dm.toKey(R.identifier)}`);if(!R.contributes)return b;for(const $ in R.contributes){const y=this.a.get($);if(!y)continue;const A=R.contributes[$],I=Array.isArray(A)?A:[A];try{y(I,b)}catch(p){(0,u.$1)(p)}}return b}}e.$NF=M,e.$OF=new M}),define(ke[266],Ee([1,0,3,5]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zl=e.$yl=void 0,e.$yl=(0,L.$ii)("remoteSocketFactoryService");class M{constructor(){this.a={}}register(R,b){return this.a[R]??=[],this.a[R].push(b),(0,u.$Sc)(()=>{const $=this.a[R]?.indexOf(b);typeof $=="number"&&$>=0&&this.a[R]?.splice($,1)})}b(R){return(this.a[R.type]||[]).find($=>$.supports(R))}connect(R,b,$,y){const A=this.b(R);if(!A)throw new Error(`No socket factory found for ${R}`);return A.connect(R,b,$,y)}}e.$zl=M}),define(ke[267],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W9b=void 0;class u{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(M){try{const P=await this.c();if(P){const R=String(u.a++);return this.b.set(R,P),{id:R,data:P.createNewMessage(M)}}}catch{}return{id:"",data:M}}async validate(M,P){if(!M.id)return!0;const R=this.b.get(M.id);if(!R)return!1;this.b.delete(M.id);try{return R.validate(P)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(M){try{return await this.d(M)}catch{}return M}}e.$W9b=u}),define(ke[110],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bl=e.$Al=void 0,e.$Al="signService",e.$Bl=(0,u.$ii)(e.$Al)}),define(ke[141],Ee([1,0,267]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sbc=void 0;class L extends u.$W9b{c(){return this.h().then(P=>new P.validator)}d(P){return this.h().then(R=>new R.signer().sign(P))}h(){return new Promise((P,R)=>he(["vsda"],P,R))}}e.$Sbc=L}),define(ke[268],Ee([1,0,11,50,30]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=R,e.$3o=b;function P($){if(u.$u===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function R($,y,A,I,p,E,v,a,m){const o=Object.create(null);o["common.machineId"]=E,o["common.sqmId"]=v,o.sessionID=(0,M.$Eg)()+Date.now(),o.commitHash=I,o.version=p,o["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,u.$h)(u.$u),o["common.nodePlatform"]=L.$ec,o["common.nodeArch"]=A,o["common.product"]=m||"desktop",a&&(o["common.msftInternal"]=a);let n=0;const i=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-i,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),u.$l&&(o["common.snap"]="true");const r=P(y);return r&&(o["common.platformDetail"]=r),o}function b($){const y=L.env.USERDNSDOMAIN;if(!y)return!1;const A=y.toLowerCase();return $.some(I=>A===I)}}),define(ke[269],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=e.$Ol=e.$Nl=void 0,e.$Nl=(0,u.$ii)("telemetryService"),e.$Ol=(0,u.$ii)("customEndpointTelemetryService"),e.$Pl="telemetry.currentSessionDate",e.$Ql="telemetry.firstSessionDate",e.$Rl="telemetry.lastSessionDate",e.$Sl="telemetry.machineId",e.$Tl="telemetry.sqmId",e.$Ul="telemetry",e.$Vl="telemetry.telemetryLevel",e.$Wl="telemetry.enableCrashReporter",e.$Xl="telemetry.enableTelemetry";var L;(function(P){P[P.NONE=0]="NONE",P[P.CRASH=1]="CRASH",P[P.ERROR=2]="ERROR",P[P.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var M;(function(P){P.OFF="off",P.CRASH="crash",P.ERROR="error",P.ON="all"})(M||(e.TelemetryConfiguration=M={}))}),define(ke[87],Ee([1,0,24,18,86,268,269]),function(he,e,u,L,M,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=void 0,e.$$o=A,e.$_o=I,e.$ap=p,e.$bp=E,e.$cp=a,e.$dp=o,e.$ep=n,e.$fp=s;class b{constructor(f){this.value=f,this.isTrustedTelemetryValue=!0}}e.$4o=b;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$5o=$,e.$6o=new $;class y{async publicLog(f,d,l){}async publicLogError(f,d,l){}}e.$7o=y,e.$8o="telemetry",e.$9o="extensionTelemetryLog",e.$0o={log:()=>null,flush:()=>Promise.resolve(null)};function A(t,f){return!f.isBuilt&&!f.disableTelemetry?!0:!(f.disableTelemetry||!t.enableTelemetry)}function I(t,f){return f.extensionTestsLocationURI?!0:!(f.isBuilt||f.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function p(t){const f=t.getValue(R.$Vl),d=t.getValue(R.$Wl);if(t.getValue(R.$Xl)===!1||d===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function E(t){const f={},d={},l={};m(t,l);for(let c in l){c=c.length>150?c.substr(c.length-149):c;const h=l[c];typeof h=="number"?d[c]=h:typeof h=="boolean"?d[c]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${c} has been trimmed to 8192, the original length is ${h.length}`),f[c]=h.substring(0,8191)):typeof h<"u"&&h!==null&&(f[c]=h)}return{properties:f,measurements:d}}const v=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(t){if(!t)return"none";const f=(0,M.$um)(t);return v.has(f)?f:"other"}function m(t,f,d=0,l){if(t)for(const c of Object.getOwnPropertyNames(t)){const h=t[c],g=l?l+c:c;Array.isArray(h)?f[g]=(0,u.$Tn)(h):h instanceof Date?f[g]=h.toISOString():(0,L.$Xf)(h)?d<2?m(h,f,d+1,g+"."):f[g]=(0,u.$Tn)(h):f[g]=h}}function o(t,f){const d=t.msftInternalDomains||[],l=f.getValue("telemetry.internalTesting");return(0,P.$3o)(d)||l}function n(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,f){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let d=t;const l=[];for(const S of f)for(;;){const w=S.exec(t);if(!w)break;l.push([w.index,S.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let g=0;for(d="";;){const S=h.exec(t);if(!S)break;const w=l.some(([C,k])=>S.index<k&&C<h.lastIndex);!c.test(S[0])&&!w&&(d+=t.substring(g,S.index)+"<REDACTED: user-file-path>",g=h.lastIndex)}return g<t.length&&(d+=t.substr(g)),d}function r(t){if(!t)return t;const f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of f)if(d.regex.test(t))return`<REDACTED: ${d.label}>`;return t}function s(t,f){return(0,u.$Qn)(t,d=>{if(d instanceof b||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let l=d.replaceAll("%20"," ");l=i(l,f);for(const c of f)l=l.replace(c,"");return l=r(l),l}})}}),define(ke[270],Ee([1,0,14,137,25,11,2,13,50,87]),function(he,e,u,L,M,P,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$hp=void 0,e.$gp=A,e.$ip=v,e.$jp=a,e.$kp=m,e.$lp=o,e.$mp=n,e.$np=i,e.$op=r,e.$qp=s,e.$rp=f;function A(d,l){return d.uuid&&l.uuid?d.uuid===l.uuid:d.id===l.id?!0:(0,u.$gf)(d.id,l.id)===0}const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(l){const c=l.manifest?l.manifest.version:l.version,h=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new p(l.identifier,c,h)}static parse(l){const c=I.exec(l);return c&&c[1]&&c[2]?new p({id:c[1]},c[2],c[4]||void 0):null}constructor(l,c,h="undefined"){this.version=c,this.targetPlatform=h,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof p?A(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.$hp=p;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(d){const l=E.exec(d);return l&&l[1]?[m(l[1]),l[2]]:[m(d),void 0]}function a(d,l){return`${d}.${l}`}function m(d){return d.toLowerCase()}function o(d,l){return m(a(d??M.$zm,l))}function n(d,l){const c=[],h=g=>{for(const S of c)if(S.some(w=>A(l(w),l(g))))return S;return null};for(const g of d){const S=h(g);S?S.push(g):c.push([g])}return c}function i(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}function r(d){return{id:new y.$4o(d.identifier.id),name:new y.$4o(d.name),galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$pp=new M.$Dm("pprice.better-merge");function s(d,l){const c=[],h=l.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const g=h.shift();if(g&&c.every(S=>!A(S.identifier,{id:g}))){const S=d.filter(w=>A(w.identifier,{id:g}));S.length===1&&(c.push(S[0]),h.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}async function t(d,l){if(!P.$k)return!1;let c;try{c=(await d.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await d.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(g){l.debug("Error while getting the os-release file.",(0,b.$0)(g))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function f(d,l){const c=await t(d,l),h=(0,L.$No)(c?"alpine":P.$u,$.$fc);return l.debug("ComputeTargetPlatform:",h),h}}),define(ke[271],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7r=u,e.$8r=L,e.$9r=M,e.$0r=P,e.$$r=R,e.$_r=b;function u($){return[...$.entries()]}function L($){return $?[...$.entries()]:[]}function M($){return new Map($)}function P($){return new Map($??[])}function R($){return Array.from($.entries()).map(y=>[y[0],u(y[1].map),L(y[1].descriptionMap)])}function b($){return new Map($.map(y=>[y[0],{map:M(y[1]),descriptionMap:P(y[2])}]))}}),define(ke[272],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cub=void 0;class u{constructor(M){this.b=M,this.a=new Map}dispose(){for(const M of this.a.values())M.dispose()}startBuffering(M,P,R=5){const b=P($=>{const y=typeof $=="string"?$:$.data;let A=this.a.get(M);if(A){A.data.push(y);return}const I=setTimeout(()=>this.flushBuffer(M),R);A={data:[y],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(M),b.dispose()}},this.a.set(M,A)});return b}stopBuffering(M){this.a.get(M)?.dispose()}flushBuffer(M){const P=this.a.get(M);P&&(this.a.delete(M),this.b(M,P.data.join("")))}}e.$Cub=u}),define(ke[273],Ee([1,0,8,78,99,56,4,18,2,214,109,37]),function(he,e,u,L,M,P,R,b,$,y,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2w=e.$1w=e.$Zw=e.$Yw=e.$Xw=e.$Ww=e.IconFontDefinition=e.IconContribution=e.$Tw=void 0,e.$Uw=m,e.$Vw=o,e.$Tw={IconContribution:"base.contributions.icons"};var p;(function(s){function t(f,d){let l=f.defaults;for(;P.ThemeIcon.isThemeIcon(l);){const c=a.getIcon(l.id);if(!c)return;l=c.defaults}return l}s.getDefinition=t})(p||(e.IconContribution=p={}));var E;(function(s){function t(d){return{weight:d.weight,style:d.style,src:d.src.map(l=>({format:l.format,location:l.location.toString()}))}}s.toJSONObject=t;function f(d){const l=c=>(0,b.$Vf)(c)?c:void 0;if(d&&Array.isArray(d.src)&&d.src.every(c=>(0,b.$Vf)(c.format)&&(0,b.$Vf)(c.location)))return{weight:l(d.weight),style:l(d.style),src:d.src.map(c=>({format:c.format,location:$.URI.parse(c.location)}))}}s.fromJSONObject=f})(E||(e.IconFontDefinition=E={}));class v{constructor(){this.a=new R.$7d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${P.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,f,d,l){const c=this.b[t];if(c){if(d&&!c.description){c.description=d,this.d.properties[t].markdownDescription=`${d} $(${t})`;const S=this.e.enum.indexOf(t);S!==-1&&(this.e.enumDescriptions[S]=d),this.a.fire()}return c}const h={id:t,description:d,defaults:f,deprecationMessage:l};this.b[t]=h;const g={$ref:"#/definitions/icons"};return l&&(g.deprecationMessage=l),d&&(g.markdownDescription=`${d}: $(${t})`),this.d.properties[t]=g,this.e.enum.push(t),this.e.enumDescriptions.push(d||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const f=this.e.enum.indexOf(t);f!==-1&&(this.e.enum.splice(f,1),this.e.enumDescriptions.splice(f,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,f){const d=this.f[t];return d||(this.f[t]=f,this.a.fire(),f)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(c,h)=>c.id.localeCompare(h.id),f=c=>{for(;P.ThemeIcon.isThemeIcon(c.defaults);)c=this.b[c.defaults.id];return`codicon codicon-${c?c.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.b).map(c=>this.b[c]);for(const c of l.filter(h=>!!h.description).sort(t))d.push(`|<i class="${f(c)}"></i>|${c.id}|${P.ThemeIcon.isThemeIcon(c.defaults)?c.defaults.id:c.id}|${c.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const c of l.filter(h=>!P.ThemeIcon.isThemeIcon(h.defaults)).sort(t))d.push(`|<i class="${f(c)}"></i>|${c.id}|`);return d.join(`
`)}}const a=new v;I.$1n.add(e.$Tw.IconContribution,a);function m(s,t,f,d){return a.registerIcon(s,t,f,d)}function o(){return a}function n(){const s=(0,M.$Dj)();for(const t in s){const f="\\"+s[t].toString(16);a.registerIcon(t,{fontCharacter:f})}}n(),e.$Ww="vscode://schemas/icons";const i=I.$1n.as(A.$2n.JSONContribution);i.registerSchema(e.$Ww,a.getIconSchema());const r=new u.$uh(()=>i.notifySchemaChanged(e.$Ww),200);a.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.$Xw=m("widget-close",L.$Hj.close,(0,y.localize)(2,null)),e.$Yw=m("goto-previous-location",L.$Hj.arrowUp,(0,y.localize)(3,null)),e.$Zw=m("goto-next-location",L.$Hj.arrowDown,(0,y.localize)(4,null)),e.$1w=P.ThemeIcon.modify(L.$Hj.sync,"spin"),e.$2w=P.ThemeIcon.modify(L.$Hj.loading,"spin")}),define(ke[88],Ee([1,0,4,2,53,5,12]),function(he,e,u,L,M,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8v=e.$7v=e.$4v=e.$2v=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Xv=e.$Wv=void 0,e.$Yv=y,e.$Zv=I,e.$1v=p,e.$3v=E,e.$5v=v,e.$6v=a,e.$Wv=(0,P.$ii)("tunnelService"),e.$Xv=(0,P.$ii)("sharedTunnelsService");var b;(function(n){n.Http="http",n.Https="https"})(b||(e.TunnelProtocol=b={}));var $;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})($||(e.TunnelPrivacyId=$={}));function y(n){return!!n.forwardPort}var A;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(A||(e.ProvidedOnAutoForward=A={}));function I(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(i)return{address:i[1],port:+i[2]}}function p(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const i=n.query.split("&");for(const r of i){const s=r.split("=")[1];if(/^https?:/.exec(s)){const t=I(L.URI.parse(s));if(t)return t}}}e.$2v=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(n){return e.$2v.indexOf(n)>=0}e.$4v=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(n){return e.$4v.indexOf(n)>=0}function a(n,i,r,s){if(r===1)return!1;if(r===2&&v(i)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(s);if(t?.length===4&&parseInt(t[1])>=18)return!1}return n<1024}class m{constructor(i,r,s){this.remoteAddress=i,this.localAddress=r,this.b=s,this.a=new u.$7d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$7v=m;let o=class{constructor(i,r){this.k=i,this.l=r,this.a=new u.$7d,this.onTunnelOpened=this.a.event,this.b=new u.$7d,this.onTunnelClosed=this.b.event,this.c=new u.$7d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],r=Array.from(this.e.values());for(const s of r){const t=Array.from(s.values());for(const f of t){const d=await f.value;d&&typeof d!="string"&&i.push(d)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:r}of i.values())await r.then(s=>typeof s!="string"?s?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,r,s,t,f){this.q(i,r,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:r,localAddress:s,privacy:t,protocol:f,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,r){(v(i)||E(i))&&(i=e.$2v[0]);const s=this.s(i,r);if(s)return++s.refcount,s.value}openTunnel(i,r,s,t,f,d=!1,l,c){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${s} on local port ${f}.`);const h=this.f??i;if(!h)return;if(r||(r="localhost"),t||(t=this.m),this.f&&this.j.has(s)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const g=this.t(h,r,s,t,f,d,l,c);return g?g.then(S=>{if(S){if(typeof S=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(r,s),S}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(r,s);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const w=this.o(S);return(S.tunnelRemoteHost!==r||S.tunnelRemotePort!==s)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),l&&S.privacy!==l&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(w),w}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),g)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const r=this.e.get(i.tunnelRemoteHost);if(r){const s=r.get(i.tunnelRemotePort);s&&(s.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,s))}}}}async p(i,r,s){if(s.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${r}.`);const t=s.value.then(async f=>{f&&typeof f!="string"&&(await f.dispose(!0),this.b.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(r),t}}async closeTunnel(i,r){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${r} `);const s=this.e.get(i);if(s&&s.has(r)){const t=s.get(r);t.refcount=0,await this.p(i,r,t)}}q(i,r,s){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(r,{refcount:1,value:s})}async r(i,r){const s=this.e.get(i);if(s){const t=s.get(r),f=t?await t.value:void 0;(!f||typeof f=="string")&&s.delete(r),s.size===0&&this.e.delete(i)}}s(i,r){const s=[i];E(i)?(s.push(...e.$2v),s.push(...e.$4v)):v(i)&&s.push(...e.$4v);const t=s.map(f=>this.e.get(f));for(const f of t){const d=f?.get(r);if(d)return d}}canTunnel(i){return!!I(i)}u(i,r,s,t,f,d,l){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${s} on local port ${t}.`);const c=s;this.j.add(c);const h=t===void 0?s:t,g={elevationRequired:f?this.isPortPrivileged(h):!1},S={remoteAddress:{host:r,port:s},localAddressPort:t,privacy:d,public:d?d!==$.Private:void 0,protocol:l},w=i.forwardPort(S,g);return w?(this.q(r,s,w),w.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(c)})):this.j.delete(c),w}};e.$8v=o,e.$8v=o=Je([qe(0,R.$Oj),qe(1,M.$Oi)],o)}),define(ke[274],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ml=void 0,e.$ml=(0,u.$ii)("IUriIdentityService")}),define(ke[275],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$9v=void 0,e.$9v=(0,u.$ii)("editSessionIdentityService");var L;(function(M){M[M.Complete=100]="Complete",M[M.Partial=50]="Partial",M[M.None=0]="None"})(L||(e.EditSessionIdentityMatch=L={}))}),define(ke[276],Ee([1,0,15]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UL=L,e.$VL=M,e.$WL=P,e.$XL=R,e.$YL=b;function L($){return $.scheme!==u.Schemas.file&&$.scheme!==u.Schemas.vscodeRemote}function M($){if($.folders.length)return $.folders.every(y=>L(y.uri))?$.folders[0].uri:void 0;if($.configuration&&L($.configuration))return $.configuration}function P($){return M($)?.scheme}function R($){return M($)?.authority}function b($){return M($)!==void 0}}),define(ke[42],Ee([1,0,216,17,77,23,2,5,15]),function(he,e,u,L,M,P,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Ci=e.$Bi=e.WorkbenchState=e.$vi=e.$ui=e.$ri=void 0,e.$si=y,e.$ti=A,e.$wi=I,e.$xi=p,e.$yi=E,e.$zi=a,e.$Ai=m,e.$Di=i,e.$Ii=r,e.$Ji=s,e.$Li=t,e.$Mi=f,e.$Ni=d,e.$ri=(0,b.$ii)("contextService");function y(l){const c=l;return typeof c?.id=="string"&&R.URI.isUri(c.uri)}function A(l){return typeof l?.id=="string"&&!y(l)&&!p(l)}e.$ui={id:"ext-dev"},e.$vi={id:"empty-window"};function I(l,c){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,L.$oc)(l)}:c?e.$ui:e.$vi;const h=l;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}function p(l){const c=l;return typeof c?.id=="string"&&R.URI.isUri(c.configPath)}function E(l){const c=l;if(c?.uri)return{id:c.id,uri:R.URI.revive(c.uri)};const h=l;if(h?.configPath)return{id:h.id,configPath:R.URI.revive(h.configPath)};if(l?.id)return{id:l.id}}var v;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function a(l){const c=l;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}function m(l){const c=l;return!!(c&&typeof c=="object"&&R.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}class o{constructor(c,h,g,S,w){this.h=c,this.j=g,this.k=S,this.l=w,this.c=M.$oi.forUris(this.l,()=>!0),this.folders=h}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=M.$oi.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Bi=o;class n{constructor(c,h){this.raw=h,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,P.$Vg)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ci=n;function i(l){return new n({uri:l,index:0,name:(0,P.$Rg)(l)},{uri:l.toString()})}e.$Ei="code-workspace",e.$Fi=`.${e.$Ei}`,e.$Gi=[{name:(0,u.localize)(0,null),extensions:[e.$Ei]}],e.$Hi="workspace.json";function r(l,c){return P.$Mg.isEqualOrParent(l,c.untitledWorkspacesHome)}function s(l){let c;return R.URI.isUri(l)?c=l:c=l.configuration,c?.scheme===$.Schemas.tmp}e.$Ki="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(l){return l.id===e.$Ki}function f(l,c){return!r(l,c)&&!s(l)}function d(l){return(typeof l=="string"?(0,L.$pc)(l):(0,P.$Tg)(l))===e.$Fi}}),define(ke[277],Ee([1,0,55,4,3,23,2,215,136,32,5,12,42,27,274,8,30,14,18]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v,a,m,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$rl=e.$ol=e.ProfileResourceType=void 0,e.$nl=r,e.$pl=s,e.$ql=t;var i;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function r(l){const c=l;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&typeof c.isDefault=="boolean"&&typeof c.name=="string"&&R.URI.isUri(c.location)&&R.URI.isUri(c.globalStorageHome)&&R.URI.isUri(c.settingsResource)&&R.URI.isUri(c.keybindingsResource)&&R.URI.isUri(c.tasksResource)&&R.URI.isUri(c.snippetsHome)&&R.URI.isUri(c.extensionsResource))}e.$ol=(0,A.$ii)("IUserDataProfilesService");function s(l,c){return{id:l.id,isDefault:l.isDefault,name:l.name,shortName:l.shortName,icon:l.icon,location:R.URI.revive(l.location).with({scheme:c}),globalStorageHome:R.URI.revive(l.globalStorageHome).with({scheme:c}),settingsResource:R.URI.revive(l.settingsResource).with({scheme:c}),keybindingsResource:R.URI.revive(l.keybindingsResource).with({scheme:c}),tasksResource:R.URI.revive(l.tasksResource).with({scheme:c}),snippetsHome:R.URI.revive(l.snippetsHome).with({scheme:c}),extensionsResource:R.URI.revive(l.extensionsResource).with({scheme:c}),cacheHome:R.URI.revive(l.cacheHome).with({scheme:c}),useDefaultFlags:l.useDefaultFlags,isTransient:l.isTransient}}function t(l,c,h,g,S,w){return{id:l,name:c,location:h,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:w&&S?.useDefaultFlags?.globalState?w.globalStorageHome:(0,P.$Vg)(h,"globalStorage"),settingsResource:w&&S?.useDefaultFlags?.settings?w.settingsResource:(0,P.$Vg)(h,"settings.json"),keybindingsResource:w&&S?.useDefaultFlags?.keybindings?w.keybindingsResource:(0,P.$Vg)(h,"keybindings.json"),tasksResource:w&&S?.useDefaultFlags?.tasks?w.tasksResource:(0,P.$Vg)(h,"tasks.json"),snippetsHome:w&&S?.useDefaultFlags?.snippets?w.snippetsHome:(0,P.$Vg)(h,"snippets"),extensionsResource:w&&S?.useDefaultFlags?.extensions?w.extensionsResource:(0,P.$Vg)(h,"extensions.json"),cacheHome:(0,P.$Vg)(g,l),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}let f=class extends M.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(c,h,g,S){super(),this.t=c,this.u=h,this.w=g,this.y=S,this.f=!0,this.h=this.B(new L.$7d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new L.$7d),this.onWillCreateProfile=this.j.event,this.m=this.B(new L.$7d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new L.$7d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new E.$Bc,emptyWindows:new Map},this.profilesHome=(0,P.$Vg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,P.$Vg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(c){this.f!==c&&(this.z=void 0,this.f=c)}isEnabled(){return this.f}get C(){if(!this.z){const c=this.D(),h=[c];if(this.f)try{for(const w of this.O()){if(!w.name||!(0,n.$Vf)(w.name)||!w.location){this.y.warn("Skipping the invalid stored profile",w.location||w.name);continue}h.push(t((0,P.$Sg)(w.location),w.name,w.location,this.g,{shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags},c))}}catch(w){this.y.error(w)}const g=new E.$Bc,S=new Map;if(h.length)try{const w=this.Q();if(w.workspaces)for(const[C,k]of Object.entries(w.workspaces)){const D=R.URI.parse(C),O=h.find(F=>F.id===k);O&&g.set(D,O)}if(w.emptyWindows)for(const[C,k]of Object.entries(w.emptyWindows)){const D=h.find(O=>O.id===k);D&&S.set(C,D)}}catch(w){this.y.error(w)}this.z={profiles:h,workspaces:g,emptyWindows:S}}return this.z}D(){const c=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...c,extensionsResource:this.S()??c.extensionsResource,isDefault:!0}}async createTransientProfile(c){const h="Temp",g=new RegExp(`${(0,o.$Ze)(h)}\\s(\\d+)`);let S=0;for(const C of this.profiles){const k=g.exec(C.name),D=k?parseInt(k[1]):0;S=D>S?D:S}const w=`${h} ${S+1}`;return this.createProfile((0,u.$9i)((0,m.$Eg)()).toString(16),w,{transient:!0},c)}async createNamedProfile(c,h,g){return this.createProfile((0,u.$9i)((0,m.$Eg)()).toString(16),c,h,g)}async createProfile(c,h,g,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const w=await this.F(c,h,g);return S&&await this.setProfileForWorkspace(S,w),w}async F(c,h,g){if(!(0,n.$Vf)(h)||!h)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(h);return S||(S=(async()=>{try{const w=this.profiles.find(D=>D.name===h||D.id===c);if(w)return w;const C=t(c,h,(0,P.$Vg)(this.profilesHome,c),this.g,g,this.defaultProfile);await this.u.createFolder(C.location);const k=[];return this.j.fire({profile:C,join(D){k.push(D)}}),await a.Promises.settled(k),this.I([C],[],[]),C}finally{this.r.delete(h)}})(),this.r.set(h,S)),S}async updateProfile(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let g=this.profiles.find(S=>S.id===c.id);if(!g)throw new Error(`Profile '${c.name}' does not exist`);return g=t(g.id,h.name??g.name,g.location,this.g,{shortName:h.shortName??g.shortName,icon:h.icon===null?void 0:h.icon??g.icon,transient:h.transient??g.isTransient,useDefaultFlags:h.useDefaultFlags??g.useDefaultFlags},this.defaultProfile),this.I([],[],[g]),g}async removeProfile(c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(c.isDefault)throw new Error("Cannot remove default profile");const h=this.profiles.find(S=>S.id===c.id);if(!h)throw new Error(`Profile '${c.name}' does not exist`);const g=[];this.m.fire({profile:h,join(S){g.push(S)}});try{await Promise.allSettled(g)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])h.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])h.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[h],[]);try{await this.u.del(h.cacheHome,{recursive:!0})}catch(S){(0,y.$6k)(S)!==1&&this.y.error(S)}}async setProfileForWorkspace(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const g=this.profiles.find(S=>S.id===h.id);if(!g)throw new Error(`Profile '${h.name}' does not exist`);this.L(c,g)}unsetWorkspace(c,h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(c,void 0,h)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const c=await this.u.resolve(this.profilesHome);await Promise.all((c.children||[]).filter(h=>h.isDirectory&&this.profiles.every(g=>!this.w.extUri.isEqual(g.location,h.resource))).map(h=>this.u.del(h.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const c=this.s.profiles.filter(h=>!this.H(h));await Promise.allSettled(c.map(h=>this.removeProfile(h)))}getProfileForWorkspace(c){const h=this.G(c);return R.URI.isUri(h)?this.s.workspaces.get(h)??this.C.workspaces.get(h):this.s.emptyWindows.get(h)??this.C.emptyWindows.get(h)}G(c){return(0,p.$si)(c)?c.uri:(0,p.$xi)(c)?c.configPath:c.id}H(c){return!!([...this.s.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.s.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.C.emptyWindows.values()].some(h=>this.w.extUri.isEqual(h.location,c.location))||[...this.C.workspaces.values()].some(h=>this.w.extUri.isEqual(h.location,c.location)))}I(c,h,g){const S=[...this.profiles,...c],w=[];this.s.profiles=[];for(let C of S)C.isDefault||h.some(k=>C.id===k.id)||(C=g.find(k=>C.id===k.id)??C,C.isTransient?this.s.profiles.push(C):w.push({location:C.location,name:C.name,shortName:C.shortName,icon:C.icon,useDefaultFlags:C.useDefaultFlags}));this.P(w),this.z=void 0,this.J(c,h,g)}J(c,h,g){this.h.fire({added:c,removed:h,updated:g,all:this.profiles})}L(c,h,g){g=h?.isTransient?!0:g,g||this.L(c,void 0,!0);const S=this.G(c),w=g?this.s:this.C;R.URI.isUri(S)?(w.workspaces.delete(S),h&&w.workspaces.set(S,h)):(w.emptyWindows.delete(S),h&&w.emptyWindows.set(S,h)),g||this.M()}M(){const c={};for(const[g,S]of this.C.workspaces.entries())c[g.toString()]=S.id;const h={};for(const[g,S]of this.C.emptyWindows.entries())h[g.toString()]=S.id;this.R({workspaces:c,emptyWindows:h}),this.z=void 0}N(c){const h={},g=this.D();if(c.workspaces)for(const[w,C]of Object.entries(c.workspaces)){const k=R.URI.parse(C);h[w]=this.w.extUri.isEqual(k,g.location)?g.id:this.w.extUri.basename(k)}const S={};if(c.emptyWindows)for(const[w,C]of Object.entries(c.emptyWindows)){const k=R.URI.parse(C);S[w]=this.w.extUri.isEqual(k,g.location)?g.id:this.w.extUri.basename(k)}return{workspaces:h,emptyWindows:S}}O(){return[]}P(c){throw new Error("not implemented")}Q(){return{}}R(c){throw new Error("not implemented")}S(){}};e.$rl=f,e.$rl=f=Je([qe(0,$.$pi),qe(1,y.$Ok),qe(2,v.$ml),qe(3,I.$Oj)],f);class d extends f{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(c){this.a=c}Q(){return this.X}R(c){this.X=c}}e.$sl=d}),define(ke[278],Ee([1,0,8,4,3,58,18,194,5,277]),function(he,e,u,L,M,P,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=e.$Op=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Mp=e.$Lp=e.$Kp=void 0,e.$Np=E,e.$Pp=a,e.$Rp=o,e.$Kp="__$__isNewStorageMarker",e.$Lp="__$__targetStorageMarker",e.$Mp=(0,$.$ii)("storageService");var A;(function(n){n[n.NONE=0]="NONE",n[n.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var I;(function(n){n[n.APPLICATION=-1]="APPLICATION",n[n.PROFILE=0]="PROFILE",n[n.WORKSPACE=1]="WORKSPACE"})(I||(e.StorageScope=I={}));var p;(function(n){n[n.USER=0]="USER",n[n.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function E(n){const i=n.get(e.$Lp);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class v extends M.$Uc{static{this.a=60*1e3}constructor(i={flushInterval:v.a}){super(),this.m=i,this.b=this.B(new L.$0d),this.c=this.B(new L.$0d),this.onDidChangeTarget=this.c.event,this.f=this.B(new L.$7d),this.onWillSaveState=this.f.event,this.h=this.B(new u.$uh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new M.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,r,s){return L.Event.filter(this.b.event,t=>t.scope===i&&(r===void 0||t.key===r),s)}n(){this.j.value=(0,u.$yh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,M.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,P.mark)("code/willInitStorage");try{await this.O()}finally{(0,P.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,r){const{key:s,external:t}=r;if(s===e.$Lp){switch(i){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:s,target:this.J(i)[s],external:t})}w(i){this.f.fire({reason:i})}get(i,r,s){return this.P(r)?.get(i,s)}getBoolean(i,r,s){return this.P(r)?.getBoolean(i,s)}getNumber(i,r,s){return this.P(r)?.getNumber(i,s)}getObject(i,r,s){return this.P(r)?.getObject(i,s)}storeAll(i,r){this.y(()=>{for(const s of i)this.store(s.key,s.value,s.scope,s.target,r)})}store(i,r,s,t,f=!1){if((0,R.$5f)(r)){this.remove(i,s,f);return}this.y(()=>{this.z(i,s,t),this.P(s)?.set(i,r,f)})}remove(i,r,s=!1){this.y(()=>{this.z(i,r,void 0),this.P(r)?.delete(i,s)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,r){const s=[],t=this.J(i);for(const f of Object.keys(t))t[f]===r&&s.push(f);return s}z(i,r,s,t=!1){const f=this.J(r);typeof s=="number"?f[i]!==s&&(f[i]=s,this.P(r)?.set(e.$Lp,JSON.stringify(f),t)):typeof f[i]=="number"&&(delete f[i],this.P(r)?.set(e.$Lp,JSON.stringify(f),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(i){switch(i){case-1:return this.I;case 0:return this.G;default:return this.D}}L(i){const r=this.P(i);return r?E(r):Object.create(null)}isNew(i){return this.getBoolean(e.$Kp,i)===!0}async flush(i=A.NONE){this.f.fire({reason:i});const r=this.P(-1),s=this.P(0),t=this.P(1);switch(i){case A.NONE:await u.Promises.settled([r?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await u.Promises.settled([r?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(-1)?.items??new Map,r=this.P(0)?.items??new Map,s=this.P(1)?.items??new Map;return o(i,r,s,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,r){return this.w(A.NONE),(0,y.$nl)(i)?this.R(i,r):this.S(i,r)}M(i,r){return!(i.id===r.id||a(r)&&a(i))}N(i,r,s){this.y(()=>{const t=new Set;for(const[f,d]of i)t.add(f),r.get(f)!==d&&this.u(s,{key:f,external:!0});for(const[f]of r.items)t.has(f)||this.u(s,{key:f,external:!0})})}}e.$Op=v;function a(n){return n.isDefault||!!n.useDefaultFlags?.globalState}class m extends v{constructor(){super(),this.U=this.B(new b.$Ip(new b.$Jp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$Ip(new b.$Jp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$Ip(new b.$Jp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(1,i))),this.B(this.W.onDidChangeStorage(i=>this.u(0,i))),this.B(this.U.onDidChangeStorage(i=>this.u(-1,i)))}P(i){switch(i){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(i){switch(i){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$Qp=m;async function o(n,i,r,s,t,f){const d=D=>{try{return JSON.parse(D)}catch{return D}},l=new Map,c=new Map;n.forEach((D,O)=>{l.set(O,D),c.set(O,d(D))});const h=new Map,g=new Map;i.forEach((D,O)=>{h.set(O,D),g.set(O,d(D))});const S=new Map,w=new Map;r.forEach((D,O)=>{S.set(O,D),w.set(O,d(D))}),console.group(s!==t?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const C=[];if(l.forEach((D,O)=>{C.push({key:O,value:D})}),console.table(C),console.groupEnd(),console.log(c),s!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const D=[];h.forEach((O,F)=>{D.push({key:F,value:O})}),console.table(D),console.groupEnd(),console.log(g)}console.group(`Storage: Workspace (path: ${f})`);const k=[];S.forEach((D,O)=>{k.push({key:O,value:D})}),console.table(k),console.groupEnd(),console.log(w)}}),define(ke[111],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ic=void 0;class u{static{this.a=!1}constructor(M){this.d=M,this.b=new Map,this.c=1}add(M){const P=this.c++;return this.b.set(P,M),this.e(),P}get(M,P){return this.b.has(M)?this.b.get(M)[P]:void 0}delete(M){this.b.delete(M),this.e()}e(){u.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$1ic=u}),define(ke[59],Ee([1,0,15,23,5]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ic=e.$6ic=void 0;class P{constructor(){this.a=new Set(Object.keys(u.Schemas)),this.b=new Map,this.extUri=new L.$Kg(b=>{const $=this.b.get(b.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(b,$){$===null?this.b.delete(b.scheme):this.b.set(b.scheme,$)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$6ic=P,e.$7ic=(0,M.$ii)("IExtHostFileSystemInfo")}),define(ke[28],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WO=void 0,e.$WO=(0,u.$ii)("IExtHostInitDataService")}),define(ke[279],Ee([1,0,222,12,259,28]),function(he,e,u,L,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$alc=void 0;let R=class extends M.$5P{constructor($,y,A){const I=A.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",p=A.remote.isRemote?(0,u.localize)(0,null):$?(0,u.localize)(1,null):(0,u.localize)(2,null);super(y.createLogger(I,{name:p}))}};e.$alc=R,e.$alc=R=Je([qe(1,L.$Pj),qe(2,P.$WO)],R)}),define(ke[280],Ee([1,0,8]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pjc=e.$Ojc=void 0;class L{constructor(R,b,$){this.h=new Map,this.a=R,this.b=b,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(y=>(this.f=y,this)),this.g=this.c.onDidChangeStorage(y=>{y.shared===this.b&&y.key===this.a&&(this.f=y.value)}),this.i=new u.$uh(()=>{const y=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of y.values())A.complete()}catch(A){for(const I of y.values())I.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,b){let $=this.f[R];return typeof $>"u"&&($=b),$}update(R,b){this.f[R]=b;const $=this.h.get(R);if($!==void 0)return $.p;const y=new u.$Fh;return this.h.set(R,y),this.i.isScheduled()||this.i.schedule(),y.p}dispose(){this.g.dispose()}}e.$Ojc=L;class M extends L{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,b){super(R.identifier.value,!0,b),this.j=R}}e.$Pjc=M}),define(ke[281],Ee([1,0,4,2]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ckc=void 0;class M{constructor(R){this.c=R,this.a=new u.$7d,this.onDidSaveNotebookDocument=this.a.event,this.b=new u.$7d,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,b,$,y){const I=this.c.getNotebookDocument(L.URI.revive(R)).acceptModelChanged(b.value,$,y);this.b.fire(I)}$acceptDirtyStateChanged(R,b){this.c.getNotebookDocument(L.URI.revive(R)).acceptDirty(b)}$acceptModelSaved(R){const b=this.c.getNotebookDocument(L.URI.revive(R));this.a.fire(b.apiNotebook)}}e.$Ckc=M}),define(ke[20],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HO=e.$GO=void 0,e.$GO=(0,u.$ii)("IExtHostRpcService");class L{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.$HO=L}),define(ke[282],Ee([1,0,25,4]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wjc=void 0;class M{#e;constructor(R,b){this.b=new L.$7d,this.onDidChange=this.b.event,this.a=u.$Dm.toKey(R.identifier),this.#e=b,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(R){return this.#e.get(this.a,R)}store(R,b){return this.#e.store(this.a,R,b)}delete(R){return this.#e.delete(this.a,R)}}e.$Wjc=M}),define(ke[66],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$njc=e.$mjc=void 0,e.$mjc=(0,u.$ii)("IURITransformerService");class L{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$njc=L}),define(ke[283],Ee([1,0,21]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vnb=M,e.$Wnb=R;class L{constructor(){this.buffers=[]}add($){let y=this.buffers.indexOf($);return y<0&&(y=this.buffers.length,this.buffers.push($)),y}}function M(b,$){if($.serializeBuffersForPostMessage){const y=new L,I=JSON.stringify(b,(E,v)=>{if(v instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:y.add(v)};if(ArrayBuffer.isView(v)){const a=P(v);if(a)return{$$vscode_array_buffer_reference$$:!0,index:y.add(v.buffer),view:{type:a,byteLength:v.byteLength,byteOffset:v.byteOffset}}}return v}),p=y.buffers.map(E=>{const v=new Uint8Array(E);return u.$ue.wrap(v)});return{message:I,buffers:p}}else return{message:JSON.stringify(b),buffers:[]}}function P(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(b,$){const y=$.map(p=>{const E=new ArrayBuffer(p.byteLength);return new Uint8Array(E).set(p.buffer),E}),A=$.length?(p,E)=>{if(E&&typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const v=E,{index:a}=v,m=y[a];if(v.view)switch(v.view.type){case 1:return new Int8Array(m,v.view.byteOffset,v.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(m,v.view.byteOffset,v.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(m,v.view.byteOffset,v.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(m,v.view.byteOffset,v.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(m,v.view.byteOffset,v.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(m,v.view.byteOffset,v.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(m,v.view.byteOffset,v.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(m,v.view.byteOffset,v.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(m,v.view.byteOffset,v.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(m,v.view.byteOffset,v.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(m,v.view.byteOffset,v.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return m}return E}:void 0;return{message:JSON.parse(b,A),arrayBuffers:y}}}),define(ke[284],Ee([1,0,285,399,400,62,2,12,401]),function(he,e,u,L,M,P,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ilc=A;const y=!1;function A(i,r,s,t,f,d){const l=d.environment.useHostProxy,c=typeof l=="boolean"?l:!d.remote.isRemote,h={resolveProxy:w=>i.resolveProxy(w),lookupProxyAuthorization:m.bind(void 0,t,f,r,{},d.remote.isRemote),getProxyURL:()=>r.getConfiguration("http").get("proxy"),getProxySupport:()=>r.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>p(r),addCertificatesV2:()=>E(r),log:t,getLogLevel:()=>{const w=t.getLevel();switch(w){case b.LogLevel.Trace:return $.LogLevel.Trace;case b.LogLevel.Debug:return $.LogLevel.Debug;case b.LogLevel.Info:return $.LogLevel.Info;case b.LogLevel.Warning:return $.LogLevel.Warning;case b.LogLevel.Error:return $.LogLevel.Error;case b.LogLevel.Off:return $.LogLevel.Off;default:return C(w)}function C(k){return t.error("Unknown log level",k),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:c,loadAdditionalCertificates:async()=>{const w=[];if(d.remote.isRemote&&w.push((0,$.loadSystemCertificates)({log:t})),c){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const C=i.loadCertificates();C.then(k=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",k.length)),w.push(C)}return(await Promise.all(w)).flat()},env:process.env},g=(0,$.createProxyResolver)(h),S=I(h,g);return a(s,S)}function I(i,r){return{http:Object.assign(u,(0,$.createHttpPatch)(i,u,r)),https:Object.assign(L,(0,$.createHttpPatch)(i,L,r)),net:Object.assign(P,(0,$.createNetPatch)(i,P)),tls:Object.assign(M,(0,$.createTlsPatch)(i,M))}}function p(i){const r=i.getConfiguration("http");return!r.get("experimental.systemCertificatesV2",y)&&!!r.get("systemCertificates")}function E(i){const r=i.getConfiguration("http");return!!r.get("experimental.systemCertificatesV2",y)&&!!r.get("systemCertificates")}const v=new Map;function a(i,r){return i.getExtensionPathIndex().then(s=>{const t=globalThis._VSCODE_NODE_MODULES.module,f=t._load;t._load=function(l,c,h){if(l==="net")return r.net;if(l==="tls")return r.tls;if(l!=="http"&&l!=="https")return f.apply(this,arguments);const g=s.findSubstr(R.URI.file(c.filename));let S=v.get(g);if(S||v.set(g,S={}),!S[l]){const w=r[l];S[l]={...w}}return S[l]}})}async function m(i,r,s,t,f,d,l,c){const h=t[d];l&&(t[d]=l),i.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${d}`,`proxyAuthenticate:${l}`,`proxyAuthenticateCache:${h}`);const g=l||h,S=Array.isArray(g)?g:typeof g=="string"?[g]:[];if(n(r,S,f),S.some(w=>/^(Negotiate|Kerberos)( |$)/i.test(w))&&!c.kerberosRequested)try{c.kerberosRequested=!0;const w=await new Promise((F,T)=>{he(["kerberos"],F,T)}),C=new URL(d),k=s.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${C.hostname}`:`HTTP@${C.hostname}`);return i.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${d}`,`spn:${k}`),"Negotiate "+await(await w.initializeClient(k)).step("")}catch(w){i.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",w)}}let o=!1;function n(i,r,s){o||!r.length||(o=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:r.map(t=>t.split(" ")[0]).join(","),extensionHostType:s?"remote":"local"}))}}),define(ke[286],Ee([1,0,133]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=M;function L(P){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:P,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function M(P){return new u.$kn(L(P))}}),define(ke[142],Ee([1,0,232,18,2,3,5,37,32,15,46,186,40]),function(he,e,u,L,M,P,R,b,$,y,A,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$pF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$gF=e.EditorInputCapabilities=e.$fF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$8E=e.$7E=e.$6E=e.$5E=e.$4E=void 0,e.$9E=a,e.$0E=m,e.$$E=o,e.$_E=n,e.$aF=i,e.$bF=r,e.$cF=s,e.$dF=t,e.$eF=f,e.$hF=S,e.$iF=C,e.$jF=k,e.$kF=D,e.$lF=O,e.$mF=F,e.$nF=T,e.$oF=Z,e.$qF=x,e.$rF=Y,e.$sF=me,e.$tF=Ce,e.$4E={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$5E={id:"default",displayName:(0,u.localize)(0,null),providerDisplayName:(0,u.localize)(1,null)},e.$6E="workbench.editor.sidebysideEditor",e.$7E="workbench.editors.textDiffEditor",e.$8E="workbench.editors.binaryResourceDiffEditor";var E;(function(ee){ee[ee.PROGRAMMATIC=1]="PROGRAMMATIC",ee[ee.USER=2]="USER",ee[ee.EDIT=3]="EDIT",ee[ee.NAVIGATION=4]="NAVIGATION",ee[ee.JUMP=5]="JUMP"})(E||(e.EditorPaneSelectionChangeReason=E={}));var v;(function(ee){ee[ee.IDENTICAL=1]="IDENTICAL",ee[ee.SIMILAR=2]="SIMILAR",ee[ee.DIFFERENT=3]="DIFFERENT"})(v||(e.EditorPaneSelectionCompareResult=v={}));function a(ee){const U=ee;return!!U&&typeof U.getSelection=="function"&&!!U.onDidChangeSelection}function m(ee){const U=ee;return!!U&&typeof U.getScrollPosition=="function"&&typeof U.setScrollPosition=="function"&&!!U.onDidChangeScroll}function o(ee,U,ie){for(const be of ie.visibleEditorPanes)if(be.group.id===U&&ee.matches(be.input))return be.getViewState()}function n(ee){if(S(ee))return!1;const U=ee;return M.URI.isUri(U?.resource)}function i(ee){if(S(ee))return!1;const U=ee;return U?.original!==void 0&&U.modified!==void 0}function r(ee){if(S(ee))return!1;const U=ee;return!U||U.resources&&!Array.isArray(U.resources)?!1:!!U.resources||!!U.multiDiffSource}function s(ee){if(S(ee)||i(ee))return!1;const U=ee;return U?.primary!==void 0&&U.secondary!==void 0}function t(ee){if(S(ee))return!1;const U=ee;return U?U.resource===void 0||U.resource.scheme===y.Schemas.untitled||U.forceUntitled===!0:!1}function f(ee){if(S(ee))return!1;const U=ee;return M.URI.isUri(U?.base?.resource)&&M.URI.isUri(U?.input1?.resource)&&M.URI.isUri(U?.input2?.resource)&&M.URI.isUri(U?.result?.resource)}var d;(function(ee){ee[ee.SHORT=0]="SHORT",ee[ee.MEDIUM=1]="MEDIUM",ee[ee.LONG=2]="LONG"})(d||(e.Verbosity=d={}));var l;(function(ee){ee[ee.EXPLICIT=1]="EXPLICIT",ee[ee.AUTO=2]="AUTO",ee[ee.FOCUS_CHANGE=3]="FOCUS_CHANGE",ee[ee.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l||(e.SaveReason=l={}));class c{constructor(){this.a=new Map}registerSource(U,ie){let be=this.a.get(U);return be||(be={source:U,label:ie},this.a.set(U,be)),be.source}getSourceLabel(U){return this.a.get(U)?.label??U}}e.$fF=new c;var h;(function(ee){ee[ee.None=0]="None",ee[ee.Readonly=2]="Readonly",ee[ee.Untitled=4]="Untitled",ee[ee.Singleton=8]="Singleton",ee[ee.RequiresTrust=16]="RequiresTrust",ee[ee.CanSplitInGroup=32]="CanSplitInGroup",ee[ee.ForceDescription=64]="ForceDescription",ee[ee.CanDropIntoEditor=128]="CanDropIntoEditor",ee[ee.MultipleEditors=256]="MultipleEditors",ee[ee.Scratchpad=512]="Scratchpad"})(h||(e.EditorInputCapabilities=h={}));class g extends P.$Uc{}e.$gF=g;function S(ee){return ee instanceof g}function w(ee){const U=ee;return M.URI.isUri(U?.preferredResource)}function C(ee){const U=ee;return S(U?.primary)&&S(U?.secondary)}function k(ee){const U=ee;return S(U?.modified)&&S(U?.original)}function D(ee,U,ie,be,Se){return Ce(be,[(0,I.$5i)({id:"workbench.action.openLargeFile",label:(0,u.localize)(2,null),run:()=>{const ae={...ie,limits:{size:Number.MAX_VALUE}};ee.openEditor(U,ae)}}),(0,I.$5i)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,u.localize)(3,null),run:()=>Se.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:p.default.Warning})}function O(ee){return S(ee?.editor)}function F(ee){const U=ee;return O(ee)&&U?.group!==void 0}function T(ee){const U=ee;return typeof U?.groupId=="number"&&S(U.editor)}var z;(function(ee){ee[ee.UNKNOWN=0]="UNKNOWN",ee[ee.REPLACE=1]="REPLACE",ee[ee.MOVE=2]="MOVE",ee[ee.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var j;(function(ee){ee[ee.GROUP_ACTIVE=0]="GROUP_ACTIVE",ee[ee.GROUP_INDEX=1]="GROUP_INDEX",ee[ee.GROUP_LABEL=2]="GROUP_LABEL",ee[ee.GROUP_LOCKED=3]="GROUP_LOCKED",ee[ee.EDITOR_OPEN=4]="EDITOR_OPEN",ee[ee.EDITOR_CLOSE=5]="EDITOR_CLOSE",ee[ee.EDITOR_MOVE=6]="EDITOR_MOVE",ee[ee.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ee[ee.EDITOR_LABEL=8]="EDITOR_LABEL",ee[ee.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ee[ee.EDITOR_PIN=10]="EDITOR_PIN",ee[ee.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",ee[ee.EDITOR_STICKY=12]="EDITOR_STICKY",ee[ee.EDITOR_DIRTY=13]="EDITOR_DIRTY",ee[ee.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(j||(e.GroupModelChangeKind=j={}));var N;(function(ee){ee[ee.PRIMARY=1]="PRIMARY",ee[ee.SECONDARY=2]="SECONDARY",ee[ee.BOTH=3]="BOTH",ee[ee.ANY=4]="ANY"})(N||(e.SideBySideEditor=N={}));class B{getOriginalUri(U,ie){if(!U)return;if(f(U))return e.$pF.getOriginalUri(U.result,ie);if(ie?.supportSideBySide){const{primary:Se,secondary:ae}=this.a(U);if(Se&&ae){if(ie?.supportSideBySide===N.BOTH)return{primary:this.getOriginalUri(Se,{filterByScheme:ie.filterByScheme}),secondary:this.getOriginalUri(ae,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===N.ANY)return this.getOriginalUri(Se,{filterByScheme:ie.filterByScheme})??this.getOriginalUri(ae,{filterByScheme:ie.filterByScheme});U=ie.supportSideBySide===N.PRIMARY?Se:ae}}if(i(U)||r(U)||s(U)||f(U))return;const be=w(U)?U.preferredResource:U.resource;return!be||!ie||!ie.filterByScheme?be:this.b(be,ie.filterByScheme)}a(U){return C(U)||s(U)?{primary:U.primary,secondary:U.secondary}:k(U)||i(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,ie){if(!U)return;if(f(U))return e.$pF.getCanonicalUri(U.result,ie);if(ie?.supportSideBySide){const{primary:Se,secondary:ae}=this.a(U);if(Se&&ae){if(ie?.supportSideBySide===N.BOTH)return{primary:this.getCanonicalUri(Se,{filterByScheme:ie.filterByScheme}),secondary:this.getCanonicalUri(ae,{filterByScheme:ie.filterByScheme})};if(ie?.supportSideBySide===N.ANY)return this.getCanonicalUri(Se,{filterByScheme:ie.filterByScheme})??this.getCanonicalUri(ae,{filterByScheme:ie.filterByScheme});U=ie.supportSideBySide===N.PRIMARY?Se:ae}}if(i(U)||r(U)||s(U)||f(U))return;const be=U.resource;return!be||!ie||!ie.filterByScheme?be:this.b(be,ie.filterByScheme)}b(U,ie){if(Array.isArray(ie)){if(ie.some(be=>U.scheme===be))return U}else if(ie===U.scheme)return U}}var W;(function(ee){ee[ee.UNKNOWN=0]="UNKNOWN",ee[ee.KEYBOARD=1]="KEYBOARD",ee[ee.MOUSE=2]="MOUSE"})(W||(e.EditorCloseMethod=W={}));function Z(ee,U,ie,be){if(!ee.isSticky(U))return!1;switch(be.preventPinnedEditorClose){case"keyboardAndMouse":return ie===W.MOUSE||ie===W.KEYBOARD;case"mouse":return ie===W.MOUSE;case"keyboard":return ie===W.KEYBOARD}return!1}e.$pF=new B;var _;(function(ee){ee[ee.LEFT=0]="LEFT",ee[ee.RIGHT=1]="RIGHT"})(_||(e.CloseDirection=_={}));class X{constructor(){this.c=new Map,this.d=new Map}start(U){const ie=this.a=U.get(R.$hi);for(const[be,Se]of this.c)this.e(be,Se,ie);this.c.clear()}e(U,ie,be){const Se=be.createInstance(ie);this.d.set(U,Se)}registerFileEditorFactory(U){if(this.b)throw new Error("Can only register one file editor factory.");this.b=U}getFileEditorFactory(){return(0,L.$7f)(this.b)}registerEditorSerializer(U,ie){if(this.c.has(U)||this.d.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.a?this.e(U,ie,this.a):this.c.set(U,ie),(0,P.$Sc)(()=>{this.c.delete(U),this.d.delete(U)})}getEditorSerializer(U){return this.d.get(typeof U=="string"?U:U.typeId)}}b.$1n.add(e.$4E.EditorFactory,new X);async function x(ee,U,ie){return!ee||!ee.length?[]:await Promise.all(ee.map(async be=>{const Se=M.URI.revive(be.fileUri);if(!Se){ie.info("Cannot resolve the path because it is not valid.",be);return}if(!await U.canHandleResource(Se)){ie.info("Cannot resolve the path because it cannot be handled",be);return}let ce=be.exists,se=be.type;if(typeof ce!="boolean"||typeof se!="number")try{se=(await U.stat(Se)).isDirectory?$.FileType.Directory:$.FileType.Unknown,ce=!0}catch(te){ie.error(te),ce=!1}if(!ce&&be.openOnlyIfExists){ie.info("Cannot resolve the path because it does not exist",be);return}if(se===$.FileType.Directory){ie.info("Cannot resolve the path because it is a directory",be);return}const K={...be.options,pinned:!0};return ce?{resource:Se,options:K}:{resource:Se,options:K,forceUntitled:!0}}))}var re;(function(ee){ee[ee.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ee[ee.SEQUENTIAL=1]="SEQUENTIAL"})(re||(e.EditorsOrder=re={}));function Y(ee){const U=ee;if(!U)return!1;const ie=U;if(ie.modified)return Y(ie.modified);const be=U;return!!(be.contributionsState&&be.viewState&&Array.isArray(be.cursorState))}function me(ee){return(0,A.$7i)(ee)}function Ce(ee,U,ie){const be=(0,A.$8i)(ee,U);return be.forceMessage=ie?.forceMessage,be.forceSeverity=ie?.forceSeverity,be.allowDialog=ie?.allowDialog,be}}),define(ke[287],Ee([1,0,4,233,5,3,27,37,19,24,78,273]),function(he,e,u,L,M,P,R,b,$,y,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BF=e.$AF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$zF=e.ViewContentGroups=e.$xF=e.ViewContainerLocation=e.Extensions=e.$wF=e.$vF=e.$uF=void 0,e.$yF=v,e.$uF="views",e.$vF=(0,L.localize)(0,null),e.$wF=(0,I.$Uw)("default-view-icon",A.$Hj.window,(0,L.localize)(1,null));var p;(function(f){f.ViewContainersRegistry="workbench.registry.view.containers",f.ViewsRegistry="workbench.registry.view"})(p||(e.Extensions=p={}));var E;(function(f){f[f.Sidebar=0]="Sidebar",f[f.Panel=1]="Panel",f[f.AuxiliaryBar=2]="AuxiliaryBar"})(E||(e.ViewContainerLocation=E={})),e.$xF=[0,1,2];function v(f){switch(f){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class a extends P.$Uc{constructor(){super(...arguments),this.c=this.B(new u.$7d),this.onDidRegister=this.c.event,this.f=this.B(new u.$7d),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,$.$Rb)([...this.g.values()])}registerViewContainer(d,l,c){const h=this.get(d.id);if(h)return h;const g=d;return g.openCommandActionDescriptor=c?.doNotRegisterOpenCommand?void 0:g.openCommandActionDescriptor??{id:g.id},(0,R.$yc)(this.g,l,[]).push(g),c?.isDefault&&this.h.push(g),this.c.fire({viewContainer:g,viewContainerLocation:l}),g}deregisterViewContainer(d){for(const l of this.g.keys()){const c=this.g.get(l),h=c?.indexOf(d);if(h!==-1){c?.splice(h,1),c.length===0&&this.g.delete(l),this.f.fire({viewContainer:d,viewContainerLocation:l});return}}}get(d){return this.all.filter(l=>l.id===d)[0]}getViewContainers(d){return[...this.g.get(d)||[]]}getViewContainerLocation(d){return[...this.g.keys()].filter(l=>this.getViewContainers(l).filter(c=>c?.id===d.id).length>0)[0]}getDefaultViewContainer(d){return this.h.find(l=>this.getViewContainerLocation(l)===d)}}b.$1n.add(p.ViewContainersRegistry,new a);var m;(function(f){f.Open="2_open",f.Debug="4_debug",f.SCM="5_scm",f.More="9_more"})(m||(e.ViewContentGroups=m={}));function o(f,d){const l=f.group??m.More,c=d.group??m.More;return l!==c?l.localeCompare(c):(f.order??5)-(d.order??5)}class n extends P.$Uc{constructor(){super(...arguments),this.c=this.B(new u.$7d),this.onViewsRegistered=this.c.event,this.f=this.B(new u.$7d),this.onViewsDeregistered=this.f.event,this.g=this.B(new u.$7d),this.onDidChangeContainer=this.g.event,this.h=this.B(new u.$7d),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Hc}registerViews(d,l){this.registerViews2([{views:d,viewContainer:l}])}registerViews2(d){d.forEach(({views:l,viewContainer:c})=>this.r(l,c)),this.c.fire(d)}deregisterViews(d,l){const c=this.s(d,l);c.length&&this.f.fire({views:c,viewContainer:l})}moveViews(d,l){for(const c of this.m.keys())if(c!==l){const h=this.s(d,c);h.length&&(this.r(h,l),this.g.fire({views:h,from:c,to:l}))}}getViews(d){return this.m.get(d)||[]}getView(d){for(const l of this.j){const c=(this.m.get(l)||[]).filter(h=>h.id===d)[0];if(c)return c}return null}getViewContainer(d){for(const l of this.j)if((this.m.get(l)||[]).filter(h=>h.id===d)[0])return l;return null}registerViewWelcomeContent(d,l){return this.n.add(d,l),this.h.fire(d),(0,P.$Sc)(()=>{this.n.delete(d,l),this.h.fire(d)})}registerViewWelcomeContent2(d,l){const c=new Map;for(const[h,g]of l)this.n.add(d,g),c.set(h,(0,P.$Sc)(()=>{this.n.delete(d,g),this.h.fire(d)}));return this.h.fire(d),c}getViewWelcomeContent(d){const l=[];return this.n.forEach(d,c=>l.push(c)),l.sort(o)}r(d,l){let c=this.m.get(l);c||(c=[],this.m.set(l,c),this.j.push(l));for(const h of d){if(this.getView(h.id)!==null)throw new Error((0,L.localize)(2,null,h.id));c.push(h)}}s(d,l){const c=this.m.get(l);if(!c)return[];const h=[],g=[];for(const S of c)d.includes(S)?h.push(S):g.push(S);return h.length&&(g.length?this.m.set(l,g):(this.m.delete(l),this.j.splice(this.j.indexOf(l),1))),h}}b.$1n.add(p.ViewsRegistry,new n),e.$zF=(0,M.$ii)("viewDescriptorService");var i;(function(f){f[f.Default=0]="Default",f[f.Expand=1]="Expand"})(i||(e.ViewVisibilityState=i={}));var r;(function(f){f[f.None=0]="None",f[f.Collapsed=1]="Collapsed",f[f.Expanded=2]="Expanded"})(r||(e.TreeItemCollapsibleState=r={}));class s{constructor(d,l){this.c=!1,this.d=!1,(0,y.$Rn)(this,d),this.d=!!l,this.resolve=async c=>{if(l&&!this.c){const h=await l(c);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}c.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$AF=s;class t extends Error{constructor(d){super((0,L.localize)(3,null,d)),this.name="NoTreeViewError"}static is(d){return d.name==="NoTreeViewError"}}e.$BF=t}),define(ke[288],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FF=void 0,e.$FF=(0,u.$ii)("IChatContributionService")}),define(ke[289],Ee([1,0,19,4,38,3,41,5,288]),function(he,e,u,L,M,P,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CG=e.$BG=e.$AG=e.ChatAgentLocation=void 0;var y;(function(p){p[p.Panel=1]="Panel",p[p.Terminal=2]="Terminal",p[p.Notebook=3]="Notebook"})(y||(e.ChatAgentLocation=y={})),function(p){function E(v){switch(v){case"panel":return p.Panel;case"terminal":return p.Terminal;case"notebook":return p.Notebook}return p.Panel}p.fromRaw=E}(y||(e.ChatAgentLocation=y={})),e.$AG=(0,b.$ii)("chatAgentService");let A=class extends P.$Uc{static{this.AGENT_LEADER="@"}constructor(E,v){super(),this.g=E,this.h=v,this.b=new Map,this.f=this.B(new L.$7d),this.onDidChangeAgents=this.f.event}dispose(){super.dispose(),this.b.clear()}registerAgent(E,v){if(this.b.has(E))throw new Error(`Already registered an agent with id ${E}`);const a=this.getAgent(E);if(!a)throw new Error(`Unknown agent: ${E}`);const m={data:a,impl:v};return this.b.set(E,m),this.f.fire(new I(a,v)),(0,P.$Sc)(()=>{this.b.delete(E)&&this.f.fire(void 0)})}registerDynamicAgent(E,v){const a={data:E,impl:v};return this.b.set(E.id,a),this.f.fire(new I(E,v)),(0,P.$Sc)(()=>{this.b.delete(E.id)&&this.f.fire(void 0)})}updateAgent(E,v){const a=this.b.get(E);if(!a?.impl)throw new Error(`No activated agent with id ${E} registered`);a.data.metadata={...a.data.metadata,...v},this.f.fire(new I(a.data,a.impl))}getDefaultAgent(){return this.getActivatedAgents().find(E=>!!E.isDefault)}getSecondaryAgent(){return M.Iterable.find(this.b.values(),E=>!!E.data.metadata.isSecondary)?.data}getRegisteredAgents(){const E=this;return this.g.registeredParticipants.map(v=>({extensionId:v.extensionId,id:v.name,metadata:{description:v.description},isDefault:v.isDefault,defaultImplicitVariables:v.defaultImplicitVariables,locations:(0,u.$Lb)(v.locations)?v.locations.map(y.fromRaw):[y.Panel],get slashCommands(){return(v.commands??[]).filter(m=>!m.when||E.h.contextMatchesRules(R.$gj.deserialize(m.when)))}}))}getAgents(){const E=this.getRegisteredAgents(),v=Array.from(this.b.values()).map(m=>m.data),a=[...E,...v];return(0,u.$Mb)(a,m=>m.id)}getActivatedAgents(){return Array.from(this.b.values()).filter(E=>!!E.impl).map(E=>new I(E.data,E.impl))}getAgent(E){return this.getAgents().find(v=>v.id===E)}async invokeAgent(E,v,a,m,o){const n=this.b.get(E);if(!n?.impl)throw new Error(`No activated agent with id ${E}`);return await n.impl.invoke(v,a,m,o)}async getFollowups(E,v,a,m,o){const n=this.b.get(E);if(!n?.impl)throw new Error(`No activated agent with id ${E}`);return n.impl?.provideFollowups?n.impl.provideFollowups(v,a,m,o):[]}};e.$BG=A,e.$BG=A=Je([qe(0,$.$FF),qe(1,R.$Aj)],A);class I{constructor(E,v){this.b=E,this.d=v}get id(){return this.b.id}get extensionId(){return this.b.extensionId}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(E,v,a,m){return this.d.invoke(E,v,a,m)}async provideFollowups(E,v,a,m){return this.d.provideFollowups?this.d.provideFollowups(E,v,a,m):[]}provideWelcomeMessage(E){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(E)}provideSampleQuestions(E){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(E)}}e.$CG=I}),define(ke[290],Ee([1,0,2,29,5]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MF=e.$LF=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$JF=P,e.$KF=R;function P(y){return!!y&&typeof y=="object"&&"uri"in y&&y.uri instanceof u.URI&&"version"in y&&typeof y.version=="number"&&"ranges"in y&&Array.isArray(y.ranges)&&y.ranges.every(L.$ct.isIRange)}function R(y){return!!y&&typeof y=="object"&&"documents"in y&&Array.isArray(y.documents)&&y.documents.every(P)}var b;(function(y){y[y.Down=0]="Down",y[y.Up=1]="Up"})(b||(e.InteractiveSessionVoteDirection=b={}));var $;(function(y){y[y.Action=1]="Action",y[y.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$LF=(0,M.$ii)("IChatService"),e.$MF="accessibility.voice.keywordActivation"}),define(ke[143],Ee([1,0,4,8,234]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pob=void 0;class P{constructor(){this.f=new Map,this.m=[],this.n=new u.$7d,this.o=new u.$7d,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(b){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=b}onEvent(b){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=b}onRequest(b){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.u("response",b)}sendRequest(b,$,y,A){const I={command:b};if($&&Object.keys($).length>0&&(I.arguments=$),this.u("request",I),typeof A=="number"){const p=setTimeout(()=>{clearTimeout(p);const E=this.f.get(I.seq);if(E){this.f.delete(I.seq);const v={type:"response",seq:0,request_seq:I.seq,success:!1,command:b,message:(0,M.localize)(0,null,A,b)};E(v)}},A)}return y&&this.f.set(I.seq,y),I.seq}acceptMessage(b){this.k?this.k(b):(this.m.push(b),this.m.length===1&&this.s())}q(b,$){return b.type!=="event"||$.type!=="event"}async s(){let b;for(;this.m.length;){if((!b||this.q(this.m[0],b))&&await(0,L.$jh)(0),b=this.m.shift(),!b)return;switch(b.type){case"event":this.j?.(b);break;case"request":this.g?.(b);break;case"response":{const $=b,y=this.f.get($.request_seq);y&&(this.f.delete($.request_seq),y($));break}}}}u(b,$){$.type=b,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach(($,y)=>b.set(y,$)),await(0,L.$jh)(500),b.forEach(($,y)=>{$({type:"response",seq:0,request_seq:y,success:!1,command:"canceled",message:"canceled"}),this.f.delete(y)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$pob=P}),define(ke[291],Ee([1,0,2,235,41,5]),function(he,e,u,L,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$QI=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$PI=e.MemoryRangeType=e.State=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=void 0,e.$OI=$,e.$DH="workbench.view.debug",e.$EH="workbench.debug.variablesView",e.$FH="workbench.debug.watchExpressionsView",e.$GH="workbench.debug.callStackView",e.$HH="workbench.debug.loadedScriptsView",e.$IH="workbench.debug.breakPointsView",e.$JH="workbench.debug.disassemblyView",e.$KH="workbench.panel.repl",e.$LH="workbench.panel.repl.view",e.$MH=new M.$zj("debugType",void 0,{type:"string",description:L.localize(0,null)}),e.$NH=new M.$zj("debugConfigurationType",void 0,{type:"string",description:L.localize(1,null)}),e.$OH=new M.$zj("debugState","inactive",{type:"string",description:L.localize(2,null)}),e.$PH="debugUx",e.$QH=new M.$zj(e.$PH,"default",{type:"string",description:L.localize(3,null)}),e.$RH=new M.$zj("hasDebugged",!1,{type:"boolean",description:L.localize(4,null)}),e.$SH=new M.$zj("inDebugMode",!1,{type:"boolean",description:L.localize(5,null)}),e.$TH=new M.$zj("inDebugRepl",!1,{type:"boolean",description:L.localize(6,null)}),e.$UH=new M.$zj("breakpointWidgetVisible",!1,{type:"boolean",description:L.localize(7,null)}),e.$VH=new M.$zj("inBreakpointWidget",!1,{type:"boolean",description:L.localize(8,null)}),e.$WH=new M.$zj("breakpointsFocused",!0,{type:"boolean",description:L.localize(9,null)}),e.$XH=new M.$zj("watchExpressionsFocused",!0,{type:"boolean",description:L.localize(10,null)}),e.$YH=new M.$zj("watchExpressionsExist",!1,{type:"boolean",description:L.localize(11,null)}),e.$ZH=new M.$zj("variablesFocused",!0,{type:"boolean",description:L.localize(12,null)}),e.$1H=new M.$zj("expressionSelected",!1,{type:"boolean",description:L.localize(13,null)}),e.$2H=new M.$zj("breakpointInputFocused",!1,{type:"boolean",description:L.localize(14,null)}),e.$3H=new M.$zj("callStackItemType",void 0,{type:"string",description:L.localize(15,null)}),e.$4H=new M.$zj("callStackSessionIsAttach",!1,{type:"boolean",description:L.localize(16,null)}),e.$5H=new M.$zj("callStackItemStopped",!1,{type:"boolean",description:L.localize(17,null)}),e.$6H=new M.$zj("callStackSessionHasOneThread",!1,{type:"boolean",description:L.localize(18,null)}),e.$7H=new M.$zj("watchItemType",void 0,{type:"string",description:L.localize(19,null)}),e.$8H=new M.$zj("canViewMemory",void 0,{type:"boolean",description:L.localize(20,null)}),e.$9H=new M.$zj("breakpointItemType",void 0,{type:"string",description:L.localize(21,null)}),e.$0H=new M.$zj("breakpointItemBytes",void 0,{type:"boolean",description:L.localize(22,null)}),e.$$H=new M.$zj("breakpointHasModes",!1,{type:"boolean",description:L.localize(23,null)}),e.$_H=new M.$zj("breakpointSupportsCondition",!1,{type:"boolean",description:L.localize(24,null)}),e.$aI=new M.$zj("loadedScriptsSupported",!1,{type:"boolean",description:L.localize(25,null)}),e.$bI=new M.$zj("loadedScriptsItemType",void 0,{type:"string",description:L.localize(26,null)}),e.$cI=new M.$zj("focusedSessionIsAttach",!1,{type:"boolean",description:L.localize(27,null)}),e.$dI=new M.$zj("focusedSessionIsNoDebug",!1,{type:"boolean",description:L.localize(28,null)}),e.$eI=new M.$zj("stepBackSupported",!1,{type:"boolean",description:L.localize(29,null)}),e.$fI=new M.$zj("restartFrameSupported",!1,{type:"boolean",description:L.localize(30,null)}),e.$gI=new M.$zj("stackFrameSupportsRestart",!1,{type:"boolean",description:L.localize(31,null)}),e.$hI=new M.$zj("jumpToCursorSupported",!1,{type:"boolean",description:L.localize(32,null)}),e.$iI=new M.$zj("stepIntoTargetsSupported",!1,{type:"boolean",description:L.localize(33,null)}),e.$jI=new M.$zj("breakpointsExist",!1,{type:"boolean",description:L.localize(34,null)}),e.$kI=new M.$zj("debuggersAvailable",!1,{type:"boolean",description:L.localize(35,null)}),e.$lI=new M.$zj("debugExtensionAvailable",!0,{type:"boolean",description:L.localize(36,null)}),e.$mI=new M.$zj("debugProtocolVariableMenuContext",void 0,{type:"string",description:L.localize(37,null)}),e.$nI=new M.$zj("debugSetVariableSupported",!1,{type:"boolean",description:L.localize(38,null)}),e.$oI=new M.$zj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:L.localize(39,null)}),e.$pI=new M.$zj("debugSetExpressionSupported",!1,{type:"boolean",description:L.localize(40,null)}),e.$qI=new M.$zj("breakWhenValueChangesSupported",!1,{type:"boolean",description:L.localize(41,null)}),e.$rI=new M.$zj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:L.localize(42,null)}),e.$sI=new M.$zj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:L.localize(43,null)}),e.$tI=new M.$zj("terminateDebuggeeSupported",!1,{type:"boolean",description:L.localize(44,null)}),e.$uI=new M.$zj("suspendDebuggeeSupported",!1,{type:"boolean",description:L.localize(45,null)}),e.$vI=new M.$zj("variableEvaluateNamePresent",!1,{type:"boolean",description:L.localize(46,null)}),e.$wI=new M.$zj("variableIsReadonly",!1,{type:"boolean",description:L.localize(47,null)}),e.$xI=new M.$zj("variableValue",!1,{type:"string",description:L.localize(48,null)}),e.$yI=new M.$zj("variableType",!1,{type:"string",description:L.localize(49,null)}),e.$zI=new M.$zj("variableName",!1,{type:"string",description:L.localize(50,null)}),e.$AI=new M.$zj("variableLanguage",!1,{type:"string",description:L.localize(51,null)}),e.$BI=new M.$zj("variableExtensionId",!1,{type:"string",description:L.localize(52,null)}),e.$CI=new M.$zj("exceptionWidgetVisible",!1,{type:"boolean",description:L.localize(53,null)}),e.$DI=new M.$zj("multiSessionRepl",!1,{type:"boolean",description:L.localize(54,null)}),e.$EI=new M.$zj("multiSessionDebug",!1,{type:"boolean",description:L.localize(55,null)}),e.$FI=new M.$zj("disassembleRequestSupported",!1,{type:"boolean",description:L.localize(56,null)}),e.$GI=new M.$zj("disassemblyViewFocus",!1,{type:"boolean",description:L.localize(57,null)}),e.$HI=new M.$zj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:L.localize(58,null)}),e.$II=new M.$zj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:L.localize(59,null)});const R=n=>L.localize(60,null,n);e.$JI=R,e.$KI="editor.contrib.debug",e.$LI="editor.contrib.breakpoint",e.$MI="debug",e.$NI={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:L.localize(61,null)};var b;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(b||(e.State=b={}));function $(n){switch(n){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var y;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(y||(e.MemoryRangeType=y={})),e.$PI="vscode-debug-memory";var A;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(A||(e.DataBreakpointSetType=A={}));var I;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(I||(e.DebugConfigurationProviderTriggerKind=I={}));var p;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(p||(e.DebuggerString=p={})),e.$QI=(0,P.$ii)("debugService");var E;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(E||(e.BreakpointWidgetContext=E={}));var v;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(v||(e.DebugVisualizationType=v={}));var a;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(a||(e.DebugTreeItemCollapsibleState=a={}));var m;(function(n){n.deserialize=i=>i,n.serialize=i=>i})(m||(e.IDebugVisualizationTreeItem=m={}));var o;(function(n){n.deserialize=i=>({id:i.id,name:i.name,iconPath:i.iconPath&&{light:u.URI.revive(i.iconPath.light),dark:u.URI.revive(i.iconPath.dark)},iconClass:i.iconClass,visualization:i.visualization}),n.serialize=i=>i})(o||(e.IDebugVisualization=o={}))}),define(ke[292],Ee([1,0,14,2,17,24,15,29,22,19]),function(he,e,u,L,M,P,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RG=void 0,e.$FG=I,e.$GG=p,e.$HG=E,e.$IG=v,e.$JG=a,e.$KG=m,e.$LG=o,e.$MG=i,e.$NG=t,e.$OG=f,e.$PG=l,e.$QG=h;const A=/{([^}]+)}/g;function I(S,w,C){return S.replace(A,function(k,D){return w&&D.length>0&&D[0]!=="_"?k:C&&C.hasOwnProperty(D)?C[D]:k})}function p(S){const w={};for(const C of Object.keys(S))C.startsWith("!")||(w[C]=S[C]);return w}function E(S){return S.configuration.request==="attach"&&!v(S)&&(!S.parentSession||E(S.parentSession))}function v(S){let w=S.configuration.type;if(w)return w==="vslsShare"&&(w=S.configuration.adapterProxy.configuration.type),(0,u.$lf)(w,"extensionhost")||(0,u.$lf)(w,"pwa-extensionhost")?S:S.parentSession?v(S.parentSession):void 0}function a(S){return S.type&&(S.label||S.program||S.runtime)}function m(S,w,C){let k,D=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let F=null;for(;F=O.exec(S);){const T=F.index+1,z=T+F[0].length;if(T<=w&&z>=C){k=F[0],D=T;break}}if(k){const T=/\w+/g;let z=null;for(;(z=T.exec(k))&&!(z.index+1+D+z[0].length>=C););z&&(k=k.substring(0,T.lastIndex))}return k?{start:D,end:D+k.length-1}:{start:0,end:0}}async function o(S,w,C,k){if(S.evaluatableExpressionProvider.has(w)){const D=S.evaluatableExpressionProvider.ordered(w),O=(0,y.$Hb)(await Promise.all(D.map(async F=>{try{return await F.provideEvaluatableExpression(w,C,k??$.CancellationToken.None)}catch{return}})));if(O.length>0){let F=O[0].expression;const T=O[0].range;return F||(F=w.getLineContent(C.lineNumber).substring(T.startColumn-1,T.endColumn-1)),{range:T,matchingExpression:F}}}else{const D=w.getLineContent(C.lineNumber),{start:O,end:F}=m(D,C.column,C.column),T=D.substring(O-1,F);return{matchingExpression:T,range:new b.$ct(C.lineNumber,O,C.lineNumber,O+T.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(S){return!!(S&&S.match(n))}function r(S){if(typeof S.path=="string"&&!(typeof S.sourceReference=="number"&&S.sourceReference>0)){if(i(S.path))return L.URI.parse(S.path);if((0,M.$jc)(S.path))return L.URI.file(S.path)}return S.path}function s(S){if(typeof S.path=="object"){const w=L.URI.revive(S.path);if(w)return w.scheme===R.Schemas.file?w.fsPath:w.toString()}return S.path}function t(S,w){const C=w?r:s,k=(0,P.$On)(S);return d(k,(D,O)=>{D&&O&&(O.path=C(O))}),k}function f(S,w){const C=w?r:s,k=(0,P.$On)(S);return d(k,(D,O)=>{!D&&O&&(O.path=C(O))}),k}function d(S,w){switch(S.type){case"event":{const C=S;switch(C.event){case"output":w(!1,C.body.source);break;case"loadedSource":w(!1,C.body.source);break;case"breakpoint":w(!1,C.body.breakpoint.source);break;default:break}break}case"request":{const C=S;switch(C.command){case"setBreakpoints":w(!0,C.arguments.source);break;case"breakpointLocations":w(!0,C.arguments.source);break;case"source":w(!0,C.arguments.source);break;case"gotoTargets":w(!0,C.arguments.source);break;case"launchVSCode":C.arguments.args.forEach(k=>w(!1,k));break;default:break}break}case"response":{const C=S;if(C.success&&C.body)switch(C.command){case"stackTrace":C.body.stackFrames.forEach(k=>w(!1,k.source));break;case"loadedSources":C.body.sources.forEach(k=>w(!1,k));break;case"scopes":C.body.scopes.forEach(k=>w(!1,k.source));break;case"setFunctionBreakpoints":C.body.breakpoints.forEach(k=>w(!1,k.source));break;case"setBreakpoints":C.body.breakpoints.forEach(k=>w(!1,k.source));break;case"disassemble":C.body?.instructions.forEach(D=>w(!1,D.location));break;default:break}break}}}function l(S){return S.filter(w=>!w.presentation?.hidden).sort((w,C)=>w.presentation?C.presentation?w.presentation.group?C.presentation.group?w.presentation.group!==C.presentation.group?w.presentation.group.localeCompare(C.presentation.group):c(w.presentation.order,C.presentation.order):-1:C.presentation.group?1:c(w.presentation.order,C.presentation.order):-1:C.presentation?1:0)}function c(S,w){return typeof S!="number"?typeof w!="number"?0:1:typeof w!="number"?-1:S-w}async function h(S,w){const C=S.getValue("debug.saveBeforeStart",{overrideIdentifier:w.activeTextEditorLanguageId});if(C!=="none"&&(await w.saveAll(),C==="allEditorsInActiveGroup")){const k=w.activeEditorPane;k&&k.input.resource?.scheme===R.Schemas.untitled&&await w.save({editor:k.input,groupId:k.group.id})}await S.reloadConfiguration()}const g=(S,w)=>!S||!w?S===w:S.name===w.name&&S.path===w.path&&S.sourceReference===w.sourceReference;e.$RG=g}),define(ke[293],Ee([1,0,52,62,24,17,11,14,31,236,143]),function(he,e,u,L,M,P,R,b,$,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$klc=e.$jlc=e.$ilc=e.$hlc=e.$glc=void 0;class I extends A.$pob{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(o,n){this.l=n,this.p=Buffer.allocUnsafe(0),this.r=-1,o.on("data",i=>this.v(i))}sendMessage(o){if(this.l){const n=JSON.stringify(o);this.l.write(`Content-Length: ${Buffer.byteLength(n,"utf8")}${I.a}${n}`,"utf8")}}v(o){for(this.p=Buffer.concat([this.p,o]);;){if(this.r>=0){if(this.p.length>=this.r){const n=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,n.length>0)try{this.acceptMessage(JSON.parse(n))}catch(i){this.n.fire(new Error((i.message||i)+`
`+n))}continue}}else{const n=this.p.indexOf(I.a);if(n!==-1){const r=this.p.toString("utf8",0,n).split(I.b);for(const s of r){const t=s.split(I.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(n+I.a.length);continue}}break}}}e.$glc=I;class p extends I{startSession(){return new Promise((o,n)=>{let i=!1;this.x=this.y(()=>{this.t(this.x,this.x),o(),i=!0}),this.x.on("close",()=>{i?this.n.fire(new Error("connection closed")):n(new Error("connection closed"))}),this.x.on("error",r=>{i?this.n.fire(r):n(r)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$hlc=p;class E extends p{constructor(o){super(),this.z=o}y(o){return L.createConnection(this.z.port,this.z.host||"127.0.0.1",o)}}e.$ilc=E;class v extends p{constructor(o){super(),this.z=o}y(o){return L.createConnection(this.z.path,o)}}e.$jlc=v;class a extends I{constructor(o,n){super(),this.y=o,this.z=n}async startSession(){const o=this.y.command,n=this.y.args,i=this.y.options||{};try{if(o)if(P.$jc(o)){if(!await $.Promises.exists(o))throw new Error(y.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(y.localize(1,null,this.z));let r=process.env;if(i.env&&Object.keys(i.env).length>0&&(r=M.$Rn(M.$On(process.env),i.env)),o==="node")if(Array.isArray(n)&&n.length>0){const s=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:r,execArgv:s?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(t.cwd=i.cwd);const f=u.fork(n[0],n.slice(1),t);if(!f.pid)throw new Error(y.localize(2,null,n[0]));this.x=f}else throw new Error(y.localize(3,null));else{const s={env:r};i.cwd&&(s.cwd=i.cwd),this.x=u.spawn(o,n,s)}this.x.on("error",s=>{this.n.fire(s)}),this.x.on("exit",(s,t)=>{this.o.fire(s)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",s=>{this.n.fire(s)}),this.x.stdin.on("error",s=>{this.n.fire(s)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(r){this.n.fire(r)}}async stopSession(){return this.x?(await this.w(),R.$i?new Promise((o,n)=>{const i=u.exec(`taskkill /F /T /PID ${this.x.pid}`,function(r,s,t){if(r)return n(r)});i.on("exit",o),i.on("error",n)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(o,n){if(!o)return;const i=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?i.runtime=P.$kc(n,o.runtime):i.runtime=o.runtime),o.runtimeArgs&&(i.runtimeArgs=o.runtimeArgs),o.program&&(P.$jc(o.program)?i.program=o.program:i.program=P.$kc(n,o.program)),o.args&&(i.args=o.args);const r=o;return r.win&&(i.win=a.A(r.win,n)),r.winx86&&(i.winx86=a.A(r.winx86,n)),r.windows&&(i.windows=a.A(r.windows,n)),r.osx&&(i.osx=a.A(r.osx,n)),r.linux&&(i.linux=a.A(r.linux,n)),i}static platformAdapterExecutable(o,n){let i=Object.create(null);n=n.toLowerCase();for(const l of o)if(l.contributes){const c=l.contributes.debuggers;c&&c.length>0&&c.filter(h=>typeof h.type=="string"&&b.$lf(h.type,n)).forEach(h=>{const g=a.A(h,l.extensionLocation.fsPath);i=M.$Rn(i,g,l.isBuiltin)})}let r;R.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?r=i.winx86||i.win||i.windows:R.$i?r=i.win||i.windows:R.$j?r=i.osx:R.$k&&(r=i.linux),r=r||i;const s=r.program||i.program,t=r.args||i.args,f=r.runtime||i.runtime,d=r.runtimeArgs||i.runtimeArgs;if(f)return{type:"executable",command:f,args:(d||[]).concat(typeof s=="string"?[s]:[]).concat(t||[])};if(s)return{type:"executable",command:s,args:t||[]}}}e.$klc=a}),define(ke[294],Ee([1,0,52,34,11]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$llc=R,e.$mlc=$;function P(y,A){return new Promise((I,p)=>{let E="";const v=u.spawn(y,A);v.pid&&v.stdout.on("data",a=>{E+=a.toString()}),v.on("error",a=>{p(a)}),v.on("close",a=>{I(E)})})}async function R(y){if(y)if(M.$i){const A=await new Promise((I,p)=>{he(["@vscode/windows-process-tree"],I,p)});return new Promise(I=>{A.getProcessTree(y,p=>{I(!!p&&p.children.length>0)})})}else return P("/usr/bin/pgrep",["-lP",String(y)]).then(A=>{const I=A.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}var b;(function(y){y[y.cmd=0]="cmd",y[y.powershell=1]="powershell",y[y.bash=2]="bash"})(b||(b={}));function $(y,A,I,p){y=y.trim().toLowerCase();let E;y.indexOf("powershell")>=0||y.indexOf("pwsh")>=0?E=1:y.indexOf("cmd.exe")>=0?E=0:y.indexOf("bash")>=0?E=2:M.$i?E=0:E=2;let v,a=" ";switch(E){case 1:if(v=m=>(m=m.replace(/\'/g,"''"),m.length>0&&m.charAt(m.length-1)==="\\"?`'${m}\\'`:`'${m}'`),p){const m=(0,L.$ng)(p);m&&(a+=`${m}:; `),a+=`cd ${v(p)}; `}if(A.length>0){const m=A.shift(),o=I?m:v(m);a+=o[0]==="'"?`& ${o} `:`${o} `;for(const n of A)a+=n==="<"||n===">"||I?n:v(n),a+=" "}break;case 0:if(v=m=>(m=m.replace(/\"/g,'""'),m=m.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(o=>m.includes(o))||m.length===0?`"${m}"`:m),p){const m=(0,L.$ng)(p);m&&(a+=`${m}: && `),a+=`cd ${v(p)} && `}for(const m of A)a+=m==="<"||m===">"||I?m:v(m),a+=" ";break;case 2:{v=m=>(m=m.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),m.length===0?'""':m),p&&(a+=`cd ${v(p)} ; `);for(const m of A)a+=m==="<"||m===">"||I?m:v(m),a+=" ";break}}return a}}),define(ke[295],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4J=e.CellExecutionUpdateType=void 0;var L;(function(M){M[M.Output=1]="Output",M[M.OutputItems=2]="OutputItems",M[M.ExecutionState=3]="ExecutionState"})(L||(e.CellExecutionUpdateType=L={})),e.$4J=(0,u.$ii)("INotebookExecutionService")}),define(ke[296],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Chb=e.$Bhb=e.ProxyKernelState=e.$Ahb=void 0,e.$Ahb=100;var L;(function(M){M[M.Disconnected=1]="Disconnected",M[M.Connected=2]="Connected",M[M.Initializing=3]="Initializing"})(L||(e.ProxyKernelState=L={})),e.$Bhb=(0,u.$ii)("INotebookKernelService"),e.$Chb=(0,u.$ii)("INotebookKernelHistoryService")}),define(ke[297],Ee([1,0,3,29,199,100]),function(he,e,u,L,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AUb=void 0;class R extends u.$Uc{constructor($,y,A){super(),this._source=$,this.b=y,this.c=A,this.a=void 0}f($){const y=$.getLineCount();return new L.$ct(1,1,y,this.g($,y))}g($,y){if(y<1||y>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(y)+1}get inputTextBuffer(){if(!this.b){const $=new M.$AC;$.acceptChunk(this._source);const y=$.finish(!0),{textBuffer:A,disposable:I}=y.create(1);this.b=A,this.B(I)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const y=new M.$AC;y.acceptChunk($);const A=y.finish(!0),{textBuffer:I,disposable:p}=A.create(1);return this.B(p),I})),this.a}findInInputs($){const A=new P.$oC($,!1,!1,null).parseSearchRequest();if(!A)return[];const I=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(I,A,!0,5e3)}findInOutputs($){const A=new P.$oC($,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(I=>{const p=I.findMatchesLineByLine(this.f(I),A,!0,5e3);if(p.length!==0)return{textBuffer:I,matches:p}}).filter(I=>!!I):[]}}e.$AUb=R}),define(ke[67],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0K=e.TestPosition=e.TestIdPathParts=void 0;var u;(function(P){P.Delimiter="\0"})(u||(e.TestIdPathParts=u={}));var L;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(L||(e.TestPosition=L={}));class M{static fromExtHostTestItem(R,b,$=R.parent){if(R._isRoot)return new M([b]);const y=[R.id];for(let A=$;A&&A.id!==b;A=A.parent)y.push(A.id);return y.push(b),new M(y.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const b=R.indexOf("\0");return b===-1?R:R.slice(0,b)}static fromString(R){return new M(R.split("\0"))}static join(R,b){return new M([...R.path,b])}static joinToString(R,b){return R.toString()+"\0"+b}static parentId(R){const b=R.lastIndexOf("\0");return b===-1?void 0:R.slice(0,b)}static localId(R){const b=R.lastIndexOf("\0");return b===-1?R:R.slice(b+1)}static isChild(R,b){return b.startsWith(R)&&b[R.length]==="\0"}static compare(R,b){return R===b?0:M.isChild(R,b)?2:M.isChild(b,R)?3:1}constructor(R,b=R.length){if(this.path=R,this.d=b,R.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new M(this.path,1)}get parentId(){return this.d>1?new M(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new M(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new M(this.path,R)}compare(R){if(typeof R=="string")return M.compare(this.toString(),R);for(let b=0;b<R.d&&b<this.d;b++)if(R.path[b]!==this.path[b])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$0K=M}),define(ke[89],Ee([1,0,2,49,29,67]),function(he,e,u,L,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$fL=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$eL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$dL=e.$cL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$bL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$aL=e.$_K=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$$K=e.TestResultState=void 0;var R;(function(j){j[j.Unset=0]="Unset",j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(R||(e.TestResultState=R={})),e.$$K={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var b;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(b||(e.ExtTestRunProfileKind=b={}));var $;(function(j){j[j.Run=2]="Run",j[j.Debug=4]="Debug",j[j.Coverage=8]="Coverage",j[j.HasNonDefaultProfile=16]="HasNonDefaultProfile",j[j.HasConfigurable=32]="HasConfigurable",j[j.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$_K=[2,4,8,16,32,64];const y=j=>"runId"in j;e.$aL=y;var A;(function(j){j.serialize=N=>({range:N.range.toJSON(),uri:N.uri.toJSON()}),j.deserialize=(N,B)=>({range:M.$ct.lift(B.range),uri:N.asCanonicalUri(u.URI.revive(B.uri))})})(A||(e.IRichLocation=A={}));var I;(function(j){j[j.Error=0]="Error",j[j.Output=1]="Output"})(I||(e.TestMessageType=I={}));var p;(function(j){j.serialize=N=>({message:N.message,type:0,expected:N.expected,actual:N.actual,contextValue:N.contextValue,location:N.location&&A.serialize(N.location)}),j.deserialize=(N,B)=>({message:B.message,type:0,expected:B.expected,actual:B.actual,contextValue:B.contextValue,location:B.location&&A.deserialize(N,B.location)})})(p||(e.ITestErrorMessage=p={}));const E=(j,N)=>`${N?"s":"e"}${j}`;e.$bL=E;var v;(function(j){j.serialize=N=>({message:N.message,type:1,offset:N.offset,length:N.length,location:N.location&&A.serialize(N.location)}),j.deserialize=(N,B)=>({message:B.message,type:1,offset:B.offset,length:B.length,location:B.location&&A.deserialize(N,B.location)})})(v||(e.ITestOutputMessage=v={}));var a;(function(j){j.serialize=N=>N.type===0?p.serialize(N):v.serialize(N),j.deserialize=(N,B)=>B.type===0?p.deserialize(N,B):v.deserialize(N,B)})(a||(e.ITestMessage=a={}));var m;(function(j){j.serializeWithoutMessages=N=>({state:N.state,duration:N.duration,messages:[]}),j.serialize=N=>({state:N.state,duration:N.duration,messages:N.messages.map(a.serialize)}),j.deserialize=(N,B)=>({state:B.state,duration:B.duration,messages:B.messages.map(W=>a.deserialize(N,W))})})(m||(e.ITestTaskState=m={}));const o="\0",n=(j,N)=>j+o+N;e.$cL=n;const i=j=>{const N=j.indexOf(o);return{ctrlId:j.slice(0,N),tagId:j.slice(N+1)}};e.$dL=i;var r;(function(j){j.serialize=N=>({extId:N.extId,label:N.label,tags:N.tags,busy:N.busy,children:void 0,uri:N.uri?.toJSON(),range:N.range?.toJSON()||null,description:N.description,error:N.error,sortText:N.sortText}),j.deserialize=(N,B)=>({extId:B.extId,label:B.label,tags:B.tags,busy:B.busy,children:void 0,uri:B.uri?N.asCanonicalUri(u.URI.revive(B.uri)):void 0,range:B.range?M.$ct.lift(B.range):null,description:B.description,error:B.error,sortText:B.sortText})})(r||(e.ITestItem=r={}));var s;(function(j){j[j.NotExpandable=0]="NotExpandable",j[j.Expandable=1]="Expandable",j[j.BusyExpanding=2]="BusyExpanding",j[j.Expanded=3]="Expanded"})(s||(e.TestItemExpandState=s={}));var t;(function(j){j.serialize=N=>({expand:N.expand,item:r.serialize(N.item)}),j.deserialize=(N,B)=>({controllerId:P.$0K.root(B.item.extId),expand:B.expand,item:r.deserialize(N,B.item)})})(t||(e.InternalTestItem=t={}));var f;(function(j){j.serialize=N=>{let B;return N.item&&(B={},N.item.label!==void 0&&(B.label=N.item.label),N.item.tags!==void 0&&(B.tags=N.item.tags),N.item.busy!==void 0&&(B.busy=N.item.busy),N.item.uri!==void 0&&(B.uri=N.item.uri?.toJSON()),N.item.range!==void 0&&(B.range=N.item.range?.toJSON()),N.item.description!==void 0&&(B.description=N.item.description),N.item.error!==void 0&&(B.error=N.item.error),N.item.sortText!==void 0&&(B.sortText=N.item.sortText)),{extId:N.extId,expand:N.expand,item:B}},j.deserialize=N=>{let B;return N.item&&(B={},N.item.label!==void 0&&(B.label=N.item.label),N.item.tags!==void 0&&(B.tags=N.item.tags),N.item.busy!==void 0&&(B.busy=N.item.busy),N.item.range!==void 0&&(B.range=N.item.range?M.$ct.lift(N.item.range):null),N.item.description!==void 0&&(B.description=N.item.description),N.item.error!==void 0&&(B.error=N.item.error),N.item.sortText!==void 0&&(B.sortText=N.item.sortText)),{extId:N.extId,expand:N.expand,item:B}}})(f||(e.ITestItemUpdate=f={}));const d=(j,N)=>{N.expand!==void 0&&(j.expand=N.expand),N.item!==void 0&&(j.item=j.item?Object.assign(j.item,N.item):N.item)};e.$eL=d;var l;(function(j){j.serializeWithoutMessages=N=>({...t.serialize(N),ownComputedState:N.ownComputedState,computedState:N.computedState,tasks:N.tasks.map(m.serializeWithoutMessages)}),j.serialize=N=>({...t.serialize(N),ownComputedState:N.ownComputedState,computedState:N.computedState,tasks:N.tasks.map(m.serialize)}),j.deserialize=(N,B)=>({...t.deserialize(N,B),ownComputedState:B.ownComputedState,computedState:B.computedState,tasks:B.tasks.map(W=>m.deserialize(N,W)),retired:!0})})(l||(e.TestResultItem=l={}));var c;(function(j){j.empty=()=>({covered:0,total:0}),j.sum=(N,B)=>{N.covered+=B.covered,N.total+=B.total}})(c||(e.ICoveredCount=c={}));var h;(function(j){j.serialize=N=>({id:N.id,statement:N.statement,branch:N.branch,declaration:N.declaration,uri:N.uri.toJSON()}),j.deserialize=(N,B)=>({id:B.id,statement:B.statement,branch:B.branch,declaration:B.declaration,uri:N.asCanonicalUri(u.URI.revive(B.uri))})})(h||(e.IFileCoverage=h={}));function g(j){return{...j,location:j.location?.toJSON()}}function S(j){return j.location=j.location?L.$bt.isIPosition(j.location)?L.$bt.lift(j.location):M.$ct.lift(j.location):void 0,j}e.$fL=3;var w;(function(j){j[j.Declaration=0]="Declaration",j[j.Statement=1]="Statement",j[j.Branch=2]="Branch"})(w||(e.DetailType=w={}));var C;(function(j){j.serialize=N=>N.type===0?D.serialize(N):O.serialize(N),j.deserialize=N=>N.type===0?D.deserialize(N):O.deserialize(N)})(C||(e.CoverageDetails=C={}));var k;(function(j){j.serialize=g,j.deserialize=S})(k||(e.IBranchCoverage=k={}));var D;(function(j){j.serialize=g,j.deserialize=S})(D||(e.IDeclarationCoverage=D={}));var O;(function(j){j.serialize=N=>({...g(N),branches:N.branches?.map(k.serialize)}),j.deserialize=N=>({...S(N),branches:N.branches?.map(k.deserialize)})})(O||(e.IStatementCoverage=O={}));var F;(function(j){j[j.Add=0]="Add",j[j.Update=1]="Update",j[j.DocumentSynced=2]="DocumentSynced",j[j.Remove=3]="Remove",j[j.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",j[j.Retire=5]="Retire",j[j.AddTag=6]="AddTag",j[j.RemoveTag=7]="RemoveTag"})(F||(e.TestDiffOpType=F={}));var T;(function(j){j.deserialize=(N,B)=>B.op===0?{op:B.op,item:t.deserialize(N,B.item)}:B.op===1?{op:B.op,item:f.deserialize(B.item)}:B.op===2?{op:B.op,uri:N.asCanonicalUri(u.URI.revive(B.uri)),docv:B.docv}:B,j.serialize=N=>N.op===0?{op:N.op,item:t.serialize(N.item)}:N.op===1?{op:N.op,item:f.serialize(N.item)}:N})(T||(e.TestsDiffOp=T={}));class z{constructor(N){this.l=N,this.f=new Map,this.g=new Map,this.h=new Set,this.j=0,this.k=0,this.tags=this.f}apply(N){const B=this.w();for(const W of N)switch(W.op){case 0:this.o(t.deserialize(this.l,W.item),B);break;case 1:this.p(f.deserialize(W.item),B);break;case 3:this.q(W.itemId,B);break;case 5:this.v(W.itemId);break;case 4:this.updatePendingRoots(W.amount);break;case 6:this.f.set(W.tag.id,W.tag);break;case 7:this.f.delete(W.id);break}B.complete?.()}o(N,B){const W=P.$0K.parentId(N.item.extId)?.toString();let Z;if(!W)Z=this.x(N),this.h.add(Z),this.g.set(N.item.extId,Z);else if(this.g.has(W)){const _=this.g.get(W);_.children.add(N.item.extId),Z=this.x(N,_),this.g.set(N.item.extId,Z)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(N)}`);return}return B.add?.(Z),N.expand===2&&this.j++,Z}p(N,B){const W=this.g.get(N.extId);if(W)return N.expand!==void 0&&(W.expand===2&&this.j--,N.expand===2&&this.j++),(0,e.$eL)(W,N),B.update?.(W),W}q(N,B){const W=this.g.get(N);if(!W)return;const Z=P.$0K.parentId(W.item.extId)?.toString();Z?this.g.get(Z).children.delete(W.item.extId):this.h.delete(W);const _=[[N]];for(;_.length;)for(const X of _.pop()){const x=this.g.get(X);x&&(_.push(x.children),this.g.delete(X),B.remove?.(x,x!==W),x.expand===2&&this.j--)}}v(N){}updatePendingRoots(N){this.k+=N}w(){return{}}}e.$gL=z}),define(ke[112],Ee([1,0,8,4,3,61,89,67]),function(he,e,u,L,M,P,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AO=e.$zO=e.$yO=e.$xO=e.$wO=e.TestItemEventOp=void 0;var $;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const y=(n,i)=>n===i,I=Object.entries({range:(n,i)=>n===i?!0:!n||!i?!1:n.equalsRange(i),busy:y,label:y,description:y,error:y,sortText:y,tags:(n,i)=>!(n.length!==i.length||n.some(r=>!i.includes(r)))}),p=(n,i)=>{let r;for(const[s,t]of I)t(n[s],i[s])||(r?r[s]=i[s]:r={[s]:i[s]});return r};class E extends M.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new u.$uh(()=>this.flushDiff(),200)),this.g=this.B(new L.$7d),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const r of this.tree.values())this.J(r)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case 2:{for(const r of this.m)if(r.op===2&&r.uri===i.uri){r.docv=i.docv;return}break}case 1:{const r=this.m[this.m.length-1];if(r){if(r.op===1&&r.item.extId===i.item.extId){(0,R.$eL)(r.item,i.item);return}if(r.op===0&&r.item.item.extId===i.item.extId){(0,R.$eL)(r.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,r){const s=this.tree.get(i);if(s){if((s.expandLevels===void 0||r>s.expandLevels)&&(s.expandLevels=r),s.expand===1){const t=this.M(s);return t.isOpen()?this.L(s,r-1):t.wait().then(()=>this.L(s,r-1))}else if(s.expand===3)return s.resolveBarrier?.isOpen()===!1?s.resolveBarrier.wait().then(()=>this.L(s,r-1)):this.L(s,r-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,r){switch(r.op){case 3:this.O(b.$0K.joinToString(i.fullId,r.id));break;case 0:this.z(r.item,i);break;case 5:for(const s of r.ops)this.w(i,s);break;case 1:this.C(r.new,r.old,i.fullId.toString());break;case 2:this.J(i);break;case 4:this.pushDiff({op:1,item:{extId:i.fullId.toString(),item:r.update}});break;case 6:this.y(i.actual.uri);break;default:(0,P.$0c)(r)}}y(i){i&&this.pushDiff({op:2,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,r){const s=b.$0K.fromExtHostTestItem(i,this.root.id,r?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==r?.actual&&this.s.getChildren(t.parent).delete(i.id);let f=this.tree.get(s.toString());if(!f){f={fullId:s,actual:i,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:0},i.tags.forEach(this.D,this),this.tree.set(f.fullId.toString(),f),this.G(i,r),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:f.expand,item:this.s.toITestItem(i)}}),this.I(i,f,r);return}if(f.actual===i){this.H(i,f,r);return}if(f.actual.uri?.toString()!==i.uri?.toString())return this.O(s.toString()),this.z(i,r);const d=this.s.getChildren(f.actual),l=f.actual,c=p(this.s.toITestItem(l),this.s.toITestItem(i));this.s.getApiFor(l).listener=void 0,f.actual=i,f.expand=0,c&&(c.hasOwnProperty("tags")&&(this.C(i.tags,l.tags,s.toString()),delete c.tags),this.w(f,{op:4,update:c})),this.I(i,f,r);for(const[h,g]of d)this.s.getChildren(i).get(g.id)||this.O(b.$0K.joinToString(s,g.id));this.y(f.actual.uri)}C(i,r,s){const t=new Set(r.map(f=>f.id));for(const f of i)t.delete(f.id)||this.D(f);this.pushDiff({op:1,item:{extId:s,item:{tags:i.map(f=>(0,R.$cL)(this.s.controllerId,f.id))}}}),t.forEach(this.F,this)}D(i){const r=this.j.get(i.id);r?r.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$cL)(this.s.controllerId,i.id)}}))}F(i){const r=this.j.get(i);r&&!--r.refCount&&(this.j.delete(i),this.pushDiff({op:7,id:(0,R.$cL)(this.s.controllerId,i)}))}G(i,r){this.s.getApiFor(i).parent=r&&r.actual!==this.root?r.actual:void 0}H(i,r,s){this.G(i,s);const t=this.s.getApiFor(i);t.parent=s?.actual,t.listener=f=>this.w(r,f),this.J(r)}I(i,r,s){this.H(i,r,s);for(const[t,f]of this.s.getChildren(i))this.z(f,r)}J(i){let r;this.h?i.resolveBarrier?r=i.resolveBarrier.isOpen()?3:2:r=i.actual.canResolveChildren?1:0:r=0,r!==i.expand&&(i.expand=r,this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:r}}),r===1&&i.expandLevels!==void 0&&this.M(i))}L(i,r){if(r<0)return;const s=[];for(const[t,f]of this.s.getChildren(i.actual)){const d=this.expand(b.$0K.joinToString(i.fullId,f.id),r);(0,u.$7g)(d)&&s.push(d)}if(s.length)return Promise.all(s).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const f=new u.$hh;return f.open(),f}i.expand=2,this.N(i);const r=i.resolveBarrier=new u.$hh,s=f=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,f)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(f){s(f)}return(0,u.$7g)(t)?t.catch(s).then(()=>{r.open(),this.J(i)}):(r.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:1,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const r=this.tree.get(i);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:i});const s=[r];for(;s.length;){const t=s.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const f of t.actual.tags)this.F(f.id);this.tree.delete(t.fullId.toString());for(const[f,d]of this.s.getChildren(t.actual))s.push(this.tree.get(b.$0K.joinToString(t.fullId,d.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$wO=E;class v extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$xO=v;class a extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$yO=a;class m extends Error{constructor(i,r,s){super(`TestItem with ID "${i}" is from controller "${r}" and cannot be added as a child of an item from controller "${s}".`)}}e.$zO=m;const o=(n,i,r)=>{let s=new Map;return{get size(){return s.size},forEach(t,f){for(const d of s.values())t.call(f,d,this)},[Symbol.iterator](){return s.entries()},replace(t){const f=new Map,d=new Set(s.keys()),l={op:5,ops:[]};for(const c of t){if(!(c instanceof r))throw new a(c.id);const h=i(c).controllerId;if(h!==n.controllerId)throw new m(c.id,h,n.controllerId);if(f.has(c.id))throw new v(c.id);f.set(c.id,c),d.delete(c.id),l.ops.push({op:0,item:c})}for(const c of d.keys())l.ops.push({op:3,id:c});n.listener?.(l),s=f},add(t){if(!(t instanceof r))throw new a(t.id);s.set(t.id,t),n.listener?.({op:0,item:t})},delete(t){s.delete(t)&&n.listener?.({op:3,id:t})},get(t){return s.get(t)},toJSON(){return Array.from(s.values())}}};e.$AO=o}),define(ke[144],Ee([1,0,112]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CO=e.$BO=void 0;const L=new WeakMap,M=(R,b)=>{const $={controllerId:b};return L.set(R,$),$};e.$BO=M;const P=R=>{const b=L.get(R);if(!b)throw new u.$yO(R?.id||"<unknown>");return b};e.$CO=P}),define(ke[113],Ee([1,0,15,2]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0yb=e.$9yb=e.$8yb=void 0,e.$$yb=M,e.$_yb=R,e.$8yb="vscode-cdn.net",e.$9yb=`vscode-resource.${e.$8yb}`,e.$0yb=`'self' https://*.${e.$8yb}`;function M(b,$){return b.scheme===u.Schemas.http||b.scheme===u.Schemas.https?b:($&&$.authority&&$.isRemote&&b.scheme===u.Schemas.file&&(b=L.URI.from({scheme:u.Schemas.vscodeRemote,authority:$.authority,path:b.path})),L.URI.from({scheme:u.Schemas.https,authority:`${b.scheme}+${P(b.authority)}.${e.$9yb}`,path:b.path,fragment:b.fragment,query:b.query}))}function P(b){return b.replace(/./g,$=>{const y=$.charCodeAt(0);return y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57?$:"-"+y.toString(16).padStart(4,"0")})}function R(b){return b.replace(/-([0-9a-f]{4})/g,($,y)=>String.fromCharCode(parseInt(y,16)))}}),define(ke[298],Ee([1,0,4,3,113]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kjc=void 0;class P{constructor(b,$,y){this.d=b,this.e=$,this.f=y,this.a=0,this.b=new L.$Tc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const A=$.getVisibleTextEditors();for(const I of this.c.values())A.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,$,y,A,I){let p;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===b){p=i;break}if(!p)throw new Error("not a visible editor");const E=this,v=this.a++,a=new u.$7d,m=new u.$7d,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,M.$$yb)(i,E.f)}get cspSource(){return M.$0yb}set options(i){this.b=i,E.d.$setOptions(v,i)}get options(){return this.b}set html(i){this.a=i,E.d.$setHtml(v,i)}get html(){return this.a}get onDidReceiveMessage(){return a.event}postMessage(i){return E.d.$postMessage(v,i)}},n=new class{constructor(){this.editor=b,this.line=$,this.height=y,this.webview=o,this.onDidDispose=m.event}dispose(){E.c.has(v)&&(E.c.delete(v),E.d.$disposeEditorInset(v),m.fire(),m.dispose(),a.dispose())}};return this.d.$createEditorInset(v,p.id,p.value.document.uri,$+1,y,A||{},I.identifier,I.extensionLocation),this.c.set(v,{editor:b,inset:n,onDidReceiveMessage:a}),n}$onDidDispose(b){const $=this.c.get(b);$&&$.inset.dispose()}$onDidReceiveMessage(b,$){this.c.get(b)?.onDidReceiveMessage.fire($)}}e.$kjc=P}),define(ke[145],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pL=e.$oL=e.$nL=void 0,e.$nL="__",e.$oL=(0,u.$ii)("IAuthenticationService"),e.$pL=(0,u.$ii)("IAuthenticationExtensionsService")}),define(ke[299],Ee([1,0,5]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tP=e.VariableKind=e.$sP=void 0,e.$sP=(0,u.$ii)("configurationResolverService");var L;(function(P){P.Unknown="unknown",P.Env="env",P.Config="config",P.Command="command",P.Input="input",P.ExtensionInstallFolder="extensionInstallFolder",P.WorkspaceFolder="workspaceFolder",P.Cwd="cwd",P.WorkspaceFolderBasename="workspaceFolderBasename",P.UserHome="userHome",P.LineNumber="lineNumber",P.SelectedText="selectedText",P.File="file",P.FileWorkspaceFolder="fileWorkspaceFolder",P.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",P.RelativeFile="relativeFile",P.RelativeFileDirname="relativeFileDirname",P.FileDirname="fileDirname",P.FileExtname="fileExtname",P.FileBasename="fileBasename",P.FileBasenameNoExtension="fileBasenameNoExtension",P.FileDirnameBasename="fileDirnameBasename",P.ExecPath="execPath",P.ExecInstallFolder="execInstallFolder",P.PathSeparator="pathSeparator",P.PathSeparatorAlias="/"})(L||(e.VariableKind=L={}));class M extends Error{constructor(R,b){super(b),this.variable=R}}e.$tP=M}),define(ke[300],Ee([1,0,17,50,18,24,11,103,239,299,14]),function(he,e,u,L,M,P,R,b,$,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IP=void 0;class I{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(E,v,a,m){this.h=new Map,this.a=E,this.b=v,this.g=a,m&&(this.c=m.then(o=>this.i(o)))}i(E){if(R.$i){const v=Object.create(null);return Object.keys(E).forEach(a=>{v[a.toLowerCase()]=E[a]}),v}return E}resolveWithEnvironment(E,v,a){return this.l({env:this.i(E),userHome:void 0},v?v.uri:void 0,a)}async resolveAsync(E,v){const a={env:await this.c,userHome:await this.g};return this.l(a,E?E.uri:void 0,v)}async j(E,v,a,m){const o=P.$On(v);R.$i&&o.windows?Object.keys(o.windows).forEach(i=>o[i]=o.windows[i]):R.$j&&o.osx?Object.keys(o.osx).forEach(i=>o[i]=o.osx[i]):R.$k&&o.linux&&Object.keys(o.linux).forEach(i=>o[i]=o.linux[i]),delete o.windows,delete o.osx,delete o.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,E?E.uri:void 0,o,a,m)}async resolveAnyAsync(E,v,a){return this.j(E,v,a)}async resolveAnyMap(E,v,a){const m=new Map;return{newConfig:await this.j(E,v,a,m),resolvedVariables:m}}resolveWithInteractionReplace(E,v,a,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,v,a,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,v){if(this.h.has(E))throw new Error("Variable "+E+" is contributed twice.");this.h.set(E,v)}async l(E,v,a,m,o){if(M.$Vf(a))return this.m(E,v,a,m,o);if(Array.isArray(a))return Promise.all(a.map(n=>this.l(E,v,n,m,o)));if(M.$Xf(a)){const n=Object.create(null),i=await Promise.all(Object.keys(a).map(async r=>[await this.m(E,v,r,m,o),await this.l(E,v,a[r],m,o)]));for(const[r,s]of i)n[r]=s;return n}return a}m(E,v,a,m,o){return(0,A.$df)(a,I.VARIABLE_REGEXP,async(n,i)=>{if(i.includes(I.VARIABLE_LHS))return n;let r=await this.o(E,n,i,v,m);return o?.set(i,r),r!==n&&M.$Vf(r)&&r.match(I.VARIABLE_REGEXP)&&(r=await this.m(E,v,r,m,o)),r})}n(E){return this.b?this.b.getUriLabel(E,{noPrefix:!0}):E.fsPath}async o(E,v,a,m,o){let n;const i=a.split(":");i.length>1&&(a=i[0],n=i[1]);const r=f=>{const d=this.a.getFilePath();if(d)return(0,b.$hw)(d);throw new y.$tP(f,(0,$.localize)(0,null,v))},s=f=>{const d=r(f);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,b.$hw)(l)}throw new y.$tP(f,(0,$.localize)(1,null,v,u.$oc(d)))},t=f=>{if(n){const d=this.a.getFolderUri(n);if(d)return d;throw new y.$tP(f,(0,$.localize)(2,null,v,n))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new y.$tP(f,(0,$.localize)(3,null,v)):new y.$tP(f,(0,$.localize)(4,null,v))};switch(a){case"env":if(n){if(E.env){const f=E.env[R.$i?n.toLowerCase():n];if(M.$Vf(f))return f}return""}throw new y.$tP(y.VariableKind.Env,(0,$.localize)(5,null,v));case"config":if(n){const f=this.a.getConfigurationValue(m,n);if(M.$5f(f))throw new y.$tP(y.VariableKind.Config,(0,$.localize)(6,null,v,n));if(M.$Xf(f))throw new y.$tP(y.VariableKind.Config,(0,$.localize)(7,null,v,n));return f}throw new y.$tP(y.VariableKind.Config,(0,$.localize)(8,null,v));case"command":return this.p(y.VariableKind.Command,v,n,o,"command");case"input":return this.p(y.VariableKind.Input,v,n,o,"input");case"extensionInstallFolder":if(n){const f=await this.a.getExtension(n);if(!f)throw new y.$tP(y.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,v,n));return this.n(f.extensionLocation)}throw new y.$tP(y.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,v));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,b.$hw)(this.n(t(y.VariableKind.WorkspaceFolder)));case"cwd":return m||n?(0,b.$hw)(this.n(t(y.VariableKind.Cwd))):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$hw)(u.$oc(this.n(t(y.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new y.$tP(y.VariableKind.UserHome,(0,$.localize)(11,null,v))}case"lineNumber":{const f=this.a.getLineNumber();if(f)return f;throw new y.$tP(y.VariableKind.LineNumber,(0,$.localize)(12,null,v))}case"selectedText":{const f=this.a.getSelectedText();if(f)return f;throw new y.$tP(y.VariableKind.SelectedText,(0,$.localize)(13,null,v))}case"file":return r(y.VariableKind.File);case"fileWorkspaceFolder":return s(y.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return u.$oc(s(y.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||n?u.$mc(this.n(t(y.VariableKind.RelativeFile)),r(y.VariableKind.RelativeFile)):r(y.VariableKind.RelativeFile);case"relativeFileDirname":{const f=u.$nc(r(y.VariableKind.RelativeFileDirname));if(m||n){const d=u.$mc(this.n(t(y.VariableKind.RelativeFileDirname)),f);return d.length===0?".":d}return f}case"fileDirname":return u.$nc(r(y.VariableKind.FileDirname));case"fileExtname":return u.$pc(r(y.VariableKind.FileExtname));case"fileBasename":return u.$oc(r(y.VariableKind.FileBasename));case"fileBasenameNoExtension":{const f=u.$oc(r(y.VariableKind.FileBasenameNoExtension));return f.slice(0,f.length-u.$pc(f).length)}case"fileDirnameBasename":return u.$oc(u.$nc(r(y.VariableKind.FileDirnameBasename)));case"execPath":{const f=this.a.getExecPath();return f||v}case"execInstallFolder":{const f=this.a.getAppRoot();return f||v}case"pathSeparator":case"/":return u.sep;default:try{const f=n?`${a}:${n}`:a;return this.p(y.VariableKind.Unknown,v,f,o,void 0)}catch{return v}}}}p(E,v,a,m,o){if(a&&m){const n=o===void 0?m[a]:m[o+":"+a];if(typeof n=="string")return n;throw new y.$tP(E,(0,$.localize)(14,null,v))}return v}}e.$IP=I}),define(ke[146],Ee([1,0,5,142]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$wD=void 0,e.$xD=y,e.$yD=p,e.$zD=E,e.$wD=(0,u.$ii)("editorGroupsService");var M;(function(v){v[v.UP=0]="UP",v[v.DOWN=1]="DOWN",v[v.LEFT=2]="LEFT",v[v.RIGHT=3]="RIGHT"})(M||(e.GroupDirection=M={}));var P;(function(v){v[v.HORIZONTAL=0]="HORIZONTAL",v[v.VERTICAL=1]="VERTICAL"})(P||(e.GroupOrientation=P={}));var R;(function(v){v[v.FIRST=0]="FIRST",v[v.LAST=1]="LAST",v[v.NEXT=2]="NEXT",v[v.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var b;(function(v){v[v.MAXIMIZE=0]="MAXIMIZE",v[v.EXPAND=1]="EXPAND",v[v.EVEN=2]="EVEN"})(b||(e.GroupsArrangement=b={}));var $;(function(v){v[v.COPY_EDITORS=0]="COPY_EDITORS",v[v.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function y(v){const a=v;return(0,L.$hF)(a?.editor)&&(0,L.$hF)(a?.replacement)}var A;(function(v){v[v.CREATION_TIME=0]="CREATION_TIME",v[v.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",v[v.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var I;(function(v){v[v.NEW_EDITOR=1]="NEW_EDITOR",v[v.MOVE_EDITOR=2]="MOVE_EDITOR",v[v.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function p(v){const a=v;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}function E(v){return v.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(ke[301],Ee([1,0,5,146]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DD=e.$CD=e.$BD=e.$AD=void 0,e.$ED=M,e.$AD=(0,u.$ii)("editorService"),e.$BD=-1,e.$CD=-2,e.$DD=-3;function M(P){const R=P;return typeof P=="number"||(0,L.$yD)(R)}}),define(ke[147],Ee([1,0,5,136]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IL=void 0,e.$IL=(0,u.$ji)(L.$pi)}),define(ke[148],Ee([1,0,25,4,17,3,8]),function(he,e,u,L,M,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z0b=e.$Y0b=e.$X0b=e.$W0b=e.$V0b=void 0;class b{constructor(n,i){this.versionId=n,this.removedDueToLooping=i}}e.$V0b=b;class ${static isHostExtension(n,i,r){if(i.getExtensionDescription(n))return!1;const s=r.getExtensionDescription(n);return s?!!((s.main||s.browser)&&s.api==="none"):!1}constructor(n,i){this.j=n,this.c=new L.$7d,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(a),this.f=new u.$Fm,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const i=this.j.readActivationEvents(n);for(const r of i)this.h.has(r)||this.h.set(r,[]),this.h.get(r).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,i){this.e=m(this.e,i),this.e=this.e.concat(n);const r=$.l(this.e);return this.e=m(this.e,r.map(s=>s.identifier)),this.k(),this.d++,this.c.fire(void 0),new b(this.d,r)}static l(n){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(d){this.d.has(d)||(this.d.add(d),this.e.push(d))}addArc(d,l){this.addNode(d),this.addNode(l),this.c.has(d)?this.c.get(d).push(l):this.c.set(d,[l])}getArcs(d){return this.c.has(d)?this.c.get(d):[]}hasOnlyGoodArcs(d,l){const c=i.getArcs(d);for(let h=0;h<c.length;h++)if(!l.has(c[h]))return!1;return!0}getNodes(){return this.e}},r=new u.$Fm;for(const d of n)if(r.set(d.identifier,d),d.extensionDependencies)for(const l of d.extensionDependencies)i.addArc(u.$Dm.toKey(d.identifier),u.$Dm.toKey(l));const s=new Set;i.getNodes().filter(d=>i.getArcs(d).length===0).forEach(d=>s.add(d));const t=i.getNodes().filter(d=>!s.has(d));let f;do{f=!1;for(let d=0;d<t.length;d++){const l=t[d];i.hasOnlyGoodArcs(l,s)&&(t.splice(d,1),d--,s.add(l),f=!0)}}while(f);return t.map(d=>r.get(d))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const i=this.h.get(n);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new y(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const i=this.f.get(n);return i||void 0}getExtensionDescriptionByUUID(n){for(const i of this.g)if(i.uuid===n)return i}getExtensionDescriptionByIdOrUUID(n,i){return this.getExtensionDescription(n)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$W0b=$;class y{constructor(n,i){this.versionId=n,this.extensions=i}}e.$X0b=y;class A{constructor(n){this.d=new E,this.c=new $(n,[])}async acquireLock(n){const i=await this.d.acquire(n);return new I(this,i)}deltaExtensions(n,i,r){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,r)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,i){return this.c.getExtensionDescriptionByIdOrUUID(n,i)}}e.$Y0b=A;class I extends P.$Uc{constructor(n,i){super(),this.f=n,this.c=!1,this.B(i)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$Z0b=I;class p{constructor(n){this.name=n;const i=(0,R.$bh)();this.promise=i.promise,this.c=i.resolve}resolve(n){this.c(n)}}class E{constructor(){this.c=[],this.d=!1}async acquire(n){const i=new p(n);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let i=!0;const r=setTimeout(()=>{i&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),s=()=>{i&&(clearTimeout(r),i=!1,this.d=!1,this.e())};n.resolve((0,P.$Sc)(s))}}var v;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(v||(v={}));function a(o,n){const i=o.isBuiltin?0:o.isUnderDevelopment?2:1,r=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(i!==r)return i-r;const s=M.$hc.basename(o.extensionLocation.path),t=M.$hc.basename(n.extensionLocation.path);return s<t?-1:s>t?1:0}function m(o,n){const i=new u.$Em(n);return o.filter(r=>!i.has(r.identifier))}}),define(ke[302],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=e.$0m=e.$9m=e.ExtHostConnectionType=void 0,e.$_m=b,e.$an=$;var u;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(u||(e.ExtHostConnectionType=u={}));class L{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(I){this.pipeName=I,this.type=1}serialize(I){I[L.ENV_KEY]=this.pipeName}}e.$9m=L;class M{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(I){I[M.ENV_KEY]="1"}}e.$0m=M;class P{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(I){I[P.ENV_KEY]="1"}}e.$$m=P;function R(A){delete A[L.ENV_KEY],delete A[M.ENV_KEY],delete A[P.ENV_KEY]}function b(A,I){R(I),A.serialize(I)}function $(A){if(A[L.ENV_KEY])return y(A,new L(A[L.ENV_KEY]));if(A[M.ENV_KEY])return y(A,new M);if(A[P.ENV_KEY])return y(A,new P);throw new Error("No connection information defined in environment!")}function y(A,I){return R(A),I}}),define(ke[114],Ee([1,0,21]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Lm=R,e.$Mm=b;var L;(function(y){y[y.Desktop=1]="Desktop",y[y.Web=2]="Web"})(L||(e.UIKind=L={}));var M;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(M||(e.ExtensionHostExitCode=M={}));var P;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(P||(e.MessageType=P={}));function R(y){const A=u.$ue.alloc(1);switch(y){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}function b(y,A){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}var $;(function(y){y.Start="START_NATIVE_LOG",y.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(ke[90],Ee([1,0,5,4,12,28,114,86,87,24,2,3,225]),function(he,e,u,L,M,P,R,b,$,y,A,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1O=e.$YO=e.$XO=void 0,e.$ZO=a;let E=class extends I.$Uc{constructor(o,n){super(),this.s=o,this.t=n,this.a=this.B(new L.$7d),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new L.$7d),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:$.$9o,name:(0,p.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(i=>{(0,M.$Qj)(i)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===M.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,n,i){const r=this.getTelemetryDetails(),s=new v(n,i,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,s]),s.apiTelemetryLogger}$initializeTelemetryLevel(o,n,i){this.f=o,this.g=n,this.c=i??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const n=Object.create(null);switch(n["common.extname"]=`${o.publisher}.${o.name}`,n["common.extversion"]=o.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=a(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:n["common.uikind"]="web";break;case R.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,b.$um)((0,$.$cp)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const n=this.getTelemetryDetails();this.r.forEach((i,r)=>{const s=i.filter(t=>!t.isDisposed);s.length===0?this.r.delete(r):this.r.set(r,s)}),this.r.forEach(i=>{for(const r of i)r.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,n){const r=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!r)return this.r.delete(o.value),!1;let s=!1;for(const t of r)t.ignoreUnhandledExtHostErrors||(t.logError(n),s=!0);return s}};e.$XO=E,e.$XO=E=Je([qe(0,P.$WO),qe(1,M.$Pj)],E);class v{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,n,i,r,s,t,f){this.g=i,this.h=r,this.i=s,this.j=t,this.a=new L.$7d,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(o,n){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let n="properties"in o?o.properties??{}:o;return n=(0,$.$fp)(n,[]),this.c&&(n=(0,y.$Rn)(n,this.c)),this.b||(n=(0,y.$Rn)(n,this.j)),"properties"in o?o.properties=n:o=n,o}k(o,n){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(o,n),this.h.trace(o,n))}logUsage(o,n){this.d.isUsageEnabled&&this.k(o,n)}logError(o,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,n);else{const i={name:o.name,message:o.message,stack:o.stack,cause:o.cause},r=(0,$.$fp)(i,[]),s=new Error(r.message,{cause:r.cause});s.stack=r.stack,s.name=r.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(s,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const o=this,n={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$YO=v;function a(m){const o=Date.now()-new Date(m).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$1O=(0,u.$ii)("IExtHostTelemetry")}),define(ke[26],Ee([1,0,4,2,270,140,25,5]),function(he,e,u,L,M,P,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cG=e.ActivationKind=e.$_F=e.$$F=e.$8F=e.ExtensionHostStartup=e.$7F=e.$6F=e.$5F=e.$4F=void 0,e.$9F=p,e.$0F=E,e.$aG=o,e.$bG=n,e.$4F=Object.freeze({identifier:new R.$Dm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$5F="extensions.webWorker",e.$6F=(0,b.$ii)("extensionService");class ${constructor(s){this.dependency=s}}e.$7F=$;var y;(function(r){r[r.EagerAutoStart=1]="EagerAutoStart",r[r.EagerManualStart=2]="EagerManualStart",r[r.Lazy=3]="Lazy"})(y||(e.ExtensionHostStartup=y={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(s,t,f){this.c=s,this.d=t.slice(0),this.e=f.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:P.$OF.createActivationEventsMap(this.d)}}set(s,t,f){if(this.c>s)throw new Error(`ExtensionHostExtensions: invalid versionId ${s} (current: ${this.c})`);const d=[],l=[],c=[],h=[],g=I(this.d),S=I(t),w=(F,T)=>F.extensionLocation.toString()===T.extensionLocation.toString()||F.isBuiltin===T.isBuiltin||F.isUserBuiltin===T.isUserBuiltin||F.isUnderDevelopment===T.isUnderDevelopment;for(const F of this.d){const T=S.get(F.identifier);if(!T){d.push(F.identifier),g.delete(F.identifier);continue}if(!w(F,T)){d.push(F.identifier),g.delete(F.identifier);continue}}for(const F of t){const T=g.get(F.identifier);if(!T){l.push(F);continue}if(!w(T,F)){d.push(T.identifier),g.delete(T.identifier);continue}}const C=new R.$Em(this.e),k=new R.$Em(f);for(const F of this.e)k.has(F)||c.push(F);for(const F of f)C.has(F)||h.push(F);const D=P.$OF.createActivationEventsMap(l),O={versionId:s,toRemove:d,toAdd:l,addActivationEvents:D,myToRemove:c,myToAdd:h};return this.delta(O),O}delta(s){if(this.c>=s.versionId)return null;const{toRemove:t,toAdd:f,myToRemove:d,myToAdd:l}=s,c=new R.$Em(t),h=new R.$Em(d);for(let g=0;g<this.d.length;g++)c.has(this.d[g].identifier)&&(this.d.splice(g,1),g--);for(let g=0;g<this.e.length;g++)h.has(this.e[g])&&(this.e.splice(g,1),g--);for(const g of f)this.d.push(g);for(const g of l)this.e.push(g);return this.f=null,s}containsExtension(s){for(const t of this.e)if(R.$Dm.equals(t,s))return!0;return!1}containsActivationEvent(s){return this.f||(this.f=this.g()),this.f.has(s)}g(){const s=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const f=P.$OF.readActivationEvents(t);for(const d of f)s.add(d)}return s}}e.$8F=A;function I(r){const s=new R.$Fm;for(const t of r)s.set(t.identifier,t);return s}function p(r,s){return r.enabledApiProposals?r.enabledApiProposals.includes(s):!1}function E(r,s){if(!p(r,s))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${s}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${s}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}class v{constructor(s,t,f,d){this.codeLoadingTime=s,this.activateCallTime=t,this.activateResolvedTime=f,this.activationReason=d}}e.$$F=v;class a{constructor(s,t){this.description=s,this.value=t}}e.$_F=a;var m;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function o(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,M.$lp)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}function n(r,s){return{identifier:new R.$Dm((0,M.$jp)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!s,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform}}class i{constructor(){this.onDidRegisterExtensions=u.Event.None,this.onDidChangeExtensionsStatus=u.Event.None,this.onDidChangeExtensions=u.Event.None,this.onWillActivateByEvent=u.Event.None,this.onDidChangeResponsiveChange=u.Event.None,this.onWillStop=u.Event.None,this.extensions=[]}activateByEvent(s){return Promise.resolve(void 0)}activateById(s,t){return Promise.resolve(void 0)}activationEventIsDone(s){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(s){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(s,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(s){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$cG=i}),define(ke[303],Ee([1,0,13,148,25,26,12,8]),function(he,e,u,L,M,P,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ljc=e.$Kjc=e.$Jjc=e.$Ijc=e.$Hjc=e.$Gjc=void 0;class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(o,n,i,r){this.startup=o,this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=r}}e.$Gjc=$;class y{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,n){return o===-1||n===-1?-1:n-o}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Hjc=y;class A{constructor(o,n,i,r,s,t){this.activationFailed=o,this.activationFailedError=n,this.activationTimes=i,this.module=r,this.exports=s,this.subscriptions=t}}e.$Ijc=A;class I extends A{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Jjc=I;class p extends A{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Kjc=p;class E extends A{constructor(o){super(!0,o,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let v=class{constructor(o,n,i,r){this.g=r,this.a=o,this.b=n,this.c=i,this.d=new M.$Fm,this.f=Object.create(null)}dispose(){for(const[o,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const o=[];for(const[n,i]of this.d)o.push(i.wait());await Promise.all(o)}isActivated(o){const n=this.d.get(o);return!!(n&&n.value)}getActivatedExtension(o){const n=this.d.get(o);if(!n||!n.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return n.value}async activateByEvent(o,n){if(this.f[o])return;const i=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(i.map(r=>({id:r.identifier,reason:{startup:n,extensionId:r.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,n){const i=this.a.getExtensionDescription(o);if(!i)throw new Error(`Extension '${o}' is not known`);return this.h([{id:i.identifier,reason:n}])}async h(o){const n=o.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all(n.map(i=>i.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const n=this.a.getExtensionDescription(o.id);if(!n){const s=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new E(s));return this.c.onExtensionActivationError(o.id,s,new P.$7F(o.id.value)),t}const i=[],r=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const s of r){if(this.m(s))continue;const t=this.d.get(s);if(t){i.push(t);continue}if(this.l(s)){i.push(this.j({id:this.b.getExtensionDescription(s).identifier,reason:o.reason}));continue}const f=this.a.getExtensionDescription(s);if(f){if(!f.main&&!f.browser)continue;i.push(this.j({id:f.identifier,reason:o.reason}));continue}const d=n.displayName||n.identifier.value,l=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${s}'`),c=this.k(o,n.displayName,[],new E(l));return this.c.onExtensionActivationError(n.identifier,l,new P.$7F(s)),c}return this.k(o,n.displayName,i,null)}k(o,n,i,r){const s=new a(o.id,n,o.reason,i,r,this.c,this.g);return this.d.set(o.id,s),s}l(o){return L.$W0b.isHostExtension(o,this.a,this.b)}m(o){const n=this.b.getExtensionDescription(o);return n?!n.main&&!n.browser:!1}};e.$Ljc=v,e.$Ljc=v=Je([qe(3,R.$Oj)],v);let a=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,n,i,r,s,t,f){this.c=o,this.d=n,this.f=i,this.g=r,this.h=s,this.j=t,this.k=f,this.a=new b.$hh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const n=this.g[o];if(n.value&&!n.value.activationFailed){this.g.splice(o,1),o--;continue}if(n.value&&n.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);i.detail=n.value.activationFailedError,this.h=new E(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const n=new Error;if(o&&o.name&&(n.name=o.name),o&&o.message?n.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(n.stack=o.stack),this.h=new E(n),this.b&&u.$4(o))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};a=Je([qe(6,R.$Oj)],a)}),define(ke[304],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[305],Ee([1,0,241,13,40,137,109,37,25,304,139,140]),function(he,e,u,L,M,P,R,b,$,y,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=void 0;const p=b.$1n.as(R.$2n.JSONContribution);class E{constructor(s,t,f){this.a=s,this.b=t,this.c=f}d(s,t){this.a({type:s,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(s){this.d(M.default.Error,s)}warn(s){this.d(M.default.Warning,s)}info(s){this.d(M.default.Info,s)}}e.$XF=E;class v{static a(s){const t=new $.$Em;for(let f=0,d=s.length;f<d;f++)t.add(s[f].description.identifier);return t}static compute(s,t){if(!s||!s.length)return new v(t,[]);if(!t||!t.length)return new v([],s);const f=this.a(s),d=this.a(t),l=t.filter(h=>!f.has(h.description.identifier)),c=s.filter(h=>!d.has(h.description.identifier));return new v(l,c)}constructor(s,t){this.added=s,this.removed=t}}e.$YF=v;class a{constructor(s,t){this.name=s,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(s){if(this.a!==null)throw new Error("Handler already set!");this.a=s,this.d()}acceptUsers(s){this.c=v.compute(this.b,s),this.b=s,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(s){(0,L.$1)(s)}}}e.$ZF=a;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[u.localize(0,null),u.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$1F={properties:{engines:{type:"object",description:u.localize(2,null),properties:{vscode:{type:"string",description:u.localize(3,null),default:"^1.22.0"}}},publisher:{description:u.localize(4,null),type:"string"},displayName:{description:u.localize(5,null),type:"string"},categories:{description:u.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$Cm},{type:"string",const:"Languages",deprecationMessage:u.localize(7,null)}]}},galleryBanner:{type:"object",description:u.localize(8,null),properties:{color:{description:u.localize(9,null),type:"string"},theme:{description:u.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:u.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:u.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:u.localize(13,null)},enabledApiProposals:{markdownDescription:u.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}},api:{markdownDescription:u.localize(15,null),type:"string",enum:["none"],enumDescriptions:[u.localize(16,null)]},activationEvents:{description:u.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:u.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:u.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:u.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:u.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:u.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:u.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:u.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:u.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:u.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:u.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:u.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:u.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:u.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:u.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:u.localize(32,null)},{label:"onUri",body:"onUri",description:u.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:u.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:u.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:u.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:u.localize(37,null)},{label:"onRenderer",description:u.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:u.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:u.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:u.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:u.localize(42,null)},{label:"*",description:u.localize(43,null),body:"*"}]}},badges:{type:"array",description:u.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:u.localize(45,null)},href:{type:"string",description:u.localize(46,null)},description:{type:"string",description:u.localize(47,null)}}}},markdown:{type:"string",description:u.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:u.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:u.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.$Fo}},extensionPack:{description:u.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.$Fo}},extensionKind:{description:u.localize(52,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:u.localize(53,null)},{body:["workspace"],description:u.localize(54,null)},{body:["ui","workspace"],description:u.localize(55,null)},{body:["workspace","ui"],description:u.localize(56,null)},{body:[],description:u.localize(57,null)}]},capabilities:{description:u.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:u.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:u.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(61,null),u.localize(62,null),u.localize(63,null)]},description:{type:"string",markdownDescription:u.localize(64,null)}}},untrustedWorkspaces:{description:u.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:u.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[u.localize(67,null),u.localize(68,null),u.localize(69,null)]},restrictedConfigurations:{description:u.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:u.localize(71,null)}}}}},sponsor:{description:u.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:u.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:u.localize(74,null),type:"string"},"vscode:uninstall":{description:u.localize(75,null),type:"string"}}},icon:{type:"string",description:u.localize(76,null)},l10n:{type:"string",description:u.localize(77,null)},pricing:{type:"string",markdownDescription:u.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(s){if(this.a.has(s.extensionPoint))throw new Error("Duplicate extension point: "+s.extensionPoint);const t=new a(s.extensionPoint,s.defaultExtensionKind);return this.a.set(s.extensionPoint,t),s.activationEventsGenerator&&I.$OF.register(s.extensionPoint,s.activationEventsGenerator),e.$1F.properties.contributes.properties[s.extensionPoint]=s.jsonSchema,p.registerSchema(o,e.$1F),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$2F=n;const i={ExtensionsRegistry:"ExtensionsRegistry"};b.$1n.add(i.ExtensionsRegistry,new n),e.$3F=b.$1n.as(i.ExtensionsRegistry),p.registerSchema(o,e.$1F),p.registerSchema(A.$9j,{properties:{extensionEnabledApiProposals:{description:u.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}}]}}}})}),define(ke[306],Ee([1,0,237,18,24,305,41,4]),function(he,e,u,L,M,P,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sH=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:u.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:u.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:u.localize(2,null),default:""}}};var y;(function(p){function E(v,a,m){if(!v)return;const o=L.$Vf(v.type)?v.type:void 0;if(!o||o.length===0){m.error(u.localize(3,null));return}const n=[];if(Array.isArray(v.required))for(const i of v.required)L.$Vf(i)&&n.push(i);return{extensionId:a.value,taskType:o,required:n,properties:v.properties?M.$On(v.properties):{},when:v.when?R.$gj.deserialize(v.when):void 0}}p.from=E})(y||(y={}));const A=P.$3F.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(p,E)=>{for(const v of p)v.type&&E.push(`onTaskType:${v.type}`)},jsonSchema:{description:u.localize(4,null),type:"array",items:$}});class I{constructor(){this.d=new b.$7d,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((E,v)=>{A.setHandler((a,m)=>{this.c=void 0;try{for(const o of m.removed){const n=o.value;for(const i of n)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const o of m.added){const n=o.value;for(const i of n){const r=y.from(i,o.description.identifier,o.collector);r&&(this.a[r.taskType]=r)}}(m.removed.length>0||m.added.length>0)&&this.d.fire()}catch{}E(void 0)})})}onReady(){return this.b}get(E){return this.a[E]}all(){return Object.keys(this.a).map(E=>this.a[E])}getJsonSchema(){if(this.c===void 0){const E=[];for(const v of this.all()){const a={type:"object",additionalProperties:!1};v.required.length>0&&(a.required=v.required.slice(0)),v.properties!==void 0?a.properties=M.$On(v.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[v.taskType]},E.push(a)}this.c={oneOf:E}}return this.c}}e.$sH=new I}),define(ke[307],Ee([1,0,238,18,23,24,41,306]),function(he,e,u,L,M,P,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$CH=e.JsonSchemaVersion=e.ExecutionEngine=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$wH=e.ShellQuoting=e.$vH=e.$uH=e.$tH=void 0,e.$tH="settings",e.$uH=new R.$zj("taskRunning",!1,u.localize(0,null)),e.$vH=u.localize2(2,"Tasks");var $;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$wH="$customized",function(j){function N(B){if(!B)return j.Strong;switch(B.toLowerCase()){case"escape":return j.Escape;case"strong":return j.Strong;case"weak":return j.Weak;default:return j.Strong}}j.from=N}($||(e.ShellQuoting=$={}));var y;(function(j){j.defaults={cwd:"${workspaceFolder}"}})(y||(e.CommandOptions=y={}));var A;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(A||(e.RevealKind=A={})),function(j){function N(B){switch(B.toLowerCase()){case"always":return j.Always;case"silent":return j.Silent;case"never":return j.Never;default:return j.Always}}j.fromString=N}(A||(e.RevealKind=A={}));var I;(function(j){j[j.Never=1]="Never",j[j.OnProblem=2]="OnProblem",j[j.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(j){function N(B){switch(B.toLowerCase()){case"always":return j.Always;case"never":return j.Never;case"onproblem":return j.OnProblem;default:return j.OnProblem}}j.fromString=N}(I||(e.RevealProblemKind=I={}));var p;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(p||(e.PanelKind=p={})),function(j){function N(B){switch(B.toLowerCase()){case"shared":return j.Shared;case"dedicated":return j.Dedicated;case"new":return j.New;default:return j.Shared}}j.fromString=N}(p||(e.PanelKind=p={}));var E;(function(j){j.defaults={echo:!0,reveal:A.Always,revealProblems:I.Never,focus:!1,panel:p.Shared,showReuseMessage:!0,clear:!1}})(E||(e.PresentationOptions=E={}));var v;(function(j){j[j.Shell=1]="Shell",j[j.Process=2]="Process",j[j.CustomExecution=3]="CustomExecution"})(v||(e.RuntimeType=v={})),function(j){function N(W){switch(W.toLowerCase()){case"shell":return j.Shell;case"process":return j.Process;case"customExecution":return j.CustomExecution;default:return j.Process}}j.fromString=N;function B(W){switch(W){case j.Shell:return"shell";case j.Process:return"process";case j.CustomExecution:return"customExecution";default:return"process"}}j.toString=B}(v||(e.RuntimeType=v={}));var a;(function(j){function N(B){return L.$Vf(B)?B:B.value}j.value=N})(a||(e.CommandString=a={}));var m;(function(j){j.Clean={_id:"clean",isDefault:!1},j.Build={_id:"build",isDefault:!1},j.Rebuild={_id:"rebuild",isDefault:!1},j.Test={_id:"test",isDefault:!1};function N(W){return W===j.Clean._id||W===j.Build._id||W===j.Rebuild._id||W===j.Test._id}j.is=N;function B(W){if(W!==void 0)return L.$Vf(W)?N(W)?{_id:W,isDefault:!1}:void 0:W}j.from=B})(m||(e.TaskGroup=m={}));var o;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var n;(function(j){j.Workspace="workspace",j.Extension="extension",j.InMemory="inMemory",j.WorkspaceFile="workspaceFile",j.User="user";function N(B){switch(B){case j.User:return 2;case j.WorkspaceFile:return 5;default:return 6}}j.toConfigurationTarget=N})(n||(e.TaskSourceKind=n={}));var i;(function(j){j.parallel="parallel",j.sequence="sequence"})(i||(e.DependsOrder=i={}));var r;(function(j){j[j.default=1]="default",j[j.folderOpen=2]="folderOpen"})(r||(e.RunOnOptions=r={}));var s;(function(j){j.defaults={reevaluateOnRerun:!0,runOn:r.default,instanceLimit:1}})(s||(e.RunOptions=s={}));class t{constructor(N,B,W,Z,_,X){this._label="",this._id=N,B&&(this._label=B),W&&(this.type=W),this.runOptions=Z,this.configurationProperties=_,this._source=X}getDefinition(N){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const N={folder:this.d(),id:this._id};return JSON.stringify(N)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(N,B=!1){if(N===void 0)return!1;if(L.$Vf(N))return N===this._label||N===this.configurationProperties.identifier||B&&N===this._id;const W=this.getDefinition(!0);return W!==void 0&&W._key===N._key}getQualifiedLabel(){const N=this.getWorkspaceFolder();return N?`${this._label} (${N.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(N){this.c===void 0&&(this.c=[]),N&&(this.c=this.c.concat(N))}get taskLoadMessages(){return this.c}}e.$xH=t;class f extends t{constructor(N,B,W,Z,_,X,x,re){super(N,W,void 0,x,re,B),this.command={},this._source=B,this.hasDefinedMatchers=X,_&&(this.command=_)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(N=!1){if(N&&this._source.customizes!==void 0)return this._source.customizes;{let B;switch(this.command?this.command.runtime:void 0){case v.Shell:B="shell";break;case v.Process:B="process";break;case v.CustomExecution:B="customExecution";break;case void 0:B="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:B,_key:this._id,id:this._id}}}static is(N){return N instanceof f}getMapKey(){const N=this._source.config.workspaceFolder;return N?`${N.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$tH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const N=this.d();if(!N)return;let B=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(B+=this._source.kind);const W={type:e.$wH,folder:N,id:B};return JSON.stringify(W)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?M.$Sg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(N){return new f(N._id,N._source,N._label,N.type,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$yH=f;class d extends t{constructor(N,B,W,Z,_,X,x){super(N,W,Z,X,x,B),this._source=B,this.configures=_}static is(N){return N instanceof d}f(N){return N}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?M.$Sg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$tH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const N=this.d();if(!N)return;let B=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(B+=this._source.kind);const W={type:e.$wH,folder:N,id:B};return JSON.stringify(W)}}e.$zH=d;class l extends t{constructor(N,B,W,Z,_,X,x,re,Y){super(N,W,Z,re,Y,B),this.defines=_,this.hasDefinedMatchers=x,this.command=X,this.icon=Y.icon,this.hide=Y.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(N){return N instanceof l}getMapKey(){const N=this._source.workspaceFolder;return N?`${this._source.scope.toString()}|${N.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const N={type:"contributed",scope:this._source.scope,id:this._id};return N.folder=this.d(),JSON.stringify(N)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(N){return new l(N._id,N._source,N._label,N.type,N.defines,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$AH=l;class c extends t{constructor(N,B,W,Z,_,X){super(N,W,Z,_,X,B),this._source=B}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(N){return N instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(N){return new c(N._id,N._source,N._label,N.type,N.runOptions,N.configurationProperties)}}e.$BH=c;var h;(function(j){j[j.Process=1]="Process",j[j.Terminal=2]="Terminal"})(h||(e.ExecutionEngine=h={})),function(j){j._default=j.Terminal}(h||(e.ExecutionEngine=h={}));var g;(function(j){j[j.V0_1_0=1]="V0_1_0",j[j.V2_0_0=2]="V2_0_0"})(g||(e.JsonSchemaVersion=g={}));class S{constructor(N){this.c=new Map;for(let B=0;B<N.length;B++)this.c.set(N[B].uri.toString(),B)}compare(N,B){const W=N.getWorkspaceFolder(),Z=B.getWorkspaceFolder();if(W&&Z){let _=this.c.get(W.uri.toString());_=_===void 0?0:_+1;let X=this.c.get(Z.uri.toString());return X=X===void 0?0:X+1,_===X?N._label.localeCompare(B._label):_-X}else return!W&&Z?-1:W&&!Z?1:0}}e.$CH=S;var w;(function(j){j.DependsOnStarted="dependsOnStarted",j.AcquiredInput="acquiredInput",j.Start="start",j.ProcessStarted="processStarted",j.Active="active",j.Inactive="inactive",j.Changed="changed",j.Terminated="terminated",j.ProcessEnded="processEnded",j.End="end"})(w||(e.TaskEventKind=w={}));var C;(function(j){j.SingleRun="singleRun",j.Background="background"})(C||(e.TaskRunType=C={}));var k;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.FolderOpen=2]="FolderOpen",j[j.ConfigurationChange=3]="ConfigurationChange",j[j.Reconnect=4]="Reconnect"})(k||(e.TaskRunSource=k={}));var D;(function(j){function N(re){return{taskId:re._id,taskName:re.configurationProperties.name,runType:re.configurationProperties.isBackground?"background":"singleRun",group:re.configurationProperties.group,__task:re}}function B(re,Y,me){return{...N(re),kind:"start",terminalId:Y,resolvedVariables:me}}j.start=B;function W(re,Y,me){return{...N(re),kind:"processStarted",terminalId:Y,processId:me}}j.processStarted=W;function Z(re,Y,me){return{...N(re),kind:"processEnded",terminalId:Y,exitCode:me}}j.processEnded=Z;function _(re,Y,me){return{...N(re),kind:"terminated",exitReason:me,terminalId:Y}}j.terminated=_;function X(re,Y,me){return{...N(Y),kind:re,terminalId:me}}j.general=X;function x(){return{kind:"changed"}}j.changed=x})(D||(e.TaskEvent=D={}));var O;(function(j){function N(W){const Z=Object.keys(W).sort();let _="";for(const X of Z){let x=W[X];x instanceof Object?x=N(x):typeof x=="string"&&(x=x.replace(/,/g,",,")),_+=X+","+x+","}return _}function B(W){const _={_key:N(W),type:W.taskType};return Object.assign(_,W),_}j.create=B})(O||(e.KeyedTaskIdentifier=O={}));var F;(function(j){j.AutoDetect="task.autoDetect",j.SaveBeforeRun="task.saveBeforeRun",j.ShowDecorations="task.showDecorations",j.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",j.SlowProviderWarning="task.slowProviderWarning",j.QuickOpenHistory="task.quickOpen.history",j.QuickOpenDetail="task.quickOpen.detail",j.QuickOpenSkip="task.quickOpen.skip",j.QuickOpenShowAll="task.quickOpen.showAll",j.AllowAutomaticTasks="task.allowAutomaticTasks",j.Reconnection="task.reconnection",j.VerboseLogging="task.verboseLogging"})(F||(e.TaskSettingId=F={}));var T;(function(j){j.Tasks="tasks",j.SuppressTaskName="tasks.suppressTaskName",j.Windows="tasks.windows",j.Osx="tasks.osx",j.Linux="tasks.linux",j.ShowOutput="tasks.showOutput",j.IsShellCommand="tasks.isShellCommand",j.ServiceTestSetting="tasks.service.testSetting"})(T||(e.TasksSchemaProperties=T={}));var z;(function(j){function N(B,W){const Z=b.$sH.get(B.type);if(Z===void 0){const re=P.$On(B);return delete re._key,O.create(re)}const _=Object.create(null);_.type=Z.taskType;const X=new Set;Z.required.forEach(re=>X.add(re));const x=Z.properties;for(const re of Object.keys(x)){const Y=B[re];if(Y!=null)_[re]=Y;else if(X.has(re)){const me=x[re];if(me.default!==void 0)_[re]=P.$On(me.default);else switch(me.type){case"boolean":_[re]=!1;break;case"number":case"integer":_[re]=0;break;case"string":_[re]="";break;default:W.error(u.localize(1,null,JSON.stringify(B,void 0,0),re));return}}}return O.create(_)}j.createTaskIdentifier=N})(z||(e.TaskDefinition=z={}))}),define(ke[308],Ee([1,0,13]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$20b=e.$10b=void 0;class L{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,b)=>{this.b=R,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,u.$1)(R))}then(R,b){return this.j().then(R,b)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$10b=L;class M extends L{constructor(){super(),this.h=!0,this.i=new u.$5}}e.$20b=M}),define(ke[68],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ew=e.$bw=void 0,e.$cw=M,e.$dw=P;class u{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++u.count}}e.$bw=u;const L=[];function M(b){const $=new u(b);return L[$.nid]=$,$}function P(b){return L[b].sid}class R{constructor($){this.value=$}}e.$ew=R}),define(ke[6],Ee([1,0,68]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mM=e.$lM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$kM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var L;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(L||(e.TextEditorRevealType=L={}));var M;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput",a[a.ChatEditorInput=10]="ChatEditorInput",a[a.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(M||(e.TabInputKind=M={}));var P;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(P||(e.TabModelOperationKind=P={}));var R;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var b;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var $;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var y;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(y||(e.NotebookEditorRevealType=y={}));var A;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class I{static{this.a=0}static mixin(m){return m._id=I.a++,m}}e.$kM=I;var p;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.kindModifier="m",a.commandIdent="n",a.commandId="o",a.commandArguments="p"})(p||(e.ISuggestDataDtoField=p={}));var E;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(E||(e.ISuggestResultDtoField=E={}));var v;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(v||(e.ExtHostTestingResource=v={})),e.$lM={MainThreadAuthentication:(0,u.$cw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,u.$cw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,u.$cw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,u.$cw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,u.$cw)("MainThreadChatVariables"),MainThreadClipboard:(0,u.$cw)("MainThreadClipboard"),MainThreadCommands:(0,u.$cw)("MainThreadCommands"),MainThreadComments:(0,u.$cw)("MainThreadComments"),MainThreadConfiguration:(0,u.$cw)("MainThreadConfiguration"),MainThreadConsole:(0,u.$cw)("MainThreadConsole"),MainThreadDebugService:(0,u.$cw)("MainThreadDebugService"),MainThreadDecorations:(0,u.$cw)("MainThreadDecorations"),MainThreadDiagnostics:(0,u.$cw)("MainThreadDiagnostics"),MainThreadDialogs:(0,u.$cw)("MainThreadDiaglogs"),MainThreadDocuments:(0,u.$cw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,u.$cw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,u.$cw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,u.$cw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,u.$cw)("MainThreadEditorTabs"),MainThreadErrors:(0,u.$cw)("MainThreadErrors"),MainThreadTreeViews:(0,u.$cw)("MainThreadTreeViews"),MainThreadDownloadService:(0,u.$cw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,u.$cw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,u.$cw)("MainThreadLanguages"),MainThreadLogger:(0,u.$cw)("MainThreadLogger"),MainThreadMessageService:(0,u.$cw)("MainThreadMessageService"),MainThreadOutputService:(0,u.$cw)("MainThreadOutputService"),MainThreadProgress:(0,u.$cw)("MainThreadProgress"),MainThreadQuickDiff:(0,u.$cw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,u.$cw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,u.$cw)("MainThreadStatusBar"),MainThreadSecretState:(0,u.$cw)("MainThreadSecretState"),MainThreadStorage:(0,u.$cw)("MainThreadStorage"),MainThreadSpeech:(0,u.$cw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,u.$cw)("MainThreadTelemetry"),MainThreadTerminalService:(0,u.$cw)("MainThreadTerminalService"),MainThreadWebviews:(0,u.$cw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,u.$cw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,u.$cw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,u.$cw)("MainThreadCustomEditors"),MainThreadUrls:(0,u.$cw)("MainThreadUrls"),MainThreadUriOpeners:(0,u.$cw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,u.$cw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,u.$cw)("MainThreadWorkspace"),MainThreadFileSystem:(0,u.$cw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,u.$cw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,u.$cw)("MainThreadExtensionService"),MainThreadSCM:(0,u.$cw)("MainThreadSCM"),MainThreadSearch:(0,u.$cw)("MainThreadSearch"),MainThreadShare:(0,u.$cw)("MainThreadShare"),MainThreadTask:(0,u.$cw)("MainThreadTask"),MainThreadWindow:(0,u.$cw)("MainThreadWindow"),MainThreadLabelService:(0,u.$cw)("MainThreadLabelService"),MainThreadNotebook:(0,u.$cw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,u.$cw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,u.$cw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,u.$cw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,u.$cw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,u.$cw)("MainThreadInteractive"),MainThreadChat:(0,u.$cw)("MainThreadChat"),MainThreadInlineChat:(0,u.$cw)("MainThreadInlineChatShape"),MainThreadTheming:(0,u.$cw)("MainThreadTheming"),MainThreadTunnelService:(0,u.$cw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,u.$cw)("MainThreadManagedSockets"),MainThreadTimeline:(0,u.$cw)("MainThreadTimeline"),MainThreadTesting:(0,u.$cw)("MainThreadTesting"),MainThreadLocalization:(0,u.$cw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,u.$cw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,u.$cw)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,u.$cw)("MainThreadIssueReporter")},e.$mM={ExtHostCommands:(0,u.$cw)("ExtHostCommands"),ExtHostConfiguration:(0,u.$cw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,u.$cw)("ExtHostDiagnostics"),ExtHostDebugService:(0,u.$cw)("ExtHostDebugService"),ExtHostDecorations:(0,u.$cw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,u.$cw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,u.$cw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,u.$cw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,u.$cw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,u.$cw)("ExtHostEditors"),ExtHostTreeViews:(0,u.$cw)("ExtHostTreeViews"),ExtHostFileSystem:(0,u.$cw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,u.$cw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,u.$cw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,u.$cw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,u.$cw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,u.$cw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,u.$cw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,u.$cw)("ExtHostStatusBar"),ExtHostShare:(0,u.$cw)("ExtHostShare"),ExtHostExtensionService:(0,u.$cw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,u.$cw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,u.$cw)("ExtHostTerminalService"),ExtHostSCM:(0,u.$cw)("ExtHostSCM"),ExtHostSearch:(0,u.$cw)("ExtHostSearch"),ExtHostTask:(0,u.$cw)("ExtHostTask"),ExtHostWorkspace:(0,u.$cw)("ExtHostWorkspace"),ExtHostWindow:(0,u.$cw)("ExtHostWindow"),ExtHostWebviews:(0,u.$cw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,u.$cw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,u.$cw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,u.$cw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,u.$cw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,u.$cw)("ExtHostEditorTabs"),ExtHostProgress:(0,u.$cw)("ExtHostProgress"),ExtHostComments:(0,u.$cw)("ExtHostComments"),ExtHostSecretState:(0,u.$cw)("ExtHostSecretState"),ExtHostStorage:(0,u.$cw)("ExtHostStorage"),ExtHostUrls:(0,u.$cw)("ExtHostUrls"),ExtHostUriOpeners:(0,u.$cw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,u.$cw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,u.$cw)("ExtHostOutputService"),ExtHostLabelService:(0,u.$cw)("ExtHostLabelService"),ExtHostNotebook:(0,u.$cw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,u.$cw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,u.$cw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,u.$cw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,u.$cw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,u.$cw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,u.$cw)("ExtHostInteractive"),ExtHostInlineChat:(0,u.$cw)("ExtHostInlineChatShape"),ExtHostChat:(0,u.$cw)("ExtHostChat"),ExtHostChatAgents2:(0,u.$cw)("ExtHostChatAgents"),ExtHostChatVariables:(0,u.$cw)("ExtHostChatVariables"),ExtHostChatProvider:(0,u.$cw)("ExtHostChatProvider"),ExtHostSpeech:(0,u.$cw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,u.$cw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,u.$cw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,u.$cw)("ExtHostTheming"),ExtHostTunnelService:(0,u.$cw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,u.$cw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,u.$cw)("ExtHostAuthentication"),ExtHostTimeline:(0,u.$cw)("ExtHostTimeline"),ExtHostTesting:(0,u.$cw)("ExtHostTesting"),ExtHostTelemetry:(0,u.$cw)("ExtHostTelemetry"),ExtHostLocalization:(0,u.$cw)("ExtHostLocalization"),ExtHostIssueReporter:(0,u.$cw)("ExtHostIssueReporter")}}),define(ke[91],Ee([1,0,5,12,6,20]),function(he,e,u,L,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ic=e.$4ic=e.$3ic=void 0,e.$3ic=(0,u.$ii)("IExtHostApiDeprecationService");let R=class{constructor($,y){this.c=y,this.a=new Set,this.b=$.getProxy(M.$lM.MainThreadTelemetry)}report($,y,A){const I=this.d($,y);this.a.has(I)||(this.a.add(I),y.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:y.identifier.value,apiId:$}))}d($,y){return`${$}-${y.identifier.value}`}};e.$4ic=R,e.$4ic=R=Je([qe(0,P.$GO),qe(1,L.$Oj)],R),e.$5ic=Object.freeze(new class{report(b,$,y){}})}),define(ke[309],Ee([1,0,38,3,6]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$djc=void 0;class P{static{this.a=0}constructor($,y){this.extension=$,this.provider=y,this.handle=P.a++}}class R{static{this.a=0}constructor($){this.b=new Map,this.c=new Map,this.d=$.getProxy(M.$lM.MainThreadChat)}registerChatProvider($,y,A){const I=new P($,A);return this.b.set(I.handle,I),this.d.$registerChatProvider(I.handle,y),(0,L.$Sc)(()=>{this.d.$unregisterChatProvider(I.handle),this.b.delete(I.handle)})}transferChatSession($,y){const A=u.Iterable.find(this.c.keys(),I=>this.c.get(I)===$)??0;typeof A=="number"&&this.d.$transferChatSession(A,y)}async $prepareChat($,y){const A=this.b.get($);if(!A)return;const I=await A.provider.prepareSession(y);if(!I)return;const p=R.a++;return this.c.set(p,I),{id:p}}$releaseSession($){this.c.delete($)}}e.$djc=R}),define(ke[310],Ee([1,0,6]),function(he,e,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ijc=void 0;class L{constructor(P){const R=P.getProxy(u.$lM.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(b){return R.$writeText(b)}})}}e.$ijc=L}),define(ke[311],Ee([1,0,24,6,28,20]),function(he,e,u,L,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_kc=void 0;let R=class{constructor(A,I){this.a=A.getProxy(L.$lM.MainThreadConsole),this.b=I.consoleForward.includeStack,this.c=I.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(A,I){const p=this,E=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){p.e(A,I,E,arguments)}})}e(A,I,p,E){this.a.$logExtensionHostMessage({type:"__$console",severity:I,arguments:$(E,this.b)}),this.c&&this.f(A,p,E)}};e.$_kc=R,e.$_kc=R=Je([qe(0,P.$GO),qe(1,M.$WO)],R);const b=1e5;function $(y,A){const I=[];if(y.length)for(let p=0;p<y.length;p++){let E=y[p];if(typeof E>"u")E="undefined";else if(E instanceof Error){const v=E;v.stack?E=v.stack:E=v.toString()}I.push(E)}if(A){const p=new Error().stack;p&&I.push({__$stack:p.split(`
`).slice(3).join(`
`)})}try{const p=(0,u.$Tn)(I);return p.length>b?"Output omitted for a large object that exceeds the limits":p}catch(p){return`Output omitted for an object that cannot be inspected ('${p.toString()}')`}}}),define(ke[312],Ee([1,0,2,6,26]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dkc=void 0;class P{constructor(b){this.a=b.getProxy(L.$lM.MainThreadDialogs)}showOpenDialog(b,$){return $?.allowUIResources&&(0,M.$0F)(b,"showLocal"),this.a.$showOpenDialog($).then(y=>y?y.map(A=>u.URI.revive(A)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then($=>$?u.URI.revive($):void 0)}}e.$dkc=P}),define(ke[313],Ee([1,0,3,6]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ykc=void 0;class M{constructor(R){this.b=0,this.a=R.getProxy(L.$lM.MainThreadLabelService)}$registerResourceLabelFormatter(R){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,R),(0,u.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$ykc=M}),define(ke[115],Ee([1,0,11,14,2,5,12,6,28,20]),function(he,e,u,L,M,P,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yjc=e.$Xjc=void 0;let A=class{constructor(p,E,v){this.f=v,this.d=new Map,this.a=E.getProxy(b.$lM.MainThreadLocalization),this.b=p.environment.appLanguage,this.c=this.b===u.$g}getMessage(p,E){const{message:v,args:a,comment:m}=E;if(this.c)return(0,L.$We)(v,a??{});let o=v;m&&m.length>0&&(o+=`/${Array.isArray(m)?m.join(""):m}`);const n=this.d.get(p)?.contents[o];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,L.$We)(n??v,a??{})}getBundle(p){return this.d.get(p)?.contents}getBundleUri(p){return this.d.get(p)?.uri}async initializeLocalizedMessages(p){if(this.c||!p.l10n&&!p.isBuiltin||this.d.has(p.identifier.value))return;let E;const v=await this.g(p);if(!v){this.f.error(`No bundle location found for extension ${p.identifier.value}`);return}try{const a=await this.a.$fetchBundleContents(v),m=JSON.parse(a);E=p.isBuiltin?m.contents?.bundle:m}catch(a){this.f.error(`Failed to load translations for ${p.identifier.value} from ${v}: ${a.message}`);return}E&&this.d.set(p.identifier.value,{contents:E,uri:v})}async g(p){if(p.isBuiltin){const E=await this.a.$fetchBuiltInBundleUri(p.identifier.value,this.b);return M.URI.revive(E)}return p.l10n?M.URI.joinPath(p.extensionLocation,p.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Xjc=A,e.$Xjc=A=Je([qe(0,$.$WO),qe(1,y.$GO),qe(2,R.$Oj)],A),e.$Yjc=(0,P.$ii)("IExtHostLocalizationService")}),define(ke[149],Ee([1,0,12,6,28,20,2,57]),function(he,e,u,L,M,P,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$kc=void 0;let $=class extends u.$Zj{constructor(I,p){super(p.logLevel,p.logsLocation,p.loggers.map(E=>(0,b.$Rh)(E))),this.r=I.getProxy(L.$lM.MainThreadLogger)}$setLogLevel(I,p){p?this.setLogLevel(R.URI.revive(p),I):this.setLogLevel(I)}setVisibility(I,p){super.setVisibility(I,p),this.r.$setVisibility(I,p)}s(I,p,E){return new y(this.r,I,p,E)}};e.$$kc=$,e.$$kc=$=Je([qe(0,P.$GO),qe(1,M.$WO)],$);class y extends u.$Uj{constructor(I,p,E,v){super(v?.logLevel==="always"),this.r=I,this.s=p,this.m=!1,this.n=[],this.setLevel(E),this.r.$createLogger(p,v).then(()=>{this.u(this.n),this.m=!0})}g(I,p){const E=[[I,p]];this.m?this.u(E):this.n.push(...E)}u(I){this.r.$log(this.s,I)}flush(){this.r.$flush(this.s)}}}),define(ke[116],Ee([1,0,6,5,3,20,21]),function(he,e,u,L,M,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1jc=e.$Zjc=void 0,e.$Zjc=(0,L.$ii)("IExtHostManagedSockets");let b=class{constructor(I){this.b=0,this.c=null,this.d=new Map,this.a=I.getProxy(u.$lM.MainThreadManagedSockets)}setFactory(I,p){for(const E of this.d.values())E.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(I,p),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(I){if(!this.c||this.c.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const p=++this.b,E=await this.c.makeConnection(),v=new M.$Tc;return this.d.set(p,new y(p,E,v)),v.add((0,M.$Sc)(()=>this.d.delete(p))),v.add(E.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(p),v.dispose()})),v.add(E.onDidClose(a=>{this.a.$onDidManagedSocketClose(p,a?.stack??a?.message),v.dispose()})),v.add(E.onDidReceiveMessage(a=>this.a.$onDidManagedSocketHaveData(p,R.$ue.wrap(a)))),p}$remoteSocketWrite(I,p){this.d.get(I)?.actual.send(p.buffer)}$remoteSocketEnd(I){const p=this.d.get(I);p&&(p.actual.end(),p.dispose())}async $remoteSocketDrain(I){await this.d.get(I)?.actual.drain?.()}};e.$1jc=b,e.$1jc=b=Je([qe(0,P.$GO)],b);class ${constructor(I,p){this.socketFactoryId=I,this.makeConnection=p}}class y extends M.$Uc{constructor(I,p,E){super(),this.socketId=I,this.actual=p,this.B(E)}}}),define(ke[314],Ee([1,0,6,12,26]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Akc=void 0;function P(b){return b&&b.title}let R=class{constructor($,y){this.b=y,this.a=$.getProxy(u.$lM.MainThreadMessageService)}showMessage($,y,A,I,p){const E={source:{identifier:$.identifier,label:$.displayName||$.name}};let v;typeof I=="string"||P(I)?v=[I,...p]:(E.modal=I?.modal,E.useCustom=I?.useCustom,E.detail=I?.detail,v=p),E.useCustom&&(0,M.$0F)($,"resolvers");const a=[];let m=!1;for(let o=0;o<v.length;o++){const n=v[o];if(typeof n=="string")a.push({title:n,handle:o,isCloseAffordance:!1});else if(typeof n=="object"){const{title:i,isCloseAffordance:r}=n;a.push({title:i,isCloseAffordance:!!r,handle:o}),r&&(m?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,n):m=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,n)}return this.a.$showMessage(y,A,E,a).then(o=>{if(typeof o=="number")return v[o]})}};e.$Akc=R,e.$Akc=R=Je([qe(1,L.$Oj)],R)}),define(ke[315],Ee([1,0,3,18,2,26,6]),function(he,e,u,L,M,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jkc=void 0;class b{constructor(y){this.b=new Map,this.a=y.getProxy(R.$lM.MainThreadProfileContentHandlers)}registerProfileContentHandler(y,A,I){if((0,P.$0F)(y,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,I),this.a.$registerProfileContentHandler(A,I.name,I.description,y.identifier.value),(0,u.$Sc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(y,A,I,p){const E=this.b.get(y);if(!E)throw new Error(`Unknown handler with id: ${y}`);return E.saveProfile(A,I,p)}async $readProfile(y,A,I){const p=this.b.get(y);if(!p)throw new Error(`Unknown handler with id: ${y}`);return p.readProfile((0,L.$Vf)(A)?A:M.URI.revive(A),I)}}e.$Jkc=b}),define(ke[117],Ee([1,0,6,4,5]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vjc=e.$Ujc=void 0;class P{constructor(b){this.b=new L.$7d,this.onDidChangePassword=this.b.event,this.a=b.getProxy(u.$lM.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,$){return this.a.$getPassword(b,$)}store(b,$,y){return this.a.$setPassword(b,$,y)}delete(b,$){return this.a.$deletePassword(b,$)}}e.$Ujc=P,e.$Vjc=(0,M.$ii)("IExtHostSecretState")}),define(ke[316],Ee([1,0,22,3,6]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qkc=void 0;class P{static{this.a=1}constructor(b){this.c=new Map,this.d=new Map,this.b=b.getProxy(M.$lM.MainThreadSpeech)}async $createSpeechToTextSession(b,$,y){const A=this.c.get(b);if(!A)return;const I=new L.$Tc,p=new u.$ee;this.d.set($,p);const E=I.add(A.provideSpeechToTextSession(p.token,y?{language:y}:void 0));I.add(E.onDidChange(v=>{p.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,v)})),I.add(p.token.onCancellationRequested(()=>I.dispose()))}async $cancelSpeechToTextSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}async $createKeywordRecognitionSession(b,$){const y=this.c.get(b);if(!y)return;const A=new L.$Tc,I=new u.$ee;this.d.set($,I);const p=A.add(y.provideKeywordRecognitionSession(I.token));A.add(p.onDidChange(E=>{I.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,E)})),A.add(I.token.onCancellationRequested(()=>A.dispose()))}async $cancelKeywordRecognitionSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}registerProvider(b,$,y){const A=P.a++;return this.c.set(A,y),this.b.$registerProvider(A,$,{extension:b,displayName:b.value}),(0,L.$Sc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$Qkc=P}),define(ke[118],Ee([1,0,6,4,5]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Njc=e.$Mjc=void 0;class P{constructor(b,$){this.c=$,this.b=new L.$7d,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(u.$lM.MainThreadStorage)}registerExtensionStorageKeysToSync(b,$){this.a.$registerExtensionStorageKeysToSync(b,$)}async initializeExtensionStorage(b,$,y){const A=await this.a.$initializeExtensionStorage(b,$);let I;return A&&(I=this.d(b,$,A)),I||y}setValue(b,$,y){return this.a.$setValue(b,$,y)}$acceptValue(b,$,y){const A=this.d(b,$,y);A&&this.b.fire({shared:b,key:$,value:A})}d(b,$,y){try{return JSON.parse(y)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${b}): ${A}`)}}}e.$Mjc=P,e.$Njc=(0,M.$ii)("IExtHostStorage")}),define(ke[317],Ee([1,0,3,15,2,6]),function(he,e,u,L,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5kc=void 0;class R{static{this.a=new Set([L.Schemas.http,L.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(P.$lM.MainThreadUriOpeners)}registerExternalUriOpener($,y,A,I){if(this.c.has(y))throw new Error(`Opener with id '${y}' already registered`);const p=I.schemes.find(E=>!R.a.has(E));if(p)throw new Error(`Scheme '${p}' is not supported. Only http and https are currently supported.`);return this.c.set(y,A),this.b.$registerUriOpener(y,I.schemes,$,I.label),(0,u.$Sc)(()=>{this.c.delete(y),this.b.$unregisterUriOpener(y)})}async $canOpenUri($,y,A){const I=this.c.get($);if(!I)throw new Error(`Unknown opener with id: ${$}`);const p=M.URI.revive(y);return I.canOpenExternalUri(p,A)}async $openUri($,y,A){const I=this.c.get($);if(!I)throw new Error(`Unknown opener id: '${$}'`);return I.openExternalUri(M.URI.revive(y.resolvedUri),{sourceUri:M.URI.revive(y.sourceUri)},A)}}e.$5kc=R}),define(ke[318],Ee([1,0,6,2,3,13,25]),function(he,e,u,L,M,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6kc=void 0;class b{static{this.a=0}constructor(y){this.c=new R.$Em,this.d=new Map,this.b=y.getProxy(u.$lM.MainThreadUrls)}registerUriHandler(y,A){const I=y.identifier;if(this.c.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const p=b.a++;return this.c.add(I),this.d.set(p,A),this.b.$registerUriHandler(p,I,y.displayName||y.name),(0,M.$Sc)(()=>{this.c.delete(I),this.d.delete(p),this.b.$unregisterUriHandler(p)})}$handleExternalUri(y,A){const I=this.d.get(y);if(!I)return Promise.resolve(void 0);try{I.handleUri(L.URI.revive(A))}catch(p){(0,P.$1)(p)}return Promise.resolve(void 0)}async createAppUri(y){return L.URI.revive(await this.b.$createAppUri(y))}}e.$6kc=b}),define(ke[92],Ee([1,0,4,3,15,24,2,245,283,113,6]),function(he,e,u,L,M,P,R,b,$,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zjc=e.$xjc=void 0,e.$yjc=p,e.$Ajc=a,e.$Bjc=m;class I{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(r,s,t,f,d,l,c){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new u.$7d,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new u.$7d,this._onDidDispose=this.#h.event,this.#e=r,this.#t=s,this.#o=t,this.#n=f,this.#s=d,this.#r=l,this.#l=p(l),this.#d=E(l),this.#i=c}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(r){return this.#u=!0,(0,y.$$yb)(r,this.#n)}get cspSource(){const r=this.#r.extensionLocation;if(r.scheme===M.Schemas.https||r.scheme===M.Schemas.http){let s=r.toString();return s.endsWith("/")||(s+="/"),s+" "+y.$0yb}return y.$0yb}get html(){return this.a(),this.#a}set html(r){this.a(),this.#a!==r&&(this.#a=r,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(r)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(r)))}get options(){return this.a(),this.#o}set options(r){this.a(),P.$Sn(this.#o,r)||this.#t.$setOptions(this.#e,m(this.#r,this.#s,r)),this.#o=r}async postMessage(r){if(this.#c)return!1;const s=(0,$.$Vnb)(r,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,s.message,...s.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(r){if(!this.#d)return r;const s=this.#r.extensionLocation?.scheme===M.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===M.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return r.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,d,l,c,h,g)=>{const S=R.URI.from({scheme:c||"file",path:decodeURIComponent(h)}),w=(0,y.$$yb)(S,{isRemote:s,authority:t}).toString();return`${d}${w}${g}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,d,l,c,h,g)=>{const S=R.URI.from({scheme:c||"file",path:decodeURIComponent(h)}),w=(0,y.$$yb)(S,{isRemote:s,authority:t}).toString();return`${d}${w}${g}`})}}e.$xjc=I;function p(i){try{const r=(0,b.$up)((0,b.$tp)(i.engines.vscode));return!!r&&r.majorBase>=1&&r.minorBase>=57}catch{return!1}}function E(i){try{const r=(0,b.$up)((0,b.$tp)(i.engines.vscode));return r?r.majorBase<1||r.majorBase===1&&r.minorBase<60:!1}catch{return!1}}class v extends L.$Uc{constructor(r,s,t,f,d){super(),this.c=s,this.f=t,this.g=f,this.h=d,this.b=new Map,this.a=r.getProxy(A.$lM.MainThreadWebviews)}dispose(){super.dispose();for(const r of this.b.values())r.dispose();this.b.clear()}$onMessage(r,s,t){const f=this.j(r);if(f){const{message:d}=(0,$.$Wnb)(s,t.value);f._onMessageEmitter.fire(d)}}$onMissingCsp(r,s){this.g.warn(`${s} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(r,s,t){const f=new I(r,this.a,o(s),this.c,this.f,t,this.h);this.b.set(r,f);const d=f._onDidDispose(()=>{d.dispose(),this.deleteWebview(r)});return f}deleteWebview(r){this.b.delete(r)}j(r){return this.b.get(r)}}e.$zjc=v;function a(i){return{id:i.identifier,location:i.extensionLocation}}function m(i,r,s){return{enableCommandUris:s.enableCommandUris,enableScripts:s.enableScripts,enableForms:s.enableForms,portMapping:s.portMapping,localResourceRoots:s.localResourceRoots||n(i,r)}}function o(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(r=>R.URI.from(r))}}function n(i,r){return[...(r?.getWorkspaceFolders()||[]).map(s=>s.uri),i.extensionLocation]}}),define(ke[150],Ee([1,0,4,6,2,15,14,5,20,26]),function(he,e,u,L,M,P,R,b,$,y){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$9kc=e.$8kc=void 0;let I=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(E){const v=this.d;return{get focused(){return v.focused},get active(){return(0,y.$0F)(E,"windowActivity"),v.active}}}constructor(E){this.c=new u.$7d,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=E.getProxy(L.$lM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:v,isActive:a})=>{this.onDidChangeWindowProperty("focused",v),this.onDidChangeWindowProperty("active",a)})}$onDidChangeWindowFocus(E){this.onDidChangeWindowProperty("focused",E)}$onDidChangeWindowActive(E){this.onDidChangeWindowProperty("active",E)}onDidChangeWindowProperty(E,v){v!==this.d[E]&&(this.d={...this.d,[E]:v},this.c.fire(this.d))}openUri(E,v){let a;if(typeof E=="string"){a=E;try{E=M.URI.parse(E)}catch{return Promise.reject(`Invalid uri - '${E}'`)}}return(0,R.$Ue)(E.scheme)?Promise.reject("Invalid scheme - cannot be empty"):E.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${E.scheme}'`):this.b.$openUri(E,a,v)}async asExternalUri(E,v){if((0,R.$Ue)(E.scheme))return Promise.reject("Invalid scheme - cannot be empty");const a=await this.b.$asExternalUri(E,v);return M.URI.from(a)}};e.$8kc=I,e.$8kc=I=A=Je([qe(0,$.$GO)],I),e.$9kc=(0,b.$ii)("IExtHostWindow")}),define(ke[319],Ee([1,0,311,28,20]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Klc=void 0;const P=1024*1024;let R=class extends u.$_kc{constructor($,y){super($,y),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f($,y,A){const I=$==="error"||$==="warn"?process.stderr:process.stdout;this.g=!0,I.write(`
START_NATIVE_LOG
`),y.apply(console,A),I.write(`
END_NATIVE_LOG
`),this.g=!1}j($,y){const A=process[$],I=A.write;let p="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(E,v,a)=>{if(!this.g){p+=E.toString(v);const m=p.length>P?p.length:p.lastIndexOf(`
`);m!==-1&&(console[y](p.slice(0,m)),p=p.slice(m+1))}I.call(A,E,v,a)}})}};e.$Klc=R,e.$Klc=R=Je([qe(0,M.$GO),qe(1,L.$WO)],R)}),define(ke[320],Ee([1,0,149,15,260,30]),function(he,e,u,L,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wlc=void 0;class R extends u.$$kc{s($,y,A){return $.scheme===L.Schemas.file?new M.$TP(A?.name||(0,P.$Eg)(),$.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,y):super.s($,y,A)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$Wlc=R}),define(ke[321],Ee([1,0,8,21,22,13,4,3,133,308,68]),function(he,e,u,L,M,P,R,b,$,y,A){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$50b=e.ResponsiveState=e.RequestInitiator=void 0,e.$30b=m,e.$40b=o;function p(k,D){try{return JSON.stringify(k,D)}catch{return"null"}}const E="$$ref$$",v={[E]:-1};class a{constructor(D,O){this.jsonString=D,this.referencedBuffers=O}}function m(k,D=null,O=!1){const F=[];return{jsonString:(O?p:JSON.stringify)(k,(z,j)=>{if(typeof j>"u")return v;if(typeof j=="object"){if(j instanceof L.$ue){const N=F.push(j)-1;return{[E]:N}}if(D)return D(z,j)}return j}),referencedBuffers:F}}function o(k,D,O){return JSON.parse(k,(F,T)=>{if(T){const z=T[E];if(typeof z=="number")return D[z];if(O&&T.$mid===1)return O.transformIncoming(T)}return T})}function n(k,D){return JSON.stringify(k,D)}function i(k){return k?(D,O)=>O&&O.$mid===1?k.transformOutgoing(O):O:null}var r;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(r||(e.RequestInitiator=r={}));var s;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(s||(e.ResponsiveState=s={}));const t=()=>{},f=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class l extends b.$Uc{static{I=f}static{this.a=3*1e3}constructor(D,O=null,F=null){super(),this[I]=!0,this.b=this.B(new R.$7d),this.onDidChangeResponsiveState=this.b.event,this.c=D,this.f=O,this.g=F,this.h=i(this.g),this.j=!1,this.m=[],this.s=[];for(let T=0,z=A.$bw.count;T<z;T++)this.m[T]=null,this.s[T]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new u.$uh(()=>this.H(),1e3)),this.c.onMessage(T=>this.L(T))}dispose(){this.j=!0,Object.keys(this.w).forEach(D=>{const O=this.w[D];delete this.w[D],O.resolveErr(P.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(D){this.z===0&&(this.C=Date.now()+l.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(D){this.C=Date.now()+l.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(D){this.y!==D&&(this.y=D,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(D){return this.g?(0,$.$nn)(D,this.g):D}getProxy(D){const{nid:O,sid:F}=D;return this.s[O]||(this.s[O]=this.J(O,F)),this.s[O]}J(D,O){const F={get:(T,z)=>(typeof z=="string"&&!T[z]&&z.charCodeAt(0)===36&&(T[z]=(...j)=>this.U(D,z,j)),z===d?O:T[z])};return new Proxy(Object.create(null),F)}set(D,O){return this.m[D.nid]=O,O}assertRegistered(D){for(let O=0,F=D.length;O<F;O++){const T=D[O];if(!this.m[T.nid])throw new Error(`Missing proxy instance ${T.sid}`)}}L(D){if(this.j)return;const O=D.byteLength,F=h.read(D,0),T=F.readUInt8(),z=F.readUInt32();switch(T){case 1:case 2:{let{rpcId:j,method:N,args:B}=S.deserializeRequestJSONArgs(F);this.g&&(B=(0,$.$nn)(B,this.g)),this.M(O,z,j,N,B,T===2);break}case 3:case 4:{let{rpcId:j,method:N,args:B}=S.deserializeRequestMixedArgs(F);this.g&&(B=(0,$.$nn)(B,this.g)),this.M(O,z,j,N,B,T===4);break}case 5:{this.f?.logIncoming(O,z,0,"ack"),this.G(z);break}case 6:{this.N(O,z);break}case 7:{this.O(O,z,void 0);break}case 9:{let j=S.deserializeReplyOKJSON(F);this.g&&(j=(0,$.$nn)(j,this.g)),this.O(O,z,j);break}case 10:{const j=S.deserializeReplyOKJSONWithBuffers(F,this.g);this.O(O,z,j);break}case 8:{const j=S.deserializeReplyOKVSBuffer(F);this.O(O,z,j);break}case 11:{let j=S.deserializeReplyErrError(F);this.g&&(j=(0,$.$nn)(j,this.g)),this.P(O,z,j);break}case 12:{this.P(O,z,void 0);break}default:console.error("received unexpected message"),console.error(D)}}M(D,O,F,T,z,j){this.f?.logIncoming(D,O,1,`receiveRequest ${(0,A.$dw)(F)}.${T}(`,z);const N=String(O);let B,W;if(j){const _=new M.$ee;z.push(_.token),B=this.Q(F,T,z),W=()=>_.cancel()}else B=this.Q(F,T,z),W=t;this.u[N]=W;const Z=S.serializeAcknowledged(O);this.f?.logOutgoing(Z.byteLength,O,1,"ack"),this.c.send(Z),B.then(_=>{delete this.u[N];const X=S.serializeReplyOK(O,_,this.h);this.f?.logOutgoing(X.byteLength,O,1,"reply:",_),this.c.send(X)},_=>{delete this.u[N];const X=S.serializeReplyErr(O,_);this.f?.logOutgoing(X.byteLength,O,1,"replyErr:",_),this.c.send(X)})}N(D,O){this.f?.logIncoming(D,O,1,"receiveCancel");const F=String(O);this.u[F]?.()}O(D,O,F){this.f?.logIncoming(D,O,0,"receiveReply:",F);const T=String(O);if(!this.w.hasOwnProperty(T))return;const z=this.w[T];delete this.w[T],z.resolveOk(F)}P(D,O,F){this.f?.logIncoming(D,O,0,"receiveReplyErr:",F);const T=String(O);if(!this.w.hasOwnProperty(T))return;const z=this.w[T];delete this.w[T];let j;F&&(F.$isError?(j=new Error,j.name=F.name,j.message=F.message,j.stack=F.stack):j=F),z.resolveErr(j)}Q(D,O,F){try{return Promise.resolve(this.S(D,O,F))}catch(T){return Promise.reject(T)}}S(D,O,F){const T=this.m[D];if(!T)throw new Error("Unknown actor "+(0,A.$dw)(D));const z=T[O];if(typeof z!="function")throw new Error("Unknown method "+O+" on actor "+(0,A.$dw)(D));return z.apply(T,F)}U(D,O,F){if(this.j)return new y.$20b;let T=null;if(F.length>0&&M.CancellationToken.isCancellationToken(F[F.length-1])&&(T=F.pop()),T&&T.isCancellationRequested)return Promise.reject(P.$6());const z=S.serializeRequestArguments(F,this.h),j=++this.t,N=String(j),B=new y.$10b,W=new b.$Tc;T&&W.add(T.onCancellationRequested(()=>{const _=S.serializeCancel(j);this.f?.logOutgoing(_.byteLength,j,0,"cancel"),this.c.send(S.serializeCancel(j))})),this.w[N]=new c(B,W),this.F(j);const Z=S.serializeRequest(j,D,O,z,!!T);return this.f?.logOutgoing(Z.byteLength,j,0,`request: ${(0,A.$dw)(D)}.${O}(`,F),this.c.send(Z),B}}e.$50b=l;class c{constructor(D,O){this.a=D,this.b=O}resolveOk(D){this.a.resolveOk(D),this.b.dispose()}resolveErr(D){this.a.resolveErr(D),this.b.dispose()}}class h{static alloc(D,O,F){const T=new h(L.$ue.alloc(F+1+4),0);return T.writeUInt8(D),T.writeUInt32(O),T}static read(D,O){return new h(D,O)}get buffer(){return this.a}constructor(D,O){this.a=D,this.b=O}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(D){this.a.writeUInt8(D,this.b),this.b+=1}readUInt8(){const D=this.a.readUInt8(this.b);return this.b+=1,D}writeUInt32(D){this.a.writeUInt32BE(D,this.b),this.b+=4}readUInt32(){const D=this.a.readUInt32BE(this.b);return this.b+=4,D}static sizeShortString(D){return 1+D.byteLength}writeShortString(D){this.a.writeUInt8(D.byteLength,this.b),this.b+=1,this.a.set(D,this.b),this.b+=D.byteLength}readShortString(){const D=this.a.readUInt8(this.b);this.b+=1;const F=this.a.slice(this.b,this.b+D).toString();return this.b+=D,F}static sizeLongString(D){return 4+D.byteLength}writeLongString(D){this.a.writeUInt32BE(D.byteLength,this.b),this.b+=4,this.a.set(D,this.b),this.b+=D.byteLength}readLongString(){const D=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+D).toString();return this.b+=D,F}writeBuffer(D){this.a.writeUInt32BE(D.byteLength,this.b),this.b+=4,this.a.set(D,this.b),this.b+=D.byteLength}static sizeVSBuffer(D){return 4+D.byteLength}writeVSBuffer(D){this.a.writeUInt32BE(D.byteLength,this.b),this.b+=4,this.a.set(D,this.b),this.b+=D.byteLength}readVSBuffer(){const D=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+D);return this.b+=D,O}static sizeMixedArray(D){let O=0;O+=1;for(let F=0,T=D.length;F<T;F++){const z=D[F];switch(O+=1,z.type){case 1:O+=this.sizeLongString(z.value);break;case 2:O+=this.sizeVSBuffer(z.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(z.value);for(let j=0;j<z.buffers.length;++j)O+=this.sizeVSBuffer(z.buffers[j]);break;case 4:break}}return O}writeMixedArray(D){this.a.writeUInt8(D.length,this.b),this.b+=1;for(let O=0,F=D.length;O<F;O++){const T=D[O];switch(T.type){case 1:this.writeUInt8(1),this.writeLongString(T.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(T.value);break;case 3:this.writeUInt8(3),this.writeUInt32(T.buffers.length),this.writeLongString(T.value);for(let z=0;z<T.buffers.length;++z)this.writeBuffer(T.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const D=this.a.readUInt8(this.b);this.b+=1;const O=new Array(D);for(let F=0;F<D;F++)switch(this.readUInt8()){case 1:O[F]=this.readLongString();break;case 2:O[F]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),j=this.readLongString(),N=[];for(let B=0;B<z;++B)N.push(this.readVSBuffer());O[F]=new A.$ew(o(j,N,null));break}case 4:O[F]=void 0;break}return O}}var g;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(g||(g={}));class S{static a(D){for(let O=0,F=D.length;O<F;O++)if(D[O]instanceof L.$ue||D[O]instanceof A.$ew||typeof D[O]>"u")return!0;return!1}static serializeRequestArguments(D,O){if(this.a(D)){const F=[];for(let T=0,z=D.length;T<z;T++){const j=D[T];if(j instanceof L.$ue)F[T]={type:2,value:j};else if(typeof j>"u")F[T]={type:4};else if(j instanceof A.$ew){const{jsonString:N,referencedBuffers:B}=m(j.value,O);F[T]={type:3,value:L.$ue.fromString(N),buffers:B}}else F[T]={type:1,value:L.$ue.fromString(n(j,O))}}return{type:1,args:F}}return{type:0,args:n(D,O)}}static serializeRequest(D,O,F,T,z){switch(T.type){case 0:return this.b(D,O,F,T.args,z);case 1:return this.c(D,O,F,T.args,z)}}static b(D,O,F,T,z){const j=L.$ue.fromString(F),N=L.$ue.fromString(T);let B=0;B+=h.sizeUInt8(),B+=h.sizeShortString(j),B+=h.sizeLongString(N);const W=h.alloc(z?2:1,D,B);return W.writeUInt8(O),W.writeShortString(j),W.writeLongString(N),W.buffer}static deserializeRequestJSONArgs(D){const O=D.readUInt8(),F=D.readShortString(),T=D.readLongString();return{rpcId:O,method:F,args:JSON.parse(T)}}static c(D,O,F,T,z){const j=L.$ue.fromString(F);let N=0;N+=h.sizeUInt8(),N+=h.sizeShortString(j),N+=h.sizeMixedArray(T);const B=h.alloc(z?4:3,D,N);return B.writeUInt8(O),B.writeShortString(j),B.writeMixedArray(T),B.buffer}static deserializeRequestMixedArgs(D){const O=D.readUInt8(),F=D.readShortString(),T=D.readMixedArray(),z=new Array(T.length);for(let j=0,N=T.length;j<N;j++){const B=T[j];typeof B=="string"?z[j]=JSON.parse(B):z[j]=B}return{rpcId:O,method:F,args:z}}static serializeAcknowledged(D){return h.alloc(5,D,0).buffer}static serializeCancel(D){return h.alloc(6,D,0).buffer}static serializeReplyOK(D,O,F){if(typeof O>"u")return this.d(D);if(O instanceof L.$ue)return this.e(D,O);if(O instanceof A.$ew){const{jsonString:T,referencedBuffers:z}=m(O.value,F,!0);return this.g(D,T,z)}else return this.f(D,p(O,F))}static d(D){return h.alloc(7,D,0).buffer}static e(D,O){let F=0;F+=h.sizeVSBuffer(O);const T=h.alloc(8,D,F);return T.writeVSBuffer(O),T.buffer}static deserializeReplyOKVSBuffer(D){return D.readVSBuffer()}static f(D,O){const F=L.$ue.fromString(O);let T=0;T+=h.sizeLongString(F);const z=h.alloc(9,D,T);return z.writeLongString(F),z.buffer}static g(D,O,F){const T=L.$ue.fromString(O);let z=0;z+=h.sizeUInt32,z+=h.sizeLongString(T);for(const N of F)z+=h.sizeVSBuffer(N);const j=h.alloc(10,D,z);j.writeUInt32(F.length),j.writeLongString(T);for(const N of F)j.writeBuffer(N);return j.buffer}static deserializeReplyOKJSON(D){const O=D.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(D,O){const F=D.readUInt32(),T=D.readLongString(),z=[];for(let j=0;j<F;++j)z.push(D.readVSBuffer());return new A.$ew(o(T,z,O))}static serializeReplyErr(D,O){const F=O?p(P.$3(O),null):void 0;if(typeof F!="string")return this.h(D);const T=L.$ue.fromString(F);let z=0;z+=h.sizeLongString(T);const j=h.alloc(11,D,z);return j.writeLongString(T),j.buffer}static deserializeReplyErrError(D){const O=D.readLongString();return JSON.parse(O)}static h(D){return h.alloc(12,D,0).buffer}}var w;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(w||(w={}));var C;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(C||(C={}))}),define(ke[322],Ee([1,0,21,27,15,84,5]),function(he,e,u,L,M,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3J=e.$ZJ=void 0,e.$1J=A,e.$2J=I,e.$ZJ=(0,R.$ii)("notebookDocumentService");const b=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${b.join("")}]+`),y=7;function A(E){if(E.scheme!==M.Schemas.vscodeNotebookCell)return;const v=E.fragment.indexOf("s");if(v<0)return;const a=parseInt(E.fragment.substring(0,v).replace($,""),y),m=(0,u.$Ne)(E.fragment.substring(v+1)).toString();if(!isNaN(a))return{handle:a,notebook:E.with({scheme:m,fragment:null})}}function I(E,v){const a=v.toString(y),o=`${a.length<b.length?b[a.length-1]:"z"}${a}s${(0,u.$Oe)(u.$ue.fromString(E.scheme),!0,!0)}`;return E.with({scheme:M.Schemas.vscodeNotebookCell,fragment:o})}class p{constructor(){this.a=new L.$Bc}getNotebook(v){if(v.scheme===M.Schemas.vscodeNotebookCell){const a=A(v);if(a){const m=this.a.get(a.notebook);if(m)return m}}return this.a.get(v)}addNotebookDocument(v){this.a.set(v.uri,v)}removeNotebookDocument(v){this.a.delete(v.uri)}}e.$3J=p,(0,P.$gs)(e.$ZJ,p,1)}),define(ke[119],Ee([1,0,21,35,38,101,15,17,11,41,322]),function(he,e,u,L,M,P,R,b,$,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kK=e.$hK=e.CellStatusbarAlignment=e.$gK=e.NotebookEditorPriority=e.$dK=e.$cK=e.$aK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$_J=e.$$J=e.$0J=e.$9J=e.CellKind=e.$8J=e.$7J=e.$6J=void 0,e.$bK=f,e.$eK=l,e.$fK=c,e.$iK=S,e.$jK=C,e.$6J="workbench.editor.notebook",e.$7J="workbench.editor.notebookTextDiffEditor",e.$8J="workbench.editor.interactive";var I;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(I||(e.CellKind=I={})),e.$9J=["application/json","application/javascript","text/html","image/svg+xml",P.$zs.latex,P.$zs.markdown,"image/png","image/jpeg",P.$zs.text],e.$0J=[P.$zs.latex,P.$zs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",P.$zs.text],e.$$J=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$_J="_notAvailable";var p;(function(B){B[B.Running=1]="Running",B[B.Idle=2]="Idle"})(p||(e.NotebookRunState=p={}));var E;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(E||(e.NotebookCellExecutionState=E={}));var v;(function(B){B[B.Unconfirmed=1]="Unconfirmed",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var a;(function(B){B[B.WithHardKernelDependency=0]="WithHardKernelDependency",B[B.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",B[B.Pure=2]="Pure",B[B.Never=3]="Never"})(a||(e.NotebookRendererMatch=a={}));var m;(function(B){B.Always="always",B.Never="never",B.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var o;(function(B){B[B.ModelChange=1]="ModelChange",B[B.Move=2]="Move",B[B.ChangeCellLanguage=5]="ChangeCellLanguage",B[B.Initialize=6]="Initialize",B[B.ChangeCellMetadata=7]="ChangeCellMetadata",B[B.Output=8]="Output",B[B.OutputItem=9]="OutputItem",B[B.ChangeCellContent=10]="ChangeCellContent",B[B.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",B[B.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",B[B.ChangeCellMime=13]="ChangeCellMime",B[B.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var n;(function(B){B[B.Handle=0]="Handle",B[B.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var i;(function(B){B[B.Replace=1]="Replace",B[B.Output=2]="Output",B[B.Metadata=3]="Metadata",B[B.CellLanguage=4]="CellLanguage",B[B.DocumentMetadata=5]="DocumentMetadata",B[B.Move=6]="Move",B[B.OutputItems=7]="OutputItems",B[B.PartialMetadata=8]="PartialMetadata",B[B.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var r;(function(B){B.scheme=R.Schemas.vscodeNotebookCell;function W(Y,me){return(0,A.$2J)(Y,me)}B.generate=W;function Z(Y){return(0,A.$1J)(Y)}B.parse=Z;function _(Y,me){return Y.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${me??""},${Y.scheme!==R.Schemas.file?Y.scheme:""}`})}B.generateCellOutputUri=_;function X(Y){if(Y.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const me=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Y.fragment);if(!me)return;const Ce=me[1]&&me[1]!==""?me[1]:void 0,ee=me[2];return{outputId:Ce,notebook:Y.with({scheme:ee||R.Schemas.file,fragment:null})}}B.parseCellOutputUri=X;function x(Y,me,Ce){return B.generate(Y,me).with({scheme:Ce})}B.generateCellPropertyUri=x;function re(Y,me){if(Y.scheme===me)return B.parse(Y.with({scheme:B.scheme}))}B.parseCellPropertyUri=re})(r||(e.CellUri=r={}));const s=B=>$.$i?B.replace(/\//g,"\\"):B;class t{constructor(W=[],Z=e.$9J){this.e=Z,this.d=[...new Set(W)].map(_=>({pattern:_,matches:L.$ck(s(_))}))}sort(W){const Z=new Map(M.Iterable.map(W,X=>[X,s(X)]));let _=[];for(const{matches:X}of this.d)for(const[x,re]of Z)if(X(re)){_.push(x),Z.delete(x);break}return Z.size&&(_=_.concat([...Z.keys()].sort((X,x)=>this.e.indexOf(X)-this.e.indexOf(x)))),_}prioritize(W,Z){const _=this.f(W);if(_===-1){this.d.unshift({pattern:W,matches:L.$ck(s(W))});return}const X=new Set(Z.map(re=>this.f(re,_)));X.delete(-1);const x=Array.from(X).sort();this.d.splice(_+1,0,...x.map(re=>this.d[re]));for(let re=x.length-1;re>=0;re--)this.d.splice(x[re],1)}toArray(){return this.d.map(W=>W.pattern)}f(W,Z=this.d.length){const _=s(W);for(let X=0;X<Z;X++)if(this.d[X].matches(_))return X;return-1}}e.$aK=t;function f(B,W,Z,_=(X,x)=>X===x){const X=[];function x(me,Ce,ee){if(Ce===0&&ee.length===0)return;const U=X[X.length-1];U&&U.start+U.deleteCount===me?(U.deleteCount+=Ce,U.toInsert.push(...ee)):X.push({start:me,deleteCount:Ce,toInsert:ee})}let re=0,Y=0;for(;;){if(re===B.length){x(re,0,W.slice(Y));break}if(Y===W.length){x(re,B.length-re,[]);break}const me=B[re],Ce=W[Y];if(_(me,Ce)){re+=1,Y+=1;continue}Z(Ce)?(x(re,1,[]),re+=1):(x(re,0,[Ce]),Y+=1)}return X}e.$cK=new y.$zj("notebookEditorCursorAtBoundary","none"),e.$dK=new y.$zj("notebookEditorCursorAtLineBoundary","none");var d;(function(B){B.default="default",B.option="option"})(d||(e.NotebookEditorPriority=d={}));function l(B){const W=B;return!!((typeof W.include=="string"||L.$dk(W.include))&&(typeof W.exclude=="string"||L.$dk(W.exclude)))}function c(B,W,Z){if(Array.isArray(B.viewType)&&B.viewType.indexOf(W)>=0||B.viewType===W)return!0;if(B.filenamePattern){const _=l(B.filenamePattern)?B.filenamePattern.include:B.filenamePattern,X=l(B.filenamePattern)?B.filenamePattern.exclude:void 0;if(L.$bk(_,(0,b.$oc)(Z.fsPath).toLowerCase()))return!(X&&L.$bk(X,(0,b.$oc)(Z.fsPath).toLowerCase()))}return!1}e.$gK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose"};var h;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(h||(e.CellStatusbarAlignment=h={}));class g{static{this.d="notebook/"}static create(W){return`${g.d}${W}`}static parse(W){if(W.startsWith(g.d))return W.substring(g.d.length)}}e.$hK=g;function S(B){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(B)}const w=new TextDecoder;function C(B){const W=[];let Z=!1;for(const re of B)(W.length===0||Z)&&(W.push(re),Z=!0);let _=O(W);const X=u.$ue.concat(W.map(re=>u.$ue.wrap(re))),x=N(X);return _=_||x.byteLength!==X.byteLength,{data:x,didCompression:_}}e.$kK="\x1B[A";const k=e.$kK.split("").map(B=>B.charCodeAt(0)),D=10;function O(B){let W=!1;return B.forEach((Z,_)=>{if(_===0||Z.length<e.$kK.length)return;const X=B[_-1],x=Z.subarray(0,e.$kK.length);if(x[0]===k[0]&&x[1]===k[1]&&x[2]===k[2]){const re=X.lastIndexOf(D);if(re===-1)return;W=!0,B[_-1]=X.subarray(0,re),B[_]=Z.subarray(e.$kK.length)}}),W}function F(B){let W=B;do B=W,W=B.replace(/[^\n]\x08/gm,"");while(W.length<B.length);return B}function T(B){for(B=B.replace(/\r+\n/gm,`
`);B.search(/\r[^$]/g)>-1;){const W=B.match(/^(.*)\r+/m)[1];let Z=B.match(/\r+(.*)$/m)[1];Z=Z+W.slice(Z.length,W.length),B=B.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Z)}return B}const z=8,j=13;function N(B){return!B.buffer.includes(z)&&!B.buffer.includes(j)?B:u.$ue.fromString(T(F(w.decode(B.buffer))))}}),define(ke[7],Ee([1,0,19,13,80,27,101,14,18,2,30,25,32,65,119]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v){"use strict";var a,m,o,n,i,r,s,t,f,d,l,c,h,g,S,w,C;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$uO=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$tO=e.$sO=e.$rO=e.$qO=e.ChatLocation=e.$pO=e.$oO=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.$iO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$hO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$gO=e.$fO=e.$eO=e.$dO=e.$cO=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$7N=e.$6N=e.$5N=e.$4N=e.$3N=e.$2N=e.$1N=e.$ZN=e.TestRunProfileKind=e.TestResultState=e.$YN=e.$XN=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$WN=e.NotebookVariablesRequestKind=e.$VN=e.$UN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$TN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$SN=e.$RN=e.$QN=e.$PN=e.$ON=e.ColorThemeKind=e.$NN=e.$MN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$LN=e.$KN=e.DebugConsoleMode=e.$JN=e.$IN=e.$HN=e.$GN=e.$FN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$EN=e.$DN=e.FileChangeType=e.$CN=e.NewSymbolNameTag=e.$BN=e.$AN=e.$zN=e.$yN=e.InlineCompletionTriggerKind=e.$xN=e.$wN=e.$vN=e.$uN=e.$tN=e.$sN=e.$rN=e.$qN=e.$pN=e.$oN=e.$nN=e.$lN=e.ConfigurationTarget=e.$kN=e.$jN=e.$iN=e.$hN=e.DocumentPasteTriggerKind=e.$gN=e.$fN=e.$eN=e.$dN=e.$cN=e.$bN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$aN=e.ViewBadge=e.ProgressLocation=e.$_M=e.$$M=e.TaskScope=e.ShellQuoting=e.$0M=e.$9M=e.$8M=e.TaskPanelKind=e.TaskRevealKind=e.$7M=e.TerminalLocation=e.$6M=e.$5M=e.$4M=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$3M=e.$2M=e.$1M=e.$ZM=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$XM=e.$WM=e.$VM=e.$UM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$TM=e.$SM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$RM=e.$QM=e.$PM=e.$OM=e.$NM=e.LanguageStatusSeverity=e.$MM=e.$LM=e.$KM=e.$JM=e.$IM=e.$HM=e.CodeActionTriggerKind=e.$GM=e.$FM=e.SymbolTag=e.SymbolKind=e.$EM=e.$DM=e.DocumentHighlightKind=e.$CM=e.$BM=e.$AM=e.$zM=e.DiagnosticSeverity=e.DiagnosticTag=e.$yM=e.$xM=e.FileEditType=e.$wM=e.$vM=e.$uM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$YM=lt,e.$mN=ne;function k(G){return Object.assign(G,{apply:function(...pe){if(pe.length===0)return Reflect.construct(G,[]);{const je=pe.length===1?[]:pe[1];return Reflect.construct(G,je,pe[0].constructor)}},call:function(...pe){if(pe.length===0)return Reflect.construct(G,[]);{const[je,...Ye]=pe;return Reflect.construct(G,Ye,je.constructor)}}})}var D;(function(G){G[G.Top=0]="Top",G[G.Bottom=1]="Bottom"})(D||(e.TerminalOutputAnchor=D={}));var O;(function(G){G[G.TerminalCommand=0]="TerminalCommand",G[G.Opener=1]="Opener",G[G.Command=3]="Command"})(O||(e.TerminalQuickFixType=O={}));let F=a=class{static from(...H){let pe=H;return new a(function(){if(pe){for(const je of pe)je&&typeof je.dispose=="function"&&je.dispose();pe=void 0}})}#e;constructor(H){this.#e=H}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$nM=F,e.$nM=F=a=Je([k],F);let T=m=class{static Min(...H){if(H.length===0)throw new TypeError;let pe=H[0];for(let je=1;je<H.length;je++){const Ye=H[je];Ye.isBefore(pe)&&(pe=Ye)}return pe}static Max(...H){if(H.length===0)throw new TypeError;let pe=H[0];for(let je=1;je<H.length;je++){const Ye=H[je];Ye.isAfter(pe)&&(pe=Ye)}return pe}static isPosition(H){if(!H)return!1;if(H instanceof m)return!0;const{line:pe,character:je}=H;return typeof pe=="number"&&typeof je=="number"}static of(H){if(H instanceof m)return H;if(this.isPosition(H))return new m(H.line,H.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(H,pe){if(H<0)throw(0,L.$7)("line must be non-negative");if(pe<0)throw(0,L.$7)("character must be non-negative");this.c=H,this.e=pe}isBefore(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<H.e}isBeforeOrEqual(H){return this.c<H.c?!0:H.c<this.c?!1:this.e<=H.e}isAfter(H){return!this.isBeforeOrEqual(H)}isAfterOrEqual(H){return!this.isBefore(H)}isEqual(H){return this.c===H.c&&this.e===H.e}compareTo(H){return this.c<H.c?-1:this.c>H.line?1:this.e<H.e?-1:this.e>H.e?1:0}translate(H,pe=0){if(H===null||pe===null)throw(0,L.$7)();let je;return typeof H>"u"?je=0:typeof H=="number"?je=H:(je=typeof H.lineDelta=="number"?H.lineDelta:0,pe=typeof H.characterDelta=="number"?H.characterDelta:0),je===0&&pe===0?this:new m(this.line+je,this.character+pe)}with(H,pe=this.character){if(H===null||pe===null)throw(0,L.$7)();let je;return typeof H>"u"?je=this.line:typeof H=="number"?je=H:(je=typeof H.line=="number"?H.line:this.line,pe=typeof H.character=="number"?H.character:this.character),je===this.line&&pe===this.character?this:new m(je,pe)}toJSON(){return{line:this.line,character:this.character}}};e.$oM=T,e.$oM=T=m=Je([k],T);let z=o=class{static isRange(H){return H instanceof o?!0:H?T.isPosition(H.start)&&T.isPosition(H.end):!1}static of(H){if(H instanceof o)return H;if(this.isRange(H))return new o(H.start,H.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(H,pe,je,Ye){let nt,dt;if(typeof H=="number"&&typeof pe=="number"&&typeof je=="number"&&typeof Ye=="number"?(nt=new T(H,pe),dt=new T(je,Ye)):T.isPosition(H)&&T.isPosition(pe)&&(nt=T.of(H),dt=T.of(pe)),!nt||!dt)throw new Error("Invalid arguments");nt.isBefore(dt)?(this.c=nt,this.e=dt):(this.c=dt,this.e=nt)}contains(H){return o.isRange(H)?this.contains(H.start)&&this.contains(H.end):T.isPosition(H)?!(T.of(H).isBefore(this.c)||this.e.isBefore(H)):!1}isEqual(H){return this.c.isEqual(H.c)&&this.e.isEqual(H.e)}intersection(H){const pe=T.Max(H.start,this.c),je=T.Min(H.end,this.e);if(!pe.isAfter(je))return new o(pe,je)}union(H){if(this.contains(H))return this;if(H.contains(this))return H;const pe=T.Min(H.start,this.c),je=T.Max(H.end,this.end);return new o(pe,je)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(H,pe=this.end){if(H===null||pe===null)throw(0,L.$7)();let je;return H?T.isPosition(H)?je=H:(je=H.start||this.start,pe=H.end||this.end):je=this.start,je.isEqual(this.c)&&pe.isEqual(this.end)?this:new o(je,pe)}toJSON(){return[this.start,this.end]}};e.$pM=z,e.$pM=z=o=Je([k],z);let j=n=class extends z{static isSelection(H){return H instanceof n?!0:H?z.isRange(H)&&T.isPosition(H.anchor)&&T.isPosition(H.active)&&typeof H.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(H,pe,je,Ye){let nt,dt;if(typeof H=="number"&&typeof pe=="number"&&typeof je=="number"&&typeof Ye=="number"?(nt=new T(H,pe),dt=new T(je,Ye)):T.isPosition(H)&&T.isPosition(pe)&&(nt=T.of(H),dt=T.of(pe)),!nt||!dt)throw new Error("Invalid arguments");super(nt,dt),this.f=nt,this.g=dt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$qM=j,e.$qM=j=n=Je([k],j);const N=G=>{if(typeof G!="string"||G.length===0||!/^[0-9A-Za-z_\-]+$/.test(G))throw(0,L.$7)("connectionToken")};class B{static isResolvedAuthority(H){return H&&typeof H=="object"&&typeof H.host=="string"&&typeof H.port=="number"&&(H.connectionToken===void 0||typeof H.connectionToken=="string")}constructor(H,pe,je){if(typeof H!="string"||H.length===0)throw(0,L.$7)("host");if(typeof pe!="number"||pe===0||Math.round(pe)!==pe)throw(0,L.$7)("port");typeof je<"u"&&N(je),this.host=H,this.port=Math.round(pe),this.connectionToken=je}}e.$rM=B;class W{static isManagedResolvedAuthority(H){return H&&typeof H=="object"&&typeof H.makeConnection=="function"&&(H.connectionToken===void 0||typeof H.connectionToken=="string")}constructor(H,pe){this.makeConnection=H,this.connectionToken=pe,typeof pe<"u"&&N(pe)}}e.$sM=W;class Z extends Error{static NotAvailable(H,pe){return new Z(H,E.RemoteAuthorityResolverErrorCode.NotAvailable,pe)}static TemporarilyNotAvailable(H){return new Z(H,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(H,pe=E.RemoteAuthorityResolverErrorCode.Unknown,je){super(H),this._message=H,this._code=pe,this._detail=je,Object.setPrototypeOf(this,Z.prototype)}}e.$tM=Z;var _;(function(G){G[G.LF=1]="LF",G[G.CRLF=2]="CRLF"})(_||(e.EndOfLine=_={}));var X;(function(G){G[G.Replace=1]="Replace",G[G.Append=2]="Append",G[G.Prepend=3]="Prepend"})(X||(e.EnvironmentVariableMutatorType=X={}));let x=i=class{static isTextEdit(H){return H instanceof i?!0:H?z.isRange(H)&&typeof H.newText=="string":!1}static replace(H,pe){return new i(H,pe)}static insert(H,pe){return i.replace(new z(H,H),pe)}static delete(H){return i.replace(H,"")}static setEndOfLine(H){const pe=new i(new z(new T(0,0),new T(0,0)),"");return pe.newEol=H,pe}get range(){return this.c}set range(H){if(H&&!z.isRange(H))throw(0,L.$7)("range");this.c=H}get newText(){return this.e||""}set newText(H){if(H&&typeof H!="string")throw(0,L.$7)("newText");this.e=H}get newEol(){return this.f}set newEol(H){if(H&&typeof H!="number")throw(0,L.$7)("newEol");this.f=H}constructor(H,pe){this.c=H,this.e=pe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$uM=x,e.$uM=x=i=Je([k],x);let re=r=class{static isNotebookCellEdit(H){return H instanceof r?!0:H?Ue.isNotebookRange(H)&&Array.isArray(H.newCells):!1}static replaceCells(H,pe){return new r(H,pe)}static insertCells(H,pe){return new r(new Ue(H,H),pe)}static deleteCells(H){return new r(H,[])}static updateCellMetadata(H,pe){const je=new r(new Ue(H,H),[]);return je.newCellMetadata=pe,je}static updateNotebookMetadata(H){const pe=new r(new Ue(0,0),[]);return pe.newNotebookMetadata=H,pe}constructor(H,pe){this.range=H,this.newCells=pe}};e.$vM=re,e.$vM=re=r=Je([k],re);class Y{static isSnippetTextEdit(H){return H instanceof Y?!0:H?z.isRange(H.range)&&ee.isSnippetString(H.snippet):!1}static replace(H,pe){return new Y(H,pe)}static insert(H,pe){return Y.replace(new z(H,H),pe)}constructor(H,pe){this.range=H,this.snippet=pe}}e.$wM=Y;var me;(function(G){G[G.File=1]="File",G[G.Text=2]="Text",G[G.Cell=3]="Cell",G[G.CellReplace=5]="CellReplace",G[G.Snippet=6]="Snippet"})(me||(e.FileEditType=me={}));let Ce=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(H,pe,je,Ye){this.c.push({_type:1,from:H,to:pe,options:je,metadata:Ye})}createFile(H,pe,je){this.c.push({_type:1,from:void 0,to:H,options:pe,metadata:je})}deleteFile(H,pe,je){this.c.push({_type:1,from:H,to:void 0,options:pe,metadata:je})}e(H,pe,je){this.c.push({_type:3,metadata:je,uri:H,edit:{editType:5,metadata:pe},notebookMetadata:pe})}f(H,pe,je,Ye){const nt=pe.start,dt=pe.end;(nt!==dt||je.length>0)&&this.c.push({_type:5,uri:H,index:nt,count:dt-nt,cells:je,metadata:Ye})}g(H,pe,je,Ye){this.c.push({_type:3,metadata:Ye,uri:H,edit:{editType:3,index:pe,metadata:je}})}replace(H,pe,je,Ye){this.c.push({_type:2,uri:H,edit:new x(pe,je),metadata:Ye})}insert(H,pe,je,Ye){this.replace(H,new z(pe,pe),je,Ye)}delete(H,pe,je){this.replace(H,pe,"",je)}has(H){return this.c.some(pe=>pe._type===2&&pe.uri.toString()===H.toString())}set(H,pe){if(pe)for(const je of pe){if(!je)continue;let Ye,nt;Array.isArray(je)?(Ye=je[0],nt=je[1]):Ye=je,re.isNotebookCellEdit(Ye)?Ye.newCellMetadata?this.g(H,Ye.range.start,Ye.newCellMetadata,nt):Ye.newNotebookMetadata?this.e(H,Ye.newNotebookMetadata,nt):this.f(H,Ye.range,Ye.newCells,nt):Y.isSnippetTextEdit(Ye)?this.c.push({_type:6,uri:H,range:Ye.range,edit:Ye.snippet,metadata:nt}):this.c.push({_type:2,uri:H,edit:Ye,metadata:nt})}else{for(let je=0;je<this.c.length;je++){const Ye=this.c[je];switch(Ye._type){case 2:case 6:case 3:case 5:Ye.uri.toString()===H.toString()&&(this.c[je]=void 0);break}}(0,u.$Ib)(this.c)}}get(H){const pe=[];for(const je of this.c)je._type===2&&je.uri.toString()===H.toString()&&pe.push(je.edit);return pe}entries(){const H=new P.$Bc;for(const pe of this.c)if(pe._type===2){let je=H.get(pe.uri);je||(je=[pe.uri,[]],H.set(pe.uri,je)),je[1].push(pe.edit)}return[...H.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$xM=Ce,e.$xM=Ce=Je([k],Ce);let ee=s=class{static isSnippetString(H){return H instanceof s?!0:H?typeof H.value=="string":!1}static c(H){return H.replace(/\$|}|\\/g,"\\$&")}constructor(H){this.e=1,this.value=H||""}appendText(H){return this.value+=s.c(H),this}appendTabstop(H=this.e++){return this.value+="$",this.value+=H,this}appendPlaceholder(H,pe=this.e++){if(typeof H=="function"){const je=new s;je.e=this.e,H(je),this.e=je.e,H=je.value}else H=s.c(H);return this.value+="${",this.value+=pe,this.value+=":",this.value+=H,this.value+="}",this}appendChoice(H,pe=this.e++){const je=H.map(Ye=>Ye.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=pe,this.value+="|",this.value+=je,this.value+="|}",this}appendVariable(H,pe){if(typeof pe=="function"){const je=new s;je.e=this.e,pe(je),this.e=je.e,pe=je.value}else typeof pe=="string"&&(pe=pe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=H,pe&&(this.value+=":",this.value+=pe),this.value+="}",this}};e.$yM=ee,e.$yM=ee=s=Je([k],ee);var U;(function(G){G[G.Unnecessary=1]="Unnecessary",G[G.Deprecated=2]="Deprecated"})(U||(e.DiagnosticTag=U={}));var ie;(function(G){G[G.Hint=3]="Hint",G[G.Information=2]="Information",G[G.Warning=1]="Warning",G[G.Error=0]="Error"})(ie||(e.DiagnosticSeverity=ie={}));let be=t=class{static isLocation(H){return H instanceof t?!0:H?z.isRange(H.range)&&y.URI.isUri(H.uri):!1}constructor(H,pe){if(this.uri=H,pe)if(z.isRange(pe))this.range=z.of(pe);else if(T.isPosition(pe))this.range=new z(pe,pe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$zM=be,e.$zM=be=t=Je([k],be);let Se=class{static is(H){return H?typeof H.message=="string"&&H.location&&z.isRange(H.location.range)&&y.URI.isUri(H.location.uri):!1}constructor(H,pe){this.location=H,this.message=pe}static isEqual(H,pe){return H===pe?!0:!H||!pe?!1:H.message===pe.message&&H.location.range.isEqual(pe.location.range)&&H.location.uri.toString()===pe.location.uri.toString()}};e.$AM=Se,e.$AM=Se=Je([k],Se);let ae=class{constructor(H,pe,je=ie.Error){if(!z.isRange(H))throw new TypeError("range must be set");if(!pe)throw new TypeError("message must be set");this.range=H,this.message=pe,this.severity=je}toJSON(){return{severity:ie[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(H,pe){return H===pe?!0:!H||!pe?!1:H.message===pe.message&&H.severity===pe.severity&&H.code===pe.code&&H.severity===pe.severity&&H.source===pe.source&&H.range.isEqual(pe.range)&&(0,u.$ub)(H.tags,pe.tags)&&(0,u.$ub)(H.relatedInformation,pe.relatedInformation,Se.isEqual)}};e.$BM=ae,e.$BM=ae=Je([k],ae);let ce=class{constructor(H,pe){if(!H)throw new Error("Illegal argument, contents must be defined");Array.isArray(H)?this.contents=H:this.contents=[H],this.range=pe}};e.$CM=ce,e.$CM=ce=Je([k],ce);var se;(function(G){G[G.Text=0]="Text",G[G.Read=1]="Read",G[G.Write=2]="Write"})(se||(e.DocumentHighlightKind=se={}));let K=class{constructor(H,pe=se.Text){this.range=H,this.kind=pe}toJSON(){return{range:this.range,kind:se[this.kind]}}};e.$DM=K,e.$DM=K=Je([k],K);let te=class{constructor(H,pe){this.uri=H,this.highlights=pe}toJSON(){return{uri:this.uri,highlights:this.highlights.map(H=>H.toJSON())}}};e.$EM=te,e.$EM=te=Je([k],te);var le;(function(G){G[G.File=0]="File",G[G.Module=1]="Module",G[G.Namespace=2]="Namespace",G[G.Package=3]="Package",G[G.Class=4]="Class",G[G.Method=5]="Method",G[G.Property=6]="Property",G[G.Field=7]="Field",G[G.Constructor=8]="Constructor",G[G.Enum=9]="Enum",G[G.Interface=10]="Interface",G[G.Function=11]="Function",G[G.Variable=12]="Variable",G[G.Constant=13]="Constant",G[G.String=14]="String",G[G.Number=15]="Number",G[G.Boolean=16]="Boolean",G[G.Array=17]="Array",G[G.Object=18]="Object",G[G.Key=19]="Key",G[G.Null=20]="Null",G[G.EnumMember=21]="EnumMember",G[G.Struct=22]="Struct",G[G.Event=23]="Event",G[G.Operator=24]="Operator",G[G.TypeParameter=25]="TypeParameter"})(le||(e.SymbolKind=le={}));var de;(function(G){G[G.Deprecated=1]="Deprecated"})(de||(e.SymbolTag=de={}));let Ae=f=class{static validate(H){if(!H.name)throw new Error("name must not be falsy")}constructor(H,pe,je,Ye,nt){this.name=H,this.kind=pe,this.containerName=nt,typeof je=="string"&&(this.containerName=je),Ye instanceof be?this.location=Ye:je instanceof z&&(this.location=new be(Ye,je)),f.validate(this)}toJSON(){return{name:this.name,kind:le[this.kind],location:this.location,containerName:this.containerName}}};e.$FM=Ae,e.$FM=Ae=f=Je([k],Ae);let $e=d=class{static validate(H){if(!H.name)throw new Error("name must not be falsy");if(!H.range.contains(H.selectionRange))throw new Error("selectionRange must be contained in fullRange");H.children?.forEach(d.validate)}constructor(H,pe,je,Ye,nt){this.name=H,this.detail=pe,this.kind=je,this.range=Ye,this.selectionRange=nt,this.children=[],d.validate(this)}};e.$GM=$e,e.$GM=$e=d=Je([k],$e);var Ie;(function(G){G[G.Invoke=1]="Invoke",G[G.Automatic=2]="Automatic"})(Ie||(e.CodeActionTriggerKind=Ie={}));let Re=class{constructor(H,pe){this.title=H,this.kind=pe}};e.$HM=Re,e.$HM=Re=Je([k],Re);let Fe=class{static{l=this}static{this.c="."}constructor(H){this.value=H}append(H){return new l(this.value?this.value+l.c+H:H)}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+l.c)}};e.$IM=Fe,e.$IM=Fe=l=Je([k],Fe),Fe.Empty=new Fe(""),Fe.QuickFix=Fe.Empty.append("quickfix"),Fe.Refactor=Fe.Empty.append("refactor"),Fe.RefactorExtract=Fe.Refactor.append("extract"),Fe.RefactorInline=Fe.Refactor.append("inline"),Fe.RefactorMove=Fe.Refactor.append("move"),Fe.RefactorRewrite=Fe.Refactor.append("rewrite"),Fe.Source=Fe.Empty.append("source"),Fe.SourceOrganizeImports=Fe.Source.append("organizeImports"),Fe.SourceFixAll=Fe.Source.append("fixAll"),Fe.Notebook=Fe.Empty.append("notebook");let q=class{constructor(H,pe){if(this.range=H,this.parent=pe,pe&&!pe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$JM=q,e.$JM=q=Je([k],q);class V{constructor(H,pe,je,Ye,nt,dt){this.kind=H,this.name=pe,this.detail=je,this.uri=Ye,this.range=nt,this.selectionRange=dt}}e.$KM=V;class Q{constructor(H,pe){this.fromRanges=pe,this.from=H}}e.$LM=Q;class J{constructor(H,pe){this.fromRanges=pe,this.to=H}}e.$MM=J;var fe;(function(G){G[G.Information=0]="Information",G[G.Warning=1]="Warning",G[G.Error=2]="Error"})(fe||(e.LanguageStatusSeverity=fe={}));let we=class{constructor(H,pe){this.range=H,this.command=pe}get isResolved(){return!!this.command}};e.$NM=we,e.$NM=we=Je([k],we);let Te=c=class{#e;static isMarkdownString(H){return H instanceof c?!0:H&&H.appendCodeblock&&H.appendMarkdown&&H.appendText&&H.value!==void 0}constructor(H,pe=!1){this.#e=new M.$Fk(H,{supportThemeIcons:pe})}get value(){return this.#e.value}set value(H){this.#e.value=H}get isTrusted(){return this.#e.isTrusted}set isTrusted(H){this.#e.isTrusted=H}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(H){this.#e.supportThemeIcons=H}get supportHtml(){return this.#e.supportHtml}set supportHtml(H){this.#e.supportHtml=H}get baseUri(){return this.#e.baseUri}set baseUri(H){this.#e.baseUri=H}appendText(H){return this.#e.appendText(H),this}appendMarkdown(H){return this.#e.appendMarkdown(H),this}appendCodeblock(H,pe){return this.#e.appendCodeblock(pe??"",H),this}};e.$OM=Te,e.$OM=Te=c=Je([k],Te);let He=class{constructor(H,pe){this.label=H,this.documentation=pe}};e.$PM=He,e.$PM=He=Je([k],He);let xe=class{constructor(H,pe){this.label=H,this.documentation=pe,this.parameters=[]}};e.$QM=xe,e.$QM=xe=Je([k],xe);let it=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$RM=it,e.$RM=it=Je([k],it);var rt;(function(G){G[G.Invoke=1]="Invoke",G[G.TriggerCharacter=2]="TriggerCharacter",G[G.ContentChange=3]="ContentChange"})(rt||(e.SignatureHelpTriggerKind=rt={}));var at;(function(G){G[G.Type=1]="Type",G[G.Parameter=2]="Parameter"})(at||(e.InlayHintKind=at={}));let ot=class{constructor(H){this.value=H}};e.$SM=ot,e.$SM=ot=Je([k],ot);let De=class{constructor(H,pe,je){this.position=H,this.label=pe,this.kind=je}};e.$TM=De,e.$TM=De=Je([k],De);var Be;(function(G){G[G.Invoke=0]="Invoke",G[G.TriggerCharacter=1]="TriggerCharacter",G[G.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Be||(e.CompletionTriggerKind=Be={}));var Ge;(function(G){G[G.Text=0]="Text",G[G.Method=1]="Method",G[G.Function=2]="Function",G[G.Constructor=3]="Constructor",G[G.Field=4]="Field",G[G.Variable=5]="Variable",G[G.Class=6]="Class",G[G.Interface=7]="Interface",G[G.Module=8]="Module",G[G.Property=9]="Property",G[G.Unit=10]="Unit",G[G.Value=11]="Value",G[G.Enum=12]="Enum",G[G.Keyword=13]="Keyword",G[G.Snippet=14]="Snippet",G[G.Color=15]="Color",G[G.File=16]="File",G[G.Reference=17]="Reference",G[G.Folder=18]="Folder",G[G.EnumMember=19]="EnumMember",G[G.Constant=20]="Constant",G[G.Struct=21]="Struct",G[G.Event=22]="Event",G[G.Operator=23]="Operator",G[G.TypeParameter=24]="TypeParameter",G[G.User=25]="User",G[G.Issue=26]="Issue"})(Ge||(e.CompletionItemKind=Ge={}));var Oe;(function(G){G[G.Deprecated=1]="Deprecated"})(Oe||(e.CompletionItemTag=Oe={}));let Qe=class{constructor(H,pe){this.label=H,this.kind=pe}toJSON(){return{label:this.label,kind:this.kind&&Ge[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$UM=Qe,e.$UM=Qe=Je([k],Qe);let oe=class{constructor(H=[],pe=!1){this.items=H,this.isIncomplete=pe}};e.$VM=oe,e.$VM=oe=Je([k],oe);let ue=class{constructor(H,pe,je){this.insertText=H,this.range=pe,this.command=je}};e.$WM=ue,e.$WM=ue=Je([k],ue);let Pe=class{constructor(H){this.commands=void 0,this.suppressSuggestions=void 0,this.items=H}};e.$XM=Pe,e.$XM=Pe=Je([k],Pe);var Ke;(function(G){G[G.Unknown=0]="Unknown",G[G.Word=1]="Word",G[G.Line=2]="Line",G[G.Suggest=3]="Suggest"})(Ke||(e.PartialAcceptTriggerKind=Ke={}));var _e;(function(G){G[G.Active=-1]="Active",G[G.Beside=-2]="Beside",G[G.One=1]="One",G[G.Two=2]="Two",G[G.Three=3]="Three",G[G.Four=4]="Four",G[G.Five=5]="Five",G[G.Six=6]="Six",G[G.Seven=7]="Seven",G[G.Eight=8]="Eight",G[G.Nine=9]="Nine"})(_e||(e.ViewColumn=_e={}));var Ne;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(Ne||(e.StatusBarAlignment=Ne={}));function lt(G,H){return`${I.$Dm.toKey(G)}.${H}`}var wt;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval"})(wt||(e.TextEditorLineNumbersStyle=wt={}));var At;(function(G){G[G.Manual=1]="Manual",G[G.AfterDelay=2]="AfterDelay",G[G.FocusOut=3]="FocusOut"})(At||(e.TextDocumentSaveReason=At={}));var zt;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(zt||(e.TextEditorRevealType=zt={}));var Qt;(function(G){G[G.Keyboard=1]="Keyboard",G[G.Mouse=2]="Mouse",G[G.Command=3]="Command"})(Qt||(e.TextEditorSelectionChangeKind=Qt={}));var _t;(function(G){G[G.Undo=1]="Undo",G[G.Redo=2]="Redo"})(_t||(e.TextDocumentChangeReason=_t={}));var Ct;(function(G){G[G.OpenOpen=0]="OpenOpen",G[G.ClosedClosed=1]="ClosedClosed",G[G.OpenClosed=2]="OpenClosed",G[G.ClosedOpen=3]="ClosedOpen"})(Ct||(e.DecorationRangeBehavior=Ct={})),function(G){function H(pe){switch(pe){case"keyboard":return G.Keyboard;case"mouse":return G.Mouse;case"api":return G.Command}}G.fromValue=H}(Qt||(e.TextEditorSelectionChangeKind=Qt={}));var Xt;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(Xt||(e.SyntaxTokenType=Xt={})),function(G){function H(pe){switch(pe){case G.Other:return"other";case G.Comment:return"comment";case G.String:return"string";case G.RegEx:return"regex"}return"other"}G.toString=H}(Xt||(e.SyntaxTokenType=Xt={}));let Vt=class{constructor(H,pe){if(pe&&!y.URI.isUri(pe))throw(0,L.$7)("target");if(!z.isRange(H)||H.isEmpty)throw(0,L.$7)("range");this.range=H,this.target=pe}};e.$ZM=Vt,e.$ZM=Vt=Je([k],Vt);let ai=class{constructor(H,pe,je,Ye){this.red=H,this.green=pe,this.blue=je,this.alpha=Ye}};e.$1M=ai,e.$1M=ai=Je([k],ai);let tt=class{constructor(H,pe){if(pe&&!(pe instanceof ai))throw(0,L.$7)("color");if(!z.isRange(H)||H.isEmpty)throw(0,L.$7)("range");this.range=H,this.color=pe}};e.$2M=tt,e.$2M=tt=Je([k],tt);let ei=class{constructor(H){if(!H||typeof H!="string")throw(0,L.$7)("label");this.label=H}};e.$3M=ei,e.$3M=ei=Je([k],ei);var ti;(function(G){G[G.RGB=0]="RGB",G[G.HEX=1]="HEX",G[G.HSL=2]="HSL"})(ti||(e.ColorFormat=ti={}));var ft;(function(G){G[G.Error=0]="Error",G[G.Warning=1]="Warning",G[G.Information=2]="Information"})(ft||(e.SourceControlInputBoxValidationType=ft={}));var bt;(function(G){G[G.Unknown=0]="Unknown",G[G.Shutdown=1]="Shutdown",G[G.Process=2]="Process",G[G.User=3]="User",G[G.Extension=4]="Extension"})(bt||(e.TerminalExitReason=bt={}));class si{constructor(H,pe,je){if(this.startIndex=H,this.length=pe,this.tooltip=je,typeof H!="number"||H<0)throw(0,L.$7)("startIndex");if(typeof pe!="number"||pe<1)throw(0,L.$7)("length");if(je!==void 0&&typeof je!="string")throw(0,L.$7)("tooltip")}}e.$4M=si;class ii{constructor(H){this.uri=H}}e.$5M=ii;class jt{constructor(H){this.terminalCommand=H}}e.$6M=jt;var mt;(function(G){G[G.Panel=1]="Panel",G[G.Editor=2]="Editor"})(mt||(e.TerminalLocation=mt={}));class Rt{constructor(H){if(this.options=H,typeof H!="object")throw(0,L.$7)("options")}}e.$7M=Rt;var qt;(function(G){G[G.Always=1]="Always",G[G.Silent=2]="Silent",G[G.Never=3]="Never"})(qt||(e.TaskRevealKind=qt={}));var Zt;(function(G){G[G.Shared=1]="Shared",G[G.Dedicated=2]="Dedicated",G[G.New=3]="New"})(Zt||(e.TaskPanelKind=Zt={}));let Ze=class{static{h=this}static{this.Clean=new h("clean","Clean")}static{this.Build=new h("build","Build")}static{this.Rebuild=new h("rebuild","Rebuild")}static{this.Test=new h("test","Test")}static from(H){switch(H){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}constructor(H,pe){if(this.label=pe,typeof H!="string"||typeof pe!="string")throw(0,L.$7)("name");this.c=H}get id(){return this.c}};e.$8M=Ze,e.$8M=Ze=h=Je([k],Ze);function Yt(G){let H="";for(let pe=0;pe<G.length;pe++)H+=G[pe].replace(/,/g,",,")+",";return H}let Bt=class{constructor(H,pe,je){if(typeof H!="string")throw(0,L.$7)("process");this.e=[],this.c=H,pe!==void 0&&(Array.isArray(pe)?(this.e=pe,this.f=je):this.f=pe)}get process(){return this.c}set process(H){if(typeof H!="string")throw(0,L.$7)("process");this.c=H}get args(){return this.e}set args(H){Array.isArray(H)||(H=[]),this.e=H}get options(){return this.f}set options(H){this.f=H}computeId(){const H=[];if(H.push("process"),this.c!==void 0&&H.push(this.c),this.e&&this.e.length>0)for(const pe of this.e)H.push(pe);return Yt(H)}};e.$9M=Bt,e.$9M=Bt=Je([k],Bt);let Ut=class{constructor(H,pe,je){if(this.f=[],Array.isArray(pe)){if(!H)throw(0,L.$7)("command can't be undefined or null");if(typeof H!="string"&&typeof H.value!="string")throw(0,L.$7)("command");this.e=H,this.f=pe,this.g=je}else{if(typeof H!="string")throw(0,L.$7)("commandLine");this.c=H,this.g=pe}}get commandLine(){return this.c}set commandLine(H){if(typeof H!="string")throw(0,L.$7)("commandLine");this.c=H}get command(){return this.e?this.e:""}set command(H){if(typeof H!="string"&&typeof H.value!="string")throw(0,L.$7)("command");this.e=H}get args(){return this.f}set args(H){this.f=H||[]}get options(){return this.g}set options(H){this.g=H}computeId(){const H=[];if(H.push("shell"),this.c!==void 0&&H.push(this.c),this.e!==void 0&&H.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const pe of this.f)H.push(typeof pe=="string"?pe:pe.value);return Yt(H)}};e.$0M=Ut,e.$0M=Ut=Je([k],Ut);var $t;(function(G){G[G.Escape=1]="Escape",G[G.Strong=2]="Strong",G[G.Weak=3]="Weak"})($t||(e.ShellQuoting=$t={}));var Ft;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace"})(Ft||(e.TaskScope=Ft={}));class Ot{constructor(H){this.c=H}computeId(){return"customExecution"+(0,A.$Eg)()}set callback(H){this.c=H}get callback(){return this.c}}e.$$M=Ot;let Tt=class{static{g=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(H,pe,je,Ye,nt,dt){this.k=!1,this.l=this.definition=H;let gt;typeof pe=="string"?(this.o=this.name=pe,this.w=this.source=je,this.execution=Ye,gt=nt,this.k=!0):pe===Ft.Global||pe===Ft.Workspace?(this.target=pe,this.o=this.name=je,this.w=this.source=Ye,this.execution=nt,gt=dt):(this.target=pe,this.o=this.name=je,this.w=this.source=Ye,this.execution=nt,gt=dt),typeof gt=="string"?(this.r=[gt],this.t=!0):Array.isArray(gt)?(this.r=gt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(H){this.j=H}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Bt?this.l={type:g.e,id:this.q.computeId()}:this.q instanceof Ut?this.l={type:g.f,id:this.q.computeId()}:this.q instanceof Ot?this.l={type:g.c,id:this.q.computeId()}:this.l={type:g.g,id:(0,A.$Eg)()}}get definition(){return this.l}set definition(H){if(H==null)throw(0,L.$7)("Kind can't be undefined or null");this.B(),this.l=H}get scope(){return this.m}set target(H){this.B(),this.m=H}get name(){return this.o}set name(H){if(typeof H!="string")throw(0,L.$7)("name");this.B(),this.o=H}get execution(){return this.q}set execution(H){H===null&&(H=void 0),this.B(),this.q=H;const pe=this.l.type;(g.g===pe||g.e===pe||g.f===pe||g.c===pe)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(H){if(Array.isArray(H))this.B(),this.r=H,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(H){H!==!0&&H!==!1&&(H=!1),this.B(),this.u=H}get source(){return this.w}set source(H){if(typeof H!="string"||H.length===0)throw(0,L.$7)("source must be a string of length > 0");this.B(),this.w=H}get group(){return this.x}set group(H){H===null&&(H=void 0),this.B(),this.x=H}get detail(){return this.A}set detail(H){H===null&&(H=void 0),this.A=H}get presentationOptions(){return this.y}set presentationOptions(H){H==null&&(H=Object.create(null)),this.B(),this.y=H}get runOptions(){return this.z}set runOptions(H){H==null&&(H=Object.create(null)),this.B(),this.z=H}};e.$_M=Tt,e.$_M=Tt=g=Je([k],Tt);var ni;(function(G){G[G.SourceControl=1]="SourceControl",G[G.Window=10]="Window",G[G.Notification=15]="Notification"})(ni||(e.ProgressLocation=ni={}));var oi;(function(G){function H(pe){const je=pe;return(0,$.$Zf)(je.value)?je.tooltip&&!(0,$.$Vf)(je.tooltip)?(console.log("INVALID view badge, invalid tooltip",je.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",je.value),!1)}G.isViewBadge=H})(oi||(e.ViewBadge=oi={}));let Ht=S=class{static isTreeItem(H,pe){const je=H;if(je.checkboxState!==void 0){const Ye=(0,$.$Zf)(je.checkboxState)?je.checkboxState:(0,$.$Xf)(je.checkboxState)&&(0,$.$Zf)(je.checkboxState.state)?je.checkboxState.state:void 0,nt=!(0,$.$Zf)(je.checkboxState)&&(0,$.$Xf)(je.checkboxState)?je.checkboxState.tooltip:void 0;if(Ye===void 0||Ye!==St.Checked&&Ye!==St.Unchecked||nt!==void 0&&!(0,$.$Vf)(nt))return console.log("INVALID tree item, invalid checkboxState",je.checkboxState),!1}if(H instanceof S)return!0;if(je.label!==void 0&&!(0,$.$Vf)(je.label)&&!je.label?.label)return console.log("INVALID tree item, invalid label",je.label),!1;if(je.id!==void 0&&!(0,$.$Vf)(je.id))return console.log("INVALID tree item, invalid id",je.id),!1;if(je.iconPath!==void 0&&!(0,$.$Vf)(je.iconPath)&&!y.URI.isUri(je.iconPath)&&(!je.iconPath||!(0,$.$Vf)(je.iconPath.id))){const Ye=je.iconPath;if(!Ye||!(0,$.$Vf)(Ye.light)&&!y.URI.isUri(Ye.light)&&!(0,$.$Vf)(Ye.dark)&&!y.URI.isUri(Ye.dark))return console.log("INVALID tree item, invalid iconPath",je.iconPath),!1}return je.description!==void 0&&!(0,$.$Vf)(je.description)&&typeof je.description!="boolean"?(console.log("INVALID tree item, invalid description",je.description),!1):je.resourceUri!==void 0&&!y.URI.isUri(je.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",je.resourceUri),!1):je.tooltip!==void 0&&!(0,$.$Vf)(je.tooltip)&&!(je.tooltip instanceof Te)?(console.log("INVALID tree item, invalid tooltip",je.tooltip),!1):je.command!==void 0&&!je.command.command?(console.log("INVALID tree item, invalid command",je.command),!1):je.collapsibleState!==void 0&&je.collapsibleState<It.None&&je.collapsibleState>It.Expanded?(console.log("INVALID tree item, invalid collapsibleState",je.collapsibleState),!1):je.contextValue!==void 0&&!(0,$.$Vf)(je.contextValue)?(console.log("INVALID tree item, invalid contextValue",je.contextValue),!1):je.accessibilityInformation!==void 0&&!je.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",je.accessibilityInformation),!1):!0}constructor(H,pe=It.None){this.collapsibleState=pe,y.URI.isUri(H)?this.resourceUri=H:this.label=H}};e.$aN=Ht,e.$aN=Ht=S=Je([k],Ht);var It;(function(G){G[G.None=0]="None",G[G.Collapsed=1]="Collapsed",G[G.Expanded=2]="Expanded"})(It||(e.TreeItemCollapsibleState=It={}));var St;(function(G){G[G.Unchecked=0]="Unchecked",G[G.Checked=1]="Checked"})(St||(e.TreeItemCheckboxState=St={}));let Gt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(H){this.value=H}};e.$bN=Gt,e.$bN=Gt=Je([k],Gt);class Pt extends Gt{}e.$cN=Pt;class yt extends Pt{#e;constructor(H){super(""),this.#e=H}asFile(){return this.#e}}e.$dN=yt;class Dt{constructor(H,pe,je,Ye){this.name=H,this.uri=pe,this._itemId=je,this.c=Ye}data(){return this.c()}}e.$eN=Dt;let Et=class{#e=new Map;constructor(H){for(const[pe,je]of H??[]){const Ye=this.#e.get(this.#t(pe));Ye?Ye.push(je):this.#e.set(this.#t(pe),[je])}}get(H){return this.#e.get(this.#t(H))?.[0]}set(H,pe){this.#e.set(this.#t(H),[pe])}forEach(H,pe){for(const[je,Ye]of this.#e)for(const nt of Ye)H.call(pe,nt,je,this)}*[Symbol.iterator](){for(const[H,pe]of this.#e)for(const je of pe)yield[H,je]}#t(H){return H.toLowerCase()}};e.$fN=Et,e.$fN=Et=Je([k],Et);let ui=class{constructor(H,pe,je){this.insertText=H,this.title=pe,this.kind=je}};e.$gN=ui,e.$gN=ui=Je([k],ui);var ri;(function(G){G[G.Automatic=0]="Automatic",G[G.PasteAs=1]="PasteAs"})(ri||(e.DocumentPasteTriggerKind=ri={}));class li{static{this.c="."}constructor(H){this.value=H}append(...H){return new li((this.value?[this.value,...H]:H).join(li.c))}intersects(H){return this.contains(H)||H.contains(this)}contains(H){return this.value===H.value||H.value.startsWith(this.value+li.c)}}e.$hN=li,li.Empty=new li("");let di=class{constructor(H,pe,je){this.title=pe,this.insertText=H,this.kind=je}};e.$iN=di,e.$iN=di=Je([k],di);let xt=class{constructor(H,pe){this.id=H,this.color=pe}static isThemeIcon(H){return typeof H.id!="string"?(console.log("INVALID ThemeIcon, invalid id",H.id),!1):!0}};e.$jN=xt,e.$jN=xt=Je([k],xt),xt.File=new xt("file"),xt.Folder=new xt("folder");let Mt=class{constructor(H){this.id=H}};e.$kN=Mt,e.$kN=Mt=Je([k],Mt);var Me;(function(G){G[G.Global=1]="Global",G[G.Workspace=2]="Workspace",G[G.WorkspaceFolder=3]="WorkspaceFolder"})(Me||(e.ConfigurationTarget=Me={}));let ze=class{get base(){return this.c}set base(H){this.c=H,this.e=y.URI.file(H)}get baseUri(){return this.e}set baseUri(H){this.e=H,this.c=H.fsPath}constructor(H,pe){if(typeof H!="string"&&(!H||!y.URI.isUri(H)&&!y.URI.isUri(H.uri)))throw(0,L.$7)("base");if(typeof pe!="string")throw(0,L.$7)("pattern");typeof H=="string"?this.baseUri=y.URI.file(H):y.URI.isUri(H)?this.baseUri=H:this.baseUri=H.uri,this.pattern=pe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$lN=ze,e.$lN=ze=Je([k],ze);const ve=new WeakMap;function ne(G,H){ve.set(G,H)}let Le=class{constructor(H,pe,je,Ye,nt){this.enabled=typeof H=="boolean"?H:!0,typeof pe=="string"&&(this.condition=pe),typeof je=="string"&&(this.hitCondition=je),typeof Ye=="string"&&(this.logMessage=Ye),typeof nt=="string"&&(this.mode=nt)}get id(){return this.c||(this.c=ve.get(this)??(0,A.$Eg)()),this.c}};e.$nN=Le,e.$nN=Le=Je([k],Le);let Ve=class extends Le{constructor(H,pe,je,Ye,nt,dt){if(super(pe,je,Ye,nt,dt),H===null)throw(0,L.$7)("location");this.location=H}};e.$oN=Ve,e.$oN=Ve=Je([k],Ve);let et=class extends Le{constructor(H,pe,je,Ye,nt,dt){super(pe,je,Ye,nt,dt),this.functionName=H}};e.$pN=et,e.$pN=et=Je([k],et);let Xe=class extends Le{constructor(H,pe,je,Ye,nt,dt,gt,Jt){if(super(Ye,nt,dt,gt,Jt),!pe)throw(0,L.$7)("dataId");this.label=H,this.dataId=pe,this.canPersist=je}};e.$qN=Xe,e.$qN=Xe=Je([k],Xe);let ct=class{constructor(H,pe,je){this.command=H,this.args=pe||[],this.options=je}};e.$rN=ct,e.$rN=ct=Je([k],ct);let kt=class{constructor(H,pe){this.port=H,this.host=pe}};e.$sN=kt,e.$sN=kt=Je([k],kt);let Kt=class{constructor(H){this.path=H}};e.$tN=Kt,e.$tN=Kt=Je([k],Kt);let Wt=class{constructor(H){this.implementation=H}};e.$uN=Wt,e.$uN=Wt=Je([k],Wt);class Lt{constructor(H,pe,je){this.session=H,this.threadId=pe,this.frameId=je}}e.$vN=Lt;class ht{constructor(H,pe){this.session=H,this.threadId=pe}}e.$wN=ht;let Ii=class{constructor(H,pe){this.range=H,this.expression=pe}};e.$xN=Ii,e.$xN=Ii=Je([k],Ii);var gi;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(gi||(e.InlineCompletionTriggerKind=gi={}));let $i=class{constructor(H,pe){this.range=H,this.text=pe}};e.$yN=$i,e.$yN=$i=Je([k],$i);let vi=class{constructor(H,pe,je=!0){this.range=H,this.variableName=pe,this.caseSensitiveLookup=je}};e.$zN=vi,e.$zN=vi=Je([k],vi);let Pi=class{constructor(H,pe){this.range=H,this.expression=pe}};e.$AN=Pi,e.$AN=Pi=Je([k],Pi);let Ai=class{constructor(H,pe){this.frameId=H,this.stoppedLocation=pe}};e.$BN=Ai,e.$BN=Ai=Je([k],Ai);var Wi;(function(G){G[G.AIGenerated=1]="AIGenerated"})(Wi||(e.NewSymbolNameTag=Wi={}));class Vi{constructor(H,pe){this.newSymbolName=H,this.tags=pe}}e.$CN=Vi;var qi;(function(G){G[G.Changed=1]="Changed",G[G.Created=2]="Created",G[G.Deleted=3]="Deleted"})(qi||(e.FileChangeType=qi={}));let yi=w=class extends Error{static FileExists(H){return new w(H,p.FileSystemProviderErrorCode.FileExists,w.FileExists)}static FileNotFound(H){return new w(H,p.FileSystemProviderErrorCode.FileNotFound,w.FileNotFound)}static FileNotADirectory(H){return new w(H,p.FileSystemProviderErrorCode.FileNotADirectory,w.FileNotADirectory)}static FileIsADirectory(H){return new w(H,p.FileSystemProviderErrorCode.FileIsADirectory,w.FileIsADirectory)}static NoPermissions(H){return new w(H,p.FileSystemProviderErrorCode.NoPermissions,w.NoPermissions)}static Unavailable(H){return new w(H,p.FileSystemProviderErrorCode.Unavailable,w.Unavailable)}constructor(H,pe=p.FileSystemProviderErrorCode.Unknown,je){super(y.URI.isUri(H)?H.toString(!0):H),this.code=je?.name??"Unknown",(0,p.$4k)(this,pe),Object.setPrototypeOf(this,w.prototype),typeof Error.captureStackTrace=="function"&&typeof je=="function"&&Error.captureStackTrace(this,je)}};e.$DN=yi,e.$DN=yi=w=Je([k],yi);let Ri=class{constructor(H,pe,je){this.start=H,this.end=pe,this.kind=je}};e.$EN=Ri,e.$EN=Ri=Je([k],Ri);var ki;(function(G){G[G.Comment=1]="Comment",G[G.Imports=2]="Imports",G[G.Region=3]="Region"})(ki||(e.FoldingRangeKind=ki={}));var Ei;(function(G){G[G.Collapsed=0]="Collapsed",G[G.Expanded=1]="Expanded"})(Ei||(e.CommentThreadCollapsibleState=Ei={}));var Hi;(function(G){G[G.Editing=0]="Editing",G[G.Preview=1]="Preview"})(Hi||(e.CommentMode=Hi={}));var Gi;(function(G){G[G.Published=0]="Published",G[G.Draft=1]="Draft"})(Gi||(e.CommentState=Gi={}));var bi;(function(G){G[G.Unresolved=0]="Unresolved",G[G.Resolved=1]="Resolved"})(bi||(e.CommentThreadState=bi={}));var Ki;(function(G){G[G.Current=0]="Current",G[G.Outdated=1]="Outdated"})(Ki||(e.CommentThreadApplicability=Ki={}));class gn{constructor(H,pe=[]){this.tokenTypes=H,this.tokenModifiers=pe}}e.$FN=gn;function mn(G){return typeof G>"u"||(0,$.$Wf)(G)}class Oi{constructor(H){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,H){this.m=!0;for(let pe=0,je=H.tokenTypes.length;pe<je;pe++)this.k.set(H.tokenTypes[pe],pe);for(let pe=0,je=H.tokenModifiers.length;pe<je;pe++)this.l.set(H.tokenModifiers[pe],pe)}}push(H,pe,je,Ye,nt){if(typeof H=="number"&&typeof pe=="number"&&typeof je=="number"&&typeof Ye=="number"&&(typeof nt=="number"||typeof nt>"u"))return typeof nt>"u"&&(nt=0),this.q(H,pe,je,Ye,nt);if(z.isRange(H)&&typeof pe=="string"&&mn(je))return this.o(H,pe,je);throw(0,L.$7)()}o(H,pe,je){if(!this.m)throw new Error("Legend must be provided in constructor");if(H.start.line!==H.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(pe))throw new Error("`tokenType` is not in the provided legend");const Ye=H.start.line,nt=H.start.character,dt=H.end.character-H.start.character,gt=this.k.get(pe);let Jt=0;if(je)for(const hi of je){if(!this.l.has(hi))throw new Error("`tokenModifier` is not in the provided legend");const fi=this.l.get(hi);Jt|=1<<fi>>>0}this.q(Ye,nt,dt,gt,Jt)}q(H,pe,je,Ye,nt){if(this.f&&(H<this.c||H===this.c&&pe<this.e)){this.f=!1;const Jt=this.g.length/5|0;let hi=0,fi=0;for(let mi=0;mi<Jt;mi++){let pi=this.g[5*mi],Bi=this.g[5*mi+1];pi===0?(pi=hi,Bi+=fi):pi+=hi,this.g[5*mi]=pi,this.g[5*mi+1]=Bi,hi=pi,fi=Bi}}let dt=H,gt=pe;this.f&&this.j>0&&(dt-=this.c,dt===0&&(gt-=this.e)),this.g[this.j++]=dt,this.g[this.j++]=gt,this.g[this.j++]=je,this.g[this.j++]=Ye,this.g[this.j++]=nt,this.c=H,this.e=pe}static r(H){const pe=[],je=H.length/5|0;for(let gt=0;gt<je;gt++)pe[gt]=gt;pe.sort((gt,Jt)=>{const hi=H[5*gt],fi=H[5*Jt];if(hi===fi){const mi=H[5*gt+1],pi=H[5*Jt+1];return mi-pi}return hi-fi});const Ye=new Uint32Array(H.length);let nt=0,dt=0;for(let gt=0;gt<je;gt++){const Jt=5*pe[gt],hi=H[Jt+0],fi=H[Jt+1],mi=H[Jt+2],pi=H[Jt+3],Bi=H[Jt+4],Ln=hi-nt,sr=Ln===0?fi-dt:fi,Ui=5*gt;Ye[Ui+0]=Ln,Ye[Ui+1]=sr,Ye[Ui+2]=mi,Ye[Ui+3]=pi,Ye[Ui+4]=Bi,nt=hi,dt=fi}return Ye}build(H){return this.f?new Mi(new Uint32Array(this.g),H):new Mi(Oi.r(this.g),H)}}e.$GN=Oi;class Mi{constructor(H,pe){this.resultId=pe,this.data=H}}e.$HN=Mi;class Ji{constructor(H,pe,je){this.start=H,this.deleteCount=pe,this.data=je}}e.$IN=Ji;class Qi{constructor(H,pe){this.resultId=pe,this.edits=H}}e.$JN=Qi;var Xi;(function(G){G[G.Separate=0]="Separate",G[G.MergeWithParent=1]="MergeWithParent"})(Xi||(e.DebugConsoleMode=Xi={}));class Zi{constructor(H){this.name=H}}e.$KN=Zi;let Ci=class{static{this.Back={iconPath:new xt("arrow-left")}}constructor(){}};e.$LN=Ci,e.$LN=Ci=Je([k],Ci);var Yi;(function(G){G[G.Separator=-1]="Separator",G[G.Default=0]="Default"})(Yi||(e.QuickPickItemKind=Yi={}));var xi;(function(G){G[G.Info=1]="Info",G[G.Warning=2]="Warning",G[G.Error=3]="Error"})(xi||(e.InputBoxValidationSeverity=xi={}));var _i;(function(G){G[G.UI=1]="UI",G[G.Workspace=2]="Workspace"})(_i||(e.ExtensionKind=_i={}));class $n{static validate(H){if(typeof H.badge=="string"){let pe=(0,b.$vf)(H.badge,0);if(pe<H.badge.length&&(pe+=(0,b.$vf)(H.badge,pe)),H.badge.length>pe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(H.badge&&!xt.isThemeIcon(H.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!H.color&&!H.badge&&!H.tooltip)throw new Error("The decoration is empty");return!0}constructor(H,pe,je){this.badge=H,this.tooltip=pe,this.color=je}}e.$MN=$n;let wi=class{constructor(H){this.kind=H}};e.$NN=wi,e.$NN=wi=Je([k],wi);var Li;(function(G){G[G.Light=1]="Light",G[G.Dark=2]="Dark",G[G.HighContrast=3]="HighContrast",G[G.HighContrastLight=4]="HighContrastLight"})(Li||(e.ColorThemeKind=Li={}));class Ue{static isNotebookRange(H){return H instanceof Ue?!0:H?typeof H.start=="number"&&typeof H.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(H,pe){if(H<0)throw(0,L.$7)("start must be positive");if(pe<0)throw(0,L.$7)("end must be positive");H<=pe?(this.c=H,this.e=pe):(this.c=pe,this.e=H)}with(H){let pe=this.c,je=this.e;return H.start!==void 0&&(pe=H.start),H.end!==void 0&&(je=H.end),pe===this.c&&je===this.e?this:new Ue(pe,je)}}e.$ON=Ue;class ci{static validate(H){if(typeof H.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof H.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof H.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(H){return Array.isArray(H)&&H.every(pe=>ci.isNotebookCellData(pe))}static isNotebookCellData(H){return!0}constructor(H,pe,je,Ye,nt,dt,gt){this.kind=H,this.value=pe,this.languageId=je,this.mime=Ye,this.outputs=nt??[],this.metadata=dt,this.executionSummary=gt,ci.validate(this)}}e.$PN=ci;class en{constructor(H){this.cells=H}}e.$QN=en;class st{static isNotebookCellOutputItem(H){return H instanceof st?!0:H?typeof H.mime=="string"&&H.data instanceof Uint8Array:!1}static error(H){const pe={name:H.name,message:H.message,stack:H.stack};return st.json(pe,"application/vnd.code.notebook.error")}static stdout(H){return st.text(H,"application/vnd.code.notebook.stdout")}static stderr(H){return st.text(H,"application/vnd.code.notebook.stderr")}static bytes(H,pe="application/octet-stream"){return new st(H,pe)}static#e=new TextEncoder;static text(H,pe=R.$zs.text){const je=st.#e.encode(String(H));return new st(je,pe)}static json(H,pe="text/x-json"){const je=JSON.stringify(H,void 0,"	");return st.text(je,pe)}constructor(H,pe){this.data=H,this.mime=pe;const je=(0,R.$Ds)(pe,!0);if(!je)throw new Error(`INVALID mime type: ${pe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=je}}e.$RN=st;class pt{static isNotebookCellOutput(H){return H instanceof pt?!0:!H||typeof H!="object"?!1:typeof H.id=="string"&&Array.isArray(H.items)}static ensureUniqueMimeTypes(H,pe=!1){const je=new Set,Ye=new Set;for(let nt=0;nt<H.length;nt++){const dt=H[nt],gt=(0,R.$Ds)(dt.mime);if(!je.has(gt)||(0,v.$iK)(gt)){je.add(gt);continue}Ye.add(nt),pe&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Ye.size===0?H:H.filter((nt,dt)=>!Ye.has(dt))}constructor(H,pe,je){this.items=pt.ensureUniqueMimeTypes(H,!0),typeof pe=="string"?(this.id=pe,this.metadata=je):(this.id=(0,A.$Eg)(),this.metadata=pe??je)}}e.$SN=pt;var tn;(function(G){G[G.Markup=1]="Markup",G[G.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function(G){G[G.Idle=1]="Idle",G[G.Pending=2]="Pending",G[G.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var ji;(function(G){G[G.Left=1]="Left",G[G.Right=2]="Right"})(ji||(e.NotebookCellStatusBarAlignment=ji={}));var rn;(function(G){G[G.Default=0]="Default",G[G.InCenter=1]="InCenter",G[G.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",G[G.AtTop=3]="AtTop"})(rn||(e.NotebookEditorRevealType=rn={}));class Si{constructor(H,pe){this.text=H,this.alignment=pe}}e.$TN=Si;var sn;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred"})(sn||(e.NotebookControllerAffinity=sn={}));var on;(function(G){G[G.Default=1]="Default",G[G.Preferred=2]="Preferred",G[G.Hidden=-1]="Hidden"})(on||(e.NotebookControllerAffinity2=on={}));class pn{constructor(H,pe=[]){this.uri=H,this.provides=(0,u.$3b)(pe)}}e.$UN=pn;class an{constructor(H){this.label=H}}e.$VN=an;var cn;(function(G){G[G.Named=1]="Named",G[G.Indexed=2]="Indexed"})(cn||(e.NotebookVariablesRequestKind=cn={}));let Ni=class{constructor(H,pe){this.label=H,this.timestamp=pe}};e.$WN=Ni,e.$WN=Ni=Je([k],Ni);var un;(function(G){G[G.Production=1]="Production",G[G.Development=2]="Development",G[G.Test=3]="Test"})(un||(e.ExtensionMode=un={}));var ln;(function(G){G[G.Node=1]="Node",G[G.Webworker=2]="Webworker"})(ln||(e.ExtensionRuntime=ln={}));var hn;(function(G){G[G.Other=0]="Other",G[G.Comment=1]="Comment",G[G.String=2]="String",G[G.RegEx=3]="RegEx"})(hn||(e.StandardTokenType=hn={}));class bn{constructor(H,pe){this.ranges=H,this.wordPattern=pe}}e.$XN=bn;class wn{constructor(H){this.c=H}get autoForwardAction(){return this.c}}e.$YN=wn;var dn;(function(G){G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(dn||(e.TestResultState=dn={}));var fn;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(fn||(e.TestRunProfileKind=fn={}));let Fi=class{constructor(H=void 0,pe=void 0,je=void 0,Ye=!1){this.include=H,this.exclude=pe,this.profile=je,this.continuous=Ye}};e.$ZN=Fi,e.$ZN=Fi=Je([k],Fi);let Ti=C=class{static diff(H,pe,je){const Ye=new C(H);return Ye.expectedOutput=pe,Ye.actualOutput=je,Ye}constructor(H){this.message=H}};e.$1N=Ti,e.$1N=Ti=C=Je([k],Ti);let ge=class{constructor(H){this.id=H}};e.$2N=ge,e.$2N=ge=Je([k],ge);class ye{constructor(H,pe){this.covered=H,this.total=pe}}e.$3N=ye;const We=G=>{if(G&&G.covered>G.total)throw new Error(`The total number of covered items (${G.covered}) cannot be greater than the total (${G.total})`)};class ut{static fromDetails(H,pe){const je=new ye(0,0),Ye=new ye(0,0),nt=new ye(0,0);for(const gt of pe)if("branches"in gt){je.total+=1,je.covered+=gt.executed?1:0;for(const Jt of gt.branches)Ye.total+=1,Ye.covered+=Jt.executed?1:0}else nt.total+=1,nt.covered+=gt.executed?1:0;const dt=new ut(H,je,Ye.total>0?Ye:void 0,nt.total>0?nt:void 0);return dt.detailedCoverage=pe,dt}constructor(H,pe,je,Ye){this.uri=H,this.statementCoverage=pe,this.branchCoverage=je,this.declarationCoverage=Ye,We(pe),We(je),We(Ye)}}e.$4N=ut;class vt{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,pe,je=[]){this.executed=H,this.location=pe,this.branches=je}}e.$5N=vt;class Nt{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,pe,je){this.executed=H,this.location=pe,this.label=je}}e.$6N=Nt;class zi{get executionCount(){return+this.executed}set executionCount(H){this.executed=H}constructor(H,pe,je){this.name=H,this.executed=pe,this.location=je}}e.$7N=zi;var vn;(function(G){G[G.None=0]="None",G[G.Option=1]="Option",G[G.Default=2]="Default",G[G.Preferred=3]="Preferred"})(vn||(e.ExternalUriOpenerPriority=vn={}));var yn;(function(G){G[G.Untrusted=0]="Untrusted",G[G.Trusted=1]="Trusted",G[G.Unspecified=2]="Unspecified"})(yn||(e.WorkspaceTrustState=yn={}));var kn;(function(G){G[G.Notify=1]="Notify",G[G.OpenBrowser=2]="OpenBrowser",G[G.OpenPreview=3]="OpenPreview",G[G.Silent=4]="Silent",G[G.Ignore=5]="Ignore",G[G.OpenBrowserOnce=6]="OpenBrowserOnce"})(kn||(e.PortAutoForwardAction=kn={}));class jn{constructor(H,pe,je,Ye,nt,dt){this.kind=H,this.name=pe,this.detail=je,this.uri=Ye,this.range=nt,this.selectionRange=dt}}e.$8N=jn;class Nn{constructor(H){this.uri=H}}e.$9N=Nn;class Fn{constructor(H,pe){this.original=H,this.modified=pe}}e.$0N=Fn;class Tn{constructor(H,pe,je,Ye){this.base=H,this.input1=pe,this.input2=je,this.result=Ye}}e.$$N=Tn;class zn{constructor(H,pe){this.uri=H,this.viewType=pe}}e.$_N=zn;class Bn{constructor(H){this.viewType=H}}e.$aO=Bn;class Un{constructor(H,pe){this.uri=H,this.notebookType=pe}}e.$bO=Un;class Wn{constructor(H,pe,je){this.original=H,this.modified=pe,this.notebookType=je}}e.$cO=Wn;class Vn{constructor(){}}e.$dO=Vn;class qn{constructor(H,pe){this.uri=H,this.inputBoxUri=pe}}e.$eO=qn;class Hn{constructor(H){this.providerId=H}}e.$fO=Hn;class Gn{constructor(H){this.textDiffs=H}}e.$gO=Gn;var En;(function(G){G[G.Down=0]="Down",G[G.Up=1]="Up"})(En||(e.InteractiveSessionVoteDirection=En={}));var Cn;(function(G){G[G.Action=1]="Action",G[G.Toolbar=2]="Toolbar"})(Cn||(e.ChatCopyKind=Cn={}));var Sn;(function(G){G[G.Short=1]="Short",G[G.Medium=2]="Medium",G[G.Full=3]="Full"})(Sn||(e.ChatVariableLevel=Sn={}));class Kn{constructor(H,pe){this.label=H,this.values=pe}}e.$hO=Kn;var Dn;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful",G[G.Undone=2]="Undone",G[G.Accepted=3]="Accepted",G[G.Bug=4]="Bug"})(Dn||(e.InteractiveEditorResponseFeedbackKind=Dn={}));var In;(function(G){G[G.Unhelpful=0]="Unhelpful",G[G.Helpful=1]="Helpful"})(In||(e.ChatResultFeedbackKind=In={}));class Jn{constructor(H){this.value=typeof H=="string"?new Te(H):H}}e.$iO=Jn;class Qn{constructor(H,pe){this.value=H,this.baseUri=pe}}e.$jO=Qn;class Xn{constructor(H,pe){this.value=H,this.title=pe}}e.$kO=Xn;class Zn{constructor(H){this.value=H}}e.$lO=Zn;class Yn{constructor(H){this.value=H}}e.$mO=Yn;class xn{constructor(H){this.value=H}}e.$nO=xn;class _n{constructor(H,pe,je,Ye){this.prompt=H,this.command=pe,this.variables=je,this.participant=Ye}}e.$oO=_n;class er{constructor(H,pe,je,Ye){this.response=H,this.result=pe,this.participant=je,this.command=Ye}}e.$pO=er;var Pn;(function(G){G[G.Panel=1]="Panel",G[G.Terminal=2]="Terminal",G[G.Notebook=3]="Notebook"})(Pn||(e.ChatLocation=Pn={}));class tr{constructor(H){this.content=H}}e.$qO=tr;class ir{constructor(H,pe){this.content=H,this.name=pe}}e.$rO=ir;class nr{constructor(H){this.content=H}}e.$sO=nr;class Di extends Error{static NotFound(H){return new Di(H,Di.NotFound.name)}static NoPermissions(H){return new Di(H,Di.NoPermissions.name)}constructor(H,pe,je){super(H,{cause:je}),this.name="LanguageModelError",this.code=pe??""}}e.$tO=Di;var An;(function(G){G[G.SymbolInformation=1]="SymbolInformation",G[G.CommandInformation=2]="CommandInformation",G[G.SearchInformation=3]="SearchInformation",G[G.SettingInformation=4]="SettingInformation"})(An||(e.RelatedInformationType=An={}));var Rn;(function(G){G[G.Started=1]="Started",G[G.Recognizing=2]="Recognizing",G[G.Recognized=3]="Recognized",G[G.Stopped=4]="Stopped"})(Rn||(e.SpeechToTextStatus=Rn={}));var On;(function(G){G[G.Recognized=1]="Recognized",G[G.Stopped=2]="Stopped"})(On||(e.KeywordRecognitionStatus=On={}));class rr{constructor(H,pe){this.text=H,this.range=pe}}e.$uO=rr;var Mn;(function(G){G[G.Invoke=0]="Invoke",G[G.Automatic=1]="Automatic"})(Mn||(e.InlineEditTriggerKind=Mn={}))}),define(ke[323],Ee([1,0,6,7]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ic=void 0;class M{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(u.$lM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,b,$){if(this.a.size===0)throw new Error("No related information providers registered");const y=this.a.get(R);if(!y)throw new Error("related information provider not found");return await y.provideRelatedInformation(b,$)??[]}getRelatedInformation(R,b,$){return this.c.$getAiRelatedInformation(b,$)}registerRelatedInformationProvider(R,b,$){const y=this.b;return this.b++,this.a.set(y,$),this.c.$registerAiRelatedInformationProvider(y,b),new L.$nM(()=>{this.c.$unregisterAiRelatedInformationProvider(y),this.a.delete(y)})}}e.$2ic=M}),define(ke[120],Ee([1,0,4,6,7,25,145,5,20]),function(he,e,u,L,M,P,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bjc=e.$ajc=void 0,e.$ajc=(0,b.$ii)("IExtHostAuthentication");let y=class{constructor(p){this.b=new Map,this.c=new u.$7d,this.onDidChangeSessions=this.c.event,this.d=new A,this.f=new A,this.a=p.getProxy(L.$lM.MainThreadAuthentication)}async getSession(p,E,v,a={}){const m=P.$Dm.toKey(p.identifier),o=[...v].sort().join(" ");return await this.d.getOrCreate(`${m} ${E} ${o}`,async()=>{await this.a.$ensureProvider(E);const n=p.displayName||p.name;return this.a.$getSession(E,v,m,n,a)})}async getSessions(p,E,v){const a=P.$Dm.toKey(p.identifier),m=[...v].sort().join(" ");return await this.f.getOrCreate(`${a} ${m}`,async()=>{await this.a.$ensureProvider(E);const o=p.displayName||p.name;return this.a.$getSessions(E,v,a,o)})}async removeSession(p,E){const v=this.b.get(p);return v?v.provider.removeSession(E):this.a.$removeSession(p,E)}registerAuthenticationProvider(p,E,v,a){if(this.b.get(p))throw new Error(`An authentication provider with id '${p}' is already registered.`);this.b.set(p,{label:E,provider:v,options:a??{supportsMultipleAccounts:!1}});const m=v.onDidChangeSessions(o=>this.a.$sendDidChangeSessions(p,o));return this.a.$registerAuthenticationProvider(p,E,a?.supportsMultipleAccounts??!1),new M.$nM(()=>{m.dispose(),this.b.delete(p),this.a.$unregisterAuthenticationProvider(p)})}$createSession(p,E,v){const a=this.b.get(p);if(a)return Promise.resolve(a.provider.createSession(E,v));throw new Error(`Unable to find authentication provider with handle: ${p}`)}$removeSession(p,E){const v=this.b.get(p);if(v)return Promise.resolve(v.provider.removeSession(E));throw new Error(`Unable to find authentication provider with handle: ${p}`)}$getSessions(p,E){const v=this.b.get(p);if(v)return Promise.resolve(v.provider.getSessions(E));throw new Error(`Unable to find authentication provider with handle: ${p}`)}$onDidChangeAuthenticationSessions(p,E){return p.startsWith(R.$nL)||this.c.fire({provider:{id:p,label:E}}),Promise.resolve()}};e.$bjc=y,e.$bjc=y=Je([qe(0,$.$GO)],y);class A{constructor(){this.a=new Map}getOrCreate(p,E){const v=this.a.get(p);if(v)return v;const a=E().finally(()=>this.a.delete(p));return this.a.set(p,a),a}}}),define(ke[151],Ee([1,0,2,6,7,5,20,12,19,14,17,26]),function(he,e,u,L,M,P,R,b,$,y,A,I){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$ckc=e.$bkc=void 0;let E=class{static{p=this}static{this.c=0}static{this.d=250}constructor(a,m){this.h=m,this.f=new Map,this.g=a.getProxy(L.$lM.MainThreadDecorations)}registerFileDecorationProvider(a,m){const o=p.c++;this.f.set(o,{provider:a,extensionDescription:m}),this.g.$registerDecorationProvider(o,m.identifier.value);const n=a.onDidChangeFileDecorations&&a.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(o,null);return}const r=(0,$.$3b)(i);if(r.length<=p.d){this.g.$onDidChange(o,r);return}this.h.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,r.length);const s=r.map(d=>({uri:d,rank:(0,y.$1e)(d.path,"/")})),t=(0,$.$zb)(s,(d,l)=>d.rank-l.rank||(0,y.$ef)(d.uri.path,l.uri.path)),f=[];e:for(const d of t){let l;for(const c of d){const h=(0,A.$nc)(c.uri.path);if(l!==h&&(l=h,f.push(c.uri)>=p.d))break e}}this.g.$onDidChange(o,f)});return new M.$nM(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(a,m,o){if(!this.f.has(a))return Object.create(null);const n=Object.create(null),{provider:i,extensionDescription:r}=this.f.get(a);return await Promise.all(m.map(async s=>{try{const{uri:t,id:f}=s,d=await Promise.resolve(i.provideFileDecoration(u.URI.revive(t),o));if(!d)return;try{M.$MN.validate(d),d.badge&&typeof d.badge!="string"&&(0,I.$0F)(r,"codiconDecoration"),n[f]=[d.propagate,d.tooltip,d.badge,d.color]}catch(l){this.h.warn(`INVALID decoration from extension '${r.identifier.value}': ${l}`)}}catch(t){this.h.error(t)}})),n}};e.$bkc=E,e.$bkc=E=p=Je([qe(0,R.$GO),qe(1,b.$Oj)],E),e.$ckc=(0,P.$ii)("IExtHostDecorations")}),define(ke[324],Ee([1,0,13,2,7,6,15,22,14]),function(he,e,u,L,M,P,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ekc=void 0;class y{static{this.a=0}constructor(I,p,E){this.d=p,this.e=E,this.b=new Map,this.c=I.getProxy(P.$lM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,p){if(Object.keys(R.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const E=y.a++;this.b.set(E,p),this.c.$registerTextContentProvider(E,I);let v;if(typeof p.onDidChange=="function"){let a;v=p.onDidChange(async m=>{if(m.scheme!==I){this.e.warn(`Provider for scheme '${I}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(m))return;a&&await a;const o=this.$provideTextDocumentContent(E,m).then(async n=>{if(!n&&typeof n!="string")return;const i=this.d.getDocument(m);if(!i)return;const r=(0,$.$$e)(n);if(!i.equalLines(r))return this.c.$onVirtualDocumentChange(m,n)}).catch(u.$1).finally(()=>{a===o&&(a=void 0)});a=o})}return new M.$nM(()=>{this.b.delete(E)&&this.c.$unregisterTextContentProvider(E),v&&(v.dispose(),v=void 0)})}$provideTextDocumentContent(I,p){const E=this.b.get(I);return E?Promise.resolve(E.provideTextDocumentContent(L.URI.revive(p),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${p.scheme}`))}}e.$ekc=y}),define(ke[152],Ee([1,0,61,15,14,182,129,7,19]),function(he,e,u,L,M,P,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KO=e.$JO=void 0,e.$IO=A;const y=new Map;function A(v,a){a?y.set(v,a):y.delete(v)}function I(v){return y.get(v)}class p extends P.$Hv{constructor(a,m,o,n,i,r,s){super(m,o,n,i),this.c=a,this.m=r,this.q=s,this.b=!1}dispose(){(0,u.ok)(!this.b),this.b=!0,this.q=!1}equalLines(a){return(0,$.$ub)(this.f,a)}get document(){if(!this.a){const a=this;this.a={get uri(){return a.d},get fileName(){return a.d.fsPath},get isUntitled(){return a.d.scheme===L.Schemas.untitled},get languageId(){return a.m},get version(){return a.h},get isClosed(){return a.b},get isDirty(){return a.q},save(){return a.r()},getText(m){return m?a.s(m):a.getText()},get eol(){return a.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return a.f.length},lineAt(m){return a.t(m)},offsetAt(m){return a.u(m)},positionAt(m){return a.v(m)},validateRange(m){return a.w(m)},validatePosition(m){return a.x(m)},getWordRangeAtPosition(m,o){return a.y(m,o)}}}return Object.freeze(this.a)}_acceptLanguageId(a){(0,u.ok)(!this.b),this.m=a}_acceptIsDirty(a){(0,u.ok)(!this.b),this.q=a}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(a){const m=this.w(a);if(m.isEmpty)return"";if(m.isSingleLine)return this.f[m.start.line].substring(m.start.character,m.end.character);const o=this.g,n=m.start.line,i=m.end.line,r=[];r.push(this.f[n].substring(m.start.character));for(let s=n+1;s<i;s++)r.push(this.f[s]);return r.push(this.f[i].substring(0,m.end.character)),r.join(o)}t(a){let m;if(a instanceof b.$oM?m=a.line:typeof a=="number"&&(m=a),typeof m!="number"||m<0||m>=this.f.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new E(m,this.f[m],m===this.f.length-1)}u(a){return a=this.x(a),this.l(),this.j.getPrefixSum(a.line-1)+a.character}v(a){a=Math.floor(a),a=Math.max(0,a),this.l();const m=this.j.getIndexOf(a),o=this.f[m.index].length;return new b.$oM(m.index,Math.min(m.remainder,o))}w(a){if(!(a instanceof b.$pM))throw new Error("Invalid argument");const m=this.x(a.start),o=this.x(a.end);return m===a.start&&o===a.end?a:new b.$pM(m.line,m.character,o.line,o.character)}x(a){if(!(a instanceof b.$oM))throw new Error("Invalid argument");if(this.f.length===0)return a.with(0,0);let{line:m,character:o}=a,n=!1;if(m<0)m=0,o=0,n=!0;else if(m>=this.f.length)m=this.f.length-1,o=this.f[m].length,n=!0;else{const i=this.f[m].length;o<0?(o=0,n=!0):o>i&&(o=i,n=!0)}return n?new b.$oM(m,o):a}y(a,m){const o=this.x(a);if(!m)m=I(this.m);else if((0,M.$0e)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const n=(0,R.$Rs)(o.character+1,(0,R.$Ps)(m),this.f[o.line],0);if(n)return new b.$pM(o.line,n.startColumn-1,o.line,n.endColumn-1)}}e.$JO=p;class E{constructor(a,m,o){this.a=a,this.b=m,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$pM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$pM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$KO=E}),define(ke[325],Ee([1,0,6,7]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gkc=void 0;class M{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(u.$lM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,b,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const y=this.a.get(R);if(!y)throw new Error("Embedding vector provider not found");const A=await y.provideEmbeddingVector(b,$);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(R,b,$){const y=this.b;return this.b++,this.a.set(y,$),this.c.$registerAiEmbeddingVectorProvider(b,y),new L.$nM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(y),this.a.delete(y)})}}e.$gkc=M}),define(ke[69],Ee([1,0,6,32,7,21,5,20,59,3,8,23,15]),function(he,e,u,L,M,P,R,b,$,y,A,I,p){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$ujc=e.$tjc=void 0;let v=E=class{constructor(m,o){this.b=new Map,this.c=new A.$rh,this.a=m.getProxy(u.$lM.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(i){try{let r;const s=n.b.get(i.scheme);return s?(await n.a.$ensureActivation(i.scheme),r=await s.impl.stat(i)):r=await n.a.$stat(i),{type:r.type,ctime:r.ctime,mtime:r.mtime,size:r.size,permissions:r.permissions===L.FilePermission.Readonly?1:void 0}}catch(r){E.e(r)}},async readDirectory(i){try{const r=n.b.get(i.scheme);return r?(await n.a.$ensureActivation(i.scheme),(await r.impl.readDirectory(i)).slice()):await n.a.$readdir(i)}catch(r){return E.e(r)}},async createDirectory(i){try{const r=n.b.get(i.scheme);return r&&!r.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(r.impl,r.extUri,i)):await n.a.$mkdir(i)}catch(r){return E.e(r)}},async readFile(i){try{const r=n.b.get(i.scheme);return r?(await n.a.$ensureActivation(i.scheme),(await r.impl.readFile(i)).slice()):(await n.a.$readFile(i)).buffer}catch(r){return E.e(r)}},async writeFile(i,r){try{const s=n.b.get(i.scheme);return s&&!s.isReadonly?(await n.a.$ensureActivation(i.scheme),await n.d(s.impl,s.extUri,s.extUri.dirname(i)),await n.c.queueFor(i,()=>Promise.resolve(s.impl.writeFile(i,r,{create:!0,overwrite:!0})))):await n.a.$writeFile(i,P.$ue.wrap(r))}catch(s){return E.e(s)}},async delete(i,r){try{const s=n.b.get(i.scheme);return s&&!s.isReadonly&&!r?.useTrash?(await n.a.$ensureActivation(i.scheme),await s.impl.delete(i,{recursive:!1,...r})):await n.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...r})}catch(s){return E.e(s)}},async rename(i,r,s){try{return await n.a.$rename(i,r,{overwrite:!1,...s})}catch(t){return E.e(t)}},async copy(i,r,s){try{return await n.a.$copy(i,r,{overwrite:!1,...s})}catch(t){return E.e(t)}},isWritableFileSystem(i){const r=o.getCapabilities(i);if(typeof r=="number")return!(r&2048)}})}async d(m,o,n){const i=[];for(;!o.isEqual(n,o.dirname(n));)try{if(!((await m.stat(n)).type&L.FileType.Directory))throw M.$DN.FileExists(`Unable to create folder '${n.scheme===p.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(r){if(L.$5k(r)!==L.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(o.basename(n)),n=o.dirname(n)}for(let r=i.length-1;r>=0;r--){n=o.joinPath(n,i[r]);try{await m.createDirectory(n)}catch(s){if(L.$5k(s)!==L.FileSystemProviderErrorCode.FileExists)throw s}}}static e(m){if(m instanceof M.$DN)throw m;if(m instanceof L.$1k)switch(m.code){case L.FileSystemProviderErrorCode.FileExists:throw M.$DN.FileExists(m.message);case L.FileSystemProviderErrorCode.FileNotFound:throw M.$DN.FileNotFound(m.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw M.$DN.FileNotADirectory(m.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw M.$DN.FileIsADirectory(m.message);case L.FileSystemProviderErrorCode.NoPermissions:throw M.$DN.NoPermissions(m.message);case L.FileSystemProviderErrorCode.Unavailable:throw M.$DN.Unavailable(m.message);default:throw new M.$DN(m.message,m.name)}if(!(m instanceof Error))throw new M.$DN(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw M.$DN.Unavailable(m.message);switch(m.name){case L.FileSystemProviderErrorCode.FileExists:throw M.$DN.FileExists(m.message);case L.FileSystemProviderErrorCode.FileNotFound:throw M.$DN.FileNotFound(m.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw M.$DN.FileNotADirectory(m.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw M.$DN.FileIsADirectory(m.message);case L.FileSystemProviderErrorCode.NoPermissions:throw M.$DN.NoPermissions(m.message);case L.FileSystemProviderErrorCode.Unavailable:throw M.$DN.Unavailable(m.message);default:throw new M.$DN(m.message,m.name)}}addFileSystemProvider(m,o,n){return this.b.set(m,{impl:o,extUri:n?.isCaseSensitive?I.$Lg:I.$Ng,isReadonly:!!n?.isReadonly}),(0,y.$Sc)(()=>this.b.delete(m))}getFileSystemProviderExtUri(m){return this.b.get(m)?.extUri??I.$Lg}};e.$tjc=v,e.$tjc=v=E=Je([qe(0,b.$GO),qe(1,$.$7ic)],v),e.$ujc=(0,R.$ii)("IExtHostConsumerFileSystem")}),define(ke[326],Ee([1,0,6,7]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xkc=void 0;class M{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(u.$lM.MainThreadIssueReporter)}async $getIssueReporterUri(R,b){if(this.a.size===0)throw new Error("No issue request handlers registered");const $=this.a.get(R);if(!$)throw new Error("Issue request handler not found");const y=await $.handleIssueUrlRequest();if(!y)throw new Error("Issue request handler returned no result");return y}async $getIssueReporterData(R,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(R);if(!$)throw new Error("Issue data provider not found");const y=await $.provideIssueData(b);if(!y)throw new Error("Issue data provider returned no result");return y}async $getIssueReporterTemplate(R,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(R);if(!$)throw new Error("Issue data provider not found");const y=await $.provideIssueTemplate(b);if(!y)throw new Error("Issue template provider returned no result");return y}registerIssueUriRequestHandler(R,b){const $=R.identifier.value;return this.a.set($,b),this.c.$registerIssueUriRequestHandler($),new L.$nM(()=>{this.c.$unregisterIssueUriRequestHandler($),this.a.delete($)})}registerIssueDataProvider(R,b){const $=R.identifier.value;return this.b.set($,b),this.c.$registerIssueDataProvider($),new L.$nM(()=>{this.c.$unregisterIssueDataProvider($),this.b.delete($)})}}e.$xkc=M}),define(ke[93],Ee([1,0,5,28,12,69,2]),function(he,e,u,L,M,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wjc=e.$vjc=void 0,e.$vjc=(0,u.$ii)("IExtensionStoragePaths");let b=class{constructor(y,A,I){this.d=A,this.f=I,this.a=y.workspace??void 0,this.b=y.environment,this.whenReady=this.h().then(p=>this.c=p)}async g(y){return R.URI.joinPath(this.b.workspaceStorageHome,y)}async h(){if(!this.a)return Promise.resolve(void 0);const y=this.a.id,A=await this.g(y);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(R.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(I){this.d.error("[ExtHostStorage]",I);return}}workspaceValue(y){if(this.c)return R.URI.joinPath(this.c,y.identifier.value)}globalValue(y){return R.URI.joinPath(this.b.globalStorageHome,y.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$wjc=b,e.$wjc=b=Je([qe(0,L.$WO),qe(1,M.$Oj),qe(2,P.$ujc)],b)}),define(ke[327],Ee([1,0,7,20,4]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1kc=void 0;let P=class{constructor(b){this.a=new u.$NN(u.ColorThemeKind.Dark),this.b=new M.$7d}get activeColorTheme(){return this.a}$onColorThemeChange(b){let $;switch(b){case"light":$=u.ColorThemeKind.Light;break;case"hcDark":$=u.ColorThemeKind.HighContrast;break;case"hcLight":$=u.ColorThemeKind.HighContrastLight;break;default:$=u.ColorThemeKind.Dark}this.a=new u.$NN($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$1kc=P,e.$1kc=P=Je([qe(0,L.$GO)],P)}),define(ke[70],Ee([1,0,22,4,3,228,5,12,88,6,28,20,7]),function(he,e,u,L,M,P,R,b,$,y,A,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OBb=e.$NBb=e.TunnelDtoConverter=void 0;class E extends $.$7v{}var v;(function(m){function o(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:i.protocol}}m.fromApiTunnel=o;function n(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==$.TunnelPrivacyId.ConstantPrivate&&i.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}m.fromServiceTunnel=n})(v||(e.TunnelDtoConverter=v={})),e.$NBb=(0,R.$ii)("IExtHostTunnelService");let a=class extends M.$Uc{constructor(o,n,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new L.$7d,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(y.$lM.MainThreadTunnelService)}async openTunnel(o,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const i=await this.a.$openTunnel(n,o.displayName);if(i){const r=new E(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(r),r}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,n){o.portRange===void 0&&o.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:o,provider:n}),this.a.$registerPortsAttributesProvider(o,i),new p.$nM(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(o,n,i,r,s){const t=[];for(const d of o){const l=this.r.get(d);if(!l)return[];t.push(...await Promise.all(n.map(async c=>{let h;try{h=await l.provider.providePortAttributes({port:c,pid:i,commandLine:r},s)}catch{h=await l.provider.providePortAttributes(c,i,r,s)}return{providedAttributes:h,port:c}})))}const f=t.filter(d=>!!d.providedAttributes);return f.length>0?f.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(r,s)=>await o.provideTunnel(r,s,u.CancellationToken.None)??void 0;const i=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,M.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,n){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const i=o.tunnelFactory??(n?this.w(n):void 0);if(i){this.b=i;let r=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&r.length===0&&(r=[{id:"private",label:P.localize(0,null),themeIcon:"lock"},{id:"public",label:P.localize(1,null),themeIcon:"eye"}]);const s=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:r,protocol:!0}:void 0;this.a.$setTunnelProvider(s)}}else this.b=void 0;return(0,M.$Sc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,n){if(this.g.has(o.host)){const i=this.g.get(o.host);i.has(o.port)&&(n&&i.get(o.port).disposeListener.dispose(),await i.get(o.port).tunnel.dispose(),i.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(o,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const r=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),r===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const s=this.B(r.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(r.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:r,disposeListener:s}),v.fromApiTunnel(r)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(o){const n=await Promise.all(o.map(r=>this.f(r.host,r.port,r.detail??""))),i=o.filter((r,s)=>n[s]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(r=>r.port).join(", ")} to ${i.map(r=>r.port).join(", ")}`),i}};e.$OBb=a,e.$OBb=a=Je([qe(0,I.$GO),qe(1,A.$WO),qe(2,b.$Oj)],a)}),define(ke[16],Ee([1,0,19,21,171,74,80,27,164,57,101,24,166,23,18,2,29,83,138,144,142,289,119,67,89,301,26,7]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v,a,m,o,n,i,r,s,t,f,d,l,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$DO=B,e.$EO=Z,e.$FO=_;var g;(function(Me){function ze(ne){const{selectionStartLineNumber:Le,selectionStartColumn:Ve,positionLineNumber:et,positionColumn:Xe}=ne,ct=new h.$oM(Le-1,Ve-1),kt=new h.$oM(et-1,Xe-1);return new h.$qM(ct,kt)}Me.to=ze;function ve(ne){const{anchor:Le,active:Ve}=ne;return{selectionStartLineNumber:Le.line+1,selectionStartColumn:Le.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}Me.from=ve})(g||(e.Selection=g={}));var S;(function(Me){function ze(ne){if(!ne)return;const{start:Le,end:Ve}=ne;return{startLineNumber:Le.line+1,startColumn:Le.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}Me.from=ze;function ve(ne){if(!ne)return;const{startLineNumber:Le,startColumn:Ve,endLineNumber:et,endColumn:Xe}=ne;return new h.$pM(Le-1,Ve-1,et-1,Xe-1)}Me.to=ve})(S||(e.Range=S={}));var w;(function(Me){function ze(ne){return{uri:ne.uri,range:S.from(ne.range)}}Me.from=ze;function ve(ne){return new h.$zM(a.URI.revive(ne.uri),S.to(ne.range))}Me.to=ve})(w||(e.Location=w={}));var C;(function(Me){function ze(ve){switch(ve){case 1:return h.StandardTokenType.Comment;case 0:return h.StandardTokenType.Other;case 3:return h.StandardTokenType.RegEx;case 2:return h.StandardTokenType.String}}Me.to=ze})(C||(e.TokenType=C={}));var k;(function(Me){function ze(ne){return new h.$oM(ne.lineNumber-1,ne.column-1)}Me.to=ze;function ve(ne){return{lineNumber:ne.line+1,column:ne.character+1}}Me.from=ve})(k||(e.Position=k={}));var D;(function(Me){function ze(Le,Ve,et){return(0,u.$Hb)((0,u.$3b)(Le).map(Xe=>ve(Xe,Ve,et)))}Me.from=ze;function ve(Le,Ve,et){if(typeof Le=="string")return{$serialized:!0,language:Le,isBuiltin:et?.isBuiltin};if(Le)return{$serialized:!0,language:Le.language,scheme:ne(Le.scheme,Ve),pattern:Pe.from(Le.pattern)??void 0,exclusive:Le.exclusive,notebookType:Le.notebookType,isBuiltin:et?.isBuiltin}}function ne(Le,Ve){return Ve&&typeof Le=="string"?Ve.transformOutgoingScheme(Le):Le}})(D||(e.DocumentSelector=D={}));var O;(function(Me){function ze(ne){switch(ne){case h.DiagnosticTag.Unnecessary:return 1;case h.DiagnosticTag.Deprecated:return 2}}Me.from=ze;function ve(ne){switch(ne){case 1:return h.DiagnosticTag.Unnecessary;case 2:return h.DiagnosticTag.Deprecated;default:return}}Me.to=ve})(O||(e.DiagnosticTag=O={}));var F;(function(Me){function ze(ne){let Le;return ne.code&&((0,v.$Vf)(ne.code)||(0,v.$Zf)(ne.code)?Le=String(ne.code):Le={value:String(ne.code.value),target:ne.code.target}),{...S.from(ne.range),message:ne.message,source:ne.source,code:Le,severity:z.from(ne.severity),relatedInformation:ne.relatedInformation&&ne.relatedInformation.map(T.from),tags:Array.isArray(ne.tags)?(0,u.$Hb)(ne.tags.map(O.from)):void 0}}Me.from=ze;function ve(ne){const Le=new h.$BM(S.to(ne),ne.message,z.to(ne.severity));return Le.source=ne.source,Le.code=(0,v.$Vf)(ne.code)?ne.code:ne.code?.value,Le.relatedInformation=ne.relatedInformation&&ne.relatedInformation.map(T.to),Le.tags=ne.tags&&(0,u.$Hb)(ne.tags.map(O.to)),Le}Me.to=ve})(F||(e.Diagnostic=F={}));var T;(function(Me){function ze(ne){return{...S.from(ne.location.range),message:ne.message,resource:ne.location.uri}}Me.from=ze;function ve(ne){return new h.$AM(new h.$zM(ne.resource,S.to(ne)),ne.message)}Me.to=ve})(T||(e.DiagnosticRelatedInformation=T={}));var z;(function(Me){function ze(ne){switch(ne){case h.DiagnosticSeverity.Error:return n.MarkerSeverity.Error;case h.DiagnosticSeverity.Warning:return n.MarkerSeverity.Warning;case h.DiagnosticSeverity.Information:return n.MarkerSeverity.Info;case h.DiagnosticSeverity.Hint:return n.MarkerSeverity.Hint}return n.MarkerSeverity.Error}Me.from=ze;function ve(ne){switch(ne){case n.MarkerSeverity.Info:return h.DiagnosticSeverity.Information;case n.MarkerSeverity.Warning:return h.DiagnosticSeverity.Warning;case n.MarkerSeverity.Error:return h.DiagnosticSeverity.Error;case n.MarkerSeverity.Hint:return h.DiagnosticSeverity.Hint;default:return h.DiagnosticSeverity.Error}}Me.to=ve})(z||(e.DiagnosticSeverity=z={}));var j;(function(Me){function ze(ne){return typeof ne=="number"&&ne>=h.ViewColumn.One?ne-1:ne===h.ViewColumn.Beside?l.$CD:l.$BD}Me.from=ze;function ve(ne){if(typeof ne=="number"&&ne>=0)return ne+1;throw new Error("invalid 'EditorGroupColumn'")}Me.to=ve})(j||(e.ViewColumn=j={}));function N(Me){return typeof Me.range<"u"}function B(Me){return Me.length===0?!0:!!N(Me[0])}var W;(function(Me){function ze(Xe){return Xe.map(Me.from)}Me.fromMany=ze;function ve(Xe){return Xe&&typeof Xe=="object"&&typeof Xe.language=="string"&&typeof Xe.value=="string"}function ne(Xe){let ct;if(ve(Xe)){const{language:Lt,value:ht}=Xe;ct={value:"```"+Lt+`
`+ht+"\n```\n"}}else h.$OM.isMarkdownString(Xe)?ct={value:Xe.value,isTrusted:Xe.isTrusted,supportThemeIcons:Xe.supportThemeIcons,supportHtml:Xe.supportHtml,baseUri:Xe.baseUri}:typeof Xe=="string"?ct={value:Xe}:ct={value:""};const kt=Object.create(null);ct.uris=kt;const Kt=Lt=>{try{let ht=a.URI.parse(Lt,!0);ht=ht.with({query:Le(ht.query,kt)}),kt[Lt]=ht}catch{}return""},Wt=new $.marked.Renderer;return Wt.link=Kt,Wt.image=Lt=>typeof Lt=="string"?Kt(R.$Nk(Lt).href):"",(0,$.marked)(ct.value,{renderer:Wt}),ct}Me.from=ne;function Le(Xe,ct){if(!Xe)return Xe;let kt;try{kt=(0,y.$Qh)(Xe)}catch{}if(!kt)return Xe;let Kt=!1;return kt=(0,I.$Qn)(kt,Wt=>{if(a.URI.isUri(Wt)){const Lt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[Lt]=Wt,Kt=!0,Lt}else return}),Kt?JSON.stringify(kt):Xe}function Ve(Xe){const ct=new h.$OM(Xe.value,Xe.supportThemeIcons);return ct.isTrusted=Xe.isTrusted,ct.supportHtml=Xe.supportHtml,ct.baseUri=Xe.baseUri?a.URI.from(Xe.baseUri):void 0,ct}Me.to=Ve;function et(Xe){if(Xe)return typeof Xe=="string"?Xe:Me.from(Xe)}Me.fromStrict=et})(W||(e.MarkdownString=W={}));function Z(Me){return B(Me)?Me.map(ze=>({range:S.from(ze.range),hoverMessage:Array.isArray(ze.hoverMessage)?W.fromMany(ze.hoverMessage):ze.hoverMessage?W.from(ze.hoverMessage):void 0,renderOptions:ze.renderOptions})):Me.map(ze=>({range:S.from(ze)}))}function _(Me){return typeof Me>"u"?Me:typeof Me=="string"?a.URI.file(Me):Me}var X;(function(Me){function ze(ve){return typeof ve>"u"?ve:{contentText:ve.contentText,contentIconPath:ve.contentIconPath?_(ve.contentIconPath):void 0,border:ve.border,borderColor:ve.borderColor,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,color:ve.color,backgroundColor:ve.backgroundColor,margin:ve.margin,width:ve.width,height:ve.height}}Me.from=ze})(X||(e.ThemableDecorationAttachmentRenderOptions=X={}));var x;(function(Me){function ze(ve){return typeof ve>"u"?ve:{backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?_(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?X.from(ve.before):void 0,after:ve.after?X.from(ve.after):void 0}}Me.from=ze})(x||(e.ThemableDecorationRenderOptions=x={}));var re;(function(Me){function ze(ve){if(typeof ve>"u")return ve;switch(ve){case h.DecorationRangeBehavior.OpenOpen:return 0;case h.DecorationRangeBehavior.ClosedClosed:return 1;case h.DecorationRangeBehavior.OpenClosed:return 2;case h.DecorationRangeBehavior.ClosedOpen:return 3}}Me.from=ze})(re||(e.DecorationRangeBehavior=re={}));var Y;(function(Me){function ze(ve){return{isWholeLine:ve.isWholeLine,rangeBehavior:ve.rangeBehavior?re.from(ve.rangeBehavior):void 0,overviewRulerLane:ve.overviewRulerLane,light:ve.light?x.from(ve.light):void 0,dark:ve.dark?x.from(ve.dark):void 0,backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?_(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?X.from(ve.before):void 0,after:ve.after?X.from(ve.after):void 0}}Me.from=ze})(Y||(e.DecorationRenderOptions=Y={}));var me;(function(Me){function ze(ne){return{text:ne.newText,eol:ne.newEol&&Ge.from(ne.newEol),range:S.from(ne.range)}}Me.from=ze;function ve(ne){const Le=new h.$uM(S.to(ne.range),ne.text);return Le.newEol=typeof ne.eol>"u"?void 0:Ge.to(ne.eol),Le}Me.to=ve})(me||(e.TextEdit=me={}));var Ce;(function(Me){function ze(ne,Le){const Ve={edits:[]};if(ne instanceof h.$xM){const et=new b.$Cc;for(const Xe of ne._allEntries())Xe._type===1&&a.URI.isUri(Xe.to)&&Xe.from===void 0&&et.add(Xe.to);for(const Xe of ne._allEntries())if(Xe._type===1){let ct;Xe.options?.contents&&(ArrayBuffer.isView(Xe.options.contents)?ct={type:"base64",value:(0,L.$Oe)(L.$ue.wrap(Xe.options.contents))}:ct={type:"dataTransferItem",id:Xe.options.contents._itemId}),Ve.edits.push({oldResource:Xe.from,newResource:Xe.to,options:{...Xe.options,contents:ct},metadata:Xe.metadata})}else Xe._type===2?Ve.edits.push({resource:Xe.uri,textEdit:me.from(Xe.edit),versionId:et.has(Xe.uri)?void 0:Le?.getTextDocumentVersion(Xe.uri),metadata:Xe.metadata}):Xe._type===6?Ve.edits.push({resource:Xe.uri,textEdit:{range:S.from(Xe.range),text:Xe.edit.value,insertAsSnippet:!0},versionId:et.has(Xe.uri)?void 0:Le?.getTextDocumentVersion(Xe.uri),metadata:Xe.metadata}):Xe._type===3?Ve.edits.push({metadata:Xe.metadata,resource:Xe.uri,cellEdit:Xe.edit,notebookMetadata:Xe.notebookMetadata,notebookVersionId:Le?.getNotebookDocumentVersion(Xe.uri)}):Xe._type===5&&Ve.edits.push({metadata:Xe.metadata,resource:Xe.uri,notebookVersionId:Le?.getNotebookDocumentVersion(Xe.uri),cellEdit:{editType:1,index:Xe.index,count:Xe.count,cells:Xe.cells.map(Qt.from)}})}return Ve}Me.from=ze;function ve(ne){const Le=new h.$xM,Ve=new b.$Bc;for(const et of ne.edits)if(et.textEdit){const Xe=et,ct=a.URI.revive(Xe.resource),kt=S.to(Xe.textEdit.range),Kt=Xe.textEdit.text,Wt=Xe.textEdit.insertAsSnippet;let Lt;Wt?Lt=h.$wM.replace(kt,new h.$yM(Kt)):Lt=h.$uM.replace(kt,Kt);const ht=Ve.get(ct);ht?ht.push(Lt):Ve.set(ct,[Lt])}else Le.renameFile(a.URI.revive(et.oldResource),a.URI.revive(et.newResource),et.options);for(const[et,Xe]of Ve)Le.set(et,Xe);return Le}Me.to=ve})(Ce||(e.WorkspaceEdit=Ce={}));var ee;(function(Me){const ze=Object.create(null);ze[h.SymbolKind.File]=0,ze[h.SymbolKind.Module]=1,ze[h.SymbolKind.Namespace]=2,ze[h.SymbolKind.Package]=3,ze[h.SymbolKind.Class]=4,ze[h.SymbolKind.Method]=5,ze[h.SymbolKind.Property]=6,ze[h.SymbolKind.Field]=7,ze[h.SymbolKind.Constructor]=8,ze[h.SymbolKind.Enum]=9,ze[h.SymbolKind.Interface]=10,ze[h.SymbolKind.Function]=11,ze[h.SymbolKind.Variable]=12,ze[h.SymbolKind.Constant]=13,ze[h.SymbolKind.String]=14,ze[h.SymbolKind.Number]=15,ze[h.SymbolKind.Boolean]=16,ze[h.SymbolKind.Array]=17,ze[h.SymbolKind.Object]=18,ze[h.SymbolKind.Key]=19,ze[h.SymbolKind.Null]=20,ze[h.SymbolKind.EnumMember]=21,ze[h.SymbolKind.Struct]=22,ze[h.SymbolKind.Event]=23,ze[h.SymbolKind.Operator]=24,ze[h.SymbolKind.TypeParameter]=25;function ve(Le){return typeof ze[Le]=="number"?ze[Le]:6}Me.from=ve;function ne(Le){for(const Ve in ze)if(ze[Ve]===Le)return Number(Ve);return h.SymbolKind.Property}Me.to=ne})(ee||(e.SymbolKind=ee={}));var U;(function(Me){function ze(ne){switch(ne){case h.SymbolTag.Deprecated:return 1}}Me.from=ze;function ve(ne){switch(ne){case 1:return h.SymbolTag.Deprecated}}Me.to=ve})(U||(e.SymbolTag=U={}));var ie;(function(Me){function ze(ne){return{name:ne.name,kind:ee.from(ne.kind),tags:ne.tags&&ne.tags.map(U.from),containerName:ne.containerName,location:se.from(ne.location)}}Me.from=ze;function ve(ne){const Le=new h.$FM(ne.name,ee.to(ne.kind),ne.containerName,se.to(ne.location));return Le.tags=ne.tags&&ne.tags.map(U.to),Le}Me.to=ve})(ie||(e.WorkspaceSymbol=ie={}));var be;(function(Me){function ze(ne){const Le={name:ne.name||"!!MISSING: name!!",detail:ne.detail,range:S.from(ne.range),selectionRange:S.from(ne.selectionRange),kind:ee.from(ne.kind),tags:ne.tags?.map(U.from)??[]};return ne.children&&(Le.children=ne.children.map(ze)),Le}Me.from=ze;function ve(ne){const Le=new h.$GM(ne.name,ne.detail,ee.to(ne.kind),S.to(ne.range),S.to(ne.selectionRange));return(0,u.$Lb)(ne.tags)&&(Le.tags=ne.tags.map(U.to)),ne.children&&(Le.children=ne.children.map(ve)),Le}Me.to=ve})(be||(e.DocumentSymbol=be={}));var Se;(function(Me){function ze(ne){const Le=new h.$KM(ee.to(ne.kind),ne.name,ne.detail||"",a.URI.revive(ne.uri),S.to(ne.range),S.to(ne.selectionRange));return Le._sessionId=ne._sessionId,Le._itemId=ne._itemId,Le}Me.to=ze;function ve(ne,Le,Ve){if(Le=Le??ne._sessionId,Ve=Ve??ne._itemId,Le===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Ve,name:ne.name,detail:ne.detail,kind:ee.from(ne.kind),uri:ne.uri,range:S.from(ne.range),selectionRange:S.from(ne.selectionRange),tags:ne.tags?.map(U.from)}}Me.from=ve})(Se||(e.CallHierarchyItem=Se={}));var ae;(function(Me){function ze(ve){return new h.$LM(Se.to(ve.from),ve.fromRanges.map(ne=>S.to(ne)))}Me.to=ze})(ae||(e.CallHierarchyIncomingCall=ae={}));var ce;(function(Me){function ze(ve){return new h.$MM(Se.to(ve.to),ve.fromRanges.map(ne=>S.to(ne)))}Me.to=ze})(ce||(e.CallHierarchyOutgoingCall=ce={}));var se;(function(Me){function ze(ne){return{range:ne.range&&S.from(ne.range),uri:ne.uri}}Me.from=ze;function ve(ne){return new h.$zM(a.URI.revive(ne.uri),S.to(ne.range))}Me.to=ve})(se||(e.location=se={}));var K;(function(Me){function ze(ne){const Le=ne,Ve=ne;return{originSelectionRange:Le.originSelectionRange?S.from(Le.originSelectionRange):void 0,uri:Le.targetUri?Le.targetUri:Ve.uri,range:S.from(Le.targetRange?Le.targetRange:Ve.range),targetSelectionRange:Le.targetSelectionRange?S.from(Le.targetSelectionRange):void 0}}Me.from=ze;function ve(ne){return{targetUri:a.URI.revive(ne.uri),targetRange:S.to(ne.range),targetSelectionRange:ne.targetSelectionRange?S.to(ne.targetSelectionRange):void 0,originSelectionRange:ne.originSelectionRange?S.to(ne.originSelectionRange):void 0}}Me.to=ve})(K||(e.DefinitionLink=K={}));var te;(function(Me){function ze(ne){return{range:S.from(ne.range),contents:W.fromMany(ne.contents)}}Me.from=ze;function ve(ne){return new h.$CM(ne.contents.map(W.to),S.to(ne.range))}Me.to=ve})(te||(e.Hover=te={}));var le;(function(Me){function ze(ne){return{range:S.from(ne.range),expression:ne.expression}}Me.from=ze;function ve(ne){return new h.$xN(S.to(ne.range),ne.expression)}Me.to=ve})(le||(e.EvaluatableExpression=le={}));var de;(function(Me){function ze(ne){if(ne instanceof h.$yN)return{type:"text",range:S.from(ne.range),text:ne.text};if(ne instanceof h.$zN)return{type:"variable",range:S.from(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};if(ne instanceof h.$AN)return{type:"expression",range:S.from(ne.range),expression:ne.expression};throw new Error("Unknown 'InlineValue' type")}Me.from=ze;function ve(ne){switch(ne.type){case"text":return{range:S.to(ne.range),text:ne.text};case"variable":return{range:S.to(ne.range),variableName:ne.variableName,caseSensitiveLookup:ne.caseSensitiveLookup};case"expression":return{range:S.to(ne.range),expression:ne.expression}}}Me.to=ve})(de||(e.InlineValue=de={}));var Ae;(function(Me){function ze(ne){return{frameId:ne.frameId,stoppedLocation:S.from(ne.stoppedLocation)}}Me.from=ze;function ve(ne){return new h.$BN(ne.frameId,S.to(ne.stoppedLocation))}Me.to=ve})(Ae||(e.InlineValueContext=Ae={}));var $e;(function(Me){function ze(ne){return{range:S.from(ne.range),kind:ne.kind}}Me.from=ze;function ve(ne){return new h.$DM(S.to(ne.range),ne.kind)}Me.to=ve})($e||(e.DocumentHighlight=$e={}));var Ie;(function(Me){function ze(ne){return{uri:ne.uri,highlights:ne.highlights.map($e.from)}}Me.from=ze;function ve(ne){return new h.$EM(a.URI.revive(ne.uri),ne.highlights.map($e.to))}Me.to=ve})(Ie||(e.MultiDocumentHighlight=Ie={}));var Re;(function(Me){function ze(ve){switch(ve){case 1:return h.CompletionTriggerKind.TriggerCharacter;case 2:return h.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return h.CompletionTriggerKind.Invoke}}Me.to=ze})(Re||(e.CompletionTriggerKind=Re={}));var Fe;(function(Me){function ze(ve){return{triggerKind:Re.to(ve.triggerKind),triggerCharacter:ve.triggerCharacter}}Me.to=ze})(Fe||(e.CompletionContext=Fe={}));var q;(function(Me){function ze(ne){switch(ne){case h.CompletionItemTag.Deprecated:return 1}}Me.from=ze;function ve(ne){switch(ne){case 1:return h.CompletionItemTag.Deprecated}}Me.to=ve})(q||(e.CompletionItemTag=q={}));var V;(function(Me){const ze=new Map([[h.CompletionItemKind.Method,0],[h.CompletionItemKind.Function,1],[h.CompletionItemKind.Constructor,2],[h.CompletionItemKind.Field,3],[h.CompletionItemKind.Variable,4],[h.CompletionItemKind.Class,5],[h.CompletionItemKind.Interface,7],[h.CompletionItemKind.Struct,6],[h.CompletionItemKind.Module,8],[h.CompletionItemKind.Property,9],[h.CompletionItemKind.Unit,12],[h.CompletionItemKind.Value,13],[h.CompletionItemKind.Constant,14],[h.CompletionItemKind.Enum,15],[h.CompletionItemKind.EnumMember,16],[h.CompletionItemKind.Keyword,17],[h.CompletionItemKind.Snippet,27],[h.CompletionItemKind.Text,18],[h.CompletionItemKind.Color,19],[h.CompletionItemKind.File,20],[h.CompletionItemKind.Reference,21],[h.CompletionItemKind.Folder,23],[h.CompletionItemKind.Event,10],[h.CompletionItemKind.Operator,11],[h.CompletionItemKind.TypeParameter,24],[h.CompletionItemKind.Issue,26],[h.CompletionItemKind.User,25]]);function ve(Ve){return ze.get(Ve)??9}Me.from=ve;const ne=new Map([[0,h.CompletionItemKind.Method],[1,h.CompletionItemKind.Function],[2,h.CompletionItemKind.Constructor],[3,h.CompletionItemKind.Field],[4,h.CompletionItemKind.Variable],[5,h.CompletionItemKind.Class],[7,h.CompletionItemKind.Interface],[6,h.CompletionItemKind.Struct],[8,h.CompletionItemKind.Module],[9,h.CompletionItemKind.Property],[12,h.CompletionItemKind.Unit],[13,h.CompletionItemKind.Value],[14,h.CompletionItemKind.Constant],[15,h.CompletionItemKind.Enum],[16,h.CompletionItemKind.EnumMember],[17,h.CompletionItemKind.Keyword],[27,h.CompletionItemKind.Snippet],[18,h.CompletionItemKind.Text],[19,h.CompletionItemKind.Color],[20,h.CompletionItemKind.File],[21,h.CompletionItemKind.Reference],[23,h.CompletionItemKind.Folder],[10,h.CompletionItemKind.Event],[11,h.CompletionItemKind.Operator],[24,h.CompletionItemKind.TypeParameter],[25,h.CompletionItemKind.User],[26,h.CompletionItemKind.Issue]]);function Le(Ve){return ne.get(Ve)??h.CompletionItemKind.Property}Me.to=Le})(V||(e.CompletionItemKind=V={}));var Q;(function(Me){function ze(ve,ne){const Le=new h.$UM(ve.label);return Le.insertText=ve.insertText,Le.kind=V.to(ve.kind),Le.tags=ve.tags?.map(q.to),Le.detail=ve.detail,Le.documentation=R.$Hk(ve.documentation)?W.to(ve.documentation):ve.documentation,Le.sortText=ve.sortText,Le.filterText=ve.filterText,Le.preselect=ve.preselect,Le.commitCharacters=ve.commitCharacters,m.$ct.isIRange(ve.range)?Le.range=S.to(ve.range):typeof ve.range=="object"&&(Le.range={inserting:S.to(ve.range.insert),replacing:S.to(ve.range.replace)}),Le.keepWhitespace=typeof ve.insertTextRules>"u"?!1:!!(ve.insertTextRules&1),typeof ve.insertTextRules<"u"&&ve.insertTextRules&4?Le.insertText=new h.$yM(ve.insertText):(Le.insertText=ve.insertText,Le.textEdit=Le.range instanceof h.$pM?new h.$uM(Le.range,Le.insertText):void 0),ve.additionalTextEdits&&ve.additionalTextEdits.length>0&&(Le.additionalTextEdits=ve.additionalTextEdits.map(Ve=>me.to(Ve))),Le.command=ne&&ve.command?ne.fromInternal(ve.command):void 0,Le}Me.to=ze})(Q||(e.CompletionItem=Q={}));var J;(function(Me){function ze(ne){if(typeof ne.label!="string"&&!Array.isArray(ne.label))throw new TypeError("Invalid label");return{label:ne.label,documentation:W.fromStrict(ne.documentation)}}Me.from=ze;function ve(ne){return{label:ne.label,documentation:R.$Hk(ne.documentation)?W.to(ne.documentation):ne.documentation}}Me.to=ve})(J||(e.ParameterInformation=J={}));var fe;(function(Me){function ze(ne){return{label:ne.label,documentation:W.fromStrict(ne.documentation),parameters:Array.isArray(ne.parameters)?ne.parameters.map(J.from):[],activeParameter:ne.activeParameter}}Me.from=ze;function ve(ne){return{label:ne.label,documentation:R.$Hk(ne.documentation)?W.to(ne.documentation):ne.documentation,parameters:Array.isArray(ne.parameters)?ne.parameters.map(J.to):[],activeParameter:ne.activeParameter}}Me.to=ve})(fe||(e.SignatureInformation=fe={}));var we;(function(Me){function ze(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(fe.from):[]}}Me.from=ze;function ve(ne){return{activeSignature:ne.activeSignature,activeParameter:ne.activeParameter,signatures:Array.isArray(ne.signatures)?ne.signatures.map(fe.to):[]}}Me.to=ve})(we||(e.SignatureHelp=we={}));var Te;(function(Me){function ze(ve,ne){const Le=new h.$TM(k.to(ne.position),typeof ne.label=="string"?ne.label:ne.label.map(He.to.bind(void 0,ve)),ne.kind&&xe.to(ne.kind));return Le.textEdits=ne.textEdits&&ne.textEdits.map(me.to),Le.tooltip=R.$Hk(ne.tooltip)?W.to(ne.tooltip):ne.tooltip,Le.paddingLeft=ne.paddingLeft,Le.paddingRight=ne.paddingRight,Le}Me.to=ze})(Te||(e.InlayHint=Te={}));var He;(function(Me){function ze(ve,ne){const Le=new h.$SM(ne.label);return Le.tooltip=R.$Hk(ne.tooltip)?W.to(ne.tooltip):ne.tooltip,o.Command.is(ne.command)&&(Le.command=ve.fromInternal(ne.command)),ne.location&&(Le.location=se.to(ne.location)),Le}Me.to=ze})(He||(e.InlayHintLabelPart=He={}));var xe;(function(Me){function ze(ne){return ne}Me.from=ze;function ve(ne){return ne}Me.to=ve})(xe||(e.InlayHintKind=xe={}));var it;(function(Me){function ze(ne){return{range:S.from(ne.range),url:ne.target,tooltip:ne.tooltip}}Me.from=ze;function ve(ne){let Le;if(ne.url)try{Le=typeof ne.url=="string"?a.URI.parse(ne.url,!0):a.URI.revive(ne.url)}catch{}return new h.$ZM(S.to(ne.range),Le)}Me.to=ve})(it||(e.DocumentLink=it={}));var rt;(function(Me){function ze(ne){const Le=new h.$3M(ne.label);return ne.textEdit&&(Le.textEdit=me.to(ne.textEdit)),ne.additionalTextEdits&&(Le.additionalTextEdits=ne.additionalTextEdits.map(Ve=>me.to(Ve))),Le}Me.to=ze;function ve(ne){return{label:ne.label,textEdit:ne.textEdit?me.from(ne.textEdit):void 0,additionalTextEdits:ne.additionalTextEdits?ne.additionalTextEdits.map(Le=>me.from(Le)):void 0}}Me.from=ve})(rt||(e.ColorPresentation=rt={}));var at;(function(Me){function ze(ne){return new h.$1M(ne[0],ne[1],ne[2],ne[3])}Me.to=ze;function ve(ne){return[ne.red,ne.green,ne.blue,ne.alpha]}Me.from=ve})(at||(e.Color=at={}));var ot;(function(Me){function ze(ne){return{range:S.from(ne.range)}}Me.from=ze;function ve(ne){return new h.$JM(S.to(ne.range))}Me.to=ve})(ot||(e.SelectionRange=ot={}));var De;(function(Me){function ze(ve){switch(ve){case 2:return h.TextDocumentSaveReason.AfterDelay;case 1:return h.TextDocumentSaveReason.Manual;case 3:case 4:return h.TextDocumentSaveReason.FocusOut}}Me.to=ze})(De||(e.TextDocumentSaveReason=De={}));var Be;(function(Me){function ze(ne){switch(ne){case h.TextEditorLineNumbersStyle.Off:return 0;case h.TextEditorLineNumbersStyle.Relative:return 2;case h.TextEditorLineNumbersStyle.Interval:return 3;case h.TextEditorLineNumbersStyle.On:default:return 1}}Me.from=ze;function ve(ne){switch(ne){case 0:return h.TextEditorLineNumbersStyle.Off;case 2:return h.TextEditorLineNumbersStyle.Relative;case 3:return h.TextEditorLineNumbersStyle.Interval;case 1:default:return h.TextEditorLineNumbersStyle.On}}Me.to=ve})(Be||(e.TextEditorLineNumbersStyle=Be={}));var Ge;(function(Me){function ze(ne){if(ne===h.EndOfLine.CRLF)return 1;if(ne===h.EndOfLine.LF)return 0}Me.from=ze;function ve(ne){if(ne===1)return h.EndOfLine.CRLF;if(ne===0)return h.EndOfLine.LF}Me.to=ve})(Ge||(e.EndOfLine=Ge={}));var Oe;(function(Me){function ze(ve){if(typeof ve=="object")return ve.viewId;switch(ve){case h.ProgressLocation.SourceControl:return 3;case h.ProgressLocation.Window:return 10;case h.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Me.from=ze})(Oe||(e.ProgressLocation=Oe={}));var Qe;(function(Me){function ze(ne){const Le={start:ne.start+1,end:ne.end+1};return ne.kind&&(Le.kind=oe.from(ne.kind)),Le}Me.from=ze;function ve(ne){const Le={start:ne.start-1,end:ne.end-1};return ne.kind&&(Le.kind=oe.to(ne.kind)),Le}Me.to=ve})(Qe||(e.FoldingRange=Qe={}));var oe;(function(Me){function ze(ne){if(ne)switch(ne){case h.FoldingRangeKind.Comment:return o.$7t.Comment;case h.FoldingRangeKind.Imports:return o.$7t.Imports;case h.FoldingRangeKind.Region:return o.$7t.Region}}Me.from=ze;function ve(ne){if(ne)switch(ne.value){case o.$7t.Comment.value:return h.FoldingRangeKind.Comment;case o.$7t.Imports.value:return h.FoldingRangeKind.Imports;case o.$7t.Region.value:return h.FoldingRangeKind.Region}}Me.to=ve})(oe||(e.FoldingRangeKind=oe={}));var ue;(function(Me){function ze(ve){if(ve)return{pinned:typeof ve.preview=="boolean"?!ve.preview:void 0,inactive:ve.background,preserveFocus:ve.preserveFocus,selection:typeof ve.selection=="object"?S.from(ve.selection):void 0,override:typeof ve.override=="boolean"?r.$5E.id:void 0}}Me.from=ze})(ue||(e.TextEditorOpenOptions=ue={}));var Pe;(function(Me){function ze(Ve){return Ve instanceof h.$lN?Ve.toJSON():typeof Ve=="string"?Ve:ve(Ve)||ne(Ve)?new h.$lN(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}Me.from=ze;function ve(Ve){const et=Ve;return et?a.URI.isUri(et.baseUri)&&typeof et.pattern=="string":!1}function ne(Ve){const et=Ve;return et?typeof et.base=="string"&&typeof et.pattern=="string":!1}function Le(Ve){return typeof Ve=="string"?Ve:new h.$lN(a.URI.revive(Ve.baseUri),Ve.pattern)}Me.to=Le})(Pe||(e.GlobPattern=Pe={}));var Ke;(function(Me){function ze(ve){if(ve){if(Array.isArray(ve))return ve.map(ze);if(typeof ve=="string")return ve;{const ne=ve;return{language:ne.language,scheme:ne.scheme,pattern:Pe.from(ne.pattern),exclusive:ne.exclusive,notebookType:ne.notebookType}}}else return}Me.from=ze})(Ke||(e.LanguageSelector=Ke={}));var _e;(function(Me){function ze(ne){return!!ne&&typeof ne=="object"&&"documents"in ne&&Array.isArray(ne.documents)&&ne.documents.every(Le=>Array.isArray(Le)&&Le.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&a.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(et=>et instanceof h.$pM)))}Me.is=ze;function ve(ne){return{documents:ne.documents.map(Le=>Le.map(Ve=>({uri:a.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(et=>S.from(et))})))}}Me.from=ve})(_e||(e.MappedEditsContext=_e={}));var Ne;(function(Me){function ze(ne){return{start:ne.start,end:ne.end}}Me.from=ze;function ve(ne){return new h.$ON(ne.start,ne.end)}Me.to=ve})(Ne||(e.NotebookRange=Ne={}));var lt;(function(Me){function ze(ne){return{timing:typeof ne.runStartTime=="number"&&typeof ne.runEndTime=="number"?{startTime:ne.runStartTime,endTime:ne.runEndTime}:void 0,executionOrder:ne.executionOrder,success:ne.lastRunSuccess}}Me.to=ze;function ve(ne){return{lastRunSuccess:ne.success,runStartTime:ne.timing?.startTime,runEndTime:ne.timing?.endTime,executionOrder:ne.executionOrder}}Me.from=ve})(lt||(e.NotebookCellExecutionSummary=lt={}));var wt;(function(Me){function ze(ve){if(ve===t.NotebookCellExecutionState.Unconfirmed)return h.NotebookCellExecutionState.Pending;if(ve===t.NotebookCellExecutionState.Pending)return;if(ve===t.NotebookCellExecutionState.Executing)return h.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ve}`)}Me.to=ze})(wt||(e.NotebookCellExecutionState=wt={}));var At;(function(Me){function ze(ne){switch(ne){case h.NotebookCellKind.Markup:return t.CellKind.Markup;case h.NotebookCellKind.Code:default:return t.CellKind.Code}}Me.from=ze;function ve(ne){switch(ne){case t.CellKind.Markup:return h.NotebookCellKind.Markup;case t.CellKind.Code:default:return h.NotebookCellKind.Code}}Me.to=ve})(At||(e.NotebookCellKind=At={}));var zt;(function(Me){function ze(ne){const Le={metadata:ne.metadata??Object.create(null),cells:[]};for(const Ve of ne.cells)h.$PN.validate(Ve),Le.cells.push(Qt.from(Ve));return Le}Me.from=ze;function ve(ne){const Le=new h.$QN(ne.cells.map(Qt.to));return(0,v.$9f)(ne.metadata)||(Le.metadata=ne.metadata),Le}Me.to=ve})(zt||(e.NotebookData=zt={}));var Qt;(function(Me){function ze(ne){return{cellKind:At.from(ne.kind),language:ne.languageId,mime:ne.mime,source:ne.value,metadata:ne.metadata,internalMetadata:lt.from(ne.executionSummary??{}),outputs:ne.outputs?ne.outputs.map(Ct.from):[]}}Me.from=ze;function ve(ne){return new h.$PN(At.to(ne.cellKind),ne.source,ne.language,ne.mime,ne.outputs?ne.outputs.map(Ct.to):void 0,ne.metadata,ne.internalMetadata?lt.to(ne.internalMetadata):void 0)}Me.to=ve})(Qt||(e.NotebookCellData=Qt={}));var _t;(function(Me){function ze(ne){return{mime:ne.mime,valueBytes:L.$ue.wrap(ne.data)}}Me.from=ze;function ve(ne){return new h.$RN(ne.valueBytes.buffer,ne.mime)}Me.to=ve})(_t||(e.NotebookCellOutputItem=_t={}));var Ct;(function(Me){function ze(ne){return{outputId:ne.id,items:ne.items.map(_t.from),metadata:ne.metadata}}Me.from=ze;function ve(ne){const Le=ne.items.map(_t.to);return new h.$SN(Le,ne.outputId,ne.metadata)}Me.to=ve})(Ct||(e.NotebookCellOutput=Ct={}));var Xt;(function(Me){function ze(Le){return ne(Le)?{include:Pe.from(Le.include)??void 0,exclude:Pe.from(Le.exclude)??void 0}:Pe.from(Le)??void 0}Me.from=ze;function ve(Le){return ne(Le)?{include:Pe.to(Le.include),exclude:Pe.to(Le.exclude)}:Pe.to(Le)}Me.to=ve;function ne(Le){const Ve=Le;return Ve?!(0,v.$5f)(Ve.include)&&!(0,v.$5f)(Ve.exclude):!1}})(Xt||(e.NotebookExclusiveDocumentPattern=Xt={}));var Vt;(function(Me){function ze(ve,ne,Le){const Ve=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{alignment:ve.alignment===h.NotebookCellStatusBarAlignment.Left?1:2,command:ne.toInternal(Ve,Le),text:ve.text,tooltip:ve.tooltip,accessibilityInformation:ve.accessibilityInformation,priority:ve.priority}}Me.from=ze})(Vt||(e.NotebookStatusBarItem=Vt={}));var ai;(function(Me){function ze(ve,ne,Le){const Ve=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{command:ne.toInternal(Ve,Le),label:ve.label,description:ve.description,detail:ve.detail,documentation:ve.documentation}}Me.from=ze})(ai||(e.NotebookKernelSourceAction=ai={}));var tt;(function(Me){function ze(ve){return{transientOutputs:ve?.transientOutputs??!1,transientCellMetadata:ve?.transientCellMetadata??{},transientDocumentMetadata:ve?.transientDocumentMetadata??{},cellContentMetadata:ve?.cellContentMetadata??{}}}Me.from=ze})(tt||(e.NotebookDocumentContentOptions=tt={}));var ei;(function(Me){function ze(ne){return{uri:ne.uri,provides:ne.provides}}Me.from=ze;function ve(ne){return new h.$UN(a.URI.revive(ne.uri),ne.provides)}Me.to=ve})(ei||(e.NotebookRendererScript=ei={}));var ti;(function(Me){function ze(ne){return{message:W.fromStrict(ne.message)||"",type:0,expected:ne.expectedOutput,actual:ne.actualOutput,contextValue:ne.contextValue,location:ne.location&&{range:S.from(ne.location.range),uri:ne.location.uri}}}Me.from=ze;function ve(ne){const Le=new h.$1N(typeof ne.message=="string"?ne.message:W.to(ne.message));return Le.actualOutput=ne.actual,Le.expectedOutput=ne.expected,Le.contextValue=ne.contextValue,Le.location=ne.location?se.to(ne.location):void 0,Le}Me.to=ve})(ti||(e.TestMessage=ti={}));var ft;(function(Me){Me.namespace=d.$cL,Me.denamespace=d.$dL})(ft||(e.TestTag=ft={}));var bt;(function(Me){function ze(ne){const Le=(0,i.$CO)(ne).controllerId;return{extId:f.$0K.fromExtHostTestItem(ne,Le).toString(),label:ne.label,uri:a.URI.revive(ne.uri),busy:ne.busy,tags:ne.tags.map(Ve=>ft.namespace(Le,Ve.id)),range:m.$ct.lift(S.from(ne.range)),description:ne.description||null,sortText:ne.sortText||null,error:ne.error&&W.fromStrict(ne.error)||null}}Me.from=ze;function ve(ne){return{parent:void 0,error:void 0,id:f.$0K.fromString(ne.extId).localId,label:ne.label,uri:a.URI.revive(ne.uri),tags:(ne.tags||[]).map(Le=>{const{tagId:Ve}=ft.denamespace(Le);return new h.$2N(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:S.to(ne.range||void 0),canResolveChildren:!1,busy:ne.busy,description:ne.description||void 0,sortText:ne.sortText||void 0}}Me.toPlain=ve})(bt||(e.TestItem=bt={})),function(Me){function ze(ne){return{id:ne.id}}Me.from=ze;function ve(ne){return new h.$2N(ne.id)}Me.to=ve}(ft||(e.TestTag=ft={}));var si;(function(Me){const ze=(ne,Le)=>{const Ve=ne.value;if(!Ve)return;const et={...bt.toPlain(Ve.item),parent:Le,taskStates:Ve.tasks.map(Xe=>({state:Xe.state,duration:Xe.duration,messages:Xe.messages.filter(ct=>ct.type===0).map(ti.to)})),children:[]};if(ne.children)for(const Xe of ne.children.values()){const ct=ze(Xe,et);ct&&et.children.push(ct)}return et};function ve(ne){const Le=new p.$vO;for(const Xe of ne.items)Le.insert(f.$0K.fromString(Xe.item.extId).path,Xe);const Ve=[Le.nodes],et=[];for(;Ve.length;)for(const Xe of Ve.pop())Xe.value?et.push(Xe):Xe.children&&Ve.push(Xe.children.values());return{completedAt:ne.completedAt,results:et.map(Xe=>ze(Xe)).filter(v.$4f)}}Me.to=ve})(si||(e.TestResults=si={}));var ii;(function(Me){function ze(Ve){return{covered:Ve.covered,total:Ve.total}}function ve(Ve){return"line"in Ve?k.from(Ve):S.from(Ve)}function ne(Ve){return"branches"in Ve?{count:Ve.executed,location:ve(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(et=>({count:et.executed,location:et.location&&ve(et.location),label:et.label})):void 0}:{type:0,name:Ve.name,count:Ve.executed,location:ve(Ve.location)}}Me.fromDetails=ne;function Le(Ve,et){return{id:Ve,uri:et.uri,statement:ze(et.statementCoverage),branch:et.branchCoverage&&ze(et.branchCoverage),declaration:et.declarationCoverage&&ze(et.declarationCoverage)}}Me.fromFile=Le})(ii||(e.TestCoverage=ii={}));var jt;(function(Me){function ze(ve){switch(ve){case 1:return h.CodeActionTriggerKind.Invoke;case 2:return h.CodeActionTriggerKind.Automatic}}Me.to=ze})(jt||(e.CodeActionTriggerKind=jt={}));var mt;(function(Me){function ze(ne){const Le=new h.$8N(ee.to(ne.kind),ne.name,ne.detail||"",a.URI.revive(ne.uri),S.to(ne.range),S.to(ne.selectionRange));return Le._sessionId=ne._sessionId,Le._itemId=ne._itemId,Le}Me.to=ze;function ve(ne,Le,Ve){if(Le=Le??ne._sessionId,Ve=Ve??ne._itemId,Le===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Ve,kind:ee.from(ne.kind),name:ne.name,detail:ne.detail??"",uri:ne.uri,range:S.from(ne.range),selectionRange:S.from(ne.selectionRange),tags:ne.tags?.map(U.from)}}Me.from=ve})(mt||(e.TypeHierarchyItem=mt={}));var Rt;(function(Me){function ze(ve){if(ve)return{value:ve.value,tooltip:ve.tooltip}}Me.from=ze})(Rt||(e.ViewBadge=Rt={}));var qt;(function(Me){function ze(Ve,et,Xe){const ct=et.fileData;return ct?new h.$dN(new h.$eN(ct.name,a.URI.revive(ct.uri),ct.id,(0,P.$db)(()=>Xe(ct.id)))):Ve===A.$zs.uriList&&et.uriListData?new h.$cN(Le(et.uriListData)):new h.$cN(et.asString)}Me.to=ze;async function ve(Ve,et){const Xe=await et.asString();if(Ve===A.$zs.uriList)return{asString:Xe,fileData:void 0,uriListData:ne(Xe)};const ct=et.asFile();return{asString:Xe,fileData:ct?{name:ct.name,uri:ct.uri,id:ct._itemId??ct.id}:void 0}}Me.from=ve;function ne(Ve){return M.$Lt.split(Ve).map(et=>{if(et.startsWith("#"))return et;try{return a.URI.parse(et)}catch{}return et})}function Le(Ve){return M.$Lt.create(Ve.map(et=>typeof et=="string"?et:a.URI.revive(et)))}})(qt||(e.DataTransferItem=qt={}));var Zt;(function(Me){function ze(ne,Le){const Ve=ne.items.map(([et,Xe])=>[et,qt.to(et,Xe,Le)]);return new h.$fN(Ve)}Me.toDataTransfer=ze;async function ve(ne){const Le={items:[]},Ve=[];for(const[et,Xe]of ne)Ve.push((async()=>{Le.items.push([et,await qt.from(et,Xe)])})());return await Promise.all(Ve),Le}Me.from=ve})(Zt||(e.DataTransfer=Zt={}));var Ze;(function(Me){function ze(ne,Le){return{kind:"reply",agentId:ne.participant??Le?.agentId??"",subCommand:ne.command??Le?.command,message:ne.prompt,title:ne.label}}Me.from=ze;function ve(ne){return{prompt:ne.message,label:ne.title,participant:ne.agentId,command:ne.subCommand}}Me.to=ve})(Ze||(e.ChatFollowup=Ze={}));var Yt;(function(Me){function ze(ve){return"commandId"in ve?{kind:"command",title:ve.title??"",commandId:ve.commandId??"",when:ve.when??"",args:ve.args}:{kind:"reply",message:ve.message,title:ve.title,tooltip:ve.tooltip}}Me.from=ze})(Yt||(e.ChatInlineFollowup=Yt={}));var Bt;(function(Me){function ze(ne){switch(ne.role){case 0:return new h.$qO(ne.content);case 1:return new h.$rO(ne.content);case 2:return new h.$sO(ne.content)}}Me.to=ze;function ve(ne){if(ne instanceof h.$qO)return{role:0,content:ne.content};if(ne instanceof h.$rO)return{role:1,content:ne.content};if(ne instanceof h.$sO)return{role:2,content:ne.content};throw new Error("Invalid LanguageModelMessage")}Me.from=ve})(Bt||(e.LanguageModelMessage=Bt={}));var Ut;(function(Me){function ze(Le){const Ve={};for(const et of Object.keys(Le))Ve[et]=Le[et].map(Me.to);return Ve}Me.objectTo=ze;function ve(Le){return{level:$t.to(Le.level),kind:Le.kind,value:(0,a.$wc)(Le.value)?a.URI.revive(Le.value):Le.value,description:Le.description}}Me.to=ve;function ne(Le){return{level:$t.from(Le.level),kind:Le.kind,value:Le.value,description:Le.description}}Me.from=ne})(Ut||(e.ChatVariable=Ut={}));var $t;(function(Me){function ze(ne){switch(ne){case"short":return h.ChatVariableLevel.Short;case"medium":return h.ChatVariableLevel.Medium;case"full":default:return h.ChatVariableLevel.Full}}Me.to=ze;function ve(ne){switch(ne){case h.ChatVariableLevel.Short:return"short";case h.ChatVariableLevel.Medium:return"medium";case h.ChatVariableLevel.Full:default:return"full"}}Me.from=ve})($t||(e.ChatVariableLevel=$t={}));var Ft;(function(Me){function ze(ve){switch(ve){case 1:return h.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return h.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return h.InteractiveEditorResponseFeedbackKind.Undone;case 3:return h.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return h.InteractiveEditorResponseFeedbackKind.Bug}}Me.to=ze})(Ft||(e.InteractiveEditorResponseFeedbackKind=Ft={}));var Ot;(function(Me){function ze(ne){return{kind:"markdownContent",content:W.from(ne.value)}}Me.to=ze;function ve(ne){return new h.$iO(W.to(ne.content))}Me.from=ve})(Ot||(e.ChatResponseMarkdownPart=Ot={}));var Tt;(function(Me){function ze(ne){const{value:Le,baseUri:Ve}=ne;function et(Xe,ct){return Xe.map(kt=>{const Kt=a.URI.joinPath(ct,kt.name);return{label:kt.name,uri:Kt,children:kt.children&&et(kt.children,Kt)}})}return{kind:"treeData",treeData:{label:(0,E.$Sg)(Ve),uri:Ve,children:et(Le,Ve)}}}Me.to=ze;function ve(ne){const Le=(0,y.$Rh)(ne.treeData);function Ve(ct){return ct.map(kt=>({name:kt.label,children:kt.children&&Ve(kt.children)}))}const et=Le.uri,Xe=Le.children?Ve(Le.children):[];return new h.$jO(Xe,et)}Me.from=ve})(Tt||(e.ChatResponseFilesPart=Tt={}));var ni;(function(Me){function ze(ne){return{kind:"inlineReference",name:ne.title,inlineReference:a.URI.isUri(ne.value)?ne.value:w.from(ne.value)}}Me.to=ze;function ve(ne){const Le=(0,y.$Rh)(ne);return new h.$kO(a.URI.isUri(Le.inlineReference)?Le.inlineReference:w.to(Le.inlineReference),ne.name)}Me.from=ve})(ni||(e.ChatResponseAnchorPart=ni={}));var oi;(function(Me){function ze(ne){return{kind:"progressMessage",content:W.from(ne.value)}}Me.to=ze;function ve(ne){return new h.$lO(ne.content.value)}Me.from=ve})(oi||(e.ChatResponseProgressPart=oi={}));var Ht;(function(Me){function ze(ne,Le,Ve){return{kind:"command",command:Le.toInternal(ne.value,Ve)??{command:ne.value.command,title:ne.value.title}}}Me.to=ze;function ve(ne,Le){return new h.$mO(Le.fromInternal(ne.command)??{command:ne.command.id,title:ne.command.title})}Me.from=ve})(Ht||(e.ChatResponseCommandButtonPart=Ht={}));var It;(function(Me){function ze(ne){return{kind:"reference",reference:a.URI.isUri(ne.value)?ne.value:w.from(ne.value)}}Me.to=ze;function ve(ne){const Le=(0,y.$Rh)(ne);return new h.$nO(a.URI.isUri(Le.reference)?Le.reference:w.to(Le.reference))}Me.from=ve})(It||(e.ChatResponseReferencePart=It={}));var St;(function(Me){function ze(Le){return Le instanceof h.$iO?Ot.to(Le):Le instanceof h.$kO?ni.to(Le):Le instanceof h.$nO?It.to(Le):Le instanceof h.$lO?oi.to(Le):Le instanceof h.$jO?Tt.to(Le):{kind:"content",content:""}}Me.to=ze;function ve(Le,Ve){switch(Le.kind){case"reference":return It.from(Le);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return ne(Le,Ve)}}Me.from=ve;function ne(Le,Ve){switch(Le.kind){case"markdownContent":return Ot.from(Le);case"inlineReference":return ni.from(Le);case"progressMessage":return;case"treeData":return Tt.from(Le);case"command":return Ht.from(Le,Ve)}}Me.fromContent=ne})(St||(e.ChatResponsePart=St={}));var Gt;(function(Me){function ze(Le,Ve){return"markdownContent"in Ve?((0,c.$0F)(Le,"chatParticipantAdditions"),{content:W.from(Ve.markdownContent),kind:"markdownContent"}):"content"in Ve?"vulnerabilities"in Ve&&Ve.vulnerabilities?((0,c.$0F)(Le,"chatParticipantAdditions"),{content:Ve.content,vulnerabilities:Ve.vulnerabilities,kind:"vulnerability"}):typeof Ve.content=="string"?{content:Ve.content,kind:"content"}:((0,c.$0F)(Le,"chatParticipantAdditions"),{content:W.from(Ve.content),kind:"markdownContent"}):"documents"in Ve?{documents:Ve.documents.map(et=>({uri:et.uri,version:et.version,ranges:et.ranges.map(Xe=>S.from(Xe))})),kind:"usedContext"}:"reference"in Ve?{reference:"uri"in Ve.reference?{uri:Ve.reference.uri,range:S.from(Ve.reference.range)}:Ve.reference,kind:"reference"}:"inlineReference"in Ve?{inlineReference:"uri"in Ve.inlineReference?{uri:Ve.inlineReference.uri,range:S.from(Ve.inlineReference.range)}:Ve.inlineReference,name:Ve.title,kind:"inlineReference"}:"participant"in Ve?((0,c.$0F)(Le,"chatParticipantAdditions"),{agentName:Ve.participant,command:Ve.command,kind:"agentDetection"}):"message"in Ve?{content:W.from(Ve.message),kind:"progressMessage"}:void 0}Me.from=ze;function ve(Le){switch(Le.kind){case"markdownContent":case"inlineReference":case"treeData":return Me.to(Le);case"content":return{content:Le.content};case"usedContext":return{documents:Le.documents.map(Ve=>({uri:a.URI.revive(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(et=>S.to(et))}))};case"reference":return{reference:(0,a.$wc)(Le.reference)?a.URI.revive(Le.reference):w.to(Le.reference)};case"agentDetection":return;case"progressMessage":return{message:Le.content.value};case"vulnerability":return{content:Le.content,vulnerabilities:Le.vulnerabilities};default:return}}Me.to=ve;function ne(Le,Ve){switch(Le.kind){case"markdownContent":return{content:Le.content.value};case"inlineReference":return{inlineReference:(0,a.$wc)(Le.inlineReference)?a.URI.revive(Le.inlineReference):w.to(Le.inlineReference),title:Le.name};case"command":return{command:Ve.fromInternal(Le.command)??{command:Le.command.id,title:Le.command.title}};default:return}}Me.toProgressContent=ne})(Gt||(e.ChatResponseProgress=Gt={}));var Pt;(function(Me){function ze(ve){return{prompt:ve.message,command:ve.command,variables:ve.variables.variables.map(Dt.to),location:yt.to(ve.location)}}Me.to=ze})(Pt||(e.ChatAgentRequest=Pt={}));var yt;(function(Me){function ze(ve){switch(ve){case s.ChatAgentLocation.Notebook:return h.ChatLocation.Notebook;case s.ChatAgentLocation.Terminal:return h.ChatLocation.Terminal;case s.ChatAgentLocation.Panel:return h.ChatLocation.Panel}}Me.to=ze})(yt||(e.ChatLocation=yt={}));var Dt;(function(Me){function ze(ve){return{name:ve.name,range:ve.range&&[ve.range.start,ve.range.endExclusive],values:ve.values.map(Ut.to)}}Me.to=ze})(Dt||(e.ChatAgentResolvedVariable=Dt={}));var Et;(function(Me){function ze(ve){return{label:ve.label,values:ve.values.map(Ut.from),insertText:ve.insertText,detail:ve.detail,documentation:ve.documentation}}Me.from=ze})(Et||(e.ChatAgentCompletionItem=Et={}));var ui;(function(Me){function ze(ve){return{errorDetails:ve.errorDetails,metadata:ve.metadata}}Me.to=ze})(ui||(e.ChatAgentResult=ui={}));var ri;(function(Me){function ze(ve,ne,Le){if(ne.action.kind==="vote")return;const Ve=ui.to(ve);return ne.action.kind==="command"?{action:{kind:"command",commandButton:Gt.toProgressContent(ne.action.commandButton,Le)},result:Ve}:ne.action.kind==="followUp"?{action:{kind:"followUp",followup:Ze.to(ne.action.followup)},result:Ve}:{action:ne.action,result:Ve}}Me.to=ze})(ri||(e.ChatAgentUserActionEvent=ri={}));var li;(function(Me){function ze(ve,ne,Le){return"terminalCommand"in ve?{terminalCommand:ve.terminalCommand,shouldExecute:ve.shouldExecute}:"uri"in ve?{uri:ve.uri}:ne.toInternal(ve,Le)}Me.from=ze})(li||(e.TerminalQuickFix=li={}));var di;(function(Me){function ze(ve){return{kind:xt.to(ve.kind)}}Me.to=ze})(di||(e.PartialAcceptInfo=di={}));var xt;(function(Me){function ze(ve){switch(ve){case 0:return h.PartialAcceptTriggerKind.Word;case 1:return h.PartialAcceptTriggerKind.Line;case 2:return h.PartialAcceptTriggerKind.Suggest;default:return h.PartialAcceptTriggerKind.Unknown}}Me.to=ze})(xt||(e.PartialAcceptTriggerKind=xt={}));var Mt;(function(Me){function ze(ve,ne){return{id:ne,label:ve.label,description:ve.description,canEdit:ve.canEdit,collapsibleState:ve.collapsibleState||0,contextValue:ve.contextValue}}Me.from=ze})(Mt||(e.DebugTreeItem=Mt={}))}),define(ke[328],Ee([1,0,6,20,16]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cjc=void 0;let P=class{constructor(b,$){this.a=b.getProxy(u.$lM.MainThreadBulkEdits),this.b={getTextDocumentVersion:y=>$.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,$,y){const A=M.WorkspaceEdit.from(b,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,y?.isRefactoring??!1)}};e.$cjc=P,e.$cjc=P=Je([qe(0,L.$GO)],P)}),define(ke[329],Ee([1,0,19,8,46,4,38,3,39,18,2,217,25,6,16,7,290,26]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v,a,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ejc=void 0;class n{constructor(t,f,d,l,c,h){this.i=t,this.j=f,this.k=d,this.l=l,this.m=c,this.n=h,this.b=$.$3d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let f=function(l){if(t.c){const c=new Error("Response stream has been closed");throw Error.captureStackTrace(c,l),c}};const t=this;this.b.reset();const d=l=>{typeof this.d>"u"&&"content"in l&&(this.d=this.b.elapsed()),this.k.$handleProgressChunk(this.j.requestId,l)};this.g={markdown(l){f(this.markdown);const c=new a.$iO(l),h=v.ChatResponseMarkdownPart.to(c);return d(h),this},filetree(l,c){f(this.filetree);const h=new a.$jO(l,c),g=v.ChatResponseFilesPart.to(h);return d(g),this},anchor(l,c){f(this.anchor);const h=new a.$kO(l,c),g=v.ChatResponseAnchorPart.to(h);return d(g),this},button(l){f(this.anchor);const c=new a.$mO(l),h=v.ChatResponseCommandButtonPart.to(c,t.m,t.n);return d(h),this},progress(l){f(this.progress);const c=new a.$lO(l),h=v.ChatResponseProgressPart.to(c);return d(h),this},reference(l){f(this.reference);const c=new a.$nO(l),h=v.ChatResponseReferencePart.to(c);return d(h),this},push(l){f(this.push);const c=v.ChatResponsePart.to(l);return d(c),this},report(l){if(f(this.report),"placeholder"in l&&"resolvedContent"in l)return;const c=v.ChatResponseProgress.from(t.i,l);if(!c){t.l.error("Unknown progress type: "+JSON.stringify(l));return}return d(c),this}}}return this.g}}class i{static{this.b=0}constructor(t,f,d){this.i=f,this.j=d,this.c=new Map,this.g=new b.$4c,this.d=t.getProxy(E.$lM.MainThreadChatAgents2)}createChatAgent(t,f,d){const l=i.b++,c=new r(t,f,this.d,l,d);return this.c.set(l,c),this.d.$registerAgent(l,t.identifier,f,{},(0,o.$9F)(t,"chatParticipantAdditions")),c.apiAgent}async $invokeAgent(t,f,d,l){const c=this.c.get(t);if(!c)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let h=this.g.get(f.sessionId);h||(h=new b.$Tc,this.g.set(f.sessionId,h));const g=new n(c.extension,f,this.d,this.i,this.j.converter,h);try{const S=await this.k(f.agentId,d),w=c.invoke(v.ChatAgentRequest.to(f),{history:S},g.apiObject,l);return await(0,L.$9g)(Promise.resolve(w).then(C=>{if(C?.metadata)try{JSON.stringify(C.metadata)}catch(k){const D=`result.metadata MUST be JSON.stringify-able. Got error: ${k.message}`;return this.i.error(`[${c.extension.identifier.value}] [@${c.id}] ${D}`,c.extension),{errorDetails:{message:D},timings:g.timings}}return{errorDetails:C?.errorDetails,timings:g.timings,metadata:C?.metadata}}),l)}catch(S){return this.i.error(S,c.extension),{errorDetails:{message:(0,I.localize)(0,null,(0,M.$6i)(S)),responseIsIncomplete:!0}}}finally{g.close()}}async k(t,f){const d=[];for(const l of f.history){const c=v.ChatAgentResult.to(l.result),h=t===l.request.agentId?c:{...c,metadata:void 0};d.push(new a.$oO(l.request.message,l.request.command,l.request.variables.variables.map(v.ChatAgentResolvedVariable.to),{extensionId:"",name:l.request.agentId}));const g=(0,u.$Hb)(l.response.map(S=>v.ChatResponsePart.fromContent(S,this.j.converter)));d.push(new a.$pO(g,h,{extensionId:"",name:l.request.agentId},l.request.command))}return d}$releaseSession(t){this.g.deleteAndDispose(t)}async $provideFollowups(t,f,d,l,c){const h=this.c.get(f);if(!h)return Promise.resolve([]);const g=await this.k(h.id,l),S=v.ChatAgentResult.to(d);return(await h.provideFollowups(S,{history:g},c)).filter(w=>{const C=!w.participant||R.Iterable.some(this.c.values(),k=>k.id===w.participant&&p.$Dm.equals(k.extension.identifier,h.extension.identifier));return C||this.i.warn(`[@${h.id}] ChatFollowup refers to an unknown participant: ${w.participant}`),C}).map(w=>v.ChatFollowup.from(w,t))}$acceptFeedback(t,f,d,l){const c=this.c.get(t);if(!c)return;const h=v.ChatAgentResult.to(f);let g;switch(d){case m.InteractiveSessionVoteDirection.Down:g=a.ChatResultFeedbackKind.Unhelpful;break;case m.InteractiveSessionVoteDirection.Up:g=a.ChatResultFeedbackKind.Helpful;break}c.acceptFeedback(Object.freeze(l?{result:h,kind:g,reportIssue:l}:{result:h,kind:g}))}$acceptAction(t,f,d){const l=this.c.get(t);if(!l||d.action.kind==="vote")return;const c=v.ChatAgentUserActionEvent.to(f,d,this.j.converter);c&&l.acceptAction(Object.freeze(c))}async $invokeCompletionProvider(t,f,d){const l=this.c.get(t);return l?(await l.invokeCompletionProvider(f,d)).map(v.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,f){const d=this.c.get(t);if(d)return await d.provideWelcomeMessage(f)}async $provideSampleQuestions(t,f){const d=this.c.get(t);if(d)return(await d.provideSampleQuestions(f)).map(l=>v.ChatFollowup.from(l,void 0))}}e.$ejc=i;class r{constructor(t,f,d,l,c){this.extension=t,this.id=f,this.x=d,this.y=l,this.z=c,this.o=new P.$7d,this.p=new P.$7d}acceptFeedback(t){this.o.fire(t)}acceptAction(t){this.p.fire(t)}async invokeCompletionProvider(t,f){return this.s?await this.s.provider.provideCompletionItems(t,f)??[]:[]}async provideFollowups(t,f,d){if(!this.b)return[];const l=await this.b.provideFollowups(t,f,d);return l?l.filter(c=>!(c&&"commandId"in c)).filter(c=>!(c&&"message"in c)):[]}async provideWelcomeMessage(t){if(!this.t)return[];const f=await this.t.provideWelcomeMessage(t);return f?f.map(d=>typeof d=="string"?d:v.MarkdownString.from(d)):[]}async provideSampleQuestions(t){if(!this.t||!this.t.provideSampleQuestions)return[];const f=await this.t.provideSampleQuestions(t);return f||[]}get apiAgent(){let t=!1,f=!1;const d=()=>{t||f||(f=!0,queueMicrotask(()=>{this.x.$updateAgent(this.y,{description:this.c,fullName:this.d,icon:this.g?this.g instanceof A.URI?this.g:"light"in this.g?this.g.light:void 0:void 0,iconDark:this.g&&"dark"in this.g?this.g.dark:void 0,themeIcon:this.g instanceof a.$jN?this.g:void 0,hasFollowups:this.b!==void 0,isSecondary:this.n,helpTextPrefix:!this.j||typeof this.j=="string"?this.j:v.MarkdownString.from(this.j),helpTextVariablesPrefix:!this.k||typeof this.k=="string"?this.k:v.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:v.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.q,isSticky:this.u,requester:this.w}),f=!1}))},l=this;return{get name(){return l.id},get description(){return l.c??""},set description(c){l.c=c,d()},get fullName(){return(0,o.$0F)(l.extension,"defaultChatParticipant"),l.d??l.extension.displayName??l.extension.name},set fullName(c){(0,o.$0F)(l.extension,"defaultChatParticipant"),l.d=c,d()},get iconPath(){return l.g},set iconPath(c){l.g=c,d()},get requestHandler(){return l.z},set requestHandler(c){(0,y.$6f)(typeof c=="function","Invalid request handler"),l.z=c},get followupProvider(){return l.b},set followupProvider(c){l.b=c,d()},get isDefault(){return(0,o.$0F)(l.extension,"defaultChatParticipant"),l.i},set isDefault(c){(0,o.$0F)(l.extension,"defaultChatParticipant"),l.i=c,d()},get helpTextPrefix(){return(0,o.$0F)(l.extension,"defaultChatParticipant"),l.j},set helpTextPrefix(c){(0,o.$0F)(l.extension,"defaultChatParticipant"),l.j=c,d()},get helpTextVariablesPrefix(){return(0,o.$0F)(l.extension,"defaultChatParticipant"),l.k},set helpTextVariablesPrefix(c){(0,o.$0F)(l.extension,"defaultChatParticipant"),l.k=c,d()},get helpTextPostfix(){return(0,o.$0F)(l.extension,"defaultChatParticipant"),l.l},set helpTextPostfix(c){(0,o.$0F)(l.extension,"defaultChatParticipant"),l.l=c,d()},get isSecondary(){return(0,o.$0F)(l.extension,"defaultChatParticipant"),l.n},set isSecondary(c){(0,o.$0F)(l.extension,"defaultChatParticipant"),l.n=c,d()},get sampleRequest(){return l.m},set sampleRequest(c){l.m=c,d()},get supportIssueReporting(){return(0,o.$0F)(l.extension,"chatParticipantAdditions"),l.q},set supportIssueReporting(c){(0,o.$0F)(l.extension,"chatParticipantAdditions"),l.q=c,d()},get onDidReceiveFeedback(){return l.o.event},set participantVariableProvider(c){if((0,o.$0F)(l.extension,"chatParticipantAdditions"),l.s=c,c){if(!c.triggerCharacters.length)throw new Error("triggerCharacters are required");l.x.$registerAgentCompletionsProvider(l.y,c.triggerCharacters)}else l.x.$unregisterAgentCompletionsProvider(l.y)},get participantVariableProvider(){return(0,o.$0F)(l.extension,"chatParticipantAdditions"),l.s},set welcomeMessageProvider(c){(0,o.$0F)(l.extension,"defaultChatParticipant"),l.t=c,d()},get welcomeMessageProvider(){return(0,o.$0F)(l.extension,"defaultChatParticipant"),l.t},onDidPerformAction:(0,o.$9F)(this.extension,"chatParticipantAdditions")?this.p.event:void 0,get isSticky(){return l.u},set isSticky(c){l.u=c,d()},set requester(c){l.w=c,d()},get requester(){return l.w},dispose(){t=!0,l.b=void 0,l.o.dispose(),l.x.$unregisterAgent(l.y)}}}invoke(t,f,d,l){return this.z(t,f,d,l)}}}),define(ke[330],Ee([1,0,13,3,6,16,7,26]),function(he,e,u,L,M,P,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hjc=void 0;class ${static{this.a=0}constructor(I){this.b=new Map,this.c=I.getProxy(M.$lM.MainThreadChatVariables)}async $resolveVariable(I,p,E,v){const a=this.b.get(I);if(a)try{if(a.resolver.resolve2){(0,b.$0F)(a.extension,"chatParticipantAdditions");const m=new y(p,this.c),o=await a.resolver.resolve2(a.data.name,{prompt:E},m.apiObject,v);if(o)return o.map(P.ChatVariable.from)}else{const m=await a.resolver.resolve(a.data.name,{prompt:E},v);if(m)return m.map(P.ChatVariable.from)}}catch(m){(0,u.$2)(m)}}registerVariableResolver(I,p,E,v){const a=$.a++;return this.b.set(a,{extension:I,data:{name:p,description:E},resolver:v}),this.c.$registerVariable(a,{name:p,description:E}),(0,L.$Sc)(()=>{this.b.delete(a),this.c.$unregisterVariable(a)})}}e.$hjc=$;class y{constructor(I,p){this.c=I,this.d=p,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let p=function(v){if(I.a){const a=new Error("Response stream has been closed");throw Error.captureStackTrace(a,v),a}};const I=this,E=v=>{this.d.$handleProgressChunk(this.c,v)};this.b={progress(v){p(this.progress);const a=new R.$lO(v),m=P.ChatResponseProgressPart.to(a);return E(m),this},reference(v){p(this.reference);const a=new R.$nO(v),m=P.ChatResponseReferencePart.to(a);return E(m),this},push(v){p(this.push);const a=P.ChatResponsePart.to(v);return E(a),this}}}return this.b}}}),define(ke[331],Ee([1,0,8,54,4,3,2,83,25,16,7,6,26]),function(he,e,u,L,M,P,R,b,$,y,A,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ljc=E;function E(v,a,m){const o=v.getProxy(I.$lM.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new $.$Fm,a.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===6){const S=this.b.get(g.handle);return S?S.value:g}else if(g&&g.$mid===7){const S=g,w=this.b.get(S.commentControlHandle);if(!w)return S;const C=w.getCommentThread(S.commentThreadHandle);return C?C.value:S}else if(g&&(g.$mid===9||g.$mid===8)){const S=this.b.get(g.thread.commentControlHandle);if(!S)return g;const w=S.getCommentThread(g.thread.commentThreadHandle);return w?g.$mid===8?w.value:{thread:w.value,text:g.text}:g}else if(g&&g.$mid===10){const S=this.b.get(g.thread.commentControlHandle);if(!S)return g;const w=S.getCommentThread(g.thread.commentThreadHandle);if(!w)return g;const C=g.commentUniqueId,k=w.getCommentByUniqueId(C);return k||g}else if(g&&g.$mid===11){const S=this.b.get(g.thread.commentControlHandle);if(!S)return g;const w=S.getCommentThread(g.thread.commentThreadHandle);if(!w)return g;const C=g.text,k=g.commentUniqueId,D=w.getCommentByUniqueId(k);return D?(typeof D.body=="string"?D.body=C:D.body=new A.$OM(C),D):g}return g}})}createCommentController(g,S,w){const C=n.a++,k=new r(g,C,S,w);this.b.set(k.handle,k);const D=this.c.get(g.identifier)||[];return D.push(k),this.c.set(g.identifier,D),k.value}async $createCommentThreadTemplate(g,S,w){const C=this.b.get(g);C&&C.$createCommentThreadTemplate(S,w)}async $setActiveComment(g,S){const w=this.b.get(g);w&&w.$setActiveComment(S??void 0)}async $updateCommentThreadTemplate(g,S,w){const C=this.b.get(g);C&&C.$updateCommentThreadTemplate(S,w)}$deleteCommentThread(g,S){this.b.get(g)?.$deleteCommentThread(S)}async $provideCommentingRanges(g,S,w){const C=this.b.get(g);if(!C||!C.commentingRangeProvider)return Promise.resolve(void 0);const k=await m.ensureDocumentData(R.URI.revive(S));return(0,u.$ah)(async()=>{const D=await C.commentingRangeProvider.provideCommentingRanges(k.document,w);let O;return Array.isArray(D)?O={ranges:D,fileComments:!1}:D?O={ranges:D.ranges||[],fileComments:D.fileComments||!1}:O=D??void 0,O}).then(D=>{let O;return D&&(O={ranges:D.ranges.map(F=>y.Range.from(F)),fileComments:D.fileComments}),O})}$toggleReaction(g,S,w,C,k){const D=this.b.get(g);return!D||!D.reactionHandler?Promise.resolve(void 0):(0,u.$ah)(()=>{const O=D.getCommentThread(S);if(O){const F=O.getCommentByUniqueId(C.uniqueIdInThread);if(D!==void 0&&F&&D.reactionHandler)return D.reactionHandler(F,f(k))}return Promise.resolve(void 0)})}}class i{static{this.a=0}set threadId(g){this.n=g}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(g){(g===void 0!=(this.p===void 0)||!g||!this.p||!g.isEqual(this.p))&&(this.p=g,this.b.range=g,this.c.fire())}get range(){return this.p}set canReply(g){this.d!==g&&(this.d=g,this.b.canReply=g,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(g){this.e=g,this.b.label=g,this.c.fire()}get contextValue(){return this.f}set contextValue(g){this.f=g,this.b.contextValue=g,this.c.fire()}get comments(){return this.q}set comments(g){this.q=g,this.b.comments=g,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(g){this.g=g,this.b.collapsibleState=g,this.c.fire()}get state(){return this.h}set state(g){this.h=g,typeof g=="object"?((0,p.$0F)(this.extensionDescription,"commentThreadApplicability"),this.b.state=g.resolved,this.b.applicability=g.applicability):this.b.state=g,this.c.fire()}get isDisposed(){return this.j}constructor(g,S,w,C,k,D,O,F){this.m=S,this.n=w,this.o=C,this.p=k,this.q=D,this.extensionDescription=O,this.r=F,this.handle=i.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new M.$7d,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new P.$Vc,this.l.value=new P.$Tc,this.n===void 0&&(this.n=`${g}.${this.handle}`),o.$createCommentThread(S,this.handle,this.n,this.o,y.Range.from(this.p),O.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=D,this.i.push({dispose:()=>{o.$deleteCommentThread(S,this.handle)}});const T=this;this.value={get uri(){return T.uri},get range(){return T.range},set range(z){T.range=z},get comments(){return T.comments},set comments(z){T.comments=z},get collapsibleState(){return T.collapsibleState},set collapsibleState(z){T.collapsibleState=z},get canReply(){return T.canReply},set canReply(z){T.canReply=z},get contextValue(){return T.contextValue},set contextValue(z){T.contextValue=z},get label(){return T.label},set label(z){T.label=z},get state(){return T.state},set state(z){T.state=z},dispose:()=>{T.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new P.$Tc);const g=w=>Object.prototype.hasOwnProperty.call(this.b,w),S={};g("range")&&(S.range=y.Range.from(this.p)),g("label")&&(S.label=this.label),g("contextValue")&&(S.contextValue=this.contextValue??null),g("comments")&&(S.comments=this.q.map(w=>s(this,w,this.k,this.extensionDescription))),g("collapsibleState")&&(S.collapseState=d(this.g)),g("canReply")&&(S.canReply=this.canReply),g("state")&&(S.state=l(this.h)),g("applicability")&&(S.applicability=c(this.h)),g("isTemplate")&&(S.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,S)}getCommentByUniqueId(g){for(const S of this.k){const w=S[0],C=S[1];if(g===C)return w}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(g=>g.dispose())}}Je([(0,L.$Nh)(100)],i.prototype,"eventuallyUpdateCommentThread",null);class r{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(g){this.b=g,g?.resourceHints&&(0,p.$0F)(this.h,"commentingRangeHint"),o.$updateCommentingRanges(this.handle,g?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(g){this.c=g,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!g})}get options(){return this.d}set options(g){this.d=g,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,p.$0F)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,p.$0F)(this.h,"activeComment"),this.f}constructor(g,S,w,C){this.h=g,this.i=S,this.j=w,this.k=C,this.a=new Map,o.$registerCommentController(this.handle,w,C,this.h.identifier.value);const k=this;this.value=Object.freeze({id:k.id,label:k.label,get options(){return k.options},set options(D){k.options=D},get commentingRangeProvider(){return k.commentingRangeProvider},set commentingRangeProvider(D){k.commentingRangeProvider=D},get reactionHandler(){return k.reactionHandler},set reactionHandler(D){k.reactionHandler=D},get activeCommentThread(){return k.activeCommentThread},createCommentThread(D,O,F){return k.createCommentThread(D,O,F).value},dispose:()=>{k.dispose()}}),this.g=[],this.g.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(g,S,w){S===void 0&&(0,p.$0F)(this.h,"fileComments");const C=new i(this.id,this.handle,void 0,g,S,w,this.h,!1);return this.a.set(C.handle,C),C}$setActiveComment(g){if(!g){this.e=void 0,this.f=void 0;return}const S=this.a.get(g.commentThreadHandle);S&&(this.e=g.uniqueIdInThread?S.getCommentByUniqueId(g.uniqueIdInThread):void 0,this.f=S)}$createCommentThreadTemplate(g,S){const w=new i(this.id,this.handle,void 0,R.URI.revive(g),y.Range.to(S),[],this.h,!0);return w.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(w.handle,w),w}$updateCommentThreadTemplate(g,S){const w=this.a.get(g);w&&(w.range=y.Range.to(S))}$deleteCommentThread(g){this.a.get(g)?.dispose(),this.a.delete(g)}getCommentThread(g){return this.a.get(g)}dispose(){this.a.forEach(g=>{g.dispose()}),this.g.forEach(g=>g.dispose())}}function s(h,g,S,w){let C=S.get(g);return C||(C=++h.commentHandle,S.set(g,C)),g.state!==void 0&&(0,p.$0F)(w,"commentsDraftState"),g.reactions?.some(k=>k.reactors!==void 0)&&(0,p.$0F)(w,"commentReactor"),{mode:g.mode,contextValue:g.contextValue,uniqueIdInThread:C,body:typeof g.body=="string"?g.body:y.MarkdownString.from(g.body),userName:g.author.name,userIconPath:g.author.iconPath,label:g.label,commentReactions:g.reactions?g.reactions.map(k=>t(k)):void 0,state:g.state,timestamp:g.timestamp?.toJSON()}}function t(h){return{label:h.label,iconPath:h.iconPath?y.$FO(h.iconPath):void 0,count:h.count,hasReacted:h.authorHasReacted,reactors:h.reactors&&h.reactors.length>0&&typeof h.reactors[0]!="string"?h.reactors.map(g=>g.name):h.reactors}}function f(h){return{label:h.label||"",count:h.count||0,iconPath:h.iconPath?R.URI.revive(h.iconPath):"",authorHasReacted:h.hasReacted||!1,reactors:h.reactors?.map(g=>({name:g}))}}function d(h){if(h!==void 0)switch(h){case A.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function l(h){let g;if(typeof h=="object"?g=h.resolved:g=h,g!==void 0)switch(g){case A.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}function c(h){let g;if(typeof h=="object"&&(g=h.applicability),g!==void 0)switch(g){case A.CommentThreadApplicability.Current:return b.CommentThreadApplicability.Current;case A.CommentThreadApplicability.Outdated:return b.CommentThreadApplicability.Outdated}return b.CommentThreadApplicability.Current}return new n}}),define(ke[332],Ee([1,0,22,55,3,15,23,2,16,92,111,6,7]),function(he,e,u,L,M,P,R,b,$,y,A,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Djc=void 0;class E{constructor(f,d){this.document=f,this.b=d,this.a=1,this.c=new A.$1ic("custom documents")}addEdit(f){return this.c.add([f])}async undo(f,d){await this.f(f).undo(),d||this.disposeBackup()}async redo(f,d){await this.f(f).redo(),d||this.disposeBackup()}disposeEdits(f){for(const d of f)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const f=s(this.document.uri)+this.a++;return(0,R.$Vg)(this.b,f)}updateBackup(f){this.d?.delete(),this.d=f}disposeBackup(){this.d?.delete(),this.d=void 0}f(f){const d=this.c.get(f,0);if(!d)throw new Error("No edit found");return d}}class v{constructor(){this.a=new Map}get(f,d){return this.a.get(this.b(f,d))}add(f,d,l){const c=this.b(f,d.uri);if(this.a.has(c))throw new Error(`Document already exists for viewType:${f} resource:${d.uri}`);const h=new E(d,l);return this.a.set(c,h),h}delete(f,d){const l=this.b(f,d.uri);this.a.delete(l)}b(f,d){return`${f}@@@${d}`}}var a;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(a||(a={}));class m{constructor(){this.a=new Map}addTextProvider(f,d,l){return this.b(0,f,d,l)}addCustomProvider(f,d,l){return this.b(1,f,d,l)}get(f){return this.a.get(f)}b(f,d,l,c){if(this.a.has(d))throw new Error(`Provider for viewType:${d} already registered`);return this.a.set(d,{type:f,extension:l,provider:c}),new p.$nM(()=>this.a.delete(d))}}class o{constructor(f,d,l,c,h){this.d=d,this.f=l,this.g=c,this.h=h,this.b=new m,this.c=new v,this.a=f.getProxy(I.$lM.MainThreadCustomEditors)}registerCustomEditorProvider(f,d,l,c){const h=new M.$Tc;return i(l)?(h.add(this.b.addTextProvider(d,f,l)),this.a.$registerTextEditorProvider((0,y.$Ajc)(f),d,c.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,y.$yjc)(f))):(h.add(this.b.addCustomProvider(d,f,l)),n(l)&&h.add(l.onDidChangeCustomDocument(g=>{const S=this.i(d,g.document.uri);if(r(g)){const w=S.addEdit(g);this.a.$onDidEdit(g.document.uri,d,w,g.label)}else this.a.$onContentChange(g.document.uri,d)})),this.a.$registerCustomEditorProvider((0,y.$Ajc)(f),d,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,y.$yjc)(f))),p.$nM.from(h,new p.$nM(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(f,d,l,c,h){const g=this.b.get(d);if(!g)throw new Error(`No provider found for '${d}'`);if(g.type!==1)throw new Error(`Invalid provide type for '${d}'`);const S=b.URI.revive(f),w=await g.provider.openCustomDocument(S,{backupId:l,untitledDocumentData:c?.buffer},h);let C;return n(g.provider)&&this.f&&(C=this.f.workspaceValue(g.extension)??this.f.globalValue(g.extension)),this.c.add(d,w,C),{editable:n(g.provider)}}async $disposeCustomDocument(f,d){const l=this.b.get(d);if(!l)throw new Error(`No provider found for '${d}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${d}'`);const c=b.URI.revive(f),{document:h}=this.i(d,c);this.c.delete(d,h),h.dispose()}async $resolveCustomEditor(f,d,l,c,h,g){const S=this.b.get(l);if(!S)throw new Error(`No provider found for '${l}'`);const w=$.ViewColumn.to(h),C=this.g.createNewWebview(d,c.contentOptions,S.extension),k=this.h.createNewWebviewPanel(d,l,c.title,w,c.options,C,c.active),D=b.URI.revive(f);switch(S.type){case 1:{const{document:O}=this.i(l,D);return S.provider.resolveCustomEditor(O,k,g)}case 0:{const O=this.d.getDocument(D);return S.provider.resolveCustomTextEditor(O,k,g)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(f,d,l){this.i(d,f).disposeEdits(l)}async $onMoveCustomEditor(f,d,l){const c=this.b.get(l);if(!c)throw new Error(`No provider found for '${l}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const h=this.h.getWebviewPanel(f);if(!h)throw new Error("No webview found");const g=b.URI.revive(d),S=this.d.getDocument(g);await c.provider.moveCustomTextEditor(S,h,u.CancellationToken.None)}async $undo(f,d,l,c){return this.i(d,f).undo(l,c)}async $redo(f,d,l,c){return this.i(d,f).redo(l,c)}async $revert(f,d,l){const c=this.i(d,f);await this.j(d).revertCustomDocument(c.document,l),c.disposeBackup()}async $onSave(f,d,l){const c=this.i(d,f);await this.j(d).saveCustomDocument(c.document,l),c.disposeBackup()}async $onSaveAs(f,d,l,c){const h=this.i(d,f);return this.j(d).saveCustomDocumentAs(h.document,b.URI.revive(l),c)}async $backup(f,d,l){const c=this.i(d,f),g=await this.j(d).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},l);return c.updateBackup(g),g.id}i(f,d){const l=this.c.get(f,b.URI.revive(d));if(!l)throw new Error("No custom document found");return l}j(f){const l=this.b.get(f)?.provider;if(!l||!n(l))throw new Error("Custom document is not editable");return l}}e.$Djc=o;function n(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function r(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function s(t){const f=t.scheme===P.Schemas.file||t.scheme===P.Schemas.untitled?t.fsPath:t.toString();return(0,L.$9i)(f)+""}}),define(ke[333],Ee([1,0,218,138,2,6,7,16,4,12,27,59]),function(he,e,u,L,M,P,R,b,$,y,A,I){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$9ic=e.$8ic=void 0;class E{#e;#t;#i;constructor(m,o,n,i,r,s,t,f){this.d=m,this.e=o,this.f=n,this.g=i,this.h=r,this.c=!1,this.f=Math.max(i,n),this.#i=new A.$Bc(d=>s.getComparisonKey(d)),this.#e=t,this.#t=f}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(m,o){if(!m){this.clear();return}this.j();let n=[];if(M.URI.isUri(m)){if(!o){this.delete(m);return}this.#i.set(m,o.slice()),n=[m]}else if(Array.isArray(m)){n=[];let s;m=[...m].sort(E.k);for(const t of m){const[f,d]=t;if((!s||f.toString()!==s.toString())&&(s&&this.#i.get(s).length===0&&this.#i.delete(s),s=f,n.push(f),this.#i.set(f,[])),d)this.#i.get(f)?.push(...d);else{const l=this.#i.get(f);l&&(l.length=0)}}}if(this.#t.fire(n),!this.#e)return;const i=[];let r=0;for(const s of n){let t=[];const f=this.#i.get(s);if(f)if(f.length>this.g){t=[];const d=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const c of f)if(c.severity===d[l]&&t.push({...b.Diagnostic.from(c),modelVersionId:this.h(s)})===this.g)break e;t.push({severity:L.MarkerSeverity.Info,message:(0,u.localize)(0,null,f.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=f.map(d=>({...b.Diagnostic.from(d),modelVersionId:this.h(s)}));if(i.push([s,t]),r+=t.length,r>this.f)break}this.#e.$changeMany(this.e,i)}delete(m){this.j(),this.#t.fire([m]),this.#i.delete(m),this.#e?.$changeMany(this.e,[[m,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(m,o){this.j();for(const[n,i]of this)m.call(o,n,i,this)}*[Symbol.iterator](){this.j();for(const m of this.#i.keys())yield[m,this.get(m)]}get(m){this.j();const o=this.#i.get(m);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(m){return this.j(),Array.isArray(this.#i.get(m))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(m,o){return m[0].toString()<o[0].toString()?-1:m[0].toString()>o[0].toString()?1:0}}e.$8ic=E;let v=class{static{p=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*p.d}static _mapper(m){const o=new A.$Bc;for(const n of m)o.set(n,n);return{uris:Object.freeze(Array.from(o.values()))}}constructor(m,o,n,i){this.j=o,this.k=n,this.l=i,this.g=new Map,this.h=new $.$$d({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,p._mapper),this.f=m.getProxy(P.$lM.MainThreadDiagnostics)}createDiagnosticCollection(m,o){const{g:n,f:i,h:r,j:s,k:t,l:f}=this,d=new class{$changeMany(h,g){i.$changeMany(h,g),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,h,g.length===0?"CLEARING":g)}$clear(h){i.$clear(h),s.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,h)}dispose(){i.dispose()}};let l;if(!o)o="_generated_diagnostic_collection_name_#"+p.c++,l=o;else if(!n.has(o))l=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do l=o+p.c++;while(n.has(l))}return new class extends E{constructor(){super(o,l,p.e,p.d,h=>f.getDocument(h)?.version,t.extUri,d,r),n.set(l,this)}dispose(){super.dispose(),n.delete(l)}}}getDiagnostics(m){if(m)return this.m(m);{const o=new Map,n=[];for(const i of this.g.values())i.forEach((r,s)=>{let t=o.get(r.toString());typeof t>"u"&&(t=n.length,o.set(r.toString(),t),n.push([r,[]])),n[t][1]=n[t][1].concat(...s)});return n}}m(m){let o=[];for(const n of this.g.values())n.has(m)&&(o=o.concat(n.get(m)));return o}$acceptMarkersChange(m){if(!this.n){const o="_generated_mirror",n=new E(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(o,n),this.n=n}for(const[o,n]of m)this.n.set(M.URI.revive(o),n.map(b.Diagnostic.to))}};e.$9ic=v,e.$9ic=v=p=Je([qe(1,y.$Oj),qe(2,I.$7ic)],v)}),define(ke[334],Ee([1,0,2,13,7,16,75]),function(he,e,u,L,M,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fkc=void 0;class b{constructor(y,A,I,p={timeout:1500,errors:3}){this.c=y,this.d=A,this.f=I,this.g=p,this.a=new R.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(y){return(A,I,p)=>{const v={dispose:this.a.push([A,I,y])};return Array.isArray(p)&&p.push(v),v}}async $participateInSave(y,A){const I=u.URI.revive(y);let p=!1;const E=setTimeout(()=>p=!0,this.g.timeout),v=[];try{for(const a of[...this.a]){if(p)break;const m=this.d.getDocument(I),o=await this.h(a,{document:m,reason:P.TextDocumentSaveReason.to(A)});v.push(o)}}finally{clearTimeout(E)}return v}h([y,A,I],p){const E=this.b.get(y);return typeof E=="number"&&E>this.g.errors?Promise.resolve(!1):this.i(I,y,A,p).then(()=>!0,v=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this.c.error(v),!(v instanceof Error)||v.message!=="concurrent_edits"){const a=this.b.get(y);this.b.set(y,a?a+1:1),typeof a=="number"&&a>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(y,A,I,p){const E=[],v=Date.now(),{document:a,reason:m}=p,{version:o}=a,n=Object.freeze({document:a,reason:m,waitUntil(i){if(Object.isFrozen(E))throw(0,L.$8)("waitUntil can not be called async");E.push(Promise.resolve(i))}});try{A.apply(I,[n])}catch(i){return Promise.reject(i)}return Object.freeze(E),new Promise((i,r)=>{const s=setTimeout(()=>r(new Error("timeout")),this.g.timeout);return Promise.all(E).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' finished after ${Date.now()-v}ms`),clearTimeout(s),i(t)}).catch(t=>{clearTimeout(s),r(t)})}).then(i=>{const r={edits:[]};for(const s of i)if(Array.isArray(s)&&s.every(t=>t instanceof M.$uM))for(const{newText:t,newEol:f,range:d}of s)r.edits.push({resource:a.uri,versionId:void 0,textEdit:{range:d&&P.Range.from(d),text:t,eol:f&&P.EndOfLine.from(f)}});if(r.edits.length!==0)return o===a.version?this.f.$tryApplyWorkspaceEdit(r):Promise.reject(new Error("concurrent_edits"))})}}e.$fkc=b}),define(ke[335],Ee([1,0,4,3,2,6,152,16,18,24,7]),function(he,e,u,L,M,P,R,b,$,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ic=void 0;class I{constructor(E,v){this.a=new u.$7d,this.b=new u.$7d,this.c=new u.$7d,this.d=new u.$7d,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new L.$Tc,this.h=new Map,this.f=E.getProxy(P.$lM.MainThreadDocuments),this.g=v,this.g.onDidRemoveDocuments(a=>{for(const m of a)this.b.fire(m.document)},void 0,this.e),this.g.onDidAddDocuments(a=>{for(const m of a)this.a.fire(m.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(E){if(!E)return;const v=this.g.getDocument(E);if(v)return v}getDocument(E){const v=this.getDocumentData(E);if(!v?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return v.document}ensureDocumentData(E){const v=this.g.getDocument(E);if(v)return Promise.resolve(v);let a=this.h.get(E.toString());return a||(a=this.f.$tryOpenDocument(E).then(m=>{this.h.delete(E.toString());const o=M.URI.revive(m);return(0,$.$7f)(this.g.getDocument(o))},m=>(this.h.delete(E.toString()),Promise.reject(m))),this.h.set(E.toString(),a)),a}createDocumentData(E){return this.f.$tryCreateDocument(E).then(v=>M.URI.revive(v))}$acceptModelLanguageChanged(E,v){const a=M.URI.revive(E),m=this.g.getDocument(a);if(!m)throw new Error("unknown document");this.b.fire(m.document),m._acceptLanguageId(v),this.a.fire(m.document)}$acceptModelSaved(E){const v=M.URI.revive(E),a=this.g.getDocument(v);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this.d.fire(a.document)}$acceptDirtyStateChanged(E,v){const a=M.URI.revive(E),m=this.g.getDocument(a);if(!m)throw new Error("unknown document");m._acceptIsDirty(v),this.c.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,v,a){const m=M.URI.revive(E),o=this.g.getDocument(m);if(!o)throw new Error("unknown document");o._acceptIsDirty(a),o.onEvents(v);let n;v.isUndoing?n=A.TextDocumentChangeReason.Undo:v.isRedoing&&(n=A.TextDocumentChangeReason.Redo),this.c.fire((0,y.$Pn)({document:o.document,contentChanges:v.changes.map(i=>({range:b.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:n}))}setWordDefinitionFor(E,v){(0,R.$IO)(E,v)}}e.$0ic=I}),define(ke[71],Ee([1,0,73,4,18,2,5,6,20,16,7]),function(he,e,u,L,M,P,R,b,$,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fjc=e.$Ejc=void 0,e.$Ejc=(0,R.$ii)("IExtHostEditorTabs");class I{constructor(m,o,n){this.e=n,this.d=o,this.acceptDtoUpdate(m)}get apiObject(){if(!this.a){const m=this,o={get isActive(){return m.b.id===m.e()},get label(){return m.b.label},get input(){return m.c},get isDirty(){return m.b.isDirty},get isPinned(){return m.b.isPinned},get isPreview(){return m.b.isPreview},get group(){return m.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(m){this.b=m,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$9N(P.URI.revive(this.b.input.uri));case 2:return new A.$0N(P.URI.revive(this.b.input.original),P.URI.revive(this.b.input.modified));case 3:return new A.$$N(P.URI.revive(this.b.input.base),P.URI.revive(this.b.input.input1),P.URI.revive(this.b.input.input2),P.URI.revive(this.b.input.result));case 6:return new A.$_N(P.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$aO(this.b.input.viewType);case 4:return new A.$bO(P.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$cO(P.URI.revive(this.b.input.original),P.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$dO;case 9:return new A.$eO(P.URI.revive(this.b.input.uri),P.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$fO(this.b.input.providerId);case 11:return new A.$gO(this.b.input.diffEditors.map(m=>new A.$0N(P.URI.revive(m.original),P.URI.revive(m.modified))));default:return}}}class p{constructor(m,o){this.c=[],this.d="",this.b=m,this.e=o;for(const n of m.tabs)n.isActive&&(this.d=n.id),this.c.push(new I(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const m=this,o={get isActive(){return m.b.groupId===m.e()},get viewColumn(){return y.ViewColumn.to(m.b.viewColumn)},get activeTab(){return m.c.find(n=>n.tabId===m.d)?.apiObject},get tabs(){return Object.freeze(m.c.map(n=>n.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(m){this.b=m}acceptTabOperation(m){if(m.kind===0){const n=new I(m.tabDto,this,()=>this.activeTabId());return this.c.splice(m.index,0,n),m.tabDto.isActive&&(this.d=n.tabId),n}else if(m.kind===1){const n=this.c.splice(m.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${m.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(m.kind===3){if(m.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(m.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${m.oldIndex} which does not exist`);return this.c.splice(m.index,0,n),n}const o=this.c.find(n=>n.tabId===m.tabDto.id);if(!o)throw new Error("INVALID tab");return m.tabDto.isActive?this.d=m.tabDto.id:this.d===m.tabDto.id&&!m.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(m.tabDto),o}activeTabId(){return this.d}}let E=class{constructor(m){this.b=new L.$7d,this.c=new L.$7d,this.e=[],this.a=m.getProxy(b.$lM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const m=this,o={onDidChangeTabGroups:m.c.event,onDidChangeTabs:m.b.event,get all(){return Object.freeze(m.e.map(n=>n.apiObject))},get activeTabGroup(){const n=m.d;return(0,M.$7f)(m.e.find(r=>r.groupId===n)?.apiObject)},close:async(n,i)=>{const r=Array.isArray(n)?n:[n];return r.length?v(r[0])?this.j(r,i):this.i(r,i):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(m){const o=new Set(this.e.map(d=>d.groupId)),n=new Set(m.map(d=>d.groupId)),i=(0,u.$L)(o,n),r=this.e.filter(d=>i.removed.includes(d.groupId)).map(d=>d.apiObject),s=[],t=[];this.e=m.map(d=>{const l=new p(d,()=>this.d);return i.added.includes(l.groupId)?s.push(l.apiObject):t.push(l.apiObject),l});const f=(0,M.$7f)(m.find(d=>d.isActive===!0)?.groupId);f!==void 0&&this.d!==f&&(this.d=f),this.c.fire(Object.freeze({opened:s,closed:r,changed:t}))}$acceptTabGroupUpdate(m){const o=this.e.find(n=>n.groupId===m.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(m),m.isActive&&(this.d=m.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(m){const o=this.e.find(i=>i.groupId===m.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const n=o.acceptTabOperation(m);switch(m.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(m){for(const o of this.e)for(const n of o.tabs)if(n.apiObject===m)return n}h(m){return this.e.find(o=>o.apiObject===m)}async i(m,o){const n=[];for(const i of m){const r=this.g(i);if(!r)throw new Error("Tab close: Invalid tab not found!");n.push(r.tabId)}return this.a.$closeTab(n,o)}async j(m,o){const n=[];for(const i of m){const r=this.h(i);if(!r)throw new Error("Group close: Invalid group not found!");n.push(r.groupId)}return this.a.$closeGroup(n,o)}};e.$Fjc=E,e.$Fjc=E=Je([qe(0,$.$GO)],E);function v(a){return a.tabs!==void 0}}),define(ke[336],Ee([1,0,2,6,3,7,16,179,14,21,26,80]),function(he,e,u,L,M,P,R,b,$,y,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hkc=void 0;class p{constructor(){this.a=[]}add(a){this.b=void 0,this.a.push(a)}delete(a){const m=this.a.indexOf(a);m>=0&&(this.a.splice(m,1),this.b=void 0)}c(){if(!this.b){const a=this.a.sort(),m=[];let o,n,i=14,r=14;for(const s of a){let t=o?(0,$.$nf)(o,s):0;for(t===0?n=1:n=r;t<s.length;t++)t+1===s.length?(i=r,r=9):r+=1,m.push([n,s.toUpperCase().charCodeAt(t),r]),m.push([n,s.toLowerCase().charCodeAt(t),r]),n=r;o=s,r=i}m.push([9,58,10]),m.push([10,47,12]),this.b=new b.$p2(m)}}provideDocumentLinks(a){this.c();const m=[],o=b.$q2.computeLinks({getLineContent(n){return a.lineAt(n-1).text},getLineCount(){return a.lineCount}},this.b);for(const n of o){const i=R.DocumentLink.to(n);i.target&&m.push(i)}return m}}class E{constructor(a,m){this.i=m,this.b=new p,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=a.getProxy(L.$lM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(a,m,o,n={}){if(E.j(o),this.d.has(m))throw new Error(`a provider for the scheme '${m}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(a,"*",this.b));const i=this.h++;this.b.add(m),this.d.add(m),this.c.set(i,o);let r=2;n.isCaseSensitive&&(r+=1024),n.isReadonly&&(r+=2048),typeof o.copy=="function"&&(r+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,A.$0F)(a,"fsChunks"),r+=4);let s;n.isReadonly&&(0,I.$Hk)(n.isReadonly)&&n.isReadonly.value!==""&&(s={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(i,m,r,s).catch(f=>{console.error(`FAILED to register filesystem provider of ${a.identifier.value}-extension for the scheme ${m}`),console.error(f)});const t=o.onDidChangeFile(f=>{const d=[];for(const l of f){const{uri:c,type:h}=l;if(c.scheme!==m)continue;let g;switch(h){case P.FileChangeType.Changed:g=0;break;case P.FileChangeType.Created:g=1;break;case P.FileChangeType.Deleted:g=2;break;default:throw new Error("Unknown FileChangeType")}d.push({resource:c,type:g})}this.a.$onFileSystemChange(i,d)});return(0,M.$Sc)(()=>{t.dispose(),this.b.delete(m),this.d.delete(m),this.c.delete(i),this.a.$unregisterProvider(i)})}static j(a){if(!a)throw new Error("MISSING provider");if(typeof a.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof a.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof a.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof a.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof a.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof a.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof a.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof a.rename!="function")throw new Error("Provider does NOT implement rename")}static k(a){const{type:m,ctime:o,mtime:n,size:i,permissions:r}=a;return{type:m,ctime:o,mtime:n,size:i,permissions:r}}$stat(a,m){return Promise.resolve(this.l(a).stat(u.URI.revive(m))).then(o=>E.k(o))}$readdir(a,m){return Promise.resolve(this.l(a).readDirectory(u.URI.revive(m)))}$readFile(a,m){return Promise.resolve(this.l(a).readFile(u.URI.revive(m))).then(o=>y.$ue.wrap(o))}$writeFile(a,m,o,n){return Promise.resolve(this.l(a).writeFile(u.URI.revive(m),o.buffer,n))}$delete(a,m,o){return Promise.resolve(this.l(a).delete(u.URI.revive(m),o))}$rename(a,m,o,n){return Promise.resolve(this.l(a).rename(u.URI.revive(m),u.URI.revive(o),n))}$copy(a,m,o,n){const i=this.l(a);if(!i.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(i.copy(u.URI.revive(m),u.URI.revive(o),n))}$mkdir(a,m){return Promise.resolve(this.l(a).createDirectory(u.URI.revive(m)))}$watch(a,m,o,n){const i=this.l(a).watch(u.URI.revive(o),n);this.f.set(m,i)}$unwatch(a,m){const o=this.f.get(m);o&&(o.dispose(),this.f.delete(m))}$open(a,m,o){const n=this.l(a);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(u.URI.revive(m),o))}$close(a,m){const o=this.l(a);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(m))}$read(a,m,o,n){const i=this.l(a);if(!i.read)throw new Error('FileSystemProvider does not implement "read"');const r=y.$ue.alloc(n);return Promise.resolve(i.read(m,o,r.buffer,0,n)).then(s=>r.slice(0,s))}$write(a,m,o,n){const i=this.l(a);if(!i.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(i.write(m,o,n.buffer,0,n.byteLength))}l(a){const m=this.c.get(a);if(!m){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return m}}e.$hkc=E}),define(ke[337],Ee([1,0,4,35,2,6,16,7,45]),function(he,e,u,L,M,P,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ikc=void 0;class y{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(E,v,a,m,o,n){this.a=Math.random(),this.b=new u.$7d,this.c=new u.$7d,this.d=new u.$7d,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const i=(0,L.$ck)(o),r=typeof o=="string",s=n?.correlate,t=m(f=>{if(!(typeof f.session=="number"&&f.session!==this.a)&&!(s&&typeof f.session>"u")){if(!n?.ignoreCreateEvents)for(const d of f.created){const l=M.URI.revive(d);i(l.fsPath)&&(!r||v.getWorkspaceFolder(l))&&this.b.fire(l)}if(!n?.ignoreChangeEvents)for(const d of f.changed){const l=M.URI.revive(d);i(l.fsPath)&&(!r||v.getWorkspaceFolder(l))&&this.c.fire(l)}if(!n?.ignoreDeleteEvents)for(const d of f.deleted){const l=M.URI.revive(d);i(l.fsPath)&&(!r||v.getWorkspaceFolder(l))&&this.d.fire(l)}}});this.g=b.$nM.from(this.i(E,a,o,n,n?.correlate),this.b,this.c,this.d,t)}i(E,v,a,m,o){const n=b.$nM.from();if(typeof a=="string")return n;const i=E.getProxy(P.$lM.MainThreadFileSystemEventService);let r=!1;return(a.pattern.includes(L.$$j)||a.pattern.includes(L.$_j))&&(r=!0),i.$watch(v.identifier.value,this.a,a.baseUri,{recursive:r,excludes:m?.excludes??[]},!!o),b.$nM.from({dispose:()=>i.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(E){this.a=E,this.session=this.a.session,this.b=new $.$V(()=>this.a.created.map(M.URI.revive)),this.c=new $.$V(()=>this.a.changed.map(M.URI.revive)),this.d=new $.$V(()=>this.a.deleted.map(M.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class I{constructor(E,v,a){this.j=E,this.k=v,this.l=a,this.a=new u.$7d,this.b=new u.$7d,this.c=new u.$7d,this.d=new u.$7d,this.g=new u.$9d,this.h=new u.$9d,this.i=new u.$9d,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(E,v,a,m){return new y(this.j,E,v,this.a.event,R.GlobPattern.from(a),m)}$onFileEvent(E){this.a.fire(new A(E))}$onDidRunFileOperation(E,v){switch(E){case 2:this.b.fire(Object.freeze({files:v.map(a=>({oldUri:M.URI.revive(a.source),newUri:M.URI.revive(a.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(a=>M.URI.revive(a.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(a=>M.URI.revive(a.target))}));break;default:}}getOnWillRenameFileEvent(E){return this.m(E,this.g)}getOnWillCreateFileEvent(E){return this.m(E,this.h)}getOnWillDeleteFileEvent(E){return this.m(E,this.i)}m(E,v){return(a,m,o)=>{const n=function(r){a.call(m,r)};return n.extension=E,v.event(n,void 0,o)}}async $onWillRunFileOperation(E,v,a,m){switch(E){case 2:return await this.n(this.g,{files:v.map(o=>({oldUri:M.URI.revive(o.source),newUri:M.URI.revive(o.target)}))},a,m);case 1:return await this.n(this.i,{files:v.map(o=>M.URI.revive(o.target))},a,m);case 0:case 3:return await this.n(this.h,{files:v.map(o=>M.URI.revive(o.target))},a,m)}}async n(E,v,a,m){const o=new Set,n=[];if(await E.fireAsync(v,m,async(r,s)=>{const t=Date.now(),f=await Promise.resolve(r);f instanceof b.$xM&&(n.push([s.extension,f]),o.add(s.extension.displayName??s.extension.identifier.value)),Date.now()-t>a&&this.k.warn("SLOW file-participant",s.extension.identifier)}),m.isCancellationRequested||n.length===0)return;const i={edits:[]};for(const[,r]of n){const{edits:s}=R.WorkspaceEdit.from(r,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(s)}return{edit:i,extensionNames:Array.from(o)}}}e.$ikc=I}),define(ke[338],Ee([1,0,19,8,22,13,124,3,24,39,14,18,2,29,175,83,134,220,25,16,7,26,111,6]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v,a,m,o,n,i,r,s,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ic=void 0;class d{constructor(q,V){this.d=q,this.e=V}async provideDocumentSymbols(q,V){const Q=this.d.getDocument(q),J=await this.e.provideDocumentSymbols(Q,V);if(!(0,u.$Kb)(J))return J[0]instanceof r.$GM?J.map(i.DocumentSymbol.from):d.f(J)}static f(q){q=q.slice(0).sort((J,fe)=>{let we=J.location.range.start.compareTo(fe.location.range.start);return we===0&&(we=fe.location.range.end.compareTo(J.location.range.end)),we});const V=[],Q=[];for(const J of q){const fe={name:J.name||"!!MISSING: name!!",kind:i.SymbolKind.from(J.kind),tags:J.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:J.containerName,range:i.Range.from(J.location.range),selectionRange:i.Range.from(J.location.range),children:[]};for(;;){if(Q.length===0){Q.push(fe),V.push(fe);break}const we=Q[Q.length-1];if(E.$ct.containsRange(we.range,fe.range)&&!E.$ct.equalsRange(we.range,fe.range)){we.children?.push(fe),Q.push(fe);break}Q.pop()}}return V}}class l{constructor(q,V,Q,J,fe,we){this.f=q,this.g=V,this.h=Q,this.j=J,this.k=fe,this.l=we,this.d=new t.$1ic("CodeLens"),this.e=new Map}async provideCodeLenses(q,V){const Q=this.f.getDocument(q),J=await this.h.provideCodeLenses(Q,V);if(!J||V.isCancellationRequested)return;const fe=this.d.add(J),we=new b.$Tc;this.e.set(fe,we);const Te={cacheId:fe,lenses:[]};for(let He=0;He<J.length;He++)Te.lenses.push({cacheId:[fe,He],range:i.Range.from(J[He].range),command:this.g.toInternal(J[He].command,we)});return Te}async resolveCodeLens(q,V){const Q=q.cacheId&&this.d.get(...q.cacheId);if(!Q)return;let J;if(typeof this.h.resolveCodeLens!="function"||Q.isResolved?J=Q:J=await this.h.resolveCodeLens(Q,V),J||(J=Q),V.isCancellationRequested)return;const fe=q.cacheId&&this.e.get(q.cacheId[0]);if(fe){if(!J.command){const we=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,we),this.l.error(we);return}return q.command=this.g.toInternal(J.command,fe),q}}releaseCodeLenses(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}}function c(Fe){return Array.isArray(Fe)?Fe.map(i.DefinitionLink.from):Fe?[i.DefinitionLink.from(Fe)]:[]}class h{constructor(q,V){this.d=q,this.e=V}async provideDefinition(q,V,Q){const J=this.d.getDocument(q),fe=i.Position.to(V),we=await this.e.provideDefinition(J,fe,Q);return c(we)}}class g{constructor(q,V){this.d=q,this.e=V}async provideDeclaration(q,V,Q){const J=this.d.getDocument(q),fe=i.Position.to(V),we=await this.e.provideDeclaration(J,fe,Q);return c(we)}}class S{constructor(q,V){this.d=q,this.e=V}async provideImplementation(q,V,Q){const J=this.d.getDocument(q),fe=i.Position.to(V),we=await this.e.provideImplementation(J,fe,Q);return c(we)}}class w{constructor(q,V){this.d=q,this.e=V}async provideTypeDefinition(q,V,Q){const J=this.d.getDocument(q),fe=i.Position.to(V),we=await this.e.provideTypeDefinition(J,fe,Q);return c(we)}}class C{constructor(q,V){this.d=q,this.e=V}async provideHover(q,V,Q){const J=this.d.getDocument(q),fe=i.Position.to(V),we=await this.e.provideHover(J,fe,Q);if(!(!we||(0,u.$Kb)(we.contents)))return we.range||(we.range=J.getWordRangeAtPosition(fe)),we.range||(we.range=new r.$pM(fe,fe)),i.Hover.from(we)}}class k{constructor(q,V){this.d=q,this.e=V}async provideEvaluatableExpression(q,V,Q){const J=this.d.getDocument(q),fe=i.Position.to(V),we=await this.e.provideEvaluatableExpression(J,fe,Q);if(we)return i.EvaluatableExpression.from(we)}}class D{constructor(q,V){this.d=q,this.e=V}async provideInlineValues(q,V,Q,J){const fe=this.d.getDocument(q),we=await this.e.provideInlineValues(fe,i.Range.to(V),i.InlineValueContext.to(Q),J);if(Array.isArray(we))return we.map(Te=>i.InlineValue.from(Te))}}class O{constructor(q,V){this.d=q,this.e=V}async provideDocumentHighlights(q,V,Q){const J=this.d.getDocument(q),fe=i.Position.to(V),we=await this.e.provideDocumentHighlights(J,fe,Q);if(Array.isArray(we))return we.map(i.DocumentHighlight.from)}}class F{constructor(q,V){this.d=q,this.e=V}async provideMultiDocumentHighlights(q,V,Q,J){const fe=this.d.getDocument(q),we=Q.map(xe=>this.d.getDocument(xe)),Te=i.Position.to(V),He=await this.e.provideMultiDocumentHighlights(fe,Te,we,J);if(Array.isArray(He))return He.map(i.MultiDocumentHighlight.from)}}class T{constructor(q,V){this.d=q,this.e=V}async provideLinkedEditingRanges(q,V,Q){const J=this.d.getDocument(q),fe=i.Position.to(V),we=await this.e.provideLinkedEditingRanges(J,fe,Q);if(we&&Array.isArray(we.ranges))return{ranges:(0,u.$Hb)(we.ranges.map(i.Range.from)),wordPattern:we.wordPattern}}}class z{constructor(q,V){this.d=q,this.e=V}async provideReferences(q,V,Q,J){const fe=this.d.getDocument(q),we=i.Position.to(V),Te=await this.e.provideReferences(fe,we,Q,J);if(Array.isArray(Te))return Te.map(i.location.from)}}class j{static{this.d=1e3}constructor(q,V,Q,J,fe,we,Te){this.g=q,this.h=V,this.j=Q,this.k=J,this.l=fe,this.m=we,this.n=Te,this.e=new t.$1ic("CodeAction"),this.f=new Map}async provideCodeActions(q,V,Q,J){const fe=this.g.getDocument(q),we=v.$et.isISelection(V)?i.Selection.to(V):i.Range.to(V),Te=[];for(const ot of this.j.getDiagnostics(q))if(we.intersection(ot.range)&&Te.push(ot)>j.d)break;const He={diagnostics:Te,only:Q.only?new r.$IM(Q.only):void 0,triggerKind:i.CodeActionTriggerKind.to(Q.trigger)},xe=await this.k.provideCodeActions(fe,we,He,J);if(!(0,u.$Lb)(xe)||J.isCancellationRequested)return;const it=this.e.add(xe),rt=new b.$Tc;this.f.set(it,rt);const at=[];for(let ot=0;ot<xe.length;ot++){const De=xe[ot];if(De)if(j.o(De))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),at.push({_isSynthetic:!0,title:De.title,command:this.h.toInternal(De,rt)});else{He.only&&(De.kind?He.only.contains(De.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${He.only.value} 'requested but returned code action is of kind '${De.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${He.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const Be=De.ranges??[];at.push({cacheId:[it,ot],title:De.title,command:De.command&&this.h.toInternal(De.command,rt),diagnostics:De.diagnostics&&De.diagnostics.map(i.Diagnostic.from),edit:De.edit&&i.WorkspaceEdit.from(De.edit,void 0),kind:De.kind&&De.kind.value,isPreferred:De.isPreferred,isAI:(0,s.$9F)(this.m,"codeActionAI")?De.isAI:!1,ranges:(0,s.$9F)(this.m,"codeActionRanges")?(0,u.$Hb)(Be.map(i.Range.from)):void 0,disabled:De.disabled?.reason})}}return{cacheId:it,actions:at}}async resolveCodeAction(q,V){const[Q,J]=q,fe=this.e.get(Q,J);if(!fe||j.o(fe))return{};if(!this.k.resolveCodeAction)return{};const we=await this.k.resolveCodeAction(fe,V)??fe;let Te;we.edit&&(Te=i.WorkspaceEdit.from(we.edit,void 0));let He;if(we.command){const xe=this.f.get(Q);xe&&(He=this.h.toInternal(we.command,xe))}return{edit:Te,command:He}}releaseCodeActions(q){this.f.get(q)?.dispose(),this.f.delete(q),this.e.delete(q)}static o(q){return typeof q.command=="string"&&typeof q.title=="string"}}class N{constructor(q,V,Q,J,fe){this.e=q,this.f=V,this.g=Q,this.h=J,this.j=fe,this.d=new t.$1ic("DocumentPasteEdit")}async prepareDocumentPaste(q,V,Q,J){if(!this.g.prepareDocumentPaste)return;const fe=this.f.getDocument(q),we=V.map(xe=>i.Range.to(xe)),Te=i.DataTransfer.toDataTransfer(Q,()=>{throw new P.$$});if(await this.g.prepareDocumentPaste(fe,we,Te,J),J.isCancellationRequested)return;const He=Array.from(Te).filter(([,xe])=>!(xe instanceof r.$cN));return i.DataTransfer.from(He)}async providePasteEdits(q,V,Q,J,fe,we){if(!this.g.provideDocumentPasteEdits)return[];const Te=this.f.getDocument(V),He=Q.map(at=>i.Range.to(at)),xe=i.DataTransfer.toDataTransfer(J,async at=>(await this.e.$resolvePasteFileData(this.h,q,at)).buffer),it=await this.g.provideDocumentPasteEdits(Te,He,xe,{only:fe.only?new r.$hN(fe.only):void 0,triggerKind:fe.triggerKind},we);if(!it||we.isCancellationRequested)return[];const rt=this.d.add(it);return it.map((at,ot)=>({_cacheId:[rt,ot],title:at.title??(0,o.localize)(0,null,this.j.displayName||this.j.name),kind:at.kind,yieldTo:at.yieldTo?.map(De=>De.value),insertText:typeof at.insertText=="string"?at.insertText:{snippet:at.insertText.value},additionalEdit:at.additionalEdit?i.WorkspaceEdit.from(at.additionalEdit,void 0):void 0}))}async resolvePasteEdit(q,V){const[Q,J]=q,fe=this.d.get(Q,J);if(!fe||!this.g.resolveDocumentPasteEdit)return{};const we=await this.g.resolveDocumentPasteEdit(fe,V)??fe;return{additionalEdit:we.additionalEdit?i.WorkspaceEdit.from(we.additionalEdit,void 0):void 0}}releasePasteEdits(q){this.d.delete(q)}}class B{constructor(q,V){this.d=q,this.e=V}async provideDocumentFormattingEdits(q,V,Q){const J=this.d.getDocument(q),fe=await this.e.provideDocumentFormattingEdits(J,V,Q);if(Array.isArray(fe))return fe.map(i.TextEdit.from)}}class W{constructor(q,V){this.d=q,this.e=V}async provideDocumentRangeFormattingEdits(q,V,Q,J){const fe=this.d.getDocument(q),we=i.Range.to(V),Te=await this.e.provideDocumentRangeFormattingEdits(fe,we,Q,J);if(Array.isArray(Te))return Te.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(q,V,Q,J){(0,I.$6f)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const fe=this.d.getDocument(q),we=V.map(i.Range.to),Te=await this.e.provideDocumentRangesFormattingEdits(fe,we,Q,J);if(Array.isArray(Te))return Te.map(i.TextEdit.from)}}class Z{constructor(q,V){this.d=q,this.e=V,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(q,V,Q,J,fe){const we=this.d.getDocument(q),Te=i.Position.to(V),He=await this.e.provideOnTypeFormattingEdits(we,Te,Q,J,fe);if(Array.isArray(He))return He.map(i.TextEdit.from)}}class _{constructor(q,V){this.e=q,this.f=V,this.d=new t.$1ic("WorkspaceSymbols")}async provideWorkspaceSymbols(q,V){const Q=await this.e.provideWorkspaceSymbols(q,V);if(!(0,u.$Lb)(Q))return{symbols:[]};const J=this.d.add(Q),fe={cacheId:J,symbols:[]};for(let we=0;we<Q.length;we++){const Te=Q[we];if(!Te||!Te.name){this.f.warn("INVALID SymbolInformation",Te);continue}fe.symbols.push({...i.WorkspaceSymbol.from(Te),cacheId:[J,we]})}return fe}async resolveWorkspaceSymbol(q,V){if(typeof this.e.resolveWorkspaceSymbol!="function"||!q.cacheId)return q;const Q=this.d.get(...q.cacheId);if(Q){const J=await this.e.resolveWorkspaceSymbol(Q,V);return J&&(0,$.$Rn)(q,i.WorkspaceSymbol.from(J),!0)}}releaseWorkspaceSymbols(q){this.d.delete(q)}}class X{static supportsResolving(q){return typeof q.prepareRename=="function"}constructor(q,V,Q){this.d=q,this.e=V,this.f=Q}async provideRenameEdits(q,V,Q,J){const fe=this.d.getDocument(q),we=i.Position.to(V);try{const Te=await this.e.provideRenameEdits(fe,we,Q,J);return Te?i.WorkspaceEdit.from(Te):void 0}catch(Te){const He=X.g(Te);return He?{rejectReason:He,edits:void 0}:Promise.reject(Te)}}async resolveRenameLocation(q,V,Q){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const J=this.d.getDocument(q),fe=i.Position.to(V);try{const we=await this.e.prepareRename(J,fe,Q);let Te,He;if(r.$pM.isRange(we)?(Te=we,He=J.getText(we)):(0,I.$Xf)(we)&&(Te=we.range,He=we.placeholder),!Te||!He)return;if(Te.start.line>fe.line||Te.end.line<fe.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Te),text:He}}catch(we){const Te=X.g(we);return Te?{rejectReason:Te,range:void 0,text:void 0}:Promise.reject(we)}}static g(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class x{constructor(q,V,Q){this.d=q,this.e=V,this.f=Q}async provideNewSymbolNames(q,V,Q){const J=this.d.getDocument(q),fe=i.Range.to(V);try{const we=await this.e.provideNewSymbolNames(J,fe,Q);return we?we.map(Te=>typeof Te=="string"?{newSymbolName:Te}:{newSymbolName:Te.newSymbolName,tags:Te.tags}):void 0}catch(we){this.f.error(x.g(we)??JSON.stringify(we,null,"	"));return}}static g(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class re{constructor(q,V){this.resultId=q,this.tokens=V}}class Y{constructor(q,V){this.f=q,this.g=V,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(q,V,Q){const J=this.f.getDocument(q),fe=V!==0?this.d.get(V):null;let we=typeof fe?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(J,fe.resultId,Q):await this.g.provideDocumentSemanticTokens(J,Q);return fe&&this.d.delete(V),we?(we=Y.h(we),this.o(Y.n(fe,we),we)):null}async releaseDocumentSemanticColoring(q){this.d.delete(q)}static h(q){return Y.j(q)?Y.k(q)?q:new r.$HN(new Uint32Array(q.data),q.resultId):Y.l(q)?Y.m(q)?q:new r.$JN(q.edits.map(V=>new r.$IN(V.start,V.deleteCount,V.data?new Uint32Array(V.data):V.data)),q.resultId):q}static j(q){return q&&!!q.data}static k(q){return q.data instanceof Uint32Array}static l(q){return q&&Array.isArray(q.edits)}static m(q){for(const V of q.edits)if(!(V.data instanceof Uint32Array))return!1;return!0}static n(q,V){if(!Y.j(V)||!q||!q.tokens)return V;const Q=q.tokens,J=Q.length,fe=V.data,we=fe.length;let Te=0;const He=Math.min(J,we);for(;Te<He&&Q[Te]===fe[Te];)Te++;if(Te===J&&Te===we)return new r.$JN([],V.resultId);let xe=0;const it=He-Te;for(;xe<it&&Q[J-xe-1]===fe[we-xe-1];)xe++;return new r.$JN([{start:Te,deleteCount:J-Te-xe,data:fe.subarray(Te,we-xe)}],V.resultId)}o(q,V){if(Y.j(q)){const Q=this.e++;return this.d.set(Q,new re(q.resultId,q.data)),(0,m.$Hab)({id:Q,type:"full",data:q.data})}if(Y.l(q)){const Q=this.e++;return Y.j(V)?this.d.set(Q,new re(V.resultId,V.data)):this.d.set(Q,new re(q.resultId)),(0,m.$Hab)({id:Q,type:"delta",deltas:(q.edits||[]).map(J=>({start:J.start,deleteCount:J.deleteCount,data:J.data}))})}return null}}class me{constructor(q,V){this.d=q,this.e=V}async provideDocumentRangeSemanticTokens(q,V,Q){const J=this.d.getDocument(q),fe=await this.e.provideDocumentRangeSemanticTokens(J,i.Range.to(V),Q);return fe?this.f(fe):null}f(q){return(0,m.$Hab)({id:0,type:"full",data:q.data})}}class Ce{static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}constructor(q,V,Q,J,fe){this.f=q,this.g=V,this.h=Q,this.j=J,this.k=fe,this.d=new t.$1ic("CompletionItem"),this.e=new Map}async provideCompletionItems(q,V,Q,J){const fe=this.f.getDocument(q),we=i.Position.to(V),Te=fe.getWordRangeAtPosition(we)||new r.$pM(we,we),He=Te.with({end:we}),xe=new y.$3d,it=await this.h.provideCompletionItems(fe,we,J,i.CompletionContext.to(Q));if(!it||J.isCancellationRequested)return;const rt=Array.isArray(it)?new r.$VM(it):it,at=Ce.supportsResolving(this.h)?this.d.add(rt.items):this.d.add([]),ot=new b.$Tc;this.e.set(at,ot);const De=[],Be={x:at,b:De,a:{replace:i.Range.from(Te),insert:i.Range.from(He)},c:rt.isIncomplete||void 0,d:xe.elapsed()};for(let Ge=0;Ge<rt.items.length;Ge++){const Oe=rt.items[Ge],Qe=this.l(Oe,[at,Ge],He,Te);De.push(Qe)}return Be}async resolveCompletionItem(q,V){if(typeof this.h.resolveCompletionItem!="function")return;const Q=this.d.get(...q);if(!Q)return;const J=this.l(Q,q),fe=await this.h.resolveCompletionItem(Q,V);if(!fe)return;const we=this.l(fe,q);return(J.h!==we.h||J.i!==we.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(J.n!==we.n||J.o!==we.o||!(0,$.$Sn)(J.p,we.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...J,d:we.d,c:we.c,l:we.l,h:we.h,i:we.i,n:we.n,o:we.o,p:we.p}}releaseCompletionItems(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,V,Q,J){const fe=this.e.get(V[0]);if(!fe)throw Error("DisposableStore is missing...");const we=this.g.toInternal(q.command,fe),Te={x:V,a:q.label,b:q.kind!==void 0?i.CompletionItemKind.from(q.kind):void 0,m:q.tags&&q.tags.map(i.CompletionItemTag.from),c:q.detail,d:typeof q.documentation>"u"?void 0:i.MarkdownString.fromStrict(q.documentation),e:q.sortText!==q.label?q.sortText:void 0,f:q.filterText!==q.label?q.filterText:void 0,g:q.preselect||void 0,i:q.keepWhitespace?1:0,k:q.commitCharacters?.join(""),l:q.additionalTextEdits&&q.additionalTextEdits.map(i.TextEdit.from),n:we?.$ident,o:we?.id,p:we?.$ident?void 0:we?.arguments};q.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Te.h=q.textEdit.newText):typeof q.insertText=="string"?Te.h=q.insertText:q.insertText instanceof r.$yM&&(Te.h=q.insertText.value,Te.i|=4);let He;return q.textEdit?He=q.textEdit.range:q.range&&(He=q.range),r.$pM.isRange(He)?Te.j=i.Range.from(He):He&&(!Q?.isEqual(He.inserting)||!J?.isEqual(He.replacing))&&(Te.j={insert:i.Range.from(He.inserting),replace:i.Range.from(He.replacing)}),Te}}class ee{async provideInlineCompletions(q,V,Q,J){}disposeCompletions(q){}handleDidShowCompletionItem(q,V,Q){}handlePartialAccept(q,V,Q,J){}}class U extends ee{constructor(q,V,Q,J){super(),this.f=q,this.g=V,this.h=Q,this.j=J,this.d=new be,this.e=(0,s.$9F)(this.f,"inlineCompletionsAdditions"),this.k={[a.InlineCompletionTriggerKind.Automatic]:r.InlineCompletionTriggerKind.Automatic,[a.InlineCompletionTriggerKind.Explicit]:r.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,s.$9F)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(q,V,Q,J){const fe=this.g.getDocument(q),we=i.Position.to(V),Te=await this.h.provideInlineCompletionItems(fe,we,{selectedCompletionInfo:Q.selectedSuggestionInfo?{range:i.Range.to(Q.selectedSuggestionInfo.range),text:Q.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Q.triggerKind]},J);if(!Te||J.isCancellationRequested)return;const He=Array.isArray(Te)?Te:Te.items,xe=this.e?Array.isArray(Te)?[]:Te.commands||[]:[],it=this.e&&!Array.isArray(Te)?Te.enableForwardStability:void 0;let rt;return{pid:this.d.createReferenceId({dispose(){rt?.dispose()},items:He}),items:He.map((ot,De)=>{let Be;ot.command&&(rt||(rt=new b.$Tc),Be=this.j.toInternal(ot.command,rt));const Ge=ot.insertText;return{insertText:typeof Ge=="string"?Ge:{snippet:Ge.value},filterText:ot.filterText,range:ot.range?i.Range.from(ot.range):void 0,command:Be,idx:De,completeBracketPairs:this.e?ot.completeBracketPairs:!1}}),commands:xe.map(ot=>(rt||(rt=new b.$Tc),this.j.toInternal(ot,rt))),suppressSuggestions:!1,enableForwardStability:it}}disposeCompletions(q){this.d.disposeReferenceId(q)?.dispose()}handleDidShowCompletionItem(q,V,Q){const J=this.d.get(q)?.items[V];J&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(J,Q)}handlePartialAccept(q,V,Q,J){const fe=this.d.get(q)?.items[V];fe&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(fe,Q),this.h.handleDidPartiallyAcceptCompletionItem(fe,i.PartialAcceptInfo.to(J)))}}class ie{async provideInlineEdits(q,V,Q){const J=this.f.getDocument(q),fe=await this.g.provideInlineEdit(J,{triggerKind:this.e[V.triggerKind]},Q);if(!fe||Q.isCancellationRequested)return;let we;const Te=this.d.createReferenceId({dispose(){we?.dispose()},item:fe});let He;fe.accepted&&(we||(we=new b.$Tc),He=this.h.toInternal(fe.accepted,we));let xe;return fe.rejected&&(we||(we=new b.$Tc),xe=this.h.toInternal(fe.rejected,we)),{pid:Te,text:fe.text,range:i.Range.from(fe.range),accepted:He,rejected:xe}}disposeEdit(q){this.d.disposeReferenceId(q)?.dispose()}constructor(q,V,Q,J){this.f=V,this.g=Q,this.h=J,this.d=new be,this.e={[a.InlineEditTriggerKind.Automatic]:r.InlineEditTriggerKind.Automatic,[a.InlineEditTriggerKind.Invoke]:r.InlineEditTriggerKind.Invoke}}}class be{constructor(){this.d=new Map,this.e=1}createReferenceId(q){const V=this.e++;return this.d.set(V,q),V}disposeReferenceId(q){const V=this.d.get(q);return this.d.delete(q),V}get(q){return this.d.get(q)}}class Se{constructor(q,V){this.e=q,this.f=V,this.d=new t.$1ic("SignatureHelp")}async provideSignatureHelp(q,V,Q,J){const fe=this.e.getDocument(q),we=i.Position.to(V),Te=this.g(Q),He=await this.f.provideSignatureHelp(fe,we,J,Te);if(He){const xe=this.d.add([He]);return{...i.SignatureHelp.from(He),id:xe}}}g(q){let V;if(q.activeSignatureHelp){const Q=i.SignatureHelp.to(q.activeSignatureHelp),J=this.d.get(q.activeSignatureHelp.id,0);J?(V=J,V.activeSignature=Q.activeSignature,V.activeParameter=Q.activeParameter):V=Q}return{...q,activeSignatureHelp:V}}releaseSignatureHelp(q){this.d.delete(q)}}class ae{constructor(q,V,Q,J,fe){this.f=q,this.g=V,this.h=Q,this.j=J,this.k=fe,this.d=new t.$1ic("InlayHints"),this.e=new Map}async provideInlayHints(q,V,Q){const J=this.f.getDocument(q),fe=i.Range.to(V),we=await this.h.provideInlayHints(J,fe,Q);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(V)}`);return}if(Q.isCancellationRequested)return;const Te=this.d.add(we);this.e.set(Te,new b.$Tc);const He={hints:[],cacheId:Te};for(let xe=0;xe<we.length;xe++)this.l(we[xe],fe)&&He.hints.push(this.m(we[xe],[Te,xe]));return this.j.trace(`[InlayHints] ${He.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(V)}`),He}async resolveInlayHint(q,V){if(typeof this.h.resolveInlayHint!="function")return;const Q=this.d.get(...q);if(!Q)return;const J=await this.h.resolveInlayHint(Q,V);if(J&&this.l(J))return this.m(J,q)}releaseHints(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,V){return q.label.length===0||Array.isArray(q.label)&&q.label.every(Q=>Q.value.length===0)?(console.log("INVALID inlay hint, empty label",q),!1):!(V&&!V.contains(q.position))}m(q,V){const Q=this.e.get(V[0]);if(!Q)throw Error("DisposableStore is missing...");const J={label:"",cacheId:V,tooltip:i.MarkdownString.fromStrict(q.tooltip),position:i.Position.from(q.position),textEdits:q.textEdits&&q.textEdits.map(i.TextEdit.from),kind:q.kind&&i.InlayHintKind.from(q.kind),paddingLeft:q.paddingLeft,paddingRight:q.paddingRight};if(typeof q.label=="string")J.label=q.label;else{const fe=[];J.label=fe;for(const we of q.label){if(!we.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Te={label:we.value,tooltip:i.MarkdownString.fromStrict(we.tooltip)};r.$zM.isLocation(we.location)&&(Te.location=i.location.from(we.location)),we.command&&(Te.command=this.g.toInternal(we.command,Q)),fe.push(Te)}}return J}}class ce{constructor(q,V){this.e=q,this.f=V,this.d=new t.$1ic("DocumentLink")}async provideLinks(q,V){const Q=this.e.getDocument(q),J=await this.f.provideDocumentLinks(Q,V);if(!(!Array.isArray(J)||J.length===0)&&!V.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:J.filter(ce.g).map(i.DocumentLink.from)};{const fe=this.d.add(J),we={links:[],cacheId:fe};for(let Te=0;Te<J.length;Te++){if(!ce.g(J[Te]))continue;const He=i.DocumentLink.from(J[Te]);He.cacheId=[fe,Te],we.links.push(He)}return we}}}static g(q){return q.target&&q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(q,V){if(typeof this.f.resolveDocumentLink!="function")return;const Q=this.d.get(...q);if(!Q)return;const J=await this.f.resolveDocumentLink(Q,V);if(!(!J||!ce.g(J)))return i.DocumentLink.from(J)}releaseLinks(q){this.d.delete(q)}}class se{constructor(q,V){this.d=q,this.e=V}async provideColors(q,V){const Q=this.d.getDocument(q),J=await this.e.provideDocumentColors(Q,V);return Array.isArray(J)?J.map(we=>({color:i.Color.from(we.color),range:i.Range.from(we.range)})):[]}async provideColorPresentations(q,V,Q){const J=this.d.getDocument(q),fe=i.Range.to(V.range),we=i.Color.to(V.color),Te=await this.e.provideColorPresentations(we,{document:J,range:fe},Q);if(Array.isArray(Te))return Te.map(i.ColorPresentation.from)}}class K{constructor(q,V){this.d=q,this.e=V}async provideFoldingRanges(q,V,Q){const J=this.d.getDocument(q),fe=await this.e.provideFoldingRanges(J,V,Q);if(Array.isArray(fe))return fe.map(i.FoldingRange.from)}}class te{constructor(q,V,Q){this.d=q,this.e=V,this.f=Q}async provideSelectionRanges(q,V,Q){const J=this.d.getDocument(q),fe=V.map(i.Position.to),we=await this.e.provideSelectionRanges(J,fe,Q);if(!(0,u.$Lb)(we))return[];if(we.length!==fe.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Te=[];for(let He=0;He<fe.length;He++){const xe=[];Te.push(xe);let it=fe[He],rt=we[He];for(;;){if(!rt.range.contains(it))throw new Error("INVALID selection range, must contain the previous range");if(xe.push(i.SelectionRange.from(rt)),!rt.parent)break;it=rt.range,rt=rt.parent}}return Te}}class le{constructor(q,V){this.f=q,this.g=V,this.d=new R.$LO(""),this.e=new Map}async prepareSession(q,V,Q){const J=this.f.getDocument(q),fe=i.Position.to(V),we=await this.g.prepareCallHierarchy(J,fe,Q);if(!we)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(we)?we.map(He=>this.h(Te,He)):[this.h(Te,we)]}async provideCallsTo(q,V,Q){const J=this.j(q,V);if(!J)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyIncomingCalls(J,Q);if(fe)return fe.map(we=>({from:this.h(q,we.from),fromRanges:we.fromRanges.map(Te=>i.Range.from(Te))}))}async provideCallsFrom(q,V,Q){const J=this.j(q,V);if(!J)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyOutgoingCalls(J,Q);if(fe)return fe.map(we=>({to:this.h(q,we.to),fromRanges:we.fromRanges.map(Te=>i.Range.from(Te))}))}releaseSession(q){this.e.delete(q)}h(q,V){const Q=this.e.get(q),J=i.CallHierarchyItem.from(V,q,Q.size.toString(36));return Q.set(J._itemId,V),J}j(q,V){return this.e.get(q)?.get(V)}}class de{constructor(q,V){this.f=q,this.g=V,this.d=new R.$LO(""),this.e=new Map}async prepareSession(q,V,Q){const J=this.f.getDocument(q),fe=i.Position.to(V),we=await this.g.prepareTypeHierarchy(J,fe,Q);if(!we)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(we)?we.map(He=>this.h(Te,He)):[this.h(Te,we)]}async provideSupertypes(q,V,Q){const J=this.j(q,V);if(!J)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySupertypes(J,Q);if(fe)return fe.map(we=>this.h(q,we))}async provideSubtypes(q,V,Q){const J=this.j(q,V);if(!J)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySubtypes(J,Q);if(fe)return fe.map(we=>this.h(q,we))}releaseSession(q){this.e.delete(q)}h(q,V){const Q=this.e.get(q),J=i.TypeHierarchyItem.from(V,q,Q.size.toString(36));return Q.set(J._itemId,V),J}j(q,V){return this.e.get(q)?.get(V)}}class Ae{constructor(q,V,Q,J,fe){this.d=q,this.e=V,this.f=Q,this.g=J,this.h=fe}async provideDocumentOnDropEdits(q,V,Q,J,fe){const we=this.e.getDocument(V),Te=i.Position.to(Q),He=i.DataTransfer.toDataTransfer(J,async it=>(await this.d.$resolveDocumentOnDropFileData(this.g,q,it)).buffer),xe=await this.f.provideDocumentDropEdits(we,Te,He,fe);if(xe)return(0,u.$3b)(xe).map(it=>({title:it.title??(0,o.localize)(1,null,this.h.displayName||this.h.name),kind:it.kind?.value,yieldTo:it.yieldTo?.map(rt=>rt.value),insertText:typeof it.insertText=="string"?it.insertText:{snippet:it.insertText.value},additionalEdit:it.additionalEdit?i.WorkspaceEdit.from(it.additionalEdit,void 0):void 0}))}}class $e{constructor(q,V){this.d=q,this.e=V}async provideMappedEdits(q,V,Q,J){const fe=p.URI.revive(q),we=this.d.getDocument(fe),Te=Q.documents.map(it=>it.map(rt=>({uri:p.URI.revive(rt.uri),version:rt.version,ranges:rt.ranges.map(at=>i.Range.to(at))}))),He={documents:Te,selections:Te[0]?.[0]?.ranges??[]},xe=await this.e.provideMappedEdits(we,V,He,J);return xe?i.WorkspaceEdit.from(xe):null}}class Ie{constructor(q,V){this.adapter=q,this.extension=V}}class Re{static{this.d=0}constructor(q,V,Q,J,fe,we,Te,He){this.g=V,this.h=Q,this.j=J,this.k=fe,this.l=we,this.m=Te,this.n=He,this.f=new Map,this.e=q.getProxy(f.$lM.MainThreadLanguageFeatures)}o(q,V){return i.DocumentSelector.from(q,this.g,V)}p(q){return new r.$nM(()=>{this.f.delete(q),this.e.$unregister(q)})}q(){return Re.d++}async s(q,V,Q,J,fe,we=!1){const Te=this.f.get(q);if(!Te||!(Te.adapter instanceof V))return J;const He=Date.now();we||this.l.trace(`[${Te.extension.identifier.value}] INVOKE provider '${Q.toString().replace(/[\r\n]/g,"")}'`);const xe=Q(Te.adapter,Te.extension);return Promise.resolve(xe).catch(it=>{(0,P.$4)(it)||(this.l.error(`[${Te.extension.identifier.value}] provider FAILED`),this.l.error(it),this.n.onExtensionError(Te.extension.identifier,it))}).finally(()=>{we||this.l.trace(`[${Te.extension.identifier.value}] provider DONE after ${Date.now()-He}ms`)}),M.CancellationToken.isCancellationToken(fe)?(0,L.$0g)(xe,fe):xe}t(q,V){const Q=this.q();return this.f.set(Q,new Ie(q,V)),Q}static u(q){return q.displayName||q.name}registerDocumentSymbolProvider(q,V,Q,J){const fe=this.t(new d(this.h,Q),q),we=J&&J.label||Re.u(q);return this.e.$registerDocumentSymbolProvider(fe,this.o(V,q),we),this.p(fe)}$provideDocumentSymbols(q,V,Q){return this.s(q,d,J=>J.provideDocumentSymbols(p.URI.revive(V),Q),void 0,Q)}registerCodeLensProvider(q,V,Q){const J=this.q(),fe=typeof Q.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(J,new Ie(new l(this.h,this.j.converter,Q,q,this.n,this.l),q)),this.e.$registerCodeLensSupport(J,this.o(V,q),fe);let we=this.p(J);if(fe!==void 0){const Te=Q.onDidChangeCodeLenses(He=>this.e.$emitCodeLensEvent(fe));we=r.$nM.from(we,Te)}return we}$provideCodeLenses(q,V,Q){return this.s(q,l,J=>J.provideCodeLenses(p.URI.revive(V),Q),void 0,Q)}$resolveCodeLens(q,V,Q){return this.s(q,l,J=>J.resolveCodeLens(V,Q),void 0,void 0)}$releaseCodeLenses(q,V){this.s(q,l,Q=>Promise.resolve(Q.releaseCodeLenses(V)),void 0,void 0)}registerDefinitionProvider(q,V,Q){const J=this.t(new h(this.h,Q),q);return this.e.$registerDefinitionSupport(J,this.o(V,q)),this.p(J)}$provideDefinition(q,V,Q,J){return this.s(q,h,fe=>fe.provideDefinition(p.URI.revive(V),Q,J),[],J)}registerDeclarationProvider(q,V,Q){const J=this.t(new g(this.h,Q),q);return this.e.$registerDeclarationSupport(J,this.o(V,q)),this.p(J)}$provideDeclaration(q,V,Q,J){return this.s(q,g,fe=>fe.provideDeclaration(p.URI.revive(V),Q,J),[],J)}registerImplementationProvider(q,V,Q){const J=this.t(new S(this.h,Q),q);return this.e.$registerImplementationSupport(J,this.o(V,q)),this.p(J)}$provideImplementation(q,V,Q,J){return this.s(q,S,fe=>fe.provideImplementation(p.URI.revive(V),Q,J),[],J)}registerTypeDefinitionProvider(q,V,Q){const J=this.t(new w(this.h,Q),q);return this.e.$registerTypeDefinitionSupport(J,this.o(V,q)),this.p(J)}$provideTypeDefinition(q,V,Q,J){return this.s(q,w,fe=>fe.provideTypeDefinition(p.URI.revive(V),Q,J),[],J)}registerHoverProvider(q,V,Q,J){const fe=this.t(new C(this.h,Q),q);return this.e.$registerHoverProvider(fe,this.o(V,q)),this.p(fe)}$provideHover(q,V,Q,J){return this.s(q,C,fe=>fe.provideHover(p.URI.revive(V),Q,J),void 0,J)}registerEvaluatableExpressionProvider(q,V,Q,J){const fe=this.t(new k(this.h,Q),q);return this.e.$registerEvaluatableExpressionProvider(fe,this.o(V,q)),this.p(fe)}$provideEvaluatableExpression(q,V,Q,J){return this.s(q,k,fe=>fe.provideEvaluatableExpression(p.URI.revive(V),Q,J),void 0,J)}registerInlineValuesProvider(q,V,Q,J){const fe=typeof Q.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new D(this.h,Q),q);this.e.$registerInlineValuesProvider(we,this.o(V,q),fe);let Te=this.p(we);if(fe!==void 0){const He=Q.onDidChangeInlineValues(xe=>this.e.$emitInlineValuesEvent(fe));Te=r.$nM.from(Te,He)}return Te}$provideInlineValues(q,V,Q,J,fe){return this.s(q,D,we=>we.provideInlineValues(p.URI.revive(V),Q,J,fe),void 0,fe)}registerDocumentHighlightProvider(q,V,Q){const J=this.t(new O(this.h,Q),q);return this.e.$registerDocumentHighlightProvider(J,this.o(V,q)),this.p(J)}registerMultiDocumentHighlightProvider(q,V,Q){const J=this.t(new F(this.h,Q),q);return this.e.$registerMultiDocumentHighlightProvider(J,this.o(V,q)),this.p(J)}$provideDocumentHighlights(q,V,Q,J){return this.s(q,O,fe=>fe.provideDocumentHighlights(p.URI.revive(V),Q,J),void 0,J)}$provideMultiDocumentHighlights(q,V,Q,J,fe){return this.s(q,F,we=>we.provideMultiDocumentHighlights(p.URI.revive(V),Q,J.map(Te=>p.URI.revive(Te)),fe),void 0,fe)}registerLinkedEditingRangeProvider(q,V,Q){const J=this.t(new T(this.h,Q),q);return this.e.$registerLinkedEditingRangeProvider(J,this.o(V,q)),this.p(J)}$provideLinkedEditingRanges(q,V,Q,J){return this.s(q,T,async fe=>{const we=await fe.provideLinkedEditingRanges(p.URI.revive(V),Q,J);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?Re.w(we.wordPattern):void 0}},void 0,J)}registerReferenceProvider(q,V,Q){const J=this.t(new z(this.h,Q),q);return this.e.$registerReferenceSupport(J,this.o(V,q)),this.p(J)}$provideReferences(q,V,Q,J,fe){return this.s(q,z,we=>we.provideReferences(p.URI.revive(V),Q,J,fe),void 0,fe)}registerCodeActionProvider(q,V,Q,J){const fe=new b.$Tc,we=this.t(new j(this.h,this.j.converter,this.k,Q,this.l,q,this.m),q);return this.e.$registerQuickFixSupport(we,this.o(V,q),{providedKinds:J?.providedCodeActionKinds?.map(Te=>Te.value),documentation:J?.documentation?.map(Te=>({kind:Te.kind.value,command:this.j.converter.toInternal(Te.command,fe)}))},Re.u(q),!!Q.resolveCodeAction),fe.add(this.p(we)),fe}$provideCodeActions(q,V,Q,J,fe){return this.s(q,j,we=>we.provideCodeActions(p.URI.revive(V),Q,J,fe),void 0,fe)}$resolveCodeAction(q,V,Q){return this.s(q,j,J=>J.resolveCodeAction(V,Q),{},void 0)}$releaseCodeActions(q,V){this.s(q,j,Q=>Promise.resolve(Q.releaseCodeActions(V)),void 0,void 0)}registerDocumentFormattingEditProvider(q,V,Q){const J=this.t(new B(this.h,Q),q);return this.e.$registerDocumentFormattingSupport(J,this.o(V,q),q.identifier,q.displayName||q.name),this.p(J)}$provideDocumentFormattingEdits(q,V,Q,J){return this.s(q,B,fe=>fe.provideDocumentFormattingEdits(p.URI.revive(V),Q,J),void 0,J)}registerDocumentRangeFormattingEditProvider(q,V,Q){const J=typeof Q.provideDocumentRangesFormattingEdits=="function",fe=this.t(new W(this.h,Q),q);return this.e.$registerRangeFormattingSupport(fe,this.o(V,q),q.identifier,q.displayName||q.name,J),this.p(fe)}$provideDocumentRangeFormattingEdits(q,V,Q,J,fe){return this.s(q,W,we=>we.provideDocumentRangeFormattingEdits(p.URI.revive(V),Q,J,fe),void 0,fe)}$provideDocumentRangesFormattingEdits(q,V,Q,J,fe){return this.s(q,W,we=>we.provideDocumentRangesFormattingEdits(p.URI.revive(V),Q,J,fe),void 0,fe)}registerOnTypeFormattingEditProvider(q,V,Q,J){const fe=this.t(new Z(this.h,Q),q);return this.e.$registerOnTypeFormattingSupport(fe,this.o(V,q),J,q.identifier),this.p(fe)}$provideOnTypeFormattingEdits(q,V,Q,J,fe,we){return this.s(q,Z,Te=>Te.provideOnTypeFormattingEdits(p.URI.revive(V),Q,J,fe,we),void 0,we)}registerWorkspaceSymbolProvider(q,V){const Q=this.t(new _(V,this.l),q);return this.e.$registerNavigateTypeSupport(Q,typeof V.resolveWorkspaceSymbol=="function"),this.p(Q)}$provideWorkspaceSymbols(q,V,Q){return this.s(q,_,J=>J.provideWorkspaceSymbols(V,Q),{symbols:[]},Q)}$resolveWorkspaceSymbol(q,V,Q){return this.s(q,_,J=>J.resolveWorkspaceSymbol(V,Q),void 0,void 0)}$releaseWorkspaceSymbols(q,V){this.s(q,_,Q=>Q.releaseWorkspaceSymbols(V),void 0,void 0)}registerRenameProvider(q,V,Q){const J=this.t(new X(this.h,Q,this.l),q);return this.e.$registerRenameSupport(J,this.o(V,q),X.supportsResolving(Q)),this.p(J)}$provideRenameEdits(q,V,Q,J,fe){return this.s(q,X,we=>we.provideRenameEdits(p.URI.revive(V),Q,J,fe),void 0,fe)}$resolveRenameLocation(q,V,Q,J){return this.s(q,X,fe=>fe.resolveRenameLocation(p.URI.revive(V),Q,J),void 0,J)}registerNewSymbolNamesProvider(q,V,Q){const J=this.t(new x(this.h,Q,this.l),q);return this.e.$registerNewSymbolNamesProvider(J,this.o(V,q)),this.p(J)}$provideNewSymbolNames(q,V,Q,J){return this.s(q,x,fe=>fe.provideNewSymbolNames(p.URI.revive(V),Q,J),void 0,J)}registerDocumentSemanticTokensProvider(q,V,Q,J){const fe=this.t(new Y(this.h,Q),q),we=typeof Q.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(fe,this.o(V,q),J,we);let Te=this.p(fe);if(we){const He=Q.onDidChangeSemanticTokens(xe=>this.e.$emitDocumentSemanticTokensEvent(we));Te=r.$nM.from(Te,He)}return Te}$provideDocumentSemanticTokens(q,V,Q,J){return this.s(q,Y,fe=>fe.provideDocumentSemanticTokens(p.URI.revive(V),Q,J),null,J)}$releaseDocumentSemanticTokens(q,V){this.s(q,Y,Q=>Q.releaseDocumentSemanticColoring(V),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(q,V,Q,J){const fe=this.t(new me(this.h,Q),q);return this.e.$registerDocumentRangeSemanticTokensProvider(fe,this.o(V,q),J),this.p(fe)}$provideDocumentRangeSemanticTokens(q,V,Q,J){return this.s(q,me,fe=>fe.provideDocumentRangeSemanticTokens(p.URI.revive(V),Q,J),null,J)}registerCompletionItemProvider(q,V,Q,J){const fe=this.t(new Ce(this.h,this.j.converter,Q,this.m,q),q);return this.e.$registerCompletionsProvider(fe,this.o(V,q),J,Ce.supportsResolving(Q),q.identifier),this.p(fe)}$provideCompletionItems(q,V,Q,J,fe){return this.s(q,Ce,we=>we.provideCompletionItems(p.URI.revive(V),Q,J,fe),void 0,fe)}$resolveCompletionItem(q,V,Q){return this.s(q,Ce,J=>J.resolveCompletionItem(V,Q),void 0,Q)}$releaseCompletionItems(q,V){this.s(q,Ce,Q=>Q.releaseCompletionItems(V),void 0,void 0)}registerInlineCompletionsProvider(q,V,Q,J){const fe=new U(q,this.h,Q,this.j.converter),we=this.t(fe,q);return this.e.$registerInlineCompletionsSupport(we,this.o(V,q),fe.supportsHandleEvents,n.$Dm.toKey(q.identifier.value),J?.yieldTo?.map(Te=>n.$Dm.toKey(Te))||[]),this.p(we)}$provideInlineCompletions(q,V,Q,J,fe){return this.s(q,ee,we=>we.provideInlineCompletions(p.URI.revive(V),Q,J,fe),void 0,fe)}$handleInlineCompletionDidShow(q,V,Q,J){this.s(q,ee,async fe=>{fe.handleDidShowCompletionItem(V,Q,J)},void 0,void 0)}$handleInlineCompletionPartialAccept(q,V,Q,J,fe){this.s(q,ee,async we=>{we.handlePartialAccept(V,Q,J,fe)},void 0,void 0)}$freeInlineCompletionsList(q,V){this.s(q,ee,async Q=>{Q.disposeCompletions(V)},void 0,void 0)}registerInlineEditProvider(q,V,Q){const J=new ie(q,this.h,Q,this.j.converter),fe=this.t(J,q);return this.e.$registerInlineEditProvider(fe,this.o(V,q),q.identifier),this.p(fe)}$provideInlineEdit(q,V,Q,J){return this.s(q,ie,fe=>fe.provideInlineEdits(p.URI.revive(V),Q,J),void 0,J)}$freeInlineEdit(q,V){this.s(q,ie,async Q=>{Q.disposeEdit(V)},void 0,void 0)}registerSignatureHelpProvider(q,V,Q,J){const fe=Array.isArray(J)?{triggerCharacters:J,retriggerCharacters:[]}:J,we=this.t(new Se(this.h,Q),q);return this.e.$registerSignatureHelpProvider(we,this.o(V,q),fe),this.p(we)}$provideSignatureHelp(q,V,Q,J,fe){return this.s(q,Se,we=>we.provideSignatureHelp(p.URI.revive(V),Q,J,fe),void 0,fe)}$releaseSignatureHelp(q,V){this.s(q,Se,Q=>Q.releaseSignatureHelp(V),void 0,void 0)}registerInlayHintsProvider(q,V,Q){const J=typeof Q.onDidChangeInlayHints=="function"?this.q():void 0,fe=this.t(new ae(this.h,this.j.converter,Q,this.l,q),q);this.e.$registerInlayHintsProvider(fe,this.o(V,q),typeof Q.resolveInlayHint=="function",J,Re.u(q));let we=this.p(fe);if(J!==void 0){const Te=Q.onDidChangeInlayHints(He=>this.e.$emitInlayHintsEvent(J));we=r.$nM.from(we,Te)}return we}$provideInlayHints(q,V,Q,J){return this.s(q,ae,fe=>fe.provideInlayHints(p.URI.revive(V),Q,J),void 0,J)}$resolveInlayHint(q,V,Q){return this.s(q,ae,J=>J.resolveInlayHint(V,Q),void 0,Q)}$releaseInlayHints(q,V){this.s(q,ae,Q=>Q.releaseHints(V),void 0,void 0)}registerDocumentLinkProvider(q,V,Q){const J=this.t(new ce(this.h,Q),q);return this.e.$registerDocumentLinkProvider(J,this.o(V,q),typeof Q.resolveDocumentLink=="function"),this.p(J)}$provideDocumentLinks(q,V,Q){return this.s(q,ce,J=>J.provideLinks(p.URI.revive(V),Q),void 0,Q,V.scheme==="output")}$resolveDocumentLink(q,V,Q){return this.s(q,ce,J=>J.resolveLink(V,Q),void 0,void 0,!0)}$releaseDocumentLinks(q,V){this.s(q,ce,Q=>Q.releaseLinks(V),void 0,void 0,!0)}registerColorProvider(q,V,Q){const J=this.t(new se(this.h,Q),q);return this.e.$registerDocumentColorProvider(J,this.o(V,q)),this.p(J)}$provideDocumentColors(q,V,Q){return this.s(q,se,J=>J.provideColors(p.URI.revive(V),Q),[],Q)}$provideColorPresentations(q,V,Q,J){return this.s(q,se,fe=>fe.provideColorPresentations(p.URI.revive(V),Q,J),void 0,J)}registerFoldingRangeProvider(q,V,Q){const J=this.q(),fe=typeof Q.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(J,new Ie(new K(this.h,Q),q)),this.e.$registerFoldingRangeProvider(J,this.o(V,q),q.identifier,fe);let we=this.p(J);if(fe!==void 0){const Te=Q.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(fe));we=r.$nM.from(we,Te)}return we}$provideFoldingRanges(q,V,Q,J){return this.s(q,K,fe=>fe.provideFoldingRanges(p.URI.revive(V),Q,J),void 0,J)}registerSelectionRangeProvider(q,V,Q){const J=this.t(new te(this.h,Q,this.l),q);return this.e.$registerSelectionRangeProvider(J,this.o(V,q)),this.p(J)}$provideSelectionRanges(q,V,Q,J){return this.s(q,te,fe=>fe.provideSelectionRanges(p.URI.revive(V),Q,J),[],J)}registerCallHierarchyProvider(q,V,Q){const J=this.t(new le(this.h,Q),q);return this.e.$registerCallHierarchyProvider(J,this.o(V,q)),this.p(J)}$prepareCallHierarchy(q,V,Q,J){return this.s(q,le,fe=>Promise.resolve(fe.prepareSession(p.URI.revive(V),Q,J)),void 0,J)}$provideCallHierarchyIncomingCalls(q,V,Q,J){return this.s(q,le,fe=>fe.provideCallsTo(V,Q,J),void 0,J)}$provideCallHierarchyOutgoingCalls(q,V,Q,J){return this.s(q,le,fe=>fe.provideCallsFrom(V,Q,J),void 0,J)}$releaseCallHierarchy(q,V){this.s(q,le,Q=>Promise.resolve(Q.releaseSession(V)),void 0,void 0)}registerTypeHierarchyProvider(q,V,Q){const J=this.t(new de(this.h,Q),q);return this.e.$registerTypeHierarchyProvider(J,this.o(V,q)),this.p(J)}$prepareTypeHierarchy(q,V,Q,J){return this.s(q,de,fe=>Promise.resolve(fe.prepareSession(p.URI.revive(V),Q,J)),void 0,J)}$provideTypeHierarchySupertypes(q,V,Q,J){return this.s(q,de,fe=>fe.provideSupertypes(V,Q,J),void 0,J)}$provideTypeHierarchySubtypes(q,V,Q,J){return this.s(q,de,fe=>fe.provideSubtypes(V,Q,J),void 0,J)}$releaseTypeHierarchy(q,V){this.s(q,de,Q=>Promise.resolve(Q.releaseSession(V)),void 0,void 0)}registerDocumentOnDropEditProvider(q,V,Q,J){const fe=this.q();return this.f.set(fe,new Ie(new Ae(this.e,this.h,Q,fe,q),q)),this.e.$registerDocumentOnDropEditProvider(fe,this.o(V,q),(0,s.$9F)(q,"dropMetadata")?J:void 0),this.p(fe)}$provideDocumentOnDropEdits(q,V,Q,J,fe,we){return this.s(q,Ae,Te=>Promise.resolve(Te.provideDocumentOnDropEdits(V,p.URI.revive(Q),J,fe,we)),void 0,void 0)}registerMappedEditsProvider(q,V,Q){const J=this.t(new $e(this.h,Q),q);return this.e.$registerMappedEditsProvider(J,this.o(V,q)),this.p(J)}$provideMappedEdits(q,V,Q,J,fe){return this.s(q,$e,we=>Promise.resolve(we.provideMappedEdits(V,Q,J,fe)),null,fe)}registerDocumentPasteEditProvider(q,V,Q,J){const fe=this.q();return this.f.set(fe,new Ie(new N(this.e,this.h,Q,fe,q),q)),this.e.$registerPasteEditProvider(fe,this.o(V,q),{supportsCopy:!!Q.prepareDocumentPaste,supportsPaste:!!Q.provideDocumentPasteEdits,supportsResolve:!!Q.resolveDocumentPasteEdit,providedPasteEditKinds:J.providedPasteEditKinds?.map(we=>we.value),copyMimeTypes:J.copyMimeTypes,pasteMimeTypes:J.pasteMimeTypes}),this.p(fe)}$prepareDocumentPaste(q,V,Q,J,fe){return this.s(q,N,we=>we.prepareDocumentPaste(p.URI.revive(V),Q,J,fe),void 0,fe)}$providePasteEdits(q,V,Q,J,fe,we,Te){return this.s(q,N,He=>He.providePasteEdits(V,p.URI.revive(Q),J,fe,we,Te),void 0,Te)}$resolvePasteEdit(q,V,Q){return this.s(q,N,J=>J.resolvePasteEdit(V,Q),{},void 0)}$releasePasteEdits(q,V){this.s(q,N,Q=>Promise.resolve(Q.releasePasteEdits(V)),void 0,void 0)}static w(q){return{pattern:q.source,flags:q.flags}}static y(q){return{decreaseIndentPattern:Re.w(q.decreaseIndentPattern),increaseIndentPattern:Re.w(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?Re.w(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?Re.w(q.unIndentedLinePattern):void 0}}static z(q){return{beforeText:Re.w(q.beforeText),afterText:q.afterText?Re.w(q.afterText):void 0,previousLineText:q.previousLineText?Re.w(q.previousLineText):void 0,action:q.action}}static B(q){return q.map(Re.z)}static C(q){return{open:q.open,close:q.close,notIn:q.notIn?q.notIn.map(V=>r.SyntaxTokenType.toString(V)):void 0}}static D(q){return q.map(Re.C)}setLanguageConfiguration(q,V,Q){const{wordPattern:J}=Q;if(J&&(0,A.$0e)(J))throw new Error(`Invalid language configuration: wordPattern '${J}' is not allowed to match the empty string.`);J?this.h.setWordDefinitionFor(V,J):this.h.setWordDefinitionFor(V,void 0),Q.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),Q.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const fe=this.q(),we={comments:Q.comments,brackets:Q.brackets,wordPattern:Q.wordPattern?Re.w(Q.wordPattern):void 0,indentationRules:Q.indentationRules?Re.y(Q.indentationRules):void 0,onEnterRules:Q.onEnterRules?Re.B(Q.onEnterRules):void 0,__electricCharacterSupport:Q.__electricCharacterSupport,__characterPairSupport:Q.__characterPairSupport,autoClosingPairs:Q.autoClosingPairs?Re.D(Q.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(fe,V,we),this.p(fe)}$setWordDefinitions(q){for(const V of q)this.h.setWordDefinitionFor(V.languageId,new RegExp(V.regexSource,V.regexFlags))}}e.$$ic=Re}),define(ke[121],Ee([1,0,3,6,16,7,108,25,8,4,221,145,13,5,20,120,12]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v,a,m){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$gjc=e.$fjc=void 0,e.$fjc=(0,E.$ii)("IExtHostLanguageModels");class n{constructor(t,f){this.option=t,this.stream=new $.$Lh,this.stream=f??new $.$Lh}}class i{constructor(){this.a=new Map,this.b=new $.$Lh,this.c=!1,this.d=!1;const t=this;this.apiObject={stream:t.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,t]of this.a)yield t.stream;else yield this.b}handleFragment(t){if(this.c)return;this.d=!0;let f=this.a.get(t.index);f||(this.a.size===0?f=new n(t.index,this.b):f=new n(t.index),this.a.set(t.index,f)),f.stream.emitOne(t.part)}get isStreaming(){return this.d}reject(t){this.c=!0;for(const f of this.f())f.reject(t)}resolve(){this.c=!0;for(const t of this.f())t.resolve()}}let r=class{static{o=this}static{this.a=1}constructor(t,f,d){this.j=f,this.k=d,this.c=new y.$7d,this.d=new y.$7d,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new b.$Fm,this.i=new Map,this.o=new Set,this.b=t.getProxy(L.$lM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(t,f,d,l){const c=o.a++;this.f.set(c,{extension:t.identifier,provider:d,languageModelId:f});let h;return l.auth&&(h={providerLabel:t.displayName||t.name,accountLabel:typeof l.auth=="object"?l.auth.label:void 0}),this.b.$registerLanguageModelProvider(c,f,{extension:t.identifier,identifier:f,model:l.name??"",auth:h}),(0,u.$Sc)(()=>{this.f.delete(c),this.b.$unregisterProvider(c)})}async $provideLanguageModelResponse(t,f,d,l,c,h){const g=this.f.get(t);if(!g)return;const S=new R.$Rv(async w=>{if(h.isCancellationRequested){this.j.warn(`[CHAT](${g.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(f,{index:w.index,part:w.part})});return g.provider.provideLanguageModelResponse2(l.map(M.LanguageModelMessage.to),c,b.$Dm.toKey(d),S,h)}$updateLanguageModels(t){const f=[],d=[];if(t.added)for(const l of t.added)this.g.set(l.identifier,l),f.push(l.model);if(t.removed)for(const l of t.removed){this.g.delete(l),d.push(l);for(const[c,h]of this.i)h.languageModelId===l&&(h.res.reject(new p.$5),this.i.delete(c))}this.d.fire(Object.freeze({added:Object.freeze(f),removed:Object.freeze(d)})),t.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(t){const f=new Array;for(const{from:d,to:l,enabled:c}of t){const h=this.h.get(d)??new b.$Em;if(h.has(l)!==c){c?h.add(l):h.delete(l),this.h.set(d,h);const S={from:d,to:l};f.push(S),this.c.fire(S)}}}async sendChatRequest(t,f,d,l,c){const h=t.identifier,g=await this.b.$prepareChatAccess(h,f,l.justification);if(!g||!this.g.has(f))throw P.$tO.NotFound(`Language model '${f}' is unknown.`);if(this.m(h,g)&&(!await this.l(t,{identifier:g.extension,displayName:g.auth.providerLabel},l.justification,l.silent)||!this.h.get(h)?.has(g.extension)))throw P.$tO.NoPermissions(`Language model '${f}' cannot be used by '${h.value}'.`);const S=Math.random()*1e6|0,w=this.b.$fetchResponse(h,f,S,d.map(M.LanguageModelMessage.from),l.modelOptions??{},c),C=new $.$hh,k=new i;this.i.set(S,{languageModelId:f,res:k});let D;if(w.catch(O=>{C.isOpen()?k.reject(O):D=O}).finally(()=>{this.i.delete(S),k.resolve(),C.open()}),await C.wait(),D)throw new P.$tO(`Language model '${f}' errored, check cause for more details`,"Unknown",D);return k.apiObject}async $handleResponseFragment(t,f){const d=this.i.get(t);d&&d.res.handleFragment(f)}async l(t,f,d,l){const c=I.$nL+f.identifier.value;if(await this.k.getSession(t,c,[],{silent:!0}))return this.$updateModelAccesslist([{from:t.identifier,to:f.identifier,enabled:!0}]),!0;if(l)return!1;try{const g=d?(0,A.localize)(0,null,f.displayName,d):(0,A.localize)(1,null,f.displayName);return await this.k.getSession(t,c,[],{forceNewSession:{detail:g}}),this.$updateModelAccesslist([{from:t.identifier,to:f.identifier,enabled:!0}]),!0}catch{return!1}}m(t,f){return!!f.auth&&!b.$Dm.equals(f.extension,t)}async n(t){for(const f of this.o)try{await this.l(f,{identifier:t.extension,displayName:""},void 0,!0)}catch(d){this.j.error("Fake Auth request failed"),this.j.error(d)}}createLanguageModelAccessInformation(t){this.o.add(t);const f=this,d=y.Event.signal(y.Event.filter(this.c.event,c=>b.$Dm.equals(c.from,t.identifier))),l=y.Event.signal(this.d.event);return{get onDidChange(){return y.Event.any(d,l)},canSendRequest(c){const h=f.g.get(c);if(!h)return;if(!f.m(t.identifier,h))return!0;const g=f.h.get(t.identifier);if(g)return g.has(h.extension)}}}};e.$gjc=r,e.$gjc=r=o=Je([qe(0,v.$GO),qe(1,m.$Oj),qe(2,a.$ajc)],r)}),define(ke[339],Ee([1,0,6,16,7,40,8,3,26]),function(he,e,u,L,M,P,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zkc=void 0;class y{constructor(I,p,E,v){this.c=p,this.d=E,this.e=v,this.b=[],this.f=0,this.g=new Set,this.a=I.getProxy(u.$lM.MainThreadLanguages)}$acceptLanguageIds(I){this.b=I}async getLanguages(){return this.b.slice(0)}async changeLanguage(I,p){await this.a.$changeLanguage(I,p);const E=this.c.getDocumentData(I);if(!E)throw new Error(`document '${I.toString()}' NOT found`);return E.document}async tokenAtPosition(I,p){const E=I.version,v=L.Position.from(p),a=await this.a.$tokensAtPosition(I.uri,v),m={type:M.StandardTokenType.Other,range:I.getWordRangeAtPosition(p)??new M.$pM(p.line,p.character,p.line,p.character)};if(!a)return m;const o={range:L.Range.to(a.range),type:L.TokenType.to(a.type)};return!o.range.contains(p)||E!==I.version?m:o}createLanguageStatusItem(I,p,E){const v=this.f++,a=this.a,m=this.g,o=`${I.identifier.value}/${p}`;if(m.has(o))throw new Error(`LanguageStatusItem with id '${p}' ALREADY exists`);m.add(o);const n={selector:E,id:p,name:I.displayName??I.name,severity:M.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const r=new b.$Tc,s=()=>{if(i?.dispose(),!m.has(o)){console.warn(`LanguageStatusItem (${p}) from ${I.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,R.$kh)(()=>{r.clear(),this.a.$setLanguageStatus(v,{id:o,name:n.name??I.displayName??I.name,source:I.displayName??I.name,selector:L.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===M.LanguageStatusSeverity.Error?P.default.Error:n.severity===M.LanguageStatusSeverity.Warning?P.default.Warning:P.default.Info,command:n.command&&this.d.toInternal(n.command,r),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},t={dispose(){r.dispose(),i?.dispose(),a.$removeLanguageStatus(v),m.delete(o)},get id(){return n.id},get name(){return n.name},set name(f){n.name=f,s()},get selector(){return n.selector},set selector(f){n.selector=f,s()},get text(){return n.text},set text(f){n.text=f,s()},set text2(f){(0,$.$0F)(I,"languageStatusText"),n.text=f,s()},get text2(){return(0,$.$0F)(I,"languageStatusText"),n.text},get detail(){return n.detail},set detail(f){n.detail=f,s()},get severity(){return n.severity},set severity(f){n.severity=f,s()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(f){n.accessibilityInformation=f,s()},get command(){return n.command},set command(f){n.command=f,s()},get busy(){return n.busy},set busy(f){n.busy=f,s()}};return s(),t}}e.$zkc=y}),define(ke[340],Ee([1,0,15,2,16,7,119]),function(he,e,u,L,M,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lkc=e.$kkc=void 0;class b{constructor(I,p,E,v){this.start=I,this.deletedCount=p,this.deletedItems=E,this.items=v}asApiEvent(){return{range:new P.$ON(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(I){return{EOL:I.eol,lines:I.source,languageId:I.language,uri:I.uri,isDirty:!1,versionId:1}}constructor(I,p,E){this.notebook=I,this.h=p,this.j=E,this.handle=E.handle,this.uri=L.URI.revive(E.uri),this.cellKind=E.cellKind,this.a=E.outputs.map(M.NotebookCellOutput.to),this.e=E.internalMetadata??{},this.b=Object.freeze(E.metadata??{}),this.d=Object.freeze(M.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const I=this,p=this.h.getDocument(this.uri);if(!p)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:M.NotebookCellKind.to(this.j.cellKind),document:p.document,get mime(){return I.g},set mime(v){I.g=v},get outputs(){return I.a.slice(0)},get metadata(){return I.b},get executionSummary(){return I.d}};this.f=Object.freeze(E)}return this.f}setOutputs(I){this.a=I.map(M.NotebookCellOutput.to)}setOutputItems(I,p,E){const v=E.map(M.NotebookCellOutputItem.to),a=this.a.find(m=>m.id===I);if(a&&(p||(a.items.length=0),a.items.push(...v),a.items.length>1&&a.items.every(m=>R.$iK(m.mime)))){const m=new Map,o=[];a.items.forEach(n=>{let i;m.has(n.mime)?i=m.get(n.mime):(i=[],m.set(n.mime,i),o.push(n.mime)),i.push(n.data)}),a.items.length=0,o.forEach(n=>{const i=R.$jK(m.get(n));a.items.push({mime:n,data:i.data.buffer})})}}setMetadata(I){this.b=Object.freeze(I)}setInternalMetadata(I){this.e=I,this.d=Object.freeze(M.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.$kkc=$;class y{static{this.a=0}constructor(I,p,E,v,a){this.k=I,this.l=p,this.m=E,this.uri=v,this.handle=y.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=a.viewType,this.f=Object.freeze(a.metadata??Object.create(null)),this.r([[0,0,a.cells]],!0,void 0),this.g=a.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const I=this,p={get uri(){return I.uri},get version(){return I.g},get notebookType(){return I.d},get isDirty(){return I.h},get isUntitled(){return I.uri.scheme===u.Schemas.untitled},get isClosed(){return I.j},get metadata(){return I.f},get cellCount(){return I.b.length},cellAt(E){return E=I.n(E),I.b[E].apiCell},getCells(E){return(E?I.p(E):I.b).map(a=>a.apiCell)},save(){return I.q()}};this.e=Object.freeze(p)}return this.e}acceptDocumentPropertiesChanged(I){I.metadata&&(this.f=Object.freeze({...this.f,...I.metadata}))}acceptDirty(I){this.h=I}acceptModelChanged(I,p,E){this.g=I.versionId,this.h=p,this.acceptDocumentPropertiesChanged({metadata:E});const v={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},a=[];for(const o of I.rawEvents)o.kind===R.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,v.contentChanges):o.kind===R.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,v.contentChanges):o.kind===R.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),a.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===R.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),a.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),a.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===R.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),a.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),a.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const m=new Map;for(let o=0;o<a.length;o++){const n=a[o],i=m.get(n.cell);if(i===void 0){const r=v.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});m.set(n.cell,r-1)}else v.cellChanges[i]={...v.cellChanges[i],...n}}return Object.freeze(v),Object.freeze(v.cellChanges),Object.freeze(v.contentChanges),v}n(I){return I=I|0,I<0?0:I>=this.b.length?this.b.length-1:I}o(I){let p=I.start|0,E=I.end|0;return p<0&&(p=0),E>this.b.length&&(E=this.b.length),I.with({start:p,end:E})}p(I){I=this.o(I);const p=[];for(let E=I.start;E<I.end;E++)p.push(this.b[E]);return p}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(I,p,E){if(this.j)return;const v=[],a=[],m=[];if(I.reverse().forEach(o=>{const i=o[2].map(t=>{const f=new $(this,this.l,t);return p||a.push($.asModelAddData(t)),f}),r=new b(o[0],o[1],[],i),s=this.b.splice(o[0],o[1],...i);for(const t of s)m.push(t.uri),r.deletedItems.push(t.apiCell);v.push(r)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:m}),E)for(const o of v)E.push(o.asApiEvent())}s(I,p,E,v){const a=this.b.splice(I,p);this.b.splice(E,0,...a);const m=[new b(I,p,a.map(o=>o.apiCell),[]),new b(E,0,[],a)];for(const o of m)v.push(o.asApiEvent())}t(I,p){this.b[I].setOutputs(p)}u(I,p,E,v){this.b[I].setOutputItems(p,E,v)}v(I,p){const E=this.b[I];E.apiCell.document.languageId!==p&&this.m.$acceptModelLanguageChanged(E.uri,p)}w(I,p){const E=this.b[I];E.apiCell.mime=p}x(I,p){this.b[I].setMetadata(p)}y(I,p){this.b[I].setInternalMetadata(p)}getCellFromApiCell(I){return this.b.find(p=>p.apiCell===I)}getCellFromIndex(I){return this.b[I]}getCell(I){return this.b.find(p=>p.handle===I)}getCellIndex(I){return this.b.indexOf(I)}}e.$lkc=y}),define(ke[341],Ee([1,0,4,2,16,7]),function(he,e,u,L,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bkc=void 0;class R{constructor($,y,A,I={timeout:1500,errors:3}){this.b=$,this.c=y,this.d=A,this.f=I,this.a=new u.$9d}dispose(){}getOnWillSaveNotebookDocumentEvent($){return(y,A,I)=>{const p=function(v){y.call(A,v)};return p.extension=$,this.a.event(p,void 0,I)}}async $participateInSave($,y,A){const I=L.URI.revive($),p=this.c.getNotebookDocument(I);if(!p)throw new Error("Unable to resolve notebook document");const E=[];if(await this.a.fireAsync({notebook:p.apiNotebook,reason:M.TextDocumentSaveReason.to(y)},A,async(a,m)=>{const o=Date.now(),n=await await Promise.resolve(a);Date.now()-o>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",m.extension.identifier),!A.isCancellationRequested&&n&&(n instanceof P.$xM?E.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",m.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(E.length===0)return!0;const v={edits:[]};for(const a of E){const{edits:m}=M.WorkspaceEdit.from(a);v.edits=v.edits.concat(m)}return this.d.$tryApplyWorkspaceEdit(v)}}e.$Bkc=R}),define(ke[153],Ee([1,0,13,16,7]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mkc=void 0;class P{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,$,y,A,I,p){this.id=b,this.f=$,this.notebookData=y,this.a=[],this.b=[],this.d=!1,this.a=I,this.b=A,this.c=p}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection($){this.selections=[$]},get selections(){return b.a},set selections($){if(!Array.isArray($)||!$.every(M.$ON.isNotebookRange))throw(0,u.$7)("selections");b.a=$,b.g($)},get visibleRanges(){return b.b},revealRange($,y){b.f.$tryRevealRange(b.id,L.NotebookRange.from($),y??M.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},P.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(L.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$mkc=P}),define(ke[342],Ee([1,0,4,12,16]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dkc=void 0;let P=class{constructor(b,$){this.c=b,this.d=$,this.a=new u.$7d,this.b=new u.$7d,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(b,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,$);const y=this.d.getEditorById(b);$.visibleRanges&&y._acceptVisibleRanges($.visibleRanges.ranges.map(M.NotebookRange.to)),$.selections&&y._acceptSelections($.selections.selections.map(M.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:y.apiEditor,visibleRanges:y.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:y.apiEditor,selections:y.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const $ in b)this.d.getEditorById($)._acceptViewColumn(M.ViewColumn.to(b[$]))}};e.$Dkc=P,e.$Dkc=P=Je([qe(0,L.$Oj)],P)}),define(ke[343],Ee([1,0,4,6,153]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gkc=void 0;class P{constructor(b,$){this.c=$,this.a=new Map,this.b=b.getProxy(L.$lM.MainThreadNotebookRenderers)}$postRendererMessage(b,$,y){const A=this.c.getEditorById(b);this.a.get($)?.fire({editor:A.apiEditor,message:y})}createRendererMessaging(b,$){if(!b.contributes?.notebookRenderer?.some(A=>A.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(A,I,p)=>this.d($).event(A,I,p),postMessage:(A,I)=>{M.$mkc.apiEditorsToExtHost.has(A)&&([A,I]=[I,A]);const p=I&&M.$mkc.apiEditorsToExtHost.get(I);return this.b.$postMessage(p?.id,$,A)}}}d(b){let $=this.a.get(b);return $||($=new u.$7d({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(b)}}),this.a.set(b,$),$)}}e.$Gkc=P}),define(ke[344],Ee([1,0,16,108,22,54,13]),function(he,e,u,L,M,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kkc=void 0;class b{constructor(I){this.b=0,this.c=new Map,this.a=I}async withProgress(I,p,E){const v=this.b++,{title:a,location:m,cancellable:o}=p,n={label:I.displayName||I.name,id:I.identifier.value};return this.a.$startProgress(v,{location:u.ProgressLocation.from(m),title:a,source:n,cancellable:o},I.isUnderDevelopment?void 0:I.identifier.value).catch(R.$2),this.d(v,E,!!o)}d(I,p,E){let v;E&&(v=new M.$ee,this.c.set(I,v));const a=o=>{this.a.$progressEnd(o),this.c.delete(o),v?.dispose()};let m;try{m=p(new y(this.a,I),E&&v?v.token:M.CancellationToken.None)}catch(o){throw a(I),o}return m.then(o=>a(I),o=>a(I)),m}$acceptProgressCanceled(I){const p=this.c.get(I);p&&(p.cancel(),this.c.delete(I))}}e.$Kkc=b;function $(A,I){return A.message=I.message,typeof I.increment=="number"&&(typeof A.increment=="number"?A.increment+=I.increment:A.increment=I.increment),A}class y extends L.$Rv{constructor(I,p){super(E=>this.throttledReport(E)),this.c=I,this.d=p}throttledReport(I){this.c.$progressReport(this.d,I)}}Je([(0,P.$Oh)(100,(A,I)=>$(A,I),()=>Object.create(null))],y.prototype,"throttledReport",null)}),define(ke[345],Ee([1,0,2,6,8,16]),function(he,e,u,L,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lkc=void 0;class R{static{this.a=0}constructor($,y){this.d=y,this.c=new Map,this.b=$.getProxy(L.$lM.MainThreadQuickDiff)}$provideOriginalResource($,y,A){const I=u.URI.revive(y),p=this.c.get($);return p?(0,M.$ah)(()=>p.provideOriginalResource(I,A)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider($,y,A,I){const p=R.a++;return this.c.set(p,y),this.b.$registerQuickDiffProvider(p,P.DocumentSelector.from($,this.d),A,I),{dispose:()=>{this.b.$unregisterQuickDiffProvider(p),this.c.delete(p)}}}}e.$Lkc=R}),define(ke[346],Ee([1,0,22,4,3,6,2,7,13,19,40,56,26,16]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mkc=v;function v(a,m,o){const n=a.getProxy(P.$lM.MainThreadQuickOpen);class i{constructor(g,S){this.e=new Map,this.f=0,this.a=g,this.b=S}showQuickPick(g,S,w,C=u.CancellationToken.None){this.c=void 0;const k=Promise.resolve(S),D=++this.f,O=n.$show(D,{title:w?.title,placeHolder:w?.placeHolder,matchOnDescription:w?.matchOnDescription,matchOnDetail:w?.matchOnDetail,ignoreFocusLost:w?.ignoreFocusOut,canPickMany:w?.canPickMany},C),F={},T=O.then(()=>F);return Promise.race([T,k]).then(z=>{if(z===F)return;const j=(0,p.$9F)(g,"quickPickItemTooltip");return k.then(N=>{const B=[];for(let W=0;W<N.length;W++){const Z=N[W];if(typeof Z=="string")B.push({label:Z,handle:W});else if(Z.kind===b.QuickPickItemKind.Separator)B.push({type:"separator",label:Z.label});else{Z.tooltip&&!j&&console.warn(`Extension '${g.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${g.identifier.value}`);const _=Z.iconPath?d(Z.iconPath):void 0;B.push({label:Z.label,iconPath:_?.iconPath,iconClass:_?.iconClass,description:Z.description,detail:Z.detail,picked:Z.picked,alwaysShow:Z.alwaysShow,tooltip:j?E.MarkdownString.fromStrict(Z.tooltip):void 0,handle:W})}}return w&&typeof w.onDidSelectItem=="function"&&(this.c=W=>{w.onDidSelectItem(N[W])}),n.$setItems(D,B),O.then(W=>{if(typeof W=="number")return N[W];if(Array.isArray(W))return W.map(Z=>N[Z])})})}).then(void 0,z=>{if(!(0,$.$4)(z))return n.$setError(D,z),Promise.reject(z)})}$onItemSelected(g){this.c?.(g)}showInput(g,S=u.CancellationToken.None){return this.d=g?.validateInput,n.$input(g,typeof this.d=="function",S).then(void 0,w=>{if(!(0,$.$4)(w))return Promise.reject(w)})}async $validateInput(g){if(!this.d)return;const S=await this.d(g);if(!S||typeof S=="string")return S;let w;switch(S.severity){case b.InputBoxValidationSeverity.Info:w=A.default.Info;break;case b.InputBoxValidationSeverity.Warning:w=A.default.Warning;break;case b.InputBoxValidationSeverity.Error:w=A.default.Error;break;default:w=S.message?A.default.Error:A.default.Ignore;break}return{content:S.message,severity:w}}async showWorkspaceFolderPick(g,S=u.CancellationToken.None){const w=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[g]);if(!w)return;const C=await this.a.getWorkspaceFolders2();if(C)return C.find(k=>k.uri.toString()===w.uri.toString())}createQuickPick(g){const S=new l(g,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}createInputBox(g){const S=new c(g,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}$onDidChangeValue(g,S){this.e.get(g)?._fireDidChangeValue(S)}$onDidAccept(g){this.e.get(g)?._fireDidAccept()}$onDidChangeActive(g,S){const w=this.e.get(g);w instanceof l&&w._fireDidChangeActive(S)}$onDidChangeSelection(g,S){const w=this.e.get(g);w instanceof l&&w._fireDidChangeSelection(S)}$onDidTriggerButton(g,S){this.e.get(g)?._fireDidTriggerButton(S)}$onDidTriggerItemButton(g,S,w){const C=this.e.get(g);C instanceof l&&C._fireDidTriggerItemButton(S,w)}$onDidHide(g){this.e.get(g)?._fireDidHide()}}class r{static{this.a=1}constructor(g,S){this.x=g,this.y=S,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new L.$7d,this.q=new L.$7d,this.r=new L.$7d,this.s=new L.$7d,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(g){this.b=g,this.z({title:g})}get step(){return this.c}set step(g){this.c=g,this.z({step:g})}get totalSteps(){return this.d}set totalSteps(g){this.d=g,this.z({totalSteps:g})}get enabled(){return this.g}set enabled(g){this.g=g,this.z({enabled:g})}get busy(){return this.j}set busy(g){this.j=g,this.z({busy:g})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(g){this.k=g,this.z({ignoreFocusOut:g})}get value(){return this.l}set value(g){this.l=g,this.z({value:g})}get placeholder(){return this.m}set placeholder(g){this.m=g,this.z({placeholder:g})}get buttons(){return this.n}set buttons(g){this.n=g.slice(),this.o.clear(),g.forEach((S,w)=>{const C=S===b.$LN.Back?-1:w;this.o.set(C,S)}),this.z({buttons:g.map((S,w)=>({...d(S.iconPath),tooltip:S.tooltip,handle:S===b.$LN.Back?-1:w}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(g){this.l=g,this.q.fire(g)}_fireDidTriggerButton(g){const S=this.o.get(g);S&&this.r.fire(S)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,M.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(g){if(!this.v){for(const S of Object.keys(g)){const w=g[S];this.u[S]=w===void 0?null:w}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function s(h){if(h instanceof b.$jN)return{id:h.id};const g=f(h),S=t(h);return{dark:typeof g=="string"?R.URI.file(g):g,light:typeof S=="string"?R.URI.file(S):S}}function t(h){return typeof h=="object"&&"light"in h?h.light:h}function f(h){return typeof h=="object"&&"dark"in h?h.dark:h}function d(h){const g=s(h);let S,w;return"id"in g?w=I.ThemeIcon.asClassName(g):S=g,{iconPath:S,iconClass:w}}class l extends r{constructor(g,S){super(g.identifier,S),this.O=g,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new L.$7d,this.L=[],this.M=new L.$7d,this.N=new L.$7d,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(g){this.B=g.slice(),this.C.clear(),this.D.clear(),g.forEach((C,k)=>{this.C.set(k,C),this.D.set(C,k)});const S=(0,p.$9F)(this.O,"quickPickItemTooltip"),w=[];for(let C=0;C<g.length;C++){const k=g[C];if(k.kind===b.QuickPickItemKind.Separator)w.push({type:"separator",label:k.label});else{k.tooltip&&!S&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const D=k.iconPath?d(k.iconPath):void 0;w.push({handle:C,label:k.label,iconPath:D?.iconPath,iconClass:D?.iconClass,description:k.description,detail:k.detail,picked:k.picked,alwaysShow:k.alwaysShow,tooltip:S?E.MarkdownString.fromStrict(k.tooltip):void 0,buttons:k.buttons?.map((O,F)=>({...d(O.iconPath),tooltip:O.tooltip,handle:F}))})}}this.z({items:w})}get canSelectMany(){return this.E}set canSelectMany(g){this.E=g,this.z({canSelectMany:g})}get matchOnDescription(){return this.F}set matchOnDescription(g){this.F=g,this.z({matchOnDescription:g})}get matchOnDetail(){return this.G}set matchOnDetail(g){this.G=g,this.z({matchOnDetail:g})}get sortByLabel(){return this.H}set sortByLabel(g){this.H=g,this.z({sortByLabel:g})}get keepScrollPosition(){return this.I}set keepScrollPosition(g){this.I=g,this.z({keepScrollPosition:g})}get activeItems(){return this.J}set activeItems(g){this.J=g.filter(S=>this.D.has(S)),this.z({activeItems:this.J.map(S=>this.D.get(S))})}get selectedItems(){return this.L}set selectedItems(g){this.L=g.filter(S=>this.D.has(S)),this.z({selectedItems:this.L.map(S=>this.D.get(S))})}_fireDidChangeActive(g){const S=(0,y.$Hb)(g.map(w=>this.C.get(w)));this.J=S,this.K.fire(S)}_fireDidChangeSelection(g){const S=(0,y.$Hb)(g.map(w=>this.C.get(w)));this.L=S,this.M.fire(S)}_fireDidTriggerItemButton(g,S){const w=this.C.get(g);if(!w||!w.buttons||!w.buttons.length)return;const C=w.buttons[S];C&&this.N.fire({button:C,item:w})}}class c extends r{constructor(g,S){super(g.identifier,S),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(g){this.B=g,this.z({password:g})}get prompt(){return this.C}set prompt(g){this.C=g,this.z({prompt:g})}get valueSelection(){return this.D}set valueSelection(g){this.D=g,this.z({valueSelection:g})}get validationMessage(){return this.E}set validationMessage(g){this.E=g,g?typeof g=="string"?this.z({validationMessage:g,severity:A.default.Error}):this.z({validationMessage:g.message,severity:g.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new i(m,o)}}),define(ke[347],Ee([1,0,2,4,54,3,8,6,19,131,12,25,56,16,26,15,11]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v,a,m){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Okc=e.$Nkc=void 0;function n(D){return D instanceof u.URI}function i(D,O){return D.scheme===a.Schemas.file&&O.scheme===a.Schemas.file&&m.$k?D.toString()===O.toString():D.toString().toLowerCase()===O.toString().toLowerCase()}function r(D){if(D)return typeof D.iconPath=="string"?u.URI.file(D.iconPath):u.URI.isUri(D.iconPath)||p.ThemeIcon.isThemeIcon(D.iconPath)?D.iconPath:void 0}function s(D){if(D.icon){if(u.URI.isUri(D.icon))return D.icon;if(p.ThemeIcon.isThemeIcon(D.icon))return D.icon;{const O=D.icon;return{light:O.light,dark:O.dark}}}else return}function t(D,O){if(!D.iconPath&&!O.iconPath)return 0;if(D.iconPath){if(!O.iconPath)return 1}else return-1;const F=typeof D.iconPath=="string"?D.iconPath:u.URI.isUri(D.iconPath)?D.iconPath.fsPath:D.iconPath.id,T=typeof O.iconPath=="string"?O.iconPath:u.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id;return(0,y.$ar)(F,T)}function f(D,O){let F=0;if(D.strikeThrough!==O.strikeThrough)return D.strikeThrough?1:-1;if(D.faded!==O.faded)return D.faded?1:-1;if(D.tooltip!==O.tooltip)return(D.tooltip||"").localeCompare(O.tooltip||"");if(F=t(D,O),F!==0)return F;if(D.light&&O.light)F=t(D.light,O.light);else{if(D.light)return 1;if(O.light)return-1}if(F!==0)return F;if(D.dark&&O.dark)F=t(D.dark,O.dark);else{if(D.dark)return 1;if(O.dark)return-1}return F}function d(D,O){if(D.command!==O.command)return D.command<O.command?-1:1;if(D.title!==O.title)return D.title<O.title?-1:1;if(D.tooltip!==O.tooltip){if(D.tooltip!==void 0&&O.tooltip!==void 0)return D.tooltip<O.tooltip?-1:1;if(D.tooltip!==void 0)return 1;if(O.tooltip!==void 0)return-1}if(D.arguments===O.arguments)return 0;if(D.arguments)if(O.arguments){if(D.arguments.length!==O.arguments.length)return D.arguments.length-O.arguments.length}else return 1;else return-1;for(let F=0;F<D.arguments.length;F++){const T=D.arguments[F],z=O.arguments[F];if(T!==z&&!(n(T)&&n(z)&&i(T,z)))return T<z?-1:1}return 0}function l(D,O){let F=(0,y.$ar)(D.resourceUri.fsPath,O.resourceUri.fsPath,!0);if(F!==0)return F;if(D.command&&O.command)F=d(D.command,O.command);else{if(D.command)return 1;if(O.command)return-1}if(F!==0)return F;if(D.decorations&&O.decorations)F=f(D.decorations,O.decorations);else{if(D.decorations)return 1;if(O.decorations)return-1}if(D.multiFileDiffEditorModifiedUri&&O.multiFileDiffEditorModifiedUri)F=(0,y.$ar)(D.multiFileDiffEditorModifiedUri.fsPath,O.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(D.multiFileDiffEditorModifiedUri)return 1;if(O.multiFileDiffEditorModifiedUri)return-1}if(D.multiDiffEditorOriginalUri&&O.multiDiffEditorOriginalUri)F=(0,y.$ar)(D.multiDiffEditorOriginalUri.fsPath,O.multiDiffEditorOriginalUri.fsPath,!0);else{if(D.multiDiffEditorOriginalUri)return 1;if(O.multiDiffEditorOriginalUri)return-1}return F}function c(D,O){for(let F=0;F<D.length;F++)if(D[F]!==O[F])return!1;return!0}function h(D,O){return D.command===O.command&&D.title===O.title&&D.tooltip===O.tooltip&&(D.arguments&&O.arguments?c(D.arguments,O.arguments):D.arguments===O.arguments)}function g(D,O){return(0,$.$ub)(D,O,h)}class S{#e;#t;get value(){return this.d}set value(O){O=O??"",this.#e.$setInputBoxValue(this.l,O),this.n(O)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(O){this.#e.$setInputBoxPlaceholder(this.l,O),this.f=O}get validateInput(){return(0,v.$0F)(this.k,"scmValidation"),this.g}set validateInput(O){if((0,v.$0F)(this.k,"scmValidation"),O&&typeof O!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=O,this.#e.$setValidationProviderIsEnabled(this.l,!!O)}get enabled(){return this.h}set enabled(O){O=!!O,this.h!==O&&(this.h=O,this.#e.$setInputBoxEnablement(this.l,O))}get visible(){return this.j}set visible(O){O=!!O,this.j!==O&&(this.j=O,this.#e.$setInputBoxVisibility(this.l,O))}get document(){return(0,v.$0F)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(O,F,T,z,j){this.k=O,this.l=z,this.m=j,this.d="",this.e=new L.$7d,this.f="",this.h=!0,this.j=!0,this.#t=F,this.#e=T}showValidationMessage(O,F){(0,v.$0F)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,O,F)}$onInputBoxValueChange(O){this.n(O)}n(O){this.d=O,this.e.fire(O)}}e.$Nkc=S;class w{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(O){this.v=O,this.q.$updateGroupLabel(this.t,this.handle,O)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(O){this.p=O,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(O){this.f=[...O],this.k.fire()}constructor(O,F,T,z,j,N,B){this.q=O,this.s=F,this.t=T,this.u=z,this.v=j,this.multiDiffEditorEnableViewChanges=N,this.w=B,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new L.$7d,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new L.$7d,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=w.d++}getResourceState(O){return this.g.get(O)}$executeResourceCommand(O,F){const T=this.h.get(O);return T?(0,R.$ah)(()=>this.s.executeCommand(T.command,...T.arguments||[],F)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const O=[...this.f].sort(l),T=(0,$.$Db)(this.o,O,l).map(N=>{const B=N.toInsert.map(W=>{const Z=this.e++;this.g.set(Z,W);const _=W.resourceUri;let X;if(W.command)if(W.command.command==="vscode.open"||W.command.command==="vscode.diff"||W.command.command==="vscode.changes"){const se=new P.$Tc;X=this.s.converter.toInternal(W.command,se),this.j.set(Z,se)}else this.h.set(Z,W.command);const x=(0,v.$9F)(this.w,"scmMultiDiffEditor"),re=x?W.multiDiffEditorOriginalUri:void 0,Y=x?W.multiFileDiffEditorModifiedUri:void 0,me=r(W.decorations),Ce=W.decorations&&r(W.decorations.light)||me,ee=W.decorations&&r(W.decorations.dark)||me,U=[Ce,ee],ie=W.decorations&&W.decorations.tooltip||"",be=W.decorations&&!!W.decorations.strikeThrough,Se=W.decorations&&!!W.decorations.faded,ae=W.contextValue||"";return{rawResource:[Z,_,U,ie,be,Se,ae,X,re,Y],handle:Z}});return{start:N.start,deleteCount:N.deleteCount,toInsert:B}}),z=T.map(({start:N,deleteCount:B,toInsert:W})=>[N,B,W.map(Z=>Z.rawResource)]),j=T.reverse();for(const{start:N,deleteCount:B,toInsert:W}of j){const Z=W.map(X=>X.handle),_=this.n.splice(N,B,...Z);for(const X of _)this.g.delete(X),this.h.delete(X),this.j.get(X)?.dispose(),this.j.delete(X)}return this.o=O,z}dispose(){this.l=!0,this.m.fire()}}class C{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(O){this.g!==O&&(this.g=O,this.#e.$updateSourceControl(this.w,{count:O}))}get quickDiffProvider(){return this.h}set quickDiffProvider(O){this.h=O;let F;(0,v.$9F)(this.x,"quickDiffProvider")&&(F=O?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!O,quickDiffLabel:F})}get historyProvider(){return(0,v.$0F)(this.x,"scmHistoryProvider"),this.j}set historyProvider(O){(0,v.$0F)(this.x,"scmHistoryProvider"),this.j=O,this.k.value=new P.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!O}),O&&this.k.value.add(O.onDidChangeCurrentHistoryItemGroup(()=>{this.l=O?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(O){O!==this.m&&(this.m=O,this.#e.$updateSourceControl(this.w,{commitTemplate:O}))}get acceptInputCommand(){return this.o}set acceptInputCommand(O){this.n.value=new P.$Tc,this.o=O;const F=this.y.converter.toInternal(O,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:F})}get actionButton(){return(0,v.$0F)(this.x,"scmActionButton"),this.q}set actionButton(O){(0,v.$0F)(this.x,"scmActionButton"),this.p.value=new P.$Tc,this.q=O;const F=O!==void 0?{command:this.y.converter.toInternal(O.command,this.p.value),secondaryCommands:O.secondaryCommands?.map(T=>T.map(z=>this.y.converter.toInternal(z,this.p.value))),description:O.description,enabled:O.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:F??null})}get statusBarCommands(){return this.t}set statusBarCommands(O){if(this.t&&O&&g(this.t,O))return;this.s.value=new P.$Tc,this.t=O;const F=(O||[]).map(T=>this.y.converter.toInternal(T,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:F})}get selected(){return this.u}constructor(O,F,T,z,j,N,B){this.x=O,this.y=z,this.z=j,this.A=N,this.B=B,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new P.$Vc,this.m=void 0,this.n=new P.$Vc,this.o=void 0,this.p=new P.$Vc,this.s=new P.$Vc,this.t=void 0,this.u=!1,this.v=new L.$7d,this.onDidChangeSelection=this.v.event,this.w=C.d++,this.C=new Map,this.D=new Set,this.#e=T;const W=u.URI.from({scheme:a.Schemas.vscodeSourceControl,path:`${j}/scm${this.w}/input`,query:B?`rootUri=${encodeURIComponent(B.toString())}`:void 0});this.f=new S(O,F,this.#e,this.w,W),this.#e.$registerSourceControl(this.w,j,N,B,W)}createResourceGroup(O,F,T){const z=(0,v.$9F)(this.x,"scmMultiDiffEditor")&&T?.multiDiffEditorEnableViewChanges===!0,j=new w(this.#e,this.y,this.w,O,F,z,this.x),N=L.Event.once(j.onDidDispose)(()=>this.C.delete(j));return this.C.set(j,N),this.eventuallyAddResourceGroups(),j}eventuallyAddResourceGroups(){const O=[],F=[];for(const[T,z]of this.C){z.dispose();const j=T.onDidUpdateResourceStates(()=>{this.D.add(T),this.eventuallyUpdateResourceStates()});L.Event.once(T.onDidDispose)(()=>{this.D.delete(T),j.dispose(),this.e.delete(T.handle),this.#e.$unregisterGroup(this.w,T.handle)}),O.push([T.handle,T.id,T.label,T.features,T.multiDiffEditorEnableViewChanges]);const N=T._takeResourceStateSnapshot();N.length>0&&F.push([T.handle,N]),this.e.set(T.handle,T)}this.#e.$registerGroups(this.w,O,F),this.C.clear()}eventuallyUpdateResourceStates(){const O=[];this.D.forEach(F=>{const T=F._takeResourceStateSnapshot();T.length!==0&&O.push([F.handle,T])}),O.length>0&&this.#e.$spliceResourceStates(this.w,O),this.D.clear()}getResourceGroup(O){return this.e.get(O)}setSelectionState(O){this.u=O,this.v.fire(O)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(O=>O.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,M.$Nh)(100)],C.prototype,"eventuallyAddResourceGroups",null),Je([(0,M.$Nh)(100)],C.prototype,"eventuallyUpdateResourceStates",null);let k=class{static{o=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(O,F,T,z){this.l=F,this.m=T,this.n=z,this.g=new Map,this.h=new I.$Fm,this.j=new L.$7d,this.e=O.getProxy(b.$lM.MainThreadSCM),this.f=O.getProxy(b.$lM.MainThreadTelemetry),F.registerArgumentProcessor({processArgument:j=>{if(j&&j.$mid===3){const N=this.g.get(j.sourceControlHandle);if(!N)return j;const B=N.getResourceGroup(j.groupHandle);return B?B.getResourceState(j.handle):j}else if(j&&j.$mid===4){const N=this.g.get(j.sourceControlHandle);return N?N.getResourceGroup(j.groupHandle):j}else if(j&&j.$mid===5){const N=this.g.get(j.handle);return N||j}return j}})}createSourceControl(O,F,T,z){this.n.trace("ExtHostSCM#createSourceControl",O.identifier.value,F,T,z),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:O.identifier.value});const j=o.d++,N=new C(O,this.m,this.e,this.l,F,T,z);this.g.set(j,N);const B=this.h.get(O.identifier)||[];return B.push(N),this.h.set(O.identifier,B),N}getLastInputBox(O){this.n.trace("ExtHostSCM#getLastInputBox",O.identifier.value);const F=this.h.get(O.identifier),T=F&&F[F.length-1];return T&&T.inputBox}$provideOriginalResource(O,F,T){const z=u.URI.revive(F);this.n.trace("ExtHostSCM#$provideOriginalResource",O,z.toString());const j=this.g.get(O);return!j||!j.quickDiffProvider||!j.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$ah)(()=>j.quickDiffProvider.provideOriginalResource(z,T)).then(N=>N||null)}$onInputBoxValueChange(O,F){this.n.trace("ExtHostSCM#$onInputBoxValueChange",O);const T=this.g.get(O);return T&&T.inputBox.$onInputBoxValueChange(F),Promise.resolve(void 0)}$executeResourceCommand(O,F,T,z){this.n.trace("ExtHostSCM#$executeResourceCommand",O,F,T);const j=this.g.get(O);if(!j)return Promise.resolve(void 0);const N=j.getResourceGroup(F);return N?N.$executeResourceCommand(T,z):Promise.resolve(void 0)}$validateInput(O,F,T){this.n.trace("ExtHostSCM#$validateInput",O);const z=this.g.get(O);return!z||!z.inputBox.validateInput?Promise.resolve(void 0):(0,R.$ah)(()=>z.inputBox.validateInput(F,T)).then(j=>{if(!j)return Promise.resolve(void 0);const N=E.MarkdownString.fromStrict(j.message);return N?Promise.resolve([N,j.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(O){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",O),O!==void 0&&this.g.get(O)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=O,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(O,F,T,z){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(F,T,z)??void 0}async $provideHistoryItems(O,F,T,z){return(await this.g.get(O)?.historyProvider?.provideHistoryItems(F,T,z))?.map(B=>({...B,icon:s(B)}))??void 0}async $provideHistoryItemSummary(O,F,T,z){const j=this.g.get(O)?.historyProvider;if(typeof j?.provideHistoryItemSummary!="function")return;const N=await j.provideHistoryItemSummary(F,T,z);return N?{...N,icon:s(N)}:void 0}async $provideHistoryItemChanges(O,F,T,z){return await this.g.get(O)?.historyProvider?.provideHistoryItemChanges(F,T,z)??void 0}};e.$Okc=k,e.$Okc=k=o=Je([qe(3,A.$Oj)],k)}),define(ke[348],Ee([1,0,6,16,2]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pkc=void 0;class P{static{this.a=0}constructor(b,$){this.d=$,this.c=new Map,this.b=b.getProxy(u.$lM.MainThreadShare)}async $provideShare(b,$,y){return await this.c.get(b)?.provideShare({selection:L.Range.to($.selection),resourceUri:M.URI.revive($.resourceUri)},y)??void 0}registerShareProvider(b,$){const y=P.a++;return this.c.set(y,$),this.b.$registerShareProvider(y,L.DocumentSelector.from(b,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(y),this.c.delete(y)}}}}e.$Pkc=P}),define(ke[349],Ee([1,0,7,6,224,3,16,18]),function(he,e,u,L,M,P,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Skc=e.$Rkc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new u.$kN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new u.$kN("statusBarItem.warningForeground")]])}#e;#t;constructor(p,E,v,a,m,o=u.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new P.$Tc,this.#e=p,this.#t=E,m&&a){this.c=(0,u.$YM)(a.identifier,m);const i=v.get(this.c);i&&(o=i.alignLeft?u.StatusBarAlignment.Left:u.StatusBarAlignment.Right,n=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String($.a++);this.e=a,this.f=m,this.g=o,this.h=this.u(n)}u(p){if((0,b.$Zf)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(p){this.k=p,this.v()}set name(p){this.m=p,this.v()}set tooltip(p){this.l=p,this.v()}set color(p){this.n=p,this.v()}set backgroundColor(p){p&&!$.b.has(p.id)&&(p=void 0),this.o=p,this.v()}set command(p){this.r?.fromApi!==p&&(this.p&&this.q.add(this.p),this.p=new P.$Tc,typeof p=="string"?this.r={fromApi:p,internal:this.#t.toInternal({title:"",command:p},this.p)}:p?this.r={fromApi:p,internal:this.#t.toInternal(p,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(p){this.t=p,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let p;this.e?this.f?p=`${this.e.identifier.value}.${this.f}`:p=this.e.identifier.value:p=this.f;let E;this.m?E=this.m:E=(0,M.localize)(0,null,this.e.displayName||this.e.name);let v=this.n;this.o&&(v=$.b.get(this.o.id));const a=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,p,this.e?.identifier.value,E,this.k,a,this.r?.internal,v,this.o,this.g===u.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Rkc=$;class y{constructor(p){this.b=[],this.a=p.createStatusBarEntry(void 0,"status.extensionMessage",u.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,M.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(p){const E={message:p};return this.b.unshift(E),this.c(),new u.$nM(()=>{const v=this.b.indexOf(E);v>=0&&(this.b.splice(v,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(p,E){this.e=new Map,this.a=p.getProxy(L.$lM.MainThreadStatusBar),this.b=E,this.c=new y(this)}$acceptStaticEntries(p){for(const E of p)this.e.set(E.entryId,E)}createStatusBarEntry(p,E,v,a){return new $(this.a,this.b,this.e,p,E,v,a)}setStatusBarMessage(p,E){const v=this.c.setMessage(p);let a;return typeof E=="number"?a=setTimeout(()=>v.dispose(),E):typeof E<"u"&&E.then(()=>v.dispose(),()=>v.dispose()),new u.$nM(()=>{v.dispose(),clearTimeout(a)})}}e.$Skc=A}),define(ke[154],Ee([1,0,29,144,67,112,89,16,2]),function(he,e,u,L,M,P,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VO=e.$UO=e.$TO=e.$SO=void 0;const y=(i,r,s,t)=>{let f=r;return{enumerable:!0,configurable:!1,get(){return f},set(d){if(!s(f,d)){const l=f;f=d,i.listener?.(t(d,l))}}}},A=(i,r)=>i===r,I={range:(i,r)=>i===r?!0:!i||!r?!1:i.isEqual(r),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(i,r)=>!(i.length!==r.length||i.some(s=>!r.find(t=>s.id===t.id)))},p=i=>r=>({op:4,update:i(r)}),E=(i,r)=>({range:(()=>{let s;const t=p(f=>({range:u.$ct.lift(b.Range.from(f))}));return{enumerable:!0,configurable:!1,get(){return s},set(f){i.listener?.({op:6}),I.range(s,f)||(s=f,i.listener?.(t(f)))}}})(),label:y(i,r,I.label,p(s=>({label:s}))),description:y(i,void 0,I.description,p(s=>({description:s}))),sortText:y(i,void 0,I.sortText,p(s=>({sortText:s}))),canResolveChildren:y(i,!1,I.canResolveChildren,s=>({op:2,state:s})),busy:y(i,!1,I.busy,p(s=>({busy:s}))),error:y(i,void 0,I.error,p(s=>({error:b.MarkdownString.fromStrict(s)||null}))),tags:y(i,[],I.tags,(s,t)=>({op:1,new:s.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),v=i=>{const r=M.$0K.fromString(i.extId),s=new m(r.controllerId,r.localId,i.label,$.URI.revive(i.uri)||void 0);return s.range=b.Range.to(i.range||void 0),s.description=i.description||void 0,s.sortText=i.sortText||void 0,s.tags=i.tags.map(t=>b.TestTag.to({id:(0,R.$dL)(t).tagId})),s},a=i=>{let r;for(const s of i.tests){const t=v(s.item);(0,L.$CO)(t).parent=r,r=t}return r};e.$SO=a;class m{constructor(r,s,t,f){if(s.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(s)} symbol`);const d=(0,L.$BO)(this,r);Object.defineProperties(this,{id:{value:s,enumerable:!0,writable:!1},uri:{value:f,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof o?void 0:d.parent}},children:{value:(0,P.$AO)(d,L.$CO,m),enumerable:!0,writable:!1},...E(d,t)})}}e.$TO=m;class o extends m{constructor(r,s){super(r,r,s,void 0),this._isRoot=!0}}e.$UO=o;class n extends P.$wO{constructor(r,s,t){super({controllerId:r,getDocumentVersion:f=>f&&t.getDocument(f)?.version,getApiFor:L.$CO,getChildren:f=>f.children,root:new o(r,s),toITestItem:b.TestItem.from})}}e.$VO=n}),define(ke[33],Ee([1,0,18,7,16,24,6,19,12,57,29,49,2,3,5,20,154,21,68,46,39,87,90,30]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v,a,m,o,n,i,r,s,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7O=e.$6O=e.$5O=e.$4O=e.$3O=e.$2O=void 0;let d=class{#e;#t;#i;constructor(w,C,k){this.b=new Map,this.c=new Map,this.#e=w.getProxy(R.$lM.MainThreadCommands),this.d=C,this.#i=k,this.#t=w.getProxy(R.$lM.MainThreadTelemetry),this.converter=new l(this,D=>{const O=this.c.get(D);return O?.result===h.Void?O:void 0},C),this.f=[{processArgument(D){return(0,y.$Rh)(D)}},{processArgument(D){return(0,P.$Qn)(D,function(O){if(A.$ct.isIRange(O))return M.Range.to(O);if(I.$bt.isIPosition(O))return M.Position.to(O);if(A.$ct.isIRange(O.range)&&p.URI.isUri(O.uri))return M.location.to(O);if(O instanceof o.$ue)return O.buffer.buffer;if(!Array.isArray(O))return O})}}]}registerArgumentProcessor(w){this.f.push(w)}registerApiCommand(w){const C=this.registerCommand(!1,w.id,async(...k)=>{const D=w.args.map((F,T)=>{if(!F.validate(k[T]))throw new Error(`Invalid argument '${F.name}' when running '${w.id}', received: ${typeof k[T]=="object"?JSON.stringify(k[T],null,"	"):k[T]} `);return F.convert(k[T])}),O=await this.executeCommand(w.internalId,...D);return w.result.convert(O,k,this.converter)},void 0,{description:w.description,args:w.args,returns:w.result.description});return this.c.set(w.id,w),new L.$nM(()=>{C.dispose(),this.c.delete(w.id)})}registerCommand(w,C,k,D,O,F){if(this.d.trace("ExtHostCommands#registerCommand",C),!C.trim().length)throw new Error("invalid id");if(this.b.has(C))throw new Error(`command '${C}' already exists`);return this.b.set(C,{callback:k,thisArg:D,metadata:O,extension:F}),w&&this.#e.$registerCommand(C),new L.$nM(()=>{this.b.delete(C)&&w&&this.#e.$unregisterCommand(C)})}executeCommand(w,...C){return this.d.trace("ExtHostCommands#executeCommand",w),this.g(w,C,!0)}async g(w,C,k){if(this.b.has(w))return this.#e.$fireCommandActivationEvent(w),this.h(w,C,!1);{let D=!1;const O=(0,P.$Qn)(C,function(F){if(F instanceof L.$oM)return M.Position.from(F);if(F instanceof L.$pM)return M.Range.from(F);if(F instanceof L.$zM)return M.location.from(F);if(L.$ON.isNotebookRange(F))return M.NotebookRange.from(F);if(F instanceof ArrayBuffer)return D=!0,o.$ue.wrap(new Uint8Array(F));if(F instanceof Uint8Array)return D=!0,o.$ue.wrap(F);if(F instanceof o.$ue)return D=!0,F;if(!Array.isArray(F))return F});try{const F=await this.#e.$executeCommand(w,D?new n.$ew(O):O,k);return(0,y.$Rh)(F)}catch(F){if(F instanceof Error&&F.message==="$executeCommand:retry")return this.g(w,C,!1);throw F}}}async h(w,C,k){const D=this.b.get(w);if(!D)throw new Error("Unknown command");const{callback:O,thisArg:F,metadata:T}=D;if(T?.args)for(let j=0;j<T.args.length;j++)try{(0,u.$ag)(C[j],T.args[j].constraint)}catch{throw new Error(`Running the contributed command: '${w}' failed. Illegal argument '${T.args[j].name}' - ${T.args[j].description}`)}const z=r.$3d.create();try{return await O.apply(F,C)}catch(j){if(w===this.converter.delegatingCommandId){const N=this.converter.getActualCommand(...C);N&&(w=N.command)}if(this.d.error(j,w,D.extension?.identifier),!k)throw j;if(D.extension?.identifier){const N=this.#i.onExtensionError(D.extension.identifier,j);this.d.trace("forwarded error to extension?",N,D.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$6i)(j)),this.id=w,this.source=D.extension?.displayName??D.extension?.name}}}finally{this.j(D,w,z.elapsed())}}j(w,C,k){w.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:w.extension.identifier.value,id:new s.$4o(C),duration:k})}$executeContributedCommand(w,...C){this.d.trace("ExtHostCommands#$executeContributedCommand",w);const k=this.b.get(w);return k?(C=C.map(D=>this.f.reduce((O,F)=>F.processArgument(O,k.extension?.identifier),D)),this.h(w,C,!0)):Promise.reject(new Error(`Contributed command '${w}' does not exist.`))}getCommands(w=!1){return this.d.trace("ExtHostCommands#getCommands",w),this.#e.$getCommands().then(C=>(w&&(C=C.filter(k=>k[0]!=="_")),C))}$getContributedCommandMetadata(){const w=Object.create(null);for(const[C,k]of this.b){const{metadata:D}=k;D&&(w[C]=D)}return Promise.resolve(w)}};e.$2O=d,e.$2O=d=Je([qe(0,a.$GO),qe(1,$.$Oj),qe(2,t.$1O)],d),e.$3O=(0,v.$ii)("IExtHostCommands");class l{constructor(w,C,k){this.d=w,this.f=C,this.g=k,this.delegatingCommandId=`__vsc${(0,f.$Eg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(w,C){if(!w)return;const k={$ident:void 0,id:w.command,title:w.title,tooltip:w.tooltip};if(!w.command)return k;const D=this.f(w.command);if(D)k.id=D.internalId,k.arguments=D.args.map((O,F)=>O.convert(w.arguments&&w.arguments[F]));else if((0,b.$Lb)(w.arguments)){const O=`${w.command} /${++this.c}`;this.b.set(O,w),C.add((0,E.$Sc)(()=>{this.b.delete(O),this.g.trace("CommandsConverter#DISPOSE",O)})),k.$ident=O,k.id=this.delegatingCommandId,k.arguments=[O],this.g.trace("CommandsConverter#CREATE",w.command,O)}return k}fromInternal(w){return typeof w.$ident=="string"?this.b.get(w.$ident):{command:w.id,title:w.title,arguments:w.arguments}}getActualCommand(...w){return this.b.get(w[0])}h(...w){const C=this.getActualCommand(...w);return this.g.trace("CommandsConverter#EXECUTE",w[0],C?C.command:"MISSING"),C?this.d.executeCommand(C.command,...C.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${w[0]}`)}}e.$4O=l;class c{static{this.Uri=new c("uri","Uri of a text document",w=>p.URI.isUri(w),w=>w)}static{this.Position=new c("position","A position in a text document",w=>L.$oM.isPosition(w),M.Position.from)}static{this.Range=new c("range","A range in a text document",w=>L.$pM.isRange(w),M.Range.from)}static{this.Selection=new c("selection","A selection in a text document",w=>L.$qM.isSelection(w),M.Selection.from)}static{this.Number=new c("number","",w=>typeof w=="number",w=>w)}static{this.String=new c("string","",w=>typeof w=="string",w=>w)}static{this.StringArray=c.Arr(c.String)}static Arr(w){return new c(`${w.name}_array`,`Array of ${w.name}, ${w.description}`,C=>Array.isArray(C)&&C.every(k=>w.validate(k)),C=>C.map(k=>w.convert(k)))}static{this.CallHierarchyItem=new c("item","A call hierarchy item",w=>w instanceof L.$KM,M.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new c("item","A type hierarchy item",w=>w instanceof L.$8N,M.TypeHierarchyItem.from)}static{this.TestItem=new c("testItem","A VS Code TestItem",w=>w instanceof m.$TO,M.TestItem.from)}constructor(w,C,k,D){this.name=w,this.description=C,this.validate=k,this.convert=D}optional(){return new c(this.name,`(optional) ${this.description}`,w=>w==null||this.validate(w),w=>w===void 0?void 0:w===null?null:this.convert(w))}with(w,C){return new c(w??this.name,C??this.description,this.validate,this.convert)}}e.$5O=c;class h{static{this.Void=new h("no result",w=>w)}constructor(w,C){this.description=w,this.convert=C}}e.$6O=h;class g{constructor(w,C,k,D,O){this.id=w,this.internalId=C,this.description=k,this.args=D,this.result=O}}e.$7O=g}),define(ke[350],Ee([1,0,19,15,2,83,134,41,33,16,7]),function(he,e,u,L,M,P,R,b,$,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ic=void 0;const I=[new $.$7O("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$5O.Uri,$.$5O.Position],new $.$6O("A promise that resolves to an array of DocumentHighlight-instances.",E(y.DocumentHighlight.to))),new $.$7O("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$5O.Uri],new $.$6O("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,m)=>{if((0,u.$Kb)(a))return;class o extends A.$FM{static to(i){const r=new o(i.name,y.SymbolKind.to(i.kind),i.containerName||"",new A.$zM(m[0],y.Range.to(i.range)));return r.detail=i.detail,r.range=r.location.range,r.selectionRange=y.Range.to(i.selectionRange),r.children=i.children?i.children.map(o.to):[],r}}return a.map(o.to)})),new $.$7O("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$5O.Uri,new $.$5O("options","Formatting options",a=>!0,a=>a)],new $.$6O("A promise that resolves to an array of TextEdits.",E(y.TextEdit.to))),new $.$7O("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$5O.Uri,$.$5O.Range,new $.$5O("options","Formatting options",a=>!0,a=>a)],new $.$6O("A promise that resolves to an array of TextEdits.",E(y.TextEdit.to))),new $.$7O("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$5O.Uri,$.$5O.Position,new $.$5O("ch","Trigger character",a=>typeof a=="string",a=>a),new $.$5O("options","Formatting options",a=>!0,a=>a)],new $.$6O("A promise that resolves to an array of TextEdits.",E(y.TextEdit.to))),new $.$7O("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$5O.Uri,$.$5O.Position],new $.$6O("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$7O("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$5O.Uri,$.$5O.Position],new $.$6O("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$7O("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$5O.Uri,$.$5O.Position],new $.$6O("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$7O("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$5O.Uri,$.$5O.Position],new $.$6O("A promise that resolves to an array of Location or LocationLink instances.",v)),new $.$7O("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$5O.Uri,$.$5O.Position],new $.$6O("A promise that resolves to an array of Location-instances.",E(y.location.to))),new $.$7O("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$5O.Uri,$.$5O.Position],new $.$6O("A promise that resolves to an array of Hover-instances.",E(y.Hover.to))),new $.$7O("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$5O.Uri,new $.$5O("position","A position in a text document",a=>Array.isArray(a)&&a.every(m=>A.$oM.isPosition(m)),a=>a.map(y.Position.from))],new $.$6O("A promise that resolves to an array of ranges.",a=>a.map(m=>{let o;for(const n of m.reverse())o=new A.$JM(y.Range.to(n),o);return o}))),new $.$7O("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$5O.String.with("query","Search string")],new $.$6O("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(y.WorkspaceSymbol.to))),new $.$7O("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$5O.Uri,$.$5O.Position],new $.$6O("A promise that resolves to an array of CallHierarchyItem-instances",a=>a.map(y.CallHierarchyItem.to))),new $.$7O("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$5O.CallHierarchyItem],new $.$6O("A promise that resolves to an array of CallHierarchyIncomingCall-instances",a=>a.map(y.CallHierarchyIncomingCall.to))),new $.$7O("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$5O.CallHierarchyItem],new $.$6O("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",a=>a.map(y.CallHierarchyOutgoingCall.to))),new $.$7O("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$5O.Uri,$.$5O.Position],new $.$6O("A promise that resolves to a range and placeholder text.",a=>{if(a)return{range:y.Range.to(a.range),placeholder:a.text}})),new $.$7O("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$5O.Uri,$.$5O.Position,$.$5O.String.with("newName","The new symbol name")],new $.$6O("A promise that resolves to a WorkspaceEdit.",a=>{if(a){if(a.rejectReason)throw new Error(a.rejectReason);return y.WorkspaceEdit.to(a)}})),new $.$7O("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$5O.Uri,$.$5O.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$6O("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(y.DocumentLink.to))),new $.$7O("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$5O.Uri],new $.$6O("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new A.$FN(a.tokenTypes,a.tokenModifiers)})),new $.$7O("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$5O.Uri],new $.$6O("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const m=(0,R.$Iab)(a);if(m.type==="full")return new A.$HN(m.data,void 0)})),new $.$7O("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$5O.Uri,$.$5O.Range.optional()],new $.$6O("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new A.$FN(a.tokenTypes,a.tokenModifiers)})),new $.$7O("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$5O.Uri,$.$5O.Range],new $.$6O("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const m=(0,R.$Iab)(a);if(m.type==="full")return new A.$HN(m.data,void 0)})),new $.$7O("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$5O.Uri,$.$5O.Position,$.$5O.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$5O.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$6O("A promise that resolves to a CompletionList-instance.",(a,m,o)=>{if(!a)return new A.$VM([]);const n=a.suggestions.map(i=>y.CompletionItem.to(i,o));return new A.$VM(n,a.incomplete)})),new $.$7O("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$5O.Uri,$.$5O.Position,$.$5O.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$6O("A promise that resolves to SignatureHelp.",a=>{if(a)return y.SignatureHelp.to(a)})),new $.$7O("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$5O.Uri,$.$5O.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$6O("A promise that resolves to an array of CodeLens-instances.",(a,m,o)=>E(n=>new A.$NM(y.Range.to(n.range),n.command&&o.fromInternal(n.command)))(a))),new $.$7O("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$5O.Uri,new $.$5O("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>A.$pM.isRange(a),a=>A.$qM.isSelection(a)?y.Selection.from(a):y.Range.from(a)),$.$5O.String.with("kind","Code action kind to return code actions for").optional(),$.$5O.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$6O("A promise that resolves to an array of Command-instances.",(a,m,o)=>E(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(n.command)}else{const i=new A.$HM(n.title,n.kind?new A.$IM(n.kind):void 0);return n.edit&&(i.edit=y.WorkspaceEdit.to(n.edit)),n.command&&(i.command=o.fromInternal(n.command)),i.isPreferred=n.isPreferred,i}})(a))),new $.$7O("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$5O.Uri],new $.$6O("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(m=>new A.$2M(y.Range.to(m.range),y.Color.to(m.color))):[])),new $.$7O("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$5O("color","The color to show and insert",a=>a instanceof A.$1M,y.Color.from),new $.$5O("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:y.Range.from(a.range)}))],new $.$6O("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(y.ColorPresentation.to):[])),new $.$7O("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$5O.Uri,$.$5O.Range],new $.$6O("A promise that resolves to an array of Inlay objects",(a,m,o)=>a.map(y.InlayHint.to.bind(void 0,o)))),new $.$7O("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$5O.Uri],new $.$6O("A promise that resolves to an array of FoldingRange objects",(a,m)=>{if(a)return a.map(y.FoldingRange.to)})),new $.$7O("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$6O("A promise that resolves to an array of NotebookContentProvider static info objects.",E(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(m=>y.NotebookExclusiveDocumentPattern.to(m))})))),new $.$7O("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$5O.Uri,$.$5O.Range,new $.$5O("context","An InlineValueContext",a=>a&&typeof a.frameId=="number"&&a.stoppedLocation instanceof A.$pM,a=>y.InlineValueContext.from(a))],new $.$6O("A promise that resolves to an array of InlineValue objects",a=>a.map(y.InlineValue.to))),new $.$7O("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$5O("uriOrString","Uri-instance or string (only http/https)",a=>M.URI.isUri(a)||typeof a=="string"&&(0,L.$sg)(a,L.Schemas.http,L.Schemas.https),a=>a),new $.$5O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[y.ViewColumn.from(a),void 0]:[y.ViewColumn.from(a.viewColumn),y.TextEditorOpenOptions.from(a)])).optional(),$.$5O.String.with("label","").optional()],$.$6O.Void),new $.$7O("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$5O.Uri.with("resource","Resource to open"),$.$5O.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$5O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[y.ViewColumn.from(a),void 0]:[y.ViewColumn.from(a.viewColumn),y.TextEditorOpenOptions.from(a)])).optional()],$.$6O.Void),new $.$7O("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$5O.Uri.with("left","Left-hand side resource of the diff editor"),$.$5O.Uri.with("right","Right-hand side resource of the diff editor"),$.$5O.String.with("title","Human readable title for the diff editor").optional(),new $.$5O("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[y.ViewColumn.from(a.viewColumn),y.TextEditorOpenOptions.from(a)]).optional()],$.$6O.Void),new $.$7O("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$5O.String.with("title","Human readable title for the changes editor"),new $.$5O("resourceList","List of resources to compare",a=>{for(const m of a){if(m.length!==3)return!1;const[o,n,i]=m;if(!M.URI.isUri(o)||!M.URI.isUri(n)&&n!==void 0&&n!==null||!M.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},a=>a)],$.$6O.Void),new $.$7O("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$5O.Uri,$.$5O.Position],new $.$6O("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(y.TypeHierarchyItem.to))),new $.$7O("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$5O.TypeHierarchyItem],new $.$6O("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(y.TypeHierarchyItem.to))),new $.$7O("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$5O.TypeHierarchyItem],new $.$6O("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(y.TypeHierarchyItem.to))),new $.$7O("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$5O.TestItem],$.$6O.Void),new $.$7O("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$5O.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$6O.Void),new $.$7O("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$5O.String.with("name","The context key name"),new $.$5O("value","The context key value",()=>!0,a=>a)],$.$6O.Void),new $.$7O("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$5O.Uri,$.$5O.StringArray,new $.$5O("MappedEditsContext","Mapped Edits Context",a=>y.MappedEditsContext.is(a),a=>y.MappedEditsContext.from(a))],new $.$6O("A promise that resolves to a workspace edit or null",a=>a?y.WorkspaceEdit.to(a):null))];class p{static register(m){I.forEach(m.registerApiCommand,m),this.a(m)}static a(m){m.registerCommand(!1,"_validateWhenClauses",b.$hj)}}e.$_ic=p;function E(a){return m=>{if(Array.isArray(m))return m.map(a)}}function v(a){if(!Array.isArray(a))return;const m=[];for(const o of a)P.$3t(o)?m.push(y.DefinitionLink.to(o)):m.push(y.location.to(o));return m}}),define(ke[351],Ee([1,0,8,3,2,6,33,16,7]),function(he,e,u,L,M,P,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jkc=void 0;class y{static{this.a=0}constructor(E,v){this.extension=E,this.provider=v,this.handle=y.a++}}class A{constructor(E){this.session=E,this.responses=[]}}class I{static{this.a=0}constructor(E,v,a,m){this.f=a,this.g=m,this.b=new Map,this.d=new Map,this.e=E.getProxy(P.$lM.MainThreadInlineChat),v.registerApiCommand(new R.$7O("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new R.$5O("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?b.Range.from(o.initialRange):void 0,initialSelection:$.$qM.isSelection(o.initialSelection)?b.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?b.Position.from(o.position):void 0}})],R.$6O.Void))}registerProvider(E,v,a){const m=new y(E,v);return this.b.set(m.handle,m),this.e.$registerInteractiveEditorProvider(m.handle,a?.label??E.displayName??E.name,E.identifier.value,typeof v.handleInteractiveEditorResponseFeedback=="function",typeof v.provideFollowups=="function",a?.supportReportIssue??!1),(0,L.$Sc)(()=>{this.e.$unregisterInteractiveEditorProvider(m.handle),this.b.delete(m.handle)})}async $prepareSession(E,v,a,m){const o=this.b.get(E);if(!o){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(M.URI.revive(v)),i=b.Selection.to(a),r=await o.provider.prepareInteractiveEditorSession({document:n,selection:i},m);if(!r)return;if(r.wholeRange&&!r.wholeRange.contains(i))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const s=I.a++;return this.d.set(s,new A(r)),{id:s,placeholder:r.placeholder,input:r.input,slashCommands:r.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:b.Range.from(r.wholeRange),message:r.message}}async $provideResponse(E,v,a,m){const o=this.b.get(E);if(!o)return;const n=this.d.get(v.id);if(!n)return;const i={prompt:a.prompt,selection:b.Selection.to(a.selection),wholeRange:b.Range.to(a.wholeRange),attempt:a.attempt,live:a.live,previewDocument:this.f.getDocument(M.URI.revive(a.previewDocument)),withIntentDetection:a.withIntentDetection};let r=!1;const s={report:async S=>{if(!a.live&&S.edits?.length)throw new Error("Progress reporting is only supported for live sessions");r||m.isCancellationRequested||await this.e.$handleProgressChunk(a.requestId,{message:S.message,edits:S.edits?.map(b.TextEdit.from),editsShouldBeInstant:S.editsShouldBeInstant,slashCommand:S.slashCommand?.command,markdownFragment:$.$OM.isMarkdownString(S.content)?S.content.value:S.content})}},t=Promise.resolve(o.provider.provideInteractiveEditorResponse(n.session,i,s,m));let f;try{f=await(0,u.$9g)(t,m)}finally{r=!0}if(!f)return;const d=n.responses.push(f)-1,l={wholeRange:b.Range.from(f.wholeRange),placeholder:f.placeholder};if(!I.h(f))return{...l,id:d,type:"editorEdit",message:b.MarkdownString.from(f.contents),edits:[]};const{edits:c,contents:h}=f,g=h!==void 0?b.MarkdownString.from(h):void 0;return c instanceof $.$xM?{...l,id:d,type:"bulkEdit",edits:b.WorkspaceEdit.from(c),message:g}:{...l,id:d,type:"editorEdit",edits:c.map(b.TextEdit.from),message:g}}async $provideFollowups(E,v,a,m){const o=this.b.get(E),n=this.d.get(v),i=n?.responses[a];if(o&&i&&o.provider.provideFollowups){const r=Promise.resolve(o.provider.provideFollowups(n.session,i,m));return(await(0,u.$9g)(r,m))?.map(b.ChatInlineFollowup.from)}}$handleFeedback(E,v,a,m){const o=this.b.get(E),n=this.d.get(v),i=n?.responses[a];if(o&&i){const r=b.InteractiveEditorResponseFeedbackKind.to(m);o.provider.handleInteractiveEditorResponseFeedback?.(n.session,i,r)}}$releaseSession(E,v){}static h(E){return typeof E=="object"&&typeof E.edits=="object"}}e.$jkc=I}),define(ke[352],Ee([1,0,2,33]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wkc=void 0;class M{constructor(R,b,$,y,A){this.a=b,this.b=$,this.c=y;const I=new L.$7O("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.$5O("showOptions","Show Options",p=>!0,p=>p),new L.$5O("resource","Interactive resource Uri",p=>!0,p=>p),new L.$5O("controllerId","Notebook controller Id",p=>!0,p=>p),new L.$5O("title","Interactive editor title",p=>!0,p=>p)],new L.$6O("Notebook and input URI",p=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",p.notebookEditorId),p.notebookEditorId!==void 0){const E=this.a.getEditorById(p.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:u.URI.revive(p.notebookUri),inputUri:u.URI.revive(p.inputUri),notebookEditor:E.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",p.notebookUri,p.inputUri),{notebookUri:u.URI.revive(p.notebookUri),inputUri:u.URI.revive(p.inputUri)}}));this.c.registerApiCommand(I)}$willAddInteractiveDocument(R,b,$,y){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:$,uri:R,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(R,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$wkc=M}),define(ke[353],Ee([1,0,19,8,22,4,3,27,2,25,12,6,33,16,7,113,295,26,68,296]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v,a,m,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ekc=void 0,e.$Fkc=c;let r=class{constructor(g,S,w,C,k){this.m=S,this.n=w,this.o=C,this.q=k,this.b=new b.$Bc,this.c=new b.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new P.$7d,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=g.getProxy(I.$lM.MainThreadNotebookKernels);const D=new p.$7O("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new p.$5O("options","Select kernel options",F=>!0,F=>{if(F&&"notebookEditor"in F&&"id"in F){const T=this.n.getIdByEditor(F.notebookEditor);return{id:F.id,extension:F.extension,notebookEditorId:T}}else if(F&&"notebookEditor"in F){const T=this.n.getIdByEditor(F.notebookEditor);if(T===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${F.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:T}}return F})],p.$6O.Void),O=new p.$7O("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[p.$5O.Uri],new p.$6O("A promise that resolves to an array of variables",(F,T)=>F.map(z=>({variable:{name:z.name,value:z.value,expression:z.expression,type:z.type,language:z.language},hasNamedChildren:z.hasNamedChildren,indexedChildrenCount:z.indexedChildrenCount}))));this.o.registerApiCommand(D),this.o.registerApiCommand(O)}createNotebookController(g,S,w,C,k,D){for(const me of this.j.values())if(me.controller.id===S&&y.$Dm.equals(g.identifier,me.extensionId))throw new Error(`notebook controller with id '${S}' ALREADY exist`);const O=this.k++,F=this;this.q.trace(`NotebookController[${O}], CREATED by ${g.identifier.value}, ${S}`);const T=()=>console.warn(`NO execute handler from notebook controller '${B.id}' of extension: '${g.identifier}'`);let z=!1;const j=new P.$7d,N=new P.$7d,B={id:c(g.identifier,S),notebookType:w,extensionId:g.identifier,extensionLocation:g.extensionLocation,label:C||g.identifier.value,preloads:D?D.map(E.NotebookRendererScript.from):[]};let W=k??T,Z,_;this.a.$addKernel(O,B).catch(me=>{console.log(me),z=!0});let X=0;const x=()=>{if(z)return;const me=++X;Promise.resolve().then(()=>{me===X&&this.a.$updateKernel(O,B)})},re=new b.$Bc,Y={get id(){return S},get notebookType(){return B.notebookType},onDidChangeSelectedNotebooks:j.event,get label(){return B.label},set label(me){B.label=me??g.displayName??g.name,x()},get detail(){return B.detail??""},set detail(me){B.detail=me,x()},get description(){return B.description??""},set description(me){B.description=me,x()},get supportedLanguages(){return B.supportedLanguages},set supportedLanguages(me){B.supportedLanguages=me,x()},get supportsExecutionOrder(){return B.supportsExecutionOrder??!1},set supportsExecutionOrder(me){B.supportsExecutionOrder=me,x()},get rendererScripts(){return B.preloads?B.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return W},set executeHandler(me){W=me??T},get interruptHandler(){return Z},set interruptHandler(me){Z=me,B.supportsInterrupt=!!me,x()},set variableProvider(me){(0,o.$0F)(g,"notebookVariableProvider"),_=me,B.hasVariableProvider=!!me,me?.onDidChangeVariables(Ce=>F.a.$variablesUpdated(Ce.uri)),x()},get variableProvider(){return _},createNotebookCellExecution(me){if(z)throw new Error("notebook controller is DISPOSED");if(!re.has(me.notebook.uri))throw F.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(re.keys()).map(Ce=>Ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${me.notebook.uri.toString()}`);return F._createNotebookCellExecution(me,c(g.identifier,this.id))},createNotebookExecution(me){if((0,o.$0F)(g,"notebookExecution"),z)throw new Error("notebook controller is DISPOSED");if(!re.has(me.uri))throw F.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(re.keys()).map(Ce=>Ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${me.uri.toString()}`);return F._createNotebookExecution(me,c(g.identifier,this.id))},dispose:()=>{z||(this.q.trace(`NotebookController[${O}], DISPOSED`),z=!0,this.j.delete(O),j.dispose(),N.dispose(),this.a.$removeKernel(O))},updateNotebookAffinity(me,Ce){Ce===v.NotebookControllerAffinity2.Hidden&&(0,o.$0F)(g,"notebookControllerAffinityHidden"),F.a.$updateNotebookPriority(O,me.uri,Ce)},onDidReceiveMessage:N.event,postMessage(me,Ce){return(0,o.$0F)(g,"notebookMessaging"),F.a.$postMessage(O,Ce&&F.n.getIdByEditor(Ce),me)},asWebviewUri(me){return(0,o.$0F)(g,"notebookMessaging"),(0,a.$$yb)(me,F.m.remote)}};return this.j.set(O,{extensionId:g.identifier,controller:Y,onDidReceiveMessage:N,onDidChangeSelection:j,associatedNotebooks:re}),Y}getIdByController(g){for(const[S,w]of this.j)if(w.controller===g)return c(w.extensionId,g.id);return null}createNotebookControllerDetectionTask(g,S){const w=this.g++,C=this;this.q.trace(`NotebookControllerDetectionTask[${w}], CREATED by ${g.identifier.value}`),this.a.$addKernelDetectionTask(w,S);const k={dispose:()=>{this.f.delete(w),C.a.$removeKernelDetectionTask(w)}};return this.f.set(w,k),k}registerKernelSourceActionProvider(g,S,w){const C=this.i++,k=typeof w.onDidChangeNotebookKernelSourceActions=="function"?C:void 0,D=this;this.h.set(C,w),this.q.trace(`NotebookKernelSourceActionProvider[${C}], CREATED by ${g.identifier.value}`),this.a.$addKernelSourceActionProvider(C,C,S);let O;return k!==void 0&&(O=w.onDidChangeNotebookKernelSourceActions(F=>this.a.$emitNotebookKernelSourceActionsChangeEvent(k))),{dispose:()=>{this.h.delete(C),D.a.$removeKernelSourceActionProvider(C,C),O?.dispose()}}}async $provideKernelSourceActions(g,S){const w=this.h.get(g);if(w){const C=new R.$Tc;return(await w.provideNotebookKernelSourceActions(S)??[]).map(D=>E.NotebookKernelSourceAction.from(D,this.o.converter,C))}return[]}$acceptNotebookAssociation(g,S,w){const C=this.j.get(g);if(C){const k=this.n.getNotebookDocument($.URI.revive(S));w?C.associatedNotebooks.set(k.uri,!0):C.associatedNotebooks.delete(k.uri),this.q.trace(`NotebookController[${g}] ASSOCIATE notebook`,k.uri.toString(),w),C.onDidChangeSelection.fire({selected:w,notebook:k.apiNotebook})}}async $executeCells(g,S,w){const C=this.j.get(g);if(!C)return;const k=this.n.getNotebookDocument($.URI.revive(S)),D=[];for(const O of w){const F=k.getCell(O);F&&D.push(F.apiCell)}try{this.q.trace(`NotebookController[${g}] EXECUTE cells`,k.uri.toString(),D.length),await C.controller.executeHandler.call(C.controller,D,k.apiNotebook,C.controller)}catch(O){this.q.error(`NotebookController[${g}] execute cells FAILED`,O),console.error(O)}}async $cancelCells(g,S,w){const C=this.j.get(g);if(!C)return;const k=this.n.getNotebookDocument($.URI.revive(S));if(C.controller.interruptHandler)await C.controller.interruptHandler.call(C.controller,k.apiNotebook);else for(const D of w){const O=k.getCell(D);O&&this.b.get(O.uri)?.cancel()}if(C.controller.interruptHandler){const D=this.c.get(k.uri);w.length&&Array.isArray(D)&&D.length&&D.forEach(O=>O.dispose())}}async $provideVariables(g,S,w,C,k,D,O){const F=this.j.get(g);if(!F)return;const T=this.n.getNotebookDocument($.URI.revive(w)),z=F.controller.variableProvider;if(!z)return;let j;if(C!==void 0){if(j=this.s[C],!j)return}else this.s={};const N=k==="named"?v.NotebookVariablesRequestKind.Named:v.NotebookVariablesRequestKind.Indexed,B=z.provideVariables(T.apiNotebook,j,N,D,O);let W=0;for await(const Z of B){if(O.isCancellationRequested)return;const _={id:this.r++,name:Z.variable.name,value:Z.variable.value,type:Z.variable.type,language:Z.variable.language,expression:Z.variable.expression,hasNamedChildren:Z.hasNamedChildren,indexedChildrenCount:Z.indexedChildrenCount,extensionId:F.extensionId.value};if(this.s[_.id]=Z.variable,this.a.$receiveVariable(S,_),W++>=i.$Ahb)return}}$acceptKernelMessageFromRenderer(g,S,w){const C=this.j.get(g);if(!C)return;const k=this.n.getEditorById(S);C.onDidReceiveMessage.fire(Object.freeze({editor:k.apiEditor,message:w}))}$cellExecutionChanged(g,S,w){const k=this.n.getNotebookDocument($.URI.revive(g)).getCell(S);if(k){const D=w?E.NotebookCellExecutionState.to(w):v.NotebookCellExecutionState.Idle;D!==void 0&&this.l.fire({cell:k.apiCell,state:D})}}_createNotebookCellExecution(g,S){if(g.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const C=this.n.getNotebookDocument(g.notebook.uri).getCellFromApiCell(g);if(!C)throw new Error("invalid cell");if(this.b.has(C.uri))throw new Error(`duplicate execution for ${C.uri}`);const k=new t(S,C,this.a);this.b.set(C.uri,k);const D=k.onDidChangeState(()=>{k.state===s.Resolved&&(k.dispose(),D.dispose(),this.b.delete(C.uri))});return k.asApiObject()}_createNotebookExecution(g,S){const w=this.n.getNotebookDocument(g.uri),C=g.getCells().find(O=>{const F=w.getCellFromApiCell(O);return F&&this.b.has(F.uri)});if(C)throw new Error(`duplicate cell execution for ${C.document.uri}`);if(this.c.has(w.uri))throw new Error(`duplicate notebook execution for ${w.uri}`);const k=new d(S,w,this.a),D=k.onDidChangeState(()=>{k.state===f.Resolved&&(k.dispose(),D.dispose(),this.c.delete(w.uri))});return this.c.set(w.uri,[k,D]),k.asApiObject()}};e.$Ekc=r,e.$Ekc=r=Je([qe(4,A.$Oj)],r);var s;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(s||(s={}));class t extends R.$Uc{static{this.a=0}get state(){return this.f}constructor(g,S,w){super(),this.m=S,this.n=w,this.b=t.a++,this.c=new P.$7d,this.onDidChangeState=this.c.event,this.f=s.Init,this.g=this.B(new M.$ee),this.h=new l(10,C=>this.s(C)),this.j=S.internalMetadata.executionOrder,this.n.$createExecution(this.b,g,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(g){await this.h.addItem(g)}async s(g){const S=Array.isArray(g)?g:[g];return this.n.$updateExecution(this.b,new n.$ew(S))}t(){if(this.f===s.Init)throw new Error("Must call start before modifying cell output");if(this.f===s.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(g){let S=this.m;if(g&&(S=this.m.notebook.getCellFromApiCell(g)),!S)throw new Error("INVALID cell");return S.handle}y(g){return g.map(S=>{const w=v.$SN.ensureUniqueMimeTypes(S.items,!0);return w===S.items?E.NotebookCellOutput.from(S):E.NotebookCellOutput.from({items:w,id:S.id,metadata:S.metadata})})}async z(g,S,w){const C=this.w(S),k=this.y((0,u.$3b)(g));return this.r({editType:m.CellExecutionUpdateType.Output,cellHandle:C,append:w,outputs:k})}async C(g,S,w){return g=v.$SN.ensureUniqueMimeTypes((0,u.$3b)(g),!0),this.r({editType:m.CellExecutionUpdateType.OutputItems,items:g.map(E.NotebookCellOutputItem.from),outputId:S.id,append:w})}asApiObject(){const g=this;return Object.freeze({get token(){return g.g.token},get cell(){return g.m.apiCell},get executionOrder(){return g.j},set executionOrder(w){g.j=w,g.s([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:g.j}])},start(w){if(g.f===s.Resolved||g.f===s.Started)throw new Error("Cannot call start again");g.f=s.Started,g.c.fire(),g.s({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:w})},end(w,C,k){if(g.f===s.Resolved)throw new Error("Cannot call resolve twice");g.f=s.Resolved,g.c.fire(),g.h.flush();const D=k?{message:k.message,stack:k.stack,location:k?.location?{startLineNumber:k.location.start.line,startColumn:k.location.start.character,endLineNumber:k.location.end.line,endColumn:k.location.end.character}:void 0,uri:k.uri}:void 0;g.n.$completeExecution(g.b,new n.$ew({runEndTime:C,lastRunSuccess:w,error:D}))},clearOutput(w){return g.t(),g.z([],w,!1)},appendOutput(w,C){return g.t(),g.z(w,C,!0)},replaceOutput(w,C){return g.t(),g.z(w,C,!1)},appendOutputItems(w,C){return g.t(),g.C(w,C,!0)},replaceOutputItems(w,C){return g.t(),g.C(w,C,!1)}})}}var f;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(f||(f={}));class d extends R.$Uc{static{this.a=0}get state(){return this.f}constructor(g,S,w){super(),this.h=S,this.j=w,this.b=d.a++,this.c=new P.$7d,this.onDidChangeState=this.c.event,this.f=f.Init,this.g=this.B(new M.$ee),this.j.$createNotebookExecution(this.b,g,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===f.Resolved||this.f===f.Started)throw new Error("Cannot call start again");this.f=f.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===f.Resolved)throw new Error("Cannot call resolve twice");this.f=f.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class l{constructor(g,S){this.f=g,this.g=S,this.a=[],this.b=Date.now()}addItem(g){return this.a.push(g),this.c||(this.c=new L.$Fh,this.b=Date.now(),(0,L.$jh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const g=this.c;this.c=void 0;const S=this.a;return this.a=[],this.g(S).finally(()=>g.complete())}}function c(h,g){return`${h.value}/${g}`}}),define(ke[47],Ee([1,0,4,6,5,2,20,3,7,226,13,271,22,30,272,56,8,16,33]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v,a,m,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tjc=e.$Sjc=e.$Rjc=e.$Qjc=void 0,e.$Qjc=(0,M.$ii)("IExtHostTerminalService");class i{constructor(w,C,k,D){this.l=w,this._id=C,this.m=k,this.n=D,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(F=>this.f=F);const O=this;this.value={get name(){return O.n||""},get processId(){return O.b},get creationOptions(){return O.m},get exitStatus(){return O.h},get state(){return O.j},get selection(){return O.k},sendText(F,T=!0){O.q(),O.l.$sendText(O._id,F,T)},show(F){O.q(),O.l.$show(O._id,F)},hide(){O.q(),O.l.$hide(O._id)},dispose(){O.a||(O.a=!0,O.l.$dispose(O._id))},get dimensions(){if(!(O.d===void 0||O.g===void 0))return{columns:O.d,rows:O.g}}}}async create(w,C){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:w.name,shellPath:w.shellPath??void 0,shellArgs:w.shellArgs??void 0,cwd:w.cwd??C?.cwd??void 0,env:w.env??void 0,icon:c(w.iconPath)??void 0,color:a.ThemeColor.isThemeColor(w.color)?w.color.id:void 0,initialText:w.message??void 0,strictEnv:w.strictEnv??void 0,hideFromUser:w.hideFromUser??void 0,forceShellIntegration:C?.forceShellIntegration??void 0,isFeatureTerminal:C?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:C?.useShellEnvironment??void 0,location:C?.location||this.o(w.location,C?.resolvedExtHostIdentifier),isTransient:w.isTransient??void 0})}async createExtensionTerminal(w,C,k,D,O){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:D,color:a.ThemeColor.isThemeColor(O)?O.id:void 0,location:C?.location||this.o(w,k),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(w,C){return typeof w=="object"?"parentTerminal"in w&&w.parentTerminal&&C?{parentTerminal:C}:"viewColumn"in w?{viewColumn:o.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus}:void 0:w}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(w){this.n=w}setExitStatus(w,C){this.h=Object.freeze({code:w,reason:C})}setDimensions(w,C){return w===this.d&&C===this.g||w===0||C===0?!1:(this.d=w,this.g=C,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(w){this.k=w}_setProcessId(w){this.f?(this.f(w),this.f=void 0):this.b.then(C=>{C!==w&&(this.b=Promise.resolve(w))})}}e.$Rjc=i;class r{get onProcessReady(){return this.b.event}constructor(w){this.g=w,this.id=0,this.shouldPersist=!1,this.a=new u.$7d,this.onProcessData=this.a.event,this.b=new u.$7d,this.d=new u.$7d,this.onDidChangeProperty=this.d.event,this.f=new u.$7d,this.onProcessExit=this.f.event}refreshProperty(w){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${w}`)}updateProperty(w,C){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${w}, value: ${C}`)}async start(){}shutdown(){this.g.close()}input(w){this.g.handleInput?.(w)}resize(w,C){this.g.setDimensions?.({columns:w,rows:C})}clearBuffer(){}async processBinary(w){}acknowledgeDataEvent(w){}async setUnicodeVersion(w){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(w){this.g.onDidWrite(C=>this.a.fire(C)),this.g.onDidClose?.((C=void 0)=>{this.f.fire(C===void 0?void 0:C)}),this.g.onDidOverrideDimensions?.(C=>{C&&this.d.fire({type:"overrideDimensions",value:{cols:C.columns,rows:C.rows}})}),this.g.onDidChangeName?.(C=>{this.d.fire({type:"title",value:C})}),this.g.open(w||void 0),w&&this.g.setDimensions?.(w),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let s=1,t=class extends b.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(w=>w.value)}constructor(w,C,k){super(),this.Q=C,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new u.$7d,this.onDidCloseTerminal=this.H.event,this.I=new u.$7d,this.onDidOpenTerminal=this.I.event,this.J=new u.$7d,this.onDidChangeActiveTerminal=this.J.event,this.L=new u.$7d,this.onDidChangeTerminalDimensions=this.L.event,this.M=new u.$7d,this.onDidChangeTerminalState=this.M.event,this.N=new u.$7d,this.onDidChangeShell=this.N.event,this.O=new u.$7d({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new u.$7d({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=k.getProxy(L.$lM.MainThreadTerminalService),this.y=new v.$Cub(this.a.$sendProcessData),this.a.$registerProcessSupport(w),this.Q.registerArgumentProcessor({processArgument:D=>{const O=F=>{const T=F;return this.W(T.instanceId)?.value};switch(D?.$mid){case 15:return O(D);default:{if(Array.isArray(D))for(let F=0;F<D.length&&D[F].$mid===15;F++)D[F]=O(D[F]);return D}}}}),this.B({dispose:()=>{for(const[D,O]of this.g)O.shutdown(!0)}})}getDefaultShell(w){return(w?this.u:this.s)?.path||""}getDefaultShellArgs(w){return(w?this.u:this.s)?.args||[]}createExtensionTerminal(w,C){const k=new i(this.a,(0,E.$Eg)(),w,w.name),D=new r(w.pty);return k.createExtensionTerminal(w.location,C,this.R(w,C).resolvedExtHostIdentifier,c(w.iconPath),h(w.color)).then(O=>{const F=this.S(O,D);this.h[O]=F}),this.f.push(k),k.value}R(w,C){if(C=C||{},w.location&&typeof w.location=="object"&&"parentTerminal"in w.location){const k=w.location.parentTerminal;if(k){const D=this.f.find(O=>O.value===k);D&&(C.resolvedExtHostIdentifier=D._id)}}else w.location&&typeof w.location!="object"?C.location=w.location:C.location&&typeof C.location=="object"&&"splitActiveTerminal"in C.location&&(C.location={splitActiveTerminal:!0});return C}attachPtyToTerminal(w,C){if(!this.W(w))throw new Error(`Cannot resolve terminal with id ${w} for virtual process`);const D=new r(C),O=this.S(w,D);this.h[w]=O}async $acceptActiveTerminalChanged(w){const C=this.b;if(w===null){this.b=void 0,C!==this.b&&this.J.fire(this.b);return}const k=this.W(w);k&&(this.b=k,C!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(w,C){const k=this.W(w);k&&this.O.fire({terminal:k.value,data:C})}async $acceptTerminalDimensions(w,C,k){const D=this.W(w);D&&D.setDimensions(C,k)&&this.L.fire({terminal:D.value,dimensions:D.value.dimensions})}async $acceptDidExecuteCommand(w,C){const k=this.W(w);k&&this.P.fire({terminal:k.value,...C})}async $acceptTerminalMaximumDimensions(w,C,k){this.g.get(w)?.resize(C,k)}async $acceptTerminalTitleChange(w,C){const k=this.W(w);k&&(k.name=C)}async $acceptTerminalClosed(w,C,k){const D=this.Y(this.f,w);if(D!==null){const O=this.f.splice(D,1)[0];O.setExitStatus(C,k),this.H.fire(O.value)}}$acceptTerminalOpened(w,C,k,D){if(C){const T=this.Y(this.f,C);if(T!==null){this.f[T]._id=w,this.I.fire(this.terminals[T]),this.f[T].isOpen=!0;return}}const O={name:D.name,shellPath:D.executable,shellArgs:D.args,cwd:typeof D.cwd=="string"?D.cwd:P.URI.revive(D.cwd),env:D.env,hideFromUser:D.hideFromUser},F=new i(this.a,w,O,k);this.f.push(F),this.I.fire(F.value),F.isOpen=!0}async $acceptTerminalProcessId(w,C){this.W(w)?._setProcessId(C)}async $startExtensionTerminal(w,C){const k=this.W(w);if(!k)return{message:(0,y.localize)(0,null,w)};k.isOpen||await new Promise(O=>{const F=this.onDidOpenTerminal(async T=>{T===k.value&&(F.dispose(),O())})});const D=this.g.get(w);D?D.startSendingEvents(C):this.j[w]={initialDimensions:C}}S(w,C){const k=new b.$Tc;k.add(C.onProcessReady(O=>this.a.$sendProcessReady(w,O.pid,O.cwd,O.windowsPty))),k.add(C.onDidChangeProperty(O=>this.a.$sendProcessProperty(w,O))),this.y.startBuffering(w,C.onProcessData),k.add(C.onProcessExit(O=>this.U(w,O))),this.g.set(w,C);const D=this.j[w];return D&&C instanceof r&&(C.startSendingEvents(D.initialDimensions),delete this.j[w]),k}$acceptProcessAckDataEvent(w,C){this.g.get(w)?.acknowledgeDataEvent(C)}$acceptProcessInput(w,C){this.g.get(w)?.input(C)}$acceptTerminalInteraction(w){const C=this.W(w);C?.setInteractedWith()&&this.M.fire(C.value)}$acceptTerminalSelection(w,C){this.W(w)?.setSelection(C)}$acceptProcessResize(w,C,k){try{this.g.get(w)?.resize(C,k)}catch(D){if(D.code!=="EPIPE"&&D.code!=="ERR_IPC_CHANNEL_CLOSED")throw D}}$acceptProcessShutdown(w,C){this.g.get(w)?.shutdown(C)}$acceptProcessRequestInitialCwd(w){this.g.get(w)?.getInitialCwd().then(C=>this.a.$sendProcessProperty(w,{type:"initialCwd",value:C}))}$acceptProcessRequestCwd(w){this.g.get(w)?.getCwd().then(C=>this.a.$sendProcessProperty(w,{type:"cwd",value:C}))}$acceptProcessRequestLatency(w){return Promise.resolve(w)}registerLinkProvider(w){return this.z.add(w),this.z.size===1&&this.a.$startLinkProvider(),new $.$nM(()=>{this.z.delete(w),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(w,C,k){if(this.C.has(C))throw new Error(`Terminal profile provider "${C}" already registered`);return this.C.set(C,k),this.a.$registerProfileProvider(C,w.identifier.value),new $.$nM(()=>{this.C.delete(C),this.a.$unregisterProfileProvider(C)})}registerTerminalQuickFixProvider(w,C,k){if(this.D.has(w))throw new Error(`Terminal quick fix provider "${w}" is already registered`);return this.D.set(w,k),this.a.$registerQuickFixProvider(w,C),new $.$nM(()=>{this.D.delete(w),this.a.$unregisterQuickFixProvider(w)})}async $provideTerminalQuickFixes(w,C){const k=new p.$ee().token;if(k.isCancellationRequested)return;const D=this.D.get(w);if(!D)return;const O=await D.provideTerminalQuickFixes(C,k);if(O===null||Array.isArray(O)&&O.length===0)return;const F=new b.$Tc;if(this.w.value=F,!Array.isArray(O))return O?o.TerminalQuickFix.from(O,this.Q.converter,F):void 0;const T=[];for(const z of O){const j=o.TerminalQuickFix.from(z,this.Q.converter,F);j&&T.push(j)}return T}async $createContributedProfileTerminal(w,C){const k=new p.$ee().token;let D=await this.C.get(w)?.provideTerminalProfile(k);if(!k.isCancellationRequested){if(D&&!("options"in D)&&(D={options:D}),!D||!("options"in D))throw new Error(`No terminal profile options provided for id "${w}"`);if("pty"in D.options){this.createExtensionTerminal(D.options,C);return}this.createTerminalFromOptions(D.options,C)}}async $provideLinks(w,C){const k=this.W(w);if(!k)return[];this.F.delete(w),this.G.get(w)?.dispose(!0);const O=new p.$ee;this.G.set(w,O);const F=[],T={terminal:k.value,line:C},z=[];for(const B of this.z)z.push(m.Promises.withAsyncBody(async W=>{O.token.onCancellationRequested(()=>W({provider:B,links:[]}));const Z=await B.provideTerminalLinks(T,O.token)||[];O.token.isCancellationRequested||W({provider:B,links:Z})}));const j=await Promise.all(z);if(O.token.isCancellationRequested)return[];const N=new Map;for(const B of j)B&&B.links.length>0&&F.push(...B.links.map(W=>{const Z={id:s++,startIndex:W.startIndex,length:W.length,label:W.tooltip};return N.set(Z.id,{provider:B.provider,link:W}),Z}));return this.F.set(w,N),F}$activateLink(w,C){const k=this.F.get(w)?.get(C);k&&k.provider.handleTerminalLink(k.link)}U(w,C){this.y.stopBuffering(w),this.g.delete(w),delete this.j[w];const k=this.h[w];k&&(k.dispose(),delete this.h[w]),this.a.$sendProcessExit(w,C)}W(w){return this.X(this.f,w)}X(w,C){const k=this.Y(w,C);return k!==null?w[k]:null}Y(w,C){const k=w.findIndex(D=>D._id===C);return k===-1?null:k}getEnvironmentVariableCollection(w){let C=this.n.get(w.identifier.value);return C||(C=new f,this.$(w.identifier.value,C)),C.getScopedEnvironmentVariableCollection(void 0)}Z(w,C){const k=(0,I.$7r)(C.map),D=(0,I.$8r)(C.descriptionMap);this.a.$setEnvironmentVariableCollection(w,C.persistent,k.length===0?void 0:k,D)}$initEnvironmentVariableCollections(w){w.forEach(C=>{const k=C[0],D=new f(C[1]);this.$(k,D)})}$acceptDefaultProfile(w,C){const k=this.s;this.s=w,this.u=C,k?.path!==w.path&&this.N.fire(w.path)}$(w,C){this.n.set(w,C),C.onDidChangeCollection(()=>{this.Z(w,C)})}};e.$Sjc=t,e.$Sjc=t=Je([qe(1,n.$3O),qe(2,R.$GO)],t);class f{get persistent(){return this.b}set persistent(w){this.b=w,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(w){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new u.$7d,this.map=new Map(w)}getScopedEnvironmentVariableCollection(w){const C=this.h(w);let k=this.a.get(C);return k||(k=new d(this,w),this.a.set(C,k),k.onDidChangeCollection(()=>this.d.fire())),k}replace(w,C,k,D){this.f(w,{value:C,type:$.EnvironmentVariableMutatorType.Replace,options:k??{applyAtProcessCreation:!0},scope:D})}append(w,C,k,D){this.f(w,{value:C,type:$.EnvironmentVariableMutatorType.Append,options:k??{applyAtProcessCreation:!0},scope:D})}prepend(w,C,k,D){this.f(w,{value:C,type:$.EnvironmentVariableMutatorType.Prepend,options:k??{applyAtProcessCreation:!0},scope:D})}f(w,C){if(C.options&&C.options.applyAtProcessCreation===!1&&!C.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const k=this.g(w,C.scope),D=this.map.get(k),O=C.options?{applyAtProcessCreation:C.options.applyAtProcessCreation??!1,applyAtShellIntegration:C.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!D||D.value!==C.value||D.type!==C.type||D.options?.applyAtProcessCreation!==O.applyAtProcessCreation||D.options?.applyAtShellIntegration!==O.applyAtShellIntegration||D.scope?.workspaceFolder?.index!==C.scope?.workspaceFolder?.index){const F=this.g(w,C.scope),T={variable:w,...C,options:O};this.map.set(F,T),this.d.fire()}}get(w,C){const k=this.g(w,C),D=this.map.get(k);return D?g(D):void 0}g(w,C){const k=this.h(C);return k.length?`${w}:::${k}`:w}h(w){return this.j(w?.workspaceFolder)??""}j(w){return w?w.uri.toString():void 0}getVariableMap(w){const C=new Map;for(const[k,D]of this.map)this.h(D.scope)===this.h(w)&&C.set(D.variable,g(D));return C}delete(w,C){const k=this.g(w,C);this.map.delete(k),this.d.fire()}clear(w){if(w?.workspaceFolder){for(const[C,k]of this.map)k.scope?.workspaceFolder?.index===w.workspaceFolder.index&&this.map.delete(C);this.k(w)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(w,C){const k=this.h(C),D=this.descriptionMap.get(k);if(!D||D.description!==w){let O;typeof w=="string"?O=w:O=w?.value.split(`

`)[0];const F={description:O,scope:C};this.descriptionMap.set(k,F),this.d.fire()}}getDescription(w){const C=this.h(w);return this.descriptionMap.get(C)?.description}k(w){const C=this.h(w);this.descriptionMap.delete(C)}}class d{get persistent(){return this.b.persistent}set persistent(w){this.b.persistent=w}get onDidChangeCollection(){return this.a&&this.a.event}constructor(w,C){this.b=w,this.d=C,this.a=new u.$7d}getScoped(w){return this.b.getScopedEnvironmentVariableCollection(w)}replace(w,C,k){this.b.replace(w,C,k,this.d)}append(w,C,k){this.b.append(w,C,k,this.d)}prepend(w,C,k){this.b.prepend(w,C,k,this.d)}get(w){return this.b.get(w,this.d)}forEach(w,C){this.b.getVariableMap(this.d).forEach((k,D)=>w.call(C,D,k,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(w){this.b.delete(w,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(w){this.b.setDescription(w,this.d)}get description(){return this.b.getDescription(this.d)}}let l=class extends t{constructor(w,C){super(!1,w,C)}createTerminal(w,C,k){throw new A.$_}createTerminalFromOptions(w,C){throw new A.$_}};e.$Tjc=l,e.$Tjc=l=Je([qe(0,n.$3O),qe(1,R.$GO)],l);function c(S){if(!(!S||typeof S=="string"))return"id"in S?{id:S.id,color:S.color}:S}function h(S){return a.ThemeColor.isThemeColor(S)?S:void 0}function g(S){const w={...S};return delete w.scope,w.options=w.options??void 0,delete w.variable,w}}),define(ke[354],Ee([1,0,8,21,22,4,74,55,3,18,30,12,6,20,154,16,7,67,112,89,26]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v,a,m,o,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zkc=e.$Ykc=e.$Xkc=e.$Wkc=void 0;let s=class extends $.$Uc{constructor(F,T,z,j){super(),this.w=j,this.f=this.B(new P.$7d),this.g=new Map,this.s=this.B(new P.$7d),this.onResultsChanged=this.f.event,this.results=[],this.h=F.getProxy(p.$lM.MainThreadTesting),this.m=new w(this.h),this.j=new l(this.h,T),z.registerArgumentProcessor({processArgument:N=>{switch(N?.$mid){case 16:{const B=N,W=B.tests[B.tests.length-1].item.extId;return this.g.get(o.$0K.root(W))?.collection.tree.get(W)?.actual??(0,v.$SO)(N)}case 18:{const{test:B,message:W}=N,Z=B.item.extId;return{test:this.g.get(o.$0K.root(Z))?.collection.tree.get(Z)?.actual??(0,v.$SO)({$mid:16,tests:[B]}),message:a.TestMessage.to(W)}}default:return N}}}),z.registerCommand(!1,"testing.getExplorerSelection",async()=>{const N=await z.executeCommand("_testing.getExplorerSelection"),B=W=>{const Z=this.g.get(o.$0K.root(W));if(Z)return o.$0K.isRoot(W)?Z.controller:Z.collection.tree.get(W)?.actual};return{include:N?.include.map(B).filter(y.$4f)||[],exclude:N?.exclude.map(B).filter(y.$4f)||[]}})}createTestController(F,T,z,j){if(this.g.has(T))throw new Error(`Attempt to insert a duplicate controller with ID "${T}"`);const N=new $.$Tc,B=N.add(new v.$VO(T,z,this.w));B.root.label=z;const W=new Map,Z=new Set,_=this.h,X={items:B.root.children,get label(){return z},set label(re){z=re,B.root.label=re,_.$updateController(T,{label:z})},get refreshHandler(){return j},set refreshHandler(re){j=re,_.$updateController(T,{canRefresh:!!re})},get id(){return T},createRunProfile:(re,Y,me,Ce,ee,U)=>{let ie=(0,b.$9i)(re);for(;W.has(ie);)ie++;return new k(this.h,W,Z,this.s.event,T,ie,re,Y,me,Ce,ee,U)},createTestItem(re,Y,me){return new v.$TO(T,re,Y,me)},createTestRun:(re,Y,me=!0)=>this.j.createTestRun(F,T,B,re,Y,me),invalidateTestResults:re=>{if(re===void 0)this.h.$markTestRetired(void 0);else{const Y=re instanceof Array?re:[re];this.h.$markTestRetired(Y.map(me=>o.$0K.fromExtHostTestItem(me,T).toString()))}},set resolveHandler(re){B.resolveHandler=re},get resolveHandler(){return B.resolveHandler},dispose:()=>{N.dispose()}};_.$registerTestController(T,z,!!j),N.add((0,$.$Sc)(()=>_.$unregisterTestController(T)));const x={controller:X,collection:B,profiles:W,extension:F,activeProfiles:Z};return this.g.set(T,x),N.add((0,$.$Sc)(()=>this.g.delete(T))),N.add(B.onDidGenerateDiff(re=>_.$publishDiff(T,re.map(i.TestsDiffOp.serialize)))),X}createTestObserver(){return this.m.checkout()}async runTests(F,T=M.CancellationToken.None){const z=c(F);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.g.get(z.controllerId);if(!j)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:F.include?.map(N=>o.$0K.fromExtHostTestItem(N,j.collection.root.id).toString())??[j.collection.root.id],profileGroup:D[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:F.exclude?.map(N=>N.id)},T)}$syncTests(){for(const{collection:F}of this.g.values())F.flushDiff();return Promise.resolve()}async $getCoverageDetails(F,T){return(await this.j.getCoverageDetails(F,T))?.map(a.TestCoverage.fromDetails)}async $disposeRun(F){this.j.disposeTestRun(F)}$configureRunProfile(F,T){this.g.get(F)?.profiles.get(T)?.configureHandler?.()}$setDefaultRunProfiles(F){const T=new Map;for(const[z,j]of Object.entries(F)){const N=this.g.get(z);if(!N)continue;const B=new Map,W=j.filter(_=>!N.activeProfiles.has(_)),Z=[...N.activeProfiles].filter(_=>!j.includes(_));for(const _ of W)B.set(_,!0),N.activeProfiles.add(_);for(const _ of Z)B.set(_,!1),N.activeProfiles.delete(_);B.size&&T.set(z,B)}this.s.fire(T)}async $refreshTests(F,T){await this.g.get(F)?.controller.refreshHandler?.(T)}$publishTestResults(F){this.results=Object.freeze(F.map(a.TestResults.to).concat(this.results).sort((T,z)=>z.completedAt-T.completedAt).slice(0,32)),this.f.fire()}async $expandTest(F,T){const z=this.g.get(o.$0K.fromString(F).controllerId)?.collection;z&&(await z.expand(F,T<0?1/0:T),z.flushDiff())}$acceptDiff(F){this.m.applyDiff(F.map(T=>i.TestsDiffOp.deserialize({asCanonicalUri:z=>z},T)))}async $runControllerTests(F,T){return Promise.all(F.map(z=>this.y(z,!1,T)))}async $startContinuousRun(F,T){const z=new M.$ee(T),j=await Promise.all(F.map(N=>this.y(N,!0,z.token)));return!T.isCancellationRequested&&!j.some(N=>N.error)&&await new Promise(N=>T.onCancellationRequested(N)),z.dispose(!0),j}async y(F,T,z){const j=this.g.get(F.controllerId);if(!j)return{};const{collection:N,profiles:B,extension:W}=j,Z=B.get(F.profileId);if(!Z)return{};const _=F.testIds.map(Y=>N.tree.get(Y)).filter(y.$4f),X=F.excludeExtIds.map(Y=>j.collection.tree.get(Y)).filter(y.$4f).filter(Y=>_.some(me=>me.fullId.compare(Y.fullId)===2));if(!_.length)return{};const x=new m.$ZN(_.some(Y=>Y.actual instanceof v.$UO)?void 0:_.map(Y=>Y.actual),X.map(Y=>Y.actual),Z,T),re=(0,i.$aL)(F)&&this.j.prepareForMainThreadTestRun(x,h.fromInternal(F,j.collection),W,Z,z);try{return await Z.runHandler(x,z),{}}catch(Y){return{error:String(Y)}}finally{re&&re.hasRunningTasks&&!z.isCancellationRequested&&await P.Event.toPromise(re.onEnd)}}$cancelExtensionTestRun(F){F===void 0?this.j.cancelAllRuns():this.j.cancelRunById(F)}};e.$Wkc=s,e.$Wkc=s=Je([qe(0,E.$GO),qe(1,I.$Oj)],s);const t=1e4;var f;(function(O){O[O.Running=0]="Running",O[O.Cancelling=1]="Cancelling",O[O.Ended=2]="Ended"})(f||(f={}));class d extends $.$Uc{get hasRunningTasks(){return this.g>0}get id(){return this.z.id}constructor(F,T,z,j,N,B){super(),this.z=F,this.C=T,this.D=z,this.F=j,this.G=N,this.f=0,this.g=0,this.h=new Map,this.j=new Set,this.s=this.B(new P.$7d),this.y=new Map,this.onEnd=this.s.event,this.m=this.B(new M.$ee(B));const W=this.B(new u.$uh(()=>this.H(),t));this.B(this.m.token.onCancellationRequested(()=>W.schedule()));const Z=new P.$7d;this.w=Z.event,this.B((0,$.$Sc)(()=>{Z.fire(),Z.dispose()}))}cancel(){this.f===0?(this.m.cancel(),this.f=1):this.f===1&&this.H()}getCoverageDetails(F,T){const[,z,j]=o.$0K.fromString(F).path,N=this.y.get(j);if(!N)return[];if(N.backCompatResolve)return N.backCompatResolve(T);const B=this.h.get(z);if(!B)throw new Error("unreachable: run task was not found");return this.G?.loadDetailedCoverage?.(B.run,N.coverage,T)??[]}createRun(F){const T=this.z.id,z=this.z.controllerId,j=(0,A.$Eg)(),N=this.D,B=re=>(Y,...me)=>{if(_){this.F.warn(`Setting the state of test "${Y.id}" is a no-op after the run ends.`);return}this.z.isIncluded(Y)&&(this.J(Y),re(Y,...me))},W=(re,Y)=>{const me=Y instanceof Array?Y.map(a.TestMessage.from):[a.TestMessage.from(Y)];if(re.uri&&re.range){const Ce={range:a.Range.from(re.range),uri:re.uri};for(const ee of me)ee.location=ee.location||Ce}this.C.$appendTestMessagesInRun(T,j,o.$0K.fromExtHostTestItem(re,z).toString(),me)},Z=(re,Y)=>{const me=re.uri.toString(),Ce=new o.$0K([T,j,me]).toString();this.y.set(me,{coverage:re,backCompatResolve:Y}),this.C.$appendCoverage(T,j,a.TestCoverage.fromFile(Ce,re))};let _=!1,X;const x={isPersisted:this.z.isPersisted,token:this.m.token,name:F,onDidDispose:this.w,get coverageProvider(){return X},set coverageProvider(re){(0,r.$0F)(N,"testCoverage"),X=re,re&&Promise.resolve(re.provideFileCoverage(M.CancellationToken.None)).then(Y=>{Y?.forEach(me=>Z(me,re.resolveFileCoverage&&(async Ce=>(await re.resolveFileCoverage(me,Ce)||me).detailedCoverage)))})},addCoverage:re=>{(0,r.$0F)(N,"testCoverage"),Z(re)},enqueued:B(re=>{this.C.$updateTestStateInRun(T,j,o.$0K.fromExtHostTestItem(re,z).toString(),1)}),skipped:B(re=>{this.C.$updateTestStateInRun(T,j,o.$0K.fromExtHostTestItem(re,z).toString(),5)}),started:B(re=>{this.C.$updateTestStateInRun(T,j,o.$0K.fromExtHostTestItem(re,z).toString(),2)}),errored:B((re,Y,me)=>{W(re,Y),this.C.$updateTestStateInRun(T,j,o.$0K.fromExtHostTestItem(re,z).toString(),6,me)}),failed:B((re,Y,me)=>{W(re,Y),this.C.$updateTestStateInRun(T,j,o.$0K.fromExtHostTestItem(re,z).toString(),4,me)}),passed:B((re,Y)=>{this.C.$updateTestStateInRun(T,j,o.$0K.fromExtHostTestItem(re,this.z.controllerId).toString(),3,Y)}),appendOutput:(re,Y,me)=>{_||(me&&(this.z.isIncluded(me)?this.J(me):me=void 0),this.C.$appendOutputToRun(T,j,L.$ue.fromString(re),Y&&a.location.from(Y),me&&o.$0K.fromExtHostTestItem(me,z).toString()))},end:()=>{_||(_=!0,this.C.$finishedTestRunTask(T,j),--this.g||this.I())}};return this.g++,this.h.set(j,{run:x}),this.C.$startedTestRunTask(T,{id:j,name:F,running:!0}),x}H(){for(const{run:F}of this.h.values())F.end()}I(){this.f!==2&&(this.f=2,this.s.fire())}J(F){if(!(F instanceof v.$TO))throw new n.$yO(F.id);if(this.j.has(o.$0K.fromExtHostTestItem(F,this.z.controllerId).toString()))return;const T=[],z=this.z.colllection.root;for(;;){const j=a.TestItem.from(F);if(T.unshift(j),this.j.has(j.extId)||(this.j.add(j.extId),F===z))break;F=F.parent||z}this.C.$addTestsToRun(this.z.controllerId,this.z.id,T)}dispose(){this.I(),super.dispose()}}class l{get trackers(){return this.f.values()}constructor(F,T){this.h=F,this.j=T,this.f=new Map,this.g=new Map}getCoverageDetails(F,T){const z=o.$0K.root(F);return this.g.get(z)?.getCoverageDetails(F,T)||[]}disposeTestRun(F){this.g.get(F)?.dispose(),this.g.delete(F);for(const[T,{id:z}]of this.f)z===F&&this.f.delete(T)}prepareForMainThreadTestRun(F,T,z,j,N){return this.k(F,T,z,j,N)}cancelRunById(F){this.g.get(F)?.cancel()}cancelAllRuns(){for(const F of this.f.values())F.cancel()}createTestRun(F,T,z,j,N,B){const W=this.f.get(j);if(W)return W.createRun(N);const Z=h.fromPublic(T,z,j,B),_=c(j);this.h.$startedExtensionTestRun({controllerId:T,continuous:!!j.continuous,profile:_&&{group:D[_.kind],id:_.profileId},exclude:j.exclude?.map(x=>o.$0K.fromExtHostTestItem(x,z.root.id).toString())??[],id:Z.id,include:j.include?.map(x=>o.$0K.fromExtHostTestItem(x,z.root.id).toString())??[z.root.id],persist:B});const X=this.k(j,Z,F,j.profile);return P.Event.once(X.onEnd)(()=>{this.h.$finishedExtensionTestRun(Z.id)}),X.createRun(N)}k(F,T,z,j,N){const B=new d(T,this.h,z,this.j,j,N);return this.f.set(F,B),this.g.set(B.id,B),B}}e.$Xkc=l;const c=O=>{if(O.profile){if(!(O.profile instanceof k))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return O.profile}};class h{static fromPublic(F,T,z,j){return new h(F,(0,A.$Eg)(),z.include?.map(N=>o.$0K.fromExtHostTestItem(N,F).toString())??[F],z.exclude?.map(N=>o.$0K.fromExtHostTestItem(N,F).toString())??[],j,T)}static fromInternal(F,T){return new h(F.controllerId,F.runId,F.testIds,F.excludeExtIds,!0,T)}constructor(F,T,z,j,N,B){this.controllerId=F,this.id=T,this.isPersisted=N,this.colllection=B,this.f=z.map(W=>W+"\0"),this.g=j.map(W=>W+"\0")}isIncluded(F){const T=o.$0K.fromExtHostTestItem(F,this.controllerId).toString()+"\0";for(const z of this.g)if(T===z||T.startsWith(z))return!1;for(const z of this.f)if(T===z||T.startsWith(z))return!0;return!1}}e.$Ykc=h;class g{get isEmpty(){return this.f.size===0&&this.h.size===0&&this.g.size===0}constructor(F){this.k=F,this.f=new Set,this.g=new Set,this.h=new Set,this.j=new Set}add(F){this.f.add(F)}update(F){Object.assign(F.revived,a.TestItem.toPlain(F.item)),this.f.has(F)||this.g.add(F)}remove(F){if(this.f.has(F)){this.f.delete(F);return}this.g.delete(F);const T=o.$0K.parentId(F.item.extId);if(T&&this.j.has(T.toString())){this.j.add(F.item.extId);return}this.h.add(F)}getChangeEvent(){const{f:F,g:T,h:z}=this;return{get added(){return[...F].map(j=>j.revived)},get updated(){return[...T].map(j=>j.revived)},get removed(){return[...z].map(j=>j.revived)}}}complete(){this.isEmpty||this.k.fire(this.getChangeEvent())}}class S extends i.$gL{constructor(){super(...arguments),this.s=new P.$7d,this.onDidChangeTests=this.s.event}get rootTests(){return this.h}getMirroredTestDataById(F){return this.g.get(F)}getMirroredTestDataByReference(F){return this.g.get(F.id)}x(F,T){return{...F,revived:a.TestItem.toPlain(F.item),depth:T?T.depth+1:0,children:new Set}}w(){return new g(this.s)}}class w{constructor(F){this.g=F}checkout(){this.f||(this.f=this.h());const F=this.f;return F.observers++,{onDidChangeTest:F.tests.onDidChangeTests,get tests(){return[...F.tests.rootTests].map(T=>T.revived)},dispose:(0,R.$db)(()=>{--F.observers===0&&(this.g.$unsubscribeFromDiffs(),this.f=void 0)})}}getMirroredTestDataByReference(F){return this.f?.tests.getMirroredTestDataByReference(F)}applyDiff(F){this.f?.tests.apply(F)}h(){const F=new S({asCanonicalUri:T=>T});return this.g.$subscribeToDiffs(),{observers:0,tests:F}}}const C=(O,F,T,z)=>{T?Object.assign(T,z):F.$updateTestRunConfig(O.controllerId,O.profileId,z)};class k{#e;#t;#i;#n;#s;get label(){return this.g}set label(F){F!==this.g&&(this.g=F,C(this,this.#e,this.#n,{label:F}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(F){F!==this.h&&(this.h=F,C(this,this.#e,this.#n,{supportsContinuousRun:F}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(F){F!==this.isDefault&&(F?this.#t.add(this.profileId):this.#t.delete(this.profileId),C(this,this.#e,this.#n,{isDefault:F}))}get tag(){return this._tag}set tag(F){F?.id!==this._tag?.id&&(this._tag=F,C(this,this.#e,this.#n,{tag:F?a.TestTag.namespace(this.controllerId,F.id):null}))}get configureHandler(){return this.f}set configureHandler(F){F!==this.f&&(this.f=F,C(this,this.#e,this.#n,{hasConfigurationHandler:!!F}))}get onDidChangeDefault(){return P.Event.chain(this.#i,F=>F.map(T=>T.get(this.controllerId)?.get(this.profileId)).filter(y.$4f))}constructor(F,T,z,j,N,B,W,Z,_,X=!1,x=void 0,re=!1){this.controllerId=N,this.profileId=B,this.g=W,this.kind=Z,this.runHandler=_,this._tag=x,this.h=re,this.#e=F,this.#s=T,this.#t=z,this.#i=j,T.set(B,this);const Y=D[Z];if(typeof Y!="number")throw new Error(`Unknown TestRunProfile.group ${Z}`);X&&z.add(B),this.#n={profileId:B,controllerId:N,tag:x?a.TestTag.namespace(this.controllerId,x.id):null,label:W,group:Y,isDefault:X,hasConfigurationHandler:!1,supportsContinuousRun:re},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Zkc=k;const D={[m.TestRunProfileKind.Coverage]:8,[m.TestRunProfileKind.Debug]:4,[m.TestRunProfileKind.Run]:2}}),define(ke[155],Ee([1,0,61,13,124,16,7]),function(he,e,u,L,M,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PO=e.$OO=e.$NO=void 0;class b{static{this.c=new M.$LO("TextEditorDecorationType")}constructor(p,E,v){const a=b.c.nextId();p.$registerTextEditorDecorationType(E.identifier,a,P.DecorationRenderOptions.from(v)),this.value=Object.freeze({key:a,dispose(){p.$removeTextEditorDecorationType(a)}})}}e.$NO=b;class ${constructor(p,E){this.g=[],this.h=void 0,this.j=!1,this.c=p,this.d=p.version,this.e=E.undoStopBefore,this.f=E.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(p,E){this.k();let v=null;if(p instanceof R.$oM)v=new R.$pM(p,p);else if(p instanceof R.$pM)v=p;else throw new Error("Unrecognized location");this.l(v,E,!1)}insert(p,E){this.k(),this.l(new R.$pM(p,p),E,!0)}delete(p){this.k();let E=null;if(p instanceof R.$pM)E=p;else throw new Error("Unrecognized location");this.l(E,null,!0)}l(p,E,v){const a=this.c.validateRange(p);this.g.push({range:a,text:E,forceMoveMarkers:v})}setEndOfLine(p){if(this.k(),p!==R.EndOfLine.LF&&p!==R.EndOfLine.CRLF)throw(0,L.$7)("endOfLine");this.h=p}}class y{constructor(p,E,v,a){this.c=p,this.d=E,this._accept(v),this.e=a;const m=this;this.value={get tabSize(){return m.f},set tabSize(o){m.n(o)},get indentSize(){return m.g},set indentSize(o){m.p(o)},get insertSpaces(){return m.j},set insertSpaces(o){m.s(o)},get cursorStyle(){return m.k},set cursorStyle(o){m.t(o)},get lineNumbers(){return m.l},set lineNumbers(o){m.u(o)}}}_accept(p){this.f=p.tabSize,this.g=p.indentSize,this.h=p.originalIndentSize,this.j=p.insertSpaces,this.k=p.cursorStyle,this.l=P.TextEditorLineNumbersStyle.to(p.lineNumbers)}m(p){if(p==="auto")return"auto";if(typeof p=="number"){const E=Math.floor(p);return E>0?E:null}if(typeof p=="string"){const E=parseInt(p,10);return isNaN(E)?null:E>0?E:null}return null}n(p){const E=this.m(p);if(E!==null){if(typeof E=="number"){if(this.f===E)return;this.f=E}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:E}))}}o(p){if(p==="tabSize")return"tabSize";if(typeof p=="number"){const E=Math.floor(p);return E>0?E:null}if(typeof p=="string"){const E=parseInt(p,10);return isNaN(E)?null:E>0?E:null}return null}p(p){const E=this.o(p);if(E!==null){if(typeof E=="number"){if(this.h===E)return;this.g=E,this.h=E}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:E}))}}q(p){return p==="auto"?"auto":p==="false"?!1:!!p}s(p){const E=this.q(p);if(typeof E=="boolean"){if(this.j===E)return;this.j=E}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:E}))}t(p){this.k!==p&&(this.k=p,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:p})))}u(p){this.l!==p&&(this.l=p,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:P.TextEditorLineNumbersStyle.from(p)})))}assign(p){const E={};let v=!1;if(typeof p.tabSize<"u"){const a=this.m(p.tabSize);a==="auto"?(v=!0,E.tabSize=a):typeof a=="number"&&this.f!==a&&(this.f=a,v=!0,E.tabSize=a)}if(typeof p.indentSize<"u"){const a=this.o(p.indentSize);a==="tabSize"?(v=!0,E.indentSize=a):typeof a=="number"&&this.h!==a&&(this.g=a,this.h=a,v=!0,E.indentSize=a)}if(typeof p.insertSpaces<"u"){const a=this.q(p.insertSpaces);a==="auto"?(v=!0,E.insertSpaces=a):this.j!==a&&(this.j=a,v=!0,E.insertSpaces=a)}typeof p.cursorStyle<"u"&&this.k!==p.cursorStyle&&(this.k=p.cursorStyle,v=!0,E.cursorStyle=p.cursorStyle),typeof p.lineNumbers<"u"&&this.l!==p.lineNumbers&&(this.l=p.lineNumbers,v=!0,E.lineNumbers=P.TextEditorLineNumbersStyle.from(p.lineNumbers)),v&&this.v("setOptions",this.c.$trySetOptions(this.d,E))}v(p,E){E.catch(v=>{this.e.warn(`ExtHostTextEditorOptions '${p}' failed:'`),this.e.warn(v)})}}e.$OO=y;class A{constructor(p,E,v,a,m,o,n,i){this.id=p,this.j=E,this.k=v,this.g=!1,this.h=new Set,this.c=m,this.d=new y(this.j,this.id,o,v),this.e=n,this.f=i;const r=this;this.value=Object.freeze({get document(){return a.value},set document(s){throw new L.$9("document")},get selection(){return r.c&&r.c[0]},set selection(s){if(!(s instanceof R.$qM))throw(0,L.$7)("selection");r.c=[s],r.l()},get selections(){return r.c},set selections(s){if(!Array.isArray(s)||s.some(t=>!(t instanceof R.$qM)))throw(0,L.$7)("selections");r.c=s,r.l()},get visibleRanges(){return r.e},set visibleRanges(s){throw new L.$9("visibleRanges")},get options(){return r.d.value},set options(s){r.g||r.d.assign(s)},get viewColumn(){return r.f},set viewColumn(s){throw new L.$9("viewColumn")},edit(s,t={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const f=new $(a.value,t);return s(f),r.m(f)},insertSnippet(s,t,f={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!t||Array.isArray(t)&&t.length===0)d=r.c.map(l=>P.Range.from(l));else if(t instanceof R.$oM){const{lineNumber:l,column:c}=P.Position.from(t);d=[{startLineNumber:l,startColumn:c,endLineNumber:l,endColumn:c}]}else if(t instanceof R.$pM)d=[P.Range.from(t)];else{d=[];for(const l of t)if(l instanceof R.$pM)d.push(P.Range.from(l));else{const{lineNumber:c,column:h}=P.Position.from(l);d.push({startLineNumber:c,startColumn:h,endLineNumber:c,endColumn:h})}}return E.$tryInsertSnippet(p,a.value.version,s.value,d,f)},setDecorations(s,t){const f=t.length===0;f&&!r.h.has(s.key)||(f?r.h.delete(s.key):r.h.add(s.key),r.n(()=>{if(P.$DO(t))return E.$trySetDecorations(p,s.key,P.$EO(t));{const d=new Array(4*t.length);for(let l=0,c=t.length;l<c;l++){const h=t[l];d[4*l]=h.start.line+1,d[4*l+1]=h.start.character+1,d[4*l+2]=h.end.line+1,d[4*l+3]=h.end.character+1}return E.$trySetDecorationsFast(p,s.key,d)}}))},revealRange(s,t){r.n(()=>E.$tryRevealRange(p,P.Range.from(s),t||R.TextEditorRevealType.Default))},show(s){E.$tryShowEditor(p,P.ViewColumn.from(s))},hide(){E.$tryHideEditor(p)}})}dispose(){(0,u.ok)(!this.g),this.g=!0}_acceptOptions(p){(0,u.ok)(!this.g),this.d._accept(p)}_acceptVisibleRanges(p){(0,u.ok)(!this.g),this.e=p}_acceptViewColumn(p){(0,u.ok)(!this.g),this.f=p}_acceptSelections(p){(0,u.ok)(!this.g),this.c=p}async l(){const p=this.c.map(P.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,p)),this.value}m(p){const E=p.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const v=E.edits.map(m=>m.range);v.sort((m,o)=>m.end.line===o.end.line?m.end.character===o.end.character?m.start.line===o.start.line?m.start.character-o.start.character:m.start.line-o.start.line:m.end.character-o.end.character:m.end.line-o.end.line);for(let m=0,o=v.length-1;m<o;m++){const n=v[m].end;if(v[m+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=E.edits.map(m=>({range:P.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,E.documentVersionId,a,{setEndOfLine:typeof E.setEndOfLine=="number"?P.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}n(p){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):p().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this.k.warn(E),null))}}e.$PO=A}),define(ke[72],Ee([1,0,61,4,3,2,5,6,152,20,155,16,12,27,15,38,45]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RO=e.$QO=void 0;class o{constructor(r){this.value=r,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(r,s){this.h=r,this.i=s,this.a=null,this.b=new Map,this.c=new E.$Bc,this.d=new L.$7d,this.e=new L.$7d,this.f=new L.$7d,this.g=new L.$7d,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const s=[],t=[],f=[];if(r.removedDocuments)for(const d of r.removedDocuments){const l=P.URI.revive(d),c=this.c.get(l);c?.unref()&&(this.c.delete(l),s.push(c.value))}if(r.addedDocuments)for(const d of r.addedDocuments){const l=P.URI.revive(d.uri);let c=this.c.get(l);if(c&&l.scheme!==v.Schemas.vscodeNotebookCell&&l.scheme!==v.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);c||(c=new o(new $.$JO(this.h.getProxy(b.$lM.MainThreadDocuments),l,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty)),this.c.set(l,c),t.push(c.value)),c.ref()}if(r.removedEditors)for(const d of r.removedEditors){const l=this.b.get(d);this.b.delete(d),l&&f.push(l)}if(r.addedEditors)for(const d of r.addedEditors){const l=P.URI.revive(d.documentUri);u.ok(this.c.has(l),`document '${l}' does not exist`),u.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const c=this.c.get(l).value,h=new A.$PO(d.id,this.h.getProxy(b.$lM.MainThreadTextEditors),this.i,new m.$V(()=>c.document),d.selections.map(I.Selection.to),d.options,d.visibleRanges.map(g=>I.Range.to(g)),typeof d.editorPosition=="number"?I.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,h)}r.newActiveEditor!==void 0&&(u.ok(r.newActiveEditor===null||this.b.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this.a=r.newActiveEditor),(0,M.$Pc)(s),(0,M.$Pc)(f),r.removedDocuments&&this.e.fire(s),r.addedDocuments&&this.d.fire(t),(r.removedEditors||r.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),r.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(r){return this.c.get(r)?.value}allDocuments(){return a.Iterable.map(this.c.values(),r=>r.value)}getEditor(r){return this.b.get(r)}activeEditor(r){if(!this.a)return;const s=this.b.get(this.a);return r?s:s?.value}allEditors(){return[...this.b.values()]}};e.$QO=n,e.$QO=n=Je([qe(0,y.$GO),qe(1,p.$Oj)],n),e.$RO=(0,R.$ii)("IExtHostDocumentsAndEditors")}),define(ke[355],Ee([1,0,19,4,6,155,16,7]),function(he,e,u,L,M,P,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jjc=void 0;class ${constructor(A,I){this.i=I,this.a=new L.$7d,this.b=new L.$7d,this.c=new L.$7d,this.d=new L.$7d,this.f=new L.$7d,this.g=new L.$7d,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=A.getProxy(M.$lM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(p=>this.g.fire(p)),this.i.onDidChangeActiveTextEditor(p=>this.f.fire(p))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(A){const I=this.i.allEditors();return A?I:I.map(p=>p.value)}async showTextDocument(A,I,p){let E;typeof I=="number"?E={position:R.ViewColumn.from(I),preserveFocus:p}:typeof I=="object"?E={position:R.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?R.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:E={preserveFocus:!1};const v=await this.h.$tryShowTextDocument(A.uri,E),a=v&&this.i.getEditor(v);if(a)return a.value;throw v?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,I){return new P.$NO(this.h,A,I).value}$acceptEditorPropertiesChanged(A,I){const p=this.i.getEditor(A);if(!p)throw new Error("unknown text editor");if(I.options&&p._acceptOptions(I.options),I.selections){const E=I.selections.selections.map(R.Selection.to);p._acceptSelections(E)}if(I.visibleRanges){const E=u.$Hb(I.visibleRanges.map(R.Range.to));p._acceptVisibleRanges(E)}if(I.options&&this.b.fire({textEditor:p.value,options:{...I.options,lineNumbers:R.TextEditorLineNumbersStyle.to(I.options.lineNumbers)}}),I.selections){const E=b.TextEditorSelectionChangeKind.fromValue(I.selections.source),v=I.selections.selections.map(R.Selection.to);this.a.fire({textEditor:p.value,selections:v,kind:E})}if(I.visibleRanges){const E=u.$Hb(I.visibleRanges.map(R.Range.to));this.c.fire({textEditor:p.value,visibleRanges:E})}}$acceptEditorPositionData(A){for(const I in A){const p=this.i.getEditor(I);if(!p)throw new Error("Unknown text editor");const E=R.ViewColumn.to(A[I]);p.value.viewColumn!==E&&(p._acceptViewColumn(E),this.d.fire({textEditor:p.value,viewColumn:E}))}}getDiffInformation(A){return Promise.resolve(this.h.$getDiffInformation(A))}}e.$jjc=$}),define(ke[356],Ee([1,0,2,5,6,3,7,16,25,18]),function(he,e,u,L,M,P,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3kc=e.$2kc=void 0,e.$2kc=(0,L.$ii)("IExtHostTimeline");class A{constructor(E,v){this.b=new Map,this.c=new Map,this.a=E.getProxy(M.$lM.MainThreadTimeline),v.registerArgumentProcessor({processArgument:(a,m)=>{if(a&&a.$mid===12)if(this.b.get(a.source)&&$.$Dm.equals(m,this.b.get(a.source)?.extension)){const o=a.uri===void 0?void 0:u.URI.revive(a.uri);return this.c.get(a.source)?.get(I(o))?.get(a.handle)}else return;return a}})}async $getTimeline(E,v,a,m){return this.b.get(E)?.provider.provideTimeline(u.URI.revive(v),a,m)}registerTimelineProvider(E,v,a,m){const o=new P.$Tc,n=this.d(v.id,m,o).bind(this);let i;v.onDidChange&&(i=v.onDidChange(s=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...s,id:v.id}),this));const r=this.c;return this.f({...v,scheme:E,onDidChange:void 0,async provideTimeline(s,t,f){t?.resetCache&&(o.clear(),r.get(v.id)?.clear());const d=await v.provideTimeline(s,t,f);if(d==null)return;const l=n(s,t);return{...d,source:v.id,items:d.items.map(l)}},dispose(){for(const s of r.values())s.get(v.id)?.clear();i?.dispose(),o.dispose()}},a)}d(E,v,a){return(m,o)=>{let n;if(o?.cacheResults){let i=this.c.get(E);i===void 0&&(i=new Map,this.c.set(E,i));const r=I(m);n=i.get(r),n===void 0&&(n=new Map,i.set(r,n))}return i=>{const{iconPath:r,...s}=i,t=`${E}|${i.id??i.timestamp}`;n?.set(t,i);let f,d,l;i.iconPath&&(r instanceof R.$jN?l={id:r.id,color:r.color}:u.URI.isUri(r)?(f=r,d=r):{light:f,dark:d}=r);let c;return R.$OM.isMarkdownString(s.tooltip)?c=b.MarkdownString.from(s.tooltip):(0,y.$Vf)(s.tooltip)?c=s.tooltip:R.$OM.isMarkdownString(s.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=b.MarkdownString.from(s.detail)):(0,y.$Vf)(s.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=s.detail),{...s,id:s.id??void 0,handle:t,source:E,command:i.command?v.toInternal(i.command,a):void 0,icon:f,iconDark:d,themeIcon:l,tooltip:c,accessibilityInformation:i.accessibilityInformation}}}}f(E,v){if(this.b.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this.a.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this.b.set(E.id,{provider:E,extension:v}),(0,P.$Sc)(()=>{for(const m of this.c.values())m.get(E.id)?.clear();this.b.delete(E.id),this.a.$unregisterTimelineProvider(E.id),E.dispose()})}}e.$3kc=A;function I(p){return p?.toString()}}),define(ke[357],Ee([1,0,227,23,2,4,3,287,8,7,18,19,16,80,22,183,26]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4kc=void 0;function o(r,s){if((0,A.$Vf)(r))return{label:r};if(r&&typeof r=="object"&&typeof r.label=="string"){let t;return Array.isArray(r.highlights)&&(t=r.highlights.filter(f=>f.length===2&&typeof f[0]=="number"&&typeof f[1]=="number"),t=t.length?t:void 0),{label:r.label,highlights:t}}}class n extends R.$Uc{constructor(s,t,f){super(),this.f=s,this.g=t,this.h=f,this.a=new Map,this.b=new a.$a0;function d(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:l=>d(l)?this.r(l):Array.isArray(l)&&l.length>0?l.map(c=>d(c)?this.r(c):c):l})}registerTreeDataProvider(s,t,f){const d=this.createTreeView(s,{treeDataProvider:t},f);return{dispose:()=>d.dispose()}}createTreeView(s,t,f){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=t.dragAndDropController?.dropMimeTypes??[],l=t.dragAndDropController?.dragMimeTypes??[],c=!!t.dragAndDropController?.handleDrag,h=!!t.dragAndDropController?.handleDrop,g=this.m(s,t,f),S={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:d,dragMimeTypes:l,hasHandleDrag:c,hasHandleDrop:h,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},w=this.f.$registerTreeViewDataProvider(s,S),C={get onDidCollapseElement(){return g.onDidCollapseElement},get onDidExpandElement(){return g.onDidExpandElement},get selection(){return g.selectedElements},get onDidChangeSelection(){return g.onDidChangeSelection},get activeItem(){return(0,m.$0F)(f,"treeViewActiveItem"),g.focusedElement},get onDidChangeActiveItem(){return(0,m.$0F)(f,"treeViewActiveItem"),g.onDidChangeActiveItem},get visible(){return g.visible},get onDidChangeVisibility(){return g.onDidChangeVisibility},get onDidChangeCheckboxState(){return g.onDidChangeCheckboxState},get message(){return g.message},set message(k){(0,E.$Hk)(k)&&(0,m.$0F)(f,"treeViewMarkdownMessage"),g.message=k},get title(){return g.title},set title(k){g.title=k},get description(){return g.description},set description(k){g.description=k},get badge(){return g.badge},set badge(k){k!==void 0&&y.ViewBadge.isViewBadge(k)?g.badge={value:Math.floor(Math.abs(k.value)),tooltip:k.tooltip}:k===void 0&&(g.badge=void 0)},reveal:(k,D)=>g.reveal(k,D),dispose:async()=>{await w,this.a.delete(s),g.dispose()}};return this.B(C),C}$getChildren(s,t){const f=this.a.get(s);return f?f.getChildren(t):Promise.reject(new b.$BF(s))}async $handleDrop(s,t,f,d,l,c,h,g){const S=this.a.get(s);if(!S)return Promise.reject(new b.$BF(s));const w=p.DataTransfer.toDataTransfer(f,async C=>(await this.f.$resolveDropFileData(s,t,C)).buffer);return h===s&&g&&await this.j(w,S,g,l,c),S.onDrop(w,d,l)}async j(s,t,f,d,l){const c=this.b.removeDragOperationTransfer(l);if(c)(await c)?.forEach((h,g)=>{h&&s.set(g,h)});else if(l&&t.handleDrag){const h=t.handleDrag(f,s,d);this.b.addDragOperationTransfer(l,h),await h}return s}async $handleDrag(s,t,f,d){const l=this.a.get(s);if(!l)return Promise.reject(new b.$BF(s));const c=await this.j(new y.$fN,l,t,d,f);if(!(!c||d.isCancellationRequested))return p.DataTransfer.from(c)}async $hasResolve(s){const t=this.a.get(s);if(!t)throw new b.$BF(s);return t.hasResolve}$resolve(s,t,f){const d=this.a.get(s);if(!d)throw new b.$BF(s);return d.resolveTreeItem(t,f)}$setExpanded(s,t,f){const d=this.a.get(s);if(!d)throw new b.$BF(s);d.setExpanded(t,f)}$setSelectionAndFocus(s,t,f){const d=this.a.get(s);if(!d)throw new b.$BF(s);d.setSelectionAndFocus(t,f)}$setVisible(s,t){const f=this.a.get(s);if(!f){if(!t)return;throw new b.$BF(s)}f.setVisible(t)}$changeCheckboxState(s,t){const f=this.a.get(s);if(!f)throw new b.$BF(s);f.setCheckboxState(t)}m(s,t,f){const d=this.B(new i(s,t,this.f,this.g.converter,this.h,f));return this.a.set(s,d),d}r(s){const t=this.a.get(s.$treeViewId);return t&&"$treeItemHandle"in s?t.getExtensionElement(s.$treeItemHandle):t&&"$focusedTreeItem"in s&&s.$focusedTreeItem?t.focusedElement:null}}e.$4kc=n;class i extends R.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(s=>this.getExtensionElement(s)).filter(s=>!(0,A.$5f)(s))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(s,t,f,d,l,c){if(super(),this.I=s,this.J=f,this.L=d,this.M=l,this.N=c,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new P.$7d),this.onDidExpandElement=this.u.event,this.w=this.B(new P.$7d),this.onDidCollapseElement=this.w.event,this.y=this.B(new P.$7d),this.onDidChangeSelection=this.y.event,this.z=this.B(new P.$7d),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new P.$7d),this.onDidChangeVisibility=this.C.event,this.D=this.B(new P.$7d),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new P.$7d),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new v.$ee,c.contributes&&c.contributes.views)for(const w in c.contributes.views)for(const C of c.contributes.views[w])C.id===s&&(this.P=C.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(w=>this.F.fire({message:!1,element:w})));let h,g;const S=P.Event.debounce(this.F.event,(w,C)=>(w||(w={message:!1,elements:[]}),C.element!==!1&&(h||(h=new Promise(k=>g=k),this.G=this.G.then(()=>h)),Array.isArray(C.element)?w.elements.push(...C.element):w.elements.push(C.element)),C.message&&(w.message=!0),w),200,!0);this.B(S(({message:w,elements:C})=>{C.length&&(this.H=this.H.then(()=>{const k=g;return h=null,this.$(C).then(()=>k())})),w&&this.J.$setMessage(this.I,p.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(s){const t=s?this.getExtensionElement(s):void 0;if(s&&!t)return this.M.error(`No tree item with id '${s}' found.`),Promise.resolve([]);let f=this.X(s);return f||(f=await this.Y(t)),f?f.map(d=>d.item):void 0}getExtensionElement(s){return this.j.get(s)}reveal(s,t){t=t||{select:!0,focus:!1};const f=(0,A.$5f)(t.select)?!0:t.select,d=(0,A.$5f)(t.focus)?!1:t.focus,l=(0,A.$5f)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):s?this.G.then(()=>this.S(s)).then(c=>this.W(s,c[c.length-1]).then(h=>this.J.$reveal(this.I,{item:h.item,parentChain:c.map(g=>g.item)},{select:f,focus:d,expand:l})),c=>this.M.error(c)):this.J.$reveal(this.I,void 0,{select:f,focus:d,expand:l})}get message(){return this.O}set message(s){this.O=s,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(s){this.P=s,this.J.$setTitle(this.I,s,this.Q)}get description(){return this.Q}set description(s){this.Q=s,this.J.$setTitle(this.I,this.P,s)}get badge(){return this.R}set badge(s){this.R?.value===s?.value&&this.R?.tooltip===s?.tooltip||(this.R=p.ViewBadge.from(s),this.J.$setBadge(this.I,s))}setExpanded(s,t){const f=this.getExtensionElement(s);f&&(t?this.u.fire(Object.freeze({element:f})):this.w.fire(Object.freeze({element:f})))}setSelectionAndFocus(s,t){const f=!(0,I.$ub)(this.s,s);this.s=s;const d=this.t!==t;this.t=t,f&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(s){s!==this.r&&(this.r=s,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(s){const t=(await Promise.all(s.map(async f=>{const d=this.getExtensionElement(f.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:f.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(f=>f!==void 0);t.forEach(f=>{f.treeItem.checkboxState=f.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(f=>[f.extensionItem,f.newState])})}async handleDrag(s,t,f){const d=[];for(const l of s){const c=this.getExtensionElement(l);c&&d.push(c)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,t,f),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(s,t,f){const d=t?this.getExtensionElement(t):void 0;if(!(!d&&t||!this.g?.handleDrop))return(0,$.$ah)(()=>this.g?.handleDrop?this.g.handleDrop(d,s,f):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(s,t){if(!this.f.resolveTreeItem)return;const f=this.j.get(s);if(f){const d=this.m.get(f);if(d){const l=await this.f.resolveTreeItem(d.extensionItem,f,t)??d.extensionItem;return this.hb(l),d.item.tooltip=this.eb(l.tooltip),d.item.command=this.fb(d.disposableStore,l.command),d.item}}}S(s){return this.U(s).then(t=>t?this.S(t).then(f=>this.W(t,f[f.length-1]).then(d=>(f.push(d),f))):Promise.resolve([]))}U(s){const t=this.m.get(s);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$ah)(()=>this.f.getParent(s))}W(s,t){const f=this.m.get(s);return f?Promise.resolve(f):(0,$.$ah)(()=>this.f.getTreeItem(s)).then(d=>this.kb(s,d,t,!0)).then(d=>this.getChildren(t?t.item.handle:void 0).then(()=>{const l=this.getExtensionElement(d);if(l){const c=this.m.get(l);if(c)return Promise.resolve(c)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(s){if(s){let t;if(typeof s=="string"){const f=this.getExtensionElement(s);t=f?this.m.get(f):void 0}else t=s;return t&&t.children||void 0}return this.h}async Y(s){this.rb(s);const t=new v.$ee(this.Z.token);try{const f=s?this.m.get(s):void 0,d=await this.f.getChildren(s);if(t.token.isCancellationRequested)return;const l=(0,I.$Hb)(d||[]),c=await Promise.all((0,I.$Hb)(l).map(g=>this.f.getTreeItem(g)));if(t.token.isCancellationRequested)return;const h=c.map((g,S)=>g?this.db(l[S],g,f):null);return(0,I.$Hb)(h)}finally{t.dispose()}}$(s){if(s.some(f=>!f))return this.Z.dispose(!0),this.Z=new v.$ee,this.tb(),this.J.$refresh(this.I);{const f=this.ab(s);if(f.length)return this.bb(f)}return Promise.resolve(void 0)}ab(s){const t=new Set,f=s.map(l=>this.m.get(l));for(const l of f)if(l&&!t.has(l.item.handle)){let c=l;for(;c&&c.parent&&f.findIndex(h=>c&&c.parent&&h&&h.item.handle===c.parent.item.handle)===-1;){const h=this.j.get(c.parent.item.handle);c=h?this.m.get(h):void 0}c&&!c.parent&&t.add(l.item.handle)}const d=[];return t.forEach(l=>{const c=this.j.get(l);if(c){const h=this.m.get(c);h&&(!h.parent||!t.has(h.parent.item.handle))&&d.push(l)}}),d}bb(s){const t={};return Promise.all(s.map(f=>this.cb(f).then(d=>{d&&(t[f]=d.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(s){const t=this.getExtensionElement(s);if(t){const f=this.m.get(t);if(f)return this.rb(t),(0,$.$ah)(()=>this.f.getTreeItem(t)).then(d=>{if(d){const l=this.ib(t,d,f.parent);return this.pb(t,l,f,f.parent),f.dispose(),l}return null})}return Promise.resolve(null)}db(s,t,f){const d=this.ib(s,t,f);if(t.id&&this.j.has(d.item.handle))throw new Error((0,u.localize)(0,null,t.id));return this.ob(s,d),this.qb(d,f),d}eb(s){return y.$OM.isMarkdownString(s)?p.MarkdownString.from(s):s}fb(s,t){return t?{...this.L.toInternal(t,s),originalId:t.command}:void 0}gb(s){if(s.checkboxState===void 0)return;let t,f,d;return typeof s.checkboxState=="number"?t=s.checkboxState:(t=s.checkboxState.state,f=s.checkboxState.tooltip,d=s.checkboxState.accessibilityInformation),{isChecked:t===y.TreeItemCheckboxState.Checked,tooltip:f,accessibilityInformation:d}}hb(s){if(!y.$aN.isTreeItem(s,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(s,t,f){this.hb(t);const d=this.B(new R.$Tc),l=this.kb(s,t,f),c=this.lb(t);return{item:{handle:l,parentHandle:f?f.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(d,t.command),contextValue:t.contextValue,icon:c,iconDark:this.mb(t)||c,themeIcon:this.jb(t),collapsibleState:(0,A.$5f)(t.collapsibleState)?y.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:f,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(s){return s.iconPath instanceof y.$jN?s.iconPath:void 0}kb(s,{id:t,label:f,resourceUri:d},l,c){if(t)return`${i.b}/${t}`;const h=o(f,this.N),g=l?l.item.handle:i.a;let S=h?h.label:d?(0,L.$Sg)(d):"";S=S.indexOf("/")!==-1?S.replace("/","//"):S;const w=this.m.has(s)?this.m.get(s).item.handle:void 0,C=this.X(l)||[];let k,D=0;do{if(k=`${g}/${D}:${S}`,c||!this.j.has(k)||w===k)break;D++}while(D<=C.length);return k}lb(s){if(s.iconPath&&!(s.iconPath instanceof y.$jN))return typeof s.iconPath=="string"||M.URI.isUri(s.iconPath)?this.nb(s.iconPath):this.nb(s.iconPath.light)}mb(s){if(s.iconPath&&!(s.iconPath instanceof y.$jN)&&s.iconPath.dark)return this.nb(s.iconPath.dark)}nb(s){return M.URI.isUri(s)?s:M.URI.file(s)}ob(s,t){this.j.set(t.item.handle,s),this.m.set(s,t)}pb(s,t,f,d){this.j.delete(t.item.handle),this.m.delete(s),t.item.handle!==f.item.handle&&this.j.delete(f.item.handle),this.ob(s,t);const l=this.X(d)||[],c=l.filter(h=>h.item.handle===f.item.handle)[0];c&&l.splice(l.indexOf(c),1,t)}qb(s,t){t?(t.children||(t.children=[]),t.children.push(s)):(this.h||(this.h=[]),this.h.push(s))}rb(s){if(s){const t=this.m.get(s);if(t){if(t.children)for(const f of t.children){const d=this.j.get(f.item.handle);d&&this.sb(d)}t.children=void 0}}else this.tb()}sb(s){const t=this.m.get(s);if(t){if(t.children)for(const f of t.children){const d=this.j.get(f.item.handle);d&&this.sb(d)}this.m.delete(s),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(s=>s.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[358],Ee([1,0,4,3,2,30,16,92,6,7]),function(he,e,u,L,M,P,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cjc=void 0;class A extends L.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(v,a,m,o){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new u.$7d),this.onDidDispose=this.#d.event,this.#h=this.B(new u.$7d),this.onDidChangeViewState=this.#h.event,this.#e=v,this.#t=a,this.#n=m,this.#i=o.viewType,this.#s=o.panelOptions,this.#o=o.viewColumn,this.#r=o.title,this.#u=o.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(v){this.c(),this.#r!==v&&(this.#r=v,this.#t.$setTitle(this.#e,v))}get iconPath(){return this.c(),this.#a}set iconPath(v){this.c(),this.#a!==v&&(this.#a=v,this.#t.$setIconPath(this.#e,M.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(v){this.#l||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(this.#u=v.active,this.#c=v.visible,this.#o=v.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(v,a){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof v>"u"?void 0:R.ViewColumn.from(v),preserveFocus:!!a})}c(){if(this.#l)throw new Error("Webview is disposed")}}class I extends L.$Uc{static c(){return(0,P.$Eg)()}constructor(v,a,m){super(),this.j=a,this.m=m,this.g=new Map,this.h=new Map,this.f=v.getProxy($.$lM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(v=>v.dispose()),this.g.clear()}createWebviewPanel(v,a,m,o,n={}){const i=typeof o=="object"?o.viewColumn:o,r={viewColumn:R.ViewColumn.from(i),preserveFocus:typeof o=="object"&&!!o.preserveFocus},s=(0,b.$yjc)(v),t=I.c();this.f.$createWebviewPanel((0,b.$Ajc)(v),t,a,{title:m,panelOptions:p(n),webviewOptions:(0,b.$Bjc)(v,this.m,n),serializeBuffersForPostMessage:s},r);const f=this.j.createNewWebview(t,n,v);return this.createNewWebviewPanel(t,a,m,i,n,f,!0)}$onDidChangeWebviewPanelViewStates(v){const a=Object.keys(v);a.sort((m,o)=>{const n=v[m],i=v[o];return n.active?1:i.active?-1:+n.visible-+i.visible});for(const m of a){const o=this.getWebviewPanel(m);if(!o)continue;const n=v[m];o._updateViewState({active:n.active,visible:n.visible,viewColumn:R.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(v){this.getWebviewPanel(v)?.dispose(),this.g.delete(v),this.j.deleteWebview(v)}registerWebviewPanelSerializer(v,a,m){if(this.h.has(a))throw new Error(`Serializer for '${a}' already registered`);return this.h.set(a,{serializer:m,extension:v}),this.f.$registerSerializer(a,{serializeBuffersForPostMessage:(0,b.$yjc)(v)}),new y.$nM(()=>{this.h.delete(a),this.f.$unregisterSerializer(a)})}async $deserializeWebviewPanel(v,a,m,o){const n=this.h.get(a);if(!n)throw new Error(`No serializer found for '${a}'`);const{serializer:i,extension:r}=n,s=this.j.createNewWebview(v,m.webviewOptions,r),t=this.createNewWebviewPanel(v,a,m.title,o,m.panelOptions,s,m.active);await i.deserializeWebviewPanel(t,m.state)}createNewWebviewPanel(v,a,m,o,n,i,r){const s=new A(v,this.f,i,{viewType:a,title:m,viewColumn:o,panelOptions:n,active:r});return this.g.set(v,s),s}getWebviewPanel(v){return this.g.get(v)}}e.$Cjc=I;function p(E){return{enableFindWidget:E.enableFindWidget,retainContextWhenHidden:E.retainContextWhenHidden}}}),define(ke[359],Ee([1,0,4,3,92,16,6,7]),function(he,e,u,L,M,P,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7kc=void 0;class $ extends L.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(I,p,E,v,a,m){super(),this.#s=!1,this.#u=this.B(new u.$7d),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new u.$7d),this.onDidDispose=this.#l.event,this.#i=E,this.#a=v,this.#e=I,this.#t=p,this.#n=a,this.#r=m}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(I){this.a(),this.#a!==I&&(this.#a=I,this.#t.$setWebviewViewTitle(this.#e,I))}get description(){return this.a(),this.#o}set description(I){this.a(),this.#o!==I&&(this.#o=I,this.#t.$setWebviewViewDescription(this.#e,I))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(I){I===this.#r||this.#s||(this.#r=I,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(I){this.a(),!(I?.value===this.#c?.value&&I?.tooltip===this.#c?.tooltip)&&(this.#c=P.ViewBadge.from(I),this.#t.$setWebviewViewBadge(this.#e,I))}show(I){this.a(),this.#t.$show(this.#e,!!I)}a(){if(this.#s)throw new Error("Webview is disposed")}}class y{constructor(I,p){this.d=p,this.b=new Map,this.c=new Map,this.a=I.getProxy(R.$lM.MainThreadWebviewViews)}registerWebviewViewProvider(I,p,E,v){if(this.b.has(p))throw new Error(`View provider for '${p}' already registered`);return this.b.set(p,{provider:E,extension:I}),this.a.$registerWebviewViewProvider((0,M.$Ajc)(I),p,{retainContextWhenHidden:v?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,M.$yjc)(I)}),new b.$nM(()=>{this.b.delete(p),this.a.$unregisterWebviewViewProvider(p)})}async $resolveWebviewView(I,p,E,v,a){const m=this.b.get(p);if(!m)throw new Error(`No view provider found for '${p}'`);const{provider:o,extension:n}=m,i=this.d.createNewWebview(I,{},n),r=new $(I,this.a,p,E,i,!0);this.c.set(I,r),await o.resolveWebviewView(r,{state:v},a)}async $onDidChangeWebviewViewVisibility(I,p){this.e(I)._setVisible(p)}async $disposeWebviewView(I){const p=this.e(I);this.c.delete(I),p.dispose(),this.d.deleteWebview(I)}e(I){const p=this.c.get(I);if(!p)throw new Error("No webview found");return p}}e.$7kc=y}),define(ke[360],Ee([1,0,69,15,12,258,32,11]),function(he,e,u,L,M,P,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Llc=void 0;let $=class{constructor(I,p){I.addFileSystemProvider(L.Schemas.file,new y(p),{isCaseSensitive:b.$k})}};e.$Llc=$,e.$Llc=$=Je([qe(0,u.$ujc),qe(1,M.$Oj)],$);class y{constructor(I){this.b=I,this.a=new P.$Vq(this.b)}async stat(I){const p=await this.a.stat(I);return{type:p.type,ctime:p.ctime,mtime:p.mtime,size:p.size,permissions:p.permissions===R.FilePermission.Readonly?1:void 0}}readDirectory(I){return this.a.readdir(I)}createDirectory(I){return this.a.mkdir(I)}readFile(I){return this.a.readFile(I)}writeFile(I,p,E){return this.a.writeFile(I,p,{...E,unlock:!1,atomic:!1})}delete(I,p){return this.a.delete(I,{...p,useTrash:!1,atomic:!1})}rename(I,p,E){return this.a.rename(I,p,E)}copy(I,p,E){return this.a.copy(I,p,E)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(I,p){throw new Error("Method not implemented.")}}}),define(ke[361],Ee([1,0,17,63,30,33,3,6,2,20]),function(he,e,u,L,M,P,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jlc=void 0;let A=class extends R.$Uc{constructor(p,E){super();const v=p.getProxy(b.$lM.MainThreadDownloadService);E.registerCommand(!1,"_workbench.downloadResource",async a=>{const m=$.URI.file((0,u.$kc)((0,L.tmpdir)(),(0,M.$Eg)()));return await v.$download(a,m),m})}};e.$Jlc=A,e.$Jlc=A=Je([qe(0,y.$GO),qe(1,P.$3O)],A)}),define(ke[362],Ee([1,0,51,17,2,93,3,15,8,31]),function(he,e,u,L,M,P,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vlc=void 0;class A extends P.$wjc{constructor(){super(...arguments),this.i=null}async g(t){const f=await super.g(t);if(f.scheme!==b.Schemas.file)return f;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${f.fsPath}.`),f;const d=f.fsPath;let l=0;do{let c;l===0?c=d:c=/[/\\]$/.test(d)?`${d.substr(0,d.length-1)}-${l}`:`${d}-${l}`,await I(c);const h=L.$kc(c,"vscode.lock"),g=await a(this.d,h,!1);if(g)return this.i=g,process.on("exit",()=>{g.dispose()}),M.URI.file(c);l++}while(l<10);return f}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Vlc=A;async function I(s){try{await y.Promises.stat(s);return}catch{}try{await y.Promises.mkdir(s,{recursive:!0})}catch{}}const p=1e3,E=10*60*1e3;class v extends R.$Uc{constructor(t,f){super(),this.b=t,this.c=f,this.a=this.B(new $.$th),this.a.cancelAndSet(async()=>{const d=await m(t,f);(!d||d.pid!==process.pid)&&(t.info(`Lock '${f}': The lock was lost unexpectedly.`),this.a.cancel());try{await y.Promises.utimes(f,new Date,new Date)}catch(l){t.error(l),t.info(`Lock '${f}': Could not update mtime.`)}},p)}dispose(){super.dispose();try{u.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const f={pid:process.pid,willReleaseAt:Date.now()+t};await y.Promises.writeFile(this.c,JSON.stringify(f),{flag:"w"})}catch(f){this.b.error(f)}}}async function a(s,t,f){try{const l={pid:process.pid,willReleaseAt:0};await y.Promises.writeFile(t,JSON.stringify(l),{flag:"wx"})}catch(l){s.error(l)}const d=await m(s,t);return!d||d.pid!==process.pid?f?(s.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(s.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),i(s,t)):(s.info(`Lock '${t}': Lock acquired.`),new v(s,t))}async function m(s,t){let f;try{f=await y.Promises.readFile(t)}catch(d){return s.error(d),null}try{return JSON.parse(String(f))}catch(d){return s.error(d),null}}async function o(s,t){let f;try{f=await y.Promises.stat(t)}catch(d){return s.error(d),0}return f.mtime.getTime()}function n(s){try{return process.kill(s,0),!0}catch{return!1}}async function i(s,t){const f=await m(s,t);if(!f)return s.info(`Lock '${t}': Could not read pid of lock holder.`),r(s,t);if(f.willReleaseAt){let g=f.willReleaseAt-Date.now();if(g<5e3){for(g>0?s.info(`Lock '${t}': The lockfile is scheduled to be released in ${g} ms.`):s.info(`Lock '${t}': The lockfile is scheduled to have been released.`);g>0;){if(await(0,$.$jh)(Math.min(100,g)),await o(s,t)===0)return r(s,t);g=f.willReleaseAt-Date.now()}return r(s,t)}}if(!n(f.pid))return s.info(`Lock '${t}': The pid ${f.pid} appears to be gone.`),r(s,t);const d=await o(s,t),l=Date.now()-d;if(l<=E)return s.info(`Lock '${t}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null;s.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$jh)(2e3);const c=await o(s,t),h=Date.now()-c;return h<=E?(s.info(`Lock '${t}': The lock does not look stale, elapsed: ${h} ms, giving up.`),null):(s.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),r(s,t))}async function r(s,t){s.info(`Lock '${t}': Deleting a stale lock.`);try{await y.Promises.unlink(t)}catch{}return a(s,t,!0)}}),define(ke[363],Ee([1,0,30,20,47,33]),function(he,e,u,L,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$elc=void 0;let R=class extends M.$Sjc{constructor($,y){super(!0,$,y)}createTerminal($,y,A){return this.createTerminalFromOptions({name:$,shellPath:y,shellArgs:A})}createTerminalFromOptions($,y){const A=new M.$Rjc(this.a,(0,u.$Eg)(),$,$.name);return this.f.push(A),A.create($,this.R($,y)),A.value}};e.$elc=R,e.$elc=R=Je([qe(0,P.$3O),qe(1,L.$GO)],R)}),define(ke[364],Ee([1,0,4,37,41,5]),function(he,e,u,L,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HL=e.$GL=e.OutputChannelUpdateMode=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=void 0,e.$tL="text/x-code-output",e.$uL="output",e.$vL="Log",e.$wL="text/x-code-log-output",e.$xL="log",e.$yL="workbench.panel.output",e.$zL=new M.$zj("inOutput",!1),e.$AL=new M.$zj("activeLogOutput",!1),e.$BL=new M.$zj("activeLogOutput.levelSettable",!1),e.$CL=new M.$zj("activeLogOutput.level",""),e.$DL=new M.$zj("activeLogOutput.levelIsDefault",!1),e.$EL=new M.$zj("outputView.scrollLock",!1),e.$FL=(0,P.$ii)("outputService");var R;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$GL={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new u.$7d,this.onDidRegisterChannel=this.b.event,this.c=new u.$7d,this.onDidRemoveChannel=this.c.event}registerChannel(y){this.a.has(y.id)||(this.a.set(y.id,y),this.b.fire(y.id))}getChannels(){const y=[];return this.a.forEach(A=>y.push(A)),y}getChannel(y){return this.a.get(y)}removeChannel(y){this.a.delete(y),this.c.fire(y)}}L.$1n.add(e.$GL.OutputChannels,new b),e.$HL=new M.$zj("activeOutputChannel","")}),define(ke[156],Ee([1,0,6,5,20,25,12,364,69,28,59,188,21,18,32,4,3]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ikc=e.$Hkc=void 0;class o extends R.$Uj{get disposed(){return this.n}constructor(s,t,f,d,l){super(),this.id=s,this.name=t,this.r=f,this.s=d,this.extension=l,this.m=0,this.n=!1,this.visible=!1,this.setLevel(f.getLevel()),this.B(f.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(s){this.append(s+`
`)}append(s){this.info(s)}clear(){const s=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,s)}replace(s){const t=this.m;this.info(s),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(s,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof s=="boolean"?s:t))}hide(){this.s.$close(this.id)}g(s,t){this.m+=p.$ue.fromString(t).byteLength,(0,R.log)(this.r,s,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends o{appendLine(s){this.append(s)}}let i=class{constructor(s,t,f,d,l,c){this.i=t,this.j=f,this.k=d,this.l=l,this.m=c,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=s.getProxy(u.$lM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,I.$Pm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(s){this.h=s;for(const[t,f]of this.g)f.visible=t===this.h}createOutputChannel(s,t,f){if(s=s.trim(),!s)throw new Error("illegal argument `name`. must not be falsy");const d=typeof t=="object"&&t.log,l=(0,E.$Vf)(t)?t:void 0;if((0,E.$Vf)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const h=this.i.environment.extensionLogLevel?.find(([S])=>P.$Dm.equals(f.identifier,S))?.[1];h&&(c=(0,R.$6j)(h));const g=d?this.o(s,c,f):this.n(s,l,f);return g.then(S=>{this.g.set(S.id,S),S.visible=S.id===this.h}),d?this.r(s,c??this.m.getLevel(),g):this.q(s,g)}async n(s,t,f){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,l=this.k.extUri.joinPath(d,`${this.f++}-${s.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),h=await this.a.$register(s,l,t,f.identifier.value);return new o(h,s,c,this.a,f)}async o(s,t,f){const d=await this.p(f),l=s.replace(/[\\/:\*\?"<>\|]/g,""),c=this.k.extUri.joinPath(d,`${l}.log`),h=`${f.identifier.value}.${l}`,g=this.l.createLogger(c,{id:h,name:s,logLevel:t,extensionId:f.identifier.value});return new n(h,s,g,this.a,f)}p(s){let t=this.d.get(s.identifier.value);if(!t){const f=this.k.extUri.joinPath(this.i.logsLocation,s.identifier.value);this.d.set(s.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(f)}catch(d){if((0,v.$5k)(d)!==v.FileSystemProviderErrorCode.FileExists)throw d}return f})())}return t}q(s,t){let f=!1;const d=()=>{if(f)throw new Error("Channel has been closed")};return{get name(){return s},append(l){d(),t.then(c=>c.append(l))},appendLine(l){d(),t.then(c=>c.appendLine(l))},clear(){d(),t.then(l=>l.clear())},replace(l){d(),t.then(c=>c.replace(l))},show(l,c){d(),t.then(h=>h.show(l,c))},hide(){d(),t.then(l=>l.hide())},dispose(){f=!0,t.then(l=>l.dispose())}}}r(s,t,f){const d=new m.$Tc,l=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},c=d.add(new a.$7d);function h(g){t=g,c.fire(g)}return f.then(g=>{d.add(g),g.logLevel!==t&&h(g.logLevel),d.add(g.onDidChangeLogLevel(S=>h(S)))}),{...this.q(s,f),get logLevel(){return t},onDidChangeLogLevel:c.event,trace(g,...S){l(),f.then(w=>w.trace(g,...S))},debug(g,...S){l(),f.then(w=>w.debug(g,...S))},info(g,...S){l(),f.then(w=>w.info(g,...S))},warn(g,...S){l(),f.then(w=>w.warn(g,...S))},error(g,...S){l(),f.then(w=>w.error(g,...S))},dispose(){d.dispose()}}}};e.$Hkc=i,e.$Hkc=i=Je([qe(0,M.$GO),qe(1,y.$WO),qe(2,$.$ujc),qe(3,A.$7ic),qe(4,R.$Pj),qe(5,R.$Oj)],i),e.$Ikc=(0,L.$ii)("IExtHostOutputService")}),define(ke[157],Ee([1,0,5,8]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=void 0,e.$5m=(0,u.$ii)("remoteAgentService"),e.$6m=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(M){let P=1/0;for(let b=0;b<this.maxSampleCount;b++){const $=await M.getRoundTripTime();if($===void 0)return;P=Math.min(P,$/2),await(0,L.$jh)(this.sampleDelay)}this.average.push(P),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(P):R=this.initial.reduce((b,$)=>b+$,0)/this.initial.length,this.lastMeasurement={initial:R,current:P,average:this.average.reduce((b,$)=>b+$,0)/this.average.length,high:typeof R>"u"?!1:P>this.highLatencyMaxThreshold||P>this.highLatencyMinThreshold&&P>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(ke[365],Ee([1,0,231,85,37,42,53,3,4,157,11,24,8]),function(he,e,u,L,M,P,R,b,$,y,A,I,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=void 0,e.$YI=Object.freeze({id:"application",order:100,title:(0,u.localize)(0,null),type:"object"}),e.$ZI=Object.freeze({id:"workbench",order:7,title:(0,u.localize)(1,null),type:"object"}),e.$1I=Object.freeze({id:"security",scope:1,title:(0,u.localize)(2,null),type:"object",order:7}),e.$2I=Object.freeze({id:"problems",title:(0,u.localize)(3,null),type:"object",order:101}),e.$3I={ConfigurationMigration:"base.contributions.configuration.migration"};class E{constructor(){this.migrations=[],this.a=new $.$7d,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const v=new E;M.$1n.add(e.$3I.ConfigurationMigration,v);let a=class extends b.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,i){super(),this.a=n,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async r=>{for(const s of r.added)await this.f(s,v.migrations)})),this.c(v.migrations),this.B(v.onDidRegisterConfigurationMigration(r=>this.c(r)))}async c(n){await this.f(void 0,n);for(const i of this.b.getWorkspace().folders)await this.f(i,n)}async f(n,i){await Promise.all([i.map(r=>this.g(r,n?.uri))])}async g(n,i){const r=this.a.inspect(n.key,{resource:i}),s=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,f]of s){const d=r[t];if(!d)continue;const l=[];if(d.value!==void 0){const c=await this.h(n,t,d.value,i,void 0);for(const h of c??[])l.push([h,[]])}for(const{identifiers:c,value:h}of d.overrides??[])if(h!==void 0){const g=await this.h(n,t,h,i,c);for(const S of g??[])l.push([S,c])}l.length&&await Promise.allSettled(l.map(async([[c,h],g])=>this.a.updateValue(c,h.value,{resource:i,overrideIdentifiers:g},f)))}}async h(n,i,r,s,t){const f=l=>{const h=this.a.inspect(l,{resource:s})[i];if(h)return t?h.overrides?.find(({identifiers:g})=>(0,I.$Sn)(g,t))?.value:h.value},d=await n.migrateFn(r,f);return Array.isArray(d)?d:[[n.key,d]]}};e.$4I=a,e.$4I=a=Je([qe(0,R.$Oi),qe(1,P.$ri)],a);let m=class extends b.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new p.$Fh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!A.$i&&(await this.b.getEnvironment())?.os!==1)return;M.$1n.as(L.$6n.Configuration).registerConfiguration({...e.$1I,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,u.localize)(4,null)},default:[],markdownDescription:(0,u.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,u.localize)(6,null),scope:2}}})}};e.$5I=m,e.$5I=m=Je([qe(0,y.$5m)],m)}),define(ke[366],Ee([1,0,35,15,17,23,240,365,85,5,37]),function(he,e,u,L,M,P,R,b,$,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$Cfb=e.$Bfb=void 0,e.$Dfb=a,e.$Efb=m,e.$Bfb=(0,y.$ii)("editorResolverService"),e.$Cfb="workbench.editorAssociations";const I=A.$1n.as($.$6n.Configuration),p={...b.$ZI,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};I.registerConfiguration(p);var E;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(E||(e.RegisteredEditorPriority=E={}));var v;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(v||(e.ResolvedStatus=v={}));function a(o){switch(o){case E.exclusive:return 5;case E.default:return 4;case E.builtin:return 3;case E.option:default:return 1}}function m(o,n){if(new Set([L.Schemas.extension,L.Schemas.webviewPanel,L.Schemas.vscodeWorkspaceTrust,L.Schemas.vscodeSettings]).has(n.scheme))return!1;const s=typeof o=="string"&&o.indexOf(M.$hc.sep)>=0?`${n.scheme}:${n.path}`:(0,P.$Sg)(n);return u.$bk(typeof o=="string"?o.toLowerCase():o,s.toLowerCase())}}),define(ke[367],Ee([1,0,34,15,17,11,23,2,5,276,42,147,157]),function(he,e,u,L,M,P,R,b,$,y,A,I,p){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$1L=e.$ZL=void 0,e.$ZL=(0,$.$ii)("pathService");let v=E=class{constructor(m,o,n,i){this.d=m,this.e=o,this.f=n,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||P.OS)(),this.b=(async()=>{const r=await this.e.getEnvironment();return this.c=r?.userHome??m})()}hasValidBasename(m,o,n){return typeof o=="string"||typeof o>"u"?this.a.then(i=>this.h(m,i,o)):this.h(m,o,n)}h(m,o,n){return m.scheme===L.Schemas.file||m.scheme===L.Schemas.vscodeRemote?(0,u.$gg)(n??(0,R.$Sg)(m),o===1):!0}get defaultUriScheme(){return E.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(m,o){if(m.remoteAuthority)return L.Schemas.vscodeRemote;const n=(0,y.$WL)(o.getWorkspace());if(n)return n;const i=o.getWorkspace().folders[0];if(i)return i.uri.scheme;const r=o.getWorkspace().configuration;return r?r.scheme:L.Schemas.file}userHome(m){return m?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(m=>m===1?M.$gc:M.$hc)}async fileURI(m){let o="";if(await this.a===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const i=m.indexOf("/",2);i===-1?(o=m.substring(2),m="/"):(o=m.substring(2,i),m=m.substring(i)||"/")}return b.URI.from({scheme:L.Schemas.file,authority:o,path:m,query:"",fragment:""})}};e.$1L=v,e.$1L=v=E=Je([qe(1,p.$5m),qe(2,I.$IL),qe(3,A.$ri)],v)}),define(ke[368],Ee([1,0,242,19,54,4,55,3,2,53,247,12,65,278,88,42,147,26,22,18,24,41]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v,a,m,o,n,i,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TL=e.$SL=e.OnPortForward=e.$NL=e.$ML=e.TunnelSource=e.TunnelCloseReason=e.$KL=e.$JL=void 0,e.$LL=c,e.$OL=S,e.$PL=w,e.$QL=C,e.$RL=D;const t=10*1e3,f="remote.tunnels.toRestore",d="remote.tunnels.toRestoreExpiration",l=1e3*60*60*24*14;e.$JL="onTunnel",e.$KL=new s.$zj("forwardedPortsViewEnabled",!1,u.localize(0,null));function c(T){const z=T.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(z)return{host:z[1]?.substring(0,z[1].length-1)||"localhost",port:Number(z[2])}}var h;(function(T){T.Other="Other",T.User="User",T.AutoForwardEnd="AutoForwardEnd"})(h||(e.TunnelCloseReason=h={}));var g;(function(T){T[T.User=0]="User",T[T.Auto=1]="Auto",T[T.Extension=2]="Extension"})(g||(e.TunnelSource=g={})),e.$ML={source:g.User,description:u.localize(1,null)},e.$NL={source:g.Auto,description:u.localize(2,null)};function S(T,z,j){const N=T.get(C(z,j));if(N)return N;if((0,v.$3v)(z))for(const B of v.$2v){const W=C(B,j);if(T.has(W))return T.get(W)}else if((0,v.$5v)(z))for(const B of v.$4v){const W=C(B,j);if(T.has(W))return T.get(W)}}function w(T,z,j){const N=S(T,z,j);if(N)return N;const B=(0,v.$5v)(z)?"localhost":(0,v.$3v)(z)?"0.0.0.0":void 0;if(B)return S(T,B,j)}function C(T,z){return T+":"+z}var k;(function(T){T.Notify="notify",T.OpenBrowser="openBrowser",T.OpenBrowserOnce="openBrowserOnce",T.OpenPreview="openPreview",T.Silent="silent",T.Ignore="ignore"})(k||(e.OnPortForward=k={}));function D(T){return T&&"host"in T&&typeof T.host=="string"&&"port"in T&&typeof T.port=="number"&&(!("detail"in T)||typeof T.detail=="string")&&(!("pid"in T)||typeof T.pid=="string")}class O extends b.$Uc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(z){super(),this.r=z,this.j=[],this.n=new P.$7d,this.onDidChangeAttributes=this.n.event,this.B(z.onDidChangeConfiguration(j=>{(j.affectsConfiguration(O.c)||j.affectsConfiguration(O.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(z,j,N){let B=this.w(z,j,N,this.j,0);const W={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;B>=0;){const Z=this.j[B];Z.key===z?(W.onAutoForward=Z.onAutoForward??W.onAutoForward,W.elevateIfNeeded=Z.elevateIfNeeded!==void 0?Z.elevateIfNeeded:W.elevateIfNeeded,W.label=Z.label??W.label,W.requireLocalPort=Z.requireLocalPort,W.protocol=Z.protocol):(W.onAutoForward=W.onAutoForward??Z.onAutoForward,W.elevateIfNeeded=W.elevateIfNeeded!==void 0?W.elevateIfNeeded:Z.elevateIfNeeded,W.label=W.label??Z.label,W.requireLocalPort=W.requireLocalPort!==void 0?W.requireLocalPort:void 0,W.protocol=W.protocol??Z.protocol),B=this.w(z,j,N,this.j,B+1)}return W.onAutoForward!==void 0||W.elevateIfNeeded!==void 0||W.label!==void 0||W.requireLocalPort!==void 0||W.protocol!==void 0?W:this.C()}t(z){return z.start!==void 0&&z.end!==void 0}u(z){return z.host!==void 0&&z.port!==void 0&&(0,i.$Vf)(z.host)&&(0,i.$Zf)(z.port)}w(z,j,N,B,W){if(W>=B.length)return-1;const Z=!(0,v.$3v)(j)&&!(0,v.$5v)(j),X=B.slice(W).findIndex(x=>(0,i.$Zf)(x.key)?Z?!1:x.key===z:this.t(x.key)?Z?!1:z>=x.key.start&&z<=x.key.end:this.u(x.key)?z===x.key.port&&j===x.key.host:N?x.key.test(N):!1);return X>=0?X+W:-1}y(){const z=this.r.getValue(O.c);if(!z||!(0,i.$Xf)(z))return[];const j=[];for(const B in z){if(B===void 0)continue;const W=z[B];let Z;if(Number(B))Z=Number(B);else if((0,i.$Vf)(B))if(O.g.test(B)){const _=B.match(O.g);Z={start:Number(_[1]),end:Number(_[2])}}else if(O.h.test(B)){const _=B.match(O.h);Z={host:_[1],port:Number(_[2])}}else{let _;try{_=RegExp(B)}catch{}_&&(Z=_)}Z&&j.push({key:Z,elevateIfNeeded:W.elevateIfNeeded,onAutoForward:W.onAutoForward,label:W.label,requireLocalPort:W.requireLocalPort,protocol:W.protocol})}const N=this.r.getValue(O.f);return N&&(this.m={elevateIfNeeded:N.elevateIfNeeded,label:N.label,onAutoForward:N.onAutoForward,requireLocalPort:N.requireLocalPort,protocol:N.protocol}),this.z(j)}z(z){function j(N,B){return(0,i.$Zf)(N.key)?N.key:B.t(N.key)?N.key.start:B.u(N.key)?N.key.port:Number.MAX_VALUE}return z.sort((N,B)=>j(N,this)-j(B,this))}C(){return this.m}static providedActionToAction(z){switch(z){case v.ProvidedOnAutoForward.Notify:return k.Notify;case v.ProvidedOnAutoForward.OpenBrowser:return k.OpenBrowser;case v.ProvidedOnAutoForward.OpenBrowserOnce:return k.OpenBrowserOnce;case v.ProvidedOnAutoForward.OpenPreview:return k.OpenPreview;case v.ProvidedOnAutoForward.Silent:return k.Silent;case v.ProvidedOnAutoForward.Ignore:return k.Ignore;default:return}}async addAttributes(z,j,N){const W=this.r.inspect(O.c).userRemoteValue;let Z;!W||!(0,i.$Xf)(W)?Z={}:Z=(0,r.$On)(W),Z[`${z}`]||(Z[`${z}`]={});for(const _ in j)Z[`${z}`][_]=j[_];return this.r.updateValue(O.c,Z,N)}}e.$SL=O;let F=class extends b.$Uc{constructor(z,j,N,B,W,Z,_,X,x,re){super(),this.H=z,this.I=j,this.J=N,this.L=B,this.M=W,this.N=Z,this.O=_,this.P=X,this.Q=x,this.R=re,this.c=new Map,this.g=new P.$7d,this.onForwardPort=this.g.event,this.h=new P.$7d,this.onClosePort=this.h.event,this.j=new P.$7d,this.onPortName=this.j.event,this.n=new P.$7d,this.onCandidatesChanged=this.n.event,this.t=new P.$7d,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new P.$7d,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new O(N),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async Y=>{const me=await this.getAttributes(Y.map(Ce=>({port:Ce.tunnelRemotePort,host:Ce.tunnelRemoteHost})));for(const Ce of Y)if(Ce.localAddress){const ee=C(Ce.tunnelRemoteHost,Ce.tunnelRemotePort),U=w(this.m??new Map,Ce.tunnelRemoteHost,Ce.tunnelRemotePort);this.forwarded.set(ee,{remotePort:Ce.tunnelRemotePort,remoteHost:Ce.tunnelRemoteHost,localAddress:Ce.localAddress,protocol:me?.get(Ce.tunnelRemotePort)?.protocol??v.TunnelProtocol.Http,localUri:await this.X(Ce.localAddress,me?.get(Ce.tunnelRemotePort)),localPort:Ce.tunnelLocalPort,runningProcess:U?.detail,hasRunningProcess:!!U,pid:U?.pid,privacy:Ce.privacy,source:e.$ML}),this.f.set(ee,Ce)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async Y=>{const me=C(Y.tunnelRemoteHost,Y.tunnelRemotePort);if(!w(this.forwarded,Y.tunnelRemoteHost,Y.tunnelRemotePort)&&!w(this.detected,Y.tunnelRemoteHost,Y.tunnelRemotePort)&&!w(this.c,Y.tunnelRemoteHost,Y.tunnelRemotePort)&&Y.localAddress){const Ce=w(this.m??new Map,Y.tunnelRemoteHost,Y.tunnelRemotePort),ee=(await this.getAttributes([{port:Y.tunnelRemotePort,host:Y.tunnelRemoteHost}]))?.get(Y.tunnelRemotePort);this.forwarded.set(me,{remoteHost:Y.tunnelRemoteHost,remotePort:Y.tunnelRemotePort,localAddress:Y.localAddress,protocol:ee?.protocol??v.TunnelProtocol.Http,localUri:await this.X(Y.localAddress,ee),localPort:Y.tunnelLocalPort,closeable:!0,runningProcess:Ce?.detail,hasRunningProcess:!!Ce,pid:Ce?.pid,privacy:Y.privacy,source:e.$ML})}await this.cb(),this.f.set(me,Y),this.g.fire(this.forwarded.get(me))})),this.B(this.H.onTunnelClosed(Y=>this.W(Y,h.Other))),this.U()}S(){return this.Q.extensions.find(z=>z.activationEvents?.includes(e.$JL))?(this.R.createKey(e.$KL.key,!0),!0):!1}U(){if(this.S())return;const z=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&z.dispose()}))}async W(z,j){const N=C(z.host,z.port);this.forwarded.has(N)&&(this.forwarded.delete(N),await this.cb(),this.h.fire(z))}X(z,j){if(z.startsWith("http"))return $.URI.parse(z);const N=j?.protocol??"http";return $.URI.parse(`${N}://${z}`)}async Y(z){const j=this.N.getWorkspace(),N=j.configuration?(0,R.$9i)(j.configuration.path):j.folders.length>0?(0,R.$9i)(j.folders[0].uri.path):void 0;if(N===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${z}.${this.L.remoteAuthority}.${N}`}async Z(){return this.Y(f)}async $(){return this.Y(d)}async ab(){const z=this.I.get(f,1);if(z)return this.I.remove(f,1),await this.cb(),z;const j=await this.Z();if(j)return this.I.get(j,0)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const z=await this.s;if(z&&z!==this.y){const j=JSON.parse(z)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${j.map(N=>N.remotePort).join(", ")}`);for(const N of j){const B=w(this.detected,N.remoteHost,N.remotePort);N.source.source!==g.Extension&&!B||N.source.source===g.Extension&&B?await this.fb({remote:{host:N.remoteHost,port:N.remotePort},local:N.localPort,name:N.name,elevateIfNeeded:!0,source:N.source}):N.source.source===g.Extension&&!B&&this.D.set(C(N.remoteHost,N.remotePort),N)}}}if(this.z=!0,this.C.fire(),!this.w){const z=await this.Z();this.w=this.B(new b.$Tc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async j=>{j.key===z&&(this.s=Promise.resolve(this.I.get(z,0)),await this.restoreForwarded())}))}}bb(){const z=this.I.keys(0,0).filter(j=>j.startsWith(d));for(const j of z){const N=this.I.getNumber(j,0);if(N&&N<Date.now()){this.s=Promise.resolve(void 0);const B=j.replace(d,f);this.I.remove(j,0),this.I.remove(B,0)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const z=Array.from(this.forwarded.values()),j=z.map(Z=>({remoteHost:Z.remoteHost,remotePort:Z.remotePort,localPort:Z.localPort,name:Z.name,localAddress:Z.localAddress,localUri:Z.localUri,protocol:Z.protocol,source:Z.source}));let N;z.length>0&&(N=JSON.stringify(j));const B=await this.Z(),W=await this.$();!N&&B&&W?(this.I.remove(B,0),this.I.remove(W,0)):N!==this.y&&B&&W&&(this.I.store(B,N,0,0),this.I.store(W,Date.now()+l,0,0)),this.y=N}}async eb(z,j,N){if(!z.tunnelLocalPort||!N?.requireLocalPort||z.tunnelLocalPort===j)return;const B=new Date;if(this.db.getTime()+t>B.getTime())return;this.db=B;const W=u.localize(3,null,j,z.tunnelRemotePort,z.tunnelLocalPort);return this.P.info(W)}async forward(z,j){return!this.z&&this.L.remoteAuthority&&await P.Event.toPromise(this.C.event),this.fb(z,j)}async fb(z,j){await this.Q.activateByEvent(e.$JL);const N=w(this.forwarded,z.remote.host,z.remote.port);j=j??(j!==null?(await this.getAttributes([z.remote]))?.get(z.remote.port):void 0);const B=z.local!==void 0?z.local:z.remote.port;let W;if(N)return this.hb(N,z,j);{const Z=this.L.remoteAuthority,_=Z?{getAddress:async()=>(await this.M.resolveAuthority(Z)).authority}:void 0,X=C(z.remote.host,z.remote.port);this.c.set(X,!0),z=this.gb(X,z);const x=await this.H.openTunnel(_,z.remote.host,z.remote.port,void 0,B,z.elevateIfNeeded?z.elevateIfNeeded:j?.elevateIfNeeded,z.privacy,j?.protocol);if(typeof x=="string")W=x;else if(x&&x.localAddress){const re=w(this.m??new Map,z.remote.host,z.remote.port),Y=x.protocol?x.protocol===v.TunnelProtocol.Https?v.TunnelProtocol.Https:v.TunnelProtocol.Http:j?.protocol??v.TunnelProtocol.Http,me={remoteHost:x.tunnelRemoteHost,remotePort:x.tunnelRemotePort,localPort:x.tunnelLocalPort,name:j?.label??z.name,closeable:!0,localAddress:x.localAddress,protocol:Y,localUri:await this.X(x.localAddress,j),runningProcess:re?.detail,hasRunningProcess:!!re,pid:re?.pid,source:z.source??e.$ML,privacy:x.privacy};return this.forwarded.set(X,me),this.f.set(X,x),this.c.delete(X),await this.cb(),await this.eb(x,B,j),this.g.fire(me),x}this.c.delete(X)}return W}gb(z,j){const N=this.D.has(z)?this.D:this.F.has(z)?this.F:void 0;if(N){const B=N.get(z);N.delete(z),B&&(j.name=B.name??j.name,j.local=("local"in B?B.local:"localPort"in B?B.localPort:void 0)??j.local,j.privacy=j.privacy)}return j}async hb(z,j,N){const B=N?.label??j.name;let W;(function(_){_[_.None=0]="None",_[_.Fire=1]="Fire",_[_.Reopen=2]="Reopen"})(W||(W={}));let Z=W.None;switch(B!==z.name&&(z.name=B,Z=W.Fire),(N?.protocol||z.protocol!==v.TunnelProtocol.Http)&&N?.protocol!==z.protocol&&(j.source=z.source,Z=W.Reopen),j.privacy&&z.privacy!==j.privacy&&(Z=W.Reopen),Z){case W.Fire:{this.g.fire();break}case W.Reopen:await this.close(z.remoteHost,z.remotePort,h.User),await this.fb(j,N)}return w(this.f,j.remote.host,j.remote.port)}async name(z,j,N){const B=w(this.forwarded,z,j),W=C(z,j);if(B){B.name=N,await this.cb(),this.j.fire({host:z,port:j});return}else this.detected.has(W)&&(this.detected.get(W).name=N,this.j.fire({host:z,port:j}))}async close(z,j,N){const B=C(z,j),W=this.forwarded.get(B);return N===h.AutoForwardEnd&&W&&W.source.source===g.Auto&&this.F.set(B,{local:W.localPort,name:W.name,privacy:W.privacy}),await this.H.closeTunnel(z,j),this.W({host:z,port:j},N)}address(z,j){const N=C(z,j);return(this.forwarded.get(N)||this.detected.get(N))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(z){if(z)for(const j of z){const N=w(this.m??new Map,j.remoteAddress.host,j.remoteAddress.port),B=typeof j.localAddress=="string"?j.localAddress:C(j.localAddress.host,j.localAddress.port);this.detected.set(C(j.remoteAddress.host,j.remoteAddress.port),{remoteHost:j.remoteAddress.host,remotePort:j.remoteAddress.port,localAddress:B,protocol:v.TunnelProtocol.Http,localUri:this.X(B),closeable:!1,runningProcess:N?.detail,hasRunningProcess:!!N,pid:N?.pid,privacy:v.TunnelPrivacyId.ConstantPrivate,source:{source:g.Extension,description:u.localize(4,null)}}),this.H.setEnvironmentTunnel(j.remoteAddress.host,j.remoteAddress.port,B,v.TunnelPrivacyId.ConstantPrivate,v.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(z){this.r=z}async setCandidates(z){let j=z;this.r&&(j=await this.r(z));const N=this.ib(j);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(N.values()).map(B=>B.port).join(", ")}`),this.n.fire(N)}ib(z){const j=this.m??new Map,N=new Map;return this.m=N,z.forEach(B=>{const W=C(B.host,B.port);N.set(W,{host:B.host,port:B.port,detail:B.detail,pid:B.pid}),j.has(W)&&j.delete(W);const Z=w(this.forwarded,B.host,B.port);Z&&(Z.runningProcess=B.detail,Z.hasRunningProcess=!0,Z.pid=B.pid)}),j.forEach((B,W)=>{const Z=c(W);if(!Z)return;const _=w(this.forwarded,Z.host,Z.port);_&&(_.runningProcess=void 0,_.hasRunningProcess=!1,_.pid=void 0);const X=w(this.detected,Z.host,Z.port);X&&(X.runningProcess=void 0,X.hasRunningProcess=!1,X.pid=void 0)}),j}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const z=Array.from(this.forwarded.values()),j=await this.getAttributes(z.map(N=>({port:N.remotePort,host:N.remoteHost})),!1);if(j)for(const N of z){const B=j.get(N.remotePort);(B?.protocol||N.protocol!==v.TunnelProtocol.Http)&&B?.protocol!==N.protocol&&await this.fb({remote:{host:N.remoteHost,port:N.remotePort},local:N.localPort,name:N.name,source:N.source},B),B&&B.label&&B.label!==N.name&&await this.name(N.remoteHost,N.remotePort,B.label)}}async getAttributes(z,j=!0){const N=new Map,B=new Map;z.forEach(x=>{const re=w(this.m??new Map,v.$2v[0],x.port)??x;if(re){N.set(x.port,re);const Y=D(re)?re.pid:void 0;B.has(Y)||B.set(Y,[]),B.get(Y)?.push(x.port)}});const W=new Map;if(z.forEach(x=>{const re=this.configPortsAttributes.getAttributes(x.port,x.host,N.get(x.port)?.detail);re&&W.set(x.port,re)}),this.G.length===0||!j)return W.size>0?W:void 0;const Z=await Promise.all((0,L.$Rb)(this.G.map(x=>Array.from(B.entries()).map(re=>{const Y=re[1],me=N.get(Y[0]);return x.providePortAttributes(Y,me?.pid,me?.detail,n.CancellationToken.None)})))),_=new Map;if(Z.forEach(x=>x.forEach(re=>{re&&_.set(re.port,re)})),!W&&!_)return;const X=new Map;return z.forEach(x=>{const re=W.get(x.port),Y=_.get(x.port);X.set(x.port,{elevateIfNeeded:re?.elevateIfNeeded,label:re?.label,onAutoForward:re?.onAutoForward??O.providedActionToAction(Y?.autoForwardAction),requireLocalPort:re?.requireLocalPort,protocol:re?.protocol})}),X}addAttributesProvider(z){this.G.push(z)}};e.$TL=F,Je([(0,M.$Nh)(1e3)],F.prototype,"cb",null),e.$TL=F=Je([qe(0,v.$Wv),qe(1,E.$Mp),qe(2,y.$Oi),qe(3,m.$IL),qe(4,p.$tl),qe(5,a.$ri),qe(6,I.$Oj),qe(7,A.$qw),qe(8,o.$6F),qe(9,s.$Aj)],F)}),define(ke[94],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$tK=e.$sK=void 0;class u{constructor(R,b){this.line=R,this.character=b}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,b){return new u(0,0)}with(R){return new u(0,0)}}e.$sK=u;class L{constructor(R,b,$,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new u(R,b),this.end=new u($,y)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new L(0,0,0,0)}with(R){return new L(0,0,0,0)}}e.$tK=L;var M;(function(P){P[P.Information=1]="Information",P[P.Warning=2]="Warning"})(M||(e.TextSearchCompleteMessageType=M={}))}),define(ke[36],Ee([1,0,19,35,24,34,14,5,17,13,94,8]),function(he,e,u,L,M,P,R,b,$,y,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SK=e.$QK=e.$JK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$GK=e.$FK=e.$EK=e.$DK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.TextSearchCompleteMessageType=void 0,e.$AK=o,e.$BK=n,e.$CK=i,e.$HK=g,e.$IK=S,e.$KK=k,e.$LK=D,e.$MK=O,e.$NK=F,e.$OK=T,e.$PK=z,e.$RK=N,e.$TK=Z,e.$UK=_,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$uK="workbench.view.search",e.$vK="workbench.panel.search",e.$wK="workbench.view.search",e.$xK="search-result",e.$yK="search.exclude";const p="\u27EA ",E=" characters skipped \u27EB",v=(p.length+E.length+5)*2;e.$zK=(0,b.$ii)("searchService");var a;(function(x){x[x.file=0]="file",x[x.text=1]="text",x[x.aiText=2]="aiText"})(a||(e.SearchProviderType=a={}));var m;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.aiText=3]="aiText"})(m||(e.QueryType=m={}));function o(x){return!!x.preview}function n(x){return!!x.resource}function i(x){return!!x.message}var r;(function(x){x[x.Normal=0]="Normal",x[x.NewSearchStarted=1]="NewSearchStarted"})(r||(e.SearchCompletionExitCode=r={}));class s{constructor(re){this.resource=re,this.results=[]}}e.$DK=s;class t{constructor(re,Y,me,Ce){this.ranges=Y,this.webviewIndex=Ce;const ee=Array.isArray(Y)?Y:[Y];if(me&&me.matchLines===1&&f(ee)){re=(0,R.$Of)(re,me.matchLines);let U="",ie=0,be=0;const Se=Math.floor(me.charsPerLine/5),ae=[];for(const ce of ee){const se=Math.max(ce.startColumn-Se,0),K=ce.startColumn+me.charsPerLine;if(se>be+Se+v){const te=p+(se-be)+E;U+=te+re.slice(se,K),ie+=se-(be+te.length)}else U+=re.slice(be,K);ae.push(new l(0,ce.startColumn-ie,ce.endColumn-ie)),be=K}this.preview={text:U,matches:Array.isArray(this.ranges)?ae:ae[0]}}else{const U=Array.isArray(Y)?Y[0].startLineNumber:Y.startLineNumber;this.preview={text:re,matches:(0,u.$2b)(Y,ie=>new d(ie.startLineNumber-U,ie.startColumn,ie.endLineNumber-U,ie.endColumn))}}}}e.$EK=t;function f(x){const re=x[0].startLineNumber;for(const Y of x)if(Y.startLineNumber!==re||Y.endLineNumber!==re)return!1;return!0}class d{constructor(re,Y,me,Ce){this.startLineNumber=re,this.startColumn=Y,this.endLineNumber=me,this.endColumn=Ce}}e.$FK=d;class l extends d{constructor(re,Y,me){super(re,Y,re,me)}}e.$GK=l;var c;(function(x){x.List="list",x.Tree="tree"})(c||(e.ViewMode=c={}));var h;(function(x){x.Default="default",x.FileNames="fileNames",x.Type="type",x.Modified="modified",x.CountDescending="countDescending",x.CountAscending="countAscending"})(h||(e.SearchSortOrder=h={}));function g(x,re=!0){const Y=x&&x.files&&x.files.exclude,me=re&&x&&x.search&&x.search.exclude;if(!Y&&!me)return;if(!Y||!me)return Y||me;let Ce=Object.create(null);return Ce=M.$Rn(Ce,M.$On(Y)),Ce=M.$Rn(Ce,M.$On(me),!0),Ce}function S(x,re){return x.excludePattern&&L.$bk(x.excludePattern,re)?!1:x.includePattern||x.usingSearchPaths?x.includePattern&&L.$bk(x.includePattern,re)?!0:x.usingSearchPaths?!!x.folderQueries&&x.folderQueries.some(Y=>{const me=Y.folder.fsPath;if(P.$ig(re,me)){const Ce=$.$mc(me,re);return!Y.includePattern||!!L.$bk(Y.includePattern,Ce)}else return!1}):!1:!0}var w;(function(x){x[x.unknownEncoding=1]="unknownEncoding",x[x.regexParseError=2]="regexParseError",x[x.globParseError=3]="globParseError",x[x.invalidLiteral=4]="invalidLiteral",x[x.rgProcessError=5]="rgProcessError",x[x.other=6]="other",x[x.canceled=7]="canceled"})(w||(e.SearchErrorCode=w={}));class C extends Error{constructor(re,Y){super(re),this.code=Y}}e.$JK=C;function k(x){const re=x.message;if((0,y.$4)(x))return new C(re,w.canceled);try{const Y=JSON.parse(re);return new C(Y.message,Y.code)}catch{return new C(re,w.other)}}function D(x){const re={message:x.message,code:x.code};return new Error(JSON.stringify(re))}function O(x){return x.type==="error"?!0:x.type==="success"}function F(x){return x.type==="success"}function T(x){return!!x.path}function z(x,re,Y=!0){const me=x.searchPath?x.searchPath:x.relativePath;return Y?(0,R.$Lf)(me,re):L.$bk(re,me)}class j{constructor(re){this.path=re,this.results=[]}addMatch(re){this.results.push(re)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$QK=j;function N(x,re){const Y={...x||{},...re||{}};return Object.keys(Y).filter(me=>{const Ce=Y[me];return typeof Ce=="boolean"&&Ce})}class B{constructor(re,Y){this.c=null,this.a={...re.excludePattern||{},...Y.excludePattern||{}},this.b=L.$ck(this.a);let me=re.includePattern;Y.includePattern&&(me?me={...me,...Y.includePattern}:me=Y.includePattern),me&&(this.c=L.$ck(me))}matchesExcludesSync(re,Y,me){return!!(this.b&&this.b(re,Y,me))}includedInQuerySync(re,Y,me){return!(this.b&&this.b(re,Y,me)||this.c&&!this.c(re,Y,me))}includedInQuery(re,Y,me){const Ce=this.b(re,Y,me),ee=()=>this.c?!!this.c(re,Y,me):!0;return(0,I.$7g)(Ce)?Ce.then(U=>U?!1:ee()):ee()}hasSiblingExcludeClauses(){return W(this.a)}}e.$SK=B;function W(x){for(const re in x)if(typeof x[re]!="boolean")return!0;return!1}function Z(x){if(!x)return;let re;return Y=>(re||(re=(x()||Promise.resolve([])).then(me=>me?X(me):{})),re.then(me=>!!me[Y]))}function _(x){if(!x)return;let re;return Y=>{if(!re){const me=x();re=me?X(me):{}}return!!re[Y]}}function X(x){const re={};for(const Y of x)re[Y]=!0;return re}}),define(ke[43],Ee([1,0,19,8,22,4,3,77,15,125,23,14,2,229,5,12,261,42,59,28,20,16,7,66,36,6,57]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v,a,m,o,n,i,r,s,t,f,d,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pjc=e.$ojc=void 0;function h(F,T,z){return new A.$Kg(j=>C(j,z)).isEqual(F,T)}function g(F,T,z){return h(F.uri,T.uri,z)?0:(0,I.$ef)(F.uri.toString(),T.uri.toString())}function S(F,T,z){return F.index!==T.index?F.index<T.index?-1:1:h(F.uri,T.uri,z)?(0,I.$ef)(F.name,T.name):(0,I.$ef)(F.uri.toString(),T.uri.toString())}function w(F,T,z,j){const N=F.slice(0).sort((W,Z)=>z(W,Z,j)),B=T.slice(0).sort((W,Z)=>z(W,Z,j));return(0,u.$Eb)(N,B,(W,Z)=>z(W,Z,j))}function C(F,T){const z=T.getCapabilities(F.scheme);return!(z&&z&1024)}class k extends o.$Bi{static toExtHostWorkspace(T,z,j,N){if(!T)return{workspace:null,added:[],removed:[]};const{id:B,name:W,folders:Z,configuration:_,transient:X,isUntitled:x}=T,re=[],Y=z;z?Z.forEach((U,ie)=>{const be=p.URI.revive(U.uri),Se=k.o(j||z,be,N);Se?(Se.name=U.name,Se.index=U.index,re.push(Se)):re.push({uri:be,name:U.name,index:ie})}):re.push(...Z.map(({uri:U,name:ie,index:be})=>({uri:p.URI.revive(U),name:ie,index:be}))),re.sort((U,ie)=>U.index<ie.index?-1:1);const me=new k(B,W,re,!!X,_?p.URI.revive(_):null,!!x,U=>C(U,N)),{added:Ce,removed:ee}=w(Y?Y.workspaceFolders:[],me.workspaceFolders,g,N);return{workspace:me,added:Ce,removed:ee}}static o(T,z,j){for(let N=0;N<T.folders.length;N++){const B=T.workspaceFolders[N];if(h(B.uri,z,j))return B}}constructor(T,z,j,N,B,W,Z){super(T,j.map(_=>new o.$Ci(_)),N,B,Z),this.t=z,this.u=W,this.q=[],this.s=b.$oi.forUris(Z),j.forEach(_=>{this.q.push(_),this.s.set(_.uri,_)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(T,z){return z&&this.s.get(T)&&(T=(0,A.$Ug)(T)),this.s.findSubstr(T)}resolveWorkspaceFolder(T){return this.s.get(T)}}let D=class{constructor(T,z,j,N,B){this.c=new P.$7d,this.onDidChangeWorkspace=this.c.event,this.g=new P.$7d,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new P.$9d,this.C=new Map,this.h=N,this.s=j,this.t=B,this.j=new y.$pm,this.k=new L.$hh,this.o=T.getProxy(l.$lM.MainThreadWorkspace),this.q=T.getProxy(l.$lM.MainThreadMessageService);const W=z.workspace;this.l=W?new k(W.id,W.name,[],!!W.transient,W.configuration?p.URI.revive(W.configuration):null,!!W.isUntitled,Z=>C(Z,j)):void 0}$initializeWorkspace(T,z){this.v=z,this.$acceptWorkspaceData(T),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?p.URI.from({scheme:$.Schemas.untitled,path:(0,A.$Sg)((0,A.$Ug)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(T,z,j,...N){const B=[];if(Array.isArray(N)&&N.forEach(x=>{p.URI.isUri(x.uri)&&!B.some(re=>h(re.uri,x.uri,this.s))&&B.push({uri:x.uri,name:x.name||(0,A.$Rg)(x.uri)})}),this.n||[z,j].some(x=>typeof x!="number"||x<0)||j===0&&B.length===0)return!1;const W=this.x?this.x.workspaceFolders:[];if(z+j>W.length)return!1;const Z=W.slice(0);Z.splice(z,j,...B.map(x=>({uri:x.uri,name:x.name||(0,A.$Rg)(x.uri),index:void 0})));for(let x=0;x<Z.length;x++){const re=Z[x];if(Z.some((Y,me)=>me!==x&&h(re.uri,Y.uri,this.s)))return!1}Z.forEach((x,re)=>x.index=re);const{added:_,removed:X}=w(W,Z,S,this.s);if(_.length===0&&X.length===0)return!1;if(this.o){const x=T.displayName||T.name;this.o.$updateWorkspaceFolders(x,z,j,B).then(void 0,re=>{this.n=void 0;const Y={source:{identifier:T.identifier,label:T.displayName||T.name}};this.q.$showMessage(m.Severity.Error,(0,E.localize)(0,null,x,re.toString()),Y,[])})}return this.y(Z),!0}getWorkspaceFolder(T,z){if(this.x)return this.x.getWorkspaceFolder(T,z)}async getWorkspaceFolder2(T,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(T,z)}async resolveWorkspaceFolder(T){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(T)}getPath(){if(!this.x)return;const{folders:T}=this.x;if(T.length!==0)return T[0].uri.fsPath}getRelativePath(T,z){let j,N="";if(typeof T=="string"?(j=p.URI.file(T),N=T):typeof T<"u"&&(j=T,N=T.fsPath),!j)return N;const B=this.getWorkspaceFolder(j,!0);if(!B)return N;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let W=(0,A.$Xg)(B.uri,j);return z&&B.name&&(W=`${B.name}/${W}`),W}y(T){this.x&&(this.n=k.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:T,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(T){const{workspace:z,added:j,removed:N}=k.toExtHostWorkspace(T,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:j,removed:N}))}findFiles(T,z,j,N,B=M.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${N.value}, entryPoint: findFiles`);let W="",Z=!0;return z===null?Z=!1:z!==void 0&&(typeof z=="string"?W=z:W=z.pattern),this.z(T,void 0,{exclude:W,maxResults:j,useDefaultExcludes:Z,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},B)}findFiles2(T,z={},j,N=M.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${j.value}, entryPoint: findFiles2`),this.z(void 0,T,z,N)}async z(T,z,j,N=M.CancellationToken.None){if(N&&N.isCancellationRequested)return Promise.resolve([]);const B=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,W={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof j.useParentIgnoreFiles=="boolean"?!j.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof j.useDefaultSearchExcludes=="boolean"?!j.useDefaultSearchExcludes:!1,maxResults:j.maxResults,excludePattern:B,shouldGlobSearch:typeof j.fuzzy=="boolean"?!j.fuzzy:!0,_reason:"startFileSearch"};let Z;if(T){const{includePattern:_,folder:X}=O(s.GlobPattern.from(T));Z=X,W.includePattern=_}else{const{includePattern:_,folder:X}=O(s.GlobPattern.from(z));Z=X,W.filePattern=_}return this.o.$startFileSearch(Z??null,W,N).then(_=>Array.isArray(_)?_.map(X=>p.URI.revive(X)):[])}async findTextInFiles(T,z,j,N,B=M.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${N.value}, entryPoint: findTextInFiles`);const W=this.j.getNext(),Z=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:_,folder:X}=O(s.GlobPattern.from(z.include)),x=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,re={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:Z,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:_,excludePattern:x},Y=!1;if(this.u[W]=me=>{if(Y)return;const Ce=p.URI.revive(me.resource);me.results.forEach(ee=>{const U=(0,c.$Rh)(ee);(0,d.$AK)(U)?j({uri:Ce,preview:{text:U.preview.text,matches:(0,u.$2b)(U.preview.matches,ie=>new t.$pM(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,u.$2b)(U.ranges,ie=>new t.$pM(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):j({uri:Ce,text:U.text,lineNumber:U.lineNumber})})},B.isCancellationRequested)return{};try{const me=await this.o.$startTextSearch(T,X??null,re,W,B);return delete this.u[W],me||{}}catch(me){throw delete this.u[W],me}}$handleTextSearchResult(T,z){this.u[z]?.(T)}async save(T){const z=await this.o.$save(T,{saveAs:!1});return p.URI.revive(z)}async saveAs(T){const z=await this.o.$save(T,{saveAs:!0});return p.URI.revive(z)}saveAll(T){return this.o.$saveAll(T)}resolveProxy(T){return this.o.$resolveProxy(T)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(T){return this.o.$requestWorkspaceTrust(T)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(T,z){if(this.w.has(T))throw new Error(`A provider has already been registered for scheme ${T}`);this.w.set(T,z);const j=this.t.transformOutgoingScheme(T),N=this.A++;return this.o.$registerEditSessionIdentityProvider(N,j),(0,R.$Sc)(()=>{this.w.delete(T),this.o.$unregisterEditSessionIdentityProvider(N)})}async $getEditSessionIdentifier(T,z){this.h.info("Getting edit session identifier for workspaceFolder",T);const j=await this.resolveWorkspaceFolder(p.URI.revive(T));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const N=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!N),!N)return;const B=await N.provideEditSessionIdentity(j,z);if(this.h.info("Provider returned edit session identifier: ",B),!!B)return B}async $provideEditSessionIdentityMatch(T,z,j,N){this.h.info("Getting edit session identifier for workspaceFolder",T);const B=await this.resolveWorkspaceFolder(p.URI.revive(T));if(!B){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const W=this.w.get(B.uri.scheme);if(this.h.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!W),!W)return;const Z=await W.provideEditSessionIdentityMatch?.(z,j,N);if(this.h.info("Provider returned edit session identifier match result: ",Z),!!Z)return Z}getOnWillCreateEditSessionIdentityEvent(T){return(z,j,N)=>{const B=function(Z){z.call(j,Z)};return B.extension=T,this.B.event(B,void 0,N)}}async $onWillCreateEditSessionIdentity(T,z,j){const N=await this.resolveWorkspaceFolder(p.URI.revive(T));if(N===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:N},z,async(B,W)=>{const Z=Date.now();await Promise.resolve(B),Date.now()-Z>j&&this.h.warn("SLOW edit session create-participant",W.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(T,z){if(this.C.has(T))throw new Error(`A provider has already been registered for scheme ${T}`);this.C.set(T,z);const j=this.t.transformOutgoingScheme(T),N=this.A++;return this.o.$registerCanonicalUriProvider(N,j),(0,R.$Sc)(()=>{this.C.delete(T),this.o.$unregisterCanonicalUriProvider(N)})}async provideCanonicalUri(T,z,j){const N=this.C.get(T.scheme);if(!N)return;const B=await N.provideCanonicalUri?.(p.URI.revive(T),z,j);if(B)return B}async $provideCanonicalUri(T,z,j){return this.provideCanonicalUri(p.URI.revive(T),{targetScheme:z},j)}};e.$ojc=D,e.$ojc=D=Je([qe(0,r.$GO),qe(1,i.$WO),qe(2,n.$7ic),qe(3,a.$Oj),qe(4,f.$mjc)],D),e.$pjc=(0,v.$ii)("IExtHostWorkspace");function O(F){let T,z;return F&&(typeof F=="string"?T=F:(T=F.pattern,z=p.URI.revive(F.baseUri))),{includePattern:T,folder:z}}}),define(ke[44],Ee([1,0,24,4,43,6,7,263,85,18,8,5,20,12,2]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sjc=e.$rjc=e.$qjc=void 0;function a(f,d){if(d){const l=d.split(".");let c=f;for(let h=0;c&&h<l.length;h++)c=c[l[h]];return c}}function m(f){return f instanceof v.URI}function o(f){return f&&f.uri instanceof v.URI&&f.languageId&&typeof f.languageId=="string"}function n(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function i(f){return f&&f.uri instanceof v.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function r(f){if(m(f))return{resource:f};if(o(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(n(f))return{overrideIdentifier:f.languageId};if(i(f))return{resource:f.uri};if(f===null)return{resource:null}}let s=class{constructor(d,l,c){this.a=d.getProxy(P.$lM.MainThreadConfiguration),this.c=l,this.b=c,this.d=new A.$hh,this.e=null}getConfigProvider(){return this.d.wait().then(d=>this.e)}$initializeConfiguration(d){this.e=new t(this.a,this.c,d,this.b),this.d.open()}$acceptConfigurationChanged(d,l){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(d,l))}};e.$qjc=s,e.$qjc=s=Je([qe(0,p.$GO),qe(1,M.$pjc),qe(2,E.$Oj)],s);class t{constructor(d,l,c,h){this.a=new L.$7d,this.b=d,this.f=h,this.c=l,this.e=b.$mo.parse(c),this.d=this.k(c.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(d,l){const c={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$mo.parse(d),this.d=this.k(d.configurationScopes),this.a.fire(this.j(l,c))}getConfiguration(d,l,c){const h=r(l)||{},g=this.g(d?a(this.e.getValue(void 0,h,this.c.workspace),d):this.e.getValue(void 0,h,this.c.workspace));d&&this.h(d,h,c?.identifier);function S(C){if(C==null)return null;if(typeof C=="boolean")return C?2:5;switch(C){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const w={has(C){return typeof a(g,C)<"u"},get:(C,k)=>{this.h(d?`${d}.${C}`:C,h,c?.identifier);let D=a(g,C);if(typeof D>"u")D=k;else{let O;const F=(T,z)=>{if((0,y.$Xf)(T)){let j;const N=()=>{O=O||(0,u.$On)(g),j=j||a(O,z)};return new Proxy(T,{get:(B,W)=>{if(typeof W=="string"&&W.toLowerCase()==="tojson")return N(),()=>j;if(O)return j=j||a(O,z),j[W];const Z=B[W];return typeof W=="string"?F(Z,`${z}.${W}`):Z},set:(B,W,Z)=>(N(),j&&(j[W]=Z),!0),deleteProperty:(B,W)=>(N(),j&&delete j[W],!0),defineProperty:(B,W,Z)=>(N(),j&&Object.defineProperty(j,W,Z),!0)})}return Array.isArray(T)?(0,u.$On)(T):T};D=F(D,C)}return D},update:(C,k,D,O)=>{C=d?`${d}.${C}`:C;const F=S(D);return k!==void 0?this.b.$updateConfigurationOption(F,C,k,h,O):this.b.$removeConfigurationOption(F,C,h,O)},inspect:C=>{C=d?`${d}.${C}`:C;const k=this.e.inspect(C,h,this.c.workspace);if(k)return{key:C,defaultValue:(0,u.$On)(k.policy?.value??k.default?.value),globalValue:(0,u.$On)(k.user?.value??k.application?.value),workspaceValue:(0,u.$On)(k.workspace?.value),workspaceFolderValue:(0,u.$On)(k.workspaceFolder?.value),defaultLanguageValue:(0,u.$On)(k.default?.override),globalLanguageValue:(0,u.$On)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,u.$On)(k.workspace?.override),workspaceFolderLanguageValue:(0,u.$On)(k.workspaceFolder?.override),languageIds:(0,u.$On)(k.overrideIdentifiers)}}};return typeof g=="object"&&(0,u.$Rn)(w,g,!1),Object.freeze(w)}g(d){const l=c=>(0,y.$Xf)(c)?new Proxy(c,{get:(h,g)=>l(h[g]),set:(h,g,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(g)}' of object`)},deleteProperty:(h,g)=>{throw new Error(`TypeError: Cannot delete read only property '${String(g)}' of object`)},defineProperty:(h,g)=>{throw new Error(`TypeError: Cannot define property '${String(g)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return l(d)}h(d,l,c){const h=$.$do.test(d)?4:this.d.get(d),g=c?`[${c.value}] `:"";if(h===4){typeof l?.resource>"u"&&this.f.warn(`${g}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${d}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){l?.resource&&this.f.warn(`${g}Accessing a window scoped configuration for a resource is not expected. To associate '${d}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(d,l){const c=new b.$oo(d,l,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(h,g)=>c.affectsConfiguration(h,r(g))})}k(d){return d.reduce((l,c)=>(l.set(c[0],c[1]),l),new Map)}}e.$rjc=t,e.$sjc=(0,I.$ii)("IExtHostConfiguration")}),define(ke[95],Ee([1,0,2,8,4,6,7,43,72,44,22,47,20,28,5,15,11,12,91,307,13]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v,a,m,o,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vkc=e.$Ukc=e.$Tkc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var s;(function(F){function T(j){if(j!=null)return j}F.from=T;function z(j){if(j!=null)return j}F.to=z})(s||(s={}));var t;(function(F){function T(j){if(j!=null)return j}F.from=T;function z(j){if(j!=null)return j}F.to=z})(t||(t={}));var f;(function(F){function T(j){if(j!=null)return j}F.from=T;function z(j){if(j!=null)return j}F.to=z})(f||(f={}));var d;(function(F){function T(N){if(N){const B=N;return B&&!!B.process}else return!1}F.is=T;function z(N){if(N==null)return;const B={process:N.process,args:N.args};return N.options&&(B.options=f.from(N.options)),B}F.from=z;function j(N){if(N!=null)return new R.$9M(N.process,N.args,N.options)}F.to=j})(d||(d={}));var l;(function(F){function T(j){if(j!=null)return j}F.from=T;function z(j){if(j!=null)return j}F.to=z})(l||(l={}));var c;(function(F){function T(N){if(N){const B=N;return B&&(!!B.commandLine||!!B.command)}else return!1}F.is=T;function z(N){if(N==null)return;const B={};return N.commandLine!==void 0?B.commandLine=N.commandLine:(B.command=N.command,B.args=N.args),N.options&&(B.options=l.from(N.options)),B}F.from=z;function j(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new R.$0M(N.commandLine,N.options):new R.$0M(N.command,N.args?N.args:[],N.options)}F.to=j})(c||(c={}));var h;(function(F){function T(N){if(N){const B=N;return B&&B.customExecution==="customExecution"}else return!1}F.is=T;function z(N){return{customExecution:"customExecution"}}F.from=z;function j(N,B){return B.get(N)}F.to=j})(h||(e.CustomExecutionDTO=h={}));var g;(function(F){function T(z,j){let N;return z.scope!==void 0&&typeof z.scope!="number"?N=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===R.TaskScope.Workspace&&j&&j.workspaceFile?N=j.workspaceFile:N=i.$tH),{id:z._id,workspaceFolder:N}}F.from=T})(g||(e.TaskHandleDTO=g={}));var S;(function(F){function T(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}F.from=T})(S||(S={}));var w;(function(F){function T(N,B){if(N==null)return[];const W=[];for(const Z of N){const _=z(Z,B);_&&W.push(_)}return W}F.fromMany=T;function z(N,B){if(N==null)return;let W;N.execution instanceof R.$9M?W=d.from(N.execution):N.execution instanceof R.$0M?W=c.from(N.execution):N.execution&&N.execution instanceof R.$$M&&(W=h.from(N.execution));const Z=s.from(N.definition);let _;return N.scope?typeof N.scope=="number"?_=N.scope:_=N.scope.uri:_=R.TaskScope.Workspace,!Z||!_?void 0:{_id:N._id,definition:Z,name:N.name,source:{extensionId:B.identifier.value,label:N.source,scope:_},execution:W,isBackground:N.isBackground,group:S.from(N.group),presentationOptions:t.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}F.from=z;async function j(N,B,W){if(N==null)return;let Z;d.is(N.execution)?Z=d.to(N.execution):c.is(N.execution)?Z=c.to(N.execution):h.is(N.execution)&&(Z=h.to(N._id,W));const _=s.to(N.definition);let X;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?X=N.source.scope:X=await B.resolveWorkspaceFolder(u.URI.revive(N.source.scope)):X=R.TaskScope.Workspace),!_||!X)return;const x=new R.$_M(_,X,N.name,N.source.label,Z,N.problemMatchers);return N.isBackground!==void 0&&(x.isBackground=N.isBackground),N.group!==void 0&&(x.group=R.$8M.from(N.group._id),x.group&&N.group.isDefault&&(x.group=new R.$8M(x.group.id,x.group.label),N.group.isDefault===!0&&(x.group.isDefault=N.group.isDefault))),N.presentationOptions&&(x.presentationOptions=t.to(N.presentationOptions)),N._id&&(x._id=N._id),N.detail&&(x.detail=N.detail),x}F.to=j})(w||(e.TaskDTO=w={}));var C;(function(F){function T(j){return j}F.from=T;function z(j){if(j)return Object.assign(Object.create(null),j)}F.to=z})(C||(C={}));class k{#e;constructor(T,z,j){this._id=z,this.a=j,this.#e=T}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(T){}fireDidEndProcess(T){}}let D=class{constructor(T,z,j,N,B,W,Z,_){this.q=new M.$7d,this.r=new M.$7d,this.s=new M.$7d,this.u=new M.$7d,this.a=T.getProxy(P.$lM.MainThreadTask),this.b=j,this.c=N,this.d=B,this.e=W,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=Z,this.g=_,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(T,z,j){if(!j)return new R.$nM(()=>{});const N=this.x();return this.j.set(N,{type:z,provider:j,extension:T}),this.a.$registerTaskProvider(N,z),new R.$nM(()=>{this.j.delete(N),this.a.$unregisterTaskProvider(N)})}registerTaskSystem(T,z){this.a.$registerTaskSystem(T,z)}fetchTasks(T){return this.a.$fetchTasks(C.from(T)).then(async z=>{const j=[];for(const N of z){const B=await w.to(N,this.b,this.m);B&&j.push(B)}return j})}get taskExecutions(){const T=[];return this.k.forEach(z=>T.push(z)),T}terminateTask(T){if(!(T instanceof k))throw new Error("No valid task execution provided");return this.a.$terminateTask(T._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(T,z,j){const N=this.m.get(T.id);N&&(this.o.set(T.id,N),this.e.attachPtyToTerminal(z,await N.callback(j))),this.p=T.id,this.q.fire({execution:await this.z(T)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(T){if(!this.l.has(T.id))return;const z=await this.z(T);this.l.delete(T.id),this.k.delete(T.id),this.B(T),this.r.fire({execution:z})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(T){const z=await this.z(T.id);this.s.fire({execution:z,processId:T.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(T){const z=await this.z(T.id);this.u.fire({execution:z,exitCode:T.exitCode})}$provideTasks(T,z){const j=this.j.get(T);if(!j)return Promise.reject(new Error("no handler found"));const N=[],B=(0,L.$ah)(()=>j.provider.provideTasks(A.CancellationToken.None)).then(W=>this.v(z,N,j,W));return new Promise(W=>{B.then(Z=>{Promise.all(N).then(()=>{W(Z)})})})}async $resolveTask(T,z){const j=this.j.get(T);if(!j)return Promise.reject(new Error("no handler found"));if(z.definition.type!==j.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${j.type}].`);const N=await w.to(z,this.b,this.m);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const B=await j.provider.resolveTask(N,A.CancellationToken.None);if(!B)return;this.A(B,j);const W=w.from(B,j.extension);if(!W)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(W.execution)&&await this.y(W,B,!0),await this.w(W)}x(){return this.h++}async y(T,z,j){const N=await this.a.$createTaskId(T);!j&&!this.m.has(N)&&(this.n.add(N),this.o.set(N,z.execution)),this.m.set(N,z.execution)}async z(T,z){if(typeof T=="string"){const B=this.l.get(T);if(!B)throw new r.$bb("Unexpected: The specified task is missing an execution");return B}const j=this.l.get(T.id);if(j)return j;let N;return z?N=Promise.resolve(new k(this,T.id,z)):N=w.to(T.task,this.b,this.m).then(B=>{if(!B)throw new r.$bb("Unexpected: Task does not exist.");return new k(this,T.id,B)}),this.l.set(T.id,N),N.then(B=>(this.k.set(T.id,B),B))}A(T,z){T._deprecated&&this.g.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}B(T){this.o.get(T.id)&&this.o.delete(T.id),this.n.has(T.id)&&this.p!==T.id&&(this.m.delete(T.id),this.n.delete(T.id));const j=this.n.values();let N=j.next();for(;!N.done;)!this.o.has(N.value)&&this.p!==N.value&&(this.m.delete(N.value),this.n.delete(N.value)),N=j.next()}};e.$Tkc=D,e.$Tkc=D=Je([qe(0,p.$GO),qe(1,E.$WO),qe(2,b.$pjc),qe(3,$.$RO),qe(4,y.$sjc),qe(5,I.$Qjc),qe(6,o.$Oj),qe(7,n.$3ic)],D);let O=class extends D{constructor(T,z,j,N,B,W,Z,_){super(T,z,j,N,B,W,Z,_),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:m.$h(0)})}async executeTask(T,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const j=w.from(z,T);if(j===void 0)throw new Error("Task is not valid");if(h.is(j.execution))await this.y(j,z,!1);else throw new r.$_;const N=await this.z(await this.a.$getTaskExecution(j),z);return this.a.$executeTask(j).catch(B=>{throw new Error(B)}),N}v(T,z,j,N){const B=[];if(N)for(const W of N){if(this.A(W,j),!W.definition||!T[W.definition.type]){const _=W.source?W.source:"No task source";this.f.warn(`The task [${_}, ${W.name}] uses an undefined task type. The task will be ignored in the future.`)}const Z=w.from(W,j.extension);Z&&h.is(Z.execution)?(B.push(Z),z.push(this.y(Z,W,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:B,extension:j.extension}}async w(T){if(h.is(T.execution))return T;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(T,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(T,z,j){}};e.$Ukc=O,e.$Ukc=O=Je([qe(0,p.$GO),qe(1,E.$WO),qe(2,b.$pjc),qe(3,$.$RO),qe(4,y.$sjc),qe(5,I.$Qjc),qe(6,o.$Oj),qe(7,n.$3ic)],O),e.$Vkc=(0,v.$ii)("IExtHostTask")}),define(ke[369],Ee([1,0,36,29]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2K=void 0,e.$1K=M,e.$3K=P;function M(R){return"cellResults"in R}e.$2K="rawCell#";function P(R,b){let $=-1;const y=[];let A=[];return R.forEach(p=>{p.range.startLineNumber!==$&&A.length>0&&(y.push([...A]),A=[]),A.push(p),$=p.range.endLineNumber}),A.length>0&&y.push([...A]),y.map(p=>{const E=[],v=p[0].range.startLineNumber,a=p[p.length-1].range.endLineNumber;for(let m=v;m<=a;m++)E.push(b.getLineContent(m));return new u.$EK(E.join(`
`)+`
`,p.map(m=>new L.$ct(m.range.startLineNumber-1,m.range.startColumn-1,m.range.endLineNumber-1,m.range.endColumn-1)))})}}),define(ke[370],Ee([1,0,223,21,4,3,27,14,18,2,32,111,6,33,16,7,68,340,153,24,15,297,369,366]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v,a,m,o,n,i,r,s,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vkc=void 0;class d{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(c=>c.apiEditor)}constructor(c,h,g,S,w,C){this.q=g,this.r=S,this.s=w,this.t=C,this.f=new Map,this.g=new R.$Bc,this.h=new Map,this.j=new M.$7d,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new M.$7d,this.onDidOpenNotebookDocument=this.m.event,this.n=new M.$7d,this.onDidCloseNotebookDocument=this.n.event,this.o=new M.$7d,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.$1ic("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=c.getProxy(p.$lM.MainThreadNotebook),this.c=c.getProxy(p.$lM.MainThreadNotebookDocuments),this.d=c.getProxy(p.$lM.MainThreadNotebookEditors),this.i=h.converter,h.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===13){const D=k.notebookEditor?.notebookUri,O=k.cell.handle,T=this.g.get(D)?.getCell(O);if(T)return T.apiCell}if(k&&k.$mid===14){const D=k.uri,O=this.g.get(D);if(O)return O.apiNotebook}return k}}),d.B(h)}getEditorById(c){const h=this.h.get(c);if(!h)throw new Error(`unknown text editor: ${c}. known editors: ${[...this.h.keys()]} `);return h}getIdByEditor(c){for(const[h,g]of this.h)if(g.apiEditor===c)return h}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(c,h){const g=this.g.get(c);if(!g&&!h)throw new Error(`NO notebook document for '${c}'`);return g}static u(c,h){if(!h)return;const g=h.filenamePattern.map(S=>v.NotebookExclusiveDocumentPattern.from(S)).filter(S=>S!==void 0);if(h.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${h.filenamePattern}`);return}return{extension:c.identifier,providerDisplayName:c.displayName||c.name,displayName:h.displayName,filenamePattern:g,exclusive:h.exclusive||!1}}registerNotebookCellStatusBarItemProvider(c,h,g){const S=d.a++,w=typeof g.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set(S,g),this.b.$registerNotebookCellStatusBarItemProvider(S,w,h);let C;return w!==void 0&&(C=g.onDidChangeCellStatusBarItems(k=>this.b.$emitCellStatusBarEvent(w))),new a.$nM(()=>{this.f.delete(S),this.b.$unregisterNotebookCellStatusBarItemProvider(S,w),C?.dispose()})}async createNotebookDocument(c){const h=await this.c.$tryCreateNotebook({viewType:c.viewType,content:c.content&&v.NotebookData.from(c.content)});return y.URI.revive(h)}async openNotebookDocument(c){const h=this.g.get(c);if(h)return h.apiNotebook;const g=await this.c.$tryOpenNotebook(c),S=this.g.get(y.URI.revive(g));return(0,$.$7f)(S?.apiNotebook)}async showNotebookDocument(c,h){y.URI.isUri(c)&&(c=await this.openNotebookDocument(c));let g;typeof h=="object"?g={position:v.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selections:h.selections&&h.selections.map(v.NotebookRange.from),pinned:typeof h.preview=="boolean"?!h.preview:void 0}:g={preserveFocus:!1};const S=await this.d.$tryShowNotebookDocument(c.uri,c.notebookType,g),w=S&&this.h.get(S)?.apiEditor;if(w)return w;throw S?new Error(`Could NOT open editor for "${c.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${c.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(c,h,g,S){const w=this.f.get(c),C=y.URI.revive(h),k=this.g.get(C);if(!k||!w)return;const D=k.getCellFromIndex(g);if(!D)return;const O=await w.provideCellStatusBarItems(D.apiCell,S);if(!O)return;const F=new P.$Tc,T=this.p.add([F]),j=(Array.isArray(O)?O:[O]).map(N=>v.NotebookStatusBarItem.from(N,this.i,F));return{cacheId:T,items:j}}$releaseNotebookCellStatusBarItems(c){this.p.delete(c)}registerNotebookSerializer(c,h,g,S,w){if((0,b.$Ue)(h))throw new Error("viewType cannot be empty or just whitespace");const C=this.w++;return this.x.set(C,{viewType:h,serializer:g,options:S}),this.b.$registerNotebookSerializer(C,{id:c.identifier,location:c.extensionLocation},h,v.NotebookDocumentContentOptions.from(S),d.u(c,w)),(0,P.$Sc)(()=>{this.b.$unregisterNotebookSerializer(C)})}async $dataToNotebook(c,h,g){const S=this.x.get(c);if(!S)throw new Error("NO serializer found");const w=await S.serializer.deserializeNotebook(h.buffer,g);return new m.$ew(v.NotebookData.from(w))}async $notebookToData(c,h,g){const S=this.x.get(c);if(!S)throw new Error("NO serializer found");const w=await S.serializer.serializeNotebook(v.NotebookData.to(h.value),g);return L.$ue.wrap(w)}async $saveNotebook(c,h,g,S,w){const C=y.URI.revive(h),k=this.x.get(c);if(!k)throw new Error("NO serializer found");const D=this.g.get(C);if(!D)throw new Error("Document NOT found");if(D.versionId!==g)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(C.scheme))throw new A.$0k((0,u.localize)(0,null,this.z(C)),6);await this.y(C,S);const O={metadata:(0,i.$Wn)(D.apiNotebook.metadata,N=>!(k.options?.transientDocumentMetadata??{})[N]),cells:[]};for(const N of D.apiNotebook.getCells()){const B=new a.$PN(N.kind,N.document.getText(),N.document.languageId,N.mime,k.options?.transientOutputs?[]:[...N.outputs],N.metadata,N.executionSummary);B.metadata=(0,i.$Wn)(N.metadata,W=>!(k.options?.transientCellMetadata??{})[W]),O.cells.push(B)}const F=await k.serializer.serializeNotebook(O,w);await this.s.value.writeFile(C,F);const T=this.s.getFileSystemProviderExtUri(C.scheme),z=await this.s.value.stat(C);return{name:T.basename(C),isFile:(z.type&A.FileType.File)!==0,isDirectory:(z.type&A.FileType.Directory)!==0,isSymbolicLink:(z.type&A.FileType.SymbolicLink)!==0,mtime:z.mtime,ctime:z.ctime,size:z.size,readonly:!!((z.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(C.scheme),locked:!!((z.permissions??0)&A.FilePermission.Locked),etag:A.$il({mtime:z.mtime,size:z.size}),children:void 0}}async $searchInNotebooks(c,h,g,S,w){const C=this.x.get(c)?.serializer;if(!C)return{limitHit:!1,results:[]};const k=new R.$Cc;await(async(z,j,N)=>{await Promise.all(z.map(async B=>await Promise.all(B.filenamePatterns.map(W=>{const Z={_reason:N._reason,folderQueries:N.folderQueries,includePattern:N.includePattern,excludePattern:N.excludePattern,maxResults:N.maxResults,type:1,filePattern:W};return this.t.doInternalFileSearchWithCustomCallback(Z,j,_=>{_.forEach(X=>{k.has(X)||S.some(re=>B.isFromSettings&&!re.isFromSettings?!1:re.filenamePatterns.some(Y=>(0,f.$Efb)(Y,X)))||k.add(X)})}).catch(_=>{if(_.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw _})}))))})(g,w,h);const O=new R.$Bc;let F=!1;const T=Array.from(k).map(async z=>{const j=[];try{if(w.isCancellationRequested)return;if(h.maxResults&&[...O.values()].reduce((Z,_)=>Z+_.cellResults.length,0)>h.maxResults){F=!0;return}const N=[],B=this.g.get(z);if(B)B.apiNotebook.getCells().forEach(_=>N.push({input:_.document.getText(),outputs:_.outputs.flatMap(X=>X.items.map(x=>x.data.toString()))}));else{const Z=await this.s.value.readFile(z),_=L.$ue.fromString(Z.toString()),X=await C.deserializeNotebook(_.buffer,w);if(w.isCancellationRequested)return;v.NotebookData.from(X).cells.forEach(re=>N.push({input:re.source,outputs:re.outputs.flatMap(Y=>Y.items.map(me=>me.valueBytes.toString()))}))}if(w.isCancellationRequested)return;N.forEach((Z,_)=>{const X=h.contentPattern.pattern,x=new s.$AUb(Z.input,void 0,Z.outputs),re=x.findInInputs(X),Y=x.findInOutputs(X),me=Y.flatMap(Ce=>(0,t.$3K)(Ce.matches,Ce.textBuffer)).map((Ce,ee)=>(Ce.webviewIndex=ee,Ce));if(re.length>0||Y.length>0){const Ce={index:_,contentResults:(0,t.$3K)(re,x.inputTextBuffer),webviewResults:me};j.push(Ce)}});const W={resource:z,cellResults:j};O.set(z,W);return}catch{return}});return await Promise.all(T),{limitHit:F,results:[...O.values()]}}async y(c,h){const g=await this.s.value.stat(c);if(typeof h?.mtime=="number"&&typeof h.etag=="string"&&h.etag!==A.$hl&&typeof g.mtime=="number"&&typeof g.size=="number"&&h.mtime<g.mtime&&h.etag!==A.$il({mtime:h.mtime,size:g.size}))throw new A.$0k((0,u.localize)(1,null),3,h)}z(c){return c.scheme===r.Schemas.file?c.fsPath:c.toString()}A(c,h,g){if(this.h.has(h))throw new Error(`editor with id ALREADY EXSIST: ${h}`);const S=new n.$mkc(h,this.d,c,g.visibleRanges.map(v.NotebookRange.to),g.selections.map(v.NotebookRange.to),typeof g.viewColumn=="number"?v.ViewColumn.to(g.viewColumn):void 0);this.h.set(h,S)}$acceptDocumentAndEditorsDelta(c){if(c.value.removedDocuments)for(const g of c.value.removedDocuments){const S=y.URI.revive(g),w=this.g.get(S);w&&(w.dispose(),this.g.delete(S),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:w.apiNotebook.getCells().map(C=>C.document.uri)}),this.n.fire(w.apiNotebook));for(const C of this.h.values())C.notebookData.uri.toString()===S.toString()&&this.h.delete(C.id)}if(c.value.addedDocuments){const g=[];for(const S of c.value.addedDocuments){const w=y.URI.revive(S.uri);if(this.g.has(w))throw new Error(`adding EXISTING notebook ${w} `);const C=new o.$lkc(this.c,this.q,this.r,w,S);g.push(...S.cells.map(k=>o.$kkc.asModelAddData(k))),this.g.get(w)?.dispose(),this.g.set(w,C),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this.m.fire(C.apiNotebook)}}if(c.value.addedEditors)for(const g of c.value.addedEditors){if(this.h.has(g.id))return;const S=y.URI.revive(g.documentUri),w=this.g.get(S);w&&this.A(w,g.id,g)}const h=[];if(c.value.removedEditors)for(const g of c.value.removedEditors){const S=this.h.get(g);S&&(this.h.delete(g),this.k?.id===S.id&&(this.k=void 0),h.push(S))}if(c.value.visibleEditors){this.l=c.value.visibleEditors.map(S=>this.h.get(S)).filter(S=>!!S);const g=new Set;this.l.forEach(S=>g.add(S.id));for(const S of this.h.values()){const w=g.has(S.id);S._acceptVisibility(w)}this.l=[...this.h.values()].map(S=>S).filter(S=>S.visible),this.o.fire(this.visibleNotebookEditors)}c.value.newActiveEditor===null?this.k=void 0:c.value.newActiveEditor&&(this.h.get(c.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${c.value.newActiveEditor}`),this.k=this.h.get(c.value.newActiveEditor)),c.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(c){const h=E.$5O.String.with("notebookType","A notebook type"),g=new E.$7O("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[h,new E.$5O("data","Bytes to convert to data",w=>w instanceof Uint8Array,w=>L.$ue.wrap(w))],new E.$6O("Notebook Data",w=>v.NotebookData.to(w.value))),S=new E.$7O("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[h,new E.$5O("NotebookData","Notebook data to convert to bytes",w=>!0,w=>new m.$ew(v.NotebookData.from(w)))],new E.$6O("Bytes",w=>w.buffer));c.registerApiCommand(g),c.registerApiCommand(S)}}e.$vkc=d}),define(ke[371],Ee([1,0,17,22,46,35,23,39,36]),function(he,e,u,L,M,P,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nkc=void 0;class y{constructor(p,E,v){this.k=p,this.l=E,this.o=v,this.e=!1,this.f=0,this.g=!1,this.a=p.filePattern,this.b=p.includePattern&&P.$ck(p.includePattern),this.c=p.maxResults||void 0,this.d=p.exists,this.h=new Set,this.j=p.excludePattern&&P.$ck(p.excludePattern)}cancel(){this.g=!0,this.h.forEach(p=>p.cancel()),this.h=new Set}search(p){const E=this.k.folderQueries||[];return new Promise((v,a)=>{const m=o=>{this.f++,p(o)};if(this.g)return v({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const n=o.toString(),i=u.$oc(n);this.j&&this.j(n,i)||this.v(m,{base:o,basename:i})}),Promise.all(E.map(o=>this.p(o,m))).then(o=>{v({limitHit:this.e,stats:o[0]||void 0})},o=>{a(new Error((0,M.$6i)(o)))})})}async p(p,E){const v=new L.$ee,a=this.q(p),m=this.r(),o=new $.$SK(this.k,p),n=!o.hasSiblingExcludeClauses();let i;try{this.h.add(v),i=b.$3d.create();const r=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},a,v.token),s=i.elapsed(),t=b.$3d.create();return this.g&&!this.e||(r&&r.forEach(f=>{const d=u.$hc.relative(p.folder.path,f.path);if(n){const l=u.$oc(f.path);this.v(E,{base:p.folder,relativePath:d,basename:l});return}this.s(m,p.folder,d,E)}),this.g&&!this.e)?null:(this.u(m,o,E),{providerTime:s,postProcessTime:t.elapsed()})}finally{v.dispose(),this.h.delete(v)}}q(p){const E=(0,$.$RK)(this.k.includePattern,p.includePattern),v=(0,$.$RK)(this.k.excludePattern,p.excludePattern);return{folder:p.folder,excludes:v,includes:E,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const p={rootEntries:[],pathToEntries:Object.create(null)};return p.pathToEntries["."]=p.rootEntries,p}s({pathToEntries:p},E,v,a){if(v===this.a){const o=u.$oc(this.a);this.v(a,{base:E,relativePath:this.a,basename:o})}function m(o){const n=u.$oc(o),i=u.$nc(o);let r=p[i];r||(r=p[i]=[],m(i)),r.push({base:E,relativePath:o,basename:n})}m(v)}u({rootEntries:p,pathToEntries:E},v,a){const m=this,o=this.a;function n(i){const r=(0,$.$UK)(()=>i.map(s=>s.basename));for(let s=0,t=i.length;s<t;s++){const f=i[s],{relativePath:d,basename:l}=f;if(v.matchesExcludesSync(d,l,o!==l?r:void 0))continue;const c=E[d];if(c)n(c);else{if(d===o)continue;m.v(a,f)}if(m.e)break}}n(p)}v(p,E){(!this.b||E.relativePath&&this.b(E.relativePath,E.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||p(E))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(p,E,v,a){const m=this.c(p.cacheKey),o=new y(p,E,m&&m.token);let n=0;const i=r=>{n+=r.length,v(r.map(s=>this.d(s)))};return this.e(o,A.a,i,a).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:r.stats}}))}clearCache(p){this.c(p)?.cancel()}c(p){if(p)return this.b.has(p)||this.b.set(p,new L.$ee),this.b.get(p)}d(p){return p.relativePath?{resource:R.$Vg(p.base,p.relativePath)}:{resource:p.base}}e(p,E,v,a){const m=a.onCancellationRequested(()=>{p.cancel()}),o=i=>{i&&(n.push(i),E>0&&n.length>=E&&(v(n),n=[]))};let n=[];return p.search(o).then(i=>(n.length&&v(n),m.dispose(),i),i=>(n.length&&v(n),m.dispose(),Promise.reject(i)))}}e.$nkc=A}),define(ke[372],Ee([1,0,19,73,35,103,27,15,17,23,14,18,2,100,243,53,12,42,146,367,36]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v,a,m,o,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2L=void 0,e.$3L=S;let s=class{constructor(C,k,D,O,F){this.a=C,this.b=k,this.c=D,this.d=O,this.e=F}text(C,k,D={}){C=this.f(C,D);const O=this.a.getValue(),F=k&&k.some(z=>!this.a.getValue({resource:z}).search.useRipgrep);return{...this.h(k?.map(o.$Di),D),type:2,contentPattern:C,previewOptions:D.previewOptions,maxFileSize:D.maxFileSize,usePCRE2:O.search.usePCRE2||F||!1,beforeContext:D.beforeContext,afterContext:D.afterContext,userDisabledExcludesAndIgnoreFiles:D.disregardExcludeSettings&&D.disregardIgnoreFiles}}f(C,k){const D=this.a.getValue();C.isRegExp&&(C.pattern=C.pattern.replace(/\r?\n/g,"\\n"));const O={...C,wordSeparators:D.editor.wordSeparators};return this.j(C,k)&&(O.isCaseSensitive=!0),this.k(C)&&(O.isMultiline=!0),k.notebookSearchConfig?.includeMarkupInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownInput=k.notebookSearchConfig.includeMarkupInput),k.notebookSearchConfig?.includeMarkupPreview&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownPreview=k.notebookSearchConfig.includeMarkupPreview),k.notebookSearchConfig?.includeCodeInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellInput=k.notebookSearchConfig.includeCodeInput),k.notebookSearchConfig?.includeOutput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellOutput=k.notebookSearchConfig.includeOutput),O}file(C,k={}){return{...this.h(C,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey,shouldGlobMatchFilePattern:k.shouldGlobSearch}}g(C,k){return C?(C=Array.isArray(C)?C.map(c):c(C),k?this.parseSearchPaths(C):{pattern:f(...Array.isArray(C)?C:[C])}):{}}h(C=[],k={}){const D=this.g(k.includePattern,k.expandPatterns),O=this.g(k.excludePattern,k.expandPatterns),F=C.length>1,T=(D.searchPaths&&D.searchPaths.length?D.searchPaths.map(N=>this.q(N,k,O)):C.map(N=>this.r(N,k,O,F))).filter(N=>!!N),z={_reason:k._reason,folderQueries:T,usingSearchPaths:!!(D.searchPaths&&D.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:O.pattern,includePattern:D.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const N=u.$Hb(u.$Rb(this.c.groups.map(Z=>Z.editors.map(_=>_.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const B=N.filter(Z=>(0,r.$IK)(z,Z.fsPath)),W=this.i(B);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(W)),{...z,...W}}const j=k.extraFileResources&&k.extraFileResources.filter(N=>(0,r.$IK)(z,N.fsPath));return z.extraFileResources=j&&j.length?j:void 0,z}i(C){const k=[],D=new R.$Bc,O={};let F=!1;return C.forEach(T=>{if(T.scheme===b.Schemas.walkThrough)return;if((0,y.$Zg)(T)){const j=this.b.getWorkspaceFolder(T)?.uri??T.with({path:$.$nc(T.fsPath)});let N=D.get(j);N||(F=!0,N={folder:j,includePattern:{}},k.push(N),D.set(j,N));const B=$.$mc(j.fsPath,T.fsPath);(0,I.$7f)(N.includePattern)[B.replace(/\\/g,"/")]=!0}else T.fsPath&&(F=!0,O[T.fsPath]=!0)}),{folderQueries:k,includePattern:O,usingSearchPaths:!0,excludePattern:F?void 0:{"**/*":!0}}}j(C,k){if(k.isSmartCase){if(C.isRegExp){if(A.$Mf(C.pattern,!0))return!0}else if(A.$Mf(C.pattern))return!0}return!!C.isCaseSensitive}k(C){return C.isMultiline||C.isRegExp&&(0,E.$pC)(C.pattern)||C.pattern.indexOf(`
`)>=0?!0:!!C.isMultiline}parseSearchPaths(C){const k=W=>$.$jc(W)||/^\.\.?([\/\\]|$)/.test(W),O=(Array.isArray(C)?C:d(C)).map(W=>{const Z=this.e.resolvedUserHome;return Z?(0,P.$jw)(W,Z.scheme===b.Schemas.file?Z.fsPath:Z.path):W}),F=L.$K(O,W=>k(W)?"searchPaths":"exprSegments"),T=(F.exprSegments||[]).map(W=>A.$6e(W,"/")).map(W=>A.$6e(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),l(W))),z={},j=this.m(F.searchPaths||[]);j&&j.length&&(z.searchPaths=j);const N=u.$Rb(T),B=f(...N);return B&&(z.pattern=B),z}l(C,k){return k.disregardExcludeSettings?void 0:(0,r.$HK)(C,!k.disregardSearchExcludeSettings)}m(C){if(!C||!C.length)return[];const k=C.flatMap(O=>{let{pathPortion:F,globPortion:T}=t(O);return T&&(T=h(T)),this.n(F).flatMap(j=>this.o(j,T))}),D=new Map;return k.forEach(O=>{const F=O.searchPath.toString(),T=D.get(F);T?O.pattern&&(T.pattern=T.pattern||{},T.pattern[O.pattern]=!0):D.set(F,{searchPath:O.searchPath,pattern:O.pattern?f(O.pattern):void 0})}),Array.from(D.values())}n(C){if($.$jc(C)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==b.Schemas.file?[{searchPath:k[0].uri.with({path:C})}]:[{searchPath:p.URI.file($.$ic(C))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(C=c(C),C.startsWith("../")||C===".."){const O=$.$hc.resolve(k.path,C);return[{searchPath:k.with({path:O})}]}const D=h(C);return[{searchPath:k,pattern:D}]}else{if(C==="./"||C===".\\")return[];{const k=C.replace(/^\.[\/\\]/,""),O=this.b.getWorkspace().folders.map(F=>{const T=k.match(new RegExp(`^${A.$Ze(F.name)}(?:/(.*)|$)`));return T?{match:T,folder:F}:null}).filter(I.$4f);if(O.length)return O.map(F=>{const T=F.match[1];return{searchPath:F.folder.uri,pattern:T&&h(T)}});{const F=C.match(/\.[\/\\](.+)[\/\\]?/),T=F?F[1]:C,z=v.localize(0,null,T);throw new Error(z)}}}}o(C,k){const D=C.pattern&&k?`${C.pattern}/${k}`:C.pattern||k,O=[{searchPath:C.searchPath,pattern:D}];return D&&!D.endsWith("**")&&O.push({searchPath:C.searchPath,pattern:D+"/**"}),O}q(C,k,D){const O=this.r((0,o.$Di)(C.searchPath),k,D,!1);return O?{...O,includePattern:C.pattern}:null}r(C,k,D,O){let F;const T=p.URI.isUri(C)?C:C.uri;if(D.searchPaths){const W=D.searchPaths.filter(Z=>(0,y.$Og)(Z.searchPath,T))[0];if(W&&!W.pattern)return null;W&&(F=W.pattern)}const z=this.a.getValue({resource:T}),N={...this.l(z,k)||{},...F||{}},B=p.URI.isUri(C)?(0,y.$Sg)(C):C.name;return{folder:T,folderName:O?B:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!z.search.followSymlinks}}};e.$2L=s,e.$2L=s=Je([qe(0,a.$Oi),qe(1,o.$ri),qe(2,n.$wD),qe(3,m.$Oj),qe(4,i.$ZL)],s);function t(w){const C=w.match(/[\*\{\}\(\)\[\]\?]/);if(C){const k=C.index,D=w.substr(0,k).match(/[/|\\][^/\\]*$/);if(D){let O=w.substr(0,D.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:w.substr((D.index||0)+1)}}}return{pathPortion:w}}function f(...w){return w.length?w.reduce((C,k)=>(C[k]=!0,C),Object.create(null)):void 0}function d(w){return M.$ak(w,",").map(C=>C.trim()).filter(C=>!!C.length)}function l(w){return[`**/${w}/**`,`**/${w}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function c(w){return w.replace(/\\/g,"/")}function h(w){return c(w).replace(/^\.\//,"").replace(/\/+$/g,"")}function g(w){return w.replace(/([?*[\]])/g,"[$1]")}function S(w,C){w=u.$Mb(w,O=>O.toString());const k=[],D=C.getWorkspace();return w&&w.forEach(O=>{let F;if(C.getWorkbenchState()===2)F=(0,y.$Xg)(D.folders[0].uri,O),F&&F!=="."&&(F="./"+F);else{const T=C.getWorkspaceFolder(O);if(T){const z=T.name;if(D.folders.filter(N=>N.name===z).length===1){const N=(0,y.$Xg)(T.uri,O);N===""?F=`./${T.name}`:F=`./${T.name}/${N}`}else F=O.fsPath}}F&&k.push(g(F))}),k}}),define(ke[373],Ee([1,0,23,2,22,13,5,372,36,42,8]),function(he,e,u,L,M,P,R,b,$,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ivb=p,e.$jvb=a;const I=7e3;function p(m,o){const n=o.activationEvents;if(!n)return Promise.resolve(void 0);const i=[],r=[];for(const c of n)if(/^workspaceContains:/.test(c)){const h=c.substr(18);h.indexOf("*")>=0||h.indexOf("?")>=0||m.forceUsingSearch?r.push(h):i.push(h)}if(i.length===0&&r.length===0)return Promise.resolve(void 0);const{promise:s,resolve:t}=(0,A.$bh)(),f=c=>t({activationEvent:c}),d=Promise.all(i.map(c=>E(m,c,f))).then(()=>{}),l=v(m,o.identifier,r,f);return Promise.all([d,l]).then(()=>{t(void 0)}),s}async function E(m,o,n){for(const i of m.folders)if(await m.exists(u.$Vg(L.URI.revive(i),o))){n(`workspaceContains:${o}`);return}}async function v(m,o,n,i){if(n.length===0)return Promise.resolve(void 0);const r=new M.$ee,s=m.checkExists(m.folders,n,r.token),t=setTimeout(async()=>{r.cancel(),m.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},I);let f=!1;try{f=await s}catch(d){P.$4(d)||P.$1(d)}r.dispose(),clearTimeout(t),f&&i(`workspaceContains:${n.join(",")}`)}function a(m,o,n,i){const r=m.get(R.$hi),s=m.get($.$zK),f=r.createInstance(b.$2L).file(o.map(d=>(0,y.$Di)(L.URI.revive(d))),{_reason:"checkExists",includePattern:n,exists:!0});return s.fileSearch(f,i).then(d=>!!d.limitHit,d=>P.$4(d)?!1:Promise.reject(d))}}),define(ke[48],Ee([1,0,219,17,58,23,8,3,77,2,12,6,44,303,118,43,26,148,13,25,21,280,7,65,5,28,93,20,107,70,47,121,4,373,117,282,15,115,39,11,116]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v,a,m,o,n,i,r,s,t,f,d,l,c,h,g,S,w,C,k,D,O,F,T,z,j,N,B){"use strict";var W;Object.defineProperty(e,"__esModule",{value:!0}),e.$6jc=e.$5jc=e.$4jc=e.$3jc=e.$2jc=void 0,e.$2jc=(0,d.$ii)("IHostUtils");let Z=W=class extends b.$Uc{constructor(U,ie,be,Se,ae,ce,se,K,te,le,de,Ae,$e){super(),this.Y=Ae,this.Z=$e,this.a=this.B(new k.$7d),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=ie,this.g=be,this.f=se,this.j=Se,this.m=ae,this.s=ce,this.t=te,this.u=le,this.w=de,this.y=this.g.getProxy(I.$lM.MainThreadWorkspace),this.z=this.g.getProxy(I.$lM.MainThreadTelemetry),this.C=this.g.getProxy(I.$lM.MainThreadExtensionService),this.D=new R.$hh,this.F=new R.$hh,this.G=new R.$hh,this.H=new R.$hh,this.I=new Ce(this.f.extensions.activationEvents),this.L=new o.$W0b(this.I,this.f.extensions.allExtensions);const Ie=new i.$Em(this.f.extensions.myExtensions);this.J=new o.$W0b(this.I,Y(this.L,Ie)),N.$t&&(this.s.info(`Creating extension host with the following global extensions: ${x(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${x(this.J)}`)),this.M=new v.$Mjc(this.g,this.s),this.N=new O.$Ujc(this.g),this.O=K,this.h=U.createChild(new g.$gi([v.$Njc,this.M],[O.$Vjc,this.N])),this.P=this.B(new E.$Ljc(this.J,this.L,{onExtensionActivationError:(Re,Fe,q)=>{this.C.$onExtensionActivationError(Re,n.$3(Fe),q)},actualActivateExtension:async(Re,Fe)=>{if(o.$W0b.isHostExtension(Re,this.J,this.L))return await this.C.$activateExtension(Re,Fe),new E.$Kjc;const q=this.J.getExtensionDescription(Re);return this.fb(q,Fe)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),M.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(U){n.$1(U)}}async $(){this.O.onWillDeactivateAll();let U=[];try{U=this.J.getAllExtensionDescriptions().map(ae=>ae.identifier).filter(ae=>this.isActivated(ae)).map(ae=>this.eb(ae))}catch{}await Promise.all(U)}terminate(U,ie=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${U}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Se=>{this.s.error(Se)}),this.g.dispose();const be=this.$();Promise.race([(0,R.$jh)(5e3),be]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${ie}`):this.s.info(`Extension host exiting with code ${ie}`),this.s.flush(),this.s.dispose(),this.c.exit(ie)})}isActivated(U){return this.G.isOpen()?this.P.isActivated(U):!1}async getExtension(U){const ie=await this.C.$getExtension(U);return ie&&{...ie,identifier:new i.$Dm(ie.identifier.value),extensionLocation:y.URI.revive(ie.extensionLocation)}}ab(U,ie){return this.P.activateByEvent(U,ie)}bb(U,ie){return this.P.activateById(U,ie)}activateByIdWithErrors(U,ie){return this.bb(U,ie).then(()=>{const be=this.P.getActivatedExtension(U);if(be.activationFailed)return Promise.reject(be.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(U=>this.J)}getExtensionExports(U){if(this.G.isOpen())return this.P.getActivatedExtension(U).exports;try{return this.P.getActivatedExtension(U).exports}catch{return null}}async cb(U){if(U.scheme===T.Schemas.file&&this.c.fsRealpath){const ie=U.fsPath;this.R.has(ie)||this.R.set(ie,this.c.fsRealpath(ie));const be=await this.R.get(ie);return y.URI.file(be)}return U}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(U=>new me(U))),this.Q}async db(U){const ie=$.$oi.forUris(be=>P.$Mg.ignorePathCasing(be));return await Promise.all(U.map(async be=>{if(this.wb(be)){const Se=await this.cb(be.extensionLocation);ie.set(Se,be)}})),ie}eb(U){let ie=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(U))return ie;const be=this.P.getActivatedExtension(U);if(!be)return ie;try{typeof be.module.deactivate=="function"&&(ie=Promise.resolve(be.module.deactivate()).then(void 0,Se=>(this.s.error(Se),Promise.resolve(void 0))))}catch(Se){this.s.error(`An error occurred when deactivating the extension '${U.value}':`),this.s.error(Se)}try{(0,b.$Pc)(be.subscriptions)}catch(Se){this.s.error(`An error occurred when deactivating the subscriptions for extension '${U.value}':`),this.s.error(Se)}return ie}async fb(U,ie){return this.f.remote.isRemote?this.C.$onWillActivateExtension(U.identifier):await this.C.$onWillActivateExtension(U.identifier),this.hb(U,ie).then(be=>{const Se=be.activationTimes;return this.C.$onDidActivateExtension(U.identifier,Se.codeLoadingTime,Se.activateCallTime,Se.activateResolvedTime,ie),this.gb(U,ie,"success",Se),be},be=>{throw this.gb(U,ie,"failure"),be})}gb(U,ie,be,Se){const ae=X(U,ie);this.z.$publicLog2("extensionActivationTimes",{...ae,...Se||{},outcome:be})}hb(U,ie){const be=X(U,ie);this.z.$publicLog2("activatePlugin",be);const Se=this.wb(U);if(!Se)return Promise.resolve(new E.$Jjc(E.$Gjc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${U.identifier.value}, startup: ${ie.startup}, activationEvent: '${ie.activationEvent}'${U.identifier.value!==ie.extensionId.value?`, root cause: ${ie.extensionId.value}`:""}`),this.s.flush();const ae=new E.$Hjc(ie.startup);return Promise.all([this.xb(U,(0,P.$Vg)(U.extensionLocation,Se),ae),this.ib(U)]).then(ce=>(M.mark(`code/extHost/willActivateExtension/${U.identifier.value}`),W.jb(this.s,U.identifier,ce[0],ce[1],ae))).then(ce=>(M.mark(`code/extHost/didActivateExtension/${U.identifier.value}`),ce))}ib(U){const ie=this.Z.createLanguageModelAccessInformation(U),be=new s.$Pjc(U,this.M),Se=new s.$Ojc(U.identifier.value,!1,this.M),ae=new F.$Wjc(U,this.N),ce=U.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,se=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${U.identifier.value}`),Promise.all([be.whenReady,Se.whenReady,this.O.whenReady]).then(()=>{const K=this;let te,le;const de=(0,m.$9F)(U,"ipc")?this.f.messagePorts?.get(i.$Dm.toKey(U.identifier)):void 0;return Object.freeze({globalState:be,workspaceState:Se,secrets:ae,subscriptions:[],get languageModelAccessInformation(){return ie},get extensionUri(){return U.extensionLocation},get extensionPath(){return U.extensionLocation.fsPath},asAbsolutePath(Ae){return L.$kc(U.extensionLocation.fsPath,Ae)},get storagePath(){return K.O.workspaceValue(U)?.fsPath},get globalStoragePath(){return K.O.globalValue(U).fsPath},get logPath(){return L.$kc(K.f.logsLocation.fsPath,U.identifier.value)},get logUri(){return y.URI.joinPath(K.f.logsLocation,U.identifier.value)},get storageUri(){return K.O.workspaceValue(U)},get globalStorageUri(){return K.O.globalValue(U)},get extensionMode(){return ce},get extension(){return te===void 0&&(te=new re(K,U.identifier,U,se,!1)),te},get extensionRuntime(){return(0,m.$0F)(U,"extensionRuntime"),K.extensionRuntime},get environmentVariableCollection(){return K.u.getEnvironmentVariableCollection(U)},get messagePassingProtocol(){if(!le){if(!de)return;const Ae=k.Event.buffer(k.Event.fromDOMEventEmitter(de,"message",$e=>$e.data));de.start(),le={onDidReceiveMessage:Ae,postMessage:de.postMessage.bind(de)}}return le}})})}static jb(U,ie,be,Se,ae){return be=be||{activate:void 0,deactivate:void 0},this.kb(U,ie,be,Se,ae).then(ce=>new E.$Ijc(!1,null,ae.build(),be,ce,Se.subscriptions))}static kb(U,ie,be,Se,ae){if(typeof be.activate=="function")try{ae.activateCallStart(),U.trace(`ExtensionService#_callActivateOptional ${ie.value}`);const ce=typeof global=="object"?global:self,se=be.activate.apply(ce,[Se]);return ae.activateCallStop(),ae.activateResolveStart(),Promise.resolve(se).then(K=>(ae.activateResolveStop(),K))}catch(ce){return Promise.reject(ce)}else return Promise.resolve(be)}lb(U,ie){this.bb(U.identifier,{startup:!1,extensionId:U.identifier,activationEvent:ie}).then(void 0,be=>{this.s.error(be)})}mb(U,ie=0){const Se=Date.now();(0,N.$B)(()=>{for(let ae=ie;ae<U.length;ae+=1){const ce=U[ae];for(const se of ce.activationEvents??[])if(se==="onStartupFinished")if(Date.now()-Se>50){this.mb(U,ae);break}else this.lb(ce,se)}})}nb(){this.C.$setPerformanceMarks(M.getMarks()),this.m.getConfigProvider().then(U=>{const ie=U.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),be=this.J.getAllExtensionDescriptions();if(ie)this.mb(be);else for(const Se of be)if(Se.activationEvents)for(const ae of Se.activationEvents)ae==="onStartupFinished"&&this.lb(Se,ae)})}ob(){const U=this.ab("*",!0).then(void 0,ce=>{this.s.error(ce)});this.B(this.j.onDidChangeWorkspace(ce=>this.pb(ce.added)));const ie=this.j.workspace?this.j.workspace.folders:[],be=this.pb(ie),Se=this.rb(),ae=Promise.all([Se,U,be]).then(()=>{});return Promise.race([ae,(0,R.$jh)(1e4)]).then(()=>{this.nb()}),ae}pb(U){return U.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(ie=>this.qb(U,ie))).then(()=>{})}async qb(U,ie){if(this.isActivated(ie.identifier))return;const be=!this.f.remote.isRemote&&!!this.f.remote.authority,Se={logService:this.s,folders:U.map(ce=>ce.uri),forceUsingSearch:be||!this.c.fsExists,exists:ce=>this.c.fsExists(ce.fsPath),checkExists:(ce,se,K)=>this.y.$checkExists(ce,se,K)},ae=await(0,D.$ivb)(Se,ie);if(ae)return this.bb(ie.identifier,{startup:!0,extensionId:ie.identifier,activationEvent:ae.activationEvent}).then(void 0,ce=>this.s.error(ce))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(U){throw console.error(U),U}}async sb(){const{extensionDevelopmentLocationURI:U,extensionTestsLocationURI:ie}=this.f.environment;if(!U||!ie)throw new Error(u.localize(0,null));const be=await this.xb(null,ie,new E.$Hjc(!1));if(!be||typeof be.run!="function")throw new Error(u.localize(1,null,ie.toString()));return new Promise((Se,ae)=>{const ce=(te,le)=>{te?(N.$t&&this.s.error("Test runner called back with error",te),ae(te)):(N.$t&&(le?this.s.info(`Test runner called back with ${le} failures.`):this.s.info("Test runner called back with successful outcome.")),Se(typeof le=="number"&&le>0?1:0))},se=(0,P.$Jg)(ie),K=be.run(se,ce);K&&K.then&&K.then(()=>{N.$t&&this.s.info("Test runner finished successfully."),Se(0)}).catch(te=>{N.$t&&this.s.error("Test runner finished with error",te),ae(te instanceof Error&&te.stack?te.stack:String(te))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$jh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(U,ie){return this.S[U]=ie,(0,b.$Sc)(()=>{delete this.S[U]})}async getRemoteExecServer(U){const{resolver:ie}=await this.ub(U);return ie?.resolveExecServer?.(U,{resolveAttempt:0})}async ub(U){const ie=U.indexOf("+");if(ie===-1)throw new t.$tM("Not an authority that can be resolved!",f.RemoteAuthorityResolverErrorCode.InvalidAuthority);const be=U.substr(0,ie);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${be}`,!1),{authorityPrefix:be,resolver:this.S[be]}}async $resolveAuthority(U,ie){const be=j.$3d.create(!1),Se=()=>`[resolveAuthority(${(0,f.$xl)(U)},${ie})][${be.elapsed()}ms] `,ae=V=>this.s.info(`${Se()}${V}`),ce=V=>this.s.warn(`${Se()}${V}`),se=(V,Q=void 0)=>this.s.error(`${Se()}${V}`,Q),K=V=>{if(V instanceof t.$tM)return{type:"error",error:{code:V._code,message:V._message,detail:V._detail}};throw V},te=async V=>{ae(`activating resolver for ${V}...`);const{resolver:Q,authorityPrefix:J}=await this.ub(V);if(!Q)throw se(`no resolver for ${J}`),new t.$tM(`No remote extension installed to resolve ${J}.`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Q,authorityPrefix:J,remoteAuthority:V}},le=U.split(/@|%40/g).reverse();ae(`activating remote resolvers ${le.join(" -> ")}`);let de;try{de=await Promise.all(le.map(te)).catch(async V=>{if(!(V instanceof t.$tM)||V._code!==f.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw V;return ce(`resolving nested authorities failed: ${V.message}`),[await te(U)]})}catch(V){return K(V)}const Ae=new R.$th;Ae.cancelAndSet(()=>ae("waiting..."),1e3);let $e,Ie;for(const[V,{authorityPrefix:Q,resolver:J,remoteAuthority:fe}]of de.entries())try{if(V===de.length-1)ae("invoking final resolve()..."),M.mark(`code/extHost/willResolveAuthority/${Q}`),$e=await J.resolve(fe,{resolveAttempt:ie,execServer:Ie}),M.mark(`code/extHost/didResolveAuthorityOK/${Q}`),ae("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(J,t.$sM.isManagedResolvedAuthority($e)?$e:void 0));else{if(ae(`invoking resolveExecServer() for ${fe}`),M.mark(`code/extHost/willResolveExecServer/${Q}`),Ie=await J.resolveExecServer?.(fe,{resolveAttempt:ie,execServer:Ie}),!Ie)throw new t.$tM(`Exec server was not available for ${fe}`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);M.mark(`code/extHost/didResolveExecServerOK/${Q}`)}}catch(we){return M.mark(`code/extHost/didResolveAuthorityError/${Q}`),se("returned an error",we),Ae.dispose(),K(we)}Ae.dispose();const Re={environmentTunnels:$e.environmentTunnels,features:$e.tunnelFeatures?{elevation:$e.tunnelFeatures.elevation,privacyOptions:$e.tunnelFeatures.privacyOptions,protocol:$e.tunnelFeatures.protocol===void 0?!0:$e.tunnelFeatures.protocol}:void 0},Fe={extensionHostEnv:$e.extensionHostEnv,isTrusted:$e.isTrusted,authenticationSession:$e.authenticationSessionForInitializingExtensions?{id:$e.authenticationSessionForInitializingExtensions.id,providerId:$e.authenticationSessionForInitializingExtensions.providerId}:void 0};ae(`returned ${t.$sM.isManagedResolvedAuthority($e)?"managed authority":`${$e.host}:${$e.port}`}`);let q;if(t.$sM.isManagedResolvedAuthority($e)){const V=ie;this.Y.setFactory(V,$e.makeConnection),q={authority:U,connectTo:new f.$ul(V),connectionToken:$e.connectionToken}}else q={authority:U,connectTo:new f.$vl($e.host,$e.port),connectionToken:$e.connectionToken};return{type:"ok",value:{authority:q,options:Fe,tunnelInformation:Re}}}async $getCanonicalURI(U,ie){this.s.info(`$getCanonicalURI invoked for authority (${(0,f.$xl)(U)})`);const{resolver:be}=await this.ub(U);if(!be)return null;const Se=y.URI.revive(ie);if(typeof be.getCanonicalURI>"u")return Se;const ae=await(0,R.$ah)(()=>be.getCanonicalURI(Se));return ae||Se}async $startExtensionHost(U){U.toAdd.forEach(ce=>ce.extensionLocation=y.URI.revive(ce.extensionLocation));const{globalRegistry:ie,myExtensions:be}=_(this.I,this.L,this.J,U),Se=await this.db(be);return(await this.getExtensionPathIndex()).setSearchTree(Se),this.L.set(ie.getAllExtensionDescriptions()),this.J.set(be),N.$t&&(this.s.info(`$startExtensionHost: global extensions: ${x(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${x(this.J)}`)),this.tb()}$activateByEvent(U,ie){return ie===1?this.D.wait().then(be=>this.ab(U,!1)):this.G.wait().then(be=>this.ab(U,!1))}async $activate(U,ie){return await this.G.wait(),this.J.getExtensionDescription(U)?(await this.bb(U,ie),!0):!1}async $deltaExtensions(U){U.toAdd.forEach(ce=>ce.extensionLocation=y.URI.revive(ce.extensionLocation));const{globalRegistry:ie,myExtensions:be}=_(this.I,this.L,this.J,U),Se=await this.db(be);return(await this.getExtensionPathIndex()).setSearchTree(Se),this.L.set(ie.getAllExtensionDescriptions()),this.J.set(be),N.$t&&(this.s.info(`$deltaExtensions: global extensions: ${x(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${x(this.J)}`)),Promise.resolve(void 0)}async $test_latency(U){return U}async $test_up(U){return U.byteLength}async $test_down(U){const ie=r.$ue.alloc(U),be=Math.random()%256;for(let Se=0;Se<U;Se++)ie.writeUInt8(be,Se);return ie}async $updateRemoteConnectionData(U){this.X=U,this.a.fire()}};e.$3jc=Z,e.$3jc=Z=W=Je([qe(0,d.$hi),qe(1,e.$2jc),qe(2,h.$GO),qe(3,a.$pjc),qe(4,p.$sjc),qe(5,A.$Oj),qe(6,l.$WO),qe(7,c.$vjc),qe(8,S.$NBb),qe(9,w.$Qjc),qe(10,z.$Yjc),qe(11,B.$Zjc),qe(12,C.$fjc)],Z);function _(ee,U,ie,be){ee.addActivationEvents(be.addActivationEvents);const Se=new o.$W0b(ee,U.getAllExtensionDescriptions());Se.deltaExtensions(be.toAdd,be.toRemove);const ae=new i.$Em(ie.getAllExtensionDescriptions().map(se=>se.identifier));for(const se of be.myToRemove)ae.delete(se);for(const se of be.myToAdd)ae.add(se);const ce=Y(Se,ae);return{globalRegistry:Se,myExtensions:ce}}function X(ee,U){return{id:ee.identifier.value,name:ee.name,extensionVersion:ee.version,publisherDisplayName:ee.publisher,activationEvents:ee.activationEvents?ee.activationEvents.join(","):null,isBuiltin:ee.isBuiltin,reason:U.activationEvent,reasonId:U.extensionId.value}}function x(ee){return ee.getAllExtensionDescriptions().map(U=>U.identifier.value).join(",")}e.$4jc=(0,d.$ii)("IExtHostExtensionService");class re{#e;#t;#i;constructor(U,ie,be,Se,ae){this.#e=U,this.#t=ie,this.#i=be.identifier,this.id=be.identifier.value,this.extensionUri=be.extensionLocation,this.extensionPath=L.$ic((0,P.$Jg)(be.extensionLocation)),this.packageJSON=be,this.extensionKind=Se,this.isFromDifferentExtensionHost=ae}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$5jc=re;function Y(ee,U){return ee.getAllExtensionDescriptions().filter(ie=>U.has(ie.identifier))}class me{constructor(U){this.a=U}setSearchTree(U){this.a=U}findSubstr(U){return this.a.findSubstr(U)}forEach(U){return this.a.forEach(U)}}e.$6jc=me;class Ce{constructor(U){this.a=new i.$Fm,this.addActivationEvents(U)}readActivationEvents(U){return this.a.get(U.identifier)??[]}addActivationEvents(U){for(const ie of Object.keys(U))this.a.set(ie,U[ie])}}}),define(ke[374],Ee([1,0,58,2,6,44,26,25,20,28,5,48,12,14]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$blc=void 0;let a=class{constructor(r,s,t,f,d,l,c){this.c=r,this.d=s,this.e=t,this.f=f,this.g=d,this.h=l,this.i=c,this.a=new Map,this.b=[]}async install(){this.j(),u.mark("code/extHost/willWaitForConfig");const r=await this.f.getConfigProvider();u.mark("code/extHost/didWaitForConfig");const s=await this.g.getExtensionPathIndex();this.register(new o(this.c,s,this.d,r,this.i)),this.register(this.e.createInstance(m)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,s,this.h.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(const s of r.nodeModuleName)this.a.set(s,r);else this.a.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this.b.push(s=>r.alternativeModuleName(s))}};e.$blc=a,e.$blc=a=Je([qe(2,A.$hi),qe(3,P.$sjc),qe(4,I.$4jc),qe(5,y.$WO),qe(6,p.$Oj)],a);let m=class{static{v=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(r){if(r.environment.appRoot&&v.a.size){const s=(0,E.$Ze)(this.c(r.environment.appRoot.fsPath)),t="[a-z0-9_.-]",f=`@${t}+\\/${t}+|${t}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${s}/${d}\\/)(${f})(.*)$`,"i")}}alternativeModuleName(r){if(!this.b)return;const s=this.b.exec(this.c(r));if(!s)return;const[,t,f,d]=s,l=v.a.get(f);if(l!==void 0)return console.warn(`${f} as been renamed to ${l}, please update your imports`),t+l+d}c(r){return r.replace(/\\/g,"/")}};m=v=Je([qe(0,y.$WO)],m);class o{constructor(r,s,t,f,d){this.c=r,this.d=s,this.e=t,this.f=f,this.g=d,this.nodeModuleName="vscode",this.a=new b.$Fm}load(r,s){const t=this.d.findSubstr(s);if(t){let f=this.a.get(t.identifier);return f||(f=this.c(t,this.e,this.f),this.a.set(t.identifier,f)),f}if(!this.b){let f="";this.d.forEach((d,l)=>f+=`	${l} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${f}`),this.b=this.c(R.$4F,this.e,this.f)}return this.b}}let n=class{constructor(r,s,t){this.e=r,this.f=s,this.nodeModuleName=["open","opn"],this.d=t.getProxy(M.$lM.MainThreadTelemetry);const f=t.getProxy(M.$lM.MainThreadWindow);this.c=(d,l)=>{const c=L.URI.parse(d);return l?this.g(d,l):c.scheme==="http"||c.scheme==="https"?f.$openUri(c,d,{allowTunneling:!0}):c.scheme==="mailto"||c.scheme===this.f?f.$openUri(c,d,{}):this.g(d,l)}}load(r,s,t){const f=this.e.findSubstr(s);return f&&(this.a=f.identifier.value,this.h()),this.b=t(r),this.c}g(r,s){return this.i(),this.b(r,s)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([qe(2,$.$GO)],n)}),define(ke[60],Ee([1,0,45,3,17,50,5,72,71,48,7,43,300,44]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8jc=e.$7jc=void 0,e.$7jc=(0,R.$ii)("IExtHostVariableResolverProvider");class v extends p.$IP{constructor(o,n,i,r,s,t,f){function d(){if(i){const l=i.activeEditor();if(l)return l.document.uri;const c=r.tabGroups.all.find(h=>h.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof A.$0N||c.input instanceof A.$cO)return c.input.modified;if(c.input instanceof A.$9N||c.input instanceof A.$bO||c.input instanceof A.$_N)return c.input.uri}}}super({getFolderUri:l=>{const c=t.folders.filter(h=>h.name===l);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(l,c)=>s.getConfiguration(void 0,l).get(c),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=d();if(l)return M.$ic(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const l=d();if(l){const c=n.getWorkspaceFolder(l);if(c)return M.$ic(c.uri.fsPath)}}},getSelectedText:()=>{if(i){const l=i.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(i){const l=i.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>o.getExtension(l)},void 0,f?Promise.resolve(f):void 0,Promise.resolve(P.env))}}let a=class extends L.$Uc{constructor(o,n,i,r,s){super(),this.b=o,this.c=n,this.g=i,this.h=r,this.j=s,this.a=new u.$V(async()=>{const t=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new v(this.b,this.c,this.g,this.j,t,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$8jc=a,e.$8jc=a=Je([qe(0,y.$4jc),qe(1,I.$pjc),qe(2,b.$RO),qe(3,E.$sjc),qe(4,$.$Ejc)],a)}),define(ke[96],Ee([1,0,8,4,2,25,5,6,71,48,20,7,43,143,292,44,60,3,56,33,16]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v,a,m,o,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$akc=e.$_jc=e.$$jc=e.$0jc=e.$9jc=void 0,e.$9jc=(0,R.$ii)("IExtHostDebugService");let s=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(g,S,w,C,k,D,O){this.N=S,this.O=w,this.P=C,this.Q=k,this.R=D,this.S=O,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new L.$7d,this.o=new L.$7d,this.q=new L.$7d,this.w=new L.$7d,this.l=g.getProxy(b.$lM.MainThreadDebugService),this.A=new L.$7d,this.C=new L.$7d,this.y=new f(this.l),this.z=new Map,this.O.getExtensionRegistry().then(F=>{F.onDidChange(T=>{this.V(F)}),this.V(F)})}async $getVisualizerTreeItem(g,S){const w=this.W(S);if(!w)return;const C=await this.H.get(g)?.getTreeItem?.(w);return C?this.U(g,C):void 0}registerDebugVisualizationTree(g,S,w){const C=P.$Dm.toKey(g.identifier),k=this.jb(C,S);if(this.G.has(k))throw new Error(`A debug visualization provider with id '${S}' is already registered`);return this.H.set(k,w),this.l.$registerDebugVisualizerTree(k,!!w.editItem),(0,o.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(k),this.H.delete(S)})}async $getVisualizerTreeItemChildren(g,S){const w=this.J.get(S)?.item;return w?(await this.H.get(g)?.getChildren?.(w))?.map(k=>this.U(g,k))||[]:[]}async $editVisualizerTreeItem(g,S){const w=this.J.get(g);if(!w)return;const C=await this.H.get(w.provider)?.editItem?.(w.item,S);return this.U(w.provider,C||w.item)}$disposeVisualizedTree(g){const S=this.J.get(g);if(!S)return;const w=[S.children];for(const C of w)if(C)for(const k of C)w.push(this.J.get(k)?.children),this.J.delete(k)}U(g,S){let w=this.I.get(S);return w||(w=this.F++,this.I.set(S,w),this.J.set(w,{provider:g,item:S})),r.DebugTreeItem.from(S,w)}asDebugSourceUri(g,S){const w=g;if(typeof w.sourceReference=="number"&&w.sourceReference>0){let C=`debug:${encodeURIComponent(w.path||"")}`,k="?";return S&&(C+=`${k}session=${encodeURIComponent(S.id)}`,k="&"),C+=`${k}ref=${w.sourceReference}`,M.URI.parse(C)}else{if(w.path)return M.URI.file(w.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(g){const S=[];for(const w of g.getAllExtensionDescriptions())if(w.contributes){const C=w.contributes.debuggers;if(C&&C.length>0)for(const k of C)(0,v.$JG)(k)&&S.push(k.type)}this.l.$registerDebugTypes(S)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const g=[];return this.z.forEach(S=>g.push(S)),g}async $resolveDebugVisualizer(g,S){const w=this.L.get(g);if(!w)throw new Error(`No debug visualizer found with id '${g}'`);let{v:C,provider:k,extensionId:D}=w;if(C.visualization||(C=await k.resolveDebugVisualization?.(C,S)||C,w.v=C),!C.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${k}'`);return this.kb(D,C.visualization)}async $executeDebugVisualizerCommand(g){const S=this.L.get(g);if(!S)throw new Error(`No debug visualizer found with id '${g}'`);const w=S.v.visualization;w&&"command"in w&&this.S.executeCommand(w.command,...w.arguments||[])}W(g){const S=this.m.get(g.sessionId);return S&&{session:S.api,variable:g.variable,containerId:g.containerId,frameId:g.frameId,threadId:g.threadId}}async $provideDebugVisualizers(g,S,w,C){const k=this.W(w),D=this.jb(g,S),O=this.G.get(D);if(!k||!O)return[];const F=await O.provideDebugVisualization(k,C);return F?F.map(T=>{const z=++this.M;this.L.set(z,{v:T,provider:O,extensionId:g});const j=T.iconPath?this.lb(T.iconPath):void 0;return{id:z,name:T.name,iconClass:j?.iconClass,iconPath:j?.iconPath,visualization:this.kb(g,T.visualization)}}):[]}$disposeDebugVisualizers(g){for(const S of g)this.L.delete(S)}registerDebugVisualizationProvider(g,S,w){if(!g.contributes?.debugVisualizers?.some(D=>D.id===S))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${S})`);const C=P.$Dm.toKey(g.identifier),k=this.jb(C,S);if(this.G.has(k))throw new Error(`A debug visualization provider with id '${S}' is already registered`);return this.G.set(k,w),this.l.$registerDebugVisualizer(C,S),(0,o.$Sc)(()=>{this.l.$unregisterDebugVisualizer(C,S),this.G.delete(S)})}addBreakpoints(g){const S=g.filter(k=>{const D=k.id;return this.z.has(D)?!1:(this.z.set(D,k),!0)});this.gb(S,[],[]);const w=[],C=new Map;for(const k of S)if(k instanceof I.$oN){let D=C.get(k.location.uri.toString());D||(D={type:"sourceMulti",uri:k.location.uri,lines:[]},C.set(k.location.uri.toString(),D),w.push(D)),D.lines.push({id:k.id,enabled:k.enabled,condition:k.condition,hitCondition:k.hitCondition,logMessage:k.logMessage,line:k.location.range.start.line,character:k.location.range.start.character,mode:k.mode})}else k instanceof I.$pN&&w.push({type:"function",id:k.id,enabled:k.enabled,hitCondition:k.hitCondition,logMessage:k.logMessage,condition:k.condition,functionName:k.functionName,mode:k.mode});return this.l.$registerBreakpoints(w)}removeBreakpoints(g){const S=g.filter(D=>this.z.delete(D.id));this.gb([],S,[]);const w=S.filter(D=>D instanceof I.$oN).map(D=>D.id),C=S.filter(D=>D instanceof I.$pN).map(D=>D.id),k=S.filter(D=>D instanceof I.$qN).map(D=>D.id);return this.l.$unregisterBreakpoints(w,C,k)}startDebugging(g,S,w){return this.l.$startDebugging(g?g.uri:void 0,S,{parentSessionID:w.parentSession?w.parentSession.id:void 0,lifecycleManagedByParent:w.lifecycleManagedByParent,repl:w.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:w.noDebug,compact:w.compact,suppressSaveBeforeStart:w.suppressSaveBeforeStart,suppressDebugStatusbar:w.suppressDebugStatusbar??w.debugUI?.simple,suppressDebugToolbar:w.suppressDebugToolbar??w.debugUI?.simple,suppressDebugView:w.suppressDebugView??w.debugUI?.simple})}stopDebugging(g){return this.l.$stopDebugging(g?g.id:void 0)}registerDebugConfigurationProvider(g,S,w){if(!S)return new I.$nM(()=>{});const C=this.d++;return this.f.push({type:g,handle:C,provider:S}),this.l.$registerDebugConfigurationProvider(g,w,!!S.provideDebugConfigurations,!!S.resolveDebugConfiguration,!!S.resolveDebugConfigurationWithSubstitutedVariables,C),new I.$nM(()=>{this.f=this.f.filter(k=>k.provider!==S),this.l.$unregisterDebugConfigurationProvider(C)})}registerDebugAdapterDescriptorFactory(g,S,w){if(!w)return new I.$nM(()=>{});if(!this.cb(g,S))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${S}' debugger.`);if(this.$(S))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const C=this.g++;return this.h.push({type:S,handle:C,factory:w}),this.l.$registerDebugAdapterDescriptorFactory(S,C),new I.$nM(()=>{this.h=this.h.filter(k=>k.factory!==w),this.l.$unregisterDebugAdapterDescriptorFactory(C)})}registerDebugAdapterTrackerFactory(g,S){if(!S)return new I.$nM(()=>{});const w=this.j++;return this.k.push({type:g,handle:w,factory:S}),new I.$nM(()=>{this.k=this.k.filter(C=>C.factory!==S)})}async $runInTerminal(g,S){return Promise.resolve(void 0)}async $substituteVariables(g,S){let w;const C=await this.ib(g);return C&&(w={uri:C.uri,name:C.name,index:C.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(w,S)}X(g,S){if(g.type==="implementation")return new l(g.implementation)}Y(){}async $startDASession(g,S){const w=this,C=await this.hb(S);return this.eb(this.$(C.type),C).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${C.type}' (extension might have failed to activate)`);const D=this.Z(k),O=this.X(D,C);if(!O)throw new Error(`Couldn't create a debug adapter for type '${C.type}'.`);const F=O;return this.D.set(g,F),this.db(C).then(T=>(T&&this.E.set(g,T),F.onMessage(async z=>{if(z.type==="request"&&z.command==="handshake"){const j=z,N={type:"response",seq:0,command:j.command,request_seq:j.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const B=await this.K.sign(j.arguments.value);N.body={signature:B},F.sendResponse(N)}else throw new Error("no signer")}catch(B){N.success=!1,N.message=B.message,F.sendResponse(N)}}else T&&T.onDidSendMessage&&T.onDidSendMessage(z),z=(0,v.$OG)(z,!0),w.l.$acceptDAMessage(g,z)}),F.onError(z=>{T&&T.onError&&T.onError(z),this.l.$acceptDAError(g,z.name,z.message,z.stack)}),F.onExit(z=>{T&&T.onExit&&T.onExit(z??void 0,void 0),this.l.$acceptDAExit(g,z??void 0,void 0)}),T&&T.onWillStartSession&&T.onWillStartSession(),F.startSession()))})}$sendDAMessage(g,S){S=(0,v.$NG)(S,!1);const w=this.E.get(g);w&&w.onWillReceiveMessage&&w.onWillReceiveMessage(S),this.D.get(g)?.sendMessage(S)}$stopDASession(g){const S=this.E.get(g);this.E.delete(g),S&&S.onWillStopSession&&S.onWillStopSession();const w=this.D.get(g);return this.D.delete(g),w?w.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(g){const S=[],w=[],C=[];if(g.added)for(const k of g.added){const D=k.id;if(D&&!this.z.has(D)){let O;if(k.type==="function")O=new I.$pN(k.functionName,k.enabled,k.condition,k.hitCondition,k.logMessage,k.mode);else if(k.type==="data")O=new I.$qN(k.label,k.dataId,k.canPersist,k.enabled,k.hitCondition,k.condition,k.logMessage,k.mode);else{const F=M.URI.revive(k.uri);O=new I.$oN(new I.$zM(F,new I.$oM(k.line,k.character)),k.enabled,k.condition,k.hitCondition,k.logMessage,k.mode)}(0,I.$mN)(O,D),this.z.set(D,O),S.push(O)}}if(g.removed)for(const k of g.removed){const D=this.z.get(k);D&&(this.z.delete(k),w.push(D))}if(g.changed){for(const k of g.changed)if(k.id){const D=this.z.get(k.id);if(D){if(D instanceof I.$pN&&k.type==="function"){const O=D;O.enabled=k.enabled,O.condition=k.condition,O.hitCondition=k.hitCondition,O.logMessage=k.logMessage,O.functionName=k.functionName}else if(D instanceof I.$oN&&k.type==="source"){const O=D;O.enabled=k.enabled,O.condition=k.condition,O.hitCondition=k.hitCondition,O.logMessage=k.logMessage,O.location=new I.$zM(M.URI.revive(k.uri),new I.$oM(k.line,k.character))}C.push(D)}}}this.gb(S,w,C)}async $acceptStackFrameFocus(g){let S;if(g){const w=await this.hb(g.sessionId);g.kind==="thread"?S=new I.$wN(w.api,g.threadId):S=new I.$vN(w.api,g.threadId,g.frameId)}this.B=S,this.C.fire(this.B)}$provideDebugConfigurations(g,S,w){return(0,u.$ah)(async()=>{const C=this.bb(g);if(!C)throw new Error("no DebugConfigurationProvider found");if(!C.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const k=await this.ib(S);return C.provideDebugConfigurations(k,w)}).then(C=>{if(!C)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return C})}$resolveDebugConfiguration(g,S,w,C){return(0,u.$ah)(async()=>{const k=this.bb(g);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const D=await this.ib(S);return k.resolveDebugConfiguration(D,w,C)})}$resolveDebugConfigurationWithSubstitutedVariables(g,S,w,C){return(0,u.$ah)(async()=>{const k=this.bb(g);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const D=await this.ib(S);return k.resolveDebugConfigurationWithSubstitutedVariables(D,w,C)})}async $provideDebugAdapter(g,S){const w=this.ab(g);if(!w)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const C=await this.hb(S);return this.eb(w,C).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${C.type}'`);return this.Z(k)})}async $acceptDebugSessionStarted(g){const S=await this.hb(g);this.n.fire(S.api)}async $acceptDebugSessionTerminated(g){const S=await this.hb(g);S&&(this.o.fire(S.api),this.m.delete(S.id))}async $acceptDebugSessionActiveChanged(g){this.u=g?await this.hb(g):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(g,S){(await this.hb(g))?._acceptNameChanged(S)}async $acceptDebugSessionCustomEvent(g,S){const C={session:(await this.hb(g)).api,event:S.event,body:S.body};this.w.fire(C)}Z(g){if(g instanceof I.$rN)return{type:"executable",command:g.command,args:g.args,options:g.options};if(g instanceof I.$sN)return{type:"server",port:g.port,host:g.host};if(g instanceof I.$tN)return{type:"pipeServer",path:g.path};if(g instanceof I.$uN)return{type:"implementation",implementation:g.implementation};throw new Error("convertToDto unexpected type")}$(g){const S=this.h.filter(w=>w.type===g);if(S.length>0)return S[0].factory}ab(g){const S=this.h.filter(w=>w.handle===g);if(S.length>0)return S[0].factory}bb(g){const S=this.f.filter(w=>w.handle===g);if(S.length>0)return S[0].provider}cb(g,S){if(g.contributes){const w=g.contributes.debuggers;if(w&&w.length>0){for(const C of w)if(C.label&&C.type&&C.type===S)return!0}}return!1}db(g){const w=g.configuration.type,C=this.k.filter(k=>k.type===w||k.type==="*").map(k=>(0,u.$ah)(()=>k.factory.createDebugAdapterTracker(g.api)).then(D=>D,D=>null));return Promise.race([Promise.all(C).then(k=>{const D=k.filter(O=>!!O);if(D.length>0)return new d(D)}),new Promise(k=>setTimeout(()=>k(void 0),1e3))]).catch(k=>{})}async eb(g,S){const w=S.configuration.debugServer;if(typeof w=="number")return Promise.resolve(new I.$sN(w));if(g){const k=await this.O.getExtensionRegistry();return(0,u.$ah)(()=>g.createDebugAdapterDescriptor(S.api,this.fb(S,k))).then(D=>{if(D)return D})}const C=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(S,C))}fb(g,S){}gb(g,S,w){(g.length>0||S.length>0||w.length>0)&&this.A.fire(Object.freeze({added:g,removed:S,changed:w}))}async hb(g){if(g)if(typeof g=="string"){const S=this.m.get(g);if(S)return S}else{let S=this.m.get(g.id);if(!S){const w=await this.ib(g.folderUri),C=g.parent?this.m.get(g.parent):void 0;S=new t(this.l,g.id,g.type,g.name,w,g.configuration,C?.api),this.m.set(S.id,S),this.l.$sessionCached(S.id)}return S}throw new Error("cannot find session")}ib(g){if(g){const S=M.URI.revive(g);return this.N.resolveWorkspaceFolder(S)}return Promise.resolve(void 0)}jb(g,S){return`${g}\0${S}`}kb(g,S){if(S){if("title"in S&&"command"in S)return{type:0};if("treeId"in S)return{type:1,id:`${g}\0${S.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(g){const S=this.mb(g);let w,C;return"id"in S?C=n.ThemeIcon.asClassName(S):w=S,{iconPath:w,iconClass:C}}mb(g){if(g instanceof I.$jN)return{id:g.id};const S=typeof g=="object"&&"dark"in g?g.dark:g,w=typeof g=="object"&&"light"in g?g.light:g;return{dark:typeof S=="string"?M.URI.file(S):S,light:typeof w=="string"?M.URI.file(w):w}}};e.$0jc=s,e.$0jc=s=Je([qe(0,A.$GO),qe(1,p.$pjc),qe(2,y.$4jc),qe(3,a.$sjc),qe(4,$.$Ejc),qe(5,m.$7jc),qe(6,i.$3O)],s);class t{constructor(g,S,w,C,k,D,O){this.f=g,this.g=S,this.h=w,this.j=C,this.k=k,this.l=D,this.m=O}get api(){const g=this;return this.d??=Object.freeze({id:g.g,type:g.h,get name(){return g.j},set name(S){g.j=S,g.f.$setDebugSessionName(g.g,S)},parentSession:g.m,workspaceFolder:g.k,configuration:g.l,customRequest(S,w){return g.f.$customDebugAdapterRequest(g.g,S,w)},getDebugProtocolBreakpoint(S){return g.f.$getDebugProtocolBreakpoint(g.g,S.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(g){this.j=g}get configuration(){return this.l}}e.$$jc=t;class f{constructor(g){this.value=Object.freeze({append(S){g.$appendDebugConsole(S)},appendLine(S){this.append(S+`
`)}})}}e.$_jc=f;class d{constructor(g){this.d=g}onWillStartSession(){this.d.forEach(g=>g.onWillStartSession?g.onWillStartSession():void 0)}onWillReceiveMessage(g){this.d.forEach(S=>S.onWillReceiveMessage?S.onWillReceiveMessage(g):void 0)}onDidSendMessage(g){this.d.forEach(S=>S.onDidSendMessage?S.onDidSendMessage(g):void 0)}onWillStopSession(){this.d.forEach(g=>g.onWillStopSession?g.onWillStopSession():void 0)}onError(g){this.d.forEach(S=>S.onError?S.onError(g):void 0)}onExit(g,S){this.d.forEach(w=>w.onExit?w.onExit(g,S):void 0)}}class l extends E.$pob{constructor(g){super(),this.h=g,g.onDidSendMessage(S=>{this.acceptMessage(S)})}startSession(){return Promise.resolve(void 0)}sendMessage(g){this.h.handleMessage(g)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let c=class extends s{constructor(g,S,w,C,k,D,O){super(g,S,w,C,k,D,O)}};e.$akc=c,e.$akc=c=Je([qe(0,A.$GO),qe(1,p.$pjc),qe(2,y.$4jc),qe(3,a.$sjc),qe(4,$.$Ejc),qe(5,m.$7jc),qe(6,i.$3O)],c)}),define(ke[375],Ee([1,0,13,58,2,6,321,12,84,107,28,256,20,66,48,90]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dlc=e.$clc=void 0;class m{static async installEarlyHandler(i){Error.stackTraceLimit=100;const r=i.get(b.$Oj),t=i.get(p.$GO).getProxy(P.$lM.MainThreadErrors);u.setUnexpectedErrorHandler(f=>{r.error(f);const d=u.$3(f);t.$onUnexpectedError(d)})}static async installFullHandler(i){const r=i.get(b.$Oj),s=i.get(p.$GO),t=i.get(v.$4jc),f=i.get(a.$1O),d=s.getProxy(P.$lM.MainThreadExtensionService),l=s.getProxy(P.$lM.MainThreadErrors),c=await t.getExtensionPathIndex(),h=new WeakMap;function g(C,k){if(h.has(C))return h.get(C).stack;let D="",O,F;for(const z of k)D+=`
	at ${z.toString()}`,F=z.getFileName(),!O&&F&&(O=c.findSubstr(M.URI.file(F)));const T=`${C.name||"Error"}: ${C.message||""}${D}`;return h.set(C,{extensionIdentifier:O?.identifier,stack:T}),T}const S=Symbol("prepareStackTrace wrapped");let w=g;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return w},set(C){if(C===g||!C||C[S]){w=C||g;return}w=function(k,D){return g(k,D),C.call(Error,k,D)},Object.assign(w,{[S]:!0})}}),u.setUnexpectedErrorHandler(C=>{r.error(C);const k=u.$3(C),D=h.get(C);if(!D?.extensionIdentifier){l.$onUnexpectedError(k);return}d.$onExtensionRuntimeError(D.extensionIdentifier,k);const O=f.onExtensionError(D.extensionIdentifier,C);r.trace("forwarded error to extension?",O,D)})}}e.$clc=m;class o{constructor(i,r,s,t,f){this.a=s,this.b=new R.$50b(i,null,t),r=o.e(r,this.b);const d=new y.$gi(...(0,$.$hs)());d.set(A.$WO,{_serviceBrand:void 0,...r,messagePorts:f}),d.set(p.$GO,new p.$HO(this.b)),d.set(E.$mjc,new E.$njc(t)),d.set(v.$2jc,s);const l=new I.$Yq(d,!0);l.invokeFunction(m.installEarlyHandler),this.d=l.invokeFunction(c=>c.get(b.$Oj)),L.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",r),this.c=l.invokeFunction(c=>c.get(v.$4jc)),this.c.initialize(),l.invokeFunction(m.installFullHandler)}async asBrowserUri(i){const r=this.b.getProxy(P.$lM.MainThreadExtensionService);return M.URI.revive(await r.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,r){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=M.URI.revive(r.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=M.URI.revive(r.transformIncomingURIs(i.environment.appRoot));const s=i.environment.extensionDevelopmentLocationURI;return s&&(i.environment.extensionDevelopmentLocationURI=s.map(t=>M.URI.revive(r.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=M.URI.revive(r.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=M.URI.revive(r.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=M.URI.revive(r.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=M.URI.revive(r.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=M.URI.revive(r.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=M.URI.revive(r.transformIncomingURIs(i.logsLocation)),i.workspace=r.transformIncomingURIs(i.workspace),i}}e.$dlc=o}),define(ke[376],Ee([1,0,8,11,230,249,141,96,71,48,20,47,7,60,43,293,294,44,33,377]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v,a,m,o,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nlc=void 0;let r=class extends b.$0jc{constructor(c,h,g,S,w,C,k,D){super(c,h,g,S,C,k,D),this.pb=w,this.nb=new d}X(c,h){switch(c.type){case"server":return new a.$ilc(c);case"pipeServer":return new a.$jlc(c);case"executable":return new a.$klc(c,h.type)}return super.X(c,h)}fb(c,h){const g=a.$klc.platformAdapterExecutable(h.getAllExtensionDescriptions(),c.type);if(g)return new p.$rN(g.command,g.args,g.options)}Y(){return new R.$Sbc}async $runInTerminal(c,h){if(c.kind==="integrated"){this.ob||(this.ob=this.pb.onDidCloseTerminal(N=>{this.nb.onTerminalClosed(N)}));const g=await this.P.getConfigProvider(),S=this.pb.getDefaultShell(!0),w=this.pb.getDefaultShellArgs(!0),C=c.title||M.localize(0,null),k=s(S,w,c);let D=await this.nb.checkout(k,C,!0),O,F=!1;if(D)O=c.cwd;else{const N={shellPath:S,shellArgs:w,cwd:c.cwd,name:C,iconPath:new p.$jN("debug"),env:c.env};F=!0,D=this.pb.createTerminalFromOptions(N,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.nb.insert(D,k)}D.show(!0);const T=await D.processId;F?await new Promise(N=>setTimeout(N,1e3)):(D.state.isInteractedWith&&D.sendText(""),g.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(S.indexOf("powershell")>=0||S.indexOf("pwsh")>=0||S.indexOf("cmd.exe")>=0?D.sendText("cls"):S.indexOf("bash")>=0?D.sendText("clear"):L.$i?D.sendText("cls"):D.sendText("clear")));const z=(0,m.$mlc)(S,c.args,!!c.argsCanBeInterpretedByShell,O);D.sendText(z);const j=this.onDidTerminateDebugSession(N=>{N.id===h&&(this.nb.free(D),j.dispose())});return T}else if(c.kind==="external")return f(c,await this.P.getConfigProvider());return super.$runInTerminal(c,h)}};e.$nlc=r,e.$nlc=r=Je([qe(0,A.$GO),qe(1,v.$pjc),qe(2,y.$4jc),qe(3,o.$sjc),qe(4,I.$Qjc),qe(5,$.$Ejc),qe(6,E.$7jc),qe(7,n.$3O)],r);function s(l,c,h){const g=(0,i.createHash)("sha256");return g.update(JSON.stringify({shell:l,shellArgs:c})),g.update(JSON.stringify(Object.entries(h.env||{}).sort(([S],[w])=>S.localeCompare(w)))),g.digest("base64")}let t;function f(l,c){if(!t)if(L.$i)t=new P.$Dac;else if(L.$j)t=new P.$Eac;else if(L.$k)t=new P.$Fac;else throw new Error("external terminals not supported on this platform");const h=c.getConfiguration("terminal");return t.runInTerminal(l.title,l.cwd,l.args,l.env||{},h.external||{})}class d{constructor(){this.b=new Map}static{this.a=1e3}async checkout(c,h,g=!1){const w=[...this.b.entries()].map(([C,k])=>(0,u.$8g)(async D=>{if(C.name!==h||k.lastUsedAt!==-1&&await(0,m.$llc)(await C.processId))return null;const O=Date.now();return k.lastUsedAt+d.a>O||D.isCancellationRequested?null:k.config!==c?(g&&C.dispose(),null):(k.lastUsedAt=O,C)}));return await(0,u.$nh)(w,C=>!!C)}insert(c,h){this.b.set(c,{lastUsedAt:Date.now(),config:h})}free(c){const h=this.b.get(c);h&&(h.lastUsedAt=-1)}onTerminalClosed(c){this.b.delete(c)}}}),define(ke[378],Ee([1,0,17,2,105,43,72,44,42,47,20,28,95,15,12,91,23,63,60]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v,a,m,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$flc=void 0;let i=class extends p.$Tkc{constructor(s,t,f,d,l,c,h,g,S){super(s,t,f,d,l,c,h,g),this.C=f,this.D=S,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(E.Schemas.vscodeRemote,{scheme:E.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(E.Schemas.file,{scheme:E.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(s,t){const f=t;if(!t.execution&&f._id===void 0)throw new Error("Tasks to execute must include an execution");if(f._id!==void 0){const d=p.TaskHandleDTO.from(f,this.C),l=await this.a.$getTaskExecution(d);if(l.task===void 0)throw new Error("Task from execution DTO is undefined");const c=await this.z(l,t);return this.a.$executeTask(d).catch(()=>{}),c}else{const d=p.TaskDTO.from(t,s);if(d===void 0)return Promise.reject(new Error("Task is not valid"));p.CustomExecutionDTO.is(d.execution)&&await this.y(d,t,!1);const l=await this.z(await this.a.$getTaskExecution(d),t);return this.a.$executeTask(d).catch(()=>{}),l}}v(s,t,f,d){const l=[];if(d)for(const c of d){this.A(c,f),(!c.definition||!s[c.definition.type])&&this.f.warn(`The task [${c.source}, ${c.name}] uses an undefined task type. The task will be ignored in the future.`);const h=p.TaskDTO.from(c,f.extension);h&&(l.push(h),p.CustomExecutionDTO.is(h.execution)&&t.push(this.y(h,c,!0)))}return{tasks:l,extension:f.extension}}async w(s){return s}async G(s){let t=s&&s.length>0?s[0]:void 0;if(!t){const f=L.URI.file((0,o.homedir)());t=new $.$Ci({uri:f,name:m.$Sg(f),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(s,t){const f=L.URI.revive(s),d={process:void 0,variables:Object.create(null)},l=await this.b.resolveWorkspaceFolder(f),c=await this.b.getWorkspaceFolders2()??[],h=await this.D.getResolver(),g=l?{uri:l.uri,name:l.name,index:l.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(c);for(const S of t.variables)d.variables[S]=await h.resolveAsync(g,S);if(t.process!==void 0){let S;if(t.process.path!==void 0){S=t.process.path.split(u.$uc);for(let w=0;w<S.length;w++)S[w]=await h.resolveAsync(g,S[w])}d.process=await M.win32.findExecutable(await h.resolveAsync(g,t.process.name),t.process.cwd!==void 0?await h.resolveAsync(g,t.process.cwd):void 0,S)}return d}async $jsonTasksSupported(){return!0}async $findExecutable(s,t,f){return M.win32.findExecutable(s,t,f)}};e.$flc=i,e.$flc=i=Je([qe(0,A.$GO),qe(1,I.$WO),qe(2,P.$pjc),qe(3,R.$RO),qe(4,b.$sjc),qe(5,y.$Qjc),qe(6,v.$Oj),qe(7,a.$3ic),qe(8,n.$7jc)],i)}),define(ke[379],Ee([1,0,63,60]),function(he,e,u,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xlc=void 0;class M extends L.$8jc{m(){return(0,u.homedir)()}}e.$Xlc=M}),define(ke[158],Ee([1,0,19,8,22,46,15,17,23,2,36]),function(he,e,u,L,M,P,R,b,$,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rkc=e.$pkc=e.$okc=void 0,e.$qkc=a;class I{constructor(n,i,r){this.d=n,this.e=i,this.f=r,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,i){const r=this.g.folderQueries||[],s=new M.$ee(i);return new Promise((t,f)=>{this.a=new E(n);let d=!1;const l=(c,h)=>{if(!d&&!this.b){const g=this.h(c);a(c)&&typeof this.g.maxResults=="number"&&this.c+g>this.g.maxResults&&(this.b=!0,d=!0,s.cancel(),c=this.j(c,this.g.maxResults-this.c));const S=this.h(c);this.c+=S,(S>0||!a(c))&&this.a.add(c,h)}};Promise.all(r.map((c,h)=>this.k(c,g=>l(g,h),s.token))).then(c=>{s.dispose(),this.a.flush();const h=c.some(g=>!!g&&!!g.limitHit);t({limitHit:this.b||h,messages:(0,u.$Rb)(c.map(g=>g?.message?Array.isArray(g.message)?g.message:[g.message]:[])),stats:{type:this.f}})},c=>{s.dispose();const h=(0,P.$6i)(c);f(new Error(h))})})}h(n){return a(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,i){const r=Array.isArray(n.ranges)?n.ranges:[n.ranges],s=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:r.slice(0,i),preview:{matches:s.slice(0,i),text:n.preview.text},uri:n.uri}}async k(n,i,r){const s=new A.$SK(this.g,n),t=[],f={report:c=>{if(!this.l(c))return;const h=n.folder.scheme===R.Schemas.file?(0,A.$TK)(()=>this.e.readdir($.$Ug(c.uri))):void 0,g=$.$Xg(n.folder,c.uri);if(g){const S=s.includedInQuery(g,b.$oc(g),h);(0,L.$7g)(S)?t.push(S.then(w=>{w&&i(c)})):S&&i(c)}}},d=this.n(n);let l;return this.d.query.type===3?l=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,d,f,r):l=await this.d.provider.provideTextSearchResults(p(this.d.query.contentPattern),d,f,r),t.length&&await Promise.all(t),l}l(n){if(a(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const i=(0,A.$RK)(this.g.includePattern,n.includePattern),r=(0,A.$RK)(this.g.excludePattern,n.excludePattern),s={folder:y.URI.from(n.folder),excludes:r,includes:i,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(s.usePCRE2=this.g.usePCRE2),s}}e.$okc=I;function p(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class E{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new m(512,i=>this.g(i))}add(n,i){this.d&&(this.b!==i||!$.$Og(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:n.uri,results:[]}),this.d.results.push(v(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$pkc=E;function v(o){return a(o)?{preview:{matches:(0,u.$2b)(o.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:o.preview.text},ranges:(0,u.$2b)(o.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function a(o){return!!o.preview}class m{static{this.a=4e3}static{this.b=50}constructor(n,i){this.g=n,this.h=i,this.c=0,this.d=[],this.e=0}addItem(n,i){n&&this.j(n,i)}addItems(n,i){n&&this.k(n,i)}j(n,i){this.d.push(n),this.e+=i,this.l()}k(n,i){this.d=this.d.concat(n),this.e+=i,this.l()}l(){this.c<m.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},m.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$rkc=m}),define(ke[97],Ee([1,0,3,6,5,371,20,66,12,2,158]),function(he,e,u,L,M,P,R,b,$,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tkc=e.$skc=void 0,e.$ukc=p,e.$skc=(0,M.$ii)("IExtHostSearch");let I=class{constructor(a,m,o){this.n=a,this.o=m,this.q=o,this.c=this.n.getProxy(L.$lM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new P.$nkc}s(a){return this.o.transformOutgoingScheme(a)}registerTextSearchProvider(a,m){if(this.g.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this.g.add(a);const o=this.d++;return this.e.set(o,m),this.c.$registerTextSearchProvider(o,this.s(a)),(0,u.$Sc)(()=>{this.g.delete(a),this.e.delete(o),this.c.$unregisterProvider(o)})}registerAITextSearchProvider(a,m){if(this.i.has(a))throw new Error(`an AI text search provider for the scheme '${a}'is already registered`);this.i.add(a);const o=this.d++;return this.h.set(o,m),this.c.$registerAITextSearchProvider(o,this.s(a)),(0,u.$Sc)(()=>{this.i.delete(a),this.h.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(a,m){if(this.k.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this.k.add(a);const o=this.d++;return this.j.set(o,m),this.c.$registerFileSearchProvider(o,this.s(a)),(0,u.$Sc)(()=>{this.k.delete(a),this.j.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(a,m,o,n){const i=p(o),r=this.j.get(a);if(r)return this.l.fileSearch(i,r,s=>{this.c.$handleFileMatch(a,m,s.map(t=>t.resource))},n);throw new Error("3 unknown provider: "+a)}async doInternalFileSearchWithCustomCallback(a,m,o){return{messages:[]}}$clearCache(a){return this.l.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,m,o,n){const i=this.e.get(a);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${a}`);const r=p(o);return this.t(r,i).search(t=>this.c.$handleTextMatch(a,m,t),n)}$provideAITextSearchResults(a,m,o,n){const i=this.h.get(a);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${a}`);const r=p(o);return this.v(r,i).search(t=>this.c.$handleTextMatch(a,m,t),n)}$enableExtensionHostSearch(){}t(a,m){return new A.$okc({query:a,provider:m},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}v(a,m){return new A.$okc({query:a,provider:m},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"aiTextSearchProvider")}};e.$tkc=I,e.$tkc=I=Je([qe(0,R.$GO),qe(1,b.$mjc),qe(2,$.$Oj)],I);function p(v){return{...v,folderQueries:v.folderQueries&&v.folderQueries.map(E),extraFileResources:v.extraFileResources&&v.extraFileResources.map(a=>y.URI.revive(a))}}function E(v){return{...v,folder:y.URI.revive(v.folder)}}}),define(ke[380],Ee([1,0,22,13,4,3,15,40,2,135,197,178,79,25,32,12,86,87,275,6,323,350,91,120,328,309,329,121,330,310,298,33,331,44,332,96,151,333,312,324,334,335,72,71,325,48,336,69,337,59,28,351,352,326,313,338,339,115,116,314,370,341,281,342,353,343,156,315,344,345,346,20,347,97,117,348,316,349,118,93,95,90,47,354,355,327,356,357,70,16,7,317,66,318,92,358,359,150,43,291,114,26,94]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v,a,m,o,n,i,r,s,t,f,d,l,c,h,g,S,w,C,k,D,O,F,T,z,j,N,B,W,Z,_,X,x,re,Y,me,Ce,ee,U,ie,be,Se,ae,ce,se,K,te,le,de,Ae,$e,Ie,Re,Fe,q,V,Q,J,fe,we,Te,He,xe,it,rt,at,ot,De,Be,Ge,Oe,Qe,oe,ue,Pe,Ke,_e,Ne,lt,wt,At,zt,Qt,_t,Ct,Xt,Vt,ai,tt,ei){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0kc=ti;function ti(ft){const bt=ft.get(ee.$WO),si=ft.get(Ce.$7ic),ii=ft.get(Y.$ujc),jt=ft.get(x.$4jc),mt=ft.get(Xt.$pjc),Rt=ft.get(Be.$1O),qt=ft.get(D.$sjc),Zt=ft.get(wt.$mjc),Ze=ft.get(fe.$GO),Yt=ft.get(at.$Njc),Bt=ft.get(ot.$vjc),Ut=ft.get(a.$Pj),$t=ft.get(a.$Oj),Ft=ft.get(Ke.$NBb),Ot=ft.get(t.$3ic),Tt=ft.get(Ct.$9kc),ni=ft.get(He.$Vjc),oi=ft.get(_.$Ejc),Ht=ft.get(K.$Zjc),It=ft.get(f.$ajc),St=ft.get(h.$fjc);Ze.set(i.$mM.ExtHostFileSystemInfo,si),Ze.set(i.$mM.ExtHostLogLevelServiceShape,Ut),Ze.set(i.$mM.ExtHostWorkspace,mt),Ze.set(i.$mM.ExtHostConfiguration,qt),Ze.set(i.$mM.ExtHostExtensionService,jt),Ze.set(i.$mM.ExtHostStorage,Yt),Ze.set(i.$mM.ExtHostTunnelService,Ft),Ze.set(i.$mM.ExtHostWindow,Tt),Ze.set(i.$mM.ExtHostSecretState,ni),Ze.set(i.$mM.ExtHostTelemetry,Rt),Ze.set(i.$mM.ExtHostEditorTabs,oi),Ze.set(i.$mM.ExtHostManagedSockets,Ht),Ze.set(i.$mM.ExtHostAuthentication,It),Ze.set(i.$mM.ExtHostChatProvider,St);const Gt=Ze.set(i.$mM.ExtHostDecorations,ft.get(T.$ckc)),Pt=Ze.set(i.$mM.ExtHostDocumentsAndEditors,ft.get(Z.$RO)),yt=Ze.set(i.$mM.ExtHostCommands,ft.get(C.$3O)),Dt=Ze.set(i.$mM.ExtHostTerminalService,ft.get(Ge.$Qjc)),Et=Ze.set(i.$mM.ExtHostDebugService,ft.get(F.$9jc)),ui=Ze.set(i.$mM.ExtHostSearch,ft.get(Te.$skc)),ri=Ze.set(i.$mM.ExtHostTask,ft.get(De.$Vkc)),li=Ze.set(i.$mM.ExtHostOutputService,ft.get(Fe.$Ikc)),di=Ze.set(i.$mM.ExtHostLocalization,ft.get(se.$Yjc)),xt=Ze.set(i.$mM.ExtHostUrls,new At.$6kc(Ze)),Mt=Ze.set(i.$mM.ExtHostDocuments,new W.$0ic(Ze,Pt)),Me=Ze.set(i.$mM.ExtHostDocumentContentProviders,new N.$ekc(Ze,Pt,$t)),ze=Ze.set(i.$mM.ExtHostDocumentSaveParticipant,new B.$fkc($t,Mt,Ze.getProxy(i.$lM.MainThreadBulkEdits))),ve=Ze.set(i.$mM.ExtHostNotebook,new le.$vkc(Ze,yt,Pt,Mt,ii,ui)),ne=Ze.set(i.$mM.ExtHostNotebookDocuments,new Ae.$Ckc(ve)),Le=Ze.set(i.$mM.ExtHostNotebookEditors,new $e.$Dkc($t,ve)),Ve=Ze.set(i.$mM.ExtHostNotebookKernels,new Ie.$Ekc(Ze,bt,ve,yt,$t)),et=Ze.set(i.$mM.ExtHostNotebookRenderers,new Re.$Gkc(Ze,ve)),Xe=Ze.set(i.$mM.ExtHostNotebookDocumentSaveParticipant,new de.$Bkc($t,ve,Ze.getProxy(i.$lM.MainThreadBulkEdits))),ct=Ze.set(i.$mM.ExtHostEditors,new Qe.$jjc(Ze,Pt)),kt=Ze.set(i.$mM.ExtHostTreeViews,new Pe.$4kc(Ze.getProxy(i.$lM.MainThreadTreeViews),yt,$t)),Kt=Ze.set(i.$mM.ExtHostEditorInsets,new w.$kjc(Ze.getProxy(i.$lM.MainThreadEditorInsets),ct,bt.remote)),Wt=Ze.set(i.$mM.ExtHostDiagnostics,new z.$9ic(Ze,$t,si,Pt)),Lt=Ze.set(i.$mM.ExtHostLanguages,new ce.$zkc(Ze,Mt,yt.converter,Zt)),ht=Ze.set(i.$mM.ExtHostLanguageFeatures,new ae.$$ic(Ze,Zt,Mt,yt,Wt,$t,Ot,Rt)),Ii=Ze.set(i.$mM.ExtHostFileSystem,new re.$hkc(Ze,ht)),gi=Ze.set(i.$mM.ExtHostFileSystemEventService,new me.$ikc(Ze,$t,Pt)),$i=Ze.set(i.$mM.ExtHostQuickOpen,(0,J.$Mkc)(Ze,mt,yt)),vi=Ze.set(i.$mM.ExtHostSCM,new we.$Okc(Ze,yt,Mt,$t)),Pi=Ze.set(i.$mM.ExtHostQuickDiff,new Q.$Lkc(Ze,Zt)),Ai=Ze.set(i.$mM.ExtHostShare,new xe.$Pkc(Ze,Zt)),Wi=Ze.set(i.$mM.ExtHostComments,(0,k.$ljc)(Ze,yt,Mt)),Vi=Ze.set(i.$mM.ExtHostProgress,new V.$Kkc(Ze.getProxy(i.$lM.MainThreadProgress))),qi=Ze.set(i.$mM.ExtHostLabelService,new Se.$ykc(Ze)),yi=Ze.set(i.$mM.ExtHostTheming,new oe.$1kc(Ze)),Ri=Ze.set(i.$mM.ExtHostTimeline,new ue.$3kc(Ze,yt)),ki=Ze.set(i.$mM.ExtHostWebviews,new zt.$zjc(Ze,bt.remote,mt,$t,Ot)),Ei=Ze.set(i.$mM.ExtHostWebviewPanels,new Qt.$Cjc(Ze,ki,mt)),Hi=Ze.set(i.$mM.ExtHostCustomEditors,new O.$Djc(Ze,Mt,Bt,ki,Ei)),Gi=Ze.set(i.$mM.ExtHostWebviewViews,new _t.$7kc(Ze,ki)),bi=Ze.set(i.$mM.ExtHostTesting,new Oe.$Wkc(Ze,$t,yt,Pt)),Ki=Ze.set(i.$mM.ExtHostUriOpeners,new lt.$5kc(Ze)),gn=Ze.set(i.$mM.ExtHostProfileContentHandlers,new q.$Jkc(Ze));Ze.set(i.$mM.ExtHostInteractive,new ie.$wkc(Ze,ve,Pt,yt,$t));const mn=Ze.set(i.$mM.ExtHostInlineChat,new U.$jkc(Ze,yt,Mt,$t)),Oi=Ze.set(i.$mM.ExtHostChatAgents2,new c.$ejc(Ze,$t,yt)),Mi=Ze.set(i.$mM.ExtHostChatVariables,new g.$hjc(Ze)),Ji=Ze.set(i.$mM.ExtHostChat,new l.$djc(Ze)),Qi=Ze.set(i.$mM.ExtHostAiRelatedInformation,new r.$2ic(Ze)),Xi=Ze.set(i.$mM.ExtHostAiEmbeddingVector,new X.$gkc(Ze)),Zi=Ze.set(i.$mM.ExtHostIssueReporter,new be.$xkc(Ze)),Ci=Ze.set(i.$mM.ExtHostStatusBar,new rt.$Skc(Ze,yt.converter)),Yi=Ze.set(i.$mM.ExtHostSpeech,new it.$Qkc(Ze)),xi=Object.values(i.$mM);Ze.assertRegistered(xi);const _i=new d.$cjc(Ze,Pt),$n=new S.$ijc(Ze),wi=new te.$Akc(Ze,$t),Li=new j.$dkc(Ze);return s.$_ic.register(yt),function(Ue,ci,en){function st(ge){return(ye,We,ut)=>{const vt=ge(Nt=>{try{ye.call(We,Nt)}catch(zi){L.$2(new Error(`[ExtensionListenerError] Extension '${Ue.identifier.value}' FAILED to handle event: ${zi.toString()}`,{cause:zi})),Rt.onExtensionError(Ue.identifier,zi)}});return ut?.push(vt),vt}}const pt=function(){let ge=!Ue.isUnderDevelopment;function ye(){ge||($t.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function We(ut){if(Array.isArray(ut))ut.forEach(We);else if(typeof ut=="string")ye();else{const vt=ut;typeof vt.scheme>"u"&&ye(),typeof vt.exclusive=="boolean"&&(0,tt.$0F)(Ue,"documentFiltersExclusive")}return ut}}(),tn={getSession(ge,ye,We){return typeof We?.forceNewSession=="object"&&We.forceNewSession.learnMore&&(0,tt.$0F)(Ue,"authLearnMore"),It.getSession(Ue,ge,ye,We)},getSessions(ge,ye){return(0,tt.$0F)(Ue,"authGetSessions"),It.getSessions(Ue,ge,ye)},async hasSession(ge,ye){return(0,tt.$0F)(Ue,"authSession"),!!await It.getSession(Ue,ge,ye,{silent:!0})},get onDidChangeSessions(){return st(It.onDidChangeSessions)},registerAuthenticationProvider(ge,ye,We,ut){return It.registerAuthenticationProvider(ge,ye,We,ut)}},nn={registerCommand(ge,ye,We){return yt.registerCommand(!0,ge,ye,We,void 0,Ue)},registerTextEditorCommand(ge,ye,We){return yt.registerCommand(!0,ge,(...ut)=>{const vt=ct.getActiveTextEditor();if(!vt){$t.warn("Cannot execute "+ge+" because there is no active text editor.");return}return vt.edit(Nt=>{ye.apply(We,[vt,Nt,...ut])}).then(Nt=>{Nt||$t.warn("Edits from command "+ge+" were not applied.")},Nt=>{$t.warn("An error occurred while running command "+ge,Nt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(ge,ye,We)=>((0,tt.$0F)(Ue,"diffCommand"),yt.registerCommand(!0,ge,async(...ut)=>{const vt=Pt.activeEditor(!0);if(!vt){$t.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Nt=await ct.getDiffInformation(vt.id);ye.apply(We,[Nt,...ut])},void 0,void 0,Ue)),executeCommand(ge,...ye){return yt.executeCommand(ge,...ye)},getCommands(ge=!1){return yt.getCommands(ge)}},ji={get machineId(){return bt.telemetryInfo.machineId},get sessionId(){return bt.telemetryInfo.sessionId},get language(){return bt.environment.appLanguage},get appName(){return bt.environment.appName},get appRoot(){return bt.environment.appRoot?.fsPath??""},get appHost(){return bt.environment.appHost},get uriScheme(){return bt.environment.appUriScheme},get clipboard(){return $n.value},get shell(){return Dt.getDefaultShell(!1)},get onDidChangeShell(){return st(Dt.onDidChangeShell)},get isTelemetryEnabled(){return Rt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return st(Rt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,tt.$0F)(Ue,"telemetry"),Rt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,tt.$0F)(Ue,"telemetry"),st(Rt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,Be.$ZO)(bt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ge,ye){return Be.$YO.validateSender(ge),Rt.instantiateLogger(Ue,ge,ye)},openExternal(ge,ye){return Tt.openUri(ge,{allowTunneling:!!bt.remote.authority,allowContributedOpeners:ye?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===bt.environment.appUriScheme)return xt.createAppUri(ge);try{return await Tt.asExternalUri(ge,{allowTunneling:!!bt.remote.authority})}catch(ye){if((0,R.$rg)(ge,R.Schemas.http)||(0,R.$rg)(ge,R.Schemas.https))return ge;throw ye}},get remoteName(){return(0,m.$um)(bt.remote.authority)},get remoteAuthority(){return(0,tt.$0F)(Ue,"resolvers"),bt.remote.authority},get uiKind(){return bt.uiKind},get logLevel(){return $t.getLevel()},get onDidChangeLogLevel(){return st($t.onDidChangeLogLevel)},registerIssueUriRequestHandler(ge){return(0,tt.$0F)(Ue,"handleIssueUri"),Zi.registerIssueUriRequestHandler(Ue,ge)},registerIssueDataProvider(ge){return(0,tt.$0F)(Ue,"handleIssueUri"),Zi.registerIssueDataProvider(Ue,ge)},get appQuality(){return(0,tt.$0F)(Ue,"resolvers"),bt.quality},get appCommit(){return(0,tt.$0F)(Ue,"resolvers"),bt.commit}};bt.environment.extensionTestsLocationURI||Object.freeze(ji);const rn={createTestController(ge,ye,We){return bi.createTestController(Ue,ge,ye,We)},createTestObserver(){return(0,tt.$0F)(Ue,"testObserver"),bi.createTestObserver()},runTests(ge){return(0,tt.$0F)(Ue,"testObserver"),bi.runTests(ge)},get onDidChangeTestResults(){return(0,tt.$0F)(Ue,"testObserver"),st(bi.onResultsChanged)},get testResults(){return(0,tt.$0F)(Ue,"testObserver"),bi.results}},Si=bt.remote.isRemote?Ne.ExtensionKind.Workspace:Ne.ExtensionKind.UI,sn={getExtension(ge,ye){(0,tt.$9F)(Ue,"extensionsAny")||(ye=!1);const We=ci.mine.getExtensionDescription(ge);if(We)return new x.$5jc(jt,Ue.identifier,We,Si,!1);if(ye){const ut=ci.all.getExtensionDescription(ge);if(ut)return new x.$5jc(jt,Ue.identifier,ut,Si,!0)}},get all(){const ge=[];for(const ye of ci.mine.getAllExtensionDescriptions())ge.push(new x.$5jc(jt,Ue.identifier,ye,Si,!1));return ge},get allAcrossExtensionHosts(){(0,tt.$0F)(Ue,"extensionsAny");const ge=new E.$Em(ci.mine.getAllExtensionDescriptions().map(We=>We.identifier)),ye=[];for(const We of ci.all.getAllExtensionDescriptions()){const ut=!ge.has(We.identifier);ye.push(new x.$5jc(jt,Ue.identifier,We,Si,ut))}return ye},get onDidChange(){return(0,tt.$9F)(Ue,"extensionsAny")?st(M.Event.any(ci.mine.onDidChange,ci.all.onDidChange)):st(ci.mine.onDidChange)}},on={createDiagnosticCollection(ge){return Wt.createDiagnosticCollection(Ue.identifier,ge)},get onDidChangeDiagnostics(){return st(Wt.onDidChangeDiagnostics)},getDiagnostics:ge=>Wt.getDiagnostics(ge),getLanguages(){return Lt.getLanguages()},setTextDocumentLanguage(ge,ye){return Lt.changeLanguage(ge.uri,ye)},match(ge,ye){const We=_e.LanguageSelector.from(ge);let ut;return(0,A.$Wt)(We)&&(ut=ve.notebookDocuments.find(vt=>vt.apiNotebook.getCells().find(Nt=>Nt.document===ye))?.apiNotebook),(0,A.$Vt)(We,ye.uri,ye.languageId,!0,ut?.uri,ut?.notebookType)},registerCodeActionsProvider(ge,ye,We){return ht.registerCodeActionProvider(Ue,pt(ge),ye,We)},registerDocumentPasteEditProvider(ge,ye,We){return(0,tt.$0F)(Ue,"documentPaste"),ht.registerDocumentPasteEditProvider(Ue,pt(ge),ye,We)},registerCodeLensProvider(ge,ye){return ht.registerCodeLensProvider(Ue,pt(ge),ye)},registerDefinitionProvider(ge,ye){return ht.registerDefinitionProvider(Ue,pt(ge),ye)},registerDeclarationProvider(ge,ye){return ht.registerDeclarationProvider(Ue,pt(ge),ye)},registerImplementationProvider(ge,ye){return ht.registerImplementationProvider(Ue,pt(ge),ye)},registerTypeDefinitionProvider(ge,ye){return ht.registerTypeDefinitionProvider(Ue,pt(ge),ye)},registerHoverProvider(ge,ye){return ht.registerHoverProvider(Ue,pt(ge),ye,Ue.identifier)},registerEvaluatableExpressionProvider(ge,ye){return ht.registerEvaluatableExpressionProvider(Ue,pt(ge),ye,Ue.identifier)},registerInlineValuesProvider(ge,ye){return ht.registerInlineValuesProvider(Ue,pt(ge),ye,Ue.identifier)},registerDocumentHighlightProvider(ge,ye){return ht.registerDocumentHighlightProvider(Ue,pt(ge),ye)},registerMultiDocumentHighlightProvider(ge,ye){return ht.registerMultiDocumentHighlightProvider(Ue,pt(ge),ye)},registerLinkedEditingRangeProvider(ge,ye){return ht.registerLinkedEditingRangeProvider(Ue,pt(ge),ye)},registerReferenceProvider(ge,ye){return ht.registerReferenceProvider(Ue,pt(ge),ye)},registerRenameProvider(ge,ye){return ht.registerRenameProvider(Ue,pt(ge),ye)},registerNewSymbolNamesProvider(ge,ye){return(0,tt.$0F)(Ue,"newSymbolNamesProvider"),ht.registerNewSymbolNamesProvider(Ue,pt(ge),ye)},registerDocumentSymbolProvider(ge,ye,We){return ht.registerDocumentSymbolProvider(Ue,pt(ge),ye,We)},registerWorkspaceSymbolProvider(ge){return ht.registerWorkspaceSymbolProvider(Ue,ge)},registerDocumentFormattingEditProvider(ge,ye){return ht.registerDocumentFormattingEditProvider(Ue,pt(ge),ye)},registerDocumentRangeFormattingEditProvider(ge,ye){return ht.registerDocumentRangeFormattingEditProvider(Ue,pt(ge),ye)},registerOnTypeFormattingEditProvider(ge,ye,We,...ut){return ht.registerOnTypeFormattingEditProvider(Ue,pt(ge),ye,[We].concat(ut))},registerDocumentSemanticTokensProvider(ge,ye,We){return ht.registerDocumentSemanticTokensProvider(Ue,pt(ge),ye,We)},registerDocumentRangeSemanticTokensProvider(ge,ye,We){return ht.registerDocumentRangeSemanticTokensProvider(Ue,pt(ge),ye,We)},registerSignatureHelpProvider(ge,ye,We,...ut){return typeof We=="object"?ht.registerSignatureHelpProvider(Ue,pt(ge),ye,We):ht.registerSignatureHelpProvider(Ue,pt(ge),ye,typeof We>"u"?[]:[We,...ut])},registerCompletionItemProvider(ge,ye,...We){return ht.registerCompletionItemProvider(Ue,pt(ge),ye,We)},registerInlineCompletionItemProvider(ge,ye,We){return ye.handleDidShowCompletionItem&&(0,tt.$0F)(Ue,"inlineCompletionsAdditions"),ye.handleDidPartiallyAcceptCompletionItem&&(0,tt.$0F)(Ue,"inlineCompletionsAdditions"),We&&(0,tt.$0F)(Ue,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider(Ue,pt(ge),ye,We)},registerInlineEditProvider(ge,ye){return(0,tt.$0F)(Ue,"inlineEdit"),ht.registerInlineEditProvider(Ue,pt(ge),ye)},registerDocumentLinkProvider(ge,ye){return ht.registerDocumentLinkProvider(Ue,pt(ge),ye)},registerColorProvider(ge,ye){return ht.registerColorProvider(Ue,pt(ge),ye)},registerFoldingRangeProvider(ge,ye){return ht.registerFoldingRangeProvider(Ue,pt(ge),ye)},registerSelectionRangeProvider(ge,ye){return ht.registerSelectionRangeProvider(Ue,ge,ye)},registerCallHierarchyProvider(ge,ye){return ht.registerCallHierarchyProvider(Ue,ge,ye)},registerTypeHierarchyProvider(ge,ye){return ht.registerTypeHierarchyProvider(Ue,ge,ye)},setLanguageConfiguration:(ge,ye)=>ht.setLanguageConfiguration(Ue,ge,ye),getTokenInformationAtPosition(ge,ye){return(0,tt.$0F)(Ue,"tokenInformation"),Lt.tokenAtPosition(ge,ye)},registerInlayHintsProvider(ge,ye){return ht.registerInlayHintsProvider(Ue,ge,ye)},createLanguageStatusItem(ge,ye){return Lt.createLanguageStatusItem(Ue,ge,ye)},registerDocumentDropEditProvider(ge,ye,We){return ht.registerDocumentOnDropEditProvider(Ue,ge,ye,(0,tt.$9F)(Ue,"dropMetadata")?We:void 0)}},pn={get activeTextEditor(){return ct.getActiveTextEditor()},get visibleTextEditors(){return ct.getVisibleTextEditors()},get activeTerminal(){return Dt.activeTerminal},get terminals(){return Dt.terminals},async showTextDocument(ge,ye,We){$.URI.isUri(ge)&&ge.scheme===R.Schemas.vscodeRemote&&!ge.authority&&Ot.report("workspace.showTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority.");const ut=await($.URI.isUri(ge)?Promise.resolve(an.openTextDocument(ge)):Promise.resolve(ge));return ct.showTextDocument(ut,ye,We)},createTextEditorDecorationType(ge){return ct.createTextEditorDecorationType(Ue,ge)},onDidChangeActiveTextEditor(ge,ye,We){return st(ct.onDidChangeActiveTextEditor)(ge,ye,We)},onDidChangeVisibleTextEditors(ge,ye,We){return st(ct.onDidChangeVisibleTextEditors)(ge,ye,We)},onDidChangeTextEditorSelection(ge,ye,We){return st(ct.onDidChangeTextEditorSelection)(ge,ye,We)},onDidChangeTextEditorOptions(ge,ye,We){return st(ct.onDidChangeTextEditorOptions)(ge,ye,We)},onDidChangeTextEditorVisibleRanges(ge,ye,We){return st(ct.onDidChangeTextEditorVisibleRanges)(ge,ye,We)},onDidChangeTextEditorViewColumn(ge,ye,We){return st(ct.onDidChangeTextEditorViewColumn)(ge,ye,We)},onDidCloseTerminal(ge,ye,We){return st(Dt.onDidCloseTerminal)(ge,ye,We)},onDidOpenTerminal(ge,ye,We){return st(Dt.onDidOpenTerminal)(ge,ye,We)},onDidChangeActiveTerminal(ge,ye,We){return st(Dt.onDidChangeActiveTerminal)(ge,ye,We)},onDidChangeTerminalDimensions(ge,ye,We){return(0,tt.$0F)(Ue,"terminalDimensions"),st(Dt.onDidChangeTerminalDimensions)(ge,ye,We)},onDidChangeTerminalState(ge,ye,We){return st(Dt.onDidChangeTerminalState)(ge,ye,We)},onDidWriteTerminalData(ge,ye,We){return(0,tt.$0F)(Ue,"terminalDataWriteEvent"),st(Dt.onDidWriteTerminalData)(ge,ye,We)},onDidExecuteTerminalCommand(ge,ye,We){return(0,tt.$0F)(Ue,"terminalExecuteCommandEvent"),st(Dt.onDidExecuteTerminalCommand)(ge,ye,We)},get state(){return Tt.getState(Ue)},onDidChangeWindowState(ge,ye,We){return st(Tt.onDidChangeWindowState)(ge,ye,We)},showInformationMessage(ge,...ye){return wi.showMessage(Ue,b.default.Info,ge,ye[0],ye.slice(1))},showWarningMessage(ge,...ye){return wi.showMessage(Ue,b.default.Warning,ge,ye[0],ye.slice(1))},showErrorMessage(ge,...ye){return wi.showMessage(Ue,b.default.Error,ge,ye[0],ye.slice(1))},showQuickPick(ge,ye,We){return $i.showQuickPick(Ue,ge,ye,We)},showWorkspaceFolderPick(ge){return $i.showWorkspaceFolderPick(ge)},showInputBox(ge,ye){return $i.showInput(ge,ye)},showOpenDialog(ge){return Li.showOpenDialog(Ue,ge)},showSaveDialog(ge){return Li.showSaveDialog(ge)},createStatusBarItem(ge,ye,We){let ut,vt,Nt;return typeof ge=="string"?(ut=ge,vt=ye,Nt=We):(vt=ge,Nt=ye),Ci.createStatusBarEntry(Ue,ut,vt,Nt)},setStatusBarMessage(ge,ye){return Ci.setStatusBarMessage(ge,ye)},withScmProgress(ge){return Ot.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),Vi.withProgress(Ue,{location:Ne.ProgressLocation.SourceControl},(ye,We)=>ge({report(ut){}}))},withProgress(ge,ye){return Vi.withProgress(Ue,ge,ye)},createOutputChannel(ge,ye){return li.createOutputChannel(ge,ye,Ue)},createWebviewPanel(ge,ye,We,ut){return Ei.createWebviewPanel(Ue,ge,ye,We,ut)},createWebviewTextEditorInset(ge,ye,We,ut){return(0,tt.$0F)(Ue,"editorInsets"),Kt.createWebviewEditorInset(ge,ye,We,ut,Ue)},createTerminal(ge,ye,We){return typeof ge=="object"?"pty"in ge?Dt.createExtensionTerminal(ge):Dt.createTerminalFromOptions(ge):Dt.createTerminal(ge,ye,We)},registerTerminalLinkProvider(ge){return Dt.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,ye){return Dt.registerProfileProvider(Ue,ge,ye)},registerTerminalQuickFixProvider(ge,ye){return(0,tt.$0F)(Ue,"terminalQuickFixProvider"),Dt.registerTerminalQuickFixProvider(ge,Ue.identifier.value,ye)},registerTreeDataProvider(ge,ye){return kt.registerTreeDataProvider(ge,ye,Ue)},createTreeView(ge,ye){return kt.createTreeView(ge,ye,Ue)},registerWebviewPanelSerializer:(ge,ye)=>Ei.registerWebviewPanelSerializer(Ue,ge,ye),registerCustomEditorProvider:(ge,ye,We={})=>Hi.registerCustomEditorProvider(Ue,ge,ye,We),registerFileDecorationProvider(ge){return Gt.registerFileDecorationProvider(ge,Ue)},registerUriHandler(ge){return xt.registerUriHandler(Ue,ge)},createQuickPick(){return $i.createQuickPick(Ue)},createInputBox(){return $i.createInputBox(Ue)},get activeColorTheme(){return yi.activeColorTheme},onDidChangeActiveColorTheme(ge,ye,We){return st(yi.onDidChangeActiveColorTheme)(ge,ye,We)},registerWebviewViewProvider(ge,ye,We){return Gi.registerWebviewViewProvider(Ue,ge,ye,We?.webviewOptions)},get activeNotebookEditor(){return ve.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,ye,We){return st(ve.onDidChangeActiveNotebookEditor)(ge,ye,We)},get visibleNotebookEditors(){return ve.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return st(ve.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ge,ye,We){return st(Le.onDidChangeNotebookEditorSelection)(ge,ye,We)},onDidChangeNotebookEditorVisibleRanges(ge,ye,We){return st(Le.onDidChangeNotebookEditorVisibleRanges)(ge,ye,We)},showNotebookDocument(ge,ye){return ve.showNotebookDocument(ge,ye)},registerExternalUriOpener(ge,ye,We){return(0,tt.$0F)(Ue,"externalUriOpener"),Ki.registerExternalUriOpener(Ue.identifier,ge,ye,We)},registerProfileContentHandler(ge,ye){return(0,tt.$0F)(Ue,"profileContentHandlers"),gn.registerProfileContentHandler(Ue,ge,ye)},registerQuickDiffProvider(ge,ye,We,ut){return(0,tt.$0F)(Ue,"quickDiffProvider"),Pi.registerQuickDiffProvider(pt(ge),ye,We,ut)},get tabGroups(){return oi.tabGroups},registerShareProvider(ge,ye){return(0,tt.$0F)(Ue,"shareProvider"),Ai.registerShareProvider(pt(ge),ye)}},an={get rootPath(){return Ot.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),mt.getPath()},set rootPath(ge){throw new L.$9("rootPath")},getWorkspaceFolder(ge){return mt.getWorkspaceFolder(ge)},get workspaceFolders(){return mt.getWorkspaceFolders()},get name(){return mt.name},set name(ge){throw new L.$9("name")},get workspaceFile(){return mt.workspaceFile},set workspaceFile(ge){throw new L.$9("workspaceFile")},updateWorkspaceFolders:(ge,ye,...We)=>mt.updateWorkspaceFolders(Ue,ge,ye||0,...We),onDidChangeWorkspaceFolders:function(ge,ye,We){return st(mt.onDidChangeWorkspace)(ge,ye,We)},asRelativePath:(ge,ye)=>mt.getRelativePath(ge,ye),findFiles:(ge,ye,We,ut)=>mt.findFiles(ge,ye,We,Ue.identifier,ut),findFiles2:(ge,ye,We)=>((0,tt.$0F)(Ue,"findFiles2"),mt.findFiles2(ge,ye,Ue.identifier,We)),findTextInFiles:(ge,ye,We,ut)=>{(0,tt.$0F)(Ue,"findTextInFiles");let vt,Nt;return typeof ye=="object"?(vt=ye,Nt=We):(vt={},Nt=ye,ut=We),mt.findTextInFiles(ge,vt||{},Nt,Ue.identifier,ut)},save:ge=>mt.save(ge),saveAs:ge=>mt.saveAs(ge),saveAll:ge=>mt.saveAll(ge),applyEdit(ge,ye){return _i.applyWorkspaceEdit(ge,Ue,ye)},createFileSystemWatcher:(ge,ye,We,ut)=>{let vt;return typeof ye=="boolean"?vt={ignoreCreateEvents:!!ye,ignoreChangeEvents:!!We,ignoreDeleteEvents:!!ut,correlate:!1}:ye&&((0,tt.$0F)(Ue,"createFileSystemWatcher"),vt={...ye,correlate:!0}),gi.createFileSystemWatcher(mt,Ue,ge,vt)},get textDocuments(){return Mt.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw new L.$9("textDocuments")},openTextDocument(ge){let ye;const We=ge;if(typeof ge=="string")ye=Promise.resolve($.URI.file(ge));else if($.URI.isUri(ge))ye=Promise.resolve(ge);else if(!We||typeof We=="object")ye=Mt.createDocumentData(We);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ye.then(ut=>(ut.scheme===R.Schemas.vscodeRemote&&!ut.authority&&Ot.report("workspace.openTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority."),Mt.ensureDocumentData(ut).then(vt=>vt.document)))},onDidOpenTextDocument:(ge,ye,We)=>st(Mt.onDidAddDocument)(ge,ye,We),onDidCloseTextDocument:(ge,ye,We)=>st(Mt.onDidRemoveDocument)(ge,ye,We),onDidChangeTextDocument:(ge,ye,We)=>st(Mt.onDidChangeDocument)(ge,ye,We),onDidSaveTextDocument:(ge,ye,We)=>st(Mt.onDidSaveDocument)(ge,ye,We),onWillSaveTextDocument:(ge,ye,We)=>st(ze.getOnWillSaveTextDocumentEvent(Ue))(ge,ye,We),get notebookDocuments(){return ve.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,ye){let We;if($.URI.isUri(ge))We=ge,await ve.openNotebookDocument(ge);else if(typeof ge=="string")We=$.URI.revive(await ve.createNotebookDocument({viewType:ge,content:ye}));else throw new Error("Invalid arguments");return ve.getNotebookDocument(We).apiNotebook},onDidSaveNotebookDocument(ge,ye,We){return st(ne.onDidSaveNotebookDocument)(ge,ye,We)},onDidChangeNotebookDocument(ge,ye,We){return st(ne.onDidChangeNotebookDocument)(ge,ye,We)},onWillSaveNotebookDocument(ge,ye,We){return st(Xe.getOnWillSaveNotebookDocumentEvent(Ue))(ge,ye,We)},get onDidOpenNotebookDocument(){return st(ve.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return st(ve.onDidCloseNotebookDocument)},registerNotebookSerializer(ge,ye,We,ut){return ve.registerNotebookSerializer(Ue,ge,ye,We,(0,tt.$9F)(Ue,"notebookLiveShare")?ut:void 0)},onDidChangeConfiguration:(ge,ye,We)=>st(en.onDidChangeConfiguration)(ge,ye,We),getConfiguration(ge,ye){return ye=arguments.length===1?void 0:ye,en.getConfiguration(ge,ye,Ue)},registerTextDocumentContentProvider(ge,ye){return Me.registerTextDocumentContentProvider(ge,ye)},registerTaskProvider:(ge,ye)=>(Ot.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),ri.registerTaskProvider(Ue,ge,ye)),registerFileSystemProvider(ge,ye,We){return(0,P.$Rc)(Ii.registerFileSystemProvider(Ue,ge,ye,We),ii.addFileSystemProvider(ge,ye,We))},get fs(){return ii.value},registerFileSearchProvider:(ge,ye)=>((0,tt.$0F)(Ue,"fileSearchProvider"),ui.registerFileSearchProvider(ge,ye)),registerTextSearchProvider:(ge,ye)=>((0,tt.$0F)(Ue,"textSearchProvider"),ui.registerTextSearchProvider(ge,ye)),registerAITextSearchProvider:(ge,ye)=>((0,tt.$0F)(Ue,"aiTextSearchProvider"),(0,tt.$0F)(Ue,"textSearchProvider"),ui.registerAITextSearchProvider(ge,ye)),registerRemoteAuthorityResolver:(ge,ye)=>((0,tt.$0F)(Ue,"resolvers"),jt.registerRemoteAuthorityResolver(ge,ye)),registerResourceLabelFormatter:ge=>((0,tt.$0F)(Ue,"resolvers"),qi.$registerResourceLabelFormatter(ge)),getRemoteExecServer:ge=>((0,tt.$0F)(Ue,"resolvers"),jt.getRemoteExecServer(ge)),onDidCreateFiles:(ge,ye,We)=>st(gi.onDidCreateFile)(ge,ye,We),onDidDeleteFiles:(ge,ye,We)=>st(gi.onDidDeleteFile)(ge,ye,We),onDidRenameFiles:(ge,ye,We)=>st(gi.onDidRenameFile)(ge,ye,We),onWillCreateFiles:(ge,ye,We)=>st(gi.getOnWillCreateFileEvent(Ue))(ge,ye,We),onWillDeleteFiles:(ge,ye,We)=>st(gi.getOnWillDeleteFileEvent(Ue))(ge,ye,We),onWillRenameFiles:(ge,ye,We)=>st(gi.getOnWillRenameFileEvent(Ue))(ge,ye,We),openTunnel:ge=>((0,tt.$0F)(Ue,"tunnels"),Ft.openTunnel(Ue,ge).then(ye=>{if(!ye)throw new Error("cannot open tunnel");return ye})),get tunnels(){return(0,tt.$0F)(Ue,"tunnels"),Ft.getTunnels()},onDidChangeTunnels:(ge,ye,We)=>((0,tt.$0F)(Ue,"tunnels"),st(Ft.onDidChangeTunnels)(ge,ye,We)),registerPortAttributesProvider:(ge,ye)=>((0,tt.$0F)(Ue,"portsAttributes"),Ft.registerPortsAttributesProvider(ge,ye)),registerTunnelProvider:(ge,ye)=>((0,tt.$0F)(Ue,"tunnelFactory"),Ft.registerTunnelProvider(ge,ye)),registerTimelineProvider:(ge,ye)=>((0,tt.$0F)(Ue,"timeline"),Ri.registerTimelineProvider(ge,ye,Ue.identifier,yt.converter)),get isTrusted(){return mt.trusted},requestWorkspaceTrust:ge=>((0,tt.$0F)(Ue,"workspaceTrust"),mt.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,ye,We)=>st(mt.onDidGrantWorkspaceTrust)(ge,ye,We),registerEditSessionIdentityProvider:(ge,ye)=>((0,tt.$0F)(Ue,"editSessionIdentityProvider"),mt.registerEditSessionIdentityProvider(ge,ye)),onWillCreateEditSessionIdentity:(ge,ye,We)=>((0,tt.$0F)(Ue,"editSessionIdentityProvider"),st(mt.getOnWillCreateEditSessionIdentityEvent(Ue))(ge,ye,We)),registerCanonicalUriProvider:(ge,ye)=>((0,tt.$0F)(Ue,"canonicalUriProvider"),mt.registerCanonicalUriProvider(ge,ye)),getCanonicalUri:(ge,ye,We)=>((0,tt.$0F)(Ue,"canonicalUriProvider"),mt.provideCanonicalUri(ge,ye,We))},cn={get inputBox(){return Ot.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),vi.getLastInputBox(Ue)},createSourceControl(ge,ye,We){return vi.createSourceControl(Ue,ge,ye,We)}},Ni={createCommentController(ge,ye){return Wi.createCommentController(Ue,ge,ye)}},un={get activeDebugSession(){return Et.activeDebugSession},get activeDebugConsole(){return Et.activeDebugConsole},get breakpoints(){return Et.breakpoints},get activeStackItem(){if((0,tt.$9F)(Ue,"debugFocus"))return Et.activeStackItem},registerDebugVisualizationProvider(ge,ye){return(0,tt.$0F)(Ue,"debugVisualization"),Et.registerDebugVisualizationProvider(Ue,ge,ye)},registerDebugVisualizationTreeProvider(ge,ye){return(0,tt.$0F)(Ue,"debugVisualization"),Et.registerDebugVisualizationTree(Ue,ge,ye)},onDidStartDebugSession(ge,ye,We){return st(Et.onDidStartDebugSession)(ge,ye,We)},onDidTerminateDebugSession(ge,ye,We){return st(Et.onDidTerminateDebugSession)(ge,ye,We)},onDidChangeActiveDebugSession(ge,ye,We){return st(Et.onDidChangeActiveDebugSession)(ge,ye,We)},onDidReceiveDebugSessionCustomEvent(ge,ye,We){return st(Et.onDidReceiveDebugSessionCustomEvent)(ge,ye,We)},onDidChangeBreakpoints(ge,ye,We){return st(Et.onDidChangeBreakpoints)(ge,ye,We)},onDidChangeActiveStackItem(ge,ye,We){return(0,tt.$0F)(Ue,"debugFocus"),st(Et.onDidChangeActiveStackItem)(ge,ye,We)},registerDebugConfigurationProvider(ge,ye,We){return Et.registerDebugConfigurationProvider(ge,ye,We||Vt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,ye){return Et.registerDebugAdapterDescriptorFactory(Ue,ge,ye)},registerDebugAdapterTrackerFactory(ge,ye){return Et.registerDebugAdapterTrackerFactory(ge,ye)},startDebugging(ge,ye,We){return!We||typeof We=="object"&&"configuration"in We?Et.startDebugging(ge,ye,{parentSession:We}):Et.startDebugging(ge,ye,We||{})},stopDebugging(ge){return Et.stopDebugging(ge)},addBreakpoints(ge){return Et.addBreakpoints(ge)},removeBreakpoints(ge){return Et.removeBreakpoints(ge)},asDebugSourceUri(ge,ye){return Et.asDebugSourceUri(ge,ye)}},ln={registerTaskProvider:(ge,ye)=>ri.registerTaskProvider(Ue,ge,ye),fetchTasks:ge=>ri.fetchTasks(ge),executeTask:ge=>ri.executeTask(Ue,ge),get taskExecutions(){return ri.taskExecutions},onDidStartTask:(ge,ye,We)=>st(ri.onDidStartTask)(ge,ye,We),onDidEndTask:(ge,ye,We)=>st(ri.onDidEndTask)(ge,ye,We),onDidStartTaskProcess:(ge,ye,We)=>st(ri.onDidStartTaskProcess)(ge,ye,We),onDidEndTaskProcess:(ge,ye,We)=>st(ri.onDidEndTaskProcess)(ge,ye,We)},hn={createNotebookController(ge,ye,We,ut,vt){return Ve.createNotebookController(Ue,ge,ye,We,ut,(0,tt.$9F)(Ue,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(ge,ye)=>ve.registerNotebookCellStatusBarItemProvider(Ue,ge,ye),createRendererMessaging(ge){return et.createRendererMessaging(Ue,ge)},createNotebookControllerDetectionTask(ge){return(0,tt.$0F)(Ue,"notebookKernelSource"),Ve.createNotebookControllerDetectionTask(Ue,ge)},registerKernelSourceActionProvider(ge,ye){return(0,tt.$0F)(Ue,"notebookKernelSource"),Ve.registerKernelSourceActionProvider(Ue,ge,ye)},onDidChangeNotebookCellExecutionState(ge,ye,We){return(0,tt.$0F)(Ue,"notebookCellExecutionState"),st(Ve.onDidChangeNotebookCellExecutionState)(ge,ye,We)}},bn={t(...ge){if(typeof ge[0]=="string"){const ye=ge.shift(),We=!ge||typeof ge[0]!="object"?ge:ge[0];return di.getMessage(Ue.identifier.value,{message:ye,args:We})}return di.getMessage(Ue.identifier.value,ge[0])},get bundle(){return di.getBundle(Ue.identifier.value)},get uri(){return di.getBundleUri(Ue.identifier.value)}},wn={_version:1,registerInteractiveEditorSessionProvider(ge,ye){return(0,tt.$0F)(Ue,"interactive"),mn.registerProvider(Ue,ge,ye)},registerInteractiveSessionProvider(ge,ye){return(0,tt.$0F)(Ue,"interactive"),Ji.registerChatProvider(Ue,ge,ye)},transferChatSession(ge,ye){return(0,tt.$0F)(Ue,"interactive"),Ji.transferChatSession(ge,ye)}},dn={getRelatedInformation(ge,ye){return(0,tt.$0F)(Ue,"aiRelatedInformation"),Qi.getRelatedInformation(Ue,ge,ye)},registerRelatedInformationProvider(ge,ye){return(0,tt.$0F)(Ue,"aiRelatedInformation"),Qi.registerRelatedInformationProvider(Ue,ge,ye)},registerEmbeddingVectorProvider(ge,ye){return(0,tt.$0F)(Ue,"aiRelatedInformation"),Xi.registerEmbeddingVectorProvider(Ue,ge,ye)}},fn={registerChatResponseProvider(ge,ye,We){return(0,tt.$0F)(Ue,"chatProvider"),St.registerLanguageModel(Ue,ge,ye,We)},registerChatVariableResolver(ge,ye,We){return(0,tt.$0F)(Ue,"chatVariableResolver"),Mi.registerVariableResolver(Ue,ge,ye,We)},registerMappedEditsProvider(ge,ye){return(0,tt.$0F)(Ue,"mappedEditsProvider"),ht.registerMappedEditsProvider(Ue,ge,ye)},createChatParticipant(ge,ye){return(0,tt.$0F)(Ue,"chatParticipant"),Oi.createChatAgent(Ue,ge,ye)}},Fi={get languageModels(){return(0,tt.$0F)(Ue,"languageModels"),St.getLanguageModelIds()},onDidChangeLanguageModels:(ge,ye,We)=>((0,tt.$0F)(Ue,"languageModels"),St.onDidChangeProviders(ge,ye,We)),sendChatRequest(ge,ye,We,ut){return(0,tt.$0F)(Ue,"languageModels"),St.sendChatRequest(Ue,ge,ye,We,ut)}},Ti={registerSpeechProvider(ge,ye){return(0,tt.$0F)(Ue,"speech"),Yi.registerProvider(Ue.identifier,ge,ye)}};return{version:bt.version,ai:dn,authentication:tn,commands:nn,comments:Ni,chat:fn,debug:un,env:ji,extensions:sn,interactive:wn,l10n:bn,languages:on,lm:Fi,notebooks:hn,scm:cn,speech:Ti,tasks:ln,tests:rn,window:pn,workspace:an,Breakpoint:Ne.$nN,TerminalOutputAnchor:Ne.TerminalOutputAnchor,ChatResultFeedbackKind:Ne.ChatResultFeedbackKind,ChatVariableLevel:Ne.ChatVariableLevel,ChatCompletionItem:Ne.$hO,CallHierarchyIncomingCall:Ne.$LM,CallHierarchyItem:Ne.$KM,CallHierarchyOutgoingCall:Ne.$MM,CancellationError:L.$5,CancellationTokenSource:u.$ee,CandidatePortSource:i.CandidatePortSource,CodeAction:Ne.$HM,CodeActionKind:Ne.$IM,CodeActionTriggerKind:Ne.CodeActionTriggerKind,CodeLens:Ne.$NM,Color:Ne.$1M,ColorInformation:Ne.$2M,ColorPresentation:Ne.$3M,ColorThemeKind:Ne.ColorThemeKind,CommentMode:Ne.CommentMode,CommentState:Ne.CommentState,CommentThreadCollapsibleState:Ne.CommentThreadCollapsibleState,CommentThreadState:Ne.CommentThreadState,CommentThreadApplicability:Ne.CommentThreadApplicability,CompletionItem:Ne.$UM,CompletionItemKind:Ne.CompletionItemKind,CompletionItemTag:Ne.CompletionItemTag,CompletionList:Ne.$VM,CompletionTriggerKind:Ne.CompletionTriggerKind,ConfigurationTarget:Ne.ConfigurationTarget,CustomExecution:Ne.$$M,DebugAdapterExecutable:Ne.$rN,DebugAdapterInlineImplementation:Ne.$uN,DebugAdapterNamedPipeServer:Ne.$tN,DebugAdapterServer:Ne.$sN,DebugConfigurationProviderTriggerKind:Vt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ne.DebugConsoleMode,DebugVisualization:Ne.$KN,DecorationRangeBehavior:Ne.DecorationRangeBehavior,Diagnostic:Ne.$BM,DiagnosticRelatedInformation:Ne.$AM,DiagnosticSeverity:Ne.DiagnosticSeverity,DiagnosticTag:Ne.DiagnosticTag,Disposable:Ne.$nM,DocumentHighlight:Ne.$DM,DocumentHighlightKind:Ne.DocumentHighlightKind,MultiDocumentHighlight:Ne.$EM,DocumentLink:Ne.$ZM,DocumentSymbol:Ne.$GM,EndOfLine:Ne.EndOfLine,EnvironmentVariableMutatorType:Ne.EnvironmentVariableMutatorType,EvaluatableExpression:Ne.$xN,InlineValueText:Ne.$yN,InlineValueVariableLookup:Ne.$zN,InlineValueEvaluatableExpression:Ne.$AN,InlineCompletionTriggerKind:Ne.InlineCompletionTriggerKind,EventEmitter:M.$7d,ExtensionKind:Ne.ExtensionKind,ExtensionMode:Ne.ExtensionMode,ExternalUriOpenerPriority:Ne.ExternalUriOpenerPriority,FileChangeType:Ne.FileChangeType,FileDecoration:Ne.$MN,FileDecoration2:Ne.$MN,FileSystemError:Ne.$DN,FileType:v.FileType,FilePermission:v.FilePermission,FoldingRange:Ne.$EN,FoldingRangeKind:Ne.FoldingRangeKind,FunctionBreakpoint:Ne.$pN,InlineCompletionItem:Ne.$WM,InlineCompletionList:Ne.$XM,Hover:Ne.$CM,IndentAction:I.IndentAction,Location:Ne.$zM,MarkdownString:Ne.$OM,OverviewRulerLane:p.OverviewRulerLane,ParameterInformation:Ne.$PM,PortAutoForwardAction:Ne.PortAutoForwardAction,Position:Ne.$oM,ProcessExecution:Ne.$9M,ProgressLocation:Ne.ProgressLocation,QuickInputButtons:Ne.$LN,Range:Ne.$pM,RelativePattern:Ne.$lN,Selection:Ne.$qM,SelectionRange:Ne.$JM,SemanticTokens:Ne.$HN,SemanticTokensBuilder:Ne.$GN,SemanticTokensEdit:Ne.$IN,SemanticTokensEdits:Ne.$JN,SemanticTokensLegend:Ne.$FN,ShellExecution:Ne.$0M,ShellQuoting:Ne.ShellQuoting,SignatureHelp:Ne.$RM,SignatureHelpTriggerKind:Ne.SignatureHelpTriggerKind,SignatureInformation:Ne.$QM,SnippetString:Ne.$yM,SourceBreakpoint:Ne.$oN,StandardTokenType:Ne.StandardTokenType,StatusBarAlignment:Ne.StatusBarAlignment,SymbolInformation:Ne.$FM,SymbolKind:Ne.SymbolKind,SymbolTag:Ne.SymbolTag,Task:Ne.$_M,TaskGroup:Ne.$8M,TaskPanelKind:Ne.TaskPanelKind,TaskRevealKind:Ne.TaskRevealKind,TaskScope:Ne.TaskScope,TerminalLink:Ne.$4M,TerminalQuickFixTerminalCommand:Ne.$6M,TerminalQuickFixOpener:Ne.$5M,TerminalLocation:Ne.TerminalLocation,TerminalProfile:Ne.$7M,TerminalExitReason:Ne.TerminalExitReason,TextDocumentSaveReason:Ne.TextDocumentSaveReason,TextEdit:Ne.$uM,SnippetTextEdit:Ne.$wM,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ne.TextEditorLineNumbersStyle,TextEditorRevealType:Ne.TextEditorRevealType,TextEditorSelectionChangeKind:Ne.TextEditorSelectionChangeKind,SyntaxTokenType:Ne.SyntaxTokenType,TextDocumentChangeReason:Ne.TextDocumentChangeReason,ThemeColor:Ne.$kN,ThemeIcon:Ne.$jN,TreeItem:Ne.$aN,TreeItemCheckboxState:Ne.TreeItemCheckboxState,TreeItemCollapsibleState:Ne.TreeItemCollapsibleState,TypeHierarchyItem:Ne.$8N,UIKind:ai.UIKind,Uri:$.URI,ViewColumn:Ne.ViewColumn,WorkspaceEdit:Ne.$xM,DocumentPasteTriggerKind:Ne.DocumentPasteTriggerKind,DocumentDropEdit:Ne.$gN,DocumentPasteEditKind:Ne.$hN,DocumentPasteEdit:Ne.$iN,InlayHint:Ne.$TM,InlayHintLabelPart:Ne.$SM,InlayHintKind:Ne.InlayHintKind,RemoteAuthorityResolverError:Ne.$tM,ResolvedAuthority:Ne.$rM,ManagedResolvedAuthority:Ne.$sM,SourceControlInputBoxValidationType:Ne.SourceControlInputBoxValidationType,ExtensionRuntime:Ne.ExtensionRuntime,TimelineItem:Ne.$WN,NotebookRange:Ne.$ON,NotebookCellKind:Ne.NotebookCellKind,NotebookCellExecutionState:Ne.NotebookCellExecutionState,NotebookCellData:Ne.$PN,NotebookData:Ne.$QN,NotebookRendererScript:Ne.$UN,NotebookCellStatusBarAlignment:Ne.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ne.NotebookEditorRevealType,NotebookCellOutput:Ne.$SN,NotebookCellOutputItem:Ne.$RN,NotebookCellStatusBarItem:Ne.$TN,NotebookControllerAffinity:Ne.NotebookControllerAffinity,NotebookControllerAffinity2:Ne.NotebookControllerAffinity2,NotebookEdit:Ne.$vM,NotebookKernelSourceAction:Ne.$VN,NotebookVariablesRequestKind:Ne.NotebookVariablesRequestKind,PortAttributes:Ne.$YN,LinkedEditingRanges:Ne.$XN,TestResultState:Ne.TestResultState,TestRunRequest:Ne.$ZN,TestMessage:Ne.$1N,TestTag:Ne.$2N,TestRunProfileKind:Ne.TestRunProfileKind,TextSearchCompleteMessageType:ei.TextSearchCompleteMessageType,DataTransfer:Ne.$fN,DataTransferItem:Ne.$bN,CoveredCount:Ne.$3N,FileCoverage:Ne.$4N,StatementCoverage:Ne.$5N,BranchCoverage:Ne.$6N,DeclarationCoverage:Ne.$7N,FunctionCoverage:Ne.$7N,WorkspaceTrustState:Ne.WorkspaceTrustState,LanguageStatusSeverity:Ne.LanguageStatusSeverity,QuickPickItemKind:Ne.QuickPickItemKind,InputBoxValidationSeverity:Ne.InputBoxValidationSeverity,TabInputText:Ne.$9N,TabInputTextDiff:Ne.$0N,TabInputTextMerge:Ne.$$N,TabInputCustom:Ne.$_N,TabInputNotebook:Ne.$bO,TabInputNotebookDiff:Ne.$cO,TabInputWebview:Ne.$aO,TabInputTerminal:Ne.$dO,TabInputInteractiveWindow:Ne.$eO,TabInputChat:Ne.$fO,TabInputTextMultiDiff:Ne.$gO,TelemetryTrustedValue:o.$4o,LogLevel:a.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ne.InteractiveSessionVoteDirection,ChatCopyKind:Ne.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Ne.InteractiveEditorResponseFeedbackKind,StackFrame:Ne.$vN,Thread:Ne.$wN,RelatedInformationType:Ne.RelatedInformationType,SpeechToTextStatus:Ne.SpeechToTextStatus,PartialAcceptTriggerKind:Ne.PartialAcceptTriggerKind,KeywordRecognitionStatus:Ne.KeywordRecognitionStatus,ChatResponseMarkdownPart:Ne.$iO,ChatResponseFileTreePart:Ne.$jO,ChatResponseAnchorPart:Ne.$kO,ChatResponseProgressPart:Ne.$lO,ChatResponseReferencePart:Ne.$nO,ChatResponseCommandButtonPart:Ne.$mO,ChatRequestTurn:Ne.$oO,ChatResponseTurn:Ne.$pO,ChatLocation:Ne.ChatLocation,LanguageModelChatSystemMessage:Ne.$qO,LanguageModelChatUserMessage:Ne.$rO,LanguageModelChatAssistantMessage:Ne.$sO,LanguageModelSystemMessage:Ne.$qO,LanguageModelUserMessage:Ne.$rO,LanguageModelAssistantMessage:Ne.$sO,LanguageModelError:Ne.$tO,NewSymbolName:Ne.$CN,NewSymbolNameTag:Ne.NewSymbolNameTag,InlineEdit:Ne.$uO,InlineEditTriggerKind:Ne.InlineEditTriggerKind}}}}),define(ke[381],Ee([1,0,84,156,43,151,44,33,72,47,95,96,97,118,70,91,150,69,59,117,90,71,149,12,60,115,116,120,121]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v,a,m,o,n,i,r,s,t,f,d,l,c,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.$gs)(l.$Yjc,l.$Xjc,1),(0,u.$gs)(f.$Pj,t.$$kc,1),(0,u.$gs)(a.$3ic,a.$4ic,1),(0,u.$gs)(b.$3O,b.$2O,0),(0,u.$gs)(h.$ajc,h.$bjc,0),(0,u.$gs)(g.$fjc,g.$gjc,0),(0,u.$gs)(R.$sjc,R.$qjc,0),(0,u.$gs)(o.$ujc,o.$tjc,0),(0,u.$gs)(I.$9jc,I.$akc,0),(0,u.$gs)(P.$ckc,P.$bkc,0),(0,u.$gs)($.$RO,$.$QO,0),(0,u.$gs)(c.$Zjc,c.$1jc,0),(0,u.$gs)(n.$7ic,n.$6ic,0),(0,u.$gs)(L.$Ikc,L.$Hkc,1),(0,u.$gs)(p.$skc,p.$tkc,0),(0,u.$gs)(E.$Njc,E.$Mjc,0),(0,u.$gs)(A.$Vkc,A.$Ukc,0),(0,u.$gs)(y.$Qjc,y.$Tjc,0),(0,u.$gs)(v.$NBb,v.$OBb,0),(0,u.$gs)(m.$9kc,m.$8kc,0),(0,u.$gs)(M.$pjc,M.$ojc,0),(0,u.$gs)(i.$Vjc,i.$Ujc,0),(0,u.$gs)(r.$1O,r.$XO,0),(0,u.$gs)(s.$Ejc,s.$Fjc,0),(0,u.$gs)(d.$7jc,d.$8jc,0)}),define(ke[122],Ee([1,0,19,12,36,94]),function(he,e,u,L,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qlc=void 0,e.$olc=R,e.$plc=b;function R(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}function b(I,p,E,v){const a=(0,u.$2b)(E,$),m=new M.$EK(p,a,v),o=m.preview.matches;return{ranges:(0,u.$2b)(a,y),uri:I,preview:{text:m.preview.text,matches:(0,u.$2b)(o,y)}}}function $(I){return new M.$FK(I.start.line,I.start.character,I.end.line,I.end.character)}function y(I){return new P.$tK(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let A=class{constructor(p,E){this.a=p,this.b=E}appendLine(p){this.b.debug(`${this.a}#search`,p)}};e.$qlc=A,e.$qlc=A=Je([qe(1,L.$Oj)],A)}),define(ke[382],Ee([1,0,52,17,76,34,11,14,122,383]),function(he,e,u,L,M,P,R,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rlc=I,e.$slc=m,e.$tlc=n;const A=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(i,r,s,t){const f=p(i,r,s,t),d=r.folder.fsPath;return{cmd:u.spawn(A,f.args,{cwd:d}),rgDiskPath:A,siblingClauses:f.siblingClauses,rgArgs:f,cwd:d}}function p(i,r,s,t){const f=["--files","--hidden","--case-sensitive","--no-require-git"];v([r],s,!1).forEach(l=>{const c=(0,$.$olc)(l);if(f.push("-g",c),R.$j){const h=(0,M.$1l)(c);h!==c&&f.push("-g",h)}});const d=E([r],t,void 0,!1);return d.globArgs.forEach(l=>{const c=`!${(0,$.$olc)(l)}`;if(f.push("-g",c),R.$j){const h=(0,M.$1l)(c);h!==c&&f.push("-g",h)}}),r.disregardIgnoreFiles!==!1?f.push("--no-ignore"):r.disregardParentIgnoreFiles!==!1&&f.push("--no-ignore-parent"),r.ignoreSymlinks||f.push("--follow"),i.exists&&f.push("--quiet"),f.push("--no-config"),r.disregardGlobalIgnoreFiles&&f.push("--no-ignore-global"),{args:f,siblingClauses:d.siblingClauses}}function E(i,r,s,t=!0){const f=[];let d={};return i.forEach(l=>{const c=Object.assign({},l.excludePattern||{},r||{}),h=a(c,t?l.folder.fsPath:void 0,s);f.push(...h.globArgs),h.siblingClauses&&(d=Object.assign(d,h.siblingClauses))}),{globArgs:f,siblingClauses:d}}function v(i,r,s=!0){const t=[];return i.forEach(f=>{const d=Object.assign({},r||{},f.includePattern||{}),l=a(d,s?f.folder.fsPath:void 0);t.push(...l.globArgs)}),t}function a(i,r,s){const t=[],f={};return Object.keys(i).forEach(d=>{if(s&&s.has(d)||!d)return;const l=i[d];d=o(r?m(r,d):d),d.startsWith("\\\\")?d="\\\\"+d.substr(2).replace(/\\/g,"/"):d=d.replace(/\\/g,"/"),typeof l=="boolean"&&l?(d.startsWith("\\\\")&&(d+="**"),t.push(n(d))):l&&l.when&&(f[d]=l)}),{globArgs:t,siblingClauses:f}}function m(i,r){return L.$jc(r)?r:L.$kc(i,r)}function o(i){return i=b.$6e(i,"\\"),b.$6e(i,"/")}function n(i){return P.$eg(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}}),define(ke[384],Ee([1,0,52,51,17,385,19,46,35,76,34,11,39,14,18,31,36,382,132]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v,a,m,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vlc=e.$ulc=void 0;const i=new Set;process.on("exit",()=>{i.forEach(d=>d())});class r{constructor(l){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=l,this.b=l.filePattern||"",this.d=l.includePattern&&$.$ck(l.includePattern),this.f=l.maxResults||null,this.g=!!l.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=l.shouldGlobMatchFilePattern?null:(0,n.$hr)(this.b).normalizedLowercase),this.u=l.excludePattern&&$.$ck(l.excludePattern),this.t=new Map,l.folderQueries.forEach(c=>{const h=Object.assign({},c.excludePattern||{},this.a.excludePattern||{}),g=c.folder.fsPath;l.folderQueries.map(S=>S.folder.fsPath).filter(S=>S!==g).forEach(S=>{(0,A.$ig)(S,g)&&(h[M.$mc(g,S)]=!0)}),this.t.set(g,new t(h,g))})}cancel(){this.l=!0,i.forEach(l=>l())}walk(l,c,h,g,S){if(this.m=p.$3d.create(!1),this.l)return S(null,this.j);c.forEach(w=>{const C=M.$oc(w.fsPath);this.u&&this.u(w.fsPath,C)||this.J(h,{relativePath:w.fsPath,searchPath:void 0})}),this.r=p.$3d.create(!1),this.w(l,(w,C)=>{this.x(this.y,this,w,h,g,k=>{if(k){const D=(0,b.$6i)(k);console.error(D),this.q.push(D),C(k,void 0)}else C(null,void 0)})},(w,C)=>{this.m.stop();const k=w?R.$Hb(w)[0]:null;S(k,this.j)})}w(l,c,h){const g=new Array(l.length),S=new Array(l.length);let w=!1,C=0;if(l.length===0)return h(null,[]);l.forEach((k,D)=>{c(k,(O,F)=>{if(O?(w=!0,g[D]=null,S[D]=O):(g[D]=F,S[D]=null),++C===l.length)return h(w?S:null,g)})})}x(l,c,...h){try{l.apply(c,h)}catch(g){h[h.length-1](g)}}y(l,c,h,g){const S=l.folder.fsPath,w=I.$j,C=()=>T&&T.kill();i.add(C);let k=B=>{i.delete(C),k=()=>{},g(B)},D="";const O=this.D(),F=(0,o.$rlc)(this.a,l,this.a.includePattern,this.t.get(l.folder.fsPath).expression),T=F.cmd,z=!Object.keys(F.siblingClauses).length,j=F.rgArgs.args.map(B=>B.match(/^-/)?B:`'${B}'`).join(" ");let N=`${F.rgDiskPath} ${j}
 - cwd: ${F.cwd}`;F.rgArgs.siblingClauses&&(N+=`
 - Sibling clauses: ${JSON.stringify(F.rgArgs.siblingClauses)}`),h({message:N}),this.s=0,this.z(T,"utf8",h,(B,W,Z)=>{if(B){k(B);return}if(this.j){k();return}const X=(D+(w?y.$Zl(W||""):W)).split(`
`);if(Z){const x=X.length;X[x-1]=X[x-1].trim(),X[x-1]||X.pop()}else D=X.pop()||"";if(X.length&&X[0].indexOf(`
`)!==-1){k(new Error("Splitting up files failed"));return}if(this.s+=X.length,z){for(const x of X)if(this.J(c,{base:S,relativePath:x,searchPath:this.N(l,x)}),this.j){C();break}(Z||this.j)&&k();return}this.G(l,O,S,X,c),Z&&(this.H(O,S,c),k())})}spawnFindCmd(l){const c=this.t.get(l.folder.fsPath),h=c.getBasenameTerms(),g=c.getPathTerms(),S=["-L","."];if(h.length||g.length){S.push("-not","(","(");for(const w of h)S.push("-name",w),S.push("-o");for(const w of g)S.push("-path",w),S.push("-o");S.pop(),S.push(")","-prune",")")}return S.push("-type","f"),u.spawn("find",S,{cwd:l.folder.fsPath})}readStdout(l,c,h){let g="";this.z(l,c,()=>{},(S,w,C)=>{if(S){h(S);return}g+=w,C&&h(null,g)})}z(l,c,h,g){let S=(k,D,O)=>{(k||O)&&(S=()=>{},this.r?.stop()),g(k,D,O)},w=!1;l.stdout?(this.A(l.stdout,c,S),l.stdout.once("data",()=>w=!0)):h({message:"stdout is null"});let C;l.stderr?C=this.B(l.stderr):h({message:"stderr is null"}),l.on("error",k=>{S(k)}),l.on("close",k=>{let D;!w&&(D=this.C(C,c))&&f(D)?S(new Error(`command failed with error code ${k}: ${this.C(C,c)}`)):(this.g&&k===0&&(this.j=!0),S(null,"",!0))})}A(l,c,h){const g=new P.StringDecoder(c);return l.on("data",S=>{h(null,g.write(S))}),g}B(l){const c=[];return l.on("data",h=>{c.push(h)}),c}C(l,c){const h=new P.StringDecoder(c);return l.map(g=>h.write(g)).join("")}D(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}G(l,{pathToEntries:c},h,g,S){g.indexOf(this.b)!==-1&&this.J(S,{base:h,relativePath:this.b,searchPath:this.N(l,this.b)});const w=C=>{const k=M.$oc(C),D=M.$nc(C);let O=c[D];O||(O=c[D]=[],w(D)),O.push({base:h,relativePath:C,basename:k,searchPath:this.N(l,C)})};g.forEach(w)}H({rootEntries:l,pathToEntries:c},h,g){const S=this,w=this.t.get(h),C=this.b;function k(D){S.o++;const O=(0,m.$UK)(()=>D.map(F=>F.basename));for(let F=0,T=D.length;F<T;F++){const z=D[F],{relativePath:j,basename:N}=z;if(w.test(j,N,C!==N?O:void 0))continue;const B=c[j];if(B)k(B);else{if(S.p++,j===C)continue;S.J(g,z)}if(S.j)break}}k(l)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(l,c,h,g,S){const w=l.folder,C=(0,m.$UK)(()=>h);this.w(h,(k,D)=>{if(this.l||this.j)return D(null);const O=c?[c,k].join(M.sep):k;if(this.t.get(l.folder.fsPath).test(O,k,this.a.filePattern!==k?C:void 0))return D(null);const F=[w.fsPath,O].join(M.sep);L.lstat(F,(T,z)=>{if(T||this.l||this.j)return D(null);this.L(F,z,(j,N)=>j||this.l||this.j?D(null):N.isDirectory()?(this.o++,this.M(F,z,(B,W)=>B||this.l||this.j||(W=W||"",this.v[W])?D(null):(this.v[W]=!0,a.Promises.readdir(F).then(Z=>{if(this.l||this.j)return D(null);this.I(l,O,Z,g,_=>D(_||null))},Z=>{D(null)})))):(this.p++,O===this.b||this.h&&v.$Zf(N.size)&&N.size>this.h||this.J(g,{base:w.fsPath,relativePath:O,searchPath:this.N(l,O)}),D(null,void 0)))})},k=>{const D=k&&R.$Hb(k);return S(D&&D.length>0?D[0]:void 0)})}J(l,c){this.K(c)&&(!this.d||this.d(c.relativePath,M.$oc(c.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||l(c))}K(l){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,m.$PK)(l,this.c);if(this.b)return(0,m.$PK)(l,this.b,!1)}return!0}L(l,c,h){return c.isSymbolicLink()?L.stat(l,h):h(null,c)}M(l,c,h){return c.isSymbolicLink()?L.realpath(l,(g,S)=>g?h(g):h(null,S)):h(null,l)}N(l,c){return l.folderName?M.$kc(l.folderName,c):c}}e.$ulc=r;class s{constructor(l){this.a=l.folderQueries,this.b=l.extraFileResources||[],this.c=new r(l)}search(l,c,h){this.c.walk(this.a,this.b,l,c,(g,S)=>{h(g,{limitHit:S,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$vlc=s;class t{constructor(l,c){this.expression=l,this.c=c,this.d(l)}d(l){let c,h;Object.keys(l).filter(g=>l[g]).forEach(g=>{M.$jc(g)?(c=c||$.$0j(),c[g]=l[g]):(h=h||$.$0j(),h[g]=l[g])}),this.a=c&&$.$ck(c,{trimForExclusions:!0}),this.b=h&&$.$ck(h,{trimForExclusions:!0})}test(l,c,h){return this.b&&this.b(l,c,h)||this.a&&this.a(M.$kc(this.c,l),c,h)}getBasenameTerms(){const l=[];return this.a&&l.push(...$.$ek(this.a)),this.b&&l.push(...$.$ek(this.b)),l}getPathTerms(){const l=[];return this.a&&l.push(...$.$fk(this.a)),this.b&&l.push(...$.$fk(this.b)),l}}function f(d){const l=d.trim().split(`
`),c=l[0].trim();if(c.startsWith("Error parsing regex"))return c;if(c.startsWith("regex parse error"))return E.$Nf(l[l.length-1].trim());if(c.startsWith("error parsing glob")||c.startsWith("unsupported encoding"))return c.charAt(0).toUpperCase()+c.substr(1);if(c==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(c.startsWith("Literal "))return c}}),define(ke[386],Ee([1,0,98,21,192,22]),function(he,e,u,L,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WD=e.$OD=e.DecodeStreamErrorKind=e.$ND=e.$MD=e.$LD=e.$JD=e.$ID=e.$HD=e.$GD=void 0,e.$KD=R,e.$PD=v,e.$QD=a,e.$RD=m,e.$SD=o,e.$TD=n,e.$UD=d,e.$VD=l,e.$GD="utf8",e.$HD="utf8bom",e.$ID="utf16be",e.$JD="utf16le";function R(c){return[e.$GD,e.$HD,e.$ID,e.$JD].some(h=>h===c)}e.$LD=[254,255],e.$MD=[255,254],e.$ND=[239,187,191];const b=512,$=512,y=512*8,A=512*128;var I;(function(c){c[c.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I||(e.DecodeStreamErrorKind=I={}));class p extends Error{constructor(h,g){super(h),this.decodeStreamErrorKind=g}}e.$OD=p;class E{static async create(h){let g;if(h!==e.$GD)g=(await(0,M.$FD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(h));else{const S=new TextDecoder;g={write(w){return S.decode(w,{stream:!0})},end(){return S.decode()}}}return new E(g)}constructor(h){this.a=h}write(h){return this.a.write(h)}end(){return this.a.end()}}function v(c,h){const g=h.minBytesRequiredForDetection??h.guessEncoding?y:$;return new Promise((S,w)=>{const C=(0,u.$ie)(z=>z.join("")),k=[];let D=0,O;const F=new P.$ee,T=async()=>{try{const z=await l({buffer:L.$ue.concat(k),bytesRead:D},h.guessEncoding);if(z.seemsBinary&&h.acceptTextOnly)throw new p("Stream is binary but only text is accepted for decoding",1);z.encoding=await h.overwriteEncoding(z.encoding),O=await E.create(z.encoding);const j=O.write(L.$ue.concat(k).buffer);C.write(j),k.length=0,D=0,S({stream:C,detected:z})}catch(z){F.cancel(),C.destroy(),w(z)}};(0,u.$me)(c,{onData:async z=>{O?C.write(O.write(z.buffer)):(k.push(z),D+=z.byteLength,D>=g&&(c.pause(),await T(),setTimeout(()=>c.resume())))},onError:z=>C.error(z),onEnd:async()=>{O||await T(),C.end(O?.end())}},F.token)})}async function a(c,h,g){const w=(await(0,M.$FD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(h),g);let C=!1,k=!1;return{read(){if(k)return null;const D=c.read();if(typeof D!="string"){if(k=!0,!C&&g?.addBOM)switch(h){case e.$GD:case e.$HD:return L.$ue.wrap(Uint8Array.from(e.$ND));case e.$ID:return L.$ue.wrap(Uint8Array.from(e.$LD));case e.$JD:return L.$ue.wrap(Uint8Array.from(e.$MD))}const O=w.end();return O&&O.length>0?(C=!0,L.$ue.wrap(O)):null}return C=!0,L.$ue.wrap(w.write(D))}}}async function m(c){return(await(0,M.$FD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(c))}function o(c){return c===e.$HD||c===null?e.$GD:c}function n(c,h){if(!c||h<e.$LD.length)return null;const g=c.readUInt8(0),S=c.readUInt8(1);if(g===e.$LD[0]&&S===e.$LD[1])return e.$ID;if(g===e.$MD[0]&&S===e.$MD[1])return e.$JD;if(h<e.$ND.length)return null;const w=c.readUInt8(2);return g===e.$ND[0]&&S===e.$ND[1]&&w===e.$ND[2]?e.$HD:null}const i=["ascii","utf-16","utf-32"];async function r(c){const h=await(0,M.$FD)("jschardet","dist/jschardet.min.js"),g=c.slice(0,A),S=f(g.buffer),w=h.detect(S);if(!w||!w.encoding)return null;const C=w.encoding.toLowerCase();return 0<=i.indexOf(C)?null:t(w.encoding)}const s={ibm866:"cp866",big5:"cp950"};function t(c){const h=c.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return s[h]||h}function f(c){let h="";for(let g=0;g<c.length;g++)h+=String.fromCharCode(c[g]);return h}function d(c){switch(c){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const h=c.match(/windows(\d+)/);return h?"windows-"+h[1]:c}}}function l({buffer:c,bytesRead:h},g){let S=n(c,h),w=!1;if(S!==e.$ID&&S!==e.$JD&&c){let C=!0,k=!0,D=!1;for(let O=0;O<h&&O<b;O++){const F=O%2===1,T=c.readUInt8(O)===0;if(T&&(D=!0),C&&(F&&!T||!F&&T)&&(C=!1),k&&(F&&T||!F&&!T)&&(k=!1),T&&!C&&!k)break}D&&(C?S=e.$JD:k?S=e.$ID:w=!0)}return g&&!w&&!S&&c?r(c.slice(0,h)).then(C=>({seemsBinary:!1,encoding:C})):{seemsBinary:w,encoding:S}}e.$WD={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[159],Ee([1,0,386,31,158]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dlc=void 0;class P extends M.$okc{constructor(b,$,y=L,A="searchProcess"){super({query:b,provider:$},{readdir:I=>y.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,u.$UD)(I)},A)}}e.$Dlc=P}),define(ke[160],Ee([1,0,52,402,385,19,73,35,14,2,36,94,403,383,122]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xlc=e.$wlc=void 0,e.$ylc=t,e.$zlc=d,e.$Alc=c,e.$Blc=h,e.$Clc=S;const a=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(C){this.a=C}provideTextSearchResults(C,k,D,O){return this.a.appendLine(`provideTextSearchResults ${C.pattern}, ${JSON.stringify({...k,folder:k.folder.toString()})}`),new Promise((F,T)=>{O.onCancellationRequested(()=>X());const z=t(C,k),j=k.folder.fsPath,N=z.map(Ce=>Ce.match(/^-/)?Ce:`'${Ce}'`).join(" ");this.a.appendLine(`${a} ${N}
 - cwd: ${j}`);let B=u.spawn(a,z,{cwd:j});B.on("error",Ce=>{console.error(Ce),this.a.appendLine("Error: "+(Ce&&Ce.message)),T((0,A.$LK)(new A.$JK(Ce&&Ce.message,A.SearchErrorCode.rgProcessError)))});let W=!1;const Z=new i(k.maxResults,k.folder,k.previewOptions);Z.on("result",Ce=>{W=!0,re="",D.report(Ce)});let _=!1;const X=()=>{_=!0,B?.kill(),Z?.cancel()};let x=!1;Z.on("hitLimit",()=>{x=!0,X()});let re="";B.stdout.on("data",Ce=>{Z.handleData(Ce),W||(re+=Ce)});let Y=!1;B.stdout.once("data",()=>Y=!0);let me="";B.stderr.on("data",Ce=>{const ee=Ce.toString();this.a.appendLine(ee),me.length+ee.length<1e6&&(me+=ee)}),B.on("close",()=>{if(this.a.appendLine(Y?"Got data from stdout":"No data from stdout"),this.a.appendLine(W?"Got result from parser":"No result from parser"),re&&this.a.appendLine(`Got data without result: ${re}`),this.a.appendLine(""),_)F({limitHit:x});else{Z.flush(),B=null;let Ce;me&&!Y&&(Ce=o(me))?T((0,A.$LK)(new A.$JK(Ce.message,Ce.code))):F({limitHit:x})}})})}}e.$wlc=m;function o(w){const C=w.split(`
`),k=C[0].trim();if(C.some(O=>O.startsWith("regex parse error")))return new A.$JK(n(C),A.SearchErrorCode.regexParseError);const D=k.match(/grep config error: unknown encoding: (.*)/);if(D)return new A.$JK(`Unknown encoding: ${D[1]}`,A.SearchErrorCode.unknownEncoding);if(k.startsWith("error parsing glob"))return new A.$JK(k.charAt(0).toUpperCase()+k.substr(1),A.SearchErrorCode.globParseError);if(k.startsWith("the literal"))return new A.$JK(k.charAt(0).toUpperCase()+k.substr(1),A.SearchErrorCode.invalidLiteral);if(k.startsWith("PCRE2: error compiling pattern"))return new A.$JK(k,A.SearchErrorCode.regexParseError)}function n(w){const C=["Regex parse error"],k=w.filter(D=>D.startsWith("PCRE2:"));if(k.length>=1){const D=k[0].replace("PCRE2:","");if(D.indexOf(":")!==-1&&D.split(":").length>=2){const O=D.split(":")[1];C.push(":"+O)}}return C.join("")}class i extends L.EventEmitter{constructor(C,k,D){super(),this.g=C,this.h=k,this.j=D,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new M.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(C,k){return super.on(C,k),this}handleData(C){if(this.b)return;const k=typeof C=="string"?C:this.d.write(C);this.k(k)}k(C){let k=C.indexOf(`
`);const D=this.a+C;if(k>=0)k+=this.a.length;else{this.a=D;return}let O=0;for(;k>=0;)this.m(D.substring(O,k).trim()),O=k+1,k=D.indexOf(`
`,O);this.a=D.substring(O)}m(C){if(this.b||!C)return;let k;try{k=JSON.parse(C)}catch{throw new Error(`malformed line from rg: ${C}`)}if(k.type==="match"){const D=r(k.data.path),O=y.URI.joinPath(this.h,D),F=this.n(k.data,O);this.p(F),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(k.type==="context"){const D=r(k.data.path),O=y.URI.joinPath(this.h,D);this.o(k.data,O).forEach(T=>this.p(T))}}n(C,k){const D=C.line_number-1,O=r(C.lines),F=Buffer.from(O);let T=0,z=0,j=D;C.submatches.length===0&&C.submatches.push(O.length?{start:0,end:1,match:{text:O[0]}}:{start:0,end:0,match:{text:""}});const N=(0,P.$Hb)(C.submatches.map((B,W)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const Z=r(B.match),_=F.slice(T,B.start).toString(),X=s(_),x=X.numLines>0?X.lastLineLength:X.lastLineLength+z,re=s(Z),Y=X.numLines+j,me=re.numLines+Y,Ce=re.numLines>0?re.lastLineLength:re.lastLineLength+x;return T=B.end,z=Ce,j=me,new I.$tK(Y,x,me,Ce)}));return(0,v.$plc)(k,O,N,this.j)}o(C,k){const D=r(C.lines),O=C.line_number;return D.replace(/\r?\n$/,"").split(`
`).map((F,T)=>({text:F,uri:k,lineNumber:O+T}))}p(C){this.emit("result",C)}}e.$xlc=i;function r(w){return w.bytes?Buffer.from(w.bytes,"base64").toString():w.text}function s(w){const C=/\n/g;let k=0,D=-1,O;for(;O=C.exec(w);)k++,D=O.index;const F=D>=0?w.length-D-1:w.length;return{numLines:k,lastLineLength:F}}function t(w,C){const k=["--hidden","--no-require-git"];k.push(w.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:D,otherIncludes:O}=(0,R.$K)(C.includes,T=>T.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const T=new Set;O.forEach(z=>{T.add(z)}),k.push("-g","!*"),T.forEach(z=>{f(z).map(v.$olc).forEach(j=>{k.push("-g",j)})})}D&&D.length&&D.forEach(T=>{k.push("-g",T)}),C.excludes.map(v.$olc).forEach(T=>k.push("-g",`!${T}`)),C.maxFileSize&&k.push("--max-filesize",C.maxFileSize+""),C.useIgnoreFiles?C.useParentIgnoreFiles||k.push("--no-ignore-parent"):k.push("--no-ignore"),C.followSymlinks&&k.push("--follow"),C.encoding&&C.encoding!=="utf8"&&k.push("--encoding",C.encoding),w.pattern==="--"&&(w.isRegExp=!0,w.pattern="\\-\\-"),w.isMultiline&&!w.isRegExp&&(w.pattern=(0,$.$Ze)(w.pattern),w.isRegExp=!0),C.usePCRE2&&k.push("--pcre2"),k.push("--crlf"),w.isRegExp&&(w.pattern=d(w.pattern),k.push("--engine","auto"));let F;if(w.isWordMatch){const z=(0,$.$9e)(w.pattern,!!w.isRegExp,{wholeWord:w.isWordMatch}).source.replace(/\\\//g,"/");k.push("--regexp",z)}else if(w.isRegExp){let T=c(w.pattern);T=h(T),k.push("--regexp",T)}else F=w.pattern,k.push("--fixed-strings");return k.push("--no-config"),C.useGlobalIgnoreFiles||k.push("--no-ignore-global"),k.push("--json"),w.isMultiline&&k.push("--multiline"),C.beforeContext&&k.push("--before-context",C.beforeContext+""),C.afterContext&&k.push("--after-context",C.afterContext+""),k.push("--"),F&&k.push(F),k.push("."),k}function f(w){return S(w).flatMap(k=>{const D=(0,b.$ak)(k,"/");return D.map((O,F)=>D.slice(0,F+1).join("/"))})}function d(w){const C=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;w.match(C);)w=w.replace(C,"$1\\x{$2}");const k=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;w.match(k);)w=w.replace(k,"$1\\x{$2}");return w}const l=w=>w.type==="Assertion"&&w.kind==="lookbehind";function c(w){let C;try{C=new p.RegExpParser().parsePattern(w)}catch{return w}let k="",D=0;const O=(z,j,N)=>{k+=w.slice(D,z)+N,D=j},F=[];return new p.RegExpVisitor({onCharacterEnter(z){if(z.raw!=="\\n")return;const j=F[0];if(!j)O(z.start,z.end,"\\r?\\n");else if(!F.some(l))if(j.type==="CharacterClass")if(j.negate){const N=w.slice(j.start+2,z.start)+w.slice(z.end,j.end-1);j.parent?.type==="Quantifier"?O(j.start,j.end,N?`[^${N}]`:"."):O(j.start,j.end,"(?!\\r?\\n"+(N?`|[${N}]`:"")+")")}else{const N=w.slice(j.start+1,z.start)+w.slice(z.end,j.end-1);O(j.start,j.end,N===""?"\\r?\\n":`(?:[${N}]|\\r?\\n)`)}else j.type==="Quantifier"&&O(z.start,z.end,"(?:\\r?\\n)")},onQuantifierEnter(z){F.unshift(z)},onQuantifierLeave(){F.shift()},onCharacterClassRangeEnter(z){F.unshift(z)},onCharacterClassRangeLeave(){F.shift()},onCharacterClassEnter(z){F.unshift(z)},onCharacterClassLeave(){F.shift()},onAssertionEnter(z){l(z)&&F.push(z)},onAssertionLeave(z){F[0]===z&&F.shift()}}).visit(C),k+=w.slice(D),k}function h(w){return w.replace(/\n/g,"\\r?\\n")}function g(w){let C=!1,k=!1,D="",O="";for(let F=0;F<w.length;F++){const T=w[F];switch(T){case"\\":k?(C?O+="\\"+T:D+="\\"+T,k=!1):k=!0;break;case"{":if(k)C?O+=T:D+=T,k=!1;else{if(C)return{strInBraces:D+"{"+O+"{"+w.substring(F+1)};C=!0}break;case"}":if(k)C?O+=T:D+=T,k=!1;else{if(C)return{fixedStart:D,strInBraces:O,fixedEnd:w.substring(F+1)};D+=T}break;default:C?O+=(k?"\\":"")+T:D+=(k?"\\":"")+T,k=!1;break}}return{strInBraces:D+(C?"{"+O:"")}}function S(w){const{fixedStart:C,strInBraces:k,fixedEnd:D}=g(w);if(C===void 0||D===void 0)return[k];let O=(0,b.$ak)(k,",");O.length||(O=[""]);const F=S(D);return O.flatMap(T=>{const z=C+T;return F.map(j=>z+j)})}}),define(ke[387],Ee([1,0,22,160,108,15]),function(he,e,u,L,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Glc=void 0;class R{constructor(y){this.b=y,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(y,A,I,p){const E=new L.$wlc(this.b);if(A.folder.scheme===P.Schemas.vscodeUserData){const v={...A,folder:A.folder.with({scheme:P.Schemas.file})},a=new M.$Rv(m=>I.report({...m,uri:m.uri.with({scheme:A.folder.scheme})}));return this.c(p,m=>E.provideTextSearchResults(y,v,a,m))}else return this.c(p,v=>E.provideTextSearchResults(y,A,I,v))}async c(y,A){const I=b(y);this.a.add(I);const p=await A(I.token);return this.a.delete(I),p}d(){this.a.forEach(y=>y.cancel())}}e.$Glc=R;function b($){const y=new u.$ee;return $.onCancellationRequested(()=>y.cancel()),y}}),define(ke[388],Ee([1,0,31,160,159]),function(he,e,u,L,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Elc=void 0;class P{constructor($){this.a=$}search($,y,A){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(E){A({message:E})}},p=new M.$Dlc(this.a,new L.$wlc(I),u);return new Promise((E,v)=>p.search(a=>{y(a.map(R))},$).then(a=>E({limitHit:a.limitHit,type:"success",stats:a.stats}),v))}}e.$Elc=P;function R(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce(($,y)=>{if(y.ranges){const A=y;return $+(Array.isArray(A.ranges)?A.ranges.length:1)}else return $+1},0)}}}),define(ke[389],Ee([1,0,19,8,13,4,132,17,39,2,32,36,384,388]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Flc=void 0;class v{static{this.a=512}constructor(r="searchProcess"){this.d=r,this.b=Object.create(null)}fileSearch(r){let s;const t=o(r),f=new P.$7d({onDidAddFirstListener:()=>{s=(0,L.$8g)(d=>this.doFileSearchWithEngine(p.$vlc,t,l=>f.fire(l),d)),s.then(d=>f.fire(d),d=>f.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{s.cancel()}});return f.event}textSearch(r){let s;const t=o(r),f=new P.$7d({onDidAddFirstListener:()=>{s=(0,L.$8g)(d=>this.f(t,l=>f.fire(l),d)),s.then(d=>f.fire(d),d=>f.fire({type:"error",error:{message:d.message,stack:d.stack}}))},onDidRemoveLastListener:()=>{s.cancel()}});return f.event}f(r,s,t){return r.maxFileSize=this.g().maxFileSize,new E.$Elc(r).search(t,s,s)}g(){return{maxFileSize:16*A.$kl.GB}}doFileSearch(r,s,t){return this.doFileSearchWithEngine(p.$vlc,r,s,t)}doFileSearchWithEngine(r,s,t,f,d=v.a){let l=0;const c=g=>{Array.isArray(g)?(l+=g.length,t(g.map(S=>this.h(S)))):g.relativePath?(l++,t(this.h(g))):t(g)};if(s.sortByScore){let g=this.l(s,c,f);if(!g){const S=s.maxResults?Object.assign({},s,{maxResults:null}):s,w=new r(S);g=this.j(w,s,t,c,f)}return new Promise((S,w)=>{g.then(([C,k])=>{const D=k.map(O=>this.h(O));this.o(D,t,d),S(C)},w)})}const h=new r(s);return this.r(h,c,d,f).then(g=>({limitHit:g.limitHit,type:"success",stats:{detailStats:g.stats,type:this.d,fromCache:!1,resultCount:l,sortingTime:void 0}}))}h(r){return{path:r.base?(0,b.$kc)(r.base,r.relativePath):r.relativePath}}j(r,s,t,f,d){const l=new P.$7d;let c=(0,L.$8g)(g=>{let S=[];const w=C=>{Array.isArray(C)?S=C:(f(C),l.fire(C))};return this.r(r,w,-1,g).then(C=>[C,S])}),h;if(s.cacheKey){h=this.k(s.cacheKey);const g={promise:c,event:l.event,resolved:!1};h.resultsToSearchCache[s.filePattern||""]=g,c.then(()=>{g.resolved=!0},S=>{delete h.resultsToSearchCache[s.filePattern||""]}),c=this.s(c)}return c.then(([g,S])=>{const w=h?h.scorerCache:Object.create(null),C=(typeof s.maxResults!="number"||s.maxResults>0)&&$.$3d.create(!1);return this.n(s,S,w,d).then(k=>{const D=C?C.elapsed():-1;return[{type:"success",stats:{detailStats:g.stats,sortingTime:D,fromCache:!1,type:this.d,workspaceFolderCount:s.folderQueries.length,resultCount:k.length},messages:g.messages,limitHit:g.limitHit||typeof s.maxResults=="number"&&S.length>s.maxResults},k]})})}k(r){const s=this.b[r];return s||(this.b[r]=new a)}l(r,s,t){const f=r.cacheKey&&this.b[r.cacheKey];if(!f)return;const d=this.q(f,r.filePattern||"",s,t);if(d)return d.then(([l,c,h])=>{const g=$.$3d.create(!1);return this.n(r,c,f.scorerCache,t).then(S=>{const w=g.elapsed(),C={fromCache:!0,detailStats:h,type:this.d,resultCount:c.length,sortingTime:w};return[{type:"success",limitHit:l.limitHit||typeof r.maxResults=="number"&&c.length>r.maxResults,stats:C},S]})})}n(r,s,t,f){const d=(0,R.$hr)(r.filePattern||""),l=(h,g)=>(0,R.$gr)(h,g,d,!0,m,t),c=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return u.$Gb(s,l,c,1e4,f)}o(r,s,t){if(t&&t>0)for(let f=0;f<r.length;f+=t)s(r.slice(f,f+t));else s(r)}q(r,s,t,f){const d=$.$3d.create(!1),l=s.indexOf(b.sep)>=0;let c;for(const w in r.resultsToSearchCache)if(s.startsWith(w)){if(l&&w.indexOf(b.sep)<0&&w!=="")continue;const C=r.resultsToSearchCache[w];c={promise:this.s(C.promise),event:C.event,resolved:C.resolved};break}if(!c)return null;const h=d.elapsed(),g=$.$3d.create(!1),S=c.event(t);return f&&f.onCancellationRequested(()=>{S.dispose()}),c.promise.then(([w,C])=>{if(f&&f.isCancellationRequested)throw(0,M.$6)();const k=[],D=(0,R.$hr)(s).normalizedLowercase;for(const O of C)(0,I.$PK)(O,D)&&k.push(O);return[w,k,{cacheWasResolved:c.resolved,cacheLookupTime:h,cacheFilterTime:g.elapsed(),cacheEntryCount:C.length}]})}r(r,s,t,f){return new Promise((d,l)=>{let c=[];f?.onCancellationRequested(()=>r.cancel()),r.search(h=>{h&&(t?(c.push(h),t>0&&c.length>=t&&(s(c),c=[])):s(h))},h=>{s(h)},(h,g)=>{c.length&&s(c),h?(s({message:"Search finished. Error: "+h.message}),l(h)):(s({message:"Search finished. Stats: "+JSON.stringify(g.stats)}),d(g))})})}clearCache(r){return delete this.b[r],Promise.resolve(void 0)}s(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(s,t){return r.then(s,t)}catch(s){return this.then(void 0,s)}finally(s){return r.finally(s)}}}}e.$Flc=v;class a{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const m=new class{getItemLabel(i){return(0,b.$oc)(i.relativePath)}getItemDescription(i){return(0,b.$nc)(i.relativePath)}getItemPath(i){return i.relativePath}};function o(i){return{...i,folderQueries:i.folderQueries&&i.folderQueries.map(n),extraFileResources:i.extraFileResources&&i.extraFileResources.map(r=>y.URI.revive(r))}}function n(i){return{...i,folder:y.URI.revive(i.folder)}}}),define(ke[390],Ee([1,0,3,15,2,31,12,28,20,97,66,36,389,387,122,159]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hlc=void 0;let m=class extends y.$tkc{constructor(n,i,r,s){super(n,r,s),this.w=P,this.x=-1,this.y=null,this.z=!1,this.A=new u.$Tc;const t=new v.$qlc("RipgrepSearchUD",this.q);this.A.add(this.registerTextSearchProvider(L.Schemas.vscodeUserData,new E.$Glc(t))),i.remote.isRemote&&i.remote.authority&&this.B()}dispose(){this.A.dispose()}$enableExtensionHostSearch(){this.B()}B(){if(this.z)return;this.z=!0;const n=new v.$qlc("RipgrepSearchEH",this.q);this.A.add(this.registerTextSearchProvider(L.Schemas.file,new E.$Glc(n))),this.A.add(this.C(L.Schemas.file,new p.$Flc("fileSearchProvider")))}C(n,i){const r=this.d++;return this.y=i,this.x=r,this.c.$registerFileSearchProvider(r,this.s(n)),(0,u.$Sc)(()=>{this.y=null,this.c.$unregisterProvider(r)})}$provideFileSearchResults(n,i,r,s){const t=(0,y.$ukc)(r);if(n===this.x){const f=Date.now();return this.D(n,i,t,s).then(d=>{const l=Date.now()-f;return this.q.debug(`Ext host file search time: ${l}ms`),d})}return super.$provideFileSearchResults(n,i,r,s)}doInternalFileSearchWithCustomCallback(n,i,r){const s=t=>{if((0,I.$OK)(t)&&(t=[t]),Array.isArray(t)){r(t.map(f=>M.URI.file(f.path)));return}t.message&&this.q.debug("ExtHostSearch",t.message)};if(!this.y)throw new Error("No internal file search handler");return this.y.doFileSearch(n,s,i)}async D(n,i,r,s){return this.doInternalFileSearchWithCustomCallback(r,s,t=>{this.c.$handleFileMatch(n,i,t)})}$clearCache(n){return this.y?.clearCache(n),super.$clearCache(n)}t(n,i){return new a.$Dlc(n,i,void 0,"textSearchProvider")}};e.$Hlc=m,e.$Hlc=m=Je([qe(0,$.$GO),qe(1,b.$WO),qe(2,A.$mjc),qe(3,R.$Oj)],m)}),define(ke[123],Ee([1,0,377,62,63,404,21,13,4,3,17,11,30,81,82]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.$_h=e.$$h=e.$0h=void 0,e.$ai=d,e.$bi=l,e.$di=g,e.$ei=S;class a{traceSocketEvent(C,k){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,C,k)}constructor(C,k=""){this.f=!0,this.debugLabel=k,this.socket=C,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=D=>{if(this.traceSocketEvent("error",{code:D?.code,message:D?.message}),D){if(D.code==="EPIPE")return;(0,b.$1)(D)}},this.socket.on("error",this.a),this.b=D=>{this.traceSocketEvent("close",{hadError:D}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(C){const k=D=>{this.traceSocketEvent("read",D),C(R.$ue.wrap(D))};return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(C){const k=D=>{C({type:0,hadError:D,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(C){const k=()=>{C()};return this.socket.on("end",k),{dispose:()=>this.socket.off("end",k)}}write(C){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",C),this.socket.write(C.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,b.$1)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,b.$1)(k)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((C,k)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),C();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),this.traceSocketEvent("nodeDrainEnd"),C()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.$0h=a;var m;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize",w[w.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(m||(m={}));var o;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(o||(o={}));class n extends y.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(C,k){this.socket.traceSocketEvent(C,k)}constructor(C,k,D,O){super(),this.f=this.B(new $.$7d),this.g=this.B(new $.$7d),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=C,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:k,inflateBytesLength:D?.byteLength||0,recordInflateBytes:O}),this.a=this.B(new i(this,k,D,O,this.f,(F,T)=>this.m(F,T))),this.B(this.a.onError(F=>{console.error(F),(0,b.$1)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new v.$5h,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(C){return this.f.event(C)}onClose(C){return this.g.event(C)}onEnd(C){return this.socket.onEnd(C)}write(C){let k=0;for(;k<C.byteLength;)this.a.writeMessage(C.slice(k,Math.min(k+262144,C.byteLength)),{compressed:!0,opcode:2}),k+=262144}m(C,{compressed:k,opcode:D}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",C);let O=2;C.byteLength<126?O+=0:C.byteLength<2**16?O+=2:O+=8;const F=R.$ue.alloc(O),T=k?64:0,z=D&15;if(F.writeUInt8(128|T|z,0),C.byteLength<126)F.writeUInt8(C.byteLength,1);else if(C.byteLength<2**16){F.writeUInt8(126,1);let j=1;F.writeUInt8(C.byteLength>>>8&255,++j),F.writeUInt8(C.byteLength>>>0&255,++j)}else{F.writeUInt8(127,1);let j=1;F.writeUInt8(0,++j),F.writeUInt8(0,++j),F.writeUInt8(0,++j),F.writeUInt8(0,++j),F.writeUInt8(C.byteLength>>>24&255,++j),F.writeUInt8(C.byteLength>>>16&255,++j),F.writeUInt8(C.byteLength>>>8&255,++j),F.writeUInt8(C.byteLength>>>0&255,++j)}this.socket.write(R.$ue.concat([F,C]))}end(){this.h=!0,this.socket.end()}n(C){if(C.byteLength!==0){for(this.b.acceptChunk(C);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const k=this.b.peek(this.j.readLen),D=k.readUInt8(0),O=(D&128)>>>7,F=(D&64)>>>6,T=D&15,z=k.readUInt8(1),j=(z&128)>>>7,N=z&127;this.j.state=2,this.j.readLen=2+(j?4:0)+(N===126?2:0)+(N===127?8:0),this.j.fin=O,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!O,this.j.mask=0,this.j.opcode=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const k=this.b.read(this.j.readLen),D=k.readUInt8(1),O=(D&128)>>>7;let F=D&127,T=1;F===126?F=k.readUInt8(++T)*2**8+k.readUInt8(++T):F===127&&(F=k.readUInt8(++T)*0+k.readUInt8(++T)*0+k.readUInt8(++T)*0+k.readUInt8(++T)*0+k.readUInt8(++T)*2**24+k.readUInt8(++T)*2**16+k.readUInt8(++T)*2**8+k.readUInt8(++T));let z=0;O&&(z=k.readUInt8(++T)*2**24+k.readUInt8(++T)*2**16+k.readUInt8(++T)*2**8+k.readUInt8(++T)),this.j.state=3,this.j.readLen=F,this.j.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const k=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",k),t(k,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",k),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(k,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(k,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$$h=n;class i extends y.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.$ue.alloc(0)}constructor(C,k,D,O,F,T){super(),this.n=C,this.r=F,this.s=T,this.a=this.B(new $.$7d),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$7d),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$7d),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,k?(this.b=this.B(new r(this.n,O,D,{windowBits:15})),this.f=this.B(new s(this.n,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(C,k){this.g.push({data:C,options:k}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:C,options:k}=this.g.shift();if(this.f&&k.compressed){const D=await this.w(this.f,C);this.s(D,k)}else this.s(C,{...k,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(C,k){return new Promise((D,O)=>{C.write(k),C.flush(F=>D(F))})}acceptFrame(C,k,D){this.h.push({data:C,isCompressed:k,isLastFrameOfMessage:D}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const C=this.h.shift();if(this.b&&C.isCompressed){const k=await this.C(this.b,C.data,C.isLastFrameOfMessage);this.r.fire(k)}else this.r.fire(C.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(C,k,D){return new Promise((O,F)=>{C.write(k),D&&C.write(R.$ue.fromByteArray([0,0,255,255])),C.flush(T=>O(T))})}}class r extends y.$Uc{get recordedInflateBytes(){return this.j?R.$ue.concat(this.f):R.$ue.alloc(0)}constructor(C,k,D,O){super(),this.h=C,this.j=k,this.a=this.B(new $.$7d),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,P.createInflateRaw)(O),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(R.$ue.wrap(F))}),D&&(this.h.traceSocketEvent("zlibInflateInitialWrite",D.buffer),this.b.write(D.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(C){this.j&&this.f.push(C.clone()),this.h.traceSocketEvent("zlibInflateWrite",C),this.b.write(C.buffer)}flush(C){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const k=R.$ue.concat(this.g);this.g.length=0,C(k)})}}class s extends y.$Uc{constructor(C,k){super(),this.g=C,this.a=this.B(new $.$7d),this.onError=this.a.event,this.f=[],this.b=(0,P.createDeflateRaw)({windowBits:15}),this.b.on("error",D=>{this.g.traceSocketEvent("zlibDeflateError",{message:D?.message,code:D?.code}),this.a.fire(D)}),this.b.on("data",D=>{this.g.traceSocketEvent("zlibDeflateData",D),this.f.push(R.$ue.wrap(D))})}write(C){this.g.traceSocketEvent("zlibDeflateWrite",C.buffer),this.b.write(C.buffer)}flush(C){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let k=R.$ue.concat(this.f);this.f.length=0,k=k.slice(0,k.byteLength-4),C(k)})}}function t(w,C){if(C===0)return;const k=w.byteLength>>>2;for(let j=0;j<k;j++){const N=w.readUInt32BE(j*4);w.writeUInt32BE(N^C,j*4)}const D=k*4,O=w.byteLength-D,F=C>>>24&255,T=C>>>16&255,z=C>>>8&255;O>=1&&w.writeUInt8(w.readUInt8(D)^F,D),O>=2&&w.writeUInt8(w.readUInt8(D+1)^T,D+1),O>=3&&w.writeUInt8(w.readUInt8(D+2)^z,D+2)}e.$_h=process.env.XDG_RUNTIME_DIR;const f={2:107,1:103};function d(){const w=(0,p.$Eg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;const C=process.platform!=="darwin"&&e.$_h?e.$_h:(0,M.tmpdir)(),k=(0,A.$kc)(C,`vscode-ipc-${w}.sock`);return c(k),k}function l(w,C,k){const O=(0,u.createHash)("sha256").update(w).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${k}-${C}-sock`;const F=k.substr(0,4),T=C.substr(0,6);let z;return process.platform!=="darwin"&&e.$_h&&!process.env.VSCODE_PORTABLE?z=(0,A.$kc)(e.$_h,`vscode-${O}-${F}-${T}.sock`):z=(0,A.$kc)(w,`${F}-${T}.sock`),c(z),z}function c(w){const C=f[I.$u];typeof C=="number"&&w.length>=C&&console.warn(`WARNING: IPC handle "${w}" is longer than ${C} chars, try a shorter --user-data-dir`)}class h extends E.$Yh{static b(C){const k=$.Event.fromNodeEventEmitter(C,"connection");return $.Event.map(k,D=>({protocol:new v.$6h(new a(D,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(D,"close"))}))}constructor(C){super(h.b(C)),this.d=C}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$ci=h;function g(w){return new Promise((C,k)=>{const D=(0,L.createServer)();D.on("error",k),D.listen(w,()=>{D.removeListener("error",k),C(new h(D))})})}function S(w,C){return new Promise((k,D)=>{const O=(0,L.createConnection)(w,()=>{O.removeListener("error",D),k(v.$7h.fromSocket(new a(O,`ipc-client${C}`),C))});O.once("error",D)})}}),define(ke[391],Ee([1,0,62,63,172,123,8,3,11,53,12,139,265,266,110,88,21]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qbc=e.$Pbc=e.$Obc=e.$Nbc=void 0;async function o(t,f,d,l,c){let h;for(let g=3;g&&(h?.dispose(),h=await new n(t,f,d,l,c).waitForReady(),!(c&&M.$Hg[c]||!M.$Hg[h.tunnelLocalPort]));g--);return h}class n extends b.$Uc{constructor(f,d,l,c,h){super(),this.m=d,this.n=h,this.privacy=a.TunnelPrivacyId.Private,this.j=new Map,this.a=f,this.b=u.createServer(),this.c=new R.$hh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=g=>this.r(g),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=c,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(d=>{d()})}async waitForReady(){const f=this.n??this.tunnelRemotePort,d=(0,a.$5v)(this.m)?"0.0.0.0":"127.0.0.1";let l=await(0,M.$Ig)(f,2,1e3,d),c=null;return this.b.listen(l,this.m),await this.c.wait(),c=this.b.address(),c||(l=0,this.b.listen(l,this.m),await this.c.wait(),c=this.b.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async r(f){f.pause();const d=(0,a.$3v)(this.tunnelRemoteHost)||(0,a.$5v)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,p.$El)(this.a,d,this.tunnelRemotePort),c=l.getSocket(),h=l.readEntireBuffer();l.dispose(),h.byteLength>0&&f.write(h.buffer),f.on("end",()=>{f.localAddress&&this.j.delete(f.localAddress),c.end()}),f.on("close",()=>c.end()),f.on("error",()=>{f.localAddress&&this.j.delete(f.localAddress),c instanceof P.$0h?c.socket.destroy():c.end()}),c instanceof P.$0h?this.t(f,c):this.s(f,c),f.localAddress&&this.j.set(f.localAddress,()=>{f.end(),c.end()})}s(f,d){d.onClose(()=>f.destroy()),d.onEnd(()=>f.end()),d.onData(l=>f.write(l.buffer)),f.on("data",l=>d.write(m.$ue.wrap(l))),f.resume()}t(f,d){const l=d.socket;l.on("end",()=>f.end()),l.on("close",()=>f.end()),l.on("error",()=>{f.destroy()}),l.pipe(f),f.pipe(l)}}e.$Nbc=n;let i=class extends a.$8v{constructor(f,d,l,c,h){super(d,h),this.v=f,this.w=l,this.y=c}isPortPrivileged(f){return(0,a.$6v)(f,this.m,$.OS,L.release())}t(f,d,l,c,h,g,S,w){const C=this.s(d,l);if(C)return++C.refcount,C.value;if((0,a.$Yv)(f))return this.u(f,d,l,h,g,S,w);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${l} on local port ${h}.`);const k={commit:this.y.commit,quality:this.y.quality,addressProvider:f,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},D=o(k,c,d,l,h);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(d,l,D),D}}};e.$Obc=i,e.$Obc=i=Je([qe(0,E.$yl),qe(1,A.$Oj),qe(2,v.$Bl),qe(3,I.$8j),qe(4,y.$Oi)],i);let r=class extends i{constructor(f,d,l,c,h){super(f,d,l,c,h)}};e.$Pbc=r,e.$Pbc=r=Je([qe(0,E.$yl),qe(1,A.$Oj),qe(2,v.$Bl),qe(3,I.$8j),qe(4,y.$Oi)],r);let s=class extends b.$Uc{constructor(f,d,l,c,h){super(),this.b=f,this.c=d,this.f=l,this.g=c,this.h=h,this.a=new Map}async openTunnel(f,d,l,c,h,g,S,w,C){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${c} on local port ${g}.`),!this.a.has(f)){const k=new r(this.b,this.c,this.g,this.f,this.h);this.B(k),this.a.set(f,k),k.onTunnelClosed(async()=>{(await k.tunnels).length===0&&(k.dispose(),this.a.delete(f))})}return this.a.get(f).openTunnel(d,l,c,h,g,S,w,C)}};e.$Qbc=s,e.$Qbc=s=Je([qe(0,E.$yl),qe(1,A.$Oj),qe(2,I.$8j),qe(3,v.$Bl),qe(4,y.$Oi)],s)}),define(ke[392],Ee([1,0,123,285,51,33,2,12,42]),function(he,e,u,L,M,P,R,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9O=e.$8O=void 0;class y{constructor(p,E,v){this.b=p,this.c=E,this.f=v,this.a=L.createServer((a,m)=>this.h(a,m)),this.g().catch(a=>(E.error(a),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",p=>this.c.error(p))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(p,E){const v=(m,o)=>{E.writeHead(m,{"content-type":"application/json"}),E.end(JSON.stringify(o||null),n=>n&&this.c.error(n))},a=[];p.setEncoding("utf8"),p.on("data",m=>a.push(m)),p.on("end",async()=>{try{const m=JSON.parse(a.join(""));let o;switch(m.type){case"open":o=await this.i(m);break;case"openExternal":o=await this.j(m);break;case"status":o=await this.l(m);break;case"extensionManagement":o=await this.k(m);break;default:v(404,`Unknown message type: ${m.type}`);break}v(200,o)}catch(m){const o=m instanceof Error?m.message:JSON.stringify(m);v(500,o),this.c.error("Error while processing pipe request",m)}})}async i(p){const{fileURIs:E,folderURIs:v,forceNewWindow:a,diffMode:m,mergeMode:o,addMode:n,forceReuseWindow:i,gotoLineMode:r,waitMarkerFilePath:s,remoteAuthority:t}=p,f=[];if(Array.isArray(v))for(const h of v)try{f.push({folderUri:R.URI.parse(h)})}catch{}if(Array.isArray(E))for(const h of E)try{(0,$.$Ni)(h)?f.push({workspaceUri:R.URI.parse(h)}):f.push({fileUri:R.URI.parse(h)})}catch{}const d=s?R.URI.file(s):void 0,c={forceNewWindow:a,diffMode:m,mergeMode:o,addMode:n,gotoLineMode:r,forceReuseWindow:i,preferNewWindow:!i&&!d&&!n,waitMarkerFileURI:d,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",f,c)}async j(p){for(const E of p.uris){const v=R.URI.parse(E),a=v.scheme==="file"?v:E;await this.b.executeCommand("_remoteCLI.openExternal",a)}}async k(p){const E=a=>a?.map(m=>/\.vsix$/i.test(m)?R.URI.parse(m):m),v={list:p.list,install:E(p.install),uninstall:E(p.uninstall),force:p.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",v)}async l(p){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&M.existsSync(this.f)&&M.unlinkSync(this.f)}}e.$8O=y;let A=class extends y{constructor(p,E){super(p,E,(0,u.$ai)())}};e.$9O=A,e.$9O=A=Je([qe(0,P.$3O),qe(1,b.$Oj)],A)}),define(ke[393],Ee([1,0,58,380,374,284,48,361,2,15,7,392,104,319,360]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mlc=void 0;class a extends M.$blc{j(){const n=this,i=globalThis._VSCODE_NODE_MODULES.module,r=i._load;i._load=function(d,l,c){return d=t(d),n.a.has(d)?n.a.get(d).load(d,$.URI.file((0,p.$Qq)(l.filename)),h=>r.apply(this,[h,l,c])):r.apply(this,arguments)};const s=i._resolveLookupPaths;i._resolveLookupPaths=(f,d)=>s.call(this,t(f),d);const t=f=>{for(const d of n.b){const l=d(f);if(l){f=l;break}}return f}}}class m extends R.$3jc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async vb(){this.h.createInstance(E.$Klc);const n=this.h.invokeFunction(L.$0kc);if(this.h.createInstance(b.$Jlc),this.f.remote.isRemote&&this.f.remote.authority){const s=this.h.createInstance(I.$9O);process.env.VSCODE_IPC_HOOK_CLI=s.ipcHandlePath}this.h.createInstance(v.$Llc),await this.h.createInstance(a,n,{mine:this.J,all:this.L}).install(),u.mark("code/extHost/didInitAPI");const r=await this.m.getConfigProvider();await(0,P.$Ilc)(this.j,r,this,this.s,this.z,this.f),u.mark("code/extHost/didInitProxyResolver")}wb(n){return n.main}async xb(n,i,r){if(i.scheme!==y.Schemas.file)throw new Error(`Cannot load URI: '${i}', must be of file-scheme`);let s=null;r.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${i.toString(!0)}`),this.s.flush();const t=n?.identifier.value;n&&await this.w.initializeLocalizedMessages(n);try{t&&u.mark(`code/extHost/willLoadExtensionCode/${t}`),s=he.__$__nodeRequire(i.fsPath)}finally{t&&u.mark(`code/extHost/didLoadExtensionCode/${t}`),r.codeLoadingStop()}return s}async $setRemoteEnvironment(n){if(this.f.remote.isRemote)for(const i in n){const r=n[i];r===null?delete process.env[i]:process.env[i]=r}}}e.$Mlc=m}),define(ke[394],Ee([1,0,52,21,4,3,125,11,23,2,31,12,264,65,110,88,391,28,20,70,368]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v,a,m,o,n,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ulc=void 0,e.$Nlc=s,e.$Olc=t,e.$Plc=f,e.$Qlc=d,e.$Rlc=c,e.$Slc=h,e.$Tlc=g;function s(C){const k=C.trim().split(`
`),D=[];return k.forEach(F=>{const T=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(F);T&&T.length>=3&&D.push({pid:parseInt(T[1],10),socket:parseInt(T[2],10)})}),D.reduce((F,T)=>(F[T.socket]=T,F),{})}function t(...C){const k=[].concat(...C.map(d));return[...new Map(k.filter(D=>D.st==="0A").map(D=>{const O=D.local_address.split(":");return{socket:parseInt(D.inode,10),ip:f(O[0]),port:parseInt(O[1],16)}}).map(D=>[D.ip+":"+D.port,D])).values()]}function f(C){let k="";if(C.length===8)for(let D=C.length-2;D>=0;D-=2)k+=parseInt(C.substr(D,2),16),D!==0&&(k+=".");else for(let D=0;D<C.length;D+=8){const O=C.substring(D,D+8);let F="";for(let T=8;T>=2;T-=2)F+=O.substring(T-2,T),(T===6||T===2)&&(F=parseInt(F,16).toString(16),k+=`${F}`,F="",D+T!==C.length-6&&(k+=":"))}return k}function d(C){const k=C.trim().split(`
`),D=k.shift().trim().split(/\s+/).filter(F=>F!=="rx_queue"&&F!=="tm->when");return k.map(F=>F.trim().split(/\s+/).reduce((T,z,j)=>(T[D[j]||j]=z,T),{}))}function l(C){return!!C.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||C.indexOf("out/server-main.js")!==-1||C.indexOf("_productName=VSCode")!==-1}function c(C){const k=C.trim().split(`
`),D=[];return k.forEach(O=>{const F=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(O);F&&F.length>=4&&D.push({pid:parseInt(F[1],10),ppid:parseInt(F[2]),cmd:F[3]})}),D}async function h(C,k,D){const O=D.reduce((T,z)=>(T[z.pid]=z,T),{}),F=[];return C.forEach(({socket:T,ip:z,port:j})=>{const N=k[T]?k[T].pid:void 0,B=N?O[N]?.cmd:void 0;N&&B&&!l(B)&&F.push({host:z,port:j,detail:B,pid:N})}),F}function g(C,k,D){const O=new Map,F=c(k);for(const T of C){const z=D.get(T.port);if(z){O.set(T.port,z);continue}const j=F.find(N=>N.cmd.includes(`${T.port}`));if(j){let N=j,B;do B=F.find(W=>W.ppid===N.pid),B&&(N=B);while(B);O.set(T.port,{host:T.ip,port:T.port,pid:N.pid,detail:N.cmd,ppid:N.ppid})}else O.set(T.port,{host:T.ip,port:T.port,ppid:Number.MAX_VALUE})}return O}let S=class extends i.$OBb{constructor(k,D,O,F){super(k,D,O),this.D=D,this.F=F,this.y=void 0,this.z=new Map,this.C=!1,b.$k&&D.remote.isRemote&&D.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(k){if(k&&this.C)return;this.C=k;let D;this.y&&(D=this.y,await this.a.$onFoundNewCandidates(this.y));const O=new R.$qm;let F=0;for(;this.C;){const T=new Date().getTime(),z=(await this.I()).filter(B=>(0,a.$3v)(B.host)||(0,a.$5v)(B.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${z.map(B=>B.port).join(", ")}`);const j=new Date().getTime()-T;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${j} ms.`),F++>3&&O.update(j),(!D||JSON.stringify(D)!==JSON.stringify(z))&&(D=z,await this.a.$onFoundNewCandidates(D));const N=this.G(O.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${N} ms.`),await new Promise(B=>setTimeout(()=>B(),N))}}G(k){return Math.max(k*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(k=>k.port).join(", ")}`)}async I(){let k="",D="";try{k=await A.Promises.readFile("/proc/net/tcp","utf8"),D=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const O=t(k,D),F=await new Promise(_=>{(0,u.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(X,x,re)=>{_(x)})}),T=s(F),z=await A.Promises.readdir("/proc"),j=[];for(const _ of z)try{const X=Number(_),x=$.$Vg(y.URI.file("/proc"),_);if((await A.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(X)){const Y=await A.Promises.readlink($.$Vg(x,"cwd").fsPath),me=await A.Promises.readFile($.$Vg(x,"cmdline").fsPath,"utf8");j.push({pid:X,cwd:Y,cmd:me})}}catch{}const N=[],B=O.filter(_=>{const X=T[_.socket];return X||N.push(_),X}),W=h(B,T,j);let Z;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${N.length}`),N.length>0){const _=await new Promise(X=>{(0,u.exec)("ps -F -A -l | grep root",(x,re,Y)=>{X(re)})});this.z=g(N,_,this.z),Z=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${Z.map(X=>X.port).join(", ")}`)}return W.then(_=>Z?_.concat(Z):_)}w(k){return async D=>{const O=new m.$Nbc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(T,z,j,N){const B=await k.makeConnection();return w.connect(B,z,j,N)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new E.$ul(0),connectionToken:k.connectionToken})}},signService:this.F},"localhost",D.remoteAddress.host||"localhost",D.remoteAddress.port,D.localAddressPort);await O.waitForReady();const F=new M.$7d;return{localAddress:(0,r.$LL)(O.localAddress)??O.localAddress,remoteAddress:{port:O.tunnelRemotePort,host:O.tunnelRemoteHost},onDidDispose:F.event,dispose:()=>{O.dispose(),F.fire(),F.dispose()}}}}};e.$Ulc=S,e.$Ulc=S=Je([qe(0,n.$GO),qe(1,o.$WO),qe(2,I.$Oj),qe(3,v.$Bl)],S);class w extends p.$kub{static connect(k,D,O,F){const T=new P.$Tc,z={onClose:T.add(new M.$7d),onData:T.add(new M.$7d),onEnd:T.add(new M.$7d)};T.add(k.onDidReceiveMessage(N=>z.onData.fire(L.$ue.wrap(N)))),T.add(k.onDidEnd(()=>z.onEnd.fire())),T.add(k.onDidClose(N=>z.onClose.fire({type:0,error:N,hadError:!!N})));const j=new w(k,F,z);return j.B(T),(0,p.$jub)(j,D,O,F,z)}constructor(k,D,O){super(D,O),this.n=k}write(k){this.n.send(k.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[395],Ee([1,0,84,363,378,376,390,393,394,96,48,97,95,47,70,93,362,320,12,379,60,279,106,110,141]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v,a,m,o,n,i,r,s,t,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,u.$gs)(A.$4jc,b.$Mlc,0),(0,u.$gs)(n.$Pj,o.$Wlc,1),(0,u.$gs)(n.$Oj,new t.$fi(s.$alc,[!1],!0)),(0,u.$gs)(f.$Bl,d.$Sbc,1),(0,u.$gs)(a.$vjc,m.$Vlc,0),(0,u.$gs)(y.$9jc,P.$nlc,0),(0,u.$gs)(I.$skc,R.$Hlc,0),(0,u.$gs)(p.$Vkc,M.$flc,0),(0,u.$gs)(E.$Qjc,L.$elc,0),(0,u.$gs)(v.$NBb,$.$Ulc,0),(0,u.$gs)(r.$7jc,i.$Xlc,0)}),define(ke[405],Ee([1,0,62,406,58,13,82,123,262,114,375,21,31,104,8,135,286,302,381,395]),function(he,e,u,L,M,P,R,b,$,y,A,I,p,E,v,a,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let g=0;g<process.execArgv.length;g++)process.execArgv[g]==="--inspect-port=0"&&(process.execArgv.splice(g,1),g--)}();const n=L(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const h=globalThis._VSCODE_NODE_MODULES.module,g=h._load;h._load=function(S){if(S==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return g.apply(this,arguments)}})();const i=process.exit.bind(process),r=process.on.bind(process);function s(h){process.exit=function(g){if(h)i(g);else{const S=new Error("An extension called process.exit() and this was prevented.");console.warn(S.stack)}},process.crash=function(){const g=new Error("An extension called process.crash() and this was prevented.");console.warn(g.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(g,S){g==="uncaughtException"&&(S=function(){try{return S.call(void 0,arguments)}catch{}}),r(g,S)}}let t=function(h){i()};function f(){const h=(0,o.$an)(process.env);if(h.type===3)return new Promise((g,S)=>{const w=C=>{const k=C[0],D=new R.$8h;k.on("message",O=>D.fire(I.$ue.wrap(O.data))),k.on("close",()=>{t("renderer closed the MessagePort")}),k.start(),g({onMessage:D.event,send:O=>k.postMessage(O.buffer)})};process.parentPort.on("message",C=>w(C.ports))});if(h.type===2)return new Promise((g,S)=>{let w=null;const C=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),k=108e5,D=3e5,O=new v.$vh(()=>t("renderer disconnected for too long (1)"),k),F=new v.$vh(()=>t("renderer disconnected for too long (2)"),D);process.on("message",(z,j)=>{if(z&&z.type==="VSCODE_EXTHOST_IPC_SOCKET"){j.setNoDelay(!0);const N=I.$ue.wrap(Buffer.from(z.initialDataChunk,"base64"));let B;if(z.skipWebSocketFrames)B=new b.$0h(j,"extHost-socket");else{const W=I.$ue.wrap(Buffer.from(z.inflateBytes,"base64"));B=new b.$$h(new b.$0h(j,"extHost-socket"),z.permessageDeflate,W,!1)}w?(O.cancel(),F.cancel(),w.beginAcceptReconnection(B,N),w.endAcceptReconnection(),w.sendResume()):(clearTimeout(C),w=new R.$9h({socket:B,initialChunk:N}),w.sendResume(),w.onDidDispose(()=>t("renderer disconnected")),g(w),w.onSocketClose(()=>{O.schedule()}))}if(z&&z.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(F.isScheduled())return;O.isScheduled()&&F.schedule()}});const T={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(T)});{const g=h.pipeName;return new Promise((S,w)=>{const C=u.createConnection(g,()=>{C.removeListener("error",w);const k=new R.$9h({socket:new b.$0h(C,"extHost-renderer")});k.sendResume(),S(k)});C.once("error",w),C.on("close",()=>{t("renderer closed the socket")})})}}async function d(){const h=await f();return new class{constructor(){this.a=new R.$8h,this.onMessage=this.a.event,this.b=!1,h.onMessage(g=>{(0,y.$Mm)(g,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(g)})}send(g){this.b||h.send(g)}async drain(){if(h.drain)return h.drain()}}}function l(h){return new Promise(g=>{const S=h.onMessage(w=>{S.dispose();const C=JSON.parse(w.toString()),k=C.commit,D=$.default.commit;if(k&&D&&k!==D&&i(55),C.parentPid){let O=0;setInterval(function(){try{process.kill(C.parentPid,0),O=0}catch(T){T&&T.code==="EPERM"?(O++,O>=3&&t(`parent process ${C.parentPid} does not exist anymore (3 x EPERM): ${T.message} (code: ${T.code}) (errno: ${T.errno})`)):t(`parent process ${C.parentPid} does not exist anymore: ${T.message} (code: ${T.code}) (errno: ${T.errno})`)}},1e3);let F;try{F=globalThis._VSCODE_NODE_MODULES["native-watchdog"],F.start(C.parentPid)}catch(T){(0,P.$1)(T)}}h.send((0,y.$Lm)(0)),g({protocol:h,initData:C})});h.send((0,y.$Lm)(1))})}async function c(){const h=[];process.on("unhandledRejection",(O,F)=>{h.push(F),setTimeout(()=>{const T=h.indexOf(F);T>=0&&F.catch(z=>{h.splice(T,1),(0,P.$4)(z)||(console.warn(`rejected promise not handled within 1 second: ${z}`),z&&z.stack&&console.warn(`stack trace: ${z.stack}`),O&&(0,P.$1)(O))})},1e3)}),process.on("rejectionHandled",O=>{const F=h.indexOf(O);F>=0&&h.splice(F,1)}),process.on("uncaughtException",function(O){(0,P.$Z)(O)||(0,P.$1)(O)}),M.mark("code/extHost/willConnectToRenderer");const g=await d();M.mark("code/extHost/didConnectToRenderer");const S=await l(g);M.mark("code/extHost/didWaitForInitData");const{initData:w}=S;s(!!w.environment.extensionTestsLocationURI),w.environment.useHostProxy=n.useHostProxy!==void 0?n.useHostProxy!=="false":void 0,w.environment.skipWorkspaceStorageLock=(0,a.boolean)(n.skipWorkspaceStorageLock,!1);const C=new class{constructor(){this.pid=process.pid}exit(F){i(F)}fsExists(F){return p.Promises.exists(F)}fsRealpath(F){return(0,E.$Pq)(F)}};let k=null;w.remote.authority&&n.transformURIs&&(k=(0,m.$ks)(w.remote.authority));const D=new A.$dlc(S.protocol,w,C,k);t=O=>D.terminate(O)}c().catch(h=>console.log(h))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/7c51753f7ce936a7aeb84ac881818c35c5a9ab8d/core/vs/workbench/api/node/extensionHostProcess.js.map
